DROP TABLE IF EXISTS `npc`;
CREATE TABLE `npc`(
  `id` smallint(5) unsigned NOT NULL,
  `idTemplate` smallint(5) unsigned NOT NULL,
  `name` varchar(200) NOT NULL DEFAULT '',
  `serverSideName` tinyint(1) NOT NULL DEFAULT '0',
  `title` varchar(45) NOT NULL DEFAULT '',
  `serverSideTitle` tinyint(1) NOT NULL DEFAULT '0',
  `class` varchar(200) DEFAULT NULL,
  `collision_radius` decimal(6,2) DEFAULT NULL,
  `collision_height` decimal(6,2) DEFAULT NULL,
  `level` tinyint(2) DEFAULT NULL,
  `sex` enum('etc','female','male') NOT NULL DEFAULT 'etc',
  `type` varchar(22) DEFAULT NULL,
  `attackrange` smallint(4) DEFAULT NULL,
  `hp` decimal(30,15) DEFAULT NULL,
  `mp` decimal(30,15) DEFAULT NULL,
  `hpreg` decimal(30,15) DEFAULT NULL,
  `mpreg` decimal(30,15) DEFAULT NULL,
  `str` tinyint(2) NOT NULL DEFAULT '40',
  `con` tinyint(2) NOT NULL DEFAULT '43',
  `dex` tinyint(2) NOT NULL DEFAULT '30',
  `int` tinyint(2) NOT NULL DEFAULT '21',
  `wit` tinyint(2) NOT NULL DEFAULT '20',
  `men` tinyint(2) NOT NULL DEFAULT '20',
  `exp` int(9) NOT NULL DEFAULT '0',
  `sp` int(9) NOT NULL DEFAULT '0',
  `patk` decimal(12,5) DEFAULT NULL,
  `pdef` decimal(12,5) DEFAULT NULL,
  `matk` decimal(12,5) DEFAULT NULL,
  `mdef` decimal(12,5) DEFAULT NULL,
  `atkspd` smallint(4) NOT NULL DEFAULT '230',
  `critical` tinyint(1) NOT NULL DEFAULT '1',
  `matkspd` smallint(4) NOT NULL DEFAULT '333',
  `rhand` smallint(5) unsigned NOT NULL DEFAULT '0',
  `lhand` smallint(5) unsigned NOT NULL DEFAULT '0',
  `enchant` tinyint(1) NOT NULL DEFAULT '0',
  `walkspd` decimal(10,5) NOT NULL DEFAULT '60',
  `runspd` decimal(10,5) NOT NULL DEFAULT '120',
  `dropHerbGroup` tinyint(1) NOT NULL DEFAULT '0',
  `basestats` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`,`idTemplate`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `npc` VALUES
(100, 100, "Thomas D. Turkey", 0, "", 0, "LineageMonster4.br_crazy_turkey", 25, 34, 80, "male", "L2Npc", 40, 680, 2000, 0, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 60000, 5.78704, 200000, 253, 1, 333, 0, 0, 0, 19.5, 160, 0, 1), 
(101, 101, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 80, "male", "L2Npc", 40, 2880.37628, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 894.75854, 341.375, 611.00409, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(102, 102, "Santa Trainee", 0, "", 0, "LineageNPC.e_smith_master_MDwarf", 8, 16.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 490, 10, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(103, 103, "Christmas Santa", 0, "Merry Christmas!", 0, "LineageNPC2.br_xmas08_santa", 8, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 490, 10, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(104, 104, "Christmas Santa", 0, "Merry Christmas!", 0, "LineageNPC2.br_xmas08_santa", 8, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 490, 10, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(105, 105, "Christmas Sled", 0, "Merry Christmas!", 0, "LineageNPC2.br_xmas08_sled", 0.01, 50, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 10, 490, 10, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(106, 106, "Birthday Cake", 0, "", 0, "LineageNPC2.br_birthday_cake", 0.01, 0.01, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 10, 490, 10, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(107, 107, "Spirit of Fire", 0, "", 0, "LineageMonster4.br_fire_elemental", 16, 22, 1, "male", "L2Npc", 40, 20000000, 40, 0, 3, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 40, 5.78704, 30, 253, 1, 333, 0, 0, 0, 25, 120, 0, 1), 
(108, 108, "Reckless Spirit of Fire", 0, "", 0, "LineageMonster4.br_fire_elemental_of_fierce", 26, 35, 1, "male", "L2Npc", 40, 20000000, 40, 0, 3, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 40, 5.78704, 30, 253, 1, 333, 0, 0, 0, 45, 180, 0, 1), 
(109, 109, "Steve Shyagel", 0, "Eva's High Priest", 0, "LineageNPC2.br_archbishop_of_eva", 8, 26.5, 85, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 723, 10, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(110, 110, "Eva's Obelisk", 0, "", 0, "LineageNPC2.br_obelisk_of_eva", 40, 120, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 10, 490, 10, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(111, 111, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 80, "male", "L2Npc", 40, 2880.37628, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 894.75854, 341.375, 611.00409, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(112, 112, "Friendly Sno", 0, "Beginner Supporter", 0, "LineageNPC2.br_tp_actor", 9, 16.3, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 4, 180, 0, 1), -- TODO: Stats require check
(113, 113, "Friendly Sno", 0, "Beginner Supporter", 0, "LineageNPC2.br_tp_actor", 9, 16.3, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 4, 180, 0, 1), -- TODO: Stats require check
(114, 114, "Friendly Sno", 0, "Beginner Supporter", 0, "LineageNPC2.br_tp_actor", 9, 16.3, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 4, 180, 0, 1), -- TODO: Stats require check
(115, 115, "Friendly Sno", 0, "Beginner Supporter", 0, "LineageNPC2.br_tp_actor", 9, 16.3, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 4, 180, 0, 1), -- TODO: Stats require check
(116, 116, "Friendly Sno", 0, "Beginner Supporter", 0, "LineageNPC2.br_tp_actor", 9, 16.3, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 4, 180, 0, 1), -- TODO: Stats require check
(117, 117, "Friendly Sno", 0, "Beginner Supporter", 0, "LineageNPC2.br_tp_actor", 9, 16.3, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 4, 180, 0, 1), -- TODO: Stats require check
(118, 118, "Uldie", 0, "Halloween's Three Siblings' Children", 0, "LineageMonster5.br_wooldie", 10, 16, 80, "male", "L2Npc", 40, 20000000, 40, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 40, 5.78704, 30, 253, 1, 333, 0, 0, 0, 25, 120, 0, 1), 
(119, 119, "Belldandy", 0, "Halloween's Three Siblings", 0, "LineageMonster5.br_berdandi", 10, 14, 80, "male", "L2Npc", 40, 20000000, 40, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 40, 5.78704, 30, 253, 1, 333, 0, 0, 0, 45, 180, 0, 1), 
(120, 120, "Skooldie", 0, "Jack Game Trainer", 0, "LineageMonster5.br_scooldie", 10, 16, 80, "male", "L2Npc", 40, 20000000, 40, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 40, 5.78704, 30, 253, 1, 333, 0, 0, 0, 45, 180, 0, 1), 
(121, 121, "Lucky Lamp", 0, "", 0, "LineageNPC2.br_lamp", 4.2, 5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 10, 490, 10, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(122, 122, "Environment Lamp", 0, "", 0, "LineageNPC2.br_lamp", 4.2, 5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 10, 490, 10, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(123, 123, "Rolling Lamp", 0, "", 0, "LineageNPC2.br_lamp", 4.2, 5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 10, 490, 10, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(124, 124, "Peace Lamp", 0, "", 0, "LineageNPC2.br_lamp", 4.2, 5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 10, 490, 10, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(125, 125, "Halloween Event Manager", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 80, "male", "L2Npc", 40, 2880.37628, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 894.75854, 341.375, 611.00409, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(126, 126, "Kadomas", 0, "", 0, "LineageNPC2.br_kadomatsu", 24.5, 14, 80, "male", "L2Npc", 40, 1673.05473, 889.8, 0, 0.9, 40, 43, 30, 21, 20, 25, 0, 0, 8.47458, 60000, 5.78704, 200000, 253, 1, 333, 0, 0, 0, 60, 180, 0, 1), 
(127, 127, "Kotatz", 0, "", 0, "LineageNPC2.br_kotatsu", 0.01, 0.01, 80, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 10, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(128, 128, "Flame Box", 0, "Flame Box", 0, "LineageNPC2.br_fire_box", 11, 12.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 10, 490, 10, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(129, 129, "White-Bearded Santa", 0, "Merry Christmas!", 0, "LineageNPC2.br_xmas08_santa", 8, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 490, 10, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(130, 130, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 80, "male", "L2Npc", 40, 2880.37628, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 894.75854, 341.375, 611.00409, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(131, 131, "Jetbike", 0, "", 0, "LineageNPC2.br_z_bike", 30, 29, 80, "male", "L2Npc", 40, 2880.37628, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 894.75854, 341.375, 611.00409, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(132, 132, "Trejuo", 0, "Blessed Child", 0, "LineageNPC2.br_blessed_taiboy", 10, 13, 80, "male", "L2Npc", 40, 2880.37628, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 894.75854, 341.375, 611.00409, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(133, 133, "Sujin", 0, "Blessed Child", 0, "LineageNPC2.br_blessed_taiboy", 10, 13, 80, "female", "L2Npc", 40, 2880.37628, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 894.75854, 341.375, 611.00409, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(134, 134, "Dragon Master Lee", 0, "", 0, "LineageNPC2.br_dragonmaster_lee", 8, 19.3, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 42, 180, 0, 1), -- TODO: Stats require check
(135, 135, "Dragon Master Karin", 0, "", 0, "LineageNPC2.br_dragonmaster_karin", 8, 18.6, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 42, 180, 0, 1), -- TODO: Stats require check
(136, 136, "Shiny Platform", 0, "", 0, "LineageNPC2.br_shiny_platform", 21.5, 12.5, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(137, 137, "Big Wedding Cake", 0, "", 0, "LineageNPC2.br_big_wedding_cake", 25.5, 27, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(138, 138, "Jetbike", 0, "", 0, "LineageNPC2.br_z_bike", 21.5, 24, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(139, 139, "Birthday Cake", 0, "", 0, "LineageNPC2.br_birthday_cake", 0.01, 0.01, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 10, 490, 10, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(140, 140, "Block Checker Blue", 0, "", 0, "LineageNPC2.br_block_checker", 8, 21, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(141, 141, "Dimensional Door", 0, "Customer Joining", 0, "LineageNPC2.br_dimension_door", 24, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(142, 142, "Dimensional Door", 0, "Customer Joining", 0, "LineageNPC2.br_dimension_door", 24, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(143, 143, "Totem of Body", 0, "", 0, "LineageNPC2.br_totem_of_body", 9, 20, 80, "etc", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(144, 144, "Totem of Spirit", 0, "", 0, "LineageNPC2.br_totem_of_mind", 9, 20, 80, "etc", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(145, 145, "Totem of Bravery", 0, "", 0, "LineageNPC2.br_totem_of_bravery", 9, 20, 80, "etc", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(146, 146, "Totem of Fortitude", 0, "", 0, "LineageNPC2.br_totem_of_fortitude", 9, 20, 80, "etc", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(147, 147, "Party Cake", 0, "", 0, "LineageNPC2.br_birthday_cake", 0.01, 5.5, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(148, 148, "Campfire", 0, "", 0, "LineageNpc2.br_campfire", 29, 31, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(149, 149, "Angry Bunny", 0, "", 0, "LineageNpc2.br_Event_Baby_Rabbit", 8, 5.5, 80, "male", "L2Monster", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(150, 150, "Large Angry Bunny", 0, "", 0, "LineageNpc2.br_Event_Baby_Rabbit_Boss", 16, 8.5, 80, "male", "L2Monster", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(151, 151, "Fearless Angry Bunny", 0, "", 0, "LineageNpc2.br_Event_Sad_Baby_Rabbit", 8, 5.5, 80, "male", "L2Monster", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(152, 152, "Large Fearless Angry Bunny", 0, "", 0, "LineageNpc2.br_Event_Sad_Baby_Rabbit_Boss", 16, 8.5, 80, "male", "L2Monster", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(153, 153, "Magic Research Institute Employee", 0, "Event Manager", 0, "LineageNPC.e_smith_Fdwarf", 8, 17.5, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(154, 154, "", 0, "", 0, "LineageNPC.clear_npc", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(155, 155, "", 0, "", 0, "LineageNPC.clear_npc", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(156, 156, "Raging Bunny", 0, "", 0, "LineageNpc2.br_Event_Rabbit", 16, 8.5, 80, "male", "L2Monster", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(157, 157, "Large Raging Bunny", 0, "", 0, "LineageNpc2.br_Event_Rabbit_Boss", 23, 15.7, 80, "male", "L2Monster", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(158, 158, "Wood Horse", 0, "", 0, "LineageNpc2.br_wood_horse", 32, 19.5, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(1501, 1501, "Majo Agathion", 0, "", 0, "LineageNPC2.br_agathion_mazu", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1502, 1502, "Gold Agathion", 0, "", 0, "LineageNPC2.br_agathion_mazu", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1503, 1503, "Black Agathion", 0, "", 0, "LineageNPC2.br_agathion_mazu", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1504, 1504, "Plaipitak Agathion", 0, "", 0, "LineageNPC2.br_agathion_elephant", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1505, 1505, "Baby Panda Agathion", 0, "", 0, "LineageNPC2.br_agathion_bpanda", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1506, 1506, "Bamboo Panda Agathion", 0, "", 0, "LineageNPC2.br_agathion_mpanda", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1507, 1507, "Sexy Panda Agathion", 0, "", 0, "LineageNPC2.br_agathion_wpanda", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1508, 1508, "White Cupid Agathion", 0, "", 0, "LineageNPC2.br_agathion_wcupid", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1509, 1509, "Dark Cupid Agathion", 0, "", 0, "LineageNPC2.br_agathion_dcupid", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1510, 1510, "White Maneki Neko Agathion", 0, "", 0, "LineageNPC2.br_agathion_maneki", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1511, 1511, "Black Maneki Neko Agathion", 0, "", 0, "LineageNPC2.br_agathion_maneki", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1512, 1512, "Brown Maneki Neko Agathion", 0, "", 0, "LineageNPC2.br_agathion_maneki", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1513, 1513, "One-Eyed Bat Drove Agathion", 0, "", 0, "LineageNPC2.br_agathion_bat", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1514, 1514, "Pegasus Agathion", 0, "", 0, "LineageNPC2.br_agathion_pegasus", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1515, 1515, "Yellow-Robed Tojigong Agathion", 0, "", 0, "LineageNPC2.br_agathion_tozi", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1516, 1516, "Blue-Robed Tojigong Agathion", 0, "", 0, "LineageNPC2.br_agathion_tozi", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1517, 1517, "Green-Robed Tojigong Agathion", 0, "", 0, "LineageNPC2.br_agathion_tozi", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1518, 1518, "Bugbear Agathion", 0, "", 0, "LineageNPC2.br_agathion_bugbear", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1519, 1519, "Red Sumo Wrestler Agathion", 0, "", 0, "LineageNPC2.br_agathion_redsumo", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1520, 1520, "Blue Sumo Wrestler Agathion", 0, "", 0, "LineageNPC2.br_agathion_bluesumo", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1521, 1521, "Great Sumo Match Agathion", 0, "", 0, "LineageNPC2.br_agathion_match", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1522, 1522, "Button-Eyed Bear Doll", 0, "", 0, "LineageNPC2.br_agathion_bear", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1523, 1523, "God of Fortune", 0, "", 0, "LineageNPC2.br_agathion_wealthgod", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1524, 1524, "Dryad Agathion", 0, "", 0, "LineageNPC2.br_agathion_dryad", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1525, 1525, "Wonboso Agathion", 0, "", 0, "LineageNPC2.br_agathion_cashcow", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1526, 1526, "Daewoonso Agathion", 0, "", 0, "LineageNPC2.br_agathion_luckycow", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1527, 1527, "Pomona Agathion", 0, "", 0, "LineageNPC2.br_agathion_pomona", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1528, 1528, "Weaver Agathion", 0, "", 0, "LineageNPC2.br_agathion_womanweaver", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1529, 1529, "Chon-chon Agathion", 0, "", 0, "LineageNPC2.br_agathion_luckygirl", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1530, 1530, "Tang-tang Agathion", 0, "", 0, "LineageNPC2.br_agathion_luckyboy", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1531, 1531, "Dancing Lucky Kid Agathion", 0, "", 0, "LineageNPC2.br_agathion_dancingchild", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1532, 1532, "Monkey King Agathion", 0, "", 0, "LineageNPC2.br_agathion_sunwukong", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1533, 1533, "Utanka Agathion", 0, "", 0, "LineageNPC2.br_agathion_uthanka", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1534, 1534, "Bonus B Agathion", 0, "", 0, "LineageNPC2.br_agathion_bonus", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1535, 1535, "Zombie Agathion", 0, "", 0, "LineageNPC2.br_agathion_gangsi", 7, 6, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1536, 1536, "Baekyi Hwamae Agathion", 0, "", 0, "LineageNPC2.br_agathion_bluebird", 6, 5, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1537, 1537, "Gwanwoo Hwamae Agathion", 0, "", 0, "LineageNPC2.br_agathion_hatbird", 6, 5, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1538, 1538, "Baby Rudolph", 0, "", 0, "LineageNPC2.br_pet_rudolf", 21.5, 27, 55, "male", "L2Pet", 40, 1673.05473, 889.8, 6.5, 2.4, 35, 37, 30, 32, 20, 25, 0, 0, 388.11142, 60000, 265.02979, 20000, 253, 4, 333, 0, 0, 0, 35, 170, 0, 1), 
(1539, 1539, "Iken Agathion", 0, "", 0, "LineageNPC2.br_local_JP_Mfighter", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1540, 1540, "Lana Agathion", 0, "", 0, "LineageNPC2.br_local_JP_FFighter", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1541, 1541, "Gnocian Agathion", 0, "", 0, "LineageNPC2.br_local_JP_MElf", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1542, 1542, "Orodriel Agathion", 0, "", 0, "LineageNPC2.br_local_JP_Felf", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1543, 1543, "Lakinos Agathion", 0, "", 0, "LineageNPC2.br_local_JP_MDarkelf", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1544, 1544, "Mortia Agathion", 0, "", 0, "LineageNPC2.br_local_JP_Fdarkelf", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1545, 1545, "Hayance Agathion", 0, "", 0, "LineageNPC2.br_local_JP_MDwarf", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1546, 1546, "Meruril Agathion", 0, "", 0, "LineageNPC2.br_local_JP_FDwarf", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1547, 1547, "Taman ze Lapatui Agathion", 0, "", 0, "LineageNPC2.br_local_JP_MOrc", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1548, 1548, "Kaurin Agathion", 0, "", 0, "LineageNPC2.br_local_JP_FOrc", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1549, 1549, "Ahertbein Agathion", 0, "", 0, "LineageNPC2.br_local_JP_MKamael", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1550, 1550, "Naonin Agathion", 0, "", 0, "LineageNPC2.br_local_JP_FKamael", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1551, 1551, "Guangong Agathion", 0, "", 0, "LineageNPC2.br_aga_warriorgod", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1552, 1552, "Gwanseum Nyang Nyang Agathion", 0, "", 0, "LineageNPC2.br_aga_mercygod", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1553, 1553, "Blue Opera Agathion", 0, "", 0, "LineageNPC2.br_aga_blue_pekingopera", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1554, 1554, "Red Opera Agathion", 0, "", 0, "LineageNPC2.br_aga_red_pekingopera", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1555, 1555, "Opera Agathion", 0, "", 0, "LineageNPC2.br_aga_redblue_pekingopera", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1556, 1556, "Mandarin Dress Agathion", 0, "", 0, "LineageNPC2.br_aga_chinesedress", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1557, 1557, "Nepal Snow Agathion", 0, "", 0, "LineageNPC2.br_aga_suno_trumpet", 10.5, 12.5, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1558, 1558, "Round Ball Snow Agathion", 0, "", 0, "LineageNPC2.br_aga_suno_ball", 15, 20.5, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1559, 1559, "Ladder Snow Agathion", 0, "", 0, "LineageNPC2.br_aga_suno_tall", 20, 28, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1560, 1560, "Blue Opera Agathion", 0, "", 0, "LineageNPC2.br_aga_blue_pekingopera", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1561, 1561, "Baby Rudolph", 0, "", 0, "LineageNPC2.br_pet_rudolf", 21.5, 27, 55, "male", "L2Pet", 40, 3862, 1494, 6.5, 2.4, 35, 37, 30, 32, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 35, 170, 0, 1), 
(1562, 1562, "Deseloph", 0, "", 0, "LineageNPC2.br_pet_rose_lover_m_a", 13.2, 16.9, 55, "male", "L2Pet", 40, 1673.05473, 889.8, 6.5, 2.4, 35, 37, 30, 32, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(1563, 1563, "Hyum", 0, "", 0, "LineageNPC2.br_pet_rose_lover_m_a", 13.2, 16.9, 55, "male", "L2Pet", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1564, 1564, "Rekang", 0, "", 0, "LineageNPC2.br_pet_rose_lover_m_a", 13.2, 16.9, 55, "male", "L2Pet", 40, 1673.05473, 889.8, 6.5, 2.4, 38, 40, 30, 26, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 20, 180, 0, 1), 
(1565, 1565, "Lilias", 0, "", 0, "LineageNPC2.br_pet_rose_lover_f_a", 14.5, 17.5, 55, "female", "L2Pet", 40, 1673.05473, 889.8, 6.5, 2.4, 38, 40, 30, 26, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 20, 180, 0, 1), 
(1566, 1566, "Lapham", 0, "", 0, "LineageNPC2.br_pet_rose_lover_f_a", 14.5, 17.5, 55, "female", "L2Pet", 40, 1673.05473, 889.8, 6.5, 2.4, 38, 40, 30, 26, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 20, 180, 0, 1), 
(1567, 1567, "Mafum", 0, "", 0, "LineageNPC2.br_pet_rose_lover_f_a", 14.5, 17.5, 55, "female", "L2Pet", 40, 1673.05473, 889.8, 6.5, 2.4, 38, 40, 30, 26, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 20, 180, 0, 1), 
(1568, 1568, "Deseloph", 0, "", 0, "LineageNPC2.br_pet_rose_lover_m_b", 15.3, 16.6, 55, "male", "L2Pet", 40, 1673.05473, 889.8, 6.5, 2.4, 38, 40, 30, 26, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 20, 180, 0, 1), 
(1569, 1569, "Hyum", 0, "", 0, "LineageNPC2.br_pet_rose_lover_m_b", 15.3, 16.6, 55, "male", "L2Pet", 40, 1673.05473, 889.8, 6.5, 2.4, 38, 40, 30, 26, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 20, 180, 0, 1), 
(1570, 1570, "Rekang", 0, "", 0, "LineageNPC2.br_pet_rose_lover_m_b", 15.3, 16.6, 55, "male", "L2Pet", 40, 1673.05473, 889.8, 6.5, 2.4, 38, 40, 30, 26, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 20, 180, 0, 1), 
(1571, 1571, "Lilias", 0, "", 0, "LineageNPC2.br_pet_rose_lover_f_b", 14.7, 17.3, 55, "female", "L2Pet", 40, 1673.05473, 889.8, 6.5, 2.4, 38, 40, 30, 26, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 20, 180, 0, 1), 
(1572, 1572, "Lapham", 0, "", 0, "LineageNPC2.br_pet_rose_lover_f_b", 14.7, 17.3, 55, "female", "L2Pet", 40, 1673.05473, 889.8, 6.5, 2.4, 38, 40, 30, 26, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 20, 180, 0, 1), 
(1573, 1573, "Mafum", 0, "", 0, "LineageNPC2.br_pet_rose_lover_f_b", 14.7, 17.3, 55, "female", "L2Pet", 40, 1673.05473, 889.8, 6.5, 2.4, 38, 40, 30, 26, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 20, 180, 0, 1), 
(1574, 1574, "Phoenix", 0, "", 0, "LineageNPC2.br_aga_china_phoenix", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1575, 1575, "Three-headed Dragon", 0, "", 0, "LineageNPC2.br_aga_threehead", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1576, 1576, "Ball Trapping Gnosian", 0, "", 0, "LineageNPC2.br_aga_ball_male", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1577, 1577, "Ball Trapping Orodriel", 0, "", 0, "LineageNPC2.br_aga_ball_female", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1578, 1578, "Penalty Kick", 0, "", 0, "LineageNPC2.br_aga_ball_kick", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1579, 1579, "Ball Trapping Gnosian (blue)", 0, "", 0, "LineageNPC2.br_aga_ball_male", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1580, 1580, "Ball Trapping Orodriel (blue)", 0, "", 0, "LineageNPC2.br_aga_ball_female", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1581, 1581, "Penalty Kick (blue)", 0, "", 0, "LineageNPC2.br_aga_ball_kick", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1582, 1582, "Ball Trapping Gnosian (red)", 0, "", 0, "LineageNPC2.br_aga_ball_male", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1583, 1583, "Ball Trapping Orodriel (red)", 0, "", 0, "LineageNPC2.br_aga_ball_female", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1584, 1584, "Penalty Kick (red)", 0, "", 0, "LineageNPC2.br_aga_ball_kick", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1585, 1585, "Granny Tiger", 0, "", 0, "LineageNPC2.br_aga_tiger_grandma", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1586, 1586, "Flower Fairy Spirit", 0, "", 0, "LineageNPC2.br_aga_flower", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1587, 1587, "Cheerleader Orodriel", 0, "", 0, "LineageNPC2.br_aga_cheer", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1588, 1588, "Cheerleader Lana", 0, "", 0, "LineageNPC2.br_aga_cheer", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1589, 1589, "Cheerleader Naonin", 0, "", 0, "LineageNPC2.br_aga_cheer", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1590, 1590, "Cheerleader Mortia", 0, "", 0, "LineageNPC2.br_aga_cheer", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1591, 1591, "Cheerleader Kaurin", 0, "", 0, "LineageNPC2.br_aga_cheer", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1592, 1592, "Cheerleader Meruril", 0, "", 0, "LineageNPC2.br_aga_cheer", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1593, 1593, "Handy", 0, "", 0, "LineageNPC2.br_aga_ball_kick", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(1594, 1594, "Singer & Dancer Agathion", 0, "Singer & Dancer Agathion", 0, "LineageNPC2.br_aga_singer_dancer", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(1595, 1595, "Zakensword Agathion", 0, "Zakensword Agathion", 0, "LineageNPC2.br_aga_zaken", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(1596, 1596, "Cow Agathion", 0, "Cow Agathion", 0, "LineageNPC2.br_aga_cow", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(1597, 1597, "Tow Agathion", 0, "Tow Agathion", 0, "LineageNPC2.br_aga_tow", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(1598, 1598, "Rudolph Agathion", 0, "", 0, "LineageNpc2.br_aga_rudolph", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(1599, 1599, "Zinyanzi Agathion", 0, "", 0, "LineageNPC2.br_aga_jiayan", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(1600, 1600, "Zinyanzi Agathion", 0, "", 0, "LineageNPC2.br_aga_jiayan", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(1601, 1601, "Super Feline Queen Z", 0, "", 0, "LineageNPC2.br_supercat_queen", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(1602, 1602, "Super Kat the Cat Z", 0, "", 0, "LineageNPC2.br_supercat", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(1603, 1603, "Super Mew the Cat Z", 0, "", 0, "LineageNPC2.br_supercat_mew", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(1604, 1604, "Hanbok Agathion", 0, "", 0, "LineageNpc2.br_aga_han", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(1605, 1605, "Juju Agathion", 0, "", 0, "LineageNPC2.agathion_cupi", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(2081, 2081, "Plague Kanabion", 0, "", 0, "LineageMonster6.br_husk_crawler", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(2082, 2082, "Plague Kanabion", 0, "Doppler", 0, "LineageMonster6.br_husk_stalker", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(2083, 2083, "Plague Kanabion", 0, "Void", 0, "LineageMonster6.br_husk_warper", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(2501, 2501, "Lucky Pig", 0, "The Spirit of Fortune", 0, "LineageNPC2.br_LuckyPig", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(2502, 2502, "Wingless Lucky Pig", 0, "", 0, "LineageNPC2.E_pig_ball", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(2503, 2503, "Wingless Lucky Pig", 0, "", 0, "LineageNPC2.E_pig_ball", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(4301, 4301, "Queen of Hearts", 0, "Valentine Messenger", 0, "LineageMonster2.queen_of_cat", 8, 15, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 10, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 26, 120, 0, 1), 
(4302, 4302, "Master Dugi", 0, "Soul Healer", 0, "LineageNPC2.event_comic_masteryogy", 9, 16.7, 1, "female", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 4, 333, 0, 0, 0, 50, 160, 0, 1), 
(4303, 4303, "Skooldy", 0, "Halloween Children", 0, "LineageMonster5.br_scooldie", 10, 16, 85, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 723, 10, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(4304, 4304, "Santa", 0, "Merry Christmas", 0, "LineageNPC2.br_xmas08_santa", 8, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 490, 10, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(4305, 4305, "Rosalia", 0, "Hopeless Romantic", 0, "LineageNPC2.message_event_master", 10, 20, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 160, 0, 1), 
(4306, 4306, "Steve Shyagel", 0, "Eva's High Priest", 0, "LineageNPC2.br_archbishop_of_eva", 8, 26.5, 85, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 723, 10, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(4307, 4307, "Santa Claus", 0, "Event Manager", 0, "LineageNPC2.santa_claus_120p", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(4308, 4308, "Angel Cat", 0, "Heavenly Envoy", 0, "LineageNPC2.br_angel_cat", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(4309, 4309, "Prophet", 0, "Sinister", 0, "LineageMonster3.solina_father", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(4310, 4310, "Prophet", 0, "Sinister", 0, "LineageMonster3.solina_father", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(4311, 4311, "Prophet", 0, "Sinister", 0, "LineageMonster3.solina_father", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(4312, 4312, "Prophet", 0, "Sinister", 0, "LineageMonster3.solina_father", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(4313, 4313, "Angel Cat", 0, "Character Collector", 0, "LineageNPC2.br_angel_cat", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(4314, 4314, "Teleport Device", 0, "", 0, "LineageNPCEV.dark_obelisk", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(4315, 4315, "Warehouse Keeper", 0, "Fantasy Isle Warehouse Keeper ", 0, "LineageNPC.e_teleporter_FDwarf", 8, 21.3, 70, "female", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(4316, 4316, "Photo Snow", 0, "Photographer", 0, "LineageNPC2.br_tp_actor", 9, 16.3, 55, "female", "L2Teleporter", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 4, 180, 0, 1), -- TODO: Stats require check
(4317, 4317, "Photo Snow", 0, "Photographer", 0, "LineageNPC2.br_tp_actor", 9, 16.3, 55, "female", "L2Teleporter", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 4, 180, 0, 1), -- TODO: Stats require check
(4318, 4318, "Photo Snow", 0, "Photographer", 0, "LineageNPC2.br_tp_actor", 9, 16.3, 55, "female", "L2Teleporter", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 4, 180, 0, 1), -- TODO: Stats require check
(4319, 4319, "Photo Snow", 0, "Photographer", 0, "LineageNPC2.br_tp_actor", 9, 16.3, 55, "female", "L2Teleporter", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 4, 180, 0, 1), -- TODO: Stats require check
(4320, 4320, "Photo Snow", 0, "Photographer", 0, "LineageNPC2.br_tp_actor", 9, 16.3, 55, "female", "L2Teleporter", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 4, 180, 0, 1), -- TODO: Stats require check
(4321, 4321, "Photo Snow", 0, "Photographer", 0, "LineageNPC2.br_tp_actor", 9, 16.3, 55, "female", "L2Teleporter", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 4, 180, 0, 1), -- TODO: Stats require check
(4322, 4322, "Photo Snow", 0, "Photographer", 0, "LineageNPC2.br_tp_actor", 9, 16.3, 55, "female", "L2Teleporter", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 4, 180, 0, 1), -- TODO: Stats require check
(4323, 4323, "Photo Snow", 0, "Photographer", 0, "LineageNPC2.br_tp_actor", 9, 16.3, 55, "female", "L2Teleporter", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 4, 180, 0, 1), -- TODO: Stats require check
(4324, 4324, "Worshipper", 0, "Sinister", 0, "LineageMonster3.solina_father", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(4325, 4325, "Altar Guard", 0, "", 0, "LineageNPC.a_guard_MHuman", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(4326, 4326, "Nevit's Herald", 0, "Invoker", 0, "LineageNPC.a_sanctuary_teacher_FHuman", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(4327, 4327, "Worshipper", 0, "Sinister", 0, "LineageNPC2.solina_father_dead", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(4328, 4328, "Altar Guard", 0, "", 0, "LineageNPC2.a_guard_Mhuman_dead", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(4329, 4329, "Miss Queen", 0, "Happy Messenger", 0, "LineageMonster2.queen_of_cat", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(12077, 12077, "Wolf", 0, "", 0, "LineageMonster.pet_wolf", 13, 11.5, 15, "male", "L2Pet", 40, 246.95422, 149.2, 2.5, 1.2, 40, 43, 30, 21, 20, 25, 0, 0, 29.61691, 73.55216, 20.22451, 53.82228, 253, 4, 333, 0, 0, 0, 24, 125, 0, 1), 
(12311, 12311, "Hatchling of the Wind", 0, "", 0, "LineageMonster.hatchling", 9, 10, 35, "male", "L2Pet", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 25, 0, 0, 129.32896, 136.72948, 88.31491, 100.0527, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(12312, 12312, "Hatchling of the Stars", 0, "", 0, "LineageMonster.hatchling", 9, 10, 35, "male", "L2Pet", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 25, 0, 0, 129.32896, 136.72948, 88.31491, 100.0527, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(12313, 12313, "Hatchling of Twilight", 0, "", 0, "LineageMonster.hatchling", 9, 10, 35, "male", "L2Pet", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 25, 0, 0, 129.32896, 136.72948, 88.31491, 100.0527, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(12526, 12526, "Wind Strider", 0, "", 0, "LineageMonster.strider", 23, 31, 55, "male", "L2Pet", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), -- TODO: Stats require check
(12527, 12527, "Star Strider", 0, "", 0, "LineageMonster.strider", 23, 31, 55, "male", "L2Pet", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), -- TODO: Stats require check
(12528, 12528, "Twilight Strider", 0, "", 0, "LineageMonster.strider", 23, 31, 55, "male", "L2Pet", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), -- TODO: Stats require check
(12564, 12564, "Sin Eater", 0, "", 0, "LineageMonster.imp", 10, 24, 15, "male", "L2Pet", 40, 424.2, 149.2, 7.2513, 1.2, 40, 1, 30, 21, 20, 25, 0, 0, 29.61691, 73.55216, 20.22451, 53.82228, 253, 4, 333, 0, 0, 0, 60, 125, 0, 1), 
(12621, 12621, "Wyvern", 0, "", 0, "LineageMonster.wyvern", 60, 80, 70, "male", "L2Pet", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), 
(12774, 12774, "Young Squash", 0, "", 0, "LineageNPC.drop_gourd_50_sm", 10, 10.5, 1, "etc", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 10, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 1, 333, 0, 0, 0, 50, 100, 0, 1), 
(12775, 12775, "High Quality Squash", 0, "", 0, "LineageNPC.drop_gourd", 23, 25, 1, "etc", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 10, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 1, 333, 0, 0, 0, 50, 100, 0, 1), 
(12776, 12776, "Low Quality Squash", 0, "", 0, "LineageNPC.drop_gourd_25_sm", 15, 16, 1, "etc", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 10, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 1, 333, 0, 0, 0, 50, 100, 0, 1), 
(12777, 12777, "Large Young Squash", 0, "", 0, "LineageNPC.drop_gourd", 23, 25, 1, "etc", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 10, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 1, 333, 0, 0, 0, 50, 100, 0, 1), 
(12778, 12778, "High Quality Large Squash", 0, "", 0, "LineageNPC.drop_gourd_50_bi", 34, 40, 1, "etc", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 10, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 1, 333, 0, 0, 0, 50, 100, 0, 1), 
(12779, 12779, "Low Quality Large Squash", 0, "", 0, "LineageNPC.drop_gourd_25_bi", 28, 31, 1, "etc", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 10, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 1, 333, 0, 0, 0, 50, 100, 0, 1), 
(12780, 12780, "Baby Buffalo", 0, "", 0, "LineageMonster2.baby_buffalo", 12, 15, 25, "male", "L2BabyPet", 40, 460.96247, 259.2, 3.5, 1.5, 40, 43, 30, 21, 20, 25, 0, 0, 64.83203, 101.83533, 44.27187, 74.51868, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(12781, 12781, "Baby Kookaburra", 0, "", 0, "LineageMonster2.baby_ostrich", 7, 15, 25, "male", "L2BabyPet", 40, 460.96247, 259.2, 3.5, 1.5, 40, 43, 30, 21, 20, 25, 0, 0, 64.83203, 101.83533, 44.27187, 74.51868, 253, 4, 333, 0, 0, 0, 13, 120, 0, 1), 
(12782, 12782, "Baby Cougar", 0, "", 0, "LineageMonster2.baby_tiger", 11, 15.7, 25, "male", "L2BabyPet", 40, 460.96247, 259.2, 3.5, 1.5, 40, 43, 30, 21, 20, 25, 0, 0, 64.83203, 101.83533, 44.27187, 74.51868, 253, 4, 333, 0, 0, 0, 28, 120, 0, 1), 
(13001, 13001, "Heart of Warding", 0, "", 0, "LineageNPC.heart_of_warding", 17, 120, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 10, 490, 10, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(13002, 13002, "Life Control Tower", 0, "", 0, "LineageNPC.broadcasting_tower", 7, 35, 20, "etc", "L2ControlTower", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 10, 40, 10, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13003, 13003, "Life Control Tower", 0, "", 0, "LineageNPC.dead_castle_aden_controltower_jewel", 7, 35, 20, "etc", "L2ControlTower", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 10, 40, 10, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13004, 13004, "Flame Control Tower", 0, "", 0, "LineageNPC.broadcasting_tower", 7, 35, 20, "etc", "L2FlameTower", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 10, 40, 10, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13005, 13005, "Flame Control Tower", 0, "", 0, "LineageNPC.dead_castle_aden_controltower_jewel", 7, 35, 20, "etc", "L2FlameTower", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 10, 40, 10, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13006, 13006, "Christmas Tree", 0, "", 0, "LineageDeco.x_mas_tree", 0.01, 0.01, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 10, 490, 10, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(13007, 13007, "Special Christmas Tree", 0, "", 0, "LineageDeco.x_mas_tree_50_bi", 0.01, 0.01, 70, "male", "L2XmassTree", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 10, 490, 10, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(13014, 13014, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 85, "male", "L2Npc", 40, 3046.70947, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 10, 0, 0, 983.0479, 361.78814, 671.29428, 264.74086, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(13015, 13015, "", 0, "", 0, "LineageMonster3.Evilate_weather", 16, 18.5, 85, "female", "L2Npc", 40, 3046.70947, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 983.0479, 361.78814, 671.29428, 264.74086, 253, 4, 333, 0, 0, 0, 10, 1, 0, 1), 
(13016, 13016, "King Squash", 0, "", 0, "LineageNPC.drop_gourd", 23, 25, 1, "etc", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 10, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 1, 333, 0, 0, 0, 50, 100, 0, 1), 
(13017, 13017, "Emperor Squash", 0, "", 0, "LineageNPC.drop_gourd_50_bi", 34, 40, 1, "etc", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 10, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 1, 333, 0, 0, 0, 50, 100, 0, 1), 
(13018, 13018, "", 0, "", 0, "LineageNPC2.skill_dummy_00_a", 5, 10, 70, "etc", "L2EffectPoint", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 20, 0, 1), 
(13019, 13019, "", 0, "", 0, "LineageNPC2.skill_dummy_00_a", 5, 10, 70, "etc", "L2EffectPoint", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 20, 0, 1), 
(13020, 13020, "", 0, "", 0, "LineageNPC2.skill_dummy_00_a", 5, 10, 70, "etc", "L2EffectPoint", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 20, 0, 1), 
(13021, 13021, "", 0, "", 0, "LineageNPC2.skill_dummy_00_a", 5, 10, 70, "etc", "L2EffectPoint", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 20, 0, 1), 
(13022, 13022, "", 0, "", 0, "LineageNPC2.skill_dummy_00_a", 5, 10, 70, "etc", "L2EffectPoint", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 20, 0, 1), 
(13023, 13023, "", 0, "", 0, "LineageNPC2.skill_dummy_00_a", 5, 10, 70, "etc", "L2EffectPoint", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 20, 0, 1), 
(13024, 13024, "", 0, "", 0, "LineageNPC2.skill_dummy_00_a", 5, 10, 70, "etc", "L2EffectPoint", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 20, 0, 1), 
(13025, 13025, "", 0, "", 0, "LineageNPC2.skill_dummy_01_a", 5, 10, 70, "etc", "L2EffectPoint", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 20, 0, 1), 
(13026, 13026, "", 0, "", 0, "LineageNPC2.skill_dummy_01_a", 5, 10, 70, "etc", "L2EffectPoint", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 20, 0, 1), 
(13027, 13027, "", 0, "", 0, "LineageNPC2.skill_dummy_01_a", 5, 10, 70, "etc", "L2EffectPoint", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 20, 0, 1), 
(13028, 13028, "", 0, "", 0, "LineageNPC2.skill_dummy_01_a", 5, 10, 70, "etc", "L2EffectPoint", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 20, 0, 1), 
(13029, 13029, "", 0, "", 0, "LineageNPC2.skill_dummy_01_a", 5, 10, 70, "etc", "L2EffectPoint", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 20, 0, 1), 
(13030, 13030, "", 0, "", 0, "LineageNPC2.skill_dummy_01_a", 5, 10, 70, "etc", "L2EffectPoint", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 20, 0, 1), 
(13031, 13031, "Huge Pig", 0, "", 0, "LineageNPC2.E_pig_ball", 15, 18.3, 80, "male", "L2Npc", 40, 680, 2000, 0, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 60000, 5.78704, 200000, 253, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(13032, 13032, "Huge Pig", 0, "", 0, "LineageNPC2.E_pig_ball", 15, 18.3, 80, "male", "L2Npc", 40, 680, 2000, 0, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 60000, 5.78704, 200000, 253, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(13033, 13033, "Huge Pig", 0, "", 0, "LineageNPC2.E_pig_ball", 15, 18.3, 80, "male", "L2Npc", 40, 680, 2000, 0, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 60000, 5.78704, 200000, 253, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(13034, 13034, "Super Huge Pig", 0, "", 0, "LineageNPC2.E_pig_ball_H", 29, 38.7, 80, "male", "L2Monster", 40, 3400, 6000, 0, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 60000, 5.78704, 200000, 253, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(13035, 13035, "Golden Pig", 0, "", 0, "LineageNPC2.E_pig_ball", 15, 18.3, 80, "male", "L2Npc", 40, 680, 2000, 0, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 60000, 5.78704, 200000, 253, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(13036, 13036, "Alchemist's Chest", 0, "", 0, "LineageMonster.mimic_even", 8.5, 8.5, 80, "male", "L2Chest", 40, 2880.37628, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 894.75854, 341.375, 611.00409, 249.80341, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(13037, 13037, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 28, "etc", "L2Npc", 40, 543.79576, 300.96, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 80.54056, 111.61368, 54.99876, 81.67405, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13038, 13038, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 36, "etc", "L2Npc", 40, 809.52639, 417.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 137.86467, 140.57278, 94.1437, 102.86506, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13039, 13039, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 43, "etc", "L2Npc", 40, 1094.28943, 557.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 210.04832, 169.13417, 143.43577, 123.76505, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13040, 13040, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 49, "etc", "L2Npc", 40, 1372.18568, 720, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 290.44588, 195.66302, 198.33688, 143.17771, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13041, 13041, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 55, "etc", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13042, 13042, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 60, "etc", "L2Npc", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 481.34551, 247.65008, 328.69659, 181.21958, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13043, 13043, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 64, "etc", "L2Npc", 40, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 562.02275, 267.04468, 383.78868, 195.41171, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13044, 13044, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 68, "etc", "L2Npc", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 646.17968, 286.3615, 441.25696, 209.54692, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13045, 13045, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 72, "etc", "L2Npc", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13046, 13046, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 49, "etc", "L2Npc", 40, 1372.18568, 720, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 290.44588, 195.66302, 198.33688, 143.17771, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13047, 13047, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 55, "etc", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13048, 13048, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 60, "etc", "L2Npc", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 481.34551, 247.65008, 328.69659, 181.21958, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13049, 13049, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 64, "etc", "L2Npc", 40, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 562.02275, 267.04468, 383.78868, 195.41171, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13050, 13050, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 68, "etc", "L2Npc", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 646.17968, 286.3615, 441.25696, 209.54692, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13051, 13051, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 72, "etc", "L2Npc", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13052, 13052, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 55, "etc", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13053, 13053, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 60, "etc", "L2Npc", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 481.34551, 247.65008, 328.69659, 181.21958, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13054, 13054, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 64, "etc", "L2Npc", 40, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 562.02275, 267.04468, 383.78868, 195.41171, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13055, 13055, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 68, "etc", "L2Npc", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 646.17968, 286.3615, 441.25696, 209.54692, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13056, 13056, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 72, "etc", "L2Npc", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13057, 13057, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 40, "etc", "L2Npc", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 176.36077, 156.55035, 120.43155, 114.55675, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13058, 13058, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 46, "etc", "L2Npc", 40, 1229.78678, 637.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 248.0526, 182.18816, 169.38777, 133.31739, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13059, 13059, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 52, "etc", "L2Npc", 40, 1520.38155, 804, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 337.18867, 209.50106, 230.25615, 153.30378, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13060, 13060, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 58, "etc", "L2Npc", 40, 1828.68266, 977.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 442.8992, 237.99429, 302.44274, 174.1539, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13061, 13061, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 62, "etc", "L2Npc", 40, 2037.81082, 1097, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 521.12391, 257.34267, 355.86007, 188.3122, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13062, 13062, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 66, "etc", "L2Npc", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 603.79903, 276.72752, 412.31647, 202.49719, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13063, 13063, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13064, 13064, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 74, "etc", "L2Npc", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 773.81598, 314.65987, 528.41601, 230.25444, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13065, 13065, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 52, "etc", "L2Npc", 40, 1520.38155, 804, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 337.18867, 209.50106, 230.25615, 153.30378, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13066, 13066, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 58, "etc", "L2Npc", 40, 1828.68266, 977.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 442.8992, 237.99429, 302.44274, 174.1539, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13067, 13067, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 62, "etc", "L2Npc", 40, 2037.81082, 1097, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 521.12391, 257.34267, 355.86007, 188.3122, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13068, 13068, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 66, "etc", "L2Npc", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 603.79903, 276.72752, 412.31647, 202.49719, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13069, 13069, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13070, 13070, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 74, "etc", "L2Npc", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 773.81598, 314.65987, 528.41601, 230.25444, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13071, 13071, "Virtual Image", 0, "", 0, "LineageNPC2.Decoy_Medium", 8.5, 25, 43, "etc", "L2Decoy", 40, 1094.28943, 557.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 210.04832, 169.13417, 143.43577, 123.76505, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13072, 13072, "Virtual Image", 0, "", 0, "LineageNPC2.Decoy_Medium", 8.5, 25, 52, "etc", "L2Decoy", 40, 1520.38155, 804, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 337.18867, 209.50106, 230.25615, 153.30378, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13073, 13073, "Virtual Image", 0, "", 0, "LineageNPC2.Decoy_Medium", 8.5, 25, 60, "etc", "L2Decoy", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 481.34551, 247.65008, 328.69659, 181.21958, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13074, 13074, "Virtual Image", 0, "", 0, "LineageNPC2.Decoy_Medium", 8.5, 25, 66, "etc", "L2Decoy", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 603.79903, 276.72752, 412.31647, 202.49719, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13075, 13075, "Virtual Image", 0, "", 0, "LineageNPC2.Decoy_Medium", 8.5, 25, 70, "etc", "L2Decoy", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13076, 13076, "Virtual Image", 0, "", 0, "LineageNPC2.Decoy_Medium", 8.5, 25, 74, "etc", "L2Decoy", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 773.81598, 314.65987, 528.41601, 230.25444, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13077, 13077, "Onyx Beast", 0, "", 0, "LineageMonster.onyx_beast", 12, 14.5, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), -- TODO: Stats require check
(13078, 13078, "Doom Wraith", 0, "", 0, "LineageMonster.death_blader_tr", 13, 25, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 100, 180, 0, 1), -- TODO: Stats require check
(13079, 13079, "Grail Apostle", 0, "", 0, "LineageMonster3.apostle_grail_tr", 10, 35, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(13080, 13080, "Grail Apostle", 0, "", 0, "LineageMonster2.apostle_warrior", 8, 30, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(13081, 13081, "Unicorn", 0, "", 0, "LineageMonster.Unicorn_tr", 15, 28, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 46, 180, 0, 1), -- TODO: Stats require check
(13082, 13082, "Lilim Knight", 0, "", 0, "LineageMonster4.lilim_knight_tr", 12, 25.5, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 56, 180, 0, 1), -- TODO: Stats require check
(13083, 13083, "Golem Guardian", 0, "", 0, "LineageMonster3.golem_guardian_tr", 13, 25, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 53, 180, 0, 1), -- TODO: Stats require check
(13084, 13084, "Inferno Drake", 0, "", 0, "LineageMonster2.inferno_drake_tr", 15, 24, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 57, 180, 0, 1), -- TODO: Stats require check
(13085, 13085, "Dragon Bomber", 0, "", 0, "LineageMonster3.antaras_ex_b_tr", 16, 24, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 100, 180, 0, 1), -- TODO: Stats require check
(13086, 13086, "Zariche", 0, "", 0, "LineageMonster4.Avatar_Z", 12, 31.57, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 8190, 0, 0, 80, 180, 0, 1), 
(13087, 13087, "Akamanah", 0, "", 0, "LineageMonster4.Avatar_A", 10, 32.73, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 8689, 0, 0, 80, 180, 0, 1), 
(13088, 13088, "Final Form", 0, "", 0, "LineageMonster4.Specular_Form", 9, 38, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(13089, 13089, "Final Form", 0, "", 0, "LineageMonster4.Specular_Form_F", 10, 32.76, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(13090, 13090, "Native", 0, "", 0, "LineageNPC.a_common_peopleC_Mhuman", 10, 24, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 50, 180, 0, 1), -- TODO: Stats require check
(13091, 13091, "Yeti", 0, "", 0, "LineageMonster.yeti", 15, 27.5, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 80, 180, 0, 1), -- TODO: Stats require check
(13092, 13092, "Buffalo", 0, "", 0, "LineageMonster2.buffalo", 22, 31, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 80, 180, 0, 1), -- TODO: Stats require check
(13093, 13093, "Pig", 0, "", 0, "LineageNPC2.E_pig_ball", 15, 18.3, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(13094, 13094, "Zombie", 0, "", 0, "LineageMonster3.zombie_laborer", 11, 24.6, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 36, 180, 0, 1), -- TODO: Stats require check
(13095, 13095, "Pixy", 0, "", 0, "LineageMonster.pixy", 5, 25, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 80, 180, 0, 1), -- TODO: Stats require check
(13096, 13096, "Rabbit", 0, "", 0, "LineageMonster.rabbit", 5, 4.5, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 50, 180, 0, 1), -- TODO: Stats require check
(13097, 13097, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 80, "male", "L2Monster", 40, 2880.37628, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 894.75854, 341.375, 611.00409, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(13098, 13098, "Event Treasure Chest", 0, "", 0, "LineageMonster.mimic_even", 8.5, 8.5, 80, "male", "L2EventChest", 40, 2880.37628, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 894.75854, 341.375, 611.00409, 249.80341, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(13099, 13099, "Zaken", 0, "", 0, "LineageMonster.zaken_tr", 16, 32, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 42, 180, 0, 1), -- TODO: Stats require check
(13100, 13100, "Anakim", 0, "", 0, "LineageMonster2.anakim_tr", 15.5, 29, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 45, 180, 0, 1), -- TODO: Stats require check
(13101, 13101, "Benom", 0, "", 0, "LineageMonster3.benom_tr", 20, 56, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 79, 180, 0, 1), -- TODO: Stats require check
(13102, 13102, "Gordon", 0, "", 0, "LineageMonster3.Cruel_Rider_tr", 43, 46.6, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(13103, 13103, "Ranku", 0, "", 0, "LineageMonster4.LaneCoo_tr", 13, 29, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 26, 180, 0, 1), -- TODO: Stats require check
(13104, 13104, "Kiyachi", 0, "", 0, "LineageMonster4.Keyache_tr", 12, 29, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 26, 180, 0, 1), -- TODO: Stats require check
(13105, 13105, "Demon Prince", 0, "", 0, "LineageMonster4.rahuu_tr", 33, 49, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(13106, 13106, "Heretic Male", 0, "", 0, "LineageMonster3.heretic_privates_tr", 7.7, 28.4, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(13107, 13107, "Heretic Female", 0, "", 0, "LineageMonster3.heretic_priest_tr", 8, 19.1, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), -- TODO: Stats require check
(13108, 13108, "Vale master", 0, "", 0, "LineageMonster.vale_master_tr", 12, 40, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 70, 180, 0, 1), -- TODO: Stats require check
(13109, 13109, "Saber Tooth Tiger", 0, "", 0, "LineageMonster.saber_toothed_tiger_tr", 34, 28, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 8190, 0, 0, 60, 180, 0, 1), 
(13110, 13110, "Ol Mahum", 0, "", 0, "LineageMonster.oel_mahum_champion_tr", 23, 61, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 8689, 0, 0, 67, 180, 0, 1), 
(13111, 13111, "Doll Blader", 0, "", 0, "LineageMonster.doll_blader_tr", 6, 12, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 22, 180, 0, 1), -- TODO: Stats require check
(13112, 13112, "Divine Knight", 0, "", 0, "LineageMonster4.Divine_tanker", 16, 30, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 49, 180, 0, 1), -- TODO: Stats require check
(13113, 13113, "Divine Warrior", 0, "", 0, "LineageMonster4.Divine_Warrior", 14.5, 29, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 46, 180, 0, 1), -- TODO: Stats require check
(13114, 13114, "Divine Rogue", 0, "", 0, "LineageMonster4.Divine_Rogue", 10, 28, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 50, 180, 0, 1), -- TODO: Stats require check
(13115, 13115, "Divine Healer", 0, "", 0, "LineageMonster4.Divine_healer", 10, 25, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(13116, 13116, "Divine Wizard", 0, "", 0, "LineageMonster4.Divine_Wizard", 10, 26, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 50, 180, 0, 1), -- TODO: Stats require check
(13117, 13117, "Divine Enchanter", 0, "", 0, "LineageMonster4.Divine_enchanter", 8, 18.25, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(13118, 13118, "Divine Summoner", 0, "", 0, "LineageMonster4.Divine_healer", 10, 25, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(13119, 13119, "Dwarf Golem", 0, "", 0, "LineageMonster3.chaos_golem_tr", 31, 51.8, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 18, 180, 0, 1), -- TODO: Stats require check
(13120, 13120, "Giant rat", 0, "", 0, "LineageMonster4.little_mouse_120p", 15, 20, 80, "male", "L2Npc", 40, 680, 2000, 0, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 60000, 5.78704, 200000, 253, 1, 333, 0, 0, 0, 19.5, 160, 0, 1), 
(13121, 13121, "Giant rat", 0, "", 0, "LineageMonster4.little_mouse_120p", 15, 20, 80, "male", "L2Npc", 40, 680, 2000, 0, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 60000, 5.78704, 200000, 253, 1, 333, 0, 0, 0, 19.5, 160, 0, 1), 
(13122, 13122, "Giant rat", 0, "", 0, "LineageMonster4.little_mouse_120p", 15, 20, 80, "male", "L2Npc", 40, 680, 2000, 0, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 60000, 5.78704, 200000, 253, 1, 333, 0, 0, 0, 19.5, 160, 0, 1), 
(13123, 13123, "Super giant rat", 0, "", 0, "LineageMonster4.little_mouse_180p", 19, 33, 80, "male", "L2Npc", 40, 3400, 6000, 0, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 60000, 5.78704, 200000, 253, 1, 333, 0, 0, 0, 28.5, 160, 0, 1), 
(13124, 13124, "Giant rat", 0, "Mr. Bashful", 0, "LineageMonster4.little_mouse_120p", 15, 20, 80, "male", "L2Npc", 40, 680, 2000, 0, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 60000, 5.78704, 200000, 253, 1, 333, 0, 0, 0, 19.5, 160, 0, 1), 
(13125, 13125, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 64, "etc", "L2Npc", 40, 2244.67715, 1219.8, 0, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 60000, 5.78704, 200000, 253, 1, 333, 0, 0, 0, 50, 1, 0, 1), 
(13126, 13126, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 64, "etc", "L2Npc", 40, 2444.46819, 1345.8, 0, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 60000, 5.78704, 200000, 253, 1, 333, 0, 0, 0, 50, 1, 0, 1), 
(13127, 13127, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 68, "etc", "L2Npc", 40, 2632.19636, 1475, 0, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 60000, 5.78704, 200000, 253, 1, 333, 0, 0, 0, 50, 1, 0, 1), 
(13128, 13128, "Golem Trader", 0, "", 0, "LineageNPC.e_teleporter_FDwarf", 8, 21.3, 70, "female", "L2MerchantSummon", 40, 2632.19636, 1475, 0, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 60000, 5.78704, 200000, 253, 1, 333, 0, 0, 0, 50, 1, 0, 1), 
(13129, 13129, "Teleporter", 0, "", 0, "LineageNPC.a_teleporter_FHuman", 8, 25, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 0, 0.9, 40, 43, 30, 21, 20, 25, 0, 0, 8.47458, 60000, 5.78704, 200000, 253, 1, 333, 0, 0, 0, 50, 180, 0, 1), 
(13130, 13130, "Light Purple Maned Horse", 0, "", 0, "LineageMonster4.gray_horse", 31, 32.5, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 0, 0.9, 40, 43, 30, 21, 20, 25, 0, 0, 8.47458, 60000, 5.78704, 200000, 253, 1, 333, 0, 0, 0, 41, 180, 0, 1), 
(13131, 13131, "Grizzly Bear", 0, "", 0, "LineageMonster.grizzly", 21, 40, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 0, 0.9, 40, 43, 30, 21, 20, 25, 0, 0, 8.47458, 60000, 5.78704, 200000, 253, 1, 333, 0, 0, 0, 40, 180, 0, 1), 
(13132, 13132, "Timitran", 0, "", 0, "LineageMonster.ti_mi_tran", 23, 90, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 0, 0.9, 40, 43, 30, 21, 20, 25, 0, 0, 8.47458, 60000, 5.78704, 200000, 253, 1, 333, 0, 0, 0, 12, 180, 0, 1), 
(13133, 13133, "Lava Golem", 0, "", 0, "LineageMonster2.lava_golem", 38, 45, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 0, 0.9, 40, 43, 30, 21, 20, 25, 0, 0, 8.47458, 60000, 5.78704, 200000, 253, 1, 333, 0, 0, 0, 13, 180, 0, 1), 
(13134, 13134, "Yeti", 0, "", 0, "LineageMonster.yeti_20_bi", 18, 32, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 0, 0.9, 40, 43, 30, 21, 20, 25, 0, 0, 8.47458, 60000, 5.78704, 200000, 253, 1, 333, 0, 0, 0, 16, 180, 0, 1), 
(13135, 13135, "Pumpkin Ghost", 0, "", 0, "LineageNpc2.Pumpkin_Head_man", 12, 18, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 0, 0.9, 40, 43, 30, 21, 20, 25, 0, 0, 8.47458, 60000, 5.78704, 200000, 253, 1, 333, 0, 0, 0, 60, 180, 0, 1), 
(13136, 13136, "", 0, "", 0, "LineageNpcEV.battle_banner", 0.01, 36, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 0, 180, 0, 1), -- TODO: Stats require check
(13137, 13137, "", 0, "", 0, "LineageNpcEV.battle_banner", 0.01, 36, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 0, 180, 0, 1), -- TODO: Stats require check
(13138, 13138, "", 0, "", 0, "LineageNpcEV.battle_banner", 0.01, 36, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 0, 180, 0, 1), -- TODO: Stats require check
(13139, 13139, "", 0, "", 0, "LineageNpcEV.battle_banner", 0.01, 36, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 0, 180, 0, 1), -- TODO: Stats require check
(13140, 13140, "", 0, "", 0, "LineageNpcEV.battle_banner", 0.01, 36, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 0, 180, 0, 1), -- TODO: Stats require check
(13141, 13141, "", 0, "", 0, "LineageNpcEV.battle_banner", 0.01, 36, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 0, 180, 0, 1), -- TODO: Stats require check
(13142, 13142, "Final Form", 0, "", 0, "LineageMonster4.Specular_Form_air", 9, 38, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(13143, 13143, "Final Form", 0, "", 0, "LineageMonster4.Specular_Form_F_air", 10, 32.7, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(13144, 13144, "Aurabird-Falcon", 0, "", 0, "LineageMonster4.closed_attacker", 38, 14.25, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 100, 180, 0, 1), -- TODO: Stats require check
(13145, 13145, "Aurabird-Owl", 0, "", 0, "LineageMonster4.heavy_shooter", 40, 19, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 100, 180, 0, 1), -- TODO: Stats require check
(13146, 13146, "Tawny-Maned Lion", 0, "", 0, "LineageMonster4.tawny_maned_lion", 25, 22.5, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 43, 180, 0, 1), -- TODO: Stats require check
(13147, 13147, "Steam Sledge", 0, "", 0, "LineageMonster4.steam_sledge", 40, 27.5, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 40, 180, 0, 1), -- TODO: Stats require check
(13148, 13148, "Lindvior", 0, "", 0, "LineageMonster4.lindvior_air", 190, 390.6, 55, "female", "L2FlyMonster", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 100, 180, 0, 1), -- TODO: Stats require check
(13149, 13149, "For Presentation 1", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 85, "male", "L2Npc", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 10, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(13150, 13150, "For Presentation 2", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 85, "male", "L2Npc", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 10, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(13151, 13151, "For Presentation 3", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 85, "male", "L2Npc", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 10, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(13152, 13152, "For Presentation 4", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 85, "male", "L2Npc", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 10, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(13153, 13153, "For Presentation 5", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 85, "male", "L2Npc", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 10, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(13154, 13154, "Demon Race", 0, "", 0, "LineageMonster4.summoner_demon_tr", 11, 27, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(13155, 13155, "Unicorniun", 0, "", 0, "LineageMonster4.summoner_unicorn_tr", 8, 30, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(13156, 13156, "Myo Race", 0, "", 0, "LineageMonster4.summoner_cat_tr", 10, 23, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 80, 180, 0, 1), -- TODO: Stats require check
(13157, 13157, "Frog", 0, "", 0, "LineageMonster.poison_toad", 20, 10, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 50, 180, 0, 1), -- TODO: Stats require check
(13158, 13158, "Young Child", 0, "", 0, "LineageNPC2.a_child_people_Mhuman", 5, 12.3, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 26, 180, 0, 1), -- TODO: Stats require check
(13159, 13159, "Mercenary", 0, "", 0, "LineageNPC.a_fighterguild_master_Mhuman", 8, 23.5, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 50, 180, 0, 1), -- TODO: Stats require check
(13160, 13160, "Snowman", 0, "", 0, "LineageNpc2.snow_man", 28, 30, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 20, 180, 0, 1), -- TODO: Stats require check
(13161, 13161, "Scarecrow", 0, "", 0, "LineageNpc2.scarecrow", 13, 30, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 23, 180, 0, 1), -- TODO: Stats require check
(13162, 13162, "Tin Plate Golem", 0, "", 0, "LineageNpc2.tin_golem", 13, 18.5, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 13, 180, 0, 1), -- TODO: Stats require check
(13163, 13163, "Tow", 0, "", 0, "LineageNPC2.tow", 4.4, 8.25, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 155, 180, 0, 1), -- TODO: Stats require check
(13164, 13164, "Lure Tow", 0, "", 0, "LineageNPC2.tow_lure", 4.4, 8.25, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 155, 180, 0, 1), -- TODO: Stats require check
(13165, 13165, "Heavy Tow", 0, "", 0, "LineageNPC2.tow_heavy", 4.4, 8.25, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 165, 180, 0, 1), -- TODO: Stats require check
(13166, 13166, "Wing Tow", 0, "", 0, "LineageNPC2.tow_whim", 4.4, 8.25, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 140, 180, 0, 1), -- TODO: Stats require check
(13167, 13167, "Main Role A", 0, "", 0, "LineageNPC2.tp_actor", 9, 28.3, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 4, 180, 0, 1), -- TODO: Stats require check
(13168, 13168, "Main Role B", 0, "", 0, "LineageNPC2.tp_actor", 9, 28.3, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 4, 180, 0, 1), -- TODO: Stats require check
(13169, 13169, "Human Male Mercenary", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 50, 180, 0, 1), -- TODO: Stats require check
(13170, 13170, "Male Elf Mercenary", 0, "", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 50, 180, 0, 1), -- TODO: Stats require check
(13171, 13171, "Dark Elf Female Mercenary", 0, "", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 50, 180, 0, 1), -- TODO: Stats require check
(13172, 13172, "Orc Male Mercenary", 0, "", 0, "LineageNPC.e_guard_MOrc", 8, 27, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 50, 180, 0, 1), -- TODO: Stats require check
(13173, 13173, "Dwarf Male Mercenary", 0, "", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 50, 180, 0, 1), -- TODO: Stats require check
(13174, 13174, "Kamael Male Mercenary", 0, "", 0, "LineageNPC2.K_M1_guard", 13, 25, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 39, 180, 0, 1), -- TODO: Stats require check
(13175, 13175, "Knight Level Mercenary", 0, "", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 50, 180, 0, 1), -- TODO: Stats require check
(13176, 13176, "Archer Level Mercenary", 0, "", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 55, "male", "L2Npc", 1100, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 8, 333, 15302, 0, 0, 30, 180, 0, 1), 
(13177, 13177, "Wizard Level Mercenary", 0, "", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 28, 180, 0, 1), -- TODO: Stats require check
(13178, 13178, "Trooper Level Mercenary", 0, "", 0, "LineageNPC2.K_F1_guard_Master", 13, 22.5, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), -- TODO: Stats require check
(13179, 13179, "Knight Leader Elite Mercenary", 0, "", 0, "LineageMonster3.Kight_of_Dawn", 12, 24.5, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 36.48, 180, 0, 1), -- TODO: Stats require check
(13180, 13180, "Commander Elite Mercenary", 0, "", 0, "LineageNPC2.chief_of_insurgents", 10, 26.99, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 29.8, 180, 0, 1), -- TODO: Stats require check
(13181, 13181, "Treasure Box", 0, "Gracia", 0, "LineageMonster.mimic_even", 8.5, 8.5, 80, "male", "L2Chest", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(13182, 13182, "Free Gift Merchant", 0, "Gracia", 0, "LineageMonster.silver_cat", 7, 15, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 48, 120, 0, 1), 
(13183, 13183, "Thomas D. Turkey", 0, "", 0, "LineageNpc2.crazy_turkey", 25, 34, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(13184, 13184, "Santa Claus", 0, "", 0, "LineageNPC2.santa_claus", 10, 21, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(13185, 13185, "Santa Claus", 0, "", 0, "LineageNPC2.santa_claus_120p", 12, 25, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(13186, 13186, "Santa Claus", 0, "", 0, "LineageNPC2.santa_sled", 0.01, 50, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 55, 0, 1), 
(13187, 13187, "Milk Cow", 0, "", 0, "LineageMonster4.milk_cow", 16, 12.5, 85, "male", "L2Npc", 40, 601.265823, 1846.8, 0, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 60000, 5.78704, 200000, 253, 1, 333, 0, 0, 0, 25, 120, 0, 1), 
(13188, 13188, "Head Milk Cow", 0, "", 0, "LineageMonster4.milk_cow_200p", 26, 28.5, 85, "male", "L2Npc", 40, 7563.291139, 1846.8, 0, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 60000, 5.78704, 200000, 253, 1, 333, 0, 0, 0, 45, 180, 0, 1), 
(13189, 13189, "Bull", 0, "", 0, "LineageMonster4.yellow_cow", 16, 12.5, 85, "male", "L2Npc", 40, 601.265823, 1846.8, 0, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 60000, 5.78704, 200000, 253, 1, 333, 0, 0, 0, 25, 120, 0, 1), 
(13190, 13190, "Head Bull", 0, "", 0, "LineageMonster4.yellow_cow_200p", 26, 28.5, 85, "male", "L2Npc", 40, 7563.291139, 1846.8, 0, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 60000, 5.78704, 200000, 253, 1, 333, 0, 0, 0, 45, 180, 0, 1), 
(13191, 13191, "Gloomy Milk Cow", 0, "", 0, "LineageMonster4.milk_cow_e", 16, 12.5, 85, "male", "L2Npc", 40, 601.265823, 1846.8, 0, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 60000, 5.78704, 200000, 253, 1, 333, 0, 0, 0, 25, 120, 0, 1), 
(13192, 13192, "Gloomy Head Milk Cow", 0, "", 0, "LineageMonster4.milk_cow_200p_e", 26, 28.5, 85, "male", "L2Npc", 40, 7563.291139, 1846.8, 0, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 60000, 5.78704, 200000, 253, 1, 333, 0, 0, 0, 45, 180, 0, 1), 
(13193, 13193, "", 0, "", 0, "LineageNpcEV.obelisk_of_middle_square", 229, 177.5, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 0, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 1, 180, 0, 1), -- TODO: Stats require check
(13194, 13194, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 85, "male", "L2Npc", 40, 4234.063127, 1846.8, 0, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 60000, 5.78704, 200000, 253, 1, 333, 0, 0, 0, 1, 120, 0, 1), 
(13195, 13195, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 85, "male", "L2Npc", 40, 4234.063127, 1846.8, 0, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 60000, 5.78704, 200000, 253, 1, 333, 0, 0, 0, 1, 120, 0, 1), 
(13196, 13196, "Great Pig", 0, "Mis-summoned", 0, "LineageNPC2.E_pig_ball", 15, 18.3, 85, "male", "L2Monster", 40, 7563.291139, 1846.8, 0, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 60000, 5.78704, 200000, 253, 1, 333, 0, 0, 0, 60, 120, 0, 1), 
(13197, 13197, "Guardian's Strider", 0, "", 0, "LineageNPC.training_doll_150p", 13, 40, 55, "etc", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 50, 180, 0, 1), -- TODO: Stats require check
(13198, 13198, "Native", 0, "", 0, "LineageNPC.a_common_peopleC_Mhuman", 10, 24, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 50, 180, 0, 1), -- TODO: Stats require check
(13199, 13199, "Native", 0, "", 0, "LineageNPC.a_common_peopleB_FHuman", 8, 20.5, 79, "female", "L2Npc", 40, 3127.824593, 1641, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 929.93081, 337.07008, 635.0222, 246.65326, 253, 4, 333, 0, 0, 0, 50, 180, 0, 1), 
(13200, 13200, "Young Child", 0, "", 0, "LineageNPC2.a_child_people_Fhuman", 5, 12.3, 79, "female", "L2Npc", 40, 3127.824593, 1641, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 929.93081, 337.07008, 635.0222, 246.65326, 253, 4, 333, 0, 0, 0, 24, 180, 0, 1), 
(13201, 13201, "Guards of the Dawn", 0, "", 0, "LineageNPC.a_fighterguild_master_FHuman", 8, 21.5, 79, "female", "L2Npc", 40, 3127.824593, 1641, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 929.93081, 337.07008, 635.0222, 246.65326, 253, 4, 333, 0, 0, 0, 50, 180, 0, 1), 
(13202, 13202, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 76, "etc", "L2Npc", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13203, 13203, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 77, "etc", "L2Npc", 40, 2856.768726, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 856.44056, 328.27073, 584.83789, 240.21427, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13204, 13204, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 78, "etc", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13205, 13205, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 79, "etc", "L2Npc", 40, 3127.824593, 1641, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 929.93081, 337.07008, 635.0222, 246.65326, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13206, 13206, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13207, 13207, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 81, "etc", "L2Npc", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13208, 13208, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 82, "etc", "L2Npc", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13209, 13209, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 83, "etc", "L2Npc", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13210, 13210, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 84, "etc", "L2Npc", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13211, 13211, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 85, "etc", "L2Npc", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13212, 13212, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 86, "etc", "L2Npc", 40, 4439.743585, 1881.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1233.98508, 365.6202, 842.65185, 267.545, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13213, 13213, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 76, "etc", "L2Npc", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13214, 13214, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 77, "etc", "L2Npc", 40, 2856.768726, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 856.44056, 328.27073, 584.83789, 240.21427, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13215, 13215, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 78, "etc", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13216, 13216, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 79, "etc", "L2Npc", 40, 3127.824593, 1641, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 929.93081, 337.07008, 635.0222, 246.65326, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13217, 13217, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13218, 13218, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 81, "etc", "L2Npc", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13219, 13219, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 82, "etc", "L2Npc", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13220, 13220, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 83, "etc", "L2Npc", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13221, 13221, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 84, "etc", "L2Npc", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13222, 13222, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 85, "etc", "L2Npc", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13223, 13223, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 86, "etc", "L2Npc", 40, 4439.743585, 1881.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1233.98508, 365.6202, 842.65185, 267.545, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13224, 13224, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 76, "etc", "L2Npc", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13225, 13225, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 77, "etc", "L2Npc", 40, 2856.768726, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 856.44056, 328.27073, 584.83789, 240.21427, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13226, 13226, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 78, "etc", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13227, 13227, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 79, "etc", "L2Npc", 40, 3127.824593, 1641, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 929.93081, 337.07008, 635.0222, 246.65326, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13228, 13228, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13229, 13229, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 81, "etc", "L2Npc", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13230, 13230, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 82, "etc", "L2Npc", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13231, 13231, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 83, "etc", "L2Npc", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13232, 13232, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 84, "etc", "L2Npc", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13233, 13233, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 85, "etc", "L2Npc", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13234, 13234, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 86, "etc", "L2Npc", 40, 4439.743585, 1881.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1233.98508, 365.6202, 842.65185, 267.545, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13235, 13235, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 76, "etc", "L2Npc", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13236, 13236, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 77, "etc", "L2Npc", 40, 2856.768726, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 856.44056, 328.27073, 584.83789, 240.21427, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13237, 13237, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 78, "etc", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13238, 13238, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 79, "etc", "L2Npc", 40, 3127.824593, 1641, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 929.93081, 337.07008, 635.0222, 246.65326, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13239, 13239, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13240, 13240, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 81, "etc", "L2Npc", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13241, 13241, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 82, "etc", "L2Npc", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13242, 13242, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 83, "etc", "L2Npc", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13243, 13243, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 84, "etc", "L2Npc", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13244, 13244, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 85, "etc", "L2Npc", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13245, 13245, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 86, "etc", "L2Npc", 40, 4439.743585, 1881.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1233.98508, 365.6202, 842.65185, 267.545, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13246, 13246, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 76, "etc", "L2Npc", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13247, 13247, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 77, "etc", "L2Npc", 40, 2856.768726, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 856.44056, 328.27073, 584.83789, 240.21427, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13248, 13248, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 78, "etc", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13249, 13249, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 79, "etc", "L2Npc", 40, 3127.824593, 1641, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 929.93081, 337.07008, 635.0222, 246.65326, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13250, 13250, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13251, 13251, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 81, "etc", "L2Npc", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13252, 13252, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 82, "etc", "L2Npc", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13253, 13253, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 83, "etc", "L2Npc", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13254, 13254, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 84, "etc", "L2Npc", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13255, 13255, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 85, "etc", "L2Npc", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13256, 13256, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 86, "etc", "L2Npc", 40, 4439.743585, 1881.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1233.98508, 365.6202, 842.65185, 267.545, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13257, 13257, "Virtual Image", 0, "", 0, "LineageNPC2.Decoy_Medium", 8.5, 25, 76, "etc", "L2Decoy", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13258, 13258, "Virtual Image", 0, "", 0, "LineageNPC2.Decoy_Medium", 8.5, 25, 77, "etc", "L2Decoy", 40, 2856.768726, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 856.44056, 328.27073, 584.83789, 240.21427, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13259, 13259, "Virtual Image", 0, "", 0, "LineageNPC2.Decoy_Medium", 8.5, 25, 78, "etc", "L2Decoy", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13260, 13260, "Virtual Image", 0, "", 0, "LineageNPC2.Decoy_Medium", 8.5, 25, 79, "etc", "L2Decoy", 40, 3127.824593, 1641, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 929.93081, 337.07008, 635.0222, 246.65326, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13261, 13261, "Virtual Image", 0, "", 0, "LineageNPC2.Decoy_Medium", 8.5, 25, 80, "etc", "L2Decoy", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13262, 13262, "Virtual Image", 0, "", 0, "LineageNPC2.Decoy_Medium", 8.5, 25, 81, "etc", "L2Decoy", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13263, 13263, "Virtual Image", 0, "", 0, "LineageNPC2.Decoy_Medium", 8.5, 25, 82, "etc", "L2Decoy", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13264, 13264, "Virtual Image", 0, "", 0, "LineageNPC2.Decoy_Medium", 8.5, 25, 83, "etc", "L2Decoy", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13265, 13265, "Virtual Image", 0, "", 0, "LineageNPC2.Decoy_Medium", 8.5, 25, 84, "etc", "L2Decoy", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13266, 13266, "Virtual Image", 0, "", 0, "LineageNPC2.Decoy_Medium", 8.5, 25, 85, "etc", "L2Decoy", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13267, 13267, "Virtual Image", 0, "", 0, "LineageNPC2.Decoy_Medium", 8.5, 25, 86, "etc", "L2Decoy", 40, 4439.743585, 1881.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1233.98508, 365.6202, 842.65185, 267.545, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(13268, 13268, "Aqua Elf", 0, "", 0, "LineageNPC2.bikini_elf", 12, 27.5, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 50, 180, 0, 1), -- TODO: Stats require check
(13269, 13269, "Hot Weather", 0, "", 0, "LineageMonster5.event_the_heat", 9, 14.5, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 10, 60000, 662.75133, 200000, 253, 4, 333, 0, 0, 0, 30, 160, 0, 1), 
(13270, 13270, "Sultriness", 0, "", 0, "LineageMonster5.event_terrible_heat", 30, 53.5, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 10, 60000, 662.75133, 200000, 253, 4, 333, 0, 0, 0, 30, 160, 0, 1), 
(13271, 13271, "Young Watermelon", 0, "", 0, "LineageNPC2.event_unripe_watermelon", 11, 22, 1, "etc", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 10, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 1, 333, 0, 0, 0, 50, 100, 0, 1), 
(13272, 13272, "Defective Watermelon", 0, "", 0, "LineageNPC2.event_bad_watermelon", 14, 30, 1, "etc", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 10, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 1, 333, 0, 0, 0, 50, 100, 0, 1), 
(13273, 13273, "Rain Watermelon", 0, "", 0, "LineageNPC2.event_good_watermelon", 17, 35, 1, "etc", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 10, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 1, 333, 0, 0, 0, 50, 100, 0, 1), 
(13274, 13274, "Large Rain Watermelon", 0, "", 0, "LineageNPC2.event_king_watermelon", 30, 65, 1, "etc", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 10, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 1, 333, 0, 0, 0, 50, 100, 0, 1), 
(13275, 13275, "Young Honey Watermelon", 0, "", 0, "LineageNPC2.event_big_watermelon", 10, 20, 1, "etc", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 10, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 1, 333, 0, 0, 0, 50, 100, 0, 1), 
(13276, 13276, "Defective Honey Watermelon", 0, "", 0, "LineageNPC2.event_bad_big_watermelon", 20, 40, 1, "etc", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 10, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 1, 333, 0, 0, 0, 50, 100, 0, 1), 
(13277, 13277, "Rain Honey Watermelon", 0, "", 0, "LineageNPC2.event_good_big_watermelon", 26, 52, 1, "etc", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 10, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 1, 333, 0, 0, 0, 50, 100, 0, 1), 
(13278, 13278, "Large Rain Honey Watermelon", 0, "", 0, "LineageNPC2.event_king_big_watermelon", 30, 60, 1, "etc", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 10, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 1, 333, 0, 0, 0, 50, 100, 0, 1), 
(13279, 13279, "Uldie", 0, "", 0, "LineageMonster4.wooldie", 8, 17, 1, "male", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 10, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 4, 333, 0, 0, 0, 18, 160, 0, 1), 
(13280, 13280, "Belldandy", 0, "", 0, "LineageMonster4.berdandi", 9, 20.5, 1, "male", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 4, 333, 0, 0, 0, 22, 174, 0, 1), 
(13281, 13281, "Skooldie", 0, "Event manager", 0, "LineageMonster4.scooldie", 8, 12.8, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 15, 160, 0, 1), 
(13282, 13282, "Skooldie", 0, "", 0, "LineageMonster4.scooldie", 8, 12.8, 1, "male", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 4, 333, 0, 0, 0, 15, 160, 0, 1), 
(13283, 13283, "Treykan", 0, "", 0, "LineageMonster5.traikan", 25, 27, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 88, 180, 0, 1), -- TODO: Stats require check
(13284, 13284, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(13285, 13285, "Santa Claus", 0, "Event manager", 0, "LineageNPC2.santa_claus_120p", 12, 25, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(13286, 13286, "Baby White Tiger", 0, "", 0, "LineageMonster2.baby_tiger_e", 8, 15.7, 85, "male", "L2Npc", 40, 601.265823, 1846.8, 0, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 60000, 5.78704, 200000, 253, 1, 333, 0, 0, 0, 28, 120, 0, 1), 
(13287, 13287, "Baby White Tiger Captain", 0, "", 0, "LineageMonster2.baby_tiger_200p_e", 22, 29.5, 85, "male", "L2Npc", 40, 7563.291139, 1846.8, 0, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 60000, 5.78704, 200000, 253, 1, 333, 0, 0, 0, 28, 180, 0, 1), 
(13288, 13288, "Gloomy Baby White Tiger", 0, "", 0, "LineageMonster2.baby_tiger_de", 8, 15.7, 85, "male", "L2Npc", 40, 601.265823, 1846.8, 0, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 60000, 5.78704, 200000, 253, 1, 333, 0, 0, 0, 28, 120, 0, 1), 
(13289, 13289, "Gloomy Baby White Tiger Captain", 0, "", 0, "LineageMonster2.baby_tiger_200p_de", 22, 29.5, 85, "male", "L2Npc", 40, 7563.291139, 1846.8, 0, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 60000, 5.78704, 200000, 253, 1, 333, 0, 0, 0, 28, 180, 0, 1), 
(13290, 13290, "White Tiger", 0, "", 0, "LineageMonster2.youth_tiger_e", 16, 17.2, 85, "male", "L2Npc", 40, 601.265823, 1846.8, 0, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 60000, 5.78704, 200000, 253, 1, 333, 0, 0, 0, 60, 120, 0, 1), 
(13291, 13291, "White Tiger Captain", 0, "", 0, "LineageMonster2.youth_tiger_200p_e", 50, 34, 85, "male", "L2Npc", 40, 7563.291139, 1846.8, 0, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 60000, 5.78704, 200000, 253, 1, 333, 0, 0, 0, 60, 180, 0, 1), 
(13292, 13292, "Employee of Magic Research Institute", 0, "Event manager", 0, "LineageNPC.e_smith_Fdwarf", 8, 17.5, 75, "female", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 313, 0, 0, 50, 120, 0, 1), 
(13293, 13293, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 85, "male", "L2Npc", 40, 4234.063127, 1846.8, 0, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 1, 333, 0, 0, 0, 1, 120, 0, 1), 
(13294, 13294, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 85, "male", "L2Npc", 40, 4234.063127, 1846.8, 0, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 1, 333, 0, 0, 0, 1, 120, 0, 1), 
(13295, 13295, "Shining White", 0, "Event manager", 0, "LineageNPC.e_smith_Fdwarf", 8, 17.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 160, 0, 1), 
(13296, 13296, "Freya", 0, "Event manager", 0, "LineageMonster5.freya_small", 18, 36, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 54, 160, 0, 1), 
(13297, 13297, "World Cup Cat", 0, "", 0, "LineageNPC2.br_worldcup_cat", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(13298, 13298, "Game Manager", 0, "Customer Joining", 0, "LineageNpc2.gm_transformer", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(14001, 14001, "Reanimated Man", 0, "", 0, "LineageMonster.skeleton", 11, 25, 46, "male", "L2Pet", 40, 1229.78678, 637.8, 5.5, 2.1, 40, 43, 30, 21, 20, 25, 0, 0, 248.0526, 182.18816, 169.38777, 133.31739, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(14002, 14002, "Reanimated Man", 0, "", 0, "LineageMonster.skeleton", 11, 25, 54, "male", "L2Pet", 40, 1621.75618, 861, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 370.68904, 218.89589, 253.13256, 160.17851, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(14003, 14003, "Reanimated Man", 0, "", 0, "LineageMonster.skeleton", 11, 25, 62, "male", "L2Pet", 40, 2037.81082, 1097, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 521.12391, 257.34267, 355.86007, 188.3122, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(14004, 14004, "Reanimated Man", 0, "", 0, "LineageMonster.skeleton", 11, 25, 66, "male", "L2Pet", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 603.79903, 276.72752, 412.31647, 202.49719, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(14005, 14005, "Reanimated Man", 0, "", 0, "LineageMonster.skeleton", 11, 25, 70, "male", "L2Pet", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(14006, 14006, "Reanimated Man", 0, "", 0, "LineageMonster.skeleton", 11, 25, 74, "male", "L2Pet", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 773.81598, 314.65987, 528.41601, 230.25444, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(14007, 14007, "Reanimated Man", 0, "", 0, "LineageMonster.skeleton", 11, 25, 76, "male", "L2Pet", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(14008, 14008, "Reanimated Man", 0, "", 0, "LineageMonster.skeleton", 11, 25, 78, "male", "L2Pet", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(14009, 14009, "Reanimated Man", 0, "", 0, "LineageMonster.skeleton", 11, 25, 78, "male", "L2Pet", 40, 2812.763385, 1615.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 860.7348, 333.79298, 587.7703, 244.25522, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(14010, 14010, "Reanimated Man", 0, "", 0, "LineageMonster.skeleton", 11, 25, 78, "male", "L2Pet", 40, 2822.62688, 1624.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 865.65573, 334.88535, 591.13065, 245.05457, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(14011, 14011, "Reanimated Man", 0, "", 0, "LineageMonster.skeleton", 11, 25, 78, "male", "L2Pet", 40, 2832.490375, 1632.6, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 870.57666, 335.97771, 594.49101, 245.85391, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(14012, 14012, "Reanimated Man", 0, "", 0, "LineageMonster.skeleton", 11, 25, 79, "male", "L2Pet", 40, 2842.35387, 1641, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 875.49759, 337.07008, 597.85136, 246.65326, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(14013, 14013, "Reanimated Man", 0, "", 0, "LineageMonster.skeleton", 11, 25, 79, "male", "L2Pet", 40, 2852.217365, 1649.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 880.41852, 338.16245, 601.21172, 247.45261, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(14014, 14014, "Reanimated Man", 0, "", 0, "LineageMonster.skeleton", 11, 25, 79, "male", "L2Pet", 40, 2862.08086, 1657.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 885.33945, 339.25482, 604.57207, 248.25196, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(14015, 14015, "Reanimated Man", 0, "", 0, "LineageMonster.skeleton", 11, 25, 79, "male", "L2Pet", 40, 2871.944355, 1666.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 890.26038, 340.34718, 607.93243, 249.0513, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(14016, 14016, "Reanimated Man", 0, "", 0, "LineageMonster.skeleton", 11, 25, 80, "male", "L2Pet", 40, 2880.37628, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 894.75854, 341.375, 611.00409, 249.80341, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(14017, 14017, "Reanimated Man", 0, "", 0, "LineageMonster.skeleton", 11, 25, 80, "male", "L2Pet", 40, 2889.881882, 1683.25, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 899.57378, 342.45123, 614.29227, 250.59095, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(14018, 14018, "Reanimated Man", 0, "", 0, "LineageMonster.skeleton", 11, 25, 80, "male", "L2Pet", 40, 2899.387485, 1691.7, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 904.38902, 343.52746, 617.58046, 251.37849, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(14019, 14019, "Reanimated Man", 0, "", 0, "LineageMonster.skeleton", 11, 25, 80, "male", "L2Pet", 40, 2908.893088, 1700.15, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 909.20425, 344.60369, 620.86864, 252.16602, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(14020, 14020, "Reanimated Man", 0, "", 0, "LineageMonster.skeleton", 11, 25, 81, "male", "L2Pet", 40, 2916.89894, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 913.54847, 345.61127, 623.83518, 252.90333, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(14021, 14021, "Reanimated Man", 0, "", 0, "LineageMonster.skeleton", 11, 25, 81, "male", "L2Pet", 40, 2926.029605, 1717.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 918.24595, 346.67034, 627.04295, 253.67831, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(14022, 14022, "Reanimated Man", 0, "", 0, "LineageMonster.skeleton", 11, 25, 81, "male", "L2Pet", 40, 2935.16027, 1725.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 922.94344, 347.72941, 630.25073, 254.45329, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(14023, 14023, "Reanimated Man", 0, "", 0, "LineageMonster.skeleton", 11, 25, 81, "male", "L2Pet", 40, 2944.290935, 1734.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 927.64092, 348.78847, 633.4585, 255.22827, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(14024, 14024, "Reanimated Man", 0, "", 0, "LineageMonster.skeleton", 11, 25, 82, "male", "L2Pet", 40, 2951.85588, 1743, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 931.81944, 349.77477, 636.31188, 255.95, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(14025, 14025, "Reanimated Man", 0, "", 0, "LineageMonster.skeleton", 11, 25, 82, "male", "L2Pet", 40, 2960.595115, 1751.55, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 936.38718, 350.81565, 639.43106, 256.71167, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(14026, 14026, "Reanimated Man", 0, "", 0, "LineageMonster.skeleton", 11, 25, 82, "male", "L2Pet", 40, 2969.33435, 1760.1, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 940.95493, 351.85652, 642.55023, 257.47334, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(14027, 14027, "Reanimated Man", 0, "", 0, "LineageMonster.skeleton", 11, 25, 82, "male", "L2Pet", 40, 2978.073585, 1768.65, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 945.52267, 352.8974, 645.66941, 258.235, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(14028, 14028, "Reanimated Man", 0, "", 0, "LineageMonster.skeleton", 11, 25, 83, "male", "L2Pet", 40, 2985.1835, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 949.52401, 353.86144, 648.40181, 258.94045, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(14029, 14029, "Reanimated Man", 0, "", 0, "LineageMonster.skeleton", 11, 25, 83, "male", "L2Pet", 40, 2993.515405, 1786, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 953.95015, 354.88311, 651.42429, 259.68806, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(14030, 14030, "Reanimated Man", 0, "", 0, "LineageMonster.skeleton", 11, 25, 83, "male", "L2Pet", 40, 3001.84731, 1794.6, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 958.3763, 355.90478, 654.44678, 260.43568, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(14031, 14031, "Reanimated Man", 0, "", 0, "LineageMonster.skeleton", 11, 25, 83, "male", "L2Pet", 40, 3010.179215, 1803.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 962.80244, 356.92644, 657.46926, 261.18329, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(14032, 14032, "Reanimated Man", 0, "", 0, "LineageMonster.skeleton", 11, 25, 84, "male", "L2Pet", 40, 3016.82079, 1812, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 966.61544, 357.86723, 660.07304, 261.87171, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(14033, 14033, "Reanimated Man", 0, "", 0, "LineageMonster.skeleton", 11, 25, 84, "male", "L2Pet", 40, 3024.730112, 1820.65, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 970.8883, 358.86868, 662.99085, 262.60453, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(14034, 14034, "Reanimated Man", 0, "", 0, "LineageMonster.skeleton", 11, 25, 84, "male", "L2Pet", 40, 3032.639435, 1829.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 975.16116, 359.87013, 665.90866, 263.33734, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(14035, 14035, "Reanimated Man", 0, "", 0, "LineageMonster.skeleton", 11, 25, 85, "male", "L2Pet", 40, 3046.70947, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 983.0479, 361.78814, 671.29428, 264.74086, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(14036, 14036, "Reanimated Man", 0, "", 0, "LineageMonster.skeleton", 11, 25, 85, "male", "L2Pet", 40, 3056.672363, 1858.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 988.52539, 363.09511, 675.03469, 265.69724, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(14037, 14037, "Reanimated Man", 0, "", 0, "LineageMonster.skeleton", 11, 25, 85, "male", "L2Pet", 40, 3066.635257, 1870, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 994.00287, 364.40208, 678.77511, 266.65363, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(14038, 14038, "Corrupted Man", 0, "", 0, "LineageMonster.zombie", 13, 21, 42, "male", "L2Pet", 40, 1050.81652, 531, 5.5, 2.1, 40, 43, 30, 21, 20, 25, 0, 0, 198.34591, 164.88513, 135.44454, 120.65578, 253, 4, 333, 0, 0, 0, 15, 140, 0, 1), 
(14039, 14039, "Corrupted Man", 0, "", 0, "LineageMonster.zombie", 13, 21, 50, "male", "L2Pet", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 25, 0, 0, 305.54906, 200.23844, 208.6504, 146.5258, 253, 4, 333, 0, 0, 0, 15, 140, 0, 1), 
(14040, 14040, "Corrupted Man", 0, "", 0, "LineageMonster.zombie", 13, 21, 58, "male", "L2Pet", 40, 1828.68266, 977.4, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 442.8992, 237.99429, 302.44274, 174.1539, 253, 4, 333, 0, 0, 0, 15, 140, 0, 1), 
(14041, 14041, "Corrupted Man", 0, "", 0, "LineageMonster.zombie", 13, 21, 64, "male", "L2Pet", 40, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 562.02275, 267.04468, 383.78868, 195.41171, 253, 4, 333, 0, 0, 0, 15, 140, 0, 1), 
(14042, 14042, "Corrupted Man", 0, "", 0, "LineageMonster.zombie", 13, 21, 68, "male", "L2Pet", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 646.17968, 286.3615, 441.25696, 209.54692, 253, 4, 333, 0, 0, 0, 15, 140, 0, 1), 
(14043, 14043, "Corrupted Man", 0, "", 0, "LineageMonster.zombie", 13, 21, 72, "male", "L2Pet", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 0, 0, 0, 15, 140, 0, 1), 
(14044, 14044, "Corrupted Man", 0, "", 0, "LineageMonster.zombie", 13, 21, 78, "male", "L2Pet", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 15, 140, 0, 1), 
(14045, 14045, "Corrupted Man", 0, "", 0, "LineageMonster.zombie", 13, 21, 78, "male", "L2Pet", 40, 2812.763385, 1615.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 860.7348, 333.79298, 587.7703, 244.25522, 253, 4, 333, 0, 0, 0, 15, 140, 0, 1), 
(14046, 14046, "Corrupted Man", 0, "", 0, "LineageMonster.zombie", 13, 21, 78, "male", "L2Pet", 40, 2822.62688, 1624.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 865.65573, 334.88535, 591.13065, 245.05457, 253, 4, 333, 0, 0, 0, 15, 140, 0, 1), 
(14047, 14047, "Corrupted Man", 0, "", 0, "LineageMonster.zombie", 13, 21, 78, "male", "L2Pet", 40, 2832.490375, 1632.6, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 870.57666, 335.97771, 594.49101, 245.85391, 253, 4, 333, 0, 0, 0, 15, 140, 0, 1), 
(14048, 14048, "Corrupted Man", 0, "", 0, "LineageMonster.zombie", 13, 21, 79, "male", "L2Pet", 40, 2842.35387, 1641, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 875.49759, 337.07008, 597.85136, 246.65326, 253, 4, 333, 0, 0, 0, 15, 140, 0, 1), 
(14049, 14049, "Corrupted Man", 0, "", 0, "LineageMonster.zombie", 13, 21, 79, "male", "L2Pet", 40, 2852.217365, 1649.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 880.41852, 338.16245, 601.21172, 247.45261, 253, 4, 333, 0, 0, 0, 15, 140, 0, 1), 
(14050, 14050, "Corrupted Man", 0, "", 0, "LineageMonster.zombie", 13, 21, 79, "male", "L2Pet", 40, 2862.08086, 1657.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 885.33945, 339.25482, 604.57207, 248.25196, 253, 4, 333, 0, 0, 0, 15, 140, 0, 1), 
(14051, 14051, "Corrupted Man", 0, "", 0, "LineageMonster.zombie", 13, 21, 79, "male", "L2Pet", 40, 2871.944355, 1666.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 890.26038, 340.34718, 607.93243, 249.0513, 253, 4, 333, 0, 0, 0, 15, 140, 0, 1), 
(14052, 14052, "Corrupted Man", 0, "", 0, "LineageMonster.zombie", 13, 21, 80, "male", "L2Pet", 40, 2880.37628, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 894.75854, 341.375, 611.00409, 249.80341, 253, 4, 333, 0, 0, 0, 15, 140, 0, 1), 
(14053, 14053, "Corrupted Man", 0, "", 0, "LineageMonster.zombie", 13, 21, 80, "male", "L2Pet", 40, 2889.881882, 1683.25, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 899.57378, 342.45123, 614.29227, 250.59095, 253, 4, 333, 0, 0, 0, 15, 140, 0, 1), 
(14054, 14054, "Corrupted Man", 0, "", 0, "LineageMonster.zombie", 13, 21, 80, "male", "L2Pet", 40, 2899.387485, 1691.7, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 904.38902, 343.52746, 617.58046, 251.37849, 253, 4, 333, 0, 0, 0, 15, 140, 0, 1), 
(14055, 14055, "Corrupted Man", 0, "", 0, "LineageMonster.zombie", 13, 21, 80, "male", "L2Pet", 40, 2908.893088, 1700.15, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 909.20425, 344.60369, 620.86864, 252.16602, 253, 4, 333, 0, 0, 0, 15, 140, 0, 1), 
(14056, 14056, "Corrupted Man", 0, "", 0, "LineageMonster.zombie", 13, 21, 81, "male", "L2Pet", 40, 2916.89894, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 913.54847, 345.61127, 623.83518, 252.90333, 253, 4, 333, 0, 0, 0, 15, 140, 0, 1), 
(14057, 14057, "Corrupted Man", 0, "", 0, "LineageMonster.zombie", 13, 21, 81, "male", "L2Pet", 40, 2926.029605, 1717.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 918.24595, 346.67034, 627.04295, 253.67831, 253, 4, 333, 0, 0, 0, 15, 140, 0, 1), 
(14058, 14058, "Corrupted Man", 0, "", 0, "LineageMonster.zombie", 13, 21, 81, "male", "L2Pet", 40, 2935.16027, 1725.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 922.94344, 347.72941, 630.25073, 254.45329, 253, 4, 333, 0, 0, 0, 15, 140, 0, 1), 
(14059, 14059, "Corrupted Man", 0, "", 0, "LineageMonster.zombie", 13, 21, 81, "male", "L2Pet", 40, 2944.290935, 1734.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 927.64092, 348.78847, 633.4585, 255.22827, 253, 4, 333, 0, 0, 0, 15, 140, 0, 1), 
(14060, 14060, "Corrupted Man", 0, "", 0, "LineageMonster.zombie", 13, 21, 82, "male", "L2Pet", 40, 2951.85588, 1743, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 931.81944, 349.77477, 636.31188, 255.95, 253, 4, 333, 0, 0, 0, 15, 140, 0, 1), 
(14061, 14061, "Corrupted Man", 0, "", 0, "LineageMonster.zombie", 13, 21, 82, "male", "L2Pet", 40, 2960.595115, 1751.55, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 936.38718, 350.81565, 639.43106, 256.71167, 253, 4, 333, 0, 0, 0, 15, 140, 0, 1), 
(14062, 14062, "Corrupted Man", 0, "", 0, "LineageMonster.zombie", 13, 21, 82, "male", "L2Pet", 40, 2969.33435, 1760.1, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 940.95493, 351.85652, 642.55023, 257.47334, 253, 4, 333, 0, 0, 0, 15, 140, 0, 1), 
(14063, 14063, "Corrupted Man", 0, "", 0, "LineageMonster.zombie", 13, 21, 82, "male", "L2Pet", 40, 2978.073585, 1768.65, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 945.52267, 352.8974, 645.66941, 258.235, 253, 4, 333, 0, 0, 0, 15, 140, 0, 1), 
(14064, 14064, "Corrupted Man", 0, "", 0, "LineageMonster.zombie", 13, 21, 83, "male", "L2Pet", 40, 2985.1835, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 949.52401, 353.86144, 648.40181, 258.94045, 253, 4, 333, 0, 0, 0, 15, 140, 0, 1), 
(14065, 14065, "Corrupted Man", 0, "", 0, "LineageMonster.zombie", 13, 21, 83, "male", "L2Pet", 40, 2993.515405, 1786, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 953.95015, 354.88311, 651.42429, 259.68806, 253, 4, 333, 0, 0, 0, 15, 140, 0, 1), 
(14066, 14066, "Corrupted Man", 0, "", 0, "LineageMonster.zombie", 13, 21, 83, "male", "L2Pet", 40, 3001.84731, 1794.6, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 958.3763, 355.90478, 654.44678, 260.43568, 253, 4, 333, 0, 0, 0, 15, 140, 0, 1), 
(14067, 14067, "Corrupted Man", 0, "", 0, "LineageMonster.zombie", 13, 21, 83, "male", "L2Pet", 40, 3010.179215, 1803.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 962.80244, 356.92644, 657.46926, 261.18329, 253, 4, 333, 0, 0, 0, 15, 140, 0, 1), 
(14068, 14068, "Corrupted Man", 0, "", 0, "LineageMonster.zombie", 13, 21, 84, "male", "L2Pet", 40, 3016.82079, 1812, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 966.61544, 357.86723, 660.07304, 261.87171, 253, 4, 333, 0, 0, 0, 15, 140, 0, 1), 
(14069, 14069, "Corrupted Man", 0, "", 0, "LineageMonster.zombie", 13, 21, 84, "male", "L2Pet", 40, 3024.730112, 1820.65, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 970.8883, 358.86868, 662.99085, 262.60453, 253, 4, 333, 0, 0, 0, 15, 140, 0, 1), 
(14070, 14070, "Corrupted Man", 0, "", 0, "LineageMonster.zombie", 13, 21, 84, "male", "L2Pet", 40, 3032.639435, 1829.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 975.16116, 359.87013, 665.90866, 263.33734, 253, 4, 333, 0, 0, 0, 15, 140, 0, 1), 
(14071, 14071, "Corrupted Man", 0, "", 0, "LineageMonster.zombie", 13, 21, 85, "male", "L2Pet", 40, 3046.70947, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 983.0479, 361.78814, 671.29428, 264.74086, 253, 4, 333, 0, 0, 0, 15, 140, 0, 1), 
(14072, 14072, "Corrupted Man", 0, "", 0, "LineageMonster.zombie", 13, 21, 85, "male", "L2Pet", 40, 3056.672363, 1858.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 988.52539, 363.09511, 675.03469, 265.69724, 253, 4, 333, 0, 0, 0, 15, 140, 0, 1), 
(14073, 14073, "Corrupted Man", 0, "", 0, "LineageMonster.zombie", 13, 21, 85, "male", "L2Pet", 40, 3066.635257, 1870, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 994.00287, 364.40208, 678.77511, 266.65363, 253, 4, 333, 0, 0, 0, 15, 140, 0, 1), 
(14074, 14074, "Cursed Man", 0, "", 0, "LineageMonster.doll_master", 20, 42, 58, "male", "L2Pet", 40, 1828.68266, 977.4, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 442.8992, 237.99429, 302.44274, 174.1539, 253, 8, 333, 0, 0, 0, 80, 160, 0, 1), 
(14075, 14075, "Cursed Man", 0, "", 0, "LineageMonster.doll_master", 20, 42, 62, "male", "L2Pet", 40, 2037.81082, 1097, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 521.12391, 257.34267, 355.86007, 188.3122, 253, 8, 333, 0, 0, 0, 80, 160, 0, 1), 
(14076, 14076, "Cursed Man", 0, "", 0, "LineageMonster.doll_master", 20, 42, 66, "male", "L2Pet", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 603.79903, 276.72752, 412.31647, 202.49719, 253, 8, 333, 0, 0, 0, 80, 160, 0, 1), 
(14077, 14077, "Cursed Man", 0, "", 0, "LineageMonster.doll_master", 20, 42, 70, "male", "L2Pet", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 8, 333, 0, 0, 0, 80, 160, 0, 1), 
(14078, 14078, "Cursed Man", 0, "", 0, "LineageMonster.doll_master", 20, 42, 72, "male", "L2Pet", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 8, 333, 0, 0, 0, 80, 160, 0, 1), 
(14079, 14079, "Cursed Man", 0, "", 0, "LineageMonster.doll_master", 20, 42, 74, "male", "L2Pet", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 773.81598, 314.65987, 528.41601, 230.25444, 253, 8, 333, 0, 0, 0, 80, 160, 0, 1), 
(14080, 14080, "Cursed Man", 0, "", 0, "LineageMonster.doll_master", 20, 42, 76, "male", "L2Pet", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 8, 333, 0, 0, 0, 80, 160, 0, 1), 
(14081, 14081, "Cursed Man", 0, "", 0, "LineageMonster.doll_master", 20, 42, 78, "male", "L2Pet", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 8, 333, 0, 0, 0, 80, 160, 0, 1), 
(14082, 14082, "Cursed Man", 0, "", 0, "LineageMonster.doll_master", 20, 42, 78, "male", "L2Pet", 40, 2812.763385, 1615.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 860.7348, 333.79298, 587.7703, 244.25522, 253, 8, 333, 0, 0, 0, 80, 160, 0, 1), 
(14083, 14083, "Cursed Man", 0, "", 0, "LineageMonster.doll_master", 20, 42, 78, "male", "L2Pet", 40, 2822.62688, 1624.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 865.65573, 334.88535, 591.13065, 245.05457, 253, 8, 333, 0, 0, 0, 80, 160, 0, 1), 
(14084, 14084, "Cursed Man", 0, "", 0, "LineageMonster.doll_master", 20, 42, 78, "male", "L2Pet", 40, 2832.490375, 1632.6, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 870.57666, 335.97771, 594.49101, 245.85391, 253, 8, 333, 0, 0, 0, 80, 160, 0, 1), 
(14085, 14085, "Cursed Man", 0, "", 0, "LineageMonster.doll_master", 20, 42, 79, "male", "L2Pet", 40, 2842.35387, 1641, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 875.49759, 337.07008, 597.85136, 246.65326, 253, 8, 333, 0, 0, 0, 80, 160, 0, 1), 
(14086, 14086, "Cursed Man", 0, "", 0, "LineageMonster.doll_master", 20, 42, 79, "male", "L2Pet", 40, 2852.217365, 1649.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 880.41852, 338.16245, 601.21172, 247.45261, 253, 8, 333, 0, 0, 0, 80, 160, 0, 1), 
(14087, 14087, "Cursed Man", 0, "", 0, "LineageMonster.doll_master", 20, 42, 79, "male", "L2Pet", 40, 2862.08086, 1657.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 885.33945, 339.25482, 604.57207, 248.25196, 253, 8, 333, 0, 0, 0, 80, 160, 0, 1), 
(14088, 14088, "Cursed Man", 0, "", 0, "LineageMonster.doll_master", 20, 42, 79, "male", "L2Pet", 40, 2871.944355, 1666.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 890.26038, 340.34718, 607.93243, 249.0513, 253, 8, 333, 0, 0, 0, 80, 160, 0, 1), 
(14089, 14089, "Cursed Man", 0, "", 0, "LineageMonster.doll_master", 20, 42, 80, "male", "L2Pet", 40, 2880.37628, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 894.75854, 341.375, 611.00409, 249.80341, 253, 8, 333, 0, 0, 0, 80, 160, 0, 1), 
(14090, 14090, "Cursed Man", 0, "", 0, "LineageMonster.doll_master", 20, 42, 80, "male", "L2Pet", 40, 2889.881882, 1683.25, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 899.57378, 342.45123, 614.29227, 250.59095, 253, 8, 333, 0, 0, 0, 80, 160, 0, 1), 
(14091, 14091, "Cursed Man", 0, "", 0, "LineageMonster.doll_master", 20, 42, 80, "male", "L2Pet", 40, 2899.387485, 1691.7, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 904.38902, 343.52746, 617.58046, 251.37849, 253, 8, 333, 0, 0, 0, 80, 160, 0, 1), 
(14092, 14092, "Cursed Man", 0, "", 0, "LineageMonster.doll_master", 20, 42, 80, "male", "L2Pet", 40, 2908.893088, 1700.15, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 909.20425, 344.60369, 620.86864, 252.16602, 253, 8, 333, 0, 0, 0, 80, 160, 0, 1), 
(14093, 14093, "Cursed Man", 0, "", 0, "LineageMonster.doll_master", 20, 42, 81, "male", "L2Pet", 40, 2916.89894, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 913.54847, 345.61127, 623.83518, 252.90333, 253, 8, 333, 0, 0, 0, 80, 160, 0, 1), 
(14094, 14094, "Cursed Man", 0, "", 0, "LineageMonster.doll_master", 20, 42, 81, "male", "L2Pet", 40, 2926.029605, 1717.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 918.24595, 346.67034, 627.04295, 253.67831, 253, 8, 333, 0, 0, 0, 80, 160, 0, 1), 
(14095, 14095, "Cursed Man", 0, "", 0, "LineageMonster.doll_master", 20, 42, 81, "male", "L2Pet", 40, 2935.16027, 1725.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 922.94344, 347.72941, 630.25073, 254.45329, 253, 8, 333, 0, 0, 0, 80, 160, 0, 1), 
(14096, 14096, "Cursed Man", 0, "", 0, "LineageMonster.doll_master", 20, 42, 81, "male", "L2Pet", 40, 2944.290935, 1734.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 927.64092, 348.78847, 633.4585, 255.22827, 253, 8, 333, 0, 0, 0, 80, 160, 0, 1), 
(14097, 14097, "Cursed Man", 0, "", 0, "LineageMonster.doll_master", 20, 42, 82, "male", "L2Pet", 40, 2951.85588, 1743, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 931.81944, 349.77477, 636.31188, 255.95, 253, 8, 333, 0, 0, 0, 80, 160, 0, 1), 
(14098, 14098, "Cursed Man", 0, "", 0, "LineageMonster.doll_master", 20, 42, 82, "male", "L2Pet", 40, 2960.595115, 1751.55, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 936.38718, 350.81565, 639.43106, 256.71167, 253, 8, 333, 0, 0, 0, 80, 160, 0, 1), 
(14099, 14099, "Cursed Man", 0, "", 0, "LineageMonster.doll_master", 20, 42, 82, "male", "L2Pet", 40, 2969.33435, 1760.1, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 940.95493, 351.85652, 642.55023, 257.47334, 253, 8, 333, 0, 0, 0, 80, 160, 0, 1), 
(14100, 14100, "Cursed Man", 0, "", 0, "LineageMonster.doll_master", 20, 42, 82, "male", "L2Pet", 40, 2978.073585, 1768.65, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 945.52267, 352.8974, 645.66941, 258.235, 253, 8, 333, 0, 0, 0, 80, 160, 0, 1), 
(14101, 14101, "Cursed Man", 0, "", 0, "LineageMonster.doll_master", 20, 42, 83, "male", "L2Pet", 40, 2985.1835, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 949.52401, 353.86144, 648.40181, 258.94045, 253, 8, 333, 0, 0, 0, 80, 160, 0, 1), 
(14102, 14102, "Cursed Man", 0, "", 0, "LineageMonster.doll_master", 20, 42, 83, "male", "L2Pet", 40, 2993.515405, 1786, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 953.95015, 354.88311, 651.42429, 259.68806, 253, 8, 333, 0, 0, 0, 80, 160, 0, 1), 
(14103, 14103, "Cursed Man", 0, "", 0, "LineageMonster.doll_master", 20, 42, 83, "male", "L2Pet", 40, 3001.84731, 1794.6, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 958.3763, 355.90478, 654.44678, 260.43568, 253, 8, 333, 0, 0, 0, 80, 160, 0, 1), 
(14104, 14104, "Cursed Man", 0, "", 0, "LineageMonster.doll_master", 20, 42, 83, "male", "L2Pet", 40, 3010.179215, 1803.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 962.80244, 356.92644, 657.46926, 261.18329, 253, 8, 333, 0, 0, 0, 80, 160, 0, 1), 
(14105, 14105, "Cursed Man", 0, "", 0, "LineageMonster.doll_master", 20, 42, 84, "male", "L2Pet", 40, 3016.82079, 1812, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 966.61544, 357.86723, 660.07304, 261.87171, 253, 8, 333, 0, 0, 0, 80, 160, 0, 1), 
(14106, 14106, "Cursed Man", 0, "", 0, "LineageMonster.doll_master", 20, 42, 84, "male", "L2Pet", 40, 3024.730112, 1820.65, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 970.8883, 358.86868, 662.99085, 262.60453, 253, 8, 333, 0, 0, 0, 80, 160, 0, 1), 
(14107, 14107, "Cursed Man", 0, "", 0, "LineageMonster.doll_master", 20, 42, 84, "male", "L2Pet", 40, 3032.639435, 1829.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 975.16116, 359.87013, 665.90866, 263.33734, 253, 8, 333, 0, 0, 0, 80, 160, 0, 1), 
(14108, 14108, "Cursed Man", 0, "", 0, "LineageMonster.doll_master", 20, 42, 85, "male", "L2Pet", 40, 3046.70947, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 983.0479, 361.78814, 671.29428, 264.74086, 253, 8, 333, 0, 0, 0, 80, 160, 0, 1), 
(14109, 14109, "Cursed Man", 0, "", 0, "LineageMonster.doll_master", 20, 42, 85, "male", "L2Pet", 40, 3056.672363, 1858.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 988.52539, 363.09511, 675.03469, 265.69724, 253, 8, 333, 0, 0, 0, 80, 160, 0, 1), 
(14110, 14110, "Cursed Man", 0, "", 0, "LineageMonster.doll_master", 20, 42, 85, "male", "L2Pet", 40, 3066.635257, 1870, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 994.00287, 364.40208, 678.77511, 266.65363, 253, 8, 333, 0, 0, 0, 80, 160, 0, 1), 
(14111, 14111, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 22, "male", "L2Pet", 40, 387.02878, 218.52, 3.5, 1.5, 40, 43, 30, 21, 20, 25, 0, 0, 51.75278, 92.65694, 35.34044, 67.80232, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14112, 14112, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 27, "male", "L2Pet", 40, 515.17856, 286.92, 3.5, 1.5, 40, 43, 30, 21, 20, 25, 0, 0, 74.99121, 108.28767, 51.20928, 79.24022, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14113, 14113, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 32, "male", "L2Pet", 40, 668.47132, 358.32, 4.5, 1.8, 40, 43, 30, 21, 20, 25, 0, 0, 106.16525, 125.57727, 72.49711, 91.89199, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14114, 14114, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 37, "male", "L2Pet", 40, 847.31754, 432.72, 4.5, 1.8, 40, 43, 30, 21, 20, 25, 0, 0, 146.82587, 144.47758, 100.26304, 105.72243, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14115, 14115, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 42, "male", "L2Pet", 40, 1050.81652, 531, 5.5, 2.1, 40, 43, 30, 21, 20, 25, 0, 0, 198.34591, 164.88513, 135.44454, 120.65578, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14116, 14116, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 46, "male", "L2Pet", 40, 1229.78678, 637.8, 5.5, 2.1, 40, 43, 30, 21, 20, 25, 0, 0, 248.0526, 182.18816, 169.38777, 133.31739, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14117, 14117, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 50, "male", "L2Pet", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 25, 0, 0, 305.54906, 200.23844, 208.6504, 146.5258, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14118, 14118, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 54, "male", "L2Pet", 40, 1621.75618, 861, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 370.68904, 218.89589, 253.13256, 160.17851, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14119, 14119, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 58, "male", "L2Pet", 40, 1828.68266, 977.4, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 442.8992, 237.99429, 302.44274, 174.1539, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14120, 14120, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 60, "male", "L2Pet", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 481.34551, 247.65008, 328.69659, 181.21958, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14121, 14121, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 62, "male", "L2Pet", 40, 2037.81082, 1097, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 521.12391, 257.34267, 355.86007, 188.3122, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14122, 14122, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 64, "male", "L2Pet", 40, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 562.02275, 267.04468, 383.78868, 195.41171, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14123, 14123, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 66, "male", "L2Pet", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 603.79903, 276.72752, 412.31647, 202.49719, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14124, 14124, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 68, "male", "L2Pet", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 646.17968, 286.3615, 441.25696, 209.54692, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14125, 14125, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 70, "male", "L2Pet", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14126, 14126, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 72, "male", "L2Pet", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14127, 14127, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 74, "male", "L2Pet", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 773.81598, 314.65987, 528.41601, 230.25444, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14128, 14128, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 76, "male", "L2Pet", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14129, 14129, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 78, "male", "L2Pet", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14130, 14130, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 78, "male", "L2Pet", 40, 2812.763385, 1615.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 860.7348, 333.79298, 587.7703, 244.25522, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14131, 14131, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 78, "male", "L2Pet", 40, 2822.62688, 1624.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 865.65573, 334.88535, 591.13065, 245.05457, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14132, 14132, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 78, "male", "L2Pet", 40, 2832.490375, 1632.6, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 870.57666, 335.97771, 594.49101, 245.85391, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14133, 14133, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 79, "male", "L2Pet", 40, 2842.35387, 1641, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 875.49759, 337.07008, 597.85136, 246.65326, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14134, 14134, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 79, "male", "L2Pet", 40, 2852.217365, 1649.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 880.41852, 338.16245, 601.21172, 247.45261, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14135, 14135, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 79, "male", "L2Pet", 40, 2862.08086, 1657.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 885.33945, 339.25482, 604.57207, 248.25196, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14136, 14136, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 79, "male", "L2Pet", 40, 2871.944355, 1666.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 890.26038, 340.34718, 607.93243, 249.0513, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14137, 14137, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 80, "male", "L2Pet", 40, 2880.37628, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 894.75854, 341.375, 611.00409, 249.80341, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14138, 14138, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 80, "male", "L2Pet", 40, 2889.881882, 1683.25, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 899.57378, 342.45123, 614.29227, 250.59095, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14139, 14139, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 80, "male", "L2Pet", 40, 2899.387485, 1691.7, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 904.38902, 343.52746, 617.58046, 251.37849, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14140, 14140, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 80, "male", "L2Pet", 40, 2908.893088, 1700.15, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 909.20425, 344.60369, 620.86864, 252.16602, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14141, 14141, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 81, "male", "L2Pet", 40, 2916.89894, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 913.54847, 345.61127, 623.83518, 252.90333, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14142, 14142, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 81, "male", "L2Pet", 40, 2926.029605, 1717.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 918.24595, 346.67034, 627.04295, 253.67831, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14143, 14143, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 81, "male", "L2Pet", 40, 2935.16027, 1725.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 922.94344, 347.72941, 630.25073, 254.45329, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14144, 14144, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 81, "male", "L2Pet", 40, 2944.290935, 1734.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 927.64092, 348.78847, 633.4585, 255.22827, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14145, 14145, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 82, "male", "L2Pet", 40, 2951.85588, 1743, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 931.81944, 349.77477, 636.31188, 255.95, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14146, 14146, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 82, "male", "L2Pet", 40, 2960.595115, 1751.55, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 936.38718, 350.81565, 639.43106, 256.71167, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14147, 14147, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 82, "male", "L2Pet", 40, 2969.33435, 1760.1, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 940.95493, 351.85652, 642.55023, 257.47334, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14148, 14148, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 82, "male", "L2Pet", 40, 2978.073585, 1768.65, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 945.52267, 352.8974, 645.66941, 258.235, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14149, 14149, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 83, "male", "L2Pet", 40, 2985.1835, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 949.52401, 353.86144, 648.40181, 258.94045, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14150, 14150, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 83, "male", "L2Pet", 40, 2993.515405, 1786, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 953.95015, 354.88311, 651.42429, 259.68806, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14151, 14151, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 83, "male", "L2Pet", 40, 3001.84731, 1794.6, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 958.3763, 355.90478, 654.44678, 260.43568, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14152, 14152, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 83, "male", "L2Pet", 40, 3010.179215, 1803.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 962.80244, 356.92644, 657.46926, 261.18329, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14153, 14153, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 84, "male", "L2Pet", 40, 3016.82079, 1812, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 966.61544, 357.86723, 660.07304, 261.87171, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14154, 14154, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 84, "male", "L2Pet", 40, 3024.730112, 1820.65, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 970.8883, 358.86868, 662.99085, 262.60453, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14155, 14155, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 84, "male", "L2Pet", 40, 3032.639435, 1829.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 975.16116, 359.87013, 665.90866, 263.33734, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14156, 14156, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 85, "male", "L2Pet", 40, 3046.70947, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 983.0479, 361.78814, 671.29428, 264.74086, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14157, 14157, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 85, "male", "L2Pet", 40, 3056.672363, 1858.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 988.52539, 363.09511, 675.03469, 265.69724, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14158, 14158, "Kat the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 85, "male", "L2Pet", 40, 3066.635257, 1870, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 994.00287, 364.40208, 678.77511, 266.65363, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(14159, 14159, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 22, "female", "L2Pet", 40, 387.02878, 218.52, 3.5, 1.5, 40, 43, 30, 21, 20, 25, 0, 0, 51.75278, 92.65694, 35.34044, 67.80232, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14160, 14160, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 27, "female", "L2Pet", 40, 515.17856, 286.92, 3.5, 1.5, 40, 43, 30, 21, 20, 25, 0, 0, 74.99121, 108.28767, 51.20928, 79.24022, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14161, 14161, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 32, "female", "L2Pet", 40, 668.47132, 358.32, 4.5, 1.8, 40, 43, 30, 21, 20, 25, 0, 0, 106.16525, 125.57727, 72.49711, 91.89199, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14162, 14162, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 37, "female", "L2Pet", 40, 847.31754, 432.72, 4.5, 1.8, 40, 43, 30, 21, 20, 25, 0, 0, 146.82587, 144.47758, 100.26304, 105.72243, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14163, 14163, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 42, "female", "L2Pet", 40, 1050.81652, 531, 5.5, 2.1, 40, 43, 30, 21, 20, 25, 0, 0, 198.34591, 164.88513, 135.44454, 120.65578, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14164, 14164, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 46, "female", "L2Pet", 40, 1229.78678, 637.8, 5.5, 2.1, 40, 43, 30, 21, 20, 25, 0, 0, 248.0526, 182.18816, 169.38777, 133.31739, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14165, 14165, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 50, "female", "L2Pet", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 25, 0, 0, 305.54906, 200.23844, 208.6504, 146.5258, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14166, 14166, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 54, "female", "L2Pet", 40, 1621.75618, 861, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 370.68904, 218.89589, 253.13256, 160.17851, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14167, 14167, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 58, "female", "L2Pet", 40, 1828.68266, 977.4, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 442.8992, 237.99429, 302.44274, 174.1539, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14168, 14168, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 60, "female", "L2Pet", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 481.34551, 247.65008, 328.69659, 181.21958, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14169, 14169, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 62, "female", "L2Pet", 40, 2037.81082, 1097, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 521.12391, 257.34267, 355.86007, 188.3122, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14170, 14170, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 64, "female", "L2Pet", 40, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 562.02275, 267.04468, 383.78868, 195.41171, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14171, 14171, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 66, "female", "L2Pet", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 603.79903, 276.72752, 412.31647, 202.49719, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14172, 14172, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 68, "female", "L2Pet", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 646.17968, 286.3615, 441.25696, 209.54692, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14173, 14173, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 70, "female", "L2Pet", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14174, 14174, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 72, "female", "L2Pet", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14175, 14175, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 74, "female", "L2Pet", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 773.81598, 314.65987, 528.41601, 230.25444, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14176, 14176, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 76, "female", "L2Pet", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14177, 14177, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 78, "female", "L2Pet", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14178, 14178, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 78, "female", "L2Pet", 40, 2812.763385, 1615.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 860.7348, 333.79298, 587.7703, 244.25522, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14179, 14179, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 78, "female", "L2Pet", 40, 2822.62688, 1624.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 865.65573, 334.88535, 591.13065, 245.05457, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14180, 14180, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 78, "female", "L2Pet", 40, 2832.490375, 1632.6, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 870.57666, 335.97771, 594.49101, 245.85391, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14181, 14181, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 79, "female", "L2Pet", 40, 2842.35387, 1641, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 875.49759, 337.07008, 597.85136, 246.65326, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14182, 14182, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 79, "female", "L2Pet", 40, 2852.217365, 1649.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 880.41852, 338.16245, 601.21172, 247.45261, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14183, 14183, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 79, "female", "L2Pet", 40, 2862.08086, 1657.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 885.33945, 339.25482, 604.57207, 248.25196, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14184, 14184, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 79, "female", "L2Pet", 40, 2871.944355, 1666.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 890.26038, 340.34718, 607.93243, 249.0513, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14185, 14185, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 80, "female", "L2Pet", 40, 2880.37628, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 894.75854, 341.375, 611.00409, 249.80341, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14186, 14186, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 80, "female", "L2Pet", 40, 2889.881882, 1683.25, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 899.57378, 342.45123, 614.29227, 250.59095, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14187, 14187, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 80, "female", "L2Pet", 40, 2899.387485, 1691.7, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 904.38902, 343.52746, 617.58046, 251.37849, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14188, 14188, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 80, "female", "L2Pet", 40, 2908.893088, 1700.15, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 909.20425, 344.60369, 620.86864, 252.16602, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14189, 14189, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 81, "female", "L2Pet", 40, 2916.89894, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 913.54847, 345.61127, 623.83518, 252.90333, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14190, 14190, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 81, "female", "L2Pet", 40, 2926.029605, 1717.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 918.24595, 346.67034, 627.04295, 253.67831, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14191, 14191, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 81, "female", "L2Pet", 40, 2935.16027, 1725.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 922.94344, 347.72941, 630.25073, 254.45329, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14192, 14192, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 81, "female", "L2Pet", 40, 2944.290935, 1734.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 927.64092, 348.78847, 633.4585, 255.22827, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14193, 14193, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 82, "female", "L2Pet", 40, 2951.85588, 1743, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 931.81944, 349.77477, 636.31188, 255.95, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14194, 14194, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 82, "female", "L2Pet", 40, 2960.595115, 1751.55, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 936.38718, 350.81565, 639.43106, 256.71167, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14195, 14195, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 82, "female", "L2Pet", 40, 2969.33435, 1760.1, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 940.95493, 351.85652, 642.55023, 257.47334, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14196, 14196, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 82, "female", "L2Pet", 40, 2978.073585, 1768.65, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 945.52267, 352.8974, 645.66941, 258.235, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14197, 14197, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 83, "female", "L2Pet", 40, 2985.1835, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 949.52401, 353.86144, 648.40181, 258.94045, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14198, 14198, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 83, "female", "L2Pet", 40, 2993.515405, 1786, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 953.95015, 354.88311, 651.42429, 259.68806, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14199, 14199, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 83, "female", "L2Pet", 40, 3001.84731, 1794.6, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 958.3763, 355.90478, 654.44678, 260.43568, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14200, 14200, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 83, "female", "L2Pet", 40, 3010.179215, 1803.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 962.80244, 356.92644, 657.46926, 261.18329, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14201, 14201, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 84, "female", "L2Pet", 40, 3016.82079, 1812, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 966.61544, 357.86723, 660.07304, 261.87171, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14202, 14202, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 84, "female", "L2Pet", 40, 3024.730112, 1820.65, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 970.8883, 358.86868, 662.99085, 262.60453, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14203, 14203, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 84, "female", "L2Pet", 40, 3032.639435, 1829.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 975.16116, 359.87013, 665.90866, 263.33734, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14204, 14204, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 85, "female", "L2Pet", 40, 3046.70947, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 983.0479, 361.78814, 671.29428, 264.74086, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14205, 14205, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 85, "female", "L2Pet", 40, 3056.672363, 1858.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 988.52539, 363.09511, 675.03469, 265.69724, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14206, 14206, "Mew the Cat", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 85, "female", "L2Pet", 40, 3066.635257, 1870, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 994.00287, 364.40208, 678.77511, 266.65363, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14207, 14207, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 42, "male", "L2Pet", 40, 1050.81652, 531, 5.5, 2.1, 40, 43, 30, 21, 20, 25, 0, 0, 198.34591, 164.88513, 135.44454, 120.65578, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14208, 14208, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 46, "male", "L2Pet", 40, 1229.78678, 637.8, 5.5, 2.1, 40, 43, 30, 21, 20, 25, 0, 0, 248.0526, 182.18816, 169.38777, 133.31739, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14209, 14209, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 50, "male", "L2Pet", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 25, 0, 0, 305.54906, 200.23844, 208.6504, 146.5258, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14210, 14210, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 54, "male", "L2Pet", 40, 1621.75618, 861, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 370.68904, 218.89589, 253.13256, 160.17851, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14211, 14211, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 58, "male", "L2Pet", 40, 1828.68266, 977.4, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 442.8992, 237.99429, 302.44274, 174.1539, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14212, 14212, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 60, "male", "L2Pet", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 481.34551, 247.65008, 328.69659, 181.21958, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14213, 14213, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 62, "male", "L2Pet", 40, 2037.81082, 1097, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 521.12391, 257.34267, 355.86007, 188.3122, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14214, 14214, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 64, "male", "L2Pet", 40, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 562.02275, 267.04468, 383.78868, 195.41171, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14215, 14215, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 66, "male", "L2Pet", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 603.79903, 276.72752, 412.31647, 202.49719, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14216, 14216, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 68, "male", "L2Pet", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 646.17968, 286.3615, 441.25696, 209.54692, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14217, 14217, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 70, "male", "L2Pet", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14218, 14218, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 72, "male", "L2Pet", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14219, 14219, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 74, "male", "L2Pet", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 773.81598, 314.65987, 528.41601, 230.25444, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14220, 14220, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 76, "male", "L2Pet", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14221, 14221, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 78, "male", "L2Pet", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14222, 14222, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 78, "male", "L2Pet", 40, 2812.763385, 1615.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 860.7348, 333.79298, 587.7703, 244.25522, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14223, 14223, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 78, "male", "L2Pet", 40, 2822.62688, 1624.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 865.65573, 334.88535, 591.13065, 245.05457, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14224, 14224, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 78, "male", "L2Pet", 40, 2832.490375, 1632.6, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 870.57666, 335.97771, 594.49101, 245.85391, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14225, 14225, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 79, "male", "L2Pet", 40, 2842.35387, 1641, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 875.49759, 337.07008, 597.85136, 246.65326, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14226, 14226, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 79, "male", "L2Pet", 40, 2852.217365, 1649.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 880.41852, 338.16245, 601.21172, 247.45261, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14227, 14227, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 79, "male", "L2Pet", 40, 2862.08086, 1657.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 885.33945, 339.25482, 604.57207, 248.25196, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14228, 14228, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 79, "male", "L2Pet", 40, 2871.944355, 1666.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 890.26038, 340.34718, 607.93243, 249.0513, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14229, 14229, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 80, "male", "L2Pet", 40, 2880.37628, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 894.75854, 341.375, 611.00409, 249.80341, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14230, 14230, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 80, "male", "L2Pet", 40, 2889.881882, 1683.25, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 899.57378, 342.45123, 614.29227, 250.59095, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14231, 14231, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 80, "male", "L2Pet", 40, 2899.387485, 1691.7, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 904.38902, 343.52746, 617.58046, 251.37849, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14232, 14232, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 80, "male", "L2Pet", 40, 2908.893088, 1700.15, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 909.20425, 344.60369, 620.86864, 252.16602, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14233, 14233, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 81, "male", "L2Pet", 40, 2916.89894, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 913.54847, 345.61127, 623.83518, 252.90333, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14234, 14234, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 81, "male", "L2Pet", 40, 2926.029605, 1717.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 918.24595, 346.67034, 627.04295, 253.67831, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14235, 14235, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 81, "male", "L2Pet", 40, 2935.16027, 1725.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 922.94344, 347.72941, 630.25073, 254.45329, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14236, 14236, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 81, "male", "L2Pet", 40, 2944.290935, 1734.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 927.64092, 348.78847, 633.4585, 255.22827, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14237, 14237, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 82, "male", "L2Pet", 40, 2951.85588, 1743, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 931.81944, 349.77477, 636.31188, 255.95, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14238, 14238, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 82, "male", "L2Pet", 40, 2960.595115, 1751.55, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 936.38718, 350.81565, 639.43106, 256.71167, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14239, 14239, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 82, "male", "L2Pet", 40, 2969.33435, 1760.1, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 940.95493, 351.85652, 642.55023, 257.47334, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14240, 14240, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 82, "male", "L2Pet", 40, 2978.073585, 1768.65, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 945.52267, 352.8974, 645.66941, 258.235, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14241, 14241, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 83, "male", "L2Pet", 40, 2985.1835, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 949.52401, 353.86144, 648.40181, 258.94045, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14242, 14242, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 83, "male", "L2Pet", 40, 2993.515405, 1786, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 953.95015, 354.88311, 651.42429, 259.68806, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14243, 14243, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 83, "male", "L2Pet", 40, 3001.84731, 1794.6, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 958.3763, 355.90478, 654.44678, 260.43568, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14244, 14244, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 83, "male", "L2Pet", 40, 3010.179215, 1803.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 962.80244, 356.92644, 657.46926, 261.18329, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14245, 14245, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 84, "male", "L2Pet", 40, 3016.82079, 1812, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 966.61544, 357.86723, 660.07304, 261.87171, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14246, 14246, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 84, "male", "L2Pet", 40, 3024.730112, 1820.65, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 970.8883, 358.86868, 662.99085, 262.60453, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14247, 14247, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 84, "male", "L2Pet", 40, 3032.639435, 1829.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 975.16116, 359.87013, 665.90866, 263.33734, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14248, 14248, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 85, "male", "L2Pet", 40, 3046.70947, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 983.0479, 361.78814, 671.29428, 264.74086, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14249, 14249, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 85, "male", "L2Pet", 40, 3056.672363, 1858.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 988.52539, 363.09511, 675.03469, 265.69724, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14250, 14250, "Kai the Cat", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 85, "male", "L2Pet", 40, 3066.635257, 1870, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 994.00287, 364.40208, 678.77511, 266.65363, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14251, 14251, "Feline Queen", 0, "", 0, "LineageMonster2.queen_of_cat", 8, 15, 58, "female", "L2Pet", 40, 1828.68266, 977.4, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 442.8992, 237.99429, 302.44274, 174.1539, 253, 4, 333, 0, 0, 0, 26, 170, 0, 1), 
(14252, 14252, "Feline Queen", 0, "", 0, "LineageMonster2.queen_of_cat", 8, 15, 60, "female", "L2Pet", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 481.34551, 247.65008, 328.69659, 181.21958, 253, 4, 333, 0, 0, 0, 26, 170, 0, 1), 
(14253, 14253, "Feline Queen", 0, "", 0, "LineageMonster2.queen_of_cat", 8, 15, 62, "female", "L2Pet", 40, 2037.81082, 1097, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 521.12391, 257.34267, 355.86007, 188.3122, 253, 4, 333, 0, 0, 0, 26, 170, 0, 1), 
(14254, 14254, "Feline Queen", 0, "", 0, "LineageMonster2.queen_of_cat", 8, 15, 64, "female", "L2Pet", 40, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 562.02275, 267.04468, 383.78868, 195.41171, 253, 4, 333, 0, 0, 0, 26, 170, 0, 1), 
(14255, 14255, "Feline Queen", 0, "", 0, "LineageMonster2.queen_of_cat", 8, 15, 66, "female", "L2Pet", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 603.79903, 276.72752, 412.31647, 202.49719, 253, 4, 333, 0, 0, 0, 26, 170, 0, 1), 
(14256, 14256, "Feline Queen", 0, "", 0, "LineageMonster2.queen_of_cat", 8, 15, 68, "female", "L2Pet", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 646.17968, 286.3615, 441.25696, 209.54692, 253, 4, 333, 0, 0, 0, 26, 170, 0, 1), 
(14257, 14257, "Feline Queen", 0, "", 0, "LineageMonster2.queen_of_cat", 8, 15, 70, "female", "L2Pet", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 26, 170, 0, 1), 
(14258, 14258, "Feline Queen", 0, "", 0, "LineageMonster2.queen_of_cat", 8, 15, 72, "female", "L2Pet", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 0, 0, 0, 26, 170, 0, 1), 
(14259, 14259, "Feline Queen", 0, "", 0, "LineageMonster2.queen_of_cat", 8, 15, 74, "female", "L2Pet", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 773.81598, 314.65987, 528.41601, 230.25444, 253, 4, 333, 0, 0, 0, 26, 170, 0, 1), 
(14260, 14260, "Feline Queen", 0, "", 0, "LineageMonster2.queen_of_cat", 8, 15, 76, "female", "L2Pet", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 0, 0, 0, 26, 170, 0, 1), 
(14265, 14265, "Feline Queen", 0, "", 0, "LineageMonster2.queen_of_cat", 8, 15, 78, "female", "L2Pet", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 26, 170, 0, 1), 
(14266, 14266, "Feline Queen", 0, "", 0, "LineageMonster2.queen_of_cat", 8, 15, 78, "female", "L2Pet", 40, 2812.763385, 1615.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 860.7348, 333.79298, 587.7703, 244.25522, 253, 4, 333, 0, 0, 0, 26, 170, 0, 1), 
(14267, 14267, "Feline Queen", 0, "", 0, "LineageMonster2.queen_of_cat", 8, 15, 78, "female", "L2Pet", 40, 2822.62688, 1624.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 865.65573, 334.88535, 591.13065, 245.05457, 253, 4, 333, 0, 0, 0, 26, 170, 0, 1), 
(14268, 14268, "Feline Queen", 0, "", 0, "LineageMonster2.queen_of_cat", 8, 15, 78, "female", "L2Pet", 40, 2832.490375, 1632.6, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 870.57666, 335.97771, 594.49101, 245.85391, 253, 4, 333, 0, 0, 0, 26, 170, 0, 1), 
(14269, 14269, "Feline Queen", 0, "", 0, "LineageMonster2.queen_of_cat", 8, 15, 79, "female", "L2Pet", 40, 2842.35387, 1641, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 875.49759, 337.07008, 597.85136, 246.65326, 253, 4, 333, 0, 0, 0, 26, 170, 0, 1), 
(14270, 14270, "Feline Queen", 0, "", 0, "LineageMonster2.queen_of_cat", 8, 15, 79, "female", "L2Pet", 40, 2852.217365, 1649.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 880.41852, 338.16245, 601.21172, 247.45261, 253, 4, 333, 0, 0, 0, 26, 170, 0, 1), 
(14271, 14271, "Feline Queen", 0, "", 0, "LineageMonster2.queen_of_cat", 8, 15, 79, "female", "L2Pet", 40, 2862.08086, 1657.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 885.33945, 339.25482, 604.57207, 248.25196, 253, 4, 333, 0, 0, 0, 26, 170, 0, 1), 
(14272, 14272, "Feline Queen", 0, "", 0, "LineageMonster2.queen_of_cat", 8, 15, 79, "female", "L2Pet", 40, 2871.944355, 1666.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 890.26038, 340.34718, 607.93243, 249.0513, 253, 4, 333, 0, 0, 0, 26, 170, 0, 1), 
(14273, 14273, "Feline Queen", 0, "", 0, "LineageMonster2.queen_of_cat", 8, 15, 80, "female", "L2Pet", 40, 2880.37628, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 894.75854, 341.375, 611.00409, 249.80341, 253, 4, 333, 0, 0, 0, 26, 170, 0, 1), 
(14274, 14274, "Feline Queen", 0, "", 0, "LineageMonster2.queen_of_cat", 8, 15, 80, "female", "L2Pet", 40, 2889.881882, 1683.25, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 899.57378, 342.45123, 614.29227, 250.59095, 253, 4, 333, 0, 0, 0, 26, 170, 0, 1), 
(14275, 14275, "Feline Queen", 0, "", 0, "LineageMonster2.queen_of_cat", 8, 15, 80, "female", "L2Pet", 40, 2899.387485, 1691.7, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 904.38902, 343.52746, 617.58046, 251.37849, 253, 4, 333, 0, 0, 0, 26, 170, 0, 1), 
(14276, 14276, "Feline Queen", 0, "", 0, "LineageMonster2.queen_of_cat", 8, 15, 80, "female", "L2Pet", 40, 2908.893088, 1700.15, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 909.20425, 344.60369, 620.86864, 252.16602, 253, 4, 333, 0, 0, 0, 26, 170, 0, 1), 
(14277, 14277, "Feline Queen", 0, "", 0, "LineageMonster2.queen_of_cat", 8, 15, 81, "female", "L2Pet", 40, 2916.89894, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 913.54847, 345.61127, 623.83518, 252.90333, 253, 4, 333, 0, 0, 0, 26, 170, 0, 1), 
(14278, 14278, "Feline Queen", 0, "", 0, "LineageMonster2.queen_of_cat", 8, 15, 81, "female", "L2Pet", 40, 2926.029605, 1717.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 918.24595, 346.67034, 627.04295, 253.67831, 253, 4, 333, 0, 0, 0, 26, 170, 0, 1), 
(14279, 14279, "Feline Queen", 0, "", 0, "LineageMonster2.queen_of_cat", 8, 15, 81, "female", "L2Pet", 40, 2935.16027, 1725.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 922.94344, 347.72941, 630.25073, 254.45329, 253, 4, 333, 0, 0, 0, 26, 170, 0, 1), 
(14280, 14280, "Feline Queen", 0, "", 0, "LineageMonster2.queen_of_cat", 8, 15, 81, "female", "L2Pet", 40, 2944.290935, 1734.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 927.64092, 348.78847, 633.4585, 255.22827, 253, 4, 333, 0, 0, 0, 26, 170, 0, 1), 
(14281, 14281, "Feline Queen", 0, "", 0, "LineageMonster2.queen_of_cat", 8, 15, 82, "female", "L2Pet", 40, 2951.85588, 1743, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 931.81944, 349.77477, 636.31188, 255.95, 253, 4, 333, 0, 0, 0, 26, 170, 0, 1), 
(14282, 14282, "Feline Queen", 0, "", 0, "LineageMonster2.queen_of_cat", 8, 15, 82, "female", "L2Pet", 40, 2960.595115, 1751.55, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 936.38718, 350.81565, 639.43106, 256.71167, 253, 4, 333, 0, 0, 0, 26, 170, 0, 1), 
(14283, 14283, "Feline Queen", 0, "", 0, "LineageMonster2.queen_of_cat", 8, 15, 82, "female", "L2Pet", 40, 2969.33435, 1760.1, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 940.95493, 351.85652, 642.55023, 257.47334, 253, 4, 333, 0, 0, 0, 26, 170, 0, 1), 
(14284, 14284, "Feline Queen", 0, "", 0, "LineageMonster2.queen_of_cat", 8, 15, 82, "female", "L2Pet", 40, 2978.073585, 1768.65, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 945.52267, 352.8974, 645.66941, 258.235, 253, 4, 333, 0, 0, 0, 26, 170, 0, 1), 
(14285, 14285, "Feline Queen", 0, "", 0, "LineageMonster2.queen_of_cat", 8, 15, 83, "female", "L2Pet", 40, 2985.1835, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 949.52401, 353.86144, 648.40181, 258.94045, 253, 4, 333, 0, 0, 0, 26, 170, 0, 1), 
(14286, 14286, "Feline Queen", 0, "", 0, "LineageMonster2.queen_of_cat", 8, 15, 83, "female", "L2Pet", 40, 2993.515405, 1786, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 953.95015, 354.88311, 651.42429, 259.68806, 253, 4, 333, 0, 0, 0, 26, 170, 0, 1), 
(14287, 14287, "Feline Queen", 0, "", 0, "LineageMonster2.queen_of_cat", 8, 15, 83, "female", "L2Pet", 40, 3001.84731, 1794.6, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 958.3763, 355.90478, 654.44678, 260.43568, 253, 4, 333, 0, 0, 0, 26, 170, 0, 1), 
(14288, 14288, "Feline Queen", 0, "", 0, "LineageMonster2.queen_of_cat", 8, 15, 83, "female", "L2Pet", 40, 3010.179215, 1803.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 962.80244, 356.92644, 657.46926, 261.18329, 253, 4, 333, 0, 0, 0, 26, 170, 0, 1), 
(14289, 14289, "Feline Queen", 0, "", 0, "LineageMonster2.queen_of_cat", 8, 15, 84, "female", "L2Pet", 40, 3016.82079, 1812, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 966.61544, 357.86723, 660.07304, 261.87171, 253, 4, 333, 0, 0, 0, 26, 170, 0, 1), 
(14290, 14290, "Feline Queen", 0, "", 0, "LineageMonster2.queen_of_cat", 8, 15, 84, "female", "L2Pet", 40, 3024.730112, 1820.65, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 970.8883, 358.86868, 662.99085, 262.60453, 253, 4, 333, 0, 0, 0, 26, 170, 0, 1), 
(14291, 14291, "Feline Queen", 0, "", 0, "LineageMonster2.queen_of_cat", 8, 15, 84, "female", "L2Pet", 40, 3032.639435, 1829.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 975.16116, 359.87013, 665.90866, 263.33734, 253, 4, 333, 0, 0, 0, 26, 170, 0, 1), 
(14292, 14292, "Feline Queen", 0, "", 0, "LineageMonster2.queen_of_cat", 8, 15, 85, "female", "L2Pet", 40, 3046.70947, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 983.0479, 361.78814, 671.29428, 264.74086, 253, 4, 333, 0, 0, 0, 26, 170, 0, 1), 
(14293, 14293, "Feline Queen", 0, "", 0, "LineageMonster2.queen_of_cat", 8, 15, 85, "female", "L2Pet", 40, 3056.672363, 1858.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 988.52539, 363.09511, 675.03469, 265.69724, 253, 4, 333, 0, 0, 0, 26, 170, 0, 1), 
(14294, 14294, "Feline Queen", 0, "", 0, "LineageMonster2.queen_of_cat", 8, 15, 85, "female", "L2Pet", 40, 3066.635257, 1870, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 994.00287, 364.40208, 678.77511, 266.65363, 253, 4, 333, 0, 0, 0, 26, 170, 0, 1), 
(14295, 14295, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 22, "male", "L2Pet", 40, 387.02878, 218.52, 3.5, 1.5, 40, 43, 30, 21, 20, 25, 0, 0, 51.75278, 92.65694, 35.34044, 67.80232, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14296, 14296, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 27, "male", "L2Pet", 40, 515.17856, 286.92, 3.5, 1.5, 40, 43, 30, 21, 20, 25, 0, 0, 74.99121, 108.28767, 51.20928, 79.24022, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14297, 14297, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 32, "male", "L2Pet", 40, 668.47132, 358.32, 4.5, 1.8, 40, 43, 30, 21, 20, 25, 0, 0, 106.16525, 125.57727, 72.49711, 91.89199, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14298, 14298, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 37, "male", "L2Pet", 40, 847.31754, 432.72, 4.5, 1.8, 40, 43, 30, 21, 20, 25, 0, 0, 146.82587, 144.47758, 100.26304, 105.72243, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14299, 14299, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 42, "male", "L2Pet", 40, 1050.81652, 531, 5.5, 2.1, 40, 43, 30, 21, 20, 25, 0, 0, 198.34591, 164.88513, 135.44454, 120.65578, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14300, 14300, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 46, "male", "L2Pet", 40, 1229.78678, 637.8, 5.5, 2.1, 40, 43, 30, 21, 20, 25, 0, 0, 248.0526, 182.18816, 169.38777, 133.31739, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14301, 14301, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 50, "male", "L2Pet", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 25, 0, 0, 305.54906, 200.23844, 208.6504, 146.5258, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14302, 14302, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 54, "male", "L2Pet", 40, 1621.75618, 861, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 370.68904, 218.89589, 253.13256, 160.17851, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14303, 14303, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 58, "male", "L2Pet", 40, 1828.68266, 977.4, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 442.8992, 237.99429, 302.44274, 174.1539, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14304, 14304, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 60, "male", "L2Pet", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 481.34551, 247.65008, 328.69659, 181.21958, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14305, 14305, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 62, "male", "L2Pet", 40, 2037.81082, 1097, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 521.12391, 257.34267, 355.86007, 188.3122, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14306, 14306, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 64, "male", "L2Pet", 40, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 562.02275, 267.04468, 383.78868, 195.41171, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14307, 14307, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 66, "male", "L2Pet", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 603.79903, 276.72752, 412.31647, 202.49719, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14308, 14308, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 68, "male", "L2Pet", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 646.17968, 286.3615, 441.25696, 209.54692, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14309, 14309, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 70, "male", "L2Pet", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14310, 14310, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 72, "male", "L2Pet", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14311, 14311, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 74, "male", "L2Pet", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 773.81598, 314.65987, 528.41601, 230.25444, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14312, 14312, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 76, "male", "L2Pet", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14313, 14313, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 78, "male", "L2Pet", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14314, 14314, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 78, "male", "L2Pet", 40, 2812.763385, 1615.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 860.7348, 333.79298, 587.7703, 244.25522, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14315, 14315, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 78, "male", "L2Pet", 40, 2822.62688, 1624.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 865.65573, 334.88535, 591.13065, 245.05457, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14316, 14316, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 78, "male", "L2Pet", 40, 2832.490375, 1632.6, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 870.57666, 335.97771, 594.49101, 245.85391, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14317, 14317, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 79, "male", "L2Pet", 40, 2842.35387, 1641, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 875.49759, 337.07008, 597.85136, 246.65326, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14318, 14318, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 79, "male", "L2Pet", 40, 2852.217365, 1649.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 880.41852, 338.16245, 601.21172, 247.45261, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14319, 14319, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 79, "male", "L2Pet", 40, 2862.08086, 1657.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 885.33945, 339.25482, 604.57207, 248.25196, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14320, 14320, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 79, "male", "L2Pet", 40, 2871.944355, 1666.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 890.26038, 340.34718, 607.93243, 249.0513, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14321, 14321, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 80, "male", "L2Pet", 40, 2880.37628, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 894.75854, 341.375, 611.00409, 249.80341, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14322, 14322, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 80, "male", "L2Pet", 40, 2889.881882, 1683.25, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 899.57378, 342.45123, 614.29227, 250.59095, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14323, 14323, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 80, "male", "L2Pet", 40, 2899.387485, 1691.7, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 904.38902, 343.52746, 617.58046, 251.37849, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14324, 14324, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 80, "male", "L2Pet", 40, 2908.893088, 1700.15, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 909.20425, 344.60369, 620.86864, 252.16602, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14325, 14325, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 81, "male", "L2Pet", 40, 2916.89894, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 913.54847, 345.61127, 623.83518, 252.90333, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14326, 14326, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 81, "male", "L2Pet", 40, 2926.029605, 1717.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 918.24595, 346.67034, 627.04295, 253.67831, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14327, 14327, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 81, "male", "L2Pet", 40, 2935.16027, 1725.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 922.94344, 347.72941, 630.25073, 254.45329, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14328, 14328, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 81, "male", "L2Pet", 40, 2944.290935, 1734.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 927.64092, 348.78847, 633.4585, 255.22827, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14329, 14329, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 82, "male", "L2Pet", 40, 2951.85588, 1743, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 931.81944, 349.77477, 636.31188, 255.95, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14330, 14330, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 82, "male", "L2Pet", 40, 2960.595115, 1751.55, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 936.38718, 350.81565, 639.43106, 256.71167, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14331, 14331, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 82, "male", "L2Pet", 40, 2969.33435, 1760.1, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 940.95493, 351.85652, 642.55023, 257.47334, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14332, 14332, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 82, "male", "L2Pet", 40, 2978.073585, 1768.65, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 945.52267, 352.8974, 645.66941, 258.235, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14333, 14333, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 83, "male", "L2Pet", 40, 2985.1835, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 949.52401, 353.86144, 648.40181, 258.94045, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14334, 14334, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 83, "male", "L2Pet", 40, 2993.515405, 1786, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 953.95015, 354.88311, 651.42429, 259.68806, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14335, 14335, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 83, "male", "L2Pet", 40, 3001.84731, 1794.6, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 958.3763, 355.90478, 654.44678, 260.43568, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14336, 14336, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 83, "male", "L2Pet", 40, 3010.179215, 1803.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 962.80244, 356.92644, 657.46926, 261.18329, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14337, 14337, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 84, "male", "L2Pet", 40, 3016.82079, 1812, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 966.61544, 357.86723, 660.07304, 261.87171, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14338, 14338, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 84, "male", "L2Pet", 40, 3024.730112, 1820.65, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 970.8883, 358.86868, 662.99085, 262.60453, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14339, 14339, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 84, "male", "L2Pet", 40, 3032.639435, 1829.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 975.16116, 359.87013, 665.90866, 263.33734, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14340, 14340, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 85, "male", "L2Pet", 40, 3046.70947, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 983.0479, 361.78814, 671.29428, 264.74086, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14341, 14341, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 85, "male", "L2Pet", 40, 3056.672363, 1858.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 988.52539, 363.09511, 675.03469, 265.69724, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14342, 14342, "Boxer the Unicorn", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 85, "male", "L2Pet", 40, 3066.635257, 1870, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 994.00287, 364.40208, 678.77511, 266.65363, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14343, 14343, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 22, "male", "L2Pet", 40, 387.02878, 218.52, 3.5, 1.5, 40, 43, 30, 21, 20, 25, 0, 0, 51.75278, 92.65694, 35.34044, 67.80232, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14344, 14344, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 27, "male", "L2Pet", 40, 515.17856, 286.92, 3.5, 1.5, 40, 43, 30, 21, 20, 25, 0, 0, 74.99121, 108.28767, 51.20928, 79.24022, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14345, 14345, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 32, "male", "L2Pet", 40, 668.47132, 358.32, 4.5, 1.8, 40, 43, 30, 21, 20, 25, 0, 0, 106.16525, 125.57727, 72.49711, 91.89199, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14346, 14346, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 37, "male", "L2Pet", 40, 847.31754, 432.72, 4.5, 1.8, 40, 43, 30, 21, 20, 25, 0, 0, 146.82587, 144.47758, 100.26304, 105.72243, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14347, 14347, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 42, "male", "L2Pet", 40, 1050.81652, 531, 5.5, 2.1, 40, 43, 30, 21, 20, 25, 0, 0, 198.34591, 164.88513, 135.44454, 120.65578, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14348, 14348, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 46, "male", "L2Pet", 40, 1229.78678, 637.8, 5.5, 2.1, 40, 43, 30, 21, 20, 25, 0, 0, 248.0526, 182.18816, 169.38777, 133.31739, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14349, 14349, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 50, "male", "L2Pet", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 25, 0, 0, 305.54906, 200.23844, 208.6504, 146.5258, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14350, 14350, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 54, "male", "L2Pet", 40, 1621.75618, 861, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 370.68904, 218.89589, 253.13256, 160.17851, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14351, 14351, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 58, "male", "L2Pet", 40, 1828.68266, 977.4, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 442.8992, 237.99429, 302.44274, 174.1539, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14352, 14352, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 60, "male", "L2Pet", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 481.34551, 247.65008, 328.69659, 181.21958, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14353, 14353, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 62, "male", "L2Pet", 40, 2037.81082, 1097, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 521.12391, 257.34267, 355.86007, 188.3122, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14354, 14354, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 64, "male", "L2Pet", 40, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 562.02275, 267.04468, 383.78868, 195.41171, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14355, 14355, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 66, "male", "L2Pet", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 603.79903, 276.72752, 412.31647, 202.49719, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14356, 14356, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 68, "male", "L2Pet", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 646.17968, 286.3615, 441.25696, 209.54692, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14357, 14357, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 70, "male", "L2Pet", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14358, 14358, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 72, "male", "L2Pet", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14359, 14359, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 74, "male", "L2Pet", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 773.81598, 314.65987, 528.41601, 230.25444, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14360, 14360, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 76, "male", "L2Pet", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14361, 14361, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 78, "male", "L2Pet", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14362, 14362, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 78, "male", "L2Pet", 40, 2812.763385, 1615.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 860.7348, 333.79298, 587.7703, 244.25522, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14363, 14363, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 78, "male", "L2Pet", 40, 2822.62688, 1624.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 865.65573, 334.88535, 591.13065, 245.05457, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14364, 14364, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 78, "male", "L2Pet", 40, 2832.490375, 1632.6, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 870.57666, 335.97771, 594.49101, 245.85391, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14365, 14365, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 79, "male", "L2Pet", 40, 2842.35387, 1641, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 875.49759, 337.07008, 597.85136, 246.65326, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14366, 14366, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 79, "male", "L2Pet", 40, 2852.217365, 1649.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 880.41852, 338.16245, 601.21172, 247.45261, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14367, 14367, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 79, "male", "L2Pet", 40, 2862.08086, 1657.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 885.33945, 339.25482, 604.57207, 248.25196, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14368, 14368, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 79, "male", "L2Pet", 40, 2871.944355, 1666.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 890.26038, 340.34718, 607.93243, 249.0513, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14369, 14369, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 80, "male", "L2Pet", 40, 2880.37628, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 894.75854, 341.375, 611.00409, 249.80341, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14370, 14370, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 80, "male", "L2Pet", 40, 2889.881882, 1683.25, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 899.57378, 342.45123, 614.29227, 250.59095, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14371, 14371, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 80, "male", "L2Pet", 40, 2899.387485, 1691.7, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 904.38902, 343.52746, 617.58046, 251.37849, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14372, 14372, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 80, "male", "L2Pet", 40, 2908.893088, 1700.15, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 909.20425, 344.60369, 620.86864, 252.16602, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14373, 14373, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 81, "male", "L2Pet", 40, 2916.89894, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 913.54847, 345.61127, 623.83518, 252.90333, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14374, 14374, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 81, "male", "L2Pet", 40, 2926.029605, 1717.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 918.24595, 346.67034, 627.04295, 253.67831, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14375, 14375, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 81, "male", "L2Pet", 40, 2935.16027, 1725.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 922.94344, 347.72941, 630.25073, 254.45329, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14376, 14376, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 81, "male", "L2Pet", 40, 2944.290935, 1734.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 927.64092, 348.78847, 633.4585, 255.22827, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14377, 14377, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 82, "male", "L2Pet", 40, 2951.85588, 1743, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 931.81944, 349.77477, 636.31188, 255.95, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14378, 14378, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 82, "male", "L2Pet", 40, 2960.595115, 1751.55, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 936.38718, 350.81565, 639.43106, 256.71167, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14379, 14379, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 82, "male", "L2Pet", 40, 2969.33435, 1760.1, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 940.95493, 351.85652, 642.55023, 257.47334, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14380, 14380, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 82, "male", "L2Pet", 40, 2978.073585, 1768.65, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 945.52267, 352.8974, 645.66941, 258.235, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14381, 14381, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 83, "male", "L2Pet", 40, 2985.1835, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 949.52401, 353.86144, 648.40181, 258.94045, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14382, 14382, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 83, "male", "L2Pet", 40, 2993.515405, 1786, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 953.95015, 354.88311, 651.42429, 259.68806, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14383, 14383, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 83, "male", "L2Pet", 40, 3001.84731, 1794.6, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 958.3763, 355.90478, 654.44678, 260.43568, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14384, 14384, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 83, "male", "L2Pet", 40, 3010.179215, 1803.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 962.80244, 356.92644, 657.46926, 261.18329, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14385, 14385, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 84, "male", "L2Pet", 40, 3016.82079, 1812, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 966.61544, 357.86723, 660.07304, 261.87171, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14386, 14386, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 84, "male", "L2Pet", 40, 3024.730112, 1820.65, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 970.8883, 358.86868, 662.99085, 262.60453, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14387, 14387, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 84, "male", "L2Pet", 40, 3032.639435, 1829.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 975.16116, 359.87013, 665.90866, 263.33734, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14388, 14388, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 85, "male", "L2Pet", 40, 3046.70947, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 983.0479, 361.78814, 671.29428, 264.74086, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14389, 14389, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 85, "male", "L2Pet", 40, 3056.672363, 1858.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 988.52539, 363.09511, 675.03469, 265.69724, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14390, 14390, "Mirage the Unicorn", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 85, "male", "L2Pet", 40, 3066.635257, 1870, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 994.00287, 364.40208, 678.77511, 266.65363, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(14391, 14391, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 42, "male", "L2Pet", 40, 1050.81652, 531, 5.5, 2.1, 40, 43, 30, 21, 20, 25, 0, 0, 198.34591, 164.88513, 135.44454, 120.65578, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14392, 14392, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 46, "male", "L2Pet", 40, 1229.78678, 637.8, 5.5, 2.1, 40, 43, 30, 21, 20, 25, 0, 0, 248.0526, 182.18816, 169.38777, 133.31739, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14393, 14393, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 50, "male", "L2Pet", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 25, 0, 0, 305.54906, 200.23844, 208.6504, 146.5258, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14394, 14394, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 54, "male", "L2Pet", 40, 1621.75618, 861, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 370.68904, 218.89589, 253.13256, 160.17851, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14395, 14395, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 58, "male", "L2Pet", 40, 1828.68266, 977.4, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 442.8992, 237.99429, 302.44274, 174.1539, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14396, 14396, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 60, "male", "L2Pet", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 481.34551, 247.65008, 328.69659, 181.21958, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14397, 14397, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 62, "male", "L2Pet", 40, 2037.81082, 1097, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 521.12391, 257.34267, 355.86007, 188.3122, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14398, 14398, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 64, "male", "L2Pet", 40, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 562.02275, 267.04468, 383.78868, 195.41171, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14399, 14399, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 66, "male", "L2Pet", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 603.79903, 276.72752, 412.31647, 202.49719, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14400, 14400, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 68, "male", "L2Pet", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 646.17968, 286.3615, 441.25696, 209.54692, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14401, 14401, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 70, "male", "L2Pet", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14402, 14402, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 72, "male", "L2Pet", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14403, 14403, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 74, "male", "L2Pet", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 773.81598, 314.65987, 528.41601, 230.25444, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14404, 14404, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 76, "male", "L2Pet", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14405, 14405, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 78, "male", "L2Pet", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14406, 14406, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 78, "male", "L2Pet", 40, 2812.763385, 1615.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 860.7348, 333.79298, 587.7703, 244.25522, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14407, 14407, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 78, "male", "L2Pet", 40, 2822.62688, 1624.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 865.65573, 334.88535, 591.13065, 245.05457, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14408, 14408, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 78, "male", "L2Pet", 40, 2832.490375, 1632.6, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 870.57666, 335.97771, 594.49101, 245.85391, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14409, 14409, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 79, "male", "L2Pet", 40, 2842.35387, 1641, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 875.49759, 337.07008, 597.85136, 246.65326, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14410, 14410, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 79, "male", "L2Pet", 40, 2852.217365, 1649.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 880.41852, 338.16245, 601.21172, 247.45261, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14411, 14411, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 79, "male", "L2Pet", 40, 2862.08086, 1657.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 885.33945, 339.25482, 604.57207, 248.25196, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14412, 14412, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 79, "male", "L2Pet", 40, 2871.944355, 1666.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 890.26038, 340.34718, 607.93243, 249.0513, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14413, 14413, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 80, "male", "L2Pet", 40, 2880.37628, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 894.75854, 341.375, 611.00409, 249.80341, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14414, 14414, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 80, "male", "L2Pet", 40, 2889.881882, 1683.25, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 899.57378, 342.45123, 614.29227, 250.59095, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14415, 14415, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 80, "male", "L2Pet", 40, 2899.387485, 1691.7, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 904.38902, 343.52746, 617.58046, 251.37849, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14416, 14416, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 80, "male", "L2Pet", 40, 2908.893088, 1700.15, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 909.20425, 344.60369, 620.86864, 252.16602, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14417, 14417, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 81, "male", "L2Pet", 40, 2916.89894, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 913.54847, 345.61127, 623.83518, 252.90333, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14418, 14418, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 81, "male", "L2Pet", 40, 2926.029605, 1717.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 918.24595, 346.67034, 627.04295, 253.67831, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14419, 14419, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 81, "male", "L2Pet", 40, 2935.16027, 1725.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 922.94344, 347.72941, 630.25073, 254.45329, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14420, 14420, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 81, "male", "L2Pet", 40, 2944.290935, 1734.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 927.64092, 348.78847, 633.4585, 255.22827, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14421, 14421, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 82, "male", "L2Pet", 40, 2951.85588, 1743, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 931.81944, 349.77477, 636.31188, 255.95, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14422, 14422, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 82, "male", "L2Pet", 40, 2960.595115, 1751.55, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 936.38718, 350.81565, 639.43106, 256.71167, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14423, 14423, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 82, "male", "L2Pet", 40, 2969.33435, 1760.1, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 940.95493, 351.85652, 642.55023, 257.47334, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14424, 14424, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 82, "male", "L2Pet", 40, 2978.073585, 1768.65, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 945.52267, 352.8974, 645.66941, 258.235, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14425, 14425, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 83, "male", "L2Pet", 40, 2985.1835, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 949.52401, 353.86144, 648.40181, 258.94045, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14426, 14426, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 83, "male", "L2Pet", 40, 2993.515405, 1786, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 953.95015, 354.88311, 651.42429, 259.68806, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14427, 14427, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 83, "male", "L2Pet", 40, 3001.84731, 1794.6, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 958.3763, 355.90478, 654.44678, 260.43568, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14428, 14428, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 83, "male", "L2Pet", 40, 3010.179215, 1803.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 962.80244, 356.92644, 657.46926, 261.18329, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14429, 14429, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 84, "male", "L2Pet", 40, 3016.82079, 1812, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 966.61544, 357.86723, 660.07304, 261.87171, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14430, 14430, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 84, "male", "L2Pet", 40, 3024.730112, 1820.65, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 970.8883, 358.86868, 662.99085, 262.60453, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14431, 14431, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 84, "male", "L2Pet", 40, 3032.639435, 1829.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 975.16116, 359.87013, 665.90866, 263.33734, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14432, 14432, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 85, "male", "L2Pet", 40, 3046.70947, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 983.0479, 361.78814, 671.29428, 264.74086, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14433, 14433, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 85, "male", "L2Pet", 40, 3056.672363, 1858.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 988.52539, 363.09511, 675.03469, 265.69724, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14434, 14434, "Merrow the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 85, "male", "L2Pet", 40, 3066.635257, 1870, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 994.00287, 364.40208, 678.77511, 266.65363, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14435, 14435, "Unicorn Seraphim", 0, "", 0, "LineageMonster2.angelic_unicorn", 9, 25.5, 58, "male", "L2Pet", 40, 1828.68266, 977.4, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 442.8992, 237.99429, 302.44274, 174.1539, 253, 4, 333, 0, 0, 0, 27, 160, 0, 1), 
(14436, 14436, "Unicorn Seraphim", 0, "", 0, "LineageMonster2.angelic_unicorn", 9, 25.5, 60, "male", "L2Pet", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 481.34551, 247.65008, 328.69659, 181.21958, 253, 4, 333, 0, 0, 0, 27, 160, 0, 1), 
(14437, 14437, "Unicorn Seraphim", 0, "", 0, "LineageMonster2.angelic_unicorn", 9, 25.5, 62, "male", "L2Pet", 40, 2037.81082, 1097, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 521.12391, 257.34267, 355.86007, 188.3122, 253, 4, 333, 0, 0, 0, 27, 160, 0, 1), 
(14438, 14438, "Unicorn Seraphim", 0, "", 0, "LineageMonster2.angelic_unicorn", 9, 25.5, 64, "male", "L2Pet", 40, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 562.02275, 267.04468, 383.78868, 195.41171, 253, 4, 333, 0, 0, 0, 27, 160, 0, 1), 
(14439, 14439, "Unicorn Seraphim", 0, "", 0, "LineageMonster2.angelic_unicorn", 9, 25.5, 66, "male", "L2Pet", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 603.79903, 276.72752, 412.31647, 202.49719, 253, 4, 333, 0, 0, 0, 27, 160, 0, 1), 
(14440, 14440, "Unicorn Seraphim", 0, "", 0, "LineageMonster2.angelic_unicorn", 9, 25.5, 68, "male", "L2Pet", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 646.17968, 286.3615, 441.25696, 209.54692, 253, 4, 333, 0, 0, 0, 27, 160, 0, 1), 
(14441, 14441, "Unicorn Seraphim", 0, "", 0, "LineageMonster2.angelic_unicorn", 9, 25.5, 70, "male", "L2Pet", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 27, 160, 0, 1), 
(14442, 14442, "Unicorn Seraphim", 0, "", 0, "LineageMonster2.angelic_unicorn", 9, 25.5, 72, "male", "L2Pet", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 0, 0, 0, 27, 160, 0, 1), 
(14443, 14443, "Unicorn Seraphim", 0, "", 0, "LineageMonster2.angelic_unicorn", 9, 25.5, 74, "male", "L2Pet", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 773.81598, 314.65987, 528.41601, 230.25444, 253, 4, 333, 0, 0, 0, 27, 160, 0, 1), 
(14444, 14444, "Unicorn Seraphim", 0, "", 0, "LineageMonster2.angelic_unicorn", 9, 25.5, 76, "male", "L2Pet", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 0, 0, 0, 27, 160, 0, 1), 
(14449, 14449, "Unicorn Seraphim", 0, "", 0, "LineageMonster2.angelic_unicorn", 9, 25.5, 78, "male", "L2Pet", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 27, 160, 0, 1), 
(14450, 14450, "Unicorn Seraphim", 0, "", 0, "LineageMonster2.angelic_unicorn", 9, 25.5, 78, "male", "L2Pet", 40, 2812.763385, 1615.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 860.7348, 333.79298, 587.7703, 244.25522, 253, 4, 333, 0, 0, 0, 27, 160, 0, 1), 
(14451, 14451, "Unicorn Seraphim", 0, "", 0, "LineageMonster2.angelic_unicorn", 9, 25.5, 78, "male", "L2Pet", 40, 2822.62688, 1624.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 865.65573, 334.88535, 591.13065, 245.05457, 253, 4, 333, 0, 0, 0, 27, 160, 0, 1), 
(14452, 14452, "Unicorn Seraphim", 0, "", 0, "LineageMonster2.angelic_unicorn", 9, 25.5, 78, "male", "L2Pet", 40, 2832.490375, 1632.6, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 870.57666, 335.97771, 594.49101, 245.85391, 253, 4, 333, 0, 0, 0, 27, 160, 0, 1), 
(14453, 14453, "Unicorn Seraphim", 0, "", 0, "LineageMonster2.angelic_unicorn", 9, 25.5, 79, "male", "L2Pet", 40, 2842.35387, 1641, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 875.49759, 337.07008, 597.85136, 246.65326, 253, 4, 333, 0, 0, 0, 27, 160, 0, 1), 
(14454, 14454, "Unicorn Seraphim", 0, "", 0, "LineageMonster2.angelic_unicorn", 9, 25.5, 79, "male", "L2Pet", 40, 2852.217365, 1649.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 880.41852, 338.16245, 601.21172, 247.45261, 253, 4, 333, 0, 0, 0, 27, 160, 0, 1), 
(14455, 14455, "Unicorn Seraphim", 0, "", 0, "LineageMonster2.angelic_unicorn", 9, 25.5, 79, "male", "L2Pet", 40, 2862.08086, 1657.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 885.33945, 339.25482, 604.57207, 248.25196, 253, 4, 333, 0, 0, 0, 27, 160, 0, 1), 
(14456, 14456, "Unicorn Seraphim", 0, "", 0, "LineageMonster2.angelic_unicorn", 9, 25.5, 79, "male", "L2Pet", 40, 2871.944355, 1666.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 890.26038, 340.34718, 607.93243, 249.0513, 253, 4, 333, 0, 0, 0, 27, 160, 0, 1), 
(14457, 14457, "Unicorn Seraphim", 0, "", 0, "LineageMonster2.angelic_unicorn", 9, 25.5, 80, "male", "L2Pet", 40, 2880.37628, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 894.75854, 341.375, 611.00409, 249.80341, 253, 4, 333, 0, 0, 0, 27, 160, 0, 1), 
(14458, 14458, "Unicorn Seraphim", 0, "", 0, "LineageMonster2.angelic_unicorn", 9, 25.5, 80, "male", "L2Pet", 40, 2889.881882, 1683.25, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 899.57378, 342.45123, 614.29227, 250.59095, 253, 4, 333, 0, 0, 0, 27, 160, 0, 1), 
(14459, 14459, "Unicorn Seraphim", 0, "", 0, "LineageMonster2.angelic_unicorn", 9, 25.5, 80, "male", "L2Pet", 40, 2899.387485, 1691.7, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 904.38902, 343.52746, 617.58046, 251.37849, 253, 4, 333, 0, 0, 0, 27, 160, 0, 1), 
(14460, 14460, "Unicorn Seraphim", 0, "", 0, "LineageMonster2.angelic_unicorn", 9, 25.5, 80, "male", "L2Pet", 40, 2908.893088, 1700.15, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 909.20425, 344.60369, 620.86864, 252.16602, 253, 4, 333, 0, 0, 0, 27, 160, 0, 1), 
(14461, 14461, "Unicorn Seraphim", 0, "", 0, "LineageMonster2.angelic_unicorn", 9, 25.5, 81, "male", "L2Pet", 40, 2916.89894, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 913.54847, 345.61127, 623.83518, 252.90333, 253, 4, 333, 0, 0, 0, 27, 160, 0, 1), 
(14462, 14462, "Unicorn Seraphim", 0, "", 0, "LineageMonster2.angelic_unicorn", 9, 25.5, 81, "male", "L2Pet", 40, 2926.029605, 1717.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 918.24595, 346.67034, 627.04295, 253.67831, 253, 4, 333, 0, 0, 0, 27, 160, 0, 1), 
(14463, 14463, "Unicorn Seraphim", 0, "", 0, "LineageMonster2.angelic_unicorn", 9, 25.5, 81, "male", "L2Pet", 40, 2935.16027, 1725.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 922.94344, 347.72941, 630.25073, 254.45329, 253, 4, 333, 0, 0, 0, 27, 160, 0, 1), 
(14464, 14464, "Unicorn Seraphim", 0, "", 0, "LineageMonster2.angelic_unicorn", 9, 25.5, 81, "male", "L2Pet", 40, 2944.290935, 1734.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 927.64092, 348.78847, 633.4585, 255.22827, 253, 4, 333, 0, 0, 0, 27, 160, 0, 1), 
(14465, 14465, "Unicorn Seraphim", 0, "", 0, "LineageMonster2.angelic_unicorn", 9, 25.5, 82, "male", "L2Pet", 40, 2951.85588, 1743, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 931.81944, 349.77477, 636.31188, 255.95, 253, 4, 333, 0, 0, 0, 27, 160, 0, 1), 
(14466, 14466, "Unicorn Seraphim", 0, "", 0, "LineageMonster2.angelic_unicorn", 9, 25.5, 82, "male", "L2Pet", 40, 2960.595115, 1751.55, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 936.38718, 350.81565, 639.43106, 256.71167, 253, 4, 333, 0, 0, 0, 27, 160, 0, 1), 
(14467, 14467, "Unicorn Seraphim", 0, "", 0, "LineageMonster2.angelic_unicorn", 9, 25.5, 82, "male", "L2Pet", 40, 2969.33435, 1760.1, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 940.95493, 351.85652, 642.55023, 257.47334, 253, 4, 333, 0, 0, 0, 27, 160, 0, 1), 
(14468, 14468, "Unicorn Seraphim", 0, "", 0, "LineageMonster2.angelic_unicorn", 9, 25.5, 82, "male", "L2Pet", 40, 2978.073585, 1768.65, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 945.52267, 352.8974, 645.66941, 258.235, 253, 4, 333, 0, 0, 0, 27, 160, 0, 1), 
(14469, 14469, "Unicorn Seraphim", 0, "", 0, "LineageMonster2.angelic_unicorn", 9, 25.5, 83, "male", "L2Pet", 40, 2985.1835, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 949.52401, 353.86144, 648.40181, 258.94045, 253, 4, 333, 0, 0, 0, 27, 160, 0, 1), 
(14470, 14470, "Unicorn Seraphim", 0, "", 0, "LineageMonster2.angelic_unicorn", 9, 25.5, 83, "male", "L2Pet", 40, 2993.515405, 1786, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 953.95015, 354.88311, 651.42429, 259.68806, 253, 4, 333, 0, 0, 0, 27, 160, 0, 1), 
(14471, 14471, "Unicorn Seraphim", 0, "", 0, "LineageMonster2.angelic_unicorn", 9, 25.5, 83, "male", "L2Pet", 40, 3001.84731, 1794.6, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 958.3763, 355.90478, 654.44678, 260.43568, 253, 4, 333, 0, 0, 0, 27, 160, 0, 1), 
(14472, 14472, "Unicorn Seraphim", 0, "", 0, "LineageMonster2.angelic_unicorn", 9, 25.5, 83, "male", "L2Pet", 40, 3010.179215, 1803.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 962.80244, 356.92644, 657.46926, 261.18329, 253, 4, 333, 0, 0, 0, 27, 160, 0, 1), 
(14473, 14473, "Unicorn Seraphim", 0, "", 0, "LineageMonster2.angelic_unicorn", 9, 25.5, 84, "male", "L2Pet", 40, 3016.82079, 1812, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 966.61544, 357.86723, 660.07304, 261.87171, 253, 4, 333, 0, 0, 0, 27, 160, 0, 1), 
(14474, 14474, "Unicorn Seraphim", 0, "", 0, "LineageMonster2.angelic_unicorn", 9, 25.5, 84, "male", "L2Pet", 40, 3024.730112, 1820.65, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 970.8883, 358.86868, 662.99085, 262.60453, 253, 4, 333, 0, 0, 0, 27, 160, 0, 1), 
(14475, 14475, "Unicorn Seraphim", 0, "", 0, "LineageMonster2.angelic_unicorn", 9, 25.5, 84, "male", "L2Pet", 40, 3032.639435, 1829.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 975.16116, 359.87013, 665.90866, 263.33734, 253, 4, 333, 0, 0, 0, 27, 160, 0, 1), 
(14476, 14476, "Unicorn Seraphim", 0, "", 0, "LineageMonster2.angelic_unicorn", 9, 25.5, 85, "male", "L2Pet", 40, 3046.70947, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 983.0479, 361.78814, 671.29428, 264.74086, 253, 4, 333, 0, 0, 0, 27, 160, 0, 1), 
(14477, 14477, "Unicorn Seraphim", 0, "", 0, "LineageMonster2.angelic_unicorn", 9, 25.5, 85, "male", "L2Pet", 40, 3056.672363, 1858.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 988.52539, 363.09511, 675.03469, 265.69724, 253, 4, 333, 0, 0, 0, 27, 160, 0, 1), 
(14478, 14478, "Unicorn Seraphim", 0, "", 0, "LineageMonster2.angelic_unicorn", 9, 25.5, 85, "male", "L2Pet", 40, 3066.635257, 1870, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 994.00287, 364.40208, 678.77511, 266.65363, 253, 4, 333, 0, 0, 0, 27, 160, 0, 1), 
(14479, 14479, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 22, "male", "L2Pet", 40, 387.02878, 218.52, 3.5, 1.5, 40, 43, 30, 21, 20, 25, 0, 0, 51.75278, 92.65694, 35.34044, 67.80232, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14480, 14480, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 27, "male", "L2Pet", 40, 515.17856, 286.92, 3.5, 1.5, 40, 43, 30, 21, 20, 25, 0, 0, 74.99121, 108.28767, 51.20928, 79.24022, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14481, 14481, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 32, "male", "L2Pet", 40, 668.47132, 358.32, 4.5, 1.8, 40, 43, 30, 21, 20, 25, 0, 0, 106.16525, 125.57727, 72.49711, 91.89199, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14482, 14482, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 37, "male", "L2Pet", 40, 847.31754, 432.72, 4.5, 1.8, 40, 43, 30, 21, 20, 25, 0, 0, 146.82587, 144.47758, 100.26304, 105.72243, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14483, 14483, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 42, "male", "L2Pet", 40, 1050.81652, 531, 5.5, 2.1, 40, 43, 30, 21, 20, 25, 0, 0, 198.34591, 164.88513, 135.44454, 120.65578, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14484, 14484, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 46, "male", "L2Pet", 40, 1229.78678, 637.8, 5.5, 2.1, 40, 43, 30, 21, 20, 25, 0, 0, 248.0526, 182.18816, 169.38777, 133.31739, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14485, 14485, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 50, "male", "L2Pet", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 25, 0, 0, 305.54906, 200.23844, 208.6504, 146.5258, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14486, 14486, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 54, "male", "L2Pet", 40, 1621.75618, 861, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 370.68904, 218.89589, 253.13256, 160.17851, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14487, 14487, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 58, "male", "L2Pet", 40, 1828.68266, 977.4, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 442.8992, 237.99429, 302.44274, 174.1539, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14488, 14488, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 60, "male", "L2Pet", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 481.34551, 247.65008, 328.69659, 181.21958, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14489, 14489, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 62, "male", "L2Pet", 40, 2037.81082, 1097, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 521.12391, 257.34267, 355.86007, 188.3122, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14490, 14490, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 64, "male", "L2Pet", 40, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 562.02275, 267.04468, 383.78868, 195.41171, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14491, 14491, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 66, "male", "L2Pet", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 603.79903, 276.72752, 412.31647, 202.49719, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14492, 14492, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 68, "male", "L2Pet", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 646.17968, 286.3615, 441.25696, 209.54692, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14493, 14493, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 70, "male", "L2Pet", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14494, 14494, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 72, "male", "L2Pet", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14495, 14495, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 74, "male", "L2Pet", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 773.81598, 314.65987, 528.41601, 230.25444, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14496, 14496, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 76, "male", "L2Pet", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14497, 14497, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 78, "male", "L2Pet", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14498, 14498, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 78, "male", "L2Pet", 40, 2812.763385, 1615.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 860.7348, 333.79298, 587.7703, 244.25522, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14499, 14499, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 78, "male", "L2Pet", 40, 2822.62688, 1624.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 865.65573, 334.88535, 591.13065, 245.05457, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14500, 14500, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 78, "male", "L2Pet", 40, 2832.490375, 1632.6, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 870.57666, 335.97771, 594.49101, 245.85391, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14501, 14501, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 79, "male", "L2Pet", 40, 2842.35387, 1641, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 875.49759, 337.07008, 597.85136, 246.65326, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14502, 14502, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 79, "male", "L2Pet", 40, 2852.217365, 1649.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 880.41852, 338.16245, 601.21172, 247.45261, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14503, 14503, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 79, "male", "L2Pet", 40, 2862.08086, 1657.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 885.33945, 339.25482, 604.57207, 248.25196, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14504, 14504, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 79, "male", "L2Pet", 40, 2871.944355, 1666.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 890.26038, 340.34718, 607.93243, 249.0513, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14505, 14505, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 80, "male", "L2Pet", 40, 2880.37628, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 894.75854, 341.375, 611.00409, 249.80341, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14506, 14506, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 80, "male", "L2Pet", 40, 2889.881882, 1683.25, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 899.57378, 342.45123, 614.29227, 250.59095, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14507, 14507, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 80, "male", "L2Pet", 40, 2899.387485, 1691.7, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 904.38902, 343.52746, 617.58046, 251.37849, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14508, 14508, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 80, "male", "L2Pet", 40, 2908.893088, 1700.15, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 909.20425, 344.60369, 620.86864, 252.16602, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14509, 14509, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 81, "male", "L2Pet", 40, 2916.89894, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 913.54847, 345.61127, 623.83518, 252.90333, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14510, 14510, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 81, "male", "L2Pet", 40, 2926.029605, 1717.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 918.24595, 346.67034, 627.04295, 253.67831, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14511, 14511, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 81, "male", "L2Pet", 40, 2935.16027, 1725.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 922.94344, 347.72941, 630.25073, 254.45329, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14512, 14512, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 81, "male", "L2Pet", 40, 2944.290935, 1734.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 927.64092, 348.78847, 633.4585, 255.22827, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14513, 14513, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 82, "male", "L2Pet", 40, 2951.85588, 1743, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 931.81944, 349.77477, 636.31188, 255.95, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14514, 14514, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 82, "male", "L2Pet", 40, 2960.595115, 1751.55, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 936.38718, 350.81565, 639.43106, 256.71167, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14515, 14515, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 82, "male", "L2Pet", 40, 2969.33435, 1760.1, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 940.95493, 351.85652, 642.55023, 257.47334, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14516, 14516, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 82, "male", "L2Pet", 40, 2978.073585, 1768.65, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 945.52267, 352.8974, 645.66941, 258.235, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14517, 14517, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 83, "male", "L2Pet", 40, 2985.1835, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 949.52401, 353.86144, 648.40181, 258.94045, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14518, 14518, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 83, "male", "L2Pet", 40, 2993.515405, 1786, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 953.95015, 354.88311, 651.42429, 259.68806, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14519, 14519, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 83, "male", "L2Pet", 40, 3001.84731, 1794.6, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 958.3763, 355.90478, 654.44678, 260.43568, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14520, 14520, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 83, "male", "L2Pet", 40, 3010.179215, 1803.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 962.80244, 356.92644, 657.46926, 261.18329, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14521, 14521, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 84, "male", "L2Pet", 40, 3016.82079, 1812, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 966.61544, 357.86723, 660.07304, 261.87171, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14522, 14522, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 84, "male", "L2Pet", 40, 3024.730112, 1820.65, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 970.8883, 358.86868, 662.99085, 262.60453, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14523, 14523, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 84, "male", "L2Pet", 40, 3032.639435, 1829.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 975.16116, 359.87013, 665.90866, 263.33734, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14524, 14524, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 85, "male", "L2Pet", 40, 3046.70947, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 983.0479, 361.78814, 671.29428, 264.74086, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14525, 14525, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 85, "male", "L2Pet", 40, 3056.672363, 1858.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 988.52539, 363.09511, 675.03469, 265.69724, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14526, 14526, "Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 85, "male", "L2Pet", 40, 3066.635257, 1870, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 994.00287, 364.40208, 678.77511, 266.65363, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14527, 14527, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 22, "female", "L2Pet", 40, 387.02878, 218.52, 3.5, 1.5, 40, 43, 30, 21, 20, 25, 0, 0, 51.75278, 92.65694, 35.34044, 67.80232, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14528, 14528, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 27, "female", "L2Pet", 40, 515.17856, 286.92, 3.5, 1.5, 40, 43, 30, 21, 20, 25, 0, 0, 74.99121, 108.28767, 51.20928, 79.24022, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14529, 14529, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 32, "female", "L2Pet", 40, 668.47132, 358.32, 4.5, 1.8, 40, 43, 30, 21, 20, 25, 0, 0, 106.16525, 125.57727, 72.49711, 91.89199, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14530, 14530, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 37, "female", "L2Pet", 40, 847.31754, 432.72, 4.5, 1.8, 40, 43, 30, 21, 20, 25, 0, 0, 146.82587, 144.47758, 100.26304, 105.72243, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14531, 14531, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 42, "female", "L2Pet", 40, 1050.81652, 531, 5.5, 2.1, 40, 43, 30, 21, 20, 25, 0, 0, 198.34591, 164.88513, 135.44454, 120.65578, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14532, 14532, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 46, "female", "L2Pet", 40, 1229.78678, 637.8, 5.5, 2.1, 40, 43, 30, 21, 20, 25, 0, 0, 248.0526, 182.18816, 169.38777, 133.31739, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14533, 14533, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 50, "female", "L2Pet", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 25, 0, 0, 305.54906, 200.23844, 208.6504, 146.5258, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14534, 14534, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 54, "female", "L2Pet", 40, 1621.75618, 861, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 370.68904, 218.89589, 253.13256, 160.17851, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14535, 14535, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 58, "female", "L2Pet", 40, 1828.68266, 977.4, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 442.8992, 237.99429, 302.44274, 174.1539, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14536, 14536, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 60, "female", "L2Pet", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 481.34551, 247.65008, 328.69659, 181.21958, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14537, 14537, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 62, "female", "L2Pet", 40, 2037.81082, 1097, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 521.12391, 257.34267, 355.86007, 188.3122, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14538, 14538, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 64, "female", "L2Pet", 40, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 562.02275, 267.04468, 383.78868, 195.41171, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14539, 14539, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 66, "female", "L2Pet", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 603.79903, 276.72752, 412.31647, 202.49719, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14540, 14540, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 68, "female", "L2Pet", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 646.17968, 286.3615, 441.25696, 209.54692, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14541, 14541, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 70, "female", "L2Pet", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14542, 14542, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 72, "female", "L2Pet", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14543, 14543, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 74, "female", "L2Pet", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 773.81598, 314.65987, 528.41601, 230.25444, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14544, 14544, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 76, "female", "L2Pet", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14545, 14545, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 78, "female", "L2Pet", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14546, 14546, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 78, "female", "L2Pet", 40, 2812.763385, 1615.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 860.7348, 333.79298, 587.7703, 244.25522, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14547, 14547, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 78, "female", "L2Pet", 40, 2822.62688, 1624.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 865.65573, 334.88535, 591.13065, 245.05457, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14548, 14548, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 78, "female", "L2Pet", 40, 2832.490375, 1632.6, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 870.57666, 335.97771, 594.49101, 245.85391, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14549, 14549, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 79, "female", "L2Pet", 40, 2842.35387, 1641, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 875.49759, 337.07008, 597.85136, 246.65326, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14550, 14550, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 79, "female", "L2Pet", 40, 2852.217365, 1649.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 880.41852, 338.16245, 601.21172, 247.45261, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14551, 14551, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 79, "female", "L2Pet", 40, 2862.08086, 1657.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 885.33945, 339.25482, 604.57207, 248.25196, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14552, 14552, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 79, "female", "L2Pet", 40, 2871.944355, 1666.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 890.26038, 340.34718, 607.93243, 249.0513, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14553, 14553, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 80, "female", "L2Pet", 40, 2880.37628, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 894.75854, 341.375, 611.00409, 249.80341, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14554, 14554, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 80, "female", "L2Pet", 40, 2889.881882, 1683.25, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 899.57378, 342.45123, 614.29227, 250.59095, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14555, 14555, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 80, "female", "L2Pet", 40, 2899.387485, 1691.7, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 904.38902, 343.52746, 617.58046, 251.37849, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14556, 14556, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 80, "female", "L2Pet", 40, 2908.893088, 1700.15, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 909.20425, 344.60369, 620.86864, 252.16602, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14557, 14557, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 81, "female", "L2Pet", 40, 2916.89894, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 913.54847, 345.61127, 623.83518, 252.90333, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14558, 14558, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 81, "female", "L2Pet", 40, 2926.029605, 1717.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 918.24595, 346.67034, 627.04295, 253.67831, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14559, 14559, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 81, "female", "L2Pet", 40, 2935.16027, 1725.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 922.94344, 347.72941, 630.25073, 254.45329, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14560, 14560, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 81, "female", "L2Pet", 40, 2944.290935, 1734.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 927.64092, 348.78847, 633.4585, 255.22827, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14561, 14561, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 82, "female", "L2Pet", 40, 2951.85588, 1743, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 931.81944, 349.77477, 636.31188, 255.95, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14562, 14562, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 82, "female", "L2Pet", 40, 2960.595115, 1751.55, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 936.38718, 350.81565, 639.43106, 256.71167, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14563, 14563, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 82, "female", "L2Pet", 40, 2969.33435, 1760.1, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 940.95493, 351.85652, 642.55023, 257.47334, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14564, 14564, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 82, "female", "L2Pet", 40, 2978.073585, 1768.65, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 945.52267, 352.8974, 645.66941, 258.235, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14565, 14565, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 83, "female", "L2Pet", 40, 2985.1835, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 949.52401, 353.86144, 648.40181, 258.94045, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14566, 14566, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 83, "female", "L2Pet", 40, 2993.515405, 1786, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 953.95015, 354.88311, 651.42429, 259.68806, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14567, 14567, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 83, "female", "L2Pet", 40, 3001.84731, 1794.6, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 958.3763, 355.90478, 654.44678, 260.43568, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14568, 14568, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 83, "female", "L2Pet", 40, 3010.179215, 1803.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 962.80244, 356.92644, 657.46926, 261.18329, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14569, 14569, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 84, "female", "L2Pet", 40, 3016.82079, 1812, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 966.61544, 357.86723, 660.07304, 261.87171, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14570, 14570, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 84, "female", "L2Pet", 40, 3024.730112, 1820.65, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 970.8883, 358.86868, 662.99085, 262.60453, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14571, 14571, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 84, "female", "L2Pet", 40, 3032.639435, 1829.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 975.16116, 359.87013, 665.90866, 263.33734, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14572, 14572, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 85, "female", "L2Pet", 40, 3046.70947, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 983.0479, 361.78814, 671.29428, 264.74086, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14573, 14573, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 85, "female", "L2Pet", 40, 3056.672363, 1858.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 988.52539, 363.09511, 675.03469, 265.69724, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14574, 14574, "Silhouette", 0, "", 0, "LineageMonster.silhouette", 8, 23, 85, "female", "L2Pet", 40, 3066.635257, 1870, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 994.00287, 364.40208, 678.77511, 266.65363, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(14575, 14575, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 42, "male", "L2Pet", 40, 1050.81652, 531, 5.5, 2.1, 40, 43, 30, 21, 20, 25, 0, 0, 198.34591, 164.88513, 135.44454, 120.65578, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14576, 14576, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 46, "male", "L2Pet", 40, 1229.78678, 637.8, 5.5, 2.1, 40, 43, 30, 21, 20, 25, 0, 0, 248.0526, 182.18816, 169.38777, 133.31739, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14577, 14577, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 50, "male", "L2Pet", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 25, 0, 0, 305.54906, 200.23844, 208.6504, 146.5258, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14578, 14578, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 54, "male", "L2Pet", 40, 1621.75618, 861, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 370.68904, 218.89589, 253.13256, 160.17851, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14579, 14579, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 58, "male", "L2Pet", 40, 1828.68266, 977.4, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 442.8992, 237.99429, 302.44274, 174.1539, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14580, 14580, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 60, "male", "L2Pet", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 481.34551, 247.65008, 328.69659, 181.21958, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14581, 14581, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 62, "male", "L2Pet", 40, 2037.81082, 1097, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 521.12391, 257.34267, 355.86007, 188.3122, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14582, 14582, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 64, "male", "L2Pet", 40, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 562.02275, 267.04468, 383.78868, 195.41171, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14583, 14583, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 66, "male", "L2Pet", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 603.79903, 276.72752, 412.31647, 202.49719, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14584, 14584, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 68, "male", "L2Pet", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 646.17968, 286.3615, 441.25696, 209.54692, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14585, 14585, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 70, "male", "L2Pet", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14586, 14586, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 72, "male", "L2Pet", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14587, 14587, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 74, "male", "L2Pet", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 773.81598, 314.65987, 528.41601, 230.25444, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14588, 14588, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 76, "male", "L2Pet", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14589, 14589, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 78, "male", "L2Pet", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14590, 14590, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 78, "male", "L2Pet", 40, 2812.763385, 1615.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 860.7348, 333.79298, 587.7703, 244.25522, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14591, 14591, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 78, "male", "L2Pet", 40, 2822.62688, 1624.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 865.65573, 334.88535, 591.13065, 245.05457, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14592, 14592, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 78, "male", "L2Pet", 40, 2832.490375, 1632.6, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 870.57666, 335.97771, 594.49101, 245.85391, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14593, 14593, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 79, "male", "L2Pet", 40, 2842.35387, 1641, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 875.49759, 337.07008, 597.85136, 246.65326, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14594, 14594, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 79, "male", "L2Pet", 40, 2852.217365, 1649.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 880.41852, 338.16245, 601.21172, 247.45261, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14595, 14595, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 79, "male", "L2Pet", 40, 2862.08086, 1657.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 885.33945, 339.25482, 604.57207, 248.25196, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14596, 14596, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 79, "male", "L2Pet", 40, 2871.944355, 1666.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 890.26038, 340.34718, 607.93243, 249.0513, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14597, 14597, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 80, "male", "L2Pet", 40, 2880.37628, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 894.75854, 341.375, 611.00409, 249.80341, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14598, 14598, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 80, "male", "L2Pet", 40, 2889.881882, 1683.25, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 899.57378, 342.45123, 614.29227, 250.59095, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14599, 14599, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 80, "male", "L2Pet", 40, 2899.387485, 1691.7, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 904.38902, 343.52746, 617.58046, 251.37849, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14600, 14600, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 80, "male", "L2Pet", 40, 2908.893088, 1700.15, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 909.20425, 344.60369, 620.86864, 252.16602, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14601, 14601, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 81, "male", "L2Pet", 40, 2916.89894, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 913.54847, 345.61127, 623.83518, 252.90333, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14602, 14602, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 81, "male", "L2Pet", 40, 2926.029605, 1717.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 918.24595, 346.67034, 627.04295, 253.67831, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14603, 14603, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 81, "male", "L2Pet", 40, 2935.16027, 1725.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 922.94344, 347.72941, 630.25073, 254.45329, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14604, 14604, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 81, "male", "L2Pet", 40, 2944.290935, 1734.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 927.64092, 348.78847, 633.4585, 255.22827, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14605, 14605, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 82, "male", "L2Pet", 40, 2951.85588, 1743, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 931.81944, 349.77477, 636.31188, 255.95, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14606, 14606, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 82, "male", "L2Pet", 40, 2960.595115, 1751.55, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 936.38718, 350.81565, 639.43106, 256.71167, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14607, 14607, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 82, "male", "L2Pet", 40, 2969.33435, 1760.1, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 940.95493, 351.85652, 642.55023, 257.47334, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14608, 14608, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 82, "male", "L2Pet", 40, 2978.073585, 1768.65, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 945.52267, 352.8974, 645.66941, 258.235, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14609, 14609, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 83, "male", "L2Pet", 40, 2985.1835, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 949.52401, 353.86144, 648.40181, 258.94045, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14610, 14610, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 83, "male", "L2Pet", 40, 2993.515405, 1786, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 953.95015, 354.88311, 651.42429, 259.68806, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14611, 14611, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 83, "male", "L2Pet", 40, 3001.84731, 1794.6, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 958.3763, 355.90478, 654.44678, 260.43568, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14612, 14612, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 83, "male", "L2Pet", 40, 3010.179215, 1803.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 962.80244, 356.92644, 657.46926, 261.18329, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14613, 14613, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 84, "male", "L2Pet", 40, 3016.82079, 1812, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 966.61544, 357.86723, 660.07304, 261.87171, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14614, 14614, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 84, "male", "L2Pet", 40, 3024.730112, 1820.65, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 970.8883, 358.86868, 662.99085, 262.60453, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14615, 14615, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 84, "male", "L2Pet", 40, 3032.639435, 1829.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 975.16116, 359.87013, 665.90866, 263.33734, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14616, 14616, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 85, "male", "L2Pet", 40, 3046.70947, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 983.0479, 361.78814, 671.29428, 264.74086, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14617, 14617, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 85, "male", "L2Pet", 40, 3056.672363, 1858.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 988.52539, 363.09511, 675.03469, 265.69724, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14618, 14618, "Soulless", 0, "", 0, "LineageMonster.shadeless", 7, 28, 85, "male", "L2Pet", 40, 3066.635257, 1870, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 994.00287, 364.40208, 678.77511, 266.65363, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(14619, 14619, "Nightshade", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 35.5, 58, "male", "L2Pet", 40, 1828.68266, 977.4, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 442.8992, 237.99429, 302.44274, 174.1539, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(14620, 14620, "Nightshade", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 35.5, 60, "male", "L2Pet", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 481.34551, 247.65008, 328.69659, 181.21958, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(14621, 14621, "Nightshade", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 35.5, 62, "male", "L2Pet", 40, 2037.81082, 1097, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 521.12391, 257.34267, 355.86007, 188.3122, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(14622, 14622, "Nightshade", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 35.5, 64, "male", "L2Pet", 40, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 562.02275, 267.04468, 383.78868, 195.41171, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(14623, 14623, "Nightshade", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 35.5, 66, "male", "L2Pet", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 603.79903, 276.72752, 412.31647, 202.49719, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(14624, 14624, "Nightshade", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 35.5, 68, "male", "L2Pet", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 646.17968, 286.3615, 441.25696, 209.54692, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(14625, 14625, "Nightshade", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 35.5, 70, "male", "L2Pet", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(14626, 14626, "Nightshade", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 35.5, 72, "male", "L2Pet", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(14627, 14627, "Nightshade", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 35.5, 74, "male", "L2Pet", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 773.81598, 314.65987, 528.41601, 230.25444, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(14628, 14628, "Nightshade", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 35.5, 76, "male", "L2Pet", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(14633, 14633, "Nightshade", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 35.5, 78, "male", "L2Pet", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(14634, 14634, "Nightshade", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 35.5, 78, "male", "L2Pet", 40, 2812.763385, 1615.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 860.7348, 333.79298, 587.7703, 244.25522, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(14635, 14635, "Nightshade", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 35.5, 78, "male", "L2Pet", 40, 2822.62688, 1624.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 865.65573, 334.88535, 591.13065, 245.05457, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(14636, 14636, "Nightshade", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 35.5, 78, "male", "L2Pet", 40, 2832.490375, 1632.6, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 870.57666, 335.97771, 594.49101, 245.85391, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(14637, 14637, "Nightshade", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 35.5, 79, "male", "L2Pet", 40, 2842.35387, 1641, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 875.49759, 337.07008, 597.85136, 246.65326, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(14638, 14638, "Nightshade", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 35.5, 79, "male", "L2Pet", 40, 2852.217365, 1649.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 880.41852, 338.16245, 601.21172, 247.45261, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(14639, 14639, "Nightshade", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 35.5, 79, "male", "L2Pet", 40, 2862.08086, 1657.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 885.33945, 339.25482, 604.57207, 248.25196, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(14640, 14640, "Nightshade", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 35.5, 79, "male", "L2Pet", 40, 2871.944355, 1666.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 890.26038, 340.34718, 607.93243, 249.0513, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(14641, 14641, "Nightshade", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 35.5, 80, "male", "L2Pet", 40, 2880.37628, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 894.75854, 341.375, 611.00409, 249.80341, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(14642, 14642, "Nightshade", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 35.5, 80, "male", "L2Pet", 40, 2889.881882, 1683.25, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 899.57378, 342.45123, 614.29227, 250.59095, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(14643, 14643, "Nightshade", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 35.5, 80, "male", "L2Pet", 40, 2899.387485, 1691.7, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 904.38902, 343.52746, 617.58046, 251.37849, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(14644, 14644, "Nightshade", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 35.5, 80, "male", "L2Pet", 40, 2908.893088, 1700.15, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 909.20425, 344.60369, 620.86864, 252.16602, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(14645, 14645, "Nightshade", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 35.5, 81, "male", "L2Pet", 40, 2916.89894, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 913.54847, 345.61127, 623.83518, 252.90333, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(14646, 14646, "Nightshade", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 35.5, 81, "male", "L2Pet", 40, 2926.029605, 1717.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 918.24595, 346.67034, 627.04295, 253.67831, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(14647, 14647, "Nightshade", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 35.5, 81, "male", "L2Pet", 40, 2935.16027, 1725.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 922.94344, 347.72941, 630.25073, 254.45329, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(14648, 14648, "Nightshade", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 35.5, 81, "male", "L2Pet", 40, 2944.290935, 1734.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 927.64092, 348.78847, 633.4585, 255.22827, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(14649, 14649, "Nightshade", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 35.5, 82, "male", "L2Pet", 40, 2951.85588, 1743, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 931.81944, 349.77477, 636.31188, 255.95, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(14650, 14650, "Nightshade", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 35.5, 82, "male", "L2Pet", 40, 2960.595115, 1751.55, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 936.38718, 350.81565, 639.43106, 256.71167, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(14651, 14651, "Nightshade", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 35.5, 82, "male", "L2Pet", 40, 2969.33435, 1760.1, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 940.95493, 351.85652, 642.55023, 257.47334, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(14652, 14652, "Nightshade", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 35.5, 82, "male", "L2Pet", 40, 2978.073585, 1768.65, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 945.52267, 352.8974, 645.66941, 258.235, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(14653, 14653, "Nightshade", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 35.5, 83, "male", "L2Pet", 40, 2985.1835, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 949.52401, 353.86144, 648.40181, 258.94045, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(14654, 14654, "Nightshade", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 35.5, 83, "male", "L2Pet", 40, 2993.515405, 1786, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 953.95015, 354.88311, 651.42429, 259.68806, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(14655, 14655, "Nightshade", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 35.5, 83, "male", "L2Pet", 40, 3001.84731, 1794.6, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 958.3763, 355.90478, 654.44678, 260.43568, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(14656, 14656, "Nightshade", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 35.5, 83, "male", "L2Pet", 40, 3010.179215, 1803.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 962.80244, 356.92644, 657.46926, 261.18329, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(14657, 14657, "Nightshade", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 35.5, 84, "male", "L2Pet", 40, 3016.82079, 1812, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 966.61544, 357.86723, 660.07304, 261.87171, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(14658, 14658, "Nightshade", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 35.5, 84, "male", "L2Pet", 40, 3024.730112, 1820.65, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 970.8883, 358.86868, 662.99085, 262.60453, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(14659, 14659, "Nightshade", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 35.5, 84, "male", "L2Pet", 40, 3032.639435, 1829.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 975.16116, 359.87013, 665.90866, 263.33734, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(14660, 14660, "Nightshade", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 35.5, 85, "male", "L2Pet", 40, 3046.70947, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 983.0479, 361.78814, 671.29428, 264.74086, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(14661, 14661, "Nightshade", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 35.5, 85, "male", "L2Pet", 40, 3056.672363, 1858.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 988.52539, 363.09511, 675.03469, 265.69724, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(14662, 14662, "Nightshade", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 35.5, 85, "male", "L2Pet", 40, 3066.635257, 1870, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 994.00287, 364.40208, 678.77511, 266.65363, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(14663, 14663, "Mechanic Golem", 0, "", 0, "LineageMonster.mechanic_golem", 5, 19, 30, "male", "L2Pet", 40, 604.08419, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 25, 0, 0, 92.64226, 118.46427, 63.26266, 86.68702, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(14664, 14664, "Mechanic Golem", 0, "", 0, "LineageMonster.mechanic_golem", 5, 19, 38, "male", "L2Pet", 40, 886.09975, 447.96, 4.5, 1.8, 40, 43, 30, 21, 20, 25, 0, 0, 156.22273, 148.44287, 106.67987, 108.62405, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(14665, 14665, "Mechanic Golem", 0, "", 0, "LineageMonster.mechanic_golem", 5, 19, 45, "male", "L2Pet", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 25, 0, 0, 234.89829, 177.78746, 160.40508, 130.09715, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(14666, 14666, "Mechanic Golem", 0, "", 0, "LineageMonster.mechanic_golem", 5, 19, 51, "male", "L2Pet", 40, 1470.41596, 775.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 321.13207, 204.85194, 219.29157, 149.90176, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(14667, 14667, "Mechanic Golem", 0, "", 0, "LineageMonster.mechanic_golem", 5, 19, 57, "male", "L2Pet", 40, 1776.58018, 948, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 424.23295, 233.18839, 289.69611, 170.63714, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(14668, 14668, "Mechanic Golem", 0, "", 0, "LineageMonster.mechanic_golem", 5, 19, 62, "male", "L2Pet", 40, 2037.81082, 1097, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 521.12391, 257.34267, 355.86007, 188.3122, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(14669, 14669, "Mechanic Golem", 0, "", 0, "LineageMonster.mechanic_golem", 5, 19, 66, "male", "L2Pet", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 603.79903, 276.72752, 412.31647, 202.49719, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(14670, 14670, "Mechanic Golem", 0, "", 0, "LineageMonster.mechanic_golem", 5, 19, 70, "male", "L2Pet", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(14671, 14671, "Mechanic Golem", 0, "", 0, "LineageMonster.mechanic_golem", 5, 19, 74, "male", "L2Pet", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 773.81598, 314.65987, 528.41601, 230.25444, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(14672, 14672, "Mechanic Golem", 0, "", 0, "LineageMonster.mechanic_golem", 5, 19, 78, "male", "L2Pet", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(14673, 14673, "Mechanic Golem", 0, "", 0, "LineageMonster.mechanic_golem", 5, 19, 78, "male", "L2Pet", 40, 2812.763385, 1615.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 860.7348, 333.79298, 587.7703, 244.25522, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(14674, 14674, "Mechanic Golem", 0, "", 0, "LineageMonster.mechanic_golem", 5, 19, 78, "male", "L2Pet", 40, 2822.62688, 1624.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 865.65573, 334.88535, 591.13065, 245.05457, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(14675, 14675, "Mechanic Golem", 0, "", 0, "LineageMonster.mechanic_golem", 5, 19, 78, "male", "L2Pet", 40, 2832.490375, 1632.6, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 870.57666, 335.97771, 594.49101, 245.85391, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(14676, 14676, "Mechanic Golem", 0, "", 0, "LineageMonster.mechanic_golem", 5, 19, 79, "male", "L2Pet", 40, 2842.35387, 1641, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 875.49759, 337.07008, 597.85136, 246.65326, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(14677, 14677, "Mechanic Golem", 0, "", 0, "LineageMonster.mechanic_golem", 5, 19, 79, "male", "L2Pet", 40, 2852.217365, 1649.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 880.41852, 338.16245, 601.21172, 247.45261, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(14678, 14678, "Mechanic Golem", 0, "", 0, "LineageMonster.mechanic_golem", 5, 19, 79, "male", "L2Pet", 40, 2862.08086, 1657.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 885.33945, 339.25482, 604.57207, 248.25196, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(14679, 14679, "Mechanic Golem", 0, "", 0, "LineageMonster.mechanic_golem", 5, 19, 79, "male", "L2Pet", 40, 2871.944355, 1666.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 890.26038, 340.34718, 607.93243, 249.0513, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(14680, 14680, "Mechanic Golem", 0, "", 0, "LineageMonster.mechanic_golem", 5, 19, 80, "male", "L2Pet", 40, 2880.37628, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 894.75854, 341.375, 611.00409, 249.80341, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(14681, 14681, "Mechanic Golem", 0, "", 0, "LineageMonster.mechanic_golem", 5, 19, 80, "male", "L2Pet", 40, 2889.881882, 1683.25, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 899.57378, 342.45123, 614.29227, 250.59095, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(14682, 14682, "Mechanic Golem", 0, "", 0, "LineageMonster.mechanic_golem", 5, 19, 80, "male", "L2Pet", 40, 2899.387485, 1691.7, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 904.38902, 343.52746, 617.58046, 251.37849, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(14683, 14683, "Mechanic Golem", 0, "", 0, "LineageMonster.mechanic_golem", 5, 19, 80, "male", "L2Pet", 40, 2908.893088, 1700.15, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 909.20425, 344.60369, 620.86864, 252.16602, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(14684, 14684, "Mechanic Golem", 0, "", 0, "LineageMonster.mechanic_golem", 5, 19, 81, "male", "L2Pet", 40, 2916.89894, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 913.54847, 345.61127, 623.83518, 252.90333, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(14685, 14685, "Mechanic Golem", 0, "", 0, "LineageMonster.mechanic_golem", 5, 19, 81, "male", "L2Pet", 40, 2926.029605, 1717.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 918.24595, 346.67034, 627.04295, 253.67831, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(14686, 14686, "Mechanic Golem", 0, "", 0, "LineageMonster.mechanic_golem", 5, 19, 81, "male", "L2Pet", 40, 2935.16027, 1725.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 922.94344, 347.72941, 630.25073, 254.45329, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(14687, 14687, "Mechanic Golem", 0, "", 0, "LineageMonster.mechanic_golem", 5, 19, 81, "male", "L2Pet", 40, 2944.290935, 1734.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 927.64092, 348.78847, 633.4585, 255.22827, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(14688, 14688, "Mechanic Golem", 0, "", 0, "LineageMonster.mechanic_golem", 5, 19, 82, "male", "L2Pet", 40, 2951.85588, 1743, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 931.81944, 349.77477, 636.31188, 255.95, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(14689, 14689, "Mechanic Golem", 0, "", 0, "LineageMonster.mechanic_golem", 5, 19, 82, "male", "L2Pet", 40, 2960.595115, 1751.55, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 936.38718, 350.81565, 639.43106, 256.71167, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(14690, 14690, "Mechanic Golem", 0, "", 0, "LineageMonster.mechanic_golem", 5, 19, 82, "male", "L2Pet", 40, 2969.33435, 1760.1, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 940.95493, 351.85652, 642.55023, 257.47334, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(14691, 14691, "Mechanic Golem", 0, "", 0, "LineageMonster.mechanic_golem", 5, 19, 82, "male", "L2Pet", 40, 2978.073585, 1768.65, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 945.52267, 352.8974, 645.66941, 258.235, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(14692, 14692, "Mechanic Golem", 0, "", 0, "LineageMonster.mechanic_golem", 5, 19, 83, "male", "L2Pet", 40, 2985.1835, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 949.52401, 353.86144, 648.40181, 258.94045, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(14693, 14693, "Mechanic Golem", 0, "", 0, "LineageMonster.mechanic_golem", 5, 19, 83, "male", "L2Pet", 40, 2993.515405, 1786, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 953.95015, 354.88311, 651.42429, 259.68806, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(14694, 14694, "Mechanic Golem", 0, "", 0, "LineageMonster.mechanic_golem", 5, 19, 83, "male", "L2Pet", 40, 3001.84731, 1794.6, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 958.3763, 355.90478, 654.44678, 260.43568, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(14695, 14695, "Mechanic Golem", 0, "", 0, "LineageMonster.mechanic_golem", 5, 19, 83, "male", "L2Pet", 40, 3010.179215, 1803.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 962.80244, 356.92644, 657.46926, 261.18329, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(14696, 14696, "Mechanic Golem", 0, "", 0, "LineageMonster.mechanic_golem", 5, 19, 84, "male", "L2Pet", 40, 3016.82079, 1812, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 966.61544, 357.86723, 660.07304, 261.87171, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(14697, 14697, "Mechanic Golem", 0, "", 0, "LineageMonster.mechanic_golem", 5, 19, 84, "male", "L2Pet", 40, 3024.730112, 1820.65, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 970.8883, 358.86868, 662.99085, 262.60453, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(14698, 14698, "Mechanic Golem", 0, "", 0, "LineageMonster.mechanic_golem", 5, 19, 84, "male", "L2Pet", 40, 3032.639435, 1829.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 975.16116, 359.87013, 665.90866, 263.33734, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(14699, 14699, "Mechanic Golem", 0, "", 0, "LineageMonster.mechanic_golem", 5, 19, 85, "male", "L2Pet", 40, 3046.70947, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 983.0479, 361.78814, 671.29428, 264.74086, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(14700, 14700, "Mechanic Golem", 0, "", 0, "LineageMonster.mechanic_golem", 5, 19, 85, "male", "L2Pet", 40, 3056.672363, 1858.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 988.52539, 363.09511, 675.03469, 265.69724, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(14701, 14701, "Mechanic Golem", 0, "", 0, "LineageMonster.mechanic_golem", 5, 19, 85, "male", "L2Pet", 40, 3066.635257, 1870, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 994.00287, 364.40208, 678.77511, 266.65363, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(14702, 14702, "Big Boom", 0, "", 0, "LineageMonster.big_boom", 6, 13, 60, "male", "L2Pet", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 481.34551, 247.65008, 328.69659, 181.21958, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14703, 14703, "Big Boom", 0, "", 0, "LineageMonster.big_boom", 6, 13, 64, "male", "L2Pet", 40, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 562.02275, 267.04468, 383.78868, 195.41171, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14704, 14704, "Big Boom", 0, "", 0, "LineageMonster.big_boom", 6, 13, 68, "male", "L2Pet", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 646.17968, 286.3615, 441.25696, 209.54692, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14705, 14705, "Big Boom", 0, "", 0, "LineageMonster.big_boom", 6, 13, 72, "male", "L2Pet", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14706, 14706, "Big Boom", 0, "", 0, "LineageMonster.big_boom", 6, 13, 76, "male", "L2Pet", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(14707, 14707, "Big Boom", 0, "", 0, "LineageMonster.big_boom", 6, 13, 78, "male", "L2Pet", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 48, 141, 0, 1), 
(14708, 14708, "Big Boom", 0, "", 0, "LineageMonster.big_boom", 6, 13, 78, "male", "L2Pet", 40, 2812.763385, 1615.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 860.7348, 333.79298, 587.7703, 244.25522, 253, 4, 333, 0, 0, 0, 48, 142, 0, 1), 
(14709, 14709, "Big Boom", 0, "", 0, "LineageMonster.big_boom", 6, 13, 78, "male", "L2Pet", 40, 2822.62688, 1624.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 865.65573, 334.88535, 591.13065, 245.05457, 253, 4, 333, 0, 0, 0, 48, 143, 0, 1), 
(14710, 14710, "Big Boom", 0, "", 0, "LineageMonster.big_boom", 6, 13, 78, "male", "L2Pet", 40, 2832.490375, 1632.6, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 870.57666, 335.97771, 594.49101, 245.85391, 253, 4, 333, 0, 0, 0, 48, 144, 0, 1), 
(14711, 14711, "Big Boom", 0, "", 0, "LineageMonster.big_boom", 6, 13, 79, "male", "L2Pet", 40, 2842.35387, 1641, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 875.49759, 337.07008, 597.85136, 246.65326, 253, 4, 333, 0, 0, 0, 48, 145, 0, 1), 
(14712, 14712, "Big Boom", 0, "", 0, "LineageMonster.big_boom", 6, 13, 79, "male", "L2Pet", 40, 2852.217365, 1649.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 880.41852, 338.16245, 601.21172, 247.45261, 253, 4, 333, 0, 0, 0, 48, 146, 0, 1), 
(14713, 14713, "Big Boom", 0, "", 0, "LineageMonster.big_boom", 6, 13, 79, "male", "L2Pet", 40, 2862.08086, 1657.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 885.33945, 339.25482, 604.57207, 248.25196, 253, 4, 333, 0, 0, 0, 48, 147, 0, 1), 
(14714, 14714, "Big Boom", 0, "", 0, "LineageMonster.big_boom", 6, 13, 79, "male", "L2Pet", 40, 2871.944355, 1666.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 890.26038, 340.34718, 607.93243, 249.0513, 253, 4, 333, 0, 0, 0, 48, 148, 0, 1), 
(14715, 14715, "Big Boom", 0, "", 0, "LineageMonster.big_boom", 6, 13, 80, "male", "L2Pet", 40, 2880.37628, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 894.75854, 341.375, 611.00409, 249.80341, 253, 4, 333, 0, 0, 0, 48, 149, 0, 1), 
(14716, 14716, "Big Boom", 0, "", 0, "LineageMonster.big_boom", 6, 13, 80, "male", "L2Pet", 40, 2889.881882, 1683.25, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 899.57378, 342.45123, 614.29227, 250.59095, 253, 4, 333, 0, 0, 0, 48, 150, 0, 1), 
(14717, 14717, "Big Boom", 0, "", 0, "LineageMonster.big_boom", 6, 13, 80, "male", "L2Pet", 40, 2899.387485, 1691.7, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 904.38902, 343.52746, 617.58046, 251.37849, 253, 4, 333, 0, 0, 0, 48, 151, 0, 1), 
(14718, 14718, "Big Boom", 0, "", 0, "LineageMonster.big_boom", 6, 13, 80, "male", "L2Pet", 40, 2908.893088, 1700.15, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 909.20425, 344.60369, 620.86864, 252.16602, 253, 4, 333, 0, 0, 0, 48, 152, 0, 1), 
(14719, 14719, "Big Boom", 0, "", 0, "LineageMonster.big_boom", 6, 13, 81, "male", "L2Pet", 40, 2916.89894, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 913.54847, 345.61127, 623.83518, 252.90333, 253, 4, 333, 0, 0, 0, 48, 153, 0, 1), 
(14720, 14720, "Big Boom", 0, "", 0, "LineageMonster.big_boom", 6, 13, 81, "male", "L2Pet", 40, 2926.029605, 1717.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 918.24595, 346.67034, 627.04295, 253.67831, 253, 4, 333, 0, 0, 0, 48, 154, 0, 1), 
(14721, 14721, "Big Boom", 0, "", 0, "LineageMonster.big_boom", 6, 13, 81, "male", "L2Pet", 40, 2935.16027, 1725.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 922.94344, 347.72941, 630.25073, 254.45329, 253, 4, 333, 0, 0, 0, 48, 155, 0, 1), 
(14722, 14722, "Big Boom", 0, "", 0, "LineageMonster.big_boom", 6, 13, 81, "male", "L2Pet", 40, 2944.290935, 1734.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 927.64092, 348.78847, 633.4585, 255.22827, 253, 4, 333, 0, 0, 0, 48, 156, 0, 1), 
(14723, 14723, "Big Boom", 0, "", 0, "LineageMonster.big_boom", 6, 13, 82, "male", "L2Pet", 40, 2951.85588, 1743, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 931.81944, 349.77477, 636.31188, 255.95, 253, 4, 333, 0, 0, 0, 48, 157, 0, 1), 
(14724, 14724, "Big Boom", 0, "", 0, "LineageMonster.big_boom", 6, 13, 82, "male", "L2Pet", 40, 2960.595115, 1751.55, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 936.38718, 350.81565, 639.43106, 256.71167, 253, 4, 333, 0, 0, 0, 48, 158, 0, 1), 
(14725, 14725, "Big Boom", 0, "", 0, "LineageMonster.big_boom", 6, 13, 82, "male", "L2Pet", 40, 2969.33435, 1760.1, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 940.95493, 351.85652, 642.55023, 257.47334, 253, 4, 333, 0, 0, 0, 48, 159, 0, 1), 
(14726, 14726, "Big Boom", 0, "", 0, "LineageMonster.big_boom", 6, 13, 82, "male", "L2Pet", 40, 2978.073585, 1768.65, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 945.52267, 352.8974, 645.66941, 258.235, 253, 4, 333, 0, 0, 0, 48, 160, 0, 1), 
(14727, 14727, "Big Boom", 0, "", 0, "LineageMonster.big_boom", 6, 13, 83, "male", "L2Pet", 40, 2985.1835, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 949.52401, 353.86144, 648.40181, 258.94045, 253, 4, 333, 0, 0, 0, 48, 161, 0, 1), 
(14728, 14728, "Big Boom", 0, "", 0, "LineageMonster.big_boom", 6, 13, 83, "male", "L2Pet", 40, 2993.515405, 1786, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 953.95015, 354.88311, 651.42429, 259.68806, 253, 4, 333, 0, 0, 0, 48, 162, 0, 1), 
(14729, 14729, "Big Boom", 0, "", 0, "LineageMonster.big_boom", 6, 13, 83, "male", "L2Pet", 40, 3001.84731, 1794.6, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 958.3763, 355.90478, 654.44678, 260.43568, 253, 4, 333, 0, 0, 0, 48, 163, 0, 1), 
(14730, 14730, "Big Boom", 0, "", 0, "LineageMonster.big_boom", 6, 13, 83, "male", "L2Pet", 40, 3010.179215, 1803.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 962.80244, 356.92644, 657.46926, 261.18329, 253, 4, 333, 0, 0, 0, 48, 164, 0, 1), 
(14731, 14731, "Big Boom", 0, "", 0, "LineageMonster.big_boom", 6, 13, 84, "male", "L2Pet", 40, 3016.82079, 1812, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 966.61544, 357.86723, 660.07304, 261.87171, 253, 4, 333, 0, 0, 0, 48, 165, 0, 1), 
(14732, 14732, "Big Boom", 0, "", 0, "LineageMonster.big_boom", 6, 13, 84, "male", "L2Pet", 40, 3024.730112, 1820.65, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 970.8883, 358.86868, 662.99085, 262.60453, 253, 4, 333, 0, 0, 0, 48, 166, 0, 1), 
(14733, 14733, "Big Boom", 0, "", 0, "LineageMonster.big_boom", 6, 13, 84, "male", "L2Pet", 40, 3032.639435, 1829.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 975.16116, 359.87013, 665.90866, 263.33734, 253, 4, 333, 0, 0, 0, 48, 167, 0, 1), 
(14734, 14734, "Big Boom", 0, "", 0, "LineageMonster.big_boom", 6, 13, 85, "male", "L2Pet", 40, 3046.70947, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 983.0479, 361.78814, 671.29428, 264.74086, 253, 4, 333, 0, 0, 0, 48, 168, 0, 1), 
(14735, 14735, "Big Boom", 0, "", 0, "LineageMonster.big_boom", 6, 13, 85, "male", "L2Pet", 40, 3056.672363, 1858.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 988.52539, 363.09511, 675.03469, 265.69724, 253, 4, 333, 0, 0, 0, 48, 169, 0, 1), 
(14736, 14736, "Big Boom", 0, "", 0, "LineageMonster.big_boom", 6, 13, 85, "male", "L2Pet", 40, 3066.635257, 1870, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 994.00287, 364.40208, 678.77511, 266.65363, 253, 4, 333, 0, 0, 0, 48, 170, 0, 1), 
(14737, 14737, "Siege Golem", 0, "", 0, "LineageMonster.siege_golem", 60, 140, 55, "male", "L2SiegeSummon", 80, 500000, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 1500, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(14738, 14738, "Siege Golem", 0, "", 0, "LineageMonster.siege_golem", 60, 140, 78, "male", "L2SiegeSummon", 80, 500000, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 1515, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(14739, 14739, "Siege Golem", 0, "", 0, "LineageMonster.siege_golem", 60, 140, 78, "male", "L2SiegeSummon", 80, 500000, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 1530, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(14740, 14740, "Siege Golem", 0, "", 0, "LineageMonster.siege_golem", 60, 140, 78, "male", "L2SiegeSummon", 80, 500000, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 1545, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(14741, 14741, "Siege Golem", 0, "", 0, "LineageMonster.siege_golem", 60, 140, 78, "male", "L2SiegeSummon", 80, 500000, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 1560, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(14742, 14742, "Siege Golem", 0, "", 0, "LineageMonster.siege_golem", 60, 140, 79, "male", "L2SiegeSummon", 80, 500000, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 1575, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(14743, 14743, "Siege Golem", 0, "", 0, "LineageMonster.siege_golem", 60, 140, 79, "male", "L2SiegeSummon", 80, 500000, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 1590, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(14744, 14744, "Siege Golem", 0, "", 0, "LineageMonster.siege_golem", 60, 140, 79, "male", "L2SiegeSummon", 80, 500000, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 1605, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(14745, 14745, "Siege Golem", 0, "", 0, "LineageMonster.siege_golem", 60, 140, 79, "male", "L2SiegeSummon", 80, 500000, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 1620, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(14746, 14746, "Siege Golem", 0, "", 0, "LineageMonster.siege_golem", 60, 140, 80, "male", "L2SiegeSummon", 80, 500000, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 1635, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(14747, 14747, "Siege Golem", 0, "", 0, "LineageMonster.siege_golem", 60, 140, 80, "male", "L2SiegeSummon", 80, 500000, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 1650, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(14748, 14748, "Siege Golem", 0, "", 0, "LineageMonster.siege_golem", 60, 140, 80, "male", "L2SiegeSummon", 80, 500000, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 1665, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(14749, 14749, "Siege Golem", 0, "", 0, "LineageMonster.siege_golem", 60, 140, 80, "male", "L2SiegeSummon", 80, 500000, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 1680, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(14750, 14750, "Siege Golem", 0, "", 0, "LineageMonster.siege_golem", 60, 140, 81, "male", "L2SiegeSummon", 80, 500000, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 1695, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(14751, 14751, "Siege Golem", 0, "", 0, "LineageMonster.siege_golem", 60, 140, 81, "male", "L2SiegeSummon", 80, 500000, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 1710, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(14752, 14752, "Siege Golem", 0, "", 0, "LineageMonster.siege_golem", 60, 140, 81, "male", "L2SiegeSummon", 80, 500000, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 1725, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(14753, 14753, "Siege Golem", 0, "", 0, "LineageMonster.siege_golem", 60, 140, 81, "male", "L2SiegeSummon", 80, 500000, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 1740, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(14754, 14754, "Siege Golem", 0, "", 0, "LineageMonster.siege_golem", 60, 140, 82, "male", "L2SiegeSummon", 80, 500000, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 1755, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(14755, 14755, "Siege Golem", 0, "", 0, "LineageMonster.siege_golem", 60, 140, 82, "male", "L2SiegeSummon", 80, 500000, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 1770, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(14756, 14756, "Siege Golem", 0, "", 0, "LineageMonster.siege_golem", 60, 140, 82, "male", "L2SiegeSummon", 80, 500000, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 1785, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(14757, 14757, "Siege Golem", 0, "", 0, "LineageMonster.siege_golem", 60, 140, 82, "male", "L2SiegeSummon", 80, 500000, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 1800, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(14758, 14758, "Siege Golem", 0, "", 0, "LineageMonster.siege_golem", 60, 140, 83, "male", "L2SiegeSummon", 80, 500000, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 1815, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(14759, 14759, "Siege Golem", 0, "", 0, "LineageMonster.siege_golem", 60, 140, 83, "male", "L2SiegeSummon", 80, 500000, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 1830, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(14760, 14760, "Siege Golem", 0, "", 0, "LineageMonster.siege_golem", 60, 140, 83, "male", "L2SiegeSummon", 80, 500000, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 1845, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(14761, 14761, "Siege Golem", 0, "", 0, "LineageMonster.siege_golem", 60, 140, 83, "male", "L2SiegeSummon", 80, 500000, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 1860, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(14762, 14762, "Siege Golem", 0, "", 0, "LineageMonster.siege_golem", 60, 140, 84, "male", "L2SiegeSummon", 80, 500000, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 1875, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(14763, 14763, "Siege Golem", 0, "", 0, "LineageMonster.siege_golem", 60, 140, 84, "male", "L2SiegeSummon", 80, 500000, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 1890, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(14764, 14764, "Siege Golem", 0, "", 0, "LineageMonster.siege_golem", 60, 140, 84, "male", "L2SiegeSummon", 80, 500000, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 1905, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(14765, 14765, "Siege Golem", 0, "", 0, "LineageMonster.siege_golem", 60, 140, 85, "male", "L2SiegeSummon", 80, 500000, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 1920, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(14766, 14766, "Siege Golem", 0, "", 0, "LineageMonster.siege_golem", 60, 140, 85, "male", "L2SiegeSummon", 80, 500000, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 1935, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(14767, 14767, "Siege Golem", 0, "", 0, "LineageMonster.siege_golem", 60, 140, 85, "male", "L2SiegeSummon", 80, 500000, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 1950, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(14768, 14768, "Wild Hog Cannon", 0, "", 0, "LineageMonster.range_golem", 93, 90, 60, "male", "L2SiegeSummon", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 481.34551, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 10, 10, 0, 1), 
(14769, 14769, "Wild Hog Cannon", 0, "", 0, "LineageMonster.range_golem", 93, 90, 78, "male", "L2SiegeSummon", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 855.81387, 333.79298, 587.7703, 244.25522, 253, 4, 333, 0, 0, 0, 10, 10, 0, 1), 
(14770, 14770, "Wild Hog Cannon", 0, "", 0, "LineageMonster.range_golem", 93, 90, 78, "male", "L2SiegeSummon", 40, 2812.763385, 1615.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 860.7348, 334.88535, 591.13065, 245.05457, 253, 4, 333, 0, 0, 0, 10, 10, 0, 1), 
(14771, 14771, "Wild Hog Cannon", 0, "", 0, "LineageMonster.range_golem", 93, 90, 78, "male", "L2SiegeSummon", 40, 2822.62688, 1624.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 865.65573, 335.97771, 594.49101, 245.85391, 253, 4, 333, 0, 0, 0, 10, 10, 0, 1), 
(14772, 14772, "Wild Hog Cannon", 0, "", 0, "LineageMonster.range_golem", 93, 90, 78, "male", "L2SiegeSummon", 40, 2832.490375, 1632.6, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 870.57666, 337.07008, 597.85136, 246.65326, 253, 4, 333, 0, 0, 0, 10, 10, 0, 1), 
(14773, 14773, "Wild Hog Cannon", 0, "", 0, "LineageMonster.range_golem", 93, 90, 79, "male", "L2SiegeSummon", 40, 2842.35387, 1641, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 875.49759, 338.16245, 601.21172, 247.45261, 253, 4, 333, 0, 0, 0, 10, 10, 0, 1), 
(14774, 14774, "Wild Hog Cannon", 0, "", 0, "LineageMonster.range_golem", 93, 90, 79, "male", "L2SiegeSummon", 40, 2852.217365, 1649.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 880.41852, 339.25482, 604.57207, 248.25196, 253, 4, 333, 0, 0, 0, 10, 10, 0, 1), 
(14775, 14775, "Wild Hog Cannon", 0, "", 0, "LineageMonster.range_golem", 93, 90, 79, "male", "L2SiegeSummon", 40, 2862.08086, 1657.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 885.33945, 340.34718, 607.93243, 249.0513, 253, 4, 333, 0, 0, 0, 10, 10, 0, 1), 
(14776, 14776, "Wild Hog Cannon", 0, "", 0, "LineageMonster.range_golem", 93, 90, 79, "male", "L2SiegeSummon", 40, 2871.944355, 1666.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 890.26038, 341.375, 611.00409, 249.80341, 253, 4, 333, 0, 0, 0, 10, 10, 0, 1), 
(14777, 14777, "Wild Hog Cannon", 0, "", 0, "LineageMonster.range_golem", 93, 90, 80, "male", "L2SiegeSummon", 40, 2880.37628, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 894.75854, 342.45123, 614.29227, 250.59095, 253, 4, 333, 0, 0, 0, 10, 10, 0, 1), 
(14778, 14778, "Wild Hog Cannon", 0, "", 0, "LineageMonster.range_golem", 93, 90, 80, "male", "L2SiegeSummon", 40, 2889.881882, 1683.25, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 899.57378, 343.52746, 617.58046, 251.37849, 253, 4, 333, 0, 0, 0, 10, 10, 0, 1), 
(14779, 14779, "Wild Hog Cannon", 0, "", 0, "LineageMonster.range_golem", 93, 90, 80, "male", "L2SiegeSummon", 40, 2899.387485, 1691.7, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 904.38902, 344.60369, 620.86864, 252.16602, 253, 4, 333, 0, 0, 0, 10, 10, 0, 1), 
(14780, 14780, "Wild Hog Cannon", 0, "", 0, "LineageMonster.range_golem", 93, 90, 80, "male", "L2SiegeSummon", 40, 2908.893088, 1700.15, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 909.20425, 345.61127, 623.83518, 252.90333, 253, 4, 333, 0, 0, 0, 10, 10, 0, 1), 
(14781, 14781, "Wild Hog Cannon", 0, "", 0, "LineageMonster.range_golem", 93, 90, 81, "male", "L2SiegeSummon", 40, 2916.89894, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 913.54847, 346.67034, 627.04295, 253.67831, 253, 4, 333, 0, 0, 0, 10, 10, 0, 1), 
(14782, 14782, "Wild Hog Cannon", 0, "", 0, "LineageMonster.range_golem", 93, 90, 81, "male", "L2SiegeSummon", 40, 2926.029605, 1717.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 918.24595, 347.72941, 630.25073, 254.45329, 253, 4, 333, 0, 0, 0, 10, 10, 0, 1), 
(14783, 14783, "Wild Hog Cannon", 0, "", 0, "LineageMonster.range_golem", 93, 90, 81, "male", "L2SiegeSummon", 40, 2935.16027, 1725.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 922.94344, 348.78847, 633.4585, 255.22827, 253, 4, 333, 0, 0, 0, 10, 10, 0, 1), 
(14784, 14784, "Wild Hog Cannon", 0, "", 0, "LineageMonster.range_golem", 93, 90, 81, "male", "L2SiegeSummon", 40, 2944.290935, 1734.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 927.64092, 349.77477, 636.31188, 255.95, 253, 4, 333, 0, 0, 0, 10, 10, 0, 1), 
(14785, 14785, "Wild Hog Cannon", 0, "", 0, "LineageMonster.range_golem", 93, 90, 82, "male", "L2SiegeSummon", 40, 2951.85588, 1743, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 931.81944, 350.81565, 639.43106, 256.71167, 253, 4, 333, 0, 0, 0, 10, 10, 0, 1), 
(14786, 14786, "Wild Hog Cannon", 0, "", 0, "LineageMonster.range_golem", 93, 90, 82, "male", "L2SiegeSummon", 40, 2960.595115, 1751.55, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 936.38718, 351.85652, 642.55023, 257.47334, 253, 4, 333, 0, 0, 0, 10, 10, 0, 1), 
(14787, 14787, "Wild Hog Cannon", 0, "", 0, "LineageMonster.range_golem", 93, 90, 82, "male", "L2SiegeSummon", 40, 2969.33435, 1760.1, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 940.95493, 352.8974, 645.66941, 258.235, 253, 4, 333, 0, 0, 0, 10, 10, 0, 1), 
(14788, 14788, "Wild Hog Cannon", 0, "", 0, "LineageMonster.range_golem", 93, 90, 82, "male", "L2SiegeSummon", 40, 2978.073585, 1768.65, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 945.52267, 353.86144, 648.40181, 258.94045, 253, 4, 333, 0, 0, 0, 10, 10, 0, 1), 
(14789, 14789, "Wild Hog Cannon", 0, "", 0, "LineageMonster.range_golem", 93, 90, 83, "male", "L2SiegeSummon", 40, 2985.1835, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 949.52401, 354.88311, 651.42429, 259.68806, 253, 4, 333, 0, 0, 0, 10, 10, 0, 1), 
(14790, 14790, "Wild Hog Cannon", 0, "", 0, "LineageMonster.range_golem", 93, 90, 83, "male", "L2SiegeSummon", 40, 2993.515405, 1786, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 953.95015, 355.90478, 654.44678, 260.43568, 253, 4, 333, 0, 0, 0, 10, 10, 0, 1), 
(14791, 14791, "Wild Hog Cannon", 0, "", 0, "LineageMonster.range_golem", 93, 90, 83, "male", "L2SiegeSummon", 40, 3001.84731, 1794.6, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 958.3763, 356.92644, 657.46926, 261.18329, 253, 4, 333, 0, 0, 0, 10, 10, 0, 1), 
(14792, 14792, "Wild Hog Cannon", 0, "", 0, "LineageMonster.range_golem", 93, 90, 83, "male", "L2SiegeSummon", 40, 3010.179215, 1803.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 962.80244, 357.86723, 660.07304, 261.87171, 253, 4, 333, 0, 0, 0, 10, 10, 0, 1), 
(14793, 14793, "Wild Hog Cannon", 0, "", 0, "LineageMonster.range_golem", 93, 90, 84, "male", "L2SiegeSummon", 40, 3016.82079, 1812, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 966.61544, 358.86868, 662.99085, 262.60453, 253, 4, 333, 0, 0, 0, 10, 10, 0, 1), 
(14794, 14794, "Wild Hog Cannon", 0, "", 0, "LineageMonster.range_golem", 93, 90, 84, "male", "L2SiegeSummon", 40, 3024.730112, 1820.65, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 970.8883, 359.87013, 665.90866, 263.33734, 253, 4, 333, 0, 0, 0, 10, 10, 0, 1), 
(14795, 14795, "Wild Hog Cannon", 0, "", 0, "LineageMonster.range_golem", 93, 90, 84, "male", "L2SiegeSummon", 40, 3032.639435, 1829.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 975.16116, 361.78814, 671.29428, 264.74086, 253, 4, 333, 0, 0, 0, 10, 10, 0, 1), 
(14796, 14796, "Wild Hog Cannon", 0, "", 0, "LineageMonster.range_golem", 93, 90, 85, "male", "L2SiegeSummon", 40, 3046.70947, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 983.0479, 363.09511, 675.03469, 265.69724, 253, 4, 333, 0, 0, 0, 10, 10, 0, 1), 
(14797, 14797, "Wild Hog Cannon", 0, "", 0, "LineageMonster.range_golem", 93, 90, 85, "male", "L2SiegeSummon", 40, 3056.672363, 1858.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 988.52539, 364.40208, 678.77511, 266.65363, 253, 4, 333, 0, 0, 0, 10, 10, 0, 1), 
(14798, 14798, "Wild Hog Cannon", 0, "", 0, "LineageMonster.range_golem", 93, 90, 85, "male", "L2SiegeSummon", 40, 3066.635257, 1870, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 994.00287, 341.375, 611.00409, 249.80341, 253, 4, 333, 0, 0, 0, 10, 10, 0, 1), 
(14799, 14799, "Dark Panther", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 42, "male", "L2Pet", 40, 1050.81652, 531, 5.5, 2.1, 40, 43, 30, 21, 20, 25, 0, 0, 198.34591, 164.88513, 135.44454, 120.65578, 253, 4, 333, 0, 0, 0, 25, 150, 0, 1), 
(14800, 14800, "Dark Panther", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 51, "male", "L2Pet", 40, 1470.41596, 775.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 321.13207, 204.85194, 219.29157, 149.90176, 253, 4, 333, 0, 0, 0, 25, 150, 0, 1), 
(14801, 14801, "Dark Panther", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 60, "male", "L2Pet", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 481.34551, 247.65008, 328.69659, 181.21958, 253, 4, 333, 0, 0, 0, 25, 150, 0, 1), 
(14802, 14802, "Dark Panther", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 64, "male", "L2Pet", 40, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 562.02275, 267.04468, 383.78868, 195.41171, 253, 4, 333, 0, 0, 0, 25, 150, 0, 1), 
(14803, 14803, "Dark Panther", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 68, "male", "L2Pet", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 646.17968, 286.3615, 441.25696, 209.54692, 253, 4, 333, 0, 0, 0, 25, 150, 0, 1), 
(14804, 14804, "Dark Panther", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 72, "male", "L2Pet", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 0, 0, 0, 25, 150, 0, 1), 
(14805, 14805, "Dark Panther", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 76, "male", "L2Pet", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 0, 0, 0, 25, 150, 0, 1), 
(14806, 14806, "Dark Panther", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 78, "male", "L2Pet", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 25, 150, 0, 1), 
(14807, 14807, "Dark Panther", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 78, "male", "L2Pet", 40, 2812.763385, 1615.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 860.7348, 333.79298, 587.7703, 244.25522, 253, 4, 333, 0, 0, 0, 25, 150, 0, 1), 
(14808, 14808, "Dark Panther", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 78, "male", "L2Pet", 40, 2822.62688, 1624.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 865.65573, 334.88535, 591.13065, 245.05457, 253, 4, 333, 0, 0, 0, 25, 150, 0, 1), 
(14809, 14809, "Dark Panther", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 78, "male", "L2Pet", 40, 2832.490375, 1632.6, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 870.57666, 335.97771, 594.49101, 245.85391, 253, 4, 333, 0, 0, 0, 25, 150, 0, 1), 
(14810, 14810, "Dark Panther", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 79, "male", "L2Pet", 40, 2842.35387, 1641, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 875.49759, 337.07008, 597.85136, 246.65326, 253, 4, 333, 0, 0, 0, 25, 150, 0, 1), 
(14811, 14811, "Dark Panther", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 79, "male", "L2Pet", 40, 2852.217365, 1649.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 880.41852, 338.16245, 601.21172, 247.45261, 253, 4, 333, 0, 0, 0, 25, 150, 0, 1), 
(14812, 14812, "Dark Panther", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 79, "male", "L2Pet", 40, 2862.08086, 1657.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 885.33945, 339.25482, 604.57207, 248.25196, 253, 4, 333, 0, 0, 0, 25, 150, 0, 1), 
(14813, 14813, "Dark Panther", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 79, "male", "L2Pet", 40, 2871.944355, 1666.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 890.26038, 340.34718, 607.93243, 249.0513, 253, 4, 333, 0, 0, 0, 25, 150, 0, 1), 
(14814, 14814, "Dark Panther", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 80, "male", "L2Pet", 40, 2880.37628, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 894.75854, 341.375, 611.00409, 249.80341, 253, 4, 333, 0, 0, 0, 25, 150, 0, 1), 
(14815, 14815, "Dark Panther", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 80, "male", "L2Pet", 40, 2889.881882, 1683.25, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 899.57378, 342.45123, 614.29227, 250.59095, 253, 4, 333, 0, 0, 0, 25, 150, 0, 1), 
(14816, 14816, "Dark Panther", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 80, "male", "L2Pet", 40, 2899.387485, 1691.7, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 904.38902, 343.52746, 617.58046, 251.37849, 253, 4, 333, 0, 0, 0, 25, 150, 0, 1), 
(14817, 14817, "Dark Panther", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 80, "male", "L2Pet", 40, 2908.893088, 1700.15, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 909.20425, 344.60369, 620.86864, 252.16602, 253, 4, 333, 0, 0, 0, 25, 150, 0, 1), 
(14818, 14818, "Dark Panther", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 81, "male", "L2Pet", 40, 2916.89894, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 913.54847, 345.61127, 623.83518, 252.90333, 253, 4, 333, 0, 0, 0, 25, 150, 0, 1), 
(14819, 14819, "Dark Panther", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 81, "male", "L2Pet", 40, 2926.029605, 1717.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 918.24595, 346.67034, 627.04295, 253.67831, 253, 4, 333, 0, 0, 0, 25, 150, 0, 1), 
(14820, 14820, "Dark Panther", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 81, "male", "L2Pet", 40, 2935.16027, 1725.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 922.94344, 347.72941, 630.25073, 254.45329, 253, 4, 333, 0, 0, 0, 25, 150, 0, 1), 
(14821, 14821, "Dark Panther", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 81, "male", "L2Pet", 40, 2944.290935, 1734.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 927.64092, 348.78847, 633.4585, 255.22827, 253, 4, 333, 0, 0, 0, 25, 150, 0, 1), 
(14822, 14822, "Dark Panther", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 82, "male", "L2Pet", 40, 2951.85588, 1743, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 931.81944, 349.77477, 636.31188, 255.95, 253, 4, 333, 0, 0, 0, 25, 150, 0, 1), 
(14823, 14823, "Dark Panther", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 82, "male", "L2Pet", 40, 2960.595115, 1751.55, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 936.38718, 350.81565, 639.43106, 256.71167, 253, 4, 333, 0, 0, 0, 25, 150, 0, 1), 
(14824, 14824, "Dark Panther", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 82, "male", "L2Pet", 40, 2969.33435, 1760.1, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 940.95493, 351.85652, 642.55023, 257.47334, 253, 4, 333, 0, 0, 0, 25, 150, 0, 1), 
(14825, 14825, "Dark Panther", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 82, "male", "L2Pet", 40, 2978.073585, 1768.65, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 945.52267, 352.8974, 645.66941, 258.235, 253, 4, 333, 0, 0, 0, 25, 150, 0, 1), 
(14826, 14826, "Dark Panther", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 83, "male", "L2Pet", 40, 2985.1835, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 949.52401, 353.86144, 648.40181, 258.94045, 253, 4, 333, 0, 0, 0, 25, 150, 0, 1), 
(14827, 14827, "Dark Panther", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 83, "male", "L2Pet", 40, 2993.515405, 1786, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 953.95015, 354.88311, 651.42429, 259.68806, 253, 4, 333, 0, 0, 0, 25, 150, 0, 1), 
(14828, 14828, "Dark Panther", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 83, "male", "L2Pet", 40, 3001.84731, 1794.6, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 958.3763, 355.90478, 654.44678, 260.43568, 253, 4, 333, 0, 0, 0, 25, 150, 0, 1), 
(14829, 14829, "Dark Panther", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 83, "male", "L2Pet", 40, 3010.179215, 1803.2, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 962.80244, 356.92644, 657.46926, 261.18329, 253, 4, 333, 0, 0, 0, 25, 150, 0, 1), 
(14830, 14830, "Dark Panther", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 84, "male", "L2Pet", 40, 3016.82079, 1812, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 966.61544, 357.86723, 660.07304, 261.87171, 253, 4, 333, 0, 0, 0, 25, 150, 0, 1), 
(14831, 14831, "Dark Panther", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 84, "male", "L2Pet", 40, 3024.730112, 1820.65, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 970.8883, 358.86868, 662.99085, 262.60453, 253, 4, 333, 0, 0, 0, 25, 150, 0, 1), 
(14832, 14832, "Dark Panther", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 84, "male", "L2Pet", 40, 3032.639435, 1829.3, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 975.16116, 359.87013, 665.90866, 263.33734, 253, 4, 333, 0, 0, 0, 25, 150, 0, 1), 
(14833, 14833, "Dark Panther", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 85, "male", "L2Pet", 40, 3046.70947, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 983.0479, 361.78814, 671.29428, 264.74086, 253, 4, 333, 0, 0, 0, 25, 150, 0, 1), 
(14834, 14834, "Dark Panther", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 85, "male", "L2Pet", 40, 3056.672363, 1858.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 988.52539, 363.09511, 675.03469, 265.69724, 253, 4, 333, 0, 0, 0, 25, 150, 0, 1), 
(14835, 14835, "Dark Panther", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 85, "male", "L2Pet", 40, 3066.635257, 1870, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 994.00287, 364.40208, 678.77511, 266.65363, 253, 4, 333, 0, 0, 0, 25, 150, 0, 1), 
(14836, 14836, "Feline King", 0, "", 0, "LineageMonster3.king_of_cat", 6, 16.01, 80, "male", "L2Pet", 40, 2880.37628, 1674.8, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 894.75854, 341.375, 611.00409, 249.80341, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14837, 14837, "Magnus the Unicorn", 0, "", 0, "LineageMonster3.unicorn_magnus", 13.5, 17, 80, "male", "L2Pet", 40, 2880.37628, 1674.8, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 894.75854, 341.375, 611.00409, 249.80341, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14838, 14838, "Spectral Lord", 0, "", 0, "LineageMonster3.spectral_knight", 12.5, 33.5, 80, "male", "L2Pet", 40, 2880.37628, 1674.8, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 894.75854, 341.375, 611.00409, 249.80341, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14839, 14839, "Swoop Cannon", 0, "", 0, "LineageMonster3.toad_cannon", 45, 47.5, 68, "male", "L2SiegeSummon", 80, 50000, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 12.475, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 60, 40, 0, 1), 
(14840, 14840, "Swoop Cannon", 0, "", 0, "LineageMonster3.toad_cannon", 45, 47.5, 78, "male", "L2SiegeSummon", 80, 50000, 889.8, 8.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 12.475, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 60, 40, 0, 1), 
(14841, 14841, "Swoop Cannon", 0, "", 0, "LineageMonster3.toad_cannon", 45, 47.5, 78, "male", "L2SiegeSummon", 80, 50000, 889.8, 8.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 12.475, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 60, 40, 0, 1), 
(14842, 14842, "Swoop Cannon", 0, "", 0, "LineageMonster3.toad_cannon", 45, 47.5, 78, "male", "L2SiegeSummon", 80, 50000, 889.8, 8.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 12.475, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 60, 40, 0, 1), 
(14843, 14843, "Swoop Cannon", 0, "", 0, "LineageMonster3.toad_cannon", 45, 47.5, 78, "male", "L2SiegeSummon", 80, 50000, 889.8, 8.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 12.82311, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 60, 40, 0, 1), 
(14844, 14844, "Swoop Cannon", 0, "", 0, "LineageMonster3.toad_cannon", 45, 47.5, 79, "male", "L2SiegeSummon", 80, 50000, 889.8, 8.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 12.82311, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 60, 40, 0, 1), 
(14845, 14845, "Swoop Cannon", 0, "", 0, "LineageMonster3.toad_cannon", 45, 47.5, 79, "male", "L2SiegeSummon", 80, 50000, 889.8, 8.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 12.82311, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 60, 40, 0, 1), 
(14846, 14846, "Swoop Cannon", 0, "", 0, "LineageMonster3.toad_cannon", 45, 47.5, 79, "male", "L2SiegeSummon", 80, 50000, 889.8, 8.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 13.37067, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 60, 40, 0, 1), 
(14847, 14847, "Swoop Cannon", 0, "", 0, "LineageMonster3.toad_cannon", 45, 47.5, 79, "male", "L2SiegeSummon", 80, 50000, 889.8, 8.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 13.37067, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 60, 40, 0, 1), 
(14848, 14848, "Swoop Cannon", 0, "", 0, "LineageMonster3.toad_cannon", 45, 47.5, 80, "male", "L2SiegeSummon", 80, 50000, 889.8, 8.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 13.37067, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 60, 40, 0, 1), 
(14849, 14849, "Swoop Cannon", 0, "", 0, "LineageMonster3.toad_cannon", 45, 47.5, 80, "male", "L2SiegeSummon", 80, 50000, 889.8, 8.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 13.83539, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 60, 40, 0, 1), 
(14850, 14850, "Swoop Cannon", 0, "", 0, "LineageMonster3.toad_cannon", 45, 47.5, 80, "male", "L2SiegeSummon", 80, 50000, 889.8, 8.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 13.83539, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 60, 40, 0, 1), 
(14851, 14851, "Swoop Cannon", 0, "", 0, "LineageMonster3.toad_cannon", 45, 47.5, 80, "male", "L2SiegeSummon", 80, 50000, 889.8, 8.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 13.83539, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 60, 40, 0, 1), 
(14852, 14852, "Swoop Cannon", 0, "", 0, "LineageMonster3.toad_cannon", 45, 47.5, 81, "male", "L2SiegeSummon", 80, 50000, 889.8, 8.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 14.37969, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 60, 40, 0, 1), 
(14853, 14853, "Swoop Cannon", 0, "", 0, "LineageMonster3.toad_cannon", 45, 47.5, 81, "male", "L2SiegeSummon", 80, 50000, 889.8, 8.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 14.37969, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 60, 40, 0, 1), 
(14854, 14854, "Swoop Cannon", 0, "", 0, "LineageMonster3.toad_cannon", 45, 47.5, 81, "male", "L2SiegeSummon", 80, 50000, 889.8, 8.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 14.37969, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 60, 40, 0, 1), 
(14855, 14855, "Swoop Cannon", 0, "", 0, "LineageMonster3.toad_cannon", 45, 47.5, 81, "male", "L2SiegeSummon", 80, 50000, 889.8, 8.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 14.92399, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 60, 40, 0, 1), 
(14856, 14856, "Swoop Cannon", 0, "", 0, "LineageMonster3.toad_cannon", 45, 47.5, 82, "male", "L2SiegeSummon", 80, 50000, 889.8, 8.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 14.92399, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 60, 40, 0, 1), 
(14857, 14857, "Swoop Cannon", 0, "", 0, "LineageMonster3.toad_cannon", 45, 47.5, 82, "male", "L2SiegeSummon", 80, 50000, 889.8, 8.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 14.92399, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 60, 40, 0, 1), 
(14858, 14858, "Swoop Cannon", 0, "", 0, "LineageMonster3.toad_cannon", 45, 47.5, 82, "male", "L2SiegeSummon", 80, 50000, 889.8, 8.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 15.3767, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 60, 40, 0, 1), 
(14859, 14859, "Swoop Cannon", 0, "", 0, "LineageMonster3.toad_cannon", 45, 47.5, 82, "male", "L2SiegeSummon", 80, 50000, 889.8, 8.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 15.3767, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 60, 40, 0, 1), 
(14860, 14860, "Swoop Cannon", 0, "", 0, "LineageMonster3.toad_cannon", 45, 47.5, 83, "male", "L2SiegeSummon", 80, 50000, 889.8, 8.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 15.3767, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 60, 40, 0, 1), 
(14861, 14861, "Swoop Cannon", 0, "", 0, "LineageMonster3.toad_cannon", 45, 47.5, 83, "male", "L2SiegeSummon", 80, 50000, 889.8, 8.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 15.91784, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 60, 40, 0, 1), 
(14862, 14862, "Swoop Cannon", 0, "", 0, "LineageMonster3.toad_cannon", 45, 47.5, 83, "male", "L2SiegeSummon", 80, 50000, 889.8, 8.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 15.91784, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 60, 40, 0, 1), 
(14863, 14863, "Swoop Cannon", 0, "", 0, "LineageMonster3.toad_cannon", 45, 47.5, 83, "male", "L2SiegeSummon", 80, 50000, 889.8, 8.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 15.91784, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 60, 40, 0, 1), 
(14864, 14864, "Swoop Cannon", 0, "", 0, "LineageMonster3.toad_cannon", 45, 47.5, 84, "male", "L2SiegeSummon", 80, 50000, 889.8, 8.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 15.91784, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 60, 40, 0, 1), 
(14865, 14865, "Swoop Cannon", 0, "", 0, "LineageMonster3.toad_cannon", 45, 47.5, 84, "male", "L2SiegeSummon", 80, 50000, 889.8, 8.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 16.45892, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 60, 40, 0, 1), 
(14866, 14866, "Swoop Cannon", 0, "", 0, "LineageMonster3.toad_cannon", 45, 47.5, 84, "male", "L2SiegeSummon", 80, 50000, 889.8, 8.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 16.45892, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 60, 40, 0, 1), 
(14867, 14867, "Swoop Cannon", 0, "", 0, "LineageMonster3.toad_cannon", 45, 47.5, 85, "male", "L2SiegeSummon", 80, 50000, 889.8, 8.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 16.45892, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 60, 40, 0, 1), 
(14868, 14868, "Swoop Cannon", 0, "", 0, "LineageMonster3.toad_cannon", 45, 47.5, 85, "male", "L2SiegeSummon", 80, 50000, 889.8, 8.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 16.45892, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 60, 40, 0, 1), 
(14869, 14869, "Swoop Cannon", 0, "", 0, "LineageMonster3.toad_cannon", 45, 47.5, 85, "male", "L2SiegeSummon", 80, 50000, 889.8, 8.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 17, 837, 265.02979, 674, 150, 4, 333, 0, 0, 0, 60, 40, 0, 1), 
(14870, 14870, "Divine Beast", 0, "", 0, "LineageMonster4.Divine_beast", 23, 15.5, 80, "male", "L2Pet", 40, 2880.37628, 1674.8, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 894.75854, 341.375, 611.00409, 249.80341, 253, 4, 333, 0, 0, 0, 40, 180, 0, 1), 
(14871, 14871, "Feline King", 0, "", 0, "LineageMonster3.king_of_cat", 6, 16.01, 81, "male", "L2Pet", 40, 2892.793545, 1687.813333, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 901.37483, 342.91014, 615.52216, 250.92676, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14872, 14872, "Feline King", 0, "", 0, "LineageMonster3.king_of_cat", 6, 16.01, 81, "male", "L2Pet", 40, 2905.21081, 1700.826667, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 907.99112, 344.44528, 620.04023, 252.05011, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14873, 14873, "Feline King", 0, "", 0, "LineageMonster3.king_of_cat", 6, 16.01, 81, "male", "L2Pet", 40, 2917.628075, 1713.84, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 914.60741, 345.98042, 624.55829, 253.17345, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14874, 14874, "Feline King", 0, "", 0, "LineageMonster3.king_of_cat", 6, 16.01, 82, "male", "L2Pet", 40, 2930.04534, 1726.853333, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 921.2237, 347.51555, 629.07636, 254.2968, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14875, 14875, "Feline King", 0, "", 0, "LineageMonster3.king_of_cat", 6, 16.01, 82, "male", "L2Pet", 40, 2942.462606, 1739.866667, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 927.83998, 349.05069, 633.59443, 255.42015, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14876, 14876, "Feline King", 0, "", 0, "LineageMonster3.king_of_cat", 6, 16.01, 82, "male", "L2Pet", 40, 2954.879871, 1752.88, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 934.45627, 350.58583, 638.1125, 256.5435, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14877, 14877, "Feline King", 0, "", 0, "LineageMonster3.king_of_cat", 6, 16.01, 83, "male", "L2Pet", 40, 2967.297136, 1765.893333, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 941.07256, 352.12097, 642.63056, 257.66684, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14878, 14878, "Feline King", 0, "", 0, "LineageMonster3.king_of_cat", 6, 16.01, 83, "male", "L2Pet", 40, 2979.714401, 1778.906667, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 947.68885, 353.65611, 647.14863, 258.79019, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14879, 14879, "Feline King", 0, "", 0, "LineageMonster3.king_of_cat", 6, 16.01, 83, "male", "L2Pet", 40, 2992.131666, 1791.92, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 954.30514, 355.19125, 651.6667, 259.91354, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14880, 14880, "Feline King", 0, "", 0, "LineageMonster3.king_of_cat", 6, 16.01, 84, "male", "L2Pet", 40, 3004.548931, 1804.933333, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 960.92143, 356.72639, 656.18477, 261.03689, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14881, 14881, "Feline King", 0, "", 0, "LineageMonster3.king_of_cat", 6, 16.01, 84, "male", "L2Pet", 40, 3016.966196, 1817.946667, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 967.53772, 358.26153, 660.70284, 262.16024, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14882, 14882, "Feline King", 0, "", 0, "LineageMonster3.king_of_cat", 6, 16.01, 84, "male", "L2Pet", 40, 3029.383461, 1830.96, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 974.15401, 359.79666, 665.2209, 263.28358, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14883, 14883, "Feline King", 0, "", 0, "LineageMonster3.king_of_cat", 6, 16.01, 85, "male", "L2Pet", 40, 3041.800726, 1843.973333, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 980.7703, 361.3318, 669.73897, 264.40693, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14884, 14884, "Feline King", 0, "", 0, "LineageMonster3.king_of_cat", 6, 16.01, 85, "male", "L2Pet", 40, 3054.217992, 1856.986667, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 987.38658, 362.86694, 674.25704, 265.53028, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14885, 14885, "Feline King", 0, "", 0, "LineageMonster3.king_of_cat", 6, 16.01, 85, "male", "L2Pet", 40, 3066.635257, 1870, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 994.00287, 364.40208, 678.77511, 266.65363, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14886, 14886, "Magnus the Unicorn", 0, "", 0, "LineageMonster3.unicorn_magnus", 13.5, 17, 81, "male", "L2Pet", 40, 2892.793545, 1687.813333, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 901.37483, 342.91014, 615.52216, 250.92676, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14887, 14887, "Magnus the Unicorn", 0, "", 0, "LineageMonster3.unicorn_magnus", 13.5, 17, 81, "male", "L2Pet", 40, 2905.21081, 1700.826667, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 907.99112, 344.44528, 620.04023, 252.05011, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14888, 14888, "Magnus the Unicorn", 0, "", 0, "LineageMonster3.unicorn_magnus", 13.5, 17, 81, "male", "L2Pet", 40, 2917.628075, 1713.84, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 914.60741, 345.98042, 624.55829, 253.17345, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14889, 14889, "Magnus the Unicorn", 0, "", 0, "LineageMonster3.unicorn_magnus", 13.5, 17, 82, "male", "L2Pet", 40, 2930.04534, 1726.853333, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 921.2237, 347.51555, 629.07636, 254.2968, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14890, 14890, "Magnus the Unicorn", 0, "", 0, "LineageMonster3.unicorn_magnus", 13.5, 17, 82, "male", "L2Pet", 40, 2942.462606, 1739.866667, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 927.83998, 349.05069, 633.59443, 255.42015, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14891, 14891, "Magnus the Unicorn", 0, "", 0, "LineageMonster3.unicorn_magnus", 13.5, 17, 82, "male", "L2Pet", 40, 2954.879871, 1752.88, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 934.45627, 350.58583, 638.1125, 256.5435, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14892, 14892, "Magnus the Unicorn", 0, "", 0, "LineageMonster3.unicorn_magnus", 13.5, 17, 83, "male", "L2Pet", 40, 2967.297136, 1765.893333, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 941.07256, 352.12097, 642.63056, 257.66684, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14893, 14893, "Magnus the Unicorn", 0, "", 0, "LineageMonster3.unicorn_magnus", 13.5, 17, 83, "male", "L2Pet", 40, 2979.714401, 1778.906667, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 947.68885, 353.65611, 647.14863, 258.79019, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14894, 14894, "Magnus the Unicorn", 0, "", 0, "LineageMonster3.unicorn_magnus", 13.5, 17, 83, "male", "L2Pet", 40, 2992.131666, 1791.92, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 954.30514, 355.19125, 651.6667, 259.91354, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14895, 14895, "Magnus the Unicorn", 0, "", 0, "LineageMonster3.unicorn_magnus", 13.5, 17, 84, "male", "L2Pet", 40, 3004.548931, 1804.933333, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 960.92143, 356.72639, 656.18477, 261.03689, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14896, 14896, "Magnus the Unicorn", 0, "", 0, "LineageMonster3.unicorn_magnus", 13.5, 17, 84, "male", "L2Pet", 40, 3016.966196, 1817.946667, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 967.53772, 358.26153, 660.70284, 262.16024, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14897, 14897, "Magnus the Unicorn", 0, "", 0, "LineageMonster3.unicorn_magnus", 13.5, 17, 84, "male", "L2Pet", 40, 3029.383461, 1830.96, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 974.15401, 359.79666, 665.2209, 263.28358, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14898, 14898, "Magnus the Unicorn", 0, "", 0, "LineageMonster3.unicorn_magnus", 13.5, 17, 85, "male", "L2Pet", 40, 3041.800726, 1843.973333, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 980.7703, 361.3318, 669.73897, 264.40693, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14899, 14899, "Magnus the Unicorn", 0, "", 0, "LineageMonster3.unicorn_magnus", 13.5, 17, 85, "male", "L2Pet", 40, 3054.217992, 1856.986667, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 987.38658, 362.86694, 674.25704, 265.53028, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14900, 14900, "Magnus the Unicorn", 0, "", 0, "LineageMonster3.unicorn_magnus", 13.5, 17, 85, "male", "L2Pet", 40, 3066.635257, 1870, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 994.00287, 364.40208, 678.77511, 266.65363, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14901, 14901, "Spectral Lord", 0, "", 0, "LineageMonster3.spectral_knight", 12.5, 33.5, 81, "male", "L2Pet", 40, 2892.793545, 1687.813333, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 901.37483, 342.91014, 615.52216, 250.92676, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14902, 14902, "Spectral Lord", 0, "", 0, "LineageMonster3.spectral_knight", 12.5, 33.5, 81, "male", "L2Pet", 40, 2905.21081, 1700.826667, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 907.99112, 344.44528, 620.04023, 252.05011, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14903, 14903, "Spectral Lord", 0, "", 0, "LineageMonster3.spectral_knight", 12.5, 33.5, 81, "male", "L2Pet", 40, 2917.628075, 1713.84, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 914.60741, 345.98042, 624.55829, 253.17345, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14904, 14904, "Spectral Lord", 0, "", 0, "LineageMonster3.spectral_knight", 12.5, 33.5, 82, "male", "L2Pet", 40, 2930.04534, 1726.853333, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 921.2237, 347.51555, 629.07636, 254.2968, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14905, 14905, "Spectral Lord", 0, "", 0, "LineageMonster3.spectral_knight", 12.5, 33.5, 82, "male", "L2Pet", 40, 2942.462606, 1739.866667, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 927.83998, 349.05069, 633.59443, 255.42015, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14906, 14906, "Spectral Lord", 0, "", 0, "LineageMonster3.spectral_knight", 12.5, 33.5, 82, "male", "L2Pet", 40, 2954.879871, 1752.88, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 934.45627, 350.58583, 638.1125, 256.5435, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14907, 14907, "Spectral Lord", 0, "", 0, "LineageMonster3.spectral_knight", 12.5, 33.5, 83, "male", "L2Pet", 40, 2967.297136, 1765.893333, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 941.07256, 352.12097, 642.63056, 257.66684, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14908, 14908, "Spectral Lord", 0, "", 0, "LineageMonster3.spectral_knight", 12.5, 33.5, 83, "male", "L2Pet", 40, 2979.714401, 1778.906667, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 947.68885, 353.65611, 647.14863, 258.79019, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14909, 14909, "Spectral Lord", 0, "", 0, "LineageMonster3.spectral_knight", 12.5, 33.5, 83, "male", "L2Pet", 40, 2992.131666, 1791.92, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 954.30514, 355.19125, 651.6667, 259.91354, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14910, 14910, "Spectral Lord", 0, "", 0, "LineageMonster3.spectral_knight", 12.5, 33.5, 84, "male", "L2Pet", 40, 3004.548931, 1804.933333, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 960.92143, 356.72639, 656.18477, 261.03689, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14911, 14911, "Spectral Lord", 0, "", 0, "LineageMonster3.spectral_knight", 12.5, 33.5, 84, "male", "L2Pet", 40, 3016.966196, 1817.946667, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 967.53772, 358.26153, 660.70284, 262.16024, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14912, 14912, "Spectral Lord", 0, "", 0, "LineageMonster3.spectral_knight", 12.5, 33.5, 84, "male", "L2Pet", 40, 3029.383461, 1830.96, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 974.15401, 359.79666, 665.2209, 263.28358, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14913, 14913, "Spectral Lord", 0, "", 0, "LineageMonster3.spectral_knight", 12.5, 33.5, 85, "male", "L2Pet", 40, 3041.800726, 1843.973333, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 980.7703, 361.3318, 669.73897, 264.40693, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14914, 14914, "Spectral Lord", 0, "", 0, "LineageMonster3.spectral_knight", 12.5, 33.5, 85, "male", "L2Pet", 40, 3054.217992, 1856.986667, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 987.38658, 362.86694, 674.25704, 265.53028, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14915, 14915, "Spectral Lord", 0, "", 0, "LineageMonster3.spectral_knight", 12.5, 33.5, 85, "male", "L2Pet", 40, 3066.635257, 1870, 8.5, 6, 40, 43, 30, 21, 20, 25, 0, 0, 994.00287, 364.40208, 678.77511, 266.65363, 253, 4, 333, 0, 0, 0, 160, 180, 0, 1), 
(14916, 14916, "Tigress", 0, "", 0, "LineageMonster.saber_toothed_tiger_070p", 22, 18.4, 61, "male", "L2Pet", 40, 1985.55926, 1066.8, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 501.08068, 252.49346, 342.17315, 184.76376, 253, 4, 333, 0, 0, 0, 47, 170, 0, 1), 
(14917, 14917, "Tigress", 0, "", 0, "LineageMonster.saber_toothed_tiger_070p", 22, 18.4, 61, "male", "L2Pet", 40, 1985.55926, 1066.8, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 501.08068, 252.49346, 342.17315, 184.76376, 253, 4, 333, 0, 0, 0, 47, 170, 0, 1), 
(14918, 14918, "Imperial Phoenix", 0, "", 0, "LineageMonster4.phoenix", 7, 34, 83, "female", "L2Pet", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 25, 0, 0, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), 
(16013, 16013, "Trained Buffalo", 0, "", 0, "LineageMonster2.buffalo", 22, 31, 67, "male", "L2TamedBeast", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 624.93199, 281.55251, 426.74754, 206.02791, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(16014, 16014, "Trained Buffalo", 0, "", 0, "LineageMonster2.buffalo", 22, 31, 67, "male", "L2TamedBeast", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 624.93199, 281.55251, 426.74754, 206.02791, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(16015, 16015, "Trained Cougar", 0, "", 0, "LineageMonster.saber_toothed_tiger", 34, 28, 69, "male", "L2TamedBeast", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 667.50361, 291.15063, 455.81844, 213.05139, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(16016, 16016, "Trained Cougar", 0, "", 0, "LineageMonster.saber_toothed_tiger", 34, 28, 69, "male", "L2TamedBeast", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 667.50361, 291.15063, 455.81844, 213.05139, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(16017, 16017, "Trained Kookaburra", 0, "", 0, "LineageMonster2.pet_ostrich", 10, 33, 65, "male", "L2TamedBeast", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 582.81759, 271.89033, 397.98887, 198.95754, 253, 4, 333, 0, 0, 0, 23, 120, 0, 1), 
(16018, 16018, "Trained Kookaburra", 0, "", 0, "LineageMonster2.pet_ostrich", 10, 33, 65, "male", "L2TamedBeast", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 0, 0, 582.81759, 271.89033, 397.98887, 198.95754, 253, 4, 333, 0, 0, 0, 23, 120, 0, 1), 
(16019, 16019, "Tiny Baby Buffalo", 0, "", 0, "LineageMonster2.baby_buffalo", 12, 15, 67, "male", "L2Monster", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 2146, 200, 624.93199, 281.55251, 426.74754, 206.02791, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(16020, 16020, "Tame Tiny Baby Buffalo", 0, "", 0, "LineageMonster2.baby_buffalo", 12, 15, 67, "male", "L2Monster", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 2146, 200, 624.93199, 281.55251, 426.74754, 206.02791, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(16021, 16021, "Tiny Baby Cougar", 0, "", 0, "LineageMonster2.baby_tiger", 11, 15.7, 69, "male", "L2Monster", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 2276, 218, 667.50361, 291.15063, 455.81844, 213.05139, 253, 4, 333, 0, 0, 0, 28, 120, 0, 1), 
(16022, 16022, "Tame Tiny Baby Cougar", 0, "", 0, "LineageMonster2.baby_tiger", 11, 15.7, 69, "male", "L2Monster", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 2276, 218, 667.50361, 291.15063, 455.81844, 213.05139, 253, 4, 333, 0, 0, 0, 28, 120, 0, 1), 
(16023, 16023, "Tiny Baby Kookaburra", 0, "", 0, "LineageMonster2.baby_ostrich", 7, 15, 65, "male", "L2Monster", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 2020, 183, 582.81759, 271.89033, 397.98887, 198.95754, 253, 4, 333, 0, 0, 0, 13, 120, 0, 1), 
(16024, 16024, "Tame Tiny Baby Kookaburra", 0, "", 0, "LineageMonster2.baby_ostrich", 7, 15, 65, "male", "L2Monster", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 25, 2020, 183, 582.81759, 271.89033, 397.98887, 198.95754, 253, 4, 333, 0, 0, 0, 13, 120, 0, 1), 
(16025, 16025, "Great Wolf", 0, "", 0, "LineageMonster4.Pet_Wolf_B", 32, 21.41, 55, "male", "L2Pet", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 45, 170, 0, 1), -- TODO: Stats require check
(16026, 16026, "Beastly Agathion", 0, "", 0, "LineageNPC2.Agathion_BF", 0.01, 11.3, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(16027, 16027, "Rainbow Agathion", 0, "", 0, "LineageNPC2.Agathion_RA", 0.01, 6.7, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(16028, 16028, "Lord Agathion", 0, "", 0, "LineageNPC2.Agathion_CL", 0.01, 9.5, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(16029, 16029, "Fortress Agathion", 0, "", 0, "LineageNPC2.Agathion_FT", 0.01, 3.5, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(16030, 16030, "Great Wolf", 0, "", 0, "LineageMonster4.Pet_Wolf_Ba", 25, 21.41, 55, "male", "L2Pet", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 45, 170, 0, 1), -- TODO: Stats require check
(16031, 16031, "Little Angel Agathion", 0, "", 0, "LineageNpc2.Agathion_ag", 0.01, 4.55, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(16032, 16032, "Little Devil Agathion", 0, "", 0, "LineageNpc2.Agathion_st", 0.01, 5.5, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(16033, 16033, "Rudolph Agathion", 0, "", 0, "LineageNpc2.Agathion_rd", 0.01, 5.27, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(16034, 16034, "Improved Baby Buffalo", 0, "", 0, "LineageMonster2.baby_buffalo", 12, 15, 55, "male", "L2BabyPet", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 30, 170, 0, 1), -- TODO: Stats require check
(16035, 16035, "Improved Baby Kookaburra", 0, "", 0, "LineageMonster2.baby_ostrich", 7, 15, 55, "male", "L2BabyPet", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 13, 170, 0, 1), -- TODO: Stats require check
(16036, 16036, "Improved Baby Cougar", 0, "", 0, "LineageMonster2.baby_tiger", 11, 15.7, 55, "male", "L2BabyPet", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 28, 170, 0, 1), -- TODO: Stats require check
(16037, 16037, "Great Snow Wolf", 0, "", 0, "LineageMonster4.Pet_Wolf_Ba", 25, 21.41, 55, "male", "L2Pet", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 45, 170, 0, 1), -- TODO: Stats require check
(16038, 16038, "Red Wind Strider", 0, "", 0, "LineageMonster.strider", 23, 31, 55, "male", "L2Pet", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), -- TODO: Stats require check
(16039, 16039, "Red Star Strider", 0, "", 0, "LineageMonster.strider", 23, 31, 55, "male", "L2Pet", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), -- TODO: Stats require check
(16040, 16040, "Red Twilight Strider", 0, "", 0, "LineageMonster.strider", 23, 31, 55, "male", "L2Pet", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), -- TODO: Stats require check
(16041, 16041, "Fenrir", 0, "", 0, "LineageMonster4.Pet_Wolf_Ba", 25, 21.41, 55, "male", "L2Pet", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 45, 170, 0, 1), -- TODO: Stats require check
(16042, 16042, "Snow Fenrir", 0, "", 0, "LineageMonster4.Pet_Wolf_Ba", 25, 21.41, 55, "male", "L2Pet", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 45, 170, 0, 1), -- TODO: Stats require check
(16043, 16043, "Fox Shaman", 0, "", 0, "LineageMonster4.foxian_wizard_pet", 10, 18.5, 55, "male", "L2Pet", 40, 1673.05473, 889.8, 6.5, 2.4, 35, 37, 30, 32, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 35, 170, 0, 1), 
(16044, 16044, "Wild Beast Fighter", 0, "", 0, "LineageMonster4.beast_fighter_pet", 11, 16.5, 55, "male", "L2Pet", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 22, 170, 0, 1), -- TODO: Stats require check
(16045, 16045, "White Weasel", 0, "", 0, "LineageMonster4.ferret_pet", 6.5, 12.5, 55, "male", "L2BabyPet", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 30, 170, 0, 1), -- TODO: Stats require check
(16046, 16046, "Fairy Princess", 0, "", 0, "LineageMonster4.fairy_princess_pet", 10, 15, 55, "male", "L2BabyPet", 40, 1673.05473, 889.8, 6.5, 2.4, 35, 37, 30, 32, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 35, 170, 0, 1), 
(16049, 16049, "Love Agathion", 0, "", 0, "LineageNpc2.agathion_love", 5, 3.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(16050, 16050, "Owl Monk", 0, "", 0, "LineageMonster4.owl_wizard_the_pet", 13, 19.5, 55, "female", "L2Pet", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), -- TODO: Stats require check
(16051, 16051, "Spirit Shaman", 0, "", 0, "LineageMonster4.sprit_magician_the_pet", 12.8, 15.6, 55, "male", "L2BabyPet", 40, 1673.05473, 889.8, 6.5, 2.4, 35, 37, 30, 32, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(16052, 16052, "Toy Knight", 0, "", 0, "LineageMonster4.toy_knight_the_pet", 10, 15, 55, "male", "L2BabyPet", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(16053, 16053, "Turtle Ascetic", 0, "", 0, "LineageMonster4.turtle_buffer_the_pet", 11, 10, 55, "male", "L2BabyPet", 40, 1673.05473, 889.8, 6.5, 2.4, 38, 40, 30, 26, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 20, 180, 0, 1), 
(16054, 16054, "Monkey", 0, "", 0, "LineageNpc2.agathion_mk", 15, 7, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(16055, 16055, "Griffon", 0, "", 0, "LineageNpc2.agathion_gr", 5, 5.5, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(16056, 16056, "Joy", 0, "", 0, "LineageNpc2.agathion_happy", 6.5, 6.5, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(16057, 16057, "Sorrow", 0, "", 0, "LineageNpc2.agathion_sorrow", 5, 5, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(16058, 16058, "Anger", 0, "", 0, "LineageNpc2.agathion_anger", 3, 3, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), -- TODO: Stats require check
(16059, 16059, "Boy Bear", 0, "", 0, "LineageNPC2.teddy_bear_boy", 3, 7, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 50, 180, 0, 1), -- TODO: Stats require check
(16060, 16060, "Girl Bear", 0, "", 0, "LineageNPC2.teddy_bear_girl", 3, 7, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 50, 180, 0, 1), -- TODO: Stats require check
(16061, 16061, "Collection Device", 0, "", 0, "LineageNPC2.collecting_golem", 5.5, 6.25, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 50, 180, 0, 1), -- TODO: Stats require check
(16062, 16062, "Knight", 0, "", 0, "LineageNPC2.agathion_pvp", 4.5, 7, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 25, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 50, 180, 0, 1), -- TODO: Stats require check
(16063, 16063, "Saerom", 0, "", 0, "LineageNPC2.agathion_gift", 3, 5.15, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 50, 180, 0, 1), 
(16064, 16064, "Juju", 0, "", 0, "LineageNPC2.agathion_cupi", 5, 7, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 50, 180, 0, 1), 
(16065, 16065, "Oink Oink", 0, "", 0, "LineageNPC2.agathion_pig", 6, 5.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 50, 180, 0, 1), 
(16066, 16066, "Light of Dawn", 0, "", 0, "LineageNPC2.agathion_pig", 6, 5.75, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 50, 180, 0, 1), 
(16067, 16067, "Deinonychus", 0, "", 0, "LineageMonster3.deinonychus", 14, 14.3, 55, "male", "L2Pet", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 1, 333, 0, 0, 0, 24, 160, 0, 1), 
(16068, 16068, "Guardian's Strider", 0, "", 0, "LineageMonster4.dragon_descendant_2a", 27, 33.5, 55, "male", "L2Pet", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 40, 170, 0, 1), 
(16069, 16069, "Pona", 0, "", 0, "LineageNPC2.agathion_pona", 3, 5.15, 55, "female", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 50, 180, 0, 1), 
(16070, 16070, "Towbat", 0, "", 0, "LineageNPC2.agathion_tow", 4, 5.87, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 50, 180, 0, 1), 
(16071, 16071, "Maguen", 0, "", 0, "LineageMonster5.marguene_pet", 11, 13.25, 55, "male", "L2Pet", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 1, 333, 0, 0, 0, 15, 120, 0, 1), 
(16072, 16072, "Elite Maguen", 0, "", 0, "LineageMonster5.marguene_pet_elite", 11, 13.25, 55, "male", "L2Pet", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 1, 333, 0, 0, 0, 15, 120, 0, 1), 
(16073, 16073, "Rudolph Agathion", 0, "", 0, "LineageNpc2.Agathion_rd", 0.01, 5.27, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), 
(16074, 16074, "Ball Trapping Gnosian", 0, "", 0, "LineageNPC2.br_aga_ball_male", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(16075, 16075, "Ball Trapping Orodriel", 0, "", 0, "LineageNPC2.br_aga_ball_female", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(16076, 16076, "Penalty Kick", 0, "", 0, "LineageNPC2.br_aga_ball_kick", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(16077, 16077, "Antharas", 0, "", 0, "LineageNPC2.agathion_anta", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(16078, 16078, "Nevit's Messenger Kanna", 0, "", 0, "LineageNPC2.agathion_ssq_a", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(16079, 16079, "Guardian of Dawn Kallesin", 0, "", 0, "LineageNPC2.agathion_ssq_b", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(18001, 18001, "Blood Queen", 0, "", 0, "LineageMonster.bloody_queen", 14, 40, 60, "female", "L2Monster", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 4536, 394, 481.34551, 247.65008, 328.69659, 150.02125, 253, 4, 333, 0, 0, 0, 80, 160, 0, 1), 
(18002, 18002, "Blood Queen", 0, "", 0, "LineageMonster.bloody_queen", 14, 40, 60, "female", "L2Monster", 40, 1933.2, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 4320, 375, 529.48, 247.65, 328.7, 150.02159, 253, 4, 333, 0, 0, 0, 80, 160, 0, 1), 
(18003, 18003, "Bearded Keltir", 0, "", 0, "LineageMonster.keltir", 9.5, 10, 1, "male", "L2Monster", 40, 39.7, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 29, 2, 4, 44.44, 5.79, 26.92143, 253, 4, 333, 0, 0, 0, 23, 110, 0, 1), 
(18004, 18004, "Susceptor Prime", 0, "", 0, "LineageMonster.susceptor_prime", 45, 72, 49, "male", "L2Monster", 1100, 1372.2, 720, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 1, 290.45, 195.66, 198.34, 118.53047, 253, 8, 333, 0, 0, 0, 78, 170, 0, 1), 
(18005, 18005, "Mimic", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 52, "male", "L2Monster", 40, 1569.5, 804, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 3245, 251, 348.07, 216.26, 230.26, 126.90823, 253, 4, 333, 0, 0, 0, 80, 156, 0, 1), 
(18006, 18006, "Maruk Lord", 0, "", 0, "LineageMonster.death_blader", 15, 45, 68, "male", "L2Monster", 40, 2421.5, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 6057, 586, 667.04, 295.61, 441.26, 173.47437, 253, 4, 333, 1472, 0, 0, 100, 170, 0, 1), 
(18007, 18007, "Limal Karinness", 0, "", 0, "LineageMonster.bloody_queen", 14, 40, 69, "female", "L2Monster", 40, 2395.5, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 5951, 582, 734.25, 291.15, 501.4, 176.37182, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(18008, 18008, "Karik", 0, "", 0, "LineageMonster.karik", 25, 90, 70, "male", "L2Monster", 40, 2444.5, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 6370, 632, 757.75, 295.92, 517.45, 179.26099, 253, 4, 333, 0, 0, 0, 37, 200, 0, 1), 
(18009, 18009, "Offering of Branded Elder", 0, "", 0, "LineageMonster.orc_fighter_bi", 12, 26.4, 34, "male", "L2FestivalMonster", 40, 736.96177, 387.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1755, 102, 121.20802, 132.9486, 82.76936, 80.53748, 253, 4, 333, 127, 0, 0, 45, 30, 0, 1), 
(18010, 18010, "Offering of the Branded", 0, "", 0, "LineageMonster.orc", 10, 21, 32, "male", "L2FestivalMonster", 40, 668.47132, 358.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1524, 86, 92.89459, 106.74068, 72.49711, 76.07208, 253, 8, 333, 218, 0, 0, 45, 30, 0, 1), 
(18011, 18011, "Offering of Branded Archer", 0, "", 0, "LineageMonster.orc_archer", 14, 25, 28, "male", "L2FestivalMonster", 1100, 543.79576, 300.96, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1001, 53, 178.96112, 94.87163, 54.99876, 67.61324, 253, 8, 333, 14, 0, 0, 45, 60, 0, 1), 
(18012, 18012, "Offering of Branded Warrior", 0, "", 0, "LineageMonster.orc_champion", 10, 23, 29, "male", "L2FestivalMonster", 40, 573.42917, 315.12, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1026, 55, 86.42002, 115.00598, 59.01367, 69.66822, 253, 4, 333, 125, 0, 0, 45, 110, 0, 1), 
(18013, 18013, "Offering of Branded Follower", 0, "", 0, "LineageMonster.orc_shaman", 9, 22, 29, "male", "L2FestivalMonster", 40, 573.42917, 315.12, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1227, 66, 75.61752, 97.75508, 59.01367, 69.66822, 253, 8, 333, 316, 0, 0, 45, 150, 0, 1), 
(18014, 18014, "Offering of Branded Berserker", 0, "", 0, "LineageMonster.virud_lizardman", 10, 23, 37, "male", "L2FestivalMonster", 40, 847.31754, 432.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2277, 140, 146.82587, 144.47758, 100.26304, 87.52151, 253, 4, 333, 292, 0, 0, 43, 115, 0, 1), 
(18015, 18015, "Offering of Branded Zealot", 0, "", 0, "LineageMonster.orc_fighter_bi", 12, 26.4, 34, "male", "L2FestivalMonster", 40, 736.96177, 387.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1651, 96, 106.05702, 113.00631, 82.76936, 80.53748, 253, 8, 333, 158, 0, 0, 45, 155, 0, 1), 
(18016, 18016, "Offering of Branded Marksman", 0, "", 0, "LineageMonster.orc_archer_20_bi", 16, 30, 32, "male", "L2FestivalMonster", 1100, 668.47132, 358.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1266, 71, 235.89919, 106.74068, 72.49711, 76.07208, 253, 8, 333, 273, 0, 0, 45, 130, 0, 1), 
(18017, 18017, "Offering of Branded Disciple", 0, "", 0, "LineageMonster.batur_orc", 9, 21.5, 34, "male", "L2FestivalMonster", 40, 736.96177, 387.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1651, 96, 121.20802, 132.9486, 82.76936, 80.53748, 253, 4, 333, 129, 0, 0, 80, 165, 0, 1), 
(18018, 18018, "Offering of Branded Saint", 0, "", 0, "LineageMonster.batur_orc_20_bi", 10, 25.3, 39, "male", "L2FestivalMonster", 40, 925.85879, 463.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2172, 138, 166.06476, 152.46752, 113.4007, 92.36164, 253, 4, 333, 72, 0, 0, 80, 165, 0, 1), 
(18019, 18019, "Apostate's Offering Elder", 0, "", 0, "LineageMonster.orc_champion_20_bi", 12, 27.6, 45, "male", "L2FestivalMonster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3013, 210, 234.89829, 177.78746, 160.40508, 107.69993, 253, 4, 333, 72, 0, 0, 45, 30, 0, 1), 
(18020, 18020, "Apostate's Offering", 0, "", 0, "LineageMonster.orc_fighter", 12, 22, 43, "male", "L2FestivalMonster", 40, 1094.28943, 557.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 2751, 186, 183.79228, 143.76404, 143.43577, 102.45795, 253, 8, 333, 223, 0, 0, 45, 30, 0, 1), 
(18021, 18021, "Apostate's Offering Archer", 0, "", 0, "LineageMonster.batur_orc_archer", 11, 21.5, 39, "male", "L2FestivalMonster", 1100, 925.85879, 463.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1880, 119, 368.9959, 129.59739, 113.4007, 92.36164, 253, 8, 333, 275, 0, 0, 45, 60, 0, 1), 
(18022, 18022, "Apostate's Offering Warrior", 0, "", 0, "LineageMonster.batur_orc_warrior", 10, 20, 40, "male", "L2FestivalMonster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1920, 124, 176.36077, 156.55035, 120.43155, 94.83493, 253, 4, 333, 127, 0, 0, 80, 115, 0, 1), 
(18023, 18023, "Apostate's Offering Follower", 0, "", 0, "LineageMonster.batur_orc_shaman", 11, 16, 40, "male", "L2FestivalMonster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2296, 148, 154.31567, 133.0678, 120.43155, 94.83493, 253, 8, 333, 316, 0, 0, 50, 155, 0, 1), 
(18024, 18024, "Apostate's Offering Berserker", 0, "", 0, "LineageMonster.zenta_lizardman", 11, 32, 48, "male", "L2FestivalMonster", 40, 1324.01623, 692.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3832, 280, 275.82705, 191.12803, 188.35412, 115.78137, 253, 4, 333, 297, 0, 0, 37, 120, 0, 1), 
(18025, 18025, "Apostate's Offering Zealot", 0, "", 0, "LineageMonster.batur_orc_20_bi", 10, 25.3, 45, "male", "L2FestivalMonster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 2892, 201, 205.536, 151.11934, 160.40508, 107.69993, 253, 8, 333, 172, 0, 0, 80, 160, 0, 1), 
(18026, 18026, "Apostate's Offering Marksman", 0, "", 0, "LineageMonster.batur_orc_archer_20_bi", 13, 25.3, 43, "male", "L2FestivalMonster", 1100, 1094.28943, 557.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 2285, 154, 466.72737, 143.76404, 143.43577, 102.45795, 253, 8, 333, 277, 0, 0, 45, 135, 0, 1), 
(18027, 18027, "Apostate's Offering Disciple", 0, "", 0, "LineageMonster.batur_orc_overlord", 12, 24, 45, "male", "L2FestivalMonster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 2892, 201, 234.89829, 177.78746, 160.40508, 107.69993, 253, 4, 333, 74, 0, 0, 80, 170, 0, 1), 
(18028, 18028, "Apostate's Offering Saint", 0, "", 0, "LineageMonster.batur_orc_overlord_20_bi", 14, 28.8, 50, "male", "L2FestivalMonster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3570, 269, 305.54906, 200.23844, 208.6504, 121.30026, 253, 4, 333, 133, 0, 0, 80, 170, 0, 1), 
(18029, 18029, "Witch's Offering Elder", 0, "", 0, "LineageMonster.batur_orc_warrior_20_bi", 12, 24, 56, "male", "L2FestivalMonster", 40, 1724.6831, 918.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 4666, 383, 405.96455, 228.40135, 277.22116, 138.36077, 253, 4, 333, 133, 0, 0, 80, 30, 0, 1), 
(18030, 18030, "Witch's Offering", 0, "", 0, "LineageMonster.batur_orc", 9, 21.5, 54, "male", "L2FestivalMonster", 40, 1621.75618, 861, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 4339, 346, 324.35291, 186.06151, 253.13256, 132.60256, 253, 8, 333, 226, 0, 0, 80, 30, 0, 1), 
(18031, 18031, "Witch's Offering Archer", 0, "", 0, "LineageMonster.batur_orc_archer", 11, 21.5, 50, "male", "L2FestivalMonster", 1100, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3090, 233, 678.93001, 170.20267, 208.6504, 121.30026, 253, 8, 333, 278, 0, 0, 45, 70, 0, 1), 
(18032, 18032, "Witch's Offering Warrior", 0, "", 0, "LineageMonster.batur_orc_warrior", 10, 20, 51, "male", "L2FestivalMonster", 40, 1470.41596, 775.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 3121, 238, 321.13207, 204.85194, 219.29157, 124.09503, 253, 4, 333, 72, 0, 0, 80, 120, 0, 1), 
(18033, 18033, "Witch's Offering Follower", 0, "", 0, "LineageMonster.batur_orc_shaman", 11, 16, 51, "male", "L2FestivalMonster", 40, 1470.41596, 775.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 3733, 285, 280.99056, 174.12415, 219.29157, 124.09503, 253, 8, 333, 316, 0, 0, 50, 160, 0, 1), 
(18034, 18034, "Witch's Offering Berserker", 0, "", 0, "LineageMonster.virud_lizardman_warrior", 12, 30, 59, "male", "L2FestivalMonster", 40, 1880.92519, 1007, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 5790, 495, 461.94387, 242.81593, 315.44778, 147.09282, 253, 4, 333, 301, 0, 0, 52, 125, 0, 1), 
(18035, 18035, "Witch's Offering Zealot", 0, "", 0, "LineageMonster.batur_orc_20_bi", 10, 25.3, 56, "male", "L2FestivalMonster", 40, 1724.6831, 918.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 4478, 368, 355.21898, 194.14115, 277.22116, 138.36077, 253, 8, 333, 91, 0, 0, 80, 165, 0, 1), 
(18036, 18036, "Witch's Offering Marksman", 0, "", 0, "LineageMonster.batur_orc_archer_20_bi", 13, 25.3, 54, "male", "L2FestivalMonster", 1100, 1621.75618, 861, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 3604, 287, 823.67105, 186.06151, 253.13256, 132.60256, 253, 8, 333, 282, 0, 0, 45, 140, 0, 1), 
(18037, 18037, "Witch's Offering Disciple", 0, "", 0, "LineageMonster.batur_orc_overlord", 12, 24, 56, "male", "L2FestivalMonster", 40, 1724.6831, 918.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 4478, 368, 405.96455, 228.40135, 277.22116, 138.36077, 253, 4, 333, 135, 0, 0, 80, 175, 0, 1), 
(18038, 18038, "Witch's Offering Saint", 0, "", 0, "LineageMonster.batur_orc_overlord_20_bi", 14, 28.8, 61, "male", "L2FestivalMonster", 40, 1985.55926, 1066.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 5314, 468, 501.08068, 252.49346, 342.17315, 152.95527, 253, 4, 333, 79, 0, 0, 80, 175, 0, 1), 
(18039, 18039, "Dark Omen Offering Elder", 0, "", 0, "LineageMonster.batur_orc_warrior_20_bi", 12, 24, 67, "male", "L2FestivalMonster", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 6680, 636, 624.93199, 281.55251, 426.74754, 170.55863, 253, 4, 333, 79, 0, 0, 80, 30, 0, 1), 
(18040, 18040, "Dark Omen Offering", 0, "", 0, "LineageMonster.batur_orc", 9, 21.5, 65, "male", "L2FestivalMonster", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 6287, 584, 509.96539, 231.10678, 397.98887, 164.70548, 253, 8, 333, 234, 0, 0, 80, 30, 0, 1), 
(18041, 18041, "Dark Omen Offering Archer", 0, "", 0, "LineageMonster.batur_orc_archer", 11, 21.5, 61, "male", "L2FestivalMonster", 1100, 1985.55926, 1066.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 4599, 405, 1113.40127, 214.61944, 342.17315, 152.95527, 253, 8, 333, 283, 0, 0, 45, 70, 0, 1), 
(18042, 18042, "Dark Omen Offering Warrior", 0, "", 0, "LineageMonster.batur_orc_warrior", 10, 20, 62, "male", "L2FestivalMonster", 40, 2037.81082, 1097, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 4613, 411, 521.12391, 257.34267, 355.86007, 155.89282, 253, 4, 333, 133, 0, 0, 80, 125, 0, 1), 
(18043, 18043, "Dark Omen Offering Follower", 0, "", 0, "LineageMonster.batur_orc_shaman", 11, 16, 62, "male", "L2FestivalMonster", 40, 2037.81082, 1097, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 5517, 492, 455.98342, 218.74127, 355.86007, 155.89282, 253, 8, 333, 316, 0, 0, 50, 165, 0, 1), 
(18044, 18044, "Dark Omen Offering Berserker", 0, "", 0, "LineageMonster.virud_lizardman_warrior", 12, 30, 70, "male", "L2FestivalMonster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 8150, 808, 688.86373, 295.91597, 470.40463, 179.25972, 253, 4, 333, 97, 0, 0, 52, 130, 0, 1), 
(18045, 18045, "Dark Omen Offering Zealot", 0, "", 0, "LineageMonster.batur_orc_20_bi", 10, 25.3, 67, "male", "L2FestivalMonster", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 6410, 610, 546.81549, 239.31963, 426.74754, 170.55863, 253, 8, 333, 2503, 0, 0, 80, 170, 0, 1), 
(18046, 18046, "Dark Omen Offering Marksman", 0, "", 0, "LineageMonster.batur_orc_archer_20_bi", 13, 25.3, 65, "male", "L2FestivalMonster", 1100, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 5222, 485, 1295.02068, 231.10678, 397.98887, 164.70548, 253, 8, 333, 286, 0, 0, 45, 145, 0, 1), 
(18047, 18047, "Dark Omen Offering Disciple", 0, "", 0, "LineageMonster.batur_orc_overlord", 12, 24, 67, "male", "L2FestivalMonster", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 6410, 610, 624.93199, 281.55251, 426.74754, 170.55863, 253, 4, 333, 142, 0, 0, 80, 180, 0, 1), 
(18048, 18048, "Dark Omen Offering Saint", 0, "", 0, "LineageMonster.batur_orc_overlord_20_bi", 14, 28.8, 72, "male", "L2FestivalMonster", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 7403, 752, 731.52506, 305.35947, 499.53679, 184.98039, 253, 4, 333, 2500, 0, 0, 80, 180, 0, 1), 
(18049, 18049, "Offering of Forbidden Path Elder", 0, "", 0, "LineageMonster.batur_orc_overlord_20_bi", 14, 28.8, 78, "male", "L2FestivalMonster", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 9053, 991, 855.81387, 332.70061, 584.40994, 201.54308, 253, 4, 333, 2500, 0, 0, 80, 30, 0, 1), 
(18050, 18050, "Offering of Forbidden Path", 0, "", 0, "LineageMonster.batur_orc_warrior", 10, 20, 76, "male", "L2FestivalMonster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 8595, 919, 713.45002, 275.21687, 556.793, 196.14192, 253, 8, 333, 236, 0, 0, 80, 30, 0, 1), 
(18051, 18051, "Offering of Forbidden Path Archer", 0, "", 0, "LineageMonster.ketra_orc_archer", 12, 27, 78, "male", "L2FestivalMonster", 1100, 3010.892998, 1777.86, 8.772, 3.0906, 40, 43, 30, 21, 20, 20, 8311, 955, 2225.9562, 314.47515, 705.71213, 224.12052, 253, 8, 333, 287, 0, 0, 45, 70, 0, 1), 
(18052, 18052, "Offering of Forbidden Path Warrior", 0, "", 0, "LineageMonster.ketra_orc_warrior", 12, 24, 78, "male", "L2FestivalMonster", 40, 2937.983806, 1708.296, 8.67, 3.06, 40, 43, 30, 21, 20, 20, 7680, 862, 912.65371, 348.2025, 635.68866, 210.9338, 253, 4, 333, 79, 0, 0, 36, 130, 0, 1), 
(18053, 18053, "Offering of Forbidden Path Follower", 0, "", 0, "LineageMonster.ketra_orc_shaman", 10, 23, 78, "male", "L2FestivalMonster", 40, 2937.983806, 1708.296, 8.67, 3.06, 40, 43, 30, 21, 20, 20, 9185, 1031, 798.572, 295.97213, 635.68866, 210.9338, 253, 8, 333, 316, 0, 0, 10, 180, 0, 1), 
(18054, 18054, "Offering of Forbidden Path Berserker", 0, "", 0, "LineageMonster.zenta_lizardman_warrior", 13, 35, 78, "male", "L2FestivalMonster", 40, 2975.236919, 1742.976, 8.721, 3.0702, 40, 43, 30, 21, 20, 20, 10912, 1239, 957.91036, 359.22144, 670.45638, 217.60884, 253, 4, 333, 305, 0, 0, 40, 135, 0, 1), 
(18055, 18055, "Offering of Forbidden Path Zealot", 0, "", 0, "LineageMonster.ketra_orc_20_bi", 14, 34.8, 78, "male", "L2FestivalMonster", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 8688, 951, 748.83714, 282.79552, 584.40994, 201.54308, 253, 8, 333, 175, 0, 0, 45, 195, 0, 1), 
(18056, 18056, "Offering of Forbidden Path Marksman", 0, "", 0, "LineageMonster.ketra_orc_archer_20_bi", 14, 32.4, 76, "male", "L2FestivalMonster", 1100, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 7139, 763, 1811.75536, 275.21687, 556.793, 196.14192, 253, 8, 333, 289, 0, 0, 45, 150, 0, 1), 
(18057, 18057, "Offering of Forbidden Path Disciple", 0, "", 0, "LineageMonster.ketra_orc_overload", 12, 24, 78, "male", "L2FestivalMonster", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 8688, 951, 855.81387, 332.70061, 584.40994, 201.54308, 253, 4, 333, 151, 0, 0, 33, 195, 0, 1), 
(18058, 18058, "Offering of Forbidden Path Saint", 0, "", 0, "LineageMonster.ketra_orc_overload_20_bi", 14, 28.8, 78, "male", "L2FestivalMonster", 40, 3044.88717, 1812.948, 8.823, 3.111, 40, 43, 30, 21, 20, 20, 9837, 1144, 1045.99572, 380.7903, 742.05697, 230.67484, 253, 4, 333, 2500, 0, 0, 33, 195, 0, 1), 
(18059, 18059, "Offering of Branded Elder", 0, "", 0, "LineageMonster.orc_fighter_bi", 12, 26.4, 34, "male", "L2FestivalMonster", 40, 736.96177, 387.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1720, 100, 121.20802, 132.9486, 82.76936, 80.53748, 253, 4, 333, 127, 0, 0, 45, 30, 0, 1), 
(18060, 18060, "Offering of the Branded", 0, "", 0, "LineageMonster.orc", 10, 21, 32, "male", "L2FestivalMonster", 40, 668.47132, 358.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1524, 86, 92.89459, 106.74068, 72.49711, 76.07208, 253, 8, 333, 218, 0, 0, 45, 30, 0, 1), 
(18061, 18061, "Offering of Branded Archer", 0, "", 0, "LineageMonster.orc_archer", 14, 25, 28, "male", "L2FestivalMonster", 1100, 543.79576, 300.96, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1001, 53, 178.96112, 94.87163, 54.99876, 67.61324, 253, 8, 333, 14, 0, 0, 45, 60, 0, 1), 
(18062, 18062, "Offering of Branded Warrior", 0, "", 0, "LineageMonster.orc_champion", 10, 23, 29, "male", "L2FestivalMonster", 40, 573.42917, 315.12, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1026, 55, 86.42002, 115.00598, 59.01367, 69.66822, 253, 4, 333, 125, 0, 0, 45, 110, 0, 1), 
(18063, 18063, "Offering of Branded Follower", 0, "", 0, "LineageMonster.orc_shaman", 9, 22, 29, "male", "L2FestivalMonster", 40, 573.42917, 315.12, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1227, 66, 75.61752, 97.75508, 59.01367, 69.66822, 253, 8, 333, 316, 0, 0, 45, 150, 0, 1), 
(18064, 18064, "Offering of Branded Berserker", 0, "", 0, "LineageMonster.virud_lizardman", 10, 23, 37, "male", "L2FestivalMonster", 40, 847.31754, 432.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2277, 140, 146.82587, 144.47758, 100.26304, 87.52151, 253, 4, 333, 292, 0, 0, 43, 115, 0, 1), 
(18065, 18065, "Offering of Branded Zealot", 0, "", 0, "LineageMonster.orc_fighter_bi", 12, 26.4, 34, "male", "L2FestivalMonster", 40, 736.96177, 387.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1651, 96, 106.05702, 113.00631, 82.76936, 80.53748, 253, 8, 333, 158, 0, 0, 45, 155, 0, 1), 
(18066, 18066, "Offering of Branded Marksman", 0, "", 0, "LineageMonster.orc_archer_20_bi", 16, 30, 32, "male", "L2FestivalMonster", 1100, 668.47132, 358.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1266, 71, 235.89919, 106.74068, 72.49711, 76.07208, 253, 8, 333, 273, 0, 0, 45, 130, 0, 1), 
(18067, 18067, "Offering of Branded Disciple", 0, "", 0, "LineageMonster.batur_orc", 9, 21.5, 34, "male", "L2FestivalMonster", 40, 736.96177, 387.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1651, 96, 121.20802, 132.9486, 82.76936, 80.53748, 253, 4, 333, 129, 0, 0, 80, 165, 0, 1), 
(18068, 18068, "Offering of Branded Saint", 0, "", 0, "LineageMonster.batur_orc_20_bi", 10, 25.3, 39, "male", "L2FestivalMonster", 40, 925.85879, 463.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2172, 138, 166.06476, 152.46752, 113.4007, 92.36164, 253, 4, 333, 72, 0, 0, 80, 165, 0, 1), 
(18069, 18069, "Apostate's Offering Elder", 0, "", 0, "LineageMonster.orc_champion_20_bi", 12, 27.6, 45, "male", "L2FestivalMonster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3013, 210, 234.89829, 177.78746, 160.40508, 107.69993, 253, 4, 333, 72, 0, 0, 45, 30, 0, 1), 
(18070, 18070, "Apostate's Offering", 0, "", 0, "LineageMonster.orc_fighter", 12, 22, 43, "male", "L2FestivalMonster", 40, 1094.28943, 557.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 2751, 186, 183.79228, 143.76404, 143.43577, 102.45795, 253, 8, 333, 223, 0, 0, 45, 30, 0, 1), 
(18071, 18071, "Apostate's Offering Archer", 0, "", 0, "LineageMonster.batur_orc_archer", 11, 21.5, 39, "male", "L2FestivalMonster", 1100, 925.85879, 463.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1880, 119, 368.9959, 129.59739, 113.4007, 92.36164, 253, 8, 333, 275, 0, 0, 45, 60, 0, 1), 
(18072, 18072, "Apostate's Offering Warrior", 0, "", 0, "LineageMonster.batur_orc_warrior", 10, 20, 40, "male", "L2FestivalMonster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1920, 124, 176.36077, 156.55035, 120.43155, 94.83493, 253, 4, 333, 127, 0, 0, 80, 115, 0, 1), 
(18073, 18073, "Apostate's Offering Follower", 0, "", 0, "LineageMonster.batur_orc_shaman", 11, 16, 40, "male", "L2FestivalMonster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2296, 148, 154.31567, 133.0678, 120.43155, 94.83493, 253, 8, 333, 316, 0, 0, 50, 155, 0, 1), 
(18074, 18074, "Apostate's Offering Berserker", 0, "", 0, "LineageMonster.zenta_lizardman", 11, 32, 48, "male", "L2FestivalMonster", 40, 1324.01623, 692.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3832, 280, 275.82705, 191.12803, 188.35412, 115.78137, 253, 4, 333, 297, 0, 0, 37, 120, 0, 1), 
(18075, 18075, "Apostate's Offering Zealot", 0, "", 0, "LineageMonster.batur_orc_20_bi", 10, 25.3, 45, "male", "L2FestivalMonster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 2892, 201, 205.536, 151.11934, 160.40508, 107.69993, 253, 8, 333, 172, 0, 0, 80, 160, 0, 1), 
(18076, 18076, "Apostate's Offering Marksman", 0, "", 0, "LineageMonster.batur_orc_archer_20_bi", 13, 25.3, 43, "male", "L2FestivalMonster", 1100, 1094.28943, 557.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 2285, 154, 466.72737, 143.76404, 143.43577, 102.45795, 253, 8, 333, 277, 0, 0, 45, 135, 0, 1), 
(18077, 18077, "Apostate's Offering Disciple", 0, "", 0, "LineageMonster.batur_orc_overlord", 12, 24, 45, "male", "L2FestivalMonster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 2892, 201, 234.89829, 177.78746, 160.40508, 107.69993, 253, 4, 333, 74, 0, 0, 80, 170, 0, 1), 
(18078, 18078, "Apostate's Offering Saint", 0, "", 0, "LineageMonster.batur_orc_overlord_20_bi", 14, 28.8, 50, "male", "L2FestivalMonster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3570, 269, 305.54906, 200.23844, 208.6504, 121.30026, 253, 4, 333, 133, 0, 0, 80, 170, 0, 1), 
(18079, 18079, "Witch's Offering Elder", 0, "", 0, "LineageMonster.batur_orc_warrior_20_bi", 12, 24, 56, "male", "L2FestivalMonster", 40, 1724.6831, 918.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 4666, 383, 405.96455, 228.40135, 277.22116, 138.36077, 253, 4, 333, 133, 0, 0, 80, 30, 0, 1), 
(18080, 18080, "Witch's Offering", 0, "", 0, "LineageMonster.batur_orc", 9, 21.5, 54, "male", "L2FestivalMonster", 40, 1621.75618, 861, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 4339, 346, 324.35291, 186.06151, 253.13256, 132.60256, 253, 8, 333, 226, 0, 0, 80, 30, 0, 1), 
(18081, 18081, "Witch's Offering Archer", 0, "", 0, "LineageMonster.batur_orc_archer", 11, 21.5, 50, "male", "L2FestivalMonster", 1100, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3090, 233, 678.93001, 170.20267, 208.6504, 121.30026, 253, 8, 333, 278, 0, 0, 45, 70, 0, 1), 
(18082, 18082, "Witch's Offering Warrior", 0, "", 0, "LineageMonster.batur_orc_warrior", 10, 20, 51, "male", "L2FestivalMonster", 40, 1470.41596, 775.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 3121, 238, 321.13207, 204.85194, 219.29157, 124.09503, 253, 4, 333, 72, 0, 0, 80, 120, 0, 1), 
(18083, 18083, "Witch's Offering Follower", 0, "", 0, "LineageMonster.batur_orc_shaman", 11, 16, 51, "male", "L2FestivalMonster", 40, 1470.41596, 775.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 3733, 285, 280.99056, 174.12415, 219.29157, 124.09503, 253, 8, 333, 316, 0, 0, 50, 160, 0, 1), 
(18084, 18084, "Witch's Offering Berserker", 0, "", 0, "LineageMonster.virud_lizardman_warrior", 12, 30, 59, "male", "L2FestivalMonster", 40, 1880.92519, 1007, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 5790, 495, 461.94387, 242.81593, 315.44778, 147.09282, 253, 4, 333, 301, 0, 0, 52, 125, 0, 1), 
(18085, 18085, "Witch's Offering Zealot", 0, "", 0, "LineageMonster.batur_orc_20_bi", 10, 25.3, 56, "male", "L2FestivalMonster", 40, 1724.6831, 918.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 4478, 368, 355.21898, 194.14115, 277.22116, 138.36077, 253, 8, 333, 91, 0, 0, 80, 165, 0, 1), 
(18086, 18086, "Witch's Offering Marksman", 0, "", 0, "LineageMonster.batur_orc_archer_20_bi", 13, 25.3, 54, "male", "L2FestivalMonster", 1100, 1621.75618, 861, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 3604, 287, 823.67105, 186.06151, 253.13256, 132.60256, 253, 8, 333, 282, 0, 0, 45, 140, 0, 1), 
(18087, 18087, "Witch's Offering Disciple", 0, "", 0, "LineageMonster.batur_orc_overlord", 12, 24, 56, "male", "L2FestivalMonster", 40, 1724.6831, 918.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 4478, 368, 405.96455, 228.40135, 277.22116, 138.36077, 253, 4, 333, 135, 0, 0, 80, 175, 0, 1), 
(18088, 18088, "Witch's Offering Saint", 0, "", 0, "LineageMonster.batur_orc_overlord_20_bi", 14, 28.8, 61, "male", "L2FestivalMonster", 40, 1985.55926, 1066.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 5314, 468, 501.08068, 252.49346, 342.17315, 152.95527, 253, 4, 333, 79, 0, 0, 80, 175, 0, 1), 
(18089, 18089, "Dark Omen Offering Elder", 0, "", 0, "LineageMonster.batur_orc_warrior_20_bi", 12, 24, 67, "male", "L2FestivalMonster", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 6680, 636, 624.93199, 281.55251, 426.74754, 170.55863, 253, 4, 333, 79, 0, 0, 80, 30, 0, 1), 
(18090, 18090, "Dark Omen Offering", 0, "", 0, "LineageMonster.batur_orc", 9, 21.5, 65, "male", "L2FestivalMonster", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 6287, 584, 509.96539, 231.10678, 397.98887, 164.70548, 253, 8, 333, 234, 0, 0, 80, 30, 0, 1), 
(18091, 18091, "Dark Omen Offering Archer", 0, "", 0, "LineageMonster.batur_orc_archer", 11, 21.5, 61, "male", "L2FestivalMonster", 1100, 1985.55926, 1066.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 4599, 405, 1113.40127, 214.61944, 342.17315, 152.95527, 253, 8, 333, 283, 0, 0, 45, 70, 0, 1), 
(18092, 18092, "Dark Omen Offering Warrior", 0, "", 0, "LineageMonster.batur_orc_warrior", 10, 20, 62, "male", "L2FestivalMonster", 40, 2037.81082, 1097, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 4613, 411, 521.12391, 257.34267, 355.86007, 155.89282, 253, 4, 333, 133, 0, 0, 80, 125, 0, 1), 
(18093, 18093, "Dark Omen Offering Follower", 0, "", 0, "LineageMonster.batur_orc_shaman", 11, 16, 62, "male", "L2FestivalMonster", 40, 2037.81082, 1097, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 5517, 492, 455.98342, 218.74127, 355.86007, 155.89282, 253, 8, 333, 316, 0, 0, 50, 165, 0, 1), 
(18094, 18094, "Dark Omen Offering Berserker", 0, "", 0, "LineageMonster.virud_lizardman_warrior", 12, 30, 70, "male", "L2FestivalMonster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 8150, 808, 688.86373, 295.91597, 470.40463, 179.25972, 253, 4, 333, 97, 0, 0, 52, 130, 0, 1), 
(18095, 18095, "Dark Omen Offering Zealot", 0, "", 0, "LineageMonster.batur_orc_20_bi", 10, 25.3, 67, "male", "L2FestivalMonster", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 6410, 610, 546.81549, 239.31963, 426.74754, 170.55863, 253, 8, 333, 2503, 0, 0, 80, 170, 0, 1), 
(18096, 18096, "Dark Omen Offering Marksman", 0, "", 0, "LineageMonster.batur_orc_archer_20_bi", 13, 25.3, 65, "male", "L2FestivalMonster", 1100, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 5222, 485, 1295.02068, 231.10678, 397.98887, 164.70548, 253, 8, 333, 286, 0, 0, 45, 145, 0, 1), 
(18097, 18097, "Dark Omen Offering Disciple", 0, "", 0, "LineageMonster.batur_orc_overlord", 12, 24, 67, "male", "L2FestivalMonster", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 6410, 610, 624.93199, 281.55251, 426.74754, 170.55863, 253, 4, 333, 142, 0, 0, 80, 180, 0, 1), 
(18098, 18098, "Dark Omen Offering Saint", 0, "", 0, "LineageMonster.batur_orc_overlord_20_bi", 14, 28.8, 72, "male", "L2FestivalMonster", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 7403, 752, 731.52506, 305.35947, 499.53679, 184.98039, 253, 4, 333, 2500, 0, 0, 80, 180, 0, 1), 
(18099, 18099, "Offering of Forbidden Path Elder", 0, "", 0, "LineageMonster.batur_orc_overlord_20_bi", 14, 28.8, 78, "male", "L2FestivalMonster", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 9053, 991, 855.81387, 332.70061, 584.40994, 201.54308, 253, 4, 333, 2500, 0, 0, 80, 30, 0, 1), 
(18100, 18100, "Offering of Forbidden Path", 0, "", 0, "LineageMonster.batur_orc_warrior", 10, 20, 76, "male", "L2FestivalMonster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 8595, 919, 713.45002, 275.21687, 556.793, 196.14192, 253, 8, 333, 236, 0, 0, 80, 30, 0, 1), 
(18101, 18101, "Offering of Forbidden Path Archer", 0, "", 0, "LineageMonster.ketra_orc_archer", 12, 27, 78, "male", "L2FestivalMonster", 1100, 3010.892998, 1777.86, 8.772, 3.0906, 40, 43, 30, 21, 20, 20, 8311, 955, 2225.9562, 314.47515, 705.71213, 224.12052, 253, 8, 333, 287, 0, 0, 45, 70, 0, 1), 
(18102, 18102, "Offering of Forbidden Path Warrior", 0, "", 0, "LineageMonster.ketra_orc_warrior", 12, 24, 78, "male", "L2FestivalMonster", 40, 2937.983806, 1708.296, 8.67, 3.06, 40, 43, 30, 21, 20, 20, 7680, 862, 912.65371, 348.2025, 635.68866, 210.9338, 253, 4, 333, 79, 0, 0, 36, 130, 0, 1), 
(18103, 18103, "Offering of Forbidden Path Follower", 0, "", 0, "LineageMonster.ketra_orc_shaman", 10, 23, 78, "male", "L2FestivalMonster", 40, 2937.983806, 1708.296, 8.67, 3.06, 40, 43, 30, 21, 20, 20, 9185, 1031, 798.572, 295.97213, 635.68866, 210.9338, 253, 8, 333, 316, 0, 0, 10, 180, 0, 1), 
(18104, 18104, "Offering of Forbidden Path Berserker", 0, "", 0, "LineageMonster.zenta_lizardman_warrior", 13, 35, 78, "male", "L2FestivalMonster", 40, 2975.236919, 1742.976, 8.721, 3.0702, 40, 43, 30, 21, 20, 20, 10912, 1239, 957.91036, 359.22144, 670.45638, 217.60884, 253, 4, 333, 305, 0, 0, 40, 135, 0, 1), 
(18105, 18105, "Offering of Forbidden Path Zealot", 0, "", 0, "LineageMonster.ketra_orc_20_bi", 14, 34.8, 78, "male", "L2FestivalMonster", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 8688, 951, 748.83714, 282.79552, 584.40994, 201.54308, 253, 8, 333, 175, 0, 0, 45, 195, 0, 1), 
(18106, 18106, "Offering of Forbidden Path Marksman", 0, "", 0, "LineageMonster.ketra_orc_archer_20_bi", 14, 32.4, 76, "male", "L2FestivalMonster", 1100, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 7139, 763, 1811.75536, 275.21687, 556.793, 196.14192, 253, 8, 333, 289, 0, 0, 45, 150, 0, 1), 
(18107, 18107, "Offering of Forbidden Path Disciple", 0, "", 0, "LineageMonster.ketra_orc_overload", 12, 24, 78, "male", "L2FestivalMonster", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 8688, 951, 855.81387, 332.70061, 584.40994, 201.54308, 253, 4, 333, 151, 0, 0, 33, 195, 0, 1), 
(18108, 18108, "Offering of Forbidden Path Saint", 0, "", 0, "LineageMonster.ketra_orc_overload_20_bi", 14, 28.8, 78, "male", "L2FestivalMonster", 40, 3044.88717, 1812.948, 8.823, 3.111, 40, 43, 30, 21, 20, 20, 9837, 1144, 1045.99572, 380.7903, 742.05697, 230.67484, 253, 4, 333, 2500, 0, 0, 33, 195, 0, 1), 
(18109, 18109, "Treasures of the Festival", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 30, "male", "L2FestivalMonster", 40, 632.854963, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 90, 0, 0, 118.46, 0, 71.76565, 253, 1, 333, 0, 0, 0, 80, 195, 0, 1), 
(18110, 18110, "Treasures of the Festival", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 41, "male", "L2FestivalMonster", 40, 942.392518, 504.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 168, 0, 0, 160.69, 0, 97.34598, 253, 1, 333, 0, 0, 0, 80, 195, 0, 1), 
(18111, 18111, "Treasures of the Festival", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 52, "male", "L2FestivalMonster", 40, 1302.758046, 804, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 270, 0, 0, 209.5, 0, 126.90823, 253, 1, 333, 0, 0, 0, 80, 195, 0, 1), 
(18112, 18112, "Treasures of the Festival", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 63, "male", "L2FestivalMonster", 40, 1671.377796, 1127.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 397, 0, 0, 262.19, 0, 158.82984, 253, 1, 333, 0, 0, 0, 80, 195, 0, 1), 
(18113, 18113, "Treasures of the Festival", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 72, "male", "L2FestivalMonster", 40, 1938.889453, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 518, 0, 0, 305.36, 0, 184.98138, 253, 1, 333, 0, 0, 0, 80, 195, 0, 1), 
(18114, 18114, "Treasures of the Festival", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 30, "male", "L2FestivalMonster", 40, 632.854963, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 90, 0, 0, 118.46, 0, 71.76565, 253, 1, 333, 0, 0, 0, 80, 195, 0, 1), 
(18115, 18115, "Treasures of the Festival", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 41, "male", "L2FestivalMonster", 40, 942.392518, 504.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 168, 0, 0, 160.69, 0, 97.34598, 253, 1, 333, 0, 0, 0, 80, 195, 0, 1), 
(18116, 18116, "Treasures of the Festival", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 52, "male", "L2FestivalMonster", 40, 1302.758046, 804, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 270, 0, 0, 209.5, 0, 126.90823, 253, 1, 333, 0, 0, 0, 80, 195, 0, 1), 
(18117, 18117, "Treasures of the Festival", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 63, "male", "L2FestivalMonster", 40, 1671.377796, 1127.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 397, 0, 0, 262.19, 0, 158.82984, 253, 1, 333, 0, 0, 0, 80, 195, 0, 1), 
(18118, 18118, "Treasures of the Festival", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 72, "male", "L2FestivalMonster", 40, 1938.889453, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 518, 0, 0, 305.36, 0, 184.98138, 253, 1, 333, 0, 0, 0, 80, 195, 0, 1), 
(18119, 18119, "Corpse of Deadman", 0, "", 0, "LineageMonster.zombie_corpse", 13, 21, 63, "male", "L2Monster", 40, 2089.92274, 1127.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 541.44774, 262.19426, 369.73862, 158.83181, 253, 4, 333, 0, 0, 0, 15, 1, 0, 1), 
(18120, 18120, "Halisha's Officer", 0, "", 0, "LineageMonster2.imperial_warlord_zombie_20_bi", 9, 36, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 58584, 6652, 1159.0719, 326.56494, 981.61518, 197.82625, 253, 4, 333, 134, 6721, 0, 39, 150, 0, 1), 
(18121, 18121, "Halisha's Officer", 0, "", 0, "LineageMonster2.imperial_warlord_zombie_20_bi", 9, 36, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 55563, 6309, 870.82765, 434.65794, 554.09618, 263.30668, 253, 4, 333, 134, 6721, 0, 39, 150, 0, 1), 
(18122, 18122, "Halisha's Officer", 0, "", 0, "LineageMonster2.imperial_warlord_zombie_20_bi", 9, 36, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 42434, 4818, 957.91036, 359.22144, 670.45638, 217.60884, 253, 4, 333, 134, 6721, 0, 39, 150, 0, 1), 
(18123, 18123, "Halisha's Officer", 0, "", 0, "LineageMonster2.imperial_warlord_zombie_20_bi", 9, 36, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 58584, 6652, 1159.0719, 326.56494, 981.61518, 197.82625, 253, 4, 333, 134, 6721, 0, 39, 150, 0, 1), 
(18124, 18124, "Halisha's Officer", 0, "", 0, "LineageMonster2.imperial_warlord_zombie_20_bi", 9, 36, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 55563, 6309, 870.82765, 434.65794, 554.09618, 263.30668, 253, 4, 333, 134, 6721, 0, 39, 150, 0, 1), 
(18125, 18125, "Halisha's Officer", 0, "", 0, "LineageMonster2.imperial_warlord_zombie_20_bi", 9, 36, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 42434, 4818, 957.91036, 359.22144, 670.45638, 217.60884, 253, 4, 333, 134, 6721, 0, 39, 150, 0, 1), 
(18126, 18126, "Halisha's Officer", 0, "", 0, "LineageMonster2.imperial_warlord_zombie_20_bi", 9, 36, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 58584, 6652, 1159.0719, 326.56494, 981.61518, 197.82625, 253, 4, 333, 134, 6721, 0, 39, 150, 0, 1), 
(18127, 18127, "Halisha's Officer", 0, "", 0, "LineageMonster2.imperial_warlord_zombie_20_bi", 9, 36, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 55563, 6309, 870.82765, 434.65794, 554.09618, 263.30668, 253, 4, 333, 134, 6721, 0, 39, 150, 0, 1), 
(18128, 18128, "Halisha's Officer", 0, "", 0, "LineageMonster2.imperial_warlord_zombie_20_bi", 9, 36, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 42434, 4818, 957.91036, 359.22144, 670.45638, 217.60884, 253, 4, 333, 134, 6721, 0, 39, 150, 0, 1), 
(18129, 18129, "Halisha's Officer", 0, "", 0, "LineageMonster2.imperial_warlord_zombie_20_bi", 9, 36, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 58584, 6652, 1159.0719, 326.56494, 981.61518, 197.82625, 253, 4, 333, 134, 6721, 0, 39, 150, 0, 1), 
(18130, 18130, "Halisha's Officer", 0, "", 0, "LineageMonster2.imperial_warlord_zombie_20_bi", 9, 36, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 55563, 6309, 870.82765, 434.65794, 554.09618, 263.30668, 253, 4, 333, 134, 6721, 0, 39, 150, 0, 1), 
(18131, 18131, "Halisha's Officer", 0, "", 0, "LineageMonster2.imperial_warlord_zombie_20_bi", 9, 36, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 42434, 4818, 957.91036, 359.22144, 670.45638, 217.60884, 253, 4, 333, 134, 6721, 0, 39, 150, 0, 1), 
(18132, 18132, "Imperial Healer", 0, "", 0, "LineageMonster2.tera_beetle", 19, 54.5, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 59699, 6779, 791.66147, 478.12374, 457.93073, 289.63736, 253, 4, 333, 0, 0, 0, 45, 170, 0, 1), 
(18133, 18133, "Imperial Mosaic", 0, "", 0, "LineageMonster2.scorpion", 28, 66, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 55141, 6261, 838.17154, 359.22144, 670.45638, 217.60884, 253, 8, 333, 0, 0, 0, 37, 170, 0, 1), 
(18134, 18134, "Imperial Mosaic", 0, "", 0, "LineageMonster2.scorpion", 28, 66, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 41438, 4705, 838.17154, 359.22144, 670.45638, 217.60884, 253, 8, 333, 0, 0, 0, 37, 170, 0, 1), 
(18135, 18135, "Imperial Mosaic", 0, "", 0, "LineageMonster2.scorpion", 28, 66, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 54900, 6234, 838.17154, 359.22144, 670.45638, 217.60884, 253, 8, 333, 0, 0, 0, 37, 170, 0, 1), 
(18136, 18136, "Imperial Mosaic", 0, "", 0, "LineageMonster2.scorpion", 28, 66, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 55141, 6261, 761.97417, 434.65794, 554.09618, 263.30668, 253, 8, 333, 0, 0, 0, 37, 170, 0, 1), 
(18137, 18137, "Imperial Mosaic", 0, "", 0, "LineageMonster2.scarab", 14, 22, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 40876, 4641, 957.91036, 359.22144, 670.45638, 217.60884, 253, 1, 333, 0, 0, 0, 45, 180, 0, 1), 
(18138, 18138, "Imperial Mosaic", 0, "", 0, "LineageMonster2.scarab", 14, 22, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 54418, 6179, 957.91036, 359.22144, 670.45638, 217.60884, 253, 1, 333, 0, 0, 0, 45, 180, 0, 1), 
(18139, 18139, "Imperial Mosaic", 0, "", 0, "LineageMonster2.scarab", 14, 22, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 53615, 6088, 957.91036, 359.22144, 670.45638, 217.60884, 253, 1, 333, 0, 0, 0, 45, 180, 0, 1), 
(18140, 18140, "Imperial Mosaic", 0, "", 0, "LineageMonster2.scarab", 14, 22, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 54394, 6176, 870.82765, 434.65794, 554.09618, 263.30668, 253, 1, 333, 0, 0, 0, 45, 180, 0, 1), 
(18141, 18141, "Beetle of Grave", 0, "", 0, "LineageMonster2.scarab", 14, 22, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 34.884, 3.0702, 40, 43, 30, 21, 20, 20, 34982, 3972, 1542.7245, 245.35307, 1738.99118, 148.62981, 253, 1, 333, 0, 0, 0, 45, 180, 0, 1), 
(18142, 18142, "Beetle of Grave", 0, "", 0, "LineageMonster2.scarab", 14, 22, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 34.884, 3.0702, 40, 43, 30, 21, 20, 20, 34982, 3972, 1542.7245, 245.35307, 1738.99118, 148.62981, 253, 1, 333, 0, 0, 0, 45, 180, 0, 1), 
(18143, 18143, "Beetle of Grave", 0, "", 0, "LineageMonster2.scarab", 14, 22, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 34.884, 3.0702, 40, 43, 30, 21, 20, 20, 34982, 3972, 1542.7245, 245.35307, 1738.99118, 148.62981, 253, 1, 333, 0, 0, 0, 45, 180, 0, 1), 
(18144, 18144, "Beetle of Grave", 0, "", 0, "LineageMonster2.scarab", 14, 22, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 34.884, 3.0702, 40, 43, 30, 21, 20, 20, 34982, 3972, 1542.7245, 245.35307, 1738.99118, 148.62981, 253, 1, 333, 0, 0, 0, 45, 180, 0, 1), 
(18145, 18145, "Beetle of Grave", 0, "", 0, "LineageMonster2.scarab", 14, 22, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 34.884, 3.0702, 40, 43, 30, 21, 20, 20, 29597, 3361, 1274.97858, 296.87722, 1187.75437, 179.84201, 253, 1, 333, 0, 0, 0, 45, 180, 0, 1), 
(18146, 18146, "Beetle of Grave", 0, "", 0, "LineageMonster2.scarab", 14, 22, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 34.884, 3.0702, 40, 43, 30, 21, 20, 20, 30276, 3438, 1274.97858, 296.87722, 1187.75437, 179.84201, 253, 1, 333, 0, 0, 0, 45, 180, 0, 1), 
(18147, 18147, "Beetle of Grave", 0, "", 0, "LineageMonster2.scarab", 14, 22, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 34.884, 3.0702, 40, 43, 30, 21, 20, 20, 28188, 3201, 1274.97858, 296.87722, 1187.75437, 179.84201, 253, 1, 333, 0, 0, 0, 45, 180, 0, 1), 
(18148, 18148, "Beetle of Grave", 0, "", 0, "LineageMonster2.scarab", 14, 22, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 34.884, 3.0702, 40, 43, 30, 21, 20, 20, 32814, 3726, 1274.97858, 296.87722, 1187.75437, 179.84201, 253, 1, 333, 0, 0, 0, 45, 180, 0, 1), 
(18149, 18149, "Beetle of Grave", 0, "", 0, "LineageMonster2.scarab", 14, 22, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 34.884, 3.0702, 40, 43, 30, 21, 20, 20, 28991, 3292, 1274.97858, 296.87722, 1187.75437, 179.84201, 253, 1, 333, 0, 0, 0, 45, 180, 0, 1), 
(18150, 18150, "Victim", 0, "", 0, "LineageNPC.a_tombkeeperA", 8, 23, 78, "female", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 8.721, 3.0702, 40, 43, 30, 21, 20, 20, 0, 0, 957.91036, 359.22144, 670.45638, 217.60884, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18151, 18151, "Victim", 0, "", 0, "LineageNPC.a_tombkeeperA", 8, 23, 78, "female", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 8.721, 3.0702, 40, 43, 30, 21, 20, 20, 0, 0, 957.91036, 359.22144, 670.45638, 217.60884, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18152, 18152, "Victim", 0, "", 0, "LineageNPC.a_tombkeeperA", 8, 23, 78, "female", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 8.721, 3.0702, 40, 43, 30, 21, 20, 20, 0, 0, 957.91036, 359.22144, 670.45638, 217.60884, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18153, 18153, "Victim", 0, "", 0, "LineageNPC.a_tombkeeperA", 8, 23, 78, "female", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 8.721, 3.0702, 40, 43, 30, 21, 20, 20, 0, 0, 957.91036, 359.22144, 670.45638, 217.60884, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18154, 18154, "Victim", 0, "", 0, "LineageNPC.a_tombkeeperA", 8, 23, 78, "female", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 8.721, 3.0702, 40, 43, 30, 21, 20, 20, 0, 0, 957.91036, 359.22144, 670.45638, 217.60884, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18155, 18155, "Victim", 0, "", 0, "LineageNPC.a_tombkeeperA", 8, 23, 78, "female", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 8.721, 3.0702, 40, 43, 30, 21, 20, 20, 0, 0, 957.91036, 359.22144, 670.45638, 217.60884, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18156, 18156, "Victim", 0, "", 0, "LineageNPC.a_tombkeeperA", 8, 23, 78, "female", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 8.721, 3.0702, 40, 43, 30, 21, 20, 20, 0, 0, 957.91036, 359.22144, 670.45638, 217.60884, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18157, 18157, "Victim", 0, "", 0, "LineageNPC.a_tombkeeperA", 8, 23, 78, "female", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 8.721, 3.0702, 40, 43, 30, 21, 20, 20, 0, 0, 957.91036, 359.22144, 670.45638, 217.60884, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18158, 18158, "Executioner of Halisha", 0, "", 0, "LineageMonster2.erinyes", 21, 50, 78, "male", "L2SepulcherMonster", 40, 17851.421513, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 0, 0, 1159.0719, 629.52473, 981.61518, 197.82625, 253, 1, 333, 0, 0, 0, 31, 150, 0, 1), 
(18159, 18159, "Executioner of Halisha", 0, "", 0, "LineageMonster2.erinyes", 21, 50, 78, "male", "L2SepulcherMonster", 40, 17851.421513, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 0, 0, 1159.0719, 326.56494, 981.61518, 381.35291, 253, 1, 333, 0, 0, 0, 31, 150, 0, 1), 
(18160, 18160, "Executioner of Halisha", 0, "", 0, "LineageMonster2.erinyes", 21, 50, 78, "male", "L2SepulcherMonster", 40, 17851.421513, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 0, 0, 1159.0719, 629.52473, 981.61518, 197.82625, 253, 1, 333, 0, 0, 0, 31, 150, 0, 1), 
(18161, 18161, "Executioner of Halisha", 0, "", 0, "LineageMonster2.erinyes", 21, 50, 78, "male", "L2SepulcherMonster", 40, 17851.421513, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 0, 0, 1159.0719, 326.56494, 981.61518, 381.35291, 253, 1, 333, 0, 0, 0, 31, 150, 0, 1), 
(18162, 18162, "Executioner of Halisha", 0, "", 0, "LineageMonster2.erinyes", 21, 50, 78, "male", "L2SepulcherMonster", 40, 17851.421513, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 0, 0, 1159.0719, 629.52473, 981.61518, 197.82625, 253, 1, 333, 0, 0, 0, 31, 150, 0, 1), 
(18163, 18163, "Executioner of Halisha", 0, "", 0, "LineageMonster2.erinyes", 21, 50, 78, "male", "L2SepulcherMonster", 40, 17851.421513, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 0, 0, 1159.0719, 326.56494, 981.61518, 381.35291, 253, 1, 333, 0, 0, 0, 31, 150, 0, 1), 
(18164, 18164, "Executioner of Halisha", 0, "", 0, "LineageMonster2.erinyes", 21, 50, 78, "male", "L2SepulcherMonster", 40, 17851.421513, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 0, 0, 1159.0719, 629.52473, 981.61518, 197.82625, 253, 1, 333, 0, 0, 0, 31, 150, 0, 1), 
(18165, 18165, "Executioner of Halisha", 0, "", 0, "LineageMonster2.erinyes", 21, 50, 78, "male", "L2SepulcherMonster", 40, 17851.421513, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 0, 0, 1159.0719, 326.56494, 981.61518, 381.35291, 253, 1, 333, 0, 0, 0, 31, 150, 0, 1), 
(18166, 18166, "Imperial Guard", 0, "", 0, "LineageMonster.death_knight", 12, 31, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 42032, 4773, 1159.0719, 326.56494, 981.61518, 197.82625, 253, 4, 333, 142, 0, 0, 27, 110, 0, 1), 
(18167, 18167, "Imperial Guard", 0, "", 0, "LineageMonster.death_knight", 12, 31, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 41438, 4705, 870.82765, 434.65794, 554.09618, 263.30668, 253, 4, 333, 142, 0, 0, 27, 110, 0, 1), 
(18168, 18168, "Imperial Guard", 0, "", 0, "LineageMonster.death_knight", 12, 31, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 42595, 4837, 957.91036, 359.22144, 670.45638, 217.60884, 253, 4, 333, 142, 0, 0, 27, 110, 0, 1), 
(18169, 18169, "Imperial Guard", 0, "", 0, "LineageMonster.death_knight", 12, 31, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 41237, 4683, 870.82765, 434.65794, 554.09618, 263.30668, 253, 4, 333, 142, 0, 0, 27, 110, 0, 1), 
(18170, 18170, "Imperial Guard", 0, "", 0, "LineageMonster.doll_master", 20, 42, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 41278, 4687, 1115.60664, 296.87722, 1187.75437, 179.84201, 253, 8, 333, 0, 0, 0, 80, 160, 0, 1), 
(18171, 18171, "Imperial Guard", 0, "", 0, "LineageMonster.doll_master", 20, 42, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 42884, 4869, 692.70383, 478.12374, 457.93073, 289.63736, 253, 8, 333, 0, 0, 0, 80, 160, 0, 1), 
(18172, 18172, "Imperial Guard", 0, "", 0, "LineageMonster.doll_master", 20, 42, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 40876, 4641, 838.17154, 359.22144, 670.45638, 217.60884, 253, 8, 333, 0, 0, 0, 80, 160, 0, 1), 
(18173, 18173, "Halisha's Foreman", 0, "", 0, "LineageMonster.kaim_vanul", 24, 40, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 45345, 5149, 1159.0719, 326.56494, 981.61518, 197.82625, 253, 4, 333, 0, 0, 0, 37, 160, 0, 1), 
(18174, 18174, "Halisha's Foreman", 0, "", 0, "LineageMonster.kaim_vanul", 24, 40, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 55932, 6351, 1159.0719, 326.56494, 981.61518, 197.82625, 253, 4, 333, 0, 0, 0, 37, 160, 0, 1), 
(18175, 18175, "Halisha's Foreman", 0, "", 0, "LineageMonster.kaim_vanul", 24, 40, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 42803, 4860, 1159.0719, 326.56494, 981.61518, 197.82625, 253, 4, 333, 0, 0, 0, 37, 160, 0, 1), 
(18176, 18176, "Halisha's Foreman", 0, "", 0, "LineageMonster.kaim_vanul", 24, 40, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 45345, 5149, 1159.0719, 326.56494, 981.61518, 197.82625, 253, 4, 333, 0, 0, 0, 37, 160, 0, 1), 
(18177, 18177, "Halisha's Foreman", 0, "", 0, "LineageMonster.kaim_vanul", 24, 40, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 55932, 6351, 1159.0719, 326.56494, 981.61518, 197.82625, 253, 4, 333, 0, 0, 0, 37, 160, 0, 1), 
(18178, 18178, "Halisha's Foreman", 0, "", 0, "LineageMonster.kaim_vanul", 24, 40, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 42803, 4860, 1159.0719, 326.56494, 981.61518, 197.82625, 253, 4, 333, 0, 0, 0, 37, 160, 0, 1), 
(18179, 18179, "Halisha's Foreman", 0, "", 0, "LineageMonster.kaim_vanul", 24, 40, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 45345, 5149, 1159.0719, 326.56494, 981.61518, 197.82625, 253, 4, 333, 0, 0, 0, 37, 160, 0, 1), 
(18180, 18180, "Halisha's Foreman", 0, "", 0, "LineageMonster.kaim_vanul", 24, 40, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 55932, 6351, 1159.0719, 326.56494, 981.61518, 197.82625, 253, 4, 333, 0, 0, 0, 37, 160, 0, 1), 
(18181, 18181, "Halisha's Foreman", 0, "", 0, "LineageMonster.kaim_vanul", 24, 40, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 42803, 4860, 1159.0719, 326.56494, 981.61518, 197.82625, 253, 4, 333, 0, 0, 0, 37, 160, 0, 1), 
(18182, 18182, "Halisha's Foreman", 0, "", 0, "LineageMonster.kaim_vanul", 24, 40, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 45345, 5149, 1159.0719, 326.56494, 981.61518, 197.82625, 253, 4, 333, 0, 0, 0, 37, 160, 0, 1), 
(18183, 18183, "Halisha's Foreman", 0, "", 0, "LineageMonster.kaim_vanul", 24, 40, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 55932, 6351, 1159.0719, 326.56494, 981.61518, 197.82625, 253, 4, 333, 0, 0, 0, 37, 160, 0, 1), 
(18184, 18184, "Halisha's Foreman", 0, "", 0, "LineageMonster.kaim_vanul", 24, 40, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 42803, 4860, 1159.0719, 326.56494, 981.61518, 197.82625, 253, 4, 333, 0, 0, 0, 37, 160, 0, 1), 
(18185, 18185, "Evil Astrologer", 0, "", 0, "LineageMonster.doll_blader", 6, 12, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 56482, 6414, 870.82765, 434.65794, 554.09618, 263.30668, 253, 4, 333, 5129, 5129, 0, 22, 150, 0, 1), 
(18186, 18186, "Evil Astrologer", 0, "", 0, "LineageMonster.doll_blader", 6, 12, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 56803, 6450, 870.82765, 434.65794, 554.09618, 263.30668, 253, 4, 333, 5129, 5129, 0, 22, 150, 0, 1), 
(18187, 18187, "Knight of Darkness", 0, "", 0, "LineageMonster.death_lord", 21, 40, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 55141, 6261, 1159.0719, 326.56494, 981.61518, 197.82625, 253, 4, 333, 78, 0, 0, 40, 160, 0, 1), 
(18188, 18188, "Knight of Darkness", 0, "", 0, "LineageMonster.death_lord", 21, 40, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 41438, 4705, 1159.0719, 326.56494, 981.61518, 197.82625, 253, 4, 333, 78, 0, 0, 40, 160, 0, 1), 
(18189, 18189, "Knight of Darkness", 0, "", 0, "LineageMonster.death_lord", 21, 40, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 54900, 6234, 1159.0719, 326.56494, 981.61518, 197.82625, 253, 4, 333, 78, 0, 0, 40, 160, 0, 1), 
(18190, 18190, "Knight of Darkness", 0, "", 0, "LineageMonster.death_lord", 21, 40, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 55141, 6261, 1159.0719, 326.56494, 981.61518, 197.82625, 253, 4, 333, 78, 0, 0, 40, 160, 0, 1), 
(18191, 18191, "Witch of dust", 0, "", 0, "LineageMonster.banshee", 9, 23, 78, "female", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 40876, 4641, 1159.0719, 326.56494, 981.61518, 197.82625, 253, 4, 333, 3939, 0, 0, 80, 160, 0, 1), 
(18192, 18192, "Witch of dust", 0, "", 0, "LineageMonster.banshee", 9, 23, 78, "female", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 54418, 6179, 1159.0719, 326.56494, 981.61518, 197.82625, 253, 4, 333, 3939, 0, 0, 80, 160, 0, 1), 
(18193, 18193, "Witch of dust", 0, "", 0, "LineageMonster.banshee", 9, 23, 78, "female", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 53615, 6088, 1159.0719, 326.56494, 981.61518, 197.82625, 253, 4, 333, 3939, 0, 0, 80, 160, 0, 1), 
(18194, 18194, "Witch of dust", 0, "", 0, "LineageMonster.banshee", 9, 23, 78, "female", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 54394, 6176, 1159.0719, 326.56494, 981.61518, 197.82625, 253, 4, 333, 3939, 0, 0, 80, 160, 0, 1), 
(18195, 18195, "Signet of Emperor", 0, "", 0, "LineageMonster.ant_larva", 12, 8, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 41679, 4733, 1542.7245, 245.35307, 1738.99118, 148.62981, 253, 4, 333, 0, 0, 0, 40, 60, 0, 1), 
(18196, 18196, "Charm of Corner", 0, "", 0, "LineageMonster2.magmagoil_lad", 15, 75, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 136143, 15459, 654.26564, 578.52972, 312.77285, 350.46119, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18197, 18197, "Charm of Corner", 0, "", 0, "LineageMonster2.magmagoil_lad", 15, 75, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 136143, 15459, 654.26564, 578.52972, 312.77285, 350.46119, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18198, 18198, "Charm of Corner", 0, "", 0, "LineageMonster2.magmagoil_lad", 15, 75, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 136143, 15459, 654.26564, 578.52972, 312.77285, 350.46119, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18199, 18199, "Charm of Corner", 0, "", 0, "LineageMonster2.magmagoil_lad", 15, 75, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 136143, 15459, 654.26564, 578.52972, 312.77285, 350.46119, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18200, 18200, "Charm of Corner", 0, "", 0, "LineageMonster2.magmagoil_lad", 15, 75, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 136143, 15459, 654.26564, 578.52972, 312.77285, 350.46119, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18201, 18201, "Charm of Corner", 0, "", 0, "LineageMonster2.magmagoil_lad", 15, 75, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 136143, 15459, 654.26564, 578.52972, 312.77285, 350.46119, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18202, 18202, "Charm of Corner", 0, "", 0, "LineageMonster2.magmagoil_lad", 15, 75, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 136143, 15459, 654.26564, 578.52972, 312.77285, 350.46119, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18203, 18203, "Charm of Corner", 0, "", 0, "LineageMonster2.magmagoil_lad", 15, 75, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 136143, 15459, 654.26564, 578.52972, 312.77285, 350.46119, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18204, 18204, "Charm of Corner", 0, "", 0, "LineageMonster2.magmagoil_lad", 15, 75, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 136143, 15459, 654.26564, 578.52972, 312.77285, 350.46119, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18205, 18205, "Charm of Corner", 0, "", 0, "LineageMonster2.magmagoil_lad", 15, 75, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 136143, 15459, 654.26564, 578.52972, 312.77285, 350.46119, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18206, 18206, "Charm of Corner", 0, "", 0, "LineageMonster2.magmagoil_lad", 15, 75, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 136143, 15459, 654.26564, 578.52972, 312.77285, 350.46119, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18207, 18207, "Charm of Corner", 0, "", 0, "LineageMonster2.magmagoil_lad", 15, 75, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 136143, 15459, 654.26564, 578.52972, 312.77285, 350.46119, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18208, 18208, "Charm of Corner", 0, "", 0, "LineageMonster2.magmagoil_lad", 15, 75, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 136143, 15459, 654.26564, 578.52972, 312.77285, 350.46119, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18209, 18209, "Charm of Corner", 0, "", 0, "LineageMonster2.magmagoil_lad", 15, 75, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 136143, 15459, 654.26564, 578.52972, 312.77285, 350.46119, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18210, 18210, "Charm of Corner", 0, "", 0, "LineageMonster2.magmagoil_lad", 15, 75, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 136143, 15459, 654.26564, 578.52972, 312.77285, 350.46119, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18211, 18211, "Charm of Corner", 0, "", 0, "LineageMonster2.magmagoil_lad", 15, 75, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 136143, 15459, 654.26564, 578.52972, 312.77285, 350.46119, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18212, 18212, "Archon of Halisha", 0, "", 0, "LineageMonster2.ahrimanes", 14, 57.75, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 173610, 19713, 791.66147, 478.12374, 457.93073, 289.63736, 253, 4, 333, 6722, 0, 0, 35, 185, 0, 1), 
(18213, 18213, "Archon of Halisha", 0, "", 0, "LineageMonster2.ahrimanes", 14, 57.75, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 173610, 19713, 791.66147, 478.12374, 457.93073, 289.63736, 253, 4, 333, 6722, 0, 0, 35, 185, 0, 1), 
(18214, 18214, "Archon of Halisha", 0, "", 0, "LineageMonster2.ahrimanes", 14, 57.75, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 173610, 19713, 791.66147, 478.12374, 457.93073, 289.63736, 253, 4, 333, 6722, 0, 0, 35, 185, 0, 1), 
(18215, 18215, "Archon of Halisha", 0, "", 0, "LineageMonster2.ahrimanes", 14, 57.75, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 173610, 19713, 791.66147, 478.12374, 457.93073, 289.63736, 253, 4, 333, 6722, 0, 0, 35, 185, 0, 1), 
(18216, 18216, "Archon of Halisha", 0, "", 0, "LineageMonster2.ahrimanes", 14, 57.75, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 173610, 19713, 791.66147, 478.12374, 457.93073, 289.63736, 253, 4, 333, 6722, 0, 0, 35, 185, 0, 1), 
(18217, 18217, "Archon of Halisha", 0, "", 0, "LineageMonster2.ahrimanes", 14, 57.75, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 173610, 19713, 791.66147, 478.12374, 457.93073, 289.63736, 253, 4, 333, 6722, 0, 0, 35, 185, 0, 1), 
(18218, 18218, "Archon of Halisha", 0, "", 0, "LineageMonster2.ahrimanes", 14, 57.75, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 173610, 19713, 791.66147, 478.12374, 457.93073, 289.63736, 253, 4, 333, 6722, 0, 0, 35, 185, 0, 1), 
(18219, 18219, "Archon of Halisha", 0, "", 0, "LineageMonster2.ahrimanes", 14, 57.75, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 173610, 19713, 791.66147, 478.12374, 457.93073, 289.63736, 253, 4, 333, 6722, 0, 0, 35, 185, 0, 1), 
(18220, 18220, "Shaman of Darkness", 0, "", 0, "LineageMonster.banshee", 9, 23, 78, "female", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 56803, 6450, 1053.70182, 359.22144, 811.25222, 217.60884, 253, 4, 333, 3939, 0, 0, 80, 160, 0, 1), 
(18221, 18221, "Shaman of Darkness", 0, "", 0, "LineageMonster.banshee", 9, 23, 78, "female", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 58329, 6623, 1053.70182, 359.22144, 811.25222, 217.60884, 253, 4, 333, 3939, 0, 0, 80, 160, 0, 1), 
(18222, 18222, "Assassin of Darkness", 0, "", 0, "LineageMonster2.ashuras", 13, 37.5, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 55261, 6275, 1274.97858, 296.87722, 1187.75437, 179.84201, 253, 4, 333, 0, 0, 0, 41, 190, 0, 1), 
(18223, 18223, "Assassin of Darkness", 0, "", 0, "LineageMonster2.ashuras", 13, 37.5, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 41438, 4705, 957.91036, 359.22144, 670.45638, 217.60884, 253, 4, 333, 0, 0, 0, 41, 190, 0, 1), 
(18224, 18224, "Assassin of Darkness", 0, "", 0, "LineageMonster2.ashuras", 13, 37.5, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 55823, 6339, 1274.97858, 296.87722, 1187.75437, 179.84201, 253, 4, 333, 0, 0, 0, 41, 190, 0, 1), 
(18225, 18225, "Assassin of Darkness", 0, "", 0, "LineageMonster2.ashuras", 13, 37.5, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 55261, 6275, 957.91036, 359.22144, 670.45638, 217.60884, 253, 4, 333, 0, 0, 0, 41, 190, 0, 1), 
(18226, 18226, "Caster of Darkness", 0, "", 0, "LineageMonster.vale_master", 12, 40, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 40876, 4641, 1274.97858, 296.87722, 1187.75437, 179.84201, 253, 4, 333, 0, 0, 0, 70, 155, 0, 1), 
(18227, 18227, "Caster of Darkness", 0, "", 0, "LineageMonster.vale_master", 12, 40, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 70240, 7976, 957.91036, 359.22144, 670.45638, 217.60884, 253, 4, 333, 0, 0, 0, 70, 155, 0, 1), 
(18228, 18228, "Caster of Darkness", 0, "", 0, "LineageMonster.vale_master", 12, 40, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 52812, 5997, 1274.97858, 296.87722, 1187.75437, 179.84201, 253, 4, 333, 0, 0, 0, 70, 155, 0, 1), 
(18229, 18229, "Caster of Darkness", 0, "", 0, "LineageMonster.vale_master", 12, 40, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 54394, 6176, 957.91036, 359.22144, 670.45638, 217.60884, 253, 4, 333, 0, 0, 0, 70, 155, 0, 1), 
(18230, 18230, "Signet of Emperor", 0, "", 0, "LineageMonster.ant_larva", 12, 8, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 26.163, 3.0702, 40, 43, 30, 21, 20, 20, 22486, 2553, 1542.7245, 245.35307, 1738.99118, 148.62981, 253, 4, 333, 0, 0, 0, 40, 60, 0, 1), 
(18231, 18231, "Statue of Protection", 0, "", 0, "LineageMonster2.temple_guard_a", 15, 42, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 66895, 7596, 870.82765, 434.65794, 554.09618, 263.30668, 253, 4, 333, 5795, 0, 0, 53, 140, 0, 1), 
(18232, 18232, "Statue of Protection", 0, "", 0, "LineageMonster2.temple_guard_a", 15, 42, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 66895, 7596, 870.82765, 434.65794, 554.09618, 263.30668, 253, 4, 333, 5795, 0, 0, 53, 140, 0, 1), 
(18233, 18233, "Statue of Protection", 0, "", 0, "LineageMonster2.temple_guard_a", 15, 42, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 66895, 7596, 870.82765, 434.65794, 554.09618, 263.30668, 253, 4, 333, 5795, 0, 0, 53, 140, 0, 1), 
(18234, 18234, "Statue of Protection", 0, "", 0, "LineageMonster2.temple_guard_a", 15, 42, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 66895, 7596, 870.82765, 434.65794, 554.09618, 263.30668, 253, 4, 333, 5795, 0, 0, 53, 140, 0, 1), 
(18235, 18235, "Statue of Protection", 0, "", 0, "LineageMonster2.temple_guard_a", 15, 42, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 66895, 7596, 870.82765, 434.65794, 554.09618, 263.30668, 253, 4, 333, 5795, 0, 0, 53, 140, 0, 1), 
(18236, 18236, "Statue of Protection", 0, "", 0, "LineageMonster2.temple_guard_a", 15, 42, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 66895, 7596, 870.82765, 434.65794, 554.09618, 263.30668, 253, 4, 333, 5795, 0, 0, 53, 140, 0, 1), 
(18237, 18237, "Statue of Protection", 0, "", 0, "LineageMonster2.temple_guard_a", 15, 42, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 66895, 7596, 870.82765, 434.65794, 554.09618, 263.30668, 253, 4, 333, 5795, 0, 0, 53, 140, 0, 1), 
(18238, 18238, "Statue of Protection", 0, "", 0, "LineageMonster2.temple_guard_a", 15, 42, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 66895, 7596, 870.82765, 434.65794, 554.09618, 263.30668, 253, 4, 333, 5795, 0, 0, 53, 140, 0, 1), 
(18239, 18239, "Statue of Protection", 0, "", 0, "LineageMonster2.temple_guard_a", 15, 42, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 66895, 7596, 870.82765, 434.65794, 554.09618, 263.30668, 253, 4, 333, 5795, 0, 0, 53, 140, 0, 1), 
(18240, 18240, "Statue of Protection", 0, "", 0, "LineageMonster2.temple_guard_a", 15, 42, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 66895, 7596, 870.82765, 434.65794, 554.09618, 263.30668, 253, 4, 333, 5795, 0, 0, 53, 140, 0, 1), 
(18241, 18241, "Statue of Protection", 0, "", 0, "LineageMonster2.temple_guard_a", 15, 42, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 66895, 7596, 870.82765, 434.65794, 554.09618, 263.30668, 253, 4, 333, 5795, 0, 0, 53, 140, 0, 1), 
(18242, 18242, "Statue of Protection", 0, "", 0, "LineageMonster2.temple_guard_a", 15, 42, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 66895, 7596, 870.82765, 434.65794, 554.09618, 263.30668, 253, 4, 333, 5795, 0, 0, 53, 140, 0, 1), 
(18243, 18243, "Statue of Protection", 0, "", 0, "LineageMonster2.temple_guard_a", 15, 42, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 52.326, 3.0702, 40, 43, 30, 21, 20, 20, 66895, 7596, 870.82765, 434.65794, 554.09618, 263.30668, 253, 4, 333, 5795, 0, 0, 53, 140, 0, 1), 
(18244, 18244, "Watchman of Grave", 0, "", 0, "LineageMonster.mana_vampire", 11, 20, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 26.163, 3.0702, 40, 43, 30, 21, 20, 20, 0, 0, 1274.97858, 296.87722, 1187.75437, 179.84201, 253, 4, 333, 0, 0, 0, 90, 1, 0, 1), 
(18245, 18245, "Watchman of Grave", 0, "", 0, "LineageMonster.mana_vampire", 11, 20, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 26.163, 3.0702, 40, 43, 30, 21, 20, 20, 0, 0, 870.82765, 434.65794, 554.09618, 263.30668, 253, 4, 333, 0, 0, 0, 90, 1, 0, 1), 
(18246, 18246, "Watchman of Grave", 0, "", 0, "LineageMonster.mana_vampire", 11, 20, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 26.163, 3.0702, 40, 43, 30, 21, 20, 20, 0, 0, 957.91036, 359.22144, 670.45638, 217.60884, 253, 4, 333, 0, 0, 0, 90, 1, 0, 1), 
(18247, 18247, "Watchman of Grave", 0, "", 0, "LineageMonster.mana_vampire", 11, 20, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 26.163, 3.0702, 40, 43, 30, 21, 20, 20, 0, 0, 1274.97858, 296.87722, 1187.75437, 179.84201, 253, 4, 333, 0, 0, 0, 90, 1, 0, 1), 
(18248, 18248, "Watchman of Grave", 0, "", 0, "LineageMonster.mana_vampire", 11, 20, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 26.163, 3.0702, 40, 43, 30, 21, 20, 20, 0, 0, 870.82765, 434.65794, 554.09618, 263.30668, 253, 4, 333, 0, 0, 0, 90, 1, 0, 1), 
(18249, 18249, "Watchman of Grave", 0, "", 0, "LineageMonster.mana_vampire", 11, 20, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 26.163, 3.0702, 40, 43, 30, 21, 20, 20, 0, 0, 957.91036, 359.22144, 670.45638, 217.60884, 253, 4, 333, 0, 0, 0, 90, 1, 0, 1), 
(18250, 18250, "Watchman of Grave", 0, "", 0, "LineageMonster.mana_vampire", 11, 20, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 26.163, 3.0702, 40, 43, 30, 21, 20, 20, 0, 0, 1274.97858, 296.87722, 1187.75437, 179.84201, 253, 4, 333, 0, 0, 0, 90, 1, 0, 1), 
(18251, 18251, "Watchman of Grave", 0, "", 0, "LineageMonster.mana_vampire", 11, 20, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 26.163, 3.0702, 40, 43, 30, 21, 20, 20, 0, 0, 870.82765, 434.65794, 554.09618, 263.30668, 253, 4, 333, 0, 0, 0, 90, 1, 0, 1), 
(18252, 18252, "Watchman of Grave", 0, "", 0, "LineageMonster.mana_vampire", 11, 20, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 26.163, 3.0702, 40, 43, 30, 21, 20, 20, 0, 0, 957.91036, 359.22144, 670.45638, 217.60884, 253, 4, 333, 0, 0, 0, 90, 1, 0, 1), 
(18253, 18253, "Watchman of Grave", 0, "", 0, "LineageMonster.mana_vampire", 11, 20, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 26.163, 3.0702, 40, 43, 30, 21, 20, 20, 0, 0, 1274.97858, 296.87722, 1187.75437, 179.84201, 253, 4, 333, 0, 0, 0, 90, 1, 0, 1), 
(18254, 18254, "Watchman of Grave", 0, "", 0, "LineageMonster.mana_vampire", 11, 20, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 26.163, 3.0702, 40, 43, 30, 21, 20, 20, 0, 0, 870.82765, 434.65794, 554.09618, 263.30668, 253, 4, 333, 0, 0, 0, 90, 1, 0, 1), 
(18255, 18255, "Watchman of Grave", 0, "", 0, "LineageMonster.mana_vampire", 11, 20, 78, "male", "L2SepulcherMonster", 40, 2975.236919, 1742.976, 26.163, 3.0702, 40, 43, 30, 21, 20, 20, 0, 0, 957.91036, 359.22144, 670.45638, 217.60884, 253, 4, 333, 0, 0, 0, 90, 1, 0, 1), 
(18256, 18256, "Halisha's Treasure Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 78, "male", "L2SepulcherMonster", 40, 1.07, 1.07, 0, 0, 40, 43, 30, 21, 20, 20, 0, 0, 1.07, 1.07, 1.1449, 1.07, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(18257, 18257, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 78, "male", "L2Chest", 40, 3365.211636, 1976.076, 3.21, 3.21, 40, 43, 30, 21, 20, 20, 0, 0, 1051.86125, 399.60938, 768.56483, 242.07501, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(18258, 18258, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 78, "male", "L2Chest", 40, 3365.211636, 1976.076, 3.21, 3.21, 40, 43, 30, 21, 20, 20, 0, 0, 1051.86125, 399.60938, 768.56483, 242.07501, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(18259, 18259, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 78, "male", "L2Chest", 40, 3365.211636, 1976.076, 3.21, 3.21, 40, 43, 30, 21, 20, 20, 0, 0, 1051.86125, 399.60938, 768.56483, 242.07501, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(18260, 18260, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 78, "male", "L2Chest", 40, 3365.211636, 1976.076, 3.21, 3.21, 40, 43, 30, 21, 20, 20, 0, 0, 1051.86125, 399.60938, 768.56483, 242.07501, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(18261, 18261, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 78, "male", "L2Chest", 40, 3365.211636, 1976.076, 3.21, 3.21, 40, 43, 30, 21, 20, 20, 0, 0, 1051.86125, 399.60938, 768.56483, 242.07501, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(18262, 18262, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 78, "male", "L2Chest", 40, 3365.211636, 1976.076, 3.21, 3.21, 40, 43, 30, 21, 20, 20, 0, 0, 1051.86125, 399.60938, 768.56483, 242.07501, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(18263, 18263, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 78, "male", "L2Chest", 40, 3365.211636, 1976.076, 3.21, 3.21, 40, 43, 30, 21, 20, 20, 0, 0, 1051.86125, 399.60938, 768.56483, 242.07501, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(18264, 18264, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 78, "male", "L2Chest", 40, 3365.211636, 1976.076, 3.21, 3.21, 40, 43, 30, 21, 20, 20, 0, 0, 1051.86125, 399.60938, 768.56483, 242.07501, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(18265, 18265, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 21, "male", "L2Chest", 40, 376.063269, 205.2, 1.5, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 47.91924, 92.6271, 32.72263, 56.11156, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(18266, 18266, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 24, "male", "L2Chest", 40, 449.397335, 245.52, 1.5, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 60.19687, 101.89554, 41.10666, 61.72619, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(18267, 18267, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 27, "male", "L2Chest", 40, 531.808581, 286.92, 1.5, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 74.99121, 111.78321, 51.20928, 67.71594, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(18268, 18268, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 30, "male", "L2Chest", 40, 623.584093, 329.4, 1.5, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 92.64226, 122.28832, 63.26266, 74.07971, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(18269, 18269, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 33, "male", "L2Chest", 40, 724.871875, 372.96, 1.8, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 113.49065, 133.40254, 77.49941, 80.81247, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(18270, 18270, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 36, "male", "L2Chest", 40, 835.657992, 417.6, 1.8, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 137.86467, 145.11049, 94.1437, 87.9049, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(18271, 18271, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 39, "male", "L2Chest", 40, 955.745617, 463.32, 1.8, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 166.06476, 157.38919, 113.4007, 95.34309, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(18272, 18272, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 42, "male", "L2Chest", 40, 1084.736994, 531, 2.1, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 198.34591, 170.20764, 135.44454, 103.10823, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(18273, 18273, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 45, "male", "L2Chest", 40, 1222.019337, 610.8, 2.1, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 234.89829, 183.52646, 160.40508, 111.17649, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(18274, 18274, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 48, "male", "L2Chest", 40, 1366.755622, 692.4, 2.1, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 275.82705, 197.29766, 188.35412, 119.5188, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(18275, 18275, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 51, "male", "L2Chest", 40, 1517.881155, 775.8, 2.4, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 321.13207, 211.46458, 219.29157, 128.10083, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(18276, 18276, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 54, "male", "L2Chest", 40, 1674.106656, 861, 2.4, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 370.68904, 225.96187, 253.13256, 136.88298, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(18277, 18277, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 57, "male", "L2Chest", 40, 1833.92839, 948, 2.4, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 424.23295, 240.71574, 289.69611, 145.82057, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(18278, 18278, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 60, "male", "L2Chest", 40, 1995.645662, 1036.8, 2.4, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 481.34551, 255.64426, 328.69659, 154.86395, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(18279, 18279, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 63, "male", "L2Chest", 40, 2157.385689, 1127.4, 2.7, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 541.44774, 270.65792, 369.73862, 163.95891, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(18280, 18280, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 66, "male", "L2Chest", 40, 2317.135591, 1219.8, 2.7, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 603.79903, 285.66032, 412.31647, 173.04705, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(18281, 18281, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 69, "male", "L2Chest", 40, 2472.78091, 1314, 2.7, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 667.50361, 300.549, 455.81844, 182.06631, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(18282, 18282, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 72, "male", "L2Chest", 40, 2622.149752, 1410, 3, 3, 40, 43, 30, 21, 20, 20, 0, 0, 731.52506, 315.21651, 499.53679, 190.95158, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(18283, 18283, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 75, "male", "L2Chest", 40, 2763.061384, 1507.8, 3, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 329.55153, 542.68324, 199.63544, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(18284, 18284, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 78, "male", "L2Chest", 40, 2893.377822, 1607.4, 3, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 343.44023, 584.40994, 208.04892, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(18285, 18285, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 78, "male", "L2Chest", 40, 3101.388473, 1760.064, 3.09, 3.1003, 40, 43, 30, 21, 20, 20, 0, 0, 967.30163, 374.45261, 683.66703, 226.83556, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(18286, 18286, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 78, "male", "L2Chest", 40, 3301.056363, 1920.72, 3.18, 3.18, 40, 43, 30, 21, 20, 20, 0, 0, 1024.61236, 391.58438, 741.65807, 237.21364, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(18287, 18287, "Otherworldly Invader Food", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 33, "male", "L2Chest", 40, 702.20463, 372.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 113.49065, 129.23095, 77.49941, 78.28541, 253, 4, 333, 0, 0, 0, 80, 165, 0, 1), 
(18288, 18288, "Otherworldly Invader Food", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 35, "male", "L2Chest", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 129.32896, 136.72948, 88.31491, 82.82786, 253, 4, 333, 0, 0, 0, 80, 165, 0, 1), 
(18289, 18289, "Dimension Invader Food", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 43, "male", "L2Chest", 40, 1094.28943, 557.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 210.04832, 169.13417, 143.43577, 102.45795, 253, 4, 333, 0, 0, 0, 80, 165, 0, 1), 
(18290, 18290, "Dimension Invader Food", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 45, "male", "L2Chest", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 234.89829, 177.78746, 160.40508, 107.69993, 253, 4, 333, 0, 0, 0, 80, 165, 0, 1), 
(18291, 18291, "Purgatory Invader Food", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 53, "male", "L2Chest", 40, 1570.8463, 832.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 353.71092, 214.18326, 241.5387, 129.74774, 253, 4, 333, 0, 0, 0, 80, 165, 0, 1), 
(18292, 18292, "Purgatory Invader Food", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 55, "male", "L2Chest", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 388.11142, 223.6362, 265.02979, 135.47414, 253, 4, 333, 0, 0, 0, 80, 165, 0, 1), 
(18293, 18293, "Forbidden Path Invader Food", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 63, "male", "L2Chest", 40, 2089.92274, 1127.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 541.44774, 262.19426, 369.73862, 158.83181, 253, 4, 333, 0, 0, 0, 80, 165, 0, 1), 
(18294, 18294, "Forbidden Path Invader Food", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 65, "male", "L2Chest", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 582.81759, 271.89033, 397.98887, 164.70548, 253, 4, 333, 0, 0, 0, 80, 165, 0, 1), 
(18295, 18295, "Dark Omen Invader Food", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 73, "male", "L2Chest", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 752.73928, 310.02959, 514.02335, 187.80945, 253, 4, 333, 0, 0, 0, 80, 165, 0, 1), 
(18296, 18296, "Dark Omen Invader Food", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 75, "male", "L2Chest", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 193.39269, 253, 4, 333, 0, 0, 0, 80, 165, 0, 1), 
(18297, 18297, "Messenger Invader Food", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 78, "male", "L2Chest", 40, 3134.442675, 1866.27, 8.925, 3.15, 40, 43, 30, 21, 20, 20, 0, 0, 997.00021, 371.55451, 714.863, 225.07997, 253, 4, 333, 0, 0, 0, 80, 165, 0, 1), 
(18298, 18298, "Messenger Invader Food", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 78, "male", "L2Chest", 40, 3259.979133, 1976.076, 9.095, 3.21, 40, 43, 30, 21, 20, 20, 0, 0, 1051.86125, 387.11331, 768.56482, 234.50516, 253, 4, 333, 0, 0, 0, 80, 165, 0, 1), 
(18299, 18299, "Flame of the Branded", 0, "", 0, "LineageMonster.big_boom", 6, 13, 35, "male", "L2Npc", 40, 2318.21406, 402.6, 13.5, 1.8, 40, 43, 30, 21, 20, 20, 4894, 290, 129.32896, 136.72948, 88.31491, 82.82786, 253, 1, 333, 0, 0, 0, 48, 30, 0, 1), 
(18300, 18300, "Offering of the Branded Evoked Spirit", 0, "", 0, "LineageMonster.orc", 10, 21, 33, "male", "L2Npc", 40, 702.20463, 372.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1751, 100, 113.49065, 129.23095, 77.49941, 78.28541, 253, 4, 333, 158, 0, 0, 45, 155, 0, 1), 
(18301, 18301, "Flame of Apostates", 0, "", 0, "LineageMonster.big_boom", 6, 13, 46, "male", "L2Npc", 40, 3689.36034, 637.8, 16.5, 2.1, 40, 43, 30, 21, 20, 20, 8454, 599, 248.0526, 182.18816, 169.38777, 110.36578, 253, 1, 333, 0, 0, 0, 48, 30, 0, 1), 
(18302, 18302, "Offering of Apostates Evoked Spirit", 0, "", 0, "LineageMonster.orc_fighter", 12, 22, 44, "male", "L2Npc", 40, 1138.62924, 584, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3113, 213, 222.23112, 173.43552, 151.75505, 105.06362, 253, 4, 333, 172, 0, 0, 45, 160, 0, 1), 
(18303, 18303, "Flame of the Witch", 0, "", 0, "LineageMonster.big_boom", 6, 13, 57, "male", "L2Npc", 40, 5329.74054, 948, 19.5, 2.4, 40, 43, 30, 21, 20, 20, 12980, 1079, 424.23295, 233.18839, 289.69611, 141.26065, 253, 1, 333, 0, 0, 0, 48, 30, 0, 1), 
(18304, 18304, "Offering of the Witch Evoked Spirit", 0, "", 0, "LineageMonster.batur_orc", 9, 21.5, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 4864, 393, 388.11142, 223.6362, 265.02979, 135.47414, 253, 4, 333, 91, 0, 0, 80, 165, 0, 1), 
(18305, 18305, "Flame of Dark Omen", 0, "", 0, "LineageMonster.big_boom", 6, 13, 68, "male", "L2Npc", 40, 7037.30094, 1282.4, 22.5, 2.7, 40, 43, 30, 21, 20, 20, 18473, 1784, 646.17968, 286.3615, 441.25696, 173.47182, 253, 1, 333, 0, 0, 0, 48, 30, 0, 1), 
(18306, 18306, "Offering of Dark Omen Evoked Spirit", 0, "", 0, "LineageMonster.batur_orc", 9, 21.5, 66, "male", "L2Npc", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 7004, 659, 603.79903, 276.72752, 412.31647, 167.63575, 253, 4, 333, 2503, 0, 0, 80, 170, 0, 1), 
(18307, 18307, "Flame of Forbidden Path", 0, "", 0, "LineageMonster.big_boom", 6, 13, 78, "male", "L2Npc", 40, 8612.332226, 1657.41, 25.755, 3.03, 40, 43, 30, 21, 20, 20, 24933, 2763, 884.25257, 340.44078, 609.86817, 206.23192, 253, 1, 333, 0, 0, 0, 48, 30, 0, 1), 
(18308, 18308, "Offering of /Forbidden Path Evoked Spirit", 0, "", 0, "LineageMonster.batur_orc_warrior", 10, 20, 77, "male", "L2Npc", 40, 2762.08447, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 9534, 1032, 835.75573, 328.27073, 570.71283, 198.85955, 253, 4, 333, 175, 0, 0, 80, 175, 0, 1), 
(18309, 18309, "Flame of the Branded", 0, "", 0, "LineageMonster.big_boom", 6, 13, 35, "male", "L2Npc", 40, 2318.21406, 402.6, 13.5, 1.8, 40, 43, 30, 21, 20, 20, 4894, 290, 129.32896, 136.72948, 88.31491, 82.82786, 253, 1, 333, 0, 0, 0, 48, 30, 0, 1), 
(18310, 18310, "Offering of the Branded Evoked Spirit", 0, "", 0, "LineageMonster.orc", 10, 21, 33, "male", "L2Npc", 40, 702.20463, 372.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1751, 100, 113.49065, 129.23095, 77.49941, 78.28541, 253, 4, 333, 158, 0, 0, 45, 155, 0, 1), 
(18311, 18311, "Flame of Apostates", 0, "", 0, "LineageMonster.big_boom", 6, 13, 46, "male", "L2Npc", 40, 3689.36034, 637.8, 16.5, 2.1, 40, 43, 30, 21, 20, 20, 8454, 599, 248.0526, 182.18816, 169.38777, 110.36578, 253, 1, 333, 0, 0, 0, 48, 30, 0, 1), 
(18312, 18312, "Offering of Apostates Evoked Spirit", 0, "", 0, "LineageMonster.orc_fighter", 12, 22, 44, "male", "L2Npc", 40, 1138.62924, 584, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3113, 213, 222.23112, 173.43552, 151.75505, 105.06362, 253, 4, 333, 172, 0, 0, 45, 160, 0, 1), 
(18313, 18313, "Flame of the Witch", 0, "", 0, "LineageMonster.big_boom", 6, 13, 57, "male", "L2Npc", 40, 5329.74054, 948, 19.5, 2.4, 40, 43, 30, 21, 20, 20, 12980, 1079, 424.23295, 233.18839, 289.69611, 141.26065, 253, 1, 333, 0, 0, 0, 48, 30, 0, 1), 
(18314, 18314, "Offering of the Witch Evoked Spirit", 0, "", 0, "LineageMonster.batur_orc", 9, 21.5, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 4864, 393, 388.11142, 223.6362, 265.02979, 135.47414, 253, 4, 333, 91, 0, 0, 80, 165, 0, 1), 
(18315, 18315, "Flame of Dark Omen", 0, "", 0, "LineageMonster.big_boom", 6, 13, 68, "male", "L2Npc", 40, 7037.30094, 1282.4, 22.5, 2.7, 40, 43, 30, 21, 20, 20, 18473, 1784, 646.17968, 286.3615, 441.25696, 173.47182, 253, 1, 333, 0, 0, 0, 48, 30, 0, 1), 
(18316, 18316, "Offering of Dark Omen Evoked Spirit", 0, "", 0, "LineageMonster.batur_orc", 9, 21.5, 66, "male", "L2Npc", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 7004, 659, 603.79903, 276.72752, 412.31647, 167.63575, 253, 4, 333, 2503, 0, 0, 80, 170, 0, 1), 
(18317, 18317, "Flame of Forbidden Path", 0, "", 0, "LineageMonster.big_boom", 6, 13, 78, "male", "L2Npc", 40, 8527.06161, 1641, 25.5, 3, 40, 43, 30, 21, 20, 20, 24933, 2763, 875.49759, 337.07008, 609.86817, 204.19002, 253, 1, 333, 0, 0, 0, 48, 30, 0, 1), 
(18318, 18318, "Offering of Forbidden Path Evoked Spirit", 0, "", 0, "LineageMonster.batur_orc_warrior", 10, 20, 77, "male", "L2Npc", 40, 2762.08447, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 9534, 1032, 835.75573, 328.27073, 570.71283, 198.85955, 253, 4, 333, 175, 0, 0, 80, 175, 0, 1), 
(18319, 18319, "Caught Frog", 0, "", 0, "LineageMonster.poison_toad", 20, 10, 10, "male", "L2PenaltyMonster", 40, 163.28607, 108.4, 2, 0.9, 40, 43, 30, 21, 20, 20, 422, 14, 19.33758, 52.55148, 13.20506, 37.45246, 253, 1, 333, 0, 0, 0, 50, 110, 0, 1), 
(18320, 18320, "Caught Undine", 0, "", 0, "LineageMonster.undine", 12, 27, 20, "female", "L2PenaltyMonster", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 844, 37, 44.32863, 73.83992, 30.2707, 52.62433, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(18321, 18321, "Caught Rakul", 0, "", 0, "LineageMonster.rakul", 30, 39, 30, "male", "L2PenaltyMonster", 40, 604.08419, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1550, 85, 92.64226, 100.69463, 63.26266, 71.76319, 253, 1, 333, 156, 0, 0, 60, 130, 0, 1), 
(18322, 18322, "Caught Sea Giant", 0, "", 0, "LineageMonster.water_giant", 13, 44, 40, "male", "L2PenaltyMonster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2756, 178, 176.36077, 133.0678, 120.43155, 94.83493, 253, 4, 333, 131, 0, 0, 35, 140, 0, 1), 
(18323, 18323, "Caught Sea Horse Soldier", 0, "", 0, "LineageMonster.theeder", 9, 32, 50, "male", "L2PenaltyMonster", 80, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4306, 324, 305.54906, 170.20267, 208.6504, 121.30026, 253, 4, 333, 291, 0, 0, 80, 150, 0, 1), 
(18324, 18324, "Caught Homunculus", 0, "", 0, "LineageMonster2.homunculus", 12, 32.5, 60, "male", "L2PenaltyMonster", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 6200, 538, 481.34551, 210.50257, 328.69659, 150.02125, 253, 4, 333, 0, 0, 0, 30, 160, 0, 1), 
(18325, 18325, "Caught Flava", 0, "", 0, "LineageMonster2.flava", 18, 34, 70, "male", "L2PenaltyMonster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 8439, 837, 688.86373, 251.52857, 470.40463, 179.25972, 253, 1, 333, 0, 0, 0, 30, 170, 0, 1), 
(18326, 18326, "Caught Gigantic Eye", 0, "", 0, "LineageMonster2.hundred_eye", 21, 55, 78, "male", "L2PenaltyMonster", 40, 2880.37628, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 11022, 1237, 894.75854, 290.16875, 635.68866, 206.79785, 253, 1, 333, 0, 0, 0, 30, 180, 0, 1), 
(18327, 18327, "Freya's Servant", 0, "", 0, "LineageMonster.gargoyle_02te", 16, 50, 58, "male", "L2Monster", 40, 1828.68266, 977.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 387.5368, 237.99429, 302.44274, 158.4515, 253, 8, 333, 0, 0, 0, 140, 140, 0, 1), 
(18328, 18328, "Hall Alarm Device", 0, "", 0, "LineageNPC.grave_keeper_key", 8, 21, 83, "male", "L2Monster", 40, 100000, 1846.8, 8.8, 3.1, 40, 43, 30, 21, 20, 20, 0, 0, 1034.34087, 378.92625, 760.91932, 277.28179, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(18329, 18329, "Hall Keeper Captain", 0, "", 0, "LineageMonster.death_lord", 21, 40, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 78, 0, 0, 40, 160, 0, 1), 
(18330, 18330, "Hall Keeper Wizard", 0, "", 0, "LineageMonster.vale_master", 12, 40, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 326, 0, 0, 70, 175, 0, 1), 
(18331, 18331, "Hall Keeper Guard", 0, "", 0, "LineageMonster.death_knight", 12, 31, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 142, 0, 0, 27, 110, 0, 1), 
(18332, 18332, "Hall Keeper Patrol", 0, "", 0, "LineageMonster.headless_knight", 21, 31, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 124, 0, 0, 70, 170, 0, 1), 
(18333, 18333, "Hall Keeper Suicidal Soldier", 0, "", 0, "LineageMonster3.self_blaster", 9, 25.8, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(18334, 18334, "Dark Choir Captain", 0, "", 0, "LineageMonster2.erinyes_cmd", 21, 50, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 1, 333, 0, 0, 0, 31, 150, 0, 1), 
(18335, 18335, "Dark Choir Prima Donna", 0, "", 0, "LineageMonster3.portrait_spirit", 23, 40, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 30, 200, 0, 1), 
(18336, 18336, "Dark Choir Lancer", 0, "", 0, "LineageMonster.death_blader", 15, 45, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 1472, 0, 0, 100, 180, 0, 1), 
(18337, 18337, "Dark Choir Archer", 0, "", 0, "LineageMonster.skeleton_archer_20_bi", 13, 32.5, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 1, 333, 279, 0, 0, 40, 140, 0, 1), 
(18338, 18338, "Dark Choir Witch Doctor", 0, "", 0, "LineageMonster3.portrait_spirit_winged", 23, 40, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 30, 190, 0, 1), 
(18339, 18339, "Dark Choir Player", 0, "", 0, "LineageMonster.skeleton", 11, 25, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 150, 103, 0, 60, 140, 0, 1), 
(18340, 18340, "Hall Keeper Suicidal Soldier", 0, "", 0, "LineageMonster3.self_blaster", 9, 25.8, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 30, 100, 0, 1), 
(18341, 18341, "Hall Keeper Suicidal Soldier", 0, "", 0, "LineageMonster3.self_blaster", 9, 25.8, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(18342, 18342, "Gremlin", 0, "", 0, "LineageMonster.gremlin", 10, 15, 1, "male", "L2Monster", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 29, 2, 8.47458, 44.44444, 5.78704, 29.59016, 253, 4, 333, 0, 0, 0, 20, 50, 0, 1), 
(18343, 18343, "Gatekeeper Zombie", 0, "", 0, "LineageMonster3.zombie_gateguard", 17, 30.5, 78, "male", "L2Monster", 40, 2985.1835, 1777.4, 8.65, 3.05, 40, 43, 30, 21, 20, 20, 0, 0, 1025.486, 373.32382, 742.05697, 273.1822, 253, 1, 333, 8217, 0, 0, 33, 120, 0, 1), 
(18344, 18344, "Ancient Egg", 0, "", 0, "LineageNpcEV.dinosaur_nest", 53, 11.5, 78, "etc", "L2Monster", 40, 10, 1881.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 998.77667, 365.6202, 709.5892, 267.545, 253, 1, 333, 0, 0, 0, 50, 100, 0, 1), 
(18345, 18345, "Sprigant", 0, "", 0, "LineageMonster3.Arachnoid", 45, 67, 78, "female", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 8267, 961, 890.50086, 332.70061, 608.09666, 243.45587, 253, 1, 333, 0, 0, 0, 60, 165, 0, 1), 
(18346, 18346, "Sprigant", 0, "", 0, "LineageMonster3.Arachnoid", 45, 67, 78, "female", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 8267, 961, 890.50086, 332.70061, 608.09666, 243.45587, 253, 1, 333, 0, 0, 0, 60, 150, 0, 1), 
(18347, 18347, "Garden Guard", 0, "", 0, "LineageMonster4.Mostro_Fighter", 15.5, 22.5, 20, "male", "L2Monster", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 708, 31, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 0, 0, 0, 36, 120, 0, 1), 
(18348, 18348, "Garden Guard", 0, "", 0, "LineageMonster4.Mostro_Fighter", 15.5, 22.5, 21, "male", "L2Monster", 40, 364.30351, 205.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 949, 35, 47.91924, 89.73059, 32.72263, 65.66095, 253, 4, 333, 0, 0, 0, 36, 110, 0, 1), 
(18349, 18349, "Garden Guard", 0, "", 0, "LineageMonster4.Mostro_Gunner", 15, 24.5, 21, "male", "L2Monster", 700, 364.30351, 205.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 907, 41, 47.91924, 89.73059, 32.72263, 65.66095, 253, 10, 333, 10128, 0, 0, 36, 110, 0, 1), 
(18350, 18350, "Garden Guard", 0, "", 0, "LineageMonster4.Mostro_Fighter", 15.5, 22.5, 21, "male", "L2Monster", 40, 364.30351, 205.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1000, 35, 47.91924, 89.73059, 32.72263, 65.66095, 253, 4, 333, 0, 0, 0, 36, 110, 0, 1), 
(18351, 18351, "Garden Guard", 0, "", 0, "LineageMonster4.Mostro_Fighter", 15.5, 22.5, 21, "male", "L2Monster", 40, 364.30351, 205.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 952, 35, 47.91924, 89.73059, 32.72263, 65.66095, 253, 4, 333, 0, 0, 0, 36, 110, 0, 1), 
(18352, 18352, "Kamael Guard", 0, "", 0, "LineageMonster4.Mostro_Fighter", 15.5, 22.5, 22, "male", "L2Monster", 40, 387.02878, 218.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1808, 68, 51.75278, 92.65694, 35.34044, 67.80232, 253, 4, 333, 0, 0, 0, 36, 130, 0, 1), 
(18353, 18353, "Guardian of Records", 0, "", 0, "LineageMonster4.Mostro_Fighter", 15.5, 22.5, 22, "male", "L2Monster", 40, 387.02878, 218.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 2401, 99, 51.75278, 92.65694, 35.34044, 67.80232, 253, 4, 333, 0, 0, 0, 36, 130, 0, 1), 
(18354, 18354, "Guardian of Observation", 0, "", 0, "LineageMonster4.Mostro_Fighter", 15.5, 22.5, 22, "male", "L2Monster", 40, 387.02878, 218.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1808, 68, 51.75278, 92.65694, 35.34044, 67.80232, 253, 4, 333, 0, 0, 0, 36, 130, 0, 1), 
(18355, 18355, "Spicula's Guard", 0, "", 0, "LineageMonster4.Mostro_Fighter", 15.5, 22.5, 22, "male", "L2Monster", 40, 387.02878, 218.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 2542, 99, 51.75278, 92.65694, 35.34044, 67.80232, 253, 4, 333, 0, 0, 0, 36, 130, 0, 1), 
(18356, 18356, "Harkilgamed's Gatekeeper", 0, "", 0, "LineageMonster4.Mostro_Gunner", 15, 24.5, 22, "male", "L2Monster", 700, 387.02878, 218.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 2470, 111, 51.75278, 92.65694, 35.34044, 67.80232, 253, 10, 333, 10128, 0, 0, 36, 130, 0, 1), 
(18357, 18357, "Rodenpicula's Gatekeeper", 0, "", 0, "LineageMonster4.Mostro_Fighter", 15.5, 22.5, 22, "male", "L2Monster", 40, 387.02878, 218.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 2401, 99, 51.75278, 92.65694, 35.34044, 67.80232, 253, 4, 333, 0, 0, 0, 36, 130, 0, 1), 
(18358, 18358, "Guardian of Secrets", 0, "", 0, "LineageMonster4.Mostro_Fighter", 15.5, 22.5, 22, "male", "L2Monster", 40, 387.02878, 218.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1808, 68, 51.75278, 92.65694, 35.34044, 67.80232, 253, 4, 333, 0, 0, 0, 36, 130, 0, 1), 
(18359, 18359, "Arviterre's Guardian", 0, "", 0, "LineageMonster4.Mostro_Fighter", 15.5, 22.5, 22, "male", "L2Monster", 40, 387.02878, 218.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1808, 68, 51.75278, 92.65694, 35.34044, 67.80232, 253, 4, 333, 0, 0, 0, 36, 130, 0, 1), 
(18360, 18360, "Katenar's Gatekeeper", 0, "", 0, "LineageMonster4.Mostro_Fighter", 15.5, 22.5, 22, "male", "L2Monster", 40, 387.02878, 218.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1808, 68, 51.75278, 92.65694, 35.34044, 67.80232, 253, 4, 333, 0, 0, 0, 36, 130, 0, 1), 
(18361, 18361, "Guardian of Prediction", 0, "", 0, "LineageMonster4.Mostro_Fighter", 15.5, 22.5, 22, "male", "L2Monster", 40, 387.02878, 218.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 2401, 99, 51.75278, 92.65694, 35.34044, 67.80232, 253, 4, 333, 0, 0, 0, 36, 130, 0, 1), 
(18362, 18362, "Garden Guard", 0, "", 0, "LineageMonster4.Mostro_Fighter", 15.5, 22.5, 19, "male", "L2Monster", 40, 321.63954, 183.28, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 742, 30, 40.96915, 84.07638, 27.97662, 61.52345, 253, 4, 333, 0, 0, 0, 36, 120, 0, 1), 
(18363, 18363, "Garden Guard", 0, "", 0, "LineageMonster4.Mostro_Gunner", 15, 24.5, 19, "male", "L2Monster", 700, 321.63954, 183.28, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 670, 29, 40.96915, 84.07638, 27.97662, 61.52345, 253, 10, 333, 10128, 0, 0, 36, 110, 0, 1), 
(18364, 18364, "Witch Warder", 0, "", 0, "LineageMonster.onyx_beast", 14, 14.5, 79, "male", "L2Monster", 40, 2842.35387, 1641, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 875.49759, 337.07008, 597.85136, 246.65326, 253, 4, 333, 0, 0, 0, 30, 170, 0, 1), 
(18365, 18365, "Witch Warder", 0, "", 0, "LineageMonster.onyx_beast", 14, 14.5, 80, "male", "L2Monster", 40, 2880.37628, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 894.75854, 341.375, 611.00409, 249.80341, 253, 4, 333, 0, 0, 0, 30, 170, 0, 1), 
(18366, 18366, "Witch Warder", 0, "", 0, "LineageMonster.onyx_beast", 14, 14.5, 82, "male", "L2Monster", 40, 2951.85588, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 931.81944, 349.77477, 636.31188, 255.95, 253, 4, 333, 0, 0, 0, 30, 170, 0, 1), 
(18367, 18367, "Prison Guard", 0, "", 0, "LineageMonster3.zombie_gateguard", 17, 30.5, 80, "male", "L2Monster", 40, 2880.37628, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 894.75854, 341.375, 611.00409, 249.80341, 253, 4, 333, 8217, 0, 0, 33, 50, 0, 1), 
(18368, 18368, "Prison Guard", 0, "", 0, "LineageMonster3.zombie_gateguard", 17, 30.5, 80, "male", "L2Monster", 40, 2880.37628, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 8579, 962, 894.75854, 341.375, 611.00409, 249.80341, 253, 4, 333, 8217, 0, 0, 33, 160, 0, 1), 
(18369, 18369, "Chromatic Crystalline Golem", 0, "", 0, "LineageMonster4.Crystal_Golem", 34, 47, 82, "male", "L2Monster", 40, 2951.85588, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 9308, 1017, 931.81944, 349.77477, 636.31188, 255.95, 253, 4, 333, 0, 0, 0, 54, 170, 0, 1), 
(18370, 18370, "Chromatic Crystalline Golem", 0, "", 0, "LineageMonster4.Crystal_Golem", 34, 47, 82, "male", "L2Monster", 40, 2951.85588, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 8545, 934, 931.81944, 349.77477, 636.31188, 255.95, 253, 4, 333, 0, 0, 0, 54, 170, 0, 1), 
(18371, 18371, "Beleth Sample", 0, "", 0, "LineageMonster3.zombie_gateguard", 17, 30.5, 82, "male", "L2Monster", 40, 2951.85588, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 7697, 841, 931.81944, 349.77477, 636.31188, 255.95, 253, 4, 333, 8217, 0, 0, 33, 50, 0, 1), 
(18372, 18372, "Beleth Sample", 0, "", 0, "LineageMonster3.zombie_laborer", 11, 24.6, 82, "male", "L2Monster", 40, 2951.85588, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 7697, 841, 931.81944, 349.77477, 636.31188, 255.95, 253, 4, 333, 123, 0, 0, 36, 180, 0, 1), 
(18373, 18373, "Beleth Sample", 0, "", 0, "LineageMonster3.zombie_enlisted_man", 17, 22.3, 82, "male", "L2Monster", 40, 2951.85588, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 7697, 841, 931.81944, 349.77477, 636.31188, 255.95, 253, 4, 333, 0, 0, 0, 38, 200, 0, 1), 
(18374, 18374, "Beleth Sample", 0, "", 0, "LineageMonster3.zombie_em_knight", 17, 22.3, 82, "male", "L2Monster", 40, 2951.85588, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 7697, 841, 931.81944, 349.77477, 636.31188, 255.95, 253, 4, 333, 8215, 0, 0, 38, 200, 0, 1), 
(18375, 18375, "Beleth Sample", 0, "", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 82, "male", "L2Monster", 40, 2951.85588, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 7697, 841, 931.81944, 349.77477, 636.31188, 255.95, 253, 4, 333, 946, 945, 0, 80, 15, 0, 1), 
(18376, 18376, "Beleth Sample", 0, "", 0, "LineageMonster.vale_master", 12, 40, 82, "male", "L2Monster", 40, 2951.85588, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 7697, 841, 931.81944, 349.77477, 636.31188, 255.95, 253, 4, 333, 205, 0, 0, 70, 155, 0, 1), 
(18377, 18377, "Beleth Sample", 0, "", 0, "LineageMonster.skeleton_knight", 10, 25, 82, "male", "L2Monster", 40, 2951.85588, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 7697, 841, 931.81944, 349.77477, 636.31188, 255.95, 253, 4, 333, 150, 103, 0, 40, 160, 0, 1), 
(18378, 18378, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_switch", 19, 13, 78, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18379, 18379, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18380, 18380, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18381, 18381, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18382, 18382, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18383, 18383, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18384, 18384, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18385, 18385, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18386, 18386, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18387, 18387, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18388, 18388, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18389, 18389, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18390, 18390, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18391, 18391, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18392, 18392, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18393, 18393, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18394, 18394, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18395, 18395, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18396, 18396, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18397, 18397, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18398, 18398, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18399, 18399, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18400, 18400, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18401, 18401, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18402, 18402, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18403, 18403, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18404, 18404, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18405, 18405, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18406, 18406, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18407, 18407, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18408, 18408, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18409, 18409, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18410, 18410, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18411, 18411, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18412, 18412, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18413, 18413, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18414, 18414, "Warrior's Gatekeeper", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 18, "etc", "L2Npc", 40, 301.66622, 174.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 37.82932, 81.34791, 25.83252, 59.52687, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(18415, 18415, "Midway Gatekeeper", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 18, "etc", "L2Npc", 40, 301.66622, 174.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 37.82932, 81.34791, 25.83252, 59.52687, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(18416, 18416, "Doorman", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 18, "etc", "L2Npc", 40, 301.66622, 174.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 37.82932, 81.34791, 25.83252, 59.52687, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(18417, 18417, "Bridge Keeper", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 18, "etc", "L2Npc", 40, 301.66622, 174.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 37.82932, 81.34791, 25.83252, 59.52687, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(18418, 18418, "Bridge Keeper", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 18, "etc", "L2Npc", 40, 301.66622, 174.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 37.82932, 81.34791, 25.83252, 59.52687, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(18419, 18419, "Bridge Keeper", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 18, "etc", "L2Npc", 40, 301.66622, 174.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 37.82932, 81.34791, 25.83252, 59.52687, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(18420, 18420, "Trap", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 18, "etc", "L2Npc", 40, 301.66622, 174.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 37.82932, 81.34791, 25.83252, 59.52687, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(18427, 18427, "", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18428, 18428, "", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18429, 18429, "", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18430, 18430, "", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18431, 18431, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18432, 18432, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_wall_switch", 24, 38, 78, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18433, 18433, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18434, 18434, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18435, 18435, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18436, 18436, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18437, 18437, "Trap", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 18, "male", "L2Npc", 40, 301.66622, 174.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 37.82932, 81.34791, 25.83252, 59.52687, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18438, 18438, "Trap", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 15, "etc", "L2Npc", 40, 301.66622, 174.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 37.82932, 81.34791, 25.83252, 59.52687, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(18441, 18441, "Kamael Gatekeeper", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 18, "etc", "L2Npc", 40, 301.66622, 174.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 37.82932, 81.34791, 25.83252, 59.52687, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(18442, 18442, "Trap", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 18, "etc", "L2Npc", 40, 301.66622, 174.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 37.82932, 81.34791, 25.83252, 59.52687, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(18443, 18443, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 78, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(18444, 18444, "Garden Guard", 0, "", 0, "LineageMonster4.Mostro_Fighter", 15.5, 22.5, 20, "male", "L2Monster", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 816, 36, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 0, 0, 0, 36, 120, 0, 1), 
(18445, 18445, "Tully's Gatekeeper", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 80, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18446, 18446, "Tully's Gatekeeper", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 80, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18447, 18447, "Tully's Gatekeeper", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 80, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18448, 18448, "Tully's Gatekeeper", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 80, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18449, 18449, "Tully's Gatekeeper", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 80, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18450, 18450, "Tully's Gatekeeper", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 80, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18451, 18451, "Tully's Gatekeeper", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 80, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18452, 18452, "Tully's Gatekeeper", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 80, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18453, 18453, "Tully's Gatekeeper", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 80, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18454, 18454, "Tully's Gatekeeper", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 80, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18455, 18455, "Tully's Gatekeeper", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 80, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18456, 18456, "Tully's Gatekeeper", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 80, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18457, 18457, "Tully's Gatekeeper", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 80, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18458, 18458, "Tully's Gatekeeper", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 80, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18459, 18459, "Tully's Gatekeeper", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 80, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18460, 18460, "Tully's Gatekeeper", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 80, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18461, 18461, "Tully's Gatekeeper", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 80, "etc", "L2Npc", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18463, 18463, "Remnant Diabolist", 0, "", 0, "LineageNPC.e_traderB_Fdwarf_mon_120p", 8, 22, 81, "female", "L2Monster", 1100, 65918.445622, 1708.8, 113.265441, 3, 40, 43, 30, 21, 20, 20, 260217, 28102, 5655.33186, 572.83923, 3907.29218, 628.76834, 253, 8, 333, 8527, 0, 0, 49, 160, 0, 1), 
(18464, 18464, "Remnant Diviner", 0, "", 0, "LineageNPC.a_mageguild_teacher_Mhuman_mon", 8, 23, 81, "male", "L2Monster", 40, 65918.445622, 1708.8, 113.265441, 3, 40, 43, 30, 21, 20, 20, 254867, 27524, 5655.33186, 572.83923, 3907.29218, 628.76834, 253, 4, 333, 8532, 0, 0, 50, 160, 0, 1), 
(18465, 18465, "Derek", 0, "First Generation Seer", 0, "LineageNPC.a_mageguild_teacher_Mhuman_mon_120p", 10, 28.1, 81, "male", "L2Monster", 40, 338766.602168, 1708.8, 194.030407, 3, 40, 43, 30, 21, 20, 20, 1067320, 115266, 7824.36515, 572.83923, 5405.88625, 628.76834, 253, 4, 333, 8678, 0, 0, 50, 160, 0, 1), 
(18466, 18466, "Outpost Captain", 0, "", 0, "LineageMonster3.benom", 20, 56, 81, "male", "L2Monster", 40, 111546.700058, 1846.8, 187.260794, 3, 40, 43, 30, 21, 20, 20, 0, 0, 9311.83315, 592.48128, 6508.39315, 650.32814, 253, 4, 333, 8203, 8203, 0, 79, 220, 0, 1), 
(18467, 18467, "Wounded Land Guard", 0, "", 0, "LineageMonster4.eyeless", 36, 43.5, 81, "male", "L2Monster", 40, 336061.04902, 1812, 189.142969, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7957.47326, 582.69205, 5529.81543, 639.58314, 253, 4, 333, 0, 0, 0, 60, 210, 0, 1), 
(18468, 18468, "Doorman", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 18, "etc", "L2Npc", 40, 301.66622, 174.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 37.82932, 81.34791, 25.83252, 59.52687, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(18469, 18469, "Hall Guard", 0, "", 0, "LineageMonster.blade_stakato_120p", 18, 43.2, 83, "male", "L2Npc", 40, 32829.283195, 1777.4, 111.507051, 3, 40, 43, 30, 21, 20, 20, 253630, 26086, 5815.28895, 566.1783, 3971.08851, 621.45708, 253, 4, 333, 0, 0, 0, 25, 180, 0, 1), 
(18470, 18470, "Hall Guard", 0, "", 0, "LineageMonster.blade_stakato_soldier_120p", 23, 45.5, 83, "male", "L2Npc", 40, 32829.283195, 1777.4, 111.507051, 3, 40, 43, 30, 21, 20, 20, 103029, 11126, 5815.28895, 566.1783, 3971.08851, 621.45708, 253, 4, 333, 0, 0, 0, 25, 180, 0, 1), 
(18471, 18471, "Hall Guard", 0, "", 0, "LineageMonster4.Anthias", 20, 41, 83, "male", "L2Npc", 40, 32829.283195, 1777.4, 111.507051, 3, 40, 43, 30, 21, 20, 20, 45987, 4761, 5815.28895, 566.1783, 3971.08851, 621.45708, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), 
(18472, 18472, "Hall Guard", 0, "", 0, "LineageMonster4.Anthias", 20, 41, 83, "male", "L2Npc", 40, 32829.283195, 1777.4, 111.507051, 3, 40, 43, 30, 21, 20, 20, 112394, 12138, 5815.28895, 566.1783, 3971.08851, 621.45708, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), 
(18473, 18473, "Hall Captain", 0, "", 0, "LineageMonster3.cannibal_stakato_leader_120p", 34, 48.8, 83, "male", "L2Npc", 40, 336949.124088, 1777.4, 190.745373, 3, 40, 43, 30, 21, 20, 20, 724449, 78237, 7733.38416, 566.1783, 5280.89889, 621.45708, 253, 4, 333, 0, 0, 0, 40, 250, 0, 1), 
(18474, 18474, "Alarm", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 83, "etc", "L2Monster", 40, 2985.1835, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 949.52401, 353.86144, 648.40181, 258.94045, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(18475, 18475, "Hall Guard", 0, "", 0, "LineageMonster.undine", 12, 27, 83, "female", "L2Npc", 40, 32829.283195, 1777.4, 111.507051, 3, 40, 43, 30, 21, 20, 20, 90678, 9792, 5815.28895, 566.1783, 3971.08851, 621.45708, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), 
(18476, 18476, "Hall Guard", 0, "", 0, "LineageMonster.lienrik_210p", 12, 50, 83, "male", "L2Npc", 40, 32829.283195, 1777.4, 111.507051, 3, 40, 43, 30, 21, 20, 20, 104688, 11305, 5815.28895, 566.1783, 3971.08851, 621.45708, 253, 4, 333, 0, 0, 0, 100, 180, 0, 1), 
(18477, 18477, "Coral Treasure Chest", 0, "", 0, "LineageMonster.mimic_even", 8.5, 8.5, 83, "male", "L2Chest", 40, 2985.1835, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 949.52401, 353.86144, 648.40181, 258.94045, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(18478, 18478, "Herb Jar", 0, "", 0, "LineageNpcEV.herb_pot", 8, 21.5, 15, "male", "L2Monster", 40, 246.95422, 149.2, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 29.61691, 73.55216, 20.22451, 53.82228, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18479, 18479, "Inner Castle Sentry", 0, "", 0, "LineageMonster.kel_mahum", 13, 26, 81, "male", "L2Npc", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1216.84607, 370.3008, 850.49984, 270.97006, 253, 4, 333, 0, 0, 0, 50, 180, 0, 1), 
(18480, 18480, "Inner Castle Guard", 0, "", 0, "LineageMonster4.eyeless", 36, 43.5, 81, "male", "L2Npc", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1216.84607, 370.3008, 850.49984, 270.97006, 253, 4, 333, 0, 0, 0, 60, 210, 0, 1), 
(18481, 18481, "Inner Castle Seer", 0, "", 0, "LineageMonster4.eyeless", 36, 43.5, 81, "male", "L2Npc", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1216.84607, 370.3008, 850.49984, 270.97006, 253, 4, 333, 0, 0, 0, 60, 210, 0, 1), 
(18482, 18482, "Fafurion Kindred", 0, "", 0, "LineageMonster3.Water_Drake", 55, 80.5, 82, "female", "L2Monster", 40, 2951.85588, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 931.81944, 349.77477, 636.31188, 255.95, 253, 4, 333, 0, 0, 0, 60, 160, 0, 1), 
(18483, 18483, "Garden Guard", 0, "", 0, "LineageMonster4.Mostro_Fighter", 15.5, 22.5, 19, "male", "L2Monster", 40, 321.63954, 183.28, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 1353, 57, 40.96915, 84.07638, 27.97662, 61.52345, 253, 4, 333, 0, 0, 0, 36, 120, 0, 1), 
(18484, 18484, "Naia Failan", 0, "", 0, "LineageNPC.heart_of_warding", 17, 120, 83, "etc", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 50, 80, 0, 1), 
(18485, 18485, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 78, "male", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18486, 18486, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 78, "male", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18487, 18487, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 78, "male", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18488, 18488, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 78, "male", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18489, 18489, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 78, "male", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18490, 18490, "Beleth's Slave", 0, "", 0, "LineageMonster4.devil_doll", 8, 17.5, 86, "female", "L2Monster", 40, 18540.117034, 1881.8, 185.679969, 3, 40, 43, 30, 21, 20, 20, 65975, 6876, 10366.89978, 584.99232, 7079.24864, 642.108, 253, 4, 333, 0, 0, 0, 60, 160, 0, 1), 
(18491, 18491, "Lock", 0, "Tower of Naia", 0, "LineageNpcEV.soulprison", 21, 53, 87, "male", "L2Monster", 40, 597541.868316, 1917, 0, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1, 1300.14544, 1, 1451.95954, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18492, 18492, "Controller", 0, "Tower of Naia", 0, "LineageNpcEV.elobrate_machine", 13, 20, 87, "male", "L2Npc", 40, 4656.720016, 1917, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1280.04975, 369.3595, 874.10805, 270.28125, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18493, 18493, "Ward", 0, "Tower of Naia", 0, "LineageMonster2.hundred_eye", 21, 55, 87, "male", "L2Monster", 40, 10160613.53938, 1917, 330.315166, 3, 40, 43, 30, 21, 20, 20, 0, 0, 13067.54736, 738.719, 8923.44082, 1081.125, 253, 4, 333, 0, 0, 0, 30, 170, 0, 1), 
(18494, 18494, "Ingenious Contraption", 0, "", 0, "LineageNpcEV.elobrate_machine", 13, 20, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18495, 18495, "Ingenious Contraption", 0, "", 0, "LineageNpcEV.elobrate_machine", 13, 20, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18496, 18496, "Ingenious Contraption", 0, "", 0, "LineageNpcEV.elobrate_machine", 13, 20, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18497, 18497, "Ingenious Contraption", 0, "", 0, "LineageNpcEV.elobrate_machine", 13, 20, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18498, 18498, "Ingenious Contraption", 0, "", 0, "LineageNpcEV.elobrate_machine", 13, 20, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18499, 18499, "Ingenious Contraption", 0, "", 0, "LineageNpcEV.elobrate_machine", 13, 20, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18500, 18500, "Ingenious Contraption", 0, "", 0, "LineageNpcEV.elobrate_machine", 13, 20, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18501, 18501, "Ingenious Contraption", 0, "", 0, "LineageNpcEV.elobrate_machine", 13, 20, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18502, 18502, "Ingenious Contraption", 0, "", 0, "LineageNpcEV.elobrate_machine", 13, 20, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18503, 18503, "Ingenious Contraption", 0, "", 0, "LineageNpcEV.elobrate_machine", 13, 20, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18504, 18504, "Ingenious Contraption", 0, "", 0, "LineageNpcEV.elobrate_machine", 13, 20, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18505, 18505, "Ingenious Contraption", 0, "", 0, "LineageNpcEV.elobrate_machine", 13, 20, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18506, 18506, "Soul Crystal Pillar", 0, "", 0, "LineageNpcEV.soulprison", 21, 53, 87, "male", "L2Monster", 40, 4656.720016, 1917, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1280.04975, 369.3595, 874.10805, 270.28125, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18507, 18507, "", 0, "", 0, "LineageNpcEV.trap_ironcastle", 12, 20.4, 78, "male", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18508, 18508, "", 0, "", 0, "LineageNpcEV.trap_ironcastle", 12, 20.4, 78, "male", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18509, 18509, "", 0, "", 0, "LineageNpcEV.trap_ironcastle", 12, 20.4, 78, "male", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18510, 18510, "", 0, "", 0, "LineageNpcEV.trap_ironcastle", 12, 20.4, 78, "male", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18511, 18511, "", 0, "", 0, "LineageNpcEV.trap_ironcastle", 12, 20.4, 78, "male", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18512, 18512, "", 0, "", 0, "LineageNpcEV.trap_ironcastle", 12, 20.4, 78, "male", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18513, 18513, "", 0, "", 0, "LineageNpcEV.trap_ironcastle", 12, 20.4, 78, "male", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18514, 18514, "", 0, "", 0, "LineageNpcEV.trap_ironcastle", 12, 20.4, 78, "male", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18515, 18515, "", 0, "", 0, "LineageNpcEV.trap_ironcastle", 12, 20.4, 78, "male", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18516, 18516, "", 0, "", 0, "LineageNpcEV.trap_ironcastle", 12, 20.4, 78, "male", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18517, 18517, "", 0, "", 0, "LineageNpcEV.trap_ironcastle", 12, 20.4, 78, "male", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18518, 18518, "", 0, "", 0, "LineageNpcEV.trap_ironcastle", 12, 20.4, 78, "male", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18519, 18519, "", 0, "", 0, "LineageNpcEV.trap_ironcastle", 12, 20.4, 78, "male", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18520, 18520, "", 0, "", 0, "LineageNpcEV.trap_ironcastle", 12, 20.4, 78, "male", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18521, 18521, "", 0, "", 0, "LineageNpcEV.trap_ironcastle", 12, 20.4, 78, "male", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18522, 18522, "", 0, "", 0, "LineageNpcEV.trap_ironcastle", 12, 20.4, 78, "male", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18523, 18523, "", 0, "", 0, "LineageNpcEV.trap_ironcastle", 12, 20.4, 78, "male", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18524, 18524, "", 0, "", 0, "LineageNpcEV.trap_ironcastle", 12, 20.4, 78, "male", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18525, 18525, "", 0, "", 0, "LineageNpcEV.trap_ironcastle", 12, 20.4, 78, "male", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18526, 18526, "", 0, "", 0, "LineageNpcEV.trap_ironcastle", 12, 20.4, 78, "male", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18527, 18527, "", 0, "", 0, "LineageNpcEV.trap_ironcastle", 12, 20.4, 78, "male", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18528, 18528, "", 0, "", 0, "LineageNpcEV.trap_ironcastle", 12, 20.4, 78, "male", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18529, 18529, "", 0, "", 0, "LineageNpcEV.trap_ironcastle", 12, 20.4, 78, "male", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18530, 18530, "", 0, "", 0, "LineageNpcEV.trap_ironcastle", 12, 20.4, 78, "male", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18531, 18531, "", 0, "", 0, "LineageNpcEV.trap_ironcastle", 12, 20.4, 78, "male", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1); 

INSERT INTO `npc` VALUES
(18532, 18532, "", 0, "", 0, "LineageNpcEV.trap_ironcastle", 12, 20.4, 78, "male", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18533, 18533, "", 0, "", 0, "LineageNpcEV.trap_ironcastle", 12, 20.4, 78, "male", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18534, 18534, "Kertang's Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 45, "male", "L2Npc", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 234.89829, 177.78746, 160.40508, 130.09715, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(18535, 18535, "Kertang's Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 55, "male", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(18536, 18536, "Kertang's Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 65, "male", "L2Npc", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 582.81759, 271.89033, 397.98887, 198.95754, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(18537, 18537, "Kertang's Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(18538, 18538, "Kertang's Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 85, "male", "L2Npc", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(18539, 18539, "Resurrection Tower", 0, "", 0, "LineageNpcEV.resurrection_tower", 28, 50, 45, "male", "L2Npc", 40, 24126.895658, 610.8, 52.593979, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 964.76735, 284.45994, 658.81103, 312.23316, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18540, 18540, "Resurrection Tower", 0, "", 0, "LineageNpcEV.resurrection_tower", 28, 50, 55, "male", "L2Npc", 40, 46220.050661, 889.8, 93.757778, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 2217.1254, 357.81792, 1514.00925, 392.75345, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18541, 18541, "Resurrection Tower", 0, "", 0, "LineageNpcEV.resurrection_tower", 28, 50, 65, "male", "L2Npc", 40, 64711.130561, 1188.8, 122.743259, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 4492.80976, 435.02453, 3068.00672, 477.4981, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18542, 18542, "Resurrection Tower", 0, "", 0, "LineageNpcEV.resurrection_tower", 28, 50, 75, "male", "L2Npc", 40, 74307.946579, 1507.8, 132.352087, 3, 40, 43, 30, 21, 20, 20, 0, 0, 6388.10354, 510.79397, 4362.24666, 560.66527, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18543, 18543, "Resurrection Tower", 0, "", 0, "LineageNpcEV.resurrection_tower", 28, 50, 80, "male", "L2Npc", 40, 113229.052562, 1674.8, 195.708889, 3, 40, 43, 30, 21, 20, 20, 0, 0, 9005.41719, 546.2, 6149.53252, 599.52818, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18544, 18544, "Cruma Border", 0, "Event Monster", 0, "LineageNpcEV.trap_ironcastle", 12, 20.4, 45, "male", "L2Monster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 234.89829, 177.78746, 160.40508, 130.09715, 253, 4, 333, 0, 0, 0, 1, 1, 1, 1), 
(18545, 18545, "Ancient Experiment", 0, "Event Monster", 0, "LineageMonster.marsh_stakato_soldier", 10, 25, 45, "male", "L2Monster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 234.89829, 177.78746, 160.40508, 130.09715, 253, 4, 333, 127, 0, 0, 30, 155, 0, 1), 
(18546, 18546, "Ancient Experiment", 0, "Event Monster", 0, "LineageMonster.stone_golem", 20, 31, 45, "male", "L2Monster", 40, 12601.107361, 610.8, 27.469028, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 538.16588, 284.45994, 367.49753, 312.23316, 253, 1, 333, 0, 0, 0, 23, 23, 0, 1), 
(18547, 18547, "Ancient Experiment", 0, "Event Monster", 0, "LineageMonster.onyx_beast", 14, 14.5, 45, "male", "L2Monster", 40, 37803.322084, 610.8, 27.469028, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 336.33483, 284.45994, 229.67309, 312.23316, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(18548, 18548, "Ancient Experiment", 0, "", 0, "LineageMonster.onyx_beast", 14, 14.5, 45, "male", "L2Monster", 40, 12601.107361, 610.8, 27.469028, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 538.16588, 284.45994, 367.49753, 312.23316, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(18549, 18549, "Ancient Experiment", 0, "", 0, "LineageMonster.onyx_beast", 14, 14.5, 45, "male", "L2Monster", 40, 12601.107361, 610.8, 27.469028, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 538.16588, 284.45994, 367.49753, 312.23316, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(18550, 18550, "Cruma Phantom", 0, "Event Monster", 0, "LineageMonster.death_blader", 15, 45, 50, "male", "L2Monster", 40, 17718.402878, 747.8, 37.234811, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 792.06595, 320.3815, 540.87837, 351.66192, 253, 4, 333, 1472, 0, 0, 100, 170, 0, 1), 
(18551, 18551, "Cruma Phantom", 0, "Event Monster", 0, "LineageMonster.susceptor", 20, 35, 50, "male", "L2Monster", 40, 53155.208634, 747.8, 37.234811, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 491.12346, 320.3815, 335.37366, 351.66192, 253, 1, 333, 0, 0, 0, 27, 150, 0, 1), 
(18552, 18552, "Cruma Phantom", 0, "", 0, "LineageMonster.gamlin", 11, 32, 50, "male", "L2Monster", 40, 17718.402878, 747.8, 37.234811, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 792.06595, 320.3815, 540.87837, 351.66192, 253, 4, 333, 6307, 0, 0, 80, 170, 0, 1), 
(18553, 18553, "Cruma Phantom", 0, "", 0, "LineageMonster.leogul", 15, 35, 50, "male", "L2Monster", 40, 17718.402878, 747.8, 37.234811, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 792.06595, 320.3815, 540.87837, 351.66192, 253, 4, 333, 6307, 0, 0, 80, 170, 0, 1), 
(18554, 18554, "Tomlan Kamos", 0, "Kaneus", 0, "LineageMonster.bugbear_bi", 25, 53, 23, "male", "L2Monster", 40, 51638.884495, 1159.8, 10.662046, 4.8, 40, 43, 30, 21, 20, 20, 355901, 19458, 68.01129, 153.03962, 46.4429, 167.98162, 253, 4, 333, 4, 0, 0, 55, 130, 0, 1), 
(18555, 18555, "Ol Ariosh", 0, "Kaneus", 0, "LineageMonster.ol_mahum_champion_05te_120p", 16, 33.2, 26, "male", "L2Monster", 40, 60567.008055, 1365, 12.179235, 4.8, 40, 43, 30, 21, 20, 20, 397272, 23285, 99.21683, 168.04509, 67.75223, 184.45214, 253, 4, 333, 67, 633, 0, 50, 110, 0, 1), 
(18556, 18556, "Follower of Ariosh", 0, "", 0, "LineageMonster.ol_mahum_champion", 14, 27, 26, "male", "L2Monster", 40, 487.5704, 1365, 3.5, 4.8, 40, 43, 30, 21, 20, 20, 0, 0, 69.75926, 105.02818, 47.63653, 76.85506, 253, 4, 333, 69, 102, 0, 50, 110, 0, 1), 
(18557, 18557, "Ranc Deumus", 0, "Kaneus", 0, "LineageMonster.virud_lizardman_warrior_bi", 12, 34.5, 26, "male", "L2Monster", 40, 60567.008055, 1365, 12.179235, 4.8, 40, 43, 30, 21, 20, 20, 397272, 23285, 99.21683, 168.04509, 67.75223, 184.45214, 253, 4, 333, 93, 0, 0, 52, 130, 0, 1), 
(18558, 18558, "Crimson Hatu Otis", 0, "Kaneus", 0, "LineageMonster.crimson_bear", 19, 36, 33, "male", "L2Monster", 40, 77012.381628, 1864.8, 14.597634, 6.48, 40, 43, 30, 21, 20, 20, 549172, 35415, 191.5783, 206.76952, 130.82316, 226.95744, 253, 4, 333, 0, 0, 0, 37, 170, 0, 1), 
(18559, 18559, "Seer Flouros", 0, "Kaneus", 0, "LineageMonster.monster_eye_05te_ef", 21, 43, 36, "male", "L2Monster", 40, 94225.552737, 2088, 17.431727, 6.48, 40, 43, 30, 21, 20, 20, 620253, 41849, 246.07679, 224.91645, 168.03855, 246.87614, 253, 4, 333, 0, 0, 0, 90, 90, 0, 1), 
(18560, 18560, "Follower of Flouros", 0, "", 0, "LineageMonster.monster_eye", 21, 43, 36, "male", "L2Monster", 40, 809.52639, 2088, 4.5, 6.48, 40, 43, 30, 21, 20, 20, 0, 0, 137.86467, 140.57278, 94.1437, 102.86506, 253, 4, 333, 0, 0, 0, 90, 90, 0, 1), 
(18561, 18561, "Granitick Duerga", 0, "Kaneus", 0, "LineageMonster.stone_golem", 20, 31, 36, "male", "L2Monster", 40, 94225.552737, 2088, 17.431727, 6.48, 40, 43, 30, 21, 20, 20, 620253, 41849, 246.07679, 224.91645, 168.03855, 246.87614, 253, 1, 333, 0, 0, 0, 23, 23, 0, 1), 
(18562, 18562, "Blade Otis", 0, "Kaneus", 0, "LineageMonster.blade_stakato_drone_10_sm", 14, 35.1, 43, "male", "L2Monster", 40, 132634.618317, 2787, 23.236178, 11.55, 40, 43, 30, 21, 20, 20, 784383, 58093, 361.02734, 270.61467, 246.53487, 297.03612, 253, 4, 333, 131, 0, 0, 25, 155, 0, 1), 
(18563, 18563, "Follower of Otis", 0, "", 0, "LineageMonster.marsh_stakato_drone", 9, 24, 43, "male", "L2Monster", 40, 1094.28943, 2787, 5.5, 11.55, 40, 43, 30, 21, 20, 20, 0, 0, 210.04832, 169.13417, 143.43577, 123.76505, 253, 4, 333, 223, 0, 0, 80, 155, 0, 1), 
(18564, 18564, "Weird Bunei", 0, "Kaneus", 0, "LineageMonster3.Water_Drake", 55, 80.5, 46, "female", "L2Monster", 40, 165222.579864, 3189, 28.302016, 11.55, 40, 43, 30, 21, 20, 20, 848114, 69276, 470.81863, 291.50106, 321.50809, 319.96174, 253, 4, 333, 0, 0, 0, 60, 160, 0, 1), 
(18565, 18565, "Brave Martim", 0, "Kaneus", 0, "LineageMonster.ogre_50_bi", 30, 66, 46, "male", "L2Monster", 40, 165222.579864, 3189, 28.302016, 11.55, 40, 43, 30, 21, 20, 20, 848114, 69276, 470.81863, 291.50106, 321.50809, 319.96174, 253, 4, 333, 298, 0, 0, 33, 185, 0, 1), 
(18566, 18566, "Kaim Abigore", 0, "Kaneus", 0, "LineageMonster.kaim_vanul_50_bi", 36, 60, 53, "male", "L2Monster", 40, 294174.619264, 4162, 47.906958, 13.2, 40, 43, 30, 21, 20, 20, 967925, 88254, 805.15012, 342.69322, 549.81315, 376.15202, 253, 4, 333, 0, 0, 0, 60, 250, 0, 1), 
(18567, 18567, "Follower of Abigore", 0, "", 0, "LineageMonster.liviona", 15, 28, 53, "male", "L2Monster", 40, 1570.8463, 4162, 6.5, 13.2, 40, 43, 30, 21, 20, 20, 0, 0, 353.71092, 214.18326, 241.5387, 156.73001, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), 
(18568, 18568, "Knight Montagnar", 0, "Kaneus", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 56, "male", "L2Monster", 40, 318250.283049, 4594, 50.755433, 13.2, 40, 43, 30, 21, 20, 20, 1002611, 124970, 1114.68191, 365.44216, 761.18324, 401.12208, 253, 4, 333, 946, 945, 0, 80, 120, 0, 1), 
(18569, 18569, "Follower of Montagnar", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 56, "male", "L2Monster", 40, 1724.6831, 4594, 6.5, 13.2, 40, 43, 30, 21, 20, 20, 0, 0, 405.96455, 228.40135, 277.22116, 167.1342, 253, 4, 333, 0, 0, 0, 25, 150, 0, 1), 
(18570, 18570, "Summer Yaganitan", 0, "Kaneus", 0, "LineageMonster2.flava_15_bi", 23, 39, 56, "male", "L2Monster", 40, 318250.283049, 4594, 50.755433, 13.2, 40, 43, 30, 21, 20, 20, 1002611, 124970, 1114.68191, 365.44216, 761.18324, 401.12208, 253, 4, 333, 0, 0, 0, 30, 165, 0, 1), 
(18571, 18571, "Venomous Storace", 0, "Kaneus", 0, "LineageMonster.serpent_slave_50_bi", 25, 72, 63, "male", "L2Monster", 40, 420501.049733, 5637, 63.974255, 16.47, 40, 43, 30, 21, 20, 20, 1046467, 179455, 1873.16418, 419.51082, 1279.12832, 460.46971, 253, 4, 333, 73, 0, 0, 70, 110, 0, 1), 
(18572, 18572, "Follower of Storace", 0, "", 0, "LineageMonster.cave_maiden_080p", 12, 54, 63, "female", "L2Monster", 40, 2089.92274, 5637, 7.5, 16.47, 40, 43, 30, 21, 20, 20, 0, 0, 541.44774, 262.19426, 369.73862, 191.86238, 253, 4, 333, 73, 0, 0, 50, 100, 0, 1), 
(18573, 18573, "Kel Bilette", 0, "Kaneus", 0, "LineageMonster.kel_mahum_champion_50_bi", 19, 48, 66, "male", "L2Monster", 40, 445990.929574, 6099, 66.538969, 16.47, 40, 43, 30, 21, 20, 20, 1052061, 186892, 2129.66944, 442.76403, 1454.28817, 485.99326, 253, 4, 333, 75, 0, 0, 50, 170, 0, 1), 
(18574, 18574, "Follower of Bilette", 0, "", 0, "LineageMonster.kel_mahum_witch_doctor", 13, 25, 66, "male", "L2Monster", 40, 2244.67715, 6099, 7.5, 16.47, 40, 43, 30, 21, 20, 20, 0, 0, 603.79903, 276.72752, 412.31647, 202.49719, 253, 4, 333, 193, 0, 0, 50, 160, 0, 1), 
(18575, 18575, "Warlord Tamuze", 0, "Kaneus", 0, "LineageMonster3.Vampire_Troop_Leader_120p", 22, 43, 66, "male", "L2Monster", 40, 445990.929574, 6099, 66.538969, 16.47, 40, 43, 30, 21, 20, 20, 1052061, 186892, 2129.66944, 442.76403, 1454.28817, 485.99326, 253, 4, 333, 8686, 0, 0, 60, 160, 0, 1), 
(18576, 18576, "Follower of Tamuze", 0, "", 0, "LineageMonster3.self_blaster", 9, 25.8, 66, "male", "L2Monster", 40, 2244.67715, 6099, 7.5, 16.47, 40, 43, 30, 21, 20, 20, 0, 0, 603.79903, 276.72752, 412.31647, 202.49719, 253, 4, 333, 0, 0, 0, 30, 240, 0, 1), 
(18577, 18577, "White Allosce", 0, "Kaneus", 0, "LineageMonster2.hundred_eye", 21, 55, 73, "male", "L2Monster", 40, 475289.654477, 7212, 67.846131, 18.3, 40, 43, 30, 21, 20, 20, 1169076, 202886, 2939.28877, 496.04734, 2007.15321, 544.47888, 253, 1, 333, 0, 0, 0, 30, 170, 0, 1), 
(18578, 18578, "Follower of Allosce", 0, "", 0, "LineageMonster.monster_eye", 21, 43, 73, "male", "L2Monster", 40, 2586.66898, 7212, 8.5, 18.3, 40, 43, 30, 21, 20, 20, 0, 0, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 0, 0, 0, 90, 90, 0, 1), 
(18579, 18579, "Hunting Ground Keeper", 0, "", 0, "LineageMonster4.employee_of_baroness", 15, 28.7, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 1, 333, 13062, 0, 0, 55, 160, 0, 1), 
(18580, 18580, "Cursed Girl", 0, "", 0, "LineageMonster4.cursed_housemaid", 8, 17, 71, "male", "L2Npc", 40, 2492.727, 1377.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 710.2185, 300.65359, 484.98717, 220.00525, 253, 4, 333, 0, 0, 0, 18, 160, 0, 1), 
(18581, 18581, "Gardener", 0, "", 0, "LineageMonster4.gardener", 17, 26.8, 72, "male", "L2Npc", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 0, 0, 0, 36, 160, 0, 1), 
(18582, 18582, "Turned Girl", 0, "Kratei's Fortune", 0, "LineageMonster4.cursed_housemaid", 8, 17, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 18, 160, 0, 1), 
(18583, 18583, "Housekeeper", 0, "", 0, "LineageMonster4.mad_laundry_maid", 9, 21.6, 74, "male", "L2Npc", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 773.81598, 314.65987, 528.41601, 230.25444, 253, 4, 333, 0, 0, 0, 33, 160, 0, 1), 
(18584, 18584, "Turned Boy", 0, "", 0, "LineageMonster4.cursed_errand_boy", 8, 12.8, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 15, 160, 0, 1), 
(18585, 18585, "Cursed Girl", 0, "", 0, "LineageMonster4.cursed_housemaid", 8, 17, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 18, 160, 0, 1), 
(18586, 18586, "Gardener", 0, "", 0, "LineageMonster4.gardener", 17, 26.8, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 36, 160, 0, 1), 
(18587, 18587, "Begrudged Maid", 0, "", 0, "LineageMonster4.head_parlour_maid", 25, 32, 76, "male", "L2Npc", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 0, 0, 0, 50, 160, 0, 1), 
(18588, 18588, "Hunting Ground Keeper", 0, "", 0, "LineageMonster4.employee_of_baroness", 15, 28.7, 77, "male", "L2Npc", 40, 2856.768726, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 856.44056, 328.27073, 584.83789, 240.21427, 253, 1, 333, 13062, 0, 0, 55, 160, 0, 1), 
(18589, 18589, "Cursed Gardener", 0, "", 0, "LineageMonster4.gardener", 17, 26.8, 77, "male", "L2Npc", 40, 2856.768726, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 856.44056, 328.27073, 584.83789, 240.21427, 253, 4, 333, 0, 0, 0, 36, 160, 0, 1), 
(18590, 18590, "Baroness' Employee", 0, "", 0, "LineageMonster4.employee_of_baroness", 15, 28.7, 78, "male", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 1, 333, 13061, 0, 0, 55, 160, 0, 1), 
(18591, 18591, "Begrudged Boy", 0, "", 0, "LineageMonster4.cursed_errand_boy", 8, 12.8, 79, "male", "L2Npc", 40, 3127.824593, 1641, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 929.93081, 337.07008, 635.0222, 246.65326, 253, 4, 333, 0, 0, 0, 15, 160, 0, 1), 
(18592, 18592, "Kratei's Steward", 0, "", 0, "LineageMonster4.chief_steward", 18, 31, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 55, 160, 0, 1), 
(18593, 18593, "Housekeeper", 0, "", 0, "LineageMonster4.mad_laundry_maid", 9, 21.6, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 33, 160, 0, 1), 
(18594, 18594, "Mansion Guide", 0, "", 0, "LineageMonster4.mad_laundry_maid", 9, 21.6, 81, "male", "L2Npc", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 0, 0, 0, 33, 160, 0, 1), 
(18595, 18595, "Baroness' Employee", 0, "", 0, "LineageMonster4.employee_of_baroness", 15, 28.7, 82, "male", "L2Npc", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1055.28566, 349.77477, 720.6233, 255.95, 253, 1, 333, 13061, 0, 0, 55, 160, 0, 1), 
(18596, 18596, "Cursed Gardener", 0, "", 0, "LineageMonster4.gardener", 17, 26.8, 83, "male", "L2Npc", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 36, 160, 0, 1), 
(18597, 18597, "Begrudged Maid", 0, "", 0, "LineageMonster4.head_parlour_maid", 25, 32, 84, "male", "L2Npc", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 50, 160, 0, 1), 
(18598, 18598, "Cursed Head Maid", 0, "", 0, "LineageMonster4.head_parlour_maid", 25, 32, 85, "male", "L2Npc", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 50, 160, 0, 1), 
(18599, 18599, "Mansion Manager", 0, "", 0, "LineageMonster4.steward", 21, 25, 85, "male", "L2Npc", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 76, 160, 0, 1), 
(18600, 18600, "Kratei's Steward", 0, "", 0, "LineageMonster4.chief_steward", 18, 31, 86, "male", "L2Npc", 40, 4439.743585, 1881.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1233.98508, 365.6202, 842.65185, 267.545, 253, 4, 333, 0, 0, 0, 55, 160, 0, 1), 
(18601, 18601, "Kratei's Watcher", 0, "", 0, "LineageNpcEV.trap_ironcastle_150p_a", 18, 32, 70, "male", "L2Npc", 40, 1, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18602, 18602, "Kratei's Watcher", 0, "", 0, "LineageNpcEV.trap_ironcastle_150p", 18, 32, 70, "male", "L2Npc", 40, 1, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18603, 18603, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 73, "male", "L2Npc", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18604, 18604, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 73, "male", "L2Npc", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18605, 18605, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 73, "male", "L2Npc", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18606, 18606, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 73, "male", "L2Npc", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18607, 18607, "Gargos", 0, "Spirit of Fire", 0, "LineageMonster.vale_master", 12, 40, 39, "male", "L2Monster", 40, 26166.476011, 387.72, 9, 1.8, 40, 43, 30, 21, 20, 20, 11225, 714, 166.06476, 132.9486, 82.76936, 97.28601, 253, 4, 333, 0, 0, 0, 70, 155, 0, 1), 
(18608, 18608, "Kinsus", 0, "Spirit of Fire", 0, "LineageMonster4.Anthias", 20, 41, 39, "male", "L2Monster", 40, 16291.374215, 387.72, 9, 1.8, 40, 43, 30, 21, 20, 20, 11225, 714, 166.06476, 132.9486, 82.76936, 97.28601, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), 
(18609, 18609, "Papion", 0, "Spirit of Water", 0, "LineageMonster4.Anthias", 20, 41, 36, "male", "L2Monster", 40, 10512.777762, 343.8, 9, 1.8, 40, 43, 30, 21, 20, 20, 10783, 652, 137.86467, 121.98819, 67.7543, 89.26566, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), 
(18610, 18610, "Hillas", 0, "Spirit of Water", 0, "LineageMonster.sylph_100_bi", 20, 70, 36, "female", "L2Monster", 40, 12143.412571, 343.8, 9, 1.8, 40, 43, 30, 21, 20, 20, 10783, 652, 137.86467, 121.98819, 67.7543, 89.26566, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(18611, 18611, "Spirit of Water", 0, "", 0, "LineageMonster.undine", 12, 27, 33, "female", "L2Monster", 40, 702.20463, 372.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 631, 22, 113.49065, 129.23095, 77.49941, 94.5656, 253, 4, 333, 0, 0, 0, 60, 100, 0, 1), 
(18612, 18612, "Spirit of Water", 0, "", 0, "LineageMonster.sylph", 11, 35, 36, "female", "L2Monster", 40, 809.52639, 417.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 726, 28, 137.86467, 140.57278, 94.1437, 102.86506, 253, 4, 333, 0, 0, 0, 60, 100, 0, 1), 
(18613, 18613, "Spirit of Water", 0, "", 0, "LineageMonster.sylph_110p", 12, 39.7, 39, "female", "L2Monster", 40, 925.85879, 463.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 852, 35, 166.06476, 152.46752, 113.4007, 111.56912, 253, 4, 333, 0, 0, 0, 60, 100, 0, 1), 
(18614, 18614, "Spirit of Fire", 0, "", 0, "LineageMonster.skeleton_knight", 10, 25, 36, "male", "L2Monster", 40, 809.52639, 417.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 726, 28, 137.86467, 140.57278, 94.1437, 102.86506, 253, 4, 333, 150, 103, 0, 40, 160, 0, 1), 
(18615, 18615, "Spirit of Fire", 0, "", 0, "LineageMonster.dre_vanul", 14, 36, 39, "male", "L2Monster", 40, 925.85879, 463.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 852, 35, 166.06476, 152.46752, 113.4007, 111.56912, 253, 4, 333, 0, 0, 0, 80, 80, 0, 1), 
(18616, 18616, "Bloom", 0, "", 0, "LineageMonster.magical_weaver", 11, 20, 36, "male", "L2Monster", 40, 809.52639, 417.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 726, 28, 137.86467, 140.57278, 94.1437, 102.86506, 253, 1, 333, 0, 0, 0, 90, 90, 0, 1), 
(18617, 18617, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 36, "male", "L2Npc", 40, 809.52639, 417.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 726, 28, 137.86467, 140.57278, 94.1437, 102.86506, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18618, 18618, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 36, "male", "L2Npc", 40, 809.52639, 417.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 726, 28, 137.86467, 140.57278, 94.1437, 102.86506, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18619, 18619, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 36, "male", "L2Npc", 40, 809.52639, 417.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 726, 28, 137.86467, 140.57278, 94.1437, 102.86506, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18620, 18620, "Adiantum", 0, "", 0, "LineageMonster.onyx_beast", 14, 14.5, 42, "male", "L2Monster", 40, 27474.799812, 432.72, 9, 1.8, 40, 43, 30, 21, 20, 20, 91640, 4070, 198.34591, 144.47758, 100.26304, 105.72243, 253, 1, 333, 0, 0, 0, 30, 120, 0, 1), 
(18621, 18621, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 42, "male", "L2Npc", 40, 1050.81652, 531, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 989, 44, 198.34591, 164.88513, 135.44454, 120.65578, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18622, 18622, "Powder Keg", 0, "", 0, "LineageNPCEV.gunpowder", 80, 60, 61, "female", "L2Monster", 40, 1985.55926, 1066.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 2085, 174, 501.08068, 252.49346, 342.17315, 184.76376, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18623, 18623, "Begrudged Archer", 0, "", 0, "LineageMonster.skeleton_archer_20_bi", 13, 32.5, 61, "male", "L2Monster", 1100, 1985.55926, 1066.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 3210, 273, 501.08068, 252.49346, 342.17315, 184.76376, 253, 8, 333, 279, 0, 0, 40, 140, 0, 1), 
(18624, 18624, "Deadman's Grudge", 0, "", 0, "LineageMonster.unpleasant_humming", 12, 26, 58, "male", "L2Monster", 40, 1828.68266, 977.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 1885, 151, 442.8992, 237.99429, 302.44274, 174.1539, 253, 8, 333, 0, 0, 0, 21, 143, 0, 1), 
(18625, 18625, "Deadman's Grudge", 0, "", 0, "LineageMonster.skeleton_knight", 10, 25, 61, "male", "L2Monster", 40, 1985.55926, 1066.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 2085, 174, 501.08068, 252.49346, 342.17315, 184.76376, 253, 4, 333, 78, 0, 0, 40, 160, 0, 1), 
(18626, 18626, "Deadman's Grudge", 0, "", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 64, "male", "L2Monster", 40, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 2295, 199, 562.02275, 267.04468, 383.78868, 195.41171, 253, 8, 333, 225, 945, 0, 80, 120, 0, 1), 
(18627, 18627, "Deadman's Grudge", 0, "", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 64, "male", "L2Monster", 40, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 2295, 199, 562.02275, 267.04468, 383.78868, 195.41171, 253, 4, 333, 225, 945, 0, 80, 120, 0, 1), 
(18628, 18628, "Atan", 0, "Lookout", 0, "LineageMonster.pirates_zombie", 10, 23, 61, "male", "L2Monster", 40, 1985.55926, 1066.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 2934, 249, 501.08068, 252.49346, 342.17315, 184.76376, 253, 8, 333, 232, 0, 0, 11, 145, 0, 1), 
(18629, 18629, "Kams", 0, "Panuka", 0, "LineageMonster.skeleton_knight_50_bi", 15, 39, 61, "male", "L2Monster", 40, 22092.824364, 1066.8, 15, 2.7, 40, 43, 30, 21, 20, 20, 63183, 5562, 501.08068, 252.49346, 342.17315, 184.76376, 253, 4, 333, 150, 103, 0, 40, 160, 0, 1), 
(18630, 18630, "Hikoro", 0, "Panuka", 0, "LineageMonster.rakul", 30, 39, 61, "male", "L2Monster", 40, 22092.824364, 1066.8, 15, 2.7, 40, 43, 30, 21, 20, 20, 63183, 5562, 501.08068, 252.49346, 342.17315, 184.76376, 253, 4, 333, 3, 0, 0, 60, 150, 0, 1), 
(18631, 18631, "Alkaso", 0, "Panuka", 0, "LineageMonster.pirates_zombie_captain_20_bi", 20, 33.6, 64, "male", "L2Monster", 40, 22860.726261, 1158, 15, 2.7, 40, 43, 30, 21, 20, 20, 64881, 5952, 562.02275, 267.04468, 383.78868, 195.41171, 253, 8, 333, 232, 0, 0, 14, 155, 0, 1), 
(18632, 18632, "Gerbera", 0, "Panuka", 0, "LineageMonster2.imperial_warlord_zombie_20_bi", 9, 36, 64, "male", "L2Monster", 40, 24719.196935, 1158, 15, 2.7, 40, 43, 30, 21, 20, 20, 64881, 5952, 562.02275, 267.04468, 383.78868, 195.41171, 253, 4, 333, 134, 6721, 0, 39, 150, 0, 1), 
(18633, 18633, "Lematan", 0, "", 0, "LineageMonster4.cursed_pirate", 24, 37, 67, "male", "L2Monster", 40, 49438.39387, 1251, 15, 2.7, 40, 43, 30, 21, 20, 20, 317821, 23080, 624.93199, 281.55251, 426.74754, 206.02791, 253, 4, 333, 0, 0, 0, 25.5, 120, 0, 1), 
(18634, 18634, "Lematan's Follower", 0, "", 0, "LineageMonster.pirates_zombie", 10, 23, 64, "male", "L2Monster", 40, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 2295, 199, 562.02275, 267.04468, 383.78868, 195.41171, 253, 8, 333, 232, 0, 0, 11, 145, 0, 1), 
(18635, 18635, "Varka Silenos Recruit", 0, "", 0, "LineageMonster2.barka_silenos_hunter", 16, 38, 71, "male", "L2Monster", 40, 7483.650316, 1410, 17, 3, 40, 43, 30, 21, 20, 20, 31557, 2980, 365.712, 305.35947, 124.8842, 223.44881, 253, 4, 333, 2504, 6918, 0, 44, 175, 0, 1), 
(18636, 18636, "Varka Silenos Footman", 0, "", 0, "LineageMonster2.barka_silenos_warrior", 16, 41, 71, "male", "L2Monster", 40, 7483.650316, 1410, 17, 3, 40, 43, 30, 21, 20, 20, 31557, 2980, 365.712, 305.35947, 124.8842, 223.44881, 253, 4, 333, 2504, 6918, 0, 34, 175, 0, 1), 
(18637, 18637, "Grazing Antelope", 0, "", 0, "LineageMonster2.antelope", 17, 34, 72, "male", "L2Monster", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 4087, 400, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 0, 0, 0, 45, 185, 0, 1), 
(18638, 18638, "Varka Silenos Scout", 0, "", 0, "LineageMonster2.barka_silenos_hunter", 16, 38, 72, "male", "L2Monster", 80, 7577.69917, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 3341, 338, 365.712, 305.35947, 124.8842, 223.44881, 253, 4, 333, 2504, 6918, 0, 44, 175, 0, 1), 
(18639, 18639, "Varka Silenos Hunter", 0, "", 0, "LineageMonster2.barka_silenos_archer", 8, 37.5, 72, "male", "L2Monster", 1100, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2905, 292, 731.52506, 305.35947, 499.53679, 223.44881, 253, 8, 333, 6917, 0, 0, 30, 175, 0, 1), 
(18640, 18640, "Varka Silenos Shaman", 0, "", 0, "LineageMonster2.barka_silenos_shaman", 14, 39.5, 72, "male", "L2Monster", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2905, 292, 731.52506, 305.35947, 499.53679, 223.44881, 253, 1, 333, 6716, 0, 0, 36, 150, 0, 1), 
(18641, 18641, "Varka Silenos Priest", 0, "", 0, "LineageMonster2.barka_silenos_priest", 9, 41.5, 72, "male", "L2Monster", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 4802, 513, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 6716, 0, 0, 36, 180, 0, 1), 
(18642, 18642, "Varka Silenos Warrior", 0, "", 0, "LineageMonster2.barka_silenos_warrior", 16, 41, 72, "male", "L2Monster", 40, 7577.69917, 1475, 17, 3, 40, 43, 30, 21, 20, 20, 3801, 402, 386.5, 314.65987, 132.104, 230.25444, 253, 4, 333, 142, 6918, 0, 34, 175, 0, 1), 
(18643, 18643, "Grazing Antelope", 0, "", 0, "LineageMonster2.antelope", 17, 34, 73, "male", "L2Monster", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 4201, 434, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 0, 0, 0, 45, 185, 0, 1), 
(18644, 18644, "Varka Silenos Medium", 0, "", 0, "LineageMonster2.barka_silenos_shaman", 14, 39.5, 72, "male", "L2Monster", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2905, 316, 731.52506, 305.35947, 499.53679, 223.44881, 253, 1, 333, 6716, 0, 0, 36, 150, 0, 1), 
(18645, 18645, "Varka Silenos Magus", 0, "", 0, "LineageMonster2.barka_silenos_mage_20_bi", 11, 55.2, 73, "male", "L2Monster", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 3255, 360, 752.73928, 310.02959, 514.02335, 226.8662, 253, 1, 333, 6716, 6918, 0, 36, 175, 0, 1), 
(18646, 18646, "Varka Silenos Officer", 0, "", 0, "LineageMonster2.barka_silenos_chieftain", 18, 42.5, 73, "male", "L2Monster", 40, 6660.845272, 1540.8, 17, 3, 40, 43, 30, 21, 20, 20, 37623, 3932, 412.21, 323.78455, 140.74335, 236.93149, 253, 1, 333, 2504, 6918, 0, 25, 175, 0, 1), 
(18647, 18647, "Grazing Flava", 0, "", 0, "LineageMonster2.flava", 18, 34, 74, "male", "L2Monster", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 4133, 449, 773.81598, 314.65987, 528.41601, 230.25444, 253, 4, 333, 0, 0, 0, 30, 165, 0, 1), 
(18648, 18648, "Varka Silenos Seer", 0, "", 0, "LineageMonster2.barka_silenos_shaman", 14, 39.5, 73, "male", "L2Monster", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 2807, 308, 752.73928, 310.02959, 514.02335, 226.8662, 253, 1, 333, 6716, 0, 0, 36, 150, 0, 1), 
(18649, 18649, "Varka Silenos Great Magus", 0, "", 0, "LineageMonster2.barka_silenos_warrior_20_bi", 20, 49.2, 73, "male", "L2Monster", 40, 9374.133085, 1574, 17, 3, 40, 43, 30, 21, 20, 20, 37090, 4028, 438.22, 328.27073, 146.209, 240.21427, 253, 4, 333, 2500, 6918, 0, 34, 175, 0, 1), 
(18650, 18650, "Varka Silenos General", 0, "", 0, "LineageMonster2.barka_silenos_chieftain", 18, 42.5, 73, "male", "L2Monster", 40, 9374.133085, 1574, 17, 3, 40, 43, 30, 21, 20, 20, 37090, 4028, 438.22, 328.27073, 146.209, 240.21427, 253, 1, 333, 2500, 6918, 0, 25, 175, 0, 1), 
(18651, 18651, "Grazing Elder Antelope", 0, "", 0, "LineageMonster2.antelope", 17, 34, 74, "male", "L2Monster", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 4133, 467, 773.81598, 314.65987, 528.41601, 230.25444, 253, 1, 333, 0, 0, 0, 45, 185, 0, 1), 
(18652, 18652, "Varka Silenos Great Seer", 0, "", 0, "LineageMonster2.barka_silenos_shaman", 14, 39.5, 74, "male", "L2Monster", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 2885, 333, 773.81598, 314.65987, 528.41601, 230.25444, 253, 1, 333, 6716, 0, 0, 36, 150, 0, 1), 
(18653, 18653, "Varka's Elite Guard", 0, "", 0, "LineageMonster2.barka_silenos_warrior", 16, 41, 74, "male", "L2Monster", 40, 6703.716221, 1475, 17, 3, 40, 43, 30, 21, 20, 20, 39208, 3836, 386.51, 314.65987, 528.41601, 230.25444, 253, 4, 333, 2504, 6918, 0, 34, 175, 0, 1), 
(18654, 18654, "Varka's Commander", 0, "", 0, "LineageMonster2.barka_silenos_chieftain_20_bi", 22, 51, 72, "male", "L2Monster", 40, 6656.859714, 1507.8, 17, 3, 40, 43, 30, 21, 20, 20, 36599, 3398, 397.12, 319.24623, 542.68324, 233.61053, 253, 4, 333, 2500, 6918, 0, 25, 175, 0, 1), 
(18655, 18655, "Varka's Head Guard", 0, "", 0, "LineageMonster2.barka_silenos_warrior", 16, 41, 74, "male", "L2Monster", 40, 8619.063713, 1574, 17, 3, 40, 43, 30, 21, 20, 20, 38113, 4028, 428.243, 328.27073, 146.209, 240.21427, 253, 4, 333, 142, 6918, 0, 34, 175, 0, 1), 
(18656, 18656, "Varka's Head Magus", 0, "", 0, "LineageMonster2.barka_silenos_shaman", 14, 39.5, 74, "male", "L2Monster", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 2885, 333, 773.81598, 314.65987, 528.41601, 230.25444, 253, 1, 333, 6716, 0, 0, 36, 150, 0, 1), 
(18657, 18657, "Prophet Guard", 0, "", 0, "LineageMonster2.barka_silenos_warrior", 16, 41, 74, "male", "L2Monster", 40, 8619.063713, 1607.4, 17, 3, 40, 43, 30, 21, 20, 20, 37565, 4122, 445.25, 332.70061, 152.024, 243.45587, 253, 4, 333, 2504, 6918, 0, 34, 175, 0, 1), 
(18658, 18658, "Disciple of Prophet", 0, "", 0, "LineageMonster2.barka_silenos_priest", 9, 41.5, 74, "male", "L2Monster", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 2885, 333, 773.81598, 314.65987, 528.41601, 230.25444, 253, 4, 333, 6716, 0, 0, 36, 180, 0, 1), 
(18659, 18659, "Varka's Prophet", 0, "", 0, "LineageMonster2.barka_silenos_shaman_20_bi", 17, 47.5, 74, "male", "L2Monster", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 2885, 346, 773.81598, 314.65987, 528.41601, 230.25444, 253, 1, 333, 6716, 0, 0, 36, 150, 0, 1), 
(18660, 18660, "Latana", 0, "", 0, "LineageMonster4.wounded_dragon", 60, 60, 75, "female", "L2Monster", 40, 60325.810295, 1251, 17, 2.7, 40, 43, 30, 21, 20, 20, 453825, 4067, 4768.26, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 1, 80, 0, 1), 
(18661, 18661, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 8087, 614, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18662, 18662, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 73, "male", "L2Npc", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 7661, 300, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18663, 18663, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 73, "male", "L2Npc", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18664, 18664, "Fortune Bug", 0, "", 0, "LineageMonster4.jackpot_bug", 16, 22.5, 52, "male", "L2Monster", 40, 1520.38155, 804, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 337.18867, 209.50106, 230.25615, 153.30378, 253, 4, 333, 0, 0, 0, 45, 160, 0, 1), 
(18665, 18665, "Fortune Bug", 0, "", 0, "LineageMonster4.jackpot_bug", 16, 22.5, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 45, 160, 0, 1), 
(18666, 18666, "Fortune Bug", 0, "", 0, "LineageMonster4.jackpot_bug", 16, 22.5, 75, "male", "L2Monster", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 45, 160, 0, 1), 
(18667, 18667, "Ward of Death", 0, "", 0, "LineageNpcEV.trap_immortality", 24, 48.5, 83, "female", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18668, 18668, "Ward of Death", 0, "", 0, "LineageNpcEV.trap_immortality", 24, 48.5, 83, "female", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18669, 18669, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 73, "male", "L2Npc", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18670, 18670, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 73, "male", "L2Npc", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18671, 18671, "Block", 0, "", 0, "LineageNPC2.block", 16, 17, 1, "female", "L2Monster", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 4, 333, 0, 0, 0, 50, 160, 0, 1), 
(18672, 18672, "Block", 0, "", 0, "LineageNPC2.block", 16, 17, 1, "female", "L2Block", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 4, 333, 0, 0, 0, 50, 160, 0, 1), 
(18673, 18673, "Block", 0, "", 0, "LineageNPC2.block", 16, 17, 1, "female", "L2Monster", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 4, 333, 0, 0, 0, 50, 160, 0, 1), 
(18674, 18674, "Block", 0, "", 0, "LineageNPC2.block", 16, 17, 1, "female", "L2Monster", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 4, 333, 0, 0, 0, 50, 160, 0, 1), 
(18675, 18675, "Block", 0, "", 0, "LineageNPC2.block", 16, 17, 1, "female", "L2Monster", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 4, 333, 0, 0, 0, 50, 160, 0, 1), 
(18676, 18676, "Block-Carrying Girl", 0, "", 0, "LineageNPC2.block_mother", 12, 31, 73, "female", "L2Monster", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 0, 0, 0, 120, 120, 0, 1), 
(18677, 18677, "Dragon Steed Troop Messenger", 0, "", 0, "LineageMonster4.dragon_peltast", 25, 46.5, 73, "male", "L2Monster", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 0, 0, 0, 89, 220, 0, 1), 
(18678, 18678, "Energy Seed - Water", 0, "", 0, "LineageNPC.seed_click_dummy_water", 10, 10, 1, "male", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18679, 18679, "Energy Seed - Fire", 0, "", 0, "LineageNPC.seed_click_dummy_fire", 10, 10, 1, "male", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18680, 18680, "Energy Seed - Wind", 0, "", 0, "LineageNPC.seed_click_dummy_wind", 10, 10, 2, "male", "L2Npc", 40, 48.09168, 47.28, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 9.32203, 46.15385, 6.36574, 33.77338, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18681, 18681, "Energy Seed - Earth", 0, "", 0, "LineageNPC.seed_click_dummy_earth", 10, 10, 2, "male", "L2Npc", 40, 48.09168, 47.28, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 9.32203, 46.15385, 6.36574, 33.77338, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18682, 18682, "Energy Seed - Divinity", 0, "", 0, "LineageNPC.seed_click_dummy_holy", 10, 10, 3, "male", "L2Npc", 40, 57.54874, 54.64, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 10.24492, 47.91652, 6.99595, 35.06323, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18683, 18683, "Energy Seed - Darkness", 0, "", 0, "LineageNPC.seed_click_dummy_dark", 10, 10, 3, "male", "L2Npc", 40, 57.54874, 54.64, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 10.24492, 47.91652, 6.99595, 35.06323, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18684, 18684, "Red Star Stone", 0, "", 0, "LineageNpcEV.star_stone_a", 54, 61, 1, "female", "L2FlyNpc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18685, 18685, "Red Star Stone", 0, "", 0, "LineageNpcEV.star_stone_b", 38, 43.5, 1, "female", "L2FlyNpc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18686, 18686, "Red Star Stone", 0, "", 0, "LineageNpcEV.star_stone_c", 38, 30.5, 1, "female", "L2FlyNpc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18687, 18687, "Blue Star Stone", 0, "", 0, "LineageNpcEV.star_stone_a", 54, 61, 1, "female", "L2FlyNpc", 40, 48.09168, 47.28, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 9.32203, 46.15385, 6.36574, 33.77338, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18688, 18688, "Blue Star Stone", 0, "", 0, "LineageNpcEV.star_stone_b", 38, 43.5, 1, "female", "L2FlyNpc", 40, 48.09168, 47.28, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 9.32203, 46.15385, 6.36574, 33.77338, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18689, 18689, "Blue Star Stone", 0, "", 0, "LineageNpcEV.star_stone_c", 38, 30.5, 1, "female", "L2FlyNpc", 40, 48.09168, 47.28, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 9.32203, 46.15385, 6.36574, 33.77338, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18690, 18690, "Green Star Stone", 0, "", 0, "LineageNpcEV.star_stone_a", 54, 61, 1, "female", "L2FlyNpc", 40, 57.54874, 54.64, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 10.24492, 47.91652, 6.99595, 35.06323, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18691, 18691, "Green Star Stone", 0, "", 0, "LineageNpcEV.star_stone_b", 38, 43.5, 1, "female", "L2FlyNpc", 40, 57.54874, 54.64, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 10.24492, 47.91652, 6.99595, 35.06323, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18692, 18692, "Green Star Stone", 0, "", 0, "LineageNpcEV.star_stone_c", 38, 30.5, 1, "female", "L2FlyNpc", 40, 57.54874, 54.64, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 10.24492, 47.91652, 6.99595, 35.06323, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18693, 18693, "Treasure Box of the Ancient Giants", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 76, "male", "L2Monster", 40, 1, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(18694, 18694, "Treasure Box Guard", 0, "", 0, "LineageMonster2.magmagoil_lad_20_sm", 12, 60, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 1, 333, 0, 0, 0, 1, 1, 0, 1), 
(18695, 18695, "Treasure Box Guard", 0, "", 0, "LineageMonster2.magmagoil_20_sm", 12, 60, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18696, 18696, "Dimension Moving Device", 0, "", 0, "LineageNpcEV.teleport_gate_of_legion", 44.5, 7, 80, "female", "L2Monster", 40, 13505.18, 1846.8, 95.72635, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1224.04634, 1944.40779, 860.59471, 272.57343, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18697, 18697, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18698, 18698, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18699, 18699, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18700, 18700, "", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18701, 18701, "", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18702, 18702, "Dimension Moving Device", 0, "", 0, "LineageNpcEV.teleport_gate_of_legion", 44.5, 7, 80, "female", "L2Npc", 40, 113229.052562, 1674.8, 195.708889, 3, 40, 43, 30, 21, 20, 20, 0, 0, 9366.93275, 595.98709, 6585.64343, 654.17623, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18703, 18703, "Defeated Troops Controller", 0, "", 0, "LineageNpcEV.crystal_of_secret_door", 57, 74, 80, "female", "L2Monster", 40, 113229.052562, 1674.8, 195.708889, 3, 40, 43, 30, 21, 20, 20, 0, 0, 9366.93275, 595.98709, 6585.64343, 654.17623, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18704, 18704, "Tumor of Death", 0, "", 0, "LineageNpcEV.tumor_immortality", 42, 55, 79, "female", "L2Monster", 40, 340289.895595, 1641, 197.223154, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7521.01104, 549.45119, 5166.44623, 603.0968, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18705, 18705, "Destroyed Tumor", 0, "", 0, "LineageNpcEV.tumor_immortality_a", 0.01, 55, 79, "female", "L2TerrainObject", 40, 340289.895595, 1641, 197.223154, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7521.01104, 549.45119, 5166.44623, 603.0968, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18706, 18706, "Soul Coffin", 0, "", 0, "LineageNpcEV.vein_immortality", 30.5, 6, 79, "female", "L2Monster", 40, 33155.371896, 1641, 115.295936, 3, 40, 43, 30, 21, 20, 20, 0, 0, 5781.02621, 549.45119, 3971.18964, 603.0968, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18707, 18707, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 73, "male", "L2Monster", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18708, 18708, "Tumor of Death", 0, "", 0, "LineageNpcEV.tumor_immortality", 42, 55, 81, "female", "L2Monster", 40, 112922.200723, 1708.8, 194.030407, 3, 40, 43, 30, 21, 20, 20, 0, 0, 9311.83315, 592.48128, 6508.39315, 650.32814, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18709, 18709, "Soul Coffin", 0, "", 0, "LineageNpcEV.vein_immortality_080p", 25, 6, 80, "female", "L2Monster", 40, 33093.42748, 1674.8, 114.399578, 3, 40, 43, 30, 21, 20, 20, 0, 0, 5746.81896, 546.2, 3924.33235, 599.52818, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18710, 18710, "Soul Coffin", 0, "", 0, "LineageNpcEV.vein_immortality", 30.5, 6, 81, "female", "L2Monster", 40, 33003.982801, 1708.8, 113.41926, 3, 40, 43, 30, 21, 20, 20, 0, 0, 5827.40072, 562.93163, 4002.76725, 617.89341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18711, 18711, "Soul Coffin", 0, "", 0, "LineageNpcEV.vein_immortality_120p", 36.5, 8.5, 81, "female", "L2Monster", 40, 33003.982801, 1708.8, 113.41926, 3, 40, 43, 30, 21, 20, 20, 0, 0, 5995.95197, 592.48128, 4190.79811, 650.32814, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18712, 18712, "Soul Coffin", 0, "", 0, "LineageNpcEV.vein_immortality_080p", 25, 6, 81, "female", "L2Monster", 40, 65918.445622, 1708.8, 113.265441, 3, 40, 43, 30, 21, 20, 20, 0, 0, 5756.11951, 592.48128, 4023.17011, 650.32814, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18713, 18713, "Soul Coffin", 0, "", 0, "LineageNpcEV.vein_immortality", 30.5, 6, 81, "female", "L2Monster", 40, 65918.445622, 1708.8, 113.265441, 3, 40, 43, 30, 21, 20, 20, 0, 0, 5756.11951, 592.48128, 4023.17011, 650.32814, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18714, 18714, "Soul Coffin", 0, "", 0, "LineageNpcEV.vein_immortality_120p", 36.5, 8.5, 81, "female", "L2Monster", 40, 65918.445622, 1708.8, 113.265441, 3, 40, 43, 30, 21, 20, 20, 0, 0, 5756.11951, 592.48128, 4023.17011, 650.32814, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18715, 18715, "Conquered Soul", 0, "", 0, "LineageMonster4.death_knight_n_104p", 22.88, 41.6, 81, "male", "L2Monster", 80, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1112.35801, 358.02452, 768.53275, 261.98681, 253, 4, 333, 13983, 0, 0, 42.5, 180, 0, 1), 
(18716, 18716, "Conquered Soul", 0, "", 0, "LineageMonster4.Death_slayer_080p", 16, 27.2, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1112.35801, 358.02452, 768.53275, 261.98681, 253, 4, 333, 13985, 0, 0, 64, 200, 0, 1), 
(18717, 18717, "Conquered Soul", 0, "", 0, "LineageMonster4.lich_b_088p", 21.12, 40.48, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1112.35801, 358.02452, 768.53275, 261.98681, 253, 4, 333, 0, 0, 0, 46, 200, 0, 1), 
(18718, 18718, "Sacrificed Fanatic", 0, "", 0, "LineageMonster4.ravager_silen_dead", 27, 48.5, 81, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 799.38377, 321.12415, 549.08653, 234.98471, 253, 4, 333, 13987, 0, 0, 1, 200, 0, 1), 
(18719, 18719, "Sacrificed Fanatic", 0, "", 0, "LineageMonster4.disciple_silen_dead", 19, 44, 81, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 799.38377, 321.12415, 549.08653, 234.98471, 253, 4, 333, 0, 0, 0, 1, 170, 0, 1), 
(18720, 18720, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18721, 18721, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18722, 18722, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18723, 18723, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18724, 18724, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18725, 18725, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18726, 18726, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18727, 18727, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18728, 18728, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18729, 18729, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18730, 18730, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18731, 18731, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18732, 18732, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18733, 18733, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18734, 18734, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18735, 18735, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18736, 18736, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18737, 18737, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18738, 18738, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18739, 18739, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18740, 18740, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18741, 18741, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18742, 18742, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18743, 18743, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18744, 18744, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18745, 18745, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18746, 18746, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18747, 18747, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18748, 18748, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18749, 18749, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18750, 18750, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18751, 18751, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18752, 18752, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18753, 18753, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18754, 18754, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18755, 18755, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18756, 18756, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18757, 18757, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18758, 18758, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18759, 18759, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18760, 18760, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18761, 18761, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18762, 18762, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18763, 18763, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18764, 18764, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18765, 18765, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18766, 18766, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18767, 18767, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18768, 18768, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18769, 18769, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18770, 18770, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18771, 18771, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18772, 18772, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18773, 18773, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18774, 18774, "Trap", 0, "", 0, "LineageNpc2.trap_mark", 5, 10, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18775, 18775, "Seed of Destruction Control Device", 0, "", 0, "LineageNpcEV.crystal_of_secret_door", 57, 74, 81, "female", "L2Npc", 40, 33003.982801, 1708.8, 113.41926, 3, 40, 43, 30, 21, 20, 20, 147312, 11412, 5827.40072, 562.93163, 4002.76725, 617.89341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18776, 18776, "Obelisk", 0, "", 0, "LineageNpcEV.obelisk_of_middle_square", 229, 177.5, 81, "female", "L2Monster", 40, 33003.982801, 1708.8, 113.41926, 3, 40, 43, 30, 21, 20, 20, 0, 0, 5827.40072, 562.93163, 4002.76725, 617.89341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18777, 18777, "Great Powerful Device", 0, "", 0, "LineageNpcEV.crystal_of_secret_door", 57, 74, 81, "female", "L2Monster", 40, 33003.982801, 1708.8, 113.41926, 3, 40, 43, 30, 21, 20, 20, 0, 0, 5827.40072, 562.93163, 4002.76725, 617.89341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18778, 18778, "Throne of Destruction Powerful Device", 0, "", 0, "LineageNpcEV.protector_of_seed", 57, 74, 81, "female", "L2Monster", 40, 33003.982801, 1708.8, 113.41926, 3, 40, 43, 30, 21, 20, 20, 0, 0, 5827.40072, 562.93163, 4002.76725, 617.89341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18779, 18779, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18780, 18780, "Symbol of Cohemenes", 0, "", 0, "LineageNpcEV.trap_immortality", 24, 48.5, 83, "female", "L2Monster", 40, 65569.257083, 1777.4, 111.355378, 3, 40, 43, 30, 21, 20, 20, 0, 0, 5589.57219, 566.1783, 3816.95322, 621.45708, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18781, 18781, "Young Drake Wing", 0, "", 0, "LineageMonster4.m_drake_wing_knave", 153, 63, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 60, 150, 0, 1), 
(18782, 18782, "Zealot of Shilen", 0, "", 0, "LineageMonster4.disciple_silen", 19, 44, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 73, 170, 0, 1), 
(18783, 18783, "Defeated Troops Commander", 0, "", 0, "LineageMonster4.Dragon_centurion_135p", 28, 46.5, 81, "male", "L2Monster", 40, 112922.200723, 1708.8, 194.030407, 3, 40, 43, 30, 21, 20, 20, 0, 0, 9169.67356, 572.83923, 6335.36539, 628.76834, 253, 4, 333, 13978, 0, 0, 55, 210, 0, 1), 
(18784, 18784, "Defeated Troops No 1 Battalion Commander", 0, "", 0, "LineageMonster4.Dragon_centurion_135p", 28, 46.5, 81, "male", "L2Monster", 40, 112922.200723, 1708.8, 194.030407, 3, 40, 43, 30, 21, 20, 20, 0, 0, 9098.07293, 562.93163, 6249.35028, 617.89341, 253, 4, 333, 13978, 0, 0, 55, 210, 0, 1), 
(18785, 18785, "Defeated Troops White Dragon Leader", 0, "", 0, "LineageMonster4.Dragon_centurion_120p", 22, 42, 81, "male", "L2Monster", 40, 112922.200723, 1708.8, 194.030407, 3, 40, 43, 30, 21, 20, 20, 0, 0, 9025.28601, 552.97803, 6163.10038, 606.96799, 253, 4, 333, 13979, 13980, 0, 56, 210, 0, 1), 
(18786, 18786, "Defeated Troops Infantry", 0, "", 0, "LineageMonster4.Dragon_centurion_120p", 22, 42, 80, "male", "L2Monster", 40, 113229.052562, 1674.8, 195.708889, 3, 40, 43, 30, 21, 20, 20, 0, 0, 9005.41719, 546.2, 6149.53252, 599.52818, 253, 4, 333, 13979, 13980, 0, 56, 210, 0, 1), 
(18787, 18787, "Defeated Troops Magic Leader", 0, "", 0, "LineageMonster4.dragon_mage_075p", 28, 39.5, 81, "male", "L2Monster", 40, 56505.860351, 1708.8, 194.184226, 3, 40, 43, 30, 21, 20, 20, 0, 0, 9320.82549, 562.93163, 6402.35617, 617.89341, 253, 4, 333, 0, 0, 0, 92, 170, 0, 1), 
(18788, 18788, "Defeated Troops Magician", 0, "", 0, "LineageMonster4.dragon_mage_075p", 28, 39.5, 81, "male", "L2Monster", 40, 56505.860351, 1708.8, 194.184226, 3, 40, 43, 30, 21, 20, 20, 0, 0, 9242.50952, 552.97803, 6311.43588, 606.96799, 253, 4, 333, 0, 0, 0, 92, 170, 0, 1), 
(18789, 18789, "Defeated Troops Magic Soldier", 0, "", 0, "LineageMonster4.dragon_mage_065p", 25, 34.5, 80, "male", "L2Monster", 40, 33093.42748, 1674.8, 114.399578, 3, 40, 43, 30, 21, 20, 20, 0, 0, 5746.81896, 546.2, 3924.33235, 599.52818, 253, 4, 333, 13981, 0, 0, 82, 170, 0, 1), 
(18790, 18790, "Defeated Troops Healer", 0, "", 0, "LineageMonster4.dragon_mage_065p", 25, 34.5, 79, "male", "L2Monster", 40, 33155.371896, 1641, 115.295936, 3, 40, 43, 30, 21, 20, 20, 0, 0, 5679.0786, 539.31213, 3878.07448, 591.96782, 253, 4, 333, 13981, 0, 0, 82, 170, 0, 1), 
(18791, 18791, "Defeated Troops Javelin Thrower", 0, "", 0, "LineageMonster4.dragon_peltast", 25, 46.5, 80, "male", "L2Monster", 1100, 56659.313636, 1674.8, 195.863713, 3, 40, 43, 30, 21, 20, 20, 0, 0, 9218.40693, 546.2, 6294.97689, 599.52818, 253, 8, 333, 13843, 0, 0, 89, 220, 0, 1), 
(18792, 18792, "Defeated Troops Javelin Thrower", 0, "", 0, "LineageMonster4.dragon_peltast", 25, 46.5, 80, "male", "L2Monster", 1100, 56659.313636, 1674.8, 195.863713, 3, 40, 43, 30, 21, 20, 20, 0, 0, 9218.40693, 546.2, 6294.97689, 599.52818, 253, 8, 333, 13843, 0, 0, 89, 220, 0, 1), 
(18793, 18793, "Bizarre Cocoon", 0, "", 0, "LineageNpcEV.n_event_stakato_egg_a", 24, 27, 84, "male", "L2Monster", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18794, 18794, "Bizarre Cocoon", 0, "", 0, "LineageNpcEV.n_event_stakato_egg_b", 35, 27, 84, "male", "L2Monster", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18795, 18795, "Bizarre Cocoon", 0, "", 0, "LineageNpcEV.n_event_stakato_egg_c", 48, 27, 84, "male", "L2Monster", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18796, 18796, "Bizarre Cocoon", 0, "", 0, "LineageNpcEV.n_event_stakato_egg_d", 24, 27, 84, "male", "L2Monster", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18797, 18797, "Bizarre Cocoon", 0, "", 0, "LineageNpcEV.n_event_stakato_egg_e", 35, 27, 84, "male", "L2Monster", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18798, 18798, "Bizarre Cocoon", 0, "", 0, "LineageNpcEV.n_event_stakato_egg_f", 48, 27, 84, "male", "L2Monster", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18799, 18799, "Newborn Lavasaurus", 0, "", 0, "LineageMonster2.magmagoil_20_sm", 12, 60, 77, "male", "L2Monster", 40, 2856.768726, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 49441, 5079, 856.44056, 328.27073, 584.83789, 240.21427, 253, 1, 333, 0, 0, 0, 1, 1, 0, 1), 
(18800, 18800, "Fledgling Lavasaurus", 0, "", 0, "LineageMonster2.magmagoil", 15, 75, 77, "male", "L2Monster", 40, 2856.768726, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 49441, 5079, 856.44056, 328.27073, 584.83789, 240.21427, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18801, 18801, "Adult Lavasaurus", 0, "", 0, "LineageMonster2.magmagoil_lad_20_sm", 12, 60, 77, "male", "L2Monster", 40, 2856.768726, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 49441, 5079, 856.44056, 328.27073, 584.83789, 240.21427, 253, 1, 333, 0, 0, 0, 1, 1, 0, 1), 
(18802, 18802, "Elderly Lavasaurus", 0, "", 0, "LineageMonster2.magmagoil_lad", 15, 75, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 50733, 5271, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18803, 18803, "Ancient Lavasaurus", 0, "", 0, "LineageMonster2.magmagoil_lad", 15, 75, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 50733, 5271, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18804, 18804, "Tar Beetle", 0, "", 0, "LineageMonster2.scarab_20_sm_e", 18, 26, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 45, 180, 0, 1), 
(18805, 18805, "Waste Landfill Machine", 0, "", 0, "LineageNpcEV.riding_control_unit_c", 19, 28, 83, "female", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18806, 18806, "Brazier of Purity", 0, "", 0, "LineageNpcEV.warp_gate_a", 16, 31, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18807, 18807, "Frightened Ragna Orc", 0, "", 0, "LineageMonster.batur_orc_03te", 9, 21.5, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2639, 292, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 0, 0, 0, 80, 130, 0, 1), 
(18808, 18808, "Dark Shaman Varangka", 0, "", 0, "LineageMonster2.ketra_orc_chieftain_20_bi_e", 17, 46.2, 82, "male", "L2Monster", 40, 21860.34, 17430, 41.206725, 50, 40, 43, 30, 21, 20, 20, 142334, 15560, 492.29855, 349.77477, 720.6233, 255.95, 253, 1, 333, 6719, 0, 0, 24, 175, 0, 1), 
(18809, 18809, "Varangka's Retainer", 0, "", 0, "LineageMonster.batur_orc_overlord_03te_120p", 12, 28, 82, "male", "L2Monster", 40, 1821.695, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 16412, 1794, 492.29855, 349.77477, 720.6233, 255.95, 253, 4, 333, 6365, 0, 0, 80, 140, 0, 1), 
(18810, 18810, "Varangka's Page", 0, "", 0, "LineageMonster.batur_orc_shaman_a_01te_120p_e", 13, 20.8, 82, "male", "L2Monster", 40, 1821.695, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 17412, 1904, 492.29855, 349.77477, 720.6233, 255.95, 253, 4, 333, 8680, 0, 0, 50, 120, 0, 1), 
(18811, 18811, "Guardian of the Altar", 0, "", 0, "LineageMonster2.parasitic_eye_050p_e", 17, 29, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1055.28566, 349.77477, 720.6233, 255.95, 253, 1, 333, 0, 0, 0, 30, 160, 0, 1), 
(18812, 18812, "Kasha's Eye", 0, "", 0, "LineageMonster2.parasitic_eye_050p_e_r", 17, 29, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 0, 0, 0, 30, 160, 0, 1), 
(18813, 18813, "Kasha's Eye", 0, "", 0, "LineageMonster2.parasitic_eye_050p_e_g", 17, 29, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 0, 0, 0, 30, 160, 0, 1), 
(18814, 18814, "Kasha's Eye", 0, "", 0, "LineageMonster2.parasitic_eye_050p_e_b", 17, 29, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 0, 0, 0, 30, 160, 0, 1), 
(18815, 18815, "Guard of the Grave", 0, "Death-calling", 0, "LineageMonster2.magmagoil_20_sm", 12, 60, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18816, 18816, "Chieftain's Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(18817, 18817, "Invader Martyr of Nightmare", 0, "", 0, "LineageMonster.doll_master", 20, 42, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 1, 333, 0, 0, 0, 80, 160, 0, 1), 
(18818, 18818, "Nihil Invader Martyr", 0, "", 0, "LineageMonster5.scapegoat", 20, 32.5, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 0, 0, 0, 45, 180, 0, 1), 
(18819, 18819, "Nihil Invader Treasure Chest", 0, "", 0, "LineageMonster5.bounded_mimic", 11, 8, 82, "female", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(18820, 18820, "Nihil Invader Treasure Chest", 0, "", 0, "LineageMonster5.bounded_mimic", 11, 8, 82, "female", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(18821, 18821, "Mutant Martyr", 0, "", 0, "LineageMonster5.doll_claw", 28, 50, 84, "male", "L2Monster", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 50, 165, 0, 1), 
(18822, 18822, "Mutant Treasure Chest", 0, "", 0, "LineageMonster5.bounded_mimic", 11, 8, 84, "female", "L2Monster", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(18823, 18823, "Mutant Treasure Chest", 0, "", 0, "LineageMonster5.bounded_mimic", 11, 8, 84, "female", "L2Monster", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(18824, 18824, "Merchant of Mammon A", 0, "", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 1, "male", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18825, 18825, "Merchant of Mammon B", 0, "", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 1, "male", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18826, 18826, "Shilen's Evil Thoughts For Presentation", 0, "", 0, "LineageMonster5.vicious_mind_of_silen", 14, 27.5, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(18827, 18827, "Priest Cain for Presentation", 0, "", 0, "LineageNPC.a_sanctuary_teacher_MHuman", 8, 23, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18828, 18828, "High Priest of Dawn", 0, "", 0, "LineageNPC2.high_priest_of_dawn", 10, 22.5, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(18829, 18829, "Shilen's Evil Thoughts Leader For Presentation", 0, "", 0, "LineageMonster5.leader_mind_of_silen", 20, 40, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 45, 180, 0, 1), 
(18830, 18830, "ssq For Presentation Camera Dummy 1", 0, "", 0, "LineageNPC.camera_target_dummy", 11, 25, 1, "male", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18831, 18831, "ssq For Presentation Camera Dummy 2", 0, "", 0, "LineageNPC.camera_target_dummy", 11, 25, 1, "male", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18832, 18832, "ssq For Presentation Camera Dummy 3", 0, "", 0, "LineageNPC.camera_target_dummy", 11, 25, 1, "male", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18833, 18833, "Emperor's Seal Device", 0, "", 0, "LineageNPCEV.ssq_sealing_emperor", 21, 24, 1, "female", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18834, 18834, "Guards of the Dawn", 0, "", 0, "LineageNPC.a_fighterguild_master_Mhuman", 8, 23.5, 85, "male", "L2Npc", 80, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 16, 0, 0, 50, 100, 0, 1), 
(18835, 18835, "Guards of the Dawn", 0, "", 0, "LineageNPC.a_mageguild_master_MHuman", 8, 24, 85, "male", "L2Npc", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 1, 333, 5, 0, 0, 50, 100, 0, 1), 
(18836, 18836, "Varangka's Guardian", 0, "", 0, "LineageMonster2.ahrimanes_70p", 14, 39.5, 82, "male", "L2Npc", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 16412, 1794, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 35, 185, 0, 1), 
(18837, 18837, "", 0, "", 0, "LineageNPC.camera_target_dummy_a", 0.1, 0.1, 1, "male", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18838, 18838, "Treasure Chest of Invader Soldier of Nightmare", 0, "", 0, "LineageMonster5.bounded_mimic", 11, 8, 84, "female", "L2Monster", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(18839, 18839, "Wild Maguen", 0, "", 0, "LineageMonster5.marguene", 11, 13.25, 85, "male", "L2Npc", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 15, 120, 0, 1), 
(18840, 18840, "", 0, "", 0, "LineageNPC.camera_target_dummy_a", 0.1, 0.1, 85, "male", "L2Npc", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18841, 18841, "", 0, "", 0, "LineageNPC.camera_target_dummy_a", 0.1, 0.1, 85, "male", "L2Npc", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18842, 18842, "", 0, "", 0, "LineageNPC.camera_target_dummy_a", 0.1, 0.1, 85, "male", "L2Npc", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18843, 18843, "Cokrakon's Ward", 0, "", 0, "LineageNpcEV.totem_of_cocracon_a", 30, 54, 85, "male", "L2Npc", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18844, 18844, "Reptilikon's Ward", 0, "", 0, "LineageNpcEV.totem_of_cocracon_b", 30, 54, 85, "male", "L2Npc", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18845, 18845, "Torumba's Telegraph", 0, "", 0, "LineageNPC.camera_target_dummy_a", 0.1, 0.1, 85, "male", "L2Npc", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18846, 18846, "Kegor", 0, "", 0, "LineageMonster5.swordmaster_kegor", 15, 27.5, 85, "male", "L2Npc", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 40, 120, 0, 1), 
(18847, 18847, "Freya", 0, "Ice Queen", 0, "LineageMonster5.freya_throne", 50, 98.5, 85, "female", "L2Npc", 40, 2388699.675054, 1846.8, 918.195504, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 45, 150, 0, 1), 
(18848, 18848, "Battalion Leader", 0, "Jinia Guild", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 85, "female", "L2Npc", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 80, 641, 0, 30, 160, 0, 1), 
(18849, 18849, "Legionnaire", 0, "Jinia Guild", 0, "LineageNPC2.officer_of_insurgents_orc", 14.5, 30, 85, "male", "L2Npc", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 9813, 9813, 0, 40, 160, 0, 1), 
(18850, 18850, "Jinia", 0, "", 0, "LineageMonster5.guildmaster_jinia", 11, 23.5, 85, "female", "L2Npc", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 40, 120, 0, 1), 
(18851, 18851, "Kegor", 0, "", 0, "LineageMonster5.swordmaster_kegor", 15, 27.5, 85, "male", "L2Npc", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 40, 120, 0, 1), 
(18852, 18852, "Sirra", 0, "", 0, "LineageMonster5.human_sirr", 10, 22, 85, "female", "L2Npc", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 40, 120, 0, 1), 
(18853, 18853, "Glacier", 0, "", 0, "LineageNpcEV.freezing_stone", 26, 27, 85, "male", "L2Npc", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18854, 18854, "Archer's Breath", 0, "", 0, "LineageMonster5.ice_elemental_bomb", 20, 50, 85, "male", "L2Npc", 40, 57746.263171, 1846.8, 109.442979, 3, 40, 43, 30, 21, 20, 20, 0, 0, 5858.114, 578.86102, 4000.33245, 635.37806, 253, 4, 333, 0, 0, 0, 30, 80, 0, 1), 
(18855, 18855, "Archery Knight", 0, "", 0, "LineageMonster5.ice_knight", 15, 31, 85, "male", "L2Npc", 40, 32596.260118, 1846.8, 109.442979, 3, 40, 43, 30, 21, 20, 20, 0, 0, 5858.114, 578.86102, 4000.33245, 635.37806, 253, 4, 333, 0, 0, 0, 20, 150, 0, 1), 
(18856, 18856, "Archery Knight", 0, "", 0, "LineageMonster5.ice_knight", 15, 31, 85, "male", "L2Npc", 40, 800666.352021, 18468, 109.442979, 300, 40, 43, 30, 21, 20, 20, 0, 0, 16109.81349, 578.86102, 4000.33245, 635.37806, 253, 4, 333, 0, 0, 0, 20, 150, 0, 1), 
(18857, 18857, "", 0, "", 0, "LineageNPC.camera_target_dummy_a", 0.1, 0.1, 1, "male", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18858, 18858, "", 0, "", 0, "LineageNPC.camera_target_dummy_a", 0.1, 0.1, 1, "male", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18859, 18859, "", 0, "", 0, "LineageNPC.camera_target_dummy_a", 0.1, 0.1, 1, "male", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18860, 18860, "", 0, "", 0, "LineageNPC.camera_target_dummy_a", 0.1, 0.1, 1, "male", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18861, 18861, "", 0, "", 0, "LineageNPC.camera_target_dummy_a", 0.1, 0.1, 1, "male", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18862, 18862, "Tanta Lizardman Guard", 0, "Escort of Ugoros", 0, "LineageMonster.zenta_lizardman_warrior", 13, 35, 82, "male", "L2Monster", 80, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 19616, 2145, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 98, 0, 0, 40, 140, 0, 1), 
(18863, 18863, "Seer Ugoros", 0, "Tanta Lizardmen", 0, "LineageMonster5.tantaar_lizardman_high_sorcerer", 40, 53.5, 84, "male", "L2Monster", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 90, 150, 0, 1), 
(18864, 18864, "Fantasy Mushroom", 0, "", 0, "LineageNpcEV.target_board_a", 16, 23, 85, "male", "L2Monster", 40, 1000, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18865, 18865, "Sticky Mushroom", 0, "", 0, "LineageNpcEV.rug_fungus", 15, 25, 85, "male", "L2Monster", 40, 1000, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18866, 18866, "Rainbow Frog", 0, "", 0, "LineageMonster5.poison_arrow_frog", 20, 18, 85, "male", "L2Monster", 40, 1000, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 15, 40, 0, 1), 
(18867, 18867, "Abyss Weed", 0, "", 0, "LineageNpcEV.poison_plant_b", 30, 27, 85, "male", "L2Monster", 40, 1000, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18868, 18868, "Energy Plant", 0, "", 0, "LineageNpcEV.rosehip_fragrant", 15, 33, 85, "male", "L2Monster", 40, 1000, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18869, 18869, "Kookaburra", 1, "Tame", 0, "LineageMonster2.baby_ostrich", 6, 15, 83, "male", "L2TamedBeast", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 13, 110, 0, 1), 
(18870, 18870, "Cougar", 1, "Tame", 0, "LineageMonster2.baby_tiger", 8, 15.7, 83, "male", "L2TamedBeast", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 1, 333, 0, 0, 0, 28, 110, 0, 1), 
(18871, 18871, "Buffalo", 1, "Tame", 0, "LineageMonster2.baby_buffalo", 8, 15, 84, "male", "L2TamedBeast", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 30, 110, 0, 1), 
(18872, 18872, "Grendel", 1, "Tame", 0, "LineageMonster5.baby_bionic_bear", 9, 12.5, 84, "male", "L2TamedBeast", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 40, 120, 0, 1), 
(18873, 18873, "Baby Alpine Kookaburra", 0, "", 0, "LineageMonster2.baby_ostrich", 6, 15, 83, "male", "L2FeedableBeast", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 11630, 1256, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 13, 110, 1, 1), 
(18874, 18874, "Young Kookaburra", 0, "", 0, "LineageMonster2.baby_ostrich_140p", 12, 21, 83, "male", "L2FeedableBeast", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 18776, 1918, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 13, 110, 1, 1), 
(18875, 18875, "Young Kookaburra", 0, "", 0, "LineageMonster2.baby_ostrich_140p", 12, 21, 83, "male", "L2FeedableBeast", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 25005, 2686, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 13, 110, 1, 1), 
(18876, 18876, "Adult Kookaburra", 0, "", 0, "LineageMonster2.youth_ostrich", 8, 26.4, 83, "male", "L2FeedableBeast", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 8516, 874, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 23, 190, 1, 1), 
(18877, 18877, "Adult Kookaburra", 0, "", 0, "LineageMonster2.youth_ostrich", 8, 26.4, 83, "male", "L2FeedableBeast", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 72113, 7459, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 23, 190, 1, 1), 
(18878, 18878, "Full Grown Kookaburra", 0, "", 0, "LineageMonster2.rough_ostrich", 10, 33, 83, "male", "L2FeedableBeast", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 11959, 1246, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 23, 190, 1, 1), 
(18879, 18879, "Full Grown Kookaburra", 0, "", 0, "LineageMonster2.rough_ostrich", 10, 33, 83, "male", "L2FeedableBeast", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 76500, 6972, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 23, 190, 1, 1), 
(18880, 18880, "Baby Alpine Cougar", 0, "", 0, "LineageMonster2.baby_tiger", 8, 15.7, 83, "male", "L2FeedableBeast", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 11630, 1256, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 1, 333, 0, 0, 0, 28, 110, 1, 1), 
(18881, 18881, "Young Cougar", 0, "", 0, "LineageMonster2.baby_tiger_130p", 13, 21, 83, "male", "L2FeedableBeast", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 18776, 1918, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 1, 333, 0, 0, 0, 28, 110, 1, 1), 
(18882, 18882, "Young Cougar", 0, "", 0, "LineageMonster2.baby_tiger_130p", 13, 21, 83, "male", "L2FeedableBeast", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 25005, 2686, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 1, 333, 0, 0, 0, 28, 110, 1, 1), 
(18883, 18883, "Adult Cougar", 0, "", 0, "LineageMonster2.youth_tiger", 16, 17.2, 83, "male", "L2FeedableBeast", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 8516, 874, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 1, 333, 0, 0, 0, 60, 170, 1, 1), 
(18884, 18884, "Adult Cougar", 0, "", 0, "LineageMonster2.youth_tiger", 16, 17.2, 83, "male", "L2FeedableBeast", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 72113, 7459, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 1, 333, 0, 0, 0, 60, 170, 1, 1), 
(18885, 18885, "Full Grown Cougar", 0, "", 0, "LineageMonster.saber_toothed_tiger", 34, 28, 83, "male", "L2FeedableBeast", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 11959, 1246, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 1, 333, 0, 0, 0, 60, 170, 1, 1), 
(18886, 18886, "Full Grown Cougar", 0, "", 0, "LineageMonster.saber_toothed_tiger", 34, 28, 83, "male", "L2FeedableBeast", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 76500, 6972, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 1, 333, 0, 0, 0, 60, 170, 1, 1), 
(18887, 18887, "Baby Alpine Buffalo", 0, "", 0, "LineageMonster2.baby_buffalo", 8, 15, 84, "male", "L2FeedableBeast", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 12929, 1379, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 30, 110, 1, 1), 
(18888, 18888, "Young Buffalo", 0, "", 0, "LineageMonster2.baby_buffalo_140p", 16, 22, 84, "male", "L2FeedableBeast", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 20911, 2111, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 30, 110, 1, 1), 
(18889, 18889, "Young Buffalo", 0, "", 0, "LineageMonster2.baby_buffalo_140p", 16, 22, 84, "male", "L2FeedableBeast", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 27445, 2908, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 30, 110, 1, 1), 
(18890, 18890, "Adult Buffalo", 0, "", 0, "LineageMonster2.youth_buffalo", 16, 25.2, 84, "male", "L2FeedableBeast", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 9438, 957, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 20, 170, 1, 1), 
(18891, 18891, "Adult Buffalo", 0, "", 0, "LineageMonster2.youth_buffalo", 16, 25.2, 84, "male", "L2FeedableBeast", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 79302, 8101, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 20, 170, 1, 1), 
(18892, 18892, "Full Grown Buffalo", 0, "", 0, "LineageMonster2.buffalo", 22, 31, 84, "male", "L2FeedableBeast", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 13050, 1342, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 1, 333, 0, 0, 0, 80, 170, 1, 1), 
(18893, 18893, "Full Grown Buffalo", 0, "", 0, "LineageMonster2.buffalo", 22, 31, 84, "male", "L2FeedableBeast", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 83904, 7596, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 1, 333, 0, 0, 0, 80, 170, 1, 1), 
(18894, 18894, "Baby Alpine Grendel", 0, "", 0, "LineageMonster5.baby_bionic_bear", 9, 12.5, 84, "male", "L2FeedableBeast", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 12929, 1379, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 40, 120, 1, 1), 
(18895, 18895, "Young Grendel", 0, "", 0, "LineageMonster5.baby_bionic_bear_e", 9, 12.5, 84, "male", "L2FeedableBeast", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 20911, 2111, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 40, 120, 1, 1), 
(18896, 18896, "Young Grendel", 0, "", 0, "LineageMonster5.baby_bionic_bear_e", 9, 12.5, 84, "male", "L2FeedableBeast", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 27445, 2908, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 40, 120, 1, 1), 
(18897, 18897, "Adult Grendel", 0, "", 0, "LineageMonster2.bionic_bear", 15, 39, 84, "male", "L2FeedableBeast", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 9438, 957, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 36, 155, 1, 1), 
(18898, 18898, "Adult Grendel", 0, "", 0, "LineageMonster2.bionic_bear", 15, 39, 84, "male", "L2FeedableBeast", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 79302, 8101, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 36, 155, 1, 1), 
(18899, 18899, "Full Grown Grendel", 0, "", 0, "LineageMonster5.rough_bionic_bear", 34, 32.5, 84, "male", "L2FeedableBeast", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 13050, 1342, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 40, 120, 1, 1), 
(18900, 18900, "Full Grown Grendel", 0, "", 0, "LineageMonster5.rough_bionic_bear", 34, 32.5, 84, "male", "L2FeedableBeast", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 83904, 7596, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 40, 120, 1, 1), 
(18901, 18901, "Kookaburra", 0, "Golden", 0, "LineageMonster2.baby_ostrich_140p_e", 12, 21, 83, "male", "L2Npc", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 13, 110, 0, 1), 
(18902, 18902, "Cougar", 0, "Golden", 0, "LineageMonster2.baby_tiger_130p_e", 13, 21, 83, "male", "L2Npc", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 28, 110, 0, 1), 
(18903, 18903, "Buffalo", 0, "Golden", 0, "LineageMonster2.baby_buffalo_140p_e", 16, 22, 84, "male", "L2Npc", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 30, 110, 0, 1), 
(18904, 18904, "Grendel", 0, "Golden", 0, "LineageMonster5.baby_bionic_bear_160p", 12, 17, 84, "male", "L2Npc", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 40, 120, 0, 1), 
(18905, 18905, "Farm Ravager", 0, "Crazed", 0, "LineageMonster5.xel_mahum_warrior", 29, 37, 84, "male", "L2Npc", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 243976, 2243, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), 
(18906, 18906, "Farm Bandit", 0, "", 0, "LineageMonster5.xel_mahum_warrior", 29, 37, 84, "male", "L2Monster", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 17662, 1884, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 60, 180, 1, 1), 
(18907, 18907, "Beast Devourer", 0, "", 0, "LineageMonster5.xel_mahum_sniper", 27, 31, 84, "male", "L2Monster", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 18652, 1990, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 60, 150, 1, 1), 
(18908, 18908, "Sel Mahum Chef", 0, "", 0, "LineageMonster5.ol_mahum_cooker", 35, 32.5, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 17548, 1759, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 40, 120, 0, 1), 
(18909, 18909, "Solina Knights", 0, "", 0, "LineageMonster3.monk_warrior", 12, 28.4, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 29810, 3060, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 8211, 8210, 0, 53, 150, 0, 1), 
(18910, 18910, "Solina Knight Captain", 0, "", 0, "LineageMonster5.solina_knight", 14, 31.5, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 44216, 4545, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 30, 66, 0, 1), 
(18911, 18911, "Abbey Treasure Chest", 0, "", 0, "LineageNpcEV.monastery_treasurebox", 17, 13, 84, "male", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18912, 18912, "Scarecrow", 0, "", 0, "LineageNpcEV.puppet", 27, 37.5, 1, "male", "L2Monster", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18913, 18913, "Furnace", 0, "", 0, "LineageNpcEV.secret_pot_b", 18, 30, 1, "male", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18914, 18914, "Furnace", 0, "", 0, "LineageNpcEV.secret_pot_a", 18, 30, 1, "male", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18915, 18915, "Divine Furnace", 0, "", 0, "LineageNpcEV.secret_pot_c", 18, 30, 1, "male", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18916, 18916, "", 0, "", 0, "LineageNPC.camera_target_dummy_a", 0.1, 0.1, 1, "male", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18917, 18917, "Pavel Safety Device", 0, "", 0, "LineageMonster4.giga_whirligig_40p", 12, 22.5, 72, "male", "L2Monster", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 0, 0, 0, 250, 250, 0, 1), 
(18918, 18918, "", 0, "", 0, "LineageNPC.camera_target_dummy_a", 0.1, 0.1, 85, "male", "L2Npc", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18919, 18919, "", 0, "", 0, "LineageNPC.camera_target_dummy_a", 0.1, 0.1, 85, "male", "L2Npc", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18920, 18920, "", 0, "", 0, "LineageNPC.camera_target_dummy_a", 0.1, 0.1, 84, "male", "L2Npc", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18921, 18921, "Square Base", 0, "", 0, "LineageNpcEV.dark_clouds_crystal", 23, 37, 84, "male", "L2Npc", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18922, 18922, "Door Golem", 0, "Final", 0, "LineageMonster2.baby_buffalo", 8, 15, 84, "male", "L2Npc", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 30, 80, 0, 1), 
(18923, 18923, "Door Golem", 0, "Final", 0, "LineageMonster2.baby_buffalo", 8, 15, 84, "male", "L2Npc", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 30, 80, 0, 1), 
(18924, 18924, "Door Golem", 0, "", 0, "LineageMonster2.baby_buffalo", 8, 15, 84, "male", "L2Npc", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 30, 80, 0, 1), 
(18925, 18925, "Trap", 0, "", 0, "LineageNpcEV.Trap_device_bottom_staff", 30, 13, 84, "etc", "L2Npc", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18926, 18926, "Mercenary Archer", 0, "Jinia Guild", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 85, "male", "L2Npc", 1100, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 8, 333, 0, 0, 0, 30, 160, 0, 1), 
(18927, 18927, "Fire", 0, "", 0, "LineageNpcEV.camp_fire_a", 29, 30.5, 84, "male", "L2Npc", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18928, 18928, "Annihilation Furnace", 0, "", 0, "LineageNpcEV.gracia_fire_pot", 63, 33.5, 85, "male", "L2TerrainObject", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18929, 18929, "Ward of the Grail", 0, "", 0, "LineageMonster.will_o_wisp", 13, 22, 84, "male", "L2Npc", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 1, 333, 0, 0, 0, 25, 140, 0, 1), 
(18930, 18930, "", 0, "", 0, "LineageNPC.camera_target_dummy_a", 0.1, 0.1, 1, "male", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18931, 18931, "", 0, "", 0, "LineageNPC.camera_target_dummy_a", 0.1, 0.1, 1, "male", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18932, 18932, "", 0, "", 0, "LineageNpcEV.freezing_dummy", 0.1, 0.1, 1, "male", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18933, 18933, "Fire Feed", 0, "", 0, "LineageNpcEV.camp_fire_c", 29, 30.5, 1, "male", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18934, 18934, "Abbey Treasure Chest", 0, "", 0, "LineageNpcEV.monastery_treasurebox", 17, 13, 84, "male", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18935, 18935, "Divine Sword Protection", 0, "", 0, "LineageNPC.camera_target_dummy_a", 0.1, 0.1, 85, "male", "L2Npc", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18936, 18936, "", 0, "", 0, "LineageNPC.camera_target_dummy_a", 0.1, 0.1, 1, "male", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(18937, 18937, "Target Dummy", 0, "", 0, "LineageNPC.camera_target_dummy_a", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(18938, 18938, "Target Dummy", 0, "", 0, "LineageNPC.camera_target_dummy_a", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(18939, 18939, "Target Dummy", 0, "", 0, "LineageNPC.camera_target_dummy_a", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(18940, 18940, "Target Dummy", 0, "", 0, "LineageNPC.camera_target_dummy_a", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(18941, 18941, "Target Dummy", 0, "", 0, "LineageNPC.camera_target_dummy_a", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(18942, 18942, "Target Dummy", 0, "", 0, "LineageNPC.camera_target_dummy_a", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(18943, 18943, "Target Dummy", 0, "", 0, "LineageNPC.camera_target_dummy_a", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(18944, 18944, "Target Dummy", 0, "", 0, "LineageNPC.camera_target_dummy_a", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(18945, 18945, "Target Dummy", 0, "", 0, "LineageNPC.camera_target_dummy_a", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(18946, 18946, "Target Dummy", 0, "", 0, "LineageNPC.camera_target_dummy_a", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(18947, 18947, "Target Dummy", 0, "", 0, "LineageNPC.camera_target_dummy_a", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(18948, 18948, "Etis van Etina", 0, "Head of the Embryo", 0, "LineageMonster6.etis_van_etina", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(18949, 18949, "Etis van Etina", 0, "Head of the Embryo", 0, "LineageMonster6.etis_van_etina_tran", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(18950, 18950, "Etis van Etina's Phantom", 0, "", 0, "LineageMonster6.etis_van_etina", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(18951, 18951, "Etis van Etina's Phantom", 0, "", 0, "LineageMonster6.etis_van_etina", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(18952, 18952, "Solina's Guardian", 0, "", 0, "LineageNpc2.fallow_of_solina", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(18953, 18953, "Solina's Guardian", 0, "", 0, "LineageNpc2.fallow_of_solina", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(18954, 18954, "Solina's Guardian", 0, "", 0, "LineageNpc2.fallow_of_solina", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(18955, 18955, "Solina's Guardian", 0, "", 0, "LineageNpc2.fallow_of_solina", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(18956, 18956, "Guardian of the Tomb", 0, "", 0, "LineageMonster3.apostle_grail_a", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(18957, 18957, "Guardian of the Tomb", 0, "", 0, "LineageMonster3.apostle_grail_a", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(18958, 18958, "Guardian of the Tomb", 0, "", 0, "LineageMonster3.apostle_grail_a", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(18959, 18959, "Guardian of the Tomb", 0, "", 0, "LineageMonster3.apostle_grail_a", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(18960, 18960, "Drake Lord", 0, "", 0, "LineageMonster6.transform_clodecus", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(18961, 18961, "Behemoth Leader", 0, "", 0, "LineageMonster3.antaras_ex_a_raid", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(18962, 18962, "Dragon Beast", 0, "", 0, "LineageMonster.kaim_vanul_50_bi_a", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(18963, 18963, "", 0, "", 0, "LineageNpc2.trap_mark", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(18964, 18964, "Antharas's Symbol", 0, "", 0, "LineageNpcEV.small_machine", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(18965, 18965, "Antharas's Symbol", 0, "", 0, "LineageNpcEV.small_machine", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(18966, 18966, "Antharas's Symbol", 0, "", 0, "LineageNpcEV.small_machine", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(18967, 18967, "", 0, "", 0, "LineageNPC.camera_target_dummy_a", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(18968, 18968, "", 0, "", 0, "LineageNPC.camera_target_dummy_a", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(18969, 18969, "Magma Drake Mother", 0, "", 0, "LineageMonster2.inferno_drake_120p", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(18970, 18970, "Magma Drake Hatchling", 0, "", 0, "LineageMonster2.inferno_drake_50p", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(18971, 18971, "Gem Dragon Hatchling", 0, "", 0, "LineageMonster3.antaras_ex_b_tr_70p", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(20001, 20001, "Gremlin", 0, "", 0, "LineageMonster.gremlin", 10, 15, 1, "male", "L2Monster", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 29, 2, 8.47458, 44.44444, 5.78704, 29.59162, 253, 4, 333, 0, 0, 0, 20, 50, 0, 1), 
(20002, 20002, "Rabbit", 0, "", 0, "LineageMonster.rabbit", 5, 4.5, 1, "male", "L2Monster", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 29, 2, 8.47458, 44.44444, 5.78704, 29.59162, 253, 4, 333, 0, 0, 0, 50, 80, 0, 1), 
(20003, 20003, "Goblin", 0, "", 0, "LineageMonster.goblin", 10, 16.5, 5, "male", "L2Monster", 40, 80.17319, 69.6, 2, 0.9, 40, 43, 30, 21, 20, 20, 178, 5, 12.34006, 51.60553, 8.42666, 34.35955, 253, 1, 333, 4, 0, 0, 40, 110, 1, 1), 
(20004, 20004, "Imp", 0, "", 0, "LineageMonster.imp", 10, 24, 6, "male", "L2Monster", 40, 93.54158, 77.2, 2, 0.9, 40, 43, 30, 21, 20, 20, 214, 6, 13.52471, 53.53373, 9.23562, 35.64336, 253, 4, 333, 0, 0, 0, 60, 80, 1, 1), 
(20005, 20005, "Imp Elder", 0, "", 0, "LineageMonster.imp", 10, 24, 7, "male", "L2Monster", 40, 108.42254, 84.88, 2, 0.9, 40, 43, 30, 21, 20, 20, 249, 8, 14.80956, 55.51894, 10.11301, 36.96514, 253, 4, 333, 0, 0, 0, 60, 80, 1, 1), 
(20006, 20006, "Orc Archer", 0, "", 0, "LineageMonster.orc_archer", 14, 25, 8, "male", "L2Monster", 1100, 124.92828, 92.64, 2, 0.9, 40, 43, 30, 21, 20, 20, 293, 10, 16.20165, 57.56203, 11.06363, 38.32545, 253, 8, 333, 14, 0, 0, 45, 110, 1, 1), 
(20007, 20007, "Green Fungus", 0, "", 0, "LineageMonster.walking_fungus", 15, 22.5, 9, "male", "L2Monster", 40, 143.17564, 100.48, 2, 0.9, 40, 43, 30, 21, 20, 20, 321, 11, 17.70841, 59.66387, 12.09255, 39.72488, 253, 4, 333, 0, 0, 0, 70, 110, 1, 1), 
(20008, 20008, "Felim Lizardman", 0, "", 0, "LineageMonster.virud_lizardman", 10, 23, 14, "male", "L2Monster", 40, 230.38548, 140.88, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 499, 19, 27.24646, 71.08179, 18.6058, 47.32706, 253, 4, 333, 1, 0, 0, 43, 130, 1, 1), 
(20009, 20009, "Vuku Orc", 0, "", 0, "LineageMonster.orc", 10, 21, 14, "male", "L2Monster", 40, 230.38548, 140.88, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 499, 19, 27.24646, 71.08179, 18.6058, 47.32706, 253, 1, 333, 156, 0, 0, 45, 110, 1, 1), 
(20010, 20010, "Felim Lizardman Scout", 0, "", 0, "LineageMonster.virud_lizardman", 10, 23, 15, "male", "L2Monster", 40, 246.95422, 149.2, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 534, 22, 29.61691, 73.55216, 20.22451, 48.97186, 253, 4, 333, 16, 0, 0, 43, 130, 1, 1), 
(20011, 20011, "Vuku Orc Archer", 0, "", 0, "LineageMonster.orc_archer", 14, 25, 15, "male", "L2Monster", 1100, 246.95422, 149.2, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 551, 22, 29.61691, 73.55216, 20.22451, 48.97186, 253, 8, 333, 14, 0, 0, 45, 110, 1, 1), 
(20012, 20012, "Gora Werewolf", 0, "", 0, "LineageMonster.werewolf", 10, 26, 16, "male", "L2Monster", 40, 264.34345, 157.6, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 582, 23, 32.16396, 76.08628, 21.96382, 50.6591, 253, 1, 333, 0, 0, 0, 50, 120, 1, 1), 
(20013, 20013, "Dryad", 0, "", 0, "LineageMonster.dryad", 9, 20, 13, "female", "L2Monster", 40, 214.61578, 132.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 463, 18, 25.04271, 68.67458, 17.10092, 45.72431, 253, 4, 333, 0, 0, 0, 40, 110, 1, 1), 
(20014, 20014, "Felim Lizardman Warrior", 0, "", 0, "LineageMonster.virud_lizardman_warrior", 12, 30, 17, "male", "L2Monster", 40, 282.57403, 166.08, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 606, 25, 34.8979, 78.68469, 23.83074, 52.38915, 253, 4, 333, 16, 0, 0, 52, 130, 1, 1), 
(20015, 20015, "Marsh Zombie", 0, "", 0, "LineageMonster.zombie", 13, 21, 13, "male", "L2Monster", 40, 214.61578, 132.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 655, 26, 25.04271, 68.67458, 17.10092, 45.72431, 253, 4, 333, 0, 0, 0, 15, 15, 1, 1), 
(20016, 20016, "Stone Golem", 0, "", 0, "LineageMonster.stone_golem", 20, 31, 13, "male", "L2Monster", 40, 214.61578, 132.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 655, 26, 25.04271, 68.67458, 17.10092, 45.72431, 253, 4, 333, 0, 0, 0, 23, 23, 1, 1), 
(20017, 20017, "Vuku Orc Fighter", 0, "", 0, "LineageMonster.orc_fighter", 12, 22, 17, "male", "L2Monster", 40, 282.57403, 166.08, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 618, 26, 34.8979, 78.68469, 23.83074, 52.38915, 253, 4, 333, 2, 0, 0, 45, 110, 1, 1), 
(20018, 20018, "Carnivorous Fungus", 0, "", 0, "LineageMonster.walking_fungus", 15, 22.5, 14, "male", "L2Monster", 40, 230.38548, 140.88, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 424, 16, 27.24646, 71.08179, 18.6058, 47.32706, 253, 4, 333, 0, 0, 0, 70, 110, 0, 1), 
(20019, 20019, "Dryad Elder", 0, "", 0, "LineageMonster.dryad", 9, 20, 14, "female", "L2Monster", 40, 230.38548, 140.88, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 499, 19, 27.24646, 71.08179, 18.6058, 47.32706, 253, 4, 333, 0, 0, 0, 40, 110, 1, 1), 
(20020, 20020, "Marsh Zombie Lord", 0, "", 0, "LineageMonster.zombie", 13, 21, 14, "male", "L2Monster", 40, 230.38548, 140.88, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 705, 27, 27.24646, 71.08179, 18.6058, 47.32706, 253, 4, 333, 0, 0, 0, 15, 15, 1, 1), 
(20021, 20021, "Red Bear", 0, "", 0, "LineageMonster.grizzly", 21, 40, 14, "male", "L2Monster", 40, 230.38548, 140.88, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 499, 19, 27.24646, 71.08179, 18.6058, 47.32706, 253, 4, 333, 0, 0, 0, 40, 110, 1, 1), 
(20022, 20022, "Misery Skeleton", 0, "", 0, "LineageMonster.skeleton", 11, 25, 14, "male", "L2Monster", 40, 230.38548, 140.88, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 424, 16, 27.24646, 71.08179, 18.6058, 47.32706, 253, 8, 333, 946, 945, 0, 60, 140, 0, 1), 
(20023, 20023, "Shadow Beast", 0, "", 0, "LineageMonster.onyx_beast", 14, 14.5, 15, "male", "L2Monster", 40, 246.95422, 149.2, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 534, 22, 29.61691, 73.55216, 20.22451, 48.97186, 253, 4, 333, 0, 0, 0, 30, 120, 1, 1), 
(20024, 20024, "Langk Lizardman Warrior", 0, "", 0, "LineageMonster.virud_lizardman_warrior", 12, 30, 17, "male", "L2Monster", 40, 282.57403, 166.08, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 618, 26, 34.8979, 78.68469, 23.83074, 52.38915, 253, 4, 333, 16, 0, 0, 52, 130, 1, 1), 
(20025, 20025, "Lesser Dark Horror", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 15, "male", "L2Monster", 40, 246.95422, 149.2, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 545, 22, 29.61691, 73.55216, 20.22451, 48.97186, 253, 4, 333, 0, 0, 0, 100, 100, 1, 1), 
(20026, 20026, "Ruin Zombie", 0, "", 0, "LineageMonster.zombie", 13, 21, 15, "male", "L2Monster", 40, 246.95422, 149.2, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 756, 31, 29.61691, 73.55216, 20.22451, 48.97186, 253, 4, 333, 0, 0, 0, 15, 15, 1, 1), 
(20027, 20027, "Langk Lizardman Scout", 0, "", 0, "LineageMonster.virud_lizardman", 10, 23, 16, "male", "L2Monster", 40, 264.34345, 157.6, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 571, 23, 32.16396, 76.08628, 21.96382, 50.6591, 253, 4, 333, 16, 0, 0, 43, 130, 1, 1), 
(20028, 20028, "Pincher", 0, "", 0, "LineageMonster.giant_spider", 26, 25.5, 16, "male", "L2Monster", 40, 264.34345, 157.6, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 571, 23, 32.16396, 76.08628, 21.96382, 50.6591, 253, 4, 333, 0, 0, 0, 72, 130, 1, 1), 
(20029, 20029, "Ruin Zombie Leader", 0, "", 0, "LineageMonster.zombie", 13, 21, 16, "male", "L2Monster", 40, 264.34345, 157.6, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 807, 33, 32.16396, 76.08628, 21.96382, 50.6591, 253, 4, 333, 0, 0, 0, 15, 15, 1, 1), 
(20030, 20030, "Langk Lizardman", 0, "", 0, "LineageMonster.virud_lizardman", 10, 23, 15, "male", "L2Monster", 40, 246.95422, 149.2, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 534, 22, 29.61691, 73.55216, 20.22451, 48.97186, 253, 4, 333, 1, 0, 0, 43, 130, 1, 1), 
(20031, 20031, "Omen Beast", 0, "", 0, "LineageMonster.onyx_beast", 14, 14.5, 17, "male", "L2Monster", 40, 282.57403, 166.08, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 505, 21, 34.8979, 78.68469, 23.83074, 52.38915, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(20032, 20032, "Pinrul", 0, "", 0, "LineageMonster.giant_spider", 26, 25.5, 17, "male", "L2Monster", 40, 282.57403, 166.08, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 606, 25, 34.8979, 78.68469, 23.83074, 52.38915, 253, 4, 333, 0, 0, 0, 72, 130, 1, 1), 
(20033, 20033, "Shade Horror", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 17, "male", "L2Monster", 40, 282.57403, 166.08, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 505, 21, 34.8979, 78.68469, 23.83074, 52.38915, 253, 4, 333, 0, 0, 0, 100, 100, 0, 1), 
(20034, 20034, "Prowler", 0, "", 0, "LineageMonster.giant_spider", 26, 25.5, 17, "male", "L2Monster", 40, 282.57403, 166.08, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 618, 26, 34.8979, 78.68469, 23.83074, 52.38915, 253, 4, 333, 0, 0, 0, 72, 130, 1, 1), 
(20035, 20035, "Tracker Skeleton", 0, "", 0, "LineageMonster.skeleton", 11, 25, 17, "male", "L2Monster", 40, 282.57403, 166.08, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 606, 25, 34.8979, 78.68469, 23.83074, 52.38915, 253, 8, 333, 946, 945, 0, 60, 140, 1, 1), 
(20036, 20036, "Lirein", 0, "", 0, "LineageMonster.sylph", 11, 35, 18, "female", "L2Monster", 40, 301.66622, 174.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 653, 28, 37.82932, 81.34791, 25.83252, 54.16236, 253, 4, 333, 0, 0, 0, 60, 60, 1, 1), 
(20037, 20037, "Mana Seeker", 0, "", 0, "LineageMonster.mana_vampire", 11, 20, 18, "male", "L2Monster", 40, 301.66622, 174.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 992, 43, 37.82932, 81.34791, 25.83252, 54.16236, 253, 1, 333, 0, 0, 0, 90, 90, 0, 1), 
(20038, 20038, "Venomous Spider", 0, "", 0, "LineageMonster.poison_spider", 27, 25.5, 18, "male", "L2Monster", 40, 301.66622, 174.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 704, 31, 37.82932, 81.34791, 25.83252, 54.16236, 253, 4, 333, 0, 0, 0, 60, 140, 1, 1), 
(20039, 20039, "Scavenger Wererat", 0, "", 0, "LineageMonster.wererat", 14, 25, 18, "male", "L2Monster", 40, 301.66622, 174.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 640, 28, 37.82932, 81.34791, 25.83252, 54.16236, 253, 8, 333, 12, 0, 0, 80, 120, 1, 1), 
(20040, 20040, "Sukar Wererat", 0, "", 0, "LineageMonster.wererat", 14, 25, 18, "male", "L2Monster", 40, 301.66622, 174.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 533, 23, 37.82932, 81.34791, 25.83252, 54.16236, 253, 8, 333, 216, 0, 0, 80, 120, 0, 1), 
(20041, 20041, "Tainted Zombie", 0, "", 0, "LineageMonster.zombie", 13, 21, 18, "male", "L2Monster", 40, 301.66622, 174.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 754, 33, 37.82932, 81.34791, 25.83252, 54.16236, 253, 4, 333, 0, 0, 0, 15, 15, 0, 1), 
(20042, 20042, "Tracker Skeleton Leader", 0, "", 0, "LineageMonster.skeleton", 11, 25, 18, "male", "L2Monster", 40, 301.66622, 174.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 653, 28, 37.82932, 81.34791, 25.83252, 54.16236, 253, 8, 333, 946, 945, 0, 60, 140, 1, 1), 
(20043, 20043, "Arachnid Tracker", 0, "", 0, "LineageMonster.poison_spider", 27, 25.5, 19, "male", "L2Monster", 40, 321.63954, 183.28, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 761, 34, 40.96915, 84.07638, 27.97662, 55.97901, 253, 4, 333, 0, 0, 0, 60, 140, 1, 1), 
(20044, 20044, "Lirein Elder", 0, "", 0, "LineageMonster.sylph", 11, 35, 19, "female", "L2Monster", 40, 321.63954, 183.28, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 692, 31, 40.96915, 84.07638, 27.97662, 55.97901, 253, 4, 333, 0, 0, 0, 60, 60, 1, 1), 
(20045, 20045, "Skeleton Scout", 0, "", 0, "LineageMonster.skeleton_archer", 11, 27, 19, "male", "L2Monster", 1100, 321.63954, 183.28, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 699, 31, 40.96915, 84.07638, 27.97662, 55.97901, 253, 8, 333, 275, 0, 0, 40, 140, 1, 1), 
(20046, 20046, "Stink Zombie", 0, "", 0, "LineageMonster.zombie", 13, 21, 19, "male", "L2Monster", 40, 321.63954, 183.28, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 799, 36, 40.96915, 84.07638, 27.97662, 55.97901, 253, 4, 333, 0, 0, 0, 15, 15, 0, 1), 
(20047, 20047, "Sukar Wererat Leader", 0, "", 0, "LineageMonster.wererat", 14, 25, 19, "male", "L2Monster", 40, 321.63954, 183.28, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 576, 26, 40.96915, 84.07638, 27.97662, 55.97901, 253, 8, 333, 216, 0, 0, 80, 120, 0, 1), 
(20048, 20048, "Lesser Succubus", 0, "", 0, "LineageMonster.succubus", 10, 36, 20, "female", "L2Monster", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 606, 27, 44.32863, 86.87049, 30.2707, 57.83936, 253, 4, 333, 0, 0, 0, 60, 100, 0, 1), 
(20049, 20049, "Lycanthrope", 0, "", 0, "LineageMonster.werewolf", 10, 26, 20, "male", "L2Monster", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 727, 32, 44.32863, 86.87049, 30.2707, 57.83936, 253, 1, 333, 0, 0, 0, 50, 120, 1, 1), 
(20050, 20050, "Arachnid Predator", 0, "", 0, "LineageMonster.poison_spider", 27, 25.5, 20, "male", "L2Monster", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 800, 35, 44.32863, 86.87049, 30.2707, 57.83936, 253, 4, 333, 0, 0, 0, 60, 140, 1, 1), 
(20051, 20051, "Skeleton Bowman", 0, "", 0, "LineageMonster.skeleton_archer", 11, 27, 20, "male", "L2Monster", 1100, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 734, 32, 44.32863, 86.87049, 30.2707, 57.83936, 253, 8, 333, 275, 0, 0, 40, 140, 1, 1), 
(20052, 20052, "Lesser Succubus Turen", 0, "", 0, "LineageMonster.succubus", 10, 36, 21, "female", "L2Monster", 40, 364.30351, 205.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 780, 36, 47.91924, 89.73059, 32.72263, 59.74364, 253, 4, 333, 0, 0, 0, 60, 100, 0, 1), 
(20053, 20053, "Ol Mahum Patrol", 0, "", 0, "LineageMonster.ol_mahum_archer", 14, 25, 21, "male", "L2Monster", 1100, 364.30351, 205.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 945, 43, 47.91924, 89.73059, 32.72263, 59.74364, 253, 8, 333, 14, 0, 0, 50, 110, 1, 1), 
(20054, 20054, "Ruin Spartoi", 0, "", 0, "LineageMonster.spartoi", 11, 27, 21, "male", "L2Monster", 40, 364.30351, 205.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 917, 42, 47.91924, 89.73059, 32.72263, 59.74364, 253, 4, 333, 73, 0, 0, 60, 140, 1, 1), 
(20055, 20055, "Wandering Eye", 0, "", 0, "LineageMonster.monster_eye", 21, 43, 21, "male", "L2Monster", 40, 364.30351, 205.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 917, 42, 47.91924, 89.73059, 32.72263, 59.74364, 253, 4, 333, 0, 0, 0, 90, 159, 1, 1), 
(20056, 20056, "Dre Vanul Disposer", 0, "", 0, "LineageMonster.dre_vanul", 14, 36, 22, "male", "L2Monster", 40, 387.02878, 218.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 921, 43, 51.75278, 92.65694, 35.34044, 61.69203, 253, 1, 333, 0, 0, 0, 80, 80, 0, 1), 
(20057, 20057, "Lesser Succubus Tilfo", 0, "", 0, "LineageMonster.succubus", 10, 36, 22, "female", "L2Monster", 40, 387.02878, 218.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 838, 40, 51.75278, 92.65694, 35.34044, 61.69203, 253, 4, 333, 0, 0, 0, 60, 100, 0, 1), 
(20058, 20058, "Ol Mahum Guard", 0, "", 0, "LineageMonster.ol_mahum", 13.5, 25, 22, "male", "L2Monster", 40, 387.02878, 218.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 986, 47, 51.75278, 92.65694, 35.34044, 61.69203, 253, 4, 333, 2, 0, 0, 50, 110, 1, 1), 
(20059, 20059, "Hungry Eye", 0, "", 0, "LineageMonster.monster_eye", 21, 43, 22, "male", "L2Monster", 40, 387.02878, 218.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 986, 47, 51.75278, 92.65694, 35.34044, 61.69203, 253, 4, 333, 0, 0, 0, 90, 159, 1, 1), 
(20060, 20060, "Raging Spartoi", 0, "", 0, "LineageMonster.spartoi", 11, 27, 22, "male", "L2Monster", 40, 387.02878, 218.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1005, 48, 51.75278, 92.65694, 35.34044, 61.69203, 253, 8, 333, 946, 945, 0, 60, 140, 1, 1), 
(20061, 20061, "Ol Mahum Straggler", 0, "", 0, "LineageMonster.ol_mahum", 13.5, 25, 23, "male", "L2Monster", 40, 410.70422, 231.96, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1075, 52, 55.84125, 95.64976, 38.13234, 63.68469, 253, 4, 333, 2, 0, 0, 50, 110, 1, 1), 
(20062, 20062, "Tumran Bugbear", 0, "", 0, "LineageMonster.bugbear", 17, 35, 23, "male", "L2Monster", 40, 410.70422, 231.96, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1054, 50, 55.84125, 95.64976, 38.13234, 63.68469, 253, 1, 333, 156, 0, 0, 55, 130, 1, 1), 
(20063, 20063, "Ol Mahum Shooter", 0, "", 0, "LineageMonster.ol_mahum_archer", 14, 25, 24, "male", "L2Monster", 1100, 435.34437, 245.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1156, 56, 60.19687, 98.70919, 41.10666, 65.72169, 253, 8, 333, 14, 0, 0, 50, 110, 1, 1), 
(20064, 20064, "Tumran Bugbear Warrior", 0, "", 0, "LineageMonster.bugbear", 17, 35, 24, "male", "L2Monster", 40, 435.34437, 245.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1145, 56, 60.19687, 98.70919, 41.10666, 65.72169, 253, 1, 333, 88, 0, 0, 55, 130, 1, 1), 
(20065, 20065, "Ol Mahum Patrolman", 0, "", 0, "LineageMonster.ol_mahum", 13.5, 25, 25, "male", "L2Monster", 40, 460.96247, 259.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 992, 49, 64.83203, 101.83533, 44.27187, 67.80312, 253, 4, 333, 2, 0, 0, 50, 110, 0, 1), 
(20066, 20066, "Ol Mahum Captain", 0, "", 0, "LineageMonster.ol_mahum_champion", 14, 27, 25, "male", "L2Monster", 40, 460.96247, 259.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1263, 64, 64.83203, 101.83533, 44.27187, 67.80312, 253, 4, 333, 69, 0, 0, 50, 110, 1, 1), 
(20067, 20067, "Monster Eye Watcher", 0, "", 0, "LineageMonster.monster_eye", 21, 43, 25, "male", "L2Monster", 40, 460.96247, 259.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1191, 60, 64.83203, 101.83533, 44.27187, 67.80312, 253, 4, 333, 0, 0, 0, 90, 159, 1, 1), 
(20068, 20068, "Monster Eye Destroyer", 0, "", 0, "LineageMonster.monster_eye", 21, 43, 26, "male", "L2Monster", 40, 487.5704, 273, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1294, 65, 69.75926, 105.02818, 47.63653, 69.92894, 253, 4, 333, 0, 0, 0, 90, 159, 1, 1), 
(20069, 20069, "Selu Lizardman Scout", 0, "", 0, "LineageMonster.virud_lizardman", 10, 23, 26, "male", "L2Monster", 40, 487.5704, 273, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1057, 53, 69.75926, 105.02818, 47.63653, 69.92894, 253, 4, 333, 16, 0, 0, 43, 130, 0, 1), 
(20070, 20070, "Lesser Basilisk", 0, "", 0, "LineageMonster.lesser_basilisk", 34, 25, 27, "male", "L2Monster", 40, 515.17856, 286.92, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1349, 70, 74.99121, 108.28767, 51.20928, 72.09915, 253, 4, 333, 0, 0, 0, 35, 131, 1, 1), 
(20071, 20071, "Selu Lizardman Warrior", 0, "", 0, "LineageMonster.virud_lizardman_warrior", 12, 30, 27, "male", "L2Monster", 40, 515.17856, 286.92, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1136, 58, 74.99121, 108.28767, 51.20928, 72.09915, 253, 4, 333, 16, 0, 0, 52, 130, 0, 1), 
(20072, 20072, "Basilisk", 0, "", 0, "LineageMonster.lesser_basilisk", 34, 25, 28, "male", "L2Monster", 40, 543.79576, 300.96, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1428, 74, 80.54056, 111.61368, 54.99876, 74.31365, 253, 4, 333, 0, 0, 0, 35, 131, 1, 1), 
(20073, 20073, "Ol Mahum Legionnaire", 0, "", 0, "LineageMonster.ol_mahum", 13.5, 25, 28, "male", "L2Monster", 40, 543.79576, 300.96, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1178, 62, 80.54056, 111.61368, 54.99876, 74.31365, 253, 4, 333, 2, 0, 0, 50, 110, 0, 1), 
(20074, 20074, "Androscorpio", 0, "", 0, "LineageMonster.onyx_beast", 14, 14.5, 29, "male", "L2Monster", 40, 573.42917, 315.12, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1492, 80, 86.42002, 115.00598, 59.01367, 76.57227, 253, 4, 333, 0, 0, 0, 30, 120, 1, 1), 
(20075, 20075, "Ant Larva", 0, "", 0, "LineageMonster.ant_larva", 12, 8, 29, "male", "L2Monster", 40, 573.42917, 315.12, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1368, 73, 86.42002, 115.00598, 59.01367, 76.57227, 253, 4, 333, 0, 0, 0, 40, 60, 0, 1), 
(20076, 20076, "Ol Mahum Commander", 0, "", 0, "LineageMonster.ol_mahum_champion", 14, 27, 29, "male", "L2Monster", 40, 573.42917, 315.12, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1583, 85, 86.42002, 115.00598, 59.01367, 76.57227, 253, 4, 333, 69, 0, 0, 50, 110, 1, 1), 
(20077, 20077, "Androscorpio Hunter", 0, "", 0, "LineageMonster.onyx_beast", 14, 14.5, 30, "male", "L2Monster", 40, 604.08419, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1571, 86, 92.64226, 118.46427, 63.26266, 78.87485, 253, 4, 333, 0, 0, 0, 30, 120, 1, 1), 
(20078, 20078, "Whispering Wind", 0, "", 0, "LineageMonster.sylph_100_bi", 20, 70, 30, "female", "L2Monster", 40, 604.08419, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1571, 86, 92.64226, 118.46427, 63.26266, 78.87485, 253, 4, 333, 0, 0, 0, 60, 60, 1, 1), 
(20079, 20079, "Ant", 0, "", 0, "LineageMonster.ant", 26, 15, 30, "male", "L2Monster", 40, 604.08419, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1571, 86, 92.64226, 118.46427, 63.26266, 78.87485, 253, 4, 333, 0, 0, 0, 40, 130, 0, 1), 
(20080, 20080, "Ant Captain", 0, "", 0, "LineageMonster.ant", 26, 15, 31, "male", "L2Monster", 40, 635.76437, 343.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1711, 95, 99.21986, 121.98819, 67.7543, 81.22111, 253, 4, 333, 0, 0, 0, 40, 130, 0, 1), 
(20081, 20081, "Ant Overseer", 0, "", 0, "LineageMonster.ant", 26, 15, 32, "male", "L2Monster", 40, 668.47132, 358.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2881, 162, 106.16525, 125.57727, 72.49711, 83.61076, 253, 4, 333, 0, 0, 0, 40, 130, 0, 1), 
(20082, 20082, "Ant Recruit", 0, "", 0, "LineageMonster.ant_soldier", 35, 17, 33, "male", "L2Monster", 40, 702.20463, 372.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1742, 100, 113.49065, 129.23095, 77.49941, 86.04342, 253, 4, 333, 0, 0, 0, 80, 130, 0, 1), 
(20083, 20083, "Granite Golem", 0, "", 0, "LineageMonster.stone_golem", 20, 31, 33, "male", "L2Monster", 40, 702.20463, 372.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2687, 155, 113.49065, 129.23095, 77.49941, 86.04342, 253, 4, 333, 0, 0, 0, 23, 23, 1, 1), 
(20084, 20084, "Ant Patrol", 0, "", 0, "LineageMonster.ant_soldier", 35, 17, 34, "male", "L2Monster", 40, 736.96177, 387.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2001, 116, 121.20802, 132.9486, 82.76936, 88.51867, 253, 4, 333, 0, 0, 0, 80, 130, 0, 1), 
(20085, 20085, "Puncher", 0, "", 0, "LineageMonster.stone_golem", 20, 31, 34, "male", "L2Monster", 40, 736.96177, 387.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2910, 170, 121.20802, 132.9486, 82.76936, 88.51867, 253, 4, 333, 0, 0, 0, 23, 23, 1, 1), 
(20086, 20086, "Ant Guard", 0, "", 0, "LineageMonster.ant_soldier", 35, 17, 35, "male", "L2Monster", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1782, 106, 129.32896, 136.72948, 88.31491, 91.03603, 253, 4, 333, 0, 0, 0, 80, 174, 0, 1), 
(20087, 20087, "Ant Soldier", 0, "", 0, "LineageMonster.ant_soldier", 35, 17, 35, "male", "L2Monster", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 4274, 253, 129.32896, 136.72948, 88.31491, 91.03603, 253, 4, 333, 0, 0, 0, 80, 174, 0, 1), 
(20088, 20088, "Ant Warrior Captain", 0, "", 0, "LineageMonster.ant_soldier", 35, 17, 36, "male", "L2Monster", 40, 809.52639, 417.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 4763, 288, 137.86467, 140.57278, 94.1437, 93.59494, 253, 4, 333, 0, 0, 0, 80, 174, 0, 1), 
(20089, 20089, "Noble Ant", 0, "", 0, "LineageMonster.noble_ant", 20, 48, 37, "male", "L2Monster", 40, 847.31754, 432.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1991, 122, 146.82587, 144.47758, 100.26304, 96.19481, 253, 4, 333, 0, 0, 0, 80, 174, 0, 1), 
(20090, 20090, "Noble Ant Leader", 0, "", 0, "LineageMonster.noble_ant", 20, 48, 38, "male", "L2Monster", 40, 886.09975, 447.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 4391, 274, 156.22273, 148.44287, 106.67987, 98.83494, 253, 4, 333, 0, 0, 0, 80, 174, 0, 1), 
(20091, 20091, "Young Fox", 0, "", 0, "LineageMonster.fox", 9.5, 10, 1, "male", "L2Monster", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 29, 2, 8.47458, 44.44444, 5.78704, 29.59162, 253, 4, 333, 0, 0, 0, 23, 110, 0, 1), 
(20092, 20092, "Monster Eye", 0, "", 0, "LineageMonster.monster_eye", 21, 43, 10, "male", "L2Monster", 40, 163.28607, 108.4, 2, 0.9, 40, 43, 30, 21, 20, 20, 294, 10, 19.33758, 61.82527, 13.20506, 41.16396, 253, 1, 333, 0, 0, 0, 90, 134, 0, 1), 
(20093, 20093, "Orc Fighter", 0, "", 0, "LineageMonster.orc_fighter", 12, 22, 10, "male", "L2Monster", 40, 163.28607, 108.4, 2, 0.9, 40, 43, 30, 21, 20, 20, 363, 12, 19.33758, 61.82527, 13.20506, 41.16396, 253, 4, 333, 1, 0, 0, 45, 110, 1, 1), 
(20094, 20094, "Orc Marksman", 0, "", 0, "LineageMonster.orc_archer", 14, 25, 10, "male", "L2Monster", 1100, 163.28607, 108.4, 2, 0.9, 40, 43, 30, 21, 20, 20, 306, 10, 19.33758, 61.82527, 13.20506, 41.16396, 253, 8, 333, 14, 0, 0, 45, 110, 0, 1), 
(20095, 20095, "Vampire Bat", 0, "", 0, "LineageMonster.vampire_bat", 10, 33.5, 10, "male", "L2Monster", 40, 163.28607, 108.4, 2, 0.9, 40, 43, 30, 21, 20, 20, 297, 10, 19.33758, 61.82527, 13.20506, 41.16396, 253, 1, 333, 0, 0, 0, 60, 80, 0, 1), 
(20096, 20096, "Orc Lieutenant", 0, "", 0, "LineageMonster.orc_fighter", 12, 22, 11, "male", "L2Monster", 40, 185.38552, 116.4, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 392, 15, 21.0973, 64.04702, 14.40672, 42.64323, 253, 4, 333, 2, 0, 0, 45, 110, 1, 1), 
(20097, 20097, "Drill Bat", 0, "", 0, "LineageMonster.vampire_bat", 10, 33.5, 11, "male", "L2Monster", 40, 185.38552, 116.4, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 326, 12, 21.0973, 64.04702, 14.40672, 42.64323, 253, 1, 333, 0, 0, 0, 60, 80, 0, 1), 
(20098, 20098, "Orc Fighter Leader", 0, "", 0, "LineageMonster.orc_fighter", 12, 22, 12, "male", "L2Monster", 40, 199.62322, 124.48, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 448, 17, 22.99606, 66.32989, 15.70333, 44.16318, 253, 4, 333, 2, 0, 0, 45, 110, 1, 1), 
(20099, 20099, "Skeleton", 0, "", 0, "LineageMonster.skeleton", 11, 25, 12, "male", "L2Monster", 40, 199.62322, 124.48, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 363, 13, 22.99606, 66.32989, 15.70333, 44.16318, 253, 8, 333, 946, 945, 0, 60, 140, 0, 1), 
(20100, 20100, "Skeleton Archer", 0, "", 0, "LineageMonster.skeleton_archer", 11, 27, 13, "male", "L2Monster", 1100, 214.61578, 132.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 405, 16, 25.04271, 68.67458, 17.10092, 45.72431, 253, 8, 333, 14, 0, 0, 40, 140, 0, 1), 
(20101, 20101, "Crasher", 0, "", 0, "LineageMonster.stone_golem", 20, 31, 14, "male", "L2Monster", 40, 230.38548, 140.88, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 705, 27, 27.24646, 71.08179, 18.6058, 47.32706, 253, 4, 333, 0, 0, 0, 23, 23, 1, 1), 
(20102, 20102, "Skeleton Marksman", 0, "", 0, "LineageMonster.skeleton_archer", 11, 27, 14, "male", "L2Monster", 1100, 230.38548, 140.88, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 428, 17, 27.24646, 71.08179, 18.6058, 47.32706, 253, 8, 333, 14, 0, 0, 40, 140, 0, 1), 
(20103, 20103, "Giant Spider", 0, "", 0, "LineageMonster.giant_spider", 26, 25.5, 15, "male", "L2Monster", 40, 246.95422, 149.2, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 545, 22, 29.61691, 73.55216, 20.22451, 48.97186, 253, 4, 333, 0, 0, 0, 72, 130, 1, 1), 
(20104, 20104, "Skeleton Lord", 0, "", 0, "LineageMonster.skeleton", 11, 25, 15, "male", "L2Monster", 40, 246.95422, 149.2, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 445, 18, 29.61691, 73.55216, 20.22451, 48.97186, 253, 8, 333, 946, 945, 0, 60, 140, 0, 1), 
(20105, 20105, "Dark Horror", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 16, "male", "L2Monster", 40, 264.34345, 157.6, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 577, 23, 32.16396, 76.08628, 21.96382, 50.6591, 253, 4, 333, 0, 0, 0, 100, 100, 1, 1), 
(20106, 20106, "Talon Spider", 0, "", 0, "LineageMonster.giant_spider", 26, 25.5, 16, "male", "L2Monster", 40, 264.34345, 157.6, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 571, 23, 32.16396, 76.08628, 21.96382, 50.6591, 253, 4, 333, 0, 0, 0, 72, 130, 1, 1), 
(20107, 20107, "Wererat", 0, "", 0, "LineageMonster.wererat", 14, 25, 16, "male", "L2Monster", 40, 264.34345, 157.6, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 476, 19, 32.16396, 76.08628, 21.96382, 50.6591, 253, 1, 333, 0, 0, 0, 80, 120, 0, 1), 
(20108, 20108, "Blade Spider", 0, "", 0, "LineageMonster.giant_spider", 26, 25.5, 17, "male", "L2Monster", 40, 282.57403, 166.08, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 618, 26, 34.8979, 78.68469, 23.83074, 52.38915, 253, 4, 333, 0, 0, 0, 72, 130, 1, 1), 
(20109, 20109, "Salamander", 0, "", 0, "LineageMonster.salamander", 16, 6.8, 17, "male", "L2Monster", 40, 282.57403, 166.08, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 990, 42, 34.8979, 78.68469, 23.83074, 52.38915, 253, 1, 333, 0, 0, 0, 64, 96, 0, 1), 
(20110, 20110, "Undine", 0, "", 0, "LineageMonster.undine", 12, 27, 17, "female", "L2Monster", 40, 282.57403, 166.08, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 958, 40, 34.8979, 78.68469, 23.83074, 52.38915, 253, 1, 333, 0, 0, 0, 60, 60, 0, 1), 
(20111, 20111, "Wererat Leader", 0, "", 0, "LineageMonster.wererat", 14, 25, 17, "male", "L2Monster", 40, 282.57403, 166.08, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 958, 40, 34.8979, 78.68469, 23.83074, 52.38915, 253, 4, 333, 1, 0, 0, 80, 120, 0, 1), 
(20112, 20112, "Salamander Elder", 0, "", 0, "LineageMonster.salamander", 16, 6.8, 18, "male", "L2Monster", 40, 301.66622, 174.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 992, 43, 37.82932, 81.34791, 25.83252, 54.16236, 253, 1, 333, 0, 0, 0, 64, 96, 0, 1), 
(20113, 20113, "Undine Elder", 0, "", 0, "LineageMonster.undine", 12, 27, 18, "female", "L2Monster", 40, 301.66622, 174.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 1012, 44, 37.82932, 81.34791, 25.83252, 54.16236, 253, 1, 333, 0, 0, 0, 60, 60, 0, 1), 
(20114, 20114, "Salamander Noble", 0, "", 0, "LineageMonster.salamander", 16, 6.8, 19, "male", "L2Monster", 40, 321.63954, 183.28, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 1051, 47, 40.96915, 84.07638, 27.97662, 55.97901, 253, 1, 333, 0, 0, 0, 64, 96, 0, 1), 
(20115, 20115, "Undine Noble", 0, "", 0, "LineageMonster.undine", 12, 27, 19, "female", "L2Monster", 40, 321.63954, 183.28, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 1072, 48, 40.96915, 84.07638, 27.97662, 55.97901, 253, 1, 333, 0, 0, 0, 60, 60, 0, 1), 
(20116, 20116, "Fox", 0, "", 0, "LineageMonster.fox", 9.5, 10, 2, "male", "L2Monster", 40, 48.09168, 47.28, 2, 0.9, 40, 43, 30, 21, 20, 20, 59, 2, 9.32203, 46.15385, 6.36574, 30.72975, 253, 4, 333, 0, 0, 0, 23, 110, 0, 1), 
(20117, 20117, "Dre Vanul", 0, "", 0, "LineageMonster.dre_vanul", 14, 36, 20, "male", "L2Monster", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 666, 29, 44.32863, 86.87049, 30.2707, 57.83936, 253, 1, 333, 0, 0, 0, 80, 80, 0, 1), 
(20118, 20118, "Dre Vanul Scout", 0, "", 0, "LineageMonster.dre_vanul", 14, 36, 21, "male", "L2Monster", 40, 364.30351, 205.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 780, 36, 47.91924, 89.73059, 32.72263, 59.74364, 253, 1, 333, 0, 0, 0, 80, 80, 0, 1), 
(20119, 20119, "Elder Fox", 0, "", 0, "LineageMonster.fox", 9.5, 10, 3, "male", "L2Monster", 40, 57.54874, 54.64, 2, 0.9, 40, 43, 30, 21, 20, 20, 88, 2, 10.24492, 47.91652, 6.99595, 31.90336, 253, 4, 333, 0, 0, 0, 23, 110, 0, 1), 
(20120, 20120, "Wolf", 0, "", 0, "LineageMonster.wolf", 13, 9, 4, "male", "L2Monster", 40, 68.20985, 62.08, 2, 0.9, 40, 43, 30, 21, 20, 20, 141, 4, 11.24892, 49.73343, 7.68155, 33.11308, 253, 4, 333, 0, 0, 0, 24, 110, 1, 1), 
(20121, 20121, "Giant Toad", 0, "", 0, "LineageMonster.poison_toad", 20, 10, 5, "male", "L2Monster", 40, 80.17319, 69.6, 2, 0.9, 40, 43, 30, 21, 20, 20, 178, 5, 12.34006, 51.60553, 8.42666, 34.35955, 253, 4, 333, 0, 0, 0, 50, 100, 1, 1), 
(20130, 20130, "Orc", 0, "", 0, "LineageMonster.orc", 10, 21, 6, "male", "L2Monster", 40, 93.54158, 77.2, 2, 0.9, 40, 43, 30, 21, 20, 20, 214, 6, 13.52471, 53.53373, 9.23562, 35.64336, 253, 1, 333, 156, 0, 0, 45, 110, 1, 1), 
(20131, 20131, "Orc Grunt", 0, "", 0, "LineageMonster.orc", 10, 21, 7, "male", "L2Monster", 40, 108.42254, 84.88, 2, 0.9, 40, 43, 30, 21, 20, 20, 249, 8, 14.80956, 55.51894, 10.11301, 36.96514, 253, 1, 333, 4, 0, 0, 45, 110, 1, 1), 
(20132, 20132, "Werewolf", 0, "", 0, "LineageMonster.werewolf", 10, 26, 9, "male", "L2Monster", 40, 143.17564, 100.48, 2, 0.9, 40, 43, 30, 21, 20, 20, 321, 11, 17.70841, 59.66387, 12.09255, 39.72488, 253, 1, 333, 0, 0, 0, 50, 120, 1, 1), 
(20133, 20133, "Bugbear", 0, "", 0, "LineageMonster.bugbear", 17, 35, 21, "male", "L2Monster", 40, 364.30351, 205.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 780, 36, 47.91924, 89.73059, 32.72263, 59.74364, 253, 1, 333, 4, 0, 0, 55, 130, 0, 1), 
(20134, 20134, "Cave Maiden", 0, "", 0, "LineageMonster.cave_maiden", 25, 65, 59, "female", "L2Monster", 40, 1880.92519, 1007, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 6135, 524, 461.94387, 242.81593, 315.44778, 161.66959, 253, 4, 333, 68, 0, 0, 70, 174, 0, 1), 
(20135, 20135, "Alligator", 0, "", 0, "LineageMonster.crocodile", 28, 11.5, 40, "male", "L2Monster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2848, 184, 176.36077, 156.55035, 120.43155, 104.23299, 253, 4, 333, 0, 0, 0, 70, 174, 1, 1), 
(20136, 20136, "Death Knight", 0, "", 0, "LineageMonster.death_knight", 12, 31, 50, "male", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 14026, 1012, 305.54906, 200.23844, 208.6504, 146.5258, 253, 4, 333, 75, 0, 0, 27, 110, 0, 1), 
(20137, 20137, "Drake", 0, "", 0, "LineageMonster.drake", 30, 100, 57, "male", "L2Monster", 40, 1776.58018, 948, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 5784, 481, 424.23295, 233.18839, 289.69611, 155.25946, 253, 4, 333, 0, 0, 0, 70, 174, 0, 1), 
(20138, 20138, "Gargoyle", 0, "", 0, "LineageMonster.gargoyle", 16, 50, 27, "male", "L2Monster", 40, 515.17856, 286.92, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1136, 58, 74.99121, 108.28767, 51.20928, 72.09915, 253, 4, 333, 0, 0, 0, 140, 140, 0, 1), 
(20139, 20139, "Giant Bee", 0, "", 0, "LineageMonster.giant_bee", 8, 24.5, 16, "male", "L2Monster", 40, 264.34345, 157.6, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 471, 19, 32.16396, 76.08628, 21.96382, 50.6591, 253, 4, 333, 0, 0, 0, 90, 90, 0, 1), 
(20140, 20140, "Giant Leech", 0, "", 0, "LineageMonster.giant_leech", 70, 29, 24, "male", "L2Monster", 40, 435.34437, 245.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 954, 47, 60.19687, 98.70919, 41.10666, 65.72169, 253, 4, 333, 0, 0, 0, 50, 110, 0, 1), 
(20141, 20141, "Giant Wild Hog", 0, "", 0, "LineageMonster.giant_wild_hog", 35, 27, 47, "male", "L2Monster", 40, 1276.53628, 665, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3277, 235, 261.69549, 186.63569, 178.7041, 124.26415, 253, 4, 333, 0, 0, 0, 35, 120, 0, 1), 
(20142, 20142, "Griffon", 0, "", 0, "LineageMonster.griffin", 20, 44, 20, "male", "L2Monster", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 594, 26, 44.32863, 86.87049, 30.2707, 57.83936, 253, 4, 333, 0, 0, 0, 90, 90, 0, 1), 
(20143, 20143, "Grizzly", 0, "", 0, "LineageMonster.grizzly", 21, 40, 12, "male", "L2Monster", 40, 199.62322, 124.48, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 436, 16, 22.99606, 66.32989, 15.70333, 44.16318, 253, 4, 333, 0, 0, 0, 40, 110, 1, 1), 
(20144, 20144, "Hangman Tree", 0, "", 0, "LineageMonster.hanged_man_ripper", 35, 80, 35, "male", "L2Monster", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2181, 130, 129.32896, 136.72948, 88.31491, 91.03603, 253, 4, 333, 0, 0, 0, 55, 174, 1, 1), 
(20145, 20145, "Harpy", 0, "", 0, "LineageMonster.harpy", 10, 42, 32, "female", "L2Monster", 40, 668.47132, 358.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1805, 101, 106.16525, 125.57727, 72.49711, 83.61076, 253, 4, 333, 0, 0, 0, 60, 100, 1, 1), 
(20146, 20146, "Headless Knight", 0, "", 0, "LineageMonster.headless_knight", 21, 31, 50, "male", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4450, 335, 305.54906, 200.23844, 208.6504, 133.32101, 253, 4, 333, 124, 0, 0, 70, 174, 0, 1), 
(20147, 20147, "Hobgoblin", 0, "", 0, "LineageMonster.hobgoblin", 12, 24, 21, "male", "L2Monster", 40, 364.30351, 205.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 917, 42, 47.91924, 89.73059, 32.72263, 59.74364, 253, 1, 333, 4, 0, 0, 45, 110, 1, 1), 
(20148, 20148, "Hungry Spirit", 0, "", 0, "LineageMonster.hungry_spirit", 30, 40, 40, "male", "L2Monster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2350, 151, 176.36077, 156.55035, 120.43155, 104.23299, 253, 4, 333, 0, 0, 0, 15, 120, 0, 1), 
(20149, 20149, "Iron Golem", 0, "", 0, "LineageMonster.iron_golem", 18, 34, 38, "male", "L2Monster", 40, 886.09975, 447.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 3029, 188, 156.22273, 148.44287, 106.67987, 98.83494, 253, 4, 333, 0, 0, 0, 20, 20, 0, 1), 
(20150, 20150, "King Bugbear", 0, "", 0, "LineageMonster.king_bugbear", 15, 40, 32, "male", "L2Monster", 40, 668.47132, 358.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1519, 85, 106.16525, 125.57727, 72.49711, 83.61076, 253, 1, 333, 88, 0, 0, 55, 130, 0, 1), 
(20151, 20151, "Kobold", 0, "", 0, "LineageMonster.kobold", 10, 15, 4, "male", "L2Monster", 40, 68.20985, 62.08, 2, 0.9, 40, 43, 30, 21, 20, 20, 119, 3, 11.24892, 49.73343, 7.68155, 33.11308, 253, 1, 333, 4, 0, 0, 47, 110, 0, 1), 
(20152, 20152, "Lizardman", 0, "", 0, "LineageMonster.virud_lizardman", 10, 23, 19, "male", "L2Monster", 40, 321.63954, 183.28, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 565, 25, 40.96915, 84.07638, 27.97662, 55.97901, 253, 4, 333, 291, 0, 0, 43, 130, 0, 1), 
(20153, 20153, "Magical Weaver", 0, "", 0, "LineageMonster.magical_weaver", 11, 20, 11, "male", "L2Monster", 40, 185.38552, 116.4, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 392, 15, 21.0973, 64.04702, 14.40672, 42.64323, 253, 4, 333, 0, 0, 0, 90, 90, 1, 1), 
(20154, 20154, "Mandragora Sprout", 0, "", 0, "LineageMonster.manadragora", 14, 17.8, 21, "female", "L2Monster", 40, 364.30351, 205.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 917, 42, 47.91924, 89.73059, 32.72263, 59.74364, 253, 4, 333, 0, 0, 0, 80, 80, 1, 1), 
(20155, 20155, "Mandragora Sapling", 0, "", 0, "LineageMonster.mandragora_a", 15, 26, 23, "female", "L2Monster", 40, 410.70422, 231.96, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1075, 52, 55.84125, 95.64976, 38.13234, 63.68469, 253, 4, 333, 0, 0, 0, 80, 120, 1, 1), 
(20156, 20156, "Mandragora Blossom", 0, "", 0, "LineageMonster.mandragora_b", 12, 25.5, 25, "female", "L2Monster", 40, 460.96247, 259.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1215, 61, 64.83203, 101.83533, 44.27187, 67.80312, 253, 4, 333, 0, 0, 0, 80, 120, 1, 1), 
(20157, 20157, "Marsh Stakato", 0, "", 0, "LineageMonster.marsh_stakato", 10, 20, 29, "male", "L2Monster", 40, 573.42917, 315.12, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1811, 97, 86.42002, 115.00598, 59.01367, 76.57227, 253, 8, 333, 223, 0, 0, 21, 120, 1, 1), 
(20158, 20158, "Medusa", 0, "", 0, "LineageMonster.medusa", 10, 25, 34, "female", "L2Monster", 40, 736.96177, 387.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2058, 120, 121.20802, 132.9486, 82.76936, 88.51867, 253, 4, 333, 0, 0, 0, 50, 110, 1, 1), 
(20159, 20159, "Minotaur", 0, "", 0, "LineageMonster.minotaur", 21, 45.5, 43, "male", "L2Monster", 40, 1094.28943, 557.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 2716, 184, 210.04832, 169.13417, 143.43577, 112.61144, 253, 1, 333, 300, 0, 0, 40, 120, 0, 1), 
(20160, 20160, "Neer Crawler", 0, "", 0, "LineageMonster.neer_crawler", 14, 22, 28, "male", "L2Monster", 40, 543.79576, 300.96, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1442, 76, 80.54056, 111.61368, 54.99876, 74.31365, 253, 4, 333, 0, 0, 0, 50, 90, 1, 1), 
(20161, 20161, "Oel Mahum", 0, "", 0, "LineageMonster.oel_mahum", 20, 37, 53, "male", "L2Monster", 40, 1570.8463, 832.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 4846, 380, 353.71092, 214.18326, 241.5387, 156.73001, 253, 4, 333, 127, 0, 0, 70, 110, 1, 1), 
(20162, 20162, "Ogre", 0, "", 0, "LineageMonster.ogre", 21, 44, 41, "male", "L2Monster", 40, 1008.23781, 504.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 2469, 162, 187.11878, 160.69002, 127.77787, 106.98923, 253, 4, 333, 98, 0, 0, 22, 80, 0, 1), 
(20163, 20163, "Ol Mahum", 0, "", 0, "LineageMonster.ol_mahum", 13.5, 25, 23, "male", "L2Monster", 40, 410.70422, 231.96, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 878, 42, 55.84125, 95.64976, 38.13234, 63.68469, 253, 4, 333, 2, 0, 0, 50, 110, 0, 1), 
(20164, 20164, "Ol Mahum Archer", 0, "", 0, "LineageMonster.ol_mahum_archer", 14, 25, 25, "male", "L2Monster", 1100, 460.96247, 259.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1043, 53, 64.83203, 101.83533, 44.27187, 67.80312, 253, 8, 333, 14, 0, 0, 50, 110, 0, 1), 
(20165, 20165, "Ol Mahum Champion", 0, "", 0, "LineageMonster.ol_mahum_champion", 14, 27, 29, "male", "L2Monster", 40, 573.42917, 315.12, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1509, 80, 86.42002, 115.00598, 59.01367, 76.57227, 253, 4, 333, 69, 0, 0, 50, 110, 0, 1), 
(20166, 20166, "Succubus", 0, "", 0, "LineageMonster.succubus", 10, 36, 32, "female", "L2Monster", 40, 668.47132, 358.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1519, 85, 106.16525, 125.57727, 72.49711, 83.61076, 253, 4, 333, 0, 0, 0, 60, 100, 0, 1), 
(20167, 20167, "Serpent Slave", 0, "", 0, "LineageMonster.serpent_slave", 17, 46, 40, "male", "L2Monster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2374, 154, 176.36077, 156.55035, 120.43155, 104.23299, 253, 4, 333, 73, 0, 0, 70, 110, 0, 1), 
(20168, 20168, "Silenos", 0, "", 0, "LineageMonster.silenos", 14, 32.5, 30, "male", "L2Monster", 40, 604.08419, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1571, 86, 92.64226, 118.46427, 63.26266, 78.87485, 253, 1, 333, 88, 0, 0, 70, 110, 1, 1), 
(20169, 20169, "Skeleton Royal Guard", 0, "", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 26, "male", "L2Monster", 40, 487.5704, 273, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1078, 54, 69.75926, 105.02818, 47.63653, 69.92894, 253, 8, 333, 946, 945, 0, 80, 120, 0, 1), 
(20170, 20170, "Spartoi", 0, "", 0, "LineageMonster.spartoi", 11, 27, 15, "male", "L2Monster", 40, 246.95422, 149.2, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 454, 19, 29.61691, 73.55216, 20.22451, 48.97186, 253, 8, 333, 946, 945, 0, 60, 140, 0, 1), 
(20171, 20171, "Specter", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 26, "male", "L2Monster", 40, 487.5704, 273, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1294, 65, 69.75926, 105.02818, 47.63653, 69.92894, 253, 4, 333, 0, 0, 0, 100, 100, 1, 1), 
(20172, 20172, "Sylph", 0, "", 0, "LineageMonster.sylph", 11, 35, 10, "female", "L2Monster", 40, 163.28607, 108.4, 2, 0.9, 40, 43, 30, 21, 20, 20, 297, 10, 19.33758, 61.82527, 13.20506, 41.16396, 253, 4, 333, 0, 0, 0, 60, 60, 0, 1), 
(20173, 20173, "Troll", 0, "", 0, "LineageMonster.troll", 21, 35, 33, "male", "L2Monster", 40, 702.20463, 372.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1600, 91, 113.49065, 129.23095, 77.49941, 86.04342, 253, 1, 333, 0, 0, 0, 55, 110, 0, 1), 
(20174, 20174, "Two-Headed Giant", 0, "", 0, "LineageMonster.twin_headed_giant", 17, 39, 35, "male", "L2Monster", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1799, 107, 129.32896, 136.72948, 88.31491, 91.03603, 253, 1, 333, 4, 0, 0, 45, 100, 0, 1), 
(20175, 20175, "Walking Fungus", 0, "", 0, "LineageMonster.walking_fungus", 15, 22.5, 8, "male", "L2Monster", 40, 124.92828, 92.64, 2, 0.9, 40, 43, 30, 21, 20, 20, 237, 8, 16.20165, 57.56203, 11.06363, 38.32545, 253, 4, 333, 0, 0, 0, 70, 110, 0, 1), 
(20176, 20176, "Wyrm", 0, "", 0, "LineageMonster.wyrm", 29, 72, 35, "male", "L2Monster", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2181, 130, 129.32896, 136.72948, 88.31491, 91.03603, 253, 4, 333, 0, 0, 0, 70, 174, 1, 1), 
(20177, 20177, "Zombie", 0, "", 0, "LineageMonster.zombie", 13, 21, 6, "male", "L2Monster", 40, 93.54158, 77.2, 2, 0.9, 40, 43, 30, 21, 20, 20, 178, 5, 13.52471, 53.53373, 9.23562, 35.64336, 253, 4, 333, 0, 0, 0, 15, 15, 0, 1), 
(20189, 20189, "Puma", 0, "", 0, "LineageMonster.onyx_beast", 14, 14.5, 15, "male", "L2Monster", 40, 246.95422, 149.2, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 441, 18, 29.61691, 73.55216, 20.22451, 48.97186, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(20190, 20190, "Skeleton Marauder", 0, "", 0, "LineageMonster.skeleton_archer", 11, 27, 29, "male", "L2Monster", 1100, 573.42917, 315.12, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1568, 84, 86.42002, 115.00598, 59.01367, 76.57227, 253, 8, 333, 14, 0, 0, 40, 140, 1, 1), 
(20191, 20191, "Skeleton Raider", 0, "", 0, "LineageMonster.skeleton", 11, 25, 30, "male", "L2Monster", 40, 604.08419, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1602, 88, 92.64226, 118.46427, 63.26266, 78.87485, 253, 8, 333, 946, 945, 0, 60, 140, 1, 1), 
(20192, 20192, "Tyrant", 0, "", 0, "LineageMonster.grave", 15, 29, 35, "male", "L2Monster", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2138, 126, 129.32896, 136.72948, 88.31491, 91.03603, 253, 4, 333, 0, 0, 0, 70, 174, 1, 1), 
(20193, 20193, "Tyrant Kingpin", 0, "", 0, "LineageMonster.grave", 15, 29, 36, "male", "L2Monster", 40, 809.52639, 417.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2307, 139, 137.86467, 140.57278, 94.1437, 93.59494, 253, 4, 333, 0, 0, 0, 70, 174, 1, 1), 
(20194, 20194, "Queen Undine", 0, "", 0, "LineageMonster.undine", 12, 27, 50, "female", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3709, 280, 305.54906, 200.23844, 208.6504, 133.32101, 253, 4, 333, 0, 0, 0, 60, 60, 0, 1), 
(20197, 20197, "Sorrow Maiden", 0, "", 0, "LineageMonster.sylph", 11, 35, 27, "female", "L2Monster", 40, 515.17856, 286.92, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1323, 67, 74.99121, 108.28767, 51.20928, 72.09915, 253, 4, 333, 0, 0, 0, 60, 60, 1, 1), 
(20198, 20198, "Neer Ghoul Berserker", 0, "", 0, "LineageMonster.neer_crawler", 14, 22, 29, "male", "L2Monster", 40, 573.42917, 315.12, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1522, 82, 86.42002, 115.00598, 59.01367, 76.57227, 253, 4, 333, 0, 0, 0, 50, 90, 1, 1), 
(20199, 20199, "Amber Basilisk", 0, "", 0, "LineageMonster.lesser_basilisk", 34, 25, 30, "male", "L2Monster", 40, 604.08419, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1869, 102, 92.64226, 118.46427, 63.26266, 78.87485, 253, 4, 333, 0, 0, 0, 35, 131, 1, 1), 
(20200, 20200, "Strain", 0, "", 0, "LineageMonster.hungry_spirit", 30, 40, 31, "male", "L2Monster", 40, 635.76437, 343.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1661, 92, 99.21986, 121.98819, 67.7543, 81.22111, 253, 4, 333, 0, 0, 0, 15, 120, 1, 1), 
(20201, 20201, "Ghoul", 0, "", 0, "LineageMonster.zombie", 13, 21, 32, "male", "L2Monster", 40, 668.47132, 358.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2502, 140, 106.16525, 125.57727, 72.49711, 83.61076, 253, 4, 333, 0, 0, 0, 15, 15, 1, 1), 
(20202, 20202, "Dead Seeker", 0, "", 0, "LineageMonster.vampire_bat", 10, 33.5, 34, "male", "L2Monster", 40, 736.96177, 387.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1998, 116, 121.20802, 132.9486, 82.76936, 88.51867, 253, 4, 333, 0, 0, 0, 60, 80, 1, 1), 
(20203, 20203, "Dion Grizzly", 0, "", 0, "LineageMonster.grizzly", 21, 40, 20, "male", "L2Monster", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 706, 31, 44.32863, 86.87049, 30.2707, 57.83936, 253, 4, 333, 0, 0, 0, 40, 110, 1, 1), 
(20204, 20204, "Bloody Bee", 0, "", 0, "LineageMonster.giant_bee", 8, 24.5, 23, "male", "L2Monster", 40, 410.70422, 231.96, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1148, 55, 55.84125, 95.64976, 38.13234, 63.68469, 253, 4, 333, 0, 0, 0, 90, 90, 1, 1), 
(20205, 20205, "Dire Wolf", 0, "", 0, "LineageMonster.dire_wolf", 13, 11, 24, "male", "L2Monster", 40, 435.34437, 245.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1145, 56, 60.19687, 98.70919, 41.10666, 65.72169, 253, 4, 333, 0, 0, 0, 24, 110, 1, 1), 
(20206, 20206, "Kadif Werewolf", 0, "", 0, "LineageMonster.werewolf", 10, 26, 25, "male", "L2Monster", 40, 460.96247, 259.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1179, 59, 64.83203, 101.83533, 44.27187, 67.80312, 253, 4, 333, 0, 0, 0, 50, 120, 1, 1), 
(20207, 20207, "Ol Mahum Guerilla", 0, "", 0, "LineageMonster.ol_mahum", 13.5, 25, 26, "male", "L2Monster", 40, 487.5704, 273, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 2359, 119, 69.75926, 105.02818, 47.63653, 69.92894, 253, 4, 333, 2, 19, 0, 50, 110, 1, 1), 
(20208, 20208, "Ol Mahum Raider", 0, "", 0, "LineageMonster.ol_mahum", 13.5, 25, 27, "male", "L2Monster", 40, 515.17856, 286.92, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 2485, 127, 74.99121, 108.28767, 51.20928, 72.09915, 253, 8, 333, 10, 0, 0, 50, 110, 1, 1), 
(20209, 20209, "Ol Mahum Marksman", 0, "", 0, "LineageMonster.ol_mahum_archer", 14, 25, 28, "male", "L2Monster", 1100, 543.79576, 300.96, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 2709, 142, 80.54056, 111.61368, 54.99876, 74.31365, 253, 8, 333, 275, 0, 0, 50, 110, 1, 1), 
(20210, 20210, "Ol Mahum Sergeant", 0, "", 0, "LineageMonster.ol_mahum", 13.5, 25, 29, "male", "L2Monster", 40, 573.42917, 315.12, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 2776, 149, 86.42002, 115.00598, 59.01367, 76.57227, 253, 4, 333, 68, 19, 0, 50, 110, 1, 1), 
(20211, 20211, "Ol Mahum Captain", 0, "", 0, "LineageMonster.ol_mahum_champion", 14, 27, 30, "male", "L2Monster", 40, 604.08419, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 2980, 163, 92.64226, 118.46427, 63.26266, 78.87485, 253, 4, 333, 123, 19, 0, 50, 110, 1, 1), 
(20212, 20212, "Bloody Axe Turmak", 0, "Ol Mahum Lord", 0, "LineageMonster.ol_mahum_champion", 14, 27, 34, "male", "L2Monster", 40, 736.96177, 387.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 3528, 206, 121.20802, 132.9486, 82.76936, 88.51867, 253, 4, 333, 69, 19, 0, 50, 110, 0, 1), 
(20213, 20213, "Porta", 0, "", 0, "LineageMonster.stone_golem", 20, 31, 40, "male", "L2Monster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 10438, 647, 176.36077, 156.55035, 120.43155, 114.55675, 253, 1, 333, 0, 0, 0, 23, 23, 0, 1), 
(20214, 20214, "Excuro", 0, "", 0, "LineageMonster.mana_vampire", 11, 20, 41, "male", "L2Monster", 40, 1008.23781, 504.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 6668, 417, 187.11878, 160.69002, 127.77787, 117.58598, 253, 4, 333, 0, 0, 0, 90, 90, 0, 1), 
(20215, 20215, "Mordeo", 0, "", 0, "LineageMonster.onyx_beast", 14, 14.5, 42, "male", "L2Monster", 40, 1050.81652, 531, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 7709, 493, 198.34591, 164.88513, 135.44454, 120.65578, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(20216, 20216, "Ricenseo", 0, "", 0, "LineageMonster.monster_eye", 21, 43, 43, "male", "L2Monster", 40, 1094.28943, 557.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 6864, 442, 210.04832, 169.13417, 143.43577, 123.76505, 253, 1, 333, 0, 0, 0, 90, 90, 0, 1), 
(20217, 20217, "Krator", 0, "", 0, "LineageMonster.stone_golem", 20, 31, 44, "male", "L2Monster", 40, 1138.62924, 584, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 7997, 523, 222.23112, 173.43552, 151.75505, 126.91259, 253, 1, 333, 0, 0, 0, 23, 23, 0, 1), 
(20218, 20218, "Premo", 0, "", 0, "LineageMonster.troll", 21, 35, 45, "male", "L2Monster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 8303, 552, 234.89829, 177.78746, 160.40508, 130.09715, 253, 1, 333, 0, 0, 0, 55, 110, 0, 1), 
(20219, 20219, "Validus", 0, "", 0, "LineageMonster.grave", 15, 29, 46, "male", "L2Monster", 40, 1229.78678, 637.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 9348, 635, 248.0526, 182.18816, 169.38777, 133.31739, 253, 4, 333, 0, 0, 0, 70, 110, 0, 1), 
(20220, 20220, "Dicor", 0, "", 0, "LineageMonster.mandragora_b", 12, 25.5, 47, "female", "L2Monster", 40, 1276.53628, 665, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 9429, 646, 261.69549, 186.63569, 178.7041, 136.5719, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(20221, 20221, "Perum", 0, "", 0, "LineageMonster.iron_golem", 18, 34, 48, "male", "L2Monster", 40, 1324.01623, 692.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 13708, 955, 275.82705, 191.12803, 188.35412, 139.8592, 253, 1, 333, 0, 0, 0, 20, 20, 0, 1), 
(20222, 20222, "Torfe", 0, "", 0, "LineageMonster.grave", 15, 29, 49, "male", "L2Monster", 40, 1372.18568, 720, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 10330, 730, 290.44588, 195.66302, 198.33688, 143.17771, 253, 4, 333, 0, 0, 0, 70, 110, 0, 1), 
(20223, 20223, "Mandragora Sprout", 0, "", 0, "LineageMonster.manadragora", 14, 17.8, 20, "female", "L2Monster", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 784, 35, 44.32863, 86.87049, 30.2707, 57.83936, 253, 4, 333, 0, 0, 0, 80, 80, 1, 1), 
(20224, 20224, "Ol Mahum Ranger", 0, "", 0, "LineageMonster.ol_mahum_archer", 14, 25, 22, "male", "L2Monster", 1100, 387.02878, 218.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1271, 60, 51.75278, 92.65694, 35.34044, 61.69203, 253, 8, 333, 13, 0, 0, 50, 110, 1, 1), 
(20225, 20225, "Giant Mist Leech", 0, "", 0, "LineageMonster.giant_leech", 70, 29, 25, "male", "L2Monster", 40, 460.96247, 259.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1191, 60, 64.83203, 101.83533, 44.27187, 67.80312, 253, 4, 333, 0, 0, 0, 50, 110, 1, 1), 
(20226, 20226, "Gray Ant", 0, "", 0, "LineageMonster.ant", 26, 15, 26, "male", "L2Monster", 40, 487.5704, 273, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1268, 64, 69.75926, 105.02818, 47.63653, 69.92894, 253, 4, 333, 0, 0, 0, 40, 130, 1, 1), 
(20227, 20227, "Horror Mist Ripper", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 27, "male", "L2Monster", 40, 515.17856, 286.92, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1349, 70, 74.99121, 108.28767, 51.20928, 72.09915, 253, 4, 333, 0, 0, 0, 100, 100, 1, 1), 
(20228, 20228, "Giant Crimson Ant", 0, "", 0, "LineageMonster.ant_soldier", 35, 17, 28, "male", "L2Monster", 40, 543.79576, 300.96, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1555, 82, 80.54056, 111.61368, 54.99876, 74.31365, 253, 4, 333, 0, 0, 0, 80, 130, 1, 1), 
(20229, 20229, "Stinger Wasp", 0, "", 0, "LineageMonster.giant_bee", 8, 24.5, 30, "male", "L2Monster", 40, 604.08419, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1745, 95, 92.64226, 118.46427, 63.26266, 78.87485, 253, 4, 333, 0, 0, 0, 90, 90, 1, 1), 
(20230, 20230, "Marsh Stakato Worker", 0, "", 0, "LineageMonster.marsh_stakato_worker", 9, 21, 31, "male", "L2Monster", 40, 635.76437, 343.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1996, 110, 99.21986, 121.98819, 67.7543, 81.22111, 253, 1, 333, 153, 0, 0, 20, 140, 1, 1), 
(20231, 20231, "Toad Lord", 0, "", 0, "LineageMonster.poison_toad", 20, 10, 32, "male", "L2Monster", 40, 668.47132, 358.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1946, 109, 106.16525, 125.57727, 72.49711, 83.61076, 253, 4, 333, 0, 0, 0, 50, 100, 1, 1), 
(20232, 20232, "Marsh Stakato Soldier", 0, "", 0, "LineageMonster.marsh_stakato_soldier", 10, 25, 33, "male", "L2Monster", 40, 702.20463, 372.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1901, 109, 113.49065, 129.23095, 77.49941, 86.04342, 253, 8, 333, 217, 0, 0, 30, 155, 1, 1), 
(20233, 20233, "Marsh Spider", 0, "", 0, "LineageMonster.poison_spider", 27, 25.5, 34, "male", "L2Monster", 40, 736.96177, 387.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2241, 131, 121.20802, 132.9486, 82.76936, 88.51867, 253, 4, 333, 0, 0, 0, 60, 140, 1, 1), 
(20234, 20234, "Marsh Stakato Drone", 0, "", 0, "LineageMonster.marsh_stakato_drone", 9, 24, 35, "male", "L2Monster", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2268, 134, 129.32896, 136.72948, 88.31491, 91.03603, 253, 8, 333, 219, 0, 0, 80, 174, 1, 1), 
(20235, 20235, "Shackle", 0, "", 0, "LineageMonster.hungry_spirit", 30, 40, 45, "male", "L2Monster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3569, 248, 234.89829, 177.78746, 160.40508, 118.3729, 253, 4, 333, 0, 0, 0, 15, 174, 0, 1), 
(20236, 20236, "Cave Servant", 0, "", 0, "LineageMonster.skeleton", 11, 25, 46, "male", "L2Monster", 40, 1229.78678, 637.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3693, 262, 248.0526, 182.18816, 169.38777, 121.30293, 253, 4, 333, 79, 945, 0, 60, 174, 0, 1), 
(20237, 20237, "Cave Servant Archer", 0, "", 0, "LineageMonster.skeleton_archer", 11, 27, 47, "male", "L2Monster", 1100, 1276.53628, 665, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4972, 356, 261.69549, 186.63569, 178.7041, 124.26415, 253, 8, 333, 14, 0, 0, 40, 174, 0, 1), 
(20238, 20238, "Cave Servant Warrior", 0, "", 0, "LineageMonster.skeleton", 11, 25, 48, "male", "L2Monster", 40, 1324.01623, 692.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4785, 349, 275.82705, 191.12803, 188.35412, 127.2552, 253, 4, 333, 77, 2495, 0, 60, 174, 0, 1), 
(20239, 20239, "Cave Servant Captain", 0, "", 0, "LineageMonster.spartoi", 11, 27, 49, "male", "L2Monster", 40, 1372.18568, 720, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 5086, 376, 290.44588, 195.66302, 198.33688, 130.27465, 253, 4, 333, 73, 2495, 0, 60, 174, 0, 1), 
(20240, 20240, "Royal Cave Servant", 0, "", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 51, "male", "L2Monster", 40, 1470.41596, 775.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 5455, 416, 321.13207, 204.85194, 219.29157, 136.39273, 253, 8, 333, 946, 945, 0, 80, 174, 0, 1), 
(20241, 20241, "Hunter Gargoyle", 0, "", 0, "LineageMonster.hunter_gargoyle", 25, 65, 52, "male", "L2Monster", 40, 1520.38155, 804, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 5420, 419, 337.18867, 209.50106, 230.25615, 153.30378, 253, 4, 333, 0, 0, 0, 100, 100, 1, 1), 
(20242, 20242, "Dustwind Gargoyle", 0, "", 0, "LineageMonster.hunter_gargoyle", 25, 65, 53, "male", "L2Monster", 40, 1570.8463, 832.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 5776, 454, 353.71092, 214.18326, 241.5387, 142.60563, 253, 4, 333, 0, 0, 0, 100, 174, 0, 1), 
(20243, 20243, "Thunder Wyrm", 0, "", 0, "LineageMonster.wyrm", 29, 72, 54, "male", "L2Monster", 40, 1621.75618, 861, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 5140, 409, 370.68904, 218.89589, 253.13256, 145.74335, 253, 4, 333, 0, 0, 0, 70, 174, 0, 1), 
(20244, 20244, "Malruk Succubus", 0, "", 0, "LineageMonster.succubus", 10, 36, 55, "female", "L2Monster", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 5279, 426, 388.11142, 223.6362, 265.02979, 148.89951, 253, 4, 333, 0, 0, 0, 60, 174, 0, 1), 
(20245, 20245, "Malruk Succubus Turen", 0, "", 0, "LineageMonster.succubus", 10, 36, 56, "female", "L2Monster", 40, 1724.6831, 918.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 5473, 450, 405.96455, 228.40135, 277.22116, 152.0722, 253, 4, 333, 0, 0, 0, 60, 174, 0, 1), 
(20246, 20246, "Cave Keeper", 0, "", 0, "LineageMonster.serpent_slave", 17, 46, 58, "male", "L2Monster", 40, 1828.68266, 977.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 6987, 590, 442.8992, 237.99429, 302.44274, 158.45929, 253, 8, 333, 223, 0, 0, 70, 174, 0, 1), 
(20248, 20248, "Turak Bugbear", 0, "", 0, "LineageMonster.bugbear", 17, 35, 31, "male", "L2Monster", 40, 635.76437, 343.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1677, 94, 99.21986, 121.98819, 67.7543, 81.22111, 253, 1, 333, 88, 0, 0, 55, 130, 1, 1), 
(20249, 20249, "Turak Bugbear Warrior", 0, "", 0, "LineageMonster.bugbear", 17, 35, 33, "male", "L2Monster", 40, 702.20463, 372.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 3606, 206, 113.49065, 129.23095, 77.49941, 86.04342, 253, 4, 333, 73, 0, 0, 55, 130, 1, 1), 
(20250, 20250, "Glass Jaguar", 0, "", 0, "LineageMonster.onyx_beast", 14, 14.5, 27, "male", "L2Monster", 40, 515.17856, 286.92, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1323, 67, 74.99121, 108.28767, 51.20928, 72.09915, 253, 4, 333, 0, 0, 0, 30, 120, 1, 1), 
(20251, 20251, "Delu Lizardman", 0, "", 0, "LineageMonster.virud_lizardman", 10, 23, 28, "male", "L2Monster", 40, 543.79576, 300.96, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1400, 73, 80.54056, 111.61368, 54.99876, 74.31365, 253, 4, 333, 1, 19, 0, 43, 130, 1, 1), 
(20252, 20252, "Delu Lizardman Scout", 0, "", 0, "LineageMonster.virud_lizardman", 10, 23, 29, "male", "L2Monster", 40, 573.42917, 315.12, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1477, 79, 86.42002, 115.00598, 59.01367, 76.57227, 253, 4, 333, 123, 0, 0, 43, 130, 1, 1), 
(20253, 20253, "Delu Lizardman Warrior", 0, "", 0, "LineageMonster.virud_lizardman_warrior", 12, 30, 30, "male", "L2Monster", 40, 604.08419, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1586, 86, 92.64226, 118.46427, 63.26266, 78.87485, 253, 4, 333, 16, 0, 0, 52, 130, 1, 1), 
(20254, 20254, "Skeleton Axeman", 0, "", 0, "LineageMonster.skeleton", 11, 25, 28, "male", "L2Monster", 40, 543.79576, 300.96, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1442, 76, 80.54056, 111.61368, 54.99876, 74.31365, 253, 1, 333, 86, 0, 0, 60, 140, 1, 1), 
(20255, 20255, "Batur Orc", 0, "", 0, "LineageMonster.batur_orc", 9, 21.5, 31, "male", "L2Monster", 40, 635.76437, 343.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1398, 78, 99.21986, 121.98819, 67.7543, 81.22111, 253, 4, 333, 123, 0, 0, 80, 130, 0, 1), 
(20256, 20256, "Batur Orc Archer", 0, "", 0, "LineageMonster.batur_orc_archer", 11, 21.5, 32, "male", "L2Monster", 1100, 668.47132, 358.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1921, 108, 106.16525, 125.57727, 72.49711, 83.61076, 253, 8, 333, 13, 0, 0, 45, 130, 0, 1), 
(20257, 20257, "Batur Orc Warrior", 0, "", 0, "LineageMonster.batur_orc_warrior", 10, 20, 33, "male", "L2Monster", 40, 702.20463, 372.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1922, 110, 113.49065, 129.23095, 77.49941, 86.04342, 253, 4, 333, 123, 19, 0, 80, 120, 0, 1), 
(20258, 20258, "Batur Orc Shaman", 0, "", 0, "LineageMonster.batur_orc_shaman", 11, 16, 34, "male", "L2Monster", 40, 736.96177, 387.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1681, 98, 121.20802, 132.9486, 82.76936, 88.51867, 253, 1, 333, 7, 0, 0, 50, 120, 0, 1), 
(20259, 20259, "Batur Orc Overlord", 0, "", 0, "LineageMonster.batur_orc_overlord", 12, 24, 35, "male", "L2Monster", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2163, 128, 129.32896, 136.72948, 88.31491, 91.03603, 253, 4, 333, 79, 0, 0, 80, 140, 0, 1), 
(20260, 20260, "Orc Champion", 0, "", 0, "LineageMonster.orc_champion", 10, 23, 14, "male", "L2Monster", 40, 230.38548, 140.88, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 435, 17, 27.24646, 71.08179, 18.6058, 47.32706, 253, 4, 333, 2, 0, 0, 45, 130, 0, 1), 
(20261, 20261, "Orc Shaman", 0, "", 0, "LineageMonster.orc_shaman", 9, 22, 17, "male", "L2Monster", 40, 282.57403, 166.08, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 505, 21, 34.8979, 78.68469, 23.83074, 52.38915, 253, 1, 333, 7, 0, 0, 45, 120, 0, 1), 
(20265, 20265, "Monster Eye Searcher", 0, "", 0, "LineageMonster.monster_eye", 21, 43, 22, "male", "L2Monster", 40, 387.02878, 218.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1833, 86, 51.75278, 92.65694, 35.34044, 61.69203, 253, 1, 333, 0, 0, 0, 90, 159, 1, 1), 
(20266, 20266, "Monster Eye Gazer", 0, "", 0, "LineageMonster.monster_eye", 21, 43, 25, "male", "L2Monster", 40, 460.96247, 259.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1191, 60, 64.83203, 101.83533, 44.27187, 67.80312, 253, 4, 333, 0, 0, 0, 90, 159, 1, 1), 
(20267, 20267, "Breka Orc", 0, "", 0, "LineageMonster.batur_orc", 9, 21.5, 31, "male", "L2Monster", 40, 635.76437, 343.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1677, 94, 99.21986, 121.98819, 67.7543, 81.22111, 253, 8, 333, 215, 0, 0, 80, 130, 1, 1), 
(20268, 20268, "Breka Orc Archer", 0, "", 0, "LineageMonster.batur_orc_archer", 11, 21.5, 32, "male", "L2Monster", 1100, 668.47132, 358.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2305, 130, 106.16525, 125.57727, 72.49711, 83.61076, 253, 8, 333, 275, 0, 0, 45, 130, 1, 1), 
(20269, 20269, "Breka Orc Shaman", 0, "", 0, "LineageMonster.batur_orc_shaman", 11, 16, 34, "male", "L2Monster", 40, 736.96177, 387.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2018, 118, 121.20802, 132.9486, 82.76936, 88.51867, 253, 1, 333, 7, 0, 0, 50, 120, 1, 1), 
(20270, 20270, "Breka Orc Overlord", 0, "", 0, "LineageMonster.batur_orc_overlord", 12, 24, 35, "male", "L2Monster", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2857, 169, 129.32896, 136.72948, 88.31491, 91.03603, 253, 4, 333, 79, 0, 0, 80, 174, 1, 1), 
(20271, 20271, "Breka Orc Warrior", 0, "", 0, "LineageMonster.batur_orc_warrior", 10, 20, 33, "male", "L2Monster", 40, 702.20463, 372.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2307, 132, 113.49065, 129.23095, 77.49941, 86.04342, 253, 4, 333, 123, 20, 0, 80, 120, 1, 1), 
(20272, 20272, "Cave Servant", 0, "", 0, "LineageMonster.skeleton", 11, 25, 46, "male", "L2Monster", 40, 1229.78678, 637.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3078, 218, 248.0526, 182.18816, 169.38777, 121.30293, 253, 4, 333, 79, 945, 0, 60, 140, 0, 1), 
(20273, 20273, "Cave Servant Archer", 0, "", 0, "LineageMonster.skeleton_archer", 11, 27, 47, "male", "L2Monster", 1100, 1276.53628, 665, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3309, 238, 261.69549, 186.63569, 178.7041, 124.26415, 253, 8, 333, 275, 0, 0, 40, 140, 0, 1), 
(20274, 20274, "Cave Servant Warrior", 0, "", 0, "LineageMonster.skeleton", 11, 25, 48, "male", "L2Monster", 40, 1324.01623, 692.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3351, 245, 275.82705, 191.12803, 188.35412, 127.2552, 253, 4, 333, 77, 0, 0, 60, 140, 0, 1), 
(20275, 20275, "Cave Servant Captain", 0, "", 0, "LineageMonster.spartoi", 11, 27, 49, "male", "L2Monster", 40, 1372.18568, 720, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3562, 263, 290.44588, 195.66302, 198.33688, 130.27465, 253, 4, 333, 73, 0, 0, 60, 140, 0, 1), 
(20276, 20276, "Royal Cave Servant", 0, "", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 51, "male", "L2Monster", 40, 1470.41596, 775.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 3783, 288, 321.13207, 204.85194, 219.29157, 136.39273, 253, 8, 333, 946, 945, 0, 80, 120, 0, 1), 
(20277, 20277, "Cave Keeper", 0, "", 0, "LineageMonster.serpent_slave", 17, 46, 58, "male", "L2Monster", 40, 1828.68266, 977.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 4893, 413, 442.8992, 237.99429, 302.44274, 158.45929, 253, 8, 333, 223, 0, 0, 70, 110, 0, 1), 
(20279, 20279, "Shackle", 0, "", 0, "LineageMonster.hungry_spirit", 30, 40, 45, "male", "L2Monster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 2974, 206, 234.89829, 177.78746, 160.40508, 118.3729, 253, 4, 333, 0, 0, 0, 15, 120, 0, 1), 
(20280, 20280, "Headless Knight", 0, "", 0, "LineageMonster.headless_knight", 21, 31, 50, "male", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3709, 280, 305.54906, 200.23844, 208.6504, 133.32101, 253, 4, 333, 124, 0, 0, 70, 110, 0, 1), 
(20281, 20281, "Dustwind Gargoyle", 0, "", 0, "LineageMonster.hunter_gargoyle", 25, 65, 53, "male", "L2Monster", 40, 1570.8463, 832.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 4045, 318, 353.71092, 214.18326, 241.5387, 142.60563, 253, 4, 333, 0, 0, 0, 100, 100, 0, 1), 
(20282, 20282, "Thunder Wyrm", 0, "", 0, "LineageMonster.wyrm", 29, 72, 54, "male", "L2Monster", 40, 1621.75618, 861, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 4283, 342, 370.68904, 218.89589, 253.13256, 145.74335, 253, 4, 333, 0, 0, 0, 70, 70, 0, 1), 
(20283, 20283, "Malruk Succubus", 0, "", 0, "LineageMonster.succubus", 10, 36, 55, "female", "L2Monster", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 4400, 355, 388.11142, 223.6362, 265.02979, 148.89951, 253, 4, 333, 0, 0, 0, 60, 100, 0, 1), 
(20284, 20284, "Malruk Succubus Turen", 0, "", 0, "LineageMonster.succubus", 10, 36, 56, "female", "L2Monster", 40, 1724.6831, 918.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 4561, 374, 405.96455, 228.40135, 277.22116, 152.0722, 253, 4, 333, 0, 0, 0, 60, 100, 0, 1), 
(20285, 20285, "Drake", 0, "", 0, "LineageMonster.drake", 30, 100, 57, "male", "L2Monster", 40, 1776.58018, 948, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 4820, 401, 424.23295, 233.18839, 289.69611, 155.25946, 253, 4, 333, 0, 0, 0, 70, 70, 0, 1), 
(20286, 20286, "Hunter Gargoyle", 0, "", 0, "LineageMonster.hunter_gargoyle", 25, 65, 52, "male", "L2Monster", 40, 1520.38155, 804, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 3894, 301, 337.18867, 209.50106, 230.25615, 139.48817, 253, 4, 333, 0, 0, 0, 100, 100, 0, 1), 
(20287, 20287, "Cave Maiden", 0, "", 0, "LineageMonster.cave_maiden", 25, 65, 59, "female", "L2Monster", 40, 1880.92519, 1007, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 5113, 437, 461.94387, 242.81593, 315.44778, 161.66959, 253, 4, 333, 68, 0, 0, 70, 120, 0, 1), 
(20291, 20291, "Enku Orc Champion", 0, "", 0, "LineageMonster.orc_champion", 10, 23, 21, "male", "L2Monster", 40, 364.30351, 205.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1113, 52, 47.91924, 89.73059, 32.72263, 59.74364, 253, 4, 333, 2, 0, 0, 45, 130, 1, 1), 
(20292, 20292, "Enku Orc Shaman", 0, "", 0, "LineageMonster.orc_shaman", 9, 22, 20, "male", "L2Monster", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 813, 36, 44.32863, 86.87049, 30.2707, 57.83936, 253, 1, 333, 7, 0, 0, 45, 120, 1, 1), 
(20293, 20293, "Virud Lizardman", 0, "", 0, "LineageMonster.virud_lizardman", 10, 23, 20, "male", "L2Monster", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 594, 26, 44.32863, 86.87049, 30.2707, 57.83936, 253, 4, 333, 291, 0, 0, 43, 130, 0, 1), 
(20294, 20294, "Virud Lizardman Matriarch", 0, "", 0, "LineageMonster.virud_lizardman_matriarch", 13, 37, 24, "male", "L2Monster", 40, 435.34437, 245.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1142, 56, 60.19687, 98.70919, 41.10666, 65.72169, 253, 4, 333, 2, 19, 0, 56, 130, 0, 1), 
(20295, 20295, "Virud Lizardman Warrior", 0, "", 0, "LineageMonster.virud_lizardman_warrior", 12, 30, 22, "male", "L2Monster", 40, 387.02878, 218.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 838, 40, 51.75278, 92.65694, 35.34044, 61.69203, 253, 4, 333, 16, 0, 0, 52, 130, 0, 1), 
(20296, 20296, "Virud Lizardman Scout", 0, "", 0, "LineageMonster.virud_lizardman_scout", 10, 22, 21, "male", "L2Monster", 1100, 364.30351, 205.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 787, 36, 47.91924, 89.73059, 32.72263, 59.74364, 253, 8, 333, 2507, 0, 0, 43, 130, 0, 1), 
(20297, 20297, "Virud Lizardman Shaman", 0, "", 0, "LineageMonster.virud_lizardman_shaman", 10, 29, 23, "male", "L2Monster", 40, 410.70422, 231.96, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 878, 42, 55.84125, 95.64976, 38.13234, 63.68469, 253, 1, 333, 7, 0, 0, 43, 120, 0, 1), 
(20298, 20298, "Virud Lizardman Shaman", 0, "", 0, "LineageMonster.virud_lizardman_shaman", 10, 29, 23, "male", "L2Monster", 40, 410.70422, 231.96, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 878, 42, 55.84125, 95.64976, 38.13234, 63.68469, 253, 1, 333, 7, 0, 0, 43, 120, 0, 1), 
(20299, 20299, "Zenta Lizardman", 0, "", 0, "LineageMonster.zenta_lizardman", 11, 32, 40, "male", "L2Monster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2327, 150, 176.36077, 156.55035, 120.43155, 104.23299, 253, 4, 333, 68, 0, 0, 37, 140, 0, 1), 
(20300, 20300, "Zenta Lizardman Matriarch", 0, "", 0, "LineageMonster.zenta_lizardman_matriarch", 20, 40, 44, "male", "L2Monster", 40, 1138.62924, 584, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3418, 234, 222.23112, 173.43552, 151.75505, 115.47533, 253, 8, 333, 221, 0, 0, 53, 140, 0, 1), 
(20301, 20301, "Zenta Lizardman Scout", 0, "", 0, "LineageMonster.zenta_lizardman_scout", 11, 30, 41, "male", "L2Monster", 1100, 1008.23781, 504.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 2518, 164, 187.11878, 160.69002, 127.77787, 106.98923, 253, 8, 333, 14, 0, 0, 37, 150, 0, 1), 
(20302, 20302, "Zenta Lizardman Warrior", 0, "", 0, "LineageMonster.zenta_lizardman_warrior", 13, 35, 42, "male", "L2Monster", 40, 1050.81652, 531, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 2617, 174, 198.34591, 164.88513, 135.44454, 109.78238, 253, 4, 333, 16, 0, 0, 40, 140, 0, 1), 
(20303, 20303, "Zenta Lizardman Shaman", 0, "", 0, "LineageMonster.zenta_lizardman_shaman", 13, 35, 43, "male", "L2Monster", 40, 1094.28943, 557.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 2689, 182, 210.04832, 169.13417, 143.43577, 112.61144, 253, 1, 333, 7, 0, 0, 43, 130, 0, 1), 
(20304, 20304, "Marsh Stakato Queen", 0, "", 0, "LineageMonster.marsh_stakato_queen", 15, 37, 36, "female", "L2Monster", 40, 809.52639, 417.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2288, 138, 137.86467, 140.57278, 94.1437, 93.59494, 253, 4, 333, 74, 0, 0, 130, 130, 0, 1), 
(20305, 20305, "Grave", 0, "", 0, "LineageMonster.grave", 15, 29, 40, "male", "L2Monster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2350, 151, 176.36077, 156.55035, 120.43155, 104.23299, 253, 4, 333, 0, 0, 0, 70, 110, 0, 1), 
(20307, 20307, "Garum Werewolf", 0, "", 0, "LineageMonster.werewolf", 10, 26, 9, "male", "L2Monster", 40, 143.17564, 100.48, 2, 0.9, 40, 43, 30, 21, 20, 20, 321, 11, 17.70841, 59.66387, 12.09255, 39.72488, 253, 1, 333, 5, 0, 0, 50, 120, 1, 1), 
(20308, 20308, "Hook Spider", 0, "", 0, "LineageMonster.giant_spider", 26, 25.5, 16, "male", "L2Monster", 40, 264.34345, 157.6, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 571, 23, 32.16396, 76.08628, 21.96382, 50.6591, 253, 4, 333, 0, 0, 0, 72, 130, 1, 1), 
(20309, 20309, "Brown Fox", 0, "", 0, "LineageMonster.fox", 9.5, 10, 2, "male", "L2Monster", 40, 48.09168, 47.28, 2, 0.9, 40, 43, 30, 21, 20, 20, 59, 2, 9.32203, 46.15385, 6.36574, 30.72975, 253, 4, 333, 0, 0, 0, 23, 110, 0, 1), 
(20310, 20310, "Brown Bear", 0, "", 0, "LineageMonster.grizzly_bi", 21, 50, 16, "male", "L2Monster", 40, 264.34345, 157.6, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 577, 23, 32.16396, 76.08628, 21.96382, 50.6591, 253, 4, 333, 0, 0, 0, 40, 110, 1, 1), 
(20311, 20311, "Rakeclaw Imp", 0, "", 0, "LineageMonster.imp", 10, 24, 6, "male", "L2Monster", 40, 93.54158, 77.2, 2, 0.9, 40, 43, 30, 21, 20, 20, 214, 6, 13.52471, 53.53373, 9.23562, 35.64336, 253, 4, 333, 0, 0, 0, 60, 80, 1, 1), 
(20312, 20312, "Rakeclaw Imp Hunter", 0, "", 0, "LineageMonster.imp", 10, 24, 7, "male", "L2Monster", 40, 108.42254, 84.88, 2, 0.9, 40, 43, 30, 21, 20, 20, 249, 8, 14.80956, 55.51894, 10.11301, 36.96514, 253, 4, 333, 0, 0, 0, 60, 80, 1, 1), 
(20313, 20313, "Rakeclaw Imp Chieftain", 0, "", 0, "LineageMonster.imp_bi", 10, 30, 10, "male", "L2Monster", 40, 163.28607, 108.4, 2, 0.9, 40, 43, 30, 21, 20, 20, 363, 12, 19.33758, 61.82527, 13.20506, 41.16396, 253, 4, 333, 0, 0, 0, 60, 80, 1, 1), 
(20314, 20314, "Great White Shark", 0, "", 0, "LineageMonster.great_white_shark", 20, 7, 42, "male", "L2Monster", 40, 1050.81652, 531, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 2617, 174, 198.34591, 164.88513, 135.44454, 109.78238, 253, 4, 333, 0, 0, 0, 80, 174, 0, 1), 
(20316, 20316, "Darkwing Bat", 0, "", 0, "LineageMonster.vampire_bat", 10, 33.5, 11, "male", "L2Monster", 40, 185.38552, 116.4, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 392, 15, 21.0973, 64.04702, 14.40672, 42.64323, 253, 4, 333, 0, 0, 0, 60, 80, 1, 1), 
(20317, 20317, "Black Wolf", 0, "", 0, "LineageMonster.wolf", 13, 9, 4, "male", "L2Monster", 40, 68.20985, 62.08, 2, 0.9, 40, 43, 30, 21, 20, 20, 141, 4, 11.24892, 49.73343, 7.68155, 33.11308, 253, 4, 333, 0, 0, 0, 24, 110, 1, 1), 
(20318, 20318, "Black Timber Wolf", 0, "", 0, "LineageMonster.wolf_bi", 13, 10.8, 6, "male", "L2Monster", 40, 93.54158, 77.2, 2, 0.9, 40, 43, 30, 21, 20, 20, 212, 6, 13.52471, 53.53373, 9.23562, 35.64336, 253, 4, 333, 0, 0, 0, 24, 110, 1, 1), 
(20319, 20319, "Goblin Grave Robber", 0, "", 0, "LineageMonster.goblin", 10, 16.5, 5, "male", "L2Monster", 40, 80.17319, 69.6, 2, 0.9, 40, 43, 30, 21, 20, 20, 178, 5, 12.34006, 51.60553, 8.42666, 34.35955, 253, 1, 333, 4, 0, 0, 40, 110, 1, 1), 
(20320, 20320, "Goblin Tomb Raider Leader", 0, "", 0, "LineageMonster.goblin_bi", 10, 21.4, 12, "male", "L2Monster", 40, 199.62322, 124.48, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 428, 16, 22.99606, 66.32989, 15.70333, 44.16318, 253, 8, 333, 12, 0, 0, 40, 110, 1, 1), 
(20321, 20321, "Goblin Thief", 0, "", 0, "LineageMonster.goblin_bi", 10, 21.4, 10, "male", "L2Monster", 40, 163.28607, 108.4, 2, 0.9, 40, 43, 30, 21, 20, 20, 356, 12, 19.33758, 61.82527, 13.20506, 41.16396, 253, 8, 333, 217, 0, 0, 40, 110, 1, 1), 
(20322, 20322, "Goblin Brigand", 0, "", 0, "LineageMonster.goblin", 10, 16.5, 8, "male", "L2Monster", 40, 124.92828, 92.64, 2, 0.9, 40, 43, 30, 21, 20, 20, 285, 10, 16.20165, 57.56203, 11.06363, 38.32545, 253, 1, 333, 4, 0, 0, 40, 110, 1, 1), 
(20323, 20323, "Goblin Brigand Leader", 0, "", 0, "LineageMonster.goblin_bi", 10, 21.4, 14, "male", "L2Monster", 40, 230.38548, 140.88, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 509, 20, 27.24646, 71.08179, 18.6058, 47.32706, 253, 8, 333, 217, 0, 0, 40, 110, 1, 1), 
(20324, 20324, "Goblin Brigand Lieutenant", 0, "", 0, "LineageMonster.goblin", 10, 16.5, 10, "male", "L2Monster", 40, 163.28607, 108.4, 2, 0.9, 40, 43, 30, 21, 20, 20, 363, 12, 19.33758, 61.82527, 13.20506, 41.16396, 253, 8, 333, 10, 0, 0, 40, 110, 1, 1), 
(20325, 20325, "Goblin Raider", 0, "", 0, "LineageMonster.goblin", 10, 16.5, 5, "male", "L2Monster", 40, 80.17319, 69.6, 2, 0.9, 40, 43, 30, 21, 20, 20, 178, 5, 12.34006, 51.60553, 8.42666, 34.35955, 253, 1, 333, 4, 0, 0, 40, 110, 1, 1), 
(20326, 20326, "Goblin Scout", 0, "", 0, "LineageMonster.goblin", 10, 16.5, 8, "male", "L2Monster", 40, 124.92828, 92.64, 2, 0.9, 40, 43, 30, 21, 20, 20, 285, 10, 16.20165, 57.56203, 11.06363, 38.32545, 253, 1, 333, 4, 0, 0, 40, 110, 1, 1), 
(20327, 20327, "Goblin Snooper", 0, "", 0, "LineageMonster.goblin", 10, 16.5, 5, "male", "L2Monster", 40, 80.17319, 69.6, 2, 0.9, 40, 43, 30, 21, 20, 20, 178, 5, 12.34006, 51.60553, 8.42666, 34.35955, 253, 1, 333, 4, 0, 0, 40, 110, 1, 1), 
(20328, 20328, "Goblin Lookout", 0, "", 0, "LineageMonster.goblin", 10, 16.5, 8, "male", "L2Monster", 40, 124.92828, 92.64, 2, 0.9, 40, 43, 30, 21, 20, 20, 285, 10, 16.20165, 57.56203, 11.06363, 38.32545, 253, 8, 333, 12, 0, 0, 40, 110, 1, 1), 
(20329, 20329, "Ghost Guardian", 0, "", 0, "LineageMonster.human_ghost", 8, 22, 21, "male", "L2Monster", 40, 364.30351, 205.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 772, 36, 47.91924, 89.73059, 32.72263, 59.74364, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(20330, 20330, "Mineshaft Bat", 0, "", 0, "LineageMonster.vampire_bat", 10, 33.5, 11, "male", "L2Monster", 40, 185.38552, 116.4, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 326, 12, 21.0973, 64.04702, 14.40672, 42.64323, 253, 4, 333, 0, 0, 0, 60, 80, 0, 1), 
(20331, 20331, "Monster Eye Tracker", 0, "", 0, "LineageMonster.monster_eye", 21, 43, 10, "male", "L2Monster", 40, 163.28607, 108.4, 2, 0.9, 40, 43, 30, 21, 20, 20, 297, 10, 19.33758, 61.82527, 13.20506, 41.16396, 253, 4, 333, 0, 0, 0, 90, 134, 0, 1), 
(20333, 20333, "Greystone Golem", 0, "", 0, "LineageMonster.stone_golem", 20, 31, 13, "male", "L2Monster", 40, 214.61578, 132.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 655, 26, 25.04271, 68.67458, 17.10092, 45.72431, 253, 4, 333, 0, 0, 0, 23, 23, 1, 1), 
(20334, 20334, "Gremlin Scavenger", 0, "", 0, "LineageMonster.gremlin", 10, 15, 1, "male", "L2Monster", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 29, 2, 8.47458, 44.44444, 5.78704, 29.59162, 253, 4, 333, 0, 0, 0, 20, 50, 0, 1), 
(20335, 20335, "Grizzly Bear", 0, "", 0, "LineageMonster.grizzly_bi", 21, 50, 17, "male", "L2Monster", 40, 282.57403, 166.08, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 600, 25, 34.8979, 78.68469, 23.83074, 52.38915, 253, 4, 333, 0, 0, 0, 40, 110, 1, 1), 
(20336, 20336, "Green Dryad", 0, "", 0, "LineageMonster.dryad_sm", 6, 15, 8, "female", "L2Monster", 40, 124.92828, 92.64, 2, 0.9, 40, 43, 30, 21, 20, 20, 285, 10, 16.20165, 57.56203, 11.06363, 38.32545, 253, 4, 333, 0, 0, 0, 40, 110, 1, 1), 
(20337, 20337, "Longtail Fox", 0, "", 0, "LineageMonster.fox", 9.5, 10, 2, "male", "L2Monster", 40, 48.09168, 47.28, 2, 0.9, 40, 43, 30, 21, 20, 20, 59, 2, 9.32203, 46.15385, 6.36574, 30.72975, 253, 4, 333, 0, 0, 0, 23, 110, 0, 1), 
(20338, 20338, "Nightmare Weaver", 0, "", 0, "LineageMonster.magical_weaver", 11, 20, 21, "male", "L2Monster", 40, 364.30351, 205.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 849, 40, 47.91924, 89.73059, 32.72263, 59.74364, 253, 4, 333, 0, 0, 0, 90, 90, 0, 1), 
(20340, 20340, "Slave Skeleton", 0, "", 0, "LineageMonster.skeleton", 11, 25, 12, "male", "L2Monster", 40, 199.62322, 124.48, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 363, 13, 22.99606, 66.32989, 15.70333, 44.16318, 253, 8, 333, 946, 0, 0, 60, 140, 0, 1), 
(20341, 20341, "Undead Slave", 0, "", 0, "LineageMonster.zombie", 13, 21, 19, "male", "L2Monster", 40, 321.63954, 183.28, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 799, 36, 40.96915, 84.07638, 27.97662, 55.97901, 253, 4, 333, 0, 0, 0, 15, 15, 0, 1), 
(20342, 20342, "Werewolf Chieftain", 0, "", 0, "LineageMonster.werewolf_bi", 11, 29.7, 12, "male", "L2Monster", 40, 199.62322, 124.48, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 436, 16, 22.99606, 66.32989, 15.70333, 44.16318, 253, 1, 333, 5, 0, 0, 50, 120, 1, 1), 
(20343, 20343, "Werewolf Hunter", 0, "", 0, "LineageMonster.werewolf", 10, 26, 10, "male", "L2Monster", 40, 163.28607, 108.4, 2, 0.9, 40, 43, 30, 21, 20, 20, 363, 12, 19.33758, 61.82527, 13.20506, 41.16396, 253, 1, 333, 5, 0, 0, 50, 120, 1, 1), 
(20345, 20345, "Dark Terror", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 16, "male", "L2Monster", 40, 264.34345, 157.6, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 534, 22, 32.16396, 76.08628, 21.96382, 50.6591, 253, 4, 333, 0, 0, 0, 100, 100, 0, 1), 
(20346, 20346, "Darkstone Golem", 0, "", 0, "LineageMonster.stone_golem", 20, 31, 13, "male", "L2Monster", 40, 214.61578, 132.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 545, 21, 25.04271, 68.67458, 17.10092, 45.72431, 253, 4, 333, 0, 0, 0, 23, 23, 0, 1), 
(20347, 20347, "Doom Wraith", 0, "", 0, "LineageMonster.death_blader", 15, 45, 55, "male", "L2Monster", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 4488, 362, 388.11142, 223.6362, 265.02979, 148.89951, 253, 4, 333, 1472, 0, 0, 100, 174, 0, 1), 
(20348, 20348, "Cave Spider", 0, "", 0, "LineageMonster.giant_spider", 26, 25.5, 15, "male", "L2Monster", 40, 246.95422, 149.2, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 445, 18, 29.61691, 73.55216, 20.22451, 48.97186, 253, 4, 333, 0, 0, 0, 72, 130, 0, 1), 
(20349, 20349, "Cave Bat", 0, "", 0, "LineageMonster.vampire_bat", 10, 33.5, 13, "male", "L2Monster", 40, 214.61578, 132.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 386, 15, 25.04271, 68.67458, 17.10092, 45.72431, 253, 4, 333, 0, 0, 0, 60, 80, 0, 1), 
(20350, 20350, "Cave Fang Spider", 0, "", 0, "LineageMonster.giant_spider", 26, 25.5, 16, "male", "L2Monster", 40, 264.34345, 157.6, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 485, 20, 32.16396, 76.08628, 21.96382, 50.6591, 253, 4, 333, 0, 0, 0, 72, 130, 0, 1), 
(20351, 20351, "Dre Vanul Tracker", 0, "", 0, "LineageMonster.dre_vanul", 14, 36, 20, "male", "L2Monster", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 606, 27, 44.32863, 86.87049, 30.2707, 57.83936, 253, 4, 333, 0, 0, 0, 80, 80, 0, 1), 
(20352, 20352, "Dre Vanul Slayer", 0, "", 0, "LineageMonster.dre_vanul", 14, 36, 22, "male", "L2Monster", 40, 387.02878, 218.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 921, 43, 51.75278, 92.65694, 35.34044, 61.69203, 253, 4, 333, 0, 0, 0, 80, 80, 0, 1), 
(20353, 20353, "Dre Vanul Beholder", 0, "", 0, "LineageMonster.dre_vanul", 14, 36, 21, "male", "L2Monster", 40, 364.30351, 205.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 780, 36, 47.91924, 89.73059, 32.72263, 59.74364, 253, 4, 333, 0, 0, 0, 80, 80, 0, 1), 
(20354, 20354, "Dwarf Ghost", 0, "", 0, "LineageMonster.dwarf_ghost", 9, 16.5, 20, "male", "L2Monster", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 606, 27, 44.32863, 86.87049, 30.2707, 57.83936, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(20356, 20356, "Langk Lizardman Leader", 0, "", 0, "LineageMonster.virud_lizardman_warrior_bi", 12, 34.5, 25, "male", "L2Monster", 40, 460.96247, 259.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1215, 61, 64.83203, 101.83533, 44.27187, 67.80312, 253, 4, 333, 16, 0, 0, 52, 130, 1, 1), 
(20357, 20357, "Langk Lizardman Lieutenant", 0, "", 0, "LineageMonster.virud_lizardman_warrior", 12, 30, 22, "male", "L2Monster", 40, 387.02878, 218.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 986, 47, 51.75278, 92.65694, 35.34044, 61.69203, 253, 4, 333, 16, 0, 0, 52, 130, 1, 1), 
(20358, 20358, "Ratman Hunter", 0, "", 0, "LineageMonster.wererat", 14, 25, 18, "male", "L2Monster", 40, 301.66622, 174.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 640, 28, 37.82932, 81.34791, 25.83252, 54.16236, 253, 8, 333, 11, 0, 0, 80, 120, 1, 1), 
(20359, 20359, "Ratman Warrior", 0, "", 0, "LineageMonster.wererat", 14, 25, 19, "male", "L2Monster", 40, 321.63954, 183.28, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 678, 30, 40.96915, 84.07638, 27.97662, 55.97901, 253, 4, 333, 2, 0, 0, 80, 120, 1, 1), 
(20360, 20360, "Ratman Spy", 0, "", 0, "LineageMonster.wererat_sm", 12, 18.7, 16, "male", "L2Monster", 40, 264.34345, 157.6, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 571, 23, 32.16396, 76.08628, 21.96382, 50.6591, 253, 8, 333, 12, 0, 0, 80, 120, 1, 1), 
(20361, 20361, "Tunath Orc Marksman", 0, "", 0, "LineageMonster.orc_archer", 14, 25, 10, "male", "L2Monster", 1100, 163.28607, 108.4, 2, 0.9, 40, 43, 30, 21, 20, 20, 306, 10, 19.33758, 61.82527, 13.20506, 41.16396, 253, 8, 333, 14, 0, 0, 45, 110, 0, 1), 
(20362, 20362, "Tunath Orc Warrior", 0, "", 0, "LineageMonster.orc_fighter", 12, 22, 12, "male", "L2Monster", 40, 199.62322, 124.48, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 363, 13, 22.99606, 66.32989, 15.70333, 44.16318, 253, 4, 333, 2, 0, 0, 45, 110, 0, 1), 
(20363, 20363, "Maraku Werewolf", 0, "", 0, "LineageMonster.werewolf", 10, 26, 9, "male", "L2Monster", 40, 143.17564, 100.48, 2, 0.9, 40, 43, 30, 21, 20, 20, 321, 11, 17.70841, 59.66387, 12.09255, 39.72488, 253, 4, 333, 0, 0, 0, 50, 120, 1, 1), 
(20364, 20364, "Maraku Werewolf Chieftain", 0, "", 0, "LineageMonster.werewolf_bi", 11, 29.7, 14, "male", "L2Monster", 40, 230.38548, 140.88, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 509, 20, 27.24646, 71.08179, 18.6058, 47.32706, 253, 8, 333, 217, 0, 0, 50, 120, 1, 1), 
(20365, 20365, "Mountain Fungus", 0, "", 0, "LineageMonster.walking_fungus", 15, 22.5, 8, "male", "L2Monster", 40, 124.92828, 92.64, 2, 0.9, 40, 43, 30, 21, 20, 20, 285, 10, 16.20165, 57.56203, 11.06363, 38.32545, 253, 4, 333, 0, 0, 0, 70, 110, 1, 1), 
(20367, 20367, "Merkenis Escort", 0, "", 0, "LineageMonster.spartoi", 11, 27, 20, "male", "L2Monster", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 606, 27, 44.32863, 86.87049, 30.2707, 57.83936, 253, 4, 333, 68, 0, 0, 60, 140, 0, 1), 
(20368, 20368, "Grave Keeper", 0, "", 0, "LineageMonster.stone_golem", 20, 31, 13, "male", "L2Monster", 40, 214.61578, 132.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 545, 21, 25.04271, 68.67458, 17.10092, 45.72431, 253, 4, 333, 0, 0, 0, 23, 23, 0, 1), 
(20369, 20369, "Moonstone Beast", 0, "", 0, "LineageMonster.onyx_beast", 14, 14.5, 17, "male", "L2Monster", 40, 282.57403, 166.08, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 600, 25, 34.8979, 78.68469, 23.83074, 52.38915, 253, 4, 333, 0, 0, 0, 30, 120, 1, 1), 
(20370, 20370, "Barbed Bat", 0, "", 0, "LineageMonster.vampire_bat", 10, 33.5, 12, "male", "L2Monster", 40, 199.62322, 124.48, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 428, 16, 22.99606, 66.32989, 15.70333, 44.16318, 253, 4, 333, 0, 0, 0, 60, 80, 1, 1), 
(20371, 20371, "Mist Terror", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 15, "male", "L2Monster", 40, 246.95422, 149.2, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 454, 19, 29.61691, 73.55216, 20.22451, 48.97186, 253, 4, 333, 0, 0, 0, 100, 100, 0, 1), 
(20372, 20372, "Baraq Orc Fighter", 0, "", 0, "LineageMonster.orc_fighter", 12, 22, 10, "male", "L2Monster", 40, 163.28607, 108.4, 2, 0.9, 40, 43, 30, 21, 20, 20, 303, 10, 19.33758, 61.82527, 13.20506, 41.16396, 253, 4, 333, 2, 0, 0, 45, 110, 0, 1), 
(20373, 20373, "Baraq Orc Warrior Leader", 0, "", 0, "LineageMonster.orc_fighter", 12, 22, 11, "male", "L2Monster", 40, 185.38552, 116.4, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 326, 12, 21.0973, 64.04702, 14.40672, 42.64323, 253, 4, 333, 2, 0, 0, 45, 110, 0, 1), 
(20374, 20374, "Baranka's Guard", 0, "", 0, "LineageMonster.spartoi", 11, 27, 22, "male", "L2Monster", 40, 387.02878, 218.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1093, 52, 51.75278, 92.65694, 35.34044, 61.69203, 253, 4, 333, 68, 0, 0, 60, 140, 0, 1), 
(20375, 20375, "Baranka's Escort", 0, "", 0, "LineageMonster.spartoi", 11, 27, 21, "male", "L2Monster", 40, 364.30351, 205.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 780, 36, 47.91924, 89.73059, 32.72263, 59.74364, 253, 8, 333, 946, 0, 0, 60, 140, 0, 1), 
(20376, 20376, "Varikan Brigand Leader", 0, "", 0, "LineageMonster.goblin_bi", 10, 21.4, 10, "male", "L2Monster", 40, 163.28607, 108.4, 2, 0.9, 40, 43, 30, 21, 20, 20, 1007, 34, 19.33758, 61.82527, 13.20506, 41.16396, 253, 1, 333, 12, 0, 0, 40, 110, 0, 1), 
(20377, 20377, "Varika's Bandit", 0, "", 0, "LineageMonster.goblin", 10, 16.5, 7, "male", "L2Monster", 40, 108.42254, 84.88, 2, 0.9, 40, 43, 30, 21, 20, 20, 167, 6, 14.80956, 55.51894, 10.11301, 36.96514, 253, 1, 333, 0, 0, 0, 40, 110, 0, 1), 
(20378, 20378, "Stone Giant", 0, "", 0, "LineageMonster.stone_golem", 20, 31, 13, "male", "L2Monster", 40, 214.61578, 132.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 545, 21, 25.04271, 68.67458, 17.10092, 45.72431, 253, 1, 333, 0, 0, 0, 23, 23, 0, 1), 
(20379, 20379, "Stone Soldier", 0, "", 0, "LineageMonster.stone_golem", 20, 31, 14, "male", "L2Monster", 40, 230.38548, 140.88, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 705, 27, 27.24646, 71.08179, 18.6058, 47.32706, 253, 4, 333, 0, 0, 0, 23, 23, 1, 1), 
(20380, 20380, "Stone Guardian", 0, "", 0, "LineageMonster.stone_golem", 20, 31, 16, "male", "L2Monster", 40, 264.34345, 157.6, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 807, 33, 32.16396, 76.08628, 21.96382, 50.6591, 253, 4, 333, 0, 0, 0, 23, 23, 1, 1), 
(20381, 20381, "Vaiss Orc", 0, "", 0, "LineageMonster.orc", 10, 21, 10, "male", "L2Monster", 40, 163.28607, 108.4, 2, 0.9, 40, 43, 30, 21, 20, 20, 297, 10, 19.33758, 61.82527, 13.20506, 41.16396, 253, 1, 333, 156, 0, 0, 45, 110, 0, 1), 
(20382, 20382, "Vaiss Orc Warrior Leader", 0, "", 0, "LineageMonster.orc_fighter", 12, 22, 11, "male", "L2Monster", 40, 185.38552, 116.4, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 326, 12, 21.0973, 64.04702, 14.40672, 42.64323, 253, 4, 333, 2, 0, 0, 45, 110, 0, 1), 
(20383, 20383, "Arachnid Hunter", 0, "", 0, "LineageMonster.binding", 12, 21, 30, "male", "L2Monster", 40, 604.08419, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1469, 80, 92.64226, 118.46427, 63.26266, 78.87485, 253, 4, 333, 0, 0, 0, 10, 140, 0, 1), 
(20385, 20385, "Balor Orc Archer", 0, "", 0, "LineageMonster.orc_archer", 14, 25, 8, "male", "L2Monster", 1100, 124.92828, 92.64, 2, 0.9, 40, 43, 30, 21, 20, 20, 293, 10, 16.20165, 57.56203, 11.06363, 38.32545, 253, 8, 333, 14, 0, 0, 45, 110, 1, 1), 
(20386, 20386, "Balor Orc Fighter", 0, "", 0, "LineageMonster.orc_fighter", 12, 22, 10, "male", "L2Monster", 40, 163.28607, 108.4, 2, 0.9, 40, 43, 30, 21, 20, 20, 363, 12, 19.33758, 61.82527, 13.20506, 41.16396, 253, 4, 333, 2, 0, 0, 45, 110, 1, 1), 
(20387, 20387, "Balor Orc Fighter Leader", 0, "", 0, "LineageMonster.orc_fighter", 12, 22, 12, "male", "L2Monster", 40, 199.62322, 124.48, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 436, 16, 22.99606, 66.32989, 15.70333, 44.16318, 253, 4, 333, 2, 0, 0, 45, 110, 1, 1), 
(20388, 20388, "Balor Orc Lieutenant", 0, "", 0, "LineageMonster.orc_fighter", 12, 22, 11, "male", "L2Monster", 40, 185.38552, 116.4, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 392, 15, 21.0973, 64.04702, 14.40672, 42.64323, 253, 4, 333, 2, 0, 0, 45, 110, 1, 1), 
(20389, 20389, "Boogle Ratman", 0, "", 0, "LineageMonster.wererat", 14, 25, 16, "male", "L2Monster", 40, 264.34345, 157.6, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 476, 19, 32.16396, 76.08628, 21.96382, 50.6591, 253, 8, 333, 12, 0, 0, 80, 120, 0, 1), 
(20390, 20390, "Boogle Ratman Leader", 0, "", 0, "LineageMonster.wererat", 14, 25, 18, "male", "L2Monster", 40, 301.66622, 174.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 533, 23, 37.82932, 81.34791, 25.83252, 54.16236, 253, 8, 333, 12, 0, 0, 80, 120, 0, 1), 
(20391, 20391, "Red Fox", 0, "", 0, "LineageMonster.fox", 9.5, 10, 2, "male", "L2Monster", 40, 48.09168, 47.28, 2, 0.9, 40, 43, 30, 21, 20, 20, 59, 2, 9.32203, 46.15385, 6.36574, 30.72975, 253, 4, 333, 0, 0, 0, 23, 110, 0, 1), 
(20392, 20392, "Redeye Bat", 0, "", 0, "LineageMonster.vampire_bat_bi", 10, 42, 15, "male", "L2Monster", 40, 246.95422, 149.2, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 534, 22, 29.61691, 73.55216, 20.22451, 48.97186, 253, 4, 333, 0, 0, 0, 60, 80, 1, 1), 
(20393, 20393, "Red Scavenger Spider", 0, "", 0, "LineageMonster.giant_spider", 26, 25.5, 16, "male", "L2Monster", 40, 264.34345, 157.6, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 571, 23, 32.16396, 76.08628, 21.96382, 50.6591, 253, 4, 333, 0, 0, 0, 72, 130, 1, 1), 
(20394, 20394, "Crimson Tarantula", 0, "", 0, "LineageMonster.giant_spider", 26, 25.5, 15, "male", "L2Monster", 40, 246.95422, 149.2, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 450, 18, 29.61691, 73.55216, 20.22451, 48.97186, 253, 4, 333, 0, 0, 0, 72, 130, 0, 1), 
(20398, 20398, "Vrykolakas", 0, "", 0, "LineageMonster.werewolf_bi", 11, 29.7, 15, "male", "L2Monster", 40, 246.95422, 149.2, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 1386, 57, 29.61691, 73.55216, 20.22451, 48.97186, 253, 1, 333, 0, 0, 0, 50, 120, 0, 1), 
(20399, 20399, "Vrykolakas Wolfkin", 0, "", 0, "LineageMonster.wolf_bi", 13, 10.8, 9, "male", "L2Monster", 40, 143.17564, 100.48, 2, 0.9, 40, 43, 30, 21, 20, 20, 177, 6, 17.70841, 59.66387, 12.09255, 39.72488, 253, 1, 333, 0, 0, 0, 24, 110, 0, 1), 
(20400, 20400, "Blood Fungus", 0, "", 0, "LineageMonster.walking_fungus", 15, 22.5, 12, "male", "L2Monster", 40, 199.62322, 124.48, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 428, 16, 22.99606, 66.32989, 15.70333, 44.16318, 253, 4, 333, 0, 0, 0, 70, 110, 1, 1), 
(20401, 20401, "Veelan Bugbear", 0, "", 0, "LineageMonster.bugbear", 17, 35, 23, "male", "L2Monster", 40, 410.70422, 231.96, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1054, 50, 55.84125, 95.64976, 38.13234, 63.68469, 253, 1, 333, 156, 0, 0, 55, 130, 1, 1), 
(20402, 20402, "Veelan Bugbear Warrior", 0, "", 0, "LineageMonster.bugbear", 17, 35, 24, "male", "L2Monster", 40, 435.34437, 245.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1145, 56, 60.19687, 98.70919, 41.10666, 65.72169, 253, 1, 333, 88, 0, 0, 55, 130, 1, 1), 
(20403, 20403, "Hunter Tarantula", 0, "", 0, "LineageMonster.giant_spider", 26, 25.5, 16, "male", "L2Monster", 40, 264.34345, 157.6, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 571, 23, 32.16396, 76.08628, 21.96382, 50.6591, 253, 4, 333, 0, 0, 0, 72, 130, 1, 1), 
(20404, 20404, "Silent Horror", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 16, "male", "L2Monster", 40, 264.34345, 157.6, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 485, 20, 32.16396, 76.08628, 21.96382, 50.6591, 253, 1, 333, 0, 0, 0, 100, 100, 0, 1), 
(20405, 20405, "Young Brown Fox", 0, "", 0, "LineageMonster.fox", 9.5, 10, 1, "male", "L2Monster", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 29, 2, 8.47458, 44.44444, 5.78704, 29.59162, 253, 4, 333, 0, 0, 0, 23, 110, 0, 1), 
(20406, 20406, "Young Red Fox", 0, "", 0, "LineageMonster.fox", 9.5, 10, 1, "male", "L2Monster", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 29, 2, 8.47458, 44.44444, 5.78704, 29.59162, 253, 4, 333, 0, 0, 0, 23, 110, 0, 1), 
(20407, 20407, "Young Crimson Fox", 0, "", 0, "LineageMonster.fox", 9.5, 10, 1, "male", "L2Monster", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 29, 2, 8.47458, 44.44444, 5.78704, 29.59162, 253, 4, 333, 0, 0, 0, 23, 110, 0, 1), 
(20410, 20410, "Scavenger Spider", 0, "", 0, "LineageMonster.giant_spider", 26, 25.5, 15, "male", "L2Monster", 40, 246.95422, 149.2, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 545, 22, 29.61691, 73.55216, 20.22451, 48.97186, 253, 4, 333, 0, 0, 0, 72, 130, 1, 1), 
(20411, 20411, "Scavenger Bat", 0, "", 0, "LineageMonster.vampire_bat", 10, 33.5, 18, "male", "L2Monster", 40, 301.66622, 174.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 640, 28, 37.82932, 81.34791, 25.83252, 54.16236, 253, 4, 333, 0, 0, 0, 60, 80, 1, 1), 
(20412, 20412, "Susceptor", 0, "", 0, "LineageMonster.susceptor", 20, 35, 49, "male", "L2Monster", 40, 1372.18568, 720, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3492, 258, 290.44588, 195.66302, 198.33688, 130.27465, 253, 4, 333, 0, 0, 0, 27, 174, 0, 1), 
(20415, 20415, "Scarlet Salamander", 0, "", 0, "LineageMonster.salamander", 16, 6.8, 17, "male", "L2Monster", 40, 282.57403, 166.08, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 555, 23, 34.8979, 78.68469, 23.83074, 52.38915, 253, 4, 333, 0, 0, 0, 64, 96, 0, 1), 
(20416, 20416, "Scarlet Salamander Elder", 0, "", 0, "LineageMonster.salamander", 16, 6.8, 18, "male", "L2Monster", 40, 301.66622, 174.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 587, 26, 37.82932, 81.34791, 25.83252, 54.16236, 253, 4, 333, 0, 0, 0, 64, 96, 0, 1), 
(20418, 20418, "Crystalline Beast", 0, "", 0, "LineageMonster.onyx_beast", 14, 14.5, 18, "male", "L2Monster", 40, 301.66622, 174.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 634, 28, 37.82932, 81.34791, 25.83252, 54.16236, 253, 4, 333, 0, 0, 0, 30, 120, 1, 1), 
(20419, 20419, "Akaste Succubus", 0, "", 0, "LineageMonster.succubus", 10, 36, 20, "female", "L2Monster", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 606, 27, 44.32863, 86.87049, 30.2707, 57.83936, 253, 4, 333, 0, 0, 0, 60, 100, 0, 1), 
(20420, 20420, "Akaste Succubus Turen", 0, "", 0, "LineageMonster.succubus", 10, 36, 21, "female", "L2Monster", 40, 364.30351, 205.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 780, 36, 47.91924, 89.73059, 32.72263, 59.74364, 253, 4, 333, 0, 0, 0, 60, 100, 0, 1), 
(20421, 20421, "Akaste Succubus Tilfo", 0, "", 0, "LineageMonster.succubus_bi", 10, 43.2, 22, "female", "L2Monster", 40, 387.02878, 218.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 838, 40, 51.75278, 92.65694, 35.34044, 61.69203, 253, 4, 333, 0, 0, 0, 60, 100, 0, 1), 
(20422, 20422, "Akaste Bone Warlord", 0, "", 0, "LineageMonster.skeleton", 11, 25, 17, "male", "L2Monster", 40, 282.57403, 166.08, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 613, 26, 34.8979, 78.68469, 23.83074, 52.38915, 253, 4, 333, 2, 18, 0, 60, 140, 0, 1), 
(20423, 20423, "Akaste Bone Archer", 0, "", 0, "LineageMonster.skeleton_archer", 11, 27, 14, "male", "L2Monster", 1100, 230.38548, 140.88, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 428, 17, 27.24646, 71.08179, 18.6058, 47.32706, 253, 8, 333, 275, 0, 0, 40, 140, 0, 1), 
(20424, 20424, "Akaste Bone Lord", 0, "", 0, "LineageMonster.skeleton", 11, 25, 19, "male", "L2Monster", 40, 321.63954, 183.28, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 592, 26, 40.96915, 84.07638, 27.97662, 55.97901, 253, 4, 333, 68, 19, 0, 60, 140, 0, 1), 
(20425, 20425, "Akaste Bone Soldier", 0, "", 0, "LineageMonster.skeleton", 11, 25, 12, "male", "L2Monster", 40, 199.62322, 124.48, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 363, 13, 22.99606, 66.32989, 15.70333, 44.16318, 253, 8, 333, 946, 0, 0, 60, 140, 0, 1), 
(20426, 20426, "Evil Eye", 0, "", 0, "LineageMonster.monster_eye", 21, 43, 10, "male", "L2Monster", 40, 163.28607, 108.4, 2, 0.9, 40, 43, 30, 21, 20, 20, 356, 12, 19.33758, 61.82527, 13.20506, 41.16396, 253, 4, 333, 0, 0, 0, 90, 134, 1, 1), 
(20427, 20427, "Evil Eye Watcher", 0, "", 0, "LineageMonster.monster_eye", 21, 43, 10, "male", "L2Monster", 40, 163.28607, 108.4, 2, 0.9, 40, 43, 30, 21, 20, 20, 297, 10, 19.33758, 61.82527, 13.20506, 41.16396, 253, 4, 333, 0, 0, 0, 90, 134, 0, 1), 
(20428, 20428, "Evil Eye Patroller", 0, "", 0, "LineageMonster.monster_eye", 21, 43, 14, "male", "L2Monster", 40, 230.38548, 140.88, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 499, 19, 27.24646, 71.08179, 18.6058, 47.32706, 253, 4, 333, 0, 0, 0, 90, 134, 1, 1), 
(20429, 20429, "Evil Eye Lookout", 0, "", 0, "LineageMonster.monster_eye", 21, 43, 14, "male", "L2Monster", 40, 230.38548, 140.88, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 416, 16, 27.24646, 71.08179, 18.6058, 47.32706, 253, 4, 333, 0, 0, 0, 90, 134, 0, 1), 
(20431, 20431, "Elf Ghost", 0, "", 0, "LineageMonster.elf_ghost", 7, 21, 20, "male", "L2Monster", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 606, 27, 44.32863, 86.87049, 30.2707, 57.83936, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(20432, 20432, "Elpy", 0, "", 0, "LineageMonster.elpy", 5, 4.5, 1, "male", "L2Monster", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 35, 2, 8.47458, 44.44444, 5.78704, 29.59162, 253, 4, 333, 0, 0, 0, 50, 80, 1, 1), 
(20433, 20433, "Festering Bat", 0, "", 0, "LineageMonster.vampire_bat", 10, 33.5, 13, "male", "L2Monster", 40, 214.61578, 132.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 463, 18, 25.04271, 68.67458, 17.10092, 45.72431, 253, 4, 333, 0, 0, 0, 60, 80, 1, 1), 
(20435, 20435, "Opal Beast", 0, "", 0, "LineageMonster.onyx_beast", 14, 14.5, 15, "male", "L2Monster", 40, 246.95422, 149.2, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 450, 18, 29.61691, 73.55216, 20.22451, 48.97186, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(20436, 20436, "Ol Mahum Supplier", 0, "", 0, "LineageMonster.ol_mahum_bi", 14, 29.2, 23, "male", "L2Monster", 40, 410.70422, 231.96, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1054, 50, 55.84125, 95.64976, 38.13234, 63.68469, 253, 4, 333, 2, 19, 0, 50, 110, 1, 1), 
(20437, 20437, "Ol Mahum Recruit", 0, "", 0, "LineageMonster.ol_mahum", 13.5, 25, 21, "male", "L2Monster", 40, 364.30351, 205.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 917, 42, 47.91924, 89.73059, 32.72263, 59.74364, 253, 4, 333, 68, 19, 0, 50, 110, 1, 1), 
(20438, 20438, "Ol Mahum General", 0, "", 0, "LineageMonster.ol_mahum_champion", 14, 27, 26, "male", "L2Monster", 40, 487.5704, 273, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1294, 65, 69.75926, 105.02818, 47.63653, 69.92894, 253, 4, 333, 67, 102, 0, 50, 110, 1, 1), 
(20439, 20439, "Ol Mahum Officer", 0, "", 0, "LineageMonster.ol_mahum", 13.5, 25, 24, "male", "L2Monster", 40, 435.34437, 245.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1123, 55, 60.19687, 98.70919, 41.10666, 65.72169, 253, 4, 333, 66, 0, 0, 50, 110, 1, 1), 
(20440, 20440, "Elder Brown Fox", 0, "", 0, "LineageMonster.fox", 9.5, 10, 3, "male", "L2Monster", 40, 57.54874, 54.64, 2, 0.9, 40, 43, 30, 21, 20, 20, 88, 2, 10.24492, 47.91652, 6.99595, 31.90336, 253, 4, 333, 0, 0, 0, 23, 110, 0, 1), 
(20441, 20441, "Elder Longtail Fox", 0, "", 0, "LineageMonster.fox", 9.5, 10, 3, "male", "L2Monster", 40, 57.54874, 54.64, 2, 0.9, 40, 43, 30, 21, 20, 20, 88, 2, 10.24492, 47.91652, 6.99595, 31.90336, 253, 4, 333, 0, 0, 0, 23, 110, 0, 1), 
(20442, 20442, "Elder Wolf", 0, "", 0, "LineageMonster.wolf", 13, 9, 5, "male", "L2Monster", 40, 80.17319, 69.6, 2, 0.9, 40, 43, 30, 21, 20, 20, 176, 5, 12.34006, 51.60553, 8.42666, 34.35955, 253, 4, 333, 0, 0, 0, 24, 110, 1, 1), 
(20443, 20443, "Elder Red Fox", 0, "", 0, "LineageMonster.fox", 9.5, 10, 3, "male", "L2Monster", 40, 57.54874, 54.64, 2, 0.9, 40, 43, 30, 21, 20, 20, 88, 2, 10.24492, 47.91652, 6.99595, 31.90336, 253, 4, 333, 0, 0, 0, 23, 110, 0, 1), 
(20444, 20444, "Elder Prairie Fox", 0, "", 0, "LineageMonster.fox", 9.5, 10, 3, "male", "L2Monster", 40, 57.54874, 54.64, 2, 0.9, 40, 43, 30, 21, 20, 20, 88, 2, 10.24492, 47.91652, 6.99595, 31.90336, 253, 4, 333, 0, 0, 0, 23, 110, 0, 1), 
(20445, 20445, "Uthanka Pirate", 0, "", 0, "LineageMonster.orc", 10, 21, 7, "male", "L2Monster", 40, 108.42254, 84.88, 2, 0.9, 40, 43, 30, 21, 20, 20, 154, 5, 14.80956, 55.51894, 10.11301, 36.96514, 253, 4, 333, 3, 0, 0, 45, 110, 0, 1), 
(20446, 20446, "Utuku Orc", 0, "", 0, "LineageMonster.orc", 10, 21, 6, "male", "L2Monster", 40, 93.54158, 77.2, 2, 0.9, 40, 43, 30, 21, 20, 20, 214, 6, 13.52471, 53.53373, 9.23562, 35.64336, 253, 1, 333, 156, 0, 0, 45, 110, 1, 1), 
(20447, 20447, "Utuku Orc Archer", 0, "", 0, "LineageMonster.orc_archer", 14, 25, 8, "male", "L2Monster", 1100, 124.92828, 92.64, 2, 0.9, 40, 43, 30, 21, 20, 20, 293, 10, 16.20165, 57.56203, 11.06363, 38.32545, 253, 8, 333, 14, 0, 0, 45, 110, 1, 1), 
(20448, 20448, "Utuku Orc Grunt", 0, "", 0, "LineageMonster.orc", 10, 21, 7, "male", "L2Monster", 40, 108.42254, 84.88, 2, 0.9, 40, 43, 30, 21, 20, 20, 249, 8, 14.80956, 55.51894, 10.11301, 36.96514, 253, 4, 333, 3, 0, 0, 45, 110, 1, 1), 
(20449, 20449, "Will-O-Wisp", 0, "", 0, "LineageMonster.will_o_wisp", 13, 22, 15, "male", "L2Monster", 40, 246.95422, 149.2, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 533, 22, 29.61691, 73.55216, 20.22451, 48.97186, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(20450, 20450, "Relic Werewolf", 0, "", 0, "LineageMonster.werewolf", 10, 26, 9, "male", "L2Monster", 40, 143.17564, 100.48, 2, 0.9, 40, 43, 30, 21, 20, 20, 268, 9, 17.70841, 59.66387, 12.09255, 39.72488, 253, 1, 333, 0, 0, 0, 50, 120, 0, 1), 
(20451, 20451, "Relic Spartoi", 0, "", 0, "LineageMonster.spartoi", 11, 27, 21, "male", "L2Monster", 40, 364.30351, 205.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1422, 65, 47.91924, 89.73059, 32.72263, 59.74364, 253, 4, 333, 68, 0, 0, 60, 140, 0, 1), 
(20453, 20453, "Human Ghost", 0, "", 0, "LineageMonster.human_ghost", 8, 22, 20, "male", "L2Monster", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 606, 27, 44.32863, 86.87049, 30.2707, 57.83936, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(20454, 20454, "Oblivion Watcher", 0, "", 0, "LineageMonster.monster_eye", 21, 43, 17, "male", "L2Monster", 40, 282.57403, 166.08, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 227, 10, 34.8979, 78.68469, 23.83074, 52.38915, 253, 1, 333, 0, 0, 0, 90, 90, 0, 1), 
(20455, 20455, "Doom Soldier", 0, "", 0, "LineageMonster.skeleton", 11, 25, 14, "male", "L2Monster", 40, 230.38548, 140.88, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 424, 16, 27.24646, 71.08179, 18.6058, 47.32706, 253, 8, 333, 946, 0, 0, 60, 140, 0, 1), 
(20456, 20456, "Ashen Wolf", 0, "", 0, "LineageMonster.wolf", 13, 9, 4, "male", "L2Monster", 40, 68.20985, 62.08, 2, 0.9, 40, 43, 30, 21, 20, 20, 141, 4, 11.24892, 49.73343, 7.68155, 33.11308, 253, 4, 333, 0, 0, 0, 24, 110, 1, 1), 
(20457, 20457, "Zombie Soldier", 0, "", 0, "LineageMonster.zombie", 13, 21, 19, "male", "L2Monster", 40, 321.63954, 183.28, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 959, 43, 40.96915, 84.07638, 27.97662, 55.97901, 253, 4, 333, 0, 0, 0, 15, 15, 1, 1), 
(20458, 20458, "Zombie Warrior", 0, "", 0, "LineageMonster.zombie_bi", 12, 27.5, 22, "male", "L2Monster", 40, 387.02878, 218.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1421, 67, 51.75278, 92.65694, 35.34044, 61.69203, 253, 4, 333, 0, 0, 0, 15, 15, 1, 1), 
(20460, 20460, "Crimson Spider", 0, "", 0, "LineageMonster.giant_spider", 26, 25.5, 15, "male", "L2Monster", 40, 246.95422, 149.2, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 545, 22, 29.61691, 73.55216, 20.22451, 48.97186, 253, 4, 333, 0, 0, 0, 72, 130, 1, 1), 
(20461, 20461, "Dungeon Spider", 0, "", 0, "LineageMonster.giant_spider", 26, 25.5, 15, "male", "L2Monster", 40, 246.95422, 149.2, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 454, 19, 29.61691, 73.55216, 20.22451, 48.97186, 253, 1, 333, 0, 0, 0, 72, 130, 0, 1), 
(20462, 20462, "Cave Blade Spider", 0, "", 0, "LineageMonster.giant_spider", 26, 25.5, 17, "male", "L2Monster", 40, 282.57403, 166.08, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 515, 22, 34.8979, 78.68469, 23.83074, 52.38915, 253, 1, 333, 0, 0, 0, 72, 130, 0, 1), 
(20463, 20463, "Dungeon Skeleton Archer", 0, "", 0, "LineageMonster.skeleton_archer", 11, 27, 13, "male", "L2Monster", 1100, 214.61578, 132.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 397, 16, 25.04271, 68.67458, 17.10092, 45.72431, 253, 8, 333, 275, 0, 0, 40, 140, 0, 1), 
(20464, 20464, "Dungeon Skeleton", 0, "", 0, "LineageMonster.skeleton", 11, 25, 12, "male", "L2Monster", 40, 199.62322, 124.48, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 363, 13, 22.99606, 66.32989, 15.70333, 44.16318, 253, 8, 333, 946, 0, 0, 60, 140, 0, 1), 
(20465, 20465, "Prairie Fox", 0, "", 0, "LineageMonster.fox", 9.5, 10, 2, "male", "L2Monster", 40, 48.09168, 47.28, 2, 0.9, 40, 43, 30, 21, 20, 20, 59, 2, 9.32203, 46.15385, 6.36574, 30.72975, 253, 4, 333, 0, 0, 0, 23, 110, 0, 1), 
(20466, 20466, "Pincer Spider", 0, "", 0, "LineageMonster.giant_spider", 26, 25.5, 17, "male", "L2Monster", 40, 282.57403, 166.08, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 618, 26, 34.8979, 78.68469, 23.83074, 52.38915, 253, 4, 333, 0, 0, 0, 72, 130, 1, 1), 
(20468, 20468, "Kaboo Orc", 0, "", 0, "LineageMonster.orc", 10, 21, 6, "male", "L2Monster", 40, 93.54158, 77.2, 2, 0.9, 40, 43, 30, 21, 20, 20, 214, 6, 13.52471, 53.53373, 9.23562, 35.64336, 253, 1, 333, 156, 0, 0, 45, 110, 1, 1), 
(20469, 20469, "Kaboo Orc Archer", 0, "", 0, "LineageMonster.orc_archer", 14, 25, 8, "male", "L2Monster", 1100, 124.92828, 92.64, 2, 0.9, 40, 43, 30, 21, 20, 20, 293, 10, 16.20165, 57.56203, 11.06363, 38.32545, 253, 8, 333, 14, 0, 0, 45, 110, 1, 1), 
(20470, 20470, "Kaboo Orc Grunt", 0, "", 0, "LineageMonster.orc", 10, 21, 7, "male", "L2Monster", 40, 108.42254, 84.88, 2, 0.9, 40, 43, 30, 21, 20, 20, 249, 8, 14.80956, 55.51894, 10.11301, 36.96514, 253, 4, 333, 3, 0, 0, 45, 110, 1, 1), 
(20471, 20471, "Kaboo Orc Fighter", 0, "", 0, "LineageMonster.orc_fighter", 12, 22, 10, "male", "L2Monster", 40, 163.28607, 108.4, 2, 0.9, 40, 43, 30, 21, 20, 20, 363, 12, 19.33758, 61.82527, 13.20506, 41.16396, 253, 4, 333, 2, 0, 0, 45, 110, 1, 1), 
(20472, 20472, "Kaboo Orc Fighter Leader", 0, "", 0, "LineageMonster.orc_fighter", 12, 22, 12, "male", "L2Monster", 40, 199.62322, 124.48, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 436, 16, 22.99606, 66.32989, 15.70333, 44.16318, 253, 4, 333, 2, 0, 0, 45, 110, 1, 1), 
(20473, 20473, "Kaboo Orc Fighter Lieutenant", 0, "", 0, "LineageMonster.orc_fighter", 12, 22, 11, "male", "L2Monster", 40, 185.38552, 116.4, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 392, 15, 21.0973, 64.04702, 14.40672, 42.64323, 253, 4, 333, 2, 0, 0, 45, 110, 1, 1), 
(20474, 20474, "Kasha Spider", 0, "", 0, "LineageMonster.giant_spider", 26, 25.5, 15, "male", "L2Monster", 40, 246.95422, 149.2, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 534, 22, 29.61691, 73.55216, 20.22451, 48.97186, 253, 4, 333, 0, 0, 0, 72, 130, 1, 1), 
(20475, 20475, "Kasha Wolf", 0, "", 0, "LineageMonster.wolf", 13, 9, 4, "male", "L2Monster", 40, 68.20985, 62.08, 2, 0.9, 40, 43, 30, 21, 20, 20, 141, 4, 11.24892, 49.73343, 7.68155, 33.11308, 253, 4, 333, 0, 0, 0, 24, 110, 1, 1), 
(20476, 20476, "Kasha Fang Spider", 0, "", 0, "LineageMonster.giant_spider", 26, 25.5, 16, "male", "L2Monster", 40, 264.34345, 157.6, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 571, 23, 32.16396, 76.08628, 21.96382, 50.6591, 253, 4, 333, 0, 0, 0, 72, 130, 1, 1), 
(20477, 20477, "Kasha Timber Wolf", 0, "", 0, "LineageMonster.wolf_bi", 13, 10.8, 6, "male", "L2Monster", 40, 93.54158, 77.2, 2, 0.9, 40, 43, 30, 21, 20, 20, 212, 6, 13.52471, 53.53373, 9.23562, 35.64336, 253, 4, 333, 0, 0, 0, 24, 110, 1, 1), 
(20478, 20478, "Kasha Blade Spider", 0, "", 0, "LineageMonster.giant_spider", 26, 25.5, 17, "male", "L2Monster", 40, 282.57403, 166.08, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 667, 28, 34.8979, 78.68469, 23.83074, 52.38915, 253, 4, 333, 0, 0, 0, 72, 130, 1, 1), 
(20479, 20479, "Kasha Bear", 0, "", 0, "LineageMonster.grizzly_bi", 21, 50, 15, "male", "L2Monster", 40, 246.95422, 149.2, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 540, 22, 29.61691, 73.55216, 20.22451, 48.97186, 253, 4, 333, 0, 0, 0, 40, 110, 1, 1), 
(20480, 20480, "Blade Bat", 0, "", 0, "LineageMonster.vampire_bat", 10, 33.5, 10, "male", "L2Monster", 40, 163.28607, 108.4, 2, 0.9, 40, 43, 30, 21, 20, 20, 356, 12, 19.33758, 61.82527, 13.20506, 41.16396, 253, 4, 333, 0, 0, 0, 60, 80, 1, 1), 
(20481, 20481, "Bearded Keltir", 0, "", 0, "LineageMonster.keltir", 9.5, 10, 1, "male", "L2Monster", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 35, 2, 8.47458, 44.44444, 5.78704, 29.59162, 253, 4, 333, 0, 0, 0, 23, 110, 1, 1), 
(20483, 20483, "Corpse Candle", 0, "", 0, "LineageMonster.will_o_wisp", 13, 22, 17, "male", "L2Monster", 40, 282.57403, 166.08, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 604, 25, 34.8979, 78.68469, 23.83074, 52.38915, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(20487, 20487, "Kuruka Ratman", 0, "", 0, "LineageMonster.wererat", 14, 25, 16, "male", "L2Monster", 40, 264.34345, 157.6, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 476, 19, 32.16396, 76.08628, 21.96382, 50.6591, 253, 8, 333, 216, 0, 0, 80, 120, 0, 1), 
(20488, 20488, "Kuruka Ratman Hunter", 0, "", 0, "LineageMonster.wererat", 14, 25, 17, "male", "L2Monster", 40, 282.57403, 166.08, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 505, 21, 34.8979, 78.68469, 23.83074, 52.38915, 253, 4, 333, 3, 0, 0, 80, 120, 0, 1), 
(20489, 20489, "Quicksilver Beast", 0, "", 0, "LineageMonster.onyx_beast", 14, 14.5, 15, "male", "L2Monster", 40, 246.95422, 149.2, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 450, 18, 29.61691, 73.55216, 20.22451, 48.97186, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(20490, 20490, "Death Doll", 0, "", 0, "LineageMonster.crimson_doll", 15, 38, 40, "male", "L2Monster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2611, 169, 176.36077, 156.55035, 120.43155, 104.23299, 253, 4, 333, 0, 0, 0, 60, 150, 0, 1), 
(20491, 20491, "Crypt Horror", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 15, "male", "L2Monster", 40, 246.95422, 149.2, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 454, 19, 29.61691, 73.55216, 20.22451, 48.97186, 253, 4, 333, 0, 0, 0, 100, 100, 0, 1), 
(20492, 20492, "Kirunak's Guards", 0, "", 0, "LineageMonster.spartoi", 11, 27, 21, "male", "L2Monster", 40, 364.30351, 205.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 764, 35, 47.91924, 89.73059, 32.72263, 59.74364, 253, 4, 333, 68, 0, 0, 60, 140, 0, 1), 
(20494, 20494, "Turek War Hound", 0, "", 0, "LineageMonster.dire_wolf", 13, 11, 24, "male", "L2Monster", 40, 435.34437, 245.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 2088, 103, 60.19687, 98.70919, 41.10666, 65.72169, 253, 4, 333, 0, 0, 0, 24, 110, 0, 1), 
(20495, 20495, "Turek Orc Warlord", 0, "", 0, "LineageMonster.orc_champion", 10, 23, 30, "male", "L2Monster", 40, 604.08419, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 3338, 182, 92.64226, 118.46427, 63.26266, 78.87485, 253, 4, 333, 127, 0, 0, 45, 130, 0, 1), 
(20496, 20496, "Turek Orc Archer", 0, "", 0, "LineageMonster.orc_archer", 14, 25, 27, "male", "L2Monster", 1100, 515.17856, 286.92, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 2585, 132, 74.99121, 108.28767, 51.20928, 72.09915, 253, 8, 333, 14, 0, 0, 45, 110, 0, 1), 
(20497, 20497, "Turek Orc Skirmisher", 0, "", 0, "LineageMonster.orc_fighter", 12, 22, 28, "male", "L2Monster", 40, 543.79576, 300.96, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 2682, 140, 80.54056, 111.61368, 54.99876, 74.31365, 253, 4, 333, 121, 0, 0, 45, 110, 0, 1), 
(20498, 20498, "Turek Orc Supplier", 0, "", 0, "LineageMonster.orc_fighter", 12, 22, 27, "male", "L2Monster", 40, 515.17856, 286.92, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 2485, 127, 74.99121, 108.28767, 51.20928, 72.09915, 253, 8, 333, 11, 0, 0, 45, 110, 0, 1), 
(20499, 20499, "Turek Orc Footman", 0, "", 0, "LineageMonster.orc", 10, 21, 26, "male", "L2Monster", 40, 487.5704, 273, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 2359, 119, 69.75926, 105.02818, 47.63653, 69.92894, 253, 4, 333, 2, 0, 0, 45, 110, 0, 1), 
(20500, 20500, "Turek Orc Sentinel", 0, "", 0, "LineageMonster.orc", 10, 21, 25, "male", "L2Monster", 40, 460.96247, 259.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 2215, 110, 64.83203, 101.83533, 44.27187, 67.80312, 253, 4, 333, 3, 0, 0, 45, 110, 0, 1), 
(20501, 20501, "Turek Orc Shaman", 0, "", 0, "LineageMonster.orc_shaman", 9, 22, 29, "male", "L2Monster", 40, 573.42917, 315.12, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 2776, 149, 86.42002, 115.00598, 59.01367, 76.57227, 253, 1, 333, 7, 0, 0, 45, 120, 0, 1), 
(20502, 20502, "Twink Puma", 0, "", 0, "LineageMonster.onyx_beast", 14, 14.5, 15, "male", "L2Monster", 40, 246.95422, 149.2, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 540, 22, 29.61691, 73.55216, 20.22451, 48.97186, 253, 4, 333, 0, 0, 0, 30, 120, 1, 1), 
(20504, 20504, "Dread Soldier", 0, "", 0, "LineageMonster.skeleton", 11, 25, 14, "male", "L2Monster", 40, 230.38548, 140.88, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 424, 16, 27.24646, 71.08179, 18.6058, 47.32706, 253, 8, 333, 946, 0, 0, 60, 140, 0, 1), 
(20505, 20505, "Ruin Bat", 0, "", 0, "LineageMonster.vampire_bat_bi", 10, 42, 20, "male", "L2Monster", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 713, 32, 44.32863, 86.87049, 30.2707, 57.83936, 253, 4, 333, 0, 0, 0, 60, 80, 1, 1), 
(20506, 20506, "Ruin Imp", 0, "", 0, "LineageMonster.imp_bi", 10, 30, 17, "male", "L2Monster", 40, 282.57403, 166.08, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 606, 25, 34.8979, 78.68469, 23.83074, 52.38915, 253, 4, 333, 0, 0, 0, 60, 80, 1, 1), 
(20507, 20507, "Ruin Imp Elder", 0, "", 0, "LineageMonster.imp_bi", 10, 30, 21, "male", "L2Monster", 40, 364.30351, 205.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 936, 43, 47.91924, 89.73059, 32.72263, 59.74364, 253, 4, 333, 0, 0, 0, 60, 80, 1, 1), 
(20508, 20508, "Plunder Tarantula", 0, "", 0, "LineageMonster.giant_spider", 26, 25.5, 17, "male", "L2Monster", 40, 282.57403, 166.08, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 618, 26, 34.8979, 78.68469, 23.83074, 52.38915, 253, 4, 333, 0, 0, 0, 72, 130, 1, 1), 
(20509, 20509, "Spore Fungus", 0, "", 0, "LineageMonster.walking_fungus", 15, 22.5, 9, "male", "L2Monster", 40, 143.17564, 100.48, 2, 0.9, 40, 43, 30, 21, 20, 20, 321, 11, 17.70841, 59.66387, 12.09255, 39.72488, 253, 4, 333, 0, 0, 0, 70, 110, 1, 1), 
(20510, 20510, "Puma", 0, "", 0, "LineageMonster.onyx_beast", 14, 14.5, 12, "male", "L2Monster", 40, 199.62322, 124.48, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 423, 16, 22.99606, 66.32989, 15.70333, 44.16318, 253, 4, 333, 0, 0, 0, 30, 120, 1, 1), 
(20511, 20511, "Pitchstone Golem", 0, "", 0, "LineageMonster.stone_golem", 20, 31, 19, "male", "L2Monster", 40, 321.63954, 183.28, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 799, 36, 40.96915, 84.07638, 27.97662, 55.97901, 253, 4, 333, 0, 0, 0, 23, 23, 0, 1), 
(20512, 20512, "Field Stalker", 0, "", 0, "LineageMonster.field_stalker", 15, 30, 35, "male", "L2Monster", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2175, 128, 129.32896, 136.72948, 88.31491, 91.03603, 253, 4, 333, 0, 0, 0, 70, 110, 0, 1), 
(20513, 20513, "Skeleton Knight", 0, "", 0, "LineageMonster.skeleton_knight", 10, 25, 32, "male", "L2Monster", 40, 668.47132, 358.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1519, 85, 106.16525, 125.57727, 72.49711, 83.61076, 253, 4, 333, 150, 0, 0, 40, 160, 0, 1), 
(20514, 20514, "Shield Skeleton", 0, "", 0, "LineageMonster.skeleton", 11, 25, 15, "male", "L2Monster", 40, 246.95422, 149.2, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 534, 22, 29.61691, 73.55216, 20.22451, 48.97186, 253, 1, 333, 157, 103, 0, 60, 140, 1, 1), 
(20515, 20515, "Skeleton Infantryman", 0, "", 0, "LineageMonster.skeleton", 11, 25, 16, "male", "L2Monster", 40, 264.34345, 157.6, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 571, 23, 32.16396, 76.08628, 21.96382, 50.6591, 253, 1, 333, 157, 18, 0, 60, 140, 1, 1), 
(20516, 20516, "Skeleton Sentinel", 0, "", 0, "LineageMonster.skeleton_bi", 11, 31, 14, "male", "L2Monster", 40, 230.38548, 140.88, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 424, 16, 27.24646, 71.08179, 18.6058, 47.32706, 253, 8, 333, 946, 0, 0, 60, 140, 0, 1), 
(20517, 20517, "Skeleton Hunter", 0, "", 0, "LineageMonster.skeleton", 11, 25, 12, "male", "L2Monster", 40, 199.62322, 124.48, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 363, 13, 22.99606, 66.32989, 15.70333, 44.16318, 253, 8, 333, 946, 0, 0, 60, 140, 0, 1), 
(20518, 20518, "Skeleton Hunter Archer", 0, "", 0, "LineageMonster.skeleton_archer", 11, 27, 13, "male", "L2Monster", 1100, 214.61578, 132.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 397, 16, 25.04271, 68.67458, 17.10092, 45.72431, 253, 8, 333, 275, 0, 0, 40, 140, 0, 1), 
(20519, 20519, "Skeleton Pikeman", 0, "", 0, "LineageMonster.skeleton_pikeman", 10, 28, 27, "male", "L2Monster", 40, 515.17856, 286.92, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1136, 58, 74.99121, 108.28767, 51.20928, 72.09915, 253, 4, 333, 299, 0, 0, 50, 155, 0, 1), 
(20520, 20520, "Pirate Captain Uthanka", 0, "", 0, "LineageMonster.orc_fighter_bi", 12, 26.4, 10, "male", "L2Monster", 40, 163.28607, 108.4, 2, 0.9, 40, 43, 30, 21, 20, 20, 926, 32, 19.33758, 61.82527, 13.20506, 41.16396, 253, 1, 333, 2, 0, 0, 45, 110, 0, 1), 
(20521, 20521, "Whinstone Golem", 0, "", 0, "LineageMonster.stone_golem", 20, 31, 14, "male", "L2Monster", 40, 230.38548, 140.88, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 705, 27, 27.24646, 71.08179, 18.6058, 47.32706, 253, 4, 333, 0, 0, 0, 23, 23, 1, 1), 
(20522, 20522, "White Fang", 0, "", 0, "LineageMonster.wolf_bi", 13, 10.8, 10, "male", "L2Monster", 40, 163.28607, 108.4, 2, 0.9, 40, 43, 30, 21, 20, 20, 917, 31, 19.33758, 61.82527, 13.20506, 41.16396, 253, 1, 333, 0, 0, 0, 24, 110, 0, 1), 
(20524, 20524, "Grey Wolf Elder", 0, "", 0, "LineageMonster.wolf", 13, 9, 7, "male", "L2Monster", 40, 108.42254, 84.88, 2, 0.9, 40, 43, 30, 21, 20, 20, 152, 5, 14.80956, 55.51894, 10.11301, 36.96514, 253, 1, 333, 0, 0, 0, 24, 110, 0, 1), 
(20525, 20525, "Gray Wolf", 0, "", 0, "LineageMonster.wolf", 13, 9, 4, "male", "L2Monster", 40, 68.20985, 62.08, 2, 0.9, 40, 43, 30, 21, 20, 20, 141, 4, 11.24892, 49.73343, 7.68155, 33.11308, 253, 4, 333, 0, 0, 0, 24, 110, 1, 1), 
(20526, 20526, "Obsidian Golem", 0, "", 0, "LineageMonster.stone_golem", 20, 31, 15, "male", "L2Monster", 40, 246.95422, 149.2, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 756, 31, 29.61691, 73.55216, 20.22451, 48.97186, 253, 4, 333, 0, 0, 0, 23, 23, 1, 1), 
(20527, 20527, "Great Snow Wolf", 0, "", 0, "LineageMonster.dire_wolf", 13, 11, 4, "male", "L2Monster", 40, 68.20985, 62.08, 2, 0.9, 40, 43, 30, 21, 20, 20, 121, 3, 11.24892, 49.73343, 7.68155, 33.11308, 253, 4, 333, 0, 0, 0, 24, 110, 0, 1), 
(20528, 20528, "Goblin Lord", 0, "", 0, "LineageMonster.goblin", 10, 16.5, 13, "male", "L2Monster", 40, 214.61578, 132.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 458, 18, 25.04271, 68.67458, 17.10092, 45.72431, 253, 8, 333, 217, 0, 0, 40, 110, 1, 1), 
(20529, 20529, "Young Brown Keltir", 0, "", 0, "LineageMonster.keltir", 9.5, 10, 1, "male", "L2Monster", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 35, 2, 8.47458, 44.44444, 5.78704, 29.59162, 253, 4, 333, 0, 0, 0, 23, 110, 1, 1), 
(20530, 20530, "Young Red Keltir", 0, "", 0, "LineageMonster.keltir", 9.5, 10, 1, "male", "L2Monster", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 35, 2, 8.47458, 44.44444, 5.78704, 29.59162, 253, 4, 333, 0, 0, 0, 23, 110, 1, 1), 
(20531, 20531, "Young Prairie Keltir", 0, "", 0, "LineageMonster.keltir", 9.5, 10, 1, "male", "L2Monster", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 35, 2, 8.47458, 44.44444, 5.78704, 29.59162, 253, 4, 333, 0, 0, 0, 23, 110, 1, 1), 
(20532, 20532, "Brown Keltir", 0, "", 0, "LineageMonster.keltir", 9.5, 10, 2, "male", "L2Monster", 40, 48.09168, 47.28, 2, 0.9, 40, 43, 30, 21, 20, 20, 71, 2, 9.32203, 46.15385, 6.36574, 30.72975, 253, 4, 333, 0, 0, 0, 23, 110, 1, 1), 
(20533, 20533, "Longtail Keltir", 0, "", 0, "LineageMonster.keltir", 9.5, 10, 2, "male", "L2Monster", 40, 48.09168, 47.28, 2, 0.9, 40, 43, 30, 21, 20, 20, 71, 2, 9.32203, 46.15385, 6.36574, 30.72975, 253, 4, 333, 0, 0, 0, 23, 110, 1, 1), 
(20534, 20534, "Red Keltir", 0, "", 0, "LineageMonster.keltir", 9.5, 10, 2, "male", "L2Monster", 40, 48.09168, 47.28, 2, 0.9, 40, 43, 30, 21, 20, 20, 71, 2, 9.32203, 46.15385, 6.36574, 30.72975, 253, 4, 333, 0, 0, 0, 23, 110, 1, 1), 
(20535, 20535, "Prairie Keltir", 0, "", 0, "LineageMonster.keltir", 9.5, 10, 2, "male", "L2Monster", 40, 48.09168, 47.28, 2, 0.9, 40, 43, 30, 21, 20, 20, 71, 2, 9.32203, 46.15385, 6.36574, 30.72975, 253, 4, 333, 0, 0, 0, 23, 110, 1, 1), 
(20536, 20536, "Elder Brown Keltir", 0, "", 0, "LineageMonster.keltir", 9.5, 10, 3, "male", "L2Monster", 40, 57.54874, 54.64, 2, 0.9, 40, 43, 30, 21, 20, 20, 106, 2, 10.24492, 47.91652, 6.99595, 31.90336, 253, 4, 333, 0, 0, 0, 23, 110, 1, 1), 
(20537, 20537, "Elder Red Keltir", 0, "", 0, "LineageMonster.keltir", 9.5, 10, 3, "male", "L2Monster", 40, 57.54874, 54.64, 2, 0.9, 40, 43, 30, 21, 20, 20, 106, 2, 10.24492, 47.91652, 6.99595, 31.90336, 253, 4, 333, 0, 0, 0, 23, 110, 1, 1), 
(20538, 20538, "Elder Prairie Keltir", 0, "", 0, "LineageMonster.keltir", 9.5, 10, 3, "male", "L2Monster", 40, 57.54874, 54.64, 2, 0.9, 40, 43, 30, 21, 20, 20, 106, 2, 10.24492, 47.91652, 6.99595, 31.90336, 253, 4, 333, 0, 0, 0, 23, 110, 1, 1), 
(20539, 20539, "Elder Longtail Keltir", 0, "", 0, "LineageMonster.keltir", 9.5, 10, 3, "male", "L2Monster", 40, 57.54874, 54.64, 2, 0.9, 40, 43, 30, 21, 20, 20, 106, 2, 10.24492, 47.91652, 6.99595, 31.90336, 253, 4, 333, 0, 0, 0, 23, 110, 1, 1), 
(20540, 20540, "Gemstone Beast", 0, "", 0, "LineageMonster.onyx_beast", 14, 14.5, 12, "male", "L2Monster", 40, 199.62322, 124.48, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 353, 13, 22.99606, 66.32989, 15.70333, 44.16318, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(20541, 20541, "Ore Bat", 0, "", 0, "LineageMonster.vampire_bat", 10, 33.5, 17, "male", "L2Monster", 40, 282.57403, 166.08, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 500, 21, 34.8979, 78.68469, 23.83074, 52.38915, 253, 4, 333, 0, 0, 0, 60, 80, 0, 1), 
(20542, 20542, "Skeleton Longbowman", 0, "", 0, "LineageMonster.skeleton_archer", 11, 27, 19, "male", "L2Monster", 1100, 321.63954, 183.28, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 588, 26, 40.96915, 84.07638, 27.97662, 55.97901, 253, 8, 333, 275, 0, 0, 40, 140, 0, 1), 
(20543, 20543, "Ghost", 0, "", 0, "LineageMonster.human_ghost", 8, 22, 20, "male", "L2Monster", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 600, 27, 44.32863, 86.87049, 30.2707, 57.83936, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(20544, 20544, "Elder Keltir", 0, "", 0, "LineageMonster.keltir", 9.5, 10, 3, "male", "L2Monster", 40, 57.54874, 54.64, 2, 0.9, 40, 43, 30, 21, 20, 20, 106, 2, 10.24492, 47.91652, 6.99595, 31.90336, 253, 4, 333, 0, 0, 0, 23, 110, 1, 1), 
(20545, 20545, "Young Keltir", 0, "", 0, "LineageMonster.keltir", 9.5, 10, 1, "male", "L2Monster", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 35, 2, 8.47458, 44.44444, 5.78704, 29.59162, 253, 4, 333, 0, 0, 0, 23, 110, 1, 1), 
(20546, 20546, "Turek Orc Elder", 0, "", 0, "LineageMonster.orc_shaman", 9, 22, 34, "male", "L2Monster", 40, 736.96177, 387.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2058, 120, 121.20802, 132.9486, 82.76936, 88.51867, 253, 1, 333, 7, 0, 0, 45, 120, 0, 1), 
(20547, 20547, "Ol Mahum Reserve", 0, "", 0, "LineageMonster.ol_mahum_bi", 14, 29.2, 23, "male", "L2Monster", 40, 410.70422, 231.96, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1054, 50, 55.84125, 95.64976, 38.13234, 63.68469, 253, 4, 333, 2, 0, 0, 50, 110, 1, 1), 
(20548, 20548, "Ol Mahum Deserter", 0, "", 0, "LineageMonster.ol_mahum", 13.5, 25, 23, "male", "L2Monster", 40, 410.70422, 231.96, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1075, 52, 55.84125, 95.64976, 38.13234, 63.68469, 253, 4, 333, 2, 0, 0, 50, 110, 1, 1), 
(20549, 20549, "Ol Mahum Lord", 0, "", 0, "LineageMonster.ol_mahum_champion", 14, 27, 34, "male", "L2Monster", 40, 736.96177, 387.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 4233, 247, 121.20802, 132.9486, 82.76936, 88.51867, 253, 4, 333, 69, 19, 0, 50, 110, 1, 1), 
(20550, 20550, "Guardian Basilisk", 0, "", 0, "LineageMonster.lesser_basilisk", 34, 25, 36, "male", "L2Monster", 40, 809.52639, 417.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2352, 142, 137.86467, 140.57278, 94.1437, 93.59494, 253, 4, 333, 0, 0, 0, 35, 174, 1, 1), 
(20551, 20551, "Road Scavenger", 0, "", 0, "LineageMonster.wererat", 14, 25, 37, "male", "L2Monster", 40, 847.31754, 432.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2389, 146, 146.82587, 144.47758, 100.26304, 96.19481, 253, 8, 333, 221, 0, 0, 80, 174, 1, 1), 
(20552, 20552, "Fettered Soul", 0, "", 0, "LineageMonster.binding", 12, 21, 38, "male", "L2Monster", 40, 886.09975, 447.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 5152, 322, 156.22273, 148.44287, 106.67987, 98.83494, 253, 4, 333, 0, 0, 0, 10, 174, 1, 1), 
(20553, 20553, "Windsus", 0, "", 0, "LineageMonster.giant_wild_hog", 35, 27, 39, "male", "L2Monster", 40, 925.85879, 463.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2655, 169, 166.06476, 152.46752, 113.4007, 101.5146, 253, 4, 333, 0, 0, 0, 35, 174, 1, 1), 
(20554, 20554, "Grandis", 0, "", 0, "LineageMonster.twin_headed_giant", 17, 39, 40, "male", "L2Monster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 3102, 200, 176.36077, 156.55035, 120.43155, 104.23299, 253, 4, 333, 0, 0, 0, 45, 174, 1, 1), 
(20555, 20555, "Giant Fungus", 0, "", 0, "LineageMonster.walking_fungus_bi", 15, 31.3, 40, "male", "L2Monster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2792, 180, 176.36077, 156.55035, 120.43155, 104.23299, 253, 4, 333, 0, 0, 0, 70, 174, 1, 1), 
(20556, 20556, "Giant Monstereye", 0, "", 0, "LineageMonster.monster_eye_bi", 29, 60, 41, "male", "L2Monster", 40, 1008.23781, 504.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 2934, 192, 187.11878, 160.69002, 127.77787, 106.98923, 253, 4, 333, 0, 0, 0, 90, 174, 1, 1), 
(20557, 20557, "Dire Wyrm", 0, "", 0, "LineageMonster.wyrm", 29, 72, 42, "male", "L2Monster", 40, 1050.81652, 531, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3109, 208, 198.34591, 164.88513, 135.44454, 109.78238, 253, 4, 333, 0, 0, 0, 70, 174, 1, 1), 
(20558, 20558, "Rotting tree", 0, "", 0, "LineageMonster.hanged_man_ripper", 35, 80, 43, "male", "L2Monster", 40, 1094.28943, 557.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3195, 216, 210.04832, 169.13417, 143.43577, 112.61144, 253, 4, 333, 0, 0, 0, 55, 174, 1, 1), 
(20559, 20559, "Rotting Golem", 0, "", 0, "LineageMonster.stone_golem_bi_one", 22, 43.4, 44, "male", "L2Monster", 40, 1138.62924, 584, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4730, 324, 222.23112, 173.43552, 151.75505, 115.47533, 253, 4, 333, 0, 0, 0, 23, 23, 1, 1), 
(20560, 20560, "Trisalim Spider", 0, "", 0, "LineageMonster.giant_spider", 26, 25.5, 45, "male", "L2Monster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3499, 244, 234.89829, 177.78746, 160.40508, 118.3729, 253, 4, 333, 0, 0, 0, 72, 174, 1, 1), 
(20561, 20561, "Trisalim Tarantula", 0, "", 0, "LineageMonster.poison_spider", 27, 25.5, 46, "male", "L2Monster", 40, 1229.78678, 637.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4144, 294, 248.0526, 182.18816, 169.38777, 121.30293, 253, 4, 333, 0, 0, 0, 60, 174, 1, 1), 
(20562, 20562, "Spore Zombie", 0, "", 0, "LineageMonster.zombie_bi", 12, 27.5, 47, "male", "L2Monster", 40, 1276.53628, 665, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4310, 308, 261.69549, 186.63569, 178.7041, 124.26415, 253, 4, 333, 0, 0, 0, 15, 15, 1, 1), 
(20563, 20563, "Manashen Gargoyle", 0, "", 0, "LineageMonster.gargoyle", 16, 50, 40, "male", "L2Monster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 3323, 215, 176.36077, 156.55035, 120.43155, 104.23299, 253, 4, 333, 0, 0, 0, 140, 174, 1, 1), 
(20564, 20564, "Enchanted Monstereye", 0, "", 0, "LineageMonster.monster_eye", 21, 43, 41, "male", "L2Monster", 40, 1008.23781, 504.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 2992, 196, 187.11878, 160.69002, 127.77787, 106.98923, 253, 4, 333, 0, 0, 0, 90, 174, 1, 1), 
(20565, 20565, "Enchanted Stone Golem", 0, "", 0, "LineageMonster.stone_golem_bi", 20, 40.3, 42, "male", "L2Monster", 40, 1050.81652, 531, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4353, 290, 198.34591, 164.88513, 135.44454, 109.78238, 253, 4, 333, 0, 0, 0, 23, 23, 1, 1), 
(20566, 20566, "Enchanted Iron Golem", 0, "", 0, "LineageMonster.iron_golem", 18, 34, 43, "male", "L2Monster", 40, 1094.28943, 557.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4563, 308, 210.04832, 169.13417, 143.43577, 112.61144, 253, 4, 333, 0, 0, 0, 20, 20, 1, 1), 
(20567, 20567, "Enchanted Gargoyle", 0, "", 0, "LineageMonster.gargoyle", 16, 50, 44, "male", "L2Monster", 40, 1138.62924, 584, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4021, 275, 222.23112, 173.43552, 151.75505, 115.47533, 253, 4, 333, 0, 0, 0, 140, 174, 1, 1), 
(20568, 20568, "Formor", 0, "", 0, "LineageMonster.troll", 21, 35, 45, "male", "L2Monster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3534, 246, 234.89829, 177.78746, 160.40508, 118.3729, 253, 4, 333, 0, 0, 0, 55, 174, 1, 1), 
(20569, 20569, "Formor Elder", 0, "", 0, "LineageMonster.troll", 21, 35, 46, "male", "L2Monster", 40, 1229.78678, 637.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3841, 272, 248.0526, 182.18816, 169.38777, 121.30293, 253, 4, 333, 0, 0, 0, 55, 174, 1, 1), 
(20570, 20570, "Tarlk Bugbear", 0, "", 0, "LineageMonster.bugbear", 17, 35, 47, "male", "L2Monster", 40, 1276.53628, 665, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3855, 276, 261.69549, 186.63569, 178.7041, 124.26415, 253, 1, 333, 88, 0, 0, 55, 174, 1, 1), 
(20571, 20571, "Tarlk Bugbear Warrior", 0, "", 0, "LineageMonster.bugbear", 17, 35, 48, "male", "L2Monster", 40, 1324.01623, 692.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4553, 332, 275.82705, 191.12803, 188.35412, 127.2552, 253, 1, 333, 169, 0, 0, 55, 174, 1, 1), 
(20572, 20572, "Tarlk Bugbear High Warrior", 0, "", 0, "LineageMonster.king_bugbear", 15, 40, 49, "male", "L2Monster", 40, 1372.18568, 720, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4987, 368, 290.44588, 195.66302, 198.33688, 130.27465, 253, 1, 333, 160, 0, 0, 55, 174, 1, 1), 
(20573, 20573, "Tarlk Basilisk", 0, "", 0, "LineageMonster.lesser_basilisk", 34, 25, 50, "male", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4288, 323, 305.54906, 200.23844, 208.6504, 146.5258, 253, 4, 333, 0, 0, 0, 35, 100, 1, 1), 
(20574, 20574, "Elder Tarlk Basilisk", 0, "", 0, "LineageMonster.lesser_basilisk", 34, 25, 51, "male", "L2Monster", 40, 1470.41596, 775.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 4506, 343, 321.13207, 204.85194, 219.29157, 149.90176, 253, 4, 333, 0, 0, 0, 35, 100, 1, 1), 
(20575, 20575, "Oel Mahum Warrior", 0, "", 0, "LineageMonster.oel_mahum_warrior", 20, 38, 54, "male", "L2Monster", 40, 1621.75618, 861, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 5051, 402, 370.68904, 218.89589, 253.13256, 160.17851, 253, 4, 333, 72, 0, 0, 70, 160, 1, 1), 
(20576, 20576, "Oel Mahum Witch Doctor", 0, "", 0, "LineageMonster.oel_mahum_witch_doctor", 15, 34, 55, "male", "L2Monster", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 10289, 791, 388.11142, 223.6362, 265.02979, 163.64727, 253, 1, 333, 201, 0, 0, 70, 130, 1, 1), 
(20577, 20577, "Leto Lizardman", 0, "", 0, "LineageMonster.zenta_lizardman", 11, 32, 35, "male", "L2Monster", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2138, 126, 129.32896, 136.72948, 88.31491, 91.03603, 253, 4, 333, 66, 0, 0, 37, 174, 1, 1), 
(20578, 20578, "Leto Lizardman Archer", 0, "", 0, "LineageMonster.zenta_lizardman_scout", 11, 30, 36, "male", "L2Monster", 1100, 809.52639, 417.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2330, 140, 137.86467, 140.57278, 94.1437, 93.59494, 253, 8, 333, 14, 0, 0, 37, 174, 1, 1), 
(20579, 20579, "Leto Lizardman Soldier", 0, "", 0, "LineageMonster.zenta_lizardman", 11, 32, 37, "male", "L2Monster", 40, 847.31754, 432.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2437, 150, 146.82587, 144.47758, 100.26304, 96.19481, 253, 4, 333, 68, 0, 0, 37, 174, 1, 1), 
(20580, 20580, "Leto Lizardman Warrior", 0, "", 0, "LineageMonster.zenta_lizardman_warrior", 13, 35, 38, "male", "L2Monster", 40, 886.09975, 447.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 4688, 292, 156.22273, 148.44287, 106.67987, 98.83494, 253, 4, 333, 93, 0, 0, 40, 174, 1, 1), 
(20581, 20581, "Leto Lizardman Shaman", 0, "", 0, "LineageMonster.zenta_lizardman_shaman", 13, 35, 39, "male", "L2Monster", 40, 925.85879, 463.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2655, 169, 166.06476, 152.46752, 113.4007, 101.5146, 253, 1, 333, 159, 0, 0, 43, 174, 1, 1), 
(20582, 20582, "Leto Lizardman Overlord", 0, "", 0, "LineageMonster.zenta_lizardman_matriarch", 20, 40, 40, "male", "L2Monster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 5298, 342, 176.36077, 156.55035, 120.43155, 104.23299, 253, 8, 333, 221, 0, 0, 53, 174, 1, 1), 
(20583, 20583, "Timak Orc", 0, "", 0, "LineageMonster.batur_orc", 9, 21.5, 40, "male", "L2Monster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2792, 180, 176.36077, 156.55035, 120.43155, 104.23299, 253, 4, 333, 2, 0, 0, 80, 174, 1, 1), 
(20584, 20584, "Timak Orc Archer", 0, "", 0, "LineageMonster.batur_orc_archer", 11, 21.5, 41, "male", "L2Monster", 1100, 1008.23781, 504.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3783, 247, 187.11878, 160.69002, 127.77787, 106.98923, 253, 8, 333, 14, 0, 0, 45, 174, 1, 1), 
(20585, 20585, "Timak Orc Soldier", 0, "", 0, "LineageMonster.batur_orc", 9, 21.5, 42, "male", "L2Monster", 40, 1050.81652, 531, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3737, 248, 198.34591, 164.88513, 135.44454, 109.78238, 253, 4, 333, 66, 0, 0, 80, 174, 1, 1), 
(20586, 20586, "Timak Orc Warrior", 0, "", 0, "LineageMonster.batur_orc_warrior", 10, 20, 43, "male", "L2Monster", 40, 1094.28943, 557.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3582, 242, 210.04832, 169.13417, 143.43577, 112.61144, 253, 4, 333, 68, 0, 0, 80, 174, 1, 1), 
(20587, 20587, "Timak Orc Shaman", 0, "", 0, "LineageMonster.batur_orc_shaman", 11, 16, 44, "male", "L2Monster", 40, 1138.62924, 584, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3379, 232, 222.23112, 173.43552, 151.75505, 115.47533, 253, 1, 333, 179, 0, 0, 50, 174, 1, 1), 
(20588, 20588, "Timak Orc Overlord", 0, "", 0, "LineageMonster.batur_orc_overlord", 12, 24, 45, "male", "L2Monster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4441, 308, 234.89829, 177.78746, 160.40508, 118.3729, 253, 4, 333, 127, 0, 0, 80, 174, 1, 1), 
(20589, 20589, "Fline", 0, "", 0, "LineageMonster.sylph", 11, 35, 45, "female", "L2Monster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 6639, 462, 234.89829, 177.78746, 160.40508, 118.3729, 253, 4, 333, 0, 0, 0, 60, 174, 0, 1), 
(20590, 20590, "Liele", 0, "", 0, "LineageMonster.undine", 12, 27, 46, "female", "L2Monster", 40, 1229.78678, 637.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 6869, 487, 248.0526, 182.18816, 169.38777, 121.30293, 253, 4, 333, 0, 0, 0, 60, 174, 0, 1), 
(20591, 20591, "Valley Treant", 0, "", 0, "LineageMonster.ti_mi_tran", 23, 90, 47, "male", "L2Monster", 40, 1276.53628, 665, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 10140, 727, 261.69549, 186.63569, 178.7041, 124.26415, 253, 4, 333, 0, 0, 0, 12, 12, 0, 1), 
(20592, 20592, "Satyr", 0, "", 0, "LineageMonster.pan", 14, 35, 48, "male", "L2Monster", 40, 1324.01623, 692.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 11074, 809, 275.82705, 191.12803, 188.35412, 127.2552, 253, 4, 333, 291, 0, 0, 45, 174, 0, 1), 
(20593, 20593, "Unicorn", 0, "", 0, "LineageMonster.unicorn", 14, 30, 49, "male", "L2Monster", 40, 1372.18568, 720, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 11880, 878, 290.44588, 195.66302, 198.33688, 130.27465, 253, 4, 333, 0, 0, 0, 46, 174, 0, 1), 
(20594, 20594, "Forest Runner", 0, "", 0, "LineageMonster.mandragora_b", 12, 25.5, 50, "female", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 8116, 611, 305.54906, 200.23844, 208.6504, 133.32101, 253, 4, 333, 0, 0, 0, 80, 174, 0, 1), 
(20595, 20595, "Fline Elder", 0, "", 0, "LineageMonster.sylph", 11, 35, 51, "female", "L2Monster", 40, 1470.41596, 775.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 8443, 644, 321.13207, 204.85194, 219.29157, 136.39273, 253, 4, 333, 0, 0, 0, 60, 174, 0, 1), 
(20596, 20596, "Liele Elder", 0, "", 0, "LineageMonster.undine", 12, 27, 52, "female", "L2Monster", 40, 1520.38155, 804, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 8953, 692, 337.18867, 209.50106, 230.25615, 139.48817, 253, 4, 333, 0, 0, 0, 60, 174, 0, 1), 
(20597, 20597, "Valley Treant Elder", 0, "", 0, "LineageMonster.ti_mi_tran", 23, 90, 53, "male", "L2Monster", 40, 1570.8463, 832.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 18717, 1471, 353.71092, 214.18326, 241.5387, 142.60563, 253, 4, 333, 0, 0, 0, 12, 12, 0, 1), 
(20598, 20598, "Satyr Elder", 0, "", 0, "LineageMonster.pan", 14, 35, 54, "male", "L2Monster", 40, 1621.75618, 861, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 13741, 1096, 370.68904, 218.89589, 253.13256, 145.74335, 253, 4, 333, 297, 0, 0, 45, 174, 0, 1), 
(20599, 20599, "Unicorn Elder", 0, "", 0, "LineageMonster.unicorn", 14, 30, 55, "male", "L2Monster", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 14255, 1151, 388.11142, 223.6362, 265.02979, 148.89951, 253, 4, 333, 0, 0, 0, 46, 174, 0, 1), 
(20600, 20600, "Karul Bugbear", 0, "", 0, "LineageMonster.bugbear", 17, 35, 40, "male", "L2Monster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 3290, 212, 176.36077, 156.55035, 120.43155, 104.23299, 253, 1, 333, 88, 0, 0, 55, 174, 1, 1), 
(20601, 20601, "Tamlin Orc", 0, "", 0, "LineageMonster.batur_orc", 9, 21.5, 41, "male", "L2Monster", 40, 1008.23781, 504.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 2934, 192, 187.11878, 160.69002, 127.77787, 106.98923, 253, 4, 333, 2, 0, 0, 80, 174, 1, 1), 
(20602, 20602, "Tamlin Orc Archer", 0, "", 0, "LineageMonster.batur_orc_archer", 11, 21.5, 42, "male", "L2Monster", 1100, 1050.81652, 531, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3970, 264, 198.34591, 164.88513, 135.44454, 109.78238, 253, 8, 333, 14, 0, 0, 45, 174, 1, 1), 
(20603, 20603, "Kronbe Spider", 0, "", 0, "LineageMonster.giant_spider", 26, 25.5, 43, "male", "L2Monster", 40, 1094.28943, 557.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3259, 221, 210.04832, 169.13417, 143.43577, 112.61144, 253, 4, 333, 0, 0, 0, 72, 174, 1, 1), 
(20604, 20604, "Rakin", 0, "", 0, "LineageMonster.twin_headed_giant", 17, 39, 44, "male", "L2Monster", 40, 1138.62924, 584, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3981, 272, 222.23112, 173.43552, 151.75505, 115.47533, 253, 1, 333, 89, 0, 0, 45, 174, 1, 1), 
(20605, 20605, "Weird Drake", 0, "", 0, "LineageMonster.drake", 30, 100, 45, "male", "L2Monster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3605, 251, 234.89829, 177.78746, 160.40508, 118.3729, 253, 4, 333, 0, 0, 0, 70, 174, 1, 1), 
(20606, 20606, "Kuran Kobold", 0, "", 0, "LineageMonster.kobold", 10, 15, 27, "male", "L2Monster", 40, 515.17856, 286.92, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 2282, 116, 74.99121, 108.28767, 51.20928, 72.09915, 253, 4, 333, 0, 0, 0, 47, 110, 0, 1), 
(20607, 20607, "Kuran Kobold Warrior", 0, "", 0, "LineageMonster.kobold", 10, 15, 28, "male", "L2Monster", 40, 543.79576, 300.96, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 2415, 127, 80.54056, 111.61368, 54.99876, 74.31365, 253, 4, 333, 0, 0, 0, 47, 110, 0, 1), 
(20608, 20608, "Patin Archer", 0, "", 0, "LineageMonster.skeleton_archer", 11, 27, 29, "male", "L2Monster", 1100, 573.42917, 315.12, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 2454, 132, 86.42002, 115.00598, 59.01367, 76.57227, 253, 8, 333, 14, 0, 0, 40, 140, 0, 1), 
(20609, 20609, "Rakin Salamander", 0, "", 0, "LineageMonster.salamander", 16, 6.8, 30, "male", "L2Monster", 40, 604.08419, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 2566, 140, 92.64226, 118.46427, 63.26266, 78.87485, 253, 1, 333, 0, 0, 0, 64, 96, 0, 1), 
(20610, 20610, "Sentinel Of Water", 0, "", 0, "LineageMonster.monster_eye", 21, 43, 31, "male", "L2Monster", 40, 635.76437, 343.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2600, 144, 99.21986, 121.98819, 67.7543, 81.22111, 253, 4, 333, 0, 0, 0, 90, 90, 0, 1), 
(20611, 20611, "Dre Vanul Warrior", 0, "", 0, "LineageMonster.dre_vanul", 14, 36, 32, "male", "L2Monster", 40, 668.47132, 358.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2770, 156, 106.16525, 125.57727, 72.49711, 83.61076, 253, 4, 333, 0, 0, 0, 80, 80, 0, 1), 
(20612, 20612, "Salamander Rowin", 0, "", 0, "LineageMonster.salamander", 16, 6.8, 33, "male", "L2Monster", 40, 702.20463, 372.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 3166, 181, 113.49065, 129.23095, 77.49941, 86.04342, 253, 1, 333, 0, 0, 0, 64, 96, 0, 1), 
(20613, 20613, "Lafi Lizardman", 0, "", 0, "LineageMonster.virud_lizardman", 10, 23, 27, "male", "L2Monster", 40, 515.17856, 286.92, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 2282, 116, 74.99121, 108.28767, 51.20928, 72.09915, 253, 4, 333, 291, 0, 0, 43, 130, 0, 1), 
(20614, 20614, "Lafi Lizardman Scout", 0, "", 0, "LineageMonster.virud_lizardman_scout", 10, 22, 28, "male", "L2Monster", 1100, 543.79576, 300.96, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 2257, 119, 80.54056, 111.61368, 54.99876, 74.31365, 253, 8, 333, 2507, 0, 0, 43, 130, 0, 1), 
(20615, 20615, "Ritmal Swordsman", 0, "", 0, "LineageMonster.spartoi", 11, 27, 29, "male", "L2Monster", 40, 573.42917, 315.12, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 2626, 140, 86.42002, 115.00598, 59.01367, 76.57227, 253, 4, 333, 73, 0, 0, 60, 140, 0, 1), 
(20616, 20616, "Rakin Undine", 0, "", 0, "LineageMonster.undine", 12, 27, 30, "female", "L2Monster", 40, 604.08419, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 3443, 188, 92.64226, 118.46427, 63.26266, 78.87485, 253, 1, 333, 0, 0, 0, 60, 60, 0, 1), 
(20617, 20617, "Sentinel Of Water", 0, "", 0, "LineageMonster.magical_weaver", 11, 20, 31, "male", "L2Monster", 40, 635.76437, 343.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2625, 145, 99.21986, 121.98819, 67.7543, 81.22111, 253, 4, 333, 0, 0, 0, 90, 90, 0, 1), 
(20618, 20618, "Kanil Succubus", 0, "", 0, "LineageMonster.succubus", 10, 36, 32, "female", "L2Monster", 40, 668.47132, 358.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2919, 164, 106.16525, 125.57727, 72.49711, 83.61076, 253, 4, 333, 0, 0, 0, 60, 100, 0, 1), 
(20619, 20619, "Rowin Undine", 0, "", 0, "LineageMonster.undine", 12, 27, 33, "female", "L2Monster", 40, 702.20463, 372.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 3005, 173, 113.49065, 129.23095, 77.49941, 86.04342, 253, 1, 333, 0, 0, 0, 60, 60, 0, 1), 
(20620, 20620, "Cave Beast", 0, "", 0, "LineageMonster.troll", 21, 35, 61, "male", "L2Monster", 40, 1985.55926, 1066.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 15494, 1363, 501.08068, 252.49346, 342.17315, 168.113, 253, 4, 333, 0, 0, 0, 55, 174, 0, 1), 
(20621, 20621, "Death Wave", 0, "", 0, "LineageMonster.will_o_wisp", 13, 22, 62, "male", "L2Monster", 40, 2037.81082, 1097, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 16701, 1488, 521.12391, 257.34267, 355.86007, 171.34165, 253, 4, 333, 0, 0, 0, 80, 174, 0, 1), 
(20622, 20622, "Malruk Soldier", 0, "", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 63, "male", "L2Monster", 40, 2089.92274, 1127.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 17833, 1610, 541.44774, 262.19426, 369.73862, 174.5719, 253, 8, 333, 221, 0, 0, 80, 174, 0, 1), 
(20623, 20623, "Plando", 0, "", 0, "LineageMonster.virud_lizardman_scout", 10, 22, 64, "male", "L2Monster", 1100, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 23778, 2177, 562.02275, 267.04468, 383.78868, 177.80136, 253, 8, 333, 2507, 0, 0, 43, 174, 0, 1), 
(20624, 20624, "Cave Howler", 0, "", 0, "LineageMonster.twin_headed_giant", 17, 39, 65, "male", "L2Monster", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 24178, 2246, 582.81759, 271.89033, 397.98887, 181.02764, 253, 4, 333, 0, 0, 0, 45, 174, 0, 1), 
(20625, 20625, "Malruk Knight", 0, "", 0, "LineageMonster.skeleton_knight", 10, 25, 66, "male", "L2Monster", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 24146, 2273, 603.79903, 276.72752, 412.31647, 184.2483, 253, 4, 333, 78, 0, 0, 40, 174, 0, 1), 
(20626, 20626, "Malruk Berserker", 0, "", 0, "LineageMonster.death_knight", 12, 31, 67, "male", "L2Monster", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 34656, 3300, 624.93199, 281.55251, 426.74754, 187.46084, 253, 4, 333, 77, 0, 0, 27, 174, 0, 1), 
(20627, 20627, "Malruk Lord", 0, "", 0, "LineageMonster.death_blader", 15, 45, 68, "male", "L2Monster", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 29789, 2878, 646.17968, 286.3615, 441.25696, 190.66272, 253, 4, 333, 1472, 0, 0, 100, 174, 0, 1), 
(20628, 20628, "Limal Karinness", 0, "", 0, "LineageMonster.bloody_queen", 14, 40, 69, "female", "L2Monster", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 32098, 3140, 667.50361, 291.15063, 455.81844, 193.85137, 253, 4, 333, 0, 0, 0, 80, 174, 0, 1), 
(20629, 20629, "Karik", 0, "", 0, "LineageMonster.karik", 25, 90, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 39507, 3917, 688.86373, 295.91597, 470.40463, 197.0242, 253, 4, 333, 0, 0, 0, 37, 174, 0, 1), 
(20630, 20630, "Taik Orc", 0, "", 0, "LineageMonster.ketra_orc", 12, 29, 40, "male", "L2Monster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2792, 180, 176.36077, 156.55035, 120.43155, 104.23299, 253, 4, 333, 127, 0, 0, 45, 174, 1, 1), 
(20631, 20631, "Taik Orc Archer", 0, "", 0, "LineageMonster.ketra_orc_archer", 12, 27, 41, "male", "L2Monster", 1100, 1008.23781, 504.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3783, 247, 187.11878, 160.69002, 127.77787, 106.98923, 253, 8, 333, 14, 0, 0, 45, 174, 1, 1), 
(20632, 20632, "Taik Orc Warrior", 0, "", 0, "LineageMonster.ketra_orc_warrior", 12, 24, 42, "male", "L2Monster", 40, 1050.81652, 531, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3774, 251, 198.34591, 164.88513, 135.44454, 109.78238, 253, 4, 333, 75, 0, 0, 36, 174, 1, 1), 
(20633, 20633, "Taik Orc Shaman", 0, "", 0, "LineageMonster.ketra_orc_shaman", 10, 23, 43, "male", "L2Monster", 40, 1094.28943, 557.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3682, 248, 210.04832, 169.13417, 143.43577, 112.61144, 253, 1, 333, 9, 0, 0, 10, 174, 1, 1), 
(20634, 20634, "Taik Orc Captain", 0, "", 0, "LineageMonster.ketra_orc_warrior", 12, 24, 44, "male", "L2Monster", 40, 1138.62924, 584, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 7065, 484, 222.23112, 173.43552, 151.75505, 115.47533, 253, 4, 333, 75, 104, 0, 36, 174, 1, 1), 
(20635, 20635, "Carinkain", 0, "", 0, "LineageMonster.mana_vampire", 11, 20, 45, "male", "L2Monster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3569, 248, 234.89829, 177.78746, 160.40508, 118.3729, 253, 4, 333, 0, 0, 0, 90, 174, 1, 1), 
(20636, 20636, "Forest of Mirrors Ghost", 0, "", 0, "LineageMonster.dwarf_ghost", 9, 16.5, 46, "male", "L2Monster", 40, 1229.78678, 637.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3973, 282, 248.0526, 182.18816, 169.38777, 121.30293, 253, 4, 333, 0, 0, 0, 80, 174, 1, 1), 
(20637, 20637, "Forest of Mirrors Ghost", 0, "", 0, "LineageMonster.elf_ghost", 7, 21, 47, "male", "L2Monster", 40, 1276.53628, 665, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4148, 298, 261.69549, 186.63569, 178.7041, 124.26415, 253, 4, 333, 0, 0, 0, 80, 174, 1, 1), 
(20638, 20638, "Forest of Mirrors Ghost", 0, "", 0, "LineageMonster.human_ghost", 8, 22, 48, "male", "L2Monster", 40, 1324.01623, 692.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4326, 316, 275.82705, 191.12803, 188.35412, 127.2552, 253, 4, 333, 0, 0, 0, 80, 174, 1, 1), 
(20639, 20639, "Mirror", 0, "", 0, "LineageMonster.mirror", 26, 52, 49, "male", "L2Monster", 40, 1372.18568, 720, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 10210, 755, 290.44588, 195.66302, 198.33688, 130.27465, 253, 4, 333, 0, 0, 0, 80, 174, 1, 1), 
(20640, 20640, "Harit Lizardman", 0, "", 0, "LineageMonster.zenta_lizardman", 11, 32, 50, "male", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4363, 329, 305.54906, 200.23844, 208.6504, 133.32101, 253, 1, 333, 88, 945, 0, 37, 174, 1, 1), 
(20641, 20641, "Harit Lizardman Grunt", 0, "", 0, "LineageMonster.zenta_lizardman", 11, 32, 51, "male", "L2Monster", 40, 1470.41596, 775.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 5402, 412, 321.13207, 204.85194, 219.29157, 136.39273, 253, 4, 333, 70, 0, 0, 37, 174, 1, 1), 
(20642, 20642, "Harit Lizardman Archer", 0, "", 0, "LineageMonster.zenta_lizardman_scout", 11, 30, 52, "male", "L2Monster", 1100, 1520.38155, 804, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 5057, 391, 337.18867, 209.50106, 230.25615, 139.48817, 253, 8, 333, 14, 0, 0, 37, 174, 1, 1), 
(20643, 20643, "Harit Lizardman Warrior", 0, "", 0, "LineageMonster.zenta_lizardman_warrior", 13, 35, 53, "male", "L2Monster", 40, 1570.8463, 832.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 5199, 409, 353.71092, 214.18326, 241.5387, 142.60563, 253, 4, 333, 291, 0, 0, 40, 174, 1, 1), 
(20644, 20644, "Harit Lizardman Shaman", 0, "", 0, "LineageMonster.zenta_lizardman_shaman", 13, 35, 54, "male", "L2Monster", 40, 1621.75618, 861, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 5089, 406, 370.68904, 218.89589, 253.13256, 145.74335, 253, 1, 333, 9, 0, 0, 43, 174, 1, 1), 
(20645, 20645, "Harit Lizardman Matriarch", 0, "", 0, "LineageMonster.zenta_lizardman_matriarch", 20, 40, 55, "male", "L2Monster", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 11444, 924, 388.11142, 223.6362, 265.02979, 148.89951, 253, 4, 333, 221, 0, 0, 53, 174, 1, 1), 
(20646, 20646, "Halingka", 0, "", 0, "LineageMonster.saber_toothed_tiger", 34, 28, 55, "male", "L2Monster", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 8623, 696, 388.11142, 223.6362, 265.02979, 148.89951, 253, 1, 333, 0, 0, 0, 60, 170, 0, 1), 
(20647, 20647, "Yintzu", 0, "", 0, "LineageMonster.field_stalker", 15, 30, 56, "male", "L2Monster", 40, 1724.6831, 918.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 8653, 710, 405.96455, 228.40135, 277.22116, 152.0722, 253, 1, 333, 0, 0, 0, 70, 110, 0, 1), 
(20648, 20648, "Paliote", 0, "", 0, "LineageMonster.will_o_wisp", 13, 22, 57, "male", "L2Monster", 40, 1776.58018, 948, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 9826, 816, 424.23295, 233.18839, 289.69611, 155.25946, 253, 1, 333, 0, 0, 0, 80, 140, 0, 1), 
(20649, 20649, "Hamrut", 0, "", 0, "LineageMonster.poison_spider", 27, 25.5, 58, "male", "L2Monster", 40, 1828.68266, 977.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 9781, 827, 442.8992, 237.99429, 302.44274, 158.45929, 253, 1, 333, 0, 0, 0, 60, 140, 0, 1), 
(20650, 20650, "Kranrot", 0, "", 0, "LineageMonster.crimson_bear", 19, 36, 59, "male", "L2Monster", 40, 1880.92519, 1007, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 10586, 905, 461.94387, 242.81593, 315.44778, 161.66959, 253, 1, 333, 0, 0, 0, 37, 170, 0, 1), 
(20651, 20651, "Gamlin", 0, "", 0, "LineageMonster.gamlin", 11, 32, 60, "male", "L2Monster", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 9835, 853, 481.34551, 247.65008, 328.69659, 164.88822, 253, 1, 333, 0, 0, 0, 80, 170, 0, 1), 
(20652, 20652, "Leogul", 0, "", 0, "LineageMonster.leogul", 15, 35, 61, "male", "L2Monster", 40, 1985.55926, 1066.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 10369, 913, 501.08068, 252.49346, 342.17315, 168.113, 253, 1, 333, 0, 0, 0, 80, 170, 0, 1), 
(20653, 20653, "Lesser Giant", 0, "", 0, "LineageMonster.lesser_giant", 21, 44, 61, "male", "L2Monster", 40, 1985.55926, 1066.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 14612, 1286, 501.08068, 252.49346, 342.17315, 168.113, 253, 1, 333, 3937, 0, 0, 15, 180, 0, 1), 
(20654, 20654, "Lesser Giant Soldier", 0, "", 0, "LineageMonster.lesser_giant", 21, 44, 62, "male", "L2Monster", 40, 2037.81082, 1097, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 22406, 1997, 521.12391, 257.34267, 355.86007, 171.34165, 253, 1, 333, 3937, 0, 0, 15, 180, 0, 1), 
(20655, 20655, "Lesser Giant Shooter", 0, "", 0, "LineageMonster.lesser_giant_shooter", 21, 44, 63, "male", "L2Monster", 1100, 2089.92274, 1127.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 18307, 1652, 541.44774, 262.19426, 369.73862, 174.5719, 253, 8, 333, 4028, 0, 0, 80, 180, 0, 1), 
(20656, 20656, "Lesser Giant Scout", 0, "", 0, "LineageMonster.lesser_giant_shooter", 21, 44, 63, "male", "L2Monster", 1100, 2089.92274, 1127.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 16702, 1508, 541.44774, 262.19426, 369.73862, 174.5719, 253, 8, 333, 4028, 0, 0, 80, 180, 0, 1), 
(20657, 20657, "Lesser Giant Mage", 0, "", 0, "LineageMonster.lesser_giant_mage", 21, 44, 64, "male", "L2Monster", 40, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 13228, 1211, 562.02275, 267.04468, 383.78868, 177.80136, 253, 1, 333, 3938, 0, 0, 15, 180, 0, 1), 
(20658, 20658, "Lesser Giant Elder", 0, "", 0, "LineageMonster.lesser_giant_mage", 21, 44, 65, "male", "L2Monster", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 12778, 1187, 582.81759, 271.89033, 397.98887, 181.02764, 253, 1, 333, 3938, 0, 0, 15, 180, 0, 1), 
(20659, 20659, "Grave Wanderer", 0, "", 0, "LineageMonster.zombie", 13, 21, 45, "male", "L2Monster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4948, 344, 234.89829, 177.78746, 160.40508, 118.3729, 253, 4, 333, 0, 0, 0, 15, 15, 1, 1), 
(20660, 20660, "Archer of Greed", 0, "", 0, "LineageMonster.skeleton_archer", 11, 27, 46, "male", "L2Monster", 1100, 1229.78678, 637.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4858, 344, 248.0526, 182.18816, 169.38777, 121.30293, 253, 8, 333, 14, 0, 0, 40, 174, 1, 1), 
(20661, 20661, "Hatar Ratman Thief", 0, "", 0, "LineageMonster.wererat", 14, 25, 47, "male", "L2Monster", 40, 1276.53628, 665, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4588, 329, 261.69549, 186.63569, 178.7041, 124.26415, 253, 8, 333, 946, 0, 0, 80, 174, 1, 1), 
(20662, 20662, "Hatar Ratman Boss", 0, "", 0, "LineageMonster.wererat", 14, 25, 48, "male", "L2Monster", 40, 1324.01623, 692.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4785, 349, 275.82705, 191.12803, 188.35412, 127.2552, 253, 8, 333, 221, 0, 0, 80, 174, 1, 1), 
(20663, 20663, "Hatar Hanishee", 0, "", 0, "LineageMonster.medusa", 10, 25, 49, "female", "L2Monster", 40, 1372.18568, 720, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4190, 310, 290.44588, 195.66302, 198.33688, 130.27465, 253, 4, 333, 0, 0, 0, 50, 174, 1, 1), 
(20664, 20664, "Deprive", 0, "", 0, "LineageMonster.field_stalker", 15, 30, 50, "male", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4406, 332, 305.54906, 200.23844, 208.6504, 133.32101, 253, 4, 333, 0, 0, 0, 70, 174, 1, 1), 
(20665, 20665, "Taik Orc Supply", 0, "", 0, "LineageMonster.ketra_orc", 12, 29, 51, "male", "L2Monster", 40, 1470.41596, 775.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 5402, 412, 321.13207, 204.85194, 219.29157, 136.39273, 253, 4, 333, 69, 0, 0, 45, 174, 1, 1), 
(20666, 20666, "Taik Orc Seeker", 0, "", 0, "LineageMonster.ketra_orc", 12, 29, 52, "male", "L2Monster", 40, 1520.38155, 804, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 5616, 434, 337.18867, 209.50106, 230.25615, 139.48817, 253, 4, 333, 72, 0, 0, 45, 174, 0, 1), 
(20667, 20667, "Farcran", 0, "", 0, "LineageMonster.crimson_bear", 19, 36, 53, "male", "L2Monster", 40, 1570.8463, 832.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 5776, 454, 353.71092, 214.18326, 241.5387, 142.60563, 253, 4, 333, 0, 0, 0, 37, 174, 1, 1), 
(20668, 20668, "Grave Guard", 0, "", 0, "LineageMonster.gargoyle", 16, 50, 54, "male", "L2Monster", 40, 1621.75618, 861, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 5140, 409, 370.68904, 218.89589, 253.13256, 145.74335, 253, 4, 333, 0, 0, 0, 140, 174, 0, 1), 
(20669, 20669, "Taik Orc Supply Leader", 0, "", 0, "LineageMonster.ketra_orc_warrior", 12, 24, 55, "male", "L2Monster", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 6408, 517, 388.11142, 223.6362, 265.02979, 148.89951, 253, 4, 333, 75, 0, 0, 36, 174, 0, 1), 
(20670, 20670, "Crimson Drake", 0, "", 0, "LineageMonster.drake", 30, 100, 61, "male", "L2Monster", 40, 1985.55926, 1066.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 6558, 577, 501.08068, 252.49346, 342.17315, 168.113, 253, 4, 333, 0, 0, 0, 70, 174, 0, 1), 
(20671, 20671, "Kadios", 0, "", 0, "LineageMonster.devastator", 35, 35, 62, "male", "L2Monster", 40, 2037.81082, 1097, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 6843, 610, 521.12391, 257.34267, 355.86007, 171.34165, 253, 4, 333, 0, 0, 0, 25, 174, 0, 1), 
(20672, 20672, "Trives", 0, "", 0, "LineageMonster.serpent_slave", 17, 46, 63, "male", "L2Monster", 40, 2089.92274, 1127.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 6927, 625, 541.44774, 262.19426, 369.73862, 174.5719, 253, 4, 333, 127, 0, 0, 70, 174, 0, 1), 
(20673, 20673, "Falibati", 0, "", 0, "LineageMonster.cave_maiden", 25, 65, 64, "female", "L2Monster", 40, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 7219, 661, 562.02275, 267.04468, 383.78868, 177.80136, 253, 4, 333, 73, 0, 0, 70, 174, 0, 1), 
(20674, 20674, "Doom Knight", 0, "", 0, "LineageMonster.death_blader", 15, 45, 65, "male", "L2Monster", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 10379, 965, 582.81759, 271.89033, 397.98887, 181.02764, 253, 4, 333, 1472, 0, 0, 100, 174, 0, 1), 
(20675, 20675, "Tairim", 0, "", 0, "LineageMonster.will_o_wisp", 13, 22, 50, "male", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4581, 346, 305.54906, 200.23844, 208.6504, 133.32101, 253, 4, 333, 0, 0, 0, 80, 174, 0, 1), 
(20676, 20676, "Judge of Marsh", 0, "", 0, "LineageMonster.hanged_man_ripper", 35, 80, 65, "male", "L2Monster", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 7447, 692, 582.81759, 271.89033, 397.98887, 181.02764, 253, 4, 333, 0, 0, 0, 55, 174, 1, 1), 
(20677, 20677, "Tulben", 0, "", 0, "LineageMonster.vampire_bat", 10, 33.5, 66, "male", "L2Monster", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 8363, 787, 603.79903, 276.72752, 412.31647, 184.2483, 253, 4, 333, 0, 0, 0, 60, 174, 1, 1), 
(20678, 20678, "Tortured Undead", 0, "", 0, "LineageMonster.hungry_spirit", 30, 40, 53, "male", "L2Monster", 40, 1570.8463, 832.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 4902, 385, 353.71092, 214.18326, 241.5387, 142.60563, 253, 4, 333, 0, 0, 0, 15, 174, 0, 1), 
(20679, 20679, "Marsh Stalker", 0, "", 0, "LineageMonster.gargoyle", 16, 50, 54, "male", "L2Monster", 40, 1621.75618, 861, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 5039, 402, 370.68904, 218.89589, 253.13256, 145.74335, 253, 4, 333, 0, 0, 0, 140, 174, 1, 1), 
(20680, 20680, "Marsh Drake", 0, "", 0, "LineageMonster.drake", 30, 100, 55, "male", "L2Monster", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 5332, 431, 388.11142, 223.6362, 265.02979, 148.89951, 253, 4, 333, 0, 0, 0, 70, 174, 1, 1), 
(20681, 20681, "Vanor Silenos", 0, "", 0, "LineageMonster.heltor_silenos", 13, 29, 45, "male", "L2Monster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3711, 258, 234.89829, 177.78746, 160.40508, 118.3729, 253, 1, 333, 88, 0, 0, 34, 174, 1, 1), 
(20682, 20682, "Vanor Silenos Grunt", 0, "", 0, "LineageMonster.heltor_silenos", 13, 29, 46, "male", "L2Monster", 40, 1229.78678, 637.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3693, 262, 248.0526, 182.18816, 169.38777, 121.30293, 253, 1, 333, 158, 18, 0, 34, 174, 1, 1), 
(20683, 20683, "Vanor Silenos Scout", 0, "", 0, "LineageMonster.heltor_silenos", 13, 29, 47, "male", "L2Monster", 40, 1276.53628, 665, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4805, 344, 261.69549, 186.63569, 178.7041, 124.26415, 253, 1, 333, 5, 0, 0, 34, 174, 1, 1), 
(20684, 20684, "Vanor Silenos Warrior", 0, "", 0, "LineageMonster.heltor_silenos_warrior", 13, 31, 48, "male", "L2Monster", 40, 1324.01623, 692.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 5026, 367, 275.82705, 191.12803, 188.35412, 127.2552, 253, 1, 333, 160, 0, 0, 36, 174, 1, 1), 
(20685, 20685, "Vanor Silenos Shaman", 0, "", 0, "LineageMonster.heltor_silenos_shaman", 13, 32, 49, "male", "L2Monster", 40, 1372.18568, 720, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4190, 310, 290.44588, 195.66302, 198.33688, 130.27465, 253, 1, 333, 9, 0, 0, 29, 174, 1, 1), 
(20686, 20686, "Vanor Silenos Chieftain", 0, "", 0, "LineageMonster.heltor_silenos_chieftain", 13, 31.5, 50, "male", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 8731, 658, 305.54906, 200.23844, 208.6504, 133.32101, 253, 4, 333, 75, 0, 0, 27, 174, 1, 1), 
(20738, 20738, "Kobold Looter Bepook", 0, "", 0, "LineageMonster.kobold_bi", 15, 24, 13, "male", "L2Monster", 40, 214.61578, 132.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 1326, 52, 25.04271, 68.67458, 17.10092, 45.72431, 253, 1, 333, 4, 0, 0, 47, 110, 0, 1), 
(20739, 20739, "Bepook's Pet", 0, "", 0, "LineageMonster.wolf", 13, 9, 10, "male", "L2Monster", 40, 163.28607, 108.4, 2, 0.9, 40, 43, 30, 21, 20, 20, 220, 7, 19.33758, 61.82527, 13.20506, 41.16396, 253, 1, 333, 0, 0, 0, 24, 110, 0, 1), 
(20742, 20742, "Mystical Weaver", 0, "", 0, "LineageMonster.magical_weaver", 11, 20, 22, "male", "L2Monster", 40, 387.02878, 218.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 821, 38, 51.75278, 92.65694, 35.34044, 61.69203, 253, 4, 333, 0, 0, 0, 90, 90, 0, 1), 
(20743, 20743, "Howler", 0, "", 0, "LineageMonster.werewolf", 10, 26, 25, "male", "L2Monster", 40, 460.96247, 259.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1012, 50, 64.83203, 101.83533, 44.27187, 67.80312, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(20744, 20744, "Red Eye Vampire Bat", 0, "", 0, "LineageMonster.vampire_bat", 10, 33.5, 22, "male", "L2Monster", 40, 387.02878, 218.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 821, 38, 51.75278, 92.65694, 35.34044, 61.69203, 253, 4, 333, 0, 0, 0, 60, 80, 0, 1), 
(20745, 20745, "Gigantiops", 0, "", 0, "LineageMonster.ant_soldier", 35, 17, 35, "male", "L2Monster", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 3218, 191, 129.32896, 136.72948, 88.31491, 91.03603, 253, 4, 333, 0, 0, 0, 80, 174, 0, 1), 
(20746, 20746, "Young Gigantiops", 0, "", 0, "LineageMonster.ant", 26, 15, 31, "male", "L2Monster", 40, 635.76437, 343.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2475, 137, 99.21986, 121.98819, 67.7543, 81.22111, 253, 4, 333, 0, 0, 0, 40, 139, 0, 1), 
(20747, 20747, "Roxide", 0, "", 0, "LineageMonster.succubus", 10, 36, 32, "female", "L2Monster", 40, 668.47132, 358.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 3504, 197, 106.16525, 125.57727, 72.49711, 83.61076, 253, 4, 333, 0, 0, 0, 60, 159, 0, 1), 
(20748, 20748, "Roxide Cohort", 0, "", 0, "LineageMonster.spartoi", 11, 27, 29, "male", "L2Monster", 40, 573.42917, 315.12, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 3240, 174, 86.42002, 115.00598, 59.01367, 76.57227, 253, 4, 333, 73, 0, 0, 60, 159, 0, 1), 
(20749, 20749, "Death Fire", 0, "", 0, "LineageMonster.dre_vanul", 14, 36, 32, "male", "L2Monster", 40, 668.47132, 358.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 3504, 197, 106.16525, 125.57727, 72.49711, 83.61076, 253, 4, 333, 0, 0, 0, 80, 159, 0, 1), 
(20750, 20750, "Fire Archer", 0, "", 0, "LineageMonster.skeleton_archer", 11, 27, 29, "male", "L2Monster", 1100, 573.42917, 315.12, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 3354, 180, 86.42002, 115.00598, 59.01367, 76.57227, 253, 8, 333, 14, 0, 0, 40, 159, 0, 1), 
(20751, 20751, "Snipe", 0, "", 0, "LineageMonster.onyx_beast", 14, 14.5, 44, "male", "L2Monster", 40, 1138.62924, 584, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 13373, 880, 222.23112, 173.43552, 151.75505, 126.91259, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(20752, 20752, "Snipe Cohort", 0, "", 0, "LineageMonster.onyx_beast", 14, 14.5, 42, "male", "L2Monster", 40, 1050.81652, 531, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 7085, 451, 198.34591, 164.88513, 135.44454, 120.65578, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(20753, 20753, "Dark Lord", 0, "", 0, "LineageMonster.death_blader", 15, 45, 50, "male", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 11417, 826, 305.54906, 200.23844, 208.6504, 146.5258, 253, 4, 333, 1472, 0, 0, 100, 170, 0, 1), 
(20754, 20754, "Dark Knight", 0, "", 0, "LineageMonster.death_knight", 12, 31, 48, "male", "L2Monster", 40, 1324.01623, 692.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 12549, 887, 275.82705, 191.12803, 188.35412, 139.8592, 253, 4, 333, 127, 0, 0, 27, 110, 0, 1), 
(20755, 20755, "Talakin", 0, "", 0, "LineageMonster.ol_mahum_champion", 14, 27, 30, "male", "L2Monster", 40, 604.08419, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 2364, 130, 92.64226, 118.46427, 63.26266, 78.87485, 253, 4, 333, 2, 0, 0, 50, 133, 0, 1), 
(20756, 20756, "Talakin Archer", 0, "", 0, "LineageMonster.ol_mahum_archer", 14, 25, 28, "male", "L2Monster", 1100, 543.79576, 300.96, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 2261, 119, 80.54056, 111.61368, 54.99876, 74.31365, 253, 8, 333, 14, 0, 0, 50, 133, 0, 1), 
(20757, 20757, "Talakin Raider", 0, "", 0, "LineageMonster.ol_mahum", 13.5, 25, 27, "male", "L2Monster", 40, 515.17856, 286.92, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1657, 85, 74.99121, 108.28767, 51.20928, 72.09915, 253, 4, 333, 3, 0, 0, 50, 133, 0, 1), 
(20758, 20758, "Dragon Bearer Chief", 0, "", 0, "LineageMonster.spartoi", 11, 27, 49, "male", "L2Monster", 40, 1372.18568, 720, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 6307, 467, 290.44588, 195.66302, 198.33688, 130.27465, 253, 4, 333, 123, 945, 0, 60, 174, 0, 1), 
(20759, 20759, "Dragon Bearer Warrior", 0, "", 0, "LineageMonster.skeleton", 11, 25, 48, "male", "L2Monster", 40, 1324.01623, 692.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 5934, 433, 275.82705, 191.12803, 188.35412, 127.2552, 253, 4, 333, 2, 945, 0, 60, 174, 0, 1), 
(20760, 20760, "Dragon Bearer Archer", 0, "", 0, "LineageMonster.skeleton_archer", 11, 27, 47, "male", "L2Monster", 1100, 1276.53628, 665, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 6165, 442, 261.69549, 186.63569, 178.7041, 124.26415, 253, 8, 333, 14, 0, 0, 40, 174, 0, 1), 
(20761, 20761, "Pytan", 0, "", 0, "LineageMonster.bloody_queen", 14, 40, 69, "female", "L2Monster", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 23881, 2336, 667.50361, 291.15063, 455.81844, 193.85137, 253, 4, 333, 0, 0, 0, 80, 174, 0, 1), 
(20762, 20762, "Pytan Knight", 0, "", 0, "LineageMonster.death_blader", 15, 45, 68, "male", "L2Monster", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 16852, 1628, 646.17968, 286.3615, 441.25696, 190.66272, 253, 4, 333, 1472, 0, 0, 100, 174, 0, 1), 
(20763, 20763, "Lord of the Plains", 0, "", 0, "LineageMonster.zenta_lizardman_matriarch", 20, 40, 40, "male", "L2Monster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 4644, 300, 176.36077, 156.55035, 120.43155, 104.23299, 253, 8, 333, 221, 0, 0, 53, 174, 0, 1), 
(20764, 20764, "Shaman of the Plains", 0, "", 0, "LineageMonster.zenta_lizardman_shaman", 13, 35, 39, "male", "L2Monster", 40, 925.85879, 463.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 4150, 264, 166.06476, 152.46752, 113.4007, 101.5146, 253, 1, 333, 179, 0, 0, 43, 174, 0, 1), 
(20765, 20765, "Warrior of the Plains", 0, "", 0, "LineageMonster.zenta_lizardman_warrior", 13, 35, 38, "male", "L2Monster", 40, 886.09975, 447.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 3591, 224, 156.22273, 148.44287, 106.67987, 98.83494, 253, 4, 333, 16, 0, 0, 40, 174, 0, 1), 
(20766, 20766, "Scout of the Plains", 0, "", 0, "LineageMonster.zenta_lizardman_scout", 11, 30, 36, "male", "L2Monster", 1100, 809.52639, 417.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 3192, 193, 137.86467, 140.57278, 94.1437, 93.59494, 253, 8, 333, 14, 0, 0, 37, 174, 0, 1), 
(20767, 20767, "Timak Orc Troop Leader", 0, "", 0, "LineageMonster.batur_orc_overlord", 12, 24, 45, "male", "L2Monster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 5762, 401, 234.89829, 177.78746, 160.40508, 118.3729, 253, 4, 333, 79, 0, 0, 80, 174, 0, 1), 
(20768, 20768, "Timak Orc Troop Shaman", 0, "", 0, "LineageMonster.batur_orc_shaman", 11, 16, 44, "male", "L2Monster", 40, 1138.62924, 584, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 5559, 380, 222.23112, 173.43552, 151.75505, 115.47533, 253, 1, 333, 7, 0, 0, 50, 174, 0, 1), 
(20769, 20769, "Timak Orc Troop Warrior", 0, "", 0, "LineageMonster.batur_orc_warrior", 10, 20, 43, "male", "L2Monster", 40, 1094.28943, 557.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4421, 299, 210.04832, 169.13417, 143.43577, 112.61144, 253, 4, 333, 123, 19, 0, 80, 174, 0, 1), 
(20770, 20770, "Timak Orc Troop Archer", 0, "", 0, "LineageMonster.batur_orc_archer", 11, 21.5, 41, "male", "L2Monster", 1100, 1008.23781, 504.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 5183, 340, 187.11878, 160.69002, 127.77787, 106.98923, 253, 8, 333, 13, 0, 0, 45, 174, 0, 1), 
(20771, 20771, "Barif", 0, "", 0, "LineageMonster.lesser_giant_mage", 21, 44, 64, "male", "L2Monster", 40, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 15637, 1432, 562.02275, 267.04468, 383.78868, 177.80136, 253, 1, 333, 3938, 0, 0, 15, 180, 0, 1), 
(20772, 20772, "Barif's Pet", 0, "", 0, "LineageMonster.leogul", 15, 35, 61, "male", "L2Monster", 40, 1985.55926, 1066.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 15199, 1338, 501.08068, 252.49346, 342.17315, 168.113, 253, 1, 333, 0, 0, 0, 80, 170, 0, 1), 
(20773, 20773, "Conjurer Bat Lord", 0, "", 0, "LineageMonster.vampire_bat", 10, 33.5, 72, "male", "L2Monster", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 12643, 1284, 731.52506, 305.35947, 499.53679, 203.31178, 253, 4, 333, 0, 0, 0, 60, 174, 0, 1), 
(20774, 20774, "Conjurer Bat", 0, "", 0, "LineageMonster.vampire_bat", 10, 33.5, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 13368, 1326, 688.86373, 295.91597, 470.40463, 197.0242, 253, 4, 333, 0, 0, 0, 60, 174, 0, 1), 
(20775, 20775, "Bugbear Raider", 0, "", 0, "LineageMonster.bugbear", 17, 35, 17, "male", "L2Monster", 40, 282.57403, 166.08, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 600, 25, 34.8979, 78.68469, 23.83074, 52.38915, 253, 4, 333, 0, 0, 0, 55, 130, 1, 1), 
(20776, 20776, "Dark Succubus", 0, "", 0, "LineageMonster.succubus", 10, 36, 20, "female", "L2Monster", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 784, 35, 44.32863, 86.87049, 30.2707, 57.83936, 253, 4, 333, 0, 0, 0, 60, 100, 1, 1), 
(20777, 20777, "Hunter Bear", 0, "", 0, "LineageMonster.grizzly", 21, 40, 14, "male", "L2Monster", 40, 230.38548, 140.88, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 499, 19, 27.24646, 71.08179, 18.6058, 47.32706, 253, 4, 333, 0, 0, 0, 40, 110, 1, 1), 
(20778, 20778, "Ragna Orc Overlord", 0, "", 0, "LineageMonster.orc_champion", 10, 23, 39, "male", "L2Monster", 40, 925.85879, 463.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2973, 188, 166.06476, 152.46752, 113.4007, 101.5146, 253, 4, 333, 2, 0, 0, 45, 174, 0, 1), 
(20779, 20779, "Ragna Orc Seer", 0, "", 0, "LineageMonster.orc_shaman", 9, 22, 39, "male", "L2Monster", 40, 925.85879, 463.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2655, 169, 166.06476, 152.46752, 113.4007, 101.5146, 253, 1, 333, 7, 0, 0, 45, 174, 0, 1), 
(20780, 20780, "Bloody Axe Elite", 0, "", 0, "LineageMonster.ol_mahum_champion", 14, 27, 35, "male", "L2Monster", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2159, 127, 129.32896, 136.72948, 88.31491, 91.03603, 253, 4, 333, 2, 0, 0, 50, 174, 1, 1), 
(20781, 20781, "Delu Lizardman Shaman", 0, "", 0, "LineageMonster.virud_lizardman_shaman", 10, 29, 35, "male", "L2Monster", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2138, 126, 129.32896, 136.72948, 88.31491, 91.03603, 253, 1, 333, 7, 0, 0, 43, 174, 1, 1), 
(20782, 20782, "Ol Mahum Novice", 0, "", 0, "LineageMonster.ol_mahum", 13.5, 25, 17, "male", "L2Monster", 40, 282.57403, 166.08, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 618, 26, 34.8979, 78.68469, 23.83074, 52.38915, 253, 4, 333, 1, 0, 0, 50, 110, 1, 1), 
(20783, 20783, "Dread Wolf", 0, "", 0, "LineageMonster.dire_wolf", 13, 11, 35, "male", "L2Monster", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 981, 58, 129.32896, 136.72948, 88.31491, 91.03603, 253, 4, 333, 0, 0, 0, 24, 140, 1, 1), 
(20784, 20784, "Tasaba Lizardman", 0, "", 0, "LineageMonster.virud_lizardman_scout", 10, 22, 36, "male", "L2Monster", 1100, 809.52639, 417.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1111, 67, 137.86467, 140.57278, 94.1437, 93.59494, 253, 8, 333, 2507, 0, 0, 43, 140, 1, 1), 
(20785, 20785, "Tasaba Lizardman Shaman", 0, "", 0, "LineageMonster.virud_lizardman_shaman", 10, 29, 37, "male", "L2Monster", 40, 847.31754, 432.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1075, 66, 146.82587, 144.47758, 100.26304, 96.19481, 253, 1, 333, 7, 0, 0, 43, 140, 1, 1), 
(20786, 20786, "Lienrik", 0, "", 0, "LineageMonster.lienrik", 12, 50, 39, "male", "L2Monster", 40, 925.85879, 463.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1195, 76, 166.06476, 152.46752, 113.4007, 101.5146, 253, 8, 333, 0, 0, 0, 100, 150, 1, 1), 
(20787, 20787, "Lienrik Lad", 0, "", 0, "LineageMonster.lienrik", 12, 50, 40, "male", "L2Monster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1453, 94, 176.36077, 156.55035, 120.43155, 104.23299, 253, 8, 333, 0, 0, 0, 100, 174, 1, 1), 
(20788, 20788, "Rakul", 0, "", 0, "LineageMonster.rakul", 30, 39, 35, "male", "L2Monster", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2544, 150, 129.32896, 136.72948, 88.31491, 91.03603, 253, 4, 333, 3, 0, 0, 60, 174, 1, 1), 
(20789, 20789, "Crokian", 0, "", 0, "LineageMonster.crokian", 18, 29, 36, "male", "L2Monster", 40, 809.52639, 417.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2399, 145, 137.86467, 140.57278, 94.1437, 93.59494, 253, 4, 333, 5128, 0, 0, 18, 174, 1, 1), 
(20790, 20790, "Dailaon", 0, "", 0, "LineageMonster.dailaon", 20, 28, 37, "male", "L2Monster", 1100, 847.31754, 432.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 3081, 190, 146.82587, 144.47758, 100.26304, 96.19481, 253, 8, 333, 5127, 0, 0, 18, 174, 1, 1), 
(20791, 20791, "Crokian Warrior", 0, "", 0, "LineageMonster.crokian", 18, 29, 38, "male", "L2Monster", 40, 886.09975, 447.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 5307, 331, 156.22273, 148.44287, 106.67987, 98.83494, 253, 4, 333, 5128, 0, 0, 18, 174, 1, 1), 
(20792, 20792, "Farhite", 0, "", 0, "LineageMonster.farhite", 16, 31, 39, "male", "L2Monster", 40, 925.85879, 463.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 4938, 314, 166.06476, 152.46752, 113.4007, 101.5146, 253, 1, 333, 5131, 0, 0, 15, 174, 1, 1), 
(20793, 20793, "Nos", 0, "", 0, "LineageMonster.nos", 26, 42, 40, "male", "L2Monster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 5404, 349, 176.36077, 156.55035, 120.43155, 104.23299, 253, 4, 333, 5130, 0, 0, 18, 174, 1, 1), 
(20794, 20794, "Blade Stakato", 0, "", 0, "LineageMonster.blade_stakato", 15, 36, 41, "male", "L2Monster", 40, 1008.23781, 504.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 5048, 330, 187.11878, 160.69002, 127.77787, 106.98923, 253, 4, 333, 223, 0, 0, 25, 174, 0, 1), 
(20795, 20795, "Blade Stakato Worker", 0, "", 0, "LineageMonster.blade_stakato_worker", 13, 40, 42, "male", "L2Monster", 40, 1050.81652, 531, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4772, 318, 198.34591, 164.88513, 135.44454, 109.78238, 253, 8, 333, 226, 0, 0, 25, 174, 0, 1), 
(20796, 20796, "Blade Stakato Warrior", 0, "", 0, "LineageMonster.blade_stakato_soldier", 15, 38, 43, "male", "L2Monster", 40, 1094.28943, 557.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 5102, 344, 210.04832, 169.13417, 143.43577, 112.61144, 253, 1, 333, 232, 0, 0, 25, 174, 0, 1), 
(20797, 20797, "Blade Stakato Drone", 0, "", 0, "LineageMonster.blade_stakato_drone", 15, 39, 44, "male", "L2Monster", 40, 1138.62924, 584, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 7754, 530, 222.23112, 173.43552, 151.75505, 115.47533, 253, 4, 333, 74, 0, 0, 25, 174, 0, 1), 
(20798, 20798, "Water Giant", 0, "", 0, "LineageMonster.water_giant", 13, 44, 45, "male", "L2Monster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 6270, 436, 234.89829, 177.78746, 160.40508, 118.3729, 253, 4, 333, 5132, 0, 0, 35, 174, 0, 1), 
(20799, 20799, "Queen Undine Lad", 0, "", 0, "LineageMonster.undine", 12, 27, 46, "female", "L2Monster", 40, 1229.78678, 637.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 6312, 448, 248.0526, 182.18816, 169.38777, 121.30293, 253, 4, 333, 0, 0, 0, 60, 174, 0, 1), 
(20800, 20800, "Eva's Seeker", 0, "", 0, "LineageMonster.field_stalker", 15, 30, 47, "male", "L2Monster", 40, 1276.53628, 665, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 5917, 424, 261.69549, 186.63569, 178.7041, 124.26415, 253, 4, 333, 0, 0, 0, 70, 174, 0, 1), 
(20801, 20801, "Theeder Piker", 0, "", 0, "LineageMonster.theeder", 9, 32, 48, "male", "L2Monster", 80, 1324.01623, 692.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 7134, 521, 275.82705, 191.12803, 188.35412, 127.2552, 253, 4, 333, 302, 0, 0, 80, 174, 0, 1), 
(20802, 20802, "Theeder Mage", 0, "", 0, "LineageMonster.theeder", 9, 32, 49, "male", "L2Monster", 40, 1372.18568, 720, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 7262, 536, 290.44588, 195.66302, 198.33688, 130.27465, 253, 1, 333, 192, 0, 0, 80, 174, 0, 1), 
(20803, 20803, "Doll Master", 0, "", 0, "LineageMonster.doll_master", 20, 42, 50, "male", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 14218, 1072, 305.54906, 200.23844, 208.6504, 133.32101, 253, 4, 333, 0, 0, 0, 80, 174, 0, 1), 
(20804, 20804, "Crokian Lad", 0, "", 0, "LineageMonster.crokian_100_bi", 36, 61, 41, "male", "L2Monster", 40, 1008.23781, 504.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 6178, 404, 187.11878, 160.69002, 127.77787, 106.98923, 253, 4, 333, 5128, 0, 0, 18, 174, 0, 1), 
(20805, 20805, "Dailaon Lad", 0, "", 0, "LineageMonster.dailaon_100_bi", 40, 58, 42, "male", "L2Monster", 1100, 1050.81652, 531, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 6697, 446, 198.34591, 164.88513, 135.44454, 109.78238, 253, 8, 333, 5127, 0, 0, 18, 174, 0, 1), 
(20806, 20806, "Crokian Lad Warrior", 0, "", 0, "LineageMonster.crokian_100_bi", 36, 61, 43, "male", "L2Monster", 40, 1094.28943, 557.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 6428, 434, 210.04832, 169.13417, 143.43577, 112.61144, 253, 4, 333, 5128, 0, 0, 18, 174, 0, 1), 
(20807, 20807, "Farhite Lad", 0, "", 0, "LineageMonster.farhite_50_bi", 24, 48, 44, "male", "L2Monster", 40, 1138.62924, 584, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 6761, 463, 222.23112, 173.43552, 151.75505, 115.47533, 253, 1, 333, 5131, 0, 0, 15, 174, 0, 1), 
(20808, 20808, "Nos Lad", 0, "", 0, "LineageMonster.nos_100_bi", 52, 86, 45, "male", "L2Monster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 8371, 582, 234.89829, 177.78746, 160.40508, 118.3729, 253, 4, 333, 128, 0, 0, 18, 174, 0, 1), 
(20809, 20809, "Ghost of the Tower", 0, "", 0, "LineageMonster.human_ghost", 8, 22, 60, "male", "L2Monster", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 14562, 1264, 481.34551, 247.65008, 328.69659, 164.88822, 253, 1, 333, 0, 0, 0, 80, 143, 0, 1), 
(20810, 20810, "Seer of Hallate", 0, "", 0, "LineageMonster.field_stalker", 15, 30, 60, "male", "L2Monster", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 14562, 1264, 481.34551, 247.65008, 328.69659, 164.88822, 253, 1, 333, 0, 0, 0, 70, 170, 0, 1), 
(20811, 20811, "Ghastly Warrior", 0, "", 0, "LineageMonster.unpleasant_humming", 12, 26, 61, "male", "L2Monster", 40, 1985.55926, 1066.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 17170, 1511, 501.08068, 252.49346, 342.17315, 168.113, 253, 8, 333, 0, 0, 0, 21, 150, 0, 1), 
(20812, 20812, "Archer of Despair", 0, "", 0, "LineageMonster.skeleton_archer", 11, 27, 61, "male", "L2Monster", 1100, 1985.55926, 1066.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 16950, 1492, 501.08068, 252.49346, 342.17315, 168.113, 253, 8, 333, 284, 0, 0, 40, 160, 0, 1), 
(20813, 20813, "Crendion", 0, "", 0, "LineageMonster.liviona", 15, 28, 62, "male", "L2Monster", 40, 2037.81082, 1097, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 15397, 1372, 521.12391, 257.34267, 355.86007, 171.34165, 253, 4, 333, 0, 0, 0, 80, 160, 0, 1), 
(20814, 20814, "Blader of Despair", 0, "", 0, "LineageMonster.spartoi", 11, 27, 62, "male", "L2Monster", 80, 2037.81082, 1097, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 17778, 1584, 521.12391, 257.34267, 355.86007, 171.34165, 253, 4, 333, 79, 0, 0, 60, 143, 0, 1), 
(20815, 20815, "Hound Dog of Hallate", 0, "", 0, "LineageMonster.dire_wolf", 13, 11, 63, "male", "L2Monster", 40, 2089.92274, 1127.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 22001, 1986, 541.44774, 262.19426, 369.73862, 174.5719, 253, 1, 333, 0, 0, 0, 24, 165, 0, 1), 
(20816, 20816, "Hallate's Royal Guard", 0, "", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 63, "male", "L2Monster", 40, 2089.92274, 1127.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 18356, 1657, 541.44774, 262.19426, 369.73862, 174.5719, 253, 8, 333, 946, 945, 0, 80, 164, 0, 1), 
(20817, 20817, "Corrupt Sage", 0, "", 0, "LineageMonster.vale_master", 12, 40, 64, "male", "L2Monster", 40, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 19137, 1752, 562.02275, 267.04468, 383.78868, 177.80136, 253, 1, 333, 210, 0, 0, 70, 160, 0, 1), 
(20818, 20818, "Hallate's Warrior", 0, "", 0, "LineageMonster.skeleton_knight", 10, 25, 64, "male", "L2Monster", 40, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 17735, 1624, 562.02275, 267.04468, 383.78868, 177.80136, 253, 4, 333, 78, 0, 0, 40, 160, 0, 1), 
(20819, 20819, "Archer of Abyss", 0, "", 0, "LineageMonster.fiend_archer", 17, 55, 65, "male", "L2Monster", 1100, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 17603, 1636, 582.81759, 271.89033, 397.98887, 181.02764, 253, 8, 333, 0, 0, 0, 70, 165, 0, 1), 
(20820, 20820, "Hallate's Knight", 0, "", 0, "LineageMonster.death_knight", 12, 31, 65, "male", "L2Monster", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 35090, 3260, 582.81759, 271.89033, 397.98887, 181.02764, 253, 4, 333, 80, 0, 0, 27, 160, 0, 1), 
(20821, 20821, "Erin Ediunce", 0, "", 0, "LineageMonster.banshee", 9, 23, 66, "female", "L2Monster", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 25609, 2411, 603.79903, 276.72752, 412.31647, 184.2483, 253, 1, 333, 3939, 0, 0, 80, 165, 0, 1), 
(20822, 20822, "Hallate's Maid", 0, "", 0, "LineageMonster.bloody_queen", 14, 40, 66, "female", "L2Monster", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 23832, 2243, 603.79903, 276.72752, 412.31647, 184.2483, 253, 8, 333, 0, 0, 0, 80, 160, 0, 1), 
(20823, 20823, "Platinum Tribe Soldier", 0, "", 0, "LineageMonster.kel_mahum", 13, 26, 67, "male", "L2Monster", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 27669, 2635, 624.93199, 281.55251, 426.74754, 187.46084, 253, 8, 333, 242, 0, 0, 50, 160, 0, 1), 
(20824, 20824, "Hallate's Commander", 0, "", 0, "LineageMonster.death_blader", 15, 45, 67, "male", "L2Monster", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 24884, 2370, 624.93199, 281.55251, 426.74754, 187.46084, 253, 1, 333, 1472, 0, 0, 100, 170, 0, 1), 
(20825, 20825, "Hallate's Inspector", 0, "", 0, "LineageMonster.karik_25_bi", 31, 110, 68, "male", "L2Monster", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 25991, 2510, 646.17968, 286.3615, 441.25696, 190.66272, 253, 1, 333, 0, 0, 0, 37, 170, 0, 1), 
(20826, 20826, "Platinum Tribe Archer", 0, "", 0, "LineageMonster.kel_mahum_archer", 13, 27, 68, "male", "L2Monster", 1100, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 27541, 2660, 646.17968, 286.3615, 441.25696, 190.66272, 253, 8, 333, 288, 0, 0, 50, 160, 0, 1), 
(20827, 20827, "Platinum Tribe Warrior", 0, "", 0, "LineageMonster.kel_mahum_warrior", 13, 28, 69, "male", "L2Monster", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 28758, 2814, 667.50361, 291.15063, 455.81844, 193.85137, 253, 4, 333, 148, 0, 0, 50, 160, 0, 1), 
(20828, 20828, "Platinum Tribe Shaman", 0, "", 0, "LineageMonster.kel_mahum_witch_doctor", 13, 25, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 35291, 3499, 688.86373, 295.91597, 470.40463, 197.0242, 253, 1, 333, 202, 0, 0, 50, 160, 0, 1), 
(20829, 20829, "Platinum Tribe Overlord", 0, "", 0, "LineageMonster.kel_mahum_champion", 13, 32, 71, "male", "L2Monster", 40, 2492.727, 1377.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 50697, 5087, 710.2185, 300.65359, 484.98717, 200.17855, 253, 4, 333, 147, 0, 0, 50, 170, 0, 1), 
(20830, 20830, "Guardian Angel", 0, "", 0, "LineageMonster.angel", 13.5, 36.5, 72, "male", "L2Monster", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 731.52506, 305.35947, 499.53679, 203.31178, 253, 4, 333, 148, 0, 0, 30, 170, 0, 1), 
(20831, 20831, "Seal Angel", 0, "", 0, "LineageMonster.angel", 13.5, 36.5, 73, "male", "L2Monster", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 752.73928, 310.02959, 514.02335, 206.4212, 253, 4, 333, 148, 0, 0, 30, 170, 0, 1), 
(20832, 20832, "Zaken's Pikeman", 0, "", 0, "LineageMonster.skeleton_pikeman", 10, 28, 43, "male", "L2Monster", 40, 1094.28943, 557.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3264, 221, 210.04832, 169.13417, 143.43577, 112.61144, 253, 4, 333, 292, 0, 0, 50, 174, 0, 1), 
(20833, 20833, "Zaken's Archer", 0, "", 0, "LineageMonster.skeleton_archer", 11, 27, 44, "male", "L2Monster", 1100, 1138.62924, 584, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3631, 248, 222.23112, 173.43552, 151.75505, 115.47533, 253, 8, 333, 279, 0, 0, 40, 174, 0, 1), 
(20834, 20834, "Mardian", 0, "", 0, "LineageMonster.giant_spider", 26, 25.5, 42, "male", "L2Monster", 40, 1050.81652, 531, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 5403, 360, 198.34591, 164.88513, 135.44454, 109.78238, 253, 4, 333, 0, 0, 0, 72, 174, 0, 1), 
(20835, 20835, "Zaken's Seer", 0, "", 0, "LineageMonster.liviona", 15, 28, 45, "male", "L2Monster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 2974, 206, 234.89829, 177.78746, 160.40508, 118.3729, 253, 1, 333, 0, 0, 0, 80, 174, 0, 1), 
(20836, 20836, "Pirate Zombie", 0, "", 0, "LineageMonster.pirates_zombie", 10, 23, 44, "male", "L2Monster", 40, 1138.62924, 584, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 6799, 466, 222.23112, 173.43552, 151.75505, 115.47533, 253, 8, 333, 225, 0, 0, 11, 174, 0, 1), 
(20837, 20837, "Tainted Ogre", 0, "", 0, "LineageMonster.ogre", 21, 44, 45, "male", "L2Monster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 6158, 428, 234.89829, 177.78746, 160.40508, 118.3729, 253, 1, 333, 194, 0, 0, 22, 174, 0, 1), 
(20838, 20838, "Bloody Bat", 0, "", 0, "LineageMonster.vampire_bat", 10, 33.5, 45, "male", "L2Monster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 5773, 402, 234.89829, 177.78746, 160.40508, 118.3729, 253, 8, 333, 0, 0, 0, 60, 174, 0, 1), 
(20839, 20839, "Unpleasant Humming", 0, "", 0, "LineageMonster.unpleasant_humming", 12, 26, 46, "male", "L2Monster", 40, 1229.78678, 637.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3453, 245, 248.0526, 182.18816, 169.38777, 121.30293, 253, 4, 333, 0, 0, 0, 21, 174, 0, 1), 
(20840, 20840, "Death Flyer", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 47, "male", "L2Monster", 40, 1276.53628, 665, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3566, 256, 261.69549, 186.63569, 178.7041, 124.26415, 253, 1, 333, 0, 0, 0, 100, 174, 0, 1), 
(20841, 20841, "Fiend Archer", 0, "", 0, "LineageMonster.fiend_archer", 17, 55, 48, "male", "L2Monster", 1100, 1324.01623, 692.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3663, 268, 275.82705, 191.12803, 188.35412, 127.2552, 253, 8, 333, 0, 0, 0, 70, 174, 0, 1), 
(20842, 20842, "Musveren", 0, "", 0, "LineageMonster.field_stalker", 15, 30, 49, "male", "L2Monster", 40, 1372.18568, 720, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3492, 258, 290.44588, 195.66302, 198.33688, 130.27465, 253, 4, 333, 0, 0, 0, 70, 174, 0, 1), 
(20843, 20843, "Zaken's Royal Guard", 0, "", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 50, "male", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4413, 332, 305.54906, 200.23844, 208.6504, 133.32101, 253, 8, 333, 225, 945, 0, 80, 174, 0, 1), 
(20844, 20844, "Kaim Vanul", 0, "", 0, "LineageMonster.kaim_vanul", 24, 40, 51, "male", "L2Monster", 40, 1470.41596, 775.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 3936, 300, 321.13207, 204.85194, 219.29157, 136.39273, 253, 4, 333, 0, 0, 0, 37, 174, 0, 1), 
(20845, 20845, "Pirate's Zombie Captain", 0, "", 0, "LineageMonster.pirates_zombie_captain", 17, 28, 52, "male", "L2Monster", 40, 1520.38155, 804, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 5945, 460, 337.18867, 209.50106, 230.25615, 139.48817, 253, 8, 333, 232, 0, 0, 14, 174, 0, 1), 
(20846, 20846, "Doll Blader", 0, "", 0, "LineageMonster.doll_blader", 6, 12, 53, "male", "L2Monster", 40, 1570.8463, 832.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 4718, 371, 353.71092, 214.18326, 241.5387, 142.60563, 253, 8, 333, 5129, 5129, 0, 22, 174, 0, 1), 
(20847, 20847, "Vale Master", 0, "", 0, "LineageMonster.vale_master", 12, 40, 54, "male", "L2Monster", 40, 1621.75618, 861, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 4501, 359, 370.68904, 218.89589, 253.13256, 145.74335, 253, 4, 333, 0, 0, 0, 70, 174, 0, 1), 
(20848, 20848, "Light Bringer", 0, "", 0, "LineageMonster.light_bringer", 10, 23, 46, "male", "L2Monster", 40, 1229.78678, 637.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 5839, 414, 248.0526, 182.18816, 169.38777, 121.30293, 253, 4, 333, 0, 0, 0, 60, 174, 0, 1), 
(20849, 20849, "Light Worm", 0, "", 0, "LineageMonster.light_worm", 5, 16, 41, "male", "L2Monster", 40, 1008.23781, 504.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4638, 304, 187.11878, 160.69002, 127.77787, 106.98923, 253, 4, 333, 0, 0, 0, 60, 174, 0, 1), 
(20850, 20850, "Golden Stag Lord", 0, "", 0, "LineageMonster.golden_stag_lord", 25, 30, 50, "male", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3783, 284, 305.54906, 200.23844, 208.6504, 133.32101, 253, 4, 333, 0, 0, 0, 35, 174, 0, 1), 
(20851, 20851, "Theeder", 0, "", 0, "LineageMonster.theeder", 9, 32, 47, "male", "L2Monster", 40, 1276.53628, 665, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3409, 245, 261.69549, 186.63569, 178.7041, 124.26415, 253, 1, 333, 0, 0, 0, 80, 174, 0, 1), 
(20852, 20852, "Banshee", 0, "", 0, "LineageMonster.banshee", 9, 23, 60, "female", "L2Monster", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 5341, 463, 481.34551, 247.65008, 328.69659, 164.88822, 253, 8, 333, 3939, 0, 0, 80, 174, 0, 1), 
(20853, 20853, "Kel Mahum", 0, "", 0, "LineageMonster.kel_mahum", 13, 26, 65, "male", "L2Monster", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9389, 872, 582.81759, 271.89033, 397.98887, 181.02764, 253, 8, 333, 242, 0, 0, 50, 174, 0, 1), 
(20854, 20854, "Kel Mahum Warrior", 0, "", 0, "LineageMonster.kel_mahum_warrior", 13, 28, 66, "male", "L2Monster", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9224, 868, 603.79903, 276.72752, 412.31647, 184.2483, 253, 4, 333, 148, 0, 0, 50, 174, 0, 1), 
(20855, 20855, "Kel Mahum Archer", 0, "", 0, "LineageMonster.kel_mahum_archer", 13, 27, 67, "male", "L2Monster", 1100, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 10680, 1018, 624.93199, 281.55251, 426.74754, 187.46084, 253, 8, 333, 288, 0, 0, 50, 174, 0, 1), 
(20856, 20856, "Kel Mahum Shaman", 0, "", 0, "LineageMonster.kel_mahum_witch_doctor", 13, 25, 68, "male", "L2Monster", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 7669, 740, 646.17968, 286.3615, 441.25696, 190.66272, 253, 1, 333, 202, 0, 0, 50, 174, 0, 1), 
(20857, 20857, "Kel Mahum Champion", 0, "", 0, "LineageMonster.kel_mahum_champion", 13, 32, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9780, 970, 688.86373, 295.91597, 470.40463, 197.0242, 253, 4, 333, 147, 0, 0, 50, 174, 0, 1), 
(20858, 20858, "Angel", 0, "", 0, "LineageMonster.angel", 13.5, 36.5, 72, "male", "L2Monster", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 10923, 1110, 731.52506, 305.35947, 499.53679, 203.31178, 253, 4, 333, 148, 0, 0, 30, 174, 0, 1), 
(20859, 20859, "Guardian Angel", 0, "", 0, "LineageMonster.angel", 13.5, 36.5, 72, "male", "L2Monster", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 59729, 6068, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 148, 0, 0, 30, 170, 0, 1), 
(20860, 20860, "Seal Angel", 0, "", 0, "LineageMonster.angel", 13.5, 36.5, 73, "male", "L2Monster", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 83696, 8612, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 148, 0, 0, 30, 170, 0, 1), 
(20861, 20861, "Oel Mahum Champion", 0, "", 0, "LineageMonster.oel_mahum_champion", 23, 61, 56, "male", "L2Monster", 40, 1724.6831, 918.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 6641, 545, 405.96455, 228.40135, 277.22116, 152.0722, 253, 4, 333, 127, 0, 0, 67, 174, 0, 1), 
(20862, 20862, "Death Lord", 0, "", 0, "LineageMonster.death_lord", 21, 40, 75, "male", "L2Monster", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 9330, 984, 794.70901, 319.24623, 542.68324, 212.55774, 253, 4, 333, 78, 0, 0, 40, 174, 0, 1), 
(20919, 20919, "Maille Lizardman", 0, "", 0, "LineageMonster.virud_lizardman", 10, 23, 20, "male", "L2Monster", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 321, 14, 44.32863, 86.87049, 30.2707, 57.83936, 253, 1, 333, 291, 0, 0, 43, 130, 1, 1), 
(20920, 20920, "Maille Lizardman Scout", 0, "", 0, "LineageMonster.virud_lizardman_scout", 10, 22, 22, "male", "L2Monster", 1100, 387.02878, 218.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 713, 34, 51.75278, 92.65694, 35.34044, 61.69203, 253, 8, 333, 2507, 0, 0, 43, 130, 1, 1), 
(20921, 20921, "Maille Lizardman Guard", 0, "", 0, "LineageMonster.virud_lizardman", 10, 23, 24, "male", "L2Monster", 40, 435.34437, 245.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 515, 25, 60.19687, 98.70919, 41.10666, 65.72169, 253, 1, 333, 291, 0, 0, 43, 130, 1, 1), 
(20922, 20922, "Maille Lizardman Warrior", 0, "", 0, "LineageMonster.virud_lizardman_warrior", 12, 30, 26, "male", "L2Monster", 40, 487.5704, 273, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 571, 29, 69.75926, 105.02818, 47.63653, 69.92894, 253, 1, 333, 16, 0, 0, 52, 130, 1, 1), 
(20923, 20923, "Maille Lizardman Shaman", 0, "", 0, "LineageMonster.virud_lizardman_shaman", 10, 29, 28, "male", "L2Monster", 40, 543.79576, 300.96, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 836, 44, 80.54056, 111.61368, 54.99876, 74.31365, 253, 1, 333, 7, 0, 0, 43, 120, 1, 1), 
(20924, 20924, "Maille Lizardman Matriarch", 0, "", 0, "LineageMonster.virud_lizardman_matriarch", 13, 37, 30, "male", "L2Monster", 40, 604.08419, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1025, 56, 92.64226, 118.46427, 63.26266, 78.87485, 253, 1, 333, 69, 627, 0, 56, 130, 1, 1), 
(20925, 20925, "Giant Araneid", 0, "", 0, "LineageMonster.giant_spider", 26, 25.5, 24, "male", "L2Monster", 40, 435.34437, 245.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 525, 26, 60.19687, 98.70919, 41.10666, 65.72169, 253, 1, 333, 0, 0, 0, 72, 130, 1, 1), 
(20926, 20926, "Poison Araneid", 0, "", 0, "LineageMonster.poison_spider", 27, 25.5, 25, "male", "L2Monster", 40, 460.96247, 259.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 607, 30, 64.83203, 101.83533, 44.27187, 67.80312, 253, 1, 333, 0, 0, 0, 60, 140, 1, 1), 
(20927, 20927, "King of the Araneid", 0, "", 0, "LineageMonster.giant_spider_50_bi", 39, 38, 27, "male", "L2Monster", 40, 515.17856, 286.92, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 872, 44, 74.99121, 108.28767, 51.20928, 72.09915, 253, 1, 333, 0, 0, 0, 72, 130, 1, 1), 
(20928, 20928, "Hatu Weird Bee", 0, "", 0, "LineageMonster.giant_bee", 8, 24.5, 30, "male", "L2Monster", 40, 604.08419, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 881, 48, 92.64226, 118.46427, 63.26266, 78.87485, 253, 1, 333, 0, 0, 0, 90, 120, 1, 1), 
(20929, 20929, "Hatu Dire Wolf", 0, "", 0, "LineageMonster.dire_wolf", 13, 11, 32, "male", "L2Monster", 40, 668.47132, 358.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 836, 47, 106.16525, 125.57727, 72.49711, 83.61076, 253, 1, 333, 0, 0, 0, 24, 110, 1, 1), 
(20930, 20930, "Hatu Brown Bear", 0, "", 0, "LineageMonster.grizzly", 21, 40, 34, "male", "L2Monster", 40, 736.96177, 387.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1317, 77, 121.20802, 132.9486, 82.76936, 88.51867, 253, 1, 333, 0, 0, 0, 40, 143, 1, 1), 
(20931, 20931, "Hatu Onyx Beast", 0, "", 0, "LineageMonster.onyx_beast", 14, 14.5, 36, "male", "L2Monster", 40, 809.52639, 417.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1221, 74, 137.86467, 140.57278, 94.1437, 93.59494, 253, 1, 333, 0, 0, 0, 30, 174, 1, 1), 
(20932, 20932, "Hatu Crimson Bear", 0, "", 0, "LineageMonster.crimson_bear", 19, 36, 38, "male", "L2Monster", 40, 886.09975, 447.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1613, 101, 156.22273, 148.44287, 106.67987, 98.83494, 253, 1, 333, 0, 0, 0, 37, 174, 1, 1), 
(20933, 20933, "Hatu Windsus", 0, "", 0, "LineageMonster.giant_wild_hog", 35, 27, 40, "male", "L2Monster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1849, 119, 176.36077, 156.55035, 120.43155, 104.23299, 253, 1, 333, 0, 0, 0, 35, 174, 1, 1), 
(20934, 20934, "Wasp Worker", 0, "", 0, "LineageMonster.giant_bee_bi", 8, 32, 35, "male", "L2Monster", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 991, 59, 129.32896, 136.72948, 88.31491, 91.03603, 253, 1, 333, 0, 0, 0, 90, 174, 1, 1), 
(20935, 20935, "Wasp Leader", 0, "", 0, "LineageMonster.giant_bee_100_bi", 16, 49, 37, "male", "L2Monster", 40, 847.31754, 432.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1086, 67, 146.82587, 144.47758, 100.26304, 96.19481, 253, 1, 333, 0, 0, 0, 90, 174, 1, 1), 
(20936, 20936, "Tanor Silenos", 0, "", 0, "LineageMonster.heltor_silenos", 13, 29, 40, "male", "L2Monster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2066, 133, 176.36077, 156.55035, 120.43155, 104.23299, 253, 1, 333, 88, 0, 0, 34, 174, 0, 1), 
(20937, 20937, "Tanor Silenos Grunt", 0, "", 0, "LineageMonster.heltor_silenos", 13, 29, 42, "male", "L2Monster", 40, 1050.81652, 531, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 2699, 180, 198.34591, 164.88513, 135.44454, 109.78238, 253, 1, 333, 158, 18, 0, 34, 174, 0, 1), 
(20938, 20938, "Tanor Silenos Scout", 0, "", 0, "LineageMonster.heltor_silenos", 13, 29, 44, "male", "L2Monster", 40, 1138.62924, 584, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 2963, 203, 222.23112, 173.43552, 151.75505, 115.47533, 253, 1, 333, 5, 0, 0, 34, 174, 0, 1), 
(20939, 20939, "Tanor Silenos Warrior", 0, "", 0, "LineageMonster.heltor_silenos_warrior", 13, 31, 46, "male", "L2Monster", 40, 1229.78678, 637.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3303, 234, 248.0526, 182.18816, 169.38777, 121.30293, 253, 1, 333, 160, 0, 0, 36, 174, 0, 1), 
(20940, 20940, "Tanor Silenos Shaman", 0, "", 0, "LineageMonster.heltor_silenos_shaman", 13, 32, 48, "male", "L2Monster", 40, 1324.01623, 692.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4024, 294, 275.82705, 191.12803, 188.35412, 127.2552, 253, 1, 333, 9, 0, 0, 29, 174, 0, 1), 
(20941, 20941, "Tanor Silenos Chieftain", 0, "", 0, "LineageMonster.heltor_silenos_chieftain", 13, 31.5, 50, "male", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3902, 294, 305.54906, 200.23844, 208.6504, 133.32101, 253, 1, 333, 75, 0, 0, 27, 174, 0, 1), 
(20942, 20942, "Nightmare Guide", 0, "", 0, "LineageMonster.harpy", 10, 42, 43, "female", "L2Monster", 40, 1094.28943, 557.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 1970, 133, 210.04832, 169.13417, 143.43577, 112.61144, 253, 1, 333, 0, 0, 0, 60, 174, 0, 1), 
(20943, 20943, "Nightmare Keeper", 0, "", 0, "LineageMonster.harpy", 10, 42, 45, "female", "L2Monster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 2833, 197, 234.89829, 177.78746, 160.40508, 118.3729, 253, 1, 333, 0, 0, 0, 60, 174, 0, 1), 
(20944, 20944, "Nightmare Lord", 0, "", 0, "LineageMonster.succubus_100_bi", 20, 75, 47, "female", "L2Monster", 40, 1276.53628, 665, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 2400, 172, 261.69549, 186.63569, 178.7041, 124.26415, 253, 1, 333, 0, 0, 0, 60, 174, 0, 1), 
(20945, 20945, "Cadeine", 0, "", 0, "LineageMonster.hobgoblin", 12, 24, 50, "male", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 2690, 203, 305.54906, 200.23844, 208.6504, 133.32101, 253, 1, 333, 127, 625, 0, 45, 174, 0, 1), 
(20946, 20946, "Sanhidro", 0, "", 0, "LineageMonster.troll", 21, 35, 52, "male", "L2Monster", 40, 1520.38155, 804, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 4138, 320, 337.18867, 209.50106, 230.25615, 139.48817, 253, 1, 333, 0, 0, 0, 55, 174, 0, 1), 
(20947, 20947, "Connabi", 0, "", 0, "LineageMonster.bugbear", 17, 35, 54, "male", "L2Monster", 40, 1621.75618, 861, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 4462, 355, 370.68904, 218.89589, 253.13256, 145.74335, 253, 1, 333, 88, 0, 0, 55, 174, 0, 1), 
(20948, 20948, "Bartal", 0, "", 0, "LineageMonster.liviona", 15, 28, 56, "male", "L2Monster", 40, 1724.6831, 918.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 4431, 364, 405.96455, 228.40135, 277.22116, 152.0722, 253, 1, 333, 0, 0, 0, 80, 174, 0, 1), 
(20949, 20949, "Luminun", 0, "", 0, "LineageMonster.twin_headed_giant", 17, 39, 58, "male", "L2Monster", 40, 1828.68266, 977.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 5220, 440, 442.8992, 237.99429, 302.44274, 158.45929, 253, 1, 333, 157, 0, 0, 45, 174, 0, 1), 
(20950, 20950, "Innersen", 0, "", 0, "LineageMonster.king_bugbear", 15, 40, 60, "male", "L2Monster", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 5619, 487, 481.34551, 247.65008, 328.69659, 164.88822, 253, 1, 333, 160, 0, 0, 55, 174, 0, 1), 
(20951, 20951, "Pobby's Maid", 0, "", 0, "LineageMonster.manadragora", 14, 17.8, 53, "female", "L2Monster", 40, 1570.8463, 832.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 3022, 238, 353.71092, 214.18326, 241.5387, 142.60563, 253, 1, 333, 0, 0, 0, 80, 174, 0, 1), 
(20952, 20952, "Pobby Escort", 0, "", 0, "LineageMonster.mandragora_b", 12, 25.5, 55, "female", "L2Monster", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 5461, 440, 388.11142, 223.6362, 265.02979, 148.89951, 253, 1, 333, 0, 0, 0, 80, 174, 0, 1), 
(20953, 20953, "Pobby", 0, "", 0, "LineageMonster.mandragora_a", 15, 26, 57, "female", "L2Monster", 40, 1776.58018, 948, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 5071, 421, 424.23295, 233.18839, 289.69611, 155.25946, 253, 1, 333, 0, 0, 0, 80, 174, 0, 1), 
(20954, 20954, "Hungered Corpse", 0, "", 0, "LineageMonster.skeleton", 11, 25, 60, "male", "L2Monster", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 5991, 520, 481.34551, 247.65008, 328.69659, 164.88822, 253, 1, 333, 123, 945, 0, 60, 180, 0, 1), 
(20955, 20955, "Ghostly Warrior", 0, "", 0, "LineageMonster.skeleton_pikeman", 10, 28, 62, "male", "L2Monster", 40, 2037.81082, 1097, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 6398, 570, 521.12391, 257.34267, 355.86007, 171.34165, 253, 1, 333, 299, 0, 0, 50, 180, 0, 1), 
(20956, 20956, "Past Knight", 0, "", 0, "LineageMonster.skeleton_knight", 10, 25, 64, "male", "L2Monster", 40, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 6953, 636, 562.02275, 267.04468, 383.78868, 177.80136, 253, 1, 333, 150, 103, 0, 40, 174, 0, 1), 
(20957, 20957, "Nihil Invader", 0, "", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 66, "male", "L2Monster", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 7250, 683, 603.79903, 276.72752, 412.31647, 184.2483, 253, 1, 333, 946, 945, 0, 80, 185, 0, 1), 
(20958, 20958, "Death Agent", 0, "", 0, "LineageMonster.death_blader", 15, 45, 68, "male", "L2Monster", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 5411, 523, 646.17968, 286.3615, 441.25696, 190.66272, 253, 1, 333, 1472, 0, 0, 100, 195, 0, 1), 
(20959, 20959, "Dark Guard", 0, "", 0, "LineageMonster.headless_knight", 21, 31, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 8318, 824, 688.86373, 295.91597, 470.40463, 197.0242, 253, 1, 333, 124, 0, 0, 70, 170, 0, 1), 
(20960, 20960, "Bloody Ghost", 0, "", 0, "LineageMonster.succubus", 10, 36, 64, "female", "L2Monster", 40, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 4793, 439, 562.02275, 267.04468, 383.78868, 177.80136, 253, 1, 333, 0, 0, 0, 60, 175, 0, 1), 
(20961, 20961, "Bloody Knight", 0, "", 0, "LineageMonster.doll_blader", 6, 12, 65, "male", "L2Monster", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 7032, 653, 582.81759, 271.89033, 397.98887, 181.02764, 253, 1, 333, 5129, 5129, 0, 22, 175, 0, 1), 
(20962, 20962, "Bloody Priest", 0, "", 0, "LineageMonster.bloody_queen", 14, 40, 66, "female", "L2Monster", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 7827, 737, 603.79903, 276.72752, 412.31647, 184.2483, 253, 1, 333, 0, 0, 0, 80, 185, 0, 1), 
(20963, 20963, "Bloody Lord", 0, "", 0, "LineageMonster.banshee", 9, 23, 68, "female", "L2Monster", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 5630, 544, 646.17968, 286.3615, 441.25696, 190.66272, 253, 1, 333, 3939, 0, 0, 80, 180, 0, 1), 
(20964, 20964, "Huge Footmark", 0, "", 0, "LineageMonster.stone_golem", 20, 31, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 23, 23, 0, 1), 
(20965, 20965, "Chimera Piece", 0, "", 0, "LineageMonster.will_o_wisp", 13, 22, 73, "male", "L2Monster", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 22599, 2237, 752.73928, 310.02959, 514.02335, 226.8662, 253, 1, 333, 0, 0, 0, 80, 140, 1, 1), 
(20966, 20966, "Changed Creation", 0, "", 0, "LineageMonster.leogul", 15, 35, 74, "male", "L2Monster", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 31161, 3114, 773.81598, 314.65987, 528.41601, 230.25444, 253, 4, 333, 0, 0, 0, 80, 170, 1, 1), 
(20967, 20967, "Past Creature", 0, "", 0, "LineageMonster.gamlin", 11, 32, 76, "male", "L2Monster", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 22942, 2360, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 0, 0, 0, 80, 170, 1, 1), 
(20968, 20968, "Nonexistent Man", 0, "", 0, "LineageMonster.susceptor", 20, 35, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 27816, 2944, 890.50086, 332.70061, 608.09666, 243.45587, 253, 1, 333, 0, 0, 0, 27, 150, 1, 1), 
(20969, 20969, "Giant's Shadow", 0, "", 0, "LineageMonster.lesser_giant_shooter", 50, 44, 78, "male", "L2Monster", 1100, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 36095, 3804, 890.50086, 332.70061, 608.09666, 243.45587, 253, 8, 333, 4028, 0, 0, 80, 180, 1, 1), 
(20970, 20970, "Soldier of Ancient Times", 0, "", 0, "LineageMonster.lesser_giant", 50, 44, 73, "male", "L2Monster", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 22599, 2237, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 3937, 0, 0, 15, 180, 1, 1), 
(20971, 20971, "Warrior of Ancient Times", 0, "", 0, "LineageMonster.lesser_giant", 50, 44, 75, "male", "L2Monster", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 23855, 2420, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 3937, 0, 0, 15, 180, 1, 1), 
(20972, 20972, "Shaman of Ancient Times", 0, "", 0, "LineageMonster.lesser_giant_mage", 50, 44, 75, "male", "L2Monster", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 24719, 2511, 794.70901, 319.24623, 542.68324, 233.61053, 253, 1, 333, 3938, 0, 0, 15, 180, 1, 1), 
(20973, 20973, "Forgotten Ancient People", 0, "", 0, "LineageMonster.lesser_giant_mage", 50, 44, 77, "male", "L2Monster", 40, 2856.768726, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 31618, 3281, 856.44056, 328.27073, 584.83789, 240.21427, 253, 1, 333, 3938, 0, 0, 15, 180, 1, 1), 
(20974, 20974, "Spiteful Soul Leader", 0, "", 0, "LineageMonster.skeleton_royal_guard_bi", 16, 44, 65, "male", "L2Monster", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 14127, 1313, 582.81759, 271.89033, 397.98887, 198.95754, 253, 4, 333, 946, 945, 0, 80, 174, 0, 1), 
(20975, 20975, "Spiteful Soul Wizard", 0, "", 0, "LineageMonster.elf_ghost_50_bi", 10, 32, 63, "male", "L2Monster", 40, 2089.92274, 1127.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 12599, 1138, 541.44774, 262.19426, 369.73862, 174.5719, 253, 4, 333, 0, 0, 0, 80, 174, 0, 1), 
(20976, 20976, "Spiteful Soul Fighter", 0, "", 0, "LineageMonster.human_ghost_50_bi", 12, 33, 62, "male", "L2Monster", 40, 2037.81082, 1097, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 10694, 953, 521.12391, 257.34267, 355.86007, 171.34165, 253, 4, 333, 0, 0, 0, 80, 174, 0, 1), 
(20977, 20977, "Elmoradan's Lady", 0, "", 0, "LineageMonster.banshee_50_bi", 13.5, 38, 65, "female", "L2Monster", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 18033, 1675, 582.81759, 271.89033, 397.98887, 181.02764, 253, 1, 333, 3939, 0, 0, 80, 160, 0, 1), 
(20978, 20978, "Elmoradan's Archer Escort", 0, "", 0, "LineageMonster.skeleton_archer", 11, 27, 64, "male", "L2Monster", 1100, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 17930, 1642, 562.02275, 267.04468, 383.78868, 177.80136, 253, 8, 333, 284, 0, 0, 40, 140, 0, 1), 
(20979, 20979, "Elmoradan's Maid", 0, "", 0, "LineageMonster.doll_blader", 6, 12, 64, "male", "L2Monster", 40, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 17139, 1570, 562.02275, 267.04468, 383.78868, 177.80136, 253, 4, 333, 5129, 5129, 0, 22, 170, 0, 1), 
(20980, 20980, "Hallate's Follower Mul", 0, "", 0, "LineageMonster.vale_master", 12, 40, 68, "male", "L2Monster", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 18255, 1764, 646.17968, 286.3615, 441.25696, 190.66272, 253, 1, 333, 210, 0, 0, 70, 170, 0, 1), 
(20981, 20981, "Mul's Wizard", 0, "", 0, "LineageMonster.kaim_vanul_50_bi", 36, 60, 67, "male", "L2Monster", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 18154, 1729, 624.93199, 281.55251, 426.74754, 187.46084, 253, 1, 333, 0, 0, 0, 37, 160, 0, 1), 
(20982, 20982, "Mul's Knight", 0, "", 0, "LineageMonster.dre_vanul_100_bi", 28, 75, 67, "male", "L2Monster", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 16025, 1526, 624.93199, 281.55251, 426.74754, 187.46084, 253, 8, 333, 0, 0, 0, 80, 143, 0, 1), 
(20983, 20983, "Binder", 0, "", 0, "LineageMonster.kel_mahum_champion_50_bi", 19, 48, 73, "male", "L2Monster", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 24823, 2554, 752.73928, 310.02959, 514.02335, 206.4212, 253, 4, 333, 147, 0, 0, 50, 170, 0, 1), 
(20984, 20984, "Bound Warrior", 0, "", 0, "LineageMonster.kel_mahum_warrior", 13, 28, 72, "male", "L2Monster", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 23326, 2370, 731.52506, 305.35947, 499.53679, 203.31178, 253, 4, 333, 148, 0, 0, 50, 160, 0, 1), 
(20985, 20985, "Bound Archer", 0, "", 0, "LineageMonster.kel_mahum_archer", 13, 27, 72, "male", "L2Monster", 1100, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 23154, 2352, 731.52506, 305.35947, 499.53679, 203.31178, 253, 8, 333, 288, 0, 0, 50, 170, 0, 1), 
(20986, 20986, "Sairon", 0, "", 0, "LineageMonster.doll_blader_50_bi", 9, 20.5, 54, "male", "L2Monster", 40, 1621.75618, 861, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 13258, 1057, 370.68904, 218.89589, 253.13256, 145.74335, 253, 4, 333, 5129, 5129, 0, 22, 174, 0, 1), 
(20987, 20987, "Sairon's Doll", 0, "", 0, "LineageMonster.doll_blader", 6, 12, 53, "male", "L2Monster", 40, 1570.8463, 832.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 12060, 948, 353.71092, 214.18326, 241.5387, 142.60563, 253, 4, 333, 5129, 5129, 0, 22, 174, 0, 1), 
(20988, 20988, "Sairon's Puppet", 0, "", 0, "LineageMonster.doll_blader", 6, 12, 53, "male", "L2Monster", 40, 1570.8463, 832.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 13265, 1043, 353.71092, 214.18326, 241.5387, 142.60563, 253, 4, 333, 5129, 5129, 0, 22, 174, 0, 1), 
(20989, 20989, "Lageos", 0, "", 0, "LineageMonster.marsh_stakato_drone_50_bi", 13, 37, 38, "male", "L2Monster", 40, 886.09975, 447.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 3299, 205, 156.22273, 148.44287, 106.67987, 98.83494, 253, 4, 333, 182, 0, 0, 80, 174, 0, 1), 
(20990, 20990, "Pageos", 0, "", 0, "LineageMonster.marsh_stakato_soldier", 10, 25, 38, "male", "L2Monster", 40, 886.09975, 447.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 3132, 196, 156.22273, 148.44287, 106.67987, 98.83494, 253, 4, 333, 128, 0, 0, 30, 174, 0, 1), 
(20991, 20991, "Swamp Tribe", 0, "", 0, "LineageMonster.farhite_50_bi", 24, 48, 45, "male", "L2Monster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 12334, 858, 234.89829, 177.78746, 160.40508, 118.3729, 253, 4, 333, 5131, 0, 0, 15, 174, 0, 1), 
(20992, 20992, "Swamp Alligator", 0, "", 0, "LineageMonster.crokian", 18, 29, 44, "male", "L2Monster", 40, 1138.62924, 584, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 11042, 756, 222.23112, 173.43552, 151.75505, 115.47533, 253, 4, 333, 5128, 0, 0, 18, 174, 0, 1), 
(20993, 20993, "Swamp Warrior", 0, "", 0, "LineageMonster.dailaon", 20, 28, 44, "male", "L2Monster", 1100, 1138.62924, 584, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 11717, 802, 222.23112, 173.43552, 151.75505, 115.47533, 253, 8, 333, 5127, 0, 0, 18, 174, 0, 1), 
(20994, 20994, "Garden Guard Leader", 0, "", 0, "LineageMonster.doll_master_50_bi", 30, 63, 50, "male", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 14866, 1120, 305.54906, 200.23844, 208.6504, 133.32101, 253, 4, 333, 0, 0, 0, 80, 174, 0, 1), 
(20995, 20995, "Garden Guard", 0, "", 0, "LineageMonster.theeder", 9, 32, 48, "male", "L2Monster", 40, 1324.01623, 692.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 10134, 740, 275.82705, 191.12803, 188.35412, 127.2552, 253, 4, 333, 94, 0, 0, 80, 174, 0, 1), 
(20996, 20996, "Spiteful Ghost of Ruins", 0, "", 0, "LineageMonster.zombie", 13, 21, 50, "male", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 6419, 484, 305.54906, 200.23844, 208.6504, 133.32101, 253, 1, 333, 0, 0, 0, 15, 15, 0, 1), 
(20997, 20997, "Soldier of Grief", 0, "", 0, "LineageMonster.unpleasant_humming", 12, 26, 51, "male", "L2Monster", 40, 1470.41596, 775.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 4539, 346, 321.13207, 204.85194, 219.29157, 136.39273, 253, 1, 333, 0, 0, 0, 21, 150, 0, 1), 
(20998, 20998, "Cruel Punisher", 0, "", 0, "LineageMonster.hungry_spirit", 30, 40, 52, "male", "L2Monster", 40, 1520.38155, 804, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 5002, 386, 337.18867, 209.50106, 230.25615, 139.48817, 253, 1, 333, 0, 0, 0, 15, 120, 0, 1), 
(20999, 20999, "Roving Soul", 0, "", 0, "LineageMonster.skeleton", 11, 25, 53, "male", "L2Monster", 40, 1570.8463, 832.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 5932, 467, 353.71092, 214.18326, 241.5387, 142.60563, 253, 8, 333, 75, 0, 0, 60, 160, 0, 1), 
(21000, 21000, "Soul of Ruins", 0, "", 0, "LineageMonster.human_ghost", 8, 22, 54, "male", "L2Monster", 40, 1621.75618, 861, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 5191, 414, 370.68904, 218.89589, 253.13256, 145.74335, 253, 4, 333, 0, 0, 0, 80, 174, 0, 1), 
(21001, 21001, "Wretched Archer", 0, "", 0, "LineageMonster.skeleton_archer", 11, 27, 55, "male", "L2Monster", 1100, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 7028, 568, 388.11142, 223.6362, 265.02979, 148.89951, 253, 8, 333, 282, 0, 0, 40, 174, 1, 1), 
(21002, 21002, "Doom Scout", 0, "", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 56, "male", "L2Monster", 40, 1724.6831, 918.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 6197, 509, 405.96455, 228.40135, 277.22116, 152.0722, 253, 8, 333, 242, 2496, 0, 80, 174, 1, 1), 
(21003, 21003, "Grave Lich", 0, "", 0, "LineageMonster.liviona", 15, 28, 57, "male", "L2Monster", 40, 1776.58018, 948, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 5670, 472, 424.23295, 233.18839, 289.69611, 155.25946, 253, 4, 333, 0, 0, 0, 80, 174, 1, 1), 
(21004, 21004, "Dismal Pole", 0, "", 0, "LineageMonster.hanged_man_ripper", 35, 80, 58, "male", "L2Monster", 80, 1828.68266, 977.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 6288, 532, 442.8992, 237.99429, 302.44274, 158.45929, 253, 4, 333, 0, 0, 0, 55, 174, 1, 1), 
(21005, 21005, "Grave Predator", 0, "", 0, "LineageMonster.devastator", 35, 35, 59, "male", "L2Monster", 40, 1880.92519, 1007, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 6878, 588, 461.94387, 242.81593, 315.44778, 161.66959, 253, 4, 333, 0, 0, 0, 25, 174, 1, 1), 
(21006, 21006, "Doom Servant", 0, "", 0, "LineageMonster.hungry_spirit", 30, 40, 60, "male", "L2Monster", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 6537, 568, 481.34551, 247.65008, 328.69659, 164.88822, 253, 1, 333, 0, 0, 0, 15, 174, 0, 1), 
(21007, 21007, "Doom Guard", 0, "", 0, "LineageMonster.hungry_spirit", 30, 40, 61, "male", "L2Monster", 40, 1985.55926, 1066.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 7014, 617, 501.08068, 252.49346, 342.17315, 168.113, 253, 1, 333, 0, 0, 0, 15, 174, 0, 1), 
(21008, 21008, "Doom Archer", 0, "", 0, "LineageMonster.skeleton_archer", 11, 27, 62, "male", "L2Monster", 1100, 2037.81082, 1097, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 8965, 799, 521.12391, 257.34267, 355.86007, 171.34165, 253, 8, 333, 286, 0, 0, 40, 174, 0, 1), 
(21009, 21009, "Doom Trooper", 0, "", 0, "LineageMonster.skeleton_pikeman", 10, 28, 63, "male", "L2Monster", 80, 2089.92274, 1127.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9559, 863, 541.44774, 262.19426, 369.73862, 174.5719, 253, 4, 333, 301, 0, 0, 50, 174, 0, 1), 
(21010, 21010, "Doom Warrior", 0, "", 0, "LineageMonster.skeleton_knight", 10, 25, 64, "male", "L2Monster", 40, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 7656, 701, 562.02275, 267.04468, 383.78868, 177.80136, 253, 8, 333, 71, 0, 0, 40, 174, 0, 1), 
(21011, 21011, "Ol Mahum Van Grunt", 0, "", 0, "LineageMonster.ol_mahum", 13.5, 25, 30, "male", "L2Monster", 40, 604.08419, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1571, 86, 92.64226, 118.46427, 63.26266, 78.87485, 253, 4, 333, 5, 0, 0, 50, 150, 1, 1), 
(21012, 21012, "Magical Eye", 0, "", 0, "LineageMonster.magical_weaver", 11, 20, 31, "male", "L2Monster", 40, 635.76437, 343.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2084, 115, 99.21986, 121.98819, 67.7543, 81.22111, 253, 4, 333, 0, 0, 0, 90, 150, 1, 1), 
(21013, 21013, "Ol Mahum Van Archer", 0, "", 0, "LineageMonster.ol_mahum_archer", 14, 25, 32, "male", "L2Monster", 1100, 668.47132, 358.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2305, 130, 106.16525, 125.57727, 72.49711, 83.61076, 253, 8, 333, 273, 0, 0, 50, 150, 1, 1), 
(21014, 21014, "Lesser Warlike Tyrant", 0, "", 0, "LineageMonster.grave", 15, 29, 33, "male", "L2Monster", 40, 702.20463, 372.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2385, 137, 113.49065, 129.23095, 77.49941, 86.04342, 253, 4, 333, 0, 0, 0, 70, 150, 1, 1), 
(21015, 21015, "Ol Mahum Van Leader", 0, "", 0, "LineageMonster.ol_mahum_champion", 14, 27, 34, "male", "L2Monster", 40, 736.96177, 387.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2449, 143, 121.20802, 132.9486, 82.76936, 88.51867, 253, 4, 333, 67, 0, 0, 50, 150, 1, 1), 
(21016, 21016, "Warlike Tyrant", 0, "", 0, "LineageMonster.grave", 15, 29, 35, "male", "L2Monster", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2631, 156, 129.32896, 136.72948, 88.31491, 91.03603, 253, 4, 333, 0, 0, 0, 70, 174, 1, 1), 
(21017, 21017, "Fallen Orc", 0, "", 0, "LineageMonster.ketra_orc", 12, 29, 55, "male", "L2Monster", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 5279, 426, 388.11142, 223.6362, 265.02979, 148.89951, 253, 4, 333, 127, 0, 0, 45, 174, 1, 1), 
(21018, 21018, "Ancient Gargoyle", 0, "", 0, "LineageMonster.hunter_gargoyle", 25, 65, 56, "male", "L2Monster", 40, 1724.6831, 918.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 6643, 546, 405.96455, 228.40135, 277.22116, 152.0722, 253, 4, 333, 0, 0, 0, 100, 174, 1, 1), 
(21019, 21019, "Fallen Orc Archer", 0, "", 0, "LineageMonster.ketra_orc_archer", 12, 27, 57, "male", "L2Monster", 1100, 1776.58018, 948, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 7312, 607, 424.23295, 233.18839, 289.69611, 155.25946, 253, 8, 333, 279, 0, 0, 45, 174, 1, 1), 
(21020, 21020, "Fallen Orc Shaman", 0, "", 0, "LineageMonster.ketra_orc_shaman", 10, 23, 58, "male", "L2Monster", 40, 1828.68266, 977.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 8278, 700, 442.8992, 237.99429, 302.44274, 158.45929, 253, 1, 333, 9, 0, 0, 10, 174, 1, 1), 
(21021, 21021, "Sharp Talon Tiger", 0, "", 0, "LineageMonster.saber_toothed_tiger", 34, 28, 59, "male", "L2Monster", 40, 1880.92519, 1007, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 7625, 652, 461.94387, 242.81593, 315.44778, 161.66959, 253, 1, 333, 0, 0, 0, 60, 174, 1, 1), 
(21022, 21022, "Fallen Orc Captain", 0, "", 0, "LineageMonster.ketra_orc_warrior", 12, 24, 60, "male", "L2Monster", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 7754, 673, 481.34551, 247.65008, 328.69659, 164.88822, 253, 1, 333, 160, 0, 0, 36, 174, 1, 1), 
(21023, 21023, "Sobbing Wind", 0, "", 0, "LineageMonster.sylph", 11, 35, 26, "female", "L2Monster", 40, 487.5704, 273, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1268, 64, 69.75926, 105.02818, 47.63653, 69.92894, 253, 1, 333, 0, 0, 0, 60, 150, 1, 1), 
(21024, 21024, "Babbling Wind", 0, "", 0, "LineageMonster.sylph", 11, 35, 27, "female", "L2Monster", 40, 515.17856, 286.92, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1336, 68, 74.99121, 108.28767, 51.20928, 72.09915, 253, 1, 333, 0, 0, 0, 60, 150, 1, 1), 
(21025, 21025, "Giggling Wind", 0, "", 0, "LineageMonster.sylph", 11, 35, 28, "female", "L2Monster", 40, 543.79576, 300.96, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1414, 74, 80.54056, 111.61368, 54.99876, 74.31365, 253, 1, 333, 0, 0, 0, 60, 150, 1, 1), 
(21026, 21026, "Singing Wind", 0, "", 0, "LineageMonster.sylph", 11, 35, 29, "female", "L2Monster", 40, 573.42917, 315.12, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1522, 82, 86.42002, 115.00598, 59.01367, 76.57227, 253, 1, 333, 0, 0, 0, 60, 150, 1, 1), 
(21034, 21034, "Ogre", 0, "", 0, "LineageMonster.ogre", 21, 44, 38, "male", "L2Monster", 40, 886.09975, 447.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2157, 134, 156.22273, 148.44287, 106.67987, 98.83494, 253, 1, 333, 98, 0, 0, 22, 174, 1, 1), 
(21035, 21035, "Catherok", 0, "", 0, "LineageMonster.marsh_stakato_soldier", 10, 25, 42, "male", "L2Monster", 40, 1050.81652, 531, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 6978, 443, 198.34591, 164.88513, 135.44454, 120.65578, 253, 4, 333, 144, 0, 0, 30, 155, 0, 1), 
(21036, 21036, "Shindebarn", 0, "", 0, "LineageMonster.magical_weaver", 11, 20, 44, "male", "L2Monster", 40, 1138.62924, 584, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 8166, 536, 222.23112, 173.43552, 151.75505, 126.91259, 253, 1, 333, 0, 0, 0, 90, 90, 0, 1), 
(21037, 21037, "Ossiud", 0, "", 0, "LineageMonster.field_stalker", 15, 30, 47, "male", "L2Monster", 40, 1276.53628, 665, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 10557, 727, 261.69549, 186.63569, 178.7041, 136.5719, 253, 4, 333, 0, 0, 0, 70, 110, 0, 1), 
(21038, 21038, "Liangma", 0, "", 0, "LineageMonster.will_o_wisp", 13, 22, 49, "male", "L2Monster", 40, 1372.18568, 720, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 8025, 560, 290.44588, 195.66302, 198.33688, 143.17771, 253, 1, 333, 0, 0, 0, 80, 140, 0, 1), 
(21039, 21039, "Snipe Cohort", 0, "", 0, "LineageMonster.onyx_beast", 14, 14.5, 43, "male", "L2Monster", 40, 1094.28943, 557.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 7953, 515, 210.04832, 169.13417, 143.43577, 123.76505, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(21040, 21040, "Soldier of Darkness", 0, "", 0, "LineageMonster.death_knight", 12, 31, 49, "male", "L2Monster", 40, 1372.18568, 720, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 12649, 899, 290.44588, 195.66302, 198.33688, 143.17771, 253, 4, 333, 127, 0, 0, 27, 110, 0, 1), 
(21058, 21058, "Beast Lord", 0, "", 0, "LineageMonster.saber_toothed_tiger", 34, 28, 60, "male", "L2Monster", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 18913, 1642, 481.34551, 247.65008, 328.69659, 164.88822, 253, 1, 333, 0, 0, 0, 60, 174, 0, 1), 
(21059, 21059, "Beast Guardian", 0, "", 0, "LineageMonster.onyx_beast", 14, 14.5, 59, "male", "L2Monster", 40, 1880.92519, 1007, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 15095, 1290, 461.94387, 242.81593, 315.44778, 161.66959, 253, 1, 333, 0, 0, 0, 30, 174, 0, 1), 
(21060, 21060, "Beast Seer", 0, "", 0, "LineageMonster.field_stalker", 15, 30, 59, "male", "L2Monster", 40, 1880.92519, 1007, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 15095, 1290, 461.94387, 242.81593, 315.44778, 161.66959, 253, 1, 333, 0, 0, 0, 70, 174, 0, 1), 
(21061, 21061, "Hallate's Guardian", 0, "", 0, "LineageMonster.kaim_vanul", 24, 40, 69, "male", "L2Monster", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 30701, 3004, 667.50361, 291.15063, 455.81844, 193.85137, 253, 1, 333, 0, 0, 0, 37, 174, 0, 1), 
(21062, 21062, "Messenger Angel", 0, "", 0, "LineageMonster.angel", 13.5, 36.5, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 197.0242, 253, 1, 333, 148, 0, 0, 30, 174, 0, 1), 
(21063, 21063, "Messenger Angel", 0, "", 0, "LineageMonster.angel", 13.5, 36.5, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 62784, 6226, 688.86373, 295.91597, 470.40463, 197.0242, 253, 1, 333, 148, 0, 0, 30, 174, 0, 1), 
(21064, 21064, "Platinum Guardian Archer", 0, "", 0, "LineageMonster.kel_mahum_archer", 13, 27, 71, "male", "L2Monster", 1100, 2492.727, 1377.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 38444, 3858, 710.2185, 300.65359, 484.98717, 200.17855, 253, 8, 333, 288, 0, 0, 50, 174, 0, 1), 
(21065, 21065, "Platinum Guardian Warrior", 0, "", 0, "LineageMonster.kel_mahum_warrior", 13, 28, 72, "male", "L2Monster", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 36221, 3680, 731.52506, 305.35947, 499.53679, 203.31178, 253, 1, 333, 148, 0, 0, 50, 174, 0, 1), 
(21066, 21066, "Platinum Guardian Shaman", 0, "", 0, "LineageMonster.kel_mahum_witch_doctor", 13, 25, 73, "male", "L2Monster", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 39180, 4032, 752.73928, 310.02959, 514.02335, 206.4212, 253, 1, 333, 202, 0, 0, 50, 174, 0, 1), 
(21067, 21067, "Guardian Archangel", 0, "", 0, "LineageMonster.angel", 13.5, 36.5, 74, "male", "L2Monster", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 773.81598, 314.65987, 528.41601, 209.50409, 253, 1, 333, 148, 0, 0, 30, 174, 0, 1), 
(21068, 21068, "Guardian Archangel", 0, "", 0, "LineageMonster.angel", 13.5, 36.5, 74, "male", "L2Monster", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 85242, 8886, 773.81598, 314.65987, 528.41601, 209.50409, 253, 1, 333, 148, 0, 0, 30, 174, 0, 1), 
(21069, 21069, "Platinum Guardian Prefect", 0, "", 0, "LineageMonster.kel_mahum_champion", 13, 32, 74, "male", "L2Monster", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 53456, 5573, 773.81598, 314.65987, 528.41601, 209.50409, 253, 4, 333, 147, 0, 0, 50, 174, 0, 1), 
(21070, 21070, "Seal Archangel", 0, "", 0, "LineageMonster.angel", 13.5, 36.5, 75, "male", "L2Monster", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 212.55774, 253, 1, 333, 148, 0, 0, 30, 174, 0, 1), 
(21071, 21071, "Seal Archangel", 0, "", 0, "LineageMonster.angel", 13.5, 36.5, 75, "male", "L2Monster", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 88404, 9325, 794.70901, 319.24623, 542.68324, 233.61053, 253, 1, 333, 148, 0, 0, 30, 174, 0, 1), 
(21072, 21072, "Platinum Guardian Chief", 0, "", 0, "LineageMonster.kel_mahum_witch_doctor", 13, 25, 75, "male", "L2Monster", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 40513, 4273, 794.70901, 319.24623, 542.68324, 212.55774, 253, 1, 333, 202, 0, 0, 50, 174, 0, 1), 
(21073, 21073, "Guardian Warrior of Elmoreden", 0, "", 0, "LineageMonster.skeleton_knight", 10, 25, 64, "male", "L2Monster", 40, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 16897, 1547, 562.02275, 267.04468, 383.78868, 177.80136, 253, 4, 333, 84, 0, 0, 40, 174, 0, 1), 
(21074, 21074, "Bound Shaman", 0, "", 0, "LineageMonster.kel_mahum_witch_doctor", 13, 25, 72, "male", "L2Monster", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 23163, 2353, 731.52506, 305.35947, 499.53679, 203.31178, 253, 1, 333, 202, 0, 0, 50, 174, 0, 1), 
(21075, 21075, "Slaughter Bathin", 0, "", 0, "LineageMonster.death_knight", 12, 31, 63, "male", "L2Monster", 40, 2089.92274, 1127.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 16790, 1516, 541.44774, 262.19426, 369.73862, 174.5719, 253, 4, 333, 84, 0, 0, 27, 174, 0, 1), 
(21076, 21076, "Bathin's Knight", 0, "", 0, "LineageMonster.skeleton_knight", 10, 25, 62, "male", "L2Monster", 40, 2037.81082, 1097, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 16516, 1471, 521.12391, 257.34267, 355.86007, 171.34165, 253, 1, 333, 78, 0, 0, 40, 174, 0, 1), 
(21077, 21077, "Bathin's Wizard", 0, "", 0, "LineageMonster.banshee", 9, 23, 62, "female", "L2Monster", 40, 2037.81082, 1097, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 16007, 1427, 521.12391, 257.34267, 355.86007, 171.34165, 253, 1, 333, 3939, 0, 0, 80, 174, 0, 1), 
(21078, 21078, "Magus Valac", 0, "", 0, "LineageMonster.vale_master", 12, 40, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 20355, 2018, 688.86373, 295.91597, 470.40463, 197.0242, 253, 1, 333, 198, 0, 0, 70, 174, 0, 1), 
(21079, 21079, "Valac's Creature", 0, "", 0, "LineageMonster.serpent_slave", 17, 46, 69, "male", "L2Monster", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 18497, 1810, 667.50361, 291.15063, 455.81844, 193.85137, 253, 4, 333, 150, 0, 0, 70, 174, 0, 1), 
(21080, 21080, "Valac's Guardian Spirit", 0, "", 0, "LineageMonster.shadow", 10, 30, 69, "male", "L2Monster", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 17096, 1673, 667.50361, 291.15063, 455.81844, 193.85137, 253, 8, 333, 0, 0, 0, 80, 174, 0, 1), 
(21081, 21081, "Power Angel Amon", 0, "", 0, "LineageMonster.angel", 13.5, 36.5, 75, "male", "L2Monster", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 21329, 2250, 794.70901, 319.24623, 542.68324, 212.55774, 253, 1, 333, 4700, 0, 0, 30, 174, 0, 1), 
(21082, 21082, "Amon's Captain of the Guards", 0, "", 0, "LineageMonster.kel_mahum_champion", 13, 32, 74, "male", "L2Monster", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 20511, 2138, 773.81598, 314.65987, 528.41601, 209.50409, 253, 4, 333, 150, 0, 0, 50, 174, 0, 1), 
(21083, 21083, "Amon's Spirits", 0, "", 0, "LineageMonster.pixy", 5, 25, 74, "female", "L2Monster", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 24232, 2526, 773.81598, 314.65987, 528.41601, 209.50409, 253, 1, 333, 0, 0, 0, 80, 174, 0, 1), 
(21084, 21084, "Bloody Lady", 0, "", 0, "LineageMonster.bloody_queen", 14, 40, 60, "female", "L2Monster", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 14806, 1285, 481.34551, 247.65008, 328.69659, 164.88822, 253, 4, 333, 0, 0, 0, 80, 174, 0, 1), 
(21085, 21085, "Bloody Sniper", 0, "", 0, "LineageMonster.fiend_archer", 17, 55, 71, "male", "L2Monster", 1100, 2492.727, 1377.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 33449, 3356, 710.2185, 300.65359, 484.98717, 200.17855, 253, 8, 333, 0, 0, 0, 70, 174, 0, 1), 
(21086, 21086, "Bloody Liviona", 0, "", 0, "LineageMonster.liviona", 15, 28, 72, "male", "L2Monster", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 33396, 3392, 731.52506, 305.35947, 499.53679, 203.31178, 253, 4, 333, 0, 0, 0, 80, 174, 0, 1), 
(21087, 21087, "Bloody Knight", 0, "", 0, "LineageMonster.death_knight", 12, 31, 73, "male", "L2Monster", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 53594, 5514, 752.73928, 310.02959, 514.02335, 206.4212, 253, 4, 333, 84, 0, 0, 27, 174, 0, 1), 
(21088, 21088, "Bloody Banshee", 0, "", 0, "LineageMonster.banshee", 9, 23, 74, "female", "L2Monster", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 35277, 3677, 773.81598, 314.65987, 528.41601, 209.50409, 253, 4, 333, 3939, 0, 0, 80, 174, 0, 1), 
(21089, 21089, "Bloody Lord", 0, "", 0, "LineageMonster.karik", 25, 90, 75, "male", "L2Monster", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 40903, 4314, 794.70901, 319.24623, 542.68324, 212.55774, 253, 4, 333, 0, 0, 0, 37, 174, 0, 1), 
(21090, 21090, "Bloody Guardian", 0, "", 0, "LineageMonster.death_blader", 15, 45, 75, "male", "L2Monster", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 31444, 3317, 794.70901, 319.24623, 542.68324, 212.55774, 253, 4, 333, 1472, 0, 0, 100, 174, 0, 1), 
(21091, 21091, "Bloody Keeper", 0, "", 0, "LineageMonster.kaim_vanul", 24, 40, 74, "male", "L2Monster", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 21195, 2209, 773.81598, 314.65987, 528.41601, 209.50409, 253, 4, 333, 0, 0, 0, 37, 174, 0, 1), 
(21092, 21092, "Bloody Mystic", 0, "", 0, "LineageMonster.banshee", 9, 23, 74, "female", "L2Monster", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 20706, 2159, 773.81598, 314.65987, 528.41601, 209.50409, 253, 4, 333, 3939, 0, 0, 80, 174, 0, 1), 
(21093, 21093, "Ratman Sub Chieftain", 0, "", 0, "LineageMonster.wererat", 14, 25, 19, "male", "L2Monster", 40, 321.63954, 183.28, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 692, 31, 40.96915, 84.07638, 27.97662, 55.97901, 253, 4, 333, 216, 0, 0, 80, 150, 1, 1), 
(21094, 21094, "Ratman Chieftain", 0, "", 0, "LineageMonster.wererat", 14, 25, 20, "male", "L2Monster", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 713, 32, 44.32863, 86.87049, 30.2707, 57.83936, 253, 4, 333, 3, 0, 0, 80, 155, 1, 1), 
(21095, 21095, "Giant Poison Bee", 0, "", 0, "LineageMonster.giant_bee", 8, 24.5, 21, "male", "L2Monster", 40, 364.30351, 205.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1009, 47, 47.91924, 89.73059, 32.72263, 59.74364, 253, 8, 333, 0, 0, 0, 90, 90, 1, 1), 
(21096, 21096, "Cloudy Beast", 0, "", 0, "LineageMonster.onyx_beast", 14, 14.5, 22, "male", "L2Monster", 40, 387.02878, 218.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1005, 48, 51.75278, 92.65694, 35.34044, 61.69203, 253, 4, 333, 0, 0, 0, 30, 140, 1, 1), 
(21097, 21097, "Young Araneid", 0, "", 0, "LineageMonster.poison_spider", 27, 25.5, 23, "male", "L2Monster", 40, 410.70422, 231.96, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1183, 58, 55.84125, 95.64976, 38.13234, 63.68469, 253, 4, 333, 0, 0, 0, 60, 130, 1, 1), 
(21098, 21098, "Plain Grizzly", 0, "", 0, "LineageMonster.grizzly", 21, 40, 24, "male", "L2Monster", 40, 435.34437, 245.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1123, 55, 60.19687, 98.70919, 41.10666, 65.72169, 253, 4, 333, 0, 0, 0, 40, 115, 1, 1), 
(21099, 21099, "Cloudy Beast Turen", 0, "", 0, "LineageMonster.onyx_beast", 14, 14.5, 25, "male", "L2Monster", 40, 460.96247, 259.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1215, 61, 64.83203, 101.83533, 44.27187, 67.80312, 253, 4, 333, 0, 0, 0, 30, 145, 1, 1), 
(21100, 21100, "Langk Lizardman Sentinel", 0, "", 0, "LineageMonster.virud_lizardman", 10, 23, 19, "male", "L2Monster", 40, 321.63954, 183.28, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 692, 31, 40.96915, 84.07638, 27.97662, 55.97901, 253, 4, 333, 2, 0, 0, 43, 130, 1, 1), 
(21101, 21101, "Langk Lizardman Shaman", 0, "", 0, "LineageMonster.virud_lizardman_shaman", 10, 29, 24, "male", "L2Monster", 40, 435.34437, 245.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1123, 55, 60.19687, 98.70919, 41.10666, 65.72169, 253, 1, 333, 6, 0, 0, 43, 130, 1, 1), 
(21102, 21102, "Watchman of the Plains", 0, "", 0, "LineageMonster.magical_weaver", 11, 20, 30, "male", "L2Monster", 40, 604.08419, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1602, 88, 92.64226, 118.46427, 63.26266, 78.87485, 253, 1, 333, 0, 0, 0, 90, 160, 1, 1), 
(21103, 21103, "Roughly Hewn Rock Golem", 0, "", 0, "LineageMonster.stone_golem_bi", 20, 40.3, 31, "male", "L2Monster", 40, 635.76437, 343.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1677, 94, 99.21986, 121.98819, 67.7543, 81.22111, 253, 1, 333, 0, 0, 0, 23, 23, 1, 1), 
(21104, 21104, "Delu Lizardman Supplier", 0, "", 0, "LineageMonster.virud_lizardman", 10, 23, 32, "male", "L2Monster", 40, 668.47132, 358.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2106, 119, 106.16525, 125.57727, 72.49711, 83.61076, 253, 8, 333, 223, 0, 0, 43, 135, 1, 1), 
(21105, 21105, "Delu Lizardman Special Agent", 0, "", 0, "LineageMonster.virud_lizardman_scout", 10, 22, 33, "male", "L2Monster", 1100, 702.20463, 372.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2427, 139, 113.49065, 129.23095, 77.49941, 86.04342, 253, 8, 333, 2507, 0, 0, 43, 135, 1, 1), 
(21106, 21106, "Cursed Seer", 0, "", 0, "LineageMonster.magical_weaver", 11, 20, 34, "male", "L2Monster", 40, 736.96177, 387.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2058, 120, 121.20802, 132.9486, 82.76936, 88.51867, 253, 1, 333, 0, 0, 0, 90, 160, 1, 1), 
(21107, 21107, "Delu Lizardman Commander", 0, "", 0, "LineageMonster.virud_lizardman_warrior", 12, 30, 35, "male", "L2Monster", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 4354, 258, 129.32896, 136.72948, 88.31491, 91.03603, 253, 4, 333, 93, 0, 0, 52, 135, 1, 1), 
(21108, 21108, "Glow Wisp", 0, "", 0, "LineageMonster.will_o_wisp", 13, 22, 67, "male", "L2Monster", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 7835, 746, 624.93199, 281.55251, 426.74754, 187.46084, 253, 1, 333, 0, 0, 0, 80, 160, 1, 1), 
(21109, 21109, "Hames Orc Scout", 0, "", 0, "LineageMonster.ketra_orc", 12, 29, 68, "male", "L2Monster", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9699, 937, 646.17968, 286.3615, 441.25696, 190.66272, 253, 8, 333, 229, 0, 0, 45, 185, 1, 1), 
(21110, 21110, "Marsh Predator", 0, "", 0, "LineageMonster.devastator", 35, 35, 69, "male", "L2Monster", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 8268, 809, 667.50361, 291.15063, 455.81844, 193.85137, 253, 4, 333, 0, 0, 0, 25, 175, 1, 1), 
(21111, 21111, "Lava Wyrm", 0, "", 0, "LineageMonster.wyrm", 29, 72, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 8637, 857, 688.86373, 295.91597, 470.40463, 197.0242, 253, 4, 333, 0, 0, 0, 70, 175, 1, 1), 
(21112, 21112, "Hames Orc Footman", 0, "", 0, "LineageMonster.ketra_orc", 12, 29, 71, "male", "L2Monster", 40, 2492.727, 1377.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 10470, 1050, 710.2185, 300.65359, 484.98717, 200.17855, 253, 4, 333, 233, 110, 0, 45, 180, 1, 1), 
(21113, 21113, "Hames Orc Sniper", 0, "", 0, "LineageMonster.ketra_orc_archer", 12, 27, 72, "male", "L2Monster", 1100, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 11667, 1186, 731.52506, 305.35947, 499.53679, 203.31178, 253, 8, 333, 287, 0, 0, 45, 160, 1, 1), 
(21114, 21114, "Cursed Guardian", 0, "", 0, "LineageMonster.death_blader", 15, 45, 73, "male", "L2Monster", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 11078, 1140, 752.73928, 310.02959, 514.02335, 206.4212, 253, 4, 333, 1472, 0, 0, 100, 175, 1, 1), 
(21115, 21115, "Hames Orc Shaman", 0, "", 0, "LineageMonster.ketra_orc_shaman", 10, 23, 74, "male", "L2Monster", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 9652, 1006, 773.81598, 314.65987, 528.41601, 209.50409, 253, 1, 333, 186, 0, 0, 10, 145, 1, 1), 
(21116, 21116, "Hames Orc Overlord", 0, "", 0, "LineageMonster.ketra_orc_warrior", 12, 24, 75, "male", "L2Monster", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 15240, 1608, 794.70901, 319.24623, 542.68324, 212.55774, 253, 4, 333, 75, 103, 0, 36, 175, 1, 1), 
(21117, 21117, "Kasha Imp", 0, "", 0, "LineageMonster.imp_bi", 10, 30, 19, "male", "L2Monster", 40, 321.63954, 183.28, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 678, 30, 40.96915, 84.07638, 27.97662, 55.97901, 253, 4, 333, 0, 0, 0, 60, 85, 1, 1), 
(21118, 21118, "Baar Dre Vanul", 0, "", 0, "LineageMonster.dre_vanul", 14, 36, 20, "male", "L2Monster", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 727, 32, 44.32863, 86.87049, 30.2707, 57.83936, 253, 4, 333, 0, 0, 0, 80, 85, 1, 1), 
(21119, 21119, "Hobgoblin", 0, "", 0, "LineageMonster.hobgoblin", 12, 24, 21, "male", "L2Monster", 40, 364.30351, 205.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 917, 42, 47.91924, 89.73059, 32.72263, 59.74364, 253, 1, 333, 4, 0, 0, 45, 110, 1, 1), 
(21120, 21120, "Kasha Imp Turen", 0, "", 0, "LineageMonster.imp_bi", 10, 30, 22, "male", "L2Monster", 40, 387.02878, 218.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1196, 56, 51.75278, 92.65694, 35.34044, 61.69203, 253, 4, 333, 0, 0, 0, 60, 85, 1, 1), 
(21121, 21121, "Kasha Dire Wolf", 0, "", 0, "LineageMonster.dire_wolf", 13, 11, 23, "male", "L2Monster", 40, 410.70422, 231.96, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1075, 52, 55.84125, 95.64976, 38.13234, 63.68469, 253, 4, 333, 0, 0, 0, 24, 135, 1, 1), 
(21122, 21122, "Kasha Bugbear", 0, "", 0, "LineageMonster.bugbear", 17, 35, 24, "male", "L2Monster", 40, 435.34437, 245.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1145, 56, 60.19687, 98.70919, 41.10666, 65.72169, 253, 1, 333, 169, 0, 0, 55, 130, 1, 1), 
(21123, 21123, "Baar Dre Vanul Destroyer", 0, "", 0, "LineageMonster.dre_vanul", 14, 36, 25, "male", "L2Monster", 40, 460.96247, 259.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1521, 76, 64.83203, 101.83533, 44.27187, 67.80312, 253, 4, 333, 0, 0, 0, 80, 85, 1, 1), 
(21124, 21124, "Red Eye Barbed Bat", 0, "", 0, "LineageMonster.vampire_bat", 10, 33.5, 18, "male", "L2Monster", 40, 301.66622, 174.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 640, 28, 37.82932, 81.34791, 25.83252, 54.16236, 253, 4, 333, 0, 0, 0, 60, 90, 1, 1), 
(21125, 21125, "Northern Trimden", 0, "", 0, "LineageMonster.poison_spider", 27, 25.5, 19, "male", "L2Monster", 40, 321.63954, 183.28, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 685, 31, 40.96915, 84.07638, 27.97662, 55.97901, 253, 4, 333, 0, 0, 0, 60, 140, 1, 1), 
(21126, 21126, "Kerope Werewolf", 0, "", 0, "LineageMonster.werewolf_bi", 11, 29.7, 20, "male", "L2Monster", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 713, 32, 44.32863, 86.87049, 30.2707, 57.83936, 253, 1, 333, 0, 0, 0, 50, 125, 1, 1), 
(21127, 21127, "Northern Goblin", 0, "", 0, "LineageMonster2.northern_goblin", 4, 15, 21, "male", "L2Monster", 40, 364.30351, 205.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 917, 42, 47.91924, 89.73059, 32.72263, 59.74364, 253, 1, 333, 152, 0, 0, 30, 120, 1, 1), 
(21128, 21128, "Spine Golem", 0, "", 0, "LineageMonster.stone_golem_bi", 20, 40.3, 22, "male", "L2Monster", 40, 387.02878, 218.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 986, 47, 51.75278, 92.65694, 35.34044, 61.69203, 253, 1, 333, 0, 0, 0, 23, 23, 1, 1), 
(21129, 21129, "Kerope Werewolf Chief", 0, "", 0, "LineageMonster.werewolf_bi", 11, 29.7, 23, "male", "L2Monster", 40, 410.70422, 231.96, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1075, 52, 55.84125, 95.64976, 38.13234, 63.68469, 253, 1, 333, 0, 0, 0, 50, 140, 1, 1), 
(21130, 21130, "Northern Goblin Leader", 0, "", 0, "LineageMonster2.northern_goblin", 4, 15, 24, "male", "L2Monster", 40, 435.34437, 245.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1145, 56, 60.19687, 98.70919, 41.10666, 65.72169, 253, 1, 333, 66, 102, 0, 30, 125, 1, 1), 
(21131, 21131, "Enchanted Spine Golem", 0, "", 0, "LineageMonster.stone_golem_bi", 20, 40.3, 25, "male", "L2Monster", 40, 460.96247, 259.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1191, 60, 64.83203, 101.83533, 44.27187, 67.80312, 253, 1, 333, 0, 0, 0, 23, 29, 1, 1), 
(21132, 21132, "Underground Kobold", 0, "", 0, "LineageMonster.kobold", 10, 15, 24, "male", "L2Monster", 40, 435.34437, 245.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 935, 46, 60.19687, 98.70919, 41.10666, 65.72169, 253, 4, 333, 0, 0, 0, 47, 110, 0, 1), 
(21133, 21133, "Dead Pit Skeleton Archer", 0, "", 0, "LineageMonster.skeleton_archer", 11, 27, 25, "male", "L2Monster", 1100, 460.96247, 259.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1022, 52, 64.83203, 101.83533, 44.27187, 67.80312, 253, 8, 333, 274, 0, 0, 40, 130, 0, 1), 
(21134, 21134, "Dead Pit Spartoi", 0, "", 0, "LineageMonster.spartoi", 11, 27, 26, "male", "L2Monster", 40, 487.5704, 273, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1078, 54, 69.75926, 105.02818, 47.63653, 69.92894, 253, 4, 333, 219, 0, 0, 60, 145, 0, 1), 
(21135, 21135, "Underground Kobold Warrior", 0, "", 0, "LineageMonster.kobold", 10, 15, 27, "male", "L2Monster", 40, 515.17856, 286.92, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1325, 67, 74.99121, 108.28767, 51.20928, 72.09915, 253, 4, 333, 0, 0, 0, 47, 115, 0, 1), 
(21136, 21136, "Dead Pit Horror", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 28, "male", "L2Monster", 40, 543.79576, 300.96, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1178, 62, 80.54056, 111.61368, 54.99876, 74.31365, 253, 4, 333, 0, 0, 0, 100, 100, 0, 1), 
(21137, 21137, "Iron Ore Golem", 0, "", 0, "LineageMonster.iron_golem", 18, 34, 29, "male", "L2Monster", 40, 573.42917, 315.12, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1268, 68, 86.42002, 115.00598, 59.01367, 76.57227, 253, 1, 333, 0, 0, 0, 20, 21, 0, 1), 
(21138, 21138, "Greedy Geist", 0, "", 0, "LineageMonster.hungry_spirit", 30, 40, 30, "male", "L2Monster", 40, 604.08419, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1361, 74, 92.64226, 118.46427, 63.26266, 78.87485, 253, 1, 333, 0, 0, 0, 15, 150, 0, 1), 
(21139, 21139, "Catacomb Barbed Bat", 0, "", 0, "LineageMonster.vampire_bat", 10, 33.5, 23, "male", "L2Monster", 40, 410.70422, 231.96, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 2621, 127, 55.84125, 95.64976, 38.13234, 63.68469, 253, 4, 333, 0, 0, 0, 60, 130, 0, 1), 
(21140, 21140, "Catacomb Wisp", 0, "", 0, "LineageMonster.will_o_wisp", 13, 22, 26, "male", "L2Monster", 40, 487.5704, 273, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 3153, 159, 69.75926, 105.02818, 47.63653, 69.92894, 253, 1, 333, 0, 0, 0, 80, 120, 0, 1), 
(21141, 21141, "Catacomb Serpent", 0, "", 0, "LineageMonster.serpent_slave", 17, 46, 28, "male", "L2Monster", 40, 543.79576, 300.96, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 3706, 194, 80.54056, 111.61368, 54.99876, 74.31365, 253, 4, 333, 73, 0, 0, 70, 130, 0, 1), 
(21142, 21142, "Grave Keeper Spartoi", 0, "", 0, "LineageMonster.spartoi", 11, 27, 29, "male", "L2Monster", 40, 573.42917, 315.12, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 3710, 199, 86.42002, 115.00598, 59.01367, 76.57227, 253, 4, 333, 221, 0, 0, 60, 140, 0, 1), 
(21143, 21143, "Catacomb Scavenger Bat", 0, "", 0, "LineageMonster.vampire_bat", 10, 33.5, 31, "male", "L2Monster", 40, 635.76437, 343.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 4170, 231, 99.21986, 121.98819, 67.7543, 81.22111, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(21144, 21144, "Catacomb Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 34, "male", "L2Monster", 40, 736.96177, 387.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 5016, 293, 121.20802, 132.9486, 82.76936, 88.51867, 253, 1, 333, 0, 0, 0, 80, 130, 0, 1), 
(21145, 21145, "Catacomb Stakato Soldier", 0, "", 0, "LineageMonster.blade_stakato_soldier", 15, 38, 38, "male", "L2Monster", 40, 886.09975, 447.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 6444, 402, 156.22273, 148.44287, 106.67987, 98.83494, 253, 4, 333, 232, 0, 0, 25, 150, 0, 1), 
(21146, 21146, "Grave Keeper Dark Horror", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 40, "male", "L2Monster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 6943, 448, 176.36077, 156.55035, 120.43155, 104.23299, 253, 4, 333, 0, 0, 0, 100, 160, 0, 1), 
(21147, 21147, "Catacomb Gargoyle", 0, "", 0, "LineageMonster.gargoyle", 16, 50, 43, "male", "L2Monster", 40, 1094.28943, 557.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 8457, 572, 210.04832, 169.13417, 143.43577, 112.61144, 253, 4, 333, 0, 0, 0, 140, 170, 0, 1), 
(21148, 21148, "Catacomb Liviona", 0, "", 0, "LineageMonster.liviona", 15, 28, 44, "male", "L2Monster", 40, 1138.62924, 584, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 8401, 575, 222.23112, 173.43552, 151.75505, 115.47533, 253, 1, 333, 0, 0, 0, 80, 140, 0, 1), 
(21149, 21149, "Decayed Ancient Pikeman", 0, "", 0, "LineageMonster.skeleton_pikeman", 10, 28, 46, "male", "L2Monster", 40, 1229.78678, 637.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 9679, 686, 248.0526, 182.18816, 169.38777, 121.30293, 253, 4, 333, 96, 0, 0, 50, 170, 0, 1), 
(21150, 21150, "Decayed Ancient Soldier", 0, "", 0, "LineageMonster.skeleton_knight", 10, 25, 49, "male", "L2Monster", 40, 1372.18568, 720, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 10982, 812, 290.44588, 195.66302, 198.33688, 130.27465, 253, 4, 333, 125, 0, 0, 40, 160, 0, 1), 
(21151, 21151, "Decayed Ancient Knight", 0, "", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 50, "male", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 11435, 861, 305.54906, 200.23844, 208.6504, 133.32101, 253, 4, 333, 227, 0, 0, 80, 170, 0, 1), 
(21152, 21152, "Purgatory Wisp", 0, "", 0, "LineageMonster.will_o_wisp", 13, 22, 53, "male", "L2Monster", 40, 1570.8463, 832.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 12189, 958, 353.71092, 214.18326, 241.5387, 142.60563, 253, 1, 333, 0, 0, 0, 80, 150, 0, 1), 
(21153, 21153, "Purgatory Serpent", 0, "", 0, "LineageMonster.serpent_slave", 17, 46, 56, "male", "L2Monster", 40, 1724.6831, 918.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 14344, 1178, 405.96455, 228.40135, 277.22116, 152.0722, 253, 4, 333, 73, 0, 0, 70, 175, 0, 1), 
(21154, 21154, "Hell Keeper Medusa", 0, "", 0, "LineageMonster.medusa", 10, 25, 58, "female", "L2Monster", 40, 1828.68266, 977.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 15013, 1268, 442.8992, 237.99429, 302.44274, 158.45929, 253, 4, 333, 0, 0, 0, 50, 165, 0, 1), 
(21155, 21155, "Purgatory Conjurer", 0, "", 0, "LineageMonster.vampire_bat", 10, 33.5, 59, "male", "L2Monster", 40, 1880.92519, 1007, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 15105, 1291, 461.94387, 242.81593, 315.44778, 161.66959, 253, 4, 333, 0, 0, 0, 60, 175, 0, 1), 
(21156, 21156, "Purgatory Shadow", 0, "", 0, "LineageMonster.shadow", 10, 30, 61, "male", "L2Monster", 40, 1985.55926, 1066.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 16146, 1421, 501.08068, 252.49346, 342.17315, 168.113, 253, 1, 333, 0, 0, 0, 80, 155, 0, 1), 
(21157, 21157, "Purgatory Tarantula", 0, "", 0, "LineageMonster.poison_spider", 27, 25.5, 64, "male", "L2Monster", 40, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 18280, 1674, 562.02275, 267.04468, 383.78868, 177.80136, 253, 4, 333, 0, 0, 0, 60, 175, 0, 1), 
(21158, 21158, "Hell Keeper Crimson Doll", 0, "", 0, "LineageMonster.crimson_doll", 15, 38, 67, "male", "L2Monster", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 20533, 1955, 624.93199, 281.55251, 426.74754, 187.46084, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), 
(21159, 21159, "Purgatory Gargoyle", 0, "", 0, "LineageMonster.gargoyle", 16, 50, 68, "male", "L2Monster", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 21151, 2043, 646.17968, 286.3615, 441.25696, 190.66272, 253, 4, 333, 0, 0, 0, 140, 175, 0, 1), 
(21160, 21160, "Purgatory Liviona", 0, "", 0, "LineageMonster.liviona", 15, 28, 71, "male", "L2Monster", 40, 2492.727, 1377.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 21874, 2195, 710.2185, 300.65359, 484.98717, 200.17855, 253, 1, 333, 0, 0, 0, 80, 160, 0, 1), 
(21161, 21161, "Lesser Ancient Soldier", 0, "", 0, "LineageMonster.medusa", 10, 25, 73, "female", "L2Monster", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 23782, 2447, 752.73928, 310.02959, 514.02335, 206.4212, 253, 4, 333, 0, 0, 0, 50, 180, 0, 1), 
(21162, 21162, "Lesser Ancient Scout", 0, "", 0, "LineageMonster.blade_stakato_drone", 15, 39, 74, "male", "L2Monster", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 23761, 2477, 773.81598, 314.65987, 528.41601, 209.50409, 253, 4, 333, 135, 0, 0, 25, 160, 0, 1), 
(21163, 21163, "Lesser Ancient Shaman", 0, "", 0, "LineageMonster.silhouette", 8, 23, 76, "female", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 25063, 2679, 815.37145, 323.78455, 556.793, 215.57941, 253, 4, 333, 0, 0, 0, 80, 200, 0, 1), 
(21164, 21164, "Guardian Spirit of Ancient Holy Ground", 0, "", 0, "LineageMonster.death_lord", 21, 40, 78, "male", "L2Monster", 40, 2870.777409, 1657.41, 8.585, 3.03, 40, 43, 30, 21, 20, 20, 28547, 3164, 884.25257, 340.44078, 609.86817, 226.66932, 253, 4, 333, 78, 0, 0, 40, 190, 0, 1), 
(21165, 21165, "Lesser Ancient Warrior", 0, "", 0, "LineageMonster.shadeless", 7, 28, 78, "male", "L2Monster", 40, 2937.983806, 1708.296, 8.67, 3.06, 40, 43, 30, 21, 20, 20, 31048, 3485, 912.65371, 348.2025, 635.68866, 231.83715, 253, 1, 333, 0, 0, 0, 48, 200, 0, 1), 
(21166, 21166, "Lith Scout", 0, "", 0, "LineageMonster2.temple_guard_a_20_sm", 12, 33.6, 21, "male", "L2Monster", 40, 364.30351, 205.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 2380, 109, 47.91924, 89.73059, 32.72263, 59.74364, 253, 8, 333, 5795, 0, 0, 53, 130, 0, 1), 
(21167, 21167, "Lith Witch", 0, "", 0, "LineageMonster2.temple_savant_a_20_sm", 8, 32, 24, "male", "L2Monster", 40, 435.34437, 245.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 2763, 136, 60.19687, 98.70919, 41.10666, 65.72169, 253, 1, 333, 5797, 0, 0, 25, 110, 0, 1), 
(21168, 21168, "Lith Warrior", 0, "", 0, "LineageMonster2.temple_guard_b_20_sm", 12, 33.6, 27, "male", "L2Monster", 40, 515.17856, 286.92, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 3420, 175, 74.99121, 108.28767, 51.20928, 72.09915, 253, 4, 333, 5796, 0, 0, 53, 130, 0, 1), 
(21169, 21169, "Lith Guard", 0, "", 0, "LineageMonster2.temple_guard_a", 15, 42, 30, "male", "L2Monster", 40, 604.08419, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 4532, 248, 92.64226, 118.46427, 63.26266, 78.87485, 253, 8, 333, 5795, 0, 0, 53, 140, 0, 1), 
(21170, 21170, "Lith Medium", 0, "", 0, "LineageMonster2.temple_savant_a", 10, 40, 33, "male", "L2Monster", 40, 702.20463, 372.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 5231, 300, 113.49065, 129.23095, 77.49941, 86.04342, 253, 1, 333, 5797, 0, 0, 25, 120, 0, 1), 
(21171, 21171, "Lith Overlord", 0, "", 0, "LineageMonster2.temple_guard_b", 15, 42, 36, "male", "L2Monster", 40, 809.52639, 417.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 6677, 404, 137.86467, 140.57278, 94.1437, 93.59494, 253, 4, 333, 5796, 0, 0, 53, 140, 0, 1), 
(21172, 21172, "Lith Patrolman", 0, "", 0, "LineageMonster2.temple_guard_a", 15, 42, 39, "male", "L2Monster", 40, 925.85879, 463.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 7888, 501, 166.06476, 152.46752, 113.4007, 101.5146, 253, 8, 333, 5795, 0, 0, 53, 150, 0, 1), 
(21173, 21173, "Lith Shaman", 0, "", 0, "LineageMonster2.temple_savant_a", 10, 40, 42, "male", "L2Monster", 40, 1050.81652, 531, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 8473, 564, 198.34591, 164.88513, 135.44454, 109.78238, 253, 1, 333, 5798, 0, 0, 25, 130, 0, 1), 
(21174, 21174, "Lith Commander", 0, "", 0, "LineageMonster2.temple_guard_b", 15, 42, 45, "male", "L2Monster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 10925, 760, 234.89829, 177.78746, 160.40508, 118.3729, 253, 4, 333, 5796, 0, 0, 53, 150, 0, 1), 
(21175, 21175, "Lilim Butcher", 0, "", 0, "LineageMonster2.lilim_assassin_10_sm", 11, 36, 48, "male", "L2Monster", 40, 1324.01623, 692.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 12374, 904, 275.82705, 191.12803, 188.35412, 127.2552, 253, 8, 333, 232, 232, 0, 36, 170, 0, 1), 
(21176, 21176, "Lilim Magus", 0, "", 0, "LineageMonster2.lilim_wizard_10_sm", 8, 30.6, 51, "female", "L2Monster", 40, 1470.41596, 775.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 12493, 953, 321.13207, 204.85194, 219.29157, 136.39273, 253, 1, 333, 0, 0, 0, 50, 140, 0, 1), 
(21177, 21177, "Lilim Knight Errant", 0, "", 0, "LineageMonster2.lilim_knight_10_sm", 11, 45, 54, "male", "L2Monster", 40, 1621.75618, 861, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 17542, 1399, 370.68904, 218.89589, 253.13256, 145.74335, 253, 4, 333, 5800, 5799, 0, 56, 170, 0, 1), 
(21178, 21178, "Lilim Marauder", 0, "", 0, "LineageMonster2.lilim_assassin_10_sm", 11, 36, 57, "male", "L2Monster", 40, 1776.58018, 948, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 18790, 1561, 424.23295, 233.18839, 289.69611, 155.25946, 253, 8, 333, 229, 229, 0, 36, 180, 0, 1), 
(21179, 21179, "Lilim Priest", 0, "", 0, "LineageMonster2.lilim_wizard_10_sm", 8, 30.6, 60, "female", "L2Monster", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 17292, 1501, 481.34551, 247.65008, 328.69659, 164.88822, 253, 1, 333, 0, 0, 0, 50, 160, 0, 1), 
(21180, 21180, "Lilim Knight", 0, "", 0, "LineageMonster2.lilim_knight_10_sm", 11, 45, 63, "male", "L2Monster", 40, 2089.92274, 1127.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 25957, 2344, 541.44774, 262.19426, 369.73862, 174.5719, 253, 4, 333, 5800, 5799, 0, 56, 180, 0, 1), 
(21181, 21181, "Lilim Assassin", 0, "", 0, "LineageMonster2.lilim_assassin_10_bi", 13, 44, 66, "male", "L2Monster", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 27475, 2586, 603.79903, 276.72752, 412.31647, 184.2483, 253, 8, 333, 234, 234, 0, 36, 190, 0, 1), 
(21182, 21182, "Lilim Soldier", 0, "", 0, "LineageMonster2.lilim_wizard_10_bi", 10, 37.5, 69, "female", "L2Monster", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 22868, 2237, 667.50361, 291.15063, 455.81844, 193.85137, 253, 1, 333, 0, 0, 0, 50, 170, 0, 1), 
(21183, 21183, "Lilim Knight Commander", 0, "", 0, "LineageMonster2.lilim_knight_10_bi", 13, 55, 72, "male", "L2Monster", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 33903, 3444, 731.52506, 305.35947, 499.53679, 203.31178, 253, 4, 333, 5800, 5799, 0, 56, 190, 0, 1), 
(21184, 21184, "Lilim Slayer", 0, "", 0, "LineageMonster2.lilim_assassin_10_bi", 13, 44, 75, "male", "L2Monster", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 35479, 3742, 794.70901, 319.24623, 542.68324, 212.55774, 253, 8, 333, 236, 236, 0, 36, 200, 0, 1), 
(21185, 21185, "Lilim Great Mystic", 0, "", 0, "LineageMonster2.lilim_wizard_10_bi", 10, 37.5, 78, "female", "L2Monster", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 29223, 3198, 855.81387, 332.70061, 584.40994, 221.51582, 253, 1, 333, 0, 0, 0, 50, 180, 0, 1), 
(21186, 21186, "Lilim Court Knight", 0, "", 0, "LineageMonster2.lilim_knight_10_bi", 13, 55, 78, "male", "L2Monster", 40, 2937.983806, 1708.296, 8.67, 3.06, 40, 43, 30, 21, 20, 20, 41856, 4698, 912.65371, 348.2025, 635.68866, 231.83715, 253, 4, 333, 5800, 5799, 0, 56, 200, 0, 1), 
(21187, 21187, "Gigant Slave", 0, "", 0, "LineageMonster2.tomb_guard_a_20_sm", 8, 32, 21, "male", "L2Monster", 40, 364.30351, 205.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 2380, 109, 47.91924, 89.73059, 32.72263, 59.74364, 253, 4, 333, 5791, 0, 0, 49, 130, 0, 1), 
(21188, 21188, "Gigant Acolyte", 0, "", 0, "LineageMonster2.tomb_savant_a_20_sm", 8, 32, 24, "male", "L2Monster", 40, 435.34437, 245.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 2763, 136, 60.19687, 98.70919, 41.10666, 65.72169, 253, 1, 333, 5793, 0, 0, 49, 110, 0, 1), 
(21189, 21189, "Gigant Overseer", 0, "", 0, "LineageMonster2.tomb_guard_b_20_sm", 12, 34, 27, "male", "L2Monster", 40, 515.17856, 286.92, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 3420, 175, 74.99121, 108.28767, 51.20928, 72.09915, 253, 4, 333, 5792, 0, 0, 49, 130, 0, 1), 
(21190, 21190, "Gigant Footman", 0, "", 0, "LineageMonster2.tomb_guard_a", 10, 40, 30, "male", "L2Monster", 40, 604.08419, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 4532, 248, 92.64226, 118.46427, 63.26266, 78.87485, 253, 4, 333, 5791, 0, 0, 49, 140, 0, 1), 
(21191, 21191, "Gigant Cleric", 0, "", 0, "LineageMonster2.tomb_savant_a", 10, 40, 33, "male", "L2Monster", 40, 702.20463, 372.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 5231, 300, 113.49065, 129.23095, 77.49941, 86.04342, 253, 1, 333, 5793, 0, 0, 49, 120, 0, 1), 
(21192, 21192, "Gigant Officer", 0, "", 0, "LineageMonster2.tomb_guard_b", 15, 42.5, 36, "male", "L2Monster", 40, 809.52639, 417.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 6677, 404, 137.86467, 140.57278, 94.1437, 93.59494, 253, 4, 333, 5792, 0, 0, 49, 140, 0, 1), 
(21193, 21193, "Gigant Raider", 0, "", 0, "LineageMonster2.tomb_guard_a", 10, 40, 39, "male", "L2Monster", 40, 925.85879, 463.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 7888, 501, 166.06476, 152.46752, 113.4007, 101.5146, 253, 4, 333, 5791, 0, 0, 49, 150, 0, 1), 
(21194, 21194, "Gigant Confessor", 0, "", 0, "LineageMonster2.tomb_savant_a", 10, 40, 42, "male", "L2Monster", 40, 1050.81652, 531, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 8473, 564, 198.34591, 164.88513, 135.44454, 109.78238, 253, 1, 333, 5794, 0, 0, 49, 130, 0, 1), 
(21195, 21195, "Gigant Commander", 0, "", 0, "LineageMonster2.tomb_guard_b", 15, 42.5, 45, "male", "L2Monster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 10925, 760, 234.89829, 177.78746, 160.40508, 118.3729, 253, 4, 333, 5792, 0, 0, 49, 150, 0, 1), 
(21196, 21196, "Nephilim Sentinel", 0, "", 0, "LineageMonster2.nephilim_slayer_10_sm", 11, 32.4, 48, "male", "L2Monster", 40, 1324.01623, 692.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 12374, 904, 275.82705, 191.12803, 188.35412, 127.2552, 253, 4, 333, 0, 0, 0, 65, 170, 0, 1), 
(21197, 21197, "Nephilim Priest", 0, "", 0, "LineageMonster2.nephilim_priest_10_sm", 21, 36.5, 51, "male", "L2Monster", 40, 1470.41596, 775.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 13567, 1034, 321.13207, 204.85194, 219.29157, 136.39273, 253, 1, 333, 0, 0, 0, 50, 140, 0, 1), 
(21198, 21198, "Nephilim Swordsman", 0, "", 0, "LineageMonster2.nephilim_lord_10_sm", 11, 39, 54, "male", "L2Monster", 40, 1621.75618, 861, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 17542, 1399, 370.68904, 218.89589, 253.13256, 145.74335, 253, 4, 333, 0, 0, 0, 65, 170, 0, 1), 
(21199, 21199, "Nephilim Guard", 0, "", 0, "LineageMonster2.nephilim_slayer_10_sm", 11, 32.4, 57, "male", "L2Monster", 40, 1776.58018, 948, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 18790, 1561, 424.23295, 233.18839, 289.69611, 155.25946, 253, 4, 333, 0, 0, 0, 65, 180, 0, 1), 
(21200, 21200, "Nephilim Bishop", 0, "", 0, "LineageMonster2.nephilim_priest_10_sm", 21, 36.5, 60, "male", "L2Monster", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 18777, 1630, 481.34551, 247.65008, 328.69659, 164.88822, 253, 1, 333, 0, 0, 0, 50, 160, 0, 1), 
(21201, 21201, "Nephilim Centurion", 0, "", 0, "LineageMonster2.nephilim_lord_10_sm", 11, 39, 63, "male", "L2Monster", 40, 2089.92274, 1127.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 25957, 2344, 541.44774, 262.19426, 369.73862, 174.5719, 253, 4, 333, 0, 0, 0, 65, 180, 0, 1), 
(21202, 21202, "Nephilim Scout", 0, "", 0, "LineageMonster2.nephilim_slayer_10_bi", 13, 39.6, 66, "male", "L2Monster", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 27475, 2586, 603.79903, 276.72752, 412.31647, 184.2483, 253, 4, 333, 0, 0, 0, 65, 190, 0, 1), 
(21203, 21203, "Nephilim Archbishop", 0, "", 0, "LineageMonster2.nephilim_priest_10_bi", 21, 44, 69, "male", "L2Monster", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 24833, 2430, 667.50361, 291.15063, 455.81844, 193.85137, 253, 1, 333, 0, 0, 0, 50, 170, 0, 1), 
(21204, 21204, "Nephilim Praetorian", 0, "", 0, "LineageMonster2.nephilim_lord_10_bi", 13, 48, 72, "male", "L2Monster", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 33903, 3444, 731.52506, 305.35947, 499.53679, 203.31178, 253, 4, 333, 0, 0, 0, 65, 190, 0, 1), 
(21205, 21205, "Nephilim Royal Guard", 0, "", 0, "LineageMonster2.nephilim_slayer_10_bi", 13, 39.6, 75, "male", "L2Monster", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 35479, 3742, 794.70901, 319.24623, 542.68324, 212.55774, 253, 4, 333, 0, 0, 0, 65, 200, 0, 1), 
(21206, 21206, "Nephilim Cardinal", 0, "", 0, "LineageMonster2.nephilim_priest_10_bi", 21, 44, 78, "male", "L2Monster", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 31734, 3473, 855.81387, 332.70061, 584.40994, 221.51582, 253, 1, 333, 0, 0, 0, 50, 180, 0, 1), 
(21207, 21207, "Nephilim Commander", 0, "", 0, "LineageMonster2.nephilim_lord_10_bi", 13, 48, 78, "male", "L2Monster", 40, 2937.983806, 1708.296, 8.67, 3.06, 40, 43, 30, 21, 20, 20, 41856, 4698, 912.65371, 348.2025, 635.68866, 231.83715, 253, 4, 333, 0, 0, 0, 65, 200, 0, 1), 
(21208, 21208, "Hallowed Watchman", 0, "", 0, "LineageMonster.skeleton", 11, 25, 20, "male", "L2Monster", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 2085, 92, 44.32863, 86.87049, 30.2707, 57.83936, 253, 4, 333, 216, 111, 0, 60, 130, 0, 1), 
(21209, 21209, "Hallowed Seer", 0, "", 0, "LineageMonster.binding", 12, 21, 22, "male", "L2Monster", 40, 387.02878, 218.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 2450, 116, 51.75278, 92.65694, 35.34044, 61.69203, 253, 1, 333, 0, 0, 0, 10, 110, 0, 1), 
(21210, 21210, "Vault Guardian", 0, "", 0, "LineageMonster.imp", 10, 24, 25, "male", "L2Monster", 40, 460.96247, 259.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 3121, 156, 64.83203, 101.83533, 44.27187, 67.80312, 253, 4, 333, 0, 0, 0, 60, 130, 0, 1), 
(21211, 21211, "Vault Seer", 0, "", 0, "LineageMonster.succubus", 10, 36, 27, "female", "L2Monster", 40, 515.17856, 286.92, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 3321, 170, 74.99121, 108.28767, 51.20928, 72.09915, 253, 4, 333, 0, 0, 0, 60, 110, 0, 1), 
(21212, 21212, "Hallowed Sentinel", 0, "", 0, "LineageMonster.skeleton_bi", 11, 31, 30, "male", "L2Monster", 40, 604.08419, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 3829, 209, 92.64226, 118.46427, 63.26266, 78.87485, 253, 4, 333, 69, 646, 0, 60, 140, 0, 1), 
(21213, 21213, "Hallowed Monk", 0, "", 0, "LineageMonster.binding_20_bi", 14, 25.3, 32, "male", "L2Monster", 40, 668.47132, 358.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 4443, 250, 106.16525, 125.57727, 72.49711, 83.61076, 253, 1, 333, 0, 0, 0, 10, 110, 0, 1), 
(21214, 21214, "Vault Sentinel", 0, "", 0, "LineageMonster.imp_bi", 10, 30, 35, "male", "L2Monster", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 5603, 332, 129.32896, 136.72948, 88.31491, 91.03603, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(21215, 21215, "Vault Monk", 0, "", 0, "LineageMonster.succubus_bi", 10, 43.2, 37, "female", "L2Monster", 40, 847.31754, 432.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 5940, 365, 146.82587, 144.47758, 100.26304, 96.19481, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(21216, 21216, "Overlord of the Holy Lands", 0, "", 0, "LineageMonster.skeleton_knight_20_bi", 12, 30.5, 40, "male", "L2Monster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 6807, 440, 176.36077, 156.55035, 120.43155, 104.23299, 253, 4, 333, 129, 646, 0, 40, 160, 0, 1), 
(21217, 21217, "Hallowed Priest", 0, "", 0, "LineageMonster.banshee_20_bi", 10, 27.5, 42, "female", "L2Monster", 40, 1050.81652, 531, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 7654, 510, 198.34591, 164.88513, 135.44454, 109.78238, 253, 4, 333, 0, 0, 0, 80, 135, 0, 1), 
(21218, 21218, "Vault Overlord", 0, "", 0, "LineageMonster.death_blader_10_sm", 14, 40.5, 45, "male", "L2Monster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 9263, 644, 234.89829, 177.78746, 160.40508, 118.3729, 253, 4, 333, 297, 0, 0, 100, 160, 0, 1), 
(21219, 21219, "Vault Priest", 0, "", 0, "LineageMonster.bloody_queen_10_sm", 13, 38, 47, "female", "L2Monster", 40, 1276.53628, 665, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 9585, 687, 261.69549, 186.63569, 178.7041, 124.26415, 253, 4, 333, 0, 0, 0, 80, 135, 0, 1), 
(21220, 21220, "Sepulcher Archon", 0, "", 0, "LineageMonster.skeleton_knight_30_bi", 13, 33, 50, "male", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 10635, 801, 305.54906, 200.23844, 208.6504, 133.32101, 253, 4, 333, 131, 107, 0, 40, 170, 0, 1), 
(21221, 21221, "Sepulcher Inquisitor", 0, "", 0, "LineageMonster.banshee_30_bi", 11, 30, 52, "female", "L2Monster", 40, 1520.38155, 804, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 11733, 908, 337.18867, 209.50106, 230.25615, 139.48817, 253, 4, 333, 0, 0, 0, 80, 145, 0, 1), 
(21222, 21222, "Sepulcher Archon", 0, "", 0, "LineageMonster.death_blader_10_bi", 16, 49.5, 55, "male", "L2Monster", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 13837, 1117, 388.11142, 223.6362, 265.02979, 148.89951, 253, 4, 333, 298, 0, 0, 100, 170, 0, 1), 
(21223, 21223, "Sepulcher Inquisitor", 0, "", 0, "LineageMonster.bloody_queen_10_bi", 15, 46, 57, "female", "L2Monster", 40, 1776.58018, 948, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 14098, 1172, 424.23295, 233.18839, 289.69611, 155.25946, 253, 4, 333, 0, 0, 0, 80, 145, 0, 1), 
(21224, 21224, "Sepulcher Guardian", 0, "", 0, "LineageMonster.skeleton_royal_guard_20_bi", 13, 34.5, 60, "male", "L2Monster", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 15315, 1329, 481.34551, 247.65008, 328.69659, 164.88822, 253, 8, 333, 233, 0, 0, 80, 190, 0, 1), 
(21225, 21225, "Sepulcher Sage", 0, "", 0, "LineageMonster.vale_master_10_bi", 13, 44, 62, "male", "L2Monster", 40, 2037.81082, 1097, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 16680, 1486, 521.12391, 257.34267, 355.86007, 171.34165, 253, 4, 333, 311, 0, 0, 70, 160, 0, 1), 
(21226, 21226, "Sepulcher Guardian", 0, "", 0, "LineageMonster.death_knight", 12, 31, 65, "male", "L2Monster", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 19326, 1795, 582.81759, 271.89033, 397.98887, 181.02764, 253, 4, 333, 0, 0, 0, 27, 190, 0, 1), 
(21227, 21227, "Sepulcher Sage", 0, "", 0, "LineageMonster.doll_master", 20, 42, 67, "male", "L2Monster", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 21777, 2074, 624.93199, 281.55251, 426.74754, 187.46084, 253, 4, 333, 0, 0, 0, 80, 160, 0, 1), 
(21228, 21228, "Sepulcher Guard", 0, "", 0, "LineageMonster.skeleton_royal_guard_30_bi", 14, 37.5, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 20845, 2067, 688.86373, 295.91597, 470.40463, 197.0242, 253, 8, 333, 236, 0, 0, 80, 200, 0, 1), 
(21229, 21229, "Sepulcher Preacher", 0, "", 0, "LineageMonster.vale_master_30_bi", 15, 52, 72, "male", "L2Monster", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 22494, 2285, 731.52506, 305.35947, 499.53679, 203.31178, 253, 4, 333, 326, 0, 0, 70, 165, 0, 1), 
(21230, 21230, "Sepulcher Guard", 0, "", 0, "LineageMonster.death_knight", 12, 31, 75, "male", "L2Monster", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 25729, 2714, 794.70901, 319.24623, 542.68324, 212.55774, 253, 4, 333, 0, 0, 0, 27, 200, 0, 1), 
(21231, 21231, "Sepulcher Preacher", 0, "", 0, "LineageMonster.doll_master_20_bi", 24, 50.4, 77, "male", "L2Monster", 40, 2762.08447, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 25727, 2784, 835.75573, 328.27073, 570.71283, 218.56635, 253, 4, 333, 0, 0, 0, 80, 165, 0, 1), 
(21232, 21232, "Barrow Guardian", 0, "", 0, "LineageMonster.skeleton", 11, 25, 20, "male", "L2Monster", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 2085, 92, 44.32863, 86.87049, 30.2707, 57.83936, 253, 4, 333, 216, 0, 0, 60, 130, 0, 1), 
(21233, 21233, "Barrow Seer", 0, "", 0, "LineageMonster.binding", 12, 21, 22, "male", "L2Monster", 40, 387.02878, 218.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 2450, 116, 51.75278, 92.65694, 35.34044, 61.69203, 253, 1, 333, 0, 0, 0, 10, 110, 0, 1), 
(21234, 21234, "Grave Guardian", 0, "", 0, "LineageMonster.imp", 10, 24, 25, "male", "L2Monster", 40, 460.96247, 259.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 3121, 156, 64.83203, 101.83533, 44.27187, 67.80312, 253, 4, 333, 0, 0, 0, 60, 130, 0, 1), 
(21235, 21235, "Grave Seer", 0, "", 0, "LineageMonster.succubus", 10, 36, 27, "female", "L2Monster", 40, 515.17856, 286.92, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 3321, 170, 74.99121, 108.28767, 51.20928, 72.09915, 253, 4, 333, 0, 0, 0, 60, 110, 0, 1), 
(21236, 21236, "Barrow Sentinel", 0, "", 0, "LineageMonster.skeleton_bi", 11, 31, 30, "male", "L2Monster", 40, 604.08419, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 3829, 209, 92.64226, 118.46427, 63.26266, 78.87485, 253, 4, 333, 69, 0, 0, 60, 140, 0, 1), 
(21237, 21237, "Barrow Monk", 0, "", 0, "LineageMonster.binding_20_bi", 14, 25.3, 32, "male", "L2Monster", 40, 668.47132, 358.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 4443, 250, 106.16525, 125.57727, 72.49711, 83.61076, 253, 1, 333, 0, 0, 0, 10, 110, 0, 1), 
(21238, 21238, "Grave Sentinel", 0, "", 0, "LineageMonster.imp_bi", 10, 30, 35, "male", "L2Monster", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 5603, 332, 129.32896, 136.72948, 88.31491, 91.03603, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(21239, 21239, "Grave Monk", 0, "", 0, "LineageMonster.succubus_bi", 10, 43.2, 37, "female", "L2Monster", 40, 847.31754, 432.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 5940, 365, 146.82587, 144.47758, 100.26304, 96.19481, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(21240, 21240, "Barrow Overlord", 0, "", 0, "LineageMonster.skeleton_knight_20_bi", 12, 30.5, 40, "male", "L2Monster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 6807, 440, 176.36077, 156.55035, 120.43155, 104.23299, 253, 4, 333, 129, 0, 0, 40, 160, 0, 1), 
(21241, 21241, "Barrow Priest", 0, "", 0, "LineageMonster.banshee_20_bi", 10, 27.5, 42, "female", "L2Monster", 40, 1050.81652, 531, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 7654, 510, 198.34591, 164.88513, 135.44454, 109.78238, 253, 4, 333, 0, 0, 0, 80, 135, 0, 1), 
(21242, 21242, "Grave Overlord", 0, "", 0, "LineageMonster.death_blader_10_sm", 14, 40.5, 45, "male", "L2Monster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 9263, 644, 234.89829, 177.78746, 160.40508, 118.3729, 253, 4, 333, 297, 0, 0, 100, 160, 0, 1), 
(21243, 21243, "Grave Priest", 0, "", 0, "LineageMonster.bloody_queen_10_sm", 13, 38, 47, "female", "L2Monster", 40, 1276.53628, 665, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 9585, 687, 261.69549, 186.63569, 178.7041, 124.26415, 253, 4, 333, 0, 0, 0, 80, 135, 0, 1), 
(21244, 21244, "Crypt Archon", 0, "", 0, "LineageMonster.skeleton_knight_30_bi", 13, 33, 50, "male", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 10635, 801, 305.54906, 200.23844, 208.6504, 133.32101, 253, 4, 333, 131, 0, 0, 40, 170, 0, 1), 
(21245, 21245, "Crypt Inquisitor", 0, "", 0, "LineageMonster.banshee_30_bi", 11, 30, 52, "female", "L2Monster", 40, 1520.38155, 804, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 11733, 908, 337.18867, 209.50106, 230.25615, 139.48817, 253, 4, 333, 0, 0, 0, 80, 145, 0, 1), 
(21246, 21246, "Tomb Archon", 0, "", 0, "LineageMonster.death_blader_10_bi", 16, 49.5, 55, "male", "L2Monster", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 13837, 1117, 388.11142, 223.6362, 265.02979, 148.89951, 253, 4, 333, 298, 0, 0, 100, 170, 0, 1), 
(21247, 21247, "Tomb Inquisitor", 0, "", 0, "LineageMonster.bloody_queen_10_bi", 15, 46, 57, "female", "L2Monster", 40, 1776.58018, 948, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 14098, 1172, 424.23295, 233.18839, 289.69611, 155.25946, 253, 4, 333, 0, 0, 0, 80, 145, 0, 1), 
(21248, 21248, "Crypt Guardian", 0, "", 0, "LineageMonster.skeleton_royal_guard_20_bi", 13, 34.5, 60, "male", "L2Monster", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 15315, 1329, 481.34551, 247.65008, 328.69659, 164.88822, 253, 8, 333, 233, 0, 0, 80, 190, 0, 1), 
(21249, 21249, "Crypt Sage", 0, "", 0, "LineageMonster.vale_master_10_bi", 13, 44, 62, "male", "L2Monster", 40, 2037.81082, 1097, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 16680, 1486, 521.12391, 257.34267, 355.86007, 171.34165, 253, 4, 333, 311, 0, 0, 70, 160, 0, 1), 
(21250, 21250, "Tomb Guardian", 0, "", 0, "LineageMonster.death_knight", 12, 31, 65, "male", "L2Monster", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 19326, 1795, 582.81759, 271.89033, 397.98887, 181.02764, 253, 4, 333, 0, 0, 0, 27, 190, 0, 1), 
(21251, 21251, "Tomb Sage", 0, "", 0, "LineageMonster.doll_master", 20, 42, 67, "male", "L2Monster", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 21777, 2074, 624.93199, 281.55251, 426.74754, 187.46084, 253, 4, 333, 0, 0, 0, 80, 160, 0, 1), 
(21252, 21252, "Crypt Guard", 0, "", 0, "LineageMonster.skeleton_royal_guard_30_bi", 14, 37.5, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 20845, 2067, 688.86373, 295.91597, 470.40463, 197.0242, 253, 8, 333, 236, 0, 0, 80, 200, 0, 1), 
(21253, 21253, "Crypt Preacher", 0, "", 0, "LineageMonster.vale_master_30_bi", 15, 52, 72, "male", "L2Monster", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 22494, 2285, 731.52506, 305.35947, 499.53679, 203.31178, 253, 4, 333, 326, 0, 0, 70, 165, 0, 1), 
(21254, 21254, "Tomb Guard", 0, "", 0, "LineageMonster.death_knight", 12, 31, 75, "male", "L2Monster", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 25729, 2714, 794.70901, 319.24623, 542.68324, 212.55774, 253, 4, 333, 78, 0, 0, 27, 200, 0, 1), 
(21255, 21255, "Tomb Preacher", 0, "", 0, "LineageMonster.doll_master_20_bi", 24, 50.4, 77, "male", "L2Monster", 40, 2762.08447, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 28763, 3113, 835.75573, 328.27073, 570.71283, 218.56635, 253, 4, 333, 0, 0, 0, 80, 165, 0, 1), 
(21256, 21256, "Underground Werewolf", 0, "", 0, "LineageMonster.werewolf_bi", 11, 29.7, 23, "male", "L2Monster", 40, 410.70422, 231.96, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 905, 43, 55.84125, 95.64976, 38.13234, 63.68469, 253, 1, 333, 0, 0, 0, 50, 135, 0, 1), 
(21257, 21257, "Evil Eye Seer", 0, "", 0, "LineageMonster.monster_eye", 21, 43, 18, "male", "L2Monster", 40, 301.66622, 174.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 646, 28, 37.82932, 81.34791, 25.83252, 54.16236, 253, 1, 333, 0, 0, 0, 90, 155, 1, 1), 
(21258, 21258, "Fallen Orc Shaman", 0, "", 0, "LineageMonster.ketra_orc_shaman", 10, 23, 58, "male", "L2Monster", 40, 1828.68266, 977.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 442.8992, 237.99429, 302.44274, 158.45929, 253, 1, 333, 9, 0, 0, 10, 130, 1, 1), 
(21259, 21259, "Fallen Orc Shaman", 0, "", 0, "LineageMonster.saber_toothed_tiger", 34, 28, 59, "male", "L2Monster", 40, 1880.92519, 1007, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 15580, 1332, 461.94387, 242.81593, 315.44778, 161.66959, 253, 4, 333, 0, 0, 0, 60, 180, 1, 1), 
(21260, 21260, "Betrayer Orc Hero", 0, "", 0, "LineageMonster.ketra_orc_warrior", 12, 24, 50, "male", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4429, 334, 305.54906, 200.23844, 208.6504, 133.32101, 253, 4, 333, 74, 0, 0, 36, 170, 0, 1), 
(21261, 21261, "Ol Mahum Transcender", 0, "", 0, "LineageMonster.ol_mahum", 13.5, 25, 50, "male", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4954, 372, 305.54906, 200.23844, 208.6504, 146.5258, 253, 4, 333, 127, 0, 0, 50, 110, 1, 1), 
(21262, 21262, "Ol Mahum Transcender", 0, "", 0, "LineageMonster.ol_mahum_champion", 14, 27, 53, "male", "L2Monster", 40, 1570.8463, 832.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 6631, 496, 353.71092, 214.18326, 241.5387, 156.73001, 253, 4, 333, 127, 102, 0, 50, 110, 1, 1), 
(21263, 21263, "Ol Mahum Transcender", 0, "", 0, "LineageMonster.oel_mahum", 20, 37, 55, "male", "L2Monster", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 9634, 691, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 127, 0, 0, 70, 110, 1, 1), 
(21264, 21264, "Ol Mahum Transcender", 0, "", 0, "LineageMonster.kel_mahum", 13, 26, 58, "male", "L2Monster", 40, 1828.68266, 977.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 13535, 933, 442.8992, 237.99429, 302.44274, 174.1539, 253, 4, 333, 127, 0, 0, 50, 160, 1, 1), 
(21265, 21265, "Cave Ant Larva", 0, "", 0, "LineageMonster.ant_larva", 12, 8, 36, "male", "L2Monster", 40, 809.52639, 417.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1904, 115, 137.86467, 140.57278, 94.1437, 93.59494, 253, 4, 333, 0, 0, 0, 40, 60, 1, 1), 
(21266, 21266, "Cave Ant Larva", 0, "", 0, "LineageMonster.ant_larva", 12, 8, 36, "male", "L2Monster", 40, 809.52639, 417.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 137.86467, 140.57278, 94.1437, 93.59494, 253, 4, 333, 0, 0, 0, 40, 60, 1, 1), 
(21267, 21267, "Cave Ant Larva", 0, "", 0, "LineageMonster.ant_larva", 12, 8, 36, "male", "L2Monster", 40, 809.52639, 417.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 137.86467, 140.57278, 94.1437, 93.59494, 253, 4, 333, 0, 0, 0, 40, 60, 1, 1), 
(21268, 21268, "Cave Ant Larva", 0, "", 0, "LineageMonster.ant_larva", 12, 8, 36, "male", "L2Monster", 40, 809.52639, 417.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 3541, 214, 137.86467, 140.57278, 94.1437, 93.59494, 253, 4, 333, 0, 0, 0, 40, 60, 1, 1), 
(21269, 21269, "Cave Ant", 0, "", 0, "LineageMonster.ant", 26, 15, 37, "male", "L2Monster", 40, 847.31754, 432.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 4042, 248, 146.82587, 144.47758, 100.26304, 96.19481, 253, 4, 333, 0, 0, 0, 40, 130, 1, 1), 
(21270, 21270, "Cave Ant Soldier", 0, "", 0, "LineageMonster.ant_soldier", 35, 17, 38, "male", "L2Monster", 40, 886.09975, 447.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 4670, 292, 156.22273, 148.44287, 106.67987, 98.83494, 253, 4, 333, 0, 0, 0, 80, 130, 1, 1), 
(21271, 21271, "Cave Ant", 0, "", 0, "LineageMonster.ant", 26, 15, 37, "male", "L2Monster", 40, 847.31754, 432.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2758, 169, 146.82587, 144.47758, 100.26304, 96.19481, 253, 4, 333, 0, 0, 0, 40, 130, 1, 1), 
(21272, 21272, "Cave Ant Soldier", 0, "", 0, "LineageMonster.ant_soldier", 35, 17, 38, "male", "L2Monster", 40, 886.09975, 447.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 4902, 306, 156.22273, 148.44287, 106.67987, 98.83494, 253, 4, 333, 0, 0, 0, 80, 130, 1, 1), 
(21273, 21273, "Cave Noble Ant", 0, "", 0, "LineageMonster.noble_ant", 20, 48, 39, "male", "L2Monster", 40, 925.85879, 463.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 14204, 902, 166.06476, 152.46752, 113.4007, 101.5146, 253, 4, 333, 0, 0, 0, 80, 174, 1, 1), 
(21274, 21274, "Kookaburra", 0, "", 0, "LineageMonster2.youth_ostrich", 8, 26.4, 67, "male", "L2Monster", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 8972, 854, 624.93199, 281.55251, 426.74754, 206.02791, 253, 4, 333, 0, 0, 0, 23, 190, 1, 1), 
(21275, 21275, "Kookaburra", 0, "", 0, "LineageMonster2.youth_ostrich", 8, 26.4, 67, "male", "L2Monster", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9030, 859, 624.93199, 281.55251, 426.74754, 206.02791, 253, 4, 333, 0, 0, 0, 23, 190, 1, 1), 
(21276, 21276, "Kookaburra", 0, "", 0, "LineageMonster2.youth_ostrich", 8, 26.4, 67, "male", "L2Monster", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 8921, 848, 624.93199, 281.55251, 426.74754, 206.02791, 253, 4, 333, 0, 0, 0, 23, 190, 1, 1), 
(21278, 21278, "Antelope", 0, "", 0, "LineageMonster2.antelope", 17, 34, 68, "male", "L2Monster", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9242, 892, 646.17968, 286.3615, 441.25696, 209.54692, 253, 4, 333, 0, 0, 0, 45, 185, 1, 1), 
(21279, 21279, "Antelope", 0, "", 0, "LineageMonster2.antelope", 17, 34, 68, "male", "L2Monster", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9189, 887, 646.17968, 286.3615, 441.25696, 209.54692, 253, 4, 333, 0, 0, 0, 45, 185, 1, 1), 
(21280, 21280, "Antelope", 0, "", 0, "LineageMonster2.antelope", 17, 34, 68, "male", "L2Monster", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9302, 898, 646.17968, 286.3615, 441.25696, 209.54692, 253, 4, 333, 0, 0, 0, 45, 185, 1, 1), 
(21282, 21282, "Bandersnatch", 0, "", 0, "LineageMonster2.bandersnatch", 18, 25, 69, "male", "L2Monster", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9516, 930, 667.50361, 291.15063, 455.81844, 213.05139, 253, 4, 333, 0, 0, 0, 30, 170, 1, 1), 
(21283, 21283, "Bandersnatch", 0, "", 0, "LineageMonster2.bandersnatch", 18, 25, 69, "male", "L2Monster", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9578, 936, 667.50361, 291.15063, 455.81844, 213.05139, 253, 4, 333, 0, 0, 0, 30, 170, 1, 1), 
(21284, 21284, "Bandersnatch", 0, "", 0, "LineageMonster2.bandersnatch", 18, 25, 69, "male", "L2Monster", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9461, 925, 667.50361, 291.15063, 455.81844, 213.05139, 253, 4, 333, 0, 0, 0, 30, 170, 1, 1), 
(21286, 21286, "Buffalo", 0, "", 0, "LineageMonster2.buffalo", 22, 31, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9794, 971, 688.86373, 295.91597, 470.40463, 216.53847, 253, 1, 333, 0, 0, 0, 80, 170, 1, 1), 
(21287, 21287, "Buffalo", 0, "", 0, "LineageMonster2.buffalo", 22, 31, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9737, 965, 688.86373, 295.91597, 470.40463, 216.53847, 253, 1, 333, 0, 0, 0, 80, 170, 1, 1), 
(21288, 21288, "Buffalo", 0, "", 0, "LineageMonster2.buffalo", 22, 31, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9857, 977, 688.86373, 295.91597, 470.40463, 216.53847, 253, 1, 333, 0, 0, 0, 80, 170, 1, 1), 
(21290, 21290, "Grendel", 0, "", 0, "LineageMonster2.bionic_bear", 15, 39, 71, "male", "L2Monster", 40, 2492.727, 1377.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 10076, 1010, 710.2185, 300.65359, 484.98717, 220.00525, 253, 4, 333, 0, 0, 0, 36, 155, 1, 1), 
(21291, 21291, "Grendel", 0, "", 0, "LineageMonster2.bionic_bear", 15, 39, 71, "male", "L2Monster", 40, 2492.727, 1377.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 10017, 1004, 710.2185, 300.65359, 484.98717, 220.00525, 253, 4, 333, 0, 0, 0, 36, 155, 1, 1), 
(21292, 21292, "Grendel", 0, "", 0, "LineageMonster2.bionic_bear", 15, 39, 71, "male", "L2Monster", 40, 2492.727, 1377.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 10141, 1016, 710.2185, 300.65359, 484.98717, 220.00525, 253, 4, 333, 0, 0, 0, 36, 155, 1, 1), 
(21294, 21294, "Canyon Antelope", 0, "", 0, "LineageMonster2.antelope", 17, 34, 68, "male", "L2Monster", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 16544, 1598, 646.17968, 286.3615, 441.25696, 190.66272, 253, 4, 333, 0, 0, 0, 45, 185, 0, 1), 
(21295, 21295, "Canyon Antelope Slave", 0, "", 0, "LineageMonster2.antelope", 17, 34, 69, "male", "L2Monster", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 17547, 1717, 667.50361, 291.15063, 455.81844, 193.85137, 253, 4, 333, 0, 0, 0, 45, 165, 0, 1), 
(21296, 21296, "Canyon Bandersnatch", 0, "", 0, "LineageMonster2.bandersnatch", 18, 25, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 26081, 2586, 688.86373, 295.91597, 470.40463, 197.0242, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(21297, 21297, "Canyon Bandersnatch Slave", 0, "", 0, "LineageMonster2.bandersnatch", 18, 25, 71, "male", "L2Monster", 40, 2492.727, 1377.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 26191, 2628, 710.2185, 300.65359, 484.98717, 200.17855, 253, 4, 333, 0, 0, 0, 30, 170, 0, 1), 
(21298, 21298, "Eye of Restrainer", 0, "", 0, "LineageMonster.monster_eye", 21, 43, 71, "male", "L2Monster", 40, 2492.727, 1377.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 16857, 1692, 710.2185, 300.65359, 484.98717, 200.17855, 253, 4, 333, 0, 0, 0, 90, 140, 0, 1), 
(21299, 21299, "Buffalo Slave", 0, "", 0, "LineageMonster2.buffalo_ec", 22, 31, 72, "male", "L2Monster", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 26934, 2736, 731.52506, 305.35947, 499.53679, 203.31178, 253, 1, 333, 0, 0, 0, 20, 160, 0, 1), 
(21300, 21300, "Eye of Guide", 0, "", 0, "LineageMonster2.parasitic_eye_20_sm", 20, 50.5, 72, "male", "L2Monster", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 26498, 2692, 731.52506, 305.35947, 499.53679, 203.31178, 253, 4, 333, 0, 0, 0, 30, 155, 0, 1), 
(21301, 21301, "Gaze of Nightmare", 0, "", 0, "LineageMonster.field_stalker", 15, 30, 72, "male", "L2Monster", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 31797, 3230, 731.52506, 305.35947, 499.53679, 203.31178, 253, 4, 333, 0, 0, 0, 70, 195, 0, 1), 
(21302, 21302, "Eye of Watchman", 0, "", 0, "LineageMonster2.parasitic_eye", 25, 63, 73, "male", "L2Monster", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 25580, 2632, 752.73928, 310.02959, 514.02335, 206.4212, 253, 4, 333, 0, 0, 0, 30, 160, 0, 1), 
(21303, 21303, "Homunculus", 0, "", 0, "LineageMonster2.homunculus_20_sm", 10, 26, 73, "male", "L2Monster", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 25867, 2662, 752.73928, 310.02959, 514.02335, 206.4212, 253, 4, 333, 0, 0, 0, 30, 185, 0, 1), 
(21304, 21304, "Grendel Slave", 0, "", 0, "LineageMonster2.bionic_bear", 15, 39, 74, "male", "L2Monster", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 38011, 3962, 773.81598, 314.65987, 528.41601, 209.50409, 253, 4, 333, 0, 0, 0, 36, 140, 0, 1), 
(21305, 21305, "Eye of Pilgrim", 0, "", 0, "LineageMonster2.parasitic_eye_20_sm", 20, 50.5, 74, "male", "L2Monster", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 27990, 2917, 773.81598, 314.65987, 528.41601, 209.50409, 253, 4, 333, 0, 0, 0, 30, 165, 0, 1), 
(21306, 21306, "Disciples of Protection", 0, "", 0, "LineageMonster2.apostle_warrior", 8, 30, 74, "female", "L2Monster", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 50649, 5280, 773.81598, 314.65987, 528.41601, 209.50409, 253, 4, 333, 6717, 0, 0, 50, 160, 0, 1), 
(21307, 21307, "Elder Homunculus", 0, "", 0, "LineageMonster2.homunculus", 12, 32.5, 75, "male", "L2Monster", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 35496, 3744, 794.70901, 319.24623, 542.68324, 212.55774, 253, 4, 333, 0, 0, 0, 30, 200, 0, 1), 
(21308, 21308, "Disciples of Punishment", 0, "", 0, "LineageMonster2.apostle_warrior", 8, 30, 75, "female", "L2Monster", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 47163, 4975, 794.70901, 319.24623, 542.68324, 212.55774, 253, 4, 333, 6717, 0, 0, 50, 190, 0, 1), 
(21309, 21309, "Disciples of Punishment", 0, "", 0, "LineageMonster2.apostle_warrior", 8, 30, 75, "female", "L2Monster", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 49155, 5185, 794.70901, 319.24623, 542.68324, 212.55774, 253, 4, 333, 6717, 0, 0, 50, 190, 0, 1), 
(21310, 21310, "Disciples of Authority", 0, "", 0, "LineageMonster2.apostle_mage", 11, 38.5, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 40357, 4315, 815.37145, 323.78455, 556.793, 215.57941, 253, 1, 333, 6718, 0, 0, 50, 155, 0, 1), 
(21311, 21311, "Disciples of Authority", 0, "", 0, "LineageMonster2.apostle_mage", 11, 38.5, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 37210, 3978, 815.37145, 323.78455, 556.793, 215.57941, 253, 1, 333, 6718, 0, 0, 50, 155, 0, 1), 
(21312, 21312, "Eye of Ruler", 0, "", 0, "LineageMonster2.parasitic_eye", 25, 63, 74, "male", "L2Monster", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 38709, 4036, 773.81598, 314.65987, 528.41601, 209.50409, 253, 4, 333, 0, 0, 0, 30, 160, 0, 1), 
(21313, 21313, "Sly Hound Dog", 0, "", 0, "LineageMonster2.bandersnatch", 18, 25, 72, "male", "L2Monster", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 37061, 3766, 731.52506, 305.35947, 499.53679, 203.31178, 253, 4, 333, 0, 0, 0, 30, 185, 0, 1), 
(21314, 21314, "Hot Springs Bandersnatchling", 0, "", 0, "LineageMonster2.bandersnatch", 18, 25, 73, "male", "L2Monster", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 20662, 2126, 752.73928, 310.02959, 514.02335, 206.4212, 253, 4, 333, 0, 0, 0, 30, 170, 1, 1), 
(21315, 21315, "Hot Springs Buffalo", 0, "", 0, "LineageMonster2.buffalo", 22, 31, 73, "male", "L2Monster", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 21532, 2215, 752.73928, 310.02959, 514.02335, 206.4212, 253, 1, 333, 0, 0, 0, 20, 170, 1, 1), 
(21316, 21316, "Hot Springs Flava", 0, "", 0, "LineageMonster2.flava", 18, 34, 74, "male", "L2Monster", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 25336, 2641, 773.81598, 314.65987, 528.41601, 209.50409, 253, 1, 333, 0, 0, 0, 30, 165, 1, 1), 
(21317, 21317, "Hot Springs Atroxspawn", 0, "", 0, "LineageMonster2.kailiharim", 45, 39, 74, "male", "L2Monster", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 21232, 2213, 773.81598, 314.65987, 528.41601, 209.50409, 253, 4, 333, 0, 0, 0, 105, 175, 1, 1), 
(21318, 21318, "Hot Springs Antelope", 0, "", 0, "LineageMonster2.antelope", 17, 34, 74, "male", "L2Monster", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 22193, 2314, 773.81598, 314.65987, 528.41601, 209.50409, 253, 4, 333, 0, 0, 0, 45, 185, 1, 1), 
(21319, 21319, "Hot Springs Nepenthes", 0, "", 0, "LineageMonster2.nephenthes", 28, 43.5, 75, "male", "L2Monster", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 27928, 2946, 794.70901, 319.24623, 542.68324, 212.55774, 253, 1, 333, 0, 0, 0, 48, 170, 1, 1), 
(21320, 21320, "Hot Springs Yeti", 0, "", 0, "LineageMonster.yeti_20_bi", 18, 32, 75, "male", "L2Monster", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 22728, 2398, 794.70901, 319.24623, 542.68324, 212.55774, 253, 4, 333, 0, 0, 0, 16, 170, 1, 1), 
(21321, 21321, "Hot Springs Atrox", 0, "", 0, "LineageMonster2.kailiharim", 45, 39, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 22270, 2381, 815.37145, 323.78455, 556.793, 215.57941, 253, 4, 333, 0, 0, 0, 105, 175, 1, 1), 
(21322, 21322, "Hot Springs Bandersnatch", 0, "", 0, "LineageMonster2.bandersnatch", 18, 25, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 22270, 2381, 815.37145, 323.78455, 556.793, 215.57941, 253, 4, 333, 0, 0, 0, 30, 170, 1, 1), 
(21323, 21323, "Hot Springs Grendel", 0, "", 0, "LineageMonster2.bionic_bear", 15, 39, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 19507, 2085, 815.37145, 323.78455, 556.793, 215.57941, 253, 4, 333, 0, 0, 0, 36, 165, 1, 1), 
(21324, 21324, "Ketra Orc Footman", 0, "", 0, "LineageMonster.ketra_orc", 12, 29, 77, "male", "L2Monster", 40, 2762.08447, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 18647, 2018, 835.75573, 328.27073, 570.71283, 218.56635, 253, 4, 333, 79, 0, 0, 45, 175, 1, 1), 
(21325, 21325, "Ketra's War Hound", 0, "", 0, "LineageMonster2.bandersnatch", 18, 25, 77, "male", "L2Monster", 40, 2762.08447, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 18031, 1951, 835.75573, 328.27073, 570.71283, 218.56635, 253, 4, 333, 0, 0, 0, 30, 185, 1, 1), 
(21326, 21326, "Grazing Kookaburra", 0, "", 0, "LineageMonster2.youth_ostrich", 8, 26.4, 77, "male", "L2Monster", 40, 2762.08447, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 18031, 1951, 835.75573, 328.27073, 570.71283, 218.56635, 253, 4, 333, 0, 0, 0, 23, 190, 1, 1), 
(21327, 21327, "Ketra Orc Raider", 0, "", 0, "LineageMonster.ketra_orc_warrior", 12, 24, 78, "male", "L2Monster", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 20480, 2241, 855.81387, 332.70061, 584.40994, 221.51582, 253, 4, 333, 79, 6919, 0, 36, 175, 1, 1), 
(21328, 21328, "Ketra Orc Scout", 0, "", 0, "LineageMonster.ketra_orc_archer", 12, 27, 78, "male", "L2Monster", 1100, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 19634, 2149, 855.81387, 332.70061, 584.40994, 221.51582, 253, 8, 333, 288, 0, 0, 45, 175, 1, 1), 
(21329, 21329, "Ketra Orc Shaman", 0, "", 0, "LineageMonster.ketra_orc_shaman", 10, 23, 78, "male", "L2Monster", 40, 2870.777409, 1657.41, 8.585, 3.03, 40, 43, 30, 21, 20, 20, 19912, 2207, 884.25257, 340.44078, 609.86817, 226.66932, 253, 1, 333, 92, 0, 0, 10, 150, 1, 1), 
(21330, 21330, "Grazing Buffalo", 0, "", 0, "LineageMonster2.buffalo", 22, 31, 78, "male", "L2Monster", 40, 2870.777409, 1657.41, 8.585, 3.03, 40, 43, 30, 21, 20, 20, 18980, 2103, 884.25257, 340.44078, 609.86817, 226.66932, 253, 1, 333, 0, 0, 0, 20, 165, 1, 1), 
(21331, 21331, "Ketra Orc Warrior", 0, "", 0, "LineageMonster.ketra_orc_warrior", 12, 24, 78, "male", "L2Monster", 40, 2937.983806, 1708.296, 8.67, 3.06, 40, 43, 30, 21, 20, 20, 18609, 2089, 912.65371, 348.2025, 635.68866, 231.83715, 253, 4, 333, 79, 6919, 0, 36, 175, 1, 1), 
(21332, 21332, "Ketra Orc Lieutenant", 0, "", 0, "LineageMonster2.ketra_orc_chieftain", 11, 38.5, 78, "male", "L2Monster", 40, 2937.983806, 1708.296, 8.67, 3.06, 40, 43, 30, 21, 20, 20, 20841, 2339, 912.65371, 348.2025, 635.68866, 231.83715, 253, 1, 333, 6719, 0, 0, 24, 175, 1, 1), 
(21333, 21333, "Grazing Windsus", 0, "", 0, "LineageMonster.giant_wild_hog", 35, 27, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 19953, 2266, 938.20801, 354.81835, 656.66638, 239.18092, 253, 1, 333, 0, 0, 0, 35, 170, 1, 1), 
(21334, 21334, "Ketra Orc Medium", 0, "", 0, "LineageMonster.ketra_orc_shaman", 10, 23, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 29867, 3391, 938.20801, 354.81835, 656.66638, 239.18092, 253, 1, 333, 92, 0, 0, 10, 150, 1, 1), 
(21335, 21335, "Ketra Orc Elite Soldier", 0, "", 0, "LineageMonster.ketra_orc", 12, 29, 78, "male", "L2Monster", 40, 3010.892998, 1777.86, 8.772, 3.1008, 40, 43, 30, 21, 20, 20, 19252, 2212, 961.93701, 361.08599, 677.64411, 246.33071, 253, 4, 333, 79, 0, 0, 45, 175, 1, 1), 
(21336, 21336, "Ketra Orc White Captain", 0, "", 0, "LineageMonster.ketra_orc_overload_20_bi", 14, 28.8, 78, "male", "L2Monster", 40, 3010.892998, 1777.86, 8.772, 3.1008, 40, 43, 30, 21, 20, 20, 22635, 2600, 961.93701, 361.08599, 677.64411, 246.33071, 253, 4, 333, 80, 0, 0, 33, 175, 1, 1), 
(21337, 21337, "Grazing Elder Buffalo", 0, "", 0, "LineageMonster2.buffalo", 22, 31, 78, "male", "L2Monster", 40, 3044.88717, 1812.948, 8.823, 3.111, 40, 43, 30, 21, 20, 20, 20950, 2435, 985.66601, 367.35364, 699.25752, 253.53446, 253, 1, 333, 0, 0, 0, 20, 165, 1, 1), 
(21338, 21338, "Ketra Orc Seer", 0, "", 0, "LineageMonster.ketra_orc_shaman", 10, 23, 78, "male", "L2Monster", 40, 3044.88717, 1812.948, 8.823, 3.111, 40, 43, 30, 21, 20, 20, 27568, 3205, 985.66601, 367.35364, 699.25752, 253.53446, 253, 4, 333, 213, 0, 0, 10, 160, 1, 1), 
(21339, 21339, "Ketra Orc General", 0, "", 0, "LineageMonster2.ketra_orc_chieftain_20_bi", 17, 46.2, 78, "male", "L2Monster", 40, 3077.157206, 1848.24, 8.874, 3.1314, 40, 43, 30, 21, 20, 20, 20989, 2469, 1009.395, 373.96949, 719.59956, 261.02228, 253, 1, 333, 6719, 0, 0, 24, 175, 1, 1), 
(21340, 21340, "Ketra Orc Battalion Commander", 0, "", 0, "LineageMonster2.ketra_orc_warlord", 12, 30, 78, "male", "L2Monster", 40, 3077.157206, 1848.24, 8.874, 3.1314, 40, 43, 30, 21, 20, 20, 20989, 2469, 1009.395, 373.96949, 719.59956, 261.02228, 253, 4, 333, 80, 6919, 0, 27, 175, 1, 1), 
(21341, 21341, "Grazing Elder Kookaburra", 0, "", 0, "LineageMonster2.youth_ostrich", 8, 26.4, 78, "male", "L2Monster", 40, 3107.643659, 1883.736, 8.925, 3.1518, 40, 43, 30, 21, 20, 20, 21972, 2615, 1033.124, 380.23713, 740.57728, 268.30468, 253, 4, 333, 0, 0, 0, 23, 190, 1, 1), 
(21342, 21342, "Ketra Orc Grand Seer", 0, "", 0, "LineageMonster.ketra_orc_shaman", 10, 23, 78, "male", "L2Monster", 40, 3107.643659, 1883.736, 8.925, 3.1518, 40, 43, 30, 21, 20, 20, 28912, 3441, 1033.124, 380.23713, 740.57728, 268.30468, 253, 1, 333, 213, 0, 0, 10, 160, 1, 1), 
(21343, 21343, "Ketra Commander", 0, "", 0, "LineageMonster2.ketra_orc_warlord_20_bi", 15, 36, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 32801, 3725, 938.20801, 354.81835, 656.66638, 239.18092, 253, 8, 333, 80, 6919, 0, 27, 175, 0, 1), 
(21344, 21344, "Ketra Elite Guard", 0, "", 0, "LineageMonster.ketra_orc_overload", 12, 24, 78, "male", "L2Monster", 40, 2937.983806, 1708.296, 8.67, 3.06, 40, 43, 30, 21, 20, 20, 22276, 2500, 912.65371, 348.2025, 635.68866, 231.83715, 253, 4, 333, 80, 0, 0, 33, 180, 0, 1), 
(21345, 21345, "Ketra's Head Shaman", 0, "", 0, "LineageMonster.ketra_orc_shaman", 10, 23, 78, "male", "L2Monster", 40, 3107.643659, 1883.736, 8.925, 3.1518, 40, 43, 30, 21, 20, 20, 24720, 2943, 1033.124, 380.23713, 740.57728, 268.30468, 253, 1, 333, 210, 0, 0, 10, 175, 0, 1), 
(21346, 21346, "Ketra's Head Guard", 0, "", 0, "LineageMonster2.ketra_orc_chieftain", 11, 38.5, 78, "male", "L2Monster", 40, 3077.157206, 1848.24, 8.874, 3.1314, 40, 43, 30, 21, 20, 20, 24560, 2889, 1009.395, 373.96949, 719.59956, 261.02228, 253, 1, 333, 6719, 0, 0, 24, 175, 0, 1), 
(21347, 21347, "Ketra Prophet", 0, "", 0, "LineageMonster.ketra_orc_shaman", 10, 23, 78, "male", "L2Monster", 40, 3163.043215, 1955.34, 9.027, 3.1824, 40, 43, 30, 21, 20, 20, 37558, 4578, 1076.93138, 410.87895, 781.26136, 295.9938, 253, 1, 333, 213, 0, 0, 10, 175, 0, 1), 
(21348, 21348, "Prophet's Guard", 0, "", 0, "LineageMonster2.ketra_orc_chieftain", 11, 38.5, 78, "male", "L2Monster", 40, 3136.290094, 1919.436, 8.976, 3.16812, 40, 43, 30, 21, 20, 20, 25743, 3101, 1055.02769, 386.50478, 760.91932, 275.61604, 253, 1, 333, 6719, 0, 0, 24, 180, 0, 1), 
(21349, 21349, "Prophet's Aide", 0, "", 0, "LineageMonster.ketra_orc_shaman", 10, 23, 78, "male", "L2Monster", 40, 3136.290094, 1919.436, 8.976, 3.16812, 40, 43, 30, 21, 20, 20, 26143, 3149, 1055.02769, 386.50478, 760.91932, 275.61604, 253, 1, 333, 210, 0, 0, 10, 180, 0, 1), 
(21350, 21350, "Varka Silenos Recruit", 0, "", 0, "LineageMonster2.barka_silenos_hunter", 16, 38, 77, "male", "L2Monster", 40, 2856.768726, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 21105, 2186, 856.44056, 328.27073, 584.83789, 240.21427, 253, 4, 333, 2504, 6918, 0, 44, 175, 1, 1), 
(21351, 21351, "Varka Silenos Footman", 0, "", 0, "LineageMonster2.barka_silenos_warrior", 16, 41, 77, "male", "L2Monster", 40, 2856.768726, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 18501, 1904, 856.44056, 328.27073, 584.83789, 240.21427, 253, 4, 333, 2504, 6918, 0, 34, 175, 1, 1), 
(21352, 21352, "Grazing Antelope", 0, "", 0, "LineageMonster2.antelope", 17, 34, 77, "male", "L2Monster", 40, 2856.768726, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 11091, 1200, 856.44056, 328.27073, 584.83789, 240.21427, 253, 4, 333, 0, 0, 0, 45, 185, 1, 1), 
(21353, 21353, "Varka Silenos Scout", 0, "", 0, "LineageMonster2.barka_silenos_hunter", 16, 38, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 25065, 2642, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 142, 6918, 0, 44, 175, 1, 1), 
(21354, 21354, "Varka Silenos Hunter", 0, "", 0, "LineageMonster2.barka_silenos_archer", 8, 37.5, 78, "male", "L2Monster", 1100, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 24846, 2618, 890.50086, 332.70061, 608.09666, 243.45587, 253, 8, 333, 6917, 0, 0, 30, 175, 1, 1), 
(21355, 21355, "Varka Silenos Shaman", 0, "", 0, "LineageMonster2.barka_silenos_shaman", 14, 39.5, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 24583, 2580, 890.50086, 332.70061, 608.09666, 243.45587, 253, 1, 333, 6716, 0, 0, 36, 150, 1, 1), 
(21356, 21356, "Grazing Nepenthes", 0, "", 0, "LineageMonster2.nephenthes", 28, 43.5, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 15612, 1708, 890.50086, 332.70061, 608.09666, 243.45587, 253, 1, 333, 0, 0, 0, 48, 150, 1, 1), 
(21357, 21357, "Varka Silenos Priest", 0, "", 0, "LineageMonster2.barka_silenos_priest", 9, 41.5, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 25424, 2681, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 6716, 0, 0, 36, 180, 1, 1), 
(21358, 21358, "Varka Silenos Warrior", 0, "", 0, "LineageMonster2.barka_silenos_warrior", 16, 41, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 25564, 2696, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 142, 6918, 0, 34, 175, 1, 1), 
(21359, 21359, "Grazing Bandersnatch", 0, "", 0, "LineageMonster2.bandersnatch", 18, 25, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 15761, 1724, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 30, 170, 1, 1), 
(21360, 21360, "Varka Silenos Medium", 0, "", 0, "LineageMonster2.barka_silenos_shaman", 14, 39.5, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 33108, 3490, 890.50086, 332.70061, 608.09666, 243.45587, 253, 1, 333, 6716, 0, 0, 36, 150, 1, 1), 
(21361, 21361, "Varka Silenos Magus", 0, "", 0, "LineageMonster2.barka_silenos_mage_20_bi", 11, 55.2, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 23322, 2452, 890.50086, 332.70061, 608.09666, 243.45587, 253, 1, 333, 6716, 0, 0, 36, 175, 1, 1), 
(21362, 21362, "Varka Silenos Officer", 0, "", 0, "LineageMonster2.barka_silenos_chieftain", 18, 42.5, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 25564, 2696, 890.50086, 332.70061, 608.09666, 243.45587, 253, 1, 333, 2504, 0, 0, 25, 175, 1, 1), 
(21363, 21363, "Grazing Flava", 0, "", 0, "LineageMonster2.flava", 18, 34, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 23952, 2522, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 30, 165, 1, 1), 
(21364, 21364, "Varka Silenos Seer", 0, "", 0, "LineageMonster2.barka_silenos_shaman", 14, 39.5, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 18179, 1988, 890.50086, 332.70061, 608.09666, 243.45587, 253, 1, 333, 6716, 0, 0, 36, 150, 1, 1), 
(21365, 21365, "Varka Silenos Great Magus", 0, "", 0, "LineageMonster2.barka_silenos_warrior_20_bi", 20, 49.2, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 25065, 2642, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 2500, 0, 0, 34, 175, 1, 1), 
(21366, 21366, "Varka Silenos General", 0, "", 0, "LineageMonster2.barka_silenos_chieftain", 18, 42.5, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 27045, 2858, 890.50086, 332.70061, 608.09666, 243.45587, 253, 1, 333, 2500, 0, 0, 25, 175, 1, 1), 
(21367, 21367, "Grazing Elder Antelope", 0, "", 0, "LineageMonster2.antelope", 17, 34, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 15761, 1724, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 45, 185, 1, 1), 
(21368, 21368, "Varka Silenos Great Seer", 0, "", 0, "LineageMonster2.barka_silenos_shaman", 14, 39.5, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 32232, 3394, 890.50086, 332.70061, 608.09666, 243.45587, 253, 1, 333, 6716, 0, 0, 36, 150, 1, 1), 
(21369, 21369, "Varka's Commander", 0, "", 0, "LineageMonster2.barka_silenos_chieftain_20_bi", 22, 51, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 31469, 3310, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 2500, 0, 0, 25, 175, 0, 1), 
(21370, 21370, "Varka's Elite Guard", 0, "", 0, "LineageMonster2.barka_silenos_warrior", 16, 41, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 26151, 2761, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 2500, 6918, 0, 34, 175, 0, 1), 
(21371, 21371, "Varka's Head Magus", 0, "", 0, "LineageMonster2.barka_silenos_shaman", 14, 39.5, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 24846, 2618, 890.50086, 332.70061, 608.09666, 243.45587, 253, 1, 333, 6716, 0, 0, 36, 150, 0, 1), 
(21372, 21372, "Varka's Head Guard", 0, "", 0, "LineageMonster2.barka_silenos_hunter", 16, 38, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 16812, 1840, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 2500, 6918, 0, 44, 175, 0, 1), 
(21373, 21373, "Varka's Prophet", 0, "", 0, "LineageMonster2.barka_silenos_shaman_20_bi", 17, 47.5, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 32074, 3370, 890.50086, 332.70061, 608.09666, 243.45587, 253, 1, 333, 6716, 0, 0, 36, 150, 0, 1), 
(21374, 21374, "Prophet Guard", 0, "", 0, "LineageMonster2.barka_silenos_warrior", 16, 41, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 16952, 1855, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 2500, 6918, 0, 34, 175, 0, 1), 
(21375, 21375, "Disciple of Prophet", 0, "", 0, "LineageMonster2.barka_silenos_priest", 9, 41.5, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 16339, 1788, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 6716, 0, 0, 36, 180, 0, 1), 
(21376, 21376, "Scarlet Stakato Worker", 0, "", 0, "LineageMonster.blade_stakato_worker", 13, 40, 78, "male", "L2Monster", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 35275, 3860, 855.81387, 332.70061, 584.40994, 221.51582, 253, 4, 333, 235, 0, 0, 25, 130, 0, 1), 
(21377, 21377, "Scarlet Stakato Soldier", 0, "", 0, "LineageMonster.blade_stakato_soldier", 15, 38, 78, "male", "L2Monster", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 34523, 3778, 855.81387, 332.70061, 584.40994, 221.51582, 253, 4, 333, 148, 0, 0, 25, 180, 0, 1), 
(21378, 21378, "Scarlet Stakato Noble", 0, "", 0, "LineageMonster.blade_stakato_drone", 15, 39, 78, "male", "L2Monster", 40, 2870.777409, 1657.41, 8.585, 3.03, 40, 43, 30, 21, 20, 20, 49148, 5447, 884.25257, 340.44078, 609.86817, 226.66932, 253, 4, 333, 235, 0, 0, 25, 180, 0, 1), 
(21379, 21379, "Tepra Scorpion", 0, "", 0, "LineageMonster2.scorpion_20_sm", 24, 52.8, 78, "male", "L2Monster", 40, 2870.777409, 1657.41, 8.585, 3.03, 40, 43, 30, 21, 20, 20, 35491, 3933, 884.25257, 340.44078, 609.86817, 226.66932, 253, 8, 333, 0, 0, 0, 37, 125, 0, 1), 
(21380, 21380, "Tepra Scarab", 0, "", 0, "LineageMonster2.scarab", 14, 22, 78, "male", "L2Monster", 40, 2870.777409, 1657.41, 8.585, 3.03, 40, 43, 30, 21, 20, 20, 36185, 4010, 884.25257, 340.44078, 609.86817, 226.66932, 253, 1, 333, 0, 0, 0, 45, 175, 0, 1), 
(21381, 21381, "Assassin Beetle", 0, "", 0, "LineageMonster2.tera_beetle", 19, 54.5, 78, "male", "L2Monster", 40, 2937.983806, 1708.296, 8.67, 3.06, 40, 43, 30, 21, 20, 20, 42075, 4722, 912.65371, 348.2025, 635.68866, 231.83715, 253, 4, 333, 0, 0, 0, 45, 145, 0, 1), 
(21382, 21382, "Mercenary of Destruction", 0, "", 0, "LineageMonster.skeleton_knight", 10, 25, 78, "male", "L2Monster", 40, 2937.983806, 1708.296, 8.67, 3.06, 40, 43, 30, 21, 20, 20, 51904, 5826, 912.65371, 348.2025, 635.68866, 231.83715, 253, 4, 333, 150, 103, 0, 40, 165, 0, 1), 
(21383, 21383, "Knight of Destruction", 0, "", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 78, "male", "L2Monster", 40, 2937.983806, 1708.296, 8.67, 3.06, 40, 43, 30, 21, 20, 20, 51983, 5835, 912.65371, 348.2025, 635.68866, 231.83715, 253, 4, 333, 946, 945, 0, 80, 185, 0, 1), 
(21384, 21384, "Necromancer of Destruction", 0, "", 0, "LineageMonster.vale_master_20_bi", 14.5, 48, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 44576, 5062, 938.20801, 354.81835, 656.66638, 239.18092, 253, 1, 333, 0, 0, 0, 70, 145, 0, 1), 
(21385, 21385, "Lavastone Golem", 0, "", 0, "LineageMonster.stone_golem", 20, 31, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 42930, 4875, 938.20801, 354.81835, 656.66638, 239.18092, 253, 1, 333, 0, 0, 0, 23, 40, 0, 1), 
(21386, 21386, "Magma Golem", 0, "", 0, "LineageMonster2.lava_golem", 22, 45, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 45872, 5209, 938.20801, 354.81835, 656.66638, 239.18092, 253, 1, 333, 0, 0, 0, 13, 60, 0, 1), 
(21387, 21387, "Arimanes of Destruction", 0, "", 0, "LineageMonster2.ahrimanes", 14, 57.75, 78, "male", "L2Monster", 40, 3010.892998, 1777.86, 8.772, 3.1008, 40, 43, 30, 21, 20, 20, 36575, 4202, 961.93701, 361.08599, 677.64411, 246.33071, 253, 4, 333, 6722, 0, 0, 35, 185, 0, 1), 
(21388, 21388, "Iblis of Destruction", 0, "", 0, "LineageMonster.fiend_archer", 17, 55, 78, "male", "L2Monster", 40, 3010.892998, 1777.86, 8.772, 3.1008, 40, 43, 30, 21, 20, 20, 55327, 6356, 961.93701, 361.08599, 677.64411, 246.33071, 253, 4, 333, 0, 0, 0, 70, 150, 0, 1), 
(21389, 21389, "Balrog of Destruction", 0, "", 0, "LineageMonster.kaim_vanul", 24, 40, 78, "male", "L2Monster", 40, 3044.88717, 1812.948, 8.823, 3.111, 40, 43, 30, 21, 20, 20, 59328, 6897, 985.66601, 367.35364, 699.25752, 253.53446, 253, 4, 333, 0, 0, 0, 37, 155, 0, 1), 
(21390, 21390, "Ashuras of Destruction", 0, "", 0, "LineageMonster2.ashuras_30_bi", 17, 49, 78, "male", "L2Monster", 40, 3077.157206, 1848.24, 8.874, 3.1314, 40, 43, 30, 21, 20, 20, 68450, 8052, 1009.395, 373.96949, 719.59956, 261.02228, 253, 4, 333, 0, 0, 0, 41, 190, 0, 1), 
(21391, 21391, "Lavasillisk", 0, "", 0, "LineageMonster.lesser_basilisk", 34, 25, 78, "male", "L2Monster", 40, 3044.88717, 1812.948, 8.823, 3.111, 40, 43, 30, 21, 20, 20, 47322, 5501, 985.66601, 367.35364, 699.25752, 253.53446, 253, 4, 333, 0, 0, 0, 35, 140, 0, 1), 
(21392, 21392, "Blazing Ifrit", 0, "", 0, "LineageMonster2.ifrit_30_bi", 13, 55, 78, "male", "L2Monster", 40, 3077.157206, 1848.24, 8.874, 3.1314, 40, 43, 30, 21, 20, 20, 67509, 7941, 1009.395, 373.96949, 719.59956, 261.02228, 253, 4, 333, 0, 0, 0, 38, 150, 0, 1), 
(21393, 21393, "Magma Drake", 0, "", 0, "LineageMonster2.inferno_drake_20_bi", 29, 42, 78, "male", "L2Monster", 40, 3107.643659, 1883.736, 8.925, 3.1518, 40, 43, 30, 21, 20, 20, 56964, 6780, 1033.124, 380.23713, 740.57728, 268.30468, 253, 4, 333, 0, 0, 0, 57, 195, 0, 1), 
(21394, 21394, "Lavasaurus", 0, "", 0, "LineageMonster2.magmagoil", 15, 75, 78, "male", "L2Monster", 1100, 2870.777409, 1657.41, 8.585, 3.03, 40, 43, 30, 21, 20, 20, 44944, 4981, 884.25257, 340.44078, 609.86817, 226.66932, 253, 8, 333, 0, 0, 0, 1, 1, 0, 1), 
(21395, 21395, "Elder Lavasaurus", 0, "", 0, "LineageMonster2.magmagoil_lad", 15, 75, 78, "male", "L2Monster", 1100, 3044.88717, 1812.948, 8.823, 3.111, 40, 43, 30, 21, 20, 20, 58564, 6808, 985.66601, 367.35364, 699.25752, 253.53446, 253, 8, 333, 0, 0, 0, 1, 1, 0, 1), 
(21396, 21396, "Carrion Scarab", 0, "", 0, "LineageMonster2.scarab", 14, 22, 78, "male", "L2Monster", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 24549, 2687, 855.81387, 332.70061, 584.40994, 221.51582, 253, 4, 333, 0, 0, 0, 45, 130, 0, 1), 
(21397, 21397, "Carrion Scarab", 0, "", 0, "LineageMonster2.scarab", 14, 22, 78, "male", "L2Monster", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 21310, 2332, 855.81387, 332.70061, 584.40994, 221.51582, 253, 4, 333, 0, 0, 0, 45, 130, 0, 1), 
(21398, 21398, "Soldier Scarab", 0, "", 0, "LineageMonster2.scarab", 14, 22, 78, "male", "L2Monster", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 40465, 4428, 855.81387, 332.70061, 584.40994, 221.51582, 253, 4, 333, 0, 0, 0, 45, 180, 0, 1), 
(21399, 21399, "Soldier Scarab", 0, "", 0, "LineageMonster2.scarab", 14, 22, 78, "male", "L2Monster", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 38680, 4233, 855.81387, 332.70061, 584.40994, 221.51582, 253, 4, 333, 0, 0, 0, 45, 180, 0, 1), 
(21400, 21400, "Hexa Beetle", 0, "", 0, "LineageMonster2.tera_beetle", 25, 54.5, 78, "male", "L2Monster", 40, 2870.777409, 1657.41, 8.585, 3.03, 40, 43, 30, 21, 20, 20, 33055, 3663, 884.25257, 340.44078, 609.86817, 226.66932, 253, 4, 333, 0, 0, 0, 45, 145, 0, 1), 
(21401, 21401, "Hexa Beetle", 0, "", 0, "LineageMonster2.tera_beetle", 25, 54.5, 78, "male", "L2Monster", 40, 2870.777409, 1657.41, 8.585, 3.03, 40, 43, 30, 21, 20, 20, 29087, 3224, 884.25257, 340.44078, 609.86817, 226.66932, 253, 4, 333, 0, 0, 0, 45, 145, 0, 1), 
(21402, 21402, "Katraxis", 0, "", 0, "LineageMonster2.scorpion_20_sm", 24, 52.8, 78, "male", "L2Monster", 40, 2870.777409, 1657.41, 8.585, 3.03, 40, 43, 30, 21, 20, 20, 30013, 3326, 884.25257, 340.44078, 609.86817, 226.66932, 253, 8, 333, 0, 0, 0, 37, 165, 0, 1), 
(21403, 21403, "Katraxis", 0, "", 0, "LineageMonster2.scorpion_20_sm", 24, 52.8, 78, "male", "L2Monster", 40, 2870.777409, 1657.41, 8.585, 3.03, 40, 43, 30, 21, 20, 20, 34642, 3839, 884.25257, 340.44078, 609.86817, 226.66932, 253, 8, 333, 0, 0, 0, 37, 165, 0, 1), 
(21404, 21404, "Tera Beetle", 0, "", 0, "LineageMonster2.tera_beetle", 25, 54.5, 78, "male", "L2Monster", 40, 2937.983806, 1708.296, 8.67, 3.06, 40, 43, 30, 21, 20, 20, 59626, 6692, 912.65371, 348.2025, 635.68866, 231.83715, 253, 4, 333, 0, 0, 0, 45, 185, 0, 1), 
(21405, 21405, "Tera Beetle", 0, "", 0, "LineageMonster2.tera_beetle", 25, 54.5, 78, "male", "L2Monster", 40, 2937.983806, 1708.296, 8.67, 3.06, 40, 43, 30, 21, 20, 20, 28588, 3209, 912.65371, 348.2025, 635.68866, 231.83715, 253, 4, 333, 0, 0, 0, 45, 185, 0, 1), 
(21406, 21406, "Knight of Empire", 0, "", 0, "LineageMonster.skeleton_knight", 10, 25, 78, "male", "L2Monster", 40, 2937.983806, 1708.296, 8.67, 3.06, 40, 43, 30, 21, 20, 20, 42272, 4745, 912.65371, 348.2025, 635.68866, 231.83715, 253, 4, 333, 150, 103, 0, 40, 145, 0, 1), 
(21407, 21407, "Knight of Empire", 0, "", 0, "LineageMonster.skeleton_knight", 10, 25, 78, "male", "L2Monster", 40, 2937.983806, 1708.296, 8.67, 3.06, 40, 43, 30, 21, 20, 20, 27052, 3036, 912.65371, 348.2025, 635.68866, 231.83715, 253, 4, 333, 150, 103, 0, 40, 145, 0, 1), 
(21408, 21408, "Royal Guard of Empire", 0, "", 0, "LineageMonster.skeleton_pikeman", 10, 28, 78, "male", "L2Monster", 40, 2937.983806, 1708.296, 8.67, 3.06, 40, 43, 30, 21, 20, 20, 36791, 4129, 912.65371, 348.2025, 635.68866, 231.83715, 253, 4, 333, 304, 0, 0, 50, 190, 0, 1), 
(21409, 21409, "Royal Guard of Empire", 0, "", 0, "LineageMonster.skeleton_pikeman", 10, 28, 78, "male", "L2Monster", 40, 2937.983806, 1708.296, 8.67, 3.06, 40, 43, 30, 21, 20, 20, 41142, 4618, 912.65371, 348.2025, 635.68866, 231.83715, 253, 4, 333, 304, 0, 0, 50, 190, 0, 1), 
(21410, 21410, "Guardian Scarab", 0, "", 0, "LineageMonster2.scarab_20_bi", 17, 26.5, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 38010, 4316, 938.20801, 354.81835, 656.66638, 239.18092, 253, 4, 333, 0, 0, 0, 45, 195, 0, 1), 
(21411, 21411, "Guardian Scarab", 0, "", 0, "LineageMonster2.scarab_20_bi", 17, 26.5, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 30337, 3445, 938.20801, 354.81835, 656.66638, 239.18092, 253, 4, 333, 0, 0, 0, 45, 195, 0, 1), 
(21412, 21412, "Ustralith", 0, "", 0, "LineageMonster2.scorpion", 28, 66, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 48414, 5497, 938.20801, 354.81835, 656.66638, 239.18092, 253, 8, 333, 0, 0, 0, 37, 130, 0, 1), 
(21413, 21413, "Ustralith", 0, "", 0, "LineageMonster2.scorpion", 28, 66, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 37229, 4227, 938.20801, 354.81835, 656.66638, 239.18092, 253, 8, 333, 0, 0, 0, 37, 130, 0, 1), 
(21414, 21414, "Assassin of Empire", 0, "", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 36181, 4108, 938.20801, 354.81835, 656.66638, 239.18092, 253, 8, 333, 946, 945, 0, 80, 175, 0, 1), 
(21415, 21415, "Assassin of Empire", 0, "", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 36499, 4144, 938.20801, 354.81835, 656.66638, 239.18092, 253, 8, 333, 946, 945, 0, 80, 175, 0, 1), 
(21416, 21416, "Imperial Commander", 0, "", 0, "LineageMonster2.imperial_warlord_zombie", 7, 30, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 43189, 4904, 938.20801, 354.81835, 656.66638, 239.18092, 253, 4, 333, 134, 6721, 0, 39, 140, 0, 1), 
(21417, 21417, "Imperial Commander", 0, "", 0, "LineageMonster2.imperial_warlord_zombie", 7, 30, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 75345, 8555, 938.20801, 354.81835, 656.66638, 239.18092, 253, 4, 333, 134, 6721, 0, 39, 140, 0, 1), 
(21418, 21418, "Imperial Royal Guard", 0, "", 0, "LineageMonster.death_knight", 12, 31, 78, "male", "L2Monster", 40, 3010.892998, 1777.86, 8.772, 3.1008, 40, 43, 30, 21, 20, 20, 32124, 3691, 961.93701, 361.08599, 677.64411, 246.33071, 253, 4, 333, 142, 0, 0, 27, 160, 0, 1), 
(21419, 21419, "Imperial Royal Guard", 0, "", 0, "LineageMonster.death_knight", 12, 31, 78, "male", "L2Monster", 40, 3010.892998, 1777.86, 8.772, 3.1008, 40, 43, 30, 21, 20, 20, 32694, 3756, 961.93701, 361.08599, 677.64411, 246.33071, 253, 4, 333, 142, 0, 0, 27, 160, 0, 1), 
(21420, 21420, "Ashuras", 0, "", 0, "LineageMonster2.ashuras", 13, 37.5, 78, "male", "L2Monster", 40, 3010.892998, 1777.86, 8.772, 3.1008, 40, 43, 30, 21, 20, 20, 38520, 4425, 961.93701, 361.08599, 677.64411, 246.33071, 253, 4, 333, 0, 0, 0, 41, 200, 0, 1), 
(21421, 21421, "Ashuras", 0, "", 0, "LineageMonster2.ashuras", 13, 37.5, 78, "male", "L2Monster", 40, 3010.892998, 1777.86, 8.772, 3.1008, 40, 43, 30, 21, 20, 20, 36159, 4154, 961.93701, 361.08599, 677.64411, 246.33071, 253, 4, 333, 0, 0, 0, 41, 200, 0, 1), 
(21422, 21422, "Dancer of Empire", 0, "", 0, "LineageMonster.banshee", 9, 23, 78, "female", "L2Monster", 40, 3010.892998, 1777.86, 8.772, 3.1008, 40, 43, 30, 21, 20, 20, 41481, 4766, 961.93701, 361.08599, 677.64411, 246.33071, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(21423, 21423, "Dancer of Empire", 0, "", 0, "LineageMonster.banshee", 9, 23, 78, "female", "L2Monster", 40, 3010.892998, 1777.86, 8.772, 3.1008, 40, 43, 30, 21, 20, 20, 43973, 5052, 961.93701, 361.08599, 677.64411, 246.33071, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(21424, 21424, "Ashkenas", 0, "", 0, "LineageMonster2.ashuras", 13, 37.5, 78, "male", "L2Monster", 40, 3010.892998, 1777.86, 8.772, 3.1008, 40, 43, 30, 21, 20, 20, 55732, 6403, 961.93701, 361.08599, 677.64411, 246.33071, 253, 4, 333, 0, 0, 0, 41, 190, 0, 1), 
(21425, 21425, "Ashkenas", 0, "", 0, "LineageMonster2.ashuras", 13, 37.5, 78, "male", "L2Monster", 40, 3010.892998, 1777.86, 8.772, 3.1008, 40, 43, 30, 21, 20, 20, 56668, 6510, 961.93701, 361.08599, 677.64411, 246.33071, 253, 4, 333, 0, 0, 0, 41, 190, 0, 1), 
(21426, 21426, "Abraxion", 0, "", 0, "LineageMonster2.erinyes", 21, 50, 78, "male", "L2Monster", 40, 3044.88717, 1812.948, 8.823, 3.111, 40, 43, 30, 21, 20, 20, 65250, 7585, 985.66601, 367.35364, 699.25752, 253.53446, 253, 1, 333, 0, 0, 0, 31, 130, 0, 1), 
(21427, 21427, "Abraxion", 0, "", 0, "LineageMonster2.erinyes", 21, 50, 78, "male", "L2Monster", 40, 3044.88717, 1812.948, 8.823, 3.111, 40, 43, 30, 21, 20, 20, 38349, 4458, 985.66601, 367.35364, 699.25752, 253.53446, 253, 1, 333, 0, 0, 0, 31, 130, 0, 1), 
(21428, 21428, "Hasturan", 0, "", 0, "LineageMonster2.erinyes", 21, 50, 78, "male", "L2Monster", 40, 3044.88717, 1812.948, 8.823, 3.111, 40, 43, 30, 21, 20, 20, 36621, 4257, 985.66601, 367.35364, 699.25752, 253.53446, 253, 1, 333, 0, 0, 0, 31, 150, 0, 1), 
(21429, 21429, "Hasturan", 0, "", 0, "LineageMonster2.erinyes", 21, 50, 78, "male", "L2Monster", 40, 3044.88717, 1812.948, 8.823, 3.111, 40, 43, 30, 21, 20, 20, 38239, 4445, 985.66601, 367.35364, 699.25752, 253.53446, 253, 1, 333, 0, 0, 0, 31, 150, 0, 1), 
(21430, 21430, "Arimanes", 0, "", 0, "LineageMonster2.ahrimanes", 14, 57.75, 78, "male", "L2Monster", 40, 3044.88717, 1812.948, 8.823, 3.111, 40, 43, 30, 21, 20, 20, 52810, 6139, 985.66601, 367.35364, 699.25752, 253.53446, 253, 4, 333, 6722, 0, 0, 35, 210, 0, 1), 
(21431, 21431, "Arimanes", 0, "", 0, "LineageMonster2.ahrimanes", 14, 57.75, 78, "male", "L2Monster", 40, 3044.88717, 1812.948, 8.823, 3.111, 40, 43, 30, 21, 20, 20, 45045, 5236, 985.66601, 367.35364, 699.25752, 253.53446, 253, 4, 333, 6722, 0, 0, 35, 210, 0, 1), 
(21432, 21432, "Chakram Beetle", 0, "", 0, "LineageMonster2.tera_beetle", 19, 54.5, 78, "male", "L2Monster", 40, 2937.983806, 1708.296, 8.67, 3.06, 40, 43, 30, 21, 20, 20, 72932, 8186, 912.65371, 348.2025, 635.68866, 231.83715, 253, 4, 333, 0, 0, 0, 45, 170, 0, 1), 
(21433, 21433, "Jamadar Beetle", 0, "", 0, "LineageMonster2.tera_beetle_20_sm", 20, 43.6, 78, "male", "L2Monster", 40, 2870.777409, 1657.41, 8.585, 3.03, 40, 43, 30, 21, 20, 20, 70729, 7839, 884.25257, 340.44078, 609.86817, 226.66932, 253, 4, 333, 0, 0, 0, 45, 175, 0, 1), 
(21434, 21434, "Seer of Blood", 0, "", 0, "LineageMonster2.erinyes", 21, 50, 78, "male", "L2Monster", 40, 3010.892998, 1777.86, 8.772, 3.1008, 40, 43, 30, 21, 20, 20, 141369, 16242, 961.93701, 361.08599, 677.64411, 246.33071, 253, 1, 333, 0, 0, 0, 31, 150, 0, 1), 
(21435, 21435, "Guide of Offering", 0, "", 0, "LineageMonster2.imperial_warlord_zombie", 7, 30, 78, "male", "L2Monster", 40, 2937.983806, 1708.296, 8.67, 3.06, 40, 43, 30, 21, 20, 20, 71537, 8029, 912.65371, 348.2025, 635.68866, 231.83715, 253, 4, 333, 134, 6721, 0, 39, 150, 0, 1), 
(21436, 21436, "Leader of Offering", 0, "", 0, "LineageMonster2.imperial_warlord_zombie", 7, 30, 78, "male", "L2Monster", 40, 2937.983806, 1708.296, 8.67, 3.06, 40, 43, 30, 21, 20, 20, 74207, 8329, 912.65371, 348.2025, 635.68866, 231.83715, 253, 4, 333, 134, 6721, 0, 39, 150, 0, 1), 
(21437, 21437, "Offering Bug", 0, "", 0, "LineageMonster2.scarab", 14, 22, 78, "male", "L2Monster", 40, 2870.777409, 1657.41, 8.585, 3.03, 40, 43, 30, 21, 20, 20, 29957, 3320, 884.25257, 340.44078, 609.86817, 226.66932, 253, 4, 333, 0, 0, 0, 45, 180, 0, 1), 
(21438, 21438, "Heathen Warrior", 0, "", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 65, "male", "L2Monster", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 1790, 167, 582.81759, 271.89033, 397.98887, 181.02764, 253, 8, 333, 946, 945, 0, 80, 175, 0, 1), 
(21439, 21439, "Heathen Executed", 0, "", 0, "LineageMonster.hungry_spirit", 30, 40, 66, "male", "L2Monster", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 1846, 174, 603.79903, 276.72752, 412.31647, 184.2483, 253, 4, 333, 0, 0, 0, 15, 175, 0, 1), 
(21440, 21440, "Heathen Archer", 0, "", 0, "LineageMonster.skeleton_archer", 11, 27, 67, "male", "L2Monster", 1100, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 2021, 192, 624.93199, 281.55251, 426.74754, 187.46084, 253, 8, 333, 284, 0, 0, 40, 155, 0, 1), 
(21441, 21441, "Heathen Grunt", 0, "", 0, "LineageMonster.skeleton_pikeman", 10, 28, 68, "male", "L2Monster", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 1959, 190, 646.17968, 286.3615, 441.25696, 190.66272, 253, 4, 333, 96, 0, 0, 50, 170, 0, 1), 
(21442, 21442, "Heathen Knight", 0, "", 0, "LineageMonster.skeleton_knight", 10, 25, 69, "male", "L2Monster", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 2017, 197, 667.50361, 291.15063, 455.81844, 193.85137, 253, 4, 333, 150, 103, 0, 40, 165, 0, 1), 
(21443, 21443, "Raider of Pastureland", 0, "", 0, "LineageMonster.dark_mahum", 13, 26, 63, "male", "L2Monster", 40, 2089.92274, 1127.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 8408, 760, 541.44774, 262.19426, 369.73862, 174.5719, 253, 8, 333, 153, 0, 0, 50, 165, 1, 1), 
(21444, 21444, "Raider of Pastureland", 0, "", 0, "LineageMonster.dark_mahum", 13, 26, 63, "male", "L2Monster", 40, 2089.92274, 1127.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 7066, 638, 541.44774, 262.19426, 369.73862, 174.5719, 253, 4, 333, 153, 0, 0, 50, 165, 1, 1), 
(21445, 21445, "Alpine Bandersnatch", 0, "", 0, "LineageMonster2.bandersnatch", 18, 25, 64, "male", "L2Monster", 40, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 7292, 667, 562.02275, 267.04468, 383.78868, 177.80136, 253, 4, 333, 0, 0, 0, 30, 170, 1, 1), 
(21446, 21446, "Raider of Pastureland", 0, "", 0, "LineageMonster.dark_mahum", 13, 26, 64, "male", "L2Monster", 40, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 8972, 821, 562.02275, 267.04468, 383.78868, 177.80136, 253, 8, 333, 160, 0, 0, 50, 165, 1, 1), 
(21447, 21447, "Raider of Pastureland", 0, "", 0, "LineageMonster.dark_mahum", 13, 26, 66, "male", "L2Monster", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9228, 869, 603.79903, 276.72752, 412.31647, 184.2483, 253, 8, 333, 229, 0, 0, 50, 165, 1, 1), 
(21448, 21448, "Raider of Pastureland", 0, "", 0, "LineageMonster.dark_mahum", 13, 26, 66, "male", "L2Monster", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 7754, 730, 603.79903, 276.72752, 412.31647, 184.2483, 253, 4, 333, 229, 0, 0, 50, 165, 1, 1), 
(21449, 21449, "Raider of Pastureland", 0, "", 0, "LineageMonster.dark_mahum", 13, 26, 68, "male", "L2Monster", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 10128, 978, 646.17968, 286.3615, 441.25696, 190.66272, 253, 8, 333, 234, 0, 0, 50, 165, 1, 1), 
(21450, 21450, "Alpine Grendel", 0, "", 0, "LineageMonster2.bionic_bear", 15, 39, 68, "male", "L2Monster", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9796, 947, 646.17968, 286.3615, 441.25696, 190.66272, 253, 4, 333, 0, 0, 0, 36, 155, 1, 1), 
(21451, 21451, "Alpine Kookaburra", 0, "", 0, "LineageMonster2.baby_ostrich", 7, 15, 65, "male", "L2FeedableBeast", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 3318, 308, 582.81759, 271.89033, 397.98887, 181.02764, 253, 4, 333, 0, 0, 0, 13, 110, 1, 1), 
(21452, 21452, "Alpine Kookaburra", 0, "", 0, "LineageMonster2.baby_ostrich", 7, 15, 65, "male", "L2FeedableBeast", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 8775, 815, 582.81759, 271.89033, 397.98887, 181.02764, 253, 4, 333, 0, 0, 0, 13, 140, 1, 1), 
(21453, 21453, "Alpine Kookaburra", 0, "", 0, "LineageMonster2.baby_ostrich", 7, 15, 65, "male", "L2FeedableBeast", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 7374, 685, 582.81759, 271.89033, 397.98887, 181.02764, 253, 4, 333, 0, 0, 0, 13, 140, 1, 1), 
(21454, 21454, "Alpine Kookaburra", 0, "", 0, "LineageMonster2.baby_ostrich", 7, 15, 65, "male", "L2FeedableBeast", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 8775, 815, 582.81759, 271.89033, 397.98887, 181.02764, 253, 4, 333, 0, 0, 0, 13, 140, 1, 1), 
(21455, 21455, "Alpine Kookaburra", 0, "", 0, "LineageMonster2.baby_ostrich", 7, 15, 65, "male", "L2FeedableBeast", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 7374, 685, 582.81759, 271.89033, 397.98887, 181.02764, 253, 4, 333, 0, 0, 0, 13, 140, 1, 1), 
(21456, 21456, "Alpine Kookaburra", 0, "", 0, "LineageMonster2.baby_ostrich", 7, 15, 65, "male", "L2FeedableBeast", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 8775, 815, 582.81759, 271.89033, 397.98887, 181.02764, 253, 4, 333, 0, 0, 0, 13, 140, 1, 1), 
(21457, 21457, "Alpine Kookaburra", 0, "", 0, "LineageMonster2.baby_ostrich", 7, 15, 65, "male", "L2FeedableBeast", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 7374, 685, 582.81759, 271.89033, 397.98887, 181.02764, 253, 4, 333, 0, 0, 0, 13, 140, 1, 1), 
(21458, 21458, "Alpine Kookaburra", 0, "", 0, "LineageMonster2.baby_ostrich", 7, 15, 65, "male", "L2FeedableBeast", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 8775, 815, 582.81759, 271.89033, 397.98887, 181.02764, 253, 4, 333, 0, 0, 0, 13, 140, 1, 1), 
(21459, 21459, "Alpine Kookaburra", 0, "", 0, "LineageMonster2.baby_ostrich", 7, 15, 65, "male", "L2FeedableBeast", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 7374, 685, 582.81759, 271.89033, 397.98887, 181.02764, 253, 4, 333, 0, 0, 0, 13, 140, 1, 1), 
(21460, 21460, "Alpine Kookaburra", 0, "", 0, "LineageMonster2.youth_ostrich", 8, 26.4, 65, "male", "L2FeedableBeast", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 18387, 1708, 582.81759, 271.89033, 397.98887, 181.02764, 253, 4, 333, 0, 0, 0, 23, 190, 0, 1), 
(21461, 21461, "Alpine Kookaburra", 0, "", 0, "LineageMonster2.youth_ostrich", 8, 26.4, 65, "male", "L2FeedableBeast", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 19112, 1776, 582.81759, 271.89033, 397.98887, 181.02764, 253, 4, 333, 0, 0, 0, 23, 190, 0, 1), 
(21462, 21462, "Alpine Kookaburra", 0, "", 0, "LineageMonster2.youth_ostrich", 8, 26.4, 65, "male", "L2FeedableBeast", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 18387, 1708, 582.81759, 271.89033, 397.98887, 181.02764, 253, 4, 333, 0, 0, 0, 23, 190, 0, 1), 
(21463, 21463, "Alpine Kookaburra", 0, "", 0, "LineageMonster2.youth_ostrich", 8, 26.4, 65, "male", "L2FeedableBeast", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 17683, 1643, 582.81759, 271.89033, 397.98887, 181.02764, 253, 4, 333, 0, 0, 0, 23, 190, 0, 1), 
(21464, 21464, "Alpine Kookaburra", 0, "", 0, "LineageMonster2.youth_ostrich", 8, 26.4, 65, "male", "L2FeedableBeast", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 18387, 1708, 582.81759, 271.89033, 397.98887, 181.02764, 253, 4, 333, 0, 0, 0, 23, 190, 0, 1), 
(21465, 21465, "Alpine Kookaburra", 0, "", 0, "LineageMonster2.youth_ostrich", 8, 26.4, 65, "male", "L2FeedableBeast", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 19112, 1776, 582.81759, 271.89033, 397.98887, 181.02764, 253, 4, 333, 0, 0, 0, 23, 190, 0, 1), 
(21466, 21466, "Alpine Kookaburra", 0, "", 0, "LineageMonster2.youth_ostrich", 8, 26.4, 65, "male", "L2FeedableBeast", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 18387, 1708, 582.81759, 271.89033, 397.98887, 181.02764, 253, 4, 333, 0, 0, 0, 23, 190, 0, 1), 
(21467, 21467, "Alpine Kookaburra", 0, "", 0, "LineageMonster2.youth_ostrich", 8, 26.4, 65, "male", "L2FeedableBeast", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 17683, 1643, 582.81759, 271.89033, 397.98887, 181.02764, 253, 4, 333, 0, 0, 0, 23, 190, 0, 1), 
(21468, 21468, "Alpine Kookaburra", 0, "", 0, "LineageMonster2.rough_ostrich", 10, 33, 65, "male", "L2FeedableBeast", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 30997, 2880, 582.81759, 271.89033, 397.98887, 181.02764, 253, 4, 333, 0, 0, 0, 23, 210, 0, 1), 
(21469, 21469, "Alpine Kookaburra", 0, "", 0, "LineageMonster2.rough_ostrich", 10, 33, 65, "male", "L2FeedableBeast", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 29568, 2747, 582.81759, 271.89033, 397.98887, 181.02764, 253, 4, 333, 0, 0, 0, 23, 210, 0, 1), 
(21470, 21470, "Alpine Buffalo", 0, "", 0, "LineageMonster2.baby_buffalo", 12, 15, 67, "male", "L2FeedableBeast", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 3526, 336, 624.93199, 281.55251, 426.74754, 187.46084, 253, 1, 333, 0, 0, 0, 30, 110, 1, 1), 
(21471, 21471, "Alpine Buffalo", 0, "", 0, "LineageMonster2.baby_buffalo", 12, 15, 67, "male", "L2FeedableBeast", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9323, 888, 624.93199, 281.55251, 426.74754, 187.46084, 253, 1, 333, 0, 0, 0, 30, 130, 1, 1), 
(21472, 21472, "Alpine Buffalo", 0, "", 0, "LineageMonster2.baby_buffalo", 12, 15, 67, "male", "L2FeedableBeast", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 7835, 746, 624.93199, 281.55251, 426.74754, 187.46084, 253, 1, 333, 0, 0, 0, 30, 130, 1, 1), 
(21473, 21473, "Alpine Buffalo", 0, "", 0, "LineageMonster2.baby_buffalo", 12, 15, 67, "male", "L2FeedableBeast", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9323, 888, 624.93199, 281.55251, 426.74754, 187.46084, 253, 1, 333, 0, 0, 0, 30, 130, 1, 1), 
(21474, 21474, "Alpine Buffalo", 0, "", 0, "LineageMonster2.baby_buffalo", 12, 15, 67, "male", "L2FeedableBeast", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 7835, 746, 624.93199, 281.55251, 426.74754, 187.46084, 253, 1, 333, 0, 0, 0, 30, 130, 1, 1), 
(21475, 21475, "Alpine Buffalo", 0, "", 0, "LineageMonster2.baby_buffalo", 12, 15, 67, "male", "L2FeedableBeast", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9323, 888, 624.93199, 281.55251, 426.74754, 187.46084, 253, 1, 333, 0, 0, 0, 30, 130, 1, 1), 
(21476, 21476, "Alpine Buffalo", 0, "", 0, "LineageMonster2.baby_buffalo", 12, 15, 67, "male", "L2FeedableBeast", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 7835, 746, 624.93199, 281.55251, 426.74754, 187.46084, 253, 1, 333, 0, 0, 0, 30, 130, 1, 1), 
(21477, 21477, "Alpine Buffalo", 0, "", 0, "LineageMonster2.baby_buffalo", 12, 15, 67, "male", "L2FeedableBeast", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9323, 888, 624.93199, 281.55251, 426.74754, 187.46084, 253, 1, 333, 0, 0, 0, 30, 130, 1, 1), 
(21478, 21478, "Alpine Buffalo", 0, "", 0, "LineageMonster2.baby_buffalo", 12, 15, 67, "male", "L2FeedableBeast", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 7835, 746, 624.93199, 281.55251, 426.74754, 187.46084, 253, 1, 333, 0, 0, 0, 30, 130, 1, 1), 
(21479, 21479, "Alpine Buffalo", 0, "", 0, "LineageMonster2.youth_buffalo", 16, 25.2, 67, "male", "L2FeedableBeast", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 19535, 1860, 624.93199, 281.55251, 426.74754, 187.46084, 253, 1, 333, 0, 0, 0, 20, 170, 0, 1), 
(21480, 21480, "Alpine Buffalo", 0, "", 0, "LineageMonster2.youth_buffalo", 16, 25.2, 67, "male", "L2FeedableBeast", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 20306, 1934, 624.93199, 281.55251, 426.74754, 187.46084, 253, 1, 333, 0, 0, 0, 20, 170, 0, 1), 
(21481, 21481, "Alpine Buffalo", 0, "", 0, "LineageMonster2.youth_buffalo", 16, 25.2, 67, "male", "L2FeedableBeast", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 19535, 1860, 624.93199, 281.55251, 426.74754, 187.46084, 253, 1, 333, 0, 0, 0, 20, 170, 0, 1), 
(21482, 21482, "Alpine Buffalo", 0, "", 0, "LineageMonster2.youth_buffalo", 16, 25.2, 67, "male", "L2FeedableBeast", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 18788, 1789, 624.93199, 281.55251, 426.74754, 187.46084, 253, 1, 333, 0, 0, 0, 20, 170, 0, 1), 
(21483, 21483, "Alpine Buffalo", 0, "", 0, "LineageMonster2.youth_buffalo", 16, 25.2, 67, "male", "L2FeedableBeast", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 19535, 1860, 624.93199, 281.55251, 426.74754, 187.46084, 253, 1, 333, 0, 0, 0, 20, 170, 0, 1), 
(21484, 21484, "Alpine Buffalo", 0, "", 0, "LineageMonster2.youth_buffalo", 16, 25.2, 67, "male", "L2FeedableBeast", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 20306, 1934, 624.93199, 281.55251, 426.74754, 187.46084, 253, 1, 333, 0, 0, 0, 20, 170, 0, 1), 
(21485, 21485, "Alpine Buffalo", 0, "", 0, "LineageMonster2.youth_buffalo", 16, 25.2, 67, "male", "L2FeedableBeast", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 19535, 1860, 624.93199, 281.55251, 426.74754, 187.46084, 253, 1, 333, 0, 0, 0, 20, 170, 0, 1), 
(21486, 21486, "Alpine Buffalo", 0, "", 0, "LineageMonster2.youth_buffalo", 16, 25.2, 67, "male", "L2FeedableBeast", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 18788, 1789, 624.93199, 281.55251, 426.74754, 187.46084, 253, 1, 333, 0, 0, 0, 20, 170, 0, 1), 
(21487, 21487, "Alpine Buffalo", 0, "", 0, "LineageMonster2.buffalo", 22, 31, 67, "male", "L2FeedableBeast", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 32934, 3137, 624.93199, 281.55251, 426.74754, 187.46084, 253, 1, 333, 0, 0, 0, 20, 170, 0, 1), 
(21488, 21488, "Alpine Buffalo", 0, "", 0, "LineageMonster2.buffalo", 22, 31, 67, "male", "L2FeedableBeast", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 31415, 2992, 624.93199, 281.55251, 426.74754, 187.46084, 253, 1, 333, 0, 0, 0, 20, 170, 0, 1), 
(21489, 21489, "Alpine Cougar", 0, "", 0, "LineageMonster2.baby_tiger", 11, 15.7, 69, "male", "L2FeedableBeast", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 3739, 366, 667.50361, 291.15063, 455.81844, 193.85137, 253, 4, 333, 0, 0, 0, 28, 110, 1, 1), 
(21490, 21490, "Alpine Cougar", 0, "", 0, "LineageMonster2.baby_tiger", 11, 15.7, 69, "male", "L2FeedableBeast", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9888, 967, 667.50361, 291.15063, 455.81844, 193.85137, 253, 4, 333, 0, 0, 0, 28, 130, 1, 1), 
(21491, 21491, "Alpine Cougar", 0, "", 0, "LineageMonster2.baby_tiger", 11, 15.7, 69, "male", "L2FeedableBeast", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 8309, 814, 667.50361, 291.15063, 455.81844, 193.85137, 253, 4, 333, 0, 0, 0, 28, 130, 1, 1), 
(21492, 21492, "Alpine Cougar", 0, "", 0, "LineageMonster2.baby_tiger", 11, 15.7, 69, "male", "L2FeedableBeast", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9888, 967, 667.50361, 291.15063, 455.81844, 193.85137, 253, 4, 333, 0, 0, 0, 28, 130, 1, 1), 
(21493, 21493, "Alpine Cougar", 0, "", 0, "LineageMonster2.baby_tiger", 11, 15.7, 69, "male", "L2FeedableBeast", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 8309, 814, 667.50361, 291.15063, 455.81844, 193.85137, 253, 4, 333, 0, 0, 0, 28, 130, 1, 1), 
(21494, 21494, "Alpine Cougar", 0, "", 0, "LineageMonster2.baby_tiger", 11, 15.7, 69, "male", "L2FeedableBeast", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9888, 967, 667.50361, 291.15063, 455.81844, 193.85137, 253, 4, 333, 0, 0, 0, 28, 130, 1, 1), 
(21495, 21495, "Alpine Cougar", 0, "", 0, "LineageMonster2.baby_tiger", 11, 15.7, 69, "male", "L2FeedableBeast", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 8309, 814, 667.50361, 291.15063, 455.81844, 193.85137, 253, 4, 333, 0, 0, 0, 28, 130, 1, 1), 
(21496, 21496, "Alpine Cougar", 0, "", 0, "LineageMonster2.baby_tiger", 11, 15.7, 69, "male", "L2FeedableBeast", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9888, 967, 667.50361, 291.15063, 455.81844, 193.85137, 253, 4, 333, 0, 0, 0, 28, 130, 1, 1), 
(21497, 21497, "Alpine Cougar", 0, "", 0, "LineageMonster2.baby_tiger", 11, 15.7, 69, "male", "L2FeedableBeast", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 8309, 814, 667.50361, 291.15063, 455.81844, 193.85137, 253, 4, 333, 0, 0, 0, 28, 130, 1, 1), 
(21498, 21498, "Alpine Cougar", 0, "", 0, "LineageMonster2.youth_tiger", 16, 17.2, 69, "male", "L2FeedableBeast", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 20719, 2027, 667.50361, 291.15063, 455.81844, 193.85137, 253, 4, 333, 0, 0, 0, 60, 175, 0, 1), 
(21499, 21499, "Alpine Cougar", 0, "", 0, "LineageMonster2.youth_tiger", 16, 17.2, 69, "male", "L2FeedableBeast", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 21536, 2107, 667.50361, 291.15063, 455.81844, 193.85137, 253, 4, 333, 0, 0, 0, 60, 175, 0, 1), 
(21500, 21500, "Alpine Cougar", 0, "", 0, "LineageMonster2.youth_tiger", 16, 17.2, 69, "male", "L2FeedableBeast", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 20719, 2027, 667.50361, 291.15063, 455.81844, 193.85137, 253, 4, 333, 0, 0, 0, 60, 175, 0, 1), 
(21501, 21501, "Alpine Cougar", 0, "", 0, "LineageMonster2.youth_tiger", 16, 17.2, 69, "male", "L2FeedableBeast", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 19926, 1950, 667.50361, 291.15063, 455.81844, 193.85137, 253, 4, 333, 0, 0, 0, 60, 175, 0, 1), 
(21502, 21502, "Alpine Cougar", 0, "", 0, "LineageMonster2.youth_tiger", 16, 17.2, 69, "male", "L2FeedableBeast", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 20719, 2027, 667.50361, 291.15063, 455.81844, 193.85137, 253, 4, 333, 0, 0, 0, 60, 175, 0, 1), 
(21503, 21503, "Alpine Cougar", 0, "", 0, "LineageMonster2.youth_tiger", 16, 17.2, 69, "male", "L2FeedableBeast", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 21536, 2107, 667.50361, 291.15063, 455.81844, 193.85137, 253, 4, 333, 0, 0, 0, 60, 175, 0, 1), 
(21504, 21504, "Alpine Cougar", 0, "", 0, "LineageMonster2.youth_tiger", 16, 17.2, 69, "male", "L2FeedableBeast", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 20719, 2027, 667.50361, 291.15063, 455.81844, 193.85137, 253, 4, 333, 0, 0, 0, 60, 175, 0, 1), 
(21505, 21505, "Alpine Cougar", 0, "", 0, "LineageMonster2.youth_tiger", 16, 17.2, 69, "male", "L2FeedableBeast", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 19926, 1950, 667.50361, 291.15063, 455.81844, 193.85137, 253, 4, 333, 0, 0, 0, 60, 175, 0, 1), 
(21506, 21506, "Alpine Cougar", 0, "", 0, "LineageMonster.saber_toothed_tiger", 34, 28, 69, "male", "L2FeedableBeast", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 34929, 3418, 667.50361, 291.15063, 455.81844, 193.85137, 253, 4, 333, 0, 0, 0, 60, 200, 0, 1), 
(21507, 21507, "Alpine Cougar", 0, "", 0, "LineageMonster.saber_toothed_tiger", 34, 28, 69, "male", "L2FeedableBeast", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 33319, 3260, 667.50361, 291.15063, 455.81844, 193.85137, 253, 4, 333, 0, 0, 0, 60, 200, 0, 1), 
(21508, 21508, "Splinter Stakato", 0, "", 0, "LineageMonster.blade_stakato", 15, 36, 66, "male", "L2Monster", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 8771, 825, 603.79903, 276.72752, 412.31647, 202.49719, 253, 4, 333, 235, 0, 0, 25, 175, 0, 1), 
(21509, 21509, "Splinter Stakato Worker", 0, "", 0, "LineageMonster.blade_stakato_worker", 13, 40, 67, "male", "L2Monster", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 8134, 774, 624.93199, 281.55251, 426.74754, 206.02791, 253, 4, 333, 0, 0, 0, 25, 180, 0, 1), 
(21510, 21510, "Splinter Stakato Soldier", 0, "", 0, "LineageMonster.blade_stakato_soldier", 15, 38, 68, "male", "L2Monster", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9561, 923, 646.17968, 286.3615, 441.25696, 209.54692, 253, 4, 333, 148, 0, 0, 25, 180, 0, 1), 
(21511, 21511, "Splinter Stakato Drone", 0, "", 0, "LineageMonster.blade_stakato_drone", 15, 39, 69, "male", "L2Monster", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 10158, 993, 667.50361, 291.15063, 455.81844, 213.05139, 253, 4, 333, 132, 0, 0, 25, 185, 0, 1), 
(21512, 21512, "Splinter Stakato Drone", 0, "", 0, "LineageMonster.blade_stakato_drone", 15, 39, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9379, 929, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 132, 0, 0, 25, 185, 0, 1), 
(21513, 21513, "Needle Stakato", 0, "", 0, "LineageMonster.blade_stakato", 15, 36, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9867, 978, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 235, 0, 0, 25, 185, 0, 1), 
(21514, 21514, "Needle Stakato Worker", 0, "", 0, "LineageMonster.blade_stakato_worker", 13, 40, 71, "male", "L2Monster", 40, 2492.727, 1377.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 9134, 916, 710.2185, 300.65359, 484.98717, 220.00525, 253, 4, 333, 0, 0, 0, 25, 190, 0, 1), 
(21515, 21515, "Needle Stakato Soldier", 0, "", 0, "LineageMonster.blade_stakato_soldier", 15, 38, 72, "male", "L2Monster", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 10718, 1088, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 148, 0, 0, 25, 190, 0, 1), 
(21516, 21516, "Needle Stakato Drone", 0, "", 0, "LineageMonster.blade_stakato_drone", 15, 39, 73, "male", "L2Monster", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 10730, 1104, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 132, 0, 0, 25, 195, 0, 1), 
(21517, 21517, "Needle Stakato Drone", 0, "", 0, "LineageMonster.blade_stakato_drone", 15, 39, 74, "male", "L2Monster", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 10481, 1092, 773.81598, 314.65987, 528.41601, 230.25444, 253, 4, 333, 132, 0, 0, 25, 195, 0, 1), 
(21518, 21518, "Frenzy Stakato Soldier", 0, "", 0, "LineageMonster.blade_stakato_soldier", 15, 38, 68, "male", "L2Monster", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9228, 891, 646.17968, 286.3615, 441.25696, 209.54692, 253, 4, 333, 235, 0, 0, 25, 185, 0, 1), 
(21519, 21519, "Frenzy Stakato Drone", 0, "", 0, "LineageMonster.blade_stakato_drone", 15, 39, 72, "male", "L2Monster", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 10345, 1051, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 235, 0, 0, 25, 195, 0, 1), 
(21520, 21520, "Eye of Splendor", 0, "", 0, "LineageMonster.kel_mahum", 13, 26, 60, "male", "L2Monster", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 8960, 778, 481.34551, 247.65008, 328.69659, 164.88822, 253, 4, 333, 326, 0, 0, 50, 160, 1, 1), 
(21521, 21521, "Claws of Splendor", 0, "", 0, "LineageMonster.kel_mahum_warrior", 13, 28, 60, "male", "L2Monster", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 8809, 764, 481.34551, 247.65008, 328.69659, 164.88822, 253, 4, 333, 326, 0, 0, 50, 160, 1, 1), 
(21522, 21522, "Claws of Splendor", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 60, "male", "L2Monster", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 10498, 911, 481.34551, 247.65008, 328.69659, 164.88822, 253, 4, 333, 0, 0, 0, 25, 155, 1, 1), 
(21523, 21523, "Flash of Splendor", 0, "", 0, "LineageMonster.kel_mahum_witch_doctor", 13, 25, 61, "male", "L2Monster", 40, 1985.55926, 1066.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9035, 796, 501.08068, 252.49346, 342.17315, 168.113, 253, 1, 333, 326, 0, 0, 50, 150, 1, 1), 
(21524, 21524, "Blade of Splendor", 0, "", 0, "LineageMonster.kel_mahum", 13, 26, 61, "male", "L2Monster", 40, 1985.55926, 1066.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9634, 848, 501.08068, 252.49346, 342.17315, 168.113, 253, 4, 333, 242, 0, 0, 50, 165, 1, 1), 
(21525, 21525, "Blade of Splendor", 0, "", 0, "LineageMonster.kel_mahum", 13, 26, 61, "male", "L2Monster", 40, 1985.55926, 1066.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9634, 848, 501.08068, 252.49346, 342.17315, 168.113, 253, 4, 333, 242, 0, 0, 50, 165, 1, 1), 
(21526, 21526, "Wisdom of Splendor", 0, "", 0, "LineageMonster.kel_mahum_warrior", 13, 28, 62, "male", "L2Monster", 40, 2037.81082, 1097, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 11065, 986, 521.12391, 257.34267, 355.86007, 171.34165, 253, 4, 333, 193, 0, 0, 50, 160, 1, 1), 
(21527, 21527, "Anger of Splendor", 0, "", 0, "LineageMonster.kel_mahum_champion", 13, 32, 63, "male", "L2Monster", 40, 2089.92274, 1127.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9759, 881, 541.44774, 262.19426, 369.73862, 174.5719, 253, 4, 333, 193, 0, 0, 50, 150, 1, 1), 
(21528, 21528, "Anger of Splendor", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 63, "male", "L2Monster", 40, 2089.92274, 1127.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 11574, 1045, 541.44774, 262.19426, 369.73862, 174.5719, 253, 4, 333, 0, 0, 0, 25, 155, 1, 1), 
(21529, 21529, "Soul of Splendor", 0, "", 0, "LineageMonster.kel_mahum_witch_doctor", 13, 25, 63, "male", "L2Monster", 40, 2089.92274, 1127.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 8853, 799, 541.44774, 262.19426, 369.73862, 174.5719, 253, 1, 333, 193, 0, 0, 50, 160, 1, 1), 
(21530, 21530, "Victory of Splendor", 0, "", 0, "LineageMonster.kel_mahum", 13, 26, 64, "male", "L2Monster", 40, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9608, 880, 562.02275, 267.04468, 383.78868, 177.80136, 253, 4, 333, 196, 0, 0, 50, 160, 1, 1), 
(21531, 21531, "Punishment of Splendor", 0, "", 0, "LineageMonster.kel_mahum_warrior", 13, 28, 64, "male", "L2Monster", 40, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 10605, 971, 562.02275, 267.04468, 383.78868, 177.80136, 253, 4, 333, 242, 0, 0, 50, 165, 1, 1), 
(21532, 21532, "Shout of Splendor", 0, "", 0, "LineageMonster.kel_mahum_champion", 13, 32, 65, "male", "L2Monster", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 11348, 1055, 582.81759, 271.89033, 397.98887, 181.02764, 253, 4, 333, 196, 0, 0, 50, 150, 1, 1), 
(21533, 21533, "Alliance of Splendor", 0, "", 0, "LineageMonster.kel_mahum_witch_doctor", 13, 25, 65, "male", "L2Monster", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9320, 866, 582.81759, 271.89033, 397.98887, 181.02764, 253, 1, 333, 196, 0, 0, 50, 160, 1, 1), 
(21534, 21534, "Alliance of Splendor", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 65, "male", "L2Monster", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 12321, 1145, 582.81759, 271.89033, 397.98887, 181.02764, 253, 4, 333, 0, 0, 0, 25, 155, 1, 1), 
(21535, 21535, "Signet of Splendor", 0, "", 0, "LineageMonster.kel_mahum_warrior", 13, 28, 66, "male", "L2Monster", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 11197, 1054, 603.79903, 276.72752, 412.31647, 184.2483, 253, 4, 333, 189, 0, 0, 50, 160, 1, 1), 
(21536, 21536, "Crown of Splendor", 0, "", 0, "LineageMonster.kel_mahum_champion", 13, 32, 66, "male", "L2Monster", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 11385, 1072, 603.79903, 276.72752, 412.31647, 184.2483, 253, 4, 333, 189, 0, 0, 50, 165, 1, 1), 
(21537, 21537, "Fang of Splendor", 0, "", 0, "LineageMonster.kel_mahum_witch_doctor", 13, 25, 67, "male", "L2Monster", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 10686, 1018, 624.93199, 281.55251, 426.74754, 187.46084, 253, 1, 333, 189, 0, 0, 50, 155, 1, 1), 
(21538, 21538, "Fang of Splendor", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 67, "male", "L2Monster", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 13091, 1247, 624.93199, 281.55251, 426.74754, 187.46084, 253, 4, 333, 0, 0, 0, 25, 155, 1, 1), 
(21539, 21539, "Wailing of Splendor", 0, "", 0, "LineageMonster.kel_mahum", 13, 26, 67, "male", "L2Monster", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 11622, 1106, 624.93199, 281.55251, 426.74754, 187.46084, 253, 4, 333, 242, 0, 0, 50, 170, 1, 1), 
(21540, 21540, "Wailing of Splendor", 0, "", 0, "LineageMonster.kel_mahum", 13, 26, 67, "male", "L2Monster", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 11622, 1106, 624.93199, 281.55251, 426.74754, 187.46084, 253, 4, 333, 242, 0, 0, 50, 170, 1, 1), 
(21541, 21541, "Pilgrim of Splendor", 0, "", 0, "LineageMonster.kel_mahum_witch_doctor", 13, 25, 63, "male", "L2Monster", 40, 2089.92274, 1127.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 11933, 1078, 541.44774, 262.19426, 369.73862, 174.5719, 253, 1, 333, 315, 0, 0, 50, 165, 0, 1), 
(21542, 21542, "Disciple of Pilgrim", 0, "", 0, "LineageMonster.kel_mahum_warrior", 13, 28, 62, "male", "L2Monster", 40, 2037.81082, 1097, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 8319, 742, 521.12391, 257.34267, 355.86007, 171.34165, 253, 4, 333, 193, 0, 0, 50, 165, 0, 1), 
(21543, 21543, "Page of Pilgrim", 0, "", 0, "LineageMonster.kel_mahum", 13, 26, 62, "male", "L2Monster", 40, 2037.81082, 1097, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9492, 846, 521.12391, 257.34267, 355.86007, 171.34165, 253, 4, 333, 326, 0, 0, 50, 165, 0, 1), 
(21544, 21544, "Judge of Splendor", 0, "", 0, "LineageMonster.kel_mahum_champion", 13, 32, 67, "male", "L2Monster", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 13598, 1295, 624.93199, 281.55251, 426.74754, 187.46084, 253, 4, 333, 150, 0, 0, 50, 160, 0, 1), 
(21545, 21545, "Judge of Fire", 0, "", 0, "LineageMonster.kel_mahum_witch_doctor", 13, 25, 66, "male", "L2Monster", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9427, 887, 603.79903, 276.72752, 412.31647, 184.2483, 253, 1, 333, 189, 0, 0, 50, 165, 0, 1), 
(21546, 21546, "Judge of Light", 0, "", 0, "LineageMonster.kel_mahum", 13, 26, 66, "male", "L2Monster", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 10756, 1013, 603.79903, 276.72752, 412.31647, 184.2483, 253, 4, 333, 196, 0, 0, 50, 165, 0, 1), 
(21547, 21547, "Corrupted Knight", 0, "", 0, "LineageMonster.skeleton_knight", 10, 25, 63, "male", "L2Monster", 40, 2089.92274, 1127.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9739, 880, 541.44774, 262.19426, 369.73862, 191.86238, 253, 4, 333, 150, 103, 0, 40, 165, 1, 1), 
(21548, 21548, "Resurrected Knight", 0, "", 0, "LineageMonster.skeleton_knight", 10, 25, 63, "male", "L2Monster", 40, 2089.92274, 1127.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 8423, 761, 541.44774, 262.19426, 369.73862, 191.86238, 253, 4, 333, 150, 103, 0, 40, 165, 1, 1), 
(21549, 21549, "Corrupted Guard", 0, "", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 64, "male", "L2Monster", 40, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 10051, 920, 562.02275, 267.04468, 383.78868, 195.41171, 253, 8, 333, 946, 0, 0, 80, 175, 1, 1), 
(21550, 21550, "Corrupted Guard", 0, "", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 64, "male", "L2Monster", 40, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 10252, 938, 562.02275, 267.04468, 383.78868, 195.41171, 253, 8, 333, 946, 945, 0, 80, 175, 1, 1), 
(21551, 21551, "Resurrected Guard", 0, "", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 66, "male", "L2Monster", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 11449, 1078, 603.79903, 276.72752, 412.31647, 202.49719, 253, 8, 333, 221, 0, 0, 80, 175, 1, 1), 
(21552, 21552, "Resurrected Guard", 0, "", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 66, "male", "L2Monster", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 10903, 1026, 603.79903, 276.72752, 412.31647, 202.49719, 253, 8, 333, 221, 945, 0, 80, 175, 1, 1), 
(21553, 21553, "Trampled Man", 0, "", 0, "LineageMonster.zombie", 13, 21, 65, "male", "L2Monster", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 7521, 698, 582.81759, 271.89033, 397.98887, 181.02764, 253, 4, 333, 0, 0, 0, 15, 40, 1, 1), 
(21554, 21554, "Trampled Man", 0, "", 0, "LineageMonster.zombie", 13, 21, 65, "male", "L2Monster", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 7521, 698, 582.81759, 271.89033, 397.98887, 181.02764, 253, 4, 333, 0, 0, 0, 15, 40, 1, 1), 
(21555, 21555, "Slaughter Executioner", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 65, "male", "L2Monster", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9144, 850, 582.81759, 271.89033, 397.98887, 181.02764, 253, 4, 333, 0, 0, 0, 100, 160, 1, 1), 
(21556, 21556, "Slaughter Executioner", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 65, "male", "L2Monster", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 8922, 829, 582.81759, 271.89033, 397.98887, 181.02764, 253, 4, 333, 0, 0, 0, 100, 160, 1, 1), 
(21557, 21557, "Bone Snatcher", 0, "", 0, "LineageMonster2.black_magician", 8, 30, 66, "male", "L2Monster", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 10529, 991, 603.79903, 276.72752, 412.31647, 184.2483, 253, 4, 333, 178, 0, 0, 19, 180, 1, 1), 
(21558, 21558, "Bone Snatcher", 0, "", 0, "LineageMonster2.black_magician", 8, 30, 66, "male", "L2Monster", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 10529, 991, 603.79903, 276.72752, 412.31647, 184.2483, 253, 4, 333, 178, 0, 0, 19, 180, 1, 1), 
(21559, 21559, "Bone Maker", 0, "", 0, "LineageMonster2.black_magician", 8, 30, 66, "male", "L2Monster", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 11515, 1084, 603.79903, 276.72752, 412.31647, 184.2483, 253, 4, 333, 178, 0, 0, 19, 180, 1, 1), 
(21560, 21560, "Bone Shaper", 0, "", 0, "LineageMonster2.black_magician", 8, 30, 66, "male", "L2Monster", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 11515, 1084, 603.79903, 276.72752, 412.31647, 184.2483, 253, 4, 333, 178, 0, 0, 19, 180, 1, 1), 
(21561, 21561, "Sacrificed Man", 0, "", 0, "LineageMonster.zombie", 13, 21, 67, "male", "L2Monster", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9669, 920, 624.93199, 281.55251, 426.74754, 187.46084, 253, 4, 333, 0, 0, 0, 15, 40, 1, 1), 
(21562, 21562, "Guillotine's Ghost", 0, "", 0, "LineageMonster.liviona", 15, 28, 67, "male", "L2Monster", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 10013, 954, 624.93199, 281.55251, 426.74754, 187.46084, 253, 1, 333, 0, 0, 0, 80, 150, 1, 1), 
(21563, 21563, "Bone Collector", 0, "", 0, "LineageMonster2.black_magician", 8, 30, 67, "male", "L2Monster", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 11634, 1108, 624.93199, 281.55251, 426.74754, 187.46084, 253, 4, 333, 178, 0, 0, 19, 180, 1, 1), 
(21564, 21564, "Skull Collector", 0, "", 0, "LineageMonster2.black_magician", 8, 30, 67, "male", "L2Monster", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 11068, 1054, 624.93199, 281.55251, 426.74754, 187.46084, 253, 4, 333, 178, 0, 0, 19, 180, 1, 1), 
(21565, 21565, "Bone Animator", 0, "", 0, "LineageMonster2.black_magician", 8, 30, 68, "male", "L2Monster", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 11177, 1080, 646.17968, 286.3615, 441.25696, 190.66272, 253, 4, 333, 178, 0, 0, 19, 180, 1, 1), 
(21566, 21566, "Skull Animator", 0, "", 0, "LineageMonster2.black_magician", 8, 30, 68, "male", "L2Monster", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 12224, 1181, 646.17968, 286.3615, 441.25696, 190.66272, 253, 4, 333, 178, 0, 0, 19, 180, 1, 1), 
(21567, 21567, "Bone Slayer", 0, "", 0, "LineageMonster2.black_magician", 8, 30, 68, "male", "L2Monster", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 14611, 1411, 646.17968, 286.3615, 441.25696, 190.66272, 253, 4, 333, 178, 0, 0, 19, 180, 1, 1), 
(21568, 21568, "Devil Bat", 0, "", 0, "LineageMonster.vampire_bat", 10, 33.5, 68, "male", "L2Monster", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 12528, 1211, 646.17968, 286.3615, 441.25696, 190.66272, 253, 4, 333, 0, 0, 0, 60, 170, 1, 1), 
(21569, 21569, "Devil Bat", 0, "", 0, "LineageMonster.vampire_bat", 10, 33.5, 68, "male", "L2Monster", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9730, 940, 646.17968, 286.3615, 441.25696, 190.66272, 253, 4, 333, 0, 0, 0, 60, 170, 1, 1), 
(21570, 21570, "Ghost of Betrayer", 0, "", 0, "LineageMonster.binding", 12, 21, 69, "male", "L2Monster", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9069, 887, 667.50361, 291.15063, 455.81844, 193.85137, 253, 4, 333, 0, 0, 0, 10, 174, 1, 1), 
(21571, 21571, "Ghost of Rebellion Soldier", 0, "", 0, "LineageMonster.skeleton_knight", 10, 25, 69, "male", "L2Monster", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 12862, 1259, 667.50361, 291.15063, 455.81844, 193.85137, 253, 4, 333, 150, 103, 0, 40, 165, 1, 1), 
(21572, 21572, "Bone Sweeper", 0, "", 0, "LineageMonster2.black_magician", 8, 30, 69, "male", "L2Monster", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 12339, 1207, 667.50361, 291.15063, 455.81844, 193.85137, 253, 4, 333, 178, 0, 0, 19, 185, 1, 1), 
(21573, 21573, "Atrox", 0, "", 0, "LineageMonster2.kailiharim", 45, 39, 69, "male", "L2Monster", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 13747, 1345, 667.50361, 291.15063, 455.81844, 193.85137, 253, 4, 333, 0, 0, 0, 105, 185, 1, 1), 
(21574, 21574, "Bone Grinder", 0, "", 0, "LineageMonster2.black_magician", 8, 30, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 15483, 1535, 688.86373, 295.91597, 470.40463, 197.0242, 253, 4, 333, 178, 0, 0, 19, 185, 1, 1), 
(21575, 21575, "Bone Grinder", 0, "", 0, "LineageMonster2.black_magician", 8, 30, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 8723, 865, 688.86373, 295.91597, 470.40463, 197.0242, 253, 4, 333, 178, 0, 0, 19, 185, 1, 1), 
(21576, 21576, "Ghost of Guillotine", 0, "", 0, "LineageMonster.liviona", 15, 28, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 11220, 1112, 688.86373, 295.91597, 470.40463, 197.0242, 253, 1, 333, 0, 0, 0, 80, 150, 1, 1), 
(21577, 21577, "Ghost of Guillotine", 0, "", 0, "LineageMonster.liviona", 15, 28, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9835, 976, 688.86373, 295.91597, 470.40463, 197.0242, 253, 1, 333, 0, 0, 0, 80, 150, 1, 1), 
(21578, 21578, "Behemoth Zombie", 0, "", 0, "LineageMonster2.giant_zombie", 13, 40, 71, "male", "L2Monster", 40, 2492.727, 1377.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 12370, 1241, 710.2185, 300.65359, 484.98717, 200.17855, 253, 4, 333, 0, 0, 0, 20, 90, 1, 1), 
(21579, 21579, "Ghost of Rebellion Leader", 0, "", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 71, "male", "L2Monster", 40, 2492.727, 1377.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 13012, 1306, 710.2185, 300.65359, 484.98717, 200.17855, 253, 8, 333, 221, 945, 0, 80, 175, 1, 1), 
(21580, 21580, "Bone Caster", 0, "", 0, "LineageMonster2.black_magician", 8, 30, 71, "male", "L2Monster", 40, 2492.727, 1377.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 12185, 1223, 710.2185, 300.65359, 484.98717, 200.17855, 253, 4, 333, 178, 0, 0, 19, 185, 1, 1), 
(21581, 21581, "Bone Puppeteer", 0, "", 0, "LineageMonster2.black_magician", 8, 30, 71, "male", "L2Monster", 40, 2492.727, 1377.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 13326, 1337, 710.2185, 300.65359, 484.98717, 200.17855, 253, 4, 333, 178, 0, 0, 19, 185, 1, 1), 
(21582, 21582, "Vampire Soldier", 0, "", 0, "LineageMonster2.vampire_soldier", 8, 23.5, 71, "male", "L2Monster", 40, 2492.727, 1377.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 14270, 1432, 710.2185, 300.65359, 484.98717, 200.17855, 253, 4, 333, 234, 0, 0, 60, 190, 1, 1), 
(21583, 21583, "Bone Scavenger", 0, "", 0, "LineageMonster2.black_magician", 8, 30, 72, "male", "L2Monster", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 13436, 1364, 731.52506, 305.35947, 499.53679, 203.31178, 253, 4, 333, 178, 0, 0, 19, 185, 1, 1), 
(21584, 21584, "Bone Scavenger", 0, "", 0, "LineageMonster2.black_magician", 8, 30, 72, "male", "L2Monster", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 12531, 1273, 731.52506, 305.35947, 499.53679, 203.31178, 253, 4, 333, 178, 0, 0, 19, 185, 1, 1), 
(21585, 21585, "Vampire Magician", 0, "", 0, "LineageMonster2.vampire_witch", 6, 21.5, 72, "female", "L2Monster", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 11554, 1174, 731.52506, 305.35947, 499.53679, 203.31178, 253, 4, 333, 946, 0, 0, 64, 180, 1, 1), 
(21586, 21586, "Vampire Adept", 0, "", 0, "LineageMonster2.vampire_wizard", 5.5, 28, 72, "female", "L2Monster", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 13649, 1387, 731.52506, 305.35947, 499.53679, 203.31178, 253, 4, 333, 99, 0, 0, 46, 180, 1, 1), 
(21587, 21587, "Vampire Warrior", 0, "", 0, "LineageMonster2.vampire_soldier_20_bi", 10, 29, 72, "male", "L2Monster", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 14223, 1445, 731.52506, 305.35947, 499.53679, 203.31178, 253, 4, 333, 234, 0, 0, 60, 190, 1, 1), 
(21588, 21588, "Vampire Wizard", 0, "", 0, "LineageMonster2.vampire_witch", 6, 21.5, 73, "female", "L2Monster", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 11923, 1226, 752.73928, 310.02959, 514.02335, 206.4212, 253, 4, 333, 946, 0, 0, 64, 180, 1, 1), 
(21589, 21589, "Vampire Wizard", 0, "", 0, "LineageMonster2.vampire_witch", 6, 21.5, 73, "female", "L2Monster", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 12202, 1255, 752.73928, 310.02959, 514.02335, 206.4212, 253, 4, 333, 946, 0, 0, 64, 180, 1, 1), 
(21590, 21590, "Vampire Magister", 0, "", 0, "LineageMonster2.vampire_wizard", 5.5, 28, 73, "female", "L2Monster", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 11923, 1226, 752.73928, 310.02959, 514.02335, 206.4212, 253, 4, 333, 99, 0, 0, 46, 180, 1, 1), 
(21591, 21591, "Vampire Magister", 0, "", 0, "LineageMonster2.vampire_wizard", 5.5, 28, 73, "female", "L2Monster", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 13756, 1415, 752.73928, 310.02959, 514.02335, 206.4212, 253, 4, 333, 99, 0, 0, 46, 180, 1, 1), 
(21592, 21592, "Vampire Magister", 0, "", 0, "LineageMonster2.vampire_wizard", 5.5, 28, 73, "female", "L2Monster", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 9301, 956, 752.73928, 310.02959, 514.02335, 206.4212, 253, 4, 333, 99, 0, 0, 46, 180, 1, 1), 
(21593, 21593, "Vampire Warlord", 0, "", 0, "LineageMonster2.vampire_warrior", 9, 31.5, 73, "male", "L2Monster", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 16016, 1648, 752.73928, 310.02959, 514.02335, 206.4212, 253, 4, 333, 6723, 0, 0, 43, 190, 1, 1), 
(21594, 21594, "Vampire Warlord", 0, "", 0, "LineageMonster2.vampire_warrior", 9, 31.5, 73, "male", "L2Monster", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 15086, 1553, 752.73928, 310.02959, 514.02335, 206.4212, 253, 4, 333, 6723, 0, 0, 43, 190, 1, 1), 
(21595, 21595, "Vampire Warlord", 0, "", 0, "LineageMonster2.vampire_warrior", 9, 31.5, 73, "male", "L2Monster", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 10993, 1132, 752.73928, 310.02959, 514.02335, 206.4212, 253, 4, 333, 6723, 0, 0, 43, 190, 1, 1), 
(21596, 21596, "Requiem Lord", 0, "", 0, "LineageMonster2.black_magician", 8, 30, 68, "male", "L2Monster", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 14446, 1396, 646.17968, 286.3615, 441.25696, 190.66272, 253, 4, 333, 178, 0, 0, 19, 185, 0, 1), 
(21597, 21597, "Requiem Behemoth", 0, "", 0, "LineageMonster2.giant_zombie", 13, 40, 67, "male", "L2Monster", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 9919, 944, 624.93199, 281.55251, 426.74754, 187.46084, 253, 4, 333, 0, 0, 0, 20, 100, 0, 1), 
(21598, 21598, "Requiem Behemoth", 0, "", 0, "LineageMonster2.giant_zombie", 13, 40, 67, "male", "L2Monster", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 11015, 1049, 624.93199, 281.55251, 426.74754, 187.46084, 253, 4, 333, 0, 0, 0, 20, 100, 0, 1), 
(21599, 21599, "Requiem Priest", 0, "", 0, "LineageMonster2.black_magician", 8, 30, 71, "male", "L2Monster", 40, 2492.727, 1377.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 15301, 1535, 710.2185, 300.65359, 484.98717, 200.17855, 253, 4, 333, 178, 0, 0, 19, 185, 0, 1), 
(21600, 21600, "Requiem Behemoth", 0, "", 0, "LineageMonster2.giant_zombie", 13, 40, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 10827, 1074, 688.86373, 295.91597, 470.40463, 197.0242, 253, 4, 333, 0, 0, 0, 20, 100, 0, 1), 
(21601, 21601, "Requiem Behemoth", 0, "", 0, "LineageMonster2.giant_zombie", 13, 40, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 12879, 1277, 688.86373, 295.91597, 470.40463, 197.0242, 253, 4, 333, 0, 0, 0, 20, 100, 0, 1), 
(21602, 21602, "Zaken's Pikeman", 0, "", 0, "LineageMonster.skeleton_pikeman", 10, 28, 43, "male", "L2Monster", 40, 1094.28943, 557.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4433, 300, 210.04832, 169.13417, 143.43577, 112.61144, 253, 4, 333, 292, 0, 0, 50, 174, 0, 1), 
(21603, 21603, "Zaken's Pikeman", 0, "", 0, "LineageMonster.skeleton_pikeman", 10, 28, 43, "male", "L2Monster", 40, 1094.28943, 557.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 6277, 425, 210.04832, 169.13417, 143.43577, 112.61144, 253, 4, 333, 292, 0, 0, 50, 174, 0, 1), 
(21604, 21604, "Zaken's Elite Pikeman", 0, "", 0, "LineageMonster.skeleton_pikeman_20_bi", 12, 33.6, 43, "male", "L2Monster", 40, 1094.28943, 557.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 10149, 686, 210.04832, 169.13417, 143.43577, 112.61144, 253, 4, 333, 292, 0, 0, 50, 174, 0, 1), 
(21605, 21605, "Zaken's Archer", 0, "", 0, "LineageMonster.skeleton_archer", 11, 27, 44, "male", "L2Monster", 1100, 1138.62924, 584, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4931, 337, 222.23112, 173.43552, 151.75505, 115.47533, 253, 8, 333, 279, 0, 0, 40, 174, 0, 1), 
(21606, 21606, "Zaken's Archer", 0, "", 0, "LineageMonster.skeleton_archer", 11, 27, 44, "male", "L2Monster", 1100, 1138.62924, 584, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 6982, 478, 222.23112, 173.43552, 151.75505, 115.47533, 253, 8, 333, 279, 0, 0, 40, 174, 0, 1), 
(21607, 21607, "Zaken's Elite Archer", 0, "", 0, "LineageMonster.skeleton_archer_20_bi", 13, 32.5, 44, "male", "L2Monster", 1100, 1138.62924, 584, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 10911, 746, 222.23112, 173.43552, 151.75505, 115.47533, 253, 8, 333, 279, 0, 0, 40, 174, 0, 1), 
(21608, 21608, "Zaken's Watchman", 0, "", 0, "LineageMonster.liviona", 15, 28, 45, "male", "L2Monster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4039, 281, 234.89829, 177.78746, 160.40508, 118.3729, 253, 1, 333, 0, 0, 0, 80, 174, 0, 1), 
(21609, 21609, "Zaken's Watchman", 0, "", 0, "LineageMonster.liviona", 15, 28, 45, "male", "L2Monster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 5720, 397, 234.89829, 177.78746, 160.40508, 118.3729, 253, 1, 333, 0, 0, 0, 80, 174, 0, 1), 
(21610, 21610, "Zaken's High Grade Watchman", 0, "", 0, "LineageMonster.liviona_20_bi", 18, 33.6, 45, "male", "L2Monster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 10440, 726, 234.89829, 177.78746, 160.40508, 118.3729, 253, 1, 333, 0, 0, 0, 80, 174, 0, 1), 
(21611, 21611, "Unpleasant Humming", 0, "", 0, "LineageMonster.unpleasant_humming", 12, 26, 46, "male", "L2Monster", 40, 1229.78678, 637.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4689, 332, 248.0526, 182.18816, 169.38777, 121.30293, 253, 4, 333, 0, 0, 0, 21, 174, 0, 1), 
(21612, 21612, "Unpleasant Humming", 0, "", 0, "LineageMonster.unpleasant_humming", 12, 26, 46, "male", "L2Monster", 40, 1229.78678, 637.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 6640, 470, 248.0526, 182.18816, 169.38777, 121.30293, 253, 4, 333, 0, 0, 0, 21, 174, 0, 1), 
(21613, 21613, "Unpleasant Shout", 0, "", 0, "LineageMonster.unpleasant_humming_20_bi", 13.5, 31.2, 46, "male", "L2Monster", 40, 1229.78678, 637.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 11332, 803, 248.0526, 182.18816, 169.38777, 121.30293, 253, 4, 333, 0, 0, 0, 21, 174, 0, 1), 
(21614, 21614, "Death Flyer", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 47, "male", "L2Monster", 40, 1276.53628, 665, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4843, 347, 261.69549, 186.63569, 178.7041, 124.26415, 253, 1, 333, 0, 0, 0, 100, 174, 0, 1), 
(21615, 21615, "Death Flyer", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 47, "male", "L2Monster", 40, 1276.53628, 665, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 6858, 492, 261.69549, 186.63569, 178.7041, 124.26415, 253, 1, 333, 0, 0, 0, 100, 174, 0, 1), 
(21616, 21616, "Gigantic Flyer", 0, "", 0, "LineageMonster.dark_horror_bi", 20, 42, 47, "male", "L2Monster", 40, 1276.53628, 665, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 12517, 898, 261.69549, 186.63569, 178.7041, 124.26415, 253, 1, 333, 0, 0, 0, 100, 174, 0, 1), 
(21617, 21617, "Fiend Archer", 0, "", 0, "LineageMonster.fiend_archer", 17, 55, 48, "male", "L2Monster", 1100, 1324.01623, 692.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4925, 360, 275.82705, 191.12803, 188.35412, 127.2552, 253, 8, 333, 0, 0, 0, 70, 174, 0, 1), 
(21618, 21618, "Fiend Archer", 0, "", 0, "LineageMonster.fiend_archer", 17, 55, 48, "male", "L2Monster", 1100, 1324.01623, 692.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 6974, 510, 275.82705, 191.12803, 188.35412, 127.2552, 253, 8, 333, 0, 0, 0, 70, 174, 0, 1), 
(21619, 21619, "Pit Archer", 0, "", 0, "LineageMonster.fiend_archer_20_bi", 20, 66, 48, "male", "L2Monster", 1100, 1324.01623, 692.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 12729, 930, 275.82705, 191.12803, 188.35412, 127.2552, 253, 8, 333, 0, 0, 0, 70, 174, 0, 1), 
(21620, 21620, "Musveren", 0, "", 0, "LineageMonster.field_stalker", 15, 30, 49, "male", "L2Monster", 40, 1372.18568, 720, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4742, 350, 290.44588, 195.66302, 198.33688, 130.27465, 253, 4, 333, 0, 0, 0, 70, 174, 0, 1), 
(21621, 21621, "Musveren", 0, "", 0, "LineageMonster.field_stalker", 15, 30, 49, "male", "L2Monster", 40, 1372.18568, 720, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 6715, 497, 290.44588, 195.66302, 198.33688, 130.27465, 253, 4, 333, 0, 0, 0, 70, 174, 0, 1), 
(21622, 21622, "Greater Musveren", 0, "", 0, "LineageMonster.field_stalker_20_bi", 18, 36, 49, "male", "L2Monster", 40, 1372.18568, 720, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 12257, 906, 290.44588, 195.66302, 198.33688, 130.27465, 253, 4, 333, 0, 0, 0, 70, 174, 0, 1), 
(21623, 21623, "Zaken's Guard", 0, "", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 50, "male", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 5993, 451, 305.54906, 200.23844, 208.6504, 133.32101, 253, 8, 333, 225, 945, 0, 80, 174, 0, 1), 
(21624, 21624, "Zaken's Guard", 0, "", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 50, "male", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 8487, 640, 305.54906, 200.23844, 208.6504, 133.32101, 253, 8, 333, 225, 945, 0, 80, 174, 0, 1), 
(21625, 21625, "Zaken's Elite Guard", 0, "", 0, "LineageMonster.skeleton_royal_guard_20_bi", 13, 34.5, 50, "male", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 13722, 1033, 305.54906, 200.23844, 208.6504, 133.32101, 253, 8, 333, 225, 945, 0, 80, 174, 0, 1), 
(21626, 21626, "Kaim Vanul", 0, "", 0, "LineageMonster.kaim_vanul", 24, 40, 51, "male", "L2Monster", 40, 1470.41596, 775.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 5345, 408, 321.13207, 204.85194, 219.29157, 136.39273, 253, 4, 333, 0, 0, 0, 37, 174, 0, 1), 
(21627, 21627, "Kaim Vanul", 0, "", 0, "LineageMonster.kaim_vanul", 24, 40, 51, "male", "L2Monster", 40, 1470.41596, 775.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 7568, 577, 321.13207, 204.85194, 219.29157, 136.39273, 253, 4, 333, 0, 0, 0, 37, 174, 0, 1), 
(21628, 21628, "Kaim Vanul Lad", 0, "", 0, "LineageMonster.kaim_vanul_20_bi", 28, 48, 51, "male", "L2Monster", 40, 1470.41596, 775.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 13814, 1054, 321.13207, 204.85194, 219.29157, 136.39273, 253, 4, 333, 0, 0, 0, 37, 174, 0, 1), 
(21629, 21629, "Pirate Zombie Captain", 0, "", 0, "LineageMonster.pirates_zombie_captain", 17, 28, 52, "male", "L2Monster", 40, 1520.38155, 804, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 8073, 624, 337.18867, 209.50106, 230.25615, 139.48817, 253, 8, 333, 232, 0, 0, 14, 174, 0, 1), 
(21630, 21630, "Pirate Zombie Captain", 0, "", 0, "LineageMonster.pirates_zombie_captain", 17, 28, 52, "male", "L2Monster", 40, 1520.38155, 804, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 11432, 884, 337.18867, 209.50106, 230.25615, 139.48817, 253, 8, 333, 232, 0, 0, 14, 174, 0, 1), 
(21631, 21631, "Zombie Captain's Spiritual Body", 0, "", 0, "LineageMonster.pirates_zombie_captain_20_bi", 20, 33.6, 52, "male", "L2Monster", 40, 1520.38155, 804, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 18953, 1466, 337.18867, 209.50106, 230.25615, 139.48817, 253, 8, 333, 232, 0, 0, 14, 174, 0, 1), 
(21632, 21632, "Doll Blader", 0, "", 0, "LineageMonster.doll_blader", 6, 12, 53, "male", "L2Monster", 40, 1570.8463, 832.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 6407, 504, 353.71092, 214.18326, 241.5387, 142.60563, 253, 8, 333, 5129, 5129, 0, 22, 174, 0, 1), 
(21633, 21633, "Doll Blader", 0, "", 0, "LineageMonster.doll_blader", 6, 12, 53, "male", "L2Monster", 40, 1570.8463, 832.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 9073, 713, 353.71092, 214.18326, 241.5387, 142.60563, 253, 8, 333, 5129, 5129, 0, 22, 174, 0, 1), 
(21634, 21634, "Crimson Doll Blader", 0, "", 0, "LineageMonster.doll_blader_20_bi", 7, 15, 53, "male", "L2Monster", 40, 1570.8463, 832.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 16560, 1302, 353.71092, 214.18326, 241.5387, 142.60563, 253, 8, 333, 5129, 5129, 0, 22, 174, 0, 1), 
(21635, 21635, "Vale Master", 0, "", 0, "LineageMonster.vale_master", 12, 40, 54, "male", "L2Monster", 40, 1621.75618, 861, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 6112, 487, 370.68904, 218.89589, 253.13256, 145.74335, 253, 4, 333, 0, 0, 0, 70, 174, 0, 1), 
(21636, 21636, "Vale Master", 0, "", 0, "LineageMonster.vale_master", 12, 40, 54, "male", "L2Monster", 40, 1621.75618, 861, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 8655, 690, 370.68904, 218.89589, 253.13256, 145.74335, 253, 4, 333, 0, 0, 0, 70, 174, 0, 1), 
(21637, 21637, "Crimson Vale Master", 0, "", 0, "LineageMonster.vale_master_20_bi", 14.5, 48, 54, "male", "L2Monster", 40, 1621.75618, 861, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 15797, 1260, 370.68904, 218.89589, 253.13256, 145.74335, 253, 4, 333, 0, 0, 0, 70, 174, 0, 1), 
(21638, 21638, "Dread Wolf", 0, "", 0, "LineageMonster.dire_wolf", 13, 11, 35, "male", "L2Monster", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1382, 82, 129.32896, 136.72948, 88.31491, 91.03603, 253, 4, 333, 0, 0, 0, 24, 140, 1, 1), 
(21639, 21639, "Tasaba Lizardman", 0, "", 0, "LineageMonster.virud_lizardman_scout", 10, 22, 36, "male", "L2Monster", 1100, 809.52639, 417.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1635, 98, 137.86467, 140.57278, 94.1437, 93.59494, 253, 8, 333, 2507, 0, 0, 43, 140, 1, 1), 
(21640, 21640, "Tasaba Lizardman Shaman", 0, "", 0, "LineageMonster.virud_lizardman_shaman", 10, 29, 37, "male", "L2Monster", 40, 847.31754, 432.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1202, 74, 146.82587, 144.47758, 100.26304, 96.19481, 253, 1, 333, 7, 0, 0, 43, 140, 1, 1), 
(21641, 21641, "Ogre", 0, "", 0, "LineageMonster.ogre", 21, 44, 38, "male", "L2Monster", 40, 886.09975, 447.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2134, 133, 156.22273, 148.44287, 106.67987, 98.83494, 253, 1, 333, 98, 0, 0, 22, 174, 1, 1), 
(21642, 21642, "Tasaba Lizardman Sniper", 0, "", 0, "LineageMonster.virud_lizardman_scout", 10, 22, 39, "male", "L2Monster", 1100, 925.85879, 463.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1958, 125, 166.06476, 152.46752, 113.4007, 101.5146, 253, 8, 333, 2507, 0, 0, 43, 140, 1, 1), 
(21643, 21643, "Tasaba Lizardman Sniper", 0, "", 0, "LineageMonster.virud_lizardman_scout", 10, 22, 39, "male", "L2Monster", 1100, 925.85879, 463.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2488, 158, 166.06476, 152.46752, 113.4007, 101.5146, 253, 8, 333, 2507, 0, 0, 43, 140, 1, 1), 
(21644, 21644, "Lienrik", 0, "", 0, "LineageMonster.lienrik", 12, 50, 39, "male", "L2Monster", 40, 925.85879, 463.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1195, 76, 166.06476, 152.46752, 113.4007, 101.5146, 253, 8, 333, 0, 0, 0, 100, 150, 1, 1), 
(21645, 21645, "Lienrik Lad", 0, "", 0, "LineageMonster.lienrik", 12, 50, 40, "male", "L2Monster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2302, 149, 176.36077, 156.55035, 120.43155, 104.23299, 253, 8, 333, 0, 0, 0, 100, 174, 1, 1), 
(21646, 21646, "Grave Scarab", 0, "", 0, "LineageMonster2.scarab", 14, 22, 73, "male", "L2Monster", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 12247, 1260, 752.73928, 310.02959, 514.02335, 206.4212, 253, 4, 333, 0, 0, 0, 45, 180, 1, 1), 
(21647, 21647, "Scavenger Scarab", 0, "", 0, "LineageMonster2.scarab", 14, 22, 73, "male", "L2Monster", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 10332, 1063, 752.73928, 310.02959, 514.02335, 206.4212, 253, 4, 333, 0, 0, 0, 45, 180, 1, 1), 
(21648, 21648, "Grave Ant", 0, "", 0, "LineageMonster.ant_soldier", 35, 17, 74, "male", "L2Monster", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 11260, 1174, 773.81598, 314.65987, 528.41601, 209.50409, 253, 4, 333, 0, 0, 0, 80, 150, 1, 1), 
(21649, 21649, "Scavenger Ant", 0, "", 0, "LineageMonster.ant_soldier", 35, 17, 74, "male", "L2Monster", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 13319, 1388, 773.81598, 314.65987, 528.41601, 209.50409, 253, 4, 333, 0, 0, 0, 80, 150, 1, 1), 
(21650, 21650, "Shrine Knight", 0, "", 0, "LineageMonster.skeleton_knight", 10, 25, 75, "male", "L2Monster", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 12179, 1285, 794.70901, 319.24623, 542.68324, 212.55774, 253, 4, 333, 150, 103, 0, 40, 165, 1, 1), 
(21651, 21651, "Shrine Guard", 0, "", 0, "LineageMonster.skeleton_pikeman", 10, 28, 75, "male", "L2Monster", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 11635, 1228, 794.70901, 319.24623, 542.68324, 212.55774, 253, 4, 333, 98, 0, 0, 50, 170, 1, 1), 
(21652, 21652, "Scarlet Stakato Noble", 0, "", 0, "LineageMonster.blade_stakato_drone", 15, 39, 78, "male", "L2Monster", 40, 2870.777409, 1657.41, 8.585, 3.03, 40, 43, 30, 21, 20, 20, 46911, 5199, 884.25257, 340.44078, 609.86817, 226.66932, 253, 8, 333, 235, 0, 0, 25, 165, 0, 1), 
(21653, 21653, "Assassin Beetle", 0, "", 0, "LineageMonster2.tera_beetle", 19, 54.5, 78, "male", "L2Monster", 40, 2937.983806, 1708.296, 8.67, 3.06, 40, 43, 30, 21, 20, 20, 34021, 3819, 912.65371, 348.2025, 635.68866, 231.83715, 253, 4, 333, 0, 0, 0, 45, 165, 0, 1), 
(21654, 21654, "Necromancer of Destruction", 0, "", 0, "LineageMonster.vale_master_20_bi", 14.5, 48, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 40213, 4566, 938.20801, 354.81835, 656.66638, 239.18092, 253, 4, 333, 0, 0, 0, 70, 140, 0, 1), 
(21655, 21655, "Arimanes of Destruction", 0, "", 0, "LineageMonster2.ahrimanes", 14, 57.75, 78, "male", "L2Monster", 40, 3010.892998, 1777.86, 8.772, 3.1008, 40, 43, 30, 21, 20, 20, 35744, 4106, 961.93701, 361.08599, 677.64411, 246.33071, 253, 4, 333, 6722, 0, 0, 35, 185, 0, 1), 
(21656, 21656, "Ashuras of Destruction", 0, "", 0, "LineageMonster2.ashuras_30_bi", 17, 49, 78, "male", "L2Monster", 40, 3077.157206, 1848.24, 8.874, 3.1314, 40, 43, 30, 21, 20, 20, 62781, 7385, 1009.395, 373.96949, 719.59956, 261.02228, 253, 4, 333, 0, 0, 0, 41, 190, 0, 1), 
(21657, 21657, "Magma Drake", 0, "", 0, "LineageMonster2.inferno_drake_20_bi", 29, 42, 78, "male", "L2Monster", 40, 3107.643659, 1883.736, 8.925, 3.1518, 40, 43, 30, 21, 20, 20, 54374, 6472, 1033.124, 380.23713, 740.57728, 268.30468, 253, 4, 333, 0, 0, 0, 57, 185, 0, 1), 
(21658, 21658, "Punishment of Splendor", 0, "", 0, "LineageMonster.kel_mahum_warrior", 13, 28, 64, "male", "L2Monster", 40, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 10605, 971, 562.02275, 267.04468, 383.78868, 177.80136, 253, 4, 333, 242, 0, 0, 50, 165, 1, 1), 
(21659, 21659, "Otherworldly Invader Soldier", 0, "", 0, "LineageMonster.neer_crawler", 14, 22, 30, "male", "L2RiftInvader", 40, 604.08419, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 4372, 239, 92.64226, 118.46427, 63.26266, 78.87485, 253, 8, 333, 0, 0, 0, 50, 165, 0, 1), 
(21660, 21660, "Otherworldly Invader Soldier", 0, "", 0, "LineageMonster.neer_crawler", 14, 22, 35, "male", "L2RiftInvader", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 6221, 368, 129.32896, 136.72948, 88.31491, 91.03603, 253, 8, 333, 0, 0, 0, 50, 165, 0, 1), 
(21661, 21661, "Otherworldly Invader Archer", 0, "", 0, "LineageMonster.skeleton_archer", 11, 27, 33, "male", "L2RiftInvader", 1100, 702.20463, 372.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 4478, 257, 113.49065, 129.23095, 77.49941, 86.04342, 253, 8, 333, 275, 0, 0, 40, 165, 0, 1), 
(21662, 21662, "Otherworldly Invader Elite Soldier", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 35, "male", "L2RiftInvader", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 5178, 306, 129.32896, 136.72948, 88.31491, 91.03603, 253, 4, 333, 0, 0, 0, 100, 165, 0, 1), 
(21663, 21663, "Otherworldly Invader Shaman", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 33, "male", "L2RiftInvader", 40, 702.20463, 372.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 5654, 324, 113.49065, 129.23095, 77.49941, 86.04342, 253, 4, 333, 0, 0, 0, 100, 165, 0, 1), 
(21664, 21664, "Otherworldly Invader Priest", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 30, "male", "L2RiftInvader", 40, 604.08419, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 3023, 165, 92.64226, 118.46427, 63.26266, 78.87485, 253, 4, 333, 0, 0, 0, 100, 165, 0, 1), 
(21665, 21665, "Otherworldly Invader Magus", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 35, "male", "L2RiftInvader", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 4089, 242, 129.32896, 136.72948, 88.31491, 91.03603, 253, 4, 333, 0, 0, 0, 100, 165, 0, 1), 
(21666, 21666, "Otherworldly Invader Martyrs", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 30, "male", "L2RiftInvader", 40, 604.08419, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 3054, 167, 92.64226, 118.46427, 63.26266, 78.87485, 253, 4, 333, 0, 0, 0, 100, 165, 0, 1), 
(21667, 21667, "Otherworldly Invader Warrior", 0, "", 0, "LineageMonster.skeleton", 11, 25, 33, "male", "L2RiftInvader", 40, 702.20463, 372.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 3635, 209, 113.49065, 129.23095, 77.49941, 86.04342, 253, 8, 333, 220, 0, 0, 60, 165, 0, 1), 
(21668, 21668, "Otherworldly Invader Soldier", 0, "", 0, "LineageMonster.neer_crawler", 14, 22, 30, "male", "L2RiftInvader", 40, 604.08419, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 3215, 176, 92.64226, 118.46427, 63.26266, 78.87485, 253, 8, 333, 0, 0, 0, 50, 165, 0, 1), 
(21669, 21669, "Otherworldly Invader Discipline", 0, "", 0, "LineageMonster.skeleton", 11, 25, 33, "male", "L2RiftInvader", 40, 702.20463, 372.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 3828, 220, 113.49065, 129.23095, 77.49941, 86.04342, 253, 8, 333, 220, 0, 0, 60, 165, 0, 1), 
(21670, 21670, "Otherworldly Invader Berserker", 0, "", 0, "LineageMonster.skeleton", 11, 25, 35, "male", "L2RiftInvader", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 5356, 317, 129.32896, 136.72948, 88.31491, 91.03603, 253, 8, 333, 220, 0, 0, 60, 165, 0, 1), 
(21671, 21671, "Otherworldly Invader Food", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 30, "male", "L2Chest", 40, 604.08419, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1309, 72, 92.64226, 118.46427, 63.26266, 78.87485, 253, 4, 333, 0, 0, 0, 80, 165, 0, 1), 
(21672, 21672, "Otherworldly Invader Elite Soldier", 0, "", 0, "LineageMonster.skeleton_pikeman", 10, 28, 35, "male", "L2RiftInvader", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 9595, 568, 129.32896, 136.72948, 88.31491, 91.03603, 253, 4, 333, 96, 0, 0, 50, 165, 0, 1), 
(21673, 21673, "Otherworldly Invader Elite Soldier", 0, "", 0, "LineageMonster.skeleton_pikeman", 10, 28, 35, "male", "L2RiftInvader", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 9777, 579, 129.32896, 136.72948, 88.31491, 91.03603, 253, 4, 333, 96, 0, 0, 50, 165, 0, 1), 
(21674, 21674, "Otherworldly Invader Elite Soldier", 0, "", 0, "LineageMonster.skeleton_pikeman", 10, 28, 35, "male", "L2RiftInvader", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 381, 23, 129.32896, 136.72948, 88.31491, 91.03603, 253, 4, 333, 96, 0, 0, 50, 165, 0, 1), 
(21675, 21675, "Otherworldly Invader Elite Soldier", 0, "", 0, "LineageMonster.skeleton_pikeman", 10, 28, 30, "male", "L2RiftInvader", 40, 604.08419, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 778, 42, 92.64226, 118.46427, 63.26266, 78.87485, 253, 4, 333, 96, 0, 0, 50, 165, 0, 1), 
(21676, 21676, "Otherworldly Invader Warrior", 0, "", 0, "LineageMonster.skeleton", 11, 25, 33, "male", "L2RiftInvader", 40, 702.20463, 372.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 8716, 500, 113.49065, 129.23095, 77.49941, 86.04342, 253, 8, 333, 220, 0, 0, 60, 165, 0, 1), 
(21677, 21677, "Otherworldly Invader Elite Soldier", 0, "", 0, "LineageMonster.skeleton_pikeman", 10, 28, 30, "male", "L2RiftInvader", 40, 604.08419, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 6988, 382, 92.64226, 118.46427, 63.26266, 78.87485, 253, 4, 333, 96, 0, 0, 50, 165, 0, 1), 
(21678, 21678, "Otherworldly Invader Elite Soldier", 0, "", 0, "LineageMonster.skeleton_pikeman", 10, 28, 33, "male", "L2RiftInvader", 40, 702.20463, 372.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 8456, 485, 113.49065, 129.23095, 77.49941, 86.04342, 253, 4, 333, 96, 0, 0, 50, 165, 0, 1), 
(21679, 21679, "Otherworldly Invader Elite Soldier", 0, "", 0, "LineageMonster.skeleton_pikeman", 10, 28, 30, "male", "L2RiftInvader", 40, 604.08419, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 6889, 376, 92.64226, 118.46427, 63.26266, 78.87485, 253, 4, 333, 96, 0, 0, 50, 165, 0, 1), 
(21680, 21680, "Otherworldly Invader Elite Soldier", 0, "", 0, "LineageMonster.skeleton_pikeman", 10, 28, 35, "male", "L2RiftInvader", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 9377, 555, 129.32896, 136.72948, 88.31491, 91.03603, 253, 4, 333, 96, 0, 0, 50, 165, 0, 1), 
(21681, 21681, "Otherworldly Invader Magus", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 33, "male", "L2RiftInvader", 40, 702.20463, 372.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 8062, 463, 113.49065, 129.23095, 77.49941, 86.04342, 253, 4, 333, 0, 0, 0, 100, 165, 0, 1), 
(21682, 21682, "Dimension Invader Soldier", 0, "", 0, "LineageMonster.neer_crawler", 14, 22, 40, "male", "L2RiftInvader", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 7772, 502, 176.36077, 156.55035, 120.43155, 104.23299, 253, 8, 333, 0, 0, 0, 50, 165, 0, 1), 
(21683, 21683, "Dimension Invader Soldier", 0, "", 0, "LineageMonster.neer_crawler", 14, 22, 45, "male", "L2RiftInvader", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 10283, 715, 234.89829, 177.78746, 160.40508, 118.3729, 253, 8, 333, 0, 0, 0, 50, 165, 0, 1), 
(21684, 21684, "Dimension Invader Archer", 0, "", 0, "LineageMonster.skeleton_archer", 11, 27, 43, "male", "L2RiftInvader", 1100, 1094.28943, 557.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 7603, 514, 210.04832, 169.13417, 143.43577, 112.61144, 253, 8, 333, 279, 0, 0, 40, 165, 0, 1), 
(21685, 21685, "Dimension Invader Elite Soldier", 0, "", 0, "LineageMonster.crimson_doll", 15, 38, 45, "male", "L2RiftInvader", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 8560, 595, 234.89829, 177.78746, 160.40508, 118.3729, 253, 4, 333, 0, 0, 0, 60, 165, 0, 1), 
(21686, 21686, "Dimension Invader Shaman", 0, "", 0, "LineageMonster.crimson_doll", 15, 38, 43, "male", "L2RiftInvader", 40, 1094.28943, 557.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 9599, 649, 210.04832, 169.13417, 143.43577, 112.61144, 253, 4, 333, 0, 0, 0, 60, 165, 0, 1), 
(21687, 21687, "Dimension Invader Priest", 0, "", 0, "LineageMonster.crimson_doll", 15, 38, 40, "male", "L2RiftInvader", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 5374, 347, 176.36077, 156.55035, 120.43155, 104.23299, 253, 4, 333, 0, 0, 0, 60, 165, 0, 1), 
(21688, 21688, "Dimension Invader Magus", 0, "", 0, "LineageMonster.crimson_doll", 15, 38, 45, "male", "L2RiftInvader", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 6759, 470, 234.89829, 177.78746, 160.40508, 118.3729, 253, 4, 333, 0, 0, 0, 60, 165, 0, 1), 
(21689, 21689, "Dimension Invader Martyrs", 0, "", 0, "LineageMonster.crimson_doll", 15, 38, 40, "male", "L2RiftInvader", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 5430, 351, 176.36077, 156.55035, 120.43155, 104.23299, 253, 4, 333, 0, 0, 0, 60, 165, 0, 1), 
(21690, 21690, "Dimension Invader Warrior", 0, "", 0, "LineageMonster.skeleton_knight", 10, 25, 43, "male", "L2RiftInvader", 40, 1094.28943, 557.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 6172, 417, 210.04832, 169.13417, 143.43577, 112.61144, 253, 4, 333, 70, 0, 0, 40, 165, 0, 1), 
(21691, 21691, "Dimension Invader Soldier", 0, "", 0, "LineageMonster.neer_crawler", 14, 22, 40, "male", "L2RiftInvader", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 5716, 369, 176.36077, 156.55035, 120.43155, 104.23299, 253, 8, 333, 0, 0, 0, 50, 165, 0, 1), 
(21692, 21692, "Dimension Invader Discipline", 0, "", 0, "LineageMonster.skeleton_knight", 10, 25, 43, "male", "L2RiftInvader", 40, 1094.28943, 557.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 6499, 439, 210.04832, 169.13417, 143.43577, 112.61144, 253, 4, 333, 70, 0, 0, 40, 165, 0, 1), 
(21693, 21693, "Dimension Invader Berserker", 0, "", 0, "LineageMonster.skeleton_knight", 10, 25, 45, "male", "L2RiftInvader", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 8854, 616, 234.89829, 177.78746, 160.40508, 118.3729, 253, 4, 333, 70, 0, 0, 40, 165, 0, 1), 
(21694, 21694, "Dimension Invader Food", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 40, "male", "L2Chest", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2327, 150, 176.36077, 156.55035, 120.43155, 104.23299, 253, 4, 333, 0, 0, 0, 80, 165, 0, 1), 
(21695, 21695, "Dimension Invader Elite Soldier", 0, "", 0, "LineageMonster.headless_knight", 21, 31, 45, "male", "L2RiftInvader", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 15861, 1103, 234.89829, 177.78746, 160.40508, 118.3729, 253, 4, 333, 135, 0, 0, 70, 165, 0, 1), 
(21696, 21696, "Dimension Invader Elite Soldier", 0, "", 0, "LineageMonster.headless_knight", 21, 31, 45, "male", "L2RiftInvader", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 16162, 1124, 234.89829, 177.78746, 160.40508, 118.3729, 253, 4, 333, 135, 0, 0, 70, 165, 0, 1), 
(21697, 21697, "Dimension Invader Elite Soldier", 0, "", 0, "LineageMonster.headless_knight", 21, 31, 45, "male", "L2RiftInvader", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 630, 44, 234.89829, 177.78746, 160.40508, 118.3729, 253, 4, 333, 135, 0, 0, 70, 165, 0, 1), 
(21698, 21698, "Dimension Invader Elite Soldier", 0, "", 0, "LineageMonster.headless_knight", 21, 31, 40, "male", "L2RiftInvader", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1382, 89, 176.36077, 156.55035, 120.43155, 104.23299, 253, 4, 333, 135, 0, 0, 70, 165, 0, 1), 
(21699, 21699, "Dimension Invader Warrior", 0, "", 0, "LineageMonster.skeleton_knight", 10, 25, 43, "male", "L2RiftInvader", 40, 1094.28943, 557.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 14798, 1000, 210.04832, 169.13417, 143.43577, 112.61144, 253, 4, 333, 70, 0, 0, 40, 165, 0, 1), 
(21700, 21700, "Dimension Invader Elite Soldier", 0, "", 0, "LineageMonster.headless_knight", 21, 31, 40, "male", "L2RiftInvader", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 12423, 802, 176.36077, 156.55035, 120.43155, 104.23299, 253, 4, 333, 135, 0, 0, 70, 165, 0, 1), 
(21701, 21701, "Dimension Invader Elite Soldier", 0, "", 0, "LineageMonster.headless_knight", 21, 31, 43, "male", "L2RiftInvader", 40, 1094.28943, 557.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 14357, 971, 210.04832, 169.13417, 143.43577, 112.61144, 253, 4, 333, 135, 0, 0, 70, 165, 0, 1), 
(21702, 21702, "Dimension Invader Elite Soldier", 0, "", 0, "LineageMonster.headless_knight", 21, 31, 40, "male", "L2RiftInvader", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 12248, 791, 176.36077, 156.55035, 120.43155, 104.23299, 253, 4, 333, 135, 0, 0, 70, 165, 0, 1), 
(21703, 21703, "Dimension Invader Elite Soldier", 0, "", 0, "LineageMonster.headless_knight", 21, 31, 45, "male", "L2RiftInvader", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 15501, 1078, 234.89829, 177.78746, 160.40508, 118.3729, 253, 4, 333, 135, 0, 0, 70, 165, 0, 1), 
(21704, 21704, "Dimension Invader Magus", 0, "", 0, "LineageMonster.crimson_doll", 15, 38, 43, "male", "L2RiftInvader", 40, 1094.28943, 557.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 13688, 925, 210.04832, 169.13417, 143.43577, 112.61144, 253, 4, 333, 0, 0, 0, 60, 165, 0, 1), 
(21705, 21705, "Purgatory Invader Soldier", 0, "", 0, "LineageMonster.doll_blader", 6, 12, 50, "male", "L2RiftInvader", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 12144, 915, 305.54906, 200.23844, 208.6504, 133.32101, 253, 8, 333, 5129, 5129, 0, 22, 165, 0, 1), 
(21706, 21706, "Purgatory Invader Soldier", 0, "", 0, "LineageMonster.doll_blader", 6, 12, 55, "male", "L2RiftInvader", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 15362, 1240, 388.11142, 223.6362, 265.02979, 148.89951, 253, 8, 333, 5129, 5129, 0, 22, 165, 0, 1), 
(21707, 21707, "Purgatory Invader Archer", 0, "", 0, "LineageMonster.skeleton_archer", 11, 27, 53, "male", "L2RiftInvader", 1100, 1570.8463, 832.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 11550, 908, 353.71092, 214.18326, 241.5387, 142.60563, 253, 8, 333, 282, 0, 0, 40, 165, 0, 1), 
(21708, 21708, "Purgatory Invader Elite Soldier", 0, "", 0, "LineageMonster.banshee", 9, 23, 55, "female", "L2RiftInvader", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 12787, 1032, 388.11142, 223.6362, 265.02979, 148.89951, 253, 1, 333, 3939, 0, 0, 80, 165, 0, 1), 
(21709, 21709, "Purgatory Invader Shaman", 0, "", 0, "LineageMonster.banshee", 9, 23, 53, "female", "L2RiftInvader", 40, 1570.8463, 832.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 14583, 1146, 353.71092, 214.18326, 241.5387, 142.60563, 253, 1, 333, 3939, 0, 0, 80, 165, 0, 1), 
(21710, 21710, "Purgatory Invader Priest", 0, "", 0, "LineageMonster.banshee", 9, 23, 50, "female", "L2RiftInvader", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 8396, 633, 305.54906, 200.23844, 208.6504, 133.32101, 253, 1, 333, 3939, 0, 0, 80, 165, 0, 1), 
(21711, 21711, "Purgatory Invader Magus", 0, "", 0, "LineageMonster.banshee", 9, 23, 55, "female", "L2RiftInvader", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 10097, 815, 388.11142, 223.6362, 265.02979, 148.89951, 253, 1, 333, 3939, 0, 0, 80, 165, 0, 1), 
(21712, 21712, "Purgatory Invader Martyrs", 0, "", 0, "LineageMonster.banshee", 9, 23, 50, "female", "L2RiftInvader", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 8484, 639, 305.54906, 200.23844, 208.6504, 133.32101, 253, 1, 333, 3939, 0, 0, 80, 165, 0, 1), 
(21713, 21713, "Purgatory Invader Warrior", 0, "", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 53, "male", "L2RiftInvader", 40, 1570.8463, 832.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 9376, 737, 353.71092, 214.18326, 241.5387, 142.60563, 253, 8, 333, 946, 946, 0, 80, 165, 0, 1), 
(21714, 21714, "Purgatory Invader Soldier", 0, "", 0, "LineageMonster.doll_blader", 6, 12, 50, "male", "L2RiftInvader", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 8932, 673, 305.54906, 200.23844, 208.6504, 133.32101, 253, 8, 333, 5129, 5129, 0, 22, 165, 0, 1), 
(21715, 21715, "Purgatory Invader Disciples", 0, "", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 53, "male", "L2RiftInvader", 40, 1570.8463, 832.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 9873, 776, 353.71092, 214.18326, 241.5387, 142.60563, 253, 8, 333, 946, 946, 0, 80, 165, 0, 1), 
(21716, 21716, "Purgatory Invader Berserker", 0, "", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 55, "male", "L2RiftInvader", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 13227, 1068, 388.11142, 223.6362, 265.02979, 148.89951, 253, 8, 333, 946, 946, 0, 80, 165, 0, 1), 
(21717, 21717, "Purgatory Invader Food", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 50, "male", "L2Chest", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3636, 274, 305.54906, 200.23844, 208.6504, 133.32101, 253, 4, 333, 0, 0, 0, 80, 165, 0, 1), 
(21718, 21718, "Purgatory Invader Elite Soldier", 0, "", 0, "LineageMonster.bloody_queen", 14, 40, 55, "female", "L2RiftInvader", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 23694, 1913, 388.11142, 223.6362, 265.02979, 148.89951, 253, 4, 333, 0, 0, 0, 80, 165, 0, 1), 
(21719, 21719, "Purgatory Invader Elite Soldier", 0, "", 0, "LineageMonster.bloody_queen", 14, 40, 55, "female", "L2RiftInvader", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 24143, 1949, 388.11142, 223.6362, 265.02979, 148.89951, 253, 4, 333, 0, 0, 0, 80, 165, 0, 1), 
(21720, 21720, "Purgatory Invader Elite Soldier", 0, "", 0, "LineageMonster.bloody_queen", 14, 40, 55, "female", "L2RiftInvader", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 942, 76, 388.11142, 223.6362, 265.02979, 148.89951, 253, 4, 333, 0, 0, 0, 80, 165, 0, 1), 
(21721, 21721, "Purgatory Invader Elite Soldier", 0, "", 0, "LineageMonster.bloody_queen", 14, 40, 50, "female", "L2RiftInvader", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 2160, 163, 305.54906, 200.23844, 208.6504, 133.32101, 253, 4, 333, 0, 0, 0, 80, 165, 0, 1), 
(21722, 21722, "Purgatory Invader Warrior", 0, "", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 53, "male", "L2RiftInvader", 40, 1570.8463, 832.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 22482, 1767, 353.71092, 214.18326, 241.5387, 142.60563, 253, 8, 333, 946, 946, 0, 80, 165, 0, 1), 
(21723, 21723, "Purgatory Invader Elite Soldier", 0, "", 0, "LineageMonster.bloody_queen", 14, 40, 50, "female", "L2RiftInvader", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 19411, 1462, 305.54906, 200.23844, 208.6504, 133.32101, 253, 4, 333, 0, 0, 0, 80, 165, 0, 1), 
(21724, 21724, "Purgatory Invader Elite Soldier", 0, "", 0, "LineageMonster.bloody_queen", 14, 40, 53, "female", "L2RiftInvader", 40, 1570.8463, 832.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 21811, 1715, 353.71092, 214.18326, 241.5387, 142.60563, 253, 4, 333, 0, 0, 0, 80, 165, 0, 1), 
(21725, 21725, "Purgatory Invader Elite Soldier", 0, "", 0, "LineageMonster.bloody_queen", 14, 40, 50, "female", "L2RiftInvader", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 19137, 1442, 305.54906, 200.23844, 208.6504, 133.32101, 253, 4, 333, 0, 0, 0, 80, 165, 0, 1), 
(21726, 21726, "Purgatory Invader Elite Soldier", 0, "", 0, "LineageMonster.bloody_queen", 14, 40, 55, "female", "L2RiftInvader", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 23156, 1869, 388.11142, 223.6362, 265.02979, 148.89951, 253, 4, 333, 0, 0, 0, 80, 165, 0, 1), 
(21727, 21727, "Purgatory Invader Magus", 0, "", 0, "LineageMonster.banshee", 9, 23, 53, "female", "L2RiftInvader", 40, 1570.8463, 832.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 20795, 1635, 353.71092, 214.18326, 241.5387, 142.60563, 253, 1, 333, 3939, 0, 0, 80, 165, 0, 1), 
(21728, 21728, "Forbidden Path Invader Elite Soldier", 0, "", 0, "LineageMonster.doll_blader", 6, 12, 60, "male", "L2RiftInvader", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 17487, 1518, 481.34551, 247.65008, 328.69659, 164.88822, 253, 8, 333, 5129, 5129, 0, 22, 165, 0, 1), 
(21729, 21729, "Forbidden Path Invader Elite Soldier", 0, "", 0, "LineageMonster.doll_blader", 6, 12, 65, "male", "L2RiftInvader", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 21456, 1993, 582.81759, 271.89033, 397.98887, 181.02764, 253, 8, 333, 5129, 5129, 0, 22, 165, 0, 1), 
(21730, 21730, "Forbidden Path Invader Archer", 0, "", 0, "LineageMonster.skeleton_archer", 11, 27, 63, "male", "L2RiftInvader", 1100, 2089.92274, 1127.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 16320, 1473, 541.44774, 262.19426, 369.73862, 174.5719, 253, 8, 333, 284, 0, 0, 40, 165, 0, 1), 
(21731, 21731, "Forbidden Path Invader Elite Soldier", 0, "", 0, "LineageMonster.banshee", 9, 23, 65, "female", "L2RiftInvader", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 17859, 1659, 582.81759, 271.89033, 397.98887, 181.02764, 253, 1, 333, 3939, 0, 0, 80, 165, 0, 1), 
(21732, 21732, "Forbidden Path Invader Shaman", 0, "", 0, "LineageMonster.banshee", 9, 23, 63, "female", "L2RiftInvader", 40, 2089.92274, 1127.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 20606, 1860, 541.44774, 262.19426, 369.73862, 174.5719, 253, 1, 333, 3939, 0, 0, 80, 165, 0, 1), 
(21733, 21733, "Forbidden Path Invader Priest", 0, "", 0, "LineageMonster.banshee", 9, 23, 60, "female", "L2RiftInvader", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 12091, 1050, 481.34551, 247.65008, 328.69659, 164.88822, 253, 1, 333, 3939, 0, 0, 80, 165, 0, 1), 
(21734, 21734, "Forbidden Path Invader Magus", 0, "", 0, "LineageMonster.banshee", 9, 23, 65, "female", "L2RiftInvader", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 14102, 1310, 582.81759, 271.89033, 397.98887, 181.02764, 253, 1, 333, 3939, 0, 0, 80, 165, 0, 1), 
(21735, 21735, "Forbidden Path Invader Martyrs", 0, "", 0, "LineageMonster.banshee", 9, 23, 60, "female", "L2RiftInvader", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 12217, 1060, 481.34551, 247.65008, 328.69659, 164.88822, 253, 1, 333, 3939, 0, 0, 80, 165, 0, 1), 
(21736, 21736, "Forbidden Path Invader Warrior", 0, "", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 63, "male", "L2RiftInvader", 40, 2089.92274, 1127.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 13248, 1196, 541.44774, 262.19426, 369.73862, 174.5719, 253, 8, 333, 946, 946, 0, 80, 165, 0, 1), 
(21737, 21737, "Forbidden Path Invader Soldier", 0, "", 0, "LineageMonster.doll_blader", 6, 12, 60, "male", "L2RiftInvader", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 12862, 1116, 481.34551, 247.65008, 328.69659, 164.88822, 253, 8, 333, 5129, 5129, 0, 22, 165, 0, 1), 
(21738, 21738, "Forbidden Path Invader Disciple", 0, "", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 63, "male", "L2RiftInvader", 40, 2089.92274, 1127.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 13950, 1259, 541.44774, 262.19426, 369.73862, 174.5719, 253, 8, 333, 946, 946, 0, 80, 165, 0, 1), 
(21739, 21739, "Forbidden Path Invader Berserker", 0, "", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 65, "male", "L2RiftInvader", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 18474, 1716, 582.81759, 271.89033, 397.98887, 181.02764, 253, 8, 333, 946, 946, 0, 80, 165, 0, 1), 
(21740, 21740, "Forbidden Path Invader Food", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 60, "male", "L2Chest", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 5236, 454, 481.34551, 247.65008, 328.69659, 164.88822, 253, 4, 333, 0, 0, 0, 80, 165, 0, 1), 
(21741, 21741, "Forbidden Path Invader Elite Soldier", 0, "", 0, "LineageMonster.bloody_queen", 14, 40, 65, "female", "L2RiftInvader", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 33094, 3074, 582.81759, 271.89033, 397.98887, 181.02764, 253, 4, 333, 0, 0, 0, 80, 165, 0, 1), 
(21742, 21742, "Forbidden Path Invader Elite Soldier", 0, "", 0, "LineageMonster.bloody_queen", 14, 40, 65, "female", "L2RiftInvader", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 33720, 3133, 582.81759, 271.89033, 397.98887, 181.02764, 253, 4, 333, 0, 0, 0, 80, 165, 0, 1), 
(21743, 21743, "Forbidden Path Invader Elite Soldier", 0, "", 0, "LineageMonster.bloody_queen", 14, 40, 65, "female", "L2RiftInvader", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 1315, 122, 582.81759, 271.89033, 397.98887, 181.02764, 253, 4, 333, 0, 0, 0, 80, 165, 0, 1), 
(21744, 21744, "Forbidden Path Invader Elite Soldier", 0, "", 0, "LineageMonster.bloody_queen", 14, 40, 60, "female", "L2RiftInvader", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 3110, 270, 481.34551, 247.65008, 328.69659, 164.88822, 253, 4, 333, 0, 0, 0, 80, 165, 0, 1), 
(21745, 21745, "Forbidden Path Invader Warrior", 0, "", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 63, "male", "L2RiftInvader", 40, 2089.92274, 1127.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 31766, 2868, 541.44774, 262.19426, 369.73862, 174.5719, 253, 8, 333, 946, 946, 0, 80, 165, 0, 1), 
(21746, 21746, "Forbidden Path Invader Elite Soldier", 0, "", 0, "LineageMonster.bloody_queen", 14, 40, 60, "female", "L2RiftInvader", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 27952, 2426, 481.34551, 247.65008, 328.69659, 164.88822, 253, 4, 333, 0, 0, 0, 80, 165, 0, 1), 
(21747, 21747, "Forbidden Path Invader Elite Soldier", 0, "", 0, "LineageMonster.bloody_queen", 14, 40, 63, "female", "L2RiftInvader", 40, 2089.92274, 1127.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 30818, 2782, 541.44774, 262.19426, 369.73862, 174.5719, 253, 4, 333, 0, 0, 0, 80, 165, 0, 1), 
(21748, 21748, "Forbidden Path Invader Elite Soldier", 0, "", 0, "LineageMonster.bloody_queen", 14, 40, 60, "female", "L2RiftInvader", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 27557, 2392, 481.34551, 247.65008, 328.69659, 164.88822, 253, 4, 333, 0, 0, 0, 80, 165, 0, 1), 
(21749, 21749, "Forbidden Path Invader Elite Soldier", 0, "", 0, "LineageMonster.bloody_queen", 14, 40, 65, "female", "L2RiftInvader", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 32342, 3005, 582.81759, 271.89033, 397.98887, 181.02764, 253, 4, 333, 0, 0, 0, 80, 165, 0, 1), 
(21750, 21750, "Forbidden Path Invader Magus", 0, "", 0, "LineageMonster.banshee", 9, 23, 63, "female", "L2RiftInvader", 40, 2089.92274, 1127.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 29382, 2653, 541.44774, 262.19426, 369.73862, 174.5719, 253, 1, 333, 3939, 0, 0, 80, 165, 0, 1), 
(21751, 21751, "Dark Omen Invader Soldier", 0, "", 0, "LineageMonster2.giant_zombie", 13, 40, 70, "male", "L2RiftInvader", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 23802, 2360, 688.86373, 295.91597, 470.40463, 197.0242, 253, 4, 333, 0, 0, 0, 20, 165, 0, 1), 
(21752, 21752, "Dark Omen Invader Soldier", 0, "", 0, "LineageMonster2.giant_zombie", 13, 40, 75, "male", "L2RiftInvader", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 28565, 3013, 794.70901, 319.24623, 542.68324, 212.55774, 253, 4, 333, 0, 0, 0, 20, 165, 0, 1), 
(21753, 21753, "Dark Omen Invader Archer", 0, "", 0, "LineageMonster.skeleton_archer", 11, 27, 73, "male", "L2RiftInvader", 1100, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 21912, 2255, 752.73928, 310.02959, 514.02335, 206.4212, 253, 8, 333, 288, 0, 0, 40, 165, 0, 1), 
(21754, 21754, "Dark Omen Invader Elite Soldier", 0, "", 0, "LineageMonster.doll_master", 20, 42, 75, "male", "L2RiftInvader", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 23777, 2508, 794.70901, 319.24623, 542.68324, 212.55774, 253, 8, 333, 0, 0, 0, 80, 165, 0, 1), 
(21755, 21755, "Dark Omen Invader Shaman", 0, "", 0, "LineageMonster.doll_master", 20, 42, 73, "male", "L2RiftInvader", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 27667, 2847, 752.73928, 310.02959, 514.02335, 206.4212, 253, 8, 333, 0, 0, 0, 80, 165, 0, 1), 
(21756, 21756, "Dark Omen Invader Priest", 0, "", 0, "LineageMonster.doll_master", 20, 42, 70, "male", "L2RiftInvader", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 16457, 1632, 688.86373, 295.91597, 470.40463, 197.0242, 253, 8, 333, 0, 0, 0, 80, 165, 0, 1), 
(21757, 21757, "Dark Omen Invader Magus", 0, "", 0, "LineageMonster.doll_master", 20, 42, 75, "male", "L2RiftInvader", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 18775, 1980, 794.70901, 319.24623, 542.68324, 212.55774, 253, 8, 333, 0, 0, 0, 80, 165, 0, 1); 

INSERT INTO `npc` VALUES
(21758, 21758, "Dark Omen Invader Martyrs", 0, "", 0, "LineageMonster.doll_master", 20, 42, 70, "male", "L2RiftInvader", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 16629, 1649, 688.86373, 295.91597, 470.40463, 197.0242, 253, 8, 333, 0, 0, 0, 80, 165, 0, 1), 
(21759, 21759, "Dark Omen Invader Warrior", 0, "", 0, "LineageMonster2.imperial_warlord_zombie", 7, 30, 73, "male", "L2RiftInvader", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 17787, 1830, 752.73928, 310.02959, 514.02335, 206.4212, 253, 4, 333, 134, 6721, 0, 39, 165, 0, 1), 
(21760, 21760, "Dark Omen Invader Soldier", 0, "", 0, "LineageMonster2.giant_zombie", 13, 40, 70, "male", "L2RiftInvader", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 17506, 1736, 688.86373, 295.91597, 470.40463, 197.0242, 253, 4, 333, 0, 0, 0, 20, 165, 0, 1), 
(21761, 21761, "Dark Omen Invader Disciple", 0, "", 0, "LineageMonster2.imperial_warlord_zombie", 7, 30, 73, "male", "L2RiftInvader", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 18730, 1927, 752.73928, 310.02959, 514.02335, 206.4212, 253, 4, 333, 134, 6721, 0, 39, 165, 0, 1), 
(21762, 21762, "Dark Omen Invader Berserker", 0, "", 0, "LineageMonster2.imperial_warlord_zombie", 7, 30, 75, "male", "L2RiftInvader", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 24596, 2594, 794.70901, 319.24623, 542.68324, 212.55774, 253, 4, 333, 134, 6721, 0, 39, 165, 0, 1), 
(21763, 21763, "Dark Omen Invader Food", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 70, "male", "L2Chest", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 7127, 707, 688.86373, 295.91597, 470.40463, 197.0242, 253, 4, 333, 0, 0, 0, 80, 165, 0, 1), 
(21764, 21764, "Dark Omen Invader Elite Soldier", 0, "", 0, "LineageMonster.death_blader", 15, 45, 75, "male", "L2RiftInvader", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 44060, 4647, 794.70901, 319.24623, 542.68324, 212.55774, 253, 4, 333, 1472, 0, 0, 100, 165, 0, 1), 
(21765, 21765, "Dark Omen Invader Elite Soldier", 0, "", 0, "LineageMonster.death_blader", 15, 45, 75, "male", "L2RiftInvader", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 44894, 4735, 794.70901, 319.24623, 542.68324, 212.55774, 253, 4, 333, 1472, 0, 0, 100, 165, 0, 1), 
(21766, 21766, "Dark Omen Invader Elite Soldier", 0, "", 0, "LineageMonster.death_blader", 15, 45, 75, "male", "L2RiftInvader", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 1751, 185, 794.70901, 319.24623, 542.68324, 212.55774, 253, 4, 333, 1472, 0, 0, 100, 165, 0, 1), 
(21767, 21767, "Dark Omen Invader Elite Soldier", 0, "", 0, "LineageMonster.death_blader", 15, 45, 70, "male", "L2RiftInvader", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 4233, 420, 688.86373, 295.91597, 470.40463, 197.0242, 253, 4, 333, 1472, 0, 0, 100, 165, 0, 1), 
(21768, 21768, "Dark Omen Invader Warrior", 0, "", 0, "LineageMonster2.imperial_warlord_zombie", 7, 30, 73, "male", "L2RiftInvader", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 42650, 4389, 752.73928, 310.02959, 514.02335, 206.4212, 253, 4, 333, 134, 6721, 0, 39, 165, 0, 1), 
(21769, 21769, "Dark Omen Invader Elite Soldier", 0, "", 0, "LineageMonster.death_blader", 15, 45, 70, "male", "L2RiftInvader", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 38046, 3772, 688.86373, 295.91597, 470.40463, 197.0242, 253, 4, 333, 1472, 0, 0, 100, 165, 0, 1), 
(21770, 21770, "Dark Omen Invader Elite Soldier", 0, "", 0, "LineageMonster.death_blader", 15, 45, 73, "male", "L2RiftInvader", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 41377, 4258, 752.73928, 310.02959, 514.02335, 206.4212, 253, 4, 333, 1472, 0, 0, 100, 165, 0, 1), 
(21771, 21771, "Dark Omen Invader Elite Soldier", 0, "", 0, "LineageMonster.death_blader", 15, 45, 70, "male", "L2RiftInvader", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 37509, 3719, 688.86373, 295.91597, 470.40463, 197.0242, 253, 4, 333, 1472, 0, 0, 100, 165, 0, 1), 
(21772, 21772, "Dark Omen Invader Elite Soldier", 0, "", 0, "LineageMonster.death_blader", 15, 45, 75, "male", "L2RiftInvader", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 43058, 4542, 794.70901, 319.24623, 542.68324, 212.55774, 253, 4, 333, 1472, 0, 0, 100, 165, 0, 1), 
(21773, 21773, "Dark Omen Invader Magus", 0, "", 0, "LineageMonster.doll_master", 20, 42, 73, "male", "L2RiftInvader", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 39450, 4059, 752.73928, 310.02959, 514.02335, 206.4212, 253, 8, 333, 0, 0, 0, 80, 165, 0, 1), 
(21774, 21774, "Messenger Invader Soldier", 0, "", 0, "LineageMonster2.giant_zombie", 13, 40, 78, "male", "L2RiftInvader", 40, 2937.983806, 1708.296, 8.67, 3.06, 40, 43, 30, 21, 20, 20, 31088, 3489, 912.65371, 348.2025, 635.68866, 231.83715, 253, 4, 333, 0, 0, 0, 20, 165, 0, 1), 
(21775, 21775, "Messenger Invader Soldier", 0, "", 0, "LineageMonster2.giant_zombie", 13, 40, 78, "male", "L2RiftInvader", 40, 3107.643659, 1883.736, 8.925, 3.1518, 40, 43, 30, 21, 20, 20, 36690, 4367, 1033.124, 380.23713, 740.57728, 268.30468, 253, 4, 333, 0, 0, 0, 20, 165, 0, 1), 
(21776, 21776, "Messenger Invader Archer", 0, "", 0, "LineageMonster.skeleton_archer", 11, 27, 78, "male", "L2RiftInvader", 1100, 3044.88717, 1812.948, 8.823, 3.111, 40, 43, 30, 21, 20, 20, 28326, 3293, 985.66601, 367.35364, 699.25752, 253.53446, 253, 8, 333, 289, 0, 0, 40, 165, 0, 1), 
(21777, 21777, "Messenger Invader Elite Soldier", 0, "", 0, "LineageMonster.doll_master", 20, 42, 78, "male", "L2RiftInvader", 40, 3107.643659, 1883.736, 8.925, 3.1518, 40, 43, 30, 21, 20, 20, 30540, 3635, 1033.124, 380.23713, 740.57728, 268.30468, 253, 8, 333, 0, 0, 0, 80, 165, 0, 1), 
(21778, 21778, "Messenger Invader Shaman", 0, "", 0, "LineageMonster.doll_master", 20, 42, 78, "male", "L2RiftInvader", 40, 3044.88717, 1812.948, 8.823, 3.111, 40, 43, 30, 21, 20, 20, 35766, 4158, 985.66601, 367.35364, 699.25752, 253.53446, 253, 8, 333, 0, 0, 0, 80, 165, 0, 1), 
(21779, 21779, "Messenger Invader Priest", 0, "", 0, "LineageMonster.doll_master", 20, 42, 78, "male", "L2RiftInvader", 40, 2937.983806, 1708.296, 8.67, 3.06, 40, 43, 30, 21, 20, 20, 21494, 2413, 912.65371, 348.2025, 635.68866, 231.83715, 253, 8, 333, 0, 0, 0, 80, 165, 0, 1), 
(21780, 21780, "Messenger Invader Magus", 0, "", 0, "LineageMonster.doll_master", 20, 42, 78, "male", "L2RiftInvader", 40, 3107.643659, 1883.736, 8.925, 3.1518, 40, 43, 30, 21, 20, 20, 24116, 2871, 1033.124, 380.23713, 740.57728, 268.30468, 253, 8, 333, 0, 0, 0, 80, 165, 0, 1), 
(21781, 21781, "Messenger Invader Martyrs", 0, "", 0, "LineageMonster.doll_master", 20, 42, 78, "male", "L2RiftInvader", 40, 2937.983806, 1708.296, 8.67, 3.06, 40, 43, 30, 21, 20, 20, 21719, 2438, 912.65371, 348.2025, 635.68866, 231.83715, 253, 8, 333, 0, 0, 0, 80, 165, 0, 1), 
(21782, 21782, "Messenger Invader Warrior", 0, "", 0, "LineageMonster2.imperial_warlord_zombie", 7, 30, 78, "male", "L2RiftInvader", 40, 3044.88717, 1812.948, 8.823, 3.111, 40, 43, 30, 21, 20, 20, 22994, 2673, 985.66601, 367.35364, 699.25752, 253.53446, 253, 4, 333, 134, 6721, 0, 39, 165, 0, 1), 
(21783, 21783, "Messenger Invader Soldier", 0, "", 0, "LineageMonster2.giant_zombie", 13, 40, 78, "male", "L2RiftInvader", 40, 2937.983806, 1708.296, 8.67, 3.06, 40, 43, 30, 21, 20, 20, 22865, 2566, 912.65371, 348.2025, 635.68866, 231.83715, 253, 4, 333, 0, 0, 0, 20, 165, 0, 1), 
(21784, 21784, "Messenger Invader Disciple", 0, "", 0, "LineageMonster2.imperial_warlord_zombie", 7, 30, 78, "male", "L2RiftInvader", 40, 3044.88717, 1812.948, 8.823, 3.111, 40, 43, 30, 21, 20, 20, 24213, 2815, 985.66601, 367.35364, 699.25752, 253.53446, 253, 4, 333, 134, 6721, 0, 39, 165, 0, 1), 
(21785, 21785, "Messenger Invader Berserker", 0, "", 0, "LineageMonster2.imperial_warlord_zombie", 7, 30, 78, "male", "L2RiftInvader", 40, 3107.643659, 1883.736, 8.925, 3.1518, 40, 43, 30, 21, 20, 20, 31592, 3760, 1033.124, 380.23713, 740.57728, 268.30468, 253, 4, 333, 134, 6721, 0, 39, 165, 0, 1), 
(21786, 21786, "Messenger Invader Food", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 78, "male", "L2Chest", 40, 2937.983806, 1708.296, 8.67, 3.06, 40, 43, 30, 21, 20, 20, 9308, 1045, 912.65371, 348.2025, 635.68866, 231.83715, 253, 4, 333, 0, 0, 0, 80, 165, 0, 1), 
(21787, 21787, "Messenger Invader Elite Soldier", 0, "", 0, "LineageMonster.death_lord", 21, 40, 78, "male", "L2RiftInvader", 40, 3107.643659, 1883.736, 8.925, 3.1518, 40, 43, 30, 21, 20, 20, 56592, 6736, 1033.124, 380.23713, 740.57728, 268.30468, 253, 4, 333, 78, 0, 0, 40, 165, 0, 1), 
(21788, 21788, "Messenger Invader Elite Soldier", 0, "", 0, "LineageMonster.death_lord", 21, 40, 78, "male", "L2RiftInvader", 40, 3107.643659, 1883.736, 8.925, 3.1518, 40, 43, 30, 21, 20, 20, 57664, 6864, 1033.124, 380.23713, 740.57728, 268.30468, 253, 4, 333, 78, 0, 0, 40, 165, 0, 1), 
(21789, 21789, "Messenger Invader Elite Soldier", 0, "", 0, "LineageMonster.death_lord", 21, 40, 78, "male", "L2RiftInvader", 40, 3107.643659, 1883.736, 8.925, 3.1518, 40, 43, 30, 21, 20, 20, 2249, 268, 1033.124, 380.23713, 740.57728, 268.30468, 253, 4, 333, 78, 0, 0, 40, 165, 0, 1), 
(21790, 21790, "Messenger Invader Elite Soldier", 0, "", 0, "LineageMonster.death_lord", 21, 40, 78, "male", "L2RiftInvader", 40, 2937.983806, 1708.296, 8.67, 3.06, 40, 43, 30, 21, 20, 20, 5529, 621, 912.65371, 348.2025, 635.68866, 231.83715, 253, 4, 333, 78, 0, 0, 40, 165, 0, 1), 
(21791, 21791, "Messenger Invader Warrior", 0, "", 0, "LineageMonster2.imperial_warlord_zombie", 7, 30, 78, "male", "L2RiftInvader", 40, 3044.88717, 1812.948, 8.823, 3.111, 40, 43, 30, 21, 20, 20, 55136, 6409, 985.66601, 367.35364, 699.25752, 253.53446, 253, 4, 333, 134, 6721, 0, 39, 165, 0, 1), 
(21792, 21792, "Messenger Invader Elite Soldier", 0, "", 0, "LineageMonster.death_lord", 21, 40, 78, "male", "L2RiftInvader", 40, 2937.983806, 1708.296, 8.67, 3.06, 40, 43, 30, 21, 20, 20, 49693, 5578, 912.65371, 348.2025, 635.68866, 231.83715, 253, 4, 333, 78, 0, 0, 40, 165, 0, 1), 
(21793, 21793, "Messenger Invader Elite Soldier", 0, "", 0, "LineageMonster.death_lord", 21, 40, 78, "male", "L2RiftInvader", 40, 3044.88717, 1812.948, 8.823, 3.111, 40, 43, 30, 21, 20, 20, 53490, 6218, 985.66601, 367.35364, 699.25752, 253.53446, 253, 4, 333, 78, 0, 0, 40, 165, 0, 1), 
(21794, 21794, "Messenger Invader Elite Soldier", 0, "", 0, "LineageMonster.death_lord", 21, 40, 78, "male", "L2RiftInvader", 40, 2937.983806, 1708.296, 8.67, 3.06, 40, 43, 30, 21, 20, 20, 48991, 5499, 912.65371, 348.2025, 635.68866, 231.83715, 253, 4, 333, 78, 0, 0, 40, 165, 0, 1), 
(21795, 21795, "Messenger Invader Elite Soldier", 0, "", 0, "LineageMonster.death_lord", 21, 40, 78, "male", "L2RiftInvader", 40, 3107.643659, 1883.736, 8.925, 3.1518, 40, 43, 30, 21, 20, 20, 55306, 6583, 1033.124, 380.23713, 740.57728, 268.30468, 253, 4, 333, 78, 0, 0, 40, 165, 0, 1), 
(21796, 21796, "Messenger Invader Magus", 0, "", 0, "LineageMonster.doll_master", 20, 42, 78, "male", "L2RiftInvader", 40, 3044.88717, 1812.948, 8.823, 3.111, 40, 43, 30, 21, 20, 20, 50999, 5928, 985.66601, 367.35364, 699.25752, 253.53446, 253, 8, 333, 0, 0, 0, 80, 165, 0, 1), 
(21797, 21797, "Spirit of Timiniel", 0, "", 0, "LineageMonster.pixy", 5, 25, 55, "female", "L2Monster", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 2376, 192, 388.11142, 223.6362, 265.02979, 148.89951, 253, 1, 333, 0, 0, 0, 80, 165, 0, 1), 
(21798, 21798, "Ghost of a Gatekeeper", 0, "", 0, "LineageMonster.skeleton_knight", 10, 25, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 14209, 1519, 815.37145, 323.78455, 556.793, 215.57941, 253, 4, 333, 150, 103, 0, 40, 165, 0, 1), 
(21799, 21799, "Ghost of a Gatekeeper", 0, "", 0, "LineageMonster.skeleton_knight", 10, 25, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 26132, 2794, 815.37145, 323.78455, 556.793, 215.57941, 253, 4, 333, 150, 103, 0, 40, 165, 0, 1), 
(21800, 21800, "Vassal Ghost", 0, "", 0, "LineageMonster.zombie", 13, 21, 77, "male", "L2Monster", 40, 2762.08447, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 13234, 1432, 835.75573, 328.27073, 570.71283, 218.56635, 253, 4, 333, 0, 0, 0, 15, 15, 0, 1), 
(21801, 21801, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 21, "male", "L2Chest", 40, 364.30351, 205.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 631, 29, 47.91924, 89.73059, 32.72263, 59.74364, 253, 1, 333, 0, 0, 0, 80, 165, 0, 1), 
(21802, 21802, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 24, "male", "L2Chest", 40, 435.34437, 245.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 772, 38, 60.19687, 98.70919, 41.10666, 65.72169, 253, 1, 333, 0, 0, 0, 80, 165, 0, 1), 
(21803, 21803, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 27, "male", "L2Chest", 40, 515.17856, 286.92, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 919, 47, 74.99121, 108.28767, 51.20928, 72.09915, 253, 1, 333, 0, 0, 0, 80, 165, 0, 1), 
(21804, 21804, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 30, "male", "L2Chest", 40, 604.08419, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1080, 59, 92.64226, 118.46427, 63.26266, 78.87485, 253, 1, 333, 0, 0, 0, 80, 165, 0, 1), 
(21805, 21805, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 33, "male", "L2Chest", 40, 702.20463, 372.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1307, 75, 113.49065, 129.23095, 77.49941, 86.04342, 253, 1, 333, 0, 0, 0, 80, 165, 0, 1), 
(21806, 21806, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 36, "male", "L2Chest", 40, 809.52639, 417.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1555, 94, 137.86467, 140.57278, 94.1437, 93.59494, 253, 1, 333, 0, 0, 0, 80, 165, 0, 1), 
(21807, 21807, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 39, "male", "L2Chest", 40, 925.85879, 463.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1825, 116, 166.06476, 152.46752, 113.4007, 101.5146, 253, 1, 333, 0, 0, 0, 80, 165, 0, 1), 
(21808, 21808, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 42, "male", "L2Chest", 40, 1050.81652, 531, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 2117, 141, 198.34591, 164.88513, 135.44454, 109.78238, 253, 1, 333, 0, 0, 0, 80, 165, 0, 1), 
(21809, 21809, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 45, "male", "L2Chest", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 2430, 169, 234.89829, 177.78746, 160.40508, 118.3729, 253, 1, 333, 0, 0, 0, 80, 165, 0, 1), 
(21810, 21810, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 48, "male", "L2Chest", 40, 1324.01623, 692.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 2765, 202, 275.82705, 191.12803, 188.35412, 127.2552, 253, 1, 333, 0, 0, 0, 80, 165, 0, 1), 
(21811, 21811, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 51, "male", "L2Chest", 40, 1470.41596, 775.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 3121, 238, 321.13207, 204.85194, 219.29157, 136.39273, 253, 1, 333, 0, 0, 0, 80, 165, 0, 1), 
(21812, 21812, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 54, "male", "L2Chest", 40, 1621.75618, 861, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 3499, 279, 370.68904, 218.89589, 253.13256, 145.74335, 253, 1, 333, 0, 0, 0, 80, 165, 0, 1), 
(21813, 21813, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 57, "male", "L2Chest", 40, 1776.58018, 948, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 3899, 324, 424.23295, 233.18839, 289.69611, 155.25946, 253, 1, 333, 0, 0, 0, 80, 165, 0, 1), 
(21814, 21814, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 60, "male", "L2Chest", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 4320, 375, 481.34551, 247.65008, 328.69659, 164.88822, 253, 1, 333, 0, 0, 0, 80, 165, 0, 1), 
(21815, 21815, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 63, "male", "L2Chest", 40, 2089.92274, 1127.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 4763, 430, 541.44774, 262.19426, 369.73862, 174.5719, 253, 1, 333, 0, 0, 0, 80, 165, 0, 1), 
(21816, 21816, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 66, "male", "L2Chest", 40, 2244.67715, 1219.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 5227, 492, 603.79903, 276.72752, 412.31647, 184.2483, 253, 1, 333, 0, 0, 0, 80, 165, 0, 1), 
(21817, 21817, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 69, "male", "L2Chest", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 5713, 559, 667.50361, 291.15063, 455.81844, 193.85137, 253, 1, 333, 0, 0, 0, 80, 165, 0, 1), 
(21818, 21818, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 72, "male", "L2Chest", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 6221, 632, 731.52506, 305.35947, 499.53679, 203.31178, 253, 1, 333, 0, 0, 0, 80, 165, 0, 1), 
(21819, 21819, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 75, "male", "L2Chest", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 6750, 712, 794.70901, 319.24623, 542.68324, 212.55774, 253, 1, 333, 0, 0, 0, 80, 165, 0, 1), 
(21820, 21820, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 78, "male", "L2Chest", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 7301, 799, 855.81387, 332.70061, 584.40994, 221.51582, 253, 1, 333, 0, 0, 0, 80, 165, 0, 1), 
(21821, 21821, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 78, "male", "L2Chest", 40, 3004.405908, 1760.064, 8.755, 3.09, 40, 43, 30, 21, 20, 20, 7873, 894, 940.9565, 355.9783, 661.83186, 237.312, 253, 1, 333, 0, 0, 0, 80, 165, 0, 1), 
(21822, 21822, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 80, "male", "L2Chest", 40, 3137.493622, 1884.48, 8.84, 3.12, 40, 43, 30, 21, 20, 20, 8467, 996, 1005.28006, 372.18192, 713.935, 247.80292, 253, 1, 333, 0, 0, 0, 80, 165, 0, 1), 
(21823, 21823, "Executor of Sacrificial Offerings", 0, "", 0, "LineageMonster2.imperial_warlord_zombie", 7, 30, 78, "male", "L2Monster", 40, 2937.983806, 1708.296, 8.67, 3.06, 40, 43, 30, 21, 20, 20, 72252, 8110, 912.65371, 348.2025, 635.68866, 231.83715, 253, 4, 333, 134, 6721, 0, 39, 190, 0, 1), 
(21824, 21824, "Alpine Kookaburra", 0, "", 0, "LineageMonster2.rough_ostrich", 10, 33, 65, "male", "L2FeedableBeast", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 30997, 2880, 582.81759, 271.89033, 397.98887, 181.02764, 253, 4, 333, 0, 0, 0, 23, 210, 0, 1), 
(21825, 21825, "Alpine Kookaburra", 0, "", 0, "LineageMonster2.rough_ostrich", 10, 33, 65, "male", "L2FeedableBeast", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 29568, 2747, 582.81759, 271.89033, 397.98887, 181.02764, 253, 4, 333, 0, 0, 0, 23, 210, 0, 1), 
(21826, 21826, "Alpine Buffalo", 0, "", 0, "LineageMonster2.buffalo", 22, 31, 67, "male", "L2FeedableBeast", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 32934, 3137, 624.93199, 281.55251, 426.74754, 187.46084, 253, 1, 333, 0, 0, 0, 20, 170, 0, 1), 
(21827, 21827, "Alpine Buffalo", 0, "", 0, "LineageMonster2.buffalo", 22, 31, 67, "male", "L2FeedableBeast", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 31415, 2992, 624.93199, 281.55251, 426.74754, 187.46084, 253, 1, 333, 0, 0, 0, 20, 170, 0, 1), 
(21828, 21828, "Alpine Cougar", 0, "", 0, "LineageMonster.saber_toothed_tiger", 34, 28, 69, "male", "L2FeedableBeast", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 34929, 3418, 667.50361, 291.15063, 455.81844, 193.85137, 253, 4, 333, 0, 0, 0, 60, 200, 0, 1), 
(21829, 21829, "Alpine Cougar", 0, "", 0, "LineageMonster.saber_toothed_tiger", 34, 28, 69, "male", "L2FeedableBeast", 40, 2395.45533, 1314, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 33319, 3260, 667.50361, 291.15063, 455.81844, 193.85137, 253, 4, 333, 0, 0, 0, 60, 200, 0, 1), 
(22001, 22001, "Grim Wolf", 0, "", 0, "LineageMonster.dire_wolf", 13, 11, 25, "male", "L2Monster", 40, 460.96247, 259.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1052, 52, 64.83203, 101.83533, 44.27187, 74.51868, 253, 4, 333, 0, 0, 0, 24, 130, 1, 1), 
(22002, 22002, "Grim Grizzly", 0, "", 0, "LineageMonster.grizzly", 21, 40, 26, "male", "L2Monster", 40, 487.5704, 273, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1120, 56, 69.75926, 105.02818, 47.63653, 76.85506, 253, 4, 333, 0, 0, 0, 40, 110, 1, 1), 
(22003, 22003, "Grave Robber Scout", 0, "", 0, "LineageNPC.e_traderB_Fdwarf_mon", 7, 18, 27, "female", "L2Monster", 1100, 515.17856, 286.92, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1395, 71, 74.99121, 108.28767, 51.20928, 79.24022, 253, 8, 333, 8527, 0, 0, 49, 110, 1, 1), 
(22004, 22004, "Grave Robber Lookout", 0, "", 0, "LineageMonster.dwarf_ghost", 9, 16.5, 27, "male", "L2Monster", 40, 515.17856, 286.92, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1659, 84, 74.99121, 108.28767, 51.20928, 79.24022, 253, 1, 333, 0, 0, 0, 80, 120, 1, 1), 
(22005, 22005, "Grave Robber Ranger", 0, "", 0, "LineageNPC.e_collector_teacher_Fdwarf_mon", 8, 17.5, 28, "female", "L2Monster", 40, 543.79576, 300.96, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1477, 77, 80.54056, 111.61368, 54.99876, 81.67405, 253, 8, 333, 8529, 0, 0, 45, 110, 1, 1), 
(22006, 22006, "Grave Robber Guard", 0, "", 0, "LineageNPC.e_collector_teacher_Mdwarf_mon", 8, 17.5, 29, "male", "L2Monster", 40, 573.42917, 315.12, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1559, 83, 86.42002, 115.00598, 59.01367, 84.15638, 253, 1, 333, 8528, 0, 0, 36, 110, 1, 1), 
(22007, 22007, "Ghost of a Soldier", 0, "", 0, "LineageMonster.orc", 10, 21, 29, "male", "L2Monster", 40, 573.42917, 315.12, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1699, 90, 86.42002, 115.00598, 59.01367, 84.15638, 253, 4, 333, 8530, 0, 0, 45, 120, 0, 1), 
(22008, 22008, "Grave Robber Fighter", 0, "", 0, "LineageNPC.e_collector_teacher_Mdwarf_mon", 8, 17.5, 30, "male", "L2Monster", 40, 604.08419, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1641, 89, 92.64226, 118.46427, 63.26266, 86.68702, 253, 1, 333, 8528, 0, 0, 36, 110, 1, 1), 
(22009, 22009, "Ghost of a Loyal Vassal", 0, "", 0, "LineageMonster.orc_shaman", 9, 22, 31, "male", "L2Monster", 40, 635.76437, 343.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1910, 106, 99.21986, 121.98819, 67.7543, 89.26566, 253, 1, 333, 8532, 0, 0, 45, 120, 0, 1), 
(22010, 22010, "Ghost of a General", 0, "", 0, "LineageMonster.orc_fighter", 12, 22, 32, "male", "L2Monster", 40, 668.47132, 358.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2035, 114, 106.16525, 125.57727, 72.49711, 91.89199, 253, 4, 333, 8532, 0, 0, 45, 120, 0, 1), 
(22011, 22011, "Ghost of a Batur Chief", 0, "", 0, "LineageMonster.orc_champion", 10, 23, 33, "male", "L2Monster", 40, 702.20463, 372.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2337, 133, 113.49065, 129.23095, 77.49941, 94.5656, 253, 4, 333, 8533, 0, 0, 45, 130, 0, 1), 
(22012, 22012, "Ghost of a Batur Chief", 0, "", 0, "LineageMonster.orc_champion", 10, 23, 33, "male", "L2Monster", 40, 702.20463, 372.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2337, 133, 113.49065, 129.23095, 77.49941, 94.5656, 253, 4, 333, 8533, 0, 0, 45, 130, 0, 1), 
(22013, 22013, "Ghost of a Morek Chief", 0, "", 0, "LineageMonster.orc_champion", 10, 23, 33, "male", "L2Monster", 40, 702.20463, 372.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2337, 133, 113.49065, 129.23095, 77.49941, 94.5656, 253, 4, 333, 8533, 0, 0, 45, 130, 0, 1), 
(22014, 22014, "Ghost of a Morek Chief", 0, "", 0, "LineageMonster.orc_champion", 10, 23, 33, "male", "L2Monster", 40, 702.20463, 372.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2337, 133, 113.49065, 129.23095, 77.49941, 94.5656, 253, 4, 333, 8533, 0, 0, 45, 130, 0, 1), 
(22015, 22015, "Ghost of a Turka Chief", 0, "", 0, "LineageMonster.orc_champion", 10, 23, 33, "male", "L2Monster", 40, 702.20463, 372.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2337, 133, 113.49065, 129.23095, 77.49941, 94.5656, 253, 4, 333, 8533, 0, 0, 45, 130, 0, 1), 
(22016, 22016, "Ghost of a Turka Chief", 0, "", 0, "LineageMonster.orc_champion", 10, 23, 33, "male", "L2Monster", 40, 702.20463, 372.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2337, 133, 113.49065, 129.23095, 77.49941, 94.5656, 253, 4, 333, 8533, 0, 0, 45, 130, 0, 1), 
(22017, 22017, "Bandit Sweeper", 0, "", 0, "LineageMonster2.northern_goblin", 4, 15, 30, "male", "L2Monster", 40, 604.08419, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1750, 95, 92.64226, 118.46427, 63.26266, 86.68702, 253, 4, 333, 152, 0, 0, 30, 145, 1, 1), 
(22018, 22018, "Bandit Hound", 0, "", 0, "LineageMonster.dire_wolf", 13, 11, 31, "male", "L2Monster", 40, 635.76437, 343.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1501, 83, 99.21986, 121.98819, 67.7543, 89.26566, 253, 4, 333, 0, 0, 0, 24, 130, 1, 1), 
(22019, 22019, "Bandit Watchman", 0, "", 0, "LineageMonster.ol_mahum_archer_04te", 14, 25, 32, "male", "L2Monster", 1100, 668.47132, 358.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2056, 115, 106.16525, 125.57727, 72.49711, 91.89199, 253, 8, 333, 273, 0, 0, 50, 130, 1, 1), 
(22020, 22020, "Snow Lynx", 0, "", 0, "LineageMonster.onyx_beast", 14, 14.5, 33, "male", "L2Monster", 40, 702.20463, 372.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1701, 97, 113.49065, 129.23095, 77.49941, 94.5656, 253, 4, 333, 0, 0, 0, 30, 140, 1, 1), 
(22021, 22021, "Bandit Undertaker", 0, "", 0, "LineageMonster2.northern_goblin_110p", 6, 16.6, 34, "male", "L2Monster", 40, 736.96177, 387.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2081, 121, 121.20802, 132.9486, 82.76936, 97.28601, 253, 1, 333, 66, 102, 0, 30, 140, 1, 1), 
(22022, 22022, "Bandit Assassin", 0, "", 0, "LineageMonster.wererat_01te", 14, 25, 35, "male", "L2Monster", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2470, 145, 129.32896, 136.72948, 88.31491, 100.0527, 253, 8, 333, 221, 0, 0, 80, 150, 1, 1), 
(22023, 22023, "Bandit Warrior", 0, "", 0, "LineageMonster.ol_mahum_04te", 13.5, 25, 36, "male", "L2Monster", 40, 809.52639, 417.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2825, 170, 137.86467, 140.57278, 94.1437, 102.86506, 253, 4, 333, 2, 0, 0, 50, 135, 1, 1), 
(22024, 22024, "Bandit Inspector", 0, "", 0, "LineageMonster2.northern_goblin_120p", 7, 18.5, 37, "male", "L2Monster", 40, 847.31754, 432.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2661, 163, 146.82587, 144.47758, 100.26304, 105.72243, 253, 1, 333, 66, 0, 0, 30, 145, 1, 1), 
(22025, 22025, "Frozen Wasteland Werewolf", 0, "", 0, "LineageMonster.werewolf", 10, 26, 38, "male", "L2Monster", 40, 886.09975, 447.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2662, 166, 156.22273, 148.44287, 106.67987, 108.62405, 253, 4, 333, 0, 0, 0, 50, 145, 1, 1), 
(22026, 22026, "Bandit Captain", 0, "", 0, "LineageMonster.ol_mahum_champion_04te", 14, 27, 40, "male", "L2Monster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 3488, 224, 176.36077, 156.55035, 120.43155, 114.55675, 253, 1, 333, 69, 19, 0, 50, 145, 1, 1), 
(22027, 22027, "Forgotten Crewman", 0, "", 0, "LineageMonster.dwarf_ghost", 9, 16.5, 39, "male", "L2Monster", 40, 925.85879, 463.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 6847, 416, 166.06476, 152.46752, 113.4007, 111.56912, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(22028, 22028, "Vagabond of the Ruins", 0, "", 0, "LineageNPC.a_mageguild_teacher_Mhuman_mon", 8, 23, 40, "male", "L2Monster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 6162, 380, 176.36077, 156.55035, 120.43155, 114.55675, 253, 8, 333, 8530, 0, 0, 50, 140, 0, 1), 
(22029, 22029, "Ragna Orc", 0, "", 0, "LineageMonster.batur_orc_03te", 9, 21.5, 40, "male", "L2Monster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 3620, 233, 176.36077, 156.55035, 120.43155, 114.55675, 253, 1, 333, 2, 0, 0, 80, 140, 0, 1), 
(22030, 22030, "Ragna Orc Shaman", 0, "", 0, "LineageMonster.batur_orc_shaman_a_03te", 11, 16, 42, "male", "L2Monster", 40, 1050.81652, 531, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3782, 251, 198.34591, 164.88513, 135.44454, 120.65578, 253, 1, 333, 159, 0, 0, 50, 140, 0, 1), 
(22031, 22031, "Ragna Orc Archer", 0, "", 0, "LineageMonster.batur_orc_archer_03te", 11, 21.5, 43, "male", "L2Monster", 1100, 1094.28943, 557.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3499, 236, 210.04832, 169.13417, 143.43577, 123.76505, 253, 8, 333, 13, 0, 0, 45, 130, 1, 1), 
(22032, 22032, "Ragna Orc Warrior", 0, "", 0, "LineageMonster.batur_orc_warrior_03te", 10, 20, 44, "male", "L2Monster", 40, 1138.62924, 584, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4380, 299, 222.23112, 173.43552, 151.75505, 126.91259, 253, 4, 333, 68, 0, 0, 80, 140, 0, 1), 
(22033, 22033, "Ragna Orc Mage", 0, "", 0, "LineageMonster.batur_orc_shaman_a_01te", 11, 16, 45, "male", "L2Monster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 5625, 391, 234.89829, 177.78746, 160.40508, 130.09715, 253, 1, 333, 179, 0, 0, 50, 140, 1, 1), 
(22034, 22034, "Ragna Orc Mage", 0, "", 0, "LineageMonster.batur_orc_shaman_a_01te", 11, 16, 45, "male", "L2Monster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 5158, 358, 234.89829, 177.78746, 160.40508, 130.09715, 253, 1, 333, 179, 0, 0, 50, 140, 1, 1), 
(22035, 22035, "Ragna Orc Mage", 0, "", 0, "LineageMonster.batur_orc_shaman_a_01te", 11, 16, 45, "male", "L2Monster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 5625, 391, 234.89829, 177.78746, 160.40508, 130.09715, 253, 1, 333, 179, 0, 0, 50, 140, 1, 1), 
(22036, 22036, "Ragna Orc Mage", 0, "", 0, "LineageMonster.batur_orc_shaman_a_01te", 11, 16, 45, "male", "L2Monster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3963, 275, 234.89829, 177.78746, 160.40508, 130.09715, 253, 1, 333, 179, 0, 0, 50, 140, 1, 1), 
(22037, 22037, "Ragna Orc Healer", 0, "", 0, "LineageMonster.batur_orc_shaman_a_03te", 11, 16, 45, "male", "L2Monster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4342, 301, 234.89829, 177.78746, 160.40508, 130.09715, 253, 1, 333, 316, 0, 0, 50, 140, 0, 1), 
(22038, 22038, "Ragna Orc Hero", 0, "", 0, "LineageMonster.batur_orc_overlord_03te", 12, 24, 48, "male", "L2Monster", 40, 1324.01623, 692.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 5213, 380, 275.82705, 191.12803, 188.35412, 139.8592, 253, 4, 333, 74, 0, 0, 80, 140, 0, 1), 
(22039, 22039, "Ragna Orc Commander", 0, "", 0, "LineageMonster.batur_orc_overlord_01te", 12, 24, 49, "male", "L2Monster", 40, 1372.18568, 720, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 5432, 401, 290.44588, 195.66302, 198.33688, 143.17771, 253, 4, 333, 135, 0, 0, 80, 140, 0, 1), 
(22040, 22040, "Ragna Orc Sniper", 0, "", 0, "LineageMonster.batur_orc_archer_01te", 11, 21.5, 47, "male", "L2Monster", 1100, 1276.53628, 665, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4180, 299, 261.69549, 186.63569, 178.7041, 136.5719, 253, 8, 333, 275, 0, 0, 45, 140, 1, 1), 
(22041, 22041, "Ragna Orc Sorcerer", 0, "", 0, "LineageMonster.batur_orc_shaman_a_01te", 11, 16, 50, "male", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 6944, 522, 305.54906, 200.23844, 208.6504, 146.5258, 253, 1, 333, 7, 0, 0, 50, 140, 1, 1), 
(22042, 22042, "Ragna Orc Sorcerer", 0, "", 0, "LineageMonster.batur_orc_shaman_a_01te", 11, 16, 50, "male", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 6368, 479, 305.54906, 200.23844, 208.6504, 146.5258, 253, 1, 333, 7, 0, 0, 50, 140, 1, 1), 
(22043, 22043, "Ragna Orc Sorcerer", 0, "", 0, "LineageMonster.batur_orc_shaman_a_01te", 11, 16, 50, "male", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 6944, 522, 305.54906, 200.23844, 208.6504, 146.5258, 253, 1, 333, 7, 0, 0, 50, 140, 1, 1), 
(22044, 22044, "Ragna Orc Sorcerer", 0, "", 0, "LineageMonster.batur_orc_shaman_a_01te", 11, 16, 50, "male", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4892, 368, 305.54906, 200.23844, 208.6504, 146.5258, 253, 1, 333, 7, 0, 0, 50, 140, 1, 1), 
(22045, 22045, "Dark Corpse", 0, "", 0, "LineageMonster.zombie_02te", 13, 21, 40, "male", "L2Monster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 1555, 96, 176.36077, 156.55035, 120.43155, 114.55675, 253, 8, 333, 0, 0, 0, 15, 15, 1, 1), 
(22046, 22046, "Varangka's Dre Vanul", 0, "", 0, "LineageMonster.dre_vanul", 14, 36, 46, "male", "L2Monster", 40, 1229.78678, 637.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 1720, 116, 248.0526, 182.18816, 169.38777, 133.31739, 253, 8, 333, 0, 0, 0, 80, 100, 1, 1), 
(22047, 22047, "Guardian of the Ghost Town", 0, "", 0, "LineageMonster.monster_eye_05te", 21, 43, 44, "male", "L2Monster", 40, 1138.62924, 584, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 1499, 98, 222.23112, 173.43552, 151.75505, 126.91259, 253, 4, 333, 0, 0, 0, 90, 100, 1, 1), 
(22048, 22048, "Dark Spider", 0, "", 0, "LineageMonster.giant_spider_04te", 26, 25.5, 42, "male", "L2Monster", 40, 1050.81652, 531, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 1433, 91, 198.34591, 164.88513, 135.44454, 120.65578, 253, 8, 333, 0, 0, 0, 72, 150, 1, 1), 
(22049, 22049, "Varangka's Succubus", 0, "", 0, "LineageMonster.succubus_05te", 10, 36, 49, "female", "L2Monster", 40, 1372.18568, 720, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 1951, 138, 290.44588, 195.66302, 198.33688, 143.17771, 253, 8, 333, 0, 0, 0, 60, 120, 1, 1), 
(22050, 22050, "Probe Golem Prodigy IV", 0, "", 0, "LineageMonster3.golem_microscout", 12, 43.5, 46, "male", "L2Monster", 40, 1229.78678, 637.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4787, 338, 248.0526, 182.18816, 169.38777, 133.31739, 253, 4, 333, 0, 0, 0, 30, 190, 1, 1), 
(22051, 22051, "Spelunking Spider", 0, "", 0, "LineageMonster.giant_spider_05te", 26, 25.5, 47, "male", "L2Monster", 40, 1276.53628, 665, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3673, 263, 261.69549, 186.63569, 178.7041, 136.5719, 253, 1, 333, 0, 0, 0, 72, 150, 1, 1), 
(22052, 22052, "Menacing Jackhammer Golem", 0, "", 0, "LineageMonster3.golem_prop", 23, 32.8, 47, "male", "L2Monster", 40, 1276.53628, 665, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 5386, 385, 261.69549, 186.63569, 178.7041, 136.5719, 253, 4, 333, 0, 0, 0, 72, 180, 1, 1), 
(22053, 22053, "Horrifying Cannon Golem I", 0, "", 0, "LineageMonster3.golem_cannon_catapult", 23.5, 34.7, 48, "male", "L2Monster", 40, 1324.01623, 692.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 5286, 385, 275.82705, 191.12803, 188.35412, 139.8592, 253, 4, 333, 0, 0, 0, 130, 180, 1, 1), 
(22054, 22054, "Horrifying Cannon Golem IV", 0, "", 0, "LineageMonster3.golem_cannon_catapult", 23.5, 34.7, 48, "male", "L2Monster", 40, 1324.01623, 692.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 5451, 397, 275.82705, 191.12803, 188.35412, 139.8592, 253, 4, 333, 0, 0, 0, 130, 180, 1, 1), 
(22055, 22055, "Cruel Vice Golem", 0, "", 0, "LineageMonster3.golem_repair", 23, 32.8, 49, "male", "L2Monster", 40, 1372.18568, 720, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 5854, 432, 290.44588, 195.66302, 198.33688, 143.17771, 253, 4, 333, 0, 0, 0, 72, 140, 1, 1), 
(22056, 22056, "Probe Golem Champion I", 0, "", 0, "LineageMonster3.golem_microscout", 12, 43.5, 49, "male", "L2Monster", 40, 1372.18568, 720, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 5266, 389, 290.44588, 195.66302, 198.33688, 143.17771, 253, 4, 333, 0, 0, 0, 30, 140, 1, 1), 
(22057, 22057, "Spelunking Ant", 0, "", 0, "LineageMonster.ant_soldier", 35, 17, 50, "male", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4157, 312, 305.54906, 200.23844, 208.6504, 146.5258, 253, 1, 333, 0, 0, 0, 80, 150, 1, 1), 
(22058, 22058, "Horrifying Excavator Golem III", 0, "", 0, "LineageMonster3.golem_carrier", 23, 32.8, 51, "male", "L2Monster", 40, 1470.41596, 775.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 6341, 482, 321.13207, 204.85194, 219.29157, 149.90176, 253, 4, 333, 0, 0, 0, 72, 150, 1, 1), 
(22059, 22059, "Bloodthirsty Ginzu Golem VII", 0, "", 0, "LineageMonster3.golem_guardian_090p", 16, 37.2, 51, "male", "L2Monster", 40, 1470.41596, 775.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 17098, 1244, 321.13207, 204.85194, 219.29157, 149.90176, 253, 4, 333, 0, 0, 0, 50, 150, 0, 1), 
(22060, 22060, "Horrifying Cannon Golem", 0, "", 0, "LineageMonster3.golem_cannon_catapult_a", 23.5, 34.7, 52, "male", "L2Monster", 40, 1520.38155, 804, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 14861, 1116, 337.18867, 209.50106, 230.25615, 153.30378, 253, 4, 333, 0, 0, 0, 130, 180, 0, 1), 
(22061, 22061, "Horrifying Cannon Golem III", 0, "", 0, "LineageMonster3.golem_microscout_a", 12, 43.5, 51, "male", "L2Monster", 40, 1470.41596, 775.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 9404, 716, 321.13207, 204.85194, 219.29157, 149.90176, 253, 4, 333, 0, 0, 0, 30, 140, 0, 1), 
(22062, 22062, "Horrifying Jackhammer Golem", 0, "", 0, "LineageMonster3.golem_prop", 23, 32.8, 52, "male", "L2Monster", 40, 1520.38155, 804, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 13973, 1032, 337.18867, 209.50106, 230.25615, 153.30378, 253, 4, 333, 0, 0, 0, 72, 140, 0, 1), 
(22063, 22063, "Ginzu Golem Prodigy X", 0, "", 0, "LineageMonster3.golem_guardian_090p", 16, 37.2, 52, "male", "L2Monster", 40, 1520.38155, 804, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 18933, 1394, 337.18867, 209.50106, 230.25615, 153.30378, 253, 4, 333, 0, 0, 0, 50, 150, 0, 1), 
(22064, 22064, "Bloodthirsty Ginzu Golem II", 0, "", 0, "LineageMonster3.golem_guardian_a_090p", 16, 37.2, 52, "male", "L2Monster", 40, 1520.38155, 804, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 17775, 1312, 337.18867, 209.50106, 230.25615, 153.30378, 253, 4, 333, 0, 0, 0, 50, 150, 0, 1), 
(22065, 22065, "Horrifying Ginzu Golem V", 0, "", 0, "LineageMonster3.golem_guardian", 18, 41.5, 53, "male", "L2Monster", 40, 1570.8463, 832.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 18465, 1385, 353.71092, 214.18326, 241.5387, 156.73001, 253, 4, 333, 0, 0, 0, 53, 150, 0, 1), 
(22066, 22066, "Horrifying Cannon Golem VI", 0, "", 0, "LineageMonster3.golem_cannon_catapult_a_090p", 21, 30, 53, "male", "L2Monster", 40, 1570.8463, 832.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 9936, 745, 353.71092, 214.18326, 241.5387, 156.73001, 253, 4, 333, 0, 0, 0, 130, 180, 0, 1), 
(22067, 22067, "Horrifying Cannon Golem VI", 0, "", 0, "LineageMonster3.golem_cannon_catapult_a_090p", 21, 30, 53, "male", "L2Monster", 40, 1570.8463, 832.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 9936, 745, 353.71092, 214.18326, 241.5387, 156.73001, 253, 4, 333, 0, 0, 0, 130, 180, 0, 1), 
(22068, 22068, "Horrifying Cannon Golem VI", 0, "", 0, "LineageMonster3.golem_cannon_catapult_a_090p", 21, 30, 53, "male", "L2Monster", 40, 1570.8463, 832.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 9936, 745, 353.71092, 214.18326, 241.5387, 156.73001, 253, 4, 333, 0, 0, 0, 130, 180, 0, 1), 
(22069, 22069, "Horrifying Cannon Golem VI", 0, "", 0, "LineageMonster3.golem_cannon_catapult_a_090p", 21, 30, 53, "male", "L2Monster", 40, 1570.8463, 832.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 9936, 745, 353.71092, 214.18326, 241.5387, 156.73001, 253, 4, 333, 0, 0, 0, 130, 180, 0, 1), 
(22070, 22070, "Horrifying Cannon Golem VI", 0, "", 0, "LineageMonster3.golem_cannon_catapult_a_090p", 21, 30, 53, "male", "L2Monster", 40, 1570.8463, 832.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 9936, 745, 353.71092, 214.18326, 241.5387, 156.73001, 253, 4, 333, 0, 0, 0, 130, 180, 0, 1), 
(22071, 22071, "Horrifying Cannon Golem VI", 0, "", 0, "LineageMonster3.golem_cannon_catapult_a_090p", 21, 30, 53, "male", "L2Monster", 40, 1570.8463, 832.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 9936, 745, 353.71092, 214.18326, 241.5387, 156.73001, 253, 4, 333, 0, 0, 0, 130, 180, 0, 1), 
(22072, 22072, "Horrifying Cannon Golem VI", 0, "", 0, "LineageMonster3.golem_cannon_catapult_a_090p", 21, 30, 53, "male", "L2Monster", 40, 1570.8463, 832.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 9936, 745, 353.71092, 214.18326, 241.5387, 156.73001, 253, 4, 333, 0, 0, 0, 130, 180, 0, 1), 
(22073, 22073, "Horrifying Cannon Golem VI", 0, "", 0, "LineageMonster3.golem_cannon_catapult_a_090p", 21, 30, 53, "male", "L2Monster", 40, 1570.8463, 832.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 9936, 745, 353.71092, 214.18326, 241.5387, 156.73001, 253, 4, 333, 0, 0, 0, 130, 180, 0, 1), 
(22074, 22074, "Epic Cannon Golem", 0, "", 0, "LineageMonster3.golem_cannon_catapult_a_090p", 21, 30, 53, "male", "L2Monster", 40, 1570.8463, 832.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 15438, 1178, 353.71092, 214.18326, 241.5387, 156.73001, 253, 4, 333, 0, 0, 0, 130, 180, 0, 1), 
(22075, 22075, "Epic Cannon Golem Adjunct", 0, "", 0, "LineageMonster3.golem_microscout_a", 12, 43.5, 52, "male", "L2Monster", 40, 1520.38155, 804, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 9777, 756, 337.18867, 209.50106, 230.25615, 153.30378, 253, 4, 333, 0, 0, 0, 30, 200, 0, 1), 
(22076, 22076, "Deadly Ginzu Golem V", 0, "", 0, "LineageMonster3.golem_guardian", 18, 41.5, 53, "male", "L2Monster", 40, 1570.8463, 832.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 18465, 1385, 353.71092, 214.18326, 241.5387, 156.73001, 253, 4, 333, 0, 0, 0, 53, 150, 0, 1), 
(22077, 22077, "Horrifying Ginzu Golem VIII", 0, "", 0, "LineageMonster3.golem_guardian_a", 18, 41.5, 54, "male", "L2Monster", 40, 1621.75618, 861, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 19169, 1458, 370.68904, 218.89589, 253.13256, 160.17851, 253, 4, 333, 0, 0, 0, 53, 150, 0, 1), 
(22078, 22078, "Deadly Ginzu Golem VIII", 0, "", 0, "LineageMonster3.golem_guardian_a", 18, 41.5, 54, "male", "L2Monster", 40, 1621.75618, 861, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 19169, 1458, 370.68904, 218.89589, 253.13256, 160.17851, 253, 4, 333, 0, 0, 0, 53, 150, 0, 1), 
(22079, 22079, "Lost Bandersnatch", 0, "", 0, "LineageMonster2.bandersnatch_c", 18, 25, 53, "male", "L2Monster", 40, 1570.8463, 832.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 4295, 331, 353.71092, 214.18326, 241.5387, 156.73001, 253, 4, 333, 0, 0, 0, 30, 170, 0, 1), 
(22080, 22080, "Massive Maze Bandersnatch", 0, "", 0, "LineageMonster2.bandersnatch", 18, 25, 54, "male", "L2Monster", 40, 1621.75618, 861, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 4710, 368, 370.68904, 218.89589, 253.13256, 160.17851, 253, 4, 333, 0, 0, 0, 30, 170, 0, 1), 
(22081, 22081, "Lost Watcher", 0, "", 0, "LineageMonster.field_stalker", 15, 30, 53, "male", "L2Monster", 40, 1570.8463, 832.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 4393, 344, 353.71092, 214.18326, 241.5387, 156.73001, 253, 4, 333, 0, 0, 0, 70, 130, 1, 1), 
(22082, 22082, "Elder Lost Watcher", 0, "", 0, "LineageMonster.field_stalker_110p", 16, 36, 54, "male", "L2Monster", 40, 1621.75618, 861, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 5039, 401, 370.68904, 218.89589, 253.13256, 160.17851, 253, 4, 333, 0, 0, 0, 70, 170, 1, 1), 
(22083, 22083, "Baby Panthera", 0, "", 0, "LineageMonster.saber_toothed_tiger_080p", 29, 22.7, 55, "male", "L2Monster", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 4625, 366, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(22084, 22084, "Panthera", 0, "", 0, "LineageMonster.saber_toothed_tiger", 34, 28, 56, "male", "L2Monster", 40, 1724.6831, 918.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 4795, 386, 405.96455, 228.40135, 277.22116, 167.1342, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(22085, 22085, "Lost Gargoyle", 0, "", 0, "LineageMonster.gargoyle_02te", 16, 50, 55, "male", "L2Monster", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 4157, 335, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 140, 140, 1, 1), 
(22086, 22086, "Lost Gargoyle Youngling", 0, "", 0, "LineageMonster.gargoyle_02te_110p", 17.5, 56, 56, "male", "L2Monster", 40, 1724.6831, 918.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 4824, 396, 405.96455, 228.40135, 277.22116, 167.1342, 253, 4, 333, 0, 0, 0, 140, 140, 1, 1), 
(22087, 22087, "Pronghorn Spirit", 0, "", 0, "LineageMonster2.antelope", 17, 34, 56, "male", "L2Monster", 40, 1724.6831, 918.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 7743, 635, 405.96455, 228.40135, 277.22116, 167.1342, 253, 4, 333, 0, 0, 0, 45, 185, 0, 1), 
(22088, 22088, "Pronghorn", 0, "", 0, "LineageMonster2.antelope_110p", 19, 37.8, 57, "male", "L2Monster", 40, 1776.58018, 948, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 4700, 390, 424.23295, 233.18839, 289.69611, 170.63714, 253, 4, 333, 0, 0, 0, 45, 185, 1, 1), 
(22089, 22089, "Ice Tarantula", 0, "", 0, "LineageMonster.giant_spider", 26, 25.5, 57, "male", "L2Monster", 40, 1776.58018, 948, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 5402, 449, 424.23295, 233.18839, 289.69611, 170.63714, 253, 1, 333, 0, 0, 0, 72, 120, 1, 1), 
(22090, 22090, "Frost Tarantula", 0, "", 0, "LineageMonster.giant_spider_110p", 32, 28, 58, "male", "L2Monster", 40, 1828.68266, 977.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 5593, 472, 442.8992, 237.99429, 302.44274, 174.1539, 253, 1, 333, 0, 0, 0, 72, 120, 1, 1), 
(22091, 22091, "Lost Iron Golem", 0, "", 0, "LineageMonster.iron_golem_120p", 22, 42.5, 58, "male", "L2Monster", 40, 1828.68266, 977.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 6029, 498, 442.8992, 237.99429, 302.44274, 174.1539, 253, 1, 333, 0, 0, 0, 20, 20, 0, 1), 
(22092, 22092, "Frost Iron Golem", 0, "", 0, "LineageMonster.iron_golem_130p", 24, 46.4, 59, "male", "L2Monster", 40, 1880.92519, 1007, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 6239, 521, 461.94387, 242.81593, 315.44778, 177.68216, 253, 4, 333, 0, 0, 0, 20, 20, 0, 1), 
(22093, 22093, "Lost Buffalo", 0, "", 0, "LineageMonster2.buffalo", 22, 31, 60, "male", "L2Monster", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 8888, 770, 481.34551, 247.65008, 328.69659, 181.21958, 253, 1, 333, 0, 0, 0, 20, 170, 0, 1), 
(22094, 22094, "Frost Buffalo", 0, "", 0, "LineageMonster2.buffalo_a_110p", 24, 34.7, 61, "male", "L2Monster", 40, 1985.55926, 1066.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 5383, 473, 501.08068, 252.49346, 342.17315, 184.76376, 253, 1, 333, 0, 0, 0, 20, 170, 1, 1), 
(22095, 22095, "Ursus Cub", 0, "", 0, "LineageMonster.grizzly", 21, 40, 61, "male", "L2Monster", 40, 1985.55926, 1066.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 5689, 491, 501.08068, 252.49346, 342.17315, 184.76376, 253, 4, 333, 0, 0, 0, 40, 120, 0, 1), 
(22096, 22096, "Ursus", 0, "", 0, "LineageMonster.grizzly_120p", 21, 40, 62, "male", "L2Monster", 40, 2037.81082, 1097, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 5877, 514, 521.12391, 257.34267, 355.86007, 188.3122, 253, 4, 333, 0, 0, 0, 40, 120, 0, 1), 
(22097, 22097, "Lost Yeti", 0, "", 0, "LineageMonster.yeti", 15, 27.5, 62, "male", "L2Monster", 40, 2037.81082, 1097, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 6728, 599, 521.12391, 257.34267, 355.86007, 188.3122, 253, 1, 333, 0, 0, 0, 16, 170, 1, 1), 
(22098, 22098, "Frost Yeti", 0, "", 0, "LineageMonster.yeti_110p", 20, 29.8, 63, "male", "L2Monster", 40, 2089.92274, 1127.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 6947, 626, 541.44774, 262.19426, 369.73862, 191.86238, 253, 1, 333, 0, 0, 0, 16, 170, 1, 1), 
(22099, 22099, "Freya's Buffalo", 0, "", 0, "LineageMonster2.buffalo", 22, 31, 57, "male", "L2Monster", 40, 1776.58018, 948, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 31854, 2570, 424.23295, 233.18839, 289.69611, 170.63714, 253, 4, 333, 0, 0, 0, 20, 170, 0, 1), 
(22100, 22100, "Freya's Gardener", 0, "", 0, "LineageMonster.field_stalker", 15, 30, 58, "male", "L2Monster", 40, 1828.68266, 977.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 37927, 3113, 442.8992, 237.99429, 302.44274, 174.1539, 253, 4, 333, 0, 0, 0, 70, 130, 0, 1), 
(22101, 22101, "Freya's Servant", 0, "", 0, "LineageMonster.gargoyle_02te", 16, 50, 58, "male", "L2Monster", 40, 1828.68266, 977.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 33143, 2723, 442.8992, 237.99429, 302.44274, 174.1539, 253, 8, 333, 0, 0, 0, 140, 168, 0, 1), 
(22102, 22102, "Freya's Servant", 0, "", 0, "LineageMonster.gargoyle_02te", 16, 50, 58, "male", "L2Monster", 40, 1828.68266, 977.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 33143, 2723, 442.8992, 237.99429, 302.44274, 174.1539, 253, 4, 333, 0, 0, 0, 140, 140, 0, 1), 
(22103, 22103, "Freya's White Bear", 0, "", 0, "LineageMonster.grizzly", 21, 40, 57, "male", "L2Monster", 40, 1776.58018, 948, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 33473, 2705, 424.23295, 233.18839, 289.69611, 170.63714, 253, 4, 333, 0, 0, 0, 40, 165, 0, 1), 
(22104, 22104, "Freya's Dog", 0, "", 0, "LineageMonster2.bandersnatch", 18, 25, 58, "male", "L2Monster", 40, 1828.68266, 977.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 34900, 2867, 442.8992, 237.99429, 302.44274, 174.1539, 253, 4, 333, 0, 0, 0, 30, 170, 0, 1), 
(22105, 22105, "Spiked Stakato", 0, "", 0, "LineageMonster.blade_stakato_120p", 18, 43.2, 72, "male", "L2Monster", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 30856, 2988, 731.52506, 305.35947, 499.53679, 223.44881, 253, 1, 333, 0, 0, 0, 25, 200, 0, 1), 
(22106, 22106, "Spiked Stakato Worker", 0, "", 0, "LineageMonster.blade_stakato_worker_120p", 22, 48.3, 73, "male", "L2Monster", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 31719, 3112, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 221, 0, 0, 25, 200, 0, 1), 
(22107, 22107, "Spiked Stakato Guard", 0, "", 0, "LineageMonster.spike_stakato", 16, 22.8, 74, "male", "L2Monster", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 32594, 3239, 773.81598, 314.65987, 528.41601, 230.25444, 253, 4, 333, 123, 0, 0, 23, 200, 0, 1), 
(22108, 22108, "Female Spiked Stakato", 0, "", 0, "LineageMonster.spike_stakato_soldier", 17, 30, 74, "male", "L2Monster", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 45208, 4534, 773.81598, 314.65987, 528.41601, 230.25444, 253, 4, 333, 123, 0, 0, 60, 220, 0, 1), 
(22109, 22109, "Male Spiked Stakato", 0, "", 0, "LineageMonster.marsh_stakato_soldier_120p", 18, 31, 74, "male", "L2Monster", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 44602, 4474, 773.81598, 314.65987, 528.41601, 230.25444, 253, 4, 333, 135, 0, 0, 30, 200, 0, 1), 
(22110, 22110, "Male Spiked Stakato", 0, "", 0, "LineageMonster3.marsh_stakato_soldier_tran", 16, 28.4, 74, "male", "L2Monster", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 33935, 3379, 773.81598, 314.65987, 528.41601, 230.25444, 253, 4, 333, 135, 0, 0, 32, 220, 0, 1), 
(22111, 22111, "Spiked Stakato Sorcerer", 0, "", 0, "LineageMonster.blade_stakato_queen_120p", 24, 43.6, 75, "female", "L2Monster", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 32663, 3281, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 221, 0, 0, 25, 170, 0, 1), 
(22112, 22112, "Cannibalistic Stakato Follower", 0, "", 0, "LineageMonster.spike_stakato_worker", 17, 29.8, 74, "male", "L2Monster", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 41268, 4144, 773.81598, 314.65987, 528.41601, 230.25444, 253, 4, 333, 223, 0, 0, 23, 200, 0, 1), 
(22113, 22113, "Cannibalistic Stakato Leader", 0, "", 0, "LineageMonster3.cannibal_stakato_leader_120p", 34, 48.8, 75, "male", "L2Monster", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 51731, 5243, 794.70901, 319.24623, 542.68324, 233.61053, 253, 1, 333, 0, 0, 0, 40, 200, 0, 1), 
(22114, 22114, "Cannibalistic Stakato Leader", 0, "", 0, "LineageMonster3.cannibal_stakato_leader_tran", 40, 42, 75, "male", "L2Monster", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 34858, 3512, 794.70901, 319.24623, 542.68324, 233.61053, 253, 1, 333, 0, 0, 0, 34, 220, 0, 1), 
(22115, 22115, "Spiked Stakato Soldier", 0, "", 0, "LineageMonster.blade_stakato_120p", 18, 43.2, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 28650, 2920, 815.37145, 323.78455, 556.793, 236.93149, 253, 1, 333, 0, 0, 0, 25, 200, 0, 1), 
(22116, 22116, "Spiked Stakato Drone", 0, "", 0, "LineageMonster.blade_stakato_drone_120p", 28, 47.3, 77, "male", "L2Monster", 40, 2762.08447, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 29409, 3034, 835.75573, 328.27073, 570.71283, 240.21427, 253, 4, 333, 235, 0, 0, 25, 200, 0, 1), 
(22117, 22117, "Spiked Stakato Captain", 0, "", 0, "LineageMonster.marsh_stakato_drone_120p", 14, 29.1, 78, "male", "L2Monster", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 30177, 3149, 855.81387, 332.70061, 584.40994, 243.45587, 253, 8, 333, 234, 0, 0, 80, 200, 0, 1), 
(22118, 22118, "Spiked Stakato Nurse", 0, "", 0, "LineageMonster.marsh_stakato_queen_120p", 26, 43.8, 78, "female", "L2Monster", 40, 2870.777409, 1657.41, 8.585, 3.03, 40, 43, 30, 21, 20, 20, 41892, 4464, 884.25257, 340.44078, 609.86817, 249.11979, 253, 4, 333, 132, 0, 0, 130, 200, 0, 1), 
(22119, 22119, "Spiked Stakato Nurse", 0, "", 0, "LineageMonster3.marsh_stakato_queen_tran", 18, 36.4, 78, "female", "L2Monster", 40, 2870.777409, 1657.41, 8.585, 3.03, 40, 43, 30, 21, 20, 20, 31155, 3293, 884.25257, 340.44078, 609.86817, 249.11979, 253, 4, 333, 0, 0, 0, 55, 220, 0, 1), 
(22120, 22120, "Spiked Stakato Baby", 0, "", 0, "LineageMonster.spike_stakato_drone", 16, 29, 78, "male", "L2Monster", 40, 2870.777409, 1657.41, 8.585, 3.03, 40, 43, 30, 21, 20, 20, 39719, 4242, 884.25257, 340.44078, 609.86817, 249.11979, 253, 4, 333, 235, 0, 0, 60, 220, 0, 1), 
(22121, 22121, "Spiked Stakato Shaman", 0, "", 0, "LineageMonster.blade_stakato_queen_120p", 24, 43.6, 78, "female", "L2Monster", 40, 2937.983806, 1708.296, 8.67, 3.06, 40, 43, 30, 21, 20, 20, 30969, 3310, 912.65371, 348.2025, 635.68866, 254.79948, 253, 8, 333, 221, 0, 0, 25, 170, 0, 1), 
(22122, 22122, "Monastic Pilgrim", 0, "", 0, "LineageMonster.angel_080p", 12, 27.8, 78, "male", "L2Monster", 40, 2937.983806, 1708.296, 8.67, 3.06, 40, 43, 30, 21, 20, 20, 41281, 4464, 912.65371, 348.2025, 635.68866, 254.79948, 253, 4, 333, 148, 0, 0, 30, 120, 0, 1), 
(22123, 22123, "Monastic Crusader", 0, "", 0, "LineageMonster.archangel_050p", 13, 37.5, 78, "male", "L2Monster", 80, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 41690, 4558, 938.20801, 354.81835, 656.66638, 259.64067, 253, 4, 333, 97, 0, 0, 50, 120, 0, 1), 
(22124, 22124, "Solina Brother", 0, "", 0, "LineageMonster3.solina_brother", 9, 23.4, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 33265, 3601, 938.20801, 354.81835, 656.66638, 259.64067, 253, 1, 333, 8212, 0, 0, 61, 180, 0, 1), 
(22125, 22125, "Solina Lay Brother", 0, "", 0, "LineageMonster3.solina_brother", 9, 23.4, 78, "male", "L2Monster", 40, 3010.892998, 1777.86, 8.772, 3.1008, 40, 43, 30, 21, 20, 20, 33305, 3644, 961.93701, 361.08599, 677.64411, 264.22706, 253, 1, 333, 8212, 0, 0, 61, 180, 0, 1), 
(22126, 22126, "Silent Seeker", 0, "", 0, "LineageMonster3.solina_father", 11, 25.4, 78, "male", "L2Monster", 40, 3010.892998, 1777.86, 8.772, 3.1008, 40, 43, 30, 21, 20, 20, 34092, 3734, 961.93701, 361.08599, 677.64411, 264.22706, 253, 4, 333, 8213, 0, 0, 70, 180, 0, 1), 
(22127, 22127, "Silent Brother", 0, "", 0, "LineageMonster3.solina_father", 11, 25.4, 78, "male", "L2Monster", 40, 3044.88717, 1812.948, 8.823, 3.111, 40, 43, 30, 21, 20, 20, 34122, 3778, 985.66601, 367.35364, 699.25752, 268.81345, 253, 4, 333, 8213, 0, 0, 70, 180, 0, 1), 
(22128, 22128, "Monastery Guardian", 0, "", 0, "LineageMonster3.grail_protection", 9, 15.6, 78, "male", "L2Monster", 40, 3044.88717, 1812.948, 8.823, 3.111, 40, 43, 30, 21, 20, 20, 9741, 1132, 985.66601, 367.35364, 699.25752, 268.81345, 253, 4, 333, 0, 0, 0, 65, 180, 0, 1), 
(22129, 22129, "Warrior Monk", 0, "", 0, "LineageMonster3.monk_warrior", 12, 28.4, 78, "male", "L2Monster", 40, 3077.157206, 1848.24, 8.874, 3.1314, 40, 43, 30, 21, 20, 20, 35775, 4012, 1009.395, 373.96949, 719.59956, 273.65464, 253, 4, 333, 8211, 8210, 0, 53, 180, 0, 1), 
(22130, 22130, "Divine Advocate", 0, "", 0, "LineageMonster2.apostle_warrior", 8, 30, 78, "female", "L2Monster", 40, 3107.643659, 1883.736, 8.925, 3.1518, 40, 43, 30, 21, 20, 20, 52227, 5990, 1033.124, 380.23713, 740.57728, 278.24103, 253, 4, 333, 6717, 0, 0, 50, 180, 0, 1), 
(22131, 22131, "Pilgrim of Light", 0, "", 0, "LineageMonster2.apostle_mage", 11, 38.5, 78, "male", "L2Monster", 40, 3107.643659, 1883.736, 8.925, 3.1518, 40, 43, 30, 21, 20, 20, 56598, 6488, 1033.124, 380.23713, 740.57728, 278.24103, 253, 1, 333, 6718, 0, 0, 50, 165, 0, 1), 
(22132, 22132, "Judge of Light", 0, "", 0, "LineageMonster3.apostle_grail_a", 13, 47, 78, "male", "L2Monster", 40, 3136.290094, 1919.436, 8.976, 3.16812, 40, 43, 30, 21, 20, 20, 37163, 4257, 1055.02769, 386.50478, 760.91932, 282.82742, 253, 1, 333, 0, 0, 0, 30, 120, 0, 1), 
(22133, 22133, "Guardian of the Grail", 0, "", 0, "LineageMonster.will_o_wisp", 13, 22, 78, "male", "L2Monster", 40, 3136.290094, 1919.436, 8.976, 3.16812, 40, 43, 30, 21, 20, 20, 13890, 1672, 1055.02769, 386.50478, 760.91932, 282.82742, 253, 8, 333, 0, 0, 0, 80, 140, 0, 1), 
(22134, 22134, "Guardian of the Holy Land", 0, "", 0, "LineageMonster3.solina_priest", 14, 34.5, 78, "male", "L2Monster", 40, 3163.043215, 1955.34, 9.027, 3.1824, 40, 43, 30, 21, 20, 20, 37490, 4352, 1076.93138, 410.87895, 781.26136, 300.66338, 253, 1, 333, 8214, 0, 0, 30, 120, 0, 1), 
(22135, 22135, "Beholder of Light", 0, "", 0, "LineageMonster3.apostle_grail", 13, 47, 78, "male", "L2Monster", 80, 3163.043215, 1955.34, 9.027, 3.1824, 40, 43, 30, 21, 20, 20, 60962, 7152, 1076.93138, 410.87895, 781.26136, 300.66338, 253, 4, 333, 8221, 0, 0, 30, 120, 0, 1), 
(22136, 22136, "Gatekeeper Zombie", 0, "", 0, "LineageMonster3.zombie_gateguard", 17, 30.5, 78, "male", "L2Monster", 40, 3044.88717, 1812.948, 8.823, 3.111, 40, 43, 30, 21, 20, 20, 35842, 3964, 985.66601, 367.35364, 699.25752, 268.81345, 253, 1, 333, 8217, 0, 0, 33, 120, 0, 1), 
(22137, 22137, "Penance Guard", 0, "", 0, "LineageMonster3.zombie_gateguard_brd", 40, 30.5, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 3681, 397, 938.20801, 354.81835, 656.66638, 259.64067, 253, 4, 333, 8217, 0, 0, 33, 120, 0, 1), 
(22138, 22138, "Chapel Guard", 0, "", 0, "LineageMonster3.zombie_gateguard_brd", 40, 30.5, 78, "male", "L2Monster", 40, 3107.643659, 1883.736, 8.925, 3.1518, 40, 43, 30, 21, 20, 20, 4054, 458, 1033.124, 380.23713, 740.57728, 278.24103, 253, 1, 333, 8217, 0, 0, 33, 120, 0, 1), 
(22139, 22139, "Old Aristocrat's Soldier", 0, "", 0, "LineageMonster3.zombie_enlisted_man", 17, 22.3, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 33132, 3573, 938.20801, 354.81835, 656.66638, 259.64067, 253, 1, 333, 0, 0, 0, 38, 200, 0, 1), 
(22140, 22140, "Zombie Worker", 0, "", 0, "LineageMonster3.zombie_laborer", 11, 24.6, 78, "male", "L2Monster", 40, 2937.983806, 1708.296, 8.67, 3.06, 40, 43, 30, 21, 20, 20, 32319, 3446, 912.65371, 348.2025, 635.68866, 254.79948, 253, 4, 333, 123, 0, 0, 36, 120, 0, 1), 
(22141, 22141, "Forgotten Victim", 0, "", 0, "LineageMonster3.zombie_laborer", 11, 24.6, 78, "male", "L2Monster", 40, 2937.983806, 1708.296, 8.67, 3.06, 40, 43, 30, 21, 20, 20, 33394, 3566, 912.65371, 348.2025, 635.68866, 254.79948, 253, 4, 333, 123, 0, 0, 36, 120, 0, 1), 
(22142, 22142, "Triol's Layperson", 0, "", 0, "LineageMonster3.heretic_privates_a", 7.7, 28.4, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 33855, 3651, 938.20801, 354.81835, 656.66638, 259.64067, 253, 4, 333, 8207, 8207, 0, 58, 200, 0, 1), 
(22143, 22143, "Triol's Believer", 0, "", 0, "LineageMonster3.heretic_privates", 7.7, 28.4, 78, "male", "L2Monster", 80, 3010.892998, 1777.86, 8.772, 3.1008, 40, 43, 30, 21, 20, 20, 39134, 4296, 961.93701, 361.08599, 677.64411, 264.22706, 253, 4, 333, 8205, 0, 0, 60, 200, 0, 1), 
(22144, 22144, "Resurrected Temple Knight", 0, "", 0, "LineageMonster3.zombie_enlisted_man", 17, 22.3, 78, "male", "L2Monster", 40, 3010.892998, 1777.86, 8.772, 3.1008, 40, 43, 30, 21, 20, 20, 33955, 3705, 961.93701, 361.08599, 677.64411, 264.22706, 253, 1, 333, 0, 0, 0, 38, 200, 0, 1), 
(22145, 22145, "Ritual Sacrifice", 0, "", 0, "LineageMonster3.self_blaster", 9, 25.8, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 32635, 3520, 938.20801, 354.81835, 656.66638, 259.64067, 253, 1, 333, 0, 0, 0, 30, 200, 0, 1), 
(22146, 22146, "Triol's Priest", 0, "", 0, "LineageMonster3.heretic_privates", 7.7, 28.4, 78, "male", "L2Monster", 80, 3077.157206, 1848.24, 8.874, 3.1314, 40, 43, 30, 21, 20, 20, 36409, 4068, 1009.395, 373.96949, 719.59956, 273.65464, 253, 4, 333, 8205, 0, 0, 60, 200, 0, 1), 
(22147, 22147, "Ritual Offering", 0, "", 0, "LineageMonster3.zombie_enlisted_man", 17, 22.3, 78, "male", "L2Monster", 40, 3044.88717, 1812.948, 8.823, 3.111, 40, 43, 30, 21, 20, 20, 35945, 3976, 985.66601, 367.35364, 699.25752, 268.81345, 253, 1, 333, 0, 0, 0, 38, 180, 0, 1), 
(22148, 22148, "Triol's Believer", 0, "", 0, "LineageMonster3.heretic_privates", 7.7, 28.4, 78, "male", "L2Monster", 80, 3010.892998, 1777.86, 8.772, 3.1008, 40, 43, 30, 21, 20, 20, 28321, 3091, 961.93701, 361.08599, 677.64411, 264.22706, 253, 4, 333, 8205, 0, 0, 60, 180, 0, 1), 
(22149, 22149, "Ritual Offering", 0, "", 0, "LineageMonster3.zombie_enlisted_man", 17, 22.3, 78, "male", "L2Monster", 40, 3010.892998, 1777.86, 8.772, 3.1008, 40, 43, 30, 21, 20, 20, 33955, 3705, 961.93701, 361.08599, 677.64411, 264.22706, 253, 1, 333, 0, 0, 0, 38, 180, 0, 1), 
(22150, 22150, "Triol's Believer", 0, "", 0, "LineageMonster3.heretic_privates", 7.7, 28.4, 78, "male", "L2Monster", 80, 3044.88717, 1812.948, 8.823, 3.111, 40, 43, 30, 21, 20, 20, 29760, 3290, 985.66601, 367.35364, 699.25752, 268.81345, 253, 4, 333, 8205, 0, 0, 60, 180, 0, 1), 
(22151, 22151, "Triol's Priest", 0, "", 0, "LineageMonster3.heretic_privates", 7.7, 28.4, 78, "male", "L2Monster", 80, 3107.643659, 1883.736, 8.925, 3.1518, 40, 43, 30, 21, 20, 20, 42050, 4783, 1033.124, 380.23713, 740.57728, 278.24103, 253, 4, 333, 8205, 0, 0, 60, 180, 0, 1), 
(22152, 22152, "Temple Guard", 0, "", 0, "LineageMonster3.zombie_em_knight", 17, 22.3, 78, "male", "L2Monster", 80, 3077.157206, 1848.24, 8.874, 3.1314, 40, 43, 30, 21, 20, 20, 36817, 4121, 1009.395, 373.96949, 719.59956, 273.65464, 253, 4, 333, 8215, 0, 0, 38, 180, 0, 1), 
(22153, 22153, "Temple Guard Captain", 0, "", 0, "LineageMonster3.zombie_em_knight", 17, 22.3, 78, "male", "L2Monster", 80, 3077.157206, 1848.24, 8.874, 3.1314, 40, 43, 30, 21, 20, 20, 35631, 3981, 1009.395, 373.96949, 719.59956, 273.65464, 253, 4, 333, 8215, 0, 0, 38, 180, 0, 1), 
(22154, 22154, "Ritual Sacrifice", 0, "", 0, "LineageMonster3.self_blaster", 9, 25.8, 78, "male", "L2Monster", 40, 3107.643659, 1883.736, 8.925, 3.1518, 40, 43, 30, 21, 20, 20, 35937, 4063, 1033.124, 380.23713, 740.57728, 278.24103, 253, 4, 333, 0, 0, 0, 30, 200, 0, 1), 
(22155, 22155, "Triol's High Priest", 0, "", 0, "LineageMonster3.heretic_priest_a", 8, 19.1, 78, "male", "L2Monster", 40, 3107.643659, 1883.736, 8.925, 3.1518, 40, 43, 30, 21, 20, 20, 51240, 5877, 1033.124, 380.23713, 740.57728, 278.24103, 253, 4, 333, 8206, 8206, 0, 30, 180, 0, 1), 
(22156, 22156, "Triol's Priest", 0, "", 0, "LineageMonster3.heretic_privates", 7.7, 28.4, 78, "male", "L2Monster", 80, 3136.290094, 1919.436, 8.976, 3.16812, 40, 43, 30, 21, 20, 20, 46329, 5392, 1055.02769, 386.50478, 760.91932, 282.82742, 253, 4, 333, 8205, 0, 0, 60, 180, 0, 1), 
(22157, 22157, "Triol's Priest", 0, "", 0, "LineageMonster3.heretic_privates", 7.7, 28.4, 78, "male", "L2Monster", 80, 3107.643659, 1883.736, 8.925, 3.1518, 40, 43, 30, 21, 20, 20, 44390, 5102, 1033.124, 380.23713, 740.57728, 278.24103, 253, 4, 333, 8205, 0, 0, 60, 180, 0, 1), 
(22158, 22158, "Triol's Believer", 0, "", 0, "LineageMonster3.heretic_privates_a", 7.7, 28.4, 78, "male", "L2Monster", 40, 3107.643659, 1883.736, 8.925, 3.1518, 40, 43, 30, 21, 20, 20, 45257, 5205, 1033.124, 380.23713, 740.57728, 278.24103, 253, 4, 333, 8207, 8207, 0, 58, 180, 0, 1), 
(22159, 22159, "Triol's High Priest", 0, "", 0, "LineageMonster3.heretic_priest_a", 8, 19.1, 78, "male", "L2Monster", 40, 3136.290094, 1919.436, 8.976, 3.16812, 40, 43, 30, 21, 20, 20, 52452, 6087, 1055.02769, 386.50478, 760.91932, 282.82742, 253, 4, 333, 8206, 8206, 0, 30, 180, 0, 1), 
(22160, 22160, "Triol's Priest", 0, "", 0, "LineageMonster3.heretic_privates", 7.7, 28.4, 78, "male", "L2Monster", 80, 3136.290094, 1919.436, 8.976, 3.16812, 40, 43, 30, 21, 20, 20, 46329, 5392, 1055.02769, 386.50478, 760.91932, 282.82742, 253, 4, 333, 8205, 0, 0, 60, 180, 0, 1), 
(22161, 22161, "Ritual Sacrifice", 0, "", 0, "LineageMonster3.self_blaster", 9, 25.8, 78, "male", "L2Monster", 40, 3107.643659, 1883.736, 8.925, 3.1518, 40, 43, 30, 21, 20, 20, 52497, 6034, 1033.124, 380.23713, 740.57728, 278.24103, 253, 4, 333, 0, 0, 0, 30, 200, 0, 1), 
(22162, 22162, "Triol's Believer", 0, "", 0, "LineageMonster3.heretic_privates_a", 7.7, 28.4, 78, "male", "L2Monster", 40, 3107.643659, 1883.736, 8.925, 3.1518, 40, 43, 30, 21, 20, 20, 45257, 5205, 1033.124, 380.23713, 740.57728, 278.24103, 253, 4, 333, 8207, 8207, 0, 58, 180, 0, 1), 
(22163, 22163, "Triol's High Priest", 0, "", 0, "LineageMonster3.heretic_priest", 8, 19.1, 78, "male", "L2Monster", 40, 3136.290094, 1919.436, 8.976, 3.16812, 40, 43, 30, 21, 20, 20, 60848, 7048, 1055.02769, 386.50478, 760.91932, 282.82742, 253, 1, 333, 8208, 0, 0, 30, 180, 0, 1), 
(22164, 22164, "Triol's Believer", 0, "", 0, "LineageMonster3.heretic_privates_a", 7.7, 28.4, 78, "male", "L2Monster", 40, 3136.290094, 1919.436, 8.976, 3.16812, 40, 43, 30, 21, 20, 20, 46329, 5392, 1055.02769, 386.50478, 760.91932, 282.82742, 253, 4, 333, 8207, 8207, 0, 58, 180, 0, 1), 
(22165, 22165, "Triol's Priest", 0, "", 0, "LineageMonster3.heretic_privates", 7.7, 28.4, 78, "male", "L2Monster", 80, 3107.643659, 1883.736, 8.925, 3.1518, 40, 43, 30, 21, 20, 20, 44390, 5102, 1033.124, 380.23713, 740.57728, 278.24103, 253, 4, 333, 8205, 0, 0, 60, 180, 0, 1), 
(22166, 22166, "Triol's Believer", 0, "", 0, "LineageMonster3.heretic_privates", 7.7, 28.4, 78, "male", "L2Monster", 80, 3107.643659, 1883.736, 8.925, 3.1518, 40, 43, 30, 21, 20, 20, 44390, 5102, 1033.124, 380.23713, 740.57728, 278.24103, 253, 4, 333, 8205, 0, 0, 60, 180, 0, 1), 
(22167, 22167, "Triol's High Priest", 0, "", 0, "LineageMonster3.heretic_priest_a", 8, 19.1, 78, "male", "L2Monster", 40, 3163.043215, 1955.34, 9.027, 3.1824, 40, 43, 30, 21, 20, 20, 53679, 6304, 1076.93138, 410.87895, 781.26136, 300.66338, 253, 4, 333, 8206, 8206, 0, 30, 180, 0, 1), 
(22168, 22168, "Triol's Priest", 0, "", 0, "LineageMonster3.heretic_privates", 7.7, 28.4, 78, "male", "L2Monster", 80, 3163.043215, 1955.34, 9.027, 3.1824, 40, 43, 30, 21, 20, 20, 46504, 5473, 1076.93138, 410.87895, 781.26136, 300.66338, 253, 4, 333, 8205, 0, 0, 60, 180, 0, 1), 
(22169, 22169, "Ritual Sacrifice", 0, "", 0, "LineageMonster3.self_blaster", 9, 25.8, 78, "male", "L2Monster", 40, 3136.290094, 1919.436, 8.976, 3.16812, 40, 43, 30, 21, 20, 20, 53740, 6251, 1055.02769, 386.50478, 760.91932, 282.82742, 253, 4, 333, 0, 0, 0, 30, 200, 0, 1), 
(22170, 22170, "Triol's Believer", 0, "", 0, "LineageMonster3.heretic_privates_a", 7.7, 28.4, 78, "male", "L2Monster", 40, 3136.290094, 1919.436, 8.976, 3.16812, 40, 43, 30, 21, 20, 20, 46329, 5392, 1055.02769, 386.50478, 760.91932, 282.82742, 253, 4, 333, 8207, 8207, 0, 58, 180, 0, 1), 
(22171, 22171, "Triol's High Priest", 0, "", 0, "LineageMonster3.heretic_priest", 8, 19.1, 78, "male", "L2Monster", 40, 3163.043215, 1955.34, 9.027, 3.1824, 40, 43, 30, 21, 20, 20, 62272, 7299, 1076.93138, 410.87895, 781.26136, 300.66338, 253, 1, 333, 8208, 0, 0, 30, 180, 0, 1), 
(22172, 22172, "Ritual Sacrifice", 0, "", 0, "LineageMonster3.self_blaster", 9, 25.8, 78, "male", "L2Monster", 40, 3136.290094, 1919.436, 8.976, 3.16812, 40, 43, 30, 21, 20, 20, 53740, 6251, 1055.02769, 386.50478, 760.91932, 282.82742, 253, 4, 333, 0, 0, 0, 30, 200, 0, 1), 
(22173, 22173, "Triol's Priest", 0, "", 0, "LineageMonster3.heretic_privates", 7.7, 28.4, 78, "male", "L2Monster", 80, 3136.290094, 1919.436, 8.976, 3.16812, 40, 43, 30, 21, 20, 20, 45441, 5285, 1055.02769, 386.50478, 760.91932, 282.82742, 253, 4, 333, 8205, 0, 0, 60, 180, 0, 1), 
(22174, 22174, "Triol's Priest", 0, "", 0, "LineageMonster3.heretic_privates", 7.7, 28.4, 78, "male", "L2Monster", 80, 3107.643659, 1883.736, 8.925, 3.1518, 40, 43, 30, 21, 20, 20, 45257, 5205, 1033.124, 380.23713, 740.57728, 278.24103, 253, 4, 333, 8205, 0, 0, 60, 180, 0, 1), 
(22175, 22175, "Andreas' Captain of the Royal Guard", 0, "", 0, "LineageMonster3.zombie_em_knight", 17, 22.3, 78, "male", "L2Monster", 80, 3107.643659, 1883.736, 8.925, 3.1518, 40, 43, 30, 21, 20, 20, 1871, 211, 1033.124, 380.23713, 740.57728, 278.24103, 253, 4, 333, 8215, 0, 0, 38, 180, 0, 1), 
(22176, 22176, "Andreas' Royal Guards", 0, "", 0, "LineageMonster3.zombie_em_knight", 17, 22.3, 78, "male", "L2Monster", 80, 3107.643659, 1883.736, 8.925, 3.1518, 40, 43, 30, 21, 20, 20, 1871, 211, 1033.124, 380.23713, 740.57728, 278.24103, 253, 4, 333, 8215, 0, 0, 38, 180, 0, 1), 
(22188, 22188, "Andreas' Captain of the Royal Guard", 0, "", 0, "LineageMonster3.heretic_priest_120p", 13, 23.2, 78, "male", "L2Monster", 40, 3163.043215, 1955.34, 9.027, 3.1824, 40, 43, 30, 21, 20, 20, 36967, 4356, 1076.93138, 410.87895, 781.26136, 300.66338, 253, 1, 333, 8208, 0, 0, 30, 180, 0, 1), 
(22189, 22189, "Andreas' Royal Guards", 0, "", 0, "LineageMonster3.heretic_privates_120p", 13, 34, 78, "male", "L2Monster", 80, 3136.290094, 1919.436, 8.976, 3.16812, 40, 43, 30, 21, 20, 20, 29554, 3460, 1055.02769, 386.50478, 760.91932, 282.82742, 253, 4, 333, 8205, 0, 0, 60, 180, 0, 1), 
(22190, 22190, "Ritual Sacrifice", 0, "", 0, "LineageMonster3.self_blaster", 9, 25.8, 78, "male", "L2Monster", 40, 3136.290094, 1919.436, 8.976, 3.16812, 40, 43, 30, 21, 20, 20, 34316, 4015, 1055.02769, 386.50478, 760.91932, 282.82742, 253, 4, 333, 0, 0, 0, 30, 200, 0, 1), 
(22191, 22191, "Andreas' Captain of the Royal Guard", 0, "", 0, "LineageMonster3.heretic_priest_120p", 13, 23.2, 78, "male", "L2Monster", 40, 3163.043215, 1955.34, 9.027, 3.1824, 40, 43, 30, 21, 20, 20, 16894, 1956, 1076.93138, 410.87895, 781.26136, 300.66338, 253, 1, 333, 8208, 0, 0, 30, 180, 0, 1), 
(22192, 22192, "Andreas' Royal Guards", 0, "", 0, "LineageMonster3.heretic_privates_120p", 13, 34, 78, "male", "L2Monster", 80, 3136.290094, 1919.436, 8.976, 3.16812, 40, 43, 30, 21, 20, 20, 8875, 1069, 1055.02769, 386.50478, 760.91932, 282.82742, 253, 4, 333, 8205, 0, 0, 60, 180, 0, 1), 
(22193, 22193, "Andreas' Royal Guards", 0, "", 0, "LineageMonster3.heretic_privates_120p", 13, 34, 78, "male", "L2Monster", 80, 3136.290094, 1919.436, 8.976, 3.16812, 40, 43, 30, 21, 20, 20, 8875, 1069, 1055.02769, 386.50478, 760.91932, 282.82742, 253, 4, 333, 8205, 0, 0, 60, 180, 0, 1), 
(22194, 22194, "Penance Guard", 0, "", 0, "LineageMonster3.zombie_gateguard_slp", 40, 22, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 3681, 397, 938.20801, 354.81835, 656.66638, 259.64067, 253, 4, 333, 8217, 0, 0, 33, 120, 0, 1), 
(22195, 22195, "Ritual Sacrifice", 0, "", 0, "LineageMonster3.self_blaster", 9, 25.8, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 32635, 3520, 938.20801, 354.81835, 656.66638, 259.64067, 253, 1, 333, 0, 0, 0, 30, 200, 0, 1), 
(22196, 22196, "Velociraptor", 0, "", 0, "LineageMonster3.velociraptor", 20, 47.2, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 24830, 2715, 970.53755, 341.375, 662.75133, 249.80341, 253, 1, 333, 0, 0, 0, 33, 180, 0, 1), 
(22197, 22197, "Velociraptor", 0, "", 0, "LineageMonster3.velociraptor", 20, 47.2, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 24830, 2715, 970.53755, 341.375, 662.75133, 249.80341, 253, 1, 333, 0, 0, 0, 33, 210, 0, 1), 
(22198, 22198, "Velociraptor", 0, "", 0, "LineageMonster3.velociraptor", 20, 47.2, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 24830, 2715, 970.53755, 341.375, 662.75133, 249.80341, 253, 1, 333, 0, 0, 0, 33, 170, 0, 1), 
(22199, 22199, "Pterosaur", 0, "", 0, "LineageMonster3.rhamphorhynchus", 36, 43.7, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 24830, 2715, 970.53755, 341.375, 662.75133, 249.80341, 253, 1, 333, 0, 0, 0, 54, 210, 0, 1), 
(22200, 22200, "Ornithomimus", 0, "", 0, "LineageMonster3.ornithomimus", 15, 37.2, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 14515, 2715, 970.53755, 341.375, 662.75133, 249.80341, 253, 1, 333, 0, 0, 0, 36, 170, 0, 1), 
(22201, 22201, "Ornithomimus", 0, "", 0, "LineageMonster3.ornithomimus", 15, 37.2, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 14515, 2715, 970.53755, 341.375, 662.75133, 249.80341, 253, 1, 333, 0, 0, 0, 36, 200, 2, 1), 
(22202, 22202, "Ornithomimus", 0, "", 0, "LineageMonster3.ornithomimus", 15, 37.2, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 14515, 2715, 970.53755, 341.375, 662.75133, 249.80341, 253, 1, 333, 0, 0, 0, 36, 160, 2, 1), 
(22203, 22203, "Deinonychus", 0, "", 0, "LineageMonster3.deinonychus", 14, 14.3, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 14515, 2715, 970.53755, 341.375, 662.75133, 249.80341, 253, 1, 333, 0, 0, 0, 24, 160, 0, 1), 
(22204, 22204, "Deinonychus", 0, "", 0, "LineageMonster3.deinonychus", 14, 14.3, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 14515, 2715, 970.53755, 341.375, 662.75133, 249.80341, 253, 1, 333, 0, 0, 0, 24, 190, 2, 1), 
(22205, 22205, "Deinonychus", 0, "", 0, "LineageMonster3.deinonychus", 14, 14.3, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 14515, 2715, 970.53755, 341.375, 662.75133, 249.80341, 253, 1, 333, 0, 0, 0, 24, 160, 2, 1), 
(22208, 22208, "Pachycephalosaurus", 0, "", 0, "LineageMonster3.pachycephalosaurus", 22, 40, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 14515, 2715, 970.53755, 341.375, 662.75133, 249.80341, 253, 1, 333, 0, 0, 0, 33, 150, 0, 1), 
(22209, 22209, "Pachycephalosaurus", 0, "", 0, "LineageMonster3.pachycephalosaurus", 22, 40, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 14515, 2715, 970.53755, 341.375, 662.75133, 249.80341, 253, 1, 333, 0, 0, 0, 33, 170, 2, 1), 
(22210, 22210, "Pachycephalosaurus", 0, "", 0, "LineageMonster3.pachycephalosaurus", 22, 40, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 14515, 2715, 970.53755, 341.375, 662.75133, 249.80341, 253, 1, 333, 0, 0, 0, 33, 150, 2, 1), 
(22211, 22211, "Wild Strider", 0, "", 0, "LineageMonster3.wild_giant_strider", 32, 44.2, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 14515, 2715, 970.53755, 341.375, 662.75133, 249.80341, 253, 1, 333, 0, 0, 0, 50, 150, 0, 1), 
(22212, 22212, "Wild Strider", 0, "", 0, "LineageMonster3.wild_giant_strider", 32, 44.2, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 14515, 2715, 970.53755, 341.375, 662.75133, 249.80341, 253, 1, 333, 0, 0, 0, 50, 170, 2, 1), 
(22213, 22213, "Wild Strider", 0, "", 0, "LineageMonster3.wild_giant_strider", 32, 44.2, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 14515, 2715, 970.53755, 341.375, 662.75133, 249.80341, 253, 1, 333, 0, 0, 0, 50, 150, 2, 1), 
(22214, 22214, "Elroki", 0, "", 0, "LineageMonster3.Crokian_Officer", 25, 33, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 14515, 2715, 970.53755, 341.375, 662.75133, 249.80341, 253, 1, 333, 0, 0, 0, 60, 180, 2, 1), 
(22215, 22215, "Tyrannosaurus", 0, "", 0, "LineageMonster3.tyranosaurus", 60, 89.7, 80, "male", "L2Monster", 40, 339687.157686, 1674.8, 195.708889, 3, 40, 43, 30, 21, 20, 20, 727610, 81666, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 1, 333, 0, 0, 0, 105, 220, 0, 1), 
(22216, 22216, "Tyrannosaurus", 0, "", 0, "LineageMonster3.tyranosaurus", 60, 89.7, 80, "male", "L2Monster", 40, 339687.157686, 1674.8, 195.708889, 3, 40, 43, 30, 21, 20, 20, 727610, 81666, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 1, 333, 0, 0, 0, 105, 220, 0, 1), 
(22217, 22217, "Tyrannosaurus", 0, "", 0, "LineageMonster3.tyranosaurus", 60, 89.7, 80, "male", "L2Monster", 40, 339687.157686, 1674.8, 195.708889, 3, 40, 43, 30, 21, 20, 20, 727610, 81666, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 1, 333, 0, 0, 0, 105, 220, 0, 1), 
(22218, 22218, "Velociraptor", 0, "", 0, "LineageMonster3.velociraptor", 20, 47.2, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 24830, 2715, 970.53755, 341.375, 662.75133, 249.80341, 253, 1, 333, 0, 0, 0, 33, 200, 0, 1), 
(22219, 22219, "Ornithomimus", 0, "", 0, "LineageMonster3.ornithomimus", 15, 37.2, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 14515, 2715, 970.53755, 341.375, 662.75133, 249.80341, 253, 1, 333, 0, 0, 0, 36, 190, 2, 1), 
(22220, 22220, "Deinonychus", 0, "", 0, "LineageMonster3.deinonychus", 14, 14.3, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 14515, 2715, 970.53755, 341.375, 662.75133, 249.80341, 253, 1, 333, 0, 0, 0, 24, 180, 2, 1), 
(22221, 22221, "Pachycephalosaurus", 0, "", 0, "LineageMonster3.pachycephalosaurus", 22, 40, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 14515, 2715, 970.53755, 341.375, 662.75133, 249.80341, 253, 1, 333, 0, 0, 0, 33, 150, 2, 1), 
(22222, 22222, "Wild Strider", 0, "", 0, "LineageMonster3.wild_giant_strider", 32, 44.2, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 14515, 2715, 970.53755, 341.375, 662.75133, 249.80341, 253, 1, 333, 0, 0, 0, 50, 150, 2, 1), 
(22223, 22223, "Velociraptor", 0, "", 0, "LineageMonster3.velociraptor", 20, 47.2, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 24830, 2715, 970.53755, 341.375, 662.75133, 249.80341, 253, 1, 333, 0, 0, 0, 33, 180, 0, 1), 
(22224, 22224, "Ornithomimus", 0, "", 0, "LineageMonster3.ornithomimus", 15, 37.2, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 14515, 2715, 970.53755, 341.375, 662.75133, 249.80341, 253, 1, 333, 0, 0, 0, 36, 170, 2, 1), 
(22225, 22225, "Deinonychus", 0, "", 0, "LineageMonster3.deinonychus", 14, 14.3, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 14515, 2715, 970.53755, 341.375, 662.75133, 249.80341, 253, 1, 333, 0, 0, 0, 24, 160, 2, 1), 
(22226, 22226, "Pachycephalosaurus", 0, "", 0, "LineageMonster3.pachycephalosaurus", 22, 40, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 14515, 2715, 970.53755, 341.375, 662.75133, 249.80341, 253, 1, 333, 0, 0, 0, 33, 140, 0, 1), 
(22227, 22227, "Wild Strider", 0, "", 0, "LineageMonster3.wild_giant_strider", 32, 44.2, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 14515, 2715, 970.53755, 341.375, 662.75133, 249.80341, 253, 1, 333, 0, 0, 0, 50, 140, 0, 1), 
(22228, 22228, "Grey Elpy", 0, "", 0, "LineageMonster.elpy", 5, 4.5, 1, "male", "L2Monster", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 35, 2, 8.47458, 44.44444, 5.78704, 32.52252, 253, 4, 333, 0, 0, 0, 50, 80, 1, 1), 
(22229, 22229, "Young Grey Keltir", 0, "", 0, "LineageMonster.keltir", 9.5, 10, 1, "male", "L2Monster", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 35, 2, 8.47458, 44.44444, 5.78704, 32.52252, 253, 4, 333, 0, 0, 0, 23, 110, 1, 1), 
(22230, 22230, "Grey Keltir", 0, "", 0, "LineageMonster.keltir", 9.5, 10, 2, "male", "L2Monster", 40, 48.09168, 47.28, 2, 0.9, 40, 43, 30, 21, 20, 20, 70, 2, 9.32203, 46.15385, 6.36574, 33.77338, 253, 4, 333, 0, 0, 0, 23, 110, 1, 1), 
(22231, 22231, "Dominant Grey Keltir", 0, "", 0, "LineageMonster.keltir", 9.5, 10, 3, "male", "L2Monster", 40, 57.54874, 54.64, 2, 0.9, 40, 43, 30, 21, 20, 20, 106, 2, 10.24492, 47.91652, 6.99595, 35.06323, 253, 4, 333, 0, 0, 0, 23, 110, 1, 1), 
(22232, 22232, "Black Wolf", 0, "", 0, "LineageMonster.wolf", 13, 9, 4, "male", "L2Monster", 40, 68.20985, 62.08, 2, 0.9, 40, 43, 30, 21, 20, 20, 141, 3, 11.24892, 49.73343, 7.68155, 36.39277, 253, 4, 333, 0, 0, 0, 24, 110, 1, 1), 
(22233, 22233, "Dominant Black Wolf", 0, "", 0, "LineageMonster.wolf_bi", 13, 10.8, 5, "male", "L2Monster", 40, 80.17319, 69.6, 2, 0.9, 40, 43, 30, 21, 20, 20, 176, 4, 12.34006, 51.60553, 8.42666, 37.76269, 253, 4, 333, 0, 0, 0, 24, 110, 1, 1), 
(22234, 22234, "Green Goblin", 0, "", 0, "LineageMonster.goblin", 10, 16.5, 6, "male", "L2Monster", 40, 93.54158, 77.2, 2, 0.9, 40, 43, 30, 21, 20, 20, 211, 5, 13.52471, 53.53373, 9.23562, 39.17366, 253, 1, 333, 4, 0, 0, 40, 110, 1, 1), 
(22235, 22235, "Mountain Werewolf", 0, "", 0, "LineageMonster.werewolf", 10, 26, 7, "male", "L2Monster", 40, 108.42254, 84.88, 2, 0.9, 40, 43, 30, 21, 20, 20, 248, 8, 14.80956, 55.51894, 10.11301, 40.62635, 253, 1, 333, 5, 0, 0, 50, 120, 1, 1), 
(22236, 22236, "Muertos Archer", 0, "", 0, "LineageMonster4.Mostro_Gunner", 15, 24.5, 8, "male", "L2Monster", 700, 124.92828, 92.64, 2, 0.9, 40, 43, 30, 21, 20, 20, 281, 9, 16.20165, 57.56203, 11.06363, 42.1214, 253, 10, 333, 10128, 0, 0, 36, 110, 1, 1), 
(22237, 22237, "Mountain Fungus", 0, "", 0, "LineageMonster.walking_fungus", 15, 22.5, 9, "male", "L2Monster", 40, 143.17564, 100.48, 2, 0.9, 40, 43, 30, 21, 20, 20, 319, 10, 17.70841, 59.66387, 12.09255, 43.65943, 253, 4, 333, 0, 0, 0, 70, 110, 1, 1), 
(22238, 22238, "Mountain Werewolf Chief", 0, "", 0, "LineageMonster.werewolf_bi", 11, 29.7, 10, "male", "L2Monster", 40, 163.28607, 108.4, 2, 0.9, 40, 43, 30, 21, 20, 20, 354, 12, 19.33758, 61.82527, 13.20506, 45.24105, 253, 1, 333, 5, 0, 0, 50, 120, 1, 1), 
(22239, 22239, "Muertos Guard", 0, "", 0, "LineageMonster4.Mostro_Fighter", 15.5, 22.5, 11, "male", "L2Monster", 40, 185.38552, 116.4, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 387, 14, 21.0973, 64.04702, 14.40672, 46.86683, 253, 4, 333, 0, 0, 0, 36, 120, 1, 1), 
(22240, 22240, "Muertos Scout", 0, "", 0, "LineageMonster4.Mostro_Fighter", 15.5, 22.5, 12, "male", "L2Monster", 40, 199.62322, 124.48, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 423, 15, 22.99606, 66.32989, 15.70333, 48.53733, 253, 4, 333, 0, 0, 0, 36, 120, 1, 1), 
(22241, 22241, "Colossus", 0, "", 0, "LineageMonster.stone_golem", 20, 31, 13, "male", "L2Monster", 40, 214.61578, 132.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 566, 22, 25.04271, 68.67458, 17.10092, 50.25308, 253, 1, 333, 0, 0, 0, 23, 23, 1, 1), 
(22242, 22242, "Muertos Warrior", 0, "", 0, "LineageMonster4.Mostro_Fighter", 15.5, 22.5, 14, "male", "L2Monster", 40, 230.38548, 140.88, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 490, 19, 27.24646, 71.08179, 18.6058, 52.01457, 253, 4, 333, 0, 0, 0, 36, 110, 1, 1), 
(22243, 22243, "Muertos Captain", 0, "", 0, "LineageMonster4.Mostro_Fighter", 15.5, 22.5, 15, "male", "L2Monster", 40, 246.95422, 149.2, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 528, 21, 29.61691, 73.55216, 20.22451, 53.82228, 253, 4, 333, 0, 0, 0, 36, 110, 1, 1), 
(22244, 22244, "Crimson Spider", 0, "", 0, "LineageMonster.giant_spider_05te", 26, 25.5, 16, "male", "L2Monster", 40, 264.34345, 157.6, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 564, 22, 32.16396, 76.08628, 21.96382, 55.67663, 253, 4, 333, 0, 0, 0, 72, 130, 1, 1), 
(22245, 22245, "Muertos Lieutenant", 0, "", 0, "LineageMonster4.Mostro_Fighter", 15.5, 22.5, 17, "male", "L2Monster", 40, 282.57403, 166.08, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 599, 25, 34.8979, 78.68469, 23.83074, 57.57804, 253, 4, 333, 0, 0, 0, 36, 120, 1, 1), 
(22246, 22246, "Muertos Commander", 0, "", 0, "LineageMonster4.Mostro_Fighter", 15.5, 22.5, 18, "male", "L2Monster", 40, 301.66622, 174.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 633, 27, 37.82932, 81.34791, 25.83252, 59.52687, 253, 4, 333, 0, 0, 0, 36, 120, 1, 1), 
(22247, 22247, "Grotto Golem", 0, "", 0, "LineageMonster.stone_golem", 20, 31, 15, "male", "L2Monster", 40, 246.95422, 149.2, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 1108, 43, 29.61691, 73.55216, 20.22451, 53.82228, 253, 1, 333, 0, 0, 0, 23, 23, 1, 1), 
(22248, 22248, "Shady Muertos", 0, "", 0, "LineageMonster4.Mostro_Fighter", 15.5, 22.5, 15, "male", "L2Monster", 40, 246.95422, 149.2, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 821, 31, 29.61691, 73.55216, 20.22451, 53.82228, 253, 4, 333, 0, 0, 0, 36, 110, 0, 1), 
(22249, 22249, "Shady Muertos Guard", 0, "", 0, "LineageMonster4.Mostro_Gunner", 15, 24.5, 16, "male", "L2Monster", 700, 264.34345, 157.6, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 877, 33, 32.16396, 76.08628, 21.96382, 55.67663, 253, 10, 333, 10128, 0, 0, 36, 110, 1, 1), 
(22250, 22250, "Grotto Leopard", 0, "", 0, "LineageMonster.onyx_beast", 14, 14.5, 16, "male", "L2Monster", 40, 264.34345, 157.6, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 877, 33, 32.16396, 76.08628, 21.96382, 55.67663, 253, 1, 333, 0, 0, 0, 30, 120, 1, 1), 
(22251, 22251, "Shady Muertos Captain", 0, "", 0, "LineageMonster4.Mostro_Fighter", 15.5, 22.5, 17, "male", "L2Monster", 40, 282.57403, 166.08, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 928, 37, 34.8979, 78.68469, 23.83074, 57.57804, 253, 4, 333, 0, 0, 0, 36, 110, 1, 1), 
(22252, 22252, "Grotto Grizzly", 0, "", 0, "LineageMonster.grizzly", 21, 40, 17, "male", "L2Monster", 40, 282.57403, 166.08, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 925, 36, 34.8979, 78.68469, 23.83074, 57.57804, 253, 1, 333, 0, 0, 0, 40, 110, 1, 1), 
(22253, 22253, "Shady Muertos Warrior", 0, "", 0, "LineageMonster4.Mostro_Fighter", 15.5, 22.5, 18, "male", "L2Monster", 40, 301.66622, 174.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 981, 40, 37.82932, 81.34791, 25.83252, 59.52687, 253, 4, 333, 0, 0, 0, 36, 110, 1, 1), 
(22254, 22254, "Shady Muertos Archer", 0, "", 0, "LineageMonster4.Mostro_Gunner", 15, 24.5, 18, "male", "L2Monster", 700, 301.66622, 174.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 983, 40, 37.82932, 81.34791, 25.83252, 59.52687, 253, 10, 333, 10128, 0, 0, 36, 110, 1, 1), 
(22255, 22255, "Shady Muertos Commander", 0, "", 0, "LineageMonster4.Mostro_Fighter", 15.5, 22.5, 19, "male", "L2Monster", 40, 321.63954, 183.28, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 1039, 44, 40.96915, 84.07638, 27.97662, 61.52345, 253, 4, 333, 0, 0, 0, 36, 110, 1, 1), 
(22256, 22256, "Shady Muertos Wizard", 0, "", 0, "LineageMonster4.Mostro_Fighter", 15.5, 22.5, 19, "male", "L2Monster", 40, 321.63954, 183.28, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 1145, 48, 40.96915, 84.07638, 27.97662, 61.52345, 253, 4, 333, 0, 0, 0, 36, 110, 1, 1), 
(22257, 22257, "Island Guardian", 0, "", 0, "LineageMonster.light_worm_250p", 12, 45, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 12616, 1380, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 60, 160, 1, 1), 
(22258, 22258, "White Sand Mirage", 0, "", 0, "LineageMonster.undine", 12, 27, 79, "female", "L2Monster", 40, 3127.824593, 1641, 8.5, 3, 40, 43, 30, 21, 20, 20, 12941, 1434, 929.93081, 337.07008, 635.0222, 246.65326, 253, 4, 333, 0, 0, 0, 60, 160, 1, 1), 
(22259, 22259, "Muddy Coral", 0, "", 0, "LineageMonster.theeder_120p", 13, 38, 80, "male", "L2Monster", 80, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 14100, 1582, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 192, 0, 0, 80, 160, 1, 1), 
(22260, 22260, "Kleopora", 0, "", 0, "LineageMonster.gargoyle_02te", 16, 50, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 11681, 1311, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 140, 170, 1, 1), 
(22261, 22261, "Seychelles", 0, "", 0, "LineageMonster.water_giant_120p", 15, 52, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 12333, 1366, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 5132, 0, 0, 75, 160, 1, 1), 
(22262, 22262, "Naiad", 0, "", 0, "LineageMonster4.tears", 20, 27.5, 81, "female", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 12486, 1383, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 9638, 9638, 0, 60, 180, 1, 1), 
(22263, 22263, "Sonneratia", 0, "", 0, "LineageMonster.onyx_beast_bi", 14, 18.7, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 14725, 1610, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 30, 180, 1, 1), 
(22264, 22264, "Castalia", 0, "", 0, "LineageMonster4.tears_d", 20, 27.5, 82, "female", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 13089, 1431, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 9638, 9638, 0, 60, 180, 1, 1), 
(22265, 22265, "Chrysocolla", 0, "", 0, "LineageMonster4.Crystal_Golem", 34, 47, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 15492, 1673, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 54, 170, 1, 1), 
(22266, 22266, "Pythia", 0, "", 0, "LineageMonster4.tears", 20, 27.5, 83, "female", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 13801, 1490, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 9638, 9638, 0, 60, 180, 1, 1), 
(22267, 22267, "Dark Water Dragon", 0, "", 0, "LineageMonster3.antaras_ex_b", 42, 34.5, 83, "male", "L2Monster", 40, 65569.257083, 1777.4, 111.355378, 3, 40, 43, 30, 21, 20, 20, 158536, 17121, 5589.57219, 566.1783, 3816.95322, 621.45708, 253, 4, 333, 0, 0, 0, 200, 200, 0, 1), 
(22268, 22268, "Shade", 0, "", 0, "LineageMonster4.eyeless", 36, 43.5, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 10249, 1120, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 60, 200, 0, 1), 
(22269, 22269, "Shade", 0, "", 0, "LineageMonster4.eyeless", 36, 43.5, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 10351, 1131, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 60, 200, 0, 1), 
(22270, 22270, "Water Dragon Detractor", 0, "", 0, "LineageMonster4.eyeless", 36, 43.5, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 11436, 1250, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 60, 200, 0, 1), 
(22271, 22271, "Water Dragon Detractor", 0, "", 0, "LineageMonster4.eyeless", 36, 43.5, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 11436, 1250, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 60, 200, 0, 1), 
(22272, 22272, "Beleth's Minion", 0, "", 0, "LineageMonster.vale_master", 12, 40, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 16531, 1728, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 210, 0, 0, 70, 170, 0, 1), 
(22273, 22273, "Beleth's Minion", 0, "", 0, "LineageMonster.silhouette", 8, 23, 82, "female", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 15997, 1670, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), 
(22274, 22274, "Beleth's Minion", 0, "", 0, "LineageMonster.shadeless", 7, 33, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 16319, 1705, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 48, 170, 0, 1), 
(22275, 22275, "Gatekeeper Lohan", 0, "", 0, "LineageMonster3.Jungle_Bleeze", 60, 47, 81, "female", "L2Monster", 40, 33003.982801, 1708.8, 113.41926, 3, 40, 43, 30, 21, 20, 20, 96272, 10663, 5770.14557, 552.97803, 3940.26143, 606.96799, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(22276, 22276, "Gatekeeper of the Square", 0, "", 0, "LineageMonster4.Crystal_Golem", 34, 47, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 28314, 2999, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 0, 0, 0, 54, 170, 0, 1), 
(22277, 22277, "Gatekeeper Provo", 0, "", 0, "LineageMonster2.lava_golem", 38, 45, 81, "male", "L2Monster", 40, 33003.982801, 1708.8, 113.41926, 3, 40, 43, 30, 21, 20, 20, 96272, 10663, 5770.14557, 552.97803, 3940.26143, 606.96799, 253, 4, 333, 0, 0, 0, 13, 80, 0, 1), 
(22278, 22278, "Gatekeeper of Fire", 0, "", 0, "LineageMonster4.Crystal_Golem", 34, 47, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 28314, 2999, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 0, 0, 0, 54, 170, 0, 1), 
(22279, 22279, "Chromatic Detainee", 0, "", 0, "LineageMonster3.Crokian_Officer", 25, 33, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 27781, 2932, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(22280, 22280, "Rodo Knight", 0, "", 0, "LineageMonster4.Crystal_Golem", 34, 47, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 15937, 1663, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 54, 170, 0, 1), 
(22281, 22281, "Plaza Caiman", 0, "", 0, "LineageMonster3.Crokian_Officer", 25, 33, 82, "male", "L2Monster", 40, 10982.014156, 1743, 112.55804, 3, 40, 43, 30, 21, 20, 20, 13121, 1370, 6734.49668, 559.63963, 4598.7882, 614.28, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(22282, 22282, "Chromatic Detainee", 0, "", 0, "LineageMonster3.Crokian_Officer", 25, 33, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 27781, 2932, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(22283, 22283, "Emerald Alligar", 0, "", 0, "LineageMonster3.Crokian_Officer", 25, 33, 82, "male", "L2Monster", 40, 10982.014156, 1743, 112.55804, 3, 40, 43, 30, 21, 20, 20, 13121, 1370, 6734.49668, 559.63963, 4598.7882, 614.28, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(22284, 22284, "Chromatic Detainee", 0, "", 0, "LineageMonster.blade_stakato", 15, 36, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 26651, 2807, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 0, 0, 0, 25, 170, 0, 1), 
(22285, 22285, "Chromatic Detainee", 0, "", 0, "LineageMonster.blade_stakato", 15, 36, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 28709, 3035, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 0, 0, 0, 25, 170, 0, 1), 
(22286, 22286, "Plaza Gaviel", 0, "", 0, "LineageMonster3.Crokian_Officer", 25, 33, 82, "male", "L2Monster", 40, 10982.014156, 1743, 112.55804, 3, 40, 43, 30, 21, 20, 20, 13121, 1370, 6734.49668, 559.63963, 4598.7882, 614.28, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(22287, 22287, "Crystalline Unicorn", 0, "", 0, "LineageMonster.unicorn", 14, 30, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 34503, 3583, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 46, 170, 0, 1), 
(22288, 22288, "Emerald Boar", 0, "", 0, "LineageMonster.giant_wild_hog", 35, 27, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 37724, 3936, 1055.28566, 349.77477, 720.6233, 255.95, 253, 1, 333, 0, 0, 0, 35, 130, 0, 1), 
(22289, 22289, "Plaza Helm", 0, "", 0, "LineageMonster2.ketra_warbeast", 20, 33.5, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 36334, 3792, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 26, 170, 0, 1), 
(22290, 22290, "Terod's Minion", 0, "", 0, "LineageMonster4.eyeless_080p", 34, 35, 82, "male", "L2Monster", 40, 32946.042468, 1743, 112.55804, 3, 40, 43, 30, 21, 20, 20, 101261, 11072, 5793.32235, 559.63963, 3956.08814, 614.28, 253, 4, 333, 0, 0, 0, 60, 200, 0, 1), 
(22291, 22291, "Weylin's Minion", 0, "", 0, "LineageMonster4.eyeless_080p", 34, 35, 82, "male", "L2Monster", 40, 32946.042468, 1743, 112.55804, 3, 40, 43, 30, 21, 20, 20, 95185, 10408, 5793.32235, 559.63963, 3956.08814, 614.28, 253, 4, 333, 0, 0, 0, 60, 210, 0, 1), 
(22292, 22292, "Tourmaline", 0, "", 0, "LineageMonster4.Crystal_Golem", 34, 47, 82, "male", "L2Monster", 40, 10982.014156, 1743, 112.55804, 3, 40, 43, 30, 21, 20, 20, 34122, 3731, 6734.49668, 559.63963, 4598.7882, 614.28, 253, 4, 333, 0, 0, 0, 54, 170, 0, 1), 
(22293, 22293, "Spinel", 0, "", 0, "LineageMonster.stone_golem", 20, 31, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 30840, 3224, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 23, 50, 0, 1), 
(22294, 22294, "Fire Opal", 0, "", 0, "LineageMonster4.Crystal_Golem", 34, 47, 82, "male", "L2Monster", 40, 10982.014156, 1743, 112.55804, 3, 40, 43, 30, 21, 20, 20, 34122, 3731, 6734.49668, 559.63963, 4598.7882, 614.28, 253, 4, 333, 0, 0, 0, 54, 170, 0, 1), 
(22295, 22295, "Reef Golem", 0, "", 0, "LineageMonster4.Crystal_Golem", 34, 47, 82, "male", "L2Monster", 40, 32946.042468, 1743, 112.55804, 3, 40, 43, 30, 21, 20, 20, 99513, 10881, 5793.32235, 559.63963, 3956.08814, 614.28, 253, 4, 333, 0, 0, 0, 54, 170, 0, 1), 
(22296, 22296, "Reef Golem", 0, "", 0, "LineageMonster4.Crystal_Golem", 34, 47, 82, "male", "L2Monster", 40, 32946.042468, 1743, 112.55804, 3, 40, 43, 30, 21, 20, 20, 104675, 11446, 5793.32235, 559.63963, 3956.08814, 614.28, 253, 4, 333, 0, 0, 0, 54, 170, 0, 1), 
(22297, 22297, "Reef Golem", 0, "", 0, "LineageMonster4.Crystal_Golem", 34, 47, 82, "male", "L2Monster", 40, 32946.042468, 1743, 112.55804, 3, 40, 43, 30, 21, 20, 20, 103023, 11265, 5793.32235, 559.63963, 3956.08814, 614.28, 253, 4, 333, 0, 0, 0, 54, 170, 0, 1), 
(22298, 22298, "Weylin", 0, "", 0, "LineageMonster.banshee_30_bi", 11, 30, 82, "female", "L2Monster", 40, 65802.611804, 1743, 112.4052, 3, 40, 43, 30, 21, 20, 20, 164166, 17951, 5571.87244, 559.63963, 3804.86656, 614.28, 253, 4, 333, 3939, 0, 0, 80, 200, 0, 1), 
(22299, 22299, "Dolph", 0, "", 0, "LineageMonster.pan_100_bi", 42, 73, 82, "male", "L2Monster", 80, 65802.611804, 1743, 112.4052, 3, 40, 43, 30, 21, 20, 20, 189054, 20673, 5571.87244, 559.63963, 3804.86656, 614.28, 253, 4, 333, 213, 0, 0, 45, 170, 0, 1), 
(22300, 22300, "Dolph's Minion", 0, "", 0, "LineageMonster4.eyeless_080p", 34, 35, 82, "male", "L2Monster", 40, 10982.014156, 1743, 112.55804, 3, 40, 43, 30, 21, 20, 20, 34451, 3767, 6734.49668, 559.63963, 4598.7882, 614.28, 253, 4, 333, 0, 0, 0, 60, 210, 0, 1), 
(22301, 22301, "Terod", 0, "", 0, "LineageMonster.doll_master_20_bi", 24, 50.4, 82, "male", "L2Monster", 40, 65802.611804, 1743, 112.4052, 3, 40, 43, 30, 21, 20, 20, 190311, 20810, 5571.87244, 559.63963, 3804.86656, 614.28, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), 
(22302, 22302, "Darnel's Guardian", 0, "", 0, "LineageMonster.pixy_bi", 10, 54, 82, "female", "L2Monster", 40, 56403.194323, 1743, 192.697894, 3, 40, 43, 30, 21, 20, 20, 182298, 19934, 9266.31774, 559.63963, 6327.69377, 614.28, 253, 4, 333, 0, 0, 0, 80, 150, 0, 1), 
(22303, 22303, "Guardian of the Square", 0, "", 0, "LineageMonster3.ice_fairy", 16, 35.6, 82, "female", "L2Monster", 40, 56403.194323, 1743, 192.697894, 3, 40, 43, 30, 21, 20, 20, 190116, 20789, 9266.31774, 559.63963, 6327.69377, 614.28, 253, 4, 333, 0, 0, 0, 30, 250, 0, 1), 
(22304, 22304, "Guardian of the Emerald", 0, "", 0, "LineageMonster.blue_eye_150p", 13, 26, 82, "male", "L2Monster", 40, 56403.194323, 1743, 192.697894, 3, 40, 43, 30, 21, 20, 20, 190922, 20877, 9266.31774, 559.63963, 6327.69377, 614.28, 253, 4, 333, 0, 0, 0, 35, 200, 0, 1), 
(22305, 22305, "Kechi's Captain", 0, "", 0, "LineageMonster.field_stalker_110p", 16, 36, 82, "male", "L2Monster", 40, 10982.014156, 1743, 112.55804, 3, 40, 43, 30, 21, 20, 20, 34650, 3789, 6734.49668, 559.63963, 4598.7882, 614.28, 253, 4, 333, 0, 0, 0, 70, 150, 0, 1), 
(22306, 22306, "Kechi's Captain", 0, "", 0, "LineageMonster2.lava_golem", 38, 45, 82, "male", "L2Monster", 40, 10982.014156, 1743, 112.55804, 3, 40, 43, 30, 21, 20, 20, 88071, 9156, 6734.49668, 559.63963, 4598.7882, 614.28, 253, 4, 333, 0, 0, 0, 13, 60, 0, 1), 
(22307, 22307, "Kechi's Captain", 0, "", 0, "LineageMonster3.Steel_Trapper", 35, 46.38, 82, "male", "L2Monster", 40, 32946.042468, 1743, 112.55804, 3, 40, 43, 30, 21, 20, 20, 190926, 19906, 5793.32235, 559.63963, 3956.08814, 614.28, 253, 1, 333, 0, 0, 0, 60, 200, 0, 1), 
(22308, 22308, "Kechi's Guard", 0, "", 0, "LineageMonster.mana_vampire_120p", 11, 27, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 30391, 3173, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 90, 110, 0, 1), 
(22309, 22309, "Kechi's Guard", 0, "", 0, "LineageMonster.blade_stakato_soldier", 15, 38, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 42319, 4434, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 148, 0, 0, 25, 170, 0, 1), 
(22310, 22310, "Kechi's Guard", 0, "", 0, "LineageMonster3.portrait_spirit_150p", 23, 52, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 39903, 4170, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 30, 200, 0, 1), 
(22311, 22311, "Parme's Guardian", 0, "", 0, "LineageMonster.riba", 25, 72, 83, "female", "L2Monster", 40, 32829.283195, 1777.4, 111.507051, 3, 40, 43, 30, 21, 20, 20, 180237, 18511, 5815.28895, 566.1783, 3971.08851, 621.45708, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), 
(22312, 22312, "Fafurion's Henchman", 0, "", 0, "LineageMonster.raikel", 37, 64, 83, "male", "L2Monster", 40, 65569.257083, 1777.4, 111.355378, 3, 40, 43, 30, 21, 20, 20, 190928, 20619, 5589.57219, 566.1783, 3816.95322, 621.45708, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), 
(22313, 22313, "Garden Stakato", 0, "", 0, "LineageMonster.blade_stakato_drone", 15, 39, 83, "male", "L2Monster", 40, 10943.094398, 1777.4, 111.507051, 3, 40, 43, 30, 21, 20, 20, 60929, 6262, 6774.50812, 566.1783, 4626.11085, 621.45708, 253, 4, 333, 134, 0, 0, 25, 180, 0, 1), 
(22314, 22314, "Garden Poison Moth", 0, "", 0, "LineageMonster4.Anthias", 20, 41, 83, "male", "L2Monster", 40, 10943.094398, 1777.4, 111.507051, 3, 40, 43, 30, 21, 20, 20, 59615, 6120, 6774.50812, 566.1783, 4626.11085, 621.45708, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), 
(22315, 22315, "Garden Guard", 0, "", 0, "LineageMonster.water_giant", 13, 44, 83, "male", "L2Monster", 80, 10943.094398, 1777.4, 111.507051, 3, 40, 43, 30, 21, 20, 20, 34896, 3768, 6774.50812, 566.1783, 4626.11085, 621.45708, 253, 4, 333, 5132, 0, 0, 35, 160, 0, 1), 
(22316, 22316, "Garden Guardian Tree", 0, "", 0, "LineageMonster3.Jungle_Bleeze", 60, 47, 83, "female", "L2Monster", 40, 32829.283195, 1777.4, 111.507051, 3, 40, 43, 30, 21, 20, 20, 100984, 10905, 5815.28895, 566.1783, 3971.08851, 621.45708, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), 
(22317, 22317, "Garden Castalia", 0, "", 0, "LineageMonster4.tears_d", 20, 27.5, 83, "female", "L2Monster", 40, 10943.094398, 1777.4, 111.507051, 3, 40, 43, 30, 21, 20, 20, 14993, 1556, 6774.50812, 566.1783, 4626.11085, 621.45708, 253, 4, 333, 9639, 9639, 0, 60, 180, 0, 1), 
(22320, 22320, "Junior Watchman", 0, "", 0, "LineageMonster4.eyeless", 36, 43.5, 81, "male", "L2Monster", 40, 33003.982801, 1708.8, 113.41926, 3, 40, 43, 30, 21, 20, 20, 163197, 17624, 5883.70412, 572.83923, 4065.07552, 628.76834, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), 
(22321, 22321, "Junior Summoner", 0, "", 0, "LineageMonster2.vampire_witch", 6, 21.5, 81, "female", "L2Monster", 40, 33003.982801, 1708.8, 113.41926, 3, 40, 43, 30, 21, 20, 20, 155632, 16807, 5883.70412, 572.83923, 4065.07552, 628.76834, 253, 4, 333, 946, 0, 0, 64, 180, 0, 1), 
(22322, 22322, "Subjugated Native", 0, "", 0, "LineageNPC.a_common_peopleC_Mhuman", 10, 24, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 11381, 1207, 1112.35801, 358.02452, 768.53275, 261.98681, 253, 4, 333, 8219, 0, 0, 50, 100, 0, 1), 
(22323, 22323, "Charmed Native", 0, "", 0, "LineageNPC.a_common_peopleC_Mhuman", 10, 24, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 11746, 1247, 1112.35801, 358.02452, 768.53275, 261.98681, 253, 1, 333, 8528, 0, 0, 50, 100, 0, 1), 
(22324, 22324, "Blind Huntsman", 0, "", 0, "LineageMonster4.eyeless_080p", 34, 35, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 28644, 2983, 1112.35801, 358.02452, 768.53275, 261.98681, 253, 4, 333, 0, 0, 0, 60, 200, 0, 1), 
(22325, 22325, "Blind Watchman", 0, "", 0, "LineageMonster4.eyeless_080p", 34, 35, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 25716, 2667, 1112.35801, 358.02452, 768.53275, 261.98681, 253, 4, 333, 0, 0, 0, 60, 200, 0, 1), 
(22326, 22326, "Hellinark", 0, "Naia's Guardian", 0, "LineageMonster.karik", 25, 90, 81, "male", "L2Monster", 40, 338766.602168, 1708.8, 194.030407, 3, 40, 43, 30, 21, 20, 20, 2629658, 267913, 7957.47326, 582.69205, 5529.81543, 639.58314, 253, 4, 333, 0, 0, 0, 37, 200, 0, 1), 
(22327, 22327, "Arcane Scout", 0, "", 0, "LineageMonster.dark_mahum", 13, 26, 81, "male", "L2Monster", 40, 65918.445622, 1708.8, 113.265441, 3, 40, 43, 30, 21, 20, 20, 320392, 34601, 5655.33186, 572.83923, 3907.29218, 628.76834, 253, 4, 333, 234, 0, 0, 50, 160, 0, 1), 
(22328, 22328, "Arcane Guardian", 0, "", 0, "LineageMonster3.Succubus_Raid", 12, 30.7, 81, "female", "L2Monster", 40, 65918.445622, 1708.8, 113.265441, 3, 40, 43, 30, 21, 20, 20, 134976, 13992, 5655.33186, 572.83923, 3907.29218, 628.76834, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(22329, 22329, "Arcane Watchman", 0, "", 0, "LineageMonster3.Death_Blader_Raid", 15, 32.5, 81, "male", "L2Monster", 40, 65918.445622, 1708.8, 113.265441, 3, 40, 43, 30, 21, 20, 20, 331002, 35747, 5655.33186, 572.83923, 3907.29218, 628.76834, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(22330, 22330, "Remnant Wraith", 0, "", 0, "LineageMonster3.zombie_laborer", 11, 24.6, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 17815, 1923, 1112.35801, 358.02452, 768.53275, 261.98681, 253, 4, 333, 123, 0, 0, 36, 180, 0, 1), 
(22334, 22334, "Sand Scorpion", 0, "", 0, "LineageMonster2.sandScorpion", 28, 66, 81, "male", "L2Monster", 40, 33003.982801, 1708.8, 113.41926, 3, 40, 43, 30, 21, 20, 20, 147904, 15780, 5940.39947, 582.69205, 4128.10846, 639.58314, 253, 4, 333, 0, 0, 0, 37, 170, 0, 1), 
(22335, 22335, "Desert Scorpion", 0, "", 0, "LineageMonster2.sandScorpion", 28, 66, 81, "male", "L2Monster", 40, 33003.982801, 1708.8, 113.41926, 3, 40, 43, 30, 21, 20, 20, 151636, 16178, 5940.39947, 582.69205, 4128.10846, 639.58314, 253, 4, 333, 0, 0, 0, 37, 170, 0, 1), 
(22336, 22336, "Sand Devil", 0, "", 0, "LineageMonster2.imperial_warlord_zombie_sand", 7, 30, 81, "male", "L2Monster", 40, 11001.3276, 1708.8, 113.41926, 3, 40, 43, 30, 21, 20, 20, 50320, 5368, 6935.07781, 582.69205, 4819.33135, 639.58314, 253, 4, 333, 0, 0, 0, 39, 150, 0, 1), 
(22337, 22337, "Desiccator", 0, "", 0, "LineageMonster.skeleton_knight_sand", 10, 25, 81, "male", "L2Monster", 40, 11001.3276, 1708.8, 113.41926, 3, 40, 43, 30, 21, 20, 20, 47148, 5030, 6935.07781, 582.69205, 4819.33135, 639.58314, 253, 4, 333, 0, 0, 0, 40, 160, 0, 1), 
(22339, 22339, "Wandering Caravan", 0, "", 0, "LineageMonster4.Caravan", 33, 58.5, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 18810, 2006, 1164.93244, 364.18253, 809.53604, 266.49298, 253, 4, 333, 0, 0, 0, 56, 160, 0, 1), 
(22340, 22340, "Sandstorm", 0, "", 0, "LineageMonster4.SandTourbillon", 10, 28, 81, "male", "L2Monster", 40, 33003.982801, 1708.8, 113.41926, 3, 40, 43, 30, 21, 20, 20, 146852, 15668, 5940.39947, 582.69205, 4128.10846, 639.58314, 253, 1, 333, 0, 0, 0, 180, 250, 0, 1), 
(22341, 22341, "Keltas", 0, "", 0, "LineageMonster3.Vampire_Troop_Leader", 19, 35, 81, "male", "L2Monster", 40, 197755.336867, 1708.8, 113.265441, 3, 40, 43, 30, 21, 20, 20, 449479, 47956, 4590.3721, 582.69205, 3189.94606, 639.58314, 253, 4, 333, 8686, 0, 0, 60, 160, 0, 1), 
(22342, 22342, "Darion's Enforcer", 0, "", 0, "LineageMonster.silhouette", 8, 23, 81, "female", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 12425, 1325, 1164.93244, 364.18253, 809.53604, 266.49298, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(22343, 22343, "Darion's Executioner", 0, "", 0, "LineageMonster.shadeless", 7, 33, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 9998, 1066, 1164.93244, 364.18253, 809.53604, 266.49298, 253, 4, 333, 0, 0, 0, 48, 190, 0, 1), 
(22344, 22344, "Quarry Supervisor", 0, "", 0, "LineageMonster2.vampire_warrior", 9, 31.5, 81, "male", "L2Monster", 40, 33003.982801, 1708.8, 113.41926, 3, 40, 43, 30, 21, 20, 20, 70970, 7317, 5940.39947, 582.69205, 4128.10846, 639.58314, 253, 4, 333, 6723, 0, 0, 43, 165, 0, 1), 
(22345, 22345, "Quarry Bowman", 0, "", 0, "LineageMonster2.vampire_wizard", 5.5, 28, 81, "female", "L2Monster", 40, 11001.3276, 1708.8, 113.41926, 3, 40, 43, 30, 21, 20, 20, 22390, 2303, 6935.07781, 582.69205, 4819.33135, 639.58314, 253, 1, 333, 99, 0, 0, 46, 165, 0, 1), 
(22346, 22346, "Quarry Foreman", 0, "", 0, "LineageMonster3.Vampire_Troop_Leader_120p", 22, 43, 81, "male", "L2Monster", 40, 65918.445622, 1708.8, 113.265441, 3, 40, 43, 30, 21, 20, 20, 274810, 29320, 5706.3176, 582.69205, 3965.44005, 639.58314, 253, 4, 333, 8686, 0, 0, 60, 165, 0, 1), 
(22347, 22347, "Quarry Patrolman", 0, "", 0, "LineageMonster4.eyeless_080p", 34, 35, 81, "male", "L2Monster", 40, 33003.982801, 1708.8, 113.41926, 3, 40, 43, 30, 21, 20, 20, 150397, 16046, 5940.39947, 582.69205, 4128.10846, 639.58314, 253, 4, 333, 0, 0, 0, 60, 210, 0, 1), 
(22349, 22349, "Chimera of Earth", 0, "", 0, "LineageMonster4.Chimera", 35, 36, 81, "male", "L2Monster", 40, 65918.445622, 1708.8, 113.265441, 3, 40, 43, 30, 21, 20, 20, 282094, 30097, 5706.3176, 582.69205, 3965.44005, 639.58314, 253, 4, 333, 0, 0, 0, 36, 170, 0, 1), 
(22350, 22350, "Chimera of Darkness", 0, "", 0, "LineageMonster4.Chimera", 35, 36, 81, "male", "L2Monster", 40, 65918.445622, 1708.8, 113.265441, 3, 40, 43, 30, 21, 20, 20, 293014, 31262, 5706.3176, 582.69205, 3965.44005, 639.58314, 253, 4, 333, 0, 0, 0, 36, 170, 0, 1), 
(22351, 22351, "Chimera of Wind", 0, "", 0, "LineageMonster4.Chimera", 35, 36, 81, "male", "L2Monster", 40, 65918.445622, 1708.8, 113.265441, 3, 40, 43, 30, 21, 20, 20, 293014, 31262, 5706.3176, 582.69205, 3965.44005, 639.58314, 253, 4, 333, 0, 0, 0, 36, 170, 0, 1), 
(22352, 22352, "Chimera of Fire", 0, "", 0, "LineageMonster4.Chimera", 35, 36, 81, "male", "L2Monster", 40, 65918.445622, 1708.8, 113.265441, 3, 40, 43, 30, 21, 20, 20, 283131, 30208, 5706.3176, 582.69205, 3965.44005, 639.58314, 253, 4, 333, 0, 0, 0, 36, 170, 0, 1), 
(22353, 22353, "Celtus", 0, "Chimera", 0, "LineageMonster4.Chimera", 35, 36, 81, "male", "L2Monster", 40, 338766.602168, 1708.8, 194.030407, 3, 40, 43, 30, 21, 20, 20, 1089802, 116275, 7957.47326, 582.69205, 5529.81543, 639.58314, 253, 4, 333, 0, 0, 0, 36, 170, 0, 1), 
(22355, 22355, "Enceinte Defender", 0, "", 0, "LineageMonster4.eyeless", 36, 43.5, 81, "male", "L2Monster", 40, 18835.286784, 1708.8, 194.184226, 3, 40, 43, 30, 21, 20, 20, 81905, 8636, 10570.68611, 592.48128, 7388.2532, 650.32814, 253, 4, 333, 0, 0, 0, 60, 210, 0, 1), 
(22356, 22356, "Enceinte Defender", 0, "", 0, "LineageMonster4.eyeless", 36, 43.5, 81, "male", "L2Monster", 40, 112922.200723, 1708.8, 194.030407, 3, 40, 43, 30, 21, 20, 20, 0, 0, 9311.83315, 592.48128, 6508.39315, 650.32814, 253, 4, 333, 0, 0, 0, 60, 210, 0, 1), 
(22357, 22357, "Enceinte Defender", 0, "", 0, "LineageMonster4.eyeless", 36, 43.5, 81, "male", "L2Monster", 40, 65918.445622, 1708.8, 113.265441, 3, 40, 43, 30, 21, 20, 20, 0, 0, 5756.11951, 592.48128, 4023.17011, 650.32814, 253, 4, 333, 0, 0, 0, 60, 210, 0, 1), 
(22358, 22358, "Enceinte Defender", 0, "", 0, "LineageMonster4.eyeless", 36, 43.5, 81, "male", "L2Monster", 40, 56505.860351, 1708.8, 194.184226, 3, 40, 43, 30, 21, 20, 20, 0, 0, 9551.66562, 592.48128, 6676.02115, 650.32814, 253, 4, 333, 0, 0, 0, 60, 210, 0, 1), 
(22359, 22359, "Town Guard", 0, "", 0, "LineageMonster4.eyeless", 36, 43.5, 81, "male", "L2Monster", 40, 11001.3276, 1708.8, 113.41926, 3, 40, 43, 30, 21, 20, 20, 49499, 5219, 7014.97247, 592.48128, 4903.03016, 650.32814, 253, 4, 333, 0, 0, 0, 60, 210, 0, 1), 
(22360, 22360, "Town Patrolman", 0, "", 0, "LineageMonster.kel_mahum", 13, 26, 81, "male", "L2Monster", 40, 33003.982801, 1708.8, 113.41926, 3, 40, 43, 30, 21, 20, 20, 143958, 15178, 5995.95197, 592.48128, 4190.79811, 650.32814, 253, 4, 333, 7887, 0, 0, 50, 180, 0, 1), 
(22361, 22361, "Steel Citadel Keymaster", 0, "", 0, "LineageMonster4.eyeless", 36, 43.5, 81, "male", "L2Monster", 40, 112922.200723, 1708.8, 194.030407, 3, 40, 43, 30, 21, 20, 20, 552530, 58258, 9311.83315, 592.48128, 6508.39315, 650.32814, 253, 4, 333, 0, 0, 0, 60, 210, 0, 1), 
(22362, 22362, "Guzen", 0, "", 0, "LineageMonster4.rahuu", 33, 49, 83, "male", "L2Monster", 40, 336949.124088, 1777.4, 190.745373, 3, 40, 43, 30, 21, 20, 20, 1086080, 114515, 7996.0366, 585.59197, 5523.7478, 642.76618, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(22363, 22363, "Body Destroyer", 0, "", 0, "LineageMonster4.finished_malignant", 14, 31.5, 83, "male", "L2Monster", 40, 56202.842001, 1777.4, 190.897046, 3, 40, 43, 30, 21, 20, 20, 314158, 33124, 9440.59974, 585.59197, 6521.6675, 642.76618, 253, 1, 333, 0, 0, 0, 51, 160, 0, 1), 
(22364, 22364, "Soul Dominator", 0, "", 0, "LineageMonster.death_blader", 15, 45, 83, "male", "L2Monster", 40, 18734.280667, 1777.4, 190.897046, 3, 40, 43, 30, 21, 20, 20, 106372, 11215, 10447.77116, 585.59197, 7217.43231, 642.76618, 253, 4, 333, 1472, 0, 0, 100, 170, 0, 1), 
(22365, 22365, "Labyrinth Watchman", 0, "", 0, "LineageMonster4.eyeless_080p", 34, 35, 83, "male", "L2Monster", 40, 56202.842001, 1777.4, 190.897046, 3, 40, 43, 30, 21, 20, 20, 258123, 27216, 9440.59974, 585.59197, 6521.6675, 642.76618, 253, 4, 333, 0, 0, 0, 60, 210, 0, 1), 
(22366, 22366, "Labyrinth Watchman", 0, "", 0, "LineageMonster4.eyeless_080p", 34, 35, 83, "male", "L2Monster", 40, 56202.842001, 1777.4, 190.897046, 3, 40, 43, 30, 21, 20, 20, 258123, 27216, 9440.59974, 585.59197, 6521.6675, 642.76618, 253, 4, 333, 0, 0, 0, 60, 210, 0, 1), 
(22367, 22367, "Labyrinth Mystic", 0, "", 0, "LineageMonster.vale_master", 12, 40, 83, "male", "L2Monster", 40, 18734.280667, 1777.4, 190.897046, 3, 40, 43, 30, 21, 20, 20, 87693, 9246, 10447.77116, 585.59197, 7217.43231, 642.76618, 253, 4, 333, 210, 0, 0, 70, 155, 0, 1), 
(22368, 22368, "Labyrinth Captain", 0, "", 0, "LineageMonster.death_lord", 21, 40, 83, "male", "L2Monster", 40, 112316.374696, 1777.4, 190.745373, 3, 40, 43, 30, 21, 20, 20, 978685, 98149, 9203.55602, 585.59197, 6357.91516, 642.76618, 253, 4, 333, 78, 0, 0, 40, 160, 0, 1), 
(22369, 22369, "Labyrinth Seer", 0, "", 0, "LineageMonster2.vampire_wizard", 5.5, 28, 83, "female", "L2Monster", 40, 56202.842001, 1777.4, 190.897046, 3, 40, 43, 30, 21, 20, 20, 102130, 10259, 9440.59974, 585.59197, 6521.6675, 642.76618, 253, 1, 333, 99, 0, 0, 46, 165, 0, 1), 
(22370, 22370, "Passageway Captain", 0, "", 0, "LineageMonster.shadow_50_bi", 15, 45, 83, "male", "L2Monster", 40, 56202.842001, 1777.4, 190.897046, 3, 40, 43, 30, 21, 20, 20, 271142, 28589, 9440.59974, 585.59197, 6521.6675, 642.76618, 253, 1, 333, 0, 0, 0, 80, 160, 0, 1), 
(22371, 22371, "Passageway Guards", 0, "", 0, "LineageMonster2.vampire_soldier_20_bi", 10, 29, 83, "male", "L2Monster", 40, 18734.280667, 1777.4, 190.897046, 3, 40, 43, 30, 21, 20, 20, 88217, 9301, 10447.77116, 585.59197, 7217.43231, 642.76618, 253, 4, 333, 234, 0, 0, 60, 190, 0, 1), 
(22372, 22372, "Passageway Mystic", 0, "", 0, "LineageMonster2.vampire_wizard", 5.5, 28, 83, "female", "L2Monster", 40, 56202.842001, 1777.4, 190.897046, 3, 40, 43, 30, 21, 20, 20, 257790, 27181, 9440.59974, 585.59197, 6521.6675, 642.76618, 253, 1, 333, 99, 0, 0, 46, 165, 0, 1), 
(22373, 22373, "Cosmic Scout", 0, "", 0, "LineageMonster.crimson_doll", 15, 38, 83, "male", "L2Monster", 40, 18734.280667, 1777.4, 190.897046, 3, 40, 43, 30, 21, 20, 20, 91940, 9694, 10447.77116, 585.59197, 7217.43231, 642.76618, 253, 4, 333, 0, 0, 0, 60, 150, 0, 1), 
(22374, 22374, "Cosmic Watcher", 0, "", 0, "LineageMonster3.zombie_enlisted_man", 17, 22.3, 83, "male", "L2Monster", 40, 56202.842001, 1777.4, 190.897046, 3, 40, 43, 30, 21, 20, 20, 256950, 27092, 9440.59974, 585.59197, 6521.6675, 642.76618, 253, 4, 333, 0, 0, 0, 38, 180, 0, 1), 
(22375, 22375, "Cosmic Priest", 0, "", 0, "LineageMonster2.vampire_wizard", 5.5, 28, 83, "female", "L2Monster", 40, 112316.374696, 1777.4, 190.745373, 3, 40, 43, 30, 21, 20, 20, 533950, 56299, 9203.55602, 585.59197, 6357.91516, 642.76618, 253, 1, 333, 99, 0, 0, 46, 165, 0, 1), 
(22376, 22376, "Cosmic Lord", 0, "", 0, "LineageMonster4.rahuu", 33, 49, 83, "male", "L2Monster", 40, 336949.124088, 1777.4, 190.745373, 3, 40, 43, 30, 21, 20, 20, 1086080, 114515, 7996.0366, 585.59197, 5523.7478, 642.76618, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(22377, 22377, "Master Zelos", 0, "", 0, "LineageMonster4.rahuu", 33, 49, 83, "male", "L2Monster", 40, 336949.124088, 1777.4, 190.745373, 3, 40, 43, 30, 21, 20, 20, 1410902, 147054, 8128.04753, 595.19567, 5647.21214, 653.30756, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(22378, 22378, "Master's Minion", 0, "", 0, "LineageMonster3.Vampire_Troop_Leader", 19, 35, 83, "male", "L2Monster", 40, 65569.257083, 1777.4, 111.355378, 3, 40, 43, 30, 21, 20, 20, 312777, 32599, 5738.72922, 595.19567, 3987.15943, 653.30756, 253, 4, 333, 0, 0, 0, 60, 160, 0, 1), 
(22379, 22379, "Master's Minion", 0, "", 0, "LineageMonster2.vampire_witch", 6, 21.5, 83, "female", "L2Monster", 40, 32829.283195, 1777.4, 111.507051, 3, 40, 43, 30, 21, 20, 20, 163810, 17073, 5981.54451, 595.19567, 4155.86285, 653.30756, 253, 1, 333, 946, 0, 0, 64, 180, 0, 1), 
(22380, 22380, "Master Festina", 0, "", 0, "LineageMonster4.rah", 20, 40.6, 83, "female", "L2Monster", 40, 336949.124088, 1777.4, 190.745373, 3, 40, 43, 30, 21, 20, 20, 1317481, 137317, 8128.04753, 595.19567, 5647.21214, 653.30756, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(22381, 22381, "Master's Guard", 0, "", 0, "LineageMonster3.portrait_spirit", 23, 40, 83, "male", "L2Monster", 40, 56202.842001, 1777.4, 190.897046, 3, 40, 43, 30, 21, 20, 20, 297386, 30995, 9516.11506, 595.19567, 6611.61494, 653.30756, 253, 4, 333, 0, 0, 0, 30, 200, 0, 1), 
(22382, 22382, "Master's Guard", 0, "", 0, "LineageMonster3.portrait_spirit_winged", 23, 40, 83, "male", "L2Monster", 40, 56202.842001, 1777.4, 190.897046, 3, 40, 43, 30, 21, 20, 20, 292521, 30488, 9516.11506, 595.19567, 6611.61494, 653.30756, 253, 4, 333, 0, 0, 0, 30, 200, 0, 1), 
(22383, 22383, "Tully's Toy", 0, "", 0, "LineageMonster3.golem_repair", 23, 32.8, 83, "male", "L2Monster", 40, 56202.842001, 1777.4, 190.897046, 3, 40, 43, 30, 21, 20, 20, 67470, 6768, 9516.11506, 595.19567, 6611.61494, 653.30756, 253, 1, 333, 0, 0, 0, 72, 190, 0, 1), 
(22384, 22384, "Mystic's Toy", 0, "", 0, "LineageMonster3.golem_microscout", 12, 43.5, 83, "male", "L2Monster", 40, 56202.842001, 1777.4, 190.897046, 3, 40, 43, 30, 21, 20, 20, 50927, 5124, 9516.11506, 595.19567, 6611.61494, 653.30756, 253, 4, 333, 0, 0, 0, 30, 250, 0, 1), 
(22385, 22385, "Tully's Golem Guard", 0, "", 0, "LineageMonster3.golem_guardian_a", 18, 41.5, 83, "male", "L2Monster", 40, 112316.374696, 1777.4, 190.745373, 3, 40, 43, 30, 21, 20, 20, 476711, 49686, 9273.29977, 595.19567, 6442.91152, 653.30756, 253, 4, 333, 0, 0, 0, 53, 200, 0, 1), 
(22386, 22386, "Foundry Mystic", 0, "", 0, "LineageMonster.doll_master", 20, 42, 83, "male", "L2Monster", 40, 56202.842001, 1777.4, 190.897046, 3, 40, 43, 30, 21, 20, 20, 291223, 30353, 9516.11506, 595.19567, 6611.61494, 653.30756, 253, 4, 333, 0, 0, 0, 80, 160, 0, 1), 
(22387, 22387, "Foundry Mystic", 0, "", 0, "LineageMonster.doll_master", 20, 42, 83, "male", "L2Monster", 40, 56202.842001, 1777.4, 190.897046, 3, 40, 43, 30, 21, 20, 20, 291223, 30353, 9516.11506, 595.19567, 6611.61494, 653.30756, 253, 4, 333, 0, 0, 0, 80, 160, 0, 1), 
(22388, 22388, "Foundry Spirit Guard", 0, "", 0, "LineageMonster4.finished_malignant", 14, 31.5, 83, "male", "L2Monster", 40, 112316.374696, 1777.4, 190.745373, 3, 40, 43, 30, 21, 20, 20, 640012, 66706, 9273.29977, 595.19567, 6442.91152, 653.30756, 253, 1, 333, 0, 0, 0, 51, 160, 0, 1), 
(22389, 22389, "Foundry Spirit Guard", 0, "", 0, "LineageMonster4.finished_malignant", 14, 31.5, 83, "male", "L2Npc", 40, 112316.374696, 1777.4, 190.745373, 3, 40, 43, 30, 21, 20, 20, 640012, 66706, 9273.29977, 595.19567, 6442.91152, 653.30756, 253, 1, 333, 0, 0, 0, 51, 160, 0, 1), 
(22390, 22390, "Foundry Foreman", 0, "", 0, "LineageMonster2.ahrimanes_20_sm", 13, 47.2, 83, "male", "L2Monster", 80, 112316.374696, 1777.4, 190.745373, 3, 40, 43, 30, 21, 20, 20, 609074, 65777, 9063.04944, 566.1783, 6188.88791, 621.45708, 253, 4, 333, 0, 0, 0, 35, 185, 0, 1), 
(22391, 22391, "Foundry Assistant Overseer", 0, "", 0, "LineageMonster2.ashuras", 13, 37.5, 83, "male", "L2Monster", 40, 32829.283195, 1777.4, 111.507051, 3, 40, 43, 30, 21, 20, 20, 286741, 29436, 5815.28895, 566.1783, 3971.08851, 621.45708, 253, 4, 333, 0, 0, 0, 41, 190, 0, 1), 
(22392, 22392, "Failed Experimental Timetwister Golem", 0, "", 0, "LineageMonster4.demon_darion_fgt", 28, 52.5, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 45682, 4530, 1255.50808, 371.9973, 872.30303, 272.21148, 253, 4, 333, 0, 0, 0, 46, 250, 0, 1), 
(22393, 22393, "Beleth's Follower", 0, "", 0, "LineageMonster3.zombie_gateguard", 17, 30.5, 83, "male", "L2Monster", 40, 65569.257083, 1777.4, 111.355378, 3, 40, 43, 30, 21, 20, 20, 358097, 37323, 5738.72922, 595.19567, 3987.15943, 653.30756, 253, 4, 333, 8217, 0, 0, 33, 160, 0, 1), 
(22394, 22394, "Beleth's Devotee", 0, "", 0, "LineageMonster3.portrait_spirit_winged", 23, 40, 83, "male", "L2Monster", 40, 196707.771249, 1777.4, 111.355378, 3, 40, 43, 30, 21, 20, 20, 304451, 30461, 4701.60426, 595.19567, 3266.58482, 653.30756, 253, 4, 333, 0, 0, 0, 30, 200, 0, 1), 
(22395, 22395, "Beleth's Projection", 0, "", 0, "LineageMonster4.behamah", 25, 37.5, 83, "male", "L2Monster", 40, 56202.842001, 1777.4, 190.897046, 3, 40, 43, 30, 21, 20, 20, 652377, 64757, 9516.11506, 595.19567, 6611.61494, 653.30756, 253, 4, 333, 10278, 10278, 0, 70, 190, 0, 1), 
(22396, 22396, "Foundry Laborer", 0, "", 0, "LineageMonster4.Caravan_Slave", 35, 47.5, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 11272, 1174, 1255.50808, 371.9973, 872.30303, 272.21148, 253, 1, 333, 0, 0, 0, 46, 160, 0, 1), 
(22397, 22397, "Foundry Foreman", 0, "", 0, "LineageMonster4.rahuu", 33, 49, 83, "male", "L2Monster", 40, 32829.283195, 1777.4, 111.507051, 3, 40, 43, 30, 21, 20, 20, 145669, 15182, 5981.54451, 595.19567, 4155.86285, 653.30756, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), 
(22398, 22398, "Lesser Evil", 0, "", 0, "LineageMonster3.zombie_gateguard", 17, 30.5, 83, "male", "L2Monster", 80, 32829.283195, 1777.4, 111.507051, 3, 40, 43, 30, 21, 20, 20, 268445, 26626, 5981.54451, 595.19567, 4155.86285, 653.30756, 253, 4, 333, 8217, 0, 0, 33, 120, 0, 1), 
(22399, 22399, "Greater Evil", 0, "", 0, "LineageMonster3.zombie_gateguard_120p", 18, 37, 83, "male", "L2Monster", 80, 32829.283195, 1777.4, 111.507051, 3, 40, 43, 30, 21, 20, 20, 385754, 38241, 5981.54451, 595.19567, 4155.86285, 653.30756, 253, 4, 333, 8217, 0, 0, 43, 120, 0, 1), 
(22400, 22400, "Parme's Healer", 0, "", 0, "LineageMonster4.tears_d", 20, 27.5, 83, "female", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 8893, 972, 1049.15028, 347.7412, 712.26832, 254.46192, 253, 4, 333, 9639, 9639, 0, 60, 180, 0, 1), 
(22401, 22401, "Parme's Healer", 0, "", 0, "LineageMonster4.tears_d", 20, 27.5, 83, "female", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 8893, 972, 1049.15028, 347.7412, 712.26832, 254.46192, 253, 4, 333, 9639, 9639, 0, 60, 180, 0, 1), 
(22402, 22402, "Shadow Column", 0, "", 0, "LineageNpcEV.dark_clouds_chessman", 68, 80, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 8545, 934, 1049.15028, 347.7412, 712.26832, 254.46192, 253, 4, 333, 0, 0, 0, 1, 100, 0, 1), 
(22403, 22403, "Foundry Foreman", 0, "", 0, "LineageMonster4.rah", 20, 40.6, 83, "female", "L2Monster", 40, 32829.283195, 1777.4, 111.507051, 3, 40, 43, 30, 21, 20, 20, 147344, 15357, 5981.54451, 595.19567, 4155.86285, 653.30756, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(22404, 22404, "Arcane Captain", 0, "", 0, "LineageMonster.kaim_vanul", 24, 40, 83, "male", "L2Monster", 40, 65569.257083, 1777.4, 111.355378, 3, 40, 43, 30, 21, 20, 20, 589351, 60722, 5589.57219, 566.1783, 3816.95322, 621.45708, 253, 4, 333, 0, 0, 0, 37, 160, 0, 1), 
(22405, 22405, "Darion's Faithful Servant", 0, "", 0, "LineageMonster3.golem_microscout_a", 12, 43.5, 83, "male", "L2Monster", 80, 10943.094398, 1777.4, 111.507051, 3, 40, 43, 30, 21, 20, 20, 105809, 10510, 7013.14725, 595.19567, 4872.60072, 653.30756, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(22406, 22406, "Darion's Faithful Servant", 0, "", 0, "LineageMonster4.demon_darion_fgt", 28, 52.5, 83, "male", "L2Monster", 80, 32829.283195, 1777.4, 111.507051, 3, 40, 43, 30, 21, 20, 20, 183265, 19101, 5981.54451, 595.19567, 4155.86285, 653.30756, 253, 4, 333, 0, 0, 0, 46, 180, 0, 1), 
(22407, 22407, "Darion's Faithful Servant", 0, "", 0, "LineageMonster4.demon_darion_fgt", 28, 52.5, 83, "male", "L2Monster", 80, 32829.283195, 1777.4, 111.507051, 3, 40, 43, 30, 21, 20, 20, 323450, 32158, 5981.54451, 595.19567, 4155.86285, 653.30756, 253, 4, 333, 0, 0, 0, 46, 180, 0, 1), 
(22408, 22408, "Darion's Faithful Servant", 0, "", 0, "LineageMonster4.demon_darion_fgt", 28, 52.5, 83, "male", "L2Monster", 80, 56202.842001, 1777.4, 190.897046, 3, 40, 43, 30, 21, 20, 20, 306237, 31559, 9590.36935, 604.71881, 6701.28091, 663.76047, 253, 4, 333, 0, 0, 0, 46, 180, 0, 1), 
(22409, 22409, "Darion's Faithful Servant", 0, "", 0, "LineageMonster4.demon_darion_fgt", 28, 52.5, 83, "male", "L2Monster", 80, 112316.374696, 1777.4, 190.745373, 3, 40, 43, 30, 21, 20, 20, 677999, 69871, 9341.74365, 604.71881, 6527.55344, 663.76047, 253, 4, 333, 0, 0, 0, 46, 180, 0, 1), 
(22410, 22410, "Darion's Faithful Servant", 0, "", 0, "LineageMonster4.demon_darion_fgt", 28, 52.5, 83, "male", "L2Monster", 80, 112316.374696, 1777.4, 190.745373, 3, 40, 43, 30, 21, 20, 20, 796818, 82116, 9341.74365, 604.71881, 6527.55344, 663.76047, 253, 4, 333, 0, 0, 0, 46, 180, 0, 1), 
(22411, 22411, "Beleth's Retainer", 0, "", 0, "LineageMonster4.demon_darion_fgt", 28, 52.5, 83, "male", "L2Monster", 80, 18734.280667, 1777.4, 190.897046, 3, 40, 43, 30, 21, 20, 20, 483637, 47912, 10547.7178, 595.19567, 7328.35282, 653.30756, 253, 4, 333, 0, 0, 0, 46, 180, 0, 1), 
(22412, 22412, "Beleth's Fighter", 0, "", 0, "LineageMonster4.behamah_120p", 32, 46.8, 83, "male", "L2Monster", 40, 112316.374696, 1777.4, 190.745373, 3, 40, 43, 30, 21, 20, 20, 1387469, 137882, 9273.29977, 595.19567, 6442.91152, 653.30756, 253, 4, 333, 10278, 10278, 0, 80, 190, 0, 1), 
(22413, 22413, "Beleth's Low Servant", 0, "", 0, "LineageMonster3.spectral_knight", 12.5, 33.5, 83, "male", "L2Monster", 80, 32829.283195, 1777.4, 111.507051, 3, 40, 43, 30, 21, 20, 20, 541934, 53798, 5981.54451, 595.19567, 4155.86285, 653.30756, 253, 4, 333, 0, 0, 0, 160, 160, 0, 1), 
(22414, 22414, "Beleth's Follower", 0, "", 0, "LineageMonster3.zombie_gateguard", 17, 30.5, 83, "male", "L2Monster", 40, 65569.257083, 1777.4, 111.355378, 3, 40, 43, 30, 21, 20, 20, 358097, 37323, 5738.72922, 595.19567, 3987.15943, 653.30756, 253, 4, 333, 8217, 0, 0, 33, 160, 0, 1), 
(22415, 22415, "Beleth's Devotee", 0, "", 0, "LineageMonster3.portrait_spirit_winged", 23, 40, 83, "male", "L2Monster", 40, 196707.771249, 1777.4, 111.355378, 3, 40, 43, 30, 21, 20, 20, 304451, 30461, 4701.60426, 595.19567, 3266.58482, 653.30756, 253, 4, 333, 0, 0, 0, 30, 200, 0, 1), 
(22416, 22416, "Kechi's Captain", 0, "", 0, "LineageMonster2.ifrit_30_bi", 13, 55, 82, "male", "L2Monster", 40, 65802.611804, 1743, 112.4052, 3, 40, 43, 30, 21, 20, 20, 199714, 21838, 5571.87244, 559.63963, 3804.86656, 614.28, 253, 4, 333, 0, 0, 0, 38, 200, 0, 1), 
(22417, 22417, "Kechi's Guard", 0, "", 0, "LineageMonster3.portrait_spirit_winged_150p", 23, 52, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 41505, 4345, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 30, 200, 0, 1), 
(22418, 22418, "Burning Iris", 0, "", 0, "LineageMonster4.eyeless_080p", 34, 35, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 28000, 2921, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 60, 200, 0, 1), 
(22419, 22419, "Flame Iris", 0, "", 0, "LineageMonster4.eyeless_080p", 34, 35, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 26322, 2738, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 60, 200, 0, 1), 
(22420, 22420, "Brimstone Iris", 0, "", 0, "LineageMonster4.eyeless_080p", 34, 35, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 28704, 2998, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 60, 200, 0, 1), 
(22422, 22422, "Failan's Guard", 0, "", 0, "LineageMonster3.Death_Blader_Raid", 15, 32.5, 83, "male", "L2Monster", 40, 10943.094398, 1777.4, 111.507051, 3, 40, 43, 30, 21, 20, 20, 63485, 6856, 6774.50812, 566.1783, 4626.11085, 621.45708, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(22423, 22423, "Original Sin Warden", 0, "", 0, "LineageMonster4.demon_darion_fgt", 28, 52.5, 83, "male", "L2Monster", 40, 65569.257083, 1777.4, 111.355378, 3, 40, 43, 30, 21, 20, 20, 69803, 6996, 5738.72922, 595.19567, 3987.15943, 653.30756, 253, 4, 333, 0, 0, 0, 46, 190, 0, 1), 
(22424, 22424, "Slave of Greed", 0, "", 0, "LineageMonster2.ashuras", 13, 37.5, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 60503, 6075, 1255.50808, 371.9973, 872.30303, 272.21148, 253, 4, 333, 0, 0, 0, 41, 190, 0, 1), 
(22425, 22425, "Slave of Lust", 0, "", 0, "LineageMonster3.Succubus_Raid", 12, 30.7, 83, "female", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 60503, 6075, 1255.50808, 371.9973, 872.30303, 272.21148, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(22426, 22426, "Slave of Wrath", 0, "", 0, "LineageMonster.vale_master_10_bi", 13, 44, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 60503, 6075, 1255.50808, 371.9973, 872.30303, 272.21148, 253, 4, 333, 0, 0, 0, 70, 160, 0, 1), 
(22427, 22427, "Slave of Sloth", 0, "", 0, "LineageMonster2.giant_zombie", 13, 40, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 60503, 6075, 1255.50808, 371.9973, 872.30303, 272.21148, 253, 1, 333, 0, 0, 0, 20, 100, 0, 1), 
(22428, 22428, "Slave of Envy", 0, "", 0, "LineageMonster3.Bloody_Queen_Raid", 11, 34, 83, "female", "L2Monster", 80, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 60503, 6075, 1255.50808, 371.9973, 872.30303, 272.21148, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(22429, 22429, "Slave of Pride", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 35.5, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 60503, 6075, 1255.50808, 371.9973, 872.30303, 272.21148, 253, 4, 333, 0, 0, 0, 30, 170, 0, 1), 
(22430, 22430, "Slave of Gluttony", 0, "", 0, "LineageMonster3.Death_Blader_Raid", 15, 32.5, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 60503, 6075, 1255.50808, 371.9973, 872.30303, 272.21148, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(22431, 22431, "Original Sin Warden", 0, "", 0, "LineageMonster4.behamah", 25, 37.5, 83, "male", "L2Monster", 40, 112316.374696, 1777.4, 190.745373, 3, 40, 43, 30, 21, 20, 20, 139297, 13961, 9273.29977, 595.19567, 6442.91152, 653.30756, 253, 4, 333, 10278, 10278, 0, 70, 190, 0, 1), 
(22432, 22432, "Slave of Greed", 0, "", 0, "LineageMonster2.ashuras", 13, 37.5, 83, "male", "L2Monster", 40, 10943.094398, 1777.4, 111.507051, 3, 40, 43, 30, 21, 20, 20, 35640, 3714, 7013.14725, 595.19567, 4872.60072, 653.30756, 253, 4, 333, 0, 0, 0, 41, 190, 0, 1), 
(22433, 22433, "Slave of Lust", 0, "", 0, "LineageMonster3.Succubus_Raid", 12, 30.7, 83, "female", "L2Monster", 40, 10943.094398, 1777.4, 111.507051, 3, 40, 43, 30, 21, 20, 20, 35640, 3714, 7013.14725, 595.19567, 4872.60072, 653.30756, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(22434, 22434, "Slave of Wrath", 0, "", 0, "LineageMonster.vale_master_10_bi", 13, 44, 83, "male", "L2Monster", 40, 10943.094398, 1777.4, 111.507051, 3, 40, 43, 30, 21, 20, 20, 35640, 3714, 7013.14725, 595.19567, 4872.60072, 653.30756, 253, 4, 333, 0, 0, 0, 70, 160, 0, 1), 
(22435, 22435, "Slave of Sloth", 0, "", 0, "LineageMonster2.giant_zombie", 13, 40, 83, "male", "L2Monster", 40, 10943.094398, 1777.4, 111.507051, 3, 40, 43, 30, 21, 20, 20, 35640, 3714, 7013.14725, 595.19567, 4872.60072, 653.30756, 253, 1, 333, 0, 0, 0, 20, 100, 0, 1), 
(22436, 22436, "Slave of Envy", 0, "", 0, "LineageMonster3.Bloody_Queen_Raid", 11, 34, 83, "female", "L2Monster", 80, 10943.094398, 1777.4, 111.507051, 3, 40, 43, 30, 21, 20, 20, 35640, 3714, 7013.14725, 595.19567, 4872.60072, 653.30756, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(22437, 22437, "Slave of Pride", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 35.5, 83, "male", "L2Monster", 40, 10943.094398, 1777.4, 111.507051, 3, 40, 43, 30, 21, 20, 20, 35640, 3714, 7013.14725, 595.19567, 4872.60072, 653.30756, 253, 4, 333, 0, 0, 0, 30, 170, 0, 1), 
(22438, 22438, "Slave of Gluttony", 0, "", 0, "LineageMonster3.Death_Blader_Raid", 15, 32.5, 83, "male", "L2Monster", 40, 10943.094398, 1777.4, 111.507051, 3, 40, 43, 30, 21, 20, 20, 35640, 3714, 7013.14725, 595.19567, 4872.60072, 653.30756, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(22439, 22439, "Beleth's Assassin", 0, "", 0, "LineageMonster.dark_mahum", 13, 26, 83, "male", "L2Monster", 40, 112316.374696, 1777.4, 190.745373, 3, 40, 43, 30, 21, 20, 20, 733679, 76469, 9273.29977, 595.19567, 6442.91152, 653.30756, 253, 4, 333, 234, 0, 0, 50, 180, 0, 1), 
(22440, 22440, "Beleth's Assassin", 0, "", 0, "LineageMonster.dark_mahum", 13, 26, 83, "male", "L2Monster", 40, 112316.374696, 1777.4, 190.745373, 3, 40, 43, 30, 21, 20, 20, 755088, 78701, 9273.29977, 595.19567, 6442.91152, 653.30756, 253, 4, 333, 234, 0, 0, 50, 180, 0, 1), 
(22441, 22441, "Beleth's Minion", 0, "", 0, "LineageMonster3.Vampire_Troop_Leader_120p", 22, 43, 83, "male", "L2Monster", 40, 56202.842001, 1777.4, 190.897046, 3, 40, 43, 30, 21, 20, 20, 638455, 63306, 9516.11506, 595.19567, 6611.61494, 653.30756, 253, 4, 333, 8686, 0, 0, 60, 160, 0, 1), 
(22442, 22442, "Beleth's Minion", 0, "", 0, "LineageMonster3.Vampire_Troop_Leader_120p", 22, 43, 83, "male", "L2Monster", 40, 32829.283195, 1777.4, 111.507051, 3, 40, 43, 30, 21, 20, 20, 363488, 36034, 5981.54451, 595.19567, 4155.86285, 653.30756, 253, 4, 333, 8686, 0, 0, 60, 160, 0, 1), 
(22443, 22443, "Kertang's Messenger", 0, "", 0, "LineageMonster4.snake_head_man", 20, 36, 45, "male", "L2Monster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3835, 266, 234.89829, 177.78746, 160.40508, 130.09715, 253, 4, 333, 0, 0, 0, 35, 160, 0, 1), 
(22444, 22444, "Kertang's Messenger", 0, "", 0, "LineageMonster4.snake_head_man", 20, 36, 55, "male", "L2Monster", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 5728, 462, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 35, 160, 0, 1), 
(22445, 22445, "Kertang's Messenger", 0, "", 0, "LineageMonster4.snake_head_man", 20, 36, 65, "male", "L2Monster", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 7798, 724, 582.81759, 271.89033, 397.98887, 198.95754, 253, 4, 333, 0, 0, 0, 35, 160, 0, 1), 
(22446, 22446, "Kertang's Messenger", 0, "", 0, "LineageMonster4.snake_head_man_a", 20, 36, 75, "male", "L2Monster", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 9659, 1018, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 15, 160, 0, 1), 
(22447, 22447, "Kertang's Messenger", 0, "", 0, "LineageMonster4.snake_head_man_a", 20, 36, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 10184, 1143, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 15, 160, 0, 1), 
(22448, 22448, "Leodas", 0, "Resistance Commander", 0, "LineageNPC.a_fighterguild_master_Mhuman_old", 8, 23.5, 86, "male", "L2Monster", 40, 194672.691398, 1881.8, 108.314129, 3, 40, 43, 30, 21, 20, 20, 944308, 93684, 4621.00533, 584.99232, 3155.5476, 642.108, 253, 4, 333, 6611, 0, 0, 50, 100, 0, 1), 
(22449, 22449, "Amaskari", 0, "Torture Expert", 0, "LineageMonster2.ahrimanes", 14, 57.75, 86, "male", "L2Monster", 40, 64890.897133, 1881.8, 108.314129, 3, 40, 43, 30, 21, 20, 20, 213008, 22201, 5640.35101, 584.99232, 3851.62856, 642.108, 253, 1, 333, 6722, 0, 0, 35, 185, 0, 1), 
(22450, 22450, "Tortured Native", 0, "", 0, "LineageNPC.a_common_peopleC_Mhuman", 10, 24, 86, "male", "L2Monster", 40, 4439.743585, 1881.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 9210, 959, 1233.98508, 365.6202, 842.65185, 267.545, 253, 4, 333, 946, 0, 0, 50, 100, 0, 1), 
(22451, 22451, "Native Elite Soldier", 0, "", 0, "LineageNPC.a_common_peopleC_Mhuman", 10, 24, 86, "male", "L2Monster", 40, 4439.743585, 1881.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 16123, 1680, 1233.98508, 365.6202, 842.65185, 267.545, 253, 4, 333, 135, 0, 0, 50, 100, 0, 1), 
(22452, 22452, "White Skull Kanabion", 0, "", 0, "LineageMonster.skeleton_pikeman", 10, 28, 25, "male", "L2Monster", 80, 460.96247, 259.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1136, 56, 64.83203, 101.83533, 44.27187, 74.51868, 253, 4, 333, 292, 0, 0, 50, 155, 1, 1), 
(22453, 22453, "White Skull Kanabion", 0, "Doppler", 0, "LineageMonster.skeleton_knight_20_bi", 12, 30.5, 25, "male", "L2Monster", 80, 460.96247, 259.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1136, 56, 64.83203, 101.83533, 44.27187, 74.51868, 253, 4, 333, 5285, 0, 0, 40, 160, 1, 1), 
(22454, 22454, "White Skull Kanabion", 0, "Void", 0, "LineageMonster.skeleton_royal_guard_30_bi", 14, 37.5, 27, "male", "L2Monster", 40, 460.96247, 259.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1463, 62, 64.83203, 101.83533, 44.27187, 74.51868, 253, 8, 333, 236, 0, 0, 80, 120, 1, 1), 
(22455, 22455, "Begrudged Kanabion", 0, "", 0, "LineageMonster.orc", 10, 21, 30, "male", "L2Monster", 40, 604.08419, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1499, 81, 92.64226, 118.46427, 63.26266, 86.68702, 253, 4, 333, 127, 0, 0, 45, 110, 1, 1), 
(22456, 22456, "Begrudged Kanabion", 0, "Doppler", 0, "LineageMonster.orc_fighter", 12, 22, 30, "male", "L2Monster", 40, 604.08419, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1499, 81, 92.64226, 118.46427, 63.26266, 86.68702, 253, 8, 333, 129, 0, 0, 45, 110, 1, 1), 
(22457, 22457, "Begrudged Kanabion", 0, "Void", 0, "LineageMonster.orc_champion", 10, 23, 32, "male", "L2Monster", 40, 604.08419, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 1883, 90, 92.64226, 118.46427, 63.26266, 86.68702, 253, 8, 333, 7886, 0, 0, 45, 130, 1, 1), 
(22458, 22458, "Rotten Kanabion", 0, "", 0, "LineageMonster.zombie_bi_one", 13, 30.5, 35, "male", "L2Monster", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2040, 120, 129.32896, 136.72948, 88.31491, 100.0527, 253, 4, 333, 0, 0, 0, 15, 15, 1, 1), 
(22459, 22459, "Rotten Kanabion", 0, "Doppler", 0, "LineageMonster.neer_crawler", 14, 22, 35, "male", "L2Monster", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2040, 120, 129.32896, 136.72948, 88.31491, 100.0527, 253, 4, 333, 0, 0, 0, 50, 90, 1, 1), 
(22460, 22460, "Rotten Kanabion", 0, "Void", 0, "LineageMonster3.Zombie_Raid", 30, 21.25, 37, "male", "L2Monster", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2517, 133, 129.32896, 136.72948, 88.31491, 100.0527, 253, 4, 333, 0, 0, 0, 60, 170, 1, 1), 
(22461, 22461, "Gluttonous Kanabion", 0, "", 0, "LineageMonster.crokian", 18, 29, 40, "male", "L2Monster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2665, 172, 176.36077, 156.55035, 120.43155, 114.55675, 253, 4, 333, 5128, 0, 0, 18, 150, 1, 1), 
(22462, 22462, "Gluttonous Kanabion", 0, "Doppler", 0, "LineageMonster3.Crokian_Officer", 25, 33, 40, "male", "L2Monster", 80, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 2665, 172, 176.36077, 156.55035, 120.43155, 114.55675, 253, 4, 333, 0, 0, 0, 60, 160, 1, 1), 
(22463, 22463, "Gluttonous Kanabion", 0, "Void", 0, "LineageMonster.nos", 26, 42, 42, "male", "L2Monster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 3243, 189, 176.36077, 156.55035, 120.43155, 114.55675, 253, 4, 333, 5130, 0, 0, 18, 150, 1, 1), 
(22464, 22464, "Callous Kanabion", 0, "", 0, "LineageMonster.zenta_lizardman", 11, 32, 45, "male", "L2Monster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3373, 234, 234.89829, 177.78746, 160.40508, 130.09715, 253, 4, 333, 7887, 0, 0, 37, 140, 1, 1), 
(22465, 22465, "Callous Kanabion", 0, "Doppler", 0, "LineageMonster.zenta_lizardman_warrior", 13, 35, 45, "male", "L2Monster", 80, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3373, 234, 234.89829, 177.78746, 160.40508, 130.09715, 253, 4, 333, 298, 0, 0, 40, 140, 1, 1), 
(22466, 22466, "Callous Kanabion", 0, "Void", 0, "LineageMonster.zenta_lizardman_matriarch", 20, 40, 47, "male", "L2Monster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4061, 258, 234.89829, 177.78746, 160.40508, 130.09715, 253, 8, 333, 226, 0, 0, 53, 140, 1, 1), 
(22467, 22467, "Savage Kanabion", 0, "", 0, "LineageMonster.heltor_silenos", 13, 29, 50, "male", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3984, 300, 305.54906, 200.23844, 208.6504, 146.5258, 253, 4, 333, 77, 0, 0, 34, 160, 1, 1), 
(22468, 22468, "Savage Kanabion", 0, "Doppler", 0, "LineageMonster.heltor_silenos_warrior", 13, 31, 50, "male", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3984, 300, 305.54906, 200.23844, 208.6504, 146.5258, 253, 4, 333, 75, 0, 0, 36, 160, 1, 1), 
(22469, 22469, "Savage Kanabion", 0, "Void", 0, "LineageMonster.heltor_silenos_chieftain", 13, 31.5, 52, "male", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 4776, 332, 305.54906, 200.23844, 208.6504, 146.5258, 253, 4, 333, 84, 0, 0, 27, 160, 1, 1), 
(22470, 22470, "Peerless Kanabion", 0, "", 0, "LineageMonster.batur_orc_20_bi", 10, 25.3, 55, "male", "L2Monster", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 4821, 389, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 7888, 0, 0, 80, 130, 1, 1), 
(22471, 22471, "Peerless Kanabion", 0, "Doppler", 0, "LineageMonster.batur_orc_warrior_20_bi", 12, 24, 55, "male", "L2Monster", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 4821, 389, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 84, 0, 0, 80, 120, 1, 1), 
(22472, 22472, "Peerless Kanabion", 0, "Void", 0, "LineageMonster.batur_orc_overlord_20_bi", 14, 28.8, 57, "male", "L2Monster", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 5739, 431, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 135, 0, 0, 80, 140, 1, 1), 
(22473, 22473, "Massive Kanabion", 0, "", 0, "LineageMonster.kel_mahum", 13, 26, 60, "male", "L2Monster", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 5737, 497, 481.34551, 247.65008, 328.69659, 181.21958, 253, 4, 333, 127, 0, 0, 50, 160, 1, 1), 
(22474, 22474, "Massive Kanabion", 0, "Doppler", 0, "LineageMonster.kel_mahum_warrior", 13, 28, 60, "male", "L2Monster", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 5737, 497, 481.34551, 247.65008, 328.69659, 181.21958, 253, 4, 333, 148, 0, 0, 50, 160, 1, 1), 
(22475, 22475, "Massive Kanabion", 0, "Void", 0, "LineageMonster.kel_mahum_champion", 13, 32, 62, "male", "L2Monster", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 6790, 552, 481.34551, 247.65008, 328.69659, 181.21958, 253, 4, 333, 161, 0, 0, 50, 170, 1, 1), 
(22476, 22476, "Fervent Kanabion", 0, "", 0, "LineageMonster2.vampire_soldier", 8, 23.5, 65, "male", "L2Monster", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 6733, 625, 582.81759, 271.89033, 397.98887, 198.95754, 253, 4, 333, 85, 0, 0, 60, 190, 1, 1), 
(22477, 22477, "Fervent Kanabion", 0, "Doppler", 0, "LineageMonster2.vampire_warrior", 9, 31.5, 65, "male", "L2Monster", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 6733, 625, 582.81759, 271.89033, 397.98887, 198.95754, 253, 4, 333, 6723, 0, 0, 43, 165, 1, 1), 
(22478, 22478, "Fervent Kanabion", 0, "Void", 0, "LineageMonster3.Vampire_Troop_Leader", 19, 35, 67, "male", "L2Monster", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 7929, 693, 582.81759, 271.89033, 397.98887, 198.95754, 253, 4, 333, 8686, 0, 0, 60, 160, 1, 1), 
(22479, 22479, "Ruptured Kanabion", 0, "", 0, "LineageMonster4.eyeless_080p", 34, 35, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 7597, 753, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 60, 210, 1, 1), 
(22480, 22480, "Ruptured Kanabion", 0, "Doppler", 0, "LineageMonster4.eyeless", 36, 43.5, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 7597, 753, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 60, 210, 1, 1), 
(22481, 22481, "Ruptured Kanabion", 0, "Void", 0, "LineageMonster4.eyeless_120p", 38, 54, 72, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 8933, 837, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 60, 210, 1, 1), 
(22482, 22482, "Sword Kanabion", 0, "", 0, "LineageMonster4.rah", 20, 40.6, 75, "female", "L2Monster", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 8721, 919, 794.70901, 319.24623, 542.68324, 233.61053, 253, 1, 333, 0, 0, 0, 60, 170, 1, 1), 
(22483, 22483, "Sword Kanabion", 0, "Doppler", 0, "LineageMonster4.rahuu", 33, 49, 75, "male", "L2Monster", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 8721, 919, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 0, 0, 0, 60, 170, 1, 1), 
(22484, 22484, "Sword Kanabion", 0, "Void", 0, "LineageMonster4.rahuu", 33, 49, 77, "male", "L2Monster", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 10217, 1022, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 0, 0, 0, 60, 180, 1, 1), 
(22485, 22485, "Lost Watcher", 0, "", 0, "LineageMonster.oel_mahum", 20, 37, 29, "male", "L2Monster", 40, 4969.535732, 315.12, 24.603857, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 329.85528, 184.00957, 225.24839, 201.97531, 253, 4, 333, 127, 0, 0, 70, 110, 0, 1), 
(22486, 22486, "Lost Watcher", 0, "", 0, "LineageMonster.oel_mahum", 20, 37, 29, "male", "L2Monster", 40, 4969.535732, 315.12, 24.603857, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 329.85528, 184.00957, 225.24839, 201.97531, 253, 4, 333, 127, 0, 0, 70, 110, 0, 1), 
(22487, 22487, "Lost Beholder", 0, "", 0, "LineageMonster.oel_mahum_warrior", 20, 38, 29, "male", "L2Monster", 40, 9939.071465, 315.12, 24.603857, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 271.29951, 184.00957, 185.26239, 201.97531, 253, 4, 333, 72, 0, 0, 70, 160, 0, 1), 
(22488, 22488, "Lost Watcher", 0, "", 0, "LineageMonster.zenta_lizardman", 11, 32, 39, "male", "L2Monster", 40, 7316.989287, 463.32, 33.395798, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 953.49066, 243.94803, 651.1105, 267.76589, 253, 4, 333, 68, 0, 0, 37, 140, 0, 1), 
(22489, 22489, "Lost Watcher", 0, "", 0, "LineageMonster.zenta_lizardman", 11, 32, 39, "male", "L2Monster", 40, 7316.989287, 463.32, 33.395798, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 953.49066, 243.94803, 651.1105, 267.76589, 253, 4, 333, 68, 0, 0, 37, 140, 0, 1), 
(22490, 22490, "Lost Beholder", 0, "", 0, "LineageMonster.zenta_lizardman_warrior", 13, 35, 39, "male", "L2Monster", 40, 14607.417808, 463.32, 33.335185, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 789.38886, 243.94803, 539.05024, 267.76589, 253, 4, 333, 16, 0, 0, 40, 140, 0, 1), 
(22491, 22491, "Lost Watcher", 0, "", 0, "LineageMonster.stone_golem", 20, 31, 49, "male", "L2Monster", 40, 16605.687302, 720, 70.298676, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 1565.16715, 313.06083, 1068.80624, 343.6265, 253, 4, 333, 0, 0, 0, 23, 23, 0, 1), 
(22492, 22492, "Lost Watcher", 0, "", 0, "LineageMonster.stone_golem", 20, 31, 49, "male", "L2Monster", 40, 16605.687302, 720, 70.298676, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 1565.16715, 313.06083, 1068.80624, 343.6265, 253, 4, 333, 0, 0, 0, 23, 23, 0, 1), 
(22493, 22493, "Lost Beholder", 0, "", 0, "LineageMonster.iron_golem_bi", 27, 52, 49, "male", "L2Monster", 40, 33211.374604, 720, 70.298676, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 1315.39401, 313.06083, 898.24357, 343.6265, 253, 1, 333, 0, 0, 0, 20, 20, 0, 1), 
(22494, 22494, "Lost Watcher", 0, "", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 59, "male", "L2Monster", 40, 29968.582999, 1007, 118.297038, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 3540.84564, 388.50549, 2417.93856, 426.43718, 253, 4, 333, 946, 945, 0, 80, 120, 0, 1), 
(22495, 22495, "Lost Watcher", 0, "", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 59, "male", "L2Monster", 40, 29968.582999, 1007, 118.297038, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 3540.84564, 388.50549, 2417.93856, 426.43718, 253, 4, 333, 946, 945, 0, 80, 120, 0, 1), 
(22496, 22496, "Lost Beholder", 0, "", 0, "LineageMonster.doll_master", 20, 42, 59, "male", "L2Monster", 40, 59874.181126, 1007, 118.172726, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 3210.45135, 388.50549, 2192.32209, 426.43718, 253, 4, 333, 0, 0, 0, 80, 160, 0, 1), 
(22497, 22497, "Lost Watcher", 0, "", 0, "LineageMonster2.bandersnatch", 18, 25, 69, "male", "L2Monster", 40, 34683.559284, 1314, 128.243674, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 5371.91131, 465.84101, 3668.31908, 511.32334, 253, 4, 333, 0, 0, 0, 30, 170, 0, 1), 
(22498, 22498, "Lost Watcher", 0, "", 0, "LineageMonster2.bandersnatch", 18, 25, 69, "male", "L2Monster", 40, 34683.559284, 1314, 128.243674, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 5371.91131, 465.84101, 3668.31908, 511.32334, 253, 4, 333, 0, 0, 0, 30, 170, 0, 1), 
(22499, 22499, "Lost Beholder", 0, "", 0, "LineageMonster.onyx_beast_150p", 20, 23.5, 69, "male", "L2Monster", 40, 69294.294495, 1314, 128.109039, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 5265.71071, 465.84101, 3595.79784, 511.32334, 253, 1, 333, 0, 0, 0, 30, 170, 0, 1), 
(22500, 22500, "Lost Watcher", 0, "", 0, "LineageMonster.angel", 13.5, 36.5, 78, "male", "L2Monster", 40, 56858.245674, 1607.4, 198.905303, 3, 40, 43, 30, 21, 20, 20, 0, 0, 9019.50828, 532.32098, 6159.15502, 584.29409, 253, 4, 333, 148, 0, 0, 30, 170, 0, 1), 
(22501, 22501, "Lost Watcher", 0, "", 0, "LineageMonster.angel", 13.5, 36.5, 78, "male", "L2Monster", 40, 56858.245674, 1607.4, 198.905303, 3, 40, 43, 30, 21, 20, 20, 0, 0, 9019.50828, 532.32098, 6159.15502, 584.29409, 253, 4, 333, 148, 0, 0, 30, 170, 0, 1), 
(22502, 22502, "Lost Beholder", 0, "", 0, "LineageMonster2.apostle_warrior", 8, 30, 78, "female", "L2Monster", 40, 113626.925314, 1607.4, 198.74864, 3, 40, 43, 30, 21, 20, 20, 0, 0, 8818.27285, 532.32098, 6021.73731, 584.29409, 253, 4, 333, 6717, 0, 0, 50, 180, 0, 1), 
(22503, 22503, "Lost Watcher", 0, "", 0, "LineageMonster4.behamah", 25, 37.5, 81, "male", "L2Monster", 40, 56505.860351, 1708.8, 194.184226, 3, 40, 43, 30, 21, 20, 20, 0, 0, 9242.50952, 552.97803, 6311.43588, 606.96799, 253, 4, 333, 10278, 10278, 0, 70, 190, 0, 1), 
(22504, 22504, "Lost Watcher", 0, "", 0, "LineageMonster4.behamah", 25, 37.5, 81, "male", "L2Monster", 40, 56505.860351, 1708.8, 194.184226, 3, 40, 43, 30, 21, 20, 20, 0, 0, 9242.50952, 552.97803, 6311.43588, 606.96799, 253, 4, 333, 10278, 10278, 0, 70, 190, 0, 1), 
(22505, 22505, "Lost Beholder", 0, "", 0, "LineageMonster2.hundred_eye", 21, 55, 81, "male", "L2Monster", 40, 112922.200723, 1708.8, 194.030407, 3, 40, 43, 30, 21, 20, 20, 0, 0, 9025.28601, 552.97803, 6163.10038, 606.96799, 253, 4, 333, 0, 0, 0, 30, 170, 0, 1), 
(22506, 22506, "Boom - Child", 0, "", 0, "LineageMonster4.boom_eye", 33, 13.5, 75, "male", "L2Monster", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 10044, 1059, 476.82541, 287.32161, 325.60994, 210.24948, 253, 4, 333, 0, 0, 0, 250, 300, 0, 1), 
(22507, 22507, "Boom - Child", 0, "", 0, "LineageMonster4.boom_eye", 33, 13.5, 77, "male", "L2Monster", 40, 2856.768726, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 10067, 1089, 513.86434, 295.44366, 350.90273, 216.19284, 253, 4, 333, 0, 0, 0, 250, 300, 0, 1), 
(22508, 22508, "Boom - Child", 0, "", 0, "LineageMonster4.boom_eye", 33, 13.5, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 10499, 1178, 582.32253, 307.2375, 397.6508, 224.82307, 253, 4, 333, 0, 0, 0, 250, 300, 0, 1), 
(22509, 22509, "Fanatic of Infinity", 0, "", 0, "LineageMonster4.ravager_silen", 27, 48.5, 76, "male", "L2Monster", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 75564, 7698, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 0, 0, 0, 92, 200, 0, 1), 
(22510, 22510, "Rotten Messenger", 0, "", 0, "LineageMonster4.death_scout_088p", 14.4, 22, 77, "female", "L2Monster", 40, 2856.768726, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 68060, 7007, 856.44056, 328.27073, 584.83789, 240.21427, 253, 4, 333, 0, 0, 0, 45, 160, 0, 1), 
(22511, 22511, "Zealot of Infinity", 0, "", 0, "LineageMonster4.disciple_silen", 19, 44, 77, "male", "L2Monster", 40, 2856.768726, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 69384, 7150, 856.44056, 328.27073, 584.83789, 240.21427, 253, 4, 333, 0, 0, 0, 73, 170, 0, 1), 
(22512, 22512, "Body Severer", 0, "", 0, "LineageMonster4.bonecreeper", 43, 47.5, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 72891, 7605, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 50, 200, 0, 1), 
(22513, 22513, "Body Harvester", 0, "", 0, "LineageMonster4.corpseshambler", 34, 34, 79, "male", "L2Monster", 40, 3127.824593, 1641, 8.5, 3, 40, 43, 30, 21, 20, 20, 74772, 7900, 929.93081, 337.07008, 635.0222, 246.65326, 253, 4, 333, 0, 0, 0, 50, 200, 0, 1), 
(22514, 22514, "Soul Exploiter", 0, "", 0, "LineageMonster4.soul_harvester", 23, 31, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 66417, 7094, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 46, 200, 0, 1), 
(22515, 22515, "Soul Devourer", 0, "", 0, "LineageMonster4.soul_wagon_104p", 56, 35.36, 80, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 63246, 6665, 1018.31276, 347.65631, 699.49026, 254.3998, 253, 4, 333, 0, 0, 0, 100, 200, 0, 1), 
(22516, 22516, "Butcher of Infinity", 0, "", 0, "LineageMonster4.ravager_silen", 27, 48.5, 80, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 55248, 5826, 1018.31276, 347.65631, 699.49026, 254.3998, 253, 4, 333, 0, 0, 0, 92, 200, 0, 1), 
(22517, 22517, "Disciple of Infinity", 0, "", 0, "LineageMonster4.disciple_silen", 19, 44, 80, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 48912, 5151, 1018.31276, 347.65631, 699.49026, 254.3998, 253, 4, 333, 0, 0, 0, 73, 170, 0, 1), 
(22518, 22518, "Rotten Messenger", 0, "", 0, "LineageMonster4.death_scout_088p", 14.4, 22, 80, "female", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 51135, 5315, 1067.77425, 353.91412, 737.7804, 258.97899, 253, 4, 333, 0, 0, 0, 45, 160, 0, 1), 
(22519, 22519, "Body Harvester", 0, "", 0, "LineageMonster4.corpseshambler", 34, 34, 81, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 58036, 5981, 1112.35801, 358.02452, 768.53275, 261.98681, 253, 4, 333, 0, 0, 0, 50, 200, 0, 1), 
(22520, 22520, "Body Severer", 0, "", 0, "LineageMonster4.bonecreeper", 43, 47.5, 81, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 56345, 5798, 1112.35801, 358.02452, 768.53275, 261.98681, 253, 4, 333, 0, 0, 0, 50, 200, 0, 1), 
(22521, 22521, "Soul Exploiter", 0, "", 0, "LineageMonster4.soul_harvester", 23, 31, 81, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 55722, 5702, 1112.35801, 358.02452, 768.53275, 261.98681, 253, 4, 333, 0, 0, 0, 46, 200, 0, 1), 
(22522, 22522, "Soul Devourer", 0, "", 0, "LineageMonster4.soul_wagon_104p", 56, 35.36, 81, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 50431, 5238, 1061.49322, 351.83227, 729.12616, 257.45559, 253, 4, 333, 0, 0, 0, 100, 200, 0, 1), 
(22523, 22523, "Soul Devourer", 0, "Food of Ekimus", 0, "LineageMonster4.soul_wagon_130p", 70, 44.2, 81, "male", "L2Monster", 40, 112020.349673, 1812, 189.142969, 3, 40, 43, 30, 21, 20, 20, 1168301, 118417, 9241.42475, 582.69205, 6422.06032, 639.58314, 253, 4, 333, 0, 0, 0, 110, 200, 0, 1), 
(22524, 22524, "Emissary of Death", 0, "", 0, "LineageMonster4.Death_slayer_080p", 16, 27.2, 81, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 57235, 5894, 1112.35801, 358.02452, 768.53275, 261.98681, 253, 4, 333, 13984, 0, 0, 64, 200, 0, 1), 
(22525, 22525, "Emissary of Death", 0, "", 0, "LineageMonster4.Death_slayer", 20, 34, 81, "male", "L2Monster", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 60043, 6109, 1164.93244, 364.18253, 809.53604, 266.49298, 253, 4, 333, 13984, 0, 0, 68, 200, 0, 1), 
(22526, 22526, "Emissary of Death", 0, "", 0, "LineageMonster4.Death_slayer_080p", 16, 27.2, 81, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 58819, 6058, 1112.35801, 358.02452, 768.53275, 261.98681, 253, 4, 333, 13985, 13986, 0, 64, 200, 0, 1), 
(22527, 22527, "Emissary of Death", 0, "", 0, "LineageMonster4.Death_slayer", 20, 34, 81, "male", "L2Monster", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 61705, 6278, 1164.93244, 364.18253, 809.53604, 266.49298, 253, 4, 333, 13985, 13986, 0, 68, 200, 0, 1), 
(22528, 22528, "Cursed Prefect", 0, "", 0, "LineageMonster4.death_knight_n_104p", 22.88, 41.6, 81, "male", "L2Monster", 80, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 74222, 7643, 1112.35801, 358.02452, 768.53275, 261.98681, 253, 4, 333, 13982, 0, 0, 42.5, 180, 0, 1), 
(22529, 22529, "Cursed Prefect", 0, "", 0, "LineageMonster4.death_knight_n_130p", 28.6, 52, 81, "male", "L2Monster", 80, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 77864, 7922, 1164.93244, 364.18253, 809.53604, 266.49298, 253, 4, 333, 13982, 0, 0, 46.5, 180, 0, 1), 
(22530, 22530, "Cursed Prefect", 0, "", 0, "LineageMonster4.death_knight_n_104p", 22.88, 41.6, 81, "male", "L2Monster", 80, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 59237, 6106, 1112.35801, 358.02452, 768.53275, 261.98681, 253, 4, 333, 13983, 0, 0, 42.5, 180, 0, 1), 
(22531, 22531, "Cursed Prefect", 0, "", 0, "LineageMonster4.death_knight_n_130p", 28.6, 52, 81, "male", "L2Monster", 80, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 62144, 6328, 1164.93244, 364.18253, 809.53604, 266.49298, 253, 4, 333, 13983, 0, 0, 46.5, 180, 0, 1), 
(22532, 22532, "Law Scholar of Conclusions", 0, "", 0, "LineageMonster4.lich_A_088p", 21.12, 40.48, 81, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 56060, 5767, 1112.35801, 358.02452, 768.53275, 261.98681, 253, 4, 333, 0, 0, 0, 46, 200, 0, 1), 
(22533, 22533, "Law Scholar of Conclusions", 0, "", 0, "LineageMonster4.lich_A_110p", 26.4, 50.6, 81, "male", "L2Monster", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 58811, 5977, 1164.93244, 364.18253, 809.53604, 266.49298, 253, 4, 333, 0, 0, 0, 46, 200, 0, 1), 
(22534, 22534, "Law Scholar of Conclusions", 0, "", 0, "LineageMonster4.lich_b_088p", 21.12, 40.48, 81, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 53542, 5495, 1112.35801, 358.02452, 768.53275, 261.98681, 253, 4, 333, 0, 0, 0, 46, 200, 0, 1), 
(22535, 22535, "Law Scholar of Conclusions", 0, "", 0, "LineageMonster4.lich_b_110p", 26.4, 50.6, 81, "male", "L2Monster", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 56169, 5696, 1164.93244, 364.18253, 809.53604, 266.49298, 253, 4, 333, 0, 0, 0, 46, 200, 0, 1), 
(22536, 22536, "Royal Guard Captain", 0, "", 0, "LineageMonster4.Dragon_eliteguard_075p", 40, 55, 81, "male", "L2Monster", 80, 32744.826519, 1812, 110.577297, 3, 40, 43, 30, 21, 20, 20, 333644, 33883, 5940.39947, 582.69205, 4128.10846, 639.58314, 253, 4, 333, 0, 0, 0, 100, 200, 0, 1), 
(22537, 22537, "Dragon Steed Troop Grand Magician", 0, "", 0, "LineageMonster4.Dragon_archmage_135p", 29, 49.9, 81, "male", "L2Monster", 40, 32744.826519, 1812, 110.577297, 3, 40, 43, 30, 21, 20, 20, 73171, 7447, 5940.39947, 582.69205, 4128.10846, 639.58314, 253, 4, 333, 0, 0, 0, 43, 170, 0, 1), 
(22538, 22538, "Dragon Steed Troop Commander", 0, "", 0, "LineageMonster4.Dragon_centurion_135p", 28, 46.5, 81, "male", "L2Monster", 80, 32829.283195, 1777.4, 111.507051, 3, 40, 43, 30, 21, 20, 20, 96783, 10083, 5883.70412, 572.83923, 4065.07552, 628.76834, 253, 4, 333, 13978, 0, 0, 55, 210, 0, 1), 
(22539, 22539, "Dragon Steed Troops No 1 Battalion Commander", 0, "", 0, "LineageMonster4.Dragon_centurion_135p", 28, 46.5, 81, "male", "L2Monster", 80, 32946.042468, 1743, 112.55804, 3, 40, 43, 30, 21, 20, 20, 98080, 10347, 5827.40072, 562.93163, 4002.76725, 617.89341, 253, 4, 333, 13978, 0, 0, 55, 210, 0, 1), 
(22540, 22540, "White Dragon Leader", 0, "", 0, "LineageMonster4.Dragon_centurion_120p", 22, 42, 81, "male", "L2Monster", 40, 33003.982801, 1708.8, 113.41926, 3, 40, 43, 30, 21, 20, 20, 82134, 8708, 5770.14557, 552.97803, 3940.26143, 606.96799, 253, 4, 333, 13979, 13980, 0, 56, 210, 0, 1), 
(22541, 22541, "Dragon Steed Troop Infantry", 0, "", 0, "LineageMonster4.Dragon_centurion_120p", 22, 42, 80, "male", "L2Monster", 40, 33093.42748, 1674.8, 114.399578, 3, 40, 43, 30, 21, 20, 20, 83347, 8955, 5746.81896, 546.2, 3924.33235, 599.52818, 253, 4, 333, 13979, 13980, 0, 56, 210, 0, 1), 
(22542, 22542, "Dragon Steed Troop Magic Leader", 0, "", 0, "LineageMonster4.dragon_mage_075p", 28, 39.5, 81, "male", "L2Monster", 40, 32946.042468, 1743, 112.55804, 3, 40, 43, 30, 21, 20, 20, 193521, 21161, 5827.40072, 562.93163, 4002.76725, 617.89341, 253, 4, 333, 0, 0, 0, 92, 170, 0, 1), 
(22543, 22543, "Dragon Steed Troop Magician", 0, "", 0, "LineageMonster4.dragon_mage_075p", 28, 39.5, 81, "male", "L2Monster", 40, 33003.982801, 1708.8, 113.41926, 3, 40, 43, 30, 21, 20, 20, 79493, 8397, 5770.14557, 552.97803, 3940.26143, 606.96799, 253, 4, 333, 0, 0, 0, 92, 170, 0, 1), 
(22544, 22544, "Dragon Steed Troop Magic Soldier", 0, "", 0, "LineageMonster4.dragon_mage_065p", 25, 34.5, 80, "male", "L2Monster", 40, 33093.42748, 1674.8, 114.399578, 3, 40, 43, 30, 21, 20, 20, 84936, 9090, 5746.81896, 546.2, 3924.33235, 599.52818, 253, 4, 333, 13981, 0, 0, 82, 170, 0, 1), 
(22545, 22545, "Wife of the Dragon of Darkness", 0, "", 0, "LineageMonster4.dragon_shadow_110p", 60, 66, 81, "male", "L2Monster", 40, 32829.283195, 1777.4, 111.507051, 3, 40, 43, 30, 21, 20, 20, 203716, 22000, 5883.70412, 572.83923, 4065.07552, 628.76834, 253, 4, 333, 0, 0, 0, 46, 160, 0, 1), 
(22546, 22546, "Warrior of Light", 0, "", 0, "LineageMonster4.dragon_berserker_090p", 50, 55, 79, "male", "L2Monster", 40, 33155.371896, 1641, 115.295936, 3, 40, 43, 30, 21, 20, 20, 82511, 8653, 5679.0786, 539.31213, 3878.07448, 591.96782, 253, 4, 333, 0, 0, 0, 100, 200, 0, 1), 
(22547, 22547, "Dragon Steed Troop Healer", 0, "", 0, "LineageMonster4.dragon_mage_065p", 25, 34.5, 79, "male", "L2Monster", 40, 33155.371896, 1641, 115.295936, 3, 40, 43, 30, 21, 20, 20, 59035, 6215, 5679.0786, 539.31213, 3878.07448, 591.96782, 253, 4, 333, 13981, 0, 0, 82, 170, 0, 1), 
(22548, 22548, "Dragon Steed Troop Javelin Thrower", 0, "", 0, "LineageMonster4.dragon_peltast", 25, 46.5, 80, "male", "L2Monster", 1100, 33093.42748, 1674.8, 114.399578, 3, 40, 43, 30, 21, 20, 20, 94968, 10260, 5746.81896, 546.2, 3924.33235, 599.52818, 253, 8, 333, 13843, 0, 0, 89, 220, 0, 1), 
(22549, 22549, "Dragon Steed Troop Javelin Thrower", 0, "", 0, "LineageMonster4.dragon_peltast", 25, 46.5, 80, "male", "L2Monster", 1100, 33093.42748, 1674.8, 114.399578, 3, 40, 43, 30, 21, 20, 20, 94968, 10260, 5746.81896, 546.2, 3924.33235, 599.52818, 253, 8, 333, 13843, 0, 0, 89, 220, 0, 1), 
(22550, 22550, "Savage Warrior", 0, "", 0, "LineageMonster4.ravager_silen", 27, 48.5, 77, "male", "L2Monster", 40, 19627.085937, 1574, 69.074399, 3, 40, 43, 30, 21, 20, 20, 103619, 10725, 4149.83975, 525.23317, 2833.80263, 576.51425, 253, 1, 333, 13987, 0, 0, 92, 200, 0, 1), 
(22551, 22551, "Priest of Darkness", 0, "", 0, "LineageMonster4.disciple_silen", 19, 44, 76, "male", "L2Monster", 40, 19633.378776, 1540.8, 69.515312, 3, 40, 43, 30, 21, 20, 20, 95778, 9756, 4090.13417, 518.05528, 2793.03141, 568.63558, 253, 4, 333, 0, 0, 0, 73, 170, 0, 1), 
(22552, 22552, "Mutation Drake", 0, "", 0, "LineageMonster4.Mutant_drake", 48, 53.5, 78, "male", "L2Monster", 40, 33212.87365, 1607.4, 116.187487, 3, 40, 43, 30, 21, 20, 20, 92347, 9614, 5606.14187, 532.32098, 3828.26821, 584.29409, 253, 4, 333, 0, 0, 0, 46, 200, 0, 1), 
(22553, 22553, "Large Crystal Core", 0, "", 0, "LineageNpcEV.source_facility", 62, 140, 75, "female", "L2Monster", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 8087, 852, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(22554, 22554, "Small Crystal Core", 0, "", 0, "LineageNpcEV.source_facility", 62, 140, 75, "female", "L2Monster", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 8087, 852, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(22555, 22555, "Small Crystal Core", 0, "", 0, "LineageNpcEV.source_facility", 62, 140, 75, "female", "L2Monster", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 8087, 852, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(22556, 22556, "Small Crystal Core", 0, "", 0, "LineageNpcEV.source_facility", 62, 140, 75, "female", "L2Monster", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 8087, 852, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(22557, 22557, "Defense Mechanism", 0, "", 0, "LineageMonster4.defence_mech", 86, 133.5, 75, "male", "L2Monster", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 8087, 852, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 45, 300, 0, 1), 
(22558, 22558, "Defense Battery", 0, "", 0, "LineageMonster4.defence_mech", 86, 133.5, 75, "male", "L2Monster", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 8087, 852, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 45, 300, 0, 1), 
(22559, 22559, "Defeated Troops Commander", 0, "", 0, "LineageMonster4.Dragon_centurion_135p", 28, 46.5, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 55, 210, 0, 1), 
(22560, 22560, "Defeated Troops No 1 Battalion Commander", 0, "", 0, "LineageMonster4.Dragon_centurion_135p", 28, 46.5, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 55, 210, 0, 1), 
(22561, 22561, "Defeated Troops White Dragon Leader", 0, "", 0, "LineageMonster4.Dragon_centurion_120p", 22, 42, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 0, 0, 0, 56, 210, 0, 1), 
(22562, 22562, "Defeated Troops Infantry", 0, "", 0, "LineageMonster4.Dragon_centurion_120p", 22, 42, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 56, 210, 0, 1), 
(22563, 22563, "Defeated Troops Magic Leader", 0, "", 0, "LineageMonster4.dragon_mage_075p", 28, 39.5, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 92, 170, 0, 1), 
(22564, 22564, "Defeated Troops Magician", 0, "", 0, "LineageMonster4.dragon_mage_075p", 28, 39.5, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 0, 0, 0, 92, 170, 0, 1), 
(22565, 22565, "Defeated Troops Magic Soldier", 0, "", 0, "LineageMonster4.dragon_mage_065p", 25, 34.5, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 82, 170, 0, 1), 
(22566, 22566, "Defeated Troops Healer", 0, "", 0, "LineageMonster4.dragon_mage_065p", 25, 34.5, 79, "male", "L2Monster", 40, 3127.824593, 1641, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 929.93081, 337.07008, 635.0222, 246.65326, 253, 4, 333, 0, 0, 0, 82, 170, 0, 1), 
(22567, 22567, "Defeated Troops Javelin Thrower", 0, "", 0, "LineageMonster4.dragon_peltast", 25, 46.5, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 89, 220, 0, 1), 
(22568, 22568, "Defeated Troops Javelin Thrower", 0, "", 0, "LineageMonster4.dragon_peltast", 25, 46.5, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 89, 220, 0, 1), 
(22569, 22569, "Soldiers of Bravery", 0, "Tiat's Bodyguard", 0, "LineageMonster4.dragon_rider", 36, 51, 81, "male", "L2Monster", 80, 334640.100173, 1846.8, 187.260794, 3, 40, 43, 30, 21, 20, 20, 1322725, 139467, 8090.10762, 592.48128, 5654.48287, 650.32814, 253, 4, 333, 0, 0, 0, 60, 200, 0, 1), 
(22570, 22570, "Royal Guard Captain", 0, "", 0, "LineageMonster4.Dragon_eliteguard_075p", 40, 55, 81, "male", "L2Monster", 40, 336061.04902, 1812, 189.142969, 3, 40, 43, 30, 21, 20, 20, 2410562, 244753, 7957.47326, 582.69205, 5529.81543, 639.58314, 253, 4, 333, 0, 0, 0, 100, 200, 0, 1), 
(22571, 22571, "Dragon Steed Troop Grand Magician", 0, "", 0, "LineageMonster4.Dragon_archmage_135p", 29, 49.9, 81, "male", "L2Monster", 40, 56054.754552, 1812, 189.293512, 3, 40, 43, 30, 21, 20, 20, 565516, 57381, 9475.50662, 582.69205, 6584.72873, 639.58314, 253, 4, 333, 0, 0, 0, 43, 170, 0, 1), 
(22572, 22572, "Dragon Steed Troop Commander", 0, "", 0, "LineageMonster4.Dragon_centurion_135p", 28, 46.5, 81, "male", "L2Monster", 80, 112316.374696, 1777.4, 190.745373, 3, 40, 43, 30, 21, 20, 20, 1277122, 131629, 9169.67356, 572.83923, 6335.36539, 628.76834, 253, 4, 333, 13978, 0, 0, 55, 210, 0, 1), 
(22573, 22573, "Dragon Steed Troops No 1 Battalion Commander", 0, "", 0, "LineageMonster4.Dragon_centurion_135p", 28, 46.5, 81, "male", "L2Monster", 80, 112716.915514, 1743, 192.545054, 3, 40, 43, 30, 21, 20, 20, 352899, 37237, 9098.07293, 562.93163, 6249.35028, 617.89341, 253, 4, 333, 13978, 0, 0, 55, 210, 0, 1), 
(22574, 22574, "White Dragon Leader", 0, "", 0, "LineageMonster4.Dragon_centurion_120p", 22, 42, 81, "male", "L2Monster", 40, 112922.200723, 1708.8, 194.030407, 3, 40, 43, 30, 21, 20, 20, 294906, 31273, 9025.28601, 552.97803, 6163.10038, 606.96799, 253, 4, 333, 13979, 13980, 0, 56, 210, 0, 1), 
(22575, 22575, "Dragon Steed Troop Infantry", 0, "", 0, "LineageMonster4.Dragon_centurion_120p", 22, 42, 80, "male", "L2Monster", 40, 113229.052562, 1674.8, 195.708889, 3, 40, 43, 30, 21, 20, 20, 299241, 32156, 9005.41719, 546.2, 6149.53252, 599.52818, 253, 4, 333, 13979, 13980, 0, 56, 210, 0, 1), 
(22576, 22576, "Dragon Steed Troop Magic Leader", 0, "", 0, "LineageMonster4.dragon_mage_075p", 28, 39.5, 81, "male", "L2Monster", 40, 56403.194323, 1743, 192.697894, 3, 40, 43, 30, 21, 20, 20, 136941, 14290, 9320.82549, 562.93163, 6402.35617, 617.89341, 253, 4, 333, 0, 0, 0, 92, 170, 0, 1), 
(22577, 22577, "Dragon Steed Troop Magician", 0, "", 0, "LineageMonster4.dragon_mage_075p", 28, 39.5, 81, "male", "L2Monster", 40, 56505.860351, 1708.8, 194.184226, 3, 40, 43, 30, 21, 20, 20, 136094, 14370, 9242.50952, 552.97803, 6311.43588, 606.96799, 253, 4, 333, 0, 0, 0, 92, 170, 0, 1), 
(22578, 22578, "Dragon Steed Troop Magic Soldier", 0, "", 0, "LineageMonster4.dragon_mage_065p", 25, 34.5, 80, "male", "L2Monster", 40, 56659.313636, 1674.8, 195.863713, 3, 40, 43, 30, 21, 20, 20, 151605, 16251, 9218.40693, 546.2, 6294.97689, 599.52818, 253, 4, 333, 13981, 0, 0, 82, 170, 0, 1), 
(22579, 22579, "Warrior of Light", 0, "", 0, "LineageMonster4.dragon_berserker_090p", 50, 55, 79, "male", "L2Monster", 40, 56759.800767, 1641, 197.379006, 3, 40, 43, 30, 21, 20, 20, 156549, 16504, 9122.90867, 539.31213, 6229.76399, 591.96782, 253, 4, 333, 0, 0, 0, 100, 200, 0, 1), 
(22580, 22580, "Dragon Steed Troop Healer", 0, "", 0, "LineageMonster4.dragon_mage_065p", 25, 34.5, 79, "male", "L2Monster", 40, 56759.800767, 1641, 197.379006, 3, 40, 43, 30, 21, 20, 20, 102203, 10760, 9122.90867, 539.31213, 6229.76399, 591.96782, 253, 4, 333, 13981, 0, 0, 82, 170, 0, 1), 
(22581, 22581, "Dragon Steed Troop Javelin Thrower", 0, "", 0, "LineageMonster4.dragon_peltast", 25, 46.5, 80, "male", "L2Monster", 1100, 56659.313636, 1674.8, 195.863713, 3, 40, 43, 30, 21, 20, 20, 170995, 18501, 9218.40693, 546.2, 6294.97689, 599.52818, 253, 8, 333, 13843, 0, 0, 89, 220, 0, 1), 
(22582, 22582, "Dragon Steed Troop Javelin Thrower", 0, "", 0, "LineageMonster4.dragon_peltast", 25, 46.5, 80, "male", "L2Monster", 1100, 56659.313636, 1674.8, 195.863713, 3, 40, 43, 30, 21, 20, 20, 170995, 18501, 9218.40693, 546.2, 6294.97689, 599.52818, 253, 8, 333, 13843, 0, 0, 89, 220, 0, 1), 
(22583, 22583, "Dragon Steed Troop Magic Leader", 0, "", 0, "LineageMonster4.dragon_mage_075p", 28, 39.5, 81, "male", "L2Monster", 40, 56403.194323, 1743, 192.697894, 3, 40, 43, 30, 21, 20, 20, 140831, 14711, 9320.82549, 562.93163, 6402.35617, 617.89341, 253, 4, 333, 0, 0, 0, 92, 170, 0, 1), 
(22584, 22584, "Dragon Steed Troop Magician", 0, "", 0, "LineageMonster4.dragon_mage_075p", 28, 39.5, 81, "male", "L2Monster", 40, 56505.860351, 1708.8, 194.184226, 3, 40, 43, 30, 21, 20, 20, 142800, 15110, 9242.50952, 552.97803, 6311.43588, 606.96799, 253, 4, 333, 0, 0, 0, 92, 170, 0, 1), 
(22585, 22585, "Dragon Steed Troop Magic Soldier", 0, "", 0, "LineageMonster4.dragon_mage_065p", 25, 34.5, 80, "male", "L2Monster", 40, 33093.42748, 1674.8, 114.399578, 3, 40, 43, 30, 21, 20, 20, 87030, 9329, 5746.81896, 546.2, 3924.33235, 599.52818, 253, 4, 333, 13981, 0, 0, 82, 170, 0, 1), 
(22586, 22586, "Dragon Steed Troop Commander", 0, "", 0, "LineageMonster4.Dragon_centurion_135p", 28, 46.5, 81, "male", "L2Monster", 80, 112316.374696, 1777.4, 190.745373, 3, 40, 43, 30, 21, 20, 20, 1295378, 133568, 9169.67356, 572.83923, 6335.36539, 628.76834, 253, 4, 333, 13978, 0, 0, 55, 210, 0, 1), 
(22587, 22587, "Dragon Steed Troop Captain #1", 0, "", 0, "LineageMonster4.Dragon_centurion_135p", 28, 46.5, 81, "male", "L2Monster", 80, 112716.915514, 1743, 192.545054, 3, 40, 43, 30, 21, 20, 20, 365328, 38596, 9098.07293, 562.93163, 6249.35028, 617.89341, 253, 4, 333, 13978, 0, 0, 55, 210, 0, 1), 
(22588, 22588, "White Dragon Leader", 0, "", 0, "LineageMonster4.Dragon_centurion_120p", 22, 42, 81, "male", "L2Monster", 40, 112922.200723, 1708.8, 194.030407, 3, 40, 43, 30, 21, 20, 20, 272419, 28783, 9025.28601, 552.97803, 6163.10038, 606.96799, 253, 4, 333, 13979, 13980, 0, 56, 210, 0, 1), 
(22589, 22589, "Dragon Steed Troop Infantry", 0, "", 0, "LineageMonster4.Dragon_centurion_120p", 22, 42, 80, "male", "L2Monster", 40, 113229.052562, 1674.8, 195.708889, 3, 40, 43, 30, 21, 20, 20, 276411, 29594, 9005.41719, 546.2, 6149.53252, 599.52818, 253, 4, 333, 13979, 13980, 0, 56, 210, 0, 1), 
(22590, 22590, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 73, "male", "L2Monster", 40, 18851.043789, 1442.4, 67.981347, 3, 40, 43, 30, 21, 20, 20, 116750, 11412, 3785.57534, 496.04734, 2585.05723, 544.47888, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(22591, 22591, "Dragon Steed Troop Magic Leader", 0, "", 0, "LineageMonster4.dragon_mage_075p", 28, 39.5, 81, "male", "L2Monster", 40, 32946.042468, 1743, 112.55804, 3, 40, 43, 30, 21, 20, 20, 82741, 8651, 5827.40072, 562.93163, 4002.76725, 617.89341, 253, 4, 333, 0, 0, 0, 92, 170, 0, 1), 
(22592, 22592, "Dragon Steed Troop Magician", 0, "", 0, "LineageMonster4.dragon_mage_075p", 28, 39.5, 81, "male", "L2Monster", 40, 33003.982801, 1708.8, 113.41926, 3, 40, 43, 30, 21, 20, 20, 82322, 8710, 5770.14557, 552.97803, 3940.26143, 606.96799, 253, 4, 333, 0, 0, 0, 92, 170, 0, 1), 
(22593, 22593, "Dragon Steed Troop Magic Soldier", 0, "", 0, "LineageMonster4.dragon_mage_065p", 25, 34.5, 80, "male", "L2Monster", 40, 33093.42748, 1674.8, 114.399578, 3, 40, 43, 30, 21, 20, 20, 87800, 9411, 5746.81896, 546.2, 3924.33235, 599.52818, 253, 4, 333, 13981, 0, 0, 82, 170, 0, 1), 
(22594, 22594, "Dragon Steed Troop Commander", 0, "", 0, "LineageMonster4.Dragon_centurion_135p", 28, 46.5, 81, "male", "L2Monster", 80, 32829.283195, 1777.4, 111.507051, 3, 40, 43, 30, 21, 20, 20, 359407, 37057, 5883.70412, 572.83923, 4065.07552, 628.76834, 253, 4, 333, 13978, 0, 0, 55, 210, 0, 1), 
(22595, 22595, "Dragon Steed Troops No 1 Battalion Commander", 0, "", 0, "LineageMonster4.Dragon_centurion_135p", 28, 46.5, 81, "male", "L2Monster", 80, 32946.042468, 1743, 112.55804, 3, 40, 43, 30, 21, 20, 20, 362118, 37795, 5827.40072, 562.93163, 4002.76725, 617.89341, 253, 4, 333, 13978, 0, 0, 55, 210, 0, 1), 
(22596, 22596, "White Dragon Leader", 0, "", 0, "LineageMonster4.Dragon_centurion_120p", 22, 42, 81, "male", "L2Monster", 40, 33003.982801, 1708.8, 113.41926, 3, 40, 43, 30, 21, 20, 20, 87965, 9354, 5770.14557, 552.97803, 3940.26143, 606.96799, 253, 4, 333, 13979, 13980, 0, 56, 210, 0, 1), 
(22597, 22597, "Dragon Steed Troop Infantry", 0, "", 0, "LineageMonster4.Dragon_centurion_120p", 22, 42, 80, "male", "L2Monster", 40, 33093.42748, 1674.8, 114.399578, 3, 40, 43, 30, 21, 20, 20, 89268, 9620, 5746.81896, 546.2, 3924.33235, 599.52818, 253, 4, 333, 13979, 13980, 0, 56, 210, 0, 1), 
(22598, 22598, "Obelisk", 0, "", 0, "LineageNpcEV.obelisk_of_middle_square", 229, 177.5, 82, "female", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(22599, 22599, "Great Powerful Device", 0, "", 0, "LineageNpcEV.crystal_of_secret_door", 57, 74, 82, "female", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(22600, 22600, "Throne of Destruction Powerful Device", 0, "", 0, "LineageNpcEV.protector_of_seed", 57, 74, 82, "female", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(22601, 22601, "Heart Protection Device", 0, "", 0, "LineageNpcEV.crystal_of_secret_door", 57, 74, 73, "female", "L2Monster", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(22602, 22602, "Mutant - Bird", 0, "", 0, "LineageMonster4.mutant_hawk", 100, 85, 73, "male", "L2FlyMonster", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 14171, 1458, 451.64357, 279.02663, 308.41401, 204.17958, 253, 4, 333, 0, 0, 0, 60, 300, 0, 1), 
(22603, 22603, "Mutant - Bird", 0, "", 0, "LineageMonster4.mutant_hawk", 100, 85, 74, "male", "L2FlyMonster", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 14562, 1517, 464.28959, 283.19388, 317.04961, 207.229, 253, 4, 333, 0, 0, 0, 60, 300, 0, 1), 
(22604, 22604, "Dra Hawk", 0, "", 0, "LineageMonster4.drahawk", 110, 35, 74, "female", "L2FlyMonster", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 9167, 955, 464.28959, 283.19388, 317.04961, 207.229, 253, 4, 333, 0, 0, 0, 60, 300, 0, 1), 
(22605, 22605, "Dra Hawk", 0, "", 0, "LineageMonster4.drahawk", 110, 35, 75, "female", "L2FlyMonster", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 9416, 993, 476.82541, 287.32161, 325.60994, 210.24948, 253, 4, 333, 0, 0, 0, 60, 300, 0, 1), 
(22606, 22606, "Floating Skull", 0, "", 0, "LineageMonster4.floating_skeleton", 28, 39, 76, "male", "L2FlyMonster", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 10528, 1125, 494.65324, 291.4061, 337.78404, 213.23834, 253, 4, 333, 0, 0, 0, 45, 300, 0, 1), 
(22607, 22607, "Floating Skull", 0, "", 0, "LineageMonster4.floating_skeleton", 28, 39, 77, "male", "L2FlyMonster", 40, 2856.768726, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 17574, 1901, 513.86434, 295.44366, 350.90273, 216.19284, 253, 4, 333, 0, 0, 0, 45, 300, 0, 1), 
(22608, 22608, "Floating Zombie", 0, "", 0, "LineageMonster4.floating_zombie", 70, 50, 75, "female", "L2FlyMonster", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 9720, 1025, 476.82541, 287.32161, 325.60994, 210.24948, 253, 4, 333, 0, 0, 0, 60, 300, 0, 1), 
(22609, 22609, "Floating Zombie", 0, "", 0, "LineageMonster4.floating_zombie", 70, 50, 76, "female", "L2FlyMonster", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 9475, 1012, 494.65324, 291.4061, 337.78404, 213.23834, 253, 4, 333, 0, 0, 0, 60, 300, 0, 1), 
(22610, 22610, "Mutated Drake Wing", 0, "", 0, "LineageMonster4.m_drake_wing_knave", 153, 63, 75, "male", "L2FlyMonster", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 11981, 1263, 476.82541, 287.32161, 325.60994, 210.24948, 253, 4, 333, 0, 0, 0, 60, 300, 0, 1), 
(22611, 22611, "Mutated Drake Wing", 0, "", 0, "LineageMonster4.m_drake_wing_knave", 153, 63, 76, "male", "L2FlyMonster", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 11797, 1261, 494.65324, 291.4061, 337.78404, 213.23834, 253, 4, 333, 0, 0, 0, 60, 300, 0, 1), 
(22612, 22612, "Drak", 0, "", 0, "LineageMonster4.drac", 100, 40, 76, "female", "L2FlyMonster", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 11485, 1227, 494.65324, 291.4061, 337.78404, 213.23834, 253, 4, 333, 0, 0, 0, 60, 300, 0, 1), 
(22613, 22613, "Drak", 0, "", 0, "LineageMonster4.drac", 100, 40, 77, "female", "L2FlyMonster", 40, 2856.768726, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 11789, 1275, 513.86434, 295.44366, 350.90273, 216.19284, 253, 4, 333, 0, 0, 0, 60, 300, 0, 1), 
(22614, 22614, "Vulture Rider", 0, "", 0, "LineageMonster4.master_rider", 123, 90, 74, "male", "L2FlyMonster", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 10093, 1052, 464.28959, 283.19388, 317.04961, 207.229, 253, 4, 333, 0, 0, 0, 60, 300, 0, 1), 
(22615, 22615, "Vulture Rider", 0, "", 0, "LineageMonster4.master_rider", 123, 90, 75, "male", "L2FlyMonster", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 10368, 1093, 476.82541, 287.32161, 325.60994, 210.24948, 253, 4, 333, 0, 0, 0, 60, 300, 0, 1), 
(22616, 22616, "Seed of Pain", 0, "", 0, "LineageMonster4.death_claw_054p", 14, 42, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 46442, 4907, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 0, 0, 0, 45, 180, 0, 1), 
(22617, 22617, "Spiked Stakato", 0, "", 0, "LineageMonster.blade_stakato_120p", 18, 43.2, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 92371, 9623, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 25, 200, 0, 1), 
(22618, 22618, "Spiked Stakato Worker", 0, "", 0, "LineageMonster.blade_stakato_worker_120p", 22, 48.3, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 92371, 9623, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 221, 0, 0, 25, 200, 0, 1), 
(22619, 22619, "Spiked Stakato Guard", 0, "", 0, "LineageMonster.spike_stakato", 16, 22.8, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 61248, 6382, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 123, 0, 0, 23, 200, 0, 1), 
(22620, 22620, "Female Spiked Stakato", 0, "", 0, "LineageMonster.spike_stakato_soldier", 17, 30, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 95359, 9925, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 123, 0, 0, 60, 220, 0, 1), 
(22621, 22621, "Male Spiked Stakato", 0, "", 0, "LineageMonster.marsh_stakato_soldier_120p", 18, 31, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 90357, 9403, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 135, 0, 0, 30, 200, 0, 1), 
(22622, 22622, "Male Spiked Stakato", 0, "", 0, "LineageMonster3.marsh_stakato_soldier_tran", 16, 28.4, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 137592, 14151, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 135, 0, 0, 32, 220, 0, 1), 
(22623, 22623, "Spiked Stakato Sorcerer", 0, "", 0, "LineageMonster.blade_stakato_queen_120p", 24, 43.6, 82, "female", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 89287, 9285, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 221, 0, 0, 25, 170, 0, 1), 
(22624, 22624, "Cannibalistic Stakato Follower", 0, "", 0, "LineageMonster.spike_stakato_worker", 17, 29.8, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 90357, 9403, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 223, 0, 0, 23, 200, 0, 1), 
(22625, 22625, "Cannibalistic Stakato Leader", 0, "", 0, "LineageMonster3.cannibal_stakato_leader_120p", 34, 48.8, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 99429, 10218, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 40, 200, 0, 1), 
(22626, 22626, "Cannibalistic Stakato Leader", 0, "", 0, "LineageMonster3.cannibal_stakato_leader_tran", 40, 42, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 137592, 14151, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 34, 220, 0, 1), 
(22627, 22627, "Spiked Stakato Soldier", 0, "", 0, "LineageMonster.blade_stakato_120p", 18, 43.2, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 94846, 9748, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 25, 200, 0, 1), 
(22628, 22628, "Spiked Stakato Drone", 0, "", 0, "LineageMonster.blade_stakato_drone_120p", 28, 47.3, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 94846, 9748, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 235, 0, 0, 25, 200, 0, 1), 
(22629, 22629, "Spiked Stakato Captain", 0, "", 0, "LineageMonster.marsh_stakato_drone_120p", 14, 29.1, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 94846, 9748, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 8, 333, 234, 0, 0, 80, 200, 0, 1), 
(22630, 22630, "Spike Stakato Nurse", 0, "", 0, "LineageMonster.marsh_stakato_queen_120p", 26, 43.8, 83, "female", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 93723, 9626, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 132, 0, 0, 130, 200, 0, 1), 
(22631, 22631, "Spike Stakato Nurse", 0, "", 0, "LineageMonster3.marsh_stakato_queen_tran", 18, 36.4, 83, "female", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 129194, 13279, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 55, 220, 0, 1), 
(22632, 22632, "Spiked Stakato Baby", 0, "", 0, "LineageMonster.spike_stakato_drone", 16, 29, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 103444, 10763, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 235, 0, 0, 60, 220, 0, 1), 
(22633, 22633, "Spiked Stakato Shaman", 0, "", 0, "LineageMonster.blade_stakato_queen_120p", 24, 43.6, 83, "female", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 93723, 9626, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 221, 0, 0, 25, 170, 0, 1), 
(22634, 22634, "Scarlet Stakato Worker", 0, "", 0, "LineageMonster.blade_stakato_worker", 13, 40, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 37570, 3918, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 235, 0, 0, 25, 150, 0, 1), 
(22635, 22635, "Scarlet Stakato Soldier", 0, "", 0, "LineageMonster.blade_stakato_soldier", 15, 38, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 36723, 3825, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 148, 0, 0, 25, 180, 0, 1), 
(22636, 22636, "Scarlet Stakato Noble", 0, "", 0, "LineageMonster.blade_stakato_drone", 15, 39, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 37891, 3953, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 235, 0, 0, 25, 180, 0, 1), 
(22637, 22637, "Tepra Scorpion", 0, "", 0, "LineageMonster2.scorpion_20_sm", 24, 52.8, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 37570, 3918, 890.50086, 332.70061, 608.09666, 243.45587, 253, 8, 333, 0, 0, 0, 37, 150, 0, 1), 
(22638, 22638, "Tepra Scarab", 0, "", 0, "LineageMonster2.scarab", 14, 22, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 37570, 3918, 890.50086, 332.70061, 608.09666, 243.45587, 253, 1, 333, 0, 0, 0, 45, 170, 0, 1), 
(22639, 22639, "Assassin Beetle", 0, "", 0, "LineageMonster2.tera_beetle", 19, 54.5, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 37745, 3937, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 45, 145, 0, 1), 
(22640, 22640, "Mercenary of Destruction", 0, "", 0, "LineageMonster.skeleton_knight", 10, 25, 78, "male", "L2Monster", 80, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 36803, 3835, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 84, 0, 0, 40, 165, 0, 1), 
(22641, 22641, "Knight of Destruction", 0, "", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 37694, 3933, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 946, 945, 0, 80, 150, 0, 1), 
(22642, 22642, "Lavastone Golem", 0, "", 0, "LineageMonster.stone_golem", 20, 31, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 48492, 5048, 890.50086, 332.70061, 608.09666, 243.45587, 253, 1, 333, 0, 0, 0, 23, 40, 0, 1), 
(22643, 22643, "Magma Golem", 0, "", 0, "LineageMonster2.lava_golem", 38, 45, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 51018, 5313, 890.50086, 332.70061, 608.09666, 243.45587, 253, 1, 333, 0, 0, 0, 13, 60, 0, 1), 
(22644, 22644, "Arimanes of Destruction", 0, "", 0, "LineageMonster2.ahrimanes", 14, 57.75, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 51456, 5361, 890.50086, 332.70061, 608.09666, 243.45587, 253, 1, 333, 6722, 0, 0, 35, 170, 0, 1), 
(22645, 22645, "Balrog of Destruction", 0, "", 0, "LineageMonster.fiend_archer", 17, 55, 78, "male", "L2Monster", 80, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 48850, 5087, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 70, 150, 0, 1), 
(22646, 22646, "Ashuras of Destruction", 0, "", 0, "LineageMonster2.ashuras_30_bi", 17, 49, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 50835, 5293, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 41, 170, 0, 1), 
(22647, 22647, "Lavasillisk", 0, "", 0, "LineageMonster.lesser_basilisk", 34, 25, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 53077, 5538, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 35, 150, 0, 1), 
(22648, 22648, "Blazing Ifrit", 0, "", 0, "LineageMonster2.ifrit_30_bi", 13, 55, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 52004, 5421, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 38, 150, 0, 1), 
(22649, 22649, "Magma Drake", 0, "", 0, "LineageMonster2.inferno_drake_20_bi", 29, 42, 78, "male", "L2Monster", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 53712, 5596, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 57, 170, 0, 1), 
(22650, 22650, "Mucrokian Fanatic", 0, "", 0, "LineageMonster3.Crokian_Officer_blue_b_120p", 25, 41, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 23243, 2402, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 60, 185, 3, 1), 
(22651, 22651, "Mucrokian Ascetic", 0, "", 0, "LineageMonster3.Crokian_Officer_red_a_120p", 25, 41, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 24133, 2498, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 60, 185, 3, 1), 
(22652, 22652, "Mucrokian Savior", 0, "", 0, "LineageMonster3.Crokian_Officer_blue_a_120p", 25, 41, 84, "male", "L2Monster", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 24383, 2490, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 60, 185, 3, 1), 
(22653, 22653, "Mucrokian Preacher", 0, "", 0, "LineageMonster3.Crokian_Officer_red_b_120p", 25, 41, 84, "male", "L2Monster", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 25317, 2589, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 60, 185, 3, 1), 
(22654, 22654, "Contaminated Mucrokian", 0, "", 0, "LineageMonster.crokian_e", 18, 29, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 6887, 743, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 5128, 0, 0, 18, 250, 3, 1), 
(22655, 22655, "Awakened Mucrokian", 0, "", 0, "LineageMonster3.Crokian_Elder_raid_120p", 30, 52, 84, "male", "L2Monster", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 42120, 4283, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 40, 120, 3, 1), 
(22656, 22656, "Suppressor", 0, "", 0, "LineageMonster3.golem_cannon_catapult_a_120p", 23.5, 41.5, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 21552, 2219, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 60, 185, 3, 1), 
(22657, 22657, "Exterminator", 0, "", 0, "LineageMonster3.golem_carrier_120p", 23, 41, 84, "male", "L2Monster", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 22610, 2300, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 60, 185, 3, 1), 
(22658, 22658, "Sentinel Waterspirit", 0, "", 0, "LineageMonster4.Anthias", 20, 41, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 22442, 2316, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 1, 333, 0, 0, 0, 60, 185, 3, 1), 
(22659, 22659, "Guardian Waterspirit", 0, "", 0, "LineageMonster4.tears_d", 20, 27.5, 84, "female", "L2Monster", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 23543, 2400, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 9638, 9638, 0, 60, 185, 3, 1), 
(22660, 22660, "Lesser Giant", 0, "", 0, "LineageMonster.lesser_giant_50_bi", 31.5, 69, 81, "male", "L2Monster", 40, 33003.982801, 1708.8, 113.41926, 3, 40, 43, 30, 21, 20, 20, 332209, 34962, 5770.14557, 552.97803, 3940.26143, 606.96799, 253, 4, 333, 3937, 0, 0, 15, 180, 0, 1), 
(22661, 22661, "Lesser Giant Soldier", 0, "", 0, "LineageMonster.lesser_giant_50_bi", 31.5, 69, 81, "male", "L2Monster", 40, 33003.982801, 1708.8, 113.41926, 3, 40, 43, 30, 21, 20, 20, 340299, 35858, 5770.14557, 552.97803, 3940.26143, 606.96799, 253, 4, 333, 3937, 0, 0, 15, 180, 0, 1), 
(22662, 22662, "Lesser Giant Shooter", 0, "", 0, "LineageMonster.lesser_giant_shooter_50_bi", 30, 66, 82, "male", "L2Monster", 1100, 32946.042468, 1743, 112.55804, 3, 40, 43, 30, 21, 20, 20, 327339, 34009, 5793.32235, 559.63963, 3956.08814, 614.28, 253, 8, 333, 4028, 0, 0, 80, 180, 0, 1), 
(22663, 22663, "Lesser Giant Scout", 0, "", 0, "LineageMonster.lesser_giant_shooter_50_bi", 30, 66, 82, "male", "L2Monster", 1100, 32946.042468, 1743, 112.55804, 3, 40, 43, 30, 21, 20, 20, 327339, 34009, 5793.32235, 559.63963, 3956.08814, 614.28, 253, 8, 333, 4028, 0, 0, 80, 180, 0, 1), 
(22664, 22664, "Lesser Giant Mage", 0, "", 0, "LineageMonster.lesser_giant_mage_50_bi", 50, 66, 82, "male", "L2Monster", 40, 32946.042468, 1743, 112.55804, 3, 40, 43, 30, 21, 20, 20, 334292, 34769, 5793.32235, 559.63963, 3956.08814, 614.28, 253, 1, 333, 3938, 0, 0, 15, 180, 0, 1), 
(22665, 22665, "Lesser Giant Elder", 0, "", 0, "LineageMonster.lesser_giant_mage_50_bi", 50, 66, 82, "male", "L2Monster", 40, 32946.042468, 1743, 112.55804, 3, 40, 43, 30, 21, 20, 20, 330424, 34346, 5793.32235, 559.63963, 3956.08814, 614.28, 253, 1, 333, 3938, 0, 0, 15, 180, 0, 1), 
(22666, 22666, "Barif", 0, "", 0, "LineageMonster.lesser_giant_mage_50_bi", 50, 66, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 29543, 3085, 1055.28566, 349.77477, 720.6233, 255.95, 253, 1, 333, 3938, 0, 0, 15, 180, 0, 1), 
(22667, 22667, "Barif's Pet", 0, "", 0, "LineageMonster.leogul", 15, 35, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 29759, 3156, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), 
(22668, 22668, "Gamlin", 0, "Scout", 0, "LineageMonster.gamlin", 11, 32, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 25150, 2646, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), 
(22669, 22669, "Leogul", 0, "Scout", 0, "LineageMonster.leogul", 15, 35, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 25150, 2646, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), 
(22670, 22670, "Cursed Lord", 0, "", 0, "LineageMonster.vampire_bat_bi_120p", 10, 56, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 30252, 3260, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(22671, 22671, "Cursed Guardian!", 0, "", 0, "LineageMonster.onyx_beast", 14, 14.5, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 28869, 3105, 970.53755, 341.375, 662.75133, 249.80341, 253, 1, 333, 0, 0, 0, 30, 140, 0, 1), 
(22672, 22672, "Cursed Seer", 0, "", 0, "LineageMonster.gargoyle_bi", 16, 65, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 28777, 3095, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 140, 150, 0, 1), 
(22673, 22673, "Hirokai", 0, "", 0, "LineageMonster.vampire_bat_bi", 10, 42, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 24791, 2648, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(22674, 22674, "Imagro", 0, "", 0, "LineageMonster.gargoyle_bi", 16, 65, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 24023, 2561, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 140, 150, 0, 1), 
(22675, 22675, "Palit", 0, "", 0, "LineageMonster2.brain_buster", 20, 29, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 25229, 2697, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 40, 150, 0, 1), 
(22676, 22676, "Hamlet", 0, "", 0, "LineageMonster.hunter_gargoyle", 25, 65, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 24791, 2648, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 100, 150, 0, 1), 
(22677, 22677, "Klennot", 0, "", 0, "LineageMonster.ogre", 21, 44, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 25475, 2724, 970.53755, 341.375, 662.75133, 249.80341, 253, 1, 333, 194, 0, 0, 22, 140, 0, 1), 
(22678, 22678, "Grave Robber Summoner", 0, "Lunatic", 0, "LineageMonster.wererat_e", 14, 27.5, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 18635, 2063, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(22679, 22679, "Grave Robber Magician", 0, "Lunatic", 0, "LineageMonster.wererat_e", 14, 27.5, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 19572, 2140, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(22680, 22680, "Grave Robber Worker", 0, "Lunatic", 0, "LineageMonster.wererat_110p", 14, 27.5, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 16064, 1778, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(22681, 22681, "Grave Robber Warrior", 0, "Lunatic", 0, "LineageMonster.wererat_110p", 14, 27.5, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 16872, 1845, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(22682, 22682, "Grave Robber Warrior of Light", 0, "Lunatic", 0, "LineageMonster.wererat_110p", 14, 27.5, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 18660, 2040, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(22683, 22683, "Servitor of Darkness", 0, "", 0, "LineageMonster.shadeless", 7, 33, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 20454, 2266, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(22684, 22684, "Servitor of Darkness", 0, "", 0, "LineageMonster.shadow_a_110p", 10, 25, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 19379, 2146, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(22685, 22685, "Servitor of Darkness", 0, "", 0, "LineageMonster2.knight_of_shadow", 10, 40, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 20353, 2226, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(22686, 22686, "Servitor of Darkness", 0, "", 0, "LineageMonster3.spectral_knight", 12.5, 33.5, 82, "male", "L2Monster", 80, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 20353, 2226, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 160, 150, 0, 1), 
(22687, 22687, "Phantoms of the Mine", 0, "", 0, "LineageMonster.banshee_20_bi", 10, 27.5, 81, "female", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 18303, 2027, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 1, 333, 0, 0, 0, 80, 160, 0, 1), 
(22688, 22688, "Evil Spirits of the Mine", 0, "", 0, "LineageMonster.vale_master", 12, 40, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 19224, 2101, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 70, 155, 0, 1), 
(22689, 22689, "Mine Bug", 0, "", 0, "LineageMonster.ant_larva_e", 12, 9, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 10501, 1132, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 40, 60, 0, 1), 
(22690, 22690, "Earthworm's Descendant", 0, "", 0, "LineageMonster.devastator_e", 35, 35, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 20165, 2204, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 25, 100, 0, 1), 
(22691, 22691, "Ragna Orc", 0, "Spirit Infested", 0, "LineageMonster.batur_orc_03te_120p", 9, 25.25, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 19788, 2191, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 2, 0, 0, 80, 130, 1, 1), 
(22692, 22692, "Ragna Orc Warrior", 0, "Spirit Infested", 0, "LineageMonster.batur_orc_warrior_03te_120p", 10, 24, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 20944, 2263, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 127, 0, 0, 80, 120, 1, 1), 
(22693, 22693, "Ragna Orc Hero", 0, "Spirit Infested", 0, "LineageMonster.batur_orc_overlord_03te_120p", 12, 28, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 21464, 2346, 1055.28566, 349.77477, 720.6233, 255.95, 253, 1, 333, 6365, 0, 0, 80, 140, 1, 1), 
(22694, 22694, "Ragna Orc Commander", 0, "Spirit Infested", 0, "LineageMonster.orc_champion_20_bi_e", 12, 27.6, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 20783, 2272, 1055.28566, 349.77477, 720.6233, 255.95, 253, 1, 333, 7892, 0, 0, 45, 130, 1, 1), 
(22695, 22695, "Ragna Orc Healer", 0, "Spirit Infested", 0, "LineageMonster.batur_orc_shaman_a_03te_120p_e", 13, 20.8, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 19884, 2202, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 1, 333, 8680, 0, 0, 50, 120, 1, 1), 
(22696, 22696, "Ragna Orc Shaman", 0, "Spirit Infested", 0, "LineageMonster.batur_orc_shaman_a_01te_120p_e", 13, 20.8, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 19739, 2185, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 1, 333, 8680, 0, 0, 50, 120, 1, 1), 
(22697, 22697, "Ragna Orc Seer", 0, "Spirit Infested", 0, "LineageMonster.orc_shaman_120p", 9, 27, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 18697, 2044, 1055.28566, 349.77477, 720.6233, 255.95, 253, 1, 333, 8687, 0, 0, 45, 120, 1, 1), 
(22698, 22698, "Ragna Orc Archer", 0, "Spirit Infested", 0, "LineageMonster.batur_orc_archer_03te_120p", 11, 26, 81, "male", "L2Monster", 1100, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 20388, 2257, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 8, 333, 8684, 0, 0, 45, 110, 1, 1), 
(22699, 22699, "Ragna Orc Sniper", 0, "Spirit Infested", 0, "LineageMonster.batur_orc_archer_01te_120p", 11, 26, 82, "male", "L2Monster", 1100, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 21414, 2341, 1055.28566, 349.77477, 720.6233, 255.95, 253, 8, 333, 8684, 0, 0, 45, 110, 1, 1), 
(22700, 22700, "Varangka's Guardian", 0, "", 0, "LineageMonster2.ahrimanes_70p", 14, 39.5, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 35, 185, 0, 1), 
(22701, 22701, "Varangka's Dre Vanul", 0, "", 0, "LineageMonster.fiend_archer_20_sm", 14, 44, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 16974, 1880, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 0, 0, 0, 70, 155, 1, 1), 
(22702, 22702, "Varangka's Destroyer", 0, "", 0, "LineageMonster.kaim_vanul_20_sm", 19, 32, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 16090, 1759, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 37, 160, 1, 1), 
(22703, 22703, "Contaminated Morek Warrior", 0, "", 0, "LineageMonster.batur_orc_overlord_20_bi", 14, 28.8, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 47031, 4946, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 135, 0, 0, 80, 140, 0, 1), 
(22704, 22704, "Contaminated Batur Warrior", 0, "", 0, "LineageMonster.ketra_orc_20_bi", 14, 34.8, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 58791, 6189, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 127, 0, 0, 45, 170, 0, 1), 
(22705, 22705, "Contaminated Batur Commander", 0, "", 0, "LineageMonster.ketra_orc_warrior_20_bi", 14, 28.8, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 62054, 6450, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 127, 0, 0, 36, 170, 0, 1), 
(22706, 22706, "Turka Follower's Ghost", 0, "", 0, "LineageMonster.ketra_orc_overload_20_bi_op", 14, 28.8, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 67199, 6999, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 80, 0, 0, 33, 190, 0, 1), 
(22707, 22707, "Turka Commander's Ghost", 0, "Grave Guardian Spirit", 0, "LineageMonster2.ketra_orc_chieftain_20_bi_op", 17, 46.2, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 66140, 6866, 1055.28566, 349.77477, 720.6233, 255.95, 253, 1, 333, 6719, 0, 0, 24, 185, 0, 1), 
(22708, 22708, "Invader Warrior of Nightmare", 0, "", 0, "LineageMonster2.imperial_warlord_zombie", 7, 30, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 86802, 9470, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 134, 6721, 0, 39, 150, 0, 1), 
(22709, 22709, "Invader Healer of Nightmare", 0, "", 0, "LineageMonster.doll_master", 20, 42, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 86976, 9490, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 1, 333, 0, 0, 0, 80, 160, 0, 1), 
(22710, 22710, "Invader Guide of Nightmare", 0, "", 0, "LineageMonster.doll_master", 20, 42, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 55432, 6053, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 1, 333, 0, 0, 0, 80, 160, 0, 1), 
(22711, 22711, "Invader Destroyer of Nightmare", 0, "", 0, "LineageMonster.death_blader", 15, 45, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 76351, 8361, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 1472, 0, 0, 100, 170, 0, 1), 
(22712, 22712, "Invader Assassin of Nightmare", 0, "", 0, "LineageMonster5.doll_degenerated", 15, 20, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 56907, 6223, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 0, 0, 0, 45, 180, 0, 1), 
(22713, 22713, "Invader Shaman of Nightmare", 0, "", 0, "LineageMonster5.twisted_banshee", 15, 26.5, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 71490, 7803, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 0, 0, 0, 45, 150, 0, 1), 
(22714, 22714, "Invader Archer of Nightmare", 0, "", 0, "LineageMonster5.skeleton_hunter", 13, 26, 81, "male", "L2Monster", 1100, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 54104, 5901, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 8, 333, 15302, 0, 0, 45, 180, 0, 1), 
(22715, 22715, "Invader Soldier of Nightmare", 0, "", 0, "LineageMonster2.giant_zombie", 13, 40, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 86802, 9470, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 1, 333, 0, 0, 0, 20, 90, 0, 1), 
(22716, 22716, "Invader Soldier of Nightmare", 0, "", 0, "LineageMonster2.giant_zombie", 13, 40, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 21388, 2454, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 1, 333, 0, 0, 0, 20, 90, 0, 1), 
(22717, 22717, "Invader Disciple of Nightmare", 0, "", 0, "LineageMonster.neer_crawler", 14, 22, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 94736, 10335, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 0, 0, 0, 50, 70, 0, 1), 
(22718, 22718, "Invader Elite Soldier of Nightmare", 0, "", 0, "LineageMonster.death_lord", 21, 40, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 102166, 11188, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 78, 0, 0, 40, 140, 0, 1), 
(22719, 22719, "Nihil Invader Warrior", 0, "", 0, "LineageMonster5.dimension_caller", 25, 40, 82, "male", "L2Monster", 80, 65802.611804, 1743, 112.4052, 3, 40, 43, 30, 21, 20, 20, 173525, 19428, 5571.87244, 559.63963, 3804.86656, 614.28, 253, 4, 333, 0, 0, 0, 60, 160, 0, 1), 
(22720, 22720, "Nihil Invader Healer", 0, "", 0, "LineageMonster5.scapegoat", 20, 32.5, 82, "male", "L2Monster", 40, 65802.611804, 1743, 112.4052, 3, 40, 43, 30, 21, 20, 20, 165990, 18584, 5571.87244, 559.63963, 3804.86656, 614.28, 253, 4, 333, 0, 0, 0, 45, 180, 0, 1), 
(22721, 22721, "Nihil Invader Guide", 0, "", 0, "LineageMonster5.scapegoat", 20, 32.5, 82, "male", "L2Monster", 40, 32946.042468, 1743, 112.55804, 3, 40, 43, 30, 21, 20, 20, 91555, 10250, 5793.32235, 559.63963, 3956.08814, 614.28, 253, 4, 333, 0, 0, 0, 45, 180, 0, 1), 
(22722, 22722, "Nihil Invader Destroyer", 0, "", 0, "LineageMonster5.mixed_skeleton_guard", 29, 40, 82, "male", "L2Monster", 40, 65802.611804, 1743, 112.4052, 3, 40, 43, 30, 21, 20, 20, 165521, 18532, 5571.87244, 559.63963, 3804.86656, 614.28, 253, 4, 333, 0, 0, 0, 45, 150, 0, 1), 
(22723, 22723, "Nihil Invader Assassin", 0, "", 0, "LineageMonster5.zombie_guadian", 14, 32.5, 82, "male", "L2Monster", 40, 32946.042468, 1743, 112.55804, 3, 40, 43, 30, 21, 20, 20, 93238, 10439, 5793.32235, 559.63963, 3956.08814, 614.28, 253, 4, 333, 0, 0, 0, 45, 150, 0, 1), 
(22724, 22724, "Nihil Invader Shaman", 0, "", 0, "LineageMonster5.scapegoat", 20, 32.5, 82, "male", "L2Monster", 40, 65802.611804, 1743, 112.4052, 3, 40, 43, 30, 21, 20, 20, 166466, 18638, 5571.87244, 559.63963, 3804.86656, 614.28, 253, 4, 333, 0, 0, 0, 45, 180, 0, 1), 
(22725, 22725, "Nihil Invader Archer", 0, "", 0, "LineageMonster5.skeleton_boneshooter", 18, 27.5, 82, "male", "L2Monster", 1100, 65802.611804, 1743, 112.4052, 3, 40, 43, 30, 21, 20, 20, 162859, 18234, 5571.87244, 559.63963, 3804.86656, 614.28, 253, 8, 333, 15302, 0, 0, 45, 170, 0, 1), 
(22726, 22726, "Nihil Invader Soldier", 0, "", 0, "LineageMonster5.chaos_zombie", 28, 41, 82, "male", "L2Monster", 40, 65802.611804, 1743, 112.4052, 3, 40, 43, 30, 21, 20, 20, 165521, 18532, 5571.87244, 559.63963, 3804.86656, 614.28, 253, 4, 333, 0, 0, 0, 30, 100, 0, 1), 
(22727, 22727, "Nihil Invader Soldier", 0, "", 0, "LineageMonster5.chaos_zombie", 28, 41, 82, "male", "L2Monster", 40, 65802.611804, 1743, 112.4052, 3, 40, 43, 30, 21, 20, 20, 33270, 3562, 5571.87244, 559.63963, 3804.86656, 614.28, 253, 4, 333, 0, 0, 0, 30, 100, 0, 1), 
(22728, 22728, "Nihil Invader Disciple", 0, "", 0, "LineageMonster5.bloody_princess", 18, 33, 82, "female", "L2Monster", 40, 65802.611804, 1743, 112.4052, 3, 40, 43, 30, 21, 20, 20, 165521, 18532, 5571.87244, 559.63963, 3804.86656, 614.28, 253, 4, 333, 0, 0, 0, 45, 160, 0, 1), 
(22729, 22729, "Nihil Invader Elite Soldier", 0, "", 0, "LineageMonster5.dimension_caller", 25, 40, 82, "male", "L2Monster", 80, 65802.611804, 1743, 112.4052, 3, 40, 43, 30, 21, 20, 20, 310253, 33057, 5571.87244, 559.63963, 3804.86656, 614.28, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(22730, 22730, "Mutant Warrior", 0, "", 0, "LineageMonster5.dimension_caller", 25, 40, 84, "male", "L2Monster", 80, 112020.349673, 1812, 189.142969, 3, 40, 43, 30, 21, 20, 20, 357615, 38610, 9081.16883, 572.58757, 6201.26109, 628.4921, 253, 4, 333, 0, 0, 0, 60, 160, 0, 1), 
(22731, 22731, "Mutant Healer", 0, "", 0, "LineageMonster5.doll_claw", 28, 50, 84, "male", "L2Monster", 40, 112020.349673, 1812, 189.142969, 3, 40, 43, 30, 21, 20, 20, 337518, 36440, 9081.16883, 572.58757, 6201.26109, 628.4921, 253, 4, 333, 0, 0, 0, 50, 165, 0, 1), 
(22732, 22732, "Mutant Guide", 0, "", 0, "LineageMonster5.doll_claw", 28, 50, 84, "male", "L2Monster", 40, 112020.349673, 1812, 189.142969, 3, 40, 43, 30, 21, 20, 20, 338470, 36543, 9081.16883, 572.58757, 6201.26109, 628.4921, 253, 4, 333, 0, 0, 0, 50, 165, 0, 1), 
(22733, 22733, "Mutant Destroyer", 0, "", 0, "LineageMonster5.mixed_skeleton_guard", 29, 40, 84, "male", "L2Monster", 40, 112020.349673, 1812, 189.142969, 3, 40, 43, 30, 21, 20, 20, 356663, 38507, 9081.16883, 572.58757, 6201.26109, 628.4921, 253, 4, 333, 0, 0, 0, 45, 150, 0, 1), 
(22734, 22734, "Mutant Assassin", 0, "", 0, "LineageMonster5.zombie_guadian", 14, 32.5, 84, "male", "L2Monster", 40, 56054.754552, 1812, 189.293512, 3, 40, 43, 30, 21, 20, 20, 166806, 18009, 9311.19148, 572.58757, 6358.33674, 628.4921, 253, 4, 333, 0, 0, 0, 45, 150, 0, 1), 
(22735, 22735, "Mutant Shaman", 0, "", 0, "LineageMonster5.doll_claw", 28, 50, 84, "male", "L2Monster", 40, 112020.349673, 1812, 189.142969, 3, 40, 43, 30, 21, 20, 20, 338470, 36543, 9081.16883, 572.58757, 6201.26109, 628.4921, 253, 4, 333, 0, 0, 0, 50, 165, 0, 1), 
(22736, 22736, "Mutant Overlord", 0, "", 0, "LineageMonster5.skeleton_sniper", 20, 34, 84, "male", "L2Monster", 1100, 56054.754552, 1812, 189.293512, 3, 40, 43, 30, 21, 20, 20, 159361, 17205, 9311.19148, 572.58757, 6358.33674, 628.4921, 253, 8, 333, 15302, 0, 0, 55, 150, 0, 1), 
(22737, 22737, "Mutant Soldier", 0, "", 0, "LineageMonster5.chaos_zombie", 28, 41, 84, "male", "L2Monster", 40, 112020.349673, 1812, 189.142969, 3, 40, 43, 30, 21, 20, 20, 336554, 36336, 9081.16883, 572.58757, 6201.26109, 628.4921, 253, 4, 333, 0, 0, 0, 30, 100, 0, 1), 
(22738, 22738, "Mutant Soldier", 0, "", 0, "LineageMonster5.chaos_zombie", 28, 41, 84, "male", "L2Monster", 40, 112020.349673, 1812, 189.142969, 3, 40, 43, 30, 21, 20, 20, 67644, 6984, 9081.16883, 572.58757, 6201.26109, 628.4921, 253, 4, 333, 0, 0, 0, 30, 100, 0, 1), 
(22739, 22739, "Mutant Disciple", 0, "", 0, "LineageMonster5.bloody_king", 30, 45, 84, "male", "L2Monster", 40, 112020.349673, 1812, 189.142969, 3, 40, 43, 30, 21, 20, 20, 618577, 63492, 9081.16883, 572.58757, 6201.26109, 628.4921, 253, 4, 333, 0, 0, 0, 45, 160, 0, 1), 
(22740, 22740, "Mutant Elite Soldier", 0, "", 0, "LineageMonster5.mistress_of_dimension", 15, 35, 84, "male", "L2Monster", 40, 112020.349673, 1812, 189.142969, 3, 40, 43, 30, 21, 20, 20, 650930, 66985, 9081.16883, 572.58757, 6201.26109, 628.4921, 253, 4, 333, 0, 0, 0, 45, 160, 0, 1), 
(22741, 22741, "Grave Robber Warrior", 0, "", 0, "LineageMonster.wererat_110p", 14, 27.5, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 13552, 1501, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 8, 333, 12, 0, 0, 80, 120, 0, 1), 
(22742, 22742, "Ornithomimus", 0, "", 0, "LineageMonster3.ornithomimus", 15, 37.2, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 5701, 862, 970.53755, 341.375, 662.75133, 249.80341, 253, 1, 333, 0, 0, 0, 36, 160, 2, 1), 
(22743, 22743, "Deinonychus", 0, "", 0, "LineageMonster3.deinonychus", 14, 14.3, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 5701, 862, 970.53755, 341.375, 662.75133, 249.80341, 253, 1, 333, 0, 0, 0, 24, 160, 2, 1), 
(22744, 22744, "Ornithomimus", 0, "", 0, "LineageMonster3.ornithomimus", 15, 37.2, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 5701, 862, 970.53755, 341.375, 662.75133, 249.80341, 253, 1, 333, 0, 0, 0, 36, 200, 2, 1), 
(22745, 22745, "Deinonychus", 0, "", 0, "LineageMonster3.deinonychus", 14, 14.3, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 5701, 862, 970.53755, 341.375, 662.75133, 249.80341, 253, 1, 333, 0, 0, 0, 24, 190, 2, 1), 
(22746, 22746, "Bgurent", 0, "", 0, "LineageMonster5.bgurent", 23, 30.5, 85, "male", "L2Monster", 40, 55817.801267, 1846.8, 187.410041, 3, 40, 43, 30, 21, 20, 20, 579304, 58205, 12008.01356, 578.86102, 8707.81891, 635.37806, 253, 4, 333, 0, 0, 0, 56, 180, 0, 1), 
(22747, 22747, "Brakian", 0, "", 0, "LineageMonster5.brakian", 28, 30, 85, "male", "L2Monster", 40, 55817.801267, 1846.8, 187.410041, 3, 40, 43, 30, 21, 20, 20, 579304, 58205, 12008.01356, 578.86102, 8707.81891, 635.37806, 253, 4, 333, 0, 0, 0, 37.5, 180, 0, 1), 
(22748, 22748, "Groikan", 0, "", 0, "LineageMonster5.groykhan", 32, 31, 85, "male", "L2Monster", 40, 55817.801267, 1846.8, 187.410041, 3, 40, 43, 30, 21, 20, 20, 579450, 58220, 12008.01356, 578.86102, 8707.81891, 635.37806, 253, 4, 333, 0, 0, 0, 56, 154, 0, 1), 
(22749, 22749, "Treykan", 0, "", 0, "LineageMonster5.traikan", 25, 27, 85, "male", "L2Monster", 40, 55817.801267, 1846.8, 187.410041, 3, 40, 43, 30, 21, 20, 20, 585940, 58904, 12008.01356, 578.86102, 8707.81891, 635.37806, 253, 4, 333, 0, 0, 0, 88, 180, 0, 1), 
(22750, 22750, "Elite Bgurent", 0, "Bistakon", 0, "LineageMonster5.bgurent_e", 23, 40.5, 85, "male", "L2Monster", 40, 111546.700058, 1846.8, 187.260794, 3, 40, 43, 30, 21, 20, 20, 1209443, 121549, 11740.1012, 578.86102, 8513.53763, 635.37806, 253, 4, 333, 0, 0, 0, 56, 180, 0, 1), 
(22751, 22751, "Elite Brakian", 0, "Bistakon", 0, "LineageMonster5.brakian_e", 35, 41.5, 85, "male", "L2Monster", 40, 111546.700058, 1846.8, 187.260794, 3, 40, 43, 30, 21, 20, 20, 1209443, 121549, 11740.1012, 578.86102, 8513.53763, 635.37806, 253, 4, 333, 0, 0, 0, 37.5, 90, 0, 1), 
(22752, 22752, "Elite Groikan", 0, "Bistakon", 0, "LineageMonster5.groykhan_e", 40, 47, 85, "male", "L2Monster", 40, 111546.700058, 1846.8, 187.260794, 3, 40, 43, 30, 21, 20, 20, 1206702, 121260, 11740.1012, 578.86102, 8513.53763, 635.37806, 253, 4, 333, 0, 0, 0, 56, 154, 0, 1), 
(22753, 22753, "Elite Treykan", 0, "Bistakon", 0, "LineageMonster5.traikan_e", 30, 42, 85, "male", "L2Monster", 40, 111546.700058, 1846.8, 187.260794, 3, 40, 43, 30, 21, 20, 20, 1209443, 121549, 11740.1012, 578.86102, 8513.53763, 635.37806, 253, 4, 333, 0, 0, 0, 88, 180, 0, 1), 
(22754, 22754, "Turtlelian", 0, "", 0, "LineageMonster5.turtlian", 28, 28.5, 85, "male", "L2Monster", 40, 55817.801267, 1846.8, 187.410041, 3, 40, 43, 30, 21, 20, 20, 579304, 58205, 12008.01356, 578.86102, 8707.81891, 635.37806, 253, 4, 333, 0, 0, 0, 29, 93, 0, 1), 
(22755, 22755, "Krajian", 0, "", 0, "LineageMonster5.krakian", 26, 36, 85, "male", "L2Monster", 40, 55817.801267, 1846.8, 187.410041, 3, 40, 43, 30, 21, 20, 20, 579304, 58205, 12008.01356, 578.86102, 8707.81891, 635.37806, 253, 4, 333, 0, 0, 0, 42, 180, 0, 1), 
(22756, 22756, "Tardyon", 0, "", 0, "LineageMonster5.tardion", 30, 35, 85, "male", "L2Monster", 40, 55817.801267, 1846.8, 187.410041, 3, 40, 43, 30, 21, 20, 20, 579450, 58220, 12008.01356, 578.86102, 8707.81891, 635.37806, 253, 4, 333, 0, 0, 0, 25, 180, 0, 1), 
(22757, 22757, "Elite Turtlelian", 0, "Reptilikon", 0, "LineageMonster5.turtlian_e", 38, 42, 85, "male", "L2Monster", 40, 111546.700058, 1846.8, 187.260794, 3, 40, 43, 30, 21, 20, 20, 1209443, 121549, 11740.1012, 578.86102, 8513.53763, 635.37806, 253, 4, 333, 0, 0, 0, 29, 93, 0, 1), 
(22758, 22758, "Elite Krajian", 0, "Reptilikon", 0, "LineageMonster5.krakian_e", 26, 48, 85, "male", "L2Monster", 40, 111546.700058, 1846.8, 187.260794, 3, 40, 43, 30, 21, 20, 20, 1206702, 121260, 11740.1012, 578.86102, 8513.53763, 635.37806, 253, 4, 333, 0, 0, 0, 42, 180, 0, 1), 
(22759, 22759, "Elite Tardyon", 0, "Reptilikon", 0, "LineageMonster5.tardion_e", 30, 47, 85, "male", "L2Monster", 40, 111546.700058, 1846.8, 187.260794, 3, 40, 43, 30, 21, 20, 20, 1209443, 121549, 11740.1012, 578.86102, 8513.53763, 635.37806, 253, 4, 333, 0, 0, 0, 25, 180, 0, 1), 
(22760, 22760, "Kanibi", 0, "", 0, "LineageMonster5.karnibi", 22, 45.5, 85, "male", "L2Monster", 40, 55817.801267, 1846.8, 187.410041, 3, 40, 43, 30, 21, 20, 20, 579304, 58205, 12008.01356, 578.86102, 8707.81891, 635.37806, 253, 4, 333, 0, 0, 0, 75, 270, 0, 1), 
(22761, 22761, "Kiriona", 0, "", 0, "LineageMonster5.cariona", 33, 33, 85, "male", "L2Monster", 40, 55817.801267, 1846.8, 187.410041, 3, 40, 43, 30, 21, 20, 20, 579304, 58205, 12008.01356, 578.86102, 8707.81891, 635.37806, 253, 4, 333, 0, 0, 0, 24, 180, 0, 1), 
(22762, 22762, "Kaiona", 0, "", 0, "LineageMonster5.kaiona", 32, 37.5, 85, "male", "L2Monster", 40, 55817.801267, 1846.8, 187.410041, 3, 40, 43, 30, 21, 20, 20, 579450, 58220, 12008.01356, 578.86102, 8707.81891, 635.37806, 253, 4, 333, 0, 0, 0, 94, 204, 0, 1), 
(22763, 22763, "Elite Kanibi", 0, "Kokracon", 0, "LineageMonster5.karnibi_e", 32, 69.5, 85, "male", "L2Monster", 40, 111546.700058, 1846.8, 187.260794, 3, 40, 43, 30, 21, 20, 20, 1209443, 121549, 11740.1012, 578.86102, 8513.53763, 635.37806, 253, 4, 333, 0, 0, 0, 75, 270, 0, 1), 
(22764, 22764, "Elite Kiriona", 0, "Kokracon", 0, "LineageMonster5.cariona_e", 48, 46, 85, "male", "L2Monster", 40, 111546.700058, 1846.8, 187.260794, 3, 40, 43, 30, 21, 20, 20, 1206702, 121260, 11740.1012, 578.86102, 8513.53763, 635.37806, 253, 4, 333, 0, 0, 0, 24, 180, 0, 1), 
(22765, 22765, "Elite Kaiona", 0, "Kokracon", 0, "LineageMonster5.kaiona_e", 35, 49.5, 85, "male", "L2Monster", 40, 111546.700058, 1846.8, 187.260794, 3, 40, 43, 30, 21, 20, 20, 1209443, 121549, 11740.1012, 578.86102, 8513.53763, 635.37806, 253, 4, 333, 0, 0, 0, 94, 204, 0, 1), 
(22766, 22766, "Mithril Millipede", 0, "", 0, "LineageMonster5.big_grima", 45, 8, 85, "male", "L2Npc", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 4502, 474, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 40, 120, 0, 1), 
(22767, 22767, "Archery Knight", 0, "", 0, "LineageMonster5.ice_knight", 15, 31, 85, "male", "L2Npc", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 31712, 3176, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 20, 150, 0, 1), 
(22768, 22768, "Tanta Lizardman Scout", 0, "", 0, "LineageMonster.zenta_lizardman_warrior", 13, 35, 82, "male", "L2Monster", 80, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 17792, 1945, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 98, 0, 0, 40, 140, 0, 1), 
(22769, 22769, "Tanta Lizardman Warrior", 0, "", 0, "LineageMonster.zenta_lizardman_matriarch", 20, 40, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 23866, 2576, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 8, 333, 8682, 0, 0, 53, 140, 0, 1), 
(22770, 22770, "Tanta Lizardman Soldier", 0, "", 0, "LineageMonster5.tantaar_lizardman_rogue", 20, 40.25, 84, "male", "L2Monster", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 41235, 4198, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 40, 120, 0, 1), 
(22771, 22771, "Tanta Lizardman Berserker", 0, "", 0, "LineageMonster5.tantaar_lizardman_warrior", 28, 37.5, 84, "male", "L2Monster", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 42355, 4318, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 58, 150, 0, 1), 
(22772, 22772, "Tanta Lizardman Archer", 0, "", 0, "LineageMonster5.tantaar_lizardman_archer", 20, 40.25, 83, "male", "L2Monster", 1100, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 25361, 2738, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 8, 333, 0, 0, 0, 40, 120, 0, 1), 
(22773, 22773, "Tanta Lizardman Magician", 0, "", 0, "LineageMonster.zenta_lizardman_shaman", 13, 35, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 25094, 2709, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 1, 333, 7, 0, 0, 43, 120, 0, 1), 
(22774, 22774, "Tanta Lizardman Summoner", 0, "", 0, "LineageMonster5.tantaar_lizardman_sorcerer", 29, 44, 84, "male", "L2Monster", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 46590, 4740, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 75, 150, 0, 1), 
(22775, 22775, "Sel Mahum Drill Sergeant", 0, "", 0, "LineageMonster5.xel_mahum_sorcerer", 27, 31.5, 84, "male", "L2Monster", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 25111, 2528, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 60, 150, 0, 1), 
(22776, 22776, "Sel Mahum Training Officer", 0, "", 0, "LineageMonster5.xel_mahum_high_sorcerer", 29, 33.5, 84, "male", "L2Monster", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 37863, 3820, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 49, 150, 0, 1), 
(22777, 22777, "Sel Mahum Drill Sergeant", 0, "", 0, "LineageMonster5.xel_mahum_warrior", 29, 37, 84, "male", "L2Monster", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 25111, 2528, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), 
(22778, 22778, "Sel Mahum Drill Sergeant", 0, "", 0, "LineageMonster5.xel_mahum_sniper", 27, 31, 84, "male", "L2Monster", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 25111, 2528, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 60, 150, 0, 1), 
(22779, 22779, "Sel Mahum Escort Guard", 0, "", 0, "LineageMonster5.xel_mahum_warrior", 29, 37, 84, "male", "L2Monster", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 24663, 2481, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), 
(22780, 22780, "Sel Mahum Recruit", 0, "", 0, "LineageMonster5.xel_mahum_sorcerer", 27, 31.5, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 8454, 912, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 60, 150, 0, 1), 
(22781, 22781, "Sel Mahum Soldier", 0, "", 0, "LineageMonster5.xel_mahum_high_sorcerer", 29, 33.5, 84, "male", "L2Monster", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 11193, 1194, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 49, 150, 0, 1), 
(22782, 22782, "Sel Mahum Recruit", 0, "", 0, "LineageMonster5.xel_mahum_warrior", 29, 37, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 8454, 912, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), 
(22783, 22783, "Sel Mahum Soldier", 0, "", 0, "LineageMonster5.xel_mahum_warrior", 29, 37, 84, "male", "L2Monster", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 8532, 910, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), 
(22784, 22784, "Sel Mahum Recruit", 0, "", 0, "LineageMonster5.xel_mahum_sniper", 27, 31, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 8454, 912, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 60, 150, 0, 1), 
(22785, 22785, "Sel Mahum Soldier", 0, "", 0, "LineageMonster5.xel_mahum_sniper", 27, 31, 84, "male", "L2Monster", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 4808, 512, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 60, 150, 0, 1), 
(22786, 22786, "Sel Mahum Squad Leader", 0, "", 0, "LineageMonster5.xel_mahum_sorcerer", 27, 31.5, 84, "male", "L2Monster", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 20752, 2063, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 60, 150, 0, 1), 
(22787, 22787, "Sel Mahum Squad Leader", 0, "", 0, "LineageMonster5.xel_mahum_warrior", 29, 37, 84, "male", "L2Monster", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 20752, 2063, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), 
(22788, 22788, "Sel Mahum Squad Leader", 0, "", 0, "LineageMonster5.xel_mahum_sniper", 27, 31, 84, "male", "L2Monster", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 20752, 2063, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 4, 333, 0, 0, 0, 60, 150, 0, 1), 
(22789, 22789, "Guide Solina", 0, "", 0, "LineageMonster3.solina_brother", 9, 23.4, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 25556, 2611, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 1, 333, 8212, 0, 0, 61, 180, 1, 1), 
(22790, 22790, "Seeker Solina", 0, "", 0, "LineageMonster3.solina_father", 11, 25.4, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 26927, 2759, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 8213, 0, 0, 70, 170, 1, 1), 
(22791, 22791, "Savior Solina", 0, "", 0, "LineageMonster3.grail_protection", 9, 15.6, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 26927, 2759, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 65, 180, 1, 1), 
(22792, 22792, "Disciple Solina", 0, "", 0, "LineageMonster5.solina_old_brother", 15, 30, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 27176, 2785, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 1, 333, 0, 0, 0, 40, 120, 1, 1), 
(22793, 22793, "Ascetic Solina", 0, "", 0, "LineageMonster3.solina_brother", 9, 23.4, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 27532, 2824, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 1, 333, 8212, 0, 0, 61, 180, 1, 1), 
(22794, 22794, "Divinity Judge", 0, "", 0, "LineageMonster.angel", 13.5, 36.5, 84, "male", "L2Monster", 40, 32744.826519, 1812, 110.577297, 3, 40, 43, 30, 21, 20, 20, 159424, 17009, 5837.38676, 572.58757, 3986.17844, 628.4921, 253, 4, 333, 148, 0, 0, 30, 170, 0, 1), 
(22795, 22795, "Divinity Manager", 0, "", 0, "LineageMonster.archangel", 15, 80, 84, "male", "L2Monster", 80, 32744.826519, 1812, 110.577297, 3, 40, 43, 30, 21, 20, 20, 165898, 17700, 5837.38676, 572.58757, 3986.17844, 628.4921, 253, 4, 333, 97, 0, 0, 50, 170, 0, 1), 
(22796, 22796, "Divinity Supervisor", 0, "", 0, "LineageMonster3.apostle_grail", 13, 47, 84, "male", "L2Monster", 80, 32744.826519, 1812, 110.577297, 3, 40, 43, 30, 21, 20, 20, 184779, 19714, 5837.38676, 572.58757, 3986.17844, 628.4921, 253, 4, 333, 8221, 0, 0, 30, 220, 0, 1), 
(22797, 22797, "Divinity Worshipper", 0, "", 0, "LineageMonster5.guardian_covenant", 24, 49, 84, "female", "L2Monster", 40, 32744.826519, 1812, 110.577297, 3, 40, 43, 30, 21, 20, 20, 170832, 18226, 5837.38676, 572.58757, 3986.17844, 628.4921, 253, 4, 333, 0, 0, 0, 50, 150, 0, 1), 
(22798, 22798, "Divinity Protector", 0, "", 0, "LineageMonster5.messenger_covenant", 18, 44, 84, "male", "L2Monster", 40, 32744.826519, 1812, 110.577297, 3, 40, 43, 30, 21, 20, 20, 325623, 33084, 5837.38676, 572.58757, 3986.17844, 628.4921, 253, 1, 333, 0, 0, 0, 40, 150, 0, 1), 
(22799, 22799, "Divinity Fighter", 0, "", 0, "LineageMonster5.guardian_covenant_a", 24, 49, 84, "female", "L2Monster", 40, 32744.826519, 1812, 110.577297, 3, 40, 43, 30, 21, 20, 20, 325931, 33117, 5837.38676, 572.58757, 3986.17844, 628.4921, 253, 4, 333, 0, 0, 0, 50, 150, 0, 1), 
(22800, 22800, "Divinity Magus", 0, "", 0, "LineageMonster5.messenger_covenant_a", 18, 44, 84, "male", "L2Monster", 40, 32744.826519, 1812, 110.577297, 3, 40, 43, 30, 21, 20, 20, 349400, 35497, 5837.38676, 572.58757, 3986.17844, 628.4921, 253, 4, 333, 0, 0, 0, 40, 150, 0, 1), 
(22801, 22801, "Cruel Pincer Golem", 0, "", 0, "LineageMonster3.golem_cannon_catapult_a_e", 23.5, 34.7, 72, "male", "L2Monster", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 10109, 1027, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 0, 0, 0, 130, 160, 1, 1), 
(22802, 22802, "Cruel Pincer Golem", 0, "", 0, "LineageMonster3.golem_cannon_catapult_a_e", 23.5, 34.7, 72, "male", "L2Monster", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 7216, 733, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 0, 0, 0, 130, 160, 1, 1), 
(22803, 22803, "Cruel Pincer Golem", 0, "", 0, "LineageMonster3.golem_cannon_catapult_a_e", 23.5, 34.7, 72, "male", "L2Monster", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 9269, 941, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 0, 0, 0, 130, 160, 1, 1), 
(22804, 22804, "Drill Golem of Terror", 0, "", 0, "LineageMonster3.golem_prop_e", 23, 32.8, 73, "male", "L2Monster", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 10392, 1069, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 0, 0, 0, 72, 190, 1, 1), 
(22805, 22805, "Drill Golem of Terror", 0, "", 0, "LineageMonster3.golem_prop_e", 23, 32.8, 73, "male", "L2Monster", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 7418, 763, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 0, 0, 0, 72, 190, 1, 1), 
(22806, 22806, "Drill Golem of Terror", 0, "", 0, "LineageMonster3.golem_prop_e", 23, 32.8, 73, "male", "L2Monster", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 9528, 980, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 0, 0, 0, 72, 190, 1, 1), 
(22807, 22807, "Scout-type Golem No. 28", 0, "", 0, "LineageMonster3.golem_carrier_70p", 20, 23, 72, "male", "L2Monster", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 9904, 1006, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 0, 0, 0, 72, 190, 1, 1), 
(22808, 22808, "Scout-type Golem No. 2", 0, "", 0, "LineageMonster.mechanic_golem_a_e", 5, 19, 72, "male", "L2Monster", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 5922, 601, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 0, 0, 0, 30, 170, 1, 1), 
(22809, 22809, "Guard Golem", 0, "", 0, "LineageMonster3.golem_guardian_a_090p_e", 16, 37.2, 73, "male", "L2Monster", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 20937, 2066, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 0, 0, 0, 50, 160, 1, 1), 
(22810, 22810, "Micro Scout Golem", 0, "", 0, "LineageMonster3.golem_microscout_a_e", 12, 43.5, 72, "male", "L2Monster", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 17331, 1676, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 0, 0, 0, 30, 180, 1, 1), 
(22811, 22811, "Great Chaos Golem", 0, "", 0, "LineageMonster3.Steel_Trapper_e", 35, 46.38, 73, "male", "L2Monster", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 30036, 2962, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 0, 0, 0, 60, 160, 1, 1), 
(22812, 22812, "Boom Golem", 0, "", 0, "LineageMonster.big_boom_e", 6, 13, 72, "male", "L2Monster", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 17281, 1671, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 0, 0, 0, 48, 160, 1, 1), 
(22813, 22813, "Demon's Banquet", 0, "", 0, "LineageMonster.skeleton", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22814, 22814, "Demon's Banquet", 0, "", 0, "LineageMonster.skeleton", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22815, 22815, "Drakos", 0, "", 0, "LineageMonster4.Death_slayer_080p", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22816, 22816, "Maluk Maiden of the Valley", 0, "", 0, "LineageMonster3.Succubus_Raid_a", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22817, 22817, "Maluk Summoner of the Valley", 0, "", 0, "LineageMonster4.death_scout_110p_a", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22818, 22818, "Exploding Orc Ghost", 0, "", 0, "LineageMonster3.zombie_enlisted_man", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22819, 22819, "Wrathful Orc Ghost", 0, "", 0, "LineageMonster3.zombie_laborer", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22820, 22820, "Mesmer Drake", 0, "Scout", 0, "LineageMonster4.dragon_shadow_80p", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22821, 22821, "Immortal Necromancer", 0, "Scout", 0, "LineageMonster4.floating_skeleton_50p", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22822, 22822, "Drakos Warrior", 0, "", 0, "LineageMonster4.dragon_berserker_090p", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22823, 22823, "Drakos Assassin", 0, "", 0, "LineageMonster4.Death_slayer_080p", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22824, 22824, "Drakos Guardian", 0, "", 0, "LineageMonster4.dragon_berserker_090p", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22825, 22825, "Giant Scorpion Bones", 0, "", 0, "LineageMonster2.scorpion", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22826, 22826, "Scorpion Bones", 0, "", 0, "LineageMonster2.scorpion_a_40p", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22827, 22827, "Batwing Drake", 0, "", 0, "LineageMonster4.mutant_drake_wing_50p", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22828, 22828, "Parasitic Leech", 0, "", 0, "LineageMonster.giant_leech_60p", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22829, 22829, "Emerald Drake", 0, "", 0, "LineageMonster4.drac_50p", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22830, 22830, "Gem Dragon", 0, "", 0, "LineageMonster3.antaras_ex_b_tr", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22831, 22831, "Dragon Tracker of the Valley", 0, "Tracker", 0, "LineageMonster3.antaras_ex_a_70p", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22832, 22832, "Dragon Scout of the Valley", 0, "Scout", 0, "LineageMonster3.antaras_ex_b_80p_a", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22833, 22833, "Sand Drake Tracker", 0, "Tracker", 0, "LineageMonster4.m_drake_wing_knave_50p", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22834, 22834, "Dust Dragon Tracker", 0, "Tracker", 0, "LineageMonster4.Mutant_drake_50p", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22835, 22835, "Magma Drake Mother", 0, "", 0, "LineageMonster2.inferno_drake_120p", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22836, 22836, "Magma Drake Hatchling", 0, "", 0, "LineageMonster2.inferno_drake_50p", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22837, 22837, "Gem Dragon Hatchling", 0, "", 0, "LineageMonster3.antaras_ex_b_tr_70p", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22838, 22838, "Maluk Leader", 0, "", 0, "LineageMonster5.leader_mind_of_silen_a", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22839, 22839, "Maluk Warlord", 0, "", 0, "LineageMonster5.dimension_caller_a", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22840, 22840, "Maluk Hunter", 0, "", 0, "LineageMonster5.vicious_mind_of_silen_a", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22841, 22841, "Maluk Princess", 0, "", 0, "LineageMonster5.bloody_princess_a", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22842, 22842, "Maluk Banshee", 0, "", 0, "LineageMonster5.twisted_banshee_a", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22843, 22843, "Maluk Sniper ", 0, "", 0, "LineageMonster5.skeleton_sniper_80p", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22844, 22844, "Dragon Knight", 0, "", 0, "LineageMonster4.Dragon_archmage_100p", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22845, 22845, "Dragon Knight", 0, "", 0, "LineageMonster4.Dragon_archmage_135p_a", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22846, 22846, "Elite Dragon Knight", 0, "", 0, "LineageMonster4.Dragon_archmage_135p_a", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22847, 22847, "Dragon Knight Warrior ", 0, "", 0, "LineageMonster4.Dragon_centurion_100p", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22848, 22848, "Drake Leader", 0, "", 0, "LineageMonster4.Dragon_archmage_135p_a", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22849, 22849, "Drake Warrior", 0, "", 0, "LineageMonster4.Dragon_centurion_120p_b", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22850, 22850, "Drake Scout", 0, "", 0, "LineageMonster4.dragon_peltast_80p", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22851, 22851, "Drake Mage", 0, "", 0, "LineageMonster4.dragon_mage_075p_b", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22852, 22852, "Dragon Guard", 0, "", 0, "LineageMonster4.Dragon_eliteguard_075p_a", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22853, 22853, "Dragon Mage", 0, "", 0, "LineageMonster4.dragon_mage_065p_a", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22854, 22854, "Bloody Karik", 0, "", 0, "LineageMonster5.leader_anakazel_high_a_140p", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22855, 22855, "Bloody Berserker", 0, "", 0, "LineageMonster5.leader_anakazel_low_a_130p", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22856, 22856, "Bloody Karinness", 0, "", 0, "LineageMonster5.leader_anakazel_mid_a_130p", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22857, 22857, "Knoriks", 0, "Land Dragon's Patroller", 0, "LineageMonster6.transform_clanicus", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22858, 22858, "Necromancer of the Valley", 0, "", 0, "LineageMonster4.floating_skeleton_50p", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22859, 22859, "Howl", 0, "Tracker", 0, "LineageMonster2.eligor", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22860, 22860, "Hungry Parasitic Leech", 0, "", 0, "LineageMonster.giant_leech_60p", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22861, 22861, "Hard Scorpion Bones", 0, "", 0, "LineageMonster2.scorpion", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(22862, 22862, "Drakos Hunter", 0, "", 0, "LineageMonster4.dragon_berserker_090p", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25001, 25001, "Greyclaw Kutus", 0, "Raid Boss", 0, "LineageMonster.ol_mahum_champion_50_bi", 21, 43.5, 23, "male", "L2RaidBoss", 40, 40330.259723, 231.96, 17.534747, 1.5, 60, 57, 73, 76, 70, 80, 2690117, 69902, 62.85328, 286.94928, 3.96218, 139.98, 253, 4, 333, 67, 633, 0, 50, 170, 0, 1), 
(25002, 25002, "Guard of Kutus", 0, "Raid Fighter", 0, "LineageMonster.ol_mahum", 13.5, 25, 22, "male", "L2Monster", 40, 4185.613808, 218.52, 17.157688, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 154.1203, 138.98541, 25.8557, 135.6, 253, 4, 333, 7, 0, 0, 50, 170, 0, 1), 
(25003, 25003, "Pawn of Kutus", 0, "Raid Fighter", 0, "LineageMonster.ol_mahum", 13.5, 25, 22, "male", "L2Monster", 40, 6247.184788, 218.52, 17.157688, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 231.18622, 138.98541, 58.17787, 135.6, 253, 4, 333, 123, 0, 0, 50, 170, 0, 1), 
(25004, 25004, "Turek Mercenary Captain", 0, "Raid Boss", 0, "LineageMonster.orc_champion_50_bi", 15, 35, 30, "male", "L2RaidBoss", 40, 70742.069002, 329.4, 28.564643, 1.5, 60, 57, 73, 76, 70, 80, 1868579, 150667, 208.03648, 355.39281, 25.01772, 173.38, 253, 4, 333, 124, 0, 0, 45, 170, 0, 1), 
(25005, 25005, "Turek Mercenary Archer", 0, "Raid Fighter", 0, "LineageMonster.orc_archer", 14, 25, 29, "male", "L2Monster", 1100, 7224.129813, 315.12, 27.486685, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 384.04607, 172.50897, 90.88351, 168.32, 253, 8, 333, 271, 0, 0, 45, 170, 0, 1), 
(25006, 25006, "Turek Mercenary Warrior", 0, "Raid Fighter", 0, "LineageMonster.orc_fighter", 12, 22, 29, "male", "L2Monster", 40, 5391.141652, 315.12, 27.486685, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 384.04607, 172.50897, 90.88351, 168.32, 253, 4, 333, 2, 0, 0, 45, 170, 0, 1), 
(25007, 25007, "Retreat Spider Cletu", 0, "Raid Boss", 0, "LineageMonster.poison_spider", 27, 25.5, 42, "male", "L2RaidBoss", 40, 139295.030978, 531, 50.721515, 2.1, 60, 57, 73, 76, 70, 80, 3062105, 303198, 508.63187, 494.65539, 93.78765, 241.32, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(25008, 25008, "Cletu's Retainer", 0, "Raid Fighter", 0, "LineageMonster.giant_spider", 26, 25.5, 41, "male", "L2Monster", 40, 21023.16115, 504.8, 48.18617, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 948.58421, 241.03503, 337.17014, 235.18, 253, 4, 333, 0, 0, 0, 72, 170, 0, 1), 
(25009, 25009, "Cletu's Pawn", 0, "Raid Fighter", 0, "LineageMonster.giant_spider", 26, 25.5, 41, "male", "L2Monster", 40, 10511.580575, 504.8, 48.18617, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 948.58421, 241.03503, 337.17014, 235.18, 253, 4, 333, 0, 0, 0, 72, 170, 0, 1), 
(25010, 25010, "Furious Thieles", 0, "Raid Boss", 0, "LineageMonster.ti_mi_tran", 23, 90, 55, "male", "L2RaidBoss", 40, 262379.847927, 889.8, 88.695358, 2.4, 60, 57, 73, 76, 70, 80, 3983098, 535296, 1142.75903, 670.9086, 324.54053, 327.3, 253, 4, 333, 0, 0, 0, 12, 50, 0, 1), 
(25011, 25011, "Guard of Thieles", 0, "Raid Fighter", 0, "LineageMonster.zenta_lizardman_scout", 11, 30, 54, "male", "L2Monster", 1100, 27092.824496, 861, 85.863876, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 2164.08581, 328.34384, 1209.24682, 320.36, 253, 8, 333, 279, 0, 0, 37, 170, 0, 1), 
(25012, 25012, "Follower of Thieles", 0, "Raid Fighter", 0, "LineageMonster.dryad", 9, 20, 54, "female", "L2Monster", 40, 20218.525743, 861, 85.863876, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 2164.08581, 328.34384, 1209.24682, 320.36, 253, 4, 333, 0, 0, 0, 40, 170, 0, 1), 
(25013, 25013, "Ghost of Peasant Leader", 0, "Raid Boss", 0, "LineageMonster.skeleton_knight_50_bi", 15, 39, 50, "male", "L2RaidBoss", 40, 213145.164738, 747.8, 73.933897, 2.1, 60, 57, 73, 76, 70, 80, 3551193, 422350, 857.79693, 600.71532, 196.05673, 293.06, 253, 4, 333, 145, 0, 0, 40, 170, 0, 1), 
(25014, 25014, "Ghost of Peasant", 0, "Raid Fighter", 0, "LineageMonster.skeleton", 11, 25, 49, "male", "L2Monster", 40, 32519.113606, 720, 70.884287, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 3227.02605, 293.49453, 2881.08815, 286.36, 253, 4, 333, 68, 0, 0, 60, 170, 0, 1), 
(25015, 25015, "Ghost of Peasant", 0, "Raid Fighter", 0, "LineageMonster.skeleton_archer", 11, 27, 49, "male", "L2Monster", 1100, 16259.556803, 720, 70.884287, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 1613.51303, 293.49453, 720.27204, 286.36, 253, 8, 333, 14, 0, 0, 40, 170, 0, 1), 
(25016, 25016, "The 3rd Underwater Guardian", 0, "Raid Boss", 0, "LineageMonster.susceptor_100_bi", 40, 73, 60, "male", "L2RaidBoss", 40, 307124.575734, 1036.8, 101.297744, 2.4, 60, 57, 73, 76, 70, 80, 4154684, 587467, 1468.52523, 742.95024, 462.90027, 362.44, 253, 4, 333, 0, 0, 0, 27, 150, 0, 1), 
(25017, 25017, "Escort of the 3rd Guardian", 0, "Raid Fighter", 0, "LineageMonster.will_o_wisp", 13, 22, 59, "male", "L2Monster", 40, 47798.555365, 1007, 99.013609, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 2801.82135, 364.2239, 1701.37044, 355.36, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), 
(25018, 25018, "Support of the 3rd Guardian", 0, "Raid Fighter", 0, "LineageMonster.will_o_wisp", 13, 22, 59, "male", "L2Monster", 40, 23899.277682, 1007, 99.013609, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 2801.82135, 364.2239, 1701.37044, 355.36, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), 
(25019, 25019, "Pan Dryad", 0, "Raid Boss", 0, "LineageMonster.pan_100_bi", 42, 73, 25, "male", "L2RaidBoss", 40, 86632.617073, 259.2, 46.096328, 1.5, 60, 57, 73, 76, 70, 80, 2541012, 79280, 148.44464, 305.50599, 18.71869, 149.04, 253, 4, 333, 291, 0, 0, 45, 170, 0, 1), 
(25020, 25020, "Breka Warlock Pastu", 0, "Raid Boss", 0, "LineageMonster.batur_orc_shaman_100_bi", 22, 35, 34, "male", "L2RaidBoss", 40, 65791.674179, 387.72, 25.612831, 1.8, 60, 57, 73, 76, 70, 80, 1918617, 135504, 151.7428, 398.8458, 12.04061, 194.58, 253, 4, 333, 8, 0, 0, 50, 170, 0, 1), 
(25021, 25021, "Pastu's Silhouette", 0, "Raid Fighter", 0, "LineageMonster.silhouette", 8, 23, 33, "female", "L2Monster", 40, 9983.703443, 372.96, 24.517094, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 281.11506, 193.84643, 44.77803, 189.14, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), 
(25022, 25022, "Pastu's Shadow", 0, "Raid Fighter", 0, "LineageMonster.shadow", 10, 30, 33, "male", "L2Monster", 40, 4991.851722, 372.96, 24.517094, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 281.11506, 193.84643, 44.77803, 189.14, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), 
(25023, 25023, "Stakato Queen Zyrnna", 0, "Raid Boss", 0, "LineageMonster.marsh_stakato_queen_100_bi", 30, 76, 34, "female", "L2RaidBoss", 40, 87402.97271, 387.72, 33.958548, 1.8, 60, 57, 73, 76, 70, 80, 2316590, 188679, 284.01972, 398.8458, 41.77719, 194.58, 253, 4, 333, 150, 0, 0, 50, 170, 0, 1), 
(25024, 25024, "Jeruna's Guard Captain", 0, "Raid Fighter", 0, "LineageMonster.marsh_stakato_drone", 9, 24, 33, "male", "L2Monster", 40, 13233.901605, 372.96, 32.436711, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 1052.3815, 193.84643, 621.48802, 189.14, 253, 8, 333, 238, 0, 0, 80, 170, 0, 1), 
(25025, 25025, "Jeruna's Guard", 0, "Raid Fighter", 0, "LineageMonster.marsh_stakato_soldier", 10, 25, 33, "male", "L2Monster", 40, 6616.950802, 372.96, 32.436711, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 526.19075, 193.84643, 155.37201, 189.14, 253, 4, 333, 144, 0, 0, 30, 170, 0, 1), 
(25026, 25026, "Katu Van Leader Atui", 0, "Raid Boss", 0, "LineageMonster.ketra_orc_overload", 12, 24, 49, "male", "L2RaidBoss", 40, 148076.094027, 720, 51.719311, 2.1, 60, 57, 73, 76, 70, 80, 2328069, 284981, 431.28336, 586.98906, 51.9276, 286.36, 253, 1, 333, 84, 0, 0, 33, 170, 0, 1), 
(25027, 25027, "Katu Van Marksman", 0, "Raid Fighter", 0, "LineageMonster.ketra_orc_archer", 12, 27, 48, "male", "L2Monster", 1100, 15133.574434, 692.4, 49.588364, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 810.39881, 286.69205, 191.37493, 279.72, 253, 8, 333, 279, 0, 0, 45, 170, 0, 1), 
(25028, 25028, "Katu Van Raider", 0, "Raid Fighter", 0, "LineageMonster.ketra_orc_warrior", 12, 24, 48, "male", "L2Monster", 40, 11293.712264, 692.4, 49.588364, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 810.39881, 286.69205, 191.37493, 279.72, 253, 4, 333, 128, 0, 0, 36, 170, 0, 1), 
(25029, 25029, "Atraiban", 0, "Raid Boss", 0, "LineageMonster.field_stalker_200_bi", 45, 96, 53, "male", "L2RaidBoss", 40, 242937.111328, 832.4, 82.956167, 2.4, 60, 57, 73, 76, 70, 80, 3895772, 516213, 1023.10032, 642.54978, 279.7529, 313.46, 253, 4, 333, 0, 0, 0, 70, 170, 0, 1), 
(25030, 25030, "Atraiban's Top Disciple", 0, "Raid Fighter", 0, "LineageMonster.will_o_wisp", 13, 22, 52, "male", "L2Monster", 40, 37286.72584, 804, 79.987469, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 1932.05423, 314.25159, 1016.89724, 306.6, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), 
(25031, 25031, "Atraiban's Disciple", 0, "Raid Fighter", 0, "LineageMonster.liviona", 15, 28, 52, "male", "L2Monster", 40, 18643.36292, 804, 79.987469, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 1932.05423, 314.25159, 1016.89724, 306.6, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), 
(25032, 25032, "Eva's Guardian Millenu", 0, "Raid Boss", 0, "LineageMonster.banshee_50_bi", 13.5, 38, 58, "female", "L2RaidBoss", 40, 290050.43916, 977.4, 96.604802, 2.4, 60, 57, 73, 76, 70, 80, 4092905, 566683, 1334.36258, 713.98287, 398.97395, 348.3, 253, 4, 333, 3939, 0, 0, 80, 170, 0, 1), 
(25033, 25033, "Millenu Guard Shaman", 0, "Raid Fighter", 0, "LineageMonster.heltor_silenos_shaman", 13, 32, 57, "male", "L2Monster", 40, 30131.174293, 948, 94.076687, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 3384.05594, 349.78259, 2642.16795, 341.28, 253, 4, 333, 5131, 0, 0, 29, 170, 0, 1), 
(25034, 25034, "Mellenu Guard Warrior", 0, "Raid Fighter", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 57, "male", "L2Monster", 40, 44971.90193, 948, 94.076687, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 5076.21081, 349.78259, 5945.138, 341.28, 253, 8, 333, 946, 945, 0, 80, 170, 0, 1), 
(25035, 25035, "Shilen's Messenger Cabrio", 0, "Raid Boss", 0, "LineageMonster.vale_master_50_bi", 18, 63, 70, "male", "L2RaidBoss", 40, 373386.071242, 1345.8, 117.684362, 2.7, 60, 57, 73, 76, 70, 80, 4596479, 802604, 2154.88112, 887.74791, 717.40387, 433.08, 253, 1, 333, 189, 0, 0, 70, 170, 0, 1), 
(25036, 25036, "Cabrio Captor", 0, "Raid Fighter", 0, "LineageMonster.skeleton_archer", 11, 27, 69, "male", "L2Monster", 1100, 39454.502253, 1314, 116.468584, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 4178.50449, 436.72595, 2773.51841, 426.1, 253, 8, 333, 279, 0, 0, 40, 170, 0, 1), 
(25037, 25037, "Cabrio Blader", 0, "Raid Fighter", 0, "LineageMonster.doll_blader", 6, 12, 69, "male", "L2Monster", 40, 29443.658398, 1314, 116.468584, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 4178.50449, 436.72595, 2773.51841, 426.1, 253, 4, 333, 5129, 5129, 0, 22, 170, 0, 1), 
(25038, 25038, "Tirak", 0, "Raid Boss", 0, "LineageMonster.dre_vanul_100_bi", 28, 75, 28, "male", "L2RaidBoss", 40, 48983.972762, 300.96, 20.212854, 1.5, 60, 57, 73, 76, 70, 80, 2390045, 97281, 94.80346, 334.84104, 6.05989, 163.34, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), 
(25039, 25039, "Tirak's Guard", 0, "Raid Fighter", 0, "LineageMonster.spartoi", 11, 27, 27, "male", "L2Monster", 40, 7507.447697, 286.92, 19.561306, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 349.74133, 162.43151, 89.51405, 158.48, 253, 4, 333, 68, 0, 0, 60, 170, 0, 1), 
(25040, 25040, "Tirak's Knight", 0, "Raid Fighter", 0, "LineageMonster.skeleton", 11, 25, 27, "male", "L2Monster", 40, 3753.723848, 286.92, 19.561306, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 174.87066, 162.43151, 22.37851, 158.48, 253, 4, 333, 2, 945, 0, 60, 170, 0, 1), 
(25041, 25041, "Remmel", 0, "Raid Boss", 0, "LineageMonster.marsh_stakato_queen_100_bi", 30, 76, 35, "female", "L2RaidBoss", 40, 69449.568455, 402.6, 26.794392, 1.8, 60, 57, 73, 76, 70, 80, 1912395, 144137, 163.69565, 410.18844, 12.93, 200.1, 253, 8, 333, 221, 109, 0, 50, 170, 0, 1), 
(25042, 25042, "Remmel's Archer", 0, "Raid Fighter", 0, "LineageMonster.batur_orc_archer", 11, 21.5, 34, "male", "L2Monster", 1100, 7052.867472, 387.72, 25.612831, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 303.4856, 199.4229, 48.16245, 194.58, 253, 8, 333, 275, 0, 0, 45, 170, 0, 1), 
(25043, 25043, "Remmel's Guard", 0, "Raid Fighter", 0, "LineageMonster.marsh_stakato", 10, 20, 34, "male", "L2Monster", 40, 5263.333934, 387.72, 25.612831, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 303.4856, 199.4229, 48.16245, 194.58, 253, 4, 333, 127, 0, 0, 21, 170, 0, 1), 
(25044, 25044, "Barion", 0, "Raid Boss", 0, "LineageMonster.skeleton_knight_50_bi", 15, 39, 47, "male", "L2RaidBoss", 40, 134366.203995, 665, 47.474088, 2.1, 60, 57, 73, 76, 70, 80, 2205665, 257531, 380.23638, 559.90707, 42.89876, 273.14, 253, 4, 333, 70, 0, 0, 40, 170, 0, 1), 
(25045, 25045, "Dark Mage's of Barion", 0, "Raid Fighter", 0, "LineageMonster.batur_orc_shaman", 11, 16, 46, "male", "L2Monster", 40, 20430.916416, 637.8, 45.388391, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 712.79213, 273.28224, 156.18161, 266.64, 253, 1, 333, 159, 0, 0, 50, 120, 0, 1), 
(25046, 25046, "Barion's Grunt", 0, "Raid Fighter", 0, "LineageMonster.spartoi", 11, 27, 46, "male", "L2Monster", 40, 10215.458208, 637.8, 45.388391, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 712.79213, 273.28224, 156.18161, 266.64, 253, 4, 333, 129, 0, 0, 60, 170, 0, 1), 
(25047, 25047, "Karte", 0, "Raid Boss", 0, "LineageMonster.death_knight_50_bi", 18, 47.5, 49, "male", "L2RaidBoss", 40, 148076.094027, 720, 51.719311, 2.1, 60, 57, 73, 76, 70, 80, 2328069, 284981, 431.28336, 586.98906, 51.9276, 286.36, 253, 4, 333, 131, 0, 0, 27, 170, 0, 1), 
(25048, 25048, "Karte's Chief Knight", 0, "Raid Fighter", 0, "LineageMonster.skeleton_knight", 10, 25, 48, "male", "L2Monster", 40, 22587.424528, 692.4, 49.588364, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 1620.79761, 286.69205, 765.49971, 279.72, 253, 4, 333, 71, 0, 0, 40, 170, 0, 1), 
(25049, 25049, "Karte's Royal Guard", 0, "Raid Fighter", 0, "LineageMonster.spartoi", 11, 27, 48, "male", "L2Monster", 40, 11293.712264, 692.4, 49.588364, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 810.39881, 286.69205, 191.37493, 279.72, 253, 1, 333, 74, 0, 0, 60, 170, 0, 1), 
(25050, 25050, "Verfa", 0, "Raid Boss", 0, "LineageMonster.death_blader_200_bi", 45, 141, 51, "male", "L2RaidBoss", 40, 324092.589187, 775.8, 139.954748, 2.4, 60, 57, 73, 76, 70, 80, 2256714, 285537, 973.55312, 614.55582, 271.817, 299.8, 253, 4, 333, 1472, 0, 0, 100, 170, 0, 1), 
(25051, 25051, "Rahha", 0, "Raid Boss", 0, "LineageMonster3.Bloody_Queen_Raid", 11, 34, 65, "female", "L2RaidBoss", 40, 344100.501827, 1188.8, 110.823041, 2.7, 60, 57, 73, 76, 70, 80, 4489693, 746626, 1815.5076, 815.67099, 606.30945, 397.92, 253, 4, 333, 0, 0, 0, 60, 190, 0, 1), 
(25052, 25052, "Priestess of Rahha", 0, "Raid Fighter", 0, "LineageMonster.medusa", 10, 25, 64, "female", "L2Monster", 40, 53978.891222, 1158, 109.161966, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 3491.34315, 400.56702, 2351.33828, 390.82, 253, 4, 333, 0, 0, 0, 50, 170, 0, 1), 
(25053, 25053, "Fanatics of Rahha", 0, "Raid Fighter", 0, "LineageMonster.harpy", 10, 42, 64, "female", "L2Monster", 40, 26989.445611, 1158, 109.161966, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 3491.34315, 400.56702, 2351.33828, 390.82, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(25054, 25054, "Kernon", 0, "Raid Boss", 0, "LineageMonster.kaim_vanul", 24, 40, 75, "male", "L2RaidBoss", 40, 397437.25144, 1507.8, 123.21629, 3, 60, 57, 73, 76, 70, 80, 5231148, 864099, 2451.22348, 957.73869, 868.87603, 467.22, 253, 4, 333, 0, 0, 0, 37, 170, 0, 1), 
(25055, 25055, "Taliadon", 0, "Raid Fighter", 0, "LineageMonster.death_blader", 15, 45, 74, "male", "L2Monster", 40, 62863.348225, 1475, 122.142751, 3, 40, 43, 30, 21, 20, 20, 0, 0, 9587.96075, 471.98981, 13630.35538, 460.5, 253, 4, 333, 1472, 0, 0, 100, 170, 0, 1), 
(25056, 25056, "Vemsk", 0, "Raid Fighter", 0, "LineageMonster.death_knight", 12, 31, 74, "male", "L2Monster", 40, 31431.674113, 1475, 122.142751, 3, 40, 43, 30, 21, 20, 20, 0, 0, 4793.98038, 471.98981, 3407.58884, 460.5, 253, 4, 333, 142, 0, 0, 27, 170, 0, 1), 
(25057, 25057, "Biconne of Blue Sky", 0, "Raid Boss", 0, "LineageMonster.lienrik", 12, 50, 45, "male", "L2RaidBoss", 40, 121183.101254, 610.8, 43.342559, 2.1, 60, 57, 73, 76, 70, 80, 2085510, 229987, 333.67447, 533.36238, 35.73201, 260.2, 253, 4, 333, 0, 0, 0, 100, 170, 0, 1), 
(25058, 25058, "Biconne's Shooter", 0, "Raid Fighter", 0, "LineageMonster.skeleton_archer", 11, 27, 44, "male", "L2Monster", 1100, 12313.398435, 584, 41.347042, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 624.12426, 260.15328, 130.5309, 253.82, 253, 8, 333, 279, 0, 0, 40, 170, 0, 1), 
(25059, 25059, "Biconne's Warrior", 0, "Raid Fighter", 0, "LineageMonster.skeleton_knight", 10, 25, 44, "male", "L2Monster", 40, 9189.10331, 584, 41.347042, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 624.12426, 260.15328, 130.5309, 253.82, 253, 4, 333, 150, 0, 0, 40, 160, 0, 1), 
(25060, 25060, "Unrequited Kael", 0, "Raid Boss", 0, "LineageMonster.succubus_100_bi", 20, 75, 24, "female", "L2RaidBoss", 40, 41750.995691, 245.52, 17.96077, 1.5, 60, 57, 73, 76, 70, 80, 2584114, 74037, 68.32045, 296.12757, 4.30075, 144.46, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(25061, 25061, "Kael's Bead", 0, "Raid Fighter", 0, "LineageMonster.will_o_wisp", 13, 22, 23, "male", "L2Monster", 40, 4323.403842, 231.96, 17.534747, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 167.60455, 143.47464, 28.17427, 139.98, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), 
(25062, 25062, "Kael's Escort", 0, "Raid Fighter", 0, "LineageMonster.harpy", 10, 42, 23, "female", "L2Monster", 40, 6452.841556, 231.96, 17.534747, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 251.41311, 143.47464, 63.39489, 139.98, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(25063, 25063, "Chertuba of Great Soul", 0, "Raid Boss", 0, "LineageMonster.ketra_orc_warrior_100_bi", 24, 51, 35, "male", "L2RaidBoss", 40, 138899.136909, 402.6, 66.98598, 1.8, 60, 57, 73, 76, 70, 80, 1912395, 144137, 327.3913, 410.18844, 51.71999, 200.1, 253, 4, 333, 78, 0, 0, 36, 170, 0, 1), 
(25064, 25064, "Wizard of Storm Teruk", 0, "Raid Boss", 0, "LineageMonster.zenta_lizardman_shaman_50_bi", 19, 55, 40, "male", "L2RaidBoss", 40, 91937.38614, 478.8, 34.038778, 1.8, 60, 57, 73, 76, 70, 80, 2030965, 181264, 236.34363, 469.65105, 18.66292, 229.12, 253, 1, 333, 90, 0, 0, 43, 170, 0, 1), 
(25065, 25065, "Teruk's Escort", 0, "Raid Fighter", 0, "LineageMonster.zenta_lizardman", 11, 32, 39, "male", "L2Monster", 40, 13899.415887, 463.32, 32.411747, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 879.87742, 228.70128, 276.79024, 223.14, 253, 4, 333, 123, 0, 0, 37, 170, 0, 1), 
(25066, 25066, "Teruk's Knight", 0, "Raid Fighter", 0, "LineageMonster.zenta_lizardman_warrior", 13, 35, 39, "male", "L2Monster", 40, 6949.707943, 463.32, 32.411747, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 439.93871, 228.70128, 69.19756, 223.14, 253, 4, 333, 291, 0, 0, 40, 170, 0, 1), 
(25067, 25067, "Captain of Red Flag Shaka", 0, "Raid Boss", 0, "LineageMonster.oel_mahum_warrior_50_bi", 30, 60, 52, "male", "L2RaidBoss", 40, 233042.036499, 804, 79.987469, 2.4, 60, 57, 73, 76, 70, 80, 3849013, 503876, 966.02712, 628.50318, 254.22431, 306.6, 253, 4, 333, 71, 0, 0, 70, 170, 0, 1), 
(25068, 25068, "Shaka's Shooter", 0, "Raid Fighter", 0, "LineageMonster.ol_mahum_archer", 14, 25, 51, "male", "L2Monster", 1100, 23915.749076, 775.8, 76.974256, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 1821.80815, 307.27791, 942.93478, 299.8, 253, 8, 333, 277, 0, 0, 50, 170, 0, 1), 
(25069, 25069, "Shaka's Follower", 0, "Raid Fighter", 0, "LineageMonster.oel_mahum_champion", 23, 61, 51, "male", "L2Monster", 40, 17847.573937, 775.8, 76.974256, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 1821.80815, 307.27791, 942.93478, 299.8, 253, 4, 333, 128, 633, 0, 67, 170, 0, 1), 
(25070, 25070, "Enchanted Forest Watcher Ruell", 0, "Raid Boss", 0, "LineageMonster.ti_mi_tran", 23, 90, 55, "male", "L2RaidBoss", 40, 189660.12936, 889.8, 64.171341, 2.4, 60, 57, 73, 76, 70, 80, 2477107, 327038, 610.43901, 670.9086, 93.51865, 327.3, 253, 4, 333, 0, 0, 0, 12, 50, 0, 1), 
(25071, 25071, "Ruell's Wind", 0, "Raid Fighter", 0, "LineageMonster.sylph", 11, 35, 54, "female", "L2Monster", 40, 19604.830085, 861, 62.194389, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 1541.34859, 328.34384, 619.46036, 320.36, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(25072, 25072, "Ruell's Unicorn", 0, "Raid Fighter", 0, "LineageMonster.unicorn", 14, 30, 54, "male", "L2Monster", 40, 29260.940425, 861, 62.194389, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 2312.08069, 328.34384, 1393.84679, 320.36, 253, 4, 333, 0, 0, 0, 46, 170, 0, 1), 
(25073, 25073, "Bloody Priest Rudelto", 0, "Raid Boss", 0, "LineageMonster.karik_100_bi", 50, 180, 69, "male", "L2RaidBoss", 40, 368045.729972, 1314, 116.468584, 2.7, 60, 57, 73, 76, 70, 80, 4576841, 791290, 2089.25225, 873.45189, 693.3796, 426.1, 253, 4, 333, 0, 0, 0, 37, 170, 0, 1), 
(25074, 25074, "Rudelto's Banshee", 0, "Raid Fighter", 0, "LineageMonster.banshee", 9, 23, 68, "female", "L2Monster", 40, 57995.138899, 1282.4, 115.186274, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 4044.43745, 429.54225, 2658.00372, 419.1, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), 
(25075, 25075, "Rudelto's Dre Vanul", 0, "Raid Fighter", 0, "LineageMonster.dre_vanul", 14, 36, 68, "male", "L2Monster", 40, 28997.56945, 1282.4, 115.186274, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 4044.43745, 429.54225, 2658.00372, 419.1, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), 
(25076, 25076, "Princess Molrang", 0, "Raid Boss", 0, "LineageMonster.poison_toad_100_bi", 40, 20, 25, "male", "L2RaidBoss", 40, 43316.308536, 259.2, 18.438531, 1.5, 60, 57, 73, 76, 70, 80, 2541012, 79280, 74.22232, 305.50599, 4.67967, 149.04, 253, 1, 333, 0, 0, 0, 50, 170, 0, 1), 
(25077, 25077, "Captain Dogun", 0, "Raid Fighter", 0, "LineageMonster.grizzly", 21, 40, 24, "male", "L2Monster", 40, 6680.15931, 245.52, 17.96077, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 273.28181, 148.06379, 68.81204, 144.46, 253, 4, 333, 0, 0, 0, 40, 170, 0, 1), 
(25078, 25078, "Princess' Guard", 0, "Raid Fighter", 0, "LineageMonster.grizzly", 21, 40, 24, "male", "L2Monster", 40, 3340.079655, 245.52, 17.96077, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 136.64091, 148.06379, 17.20301, 144.46, 253, 4, 333, 0, 0, 0, 40, 170, 0, 1), 
(25079, 25079, "Cat's Eye Bandit", 0, "Raid Boss", 0, "LineageMonster3.Ol_Mahum_Raid", 15, 25, 30, "male", "L2RaidBoss", 40, 70742.069002, 329.4, 28.564643, 1.5, 60, 57, 73, 76, 70, 80, 1868579, 150667, 208.03648, 355.39281, 25.01772, 173.38, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(25080, 25080, "Mercenary", 0, "Raid Fighter", 0, "LineageMonster.orc_shaman", 9, 22, 29, "male", "L2Monster", 40, 10782.283303, 315.12, 27.486685, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 384.04607, 172.50897, 90.88351, 168.32, 253, 1, 333, 179, 0, 0, 45, 170, 0, 1), 
(25081, 25081, "Cat's Eye Bandit", 0, "Raid Fighter", 0, "LineageMonster.ol_mahum", 13.5, 25, 29, "male", "L2Monster", 40, 5391.141652, 315.12, 27.486685, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 384.04607, 172.50897, 90.88351, 168.32, 253, 4, 333, 218, 0, 0, 50, 170, 0, 1), 
(25082, 25082, "Leader of Cat Gang", 0, "Raid Boss", 0, "LineageMonster.cat_the_cat_50_bi", 13.5, 26, 39, "male", "L2RaidBoss", 40, 86871.349292, 463.32, 32.411747, 1.8, 60, 57, 73, 76, 70, 80, 1988451, 173127, 219.96935, 457.40256, 17.29939, 223.14, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), 
(25083, 25083, "Cat Gang", 0, "Raid Fighter", 0, "LineageMonster.cutie_cat", 8, 15, 38, "female", "L2Monster", 40, 8799.946422, 447.96, 30.872687, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 545.46428, 222.66431, 114.82299, 217.24, 253, 4, 333, 0, 0, 0, 48, 170, 0, 1), 
(25084, 25084, "Cat Gang", 0, "Raid Fighter", 0, "LineageMonster.cat_the_cat", 9, 16, 38, "male", "L2Monster", 40, 13134.248391, 447.96, 30.872687, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 818.21687, 222.66431, 258.36304, 217.24, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), 
(25085, 25085, "Timak Orc Chief Ranger", 0, "Raid Boss", 0, "LineageMonster.ketra_orc_warrior_100_bi", 24, 51, 44, "male", "L2RaidBoss", 40, 156185.297319, 584, 56.113661, 2.1, 60, 57, 73, 76, 70, 80, 3196387, 320242, 583.32632, 520.30656, 113.07982, 253.82, 253, 1, 333, 157, 0, 0, 36, 170, 0, 1), 
(25086, 25086, "Timak Orc Ranger", 0, "Raid Fighter", 0, "LineageMonster.ketra_orc_archer", 12, 27, 43, "male", "L2Monster", 1100, 15819.164953, 557.4, 53.367326, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 1089.91991, 253.70126, 412.56627, 247.54, 253, 8, 333, 14, 0, 0, 45, 170, 0, 1), 
(25087, 25087, "Timak Orc Ranger", 0, "Raid Fighter", 0, "LineageMonster.ketra_orc", 12, 29, 43, "male", "L2Monster", 40, 11805.34698, 557.4, 53.367326, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 1089.91991, 253.70126, 412.56627, 247.54, 253, 4, 333, 68, 0, 0, 45, 170, 0, 1), 
(25088, 25088, "Crazy Mechanic Golem", 0, "Raid Boss", 0, "LineageMonster.mechanic_golem_200_bi", 15, 63, 43, "male", "L2RaidBoss", 40, 295133.674501, 557.4, 133.418314, 2.1, 60, 57, 73, 76, 70, 80, 3128858, 311947, 1089.91991, 507.40251, 412.56627, 247.54, 253, 4, 333, 0, 0, 0, 30, 150, 0, 1), 
(25089, 25089, "Soulless Wild Boar", 0, "Raid Boss", 0, "LineageMonster.giant_wild_hog", 35, 27, 59, "male", "L2RaidBoss", 40, 215207.609633, 1007, 71.371054, 2.4, 60, 57, 73, 76, 70, 80, 2684275, 381459, 748.77526, 728.44779, 122.63548, 355.36, 253, 4, 333, 0, 0, 0, 35, 170, 0, 1), 
(25090, 25090, "Soulless Wolf", 0, "Raid Fighter", 0, "LineageMonster.dire_wolf", 13, 11, 58, "male", "L2Monster", 40, 22415.60317, 977.4, 69.690691, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 1901.34501, 356.99144, 817.7647, 348.3, 253, 4, 333, 0, 0, 0, 24, 170, 0, 1), 
(25091, 25091, "Soulless Bear", 0, "Raid Fighter", 0, "LineageMonster.crimson_bear", 19, 36, 58, "male", "L2Monster", 40, 33456.124134, 977.4, 69.690691, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 2852.08882, 356.99144, 1840.05109, 348.3, 253, 4, 333, 0, 0, 0, 37, 170, 0, 1), 
(25092, 25092, "Korim", 0, "Raid Boss", 0, "LineageMonster.heltor_silenos_shaman_50_bi", 19.5, 51, 70, "male", "L2RaidBoss", 40, 373386.071242, 1345.8, 117.684362, 2.7, 60, 57, 73, 76, 70, 80, 4596479, 802604, 2154.88112, 887.74791, 717.40387, 433.08, 253, 1, 333, 201, 0, 0, 29, 170, 0, 1), 
(25093, 25093, "Korim Chief Guard Kaywon", 0, "Raid Fighter", 0, "LineageMonster.heltor_silenos_warrior", 13, 31, 69, "male", "L2Monster", 40, 58887.316796, 1314, 116.468584, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 8357.00898, 436.72595, 11094.07362, 426.1, 253, 1, 333, 162, 0, 0, 36, 170, 0, 1), 
(25094, 25094, "Korim Guards", 0, "Raid Fighter", 0, "LineageMonster.heltor_silenos", 13, 29, 69, "male", "L2Monster", 40, 29443.658398, 1314, 116.468584, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 4178.50449, 436.72595, 2773.51841, 426.1, 253, 4, 333, 86, 0, 0, 34, 170, 0, 1), 
(25095, 25095, "Elf Renoa", 0, "Raid Boss", 0, "LineageMonster.elf_ghost", 7, 21, 29, "male", "L2RaidBoss", 40, 51235.837419, 315.12, 20.929197, 1.5, 60, 57, 73, 76, 70, 80, 2345715, 104160, 102.7203, 345.01794, 6.55639, 168.32, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), 
(25096, 25096, "Renoa's Elpy", 0, "Raid Fighter", 0, "LineageMonster.elpy", 5, 4.5, 28, "male", "L2Monster", 40, 5251.08188, 300.96, 20.212854, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 252.8029, 167.42052, 43.09069, 163.34, 253, 4, 333, 0, 0, 0, 50, 170, 0, 1), 
(25097, 25097, "Renoa's Hog", 0, "Raid Fighter", 0, "LineageMonster.giant_wild_hog", 35, 27, 28, "male", "L2Monster", 40, 7837.435642, 300.96, 20.212854, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 379.21383, 167.42052, 96.9583, 163.34, 253, 4, 333, 0, 0, 0, 35, 170, 0, 1), 
(25098, 25098, "Sejarr's Servitor", 0, "Raid Boss", 0, "LineageMonster.dark_fencer_200_bi", 30, 43, 35, "male", "L2RaidBoss", 40, 138899.136909, 402.6, 66.98598, 1.8, 60, 57, 73, 76, 70, 80, 1912395, 144137, 327.3913, 410.18844, 51.71999, 200.1, 253, 4, 333, 0, 0, 0, 25, 170, 0, 1), 
(25099, 25099, "Rotten Tree Repiro", 0, "Raid Boss", 0, "LineageMonster.hanged_man_ripper", 35, 80, 44, "male", "L2RaidBoss", 40, 114863.791375, 584, 41.347042, 2.1, 60, 57, 73, 76, 70, 80, 2030767, 217826, 312.06213, 520.30656, 32.63272, 253.82, 253, 4, 333, 0, 0, 0, 55, 55, 0, 1), 
(25100, 25100, "Spirit of Sea of Spores", 0, "Raid Fighter", 0, "LineageMonster.pixy", 5, 25, 43, "female", "L2Monster", 40, 17401.621187, 557.4, 39.411275, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 583.08879, 253.70126, 119.06209, 247.54, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), 
(25101, 25101, "Fighter of Sea of Spores", 0, "Raid Fighter", 0, "LineageMonster.troll", 21, 35, 43, "male", "L2Monster", 40, 8700.810593, 557.4, 39.411275, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 583.08879, 253.70126, 119.06209, 247.54, 253, 4, 333, 0, 0, 0, 55, 170, 0, 1), 
(25102, 25102, "Shacram", 0, "Raid Boss", 0, "LineageMonster.minotaur_100_bi", 42, 94, 45, "male", "L2RaidBoss", 40, 242366.202507, 610.8, 108.356398, 2.1, 60, 57, 73, 76, 70, 80, 2085510, 229987, 667.34895, 533.36238, 142.92804, 260.2, 253, 4, 333, 300, 0, 0, 40, 170, 0, 1), 
(25103, 25103, "Sorcerer Isirr", 0, "Raid Boss", 0, "LineageMonster.zenta_lizardman_matriarch_50_bi", 30, 63, 55, "male", "L2RaidBoss", 40, 189660.12936, 889.8, 64.171341, 2.4, 60, 57, 73, 76, 70, 80, 2477107, 327038, 610.43901, 670.9086, 93.51865, 327.3, 253, 1, 333, 195, 0, 0, 53, 170, 0, 1), 
(25104, 25104, "Isirr's Guard", 0, "Raid Fighter", 0, "LineageMonster.zenta_lizardman_warrior", 13, 35, 54, "male", "L2Monster", 40, 29260.940425, 861, 62.194389, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 2312.08069, 328.34384, 1393.84679, 320.36, 253, 8, 333, 95, 0, 0, 40, 170, 0, 1), 
(25105, 25105, "Isirr's Guards", 0, "Raid Fighter", 0, "LineageMonster.zenta_lizardman", 11, 32, 54, "male", "L2Monster", 40, 14630.470212, 861, 62.194389, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 1156.04035, 328.34384, 348.4617, 320.36, 253, 4, 333, 131, 0, 0, 37, 170, 0, 1), 
(25106, 25106, "Ghost of the Well Lidia", 0, "Raid Boss", 0, "LineageMonster.bloody_queen_100_bi", 28, 85, 60, "female", "L2RaidBoss", 40, 221100.024975, 1036.8, 72.964382, 2.4, 60, 57, 73, 76, 70, 80, 2735033, 394692, 785.17745, 742.95024, 133.51196, 362.44, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), 
(25107, 25107, "Lidia's Archer", 0, "Raid Fighter", 0, "LineageMonster.skeleton_archer", 11, 27, 59, "male", "L2Monster", 1100, 23070.255753, 1007, 71.371054, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 1497.55052, 364.2239, 490.54191, 355.36, 253, 8, 333, 279, 0, 0, 40, 170, 0, 1), 
(25108, 25108, "Lidia's Fighter", 0, "Raid Fighter", 0, "LineageMonster.death_blader", 15, 45, 59, "male", "L2Monster", 40, 17216.608771, 1007, 71.371054, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 1497.55052, 364.2239, 490.54191, 355.36, 253, 4, 333, 1472, 0, 0, 100, 170, 0, 1), 
(25109, 25109, "Antharas Priest Cloe", 0, "Raid Boss", 0, "LineageMonster.succubus_100_bi", 20, 75, 74, "female", "L2RaidBoss", 40, 392895.926409, 1475, 122.142751, 3, 60, 57, 73, 76, 70, 80, 5199407, 852059, 2396.99019, 943.97961, 851.89721, 460.5, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(25110, 25110, "Cloe's Servitor", 0, "Raid Fighter", 0, "LineageMonster.silhouette", 8, 23, 73, "female", "L2Monster", 40, 41619.856677, 1442.4, 121.063992, 3, 40, 43, 30, 21, 20, 20, 0, 0, 6239.97653, 465.04439, 5934.25589, 453.74, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), 
(25111, 25111, "Cloe's Servitor", 0, "Raid Fighter", 0, "LineageMonster.shadow", 10, 30, 73, "male", "L2Monster", 40, 62119.189069, 1442.4, 121.063992, 3, 40, 43, 30, 21, 20, 20, 0, 0, 9360.1988, 465.04439, 13352.65994, 453.74, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), 
(25112, 25112, "Agent of Beres Meana", 0, "Raid Boss", 0, "LineageMonster.medusa_100_bi", 20, 53, 30, "female", "L2RaidBoss", 40, 53690.033689, 329.4, 21.714039, 1.5, 60, 57, 73, 76, 70, 80, 2308288, 111484, 111.21878, 355.39281, 7.21488, 173.38, 253, 4, 333, 0, 0, 0, 50, 170, 0, 1), 
(25113, 25113, "Meana's Maid", 0, "Raid Fighter", 0, "LineageMonster.succubus", 10, 36, 29, "female", "L2Monster", 40, 5492.481771, 315.12, 20.929197, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 273.91394, 172.50897, 46.62116, 168.32, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(25114, 25114, "Meana's Guard Doll", 0, "Raid Fighter", 0, "LineageMonster.crimson_doll", 15, 38, 29, "male", "L2Monster", 40, 8197.733987, 315.12, 20.929197, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 410.88118, 172.50897, 104.9022, 168.32, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(25115, 25115, "Icarus Sample 1", 0, "Raid Boss", 0, "LineageMonster3.Kernon_Raid", 42, 45, 40, "male", "L2RaidBoss", 40, 123885.150698, 478.8, 45.769266, 1.8, 60, 57, 73, 76, 70, 80, 2741414, 271385, 441.8825, 469.65105, 64.68561, 229.12, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(25116, 25116, "Icarus Sample 2", 0, "Raid Fighter", 0, "LineageMonster.skeleton_archer", 11, 27, 39, "male", "L2Monster", 1100, 12518.769482, 463.32, 43.476782, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 822.67619, 228.70128, 239.8804, 223.14, 253, 8, 333, 273, 0, 0, 40, 170, 0, 1), 
(25117, 25117, "Icarus Sample 3", 0, "Raid Fighter", 0, "LineageMonster.magical_weaver", 11, 20, 39, "male", "L2Monster", 40, 9342.365285, 463.32, 43.476782, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 822.67619, 228.70128, 239.8804, 223.14, 253, 4, 333, 0, 0, 0, 90, 170, 0, 1), 
(25118, 25118, "Guilotine Warden of the Execution Grounds", 0, "Raid Boss", 0, "LineageMonster.skeleton_pikeman_100_bi", 20, 58, 35, "male", "L2RaidBoss", 40, 138899.136909, 402.6, 66.98598, 1.8, 60, 57, 73, 76, 70, 80, 1912395, 144137, 327.3913, 410.18844, 51.71999, 200.1, 253, 4, 333, 96, 0, 0, 50, 170, 0, 1), 
(25119, 25119, "Messenger of Fairy Queen Berun", 0, "Raid Boss", 0, "LineageMonster.pan_100_bi", 42, 73, 50, "male", "L2RaidBoss", 40, 213145.164738, 747.8, 73.933897, 2.1, 60, 57, 73, 76, 70, 80, 3551193, 422350, 857.79693, 600.71532, 196.05673, 293.06, 253, 4, 333, 213, 0, 0, 45, 170, 0, 1), 
(25120, 25120, "Berun's Officer", 0, "Raid Fighter", 0, "LineageMonster.pan", 14, 35, 49, "male", "L2Monster", 40, 21787.806116, 720, 70.884287, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 2151.29692, 293.49453, 1280.4276, 286.36, 253, 4, 333, 90, 0, 0, 45, 110, 0, 1), 
(25121, 25121, "Berun's Prattler", 0, "Raid Fighter", 0, "LineageMonster.pixy", 5, 25, 49, "female", "L2Monster", 40, 32519.113606, 720, 70.884287, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 3227.02605, 293.49453, 2881.08815, 286.36, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(25122, 25122, "Refugee Hopeful Leo", 0, "Raid Boss", 0, "LineageMonster.oel_mahum_witch_doctor_50_bi", 22.5, 54, 56, "male", "L2RaidBoss", 40, 196306.513056, 918.8, 66.084883, 2.4, 60, 57, 73, 76, 70, 80, 2529799, 340561, 643.78481, 685.20405, 100.16291, 334.26, 253, 1, 333, 201, 0, 0, 70, 170, 0, 1), 
(25123, 25123, "Leo's Servant", 0, "Raid Fighter", 0, "LineageMonster.lesser_giant", 21, 44, 55, "male", "L2Monster", 40, 30345.620698, 889.8, 64.171341, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 2441.75605, 335.4543, 1496.29839, 327.3, 253, 1, 333, 3937, 0, 0, 15, 180, 0, 1), 
(25124, 25124, "Leo's Steward", 0, "Raid Fighter", 0, "LineageMonster.lesser_giant_mage", 21, 44, 55, "male", "L2Monster", 40, 15172.810349, 889.8, 64.171341, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 1220.87802, 335.4543, 374.0746, 327.3, 253, 4, 333, 3938, 0, 0, 15, 180, 0, 1), 
(25125, 25125, "Fierce Tiger King Angel", 0, "Raid Boss", 0, "LineageMonster.saber_toothed_tiger_200_bi", 72, 87, 65, "male", "L2RaidBoss", 40, 688201.003655, 1188.8, 277.057601, 2.7, 60, 57, 73, 76, 70, 80, 4489693, 746626, 3631.0152, 815.67099, 2425.23781, 397.92, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(25126, 25126, "Longhorn Golkonda", 0, "Raid Boss", 0, "LineageMonster.minotaur_100_bi", 42, 94, 79, "male", "L2RaidBoss", 40, 829806.783271, 1641, 319.22932, 3, 60, 57, 73, 76, 70, 80, 5390003, 1205333, 5267.04651, 1011.21024, 3790.2949, 493.3, 253, 4, 333, 91, 0, 0, 40, 170, 0, 1), 
(25127, 25127, "Langk Matriarch Rashkos", 0, "Raid Boss", 0, "LineageMonster.virud_lizardman_matriarch_50_bi", 19, 57, 24, "male", "L2RaidBoss", 40, 83501.991381, 245.52, 44.901925, 1.5, 60, 57, 73, 76, 70, 80, 2584114, 74037, 136.64091, 296.12757, 17.20301, 144.46, 253, 4, 333, 124, 0, 0, 56, 170, 0, 1), 
(25128, 25128, "Vuku Grand Seer Gharmash", 0, "Raid Boss", 0, "LineageMonster.batur_orc_shaman_100_bi", 22, 35, 33, "male", "L2RaidBoss", 40, 62398.146521, 372.96, 24.517094, 1.8, 60, 57, 73, 76, 70, 80, 1932560, 127255, 140.55753, 387.69285, 11.19451, 189.14, 253, 4, 333, 195, 0, 0, 50, 170, 0, 1), 
(25129, 25129, "Vuku Shaman", 0, "Raid Fighter", 0, "LineageMonster.orc_shaman", 9, 22, 32, "male", "L2Monster", 40, 6352.47741, 358.32, 23.504309, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 346.92626, 188.36591, 73.99717, 183.78, 253, 4, 333, 7, 0, 0, 45, 170, 0, 1), 
(25130, 25130, "Gharmash's Pet Trimden", 0, "Raid Fighter", 0, "LineageMonster.poison_spider", 27, 25.5, 32, "male", "L2Monster", 40, 9481.309568, 358.32, 23.504309, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 520.4024, 188.36591, 166.50091, 183.78, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(25131, 25131, "Carnage Lord Gato", 0, "Raid Boss", 0, "LineageMonster.oel_mahum_50_bi", 30, 57, 50, "male", "L2RaidBoss", 40, 155046.064475, 747.8, 53.854634, 2.1, 60, 57, 73, 76, 70, 80, 2389767, 281312, 458.48043, 600.71532, 56.52768, 293.06, 253, 4, 333, 71, 0, 0, 70, 170, 0, 1), 
(25132, 25132, "Gato's Marksman", 0, "Raid Fighter", 0, "LineageMonster.ol_mahum_archer", 14, 25, 49, "male", "L2Monster", 1100, 15873.75728, 720, 51.719311, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 862.56672, 293.49453, 207.71039, 286.36, 253, 8, 333, 273, 0, 0, 50, 170, 0, 1), 
(25133, 25133, "Gato's Troop Leader", 0, "Raid Fighter", 0, "LineageMonster.ol_mahum_champion", 14, 27, 49, "male", "L2Monster", 40, 11846.087522, 720, 51.719311, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 862.56672, 293.49453, 207.71039, 286.36, 253, 4, 333, 69, 0, 0, 50, 170, 0, 1), 
(25134, 25134, "Leto Chief Talkin", 0, "Raid Boss", 0, "LineageMonster3.Zenta_Lizardman_Raid", 37.5, 30, 40, "female", "L2RaidBoss", 40, 91937.38614, 478.8, 34.038778, 1.8, 60, 57, 73, 76, 70, 80, 2030965, 181264, 236.34363, 469.65105, 18.66292, 229.12, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(25135, 25135, "Talkin's Seer", 0, "Raid Fighter", 0, "LineageMonster.virud_lizardman_shaman", 10, 29, 39, "male", "L2Monster", 40, 13899.415887, 463.32, 32.411747, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 439.93871, 228.70128, 69.19756, 223.14, 253, 1, 333, 7, 0, 0, 43, 170, 0, 1), 
(25136, 25136, "Talkin's Bodyguard", 0, "Raid Fighter", 0, "LineageMonster.zenta_lizardman_warrior", 13, 35, 39, "male", "L2Monster", 40, 6949.707943, 463.32, 32.411747, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 439.93871, 228.70128, 69.19756, 223.14, 253, 4, 333, 16, 0, 0, 40, 170, 0, 1), 
(25137, 25137, "Beleth's Seer Sephia", 0, "Raid Boss", 0, "LineageMonster.bloody_queen_100_bi", 28, 85, 55, "female", "L2RaidBoss", 40, 189660.12936, 889.8, 64.171341, 2.4, 60, 57, 73, 76, 70, 80, 2477107, 327038, 610.43901, 670.9086, 93.51865, 327.3, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), 
(25138, 25138, "Soul Drinker", 0, "Raid Fighter", 0, "LineageMonster.mana_vampire", 11, 20, 54, "male", "L2Monster", 40, 19604.830085, 861, 62.194389, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 1541.34859, 328.34384, 619.46036, 320.36, 253, 4, 333, 0, 0, 0, 90, 170, 0, 1), 
(25139, 25139, "Sephia's Salve", 0, "Raid Fighter", 0, "LineageMonster.kaim_vanul", 24, 40, 54, "male", "L2Monster", 40, 29260.940425, 861, 62.194389, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 2312.08069, 328.34384, 1393.84679, 320.36, 253, 4, 333, 0, 0, 0, 37, 170, 0, 1), 
(25140, 25140, "Hekaton Prime", 0, "Raid Boss", 0, "LineageMonster.susceptor", 20, 35, 65, "male", "L2RaidBoss", 40, 344100.501827, 1188.8, 110.823041, 2.7, 60, 57, 73, 76, 70, 80, 4489693, 746626, 1815.5076, 815.67099, 606.30945, 397.92, 253, 1, 333, 0, 0, 0, 27, 170, 0, 1), 
(25141, 25141, "Hekaton Cottus", 0, "Raid Fighter", 0, "LineageMonster.gamlin", 11, 32, 64, "male", "L2Monster", 40, 53978.891222, 1158, 109.161966, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 6982.68629, 400.56702, 9405.35312, 390.82, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), 
(25142, 25142, "Hekaton Chires", 0, "Raid Fighter", 0, "LineageMonster.lesser_giant", 21, 44, 64, "male", "L2Monster", 40, 26989.445611, 1158, 109.161966, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 3491.34315, 400.56702, 2351.33828, 390.82, 253, 4, 333, 3937, 0, 0, 15, 180, 0, 1), 
(25143, 25143, "Fire of Wrath Shuriel", 0, "Raid Boss", 0, "LineageMonster.angel", 13.5, 36.5, 78, "male", "L2RaidBoss", 40, 410600.548543, 1607.4, 126.536106, 3, 60, 57, 73, 76, 70, 80, 5346496, 1193017, 2592.71887, 998.10183, 929.62086, 486.92, 253, 1, 333, 2500, 0, 0, 30, 170, 0, 1), 
(25144, 25144, "Shuriel's Oracle", 0, "Raid Fighter", 0, "LineageMonster.oel_mahum_witch_doctor", 15, 34, 78, "male", "L2Monster", 40, 65696.087767, 1607.4, 126.536106, 3, 40, 43, 30, 21, 20, 20, 0, 0, 5185.43774, 499.05092, 3718.48344, 486.92, 253, 1, 333, 201, 0, 0, 70, 170, 0, 1), 
(25145, 25145, "Shuriel's Paladin", 0, "Raid Fighter", 0, "LineageMonster.kel_mahum_champion", 13, 32, 78, "male", "L2Monster", 40, 32848.043883, 1607.4, 126.536106, 3, 40, 43, 30, 21, 20, 20, 0, 0, 5185.43774, 499.05092, 3718.48344, 486.92, 253, 4, 333, 147, 0, 0, 50, 170, 0, 1), 
(25146, 25146, "Serpent Demon Bifrons", 0, "Raid Boss", 0, "LineageMonster.serpent_slave_50_bi", 25, 72, 21, "male", "L2RaidBoss", 40, 37886.485367, 205.2, 16.826966, 1.5, 60, 57, 73, 76, 70, 80, 2646357, 60367, 53.12758, 269.19177, 3.16861, 131.32, 253, 4, 333, 73, 0, 0, 70, 170, 0, 1), 
(25147, 25147, "Assassin of Bifrons", 0, "Raid Fighter", 0, "LineageMonster.virud_lizardman_scout", 10, 22, 20, "male", "L2Monster", 1100, 3950.018347, 192, 16.540032, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 97.65033, 130.30574, 9.52955, 127.14, 253, 8, 333, 2507, 0, 0, 43, 170, 0, 1), 
(25148, 25148, "Butcher of Bifrons", 0, "Raid Fighter", 0, "LineageMonster.virud_lizardman_warrior", 12, 30, 20, "male", "L2Monster", 40, 2947.774886, 192, 16.540032, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 97.65033, 130.30574, 9.52955, 127.14, 253, 4, 333, 16, 0, 0, 52, 170, 0, 1), 
(25149, 25149, "Zombie Lord Crowl", 0, "Raid Boss", 0, "LineageMonster3.Zombie_Raid", 30, 21.25, 25, "male", "L2RaidBoss", 40, 43316.308536, 259.2, 18.438531, 1.5, 60, 57, 73, 76, 70, 80, 2541012, 79280, 74.22232, 305.50599, 4.67967, 149.04, 253, 4, 333, 0, 0, 0, 60, 190, 0, 1), 
(25150, 25150, "Evil Spirit Archer", 0, "Raid Fighter", 0, "LineageMonster.skeleton_archer", 11, 27, 24, "male", "L2Monster", 1100, 4475.706738, 245.52, 17.96077, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 136.64091, 148.06379, 17.20301, 144.46, 253, 8, 333, 14, 0, 0, 40, 170, 0, 1), 
(25151, 25151, "Evil Spirit Warrior", 0, "Raid Fighter", 0, "LineageMonster.skeleton", 11, 25, 24, "male", "L2Monster", 40, 3340.079655, 245.52, 17.96077, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 136.64091, 148.06379, 17.20301, 144.46, 253, 4, 333, 946, 0, 0, 60, 170, 0, 1), 
(25152, 25152, "Flame Lord Shadar", 0, "Raid Boss", 0, "LineageMonster.dre_vanul_100_bi", 28, 75, 35, "male", "L2RaidBoss", 40, 69449.568455, 402.6, 26.794392, 1.8, 60, 57, 73, 76, 70, 80, 1912395, 144137, 163.69565, 410.18844, 12.93, 200.1, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), 
(25153, 25153, "Claws of Shadar", 0, "Raid Fighter", 0, "LineageMonster.imp", 10, 24, 34, "male", "L2Monster", 40, 10526.667869, 387.72, 25.612831, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 606.9712, 199.4229, 192.64979, 194.58, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(25154, 25154, "Whip of Shadar", 0, "Raid Fighter", 0, "LineageMonster.succubus", 10, 36, 34, "female", "L2Monster", 40, 5263.333934, 387.72, 25.612831, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 303.4856, 199.4229, 48.16245, 194.58, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(25155, 25155, "Shaman King Selu", 0, "Raid Boss", 0, "LineageMonster.batur_orc_overlord_100_bi", 24, 52, 40, "male", "L2RaidBoss", 40, 123885.150698, 478.8, 45.769266, 1.8, 60, 57, 73, 76, 70, 80, 2741414, 271385, 441.8825, 469.65105, 64.68561, 229.12, 253, 4, 333, 79, 0, 0, 80, 170, 0, 1), 
(25156, 25156, "Fanatic Shaman", 0, "Raid Fighter", 0, "LineageMonster.batur_orc_shaman", 11, 16, 39, "male", "L2Monster", 40, 12518.769482, 463.32, 43.476782, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 1096.87417, 228.70128, 426.43539, 223.14, 253, 4, 333, 123, 19, 0, 50, 170, 0, 1), 
(25157, 25157, "Fanatic Soldier", 0, "Raid Fighter", 0, "LineageMonster.batur_orc_warrior", 10, 20, 39, "male", "L2Monster", 40, 18684.730571, 463.32, 43.476782, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 1645.35239, 228.70128, 959.5216, 223.14, 253, 1, 333, 7, 0, 0, 80, 170, 0, 1), 
(25158, 25158, "King Tarlk", 0, "Raid Boss", 0, "LineageMonster.king_bugbear_200_bi", 45, 126, 48, "male", "L2RaidBoss", 40, 386886.590885, 692.4, 169.608687, 2.1, 60, 57, 73, 76, 70, 80, 3443211, 354989, 1515.63787, 573.38409, 663.49812, 279.72, 253, 4, 333, 160, 0, 0, 55, 170, 0, 1), 
(25159, 25159, "Paniel the Unicorn", 0, "Raid Boss", 0, "LineageMonster.unicorn", 14, 30, 54, "male", "L2RaidBoss", 40, 182880.877656, 861, 62.194389, 2.4, 60, 57, 73, 76, 70, 80, 2422283, 313577, 578.02017, 656.68767, 87.11542, 320.36, 253, 4, 333, 0, 0, 0, 46, 170, 0, 1), 
(25160, 25160, "Rapini the Unicorn", 0, "Raid Fighter", 0, "LineageMonster.unicorn_boxer", 11, 18, 53, "male", "L2Monster", 40, 28159.61653, 832.4, 60.163394, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 1093.15425, 321.27489, 322.48909, 313.46, 253, 4, 333, 0, 0, 0, 27, 170, 0, 1), 
(25161, 25161, "Ririf the Unicorn", 0, "Raid Fighter", 0, "LineageMonster.unicorn_mirage", 13, 17, 53, "male", "L2Monster", 40, 14079.808265, 832.4, 60.163394, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 1093.15425, 321.27489, 322.48909, 313.46, 253, 4, 333, 0, 0, 0, 27, 170, 0, 1), 
(25162, 25162, "Giant Marpanak", 0, "Raid Boss", 0, "LineageMonster.lesser_giant_100_bi", 42, 91, 60, "male", "L2RaidBoss", 40, 614249.151468, 1036.8, 253.244359, 2.4, 60, 57, 73, 76, 70, 80, 4154684, 587467, 2937.05045, 742.95024, 1851.60109, 362.44, 253, 4, 333, 3937, 0, 0, 15, 180, 0, 1), 
(25163, 25163, "Roaring Skylancer", 0, "Raid Boss", 0, "LineageMonster3.Drake_Raid", 44, 51.5, 70, "male", "L2RaidBoss", 40, 746772.142485, 1345.8, 294.210906, 2.7, 60, 57, 73, 76, 70, 80, 4596479, 802604, 4309.76223, 887.74791, 2869.61549, 433.08, 253, 4, 333, 0, 0, 0, 60, 190, 0, 1), 
(25166, 25166, "Ikuntai", 0, "Raid Boss", 0, "LineageMonster.skeleton_knight_50_bi", 15, 39, 25, "male", "L2RaidBoss", 40, 56644.139929, 259.2, 24.086233, 1.5, 60, 57, 73, 76, 70, 80, 1589296, 122871, 138.03739, 305.50599, 16.13317, 149.04, 253, 4, 333, 150, 0, 0, 40, 170, 0, 1), 
(25167, 25167, "Ikuntai's Servitor", 0, "Raid Fighter", 0, "LineageMonster.silhouette", 8, 23, 24, "female", "L2Monster", 40, 8725.562981, 245.52, 23.437467, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 253.59237, 148.06379, 59.18346, 144.46, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), 
(25168, 25168, "Pawn of Ikuntai", 0, "Raid Fighter", 0, "LineageMonster.skeleton_pikeman", 10, 28, 24, "male", "L2Monster", 40, 4362.78149, 245.52, 23.437467, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 253.59237, 148.06379, 59.18346, 144.46, 253, 4, 333, 299, 0, 0, 50, 170, 0, 1), 
(25169, 25169, "Ragraman", 0, "Raid Boss", 0, "LineageMonster.batur_orc_overlord_100_bi", 24, 52, 30, "male", "L2RaidBoss", 40, 141484.138004, 329.4, 71.411606, 1.5, 60, 57, 73, 76, 70, 80, 1868579, 150667, 416.07296, 355.39281, 100.07089, 173.38, 253, 4, 333, 72, 0, 0, 80, 170, 0, 1), 
(25170, 25170, "Lizardmen Leader Hellion", 0, "Raid Boss", 0, "LineageMonster.zenta_lizardman_matriarch_50_bi", 30, 63, 38, "male", "L2RaidBoss", 40, 82089.052445, 447.96, 30.872687, 1.8, 60, 57, 73, 76, 70, 80, 1957608, 163199, 204.55422, 445.32861, 16.14769, 217.24, 253, 8, 333, 223, 0, 0, 53, 170, 0, 1), 
(25171, 25171, "Hellion's Archers", 0, "Raid Fighter", 0, "LineageMonster.zenta_lizardman_scout", 11, 30, 37, "male", "L2Monster", 1100, 8317.932837, 432.72, 29.423287, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 380.12443, 216.71637, 60.27327, 211.44, 253, 8, 333, 278, 0, 0, 37, 170, 0, 1), 
(25172, 25172, "Hellion's Guards", 0, "Raid Fighter", 0, "LineageMonster.zenta_lizardman_warrior", 13, 35, 37, "male", "L2Monster", 40, 6207.412565, 432.72, 29.423287, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 380.12443, 216.71637, 60.27327, 211.44, 253, 4, 333, 291, 0, 0, 40, 170, 0, 1), 
(25173, 25173, "Tiger King Karuta", 0, "Raid Boss", 0, "LineageMonster.saber_toothed_tiger_200_bi", 72, 87, 45, "male", "L2RaidBoss", 40, 121183.101254, 610.8, 43.342559, 2.1, 60, 57, 73, 76, 70, 80, 2085510, 229987, 333.67447, 533.36238, 35.73201, 260.2, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(25174, 25174, "Karuta's Follower", 0, "Raid Fighter", 0, "LineageMonster.heltor_silenos_chieftain", 13, 31.5, 44, "male", "L2Monster", 40, 18378.20662, 584, 41.347042, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 624.12426, 260.15328, 130.5309, 253.82, 253, 4, 333, 127, 0, 0, 27, 170, 0, 1), 
(25175, 25175, "Karuta's Inferiors", 0, "Raid Fighter", 0, "LineageMonster.crimson_bear", 19, 36, 44, "male", "L2Monster", 40, 9189.10331, 584, 41.347042, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 624.12426, 260.15328, 130.5309, 253.82, 253, 4, 333, 0, 0, 0, 37, 170, 0, 1), 
(25176, 25176, "Black Lily", 0, "Raid Boss", 0, "LineageMonster3.Succubus_Raid", 12, 30.7, 55, "female", "L2RaidBoss", 40, 189660.12936, 889.8, 64.171341, 2.4, 60, 57, 73, 76, 70, 80, 2477107, 327038, 610.43901, 670.9086, 93.51865, 327.3, 253, 4, 333, 0, 0, 0, 60, 190, 0, 1), 
(25177, 25177, "Guardian Knight of Black Lily", 0, "Raid Fighter", 0, "LineageMonster.death_knight", 12, 31, 54, "male", "L2Monster", 40, 29260.940425, 861, 62.194389, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 2312.08069, 328.34384, 1393.84679, 320.36, 253, 4, 333, 75, 0, 0, 27, 170, 0, 1), 
(25178, 25178, "Servitor of Black Lily", 0, "Raid Fighter", 0, "LineageMonster.silhouette", 8, 23, 54, "female", "L2Monster", 40, 14630.470212, 861, 62.194389, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 1156.04035, 328.34384, 348.4617, 320.36, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), 
(25179, 25179, "Guardian of the Statue of Giant Karum", 0, "Raid Boss", 0, "LineageMonster.lesser_giant_shooter_50_bi", 30, 66, 60, "male", "L2RaidBoss", 1100, 221100.024975, 1036.8, 72.964382, 2.4, 60, 57, 73, 76, 70, 80, 2735033, 394692, 785.17745, 742.95024, 133.51196, 362.44, 253, 8, 333, 4028, 0, 0, 80, 180, 0, 1), 
(25180, 25180, "Karum's Guard", 0, "Raid Fighter", 0, "LineageMonster.lesser_giant_mage", 21, 44, 59, "male", "L2Monster", 40, 23070.255753, 1007, 71.371054, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 1996.68411, 364.2239, 872.03635, 355.36, 253, 4, 333, 3938, 0, 0, 15, 180, 0, 1), 
(25181, 25181, "Karum's Warrior", 0, "Raid Fighter", 0, "LineageMonster.susceptor", 20, 35, 59, "male", "L2Monster", 40, 34433.217541, 1007, 71.371054, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 2995.10104, 364.2239, 1962.16762, 355.36, 253, 4, 333, 0, 0, 0, 27, 170, 0, 1), 
(25182, 25182, "Demon Kurikups", 0, "Raid Boss", 0, "LineageMonster.karik_100_bi", 50, 180, 59, "male", "L2RaidBoss", 40, 215207.609633, 1007, 71.371054, 2.4, 60, 57, 73, 76, 70, 80, 2684275, 381459, 748.77526, 728.44779, 122.63548, 355.36, 253, 4, 333, 0, 0, 0, 37, 200, 0, 1), 
(25183, 25183, "Kurikups' Wife", 0, "Raid Fighter", 0, "LineageMonster.bloody_queen", 14, 40, 58, "female", "L2Monster", 40, 33456.124134, 977.4, 69.690691, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 1426.04441, 356.99144, 460.01277, 348.3, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), 
(25184, 25184, "Devil Blader of Chaos", 0, "Raid Fighter", 0, "LineageMonster.death_blader", 15, 45, 58, "male", "L2Monster", 40, 16728.062067, 977.4, 69.690691, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 1426.04441, 356.99144, 460.01277, 348.3, 253, 4, 333, 1472, 0, 0, 100, 170, 0, 1), 
(25185, 25185, "Tasaba Patriarch Hellena", 0, "Raid Boss", 0, "LineageMonster.zenta_lizardman_matriarch", 20, 40, 35, "male", "L2RaidBoss", 40, 69449.568455, 402.6, 26.794392, 1.8, 60, 57, 73, 76, 70, 80, 1912395, 144137, 163.69565, 410.18844, 12.93, 200.1, 253, 8, 333, 225, 0, 0, 53, 170, 0, 1), 
(25186, 25186, "Hellena's Marksman", 0, "Raid Fighter", 0, "LineageMonster.zenta_lizardman_scout", 11, 30, 34, "male", "L2Monster", 1100, 7052.867472, 387.72, 25.612831, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 303.4856, 199.4229, 48.16245, 194.58, 253, 8, 333, 272, 0, 0, 37, 170, 0, 1), 
(25187, 25187, "Helena's Soldier", 0, "Raid Fighter", 0, "LineageMonster.zenta_lizardman_warrior", 13, 35, 34, "male", "L2Monster", 40, 5263.333934, 387.72, 25.612831, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 303.4856, 199.4229, 48.16245, 194.58, 253, 4, 333, 16, 0, 0, 40, 170, 0, 1), 
(25188, 25188, "Apepi", 0, "Raid Boss", 0, "LineageMonster.lienrik", 12, 50, 30, "male", "L2RaidBoss", 40, 107380.067377, 329.4, 54.285096, 1.5, 60, 57, 73, 76, 70, 80, 2308288, 111484, 222.43755, 355.39281, 28.85951, 173.38, 253, 4, 333, 0, 0, 0, 100, 170, 0, 1), 
(25189, 25189, "Cronos's Servitor Mumu", 0, "Raid Boss", 0, "LineageMonster.cutie_cat", 8, 15, 34, "female", "L2RaidBoss", 40, 65791.674179, 387.72, 25.612831, 1.8, 60, 57, 73, 76, 70, 80, 1918617, 135504, 151.7428, 398.8458, 12.04061, 194.58, 253, 4, 333, 0, 0, 0, 48, 170, 0, 1), 
(25190, 25190, "Mumu's Wizard", 0, "Raid Fighter", 0, "LineageMonster.cutie_cat", 8, 15, 33, "female", "L2Monster", 40, 6689.081307, 372.96, 24.517094, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 374.81071, 193.84643, 79.6019, 189.14, 253, 4, 333, 0, 0, 0, 48, 170, 0, 1), 
(25191, 25191, "Mumu's Warrior", 0, "Raid Fighter", 0, "LineageMonster.cat_the_cat", 9, 16, 33, "male", "L2Monster", 40, 9983.703443, 372.96, 24.517094, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 562.23012, 193.84643, 179.1121, 189.14, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), 
(25192, 25192, "Earth Protector Panathen", 0, "Raid Boss", 0, "LineageMonster.farhite", 16, 31, 43, "male", "L2RaidBoss", 40, 108760.132419, 557.4, 39.411275, 2.1, 60, 57, 73, 76, 70, 80, 1976893, 206038, 291.5444, 507.40251, 29.76552, 247.54, 253, 1, 333, 183, 0, 0, 15, 170, 0, 1), 
(25193, 25193, "Panathen's Knight", 0, "Raid Fighter", 0, "LineageMonster.nos", 26, 42, 42, "male", "L2Monster", 40, 16462.952785, 531, 37.54353, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 1088.40749, 247.3277, 433.04587, 241.32, 253, 4, 333, 5130, 0, 0, 18, 170, 0, 1), 
(25194, 25194, "Panathen's Protectors", 0, "Raid Fighter", 0, "LineageMonster.dailaon", 20, 28, 42, "male", "L2Monster", 1100, 8231.476393, 531, 37.54353, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 544.20375, 247.3277, 108.26147, 241.32, 253, 8, 333, 5127, 0, 0, 18, 170, 0, 1), 
(25198, 25198, "Fafurion's Herald Lokness", 0, "Raid Boss", 0, "LineageMonster3.Water_Drake", 55, 80.5, 70, "female", "L2RaidBoss", 40, 746772.142485, 1345.8, 294.210906, 2.7, 60, 57, 73, 76, 70, 80, 4596479, 802604, 4309.76223, 887.74791, 2869.61549, 433.08, 253, 4, 333, 0, 0, 0, 60, 190, 0, 1), 
(25199, 25199, "Water Dragon Seer Sheshark", 0, "Raid Boss", 0, "LineageMonster.virud_lizardman_shaman", 10, 29, 72, "male", "L2RaidBoss", 40, 383459.92099, 1410, 119.969287, 3, 60, 57, 73, 76, 70, 80, 5140647, 827123, 2280.56634, 916.07841, 813.63722, 446.9, 253, 4, 333, 181, 0, 0, 43, 200, 0, 1), 
(25200, 25200, "Family of Sheshark", 0, "Raid Fighter", 0, "LineageMonster.lienrik", 12, 50, 71, "male", "L2Monster", 40, 40576.868997, 1377.8, 118.846913, 3, 40, 43, 30, 21, 20, 20, 0, 0, 5916.53342, 450.98039, 5656.07573, 440.02, 253, 4, 333, 0, 0, 0, 100, 170, 0, 1), 
(25201, 25201, "Guard of Sheshark", 0, "Raid Fighter", 0, "LineageMonster.virud_lizardman_warrior", 12, 30, 71, "male", "L2Monster", 40, 60562.49104, 1377.8, 118.846913, 3, 40, 43, 30, 21, 20, 20, 0, 0, 8875.022, 450.98039, 12726.72719, 440.02, 253, 4, 333, 6370, 0, 0, 52, 170, 0, 1), 
(25202, 25202, "Krokian Padisha Sobekk", 0, "Raid Boss", 0, "LineageMonster.nos_100_bi", 52, 86, 74, "male", "L2RaidBoss", 40, 392895.926409, 1475, 122.142751, 3, 60, 57, 73, 76, 70, 80, 5199407, 852059, 2396.99019, 943.97961, 851.89721, 460.5, 253, 4, 333, 5130, 0, 0, 18, 170, 0, 1), 
(25203, 25203, "Parhit Padisha Sobekk", 0, "Raid Fighter", 0, "LineageMonster.farhite_100_bi", 32, 65, 73, "male", "L2Monster", 40, 62119.189069, 1442.4, 121.063992, 3, 40, 43, 30, 21, 20, 20, 0, 0, 4680.0994, 465.04439, 3338.16499, 453.74, 253, 4, 333, 5131, 0, 0, 15, 170, 0, 1), 
(25204, 25204, "Krokian Padisha Sobekk", 0, "Raid Fighter", 0, "LineageMonster.crokian_100_bi", 36, 61, 73, "male", "L2Monster", 40, 31059.594535, 1442.4, 121.063992, 3, 40, 43, 30, 21, 20, 20, 0, 0, 4680.0994, 465.04439, 3338.16499, 453.74, 253, 4, 333, 5128, 0, 0, 18, 170, 0, 1), 
(25205, 25205, "Ocean Flame Ashakiel", 0, "Raid Boss", 0, "LineageMonster.archangel_50_bi", 22, 120, 76, "male", "L2RaidBoss", 40, 401886.766609, 1540.8, 124.302529, 3, 60, 57, 73, 76, 70, 80, 5267108, 1171763, 2501.79548, 971.35365, 888.04886, 473.86, 253, 4, 333, 98, 0, 0, 50, 170, 0, 1), 
(25206, 25206, "Ashakiel's Blade", 0, "Raid Fighter", 0, "LineageMonster2.apostle_warrior", 8, 30, 75, "female", "L2Monster", 40, 63589.96023, 1507.8, 123.21629, 3, 40, 43, 30, 21, 20, 20, 0, 0, 9804.89392, 478.86935, 13902.01643, 467.22, 253, 4, 333, 6717, 0, 0, 50, 170, 0, 1), 
(25207, 25207, "Ashakiel's Rod", 0, "Raid Fighter", 0, "LineageMonster2.apostle_mage", 11, 38.5, 75, "male", "L2Monster", 40, 31794.980115, 1507.8, 123.21629, 3, 40, 43, 30, 21, 20, 20, 0, 0, 4902.44696, 478.86935, 3475.50411, 467.22, 253, 4, 333, 6718, 0, 0, 50, 170, 0, 1), 
(25208, 25208, "Water Couatle Ateka", 0, "Raid Boss", 0, "LineageMonster.lienrik", 12, 50, 40, "male", "L2RaidBoss", 40, 91937.38614, 478.8, 34.038778, 1.8, 60, 57, 73, 76, 70, 80, 2030965, 181264, 236.34363, 469.65105, 18.66292, 229.12, 253, 4, 333, 0, 0, 0, 100, 170, 0, 1), 
(25209, 25209, "Ateka's Shaman", 0, "Raid Fighter", 0, "LineageMonster.lienrik", 12, 50, 39, "male", "L2Monster", 40, 9312.608644, 463.32, 32.411747, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 586.57028, 228.70128, 123.0125, 223.14, 253, 4, 333, 0, 0, 0, 100, 170, 0, 1), 
(25210, 25210, "Ateka's Grunt", 0, "Raid Fighter", 0, "LineageMonster.lienrik", 12, 50, 39, "male", "L2Monster", 40, 13899.415887, 463.32, 32.411747, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 879.87742, 228.70128, 276.79024, 223.14, 253, 4, 333, 0, 0, 0, 100, 170, 0, 1), 
(25211, 25211, "Sebek", 0, "Raid Boss", 0, "LineageMonster.nos", 26, 42, 36, "male", "L2RaidBoss", 40, 73380.923976, 417.6, 28.064045, 1.8, 60, 57, 73, 76, 70, 80, 1916442, 153260, 176.45564, 421.71834, 14.03993, 205.74, 253, 4, 333, 5130, 0, 0, 18, 170, 0, 1), 
(25212, 25212, "Sebek's Priest", 0, "Raid Fighter", 0, "LineageMonster.zenta_lizardman_scout", 11, 30, 35, "male", "L2Monster", 1100, 7444.993738, 402.6, 26.794392, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 327.3913, 205.09422, 51.71999, 200.1, 253, 8, 333, 279, 0, 0, 37, 170, 0, 1), 
(25213, 25213, "Sebek's Fanatic", 0, "Raid Fighter", 0, "LineageMonster.dailaon", 20, 28, 35, "male", "L2Monster", 1100, 5555.965476, 402.6, 26.794392, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 327.3913, 205.09422, 51.71999, 200.1, 253, 8, 333, 5127, 0, 0, 18, 170, 0, 1), 
(25214, 25214, "Fafurion's Page Sika", 0, "Raid Boss", 0, "LineageMonster.water_giant", 13, 44, 40, "male", "L2RaidBoss", 80, 91937.38614, 478.8, 34.038778, 1.8, 60, 57, 73, 76, 70, 80, 2030965, 181264, 236.34363, 469.65105, 18.66292, 229.12, 253, 4, 333, 5132, 0, 0, 35, 170, 0, 1), 
(25215, 25215, "Sika's Wizard", 0, "Raid Fighter", 0, "LineageMonster.undine", 12, 27, 39, "female", "L2Monster", 40, 9312.608644, 463.32, 32.411747, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 586.57028, 228.70128, 123.0125, 223.14, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(25216, 25216, "Sika's Fighter", 0, "Raid Fighter", 0, "LineageMonster.undine", 12, 27, 39, "female", "L2Monster", 40, 13899.415887, 463.32, 32.411747, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 879.87742, 228.70128, 276.79024, 223.14, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(25217, 25217, "Cursed Clara", 0, "Raid Boss", 0, "LineageMonster.medusa", 10, 25, 50, "female", "L2RaidBoss", 40, 155046.064475, 747.8, 53.854634, 2.1, 60, 57, 73, 76, 70, 80, 2389767, 281312, 458.48043, 600.71532, 56.52768, 293.06, 253, 8, 333, 0, 0, 0, 50, 170, 0, 1), 
(25218, 25218, "Clara's Marksman", 0, "Raid Fighter", 0, "LineageMonster.virud_lizardman_scout", 10, 22, 49, "male", "L2Monster", 1100, 15873.75728, 720, 51.719311, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 862.56672, 293.49453, 207.71039, 286.36, 253, 8, 333, 2507, 0, 0, 43, 170, 0, 1), 
(25219, 25219, "Clara's Pawn", 0, "Raid Fighter", 0, "LineageMonster.virud_lizardman_warrior", 12, 30, 49, "male", "L2Monster", 40, 11846.087522, 720, 51.719311, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 862.56672, 293.49453, 207.71039, 286.36, 253, 4, 333, 94, 0, 0, 52, 170, 0, 1), 
(25220, 25220, "Death Lord Hallate", 0, "Raid Boss", 0, "LineageMonster.death_lord", 21, 40, 73, "male", "L2RaidBoss", 40, 388244.931684, 1442.4, 121.063992, 3, 60, 57, 73, 76, 70, 80, 5168419, 839126, 2340.0497, 930.08877, 834.54125, 453.74, 253, 4, 333, 78, 0, 0, 40, 170, 0, 1), 
(25221, 25221, "Death Mage Krician", 0, "Raid Fighter", 0, "LineageMonster.death_blader", 15, 45, 72, "male", "L2Monster", 40, 41106.90353, 1410, 119.969287, 3, 40, 43, 30, 21, 20, 20, 0, 0, 6081.35821, 458.03921, 5785.61151, 446.9, 253, 4, 333, 1472, 0, 0, 100, 170, 0, 1), 
(25222, 25222, "Death Fighter Harik", 0, "Raid Fighter", 0, "LineageMonster.death_knight", 12, 31, 72, "male", "L2Monster", 40, 61353.587358, 1410, 119.969287, 3, 40, 43, 30, 21, 20, 20, 0, 0, 9122.26537, 458.03921, 13018.19544, 446.9, 253, 4, 333, 75, 0, 0, 27, 170, 0, 1), 
(25223, 25223, "Soul Collector Acheron", 0, "Raid Boss", 0, "LineageMonster.vale_master_50_bi", 18, 63, 35, "male", "L2RaidBoss", 40, 69449.568455, 402.6, 26.794392, 1.8, 60, 57, 73, 76, 70, 80, 1912395, 144137, 163.69565, 410.18844, 12.93, 200.1, 253, 1, 333, 192, 0, 0, 70, 160, 0, 1), 
(25224, 25224, "Soul Slasher", 0, "Raid Fighter", 0, "LineageMonster.dark_horror", 20, 35, 34, "male", "L2Monster", 40, 7052.867472, 387.72, 25.612831, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 404.63735, 199.4229, 85.61838, 194.58, 253, 1, 333, 0, 0, 0, 100, 140, 0, 1), 
(25225, 25225, "Soul Strainer", 0, "Raid Fighter", 0, "LineageMonster.hungry_spirit", 30, 40, 34, "male", "L2Monster", 40, 10526.667869, 387.72, 25.612831, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 606.9712, 199.4229, 192.64979, 194.58, 253, 1, 333, 0, 0, 0, 15, 155, 0, 1), 
(25226, 25226, "Roaring Lord Kastor", 0, "Raid Boss", 0, "LineageMonster.oel_mahum_witch_doctor_50_bi", 22.5, 54, 62, "male", "L2RaidBoss", 40, 322915.008584, 1097, 105.482286, 2.7, 60, 57, 73, 76, 70, 80, 4417539, 712205, 1606.18889, 772.02801, 538.7214, 376.62, 253, 1, 333, 186, 0, 0, 70, 180, 0, 1), 
(25227, 25227, "Kastor's Seer", 0, "Raid Fighter", 0, "LineageMonster.oel_mahum_witch_doctor", 15, 34, 61, "male", "L2Monster", 40, 50429.723461, 1066.8, 103.454193, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 3074.03785, 378.74019, 2082.55682, 369.52, 253, 1, 333, 9, 0, 0, 70, 170, 0, 1), 
(25228, 25228, "Kastor's Prefect", 0, "Raid Fighter", 0, "LineageMonster.oel_mahum_warrior", 20, 38, 61, "male", "L2Monster", 40, 25214.861731, 1066.8, 103.454193, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 3074.03785, 378.74019, 2082.55682, 369.52, 253, 4, 333, 79, 0, 0, 70, 190, 0, 1), 
(25229, 25229, "Storm Winged Naga", 0, "Raid Boss", 0, "LineageMonster.wyrm_50_bi", 58, 108, 75, "male", "L2RaidBoss", 40, 794874.50288, 1507.8, 308.040724, 3, 60, 57, 73, 76, 70, 80, 5231148, 864099, 4902.44696, 957.73869, 3475.50411, 467.22, 253, 4, 333, 0, 0, 0, 70, 200, 0, 1), 
(25230, 25230, "Timak Seer Ragoth", 0, "Raid Boss", 0, "LineageMonster.batur_orc_shaman_50_bi", 15, 25, 57, "male", "L2RaidBoss", 40, 202794.195341, 948, 67.926903, 2.4, 60, 57, 73, 76, 70, 80, 2581681, 354156, 678.00086, 699.56517, 107.08625, 341.28, 253, 1, 333, 201, 0, 0, 50, 160, 0, 1), 
(25231, 25231, "Ragoth's Guard", 0, "Raid Fighter", 0, "LineageMonster.batur_orc_warrior", 10, 20, 56, "male", "L2Monster", 40, 31409.042089, 918.8, 66.084883, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 2575.13922, 342.60203, 1602.60653, 334.26, 253, 4, 333, 74, 657, 0, 80, 175, 0, 1), 
(25232, 25232, "Ragoth's Herald", 0, "Raid Fighter", 0, "LineageMonster.batur_orc", 9, 21.5, 56, "male", "L2Monster", 40, 15704.521044, 918.8, 66.084883, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 1287.56961, 342.60203, 400.65163, 334.26, 253, 8, 333, 74, 0, 0, 80, 165, 0, 1), 
(25233, 25233, "Spirit of Andras the Betrayer", 0, "Raid Boss", 0, "LineageMonster.headless_knight_50_bi", 30, 46.5, 69, "male", "L2RaidBoss", 40, 528013.331879, 1314, 208.900753, 2.7, 60, 57, 73, 76, 70, 80, 2969653, 474928, 2246.91708, 873.45189, 804.53961, 426.1, 253, 4, 333, 2500, 0, 0, 70, 190, 0, 1), 
(25234, 25234, "Ancient Weird Drake", 0, "Raid Boss", 0, "LineageMonster.drake_50_bi", 45, 150, 60, "male", "L2RaidBoss", 40, 442200.04995, 1036.8, 182.410956, 2.4, 60, 57, 73, 76, 70, 80, 2735033, 394692, 1570.3549, 742.95024, 534.04783, 362.44, 253, 4, 333, 0, 0, 0, 70, 170, 0, 1), 
(25235, 25235, "Vanor Chief Kandra", 0, "Raid Boss", 0, "LineageMonster.heltor_silenos_50_bi", 19, 43.5, 72, "male", "L2RaidBoss", 40, 383459.92099, 1410, 119.969287, 3, 60, 57, 73, 76, 70, 80, 5140647, 827123, 2280.56634, 916.07841, 813.63722, 446.9, 253, 4, 333, 135, 0, 0, 34, 180, 0, 1), 
(25236, 25236, "Kandra's Healer", 0, "Raid Fighter", 0, "LineageMonster.heltor_silenos_shaman", 13, 32, 71, "male", "L2Monster", 40, 60562.49104, 1377.8, 118.846913, 3, 40, 43, 30, 21, 20, 20, 0, 0, 4437.511, 450.98039, 3181.6818, 440.02, 253, 1, 333, 200, 0, 0, 29, 170, 0, 1), 
(25237, 25237, "Kandra's Guard", 0, "Raid Fighter", 0, "LineageMonster.heltor_silenos_warrior", 13, 31, 71, "male", "L2Monster", 40, 30281.24552, 1377.8, 118.846913, 3, 40, 43, 30, 21, 20, 20, 0, 0, 4437.511, 450.98039, 3181.6818, 440.02, 253, 4, 333, 228, 0, 0, 36, 190, 0, 1), 
(25238, 25238, "Abyss Brukunt", 0, "Raid Boss", 0, "LineageMonster.drake_50_bi", 45, 150, 59, "male", "L2RaidBoss", 40, 215207.609633, 1007, 71.371054, 2.4, 60, 57, 73, 76, 70, 80, 2684275, 381459, 748.77526, 728.44779, 122.63548, 355.36, 253, 4, 333, 0, 0, 0, 70, 185, 0, 1), 
(25239, 25239, "Monstrous Beast of Abyss Brukunt", 0, "Raid Fighter", 0, "LineageMonster.hunter_gargoyle", 25, 65, 58, "male", "L2Monster", 40, 33456.124134, 977.4, 69.690691, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 1426.04441, 356.99144, 460.01277, 348.3, 253, 1, 333, 0, 0, 0, 100, 180, 0, 1), 
(25240, 25240, "Wild Beast of Abyss Brukunt", 0, "Raid Fighter", 0, "LineageMonster.saber_toothed_tiger", 34, 28, 58, "male", "L2Monster", 40, 16728.062067, 977.4, 69.690691, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 1426.04441, 356.99144, 460.01277, 348.3, 253, 4, 333, 0, 0, 0, 60, 190, 0, 1), 
(25241, 25241, "Harit Hero Tamash", 0, "Raid Boss", 0, "LineageMonster.zenta_lizardman_warrior_50_bi", 18, 53, 55, "male", "L2RaidBoss", 40, 262379.847927, 889.8, 88.695358, 2.4, 60, 57, 73, 76, 70, 80, 3983098, 535296, 1142.75903, 670.9086, 324.54053, 327.3, 253, 1, 333, 298, 0, 0, 40, 175, 0, 1), 
(25242, 25242, "Tamash's Advisor", 0, "Raid Fighter", 0, "LineageMonster.zenta_lizardman_shaman", 13, 35, 54, "male", "L2Monster", 40, 27092.824496, 861, 85.863876, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 2885.37561, 328.34384, 2149.67807, 320.36, 253, 1, 333, 193, 0, 0, 43, 155, 0, 1), 
(25243, 25243, "Tamash's Servant", 0, "Raid Fighter", 0, "LineageMonster.zenta_lizardman", 11, 32, 54, "male", "L2Monster", 40, 40437.051486, 861, 85.863876, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 4328.17162, 328.34384, 4836.98728, 320.36, 253, 8, 333, 234, 0, 0, 37, 170, 0, 1), 
(25244, 25244, "Last Lesser Giant Olkuth", 0, "Raid Boss", 0, "LineageMonster.lesser_giant_50_bi", 31.5, 69, 75, "male", "L2RaidBoss", 40, 794874.50288, 1507.8, 308.040724, 3, 60, 57, 73, 76, 70, 80, 5231148, 864099, 4902.44696, 957.73869, 3475.50411, 467.22, 253, 1, 333, 78, 0, 0, 15, 140, 0, 1), 
(25245, 25245, "Last Lesser Giant Glaki", 0, "Raid Boss", 0, "LineageMonster.lesser_giant_mage_50_bi", 30, 66, 78, "male", "L2RaidBoss", 40, 410600.548543, 1607.4, 126.536106, 3, 60, 57, 73, 76, 70, 80, 5346496, 1193017, 2592.71887, 998.10183, 929.62086, 486.92, 253, 1, 333, 179, 0, 0, 15, 95, 0, 1), 
(25246, 25246, "Glaki's Henchman", 0, "Raid Fighter", 0, "LineageMonster.lesser_giant", 21, 44, 77, "male", "L2Monster", 40, 65002.827462, 1574, 125.407546, 3, 40, 43, 30, 21, 20, 20, 0, 0, 10195.55783, 492.4061, 14646.91221, 480.42, 253, 1, 333, 169, 0, 0, 15, 150, 0, 1), 
(25247, 25247, "Glaki's Servant", 0, "Raid Fighter", 0, "LineageMonster.lesser_giant", 21, 44, 77, "male", "L2Monster", 40, 32501.413731, 1574, 125.407546, 3, 40, 43, 30, 21, 20, 20, 0, 0, 5097.77892, 492.4061, 3661.72805, 480.42, 253, 1, 333, 166, 0, 0, 15, 140, 0, 1), 
(25248, 25248, "Doom Blade Tanatos", 0, "Raid Boss", 0, "LineageMonster3.Death_Blader_Raid", 15, 32.5, 72, "male", "L2RaidBoss", 40, 766919.841979, 1410, 299.923216, 3, 60, 57, 73, 76, 70, 80, 5140647, 827123, 4561.13269, 916.07841, 3254.54886, 446.9, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), 
(25249, 25249, "Palatanos of Horrific Power", 0, "Raid Boss", 0, "LineageMonster3.Jungle_Bleeze", 60, 47, 75, "female", "L2RaidBoss", 40, 397437.25144, 1507.8, 123.21629, 3, 60, 57, 73, 76, 70, 80, 5231148, 864099, 2451.22348, 957.73869, 868.87603, 467.22, 253, 1, 333, 0, 0, 0, 60, 190, 0, 1), 
(25250, 25250, "Man-Eating Plant of Palatanos", 0, "Raid Fighter", 0, "LineageMonster.mandragora_a", 15, 26, 74, "female", "L2Monster", 40, 42118.443311, 1475, 122.142751, 3, 40, 43, 30, 21, 20, 20, 0, 0, 6391.81404, 471.98981, 6057.67069, 460.5, 253, 1, 333, 0, 0, 0, 80, 170, 0, 1), 
(25251, 25251, "Sapling of Palatanos", 0, "Raid Fighter", 0, "LineageMonster.mandragora_a", 15, 26, 74, "female", "L2Monster", 40, 62863.348225, 1475, 122.142751, 3, 40, 43, 30, 21, 20, 20, 0, 0, 9587.96075, 471.98981, 13630.35538, 460.5, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), 
(25252, 25252, "Palibati Queen Themis", 0, "Raid Boss", 0, "LineageMonster.cave_maiden_50_bi", 37, 98, 70, "female", "L2RaidBoss", 40, 373386.071242, 1345.8, 117.684362, 2.7, 60, 57, 73, 76, 70, 80, 4596479, 802604, 2154.88112, 887.74791, 717.40387, 433.08, 253, 8, 333, 234, 0, 0, 70, 160, 0, 1), 
(25253, 25253, "Handmaiden of Themis", 0, "Raid Fighter", 0, "LineageMonster.succubus", 10, 36, 69, "female", "L2Monster", 40, 39454.502253, 1314, 116.468584, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 5571.20004, 436.72595, 4930.48367, 426.1, 253, 4, 333, 0, 0, 0, 60, 150, 0, 1), 
(25254, 25254, "Themis's Sentinel", 0, "Raid Fighter", 0, "LineageMonster.death_blader", 15, 45, 69, "male", "L2Monster", 40, 58887.316796, 1314, 116.468584, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 8357.00898, 436.72595, 11094.07362, 426.1, 253, 4, 333, 1472, 0, 0, 100, 170, 0, 1), 
(25255, 25255, "Gargoyle Lord Tiphon", 0, "Raid Boss", 0, "LineageMonster.hunter_gargoyle_50_bi", 37, 98, 65, "male", "L2RaidBoss", 40, 688201.003655, 1188.8, 277.057601, 2.7, 60, 57, 73, 76, 70, 80, 4489693, 746626, 3631.0152, 815.67099, 2425.23781, 397.92, 253, 4, 333, 0, 0, 0, 100, 180, 0, 1), 
(25256, 25256, "Taik High Prefect Arak", 0, "Raid Boss", 0, "LineageMonster.ketra_orc_warrior_50_bi", 18, 37, 60, "male", "L2RaidBoss", 40, 221100.024975, 1036.8, 72.964382, 2.4, 60, 57, 73, 76, 70, 80, 2735033, 394692, 785.17745, 742.95024, 133.51196, 362.44, 253, 4, 333, 71, 0, 0, 36, 175, 0, 1), 
(25257, 25257, "Arak's Archer", 0, "Raid Fighter", 0, "LineageMonster.ketra_orc_archer", 12, 27, 59, "male", "L2Monster", 1100, 23070.255753, 1007, 71.371054, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 1497.55052, 364.2239, 490.54191, 355.36, 253, 8, 333, 283, 0, 0, 45, 160, 0, 1), 
(25258, 25258, "Arak's Footman", 0, "Raid Fighter", 0, "LineageMonster.ketra_orc", 12, 29, 59, "male", "L2Monster", 40, 17216.608771, 1007, 71.371054, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 1497.55052, 364.2239, 490.54191, 355.36, 253, 4, 333, 127, 0, 0, 45, 175, 0, 1), 
(25259, 25259, "Zaken's Butcher Krantz", 0, "Raid Boss", 0, "LineageMonster.ogre_50_bi", 30, 66, 55, "male", "L2RaidBoss", 40, 524759.695853, 889.8, 221.738396, 2.4, 60, 57, 73, 76, 70, 80, 3983098, 535296, 2285.51807, 670.9086, 1298.16213, 327.3, 253, 1, 333, 297, 0, 0, 22, 160, 0, 1), 
(25260, 25260, "Iron Giant Totem", 0, "Raid Boss", 0, "LineageMonster3.Steel_Trapper", 35, 46.38, 45, "male", "L2RaidBoss", 40, 165119.995136, 610.8, 58.948707, 2.1, 60, 57, 73, 76, 70, 80, 3259016, 329439, 623.77149, 533.36238, 123.8288, 260.2, 253, 1, 333, 0, 0, 0, 60, 180, 0, 1), 
(25261, 25261, "Totem Guard Archer", 0, "Raid Fighter", 0, "LineageMonster.batur_orc_archer", 11, 21.5, 44, "male", "L2Monster", 1100, 16743.063873, 584, 56.113661, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 1166.65265, 260.15328, 452.31928, 253.82, 253, 8, 333, 282, 0, 0, 45, 170, 0, 1), 
(25262, 25262, "Totem Guard", 0, "Raid Fighter", 0, "LineageMonster.batur_orc", 9, 21.5, 44, "male", "L2Monster", 40, 12494.823785, 584, 56.113661, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 1166.65265, 260.15328, 452.31928, 253.82, 253, 8, 333, 215, 0, 0, 80, 170, 0, 1), 
(25263, 25263, "Kernon's Faithful Servant Kelone", 0, "Raid Boss", 0, "LineageMonster.medusa_100_bi", 20, 53, 67, "female", "L2RaidBoss", 40, 356634.034509, 1251, 113.825371, 2.7, 60, 57, 73, 76, 70, 80, 4534433, 767699, 1954.06059, 844.65753, 645.97193, 412.06, 253, 1, 333, 0, 0, 0, 50, 165, 0, 1), 
(25264, 25264, "Kelone's Assassin", 0, "Raid Fighter", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 66, "male", "L2Monster", 40, 37575.45567, 1219.8, 112.374448, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 5026.70768, 415.09128, 4443.4398, 405, 253, 8, 333, 229, 0, 0, 80, 190, 0, 1), 
(25265, 25265, "Kelone's Secret Knight", 0, "Raid Fighter", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 66, "male", "L2Monster", 40, 56082.769657, 1219.8, 112.374448, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 7540.25002, 415.09128, 9998.17698, 405, 253, 4, 333, 229, 0, 0, 80, 180, 0, 1), 
(25266, 25266, "Bloody Empress Decarbia", 0, "Raid Boss", 0, "LineageMonster3.lidia_von_helmann_120p", 14, 31, 75, "female", "L2RaidBoss", 40, 397437.25144, 1507.8, 123.21629, 3, 60, 57, 73, 76, 70, 80, 5231148, 864099, 2451.22348, 957.73869, 868.87603, 467.22, 253, 4, 333, 0, 0, 0, 20, 190, 0, 1), 
(25267, 25267, "Decarbia's Royal Guard", 0, "Raid Fighter", 0, "LineageMonster.death_knight", 12, 31, 74, "male", "L2Monster", 40, 31431.674113, 1475, 122.142751, 3, 40, 43, 30, 21, 20, 20, 0, 0, 4793.98038, 471.98981, 3407.58884, 460.5, 253, 4, 333, 5286, 0, 0, 27, 200, 0, 1), 
(25268, 25268, "Decarbia's Escort", 0, "Raid Fighter", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 74, "male", "L2Monster", 40, 62863.348225, 1475, 122.142751, 3, 40, 43, 30, 21, 20, 20, 0, 0, 9587.96075, 471.98981, 13630.35538, 460.5, 253, 8, 333, 234, 0, 0, 80, 210, 0, 1), 
(25269, 25269, "Beast Lord Behemoth", 0, "Raid Boss", 0, "LineageMonster3.Elder_Troll", 46, 71.5, 70, "male", "L2RaidBoss", 40, 373386.071242, 1345.8, 117.684362, 2.7, 60, 57, 73, 76, 70, 80, 4596479, 802604, 2154.88112, 887.74791, 717.40387, 433.08, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), 
(25270, 25270, "Behemoth Javeliner", 0, "Raid Fighter", 0, "LineageMonster.virud_lizardman_scout", 10, 22, 69, "male", "L2Monster", 1100, 39454.502253, 1314, 116.468584, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 4178.50449, 436.72595, 2773.51841, 426.1, 253, 8, 333, 2507, 0, 0, 43, 170, 0, 1), 
(25271, 25271, "Behemoth Flare", 0, "Raid Fighter", 0, "LineageMonster.will_o_wisp", 13, 22, 69, "male", "L2Monster", 40, 29443.658398, 1314, 116.468584, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 4178.50449, 436.72595, 2773.51841, 426.1, 253, 1, 333, 0, 0, 0, 80, 165, 0, 1), 
(25272, 25272, "Partisan Leader Talakin", 0, "Raid Boss", 0, "LineageMonster.ol_mahum_champion_50_bi", 21, 43.5, 28, "male", "L2RaidBoss", 40, 97967.945523, 300.96, 50.532136, 1.5, 60, 57, 73, 76, 70, 80, 2390045, 97281, 189.60691, 334.84104, 24.23957, 163.34, 253, 1, 333, 77, 0, 0, 50, 190, 0, 1), 
(25273, 25273, "Carnamakos", 0, "Raid Boss", 0, "LineageMonster3.Steel_Trapper", 35, 46.38, 50, "male", "L2RaidBoss", 40, 213145.164738, 747.8, 73.933897, 2.1, 60, 57, 73, 76, 70, 80, 3551193, 422350, 857.79693, 600.71532, 196.05673, 293.06, 253, 1, 333, 0, 0, 0, 60, 180, 0, 1), 
(25274, 25274, "Carnabarun", 0, "Raid Fighter", 0, "LineageMonster.magical_weaver", 11, 20, 49, "male", "L2Monster", 40, 21787.806116, 720, 70.884287, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 2151.29692, 293.49453, 1280.4276, 286.36, 253, 1, 333, 0, 0, 0, 90, 170, 0, 1), 
(25275, 25275, "Carnassiud", 0, "Raid Fighter", 0, "LineageMonster.field_stalker", 15, 30, 49, "male", "L2Monster", 40, 32519.113606, 720, 70.884287, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 3227.02605, 293.49453, 2881.08815, 286.36, 253, 1, 333, 0, 0, 0, 70, 170, 0, 1), 
(25276, 25276, "Death Lord Ipos", 0, "Raid Boss", 0, "LineageMonster.death_lord_50_bi", 31, 61.5, 75, "male", "L2RaidBoss", 40, 794874.50288, 1507.8, 308.040724, 3, 60, 57, 73, 76, 70, 80, 5231148, 864099, 4902.44696, 957.73869, 3475.50411, 467.22, 253, 4, 333, 78, 0, 0, 40, 190, 0, 1), 
(25277, 25277, "Lilith's Witch Marilion", 0, "Raid Boss", 0, "LineageMonster.bloody_queen_50_bi", 21, 64, 50, "female", "L2RaidBoss", 40, 213145.164738, 747.8, 73.933897, 2.1, 60, 57, 73, 76, 70, 80, 3551193, 422350, 857.79693, 600.71532, 196.05673, 293.06, 253, 1, 333, 0, 0, 0, 80, 190, 0, 1), 
(25278, 25278, "Dead Soul of Stigma", 0, "Raid Fighter", 0, "LineageMonster.mana_vampire", 11, 20, 49, "male", "L2Monster", 40, 32519.113606, 720, 70.884287, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 1613.51303, 293.49453, 720.27204, 286.36, 253, 1, 333, 0, 0, 0, 90, 180, 0, 1), 
(25279, 25279, "Evil Spirit of Stigma", 0, "Raid Fighter", 0, "LineageMonster.magical_weaver", 11, 20, 49, "male", "L2Monster", 40, 16259.556803, 720, 70.884287, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 1613.51303, 293.49453, 720.27204, 286.36, 253, 1, 333, 0, 0, 0, 90, 180, 0, 1), 
(25280, 25280, "Pagan Watcher Cerberon", 0, "Raid Boss", 0, "LineageMonster.kel_mahum_champion_50_bi", 19, 48, 55, "male", "L2RaidBoss", 40, 524759.695853, 889.8, 221.738396, 2.4, 60, 57, 73, 76, 70, 80, 3983098, 535296, 2285.51807, 670.9086, 1298.16213, 327.3, 253, 4, 333, 75, 0, 0, 50, 210, 0, 1), 
(25281, 25281, "Anakim's Nemesis Zakaron", 0, "Raid Boss", 0, "LineageMonster.karik_50_bi", 37, 136.5, 70, "male", "L2RaidBoss", 40, 746772.142485, 1345.8, 294.210906, 2.7, 60, 57, 73, 76, 70, 80, 4596479, 802604, 4309.76223, 887.74791, 2869.61549, 433.08, 253, 4, 333, 0, 0, 0, 37, 215, 0, 1), 
(25282, 25282, "Death Lord Shax", 0, "Raid Boss", 0, "LineageMonster.death_lord_50_bi", 31, 61.5, 75, "male", "L2RaidBoss", 40, 794874.50288, 1507.8, 308.040724, 3, 60, 57, 73, 76, 70, 80, 5231148, 864099, 4902.44696, 957.73869, 3475.50411, 467.22, 253, 4, 333, 2500, 0, 0, 40, 210, 0, 1), 
(25283, 25283, "Lilith", 0, "Raid Boss", 0, "LineageMonster2.lilith", 42.5, 55, 80, "female", "L2RaidBoss", 40, 688716.90267, 1674.8, 211.789459, 3, 60, 57, 73, 76, 70, 80, 9911897, 1421059, 3893.46388, 1024.125, 630.9984, 499.6, 253, 4, 333, 0, 0, 0, 45, 200, 0, 1), 
(25284, 25284, "Lilith's Agent", 0, "Raid Fighter", 0, "LineageMonster2.lilim_wizard", 9, 34, 79, "female", "L2Monster", 40, 73063.923655, 1641, 209.832715, 3, 40, 43, 30, 21, 20, 20, 0, 0, 10232.17843, 505.60512, 4457.93887, 493.3, 253, 1, 333, 0, 0, 0, 50, 190, 0, 1), 
(25285, 25285, "Lilith's Escort", 0, "Raid Fighter", 0, "LineageMonster2.lilim_knight", 12, 50, 79, "male", "L2Monster", 40, 109050.632321, 1641, 209.832715, 3, 40, 43, 30, 21, 20, 20, 0, 0, 15348.65136, 505.60512, 10030.80131, 493.3, 253, 4, 333, 5800, 5799, 0, 56, 220, 0, 1), 
(25286, 25286, "Anakim", 0, "Raid Boss", 0, "LineageMonster2.anakim", 15.5, 29, 80, "female", "L2RaidBoss", 40, 688716.90267, 1674.8, 211.789459, 3, 60, 57, 73, 76, 70, 80, 9911897, 1421059, 3893.46388, 1024.125, 630.9984, 499.6, 253, 4, 333, 0, 0, 0, 45, 200, 0, 1), 
(25287, 25287, "Anakim's Guardian", 0, "Raid Fighter", 0, "LineageMonster2.nephilim_priest", 23, 40.5, 79, "male", "L2Monster", 40, 109050.632321, 1641, 209.832715, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7674.32568, 505.60512, 2507.70033, 493.3, 253, 1, 333, 0, 0, 0, 50, 190, 0, 1), 
(25288, 25288, "Anakim's Royal Guard", 0, "Raid Fighter", 0, "LineageMonster2.nephilim_lord", 12, 43, 79, "male", "L2Monster", 40, 54525.31616, 1641, 209.832715, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7674.32568, 505.60512, 2507.70033, 493.3, 253, 4, 333, 0, 0, 0, 65, 220, 0, 1), 
(25289, 25289, "Anakim's Executor", 0, "", 0, "LineageMonster2.nephilim_slayer", 12, 36, 79, "male", "L2Monster", 40, 54525.31616, 1641, 209.832715, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7674.32568, 505.60512, 2507.70033, 493.3, 253, 4, 333, 0, 0, 0, 65, 190, 0, 1), 
(25290, 25290, "Daimon the White-Eyed", 0, "Raid Boss", 0, "LineageMonster2.hundred_eye", 21, 55, 78, "male", "L2RaidBoss", 40, 410600.548543, 1607.4, 126.536106, 3, 60, 57, 73, 76, 70, 80, 5346496, 1193017, 2592.71887, 998.10183, 929.62086, 486.92, 253, 1, 333, 0, 0, 0, 30, 190, 0, 1), 
(25291, 25291, "Family of Daimon", 0, "Raid Fighter", 0, "LineageMonster.field_stalker", 15, 30, 77, "male", "L2Monster", 40, 43551.8944, 1574, 125.407546, 3, 40, 43, 30, 21, 20, 20, 0, 0, 6796.86863, 492.4061, 6509.45396, 480.42, 253, 1, 333, 0, 0, 0, 70, 190, 0, 1), 
(25292, 25292, "Family of Daimon", 0, "Raid Fighter", 0, "LineageMonster2.parasitic_eye", 25, 63, 77, "male", "L2Monster", 40, 65002.827462, 1574, 125.407546, 3, 40, 43, 30, 21, 20, 20, 0, 0, 5097.77892, 492.4061, 3661.72805, 480.42, 253, 1, 333, 0, 0, 0, 30, 190, 0, 1), 
(25293, 25293, "Hestia Guardian Deity of the Hot Springs", 0, "Raid Boss", 0, "LineageMonster.pixy_bi", 10, 54, 78, "female", "L2RaidBoss", 40, 410600.548543, 1607.4, 126.536106, 3, 60, 57, 73, 76, 70, 80, 5346496, 1193017, 2592.71887, 998.10183, 929.62086, 486.92, 253, 1, 333, 0, 0, 0, 80, 190, 0, 1), 
(25294, 25294, "Fighter of Hestia", 0, "Raid Fighter", 0, "LineageMonster.yeti", 15, 27.5, 77, "male", "L2Monster", 40, 65002.827462, 1574, 125.407546, 3, 40, 43, 30, 21, 20, 20, 0, 0, 10195.55783, 492.4061, 14646.91221, 480.42, 253, 4, 333, 0, 0, 0, 16, 190, 0, 1), 
(25295, 25295, "Follower of Hestia", 0, "Raid Fighter", 0, "LineageMonster.yeti", 15, 27.5, 77, "male", "L2Monster", 40, 32501.413731, 1574, 125.407546, 3, 40, 43, 30, 21, 20, 20, 0, 0, 5097.77892, 492.4061, 3661.72805, 480.42, 253, 4, 333, 0, 0, 0, 16, 190, 0, 1), 
(25296, 25296, "Icicle Emperor Bumbalump", 0, "Raid Boss", 0, "LineageMonster.yeti_20_bi", 18, 32, 74, "male", "L2RaidBoss", 40, 392895.926409, 1475, 122.142751, 3, 60, 57, 73, 76, 70, 80, 5199407, 852059, 2396.99019, 943.97961, 851.89721, 460.5, 253, 4, 333, 0, 0, 0, 16, 190, 0, 1), 
(25297, 25297, "Icicle Giant", 0, "Raid Fighter", 0, "LineageMonster.stone_golem", 20, 31, 73, "male", "L2Monster", 40, 41619.856677, 1442.4, 121.063992, 3, 40, 43, 30, 21, 20, 20, 0, 0, 6239.97653, 465.04439, 5934.25589, 453.74, 253, 4, 333, 0, 0, 0, 23, 190, 0, 1), 
(25298, 25298, "Icicle Giant", 0, "Raid Fighter", 0, "LineageMonster.stone_golem", 20, 31, 73, "male", "L2Monster", 40, 62119.189069, 1442.4, 121.063992, 3, 40, 43, 30, 21, 20, 20, 0, 0, 9360.1988, 465.04439, 13352.65994, 453.74, 253, 4, 333, 0, 0, 0, 23, 190, 0, 1), 
(25299, 25299, "Ketra's Hero Hekaton", 0, "Raid Boss", 0, "LineageMonster2.ketra_orc_chieftain_20_bi", 17, 46.2, 80, "male", "L2RaidBoss", 40, 300327.053711, 1674.8, 92.338763, 3, 60, 57, 73, 76, 70, 80, 3775961, 557272, 1445.33275, 1024.125, 280.52214, 499.6, 253, 1, 333, 6719, 0, 0, 24, 190, 0, 1), 
(25300, 25300, "Scout of Hekaton", 0, "Raid Fighter", 0, "LineageMonster.ketra_orc_archer", 12, 27, 79, "male", "L2Monster", 1100, 31866.802014, 1641, 91.493086, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2848.82203, 505.60512, 1105.91357, 493.3, 253, 8, 333, 288, 0, 0, 45, 190, 0, 1), 
(25301, 25301, "Servant of Hekaton", 0, "Raid Fighter", 0, "LineageMonster.ketra_orc", 12, 29, 79, "male", "L2Monster", 40, 23781.195533, 1641, 91.493086, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2848.82203, 505.60512, 1105.91357, 493.3, 253, 8, 333, 79, 0, 0, 45, 190, 0, 1), 
(25302, 25302, "Ketra's Commander Tayr", 0, "Raid Boss", 0, "LineageMonster2.ketra_orc_warlord_20_bi", 15, 36, 80, "male", "L2RaidBoss", 40, 325022.397859, 1884.48, 99.931611, 3.12, 60, 57, 73, 76, 70, 80, 3775961, 557272, 1504.01905, 1116.54576, 322.5561, 544.6896, 253, 4, 333, 80, 0, 0, 27, 190, 0, 1), 
(25303, 25303, "Tayr's Aide", 0, "Raid Fighter", 0, "LineageMonster.ketra_orc_shaman", 10, 23, 80, "male", "L2Monster", 40, 34165.720756, 1830.722, 97.990822, 3.09, 40, 43, 30, 21, 20, 20, 0, 0, 3970.90812, 546.71592, 2222.63214, 533.4164, 253, 1, 333, 213, 0, 0, 10, 190, 0, 1), 
(25304, 25304, "Tayr's Guard", 0, "Raid Fighter", 0, "LineageMonster.ketra_orc", 12, 29, 80, "male", "L2Monster", 40, 50993.613069, 1830.722, 97.990822, 3.09, 40, 43, 30, 21, 20, 20, 0, 0, 5956.5111, 546.71592, 5001.14111, 533.4164, 253, 4, 333, 79, 6919, 0, 45, 190, 0, 1), 
(25305, 25305, "Ketra's Chief Brakki", 0, "Raid Boss", 0, "LineageMonster2.ketra_warbeast", 20, 33.5, 80, "male", "L2RaidBoss", 40, 689061.278162, 2051.19, 264.82407, 3.21, 60, 57, 73, 76, 70, 80, 3775961, 557272, 3099.18467, 1185.644, 1426.64875, 578.3992, 253, 4, 333, 0, 0, 0, 26, 190, 0, 1), 
(25306, 25306, "Soul of Fire Nastron", 0, "Raid Boss", 0, "LineageMonster2.ifrit", 10, 42, 80, "male", "L2RaidBoss", 40, 240490.391893, 2051.19, 82.15495, 3.21, 60, 57, 73, 76, 70, 80, 2643173, 390090, 919.75393, 1185.644, 309.85402, 578.3992, 253, 4, 333, 0, 0, 0, 38, 190, 0, 1), 
(25307, 25307, "Family of Nastron", 0, "Raid Fighter", 0, "LineageMonster.mana_vampire", 11, 20, 80, "male", "L2Monster", 40, 37741.436537, 1994.708, 80.581333, 3.18, 40, 43, 30, 21, 20, 20, 0, 0, 3642.58983, 581.33612, 4799.50286, 567.1848, 253, 1, 333, 0, 0, 0, 90, 190, 0, 1), 
(25308, 25308, "Family of Nastron", 0, "Raid Fighter", 0, "LineageMonster.mana_vampire", 11, 20, 80, "male", "L2Monster", 40, 18870.718268, 1994.708, 80.581333, 3.18, 40, 43, 30, 21, 20, 20, 0, 0, 1821.29491, 581.33612, 1199.87571, 567.1848, 253, 1, 333, 0, 0, 0, 90, 190, 0, 1), 
(25309, 25309, "Varka's Hero Shadith", 0, "Raid Boss", 0, "LineageMonster2.barka_silenos_shaman_20_bi", 17, 47.5, 80, "male", "L2RaidBoss", 40, 300327.053711, 1674.8, 92.338763, 3, 60, 57, 73, 76, 70, 80, 3775961, 557272, 1445.33275, 1024.125, 280.52214, 499.6, 253, 1, 333, 6716, 0, 0, 36, 190, 0, 1), 
(25310, 25310, "Shadith's Royal Guard Captain", 0, "Raid Fighter", 0, "LineageMonster2.barka_silenos_warrior", 16, 41, 79, "male", "L2Monster", 40, 47562.391065, 1641, 91.493086, 3, 40, 43, 30, 21, 20, 20, 0, 0, 5697.64406, 505.60512, 4423.65426, 493.3, 253, 4, 333, 142, 6918, 0, 34, 190, 0, 1), 
(25311, 25311, "Shadith's Sentinel", 0, "Raid Fighter", 0, "LineageMonster2.barka_silenos_hunter", 16, 38, 79, "male", "L2Monster", 40, 23781.195533, 1641, 91.493086, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2848.82203, 505.60512, 1105.91357, 493.3, 253, 8, 333, 2504, 0, 0, 44, 190, 0, 1), 
(25312, 25312, "Varka's Commander Mos", 0, "Raid Boss", 0, "LineageMonster2.barka_silenos_chieftain_20_bi", 22, 51, 80, "male", "L2RaidBoss", 40, 325022.397859, 1884.48, 99.931611, 3.12, 60, 57, 73, 76, 70, 80, 3775961, 557272, 1504.01905, 1116.54576, 322.5561, 544.6896, 253, 1, 333, 2500, 0, 0, 25, 190, 0, 1), 
(25313, 25313, "Mos' Aide", 0, "Raid Fighter", 0, "LineageMonster2.barka_silenos_priest", 9, 41.5, 80, "male", "L2Monster", 40, 50993.613069, 1830.722, 97.990822, 3.09, 40, 43, 30, 21, 20, 20, 0, 0, 2978.25555, 546.71592, 1250.28528, 533.4164, 253, 1, 333, 6716, 0, 0, 36, 190, 0, 1), 
(25314, 25314, "Mos' Guard", 0, "Raid Fighter", 0, "LineageMonster2.barka_silenos_hunter", 16, 38, 80, "male", "L2Monster", 40, 25496.806534, 1830.722, 97.990822, 3.09, 40, 43, 30, 21, 20, 20, 0, 0, 2978.25555, 546.71592, 1250.28528, 533.4164, 253, 4, 333, 142, 0, 0, 44, 190, 0, 1), 
(25315, 25315, "Varka's Chief Horus", 0, "Raid Boss", 0, "LineageMonster2.barka_silenos_chieftain_20_bi", 22, 51, 80, "male", "L2RaidBoss", 40, 689061.278162, 2051.19, 264.82407, 3.21, 60, 57, 73, 76, 70, 80, 3775961, 557272, 3099.18467, 1185.644, 1426.64875, 578.3992, 253, 1, 333, 2500, 0, 0, 25, 190, 0, 1), 
(25316, 25316, "Soul of Water Ashutar", 0, "Raid Boss", 0, "LineageMonster.undine", 12, 27, 80, "female", "L2RaidBoss", 40, 240490.391893, 2051.19, 82.15495, 3.21, 60, 57, 73, 76, 70, 80, 2643173, 390090, 919.75393, 1185.644, 309.85402, 578.3992, 253, 4, 333, 0, 0, 0, 60, 190, 0, 1), 
(25317, 25317, "Family of Ashutar", 0, "Raid Fighter", 0, "LineageMonster.magical_weaver", 11, 20, 80, "male", "L2Monster", 40, 37741.436537, 1994.708, 80.581333, 3.18, 40, 43, 30, 21, 20, 20, 0, 0, 3642.58983, 581.33612, 4799.50286, 567.1848, 253, 1, 333, 0, 0, 0, 90, 190, 0, 1), 
(25318, 25318, "Family of Ashutar", 0, "Raid Fighter", 0, "LineageMonster.magical_weaver", 11, 20, 80, "male", "L2Monster", 40, 18870.718268, 1994.708, 80.581333, 3.18, 40, 43, 30, 21, 20, 20, 0, 0, 1821.29491, 581.33612, 1199.87571, 567.1848, 253, 1, 333, 0, 0, 0, 90, 190, 0, 1), 
(25319, 25319, "Ember", 0, "Raid Boss", 0, "LineageMonster2.inferno_drake_100_bi", 48, 73, 80, "male", "L2RaidBoss", 40, 462603.417572, 1939.14, 142.223325, 3.15, 60, 57, 73, 76, 70, 80, 5437589, 1219007, 2807.84036, 1139.63264, 1145.14415, 555.954, 253, 4, 333, 0, 0, 0, 57, 190, 0, 1), 
(25320, 25320, "Sentinel of Ember", 0, "Raid Fighter", 0, "LineageMonster2.lava_golem", 22, 45, 80, "male", "L2Monster", 40, 48632.465647, 1884.48, 139.474077, 3.12, 40, 43, 30, 21, 20, 20, 0, 0, 7413.25455, 558.27288, 7859.00329, 544.6896, 253, 4, 333, 0, 0, 0, 13, 190, 0, 1), 
(25321, 25321, "Messenger of Ember", 0, "Raid Fighter", 0, "LineageMonster2.ifrit", 10, 42, 80, "male", "L2Monster", 40, 72585.769622, 1884.48, 139.474077, 3.12, 40, 43, 30, 21, 20, 20, 0, 0, 5560.07992, 558.27288, 4420.88276, 544.6896, 253, 4, 333, 0, 0, 0, 38, 190, 0, 1), 
(25322, 25322, "Demon's Agent Falston", 0, "Raid Boss", 0, "LineageMonster2.vampire_warrior", 9, 31.5, 66, "male", "L2RaidBoss", 40, 350517.310357, 1219.8, 112.374448, 2.7, 60, 57, 73, 76, 70, 80, 4512325, 757636, 1885.06251, 830.18256, 624.88606, 405, 253, 4, 333, 6723, 0, 0, 43, 190, 0, 1), 
(25323, 25323, "Falston's Disciple", 0, "Raid Fighter", 0, "LineageMonster2.vampire_wizard", 5.5, 28, 65, "female", "L2Monster", 40, 36887.573796, 1188.8, 110.823041, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 4841.23256, 407.8355, 4311.34526, 397.92, 253, 1, 333, 99, 0, 0, 46, 190, 0, 1), 
(25324, 25324, "Servant of Falston", 0, "Raid Fighter", 0, "LineageMonster2.black_magician", 8, 30, 65, "male", "L2Monster", 40, 55056.080292, 1188.8, 110.823041, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 7262.03039, 407.8355, 9700.95124, 397.92, 253, 1, 333, 178, 0, 0, 19, 190, 0, 1), 
(25325, 25325, "Flame of Splendor Barakiel", 0, "Raid Boss", 0, "LineageMonster2.apostle_warrior", 8, 30, 70, "female", "L2RaidBoss", 40, 373386.071242, 1345.8, 117.684362, 2.7, 60, 57, 73, 76, 70, 80, 4596479, 802604, 2154.88112, 887.74791, 717.40387, 433.08, 253, 4, 333, 6717, 0, 0, 50, 190, 0, 1), 
(25326, 25326, "Barakiel's Disciple", 0, "Raid Fighter", 0, "LineageMonster2.apostle_mage", 11, 38.5, 69, "male", "L2Monster", 40, 58887.316796, 1314, 116.468584, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 8357.00898, 436.72595, 11094.07362, 426.1, 253, 1, 333, 6718, 0, 0, 50, 190, 0, 1), 
(25327, 25327, "Barakiel's Acolyte", 0, "Raid Fighter", 0, "LineageMonster2.apostle_mage", 11, 38.5, 69, "male", "L2Monster", 40, 29443.658398, 1314, 116.468584, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 4178.50449, 436.72595, 2773.51841, 426.1, 253, 1, 333, 6718, 0, 0, 50, 190, 0, 1), 
(25328, 25328, "Eilhalder von Hellmann", 0, "Raid Boss", 0, "LineageMonster2.vampire_lord", 7.5, 25.8, 71, "male", "L2RaidBoss", 40, 378515.569001, 1377.8, 118.846913, 3, 60, 57, 73, 76, 70, 80, 5113018, 815421, 2218.7555, 901.96077, 795.42045, 440.02, 253, 4, 333, 0, 0, 0, 15, 190, 0, 1), 
(25329, 25329, "Violet", 0, "Raid Fighter", 0, "LineageMonster2.vampire_witch", 6, 21.5, 70, "female", "L2Monster", 40, 40026.986837, 1345.8, 117.684362, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 5746.20599, 443.87396, 5101.31545, 433.08, 253, 8, 333, 946, 0, 0, 64, 190, 0, 1), 
(25330, 25330, "Kurstin", 0, "Raid Fighter", 0, "LineageMonster2.vampire_witch", 6, 21.5, 70, "female", "L2Monster", 40, 40026.986837, 1345.8, 117.684362, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 5746.20599, 443.87396, 5101.31545, 433.08, 253, 8, 333, 946, 0, 0, 64, 190, 0, 1), 
(25331, 25331, "Mina", 0, "Raid Fighter", 0, "LineageMonster2.vampire_witch", 6, 21.5, 70, "female", "L2Monster", 40, 40026.986837, 1345.8, 117.684362, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 5746.20599, 443.87396, 5101.31545, 433.08, 253, 8, 333, 946, 0, 0, 64, 190, 0, 1), 
(25332, 25332, "Dorian", 0, "Raid Fighter", 0, "LineageMonster2.vampire_soldier", 8, 23.5, 70, "male", "L2Monster", 40, 59741.771399, 1345.8, 117.684362, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 8619.52447, 443.87396, 11478.46194, 433.08, 253, 4, 333, 234, 0, 0, 60, 190, 0, 1), 
(25333, 25333, "Anakazel", 0, "Invaders' Leader", 0, "LineageMonster.dre_vanul_bi_one", 21, 54, 28, "male", "L2RaidBoss", 40, 81413.346462, 300.96, 46.812502, 1.5, 60, 57, 73, 76, 70, 80, 1673031, 68097, 94.85999, 334.84104, 14.70841, 163.34, 253, 4, 333, 0, 0, 0, 80, 190, 0, 1), 
(25334, 25334, "Anakazel", 0, "Invaders' Leader", 0, "LineageMonster.dre_vanul_bi_one", 21, 54, 38, "male", "L2RaidBoss", 40, 128864.779151, 447.96, 67.729705, 1.8, 60, 57, 73, 76, 70, 80, 1370326, 114239, 226.00591, 445.32861, 48.79994, 217.24, 253, 4, 333, 0, 0, 0, 80, 190, 0, 1), 
(25335, 25335, "Anakazel", 0, "Invaders' Leader", 0, "LineageMonster.kaim_vanul_20_bi", 28, 48, 48, "male", "L2RaidBoss", 40, 207715.744744, 692.4, 101.830257, 2.1, 60, 57, 73, 76, 70, 80, 1586608, 189699, 464.46636, 573.38409, 158.43765, 279.72, 253, 4, 333, 0, 0, 0, 37, 190, 0, 1), 
(25336, 25336, "Anakazel", 0, "Invaders' Leader", 0, "LineageMonster.kaim_vanul_20_bi", 28, 48, 58, "male", "L2RaidBoss", 40, 296249.601689, 977.4, 137.414907, 2.4, 60, 57, 73, 76, 70, 80, 1843815, 257493, 822.28385, 713.98287, 388.65348, 348.3, 253, 4, 333, 0, 0, 0, 37, 190, 0, 1), 
(25337, 25337, "Anakazel", 0, "Invaders' Leader", 0, "LineageMonster.karik", 25, 90, 68, "male", "L2RaidBoss", 40, 363785.271769, 1282.4, 160.661814, 2.7, 60, 57, 73, 76, 70, 80, 2044017, 324825, 1269.93206, 859.0845, 659.9856, 419.1, 253, 4, 333, 0, 0, 0, 37, 190, 0, 1), 
(25338, 25338, "Anakazel", 0, "Invaders' Leader", 0, "LineageMonster.karik", 25, 90, 78, "male", "L2RaidBoss", 40, 410724.290197, 1607.4, 175.808199, 3, 60, 57, 73, 76, 70, 80, 2504378, 380180, 1662.16595, 998.10183, 941.25731, 486.92, 253, 4, 333, 0, 0, 0, 37, 190, 0, 1), 
(25339, 25339, "Shadow of Halisha", 0, "Ruler of Sepulcher", 0, "LineageMonster2.halisha_a", 23, 60, 80, "female", "L2SepulcherMonster", 1100, 213848.930921, 1725.888, 73.053847, 3.03, 60, 57, 73, 76, 70, 80, 2643173, 390090, 866.44981, 1047.20215, 251.11046, 510.858, 253, 8, 333, 6720, 0, 0, 43, 190, 0, 1), 
(25340, 25340, "Knight of Shadow", 0, "", 0, "LineageMonster.vale_master", 12, 40, 80, "male", "L2Monster", 40, 33541.641944, 1674.8, 71.614397, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1715.7422, 512.0625, 974.82622, 499.6, 253, 4, 333, 0, 0, 0, 70, 190, 0, 1), 
(25341, 25341, "Knight of Shadow", 0, "", 0, "LineageMonster2.eligor", 21, 35, 80, "male", "L2Monster", 40, 16770.820972, 1674.8, 71.614397, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1715.7422, 512.0625, 974.82622, 499.6, 253, 4, 333, 0, 0, 0, 35, 190, 0, 1), 
(25342, 25342, "Shadow of Halisha", 0, "Ruler of Sepulcher", 0, "LineageMonster2.halisha_b", 23, 60, 80, "female", "L2SepulcherMonster", 1100, 213848.930921, 1725.888, 73.053847, 3.03, 60, 57, 73, 76, 70, 80, 2643173, 390090, 866.44981, 1047.20215, 251.11046, 510.858, 253, 8, 333, 6720, 0, 0, 43, 190, 0, 1), 
(25343, 25343, "Knight of Shadow", 0, "", 0, "LineageMonster.vale_master", 12, 40, 80, "male", "L2Monster", 40, 33541.641944, 1674.8, 71.614397, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1715.7422, 512.0625, 974.82622, 499.6, 253, 4, 333, 0, 0, 0, 70, 190, 0, 1), 
(25344, 25344, "Knight of Shadow", 0, "", 0, "LineageMonster.fiend_archer", 17, 55, 80, "male", "L2Monster", 1100, 22472.900103, 1674.8, 71.614397, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1715.7422, 512.0625, 974.82622, 499.6, 253, 8, 333, 0, 0, 0, 70, 190, 0, 1), 
(25345, 25345, "Knight of shadow", 0, "", 0, "LineageMonster2.lilim_wizard", 9, 34, 80, "female", "L2Monster", 40, 22472.900103, 1674.8, 71.614397, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2287.59907, 512.0625, 1732.94857, 499.6, 253, 1, 333, 0, 0, 0, 50, 190, 0, 1), 
(25346, 25346, "Shadow of Halisha", 0, "Ruler of Sepulcher", 0, "LineageMonster2.halisha_c", 23, 60, 80, "female", "L2SepulcherMonster", 1100, 213848.930921, 1725.888, 73.053847, 3.03, 60, 57, 73, 76, 70, 80, 2643173, 390090, 866.44981, 1047.20215, 251.11046, 510.858, 253, 8, 333, 6720, 0, 0, 43, 190, 0, 1), 
(25347, 25347, "Knight of Shadow", 0, "", 0, "LineageMonster2.lilim_wizard", 9, 34, 80, "female", "L2Monster", 40, 22472.900103, 1674.8, 71.614397, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2287.59907, 512.0625, 1732.94857, 499.6, 253, 1, 333, 0, 0, 0, 50, 190, 0, 1), 
(25348, 25348, "Knight of Shadow", 0, "", 0, "LineageMonster.death_lord", 21, 40, 80, "male", "L2Monster", 40, 33541.641944, 1674.8, 71.614397, 3, 40, 43, 30, 21, 20, 20, 0, 0, 3431.48439, 512.0625, 3899.30487, 499.6, 253, 4, 333, 78, 0, 0, 40, 190, 0, 1), 
(25349, 25349, "Shadow of Halisha", 0, "Ruler of Sepulcher", 0, "LineageMonster2.halisha_d", 23, 60, 80, "female", "L2SepulcherMonster", 1100, 213848.930921, 1725.888, 73.053847, 3.03, 60, 57, 73, 76, 70, 80, 2643173, 390090, 866.44981, 1047.20215, 251.11046, 510.858, 253, 8, 333, 6720, 0, 0, 43, 190, 0, 1), 
(25350, 25350, "Knight of Shadow", 0, "", 0, "LineageMonster2.lilim_wizard", 9, 34, 80, "female", "L2Monster", 40, 22472.900103, 1674.8, 71.614397, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2287.59907, 512.0625, 1732.94857, 499.6, 253, 1, 333, 0, 0, 0, 50, 190, 0, 1), 
(25351, 25351, "Knight of Shadow", 0, "", 0, "LineageMonster.vale_master", 12, 40, 80, "male", "L2Monster", 40, 33541.641944, 1674.8, 71.614397, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1715.7422, 512.0625, 974.82622, 499.6, 253, 4, 333, 0, 0, 0, 70, 190, 0, 1), 
(25352, 25352, "Giant Wasteland Basilisk", 0, "Raid Boss", 0, "LineageMonster.lesser_basilisk", 34, 25, 30, "male", "L2RaidBoss", 40, 53690.033689, 329.4, 21.714039, 1.5, 60, 57, 73, 76, 70, 80, 2308288, 111484, 111.21878, 355.39281, 7.21488, 173.38, 253, 4, 333, 0, 0, 0, 35, 190, 0, 1), 
(25353, 25353, "Giant Wasteland Basilisk", 0, "Raid Fighter", 0, "LineageMonster.lesser_basilisk_sm", 32, 22, 29, "male", "L2Monster", 40, 8197.733987, 315.12, 20.929197, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 410.88118, 172.50897, 104.9022, 168.32, 253, 4, 333, 0, 0, 0, 35, 190, 0, 1), 
(25354, 25354, "Gargoyle Lord Sirocco", 0, "Raid Boss", 0, "LineageMonster.gargoyle_bi", 16, 65, 35, "male", "L2RaidBoss", 40, 69449.568455, 402.6, 26.794392, 1.8, 60, 57, 73, 76, 70, 80, 1912395, 144137, 163.69565, 410.18844, 12.93, 200.1, 253, 4, 333, 0, 0, 0, 140, 190, 0, 1), 
(25355, 25355, "Sirocco's Gargoyle", 0, "Raid Fighter", 0, "LineageMonster.gargoyle", 16, 50, 34, "male", "L2Monster", 40, 5263.333934, 387.72, 25.612831, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 303.4856, 199.4229, 48.16245, 194.58, 253, 4, 333, 0, 0, 0, 140, 190, 0, 1), 
(25356, 25356, "Sirocco's Guards", 0, "Raid Fighter", 0, "LineageMonster.gargoyle", 16, 50, 34, "male", "L2Monster", 40, 10526.667869, 387.72, 25.612831, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 606.9712, 199.4229, 192.64979, 194.58, 253, 4, 333, 0, 0, 0, 140, 190, 0, 1), 
(25357, 25357, "Sukar Wererat Chief", 0, "Raid Boss", 0, "LineageMonster.wererat", 14, 25, 21, "male", "L2RaidBoss", 40, 37886.485367, 205.2, 16.826966, 1.5, 60, 57, 73, 76, 70, 80, 2646357, 60367, 53.12758, 269.19177, 3.16861, 131.32, 253, 8, 333, 216, 0, 0, 80, 190, 0, 1), 
(25358, 25358, "Sukar Wererat Guard", 0, "Raid Fighter", 0, "LineageMonster.wererat_sm", 12, 18.7, 20, "male", "L2Monster", 40, 5895.549772, 192, 16.540032, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 195.30066, 130.30574, 38.1182, 127.14, 253, 8, 333, 216, 0, 0, 80, 190, 0, 1), 
(25359, 25359, "Sukar Wererat Priest", 0, "Raid Fighter", 0, "LineageMonster.wererat_sm", 12, 18.7, 20, "male", "L2Monster", 40, 5895.549772, 192, 16.540032, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 97.65033, 130.30574, 9.52955, 127.14, 253, 1, 333, 179, 0, 0, 80, 190, 0, 1), 
(25360, 25360, "Tiger Hornet", 0, "Raid Boss", 0, "LineageMonster.giant_bee_bi", 8, 32, 26, "male", "L2RaidBoss", 40, 45036.20995, 273, 18.970989, 1.5, 60, 57, 73, 76, 70, 80, 2487618, 84828, 80.58475, 315.08454, 5.07204, 153.72, 253, 8, 333, 0, 0, 0, 90, 190, 0, 1), 
(25361, 25361, "Yellow Hornet", 0, "Raid Fighter", 0, "LineageMonster.giant_bee", 8, 24.5, 25, "male", "L2Monster", 40, 6930.609366, 259.2, 18.438531, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 296.88928, 152.753, 74.87476, 149.04, 253, 8, 333, 0, 0, 0, 90, 190, 0, 1), 
(25362, 25362, "Tracker Leader Sharuk", 0, "Raid Boss", 0, "LineageMonster.virud_lizardman_warrior", 12, 30, 23, "male", "L2RaidBoss", 40, 40330.259723, 231.96, 17.534747, 1.5, 60, 57, 73, 76, 70, 80, 2690117, 69902, 62.85328, 286.94928, 3.96218, 139.98, 253, 4, 333, 291, 0, 0, 52, 190, 0, 1), 
(25363, 25363, "Sharuk's Tracker", 0, "Raid Fighter", 0, "LineageMonster.virud_lizardman", 10, 23, 22, "male", "L2Monster", 40, 3123.592394, 218.52, 17.157688, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 115.59311, 138.98541, 14.54447, 135.6, 253, 4, 333, 2, 0, 0, 43, 190, 0, 1), 
(25364, 25364, "Sharuk's Marksman", 0, "Raid Fighter", 0, "LineageMonster.virud_lizardman_scout", 10, 22, 22, "male", "L2Monster", 1100, 4185.613808, 218.52, 17.157688, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 115.59311, 138.98541, 14.54447, 135.6, 253, 8, 333, 2507, 0, 0, 43, 190, 0, 1), 
(25365, 25365, "Patriarch Kuroboros", 0, "Raid Boss", 0, "LineageMonster.virud_lizardman_warrior_bi", 12, 34.5, 26, "male", "L2RaidBoss", 40, 90072.419899, 273, 47.427471, 1.5, 60, 57, 73, 76, 70, 80, 2487618, 84828, 161.16949, 315.08454, 20.28816, 153.72, 253, 4, 333, 93, 0, 0, 52, 190, 0, 1), 
(25366, 25366, "Kuroboros' Priest", 0, "Raid Boss", 0, "LineageMonster.virud_lizardman_matriarch", 13, 37, 23, "male", "L2RaidBoss", 40, 40330.259723, 231.96, 17.534747, 1.5, 60, 57, 73, 76, 70, 80, 2690117, 69902, 62.85328, 286.94928, 3.96218, 139.98, 253, 4, 333, 2, 0, 0, 56, 190, 0, 1), 
(25367, 25367, "Kuroboros' Follower", 0, "Raid Fighter", 0, "LineageMonster.virud_lizardman", 10, 23, 22, "male", "L2Monster", 40, 6247.184788, 218.52, 17.157688, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 231.18622, 138.98541, 58.17787, 135.6, 253, 4, 333, 1, 102, 0, 43, 190, 0, 1), 
(25368, 25368, "Kuroboros' Discipline", 0, "Raid Fighter", 0, "LineageMonster.virud_lizardman_shaman", 10, 29, 22, "male", "L2Monster", 40, 6247.184788, 218.52, 17.157688, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 115.59311, 138.98541, 14.54447, 135.6, 253, 1, 333, 179, 0, 0, 43, 190, 0, 1), 
(25369, 25369, "Soul Scavenger", 0, "Raid Boss", 0, "LineageMonster.dark_horror_bi", 20, 42, 25, "male", "L2RaidBoss", 40, 43316.308536, 259.2, 18.438531, 1.5, 60, 57, 73, 76, 70, 80, 2541012, 79280, 74.22232, 305.50599, 4.67967, 149.04, 253, 4, 333, 0, 0, 0, 100, 190, 0, 1), 
(25370, 25370, "Corpse Scavenger", 0, "Raid Fighter", 0, "LineageMonster.skeleton_bi", 11, 31, 24, "male", "L2Monster", 40, 6680.15931, 245.52, 17.96077, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 273.28181, 148.06379, 68.81204, 144.46, 253, 8, 333, 946, 0, 0, 60, 190, 0, 1), 
(25371, 25371, "Anima Scavenger", 0, "Raid Fighter", 0, "LineageMonster.spartoi", 11, 27, 24, "male", "L2Monster", 40, 3340.079655, 245.52, 17.96077, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 136.64091, 148.06379, 17.20301, 144.46, 253, 8, 333, 946, 0, 0, 60, 190, 0, 1), 
(25372, 25372, "Discarded Guardian", 0, "Raid Boss", 0, "LineageMonster.stone_golem_bi", 20, 40.3, 20, "male", "L2RaidBoss", 40, 73694.372151, 192, 41.350081, 1.2, 60, 57, 73, 76, 70, 80, 3041766, 59634, 97.65033, 260.61147, 9.52955, 127.14, 253, 4, 333, 0, 0, 0, 23, 190, 0, 1), 
(25373, 25373, "Malex Herald of Dagoniel", 0, "Raid Boss", 0, "LineageMonster.dre_vanul_bi_one", 21, 54, 21, "male", "L2RaidBoss", 40, 37886.485367, 205.2, 16.826966, 1.5, 60, 57, 73, 76, 70, 80, 2646357, 60367, 53.12758, 269.19177, 3.16861, 131.32, 253, 4, 333, 0, 0, 0, 80, 190, 0, 1), 
(25374, 25374, "Abyss Flyer", 0, "Raid Fighter", 0, "LineageMonster.vampire_bat", 10, 33.5, 20, "male", "L2Monster", 40, 5895.549772, 192, 16.540032, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 195.30066, 130.30574, 38.1182, 127.14, 253, 4, 333, 0, 0, 0, 60, 190, 0, 1), 
(25375, 25375, "Zombie Lord Farakelsus", 0, "Raid Boss", 0, "LineageMonster.zombie_bi", 12, 27.5, 20, "male", "L2RaidBoss", 40, 36847.186075, 192, 16.540032, 1.2, 60, 57, 73, 76, 70, 80, 3041766, 59634, 48.82516, 260.61147, 2.38239, 127.14, 253, 4, 333, 0, 0, 0, 15, 190, 0, 1), 
(25376, 25376, "Warrior Zombie of Farakelsus", 0, "Raid Fighter", 0, "LineageMonster.zombie", 13, 21, 19, "male", "L2Monster", 40, 5747.152315, 183.28, 16.294366, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 179.4779, 126.11457, 33.83233, 123.04, 253, 4, 333, 0, 0, 0, 15, 190, 0, 1), 
(25377, 25377, "Priest Zombie of Farakelsus", 0, "Raid Fighter", 0, "LineageMonster.zombie", 13, 21, 19, "male", "L2Monster", 40, 5747.152315, 183.28, 16.294366, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 89.73895, 126.11457, 8.45808, 123.04, 253, 4, 333, 0, 0, 0, 15, 190, 0, 1), 
(25378, 25378, "Madness Beast", 0, "Raid Boss", 0, "LineageMonster.onyx_beast_bi", 14, 18.7, 20, "male", "L2RaidBoss", 40, 36847.186075, 192, 16.540032, 1.2, 60, 57, 73, 76, 70, 80, 3041766, 59634, 48.82516, 260.61147, 2.38239, 127.14, 253, 4, 333, 0, 0, 0, 30, 190, 0, 1), 
(25379, 25379, "Dementia Beast", 0, "Raid Fighter", 0, "LineageMonster.onyx_beast", 14, 14.5, 19, "male", "L2Monster", 40, 5747.152315, 183.28, 16.294366, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 179.4779, 126.11457, 33.83233, 123.04, 253, 4, 333, 0, 0, 0, 30, 190, 0, 1), 
(25380, 25380, "Kaysha Herald of Icarus", 0, "Raid Boss", 0, "LineageMonster.succubus_bi", 10, 43.2, 21, "female", "L2RaidBoss", 40, 37886.485367, 205.2, 16.826966, 1.5, 60, 57, 73, 76, 70, 80, 2646357, 60367, 53.12758, 269.19177, 3.16861, 131.32, 253, 4, 333, 0, 0, 0, 60, 190, 0, 1), 
(25381, 25381, "Nightmare Flyer", 0, "Raid Fighter", 0, "LineageMonster.vampire_bat_bi", 10, 42, 19, "male", "L2Monster", 40, 5747.152315, 183.28, 16.294366, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 179.4779, 126.11457, 33.83233, 123.04, 253, 4, 333, 0, 0, 0, 60, 190, 0, 1), 
(25382, 25382, "Hostile Flyer", 0, "Raid Fighter", 0, "LineageMonster.vampire_bat", 10, 33.5, 19, "male", "L2Monster", 40, 2873.576158, 183.28, 16.294366, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 89.73895, 126.11457, 8.45808, 123.04, 253, 4, 333, 0, 0, 0, 60, 190, 0, 1), 
(25383, 25383, "Revenant of Sir Calibus", 0, "Raid Boss", 0, "LineageMonster.death_knight_bi", 24, 29, 34, "male", "L2RaidBoss", 40, 65791.674179, 387.72, 25.612831, 1.8, 60, 57, 73, 76, 70, 80, 1918617, 135504, 151.7428, 398.8458, 12.04061, 194.58, 253, 4, 333, 75, 0, 0, 27, 190, 0, 1), 
(25384, 25384, "Servant of Calibus", 0, "Raid Fighter", 0, "LineageMonster.spartoi", 11, 27, 33, "male", "L2Monster", 40, 9983.703443, 372.96, 24.517094, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 562.23012, 193.84643, 179.1121, 189.14, 253, 8, 333, 946, 0, 0, 60, 190, 0, 1), 
(25385, 25385, "Evil Spirit Tempest", 0, "Raid Boss", 0, "LineageMonster.dre_vanul_bi_one", 21, 54, 36, "male", "L2RaidBoss", 40, 73380.923976, 417.6, 28.064045, 1.8, 60, 57, 73, 76, 70, 80, 1916442, 153260, 176.45564, 421.71834, 14.03993, 205.74, 253, 4, 333, 0, 0, 0, 80, 190, 0, 1), 
(25386, 25386, "Ghost of the Execution Grounds", 0, "Raid Fighter", 0, "LineageMonster.skeleton_bi", 11, 31, 35, "male", "L2Monster", 40, 11111.930953, 402.6, 26.794392, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 654.78259, 205.09422, 206.87995, 200.1, 253, 4, 333, 128, 0, 0, 60, 190, 0, 1), 
(25387, 25387, "Malignant Spirit of the Execution Grounds", 0, "Raid Fighter", 0, "LineageMonster.skeleton", 11, 25, 35, "male", "L2Monster", 40, 5555.965476, 402.6, 26.794392, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 327.3913, 205.09422, 51.71999, 200.1, 253, 8, 333, 946, 0, 0, 60, 190, 0, 1), 
(25388, 25388, "Red Eye Captain Trakia", 0, "Raid Boss", 0, "LineageMonster.oel_mahum_bi", 30, 55, 35, "male", "L2RaidBoss", 40, 69449.568455, 402.6, 26.794392, 1.8, 60, 57, 73, 76, 70, 80, 1912395, 144137, 163.69565, 410.18844, 12.93, 200.1, 253, 4, 333, 70, 0, 0, 70, 190, 0, 1), 
(25389, 25389, "Red Eye Archer", 0, "Raid Fighter", 0, "LineageMonster.ol_mahum_archer", 14, 25, 34, "male", "L2Monster", 1100, 7052.867472, 387.72, 25.612831, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 303.4856, 199.4229, 48.16245, 194.58, 253, 8, 333, 279, 0, 0, 50, 190, 0, 1), 
(25390, 25390, "Red Eye Guards", 0, "Raid Fighter", 0, "LineageMonster.ol_mahum_champion", 14, 27, 34, "male", "L2Monster", 40, 5263.333934, 387.72, 25.612831, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 303.4856, 199.4229, 48.16245, 194.58, 253, 4, 333, 128, 0, 0, 50, 190, 0, 1), 
(25391, 25391, "Nurka's Messenger", 0, "Raid Boss", 0, "LineageMonster.ol_mahum_champion_bi", 21, 40.5, 33, "male", "L2RaidBoss", 40, 124796.293042, 372.96, 61.292735, 1.8, 60, 57, 73, 76, 70, 80, 1932560, 127255, 281.11506, 387.69285, 44.77803, 189.14, 253, 4, 333, 127, 0, 0, 50, 190, 0, 1), 
(25392, 25392, "Captain of Queen's Royal Guards", 0, "Raid Boss", 0, "LineageMonster.marsh_stakato_queen", 15, 37, 32, "female", "L2RaidBoss", 40, 59258.184798, 358.32, 23.504309, 1.8, 60, 57, 73, 76, 70, 80, 1962692, 119633, 130.1006, 376.73181, 10.40631, 183.78, 253, 4, 333, 129, 0, 0, 130, 190, 0, 1), 
(25393, 25393, "Marsh Stakato Noble", 0, "Raid Fighter", 0, "LineageMonster.marsh_stakato_drone", 9, 24, 31, "male", "L2Monster", 40, 9017.560565, 343.8, 22.571159, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 481.33401, 182.98229, 148.97362, 178.54, 253, 8, 333, 223, 0, 0, 80, 190, 0, 1), 
(25394, 25394, "Premo Prime", 0, "Raid Boss", 0, "LineageMonster.twin_headed_giant", 17, 39, 38, "male", "L2RaidBoss", 40, 164178.104891, 447.96, 77.181718, 1.8, 60, 57, 73, 76, 70, 80, 1957608, 163199, 409.10844, 445.32861, 64.59076, 217.24, 253, 1, 333, 88, 0, 0, 45, 190, 0, 1), 
(25395, 25395, "Archon Suscepter", 0, "Raid Boss", 0, "LineageMonster.susceptor_prime", 45, 72, 45, "male", "L2RaidBoss", 40, 121183.101254, 610.8, 43.342559, 2.1, 60, 57, 73, 76, 70, 80, 2085510, 229987, 333.67447, 533.36238, 35.73201, 260.2, 253, 1, 333, 0, 0, 0, 78, 190, 0, 1), 
(25396, 25396, "Kusion Suscepter", 0, "Raid Fighter", 0, "LineageMonster.susceptor", 20, 35, 44, "male", "L2Monster", 40, 18378.20662, 584, 41.347042, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 624.12426, 260.15328, 130.5309, 253.82, 253, 1, 333, 0, 0, 0, 27, 190, 0, 1), 
(25397, 25397, "Gustos Suscepter", 0, "Raid Fighter", 0, "LineageMonster.susceptor", 20, 35, 44, "male", "L2Monster", 40, 18378.20662, 584, 41.347042, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 1248.24851, 260.15328, 522.12359, 253.82, 253, 1, 333, 0, 0, 0, 27, 190, 0, 1), 
(25398, 25398, "Eye of Beleth", 0, "Raid Boss", 0, "LineageMonster.monster_eye", 21, 43, 35, "male", "L2RaidBoss", 40, 69449.568455, 402.6, 26.794392, 1.8, 60, 57, 73, 76, 70, 80, 1912395, 144137, 163.69565, 410.18844, 12.93, 200.1, 253, 1, 333, 0, 0, 0, 90, 190, 0, 1), 
(25399, 25399, "Apprentice of Watchman", 0, "Raid Fighter", 0, "LineageMonster.mana_vampire", 11, 20, 34, "male", "L2Monster", 40, 7052.867472, 387.72, 25.612831, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 404.63735, 199.4229, 85.61838, 194.58, 253, 1, 333, 0, 0, 0, 90, 190, 0, 1), 
(25400, 25400, "Page of Watchman", 0, "Raid Fighter", 0, "LineageMonster.magical_weaver", 11, 20, 34, "male", "L2Monster", 40, 10526.667869, 387.72, 25.612831, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 303.4856, 199.4229, 48.16245, 194.58, 253, 1, 333, 0, 0, 0, 90, 190, 0, 1), 
(25401, 25401, "Skyla", 0, "Raid Boss", 0, "LineageMonster.zenta_lizardman_matriarch_bi", 30, 63, 32, "male", "L2RaidBoss", 40, 59258.184798, 358.32, 23.504309, 1.8, 60, 57, 73, 76, 70, 80, 1962692, 119633, 130.1006, 376.73181, 10.40631, 183.78, 253, 8, 333, 215, 0, 0, 53, 190, 0, 1), 
(25402, 25402, "Retainer of Skyla", 0, "Raid Fighter", 0, "LineageMonster.zenta_lizardman", 11, 32, 31, "male", "L2Monster", 40, 9017.560565, 343.8, 22.571159, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 481.33401, 182.98229, 148.97362, 178.54, 253, 8, 333, 221, 0, 0, 37, 190, 0, 1), 
(25403, 25403, "Follower of Skyla", 0, "Raid Fighter", 0, "LineageMonster.zenta_lizardman_shaman", 13, 35, 31, "male", "L2Monster", 40, 6041.765579, 343.8, 22.571159, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 320.88132, 182.98229, 66.2076, 178.54, 253, 1, 333, 180, 0, 0, 43, 190, 0, 1), 
(25404, 25404, "Corsair Captain Kylon", 0, "Raid Boss", 0, "LineageMonster.pirates_zombie_captain", 17, 28, 33, "male", "L2RaidBoss", 40, 62398.146521, 372.96, 24.517094, 1.8, 60, 57, 73, 76, 70, 80, 1932560, 127255, 140.55753, 387.69285, 11.19451, 189.14, 253, 8, 333, 231, 0, 0, 14, 190, 0, 1), 
(25405, 25405, "Kylon's Pirate", 0, "Raid Fighter", 0, "LineageMonster.skeleton_bi_one", 16, 40, 32, "male", "L2Monster", 40, 9481.309568, 358.32, 23.504309, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 520.4024, 188.36591, 166.50091, 183.78, 253, 8, 333, 946, 945, 0, 60, 190, 0, 1), 
(25406, 25406, "Kylon's Mate", 0, "Raid Fighter", 0, "LineageMonster.skeleton_knight_50_bi", 15, 39, 32, "male", "L2Monster", 40, 9481.309568, 358.32, 23.504309, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 520.4024, 188.36591, 166.50091, 183.78, 253, 4, 333, 130, 103, 0, 40, 190, 0, 1), 
(25407, 25407, "Lord Ishka", 0, "Raid Boss", 0, "LineageMonster.death_blader_bi", 22, 67, 60, "male", "L2RaidBoss", 40, 221100.024975, 1036.8, 72.964382, 2.4, 60, 57, 73, 76, 70, 80, 2735033, 394692, 785.17745, 742.95024, 133.51196, 362.44, 253, 4, 333, 1472, 0, 0, 100, 190, 0, 1), 
(25408, 25408, "Ishka's Elite Officer", 0, "Raid Fighter", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 59, "male", "L2Monster", 40, 34433.217541, 1007, 71.371054, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 2995.10104, 364.2239, 1962.16762, 355.36, 253, 8, 333, 946, 945, 0, 80, 190, 0, 1), 
(25409, 25409, "Ishka's Elite Soldier", 0, "Raid Fighter", 0, "LineageMonster.skeleton_knight_20_bi", 12, 30.5, 59, "male", "L2Monster", 40, 34433.217541, 1007, 71.371054, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 2995.10104, 364.2239, 1962.16762, 355.36, 253, 4, 333, 150, 103, 0, 40, 190, 0, 1), 
(25410, 25410, "Road Scavenger Leader", 0, "Raid Boss", 0, "LineageMonster.wererat_bi", 21, 38, 40, "male", "L2RaidBoss", 40, 91937.38614, 478.8, 34.038778, 1.8, 60, 57, 73, 76, 70, 80, 2030965, 181264, 236.34363, 469.65105, 18.66292, 229.12, 253, 1, 333, 88, 0, 0, 80, 190, 0, 1), 
(25411, 25411, "Road Scavenger Henchman", 0, "Raid Fighter", 0, "LineageMonster.kobold_bi", 15, 24, 39, "male", "L2Monster", 40, 13899.415887, 463.32, 32.411747, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 879.87742, 228.70128, 276.79024, 223.14, 253, 1, 333, 0, 0, 0, 47, 190, 0, 1), 
(25412, 25412, "Necrosentinel Royal Guard", 0, "Raid Boss", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 47, "male", "L2RaidBoss", 40, 134366.203995, 665, 47.474088, 2.1, 60, 57, 73, 76, 70, 80, 2205665, 257531, 380.23638, 559.90707, 42.89876, 273.14, 253, 8, 333, 946, 946, 0, 80, 190, 0, 1), 
(25413, 25413, "Necrosentinel Archer", 0, "Raid Fighter", 0, "LineageMonster.skeleton_archer", 11, 27, 46, "male", "L2Monster", 1100, 13688.713999, 637.8, 45.388391, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 712.79213, 273.28224, 156.18161, 266.64, 253, 8, 333, 279, 0, 0, 40, 190, 0, 1), 
(25414, 25414, "Necrosentinel Soldier", 0, "Raid Fighter", 0, "LineageMonster.skeleton_knight", 10, 25, 46, "male", "L2Monster", 40, 10215.458208, 637.8, 45.388391, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 712.79213, 273.28224, 156.18161, 266.64, 253, 4, 333, 150, 103, 0, 40, 190, 0, 1), 
(25415, 25415, "Nakondas", 0, "Raid Boss", 0, "LineageMonster.drake_bi", 37, 125, 40, "male", "L2RaidBoss", 40, 91937.38614, 478.8, 34.038778, 1.8, 60, 57, 73, 76, 70, 80, 2030965, 181264, 236.34363, 469.65105, 18.66292, 229.12, 253, 4, 333, 0, 0, 0, 70, 190, 0, 1), 
(25416, 25416, "Nakondas' Slave", 0, "Raid Fighter", 0, "LineageMonster.wyrm", 29, 72, 39, "male", "L2Monster", 40, 9312.608644, 463.32, 32.411747, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 586.57028, 228.70128, 123.0125, 223.14, 253, 4, 333, 0, 0, 0, 70, 190, 0, 1), 
(25417, 25417, "Nakondas' Chain", 0, "Raid Fighter", 0, "LineageMonster.succubus", 10, 36, 39, "female", "L2Monster", 40, 13899.415887, 463.32, 32.411747, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 439.93871, 228.70128, 69.19756, 223.14, 253, 4, 333, 0, 0, 0, 60, 190, 0, 1), 
(25418, 25418, "Dread Avenger Kraven", 0, "Raid Boss", 0, "LineageMonster.death_knight_bi", 24, 29, 44, "male", "L2RaidBoss", 40, 114863.791375, 584, 41.347042, 2.1, 60, 57, 73, 76, 70, 80, 2030767, 217826, 312.06213, 520.30656, 32.63272, 253.82, 253, 4, 333, 75, 0, 0, 27, 190, 0, 1), 
(25419, 25419, "Dread Panther", 0, "Raid Fighter", 0, "LineageMonster.onyx_beast", 14, 14.5, 43, "male", "L2Monster", 40, 17401.621187, 557.4, 39.411275, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 1166.17758, 253.70126, 476.24837, 247.54, 253, 4, 333, 0, 0, 0, 30, 190, 0, 1), 
(25420, 25420, "Orfen's Handmaiden", 0, "Raid Boss", 0, "LineageMonster.riba", 25, 72, 48, "female", "L2RaidBoss", 40, 141171.403299, 692.4, 49.588364, 2.1, 60, 57, 73, 76, 70, 80, 2266583, 270998, 405.1994, 573.38409, 47.84373, 279.72, 253, 8, 333, 0, 0, 0, 60, 190, 0, 1), 
(25421, 25421, "Trisalim Escort", 0, "Raid Fighter", 0, "LineageMonster.poison_spider_bi", 40, 38, 47, "male", "L2Monster", 40, 14404.057068, 665, 47.474088, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 1013.93832, 279.95354, 305.0445, 273.14, 253, 4, 333, 0, 0, 0, 60, 190, 0, 1), 
(25422, 25422, "Page of Rotting Tree", 0, "Raid Fighter", 0, "LineageMonster.hanged_man_ripper", 35, 80, 47, "male", "L2Monster", 40, 21498.592639, 665, 47.474088, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 760.47275, 279.95354, 171.59504, 273.14, 253, 1, 333, 0, 0, 0, 55, 190, 0, 1), 
(25423, 25423, "Fairy Queen Timiniel", 0, "Raid Boss", 0, "LineageMonster.pixy_bi", 10, 54, 61, "female", "L2RaidBoss", 40, 226767.438196, 1066.8, 74.468693, 2.7, 60, 57, 73, 76, 70, 80, 2601295, 380861, 822.13654, 757.48038, 150.22565, 369.52, 253, 4, 333, 0, 0, 0, 80, 190, 0, 1), 
(25424, 25424, "Timiniel's Royal Guards", 0, "Raid Fighter", 0, "LineageMonster.pixy", 5, 25, 60, "female", "L2Monster", 40, 17688.001998, 1036.8, 72.964382, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 1570.3549, 371.47512, 534.04783, 362.44, 253, 4, 333, 0, 0, 0, 80, 190, 0, 1), 
(25425, 25425, "Timiniel's Royal Guard Captain", 0, "Raid Fighter", 0, "LineageMonster.pixy", 5, 25, 60, "female", "L2Monster", 40, 35376.003996, 1036.8, 72.964382, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 3140.7098, 371.47512, 2136.19132, 362.44, 253, 4, 333, 0, 0, 0, 80, 190, 0, 1), 
(25426, 25426, "Betrayer of Urutu Freki", 0, "Raid Boss", 0, "LineageMonster.werewolf_bi", 11, 29.7, 25, "male", "L2RaidBoss", 40, 43316.308536, 259.2, 18.438531, 1.5, 60, 57, 73, 76, 70, 80, 2541012, 79280, 74.22232, 305.50599, 4.67967, 149.04, 253, 4, 333, 0, 0, 0, 50, 190, 0, 1), 
(25427, 25427, "Freki's Vampire Bat", 0, "Raid Fighter", 0, "LineageMonster.vampire_bat", 10, 33.5, 24, "male", "L2Monster", 40, 6680.15931, 245.52, 17.96077, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 273.28181, 148.06379, 68.81204, 144.46, 253, 4, 333, 0, 0, 0, 60, 190, 0, 1), 
(25428, 25428, "Freki's Wild Bear", 0, "Raid Fighter", 0, "LineageMonster.grizzly", 21, 40, 24, "male", "L2Monster", 40, 6680.15931, 245.52, 17.96077, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 273.28181, 148.06379, 68.81204, 144.46, 253, 4, 333, 0, 0, 0, 40, 190, 0, 1), 
(25429, 25429, "Mammon Collector Talos", 0, "Raid Boss", 0, "LineageMonster2.ashuras", 13, 37.5, 25, "male", "L2RaidBoss", 40, 43316.308536, 259.2, 18.438531, 1.5, 60, 57, 73, 76, 70, 80, 2541012, 79280, 74.22232, 305.50599, 4.67967, 149.04, 253, 4, 333, 0, 0, 0, 41, 190, 0, 1), 
(25430, 25430, "Talos' Cohort", 0, "Raid Fighter", 0, "LineageMonster.dre_vanul", 14, 36, 22, "male", "L2Monster", 40, 6247.184788, 218.52, 17.157688, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 231.18622, 138.98541, 58.17787, 135.6, 253, 4, 333, 0, 0, 0, 80, 190, 0, 1), 
(25431, 25431, "Flamestone Golem", 0, "Raid Boss", 0, "LineageMonster2.lava_golem", 22, 45, 44, "male", "L2RaidBoss", 40, 114863.791375, 584, 41.347042, 2.1, 60, 57, 73, 76, 70, 80, 2030767, 217826, 312.06213, 520.30656, 32.63272, 253.82, 253, 1, 333, 0, 0, 0, 13, 190, 0, 1), 
(25432, 25432, "Elemental of Flame", 0, "Raid Fighter", 0, "LineageMonster.mana_vampire", 11, 20, 43, "male", "L2Monster", 40, 17401.621187, 557.4, 39.411275, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 583.08879, 253.70126, 119.06209, 247.54, 253, 1, 333, 0, 0, 0, 90, 190, 0, 1), 
(25433, 25433, "Elemental of Spark", 0, "Raid Fighter", 0, "LineageMonster.magical_weaver", 11, 20, 43, "male", "L2Monster", 40, 8700.810593, 557.4, 39.411275, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 583.08879, 253.70126, 119.06209, 247.54, 253, 1, 333, 0, 0, 0, 90, 190, 0, 1), 
(25434, 25434, "Bandit Leader Barda", 0, "Raid Boss", 0, "LineageMonster.oel_mahum_warrior_50_bi", 30, 60, 55, "male", "L2RaidBoss", 40, 189660.12936, 889.8, 64.171341, 2.4, 60, 57, 73, 76, 70, 80, 2477107, 327038, 610.43901, 670.9086, 93.51865, 327.3, 253, 4, 333, 121, 0, 0, 70, 190, 0, 1), 
(25435, 25435, "Barda's Bandit", 0, "Raid Fighter", 0, "LineageMonster.oel_mahum", 20, 37, 54, "male", "L2Monster", 40, 29260.940425, 861, 62.194389, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 2312.08069, 328.34384, 1393.84679, 320.36, 253, 4, 333, 145, 0, 0, 70, 190, 0, 1), 
(25436, 25436, "Barda's Shaman", 0, "Raid Fighter", 0, "LineageMonster.oel_mahum_witch_doctor", 15, 34, 54, "male", "L2Monster", 40, 19604.830085, 861, 62.194389, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 1541.34859, 328.34384, 619.46036, 320.36, 253, 1, 333, 201, 0, 0, 70, 190, 0, 1), 
(25437, 25437, "Timak Orc Gosmos", 0, "Raid Boss", 0, "LineageMonster.batur_orc_overlord_100_bi", 24, 52, 45, "male", "L2RaidBoss", 40, 242366.202507, 610.8, 108.356398, 2.1, 60, 57, 73, 76, 70, 80, 2085510, 229987, 667.34895, 533.36238, 142.92804, 260.2, 253, 4, 333, 145, 0, 0, 80, 190, 0, 1), 
(25438, 25438, "Thief Kelbar", 0, "Raid Boss", 0, "LineageMonster.wererat_100_bi", 25, 50, 44, "male", "L2RaidBoss", 40, 114863.791375, 584, 41.347042, 2.1, 60, 57, 73, 76, 70, 80, 2030767, 217826, 312.06213, 520.30656, 32.63272, 253.82, 253, 8, 333, 239, 0, 0, 80, 190, 0, 1), 
(25439, 25439, "Kelbar's Inferior", 0, "Raid Fighter", 0, "LineageMonster.wererat_bi", 21, 38, 43, "male", "L2Monster", 40, 17401.621187, 557.4, 39.411275, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 1166.17758, 253.70126, 476.24837, 247.54, 253, 4, 333, 130, 0, 0, 80, 190, 0, 1), 
(25440, 25440, "Kelbar's Wizard", 0, "Raid Fighter", 0, "LineageMonster.wererat", 14, 25, 43, "male", "L2Monster", 40, 11659.086195, 557.4, 39.411275, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 777.43229, 253.70126, 211.65668, 247.54, 253, 1, 333, 99, 0, 0, 80, 190, 0, 1), 
(25441, 25441, "Evil Spirit Cyrion", 0, "Raid Boss", 0, "LineageMonster.drake_50_bi", 45, 150, 45, "male", "L2RaidBoss", 40, 121183.101254, 610.8, 43.342559, 2.1, 60, 57, 73, 76, 70, 80, 2085510, 229987, 333.67447, 533.36238, 35.73201, 260.2, 253, 4, 333, 0, 0, 0, 70, 190, 0, 1), 
(25442, 25442, "Evil Creature of Forest", 0, "Raid Fighter", 0, "LineageMonster.crimson_bear", 19, 36, 44, "male", "L2Monster", 40, 9189.10331, 584, 41.347042, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 624.12426, 260.15328, 130.5309, 253.82, 253, 4, 333, 0, 0, 0, 37, 190, 0, 1), 
(25443, 25443, "Anger of Forest", 0, "Raid Fighter", 0, "LineageMonster.giant_wild_hog", 35, 27, 44, "male", "L2Monster", 40, 18378.20662, 584, 41.347042, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 1248.24851, 260.15328, 522.12359, 253.82, 253, 1, 333, 0, 0, 0, 35, 190, 0, 1), 
(25444, 25444, "Enmity Ghost Ramdal", 0, "Raid Boss", 0, "LineageMonster.dark_horror_100_bi", 40, 70, 65, "male", "L2RaidBoss", 40, 247116.172388, 1188.8, 79.611591, 2.7, 60, 57, 73, 76, 70, 80, 2780578, 429547, 973.34478, 815.67099, 175.35143, 397.92, 253, 4, 333, 0, 0, 0, 100, 190, 0, 1), 
(25445, 25445, "Enmity Ghosts", 0, "Raid Fighter", 0, "LineageMonster.crimson_doll", 15, 38, 64, "male", "L2Monster", 40, 19389.969859, 1158, 78.451681, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 1870.56281, 400.56702, 679.58089, 390.82, 253, 4, 333, 0, 0, 0, 60, 190, 0, 1), 
(25446, 25446, "Shooter of Enmity", 0, "Raid Fighter", 0, "LineageMonster.skeleton_archer", 11, 27, 64, "male", "L2Monster", 1100, 25982.559611, 1158, 78.451681, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 1870.56281, 400.56702, 679.58089, 390.82, 253, 8, 333, 279, 0, 0, 40, 190, 0, 1), 
(25447, 25447, "Immortal Savior Mardil", 0, "Raid Boss", 0, "LineageMonster.banshee_50_bi", 13.5, 38, 71, "female", "L2RaidBoss", 40, 271409.095507, 1377.8, 85.229359, 3, 60, 57, 73, 76, 70, 80, 3074084, 495533, 1194.92418, 901.96077, 231.0889, 440.02, 253, 1, 333, 3939, 0, 0, 80, 190, 0, 1), 
(25448, 25448, "Immortal Savior", 0, "Raid Fighter", 0, "LineageMonster.binding", 12, 21, 70, "male", "L2Monster", 40, 21422.465316, 1345.8, 84.412907, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 2319.29006, 443.87396, 833.05536, 433.08, 253, 1, 333, 0, 0, 0, 10, 190, 0, 1), 
(25449, 25449, "Immortal Guide", 0, "Raid Fighter", 0, "LineageMonster.liviona", 15, 28, 70, "male", "L2Monster", 40, 42844.930631, 1345.8, 84.412907, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 2319.29006, 443.87396, 833.05536, 433.08, 253, 1, 333, 0, 0, 0, 80, 190, 0, 1), 
(25450, 25450, "Cherub Galaxia", 0, "Raid Boss", 0, "LineageMonster.archangel_50_bi", 22, 120, 79, "male", "L2RaidBoss", 40, 414903.391635, 1641, 127.691728, 3, 60, 57, 73, 76, 70, 80, 5390003, 1205333, 2633.52326, 1011.21024, 947.57373, 493.3, 253, 4, 333, 97, 0, 0, 50, 190, 0, 1), 
(25451, 25451, "Galaxia's Guards", 0, "Raid Fighter", 0, "LineageMonster.angel", 13.5, 36.5, 78, "male", "L2Monster", 40, 44016.378804, 1607.4, 126.536106, 3, 40, 43, 30, 21, 20, 20, 0, 0, 6913.74414, 499.05092, 6610.34801, 486.92, 253, 4, 333, 148, 0, 0, 30, 190, 0, 1), 
(25452, 25452, "Messenger of Angel", 0, "Raid Fighter", 0, "LineageMonster.angel", 13.5, 36.5, 79, "male", "L2Monster", 40, 66384.542662, 1641, 127.691728, 3, 40, 43, 30, 21, 20, 20, 0, 0, 5267.04651, 505.60512, 3790.2949, 493.3, 253, 4, 333, 148, 0, 0, 30, 190, 0, 1), 
(25453, 25453, "Meanas Anor", 0, "Raid Boss", 0, "LineageMonster.wyrm_50_bi", 58, 108, 70, "male", "L2RaidBoss", 40, 373386.071242, 1345.8, 117.684362, 2.7, 60, 57, 73, 76, 70, 80, 4596479, 802604, 2154.88112, 887.74791, 717.40387, 433.08, 253, 4, 333, 0, 0, 0, 70, 190, 0, 1), 
(25454, 25454, "Wyvern of Marsh", 0, "Raid Fighter", 0, "LineageMonster.wyrm", 29, 72, 69, "male", "L2Monster", 40, 39454.502253, 1314, 116.468584, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 5571.20004, 436.72595, 4930.48367, 426.1, 253, 4, 333, 0, 0, 0, 70, 190, 0, 1), 
(25455, 25455, "Succubus of Marsh", 0, "Raid Fighter", 0, "LineageMonster.succubus", 10, 36, 69, "female", "L2Monster", 40, 58887.316796, 1314, 116.468584, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 4178.50449, 436.72595, 2773.51841, 426.1, 253, 4, 333, 0, 0, 0, 60, 190, 0, 1), 
(25456, 25456, "Mirror of Oblivion", 0, "Raid Boss", 0, "LineageMonster.mirror_50_bi", 45, 78, 49, "male", "L2RaidBoss", 40, 148076.094027, 720, 51.719311, 2.1, 60, 57, 73, 76, 70, 80, 2328069, 284981, 431.28336, 586.98906, 51.9276, 286.36, 253, 1, 333, 0, 0, 0, 80, 190, 0, 1), 
(25457, 25457, "Shards of Oblivion", 0, "Raid Fighter", 0, "LineageMonster.human_ghost", 8, 22, 48, "male", "L2Monster", 40, 11293.712264, 692.4, 49.588364, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 810.39881, 286.69205, 191.37493, 279.72, 253, 4, 333, 0, 0, 0, 80, 190, 0, 1), 
(25458, 25458, "Shadow of Oblivion", 0, "Raid Fighter", 0, "LineageMonster.elf_ghost", 7, 21, 48, "male", "L2Monster", 40, 22587.424528, 692.4, 49.588364, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 810.39881, 286.69205, 191.37493, 279.72, 253, 4, 333, 0, 0, 0, 80, 190, 0, 1), 
(25459, 25459, "Shards of Oblivion", 0, "Raid Fighter", 0, "LineageMonster.dwarf_ghost", 9, 16.5, 48, "male", "L2Monster", 40, 11293.712264, 692.4, 49.588364, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 810.39881, 286.69205, 191.37493, 279.72, 253, 4, 333, 0, 0, 0, 80, 190, 0, 1), 
(25460, 25460, "Deadman Ereve", 0, "Raid Boss", 0, "LineageMonster.death_blader_200_bi", 45, 141, 51, "male", "L2RaidBoss", 40, 162046.294594, 775.8, 55.981899, 2.4, 60, 57, 73, 76, 70, 80, 2256714, 285537, 486.77656, 614.55582, 67.95425, 299.8, 253, 1, 333, 194, 0, 0, 100, 190, 0, 1), 
(25461, 25461, "Ereve's Knight", 0, "Raid Fighter", 0, "LineageMonster.skeleton_knight", 10, 25, 50, "male", "L2Monster", 40, 24807.370316, 747.8, 53.854634, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 1833.92174, 300.35766, 904.44286, 293.06, 253, 4, 333, 70, 0, 0, 40, 190, 0, 1), 
(25462, 25462, "Ereve's Squire", 0, "Raid Fighter", 0, "LineageMonster.skeleton_pikeman", 10, 28, 50, "male", "L2Monster", 40, 24807.370316, 747.8, 53.854634, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 1833.92174, 300.35766, 904.44286, 293.06, 253, 4, 333, 98, 0, 0, 50, 190, 0, 1), 
(25463, 25463, "Harit Guardian Garangky", 0, "Raid Boss", 0, "LineageMonster.saber_toothed_tiger", 34, 28, 56, "male", "L2RaidBoss", 40, 196306.513056, 918.8, 66.084883, 2.4, 60, 57, 73, 76, 70, 80, 2529799, 340561, 643.78481, 685.20405, 100.16291, 334.26, 253, 4, 333, 0, 0, 0, 60, 190, 0, 1), 
(25464, 25464, "Garangky Guard Captain", 0, "Raid Fighter", 0, "LineageMonster.zenta_lizardman_warrior", 13, 35, 55, "male", "L2Monster", 40, 30345.620698, 889.8, 64.171341, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 2441.75605, 335.4543, 1496.29839, 327.3, 253, 1, 333, 303, 0, 0, 40, 190, 0, 1), 
(25465, 25465, "Garangky Guard Shaman", 0, "Raid Fighter", 0, "LineageMonster.zenta_lizardman_shaman", 13, 35, 55, "male", "L2Monster", 40, 30345.620698, 889.8, 64.171341, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 1220.87802, 335.4543, 374.0746, 327.3, 253, 1, 333, 206, 0, 0, 43, 190, 0, 1), 
(25466, 25466, "Garangky Guard", 0, "Raid Fighter", 0, "LineageMonster.zenta_lizardman", 11, 32, 55, "male", "L2Monster", 40, 30345.620698, 889.8, 64.171341, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 2441.75605, 335.4543, 1496.29839, 327.3, 253, 4, 333, 77, 0, 0, 37, 190, 0, 1), 
(25467, 25467, "Gorgolos", 0, "Raid Boss", 0, "LineageMonster.field_stalker_200_bi", 45, 96, 64, "male", "L2RaidBoss", 40, 242374.623236, 1158, 78.451681, 2.7, 60, 57, 73, 76, 70, 80, 2736355, 417632, 935.2814, 801.13404, 169.89522, 390.82, 253, 1, 333, 0, 0, 0, 70, 190, 0, 1), 
(25468, 25468, "Cursed Life", 0, "Raid Fighter", 0, "LineageMonster.field_stalker", 15, 30, 63, "male", "L2Monster", 40, 18992.425037, 1127.4, 77.210385, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 1794.61196, 393.29139, 658.02317, 383.72, 253, 1, 333, 0, 0, 0, 70, 190, 0, 1), 
(25469, 25469, "Cursed Soul", 0, "Raid Fighter", 0, "LineageMonster.field_stalker", 15, 30, 63, "male", "L2Monster", 40, 37984.850074, 1127.4, 77.210385, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 3589.22391, 393.29139, 2632.09268, 383.72, 253, 1, 333, 0, 0, 0, 70, 190, 0, 1), 
(25470, 25470, "Last Titan Utenus", 0, "Raid Boss", 0, "LineageMonster.lesser_giant_mage", 21, 44, 66, "male", "L2RaidBoss", 40, 251638.068338, 1219.8, 80.695494, 2.7, 60, 57, 73, 76, 70, 80, 2826358, 441301, 1011.35162, 830.18256, 180.85221, 405, 253, 1, 333, 3938, 0, 0, 15, 190, 0, 1), 
(25471, 25471, "Utenus's Wizard", 0, "Raid Fighter", 0, "LineageMonster.lesser_giant", 21, 44, 65, "male", "L2Monster", 40, 26490.85368, 1188.8, 79.611591, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 2595.52118, 407.8355, 1246.88892, 397.92, 253, 1, 333, 0, 0, 0, 15, 190, 0, 1), 
(25472, 25472, "Utenus's Guard", 0, "Raid Fighter", 0, "LineageMonster.leogul", 15, 35, 65, "male", "L2Monster", 40, 39538.587582, 1188.8, 79.611591, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 3893.3791, 407.8355, 2805.62282, 397.92, 253, 1, 333, 0, 0, 0, 80, 190, 0, 1), 
(25473, 25473, "Grave Robber Kim", 0, "Raid Boss", 0, "LineageMonster.batur_orc_warrior_100_bi", 20, 42, 52, "male", "L2RaidBoss", 40, 169041.653947, 804, 58.088796, 2.4, 60, 57, 73, 76, 70, 80, 2313340, 287521, 516.1512, 628.50318, 73.27274, 306.6, 253, 1, 333, 160, 0, 0, 80, 190, 0, 1), 
(25474, 25474, "Kim's Gang", 0, "Raid Fighter", 0, "LineageMonster.batur_orc", 9, 21.5, 51, "male", "L2Monster", 40, 25927.407135, 775.8, 55.981899, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 1947.10625, 307.27791, 1087.26799, 299.8, 253, 1, 333, 89, 0, 0, 80, 190, 0, 1), 
(25475, 25475, "Ghost Knight Kabed", 0, "Raid Boss", 0, "LineageMonster.headless_knight_50_bi", 30, 46.5, 55, "male", "L2RaidBoss", 40, 189660.12936, 889.8, 64.171341, 2.4, 60, 57, 73, 76, 70, 80, 2477107, 327038, 610.43901, 670.9086, 93.51865, 327.3, 253, 4, 333, 145, 0, 0, 70, 190, 0, 1), 
(25476, 25476, "Kabed's Soldier", 0, "Raid Fighter", 0, "LineageMonster.skeleton_knight", 10, 25, 54, "male", "L2Monster", 40, 14630.470212, 861, 62.194389, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 1156.04035, 328.34384, 348.4617, 320.36, 253, 4, 333, 125, 0, 0, 40, 190, 0, 1), 
(25477, 25477, "Kabed's Archer", 0, "Raid Fighter", 0, "LineageMonster.skeleton_archer", 11, 27, 54, "male", "L2Monster", 1100, 19604.830085, 861, 62.194389, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 1156.04035, 328.34384, 348.4617, 320.36, 253, 8, 333, 279, 0, 0, 40, 190, 0, 1), 
(25478, 25478, "Shilen's Priest Hisilrome", 0, "Raid Boss", 0, "LineageMonster.cave_maiden", 25, 65, 65, "female", "L2RaidBoss", 40, 247116.172388, 1188.8, 79.611591, 2.7, 60, 57, 73, 76, 70, 80, 2780578, 429547, 973.34478, 815.67099, 175.35143, 397.92, 253, 8, 333, 230, 0, 0, 70, 190, 0, 1), 
(25479, 25479, "Hisilrome's Servitor", 0, "Raid Fighter", 0, "LineageMonster.serpent_slave", 17, 46, 64, "male", "L2Monster", 40, 25982.559611, 1158, 78.451681, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 2494.02139, 400.56702, 1208.09094, 390.82, 253, 4, 333, 68, 0, 0, 70, 190, 0, 1), 
(25480, 25480, "Hisilrome's Page", 0, "Raid Fighter", 0, "LineageMonster.lienrik", 12, 50, 64, "male", "L2Monster", 40, 38779.939718, 1158, 78.451681, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 1870.56281, 400.56702, 679.58089, 390.82, 253, 1, 333, 0, 0, 0, 100, 190, 0, 1), 
(25481, 25481, "Magus Kenishee", 0, "Raid Boss", 0, "LineageMonster.banshee_50_bi", 13.5, 38, 53, "female", "L2RaidBoss", 40, 175997.603312, 832.4, 60.163394, 2.4, 60, 57, 73, 76, 70, 80, 2368104, 300304, 546.57712, 642.54978, 80.62227, 313.46, 253, 1, 333, 3939, 0, 0, 80, 190, 0, 1), 
(25482, 25482, "Shadow of Kenishee", 0, "Raid Fighter", 0, "LineageMonster.shadow", 10, 30, 52, "male", "L2Monster", 40, 27046.664632, 804, 58.088796, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 2064.60481, 314.25159, 1172.36381, 306.6, 253, 1, 333, 0, 0, 0, 80, 190, 0, 1), 
(25483, 25483, "Phantom of Kenishee", 0, "Raid Fighter", 0, "LineageMonster.silhouette", 8, 23, 52, "female", "L2Monster", 40, 27046.664632, 804, 58.088796, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 1032.3024, 314.25159, 293.09095, 306.6, 253, 1, 333, 0, 0, 0, 80, 190, 0, 1), 
(25484, 25484, "Zaken's Chief Mate Tillion", 0, "Raid Boss", 0, "LineageMonster.skeleton_knight_50_bi", 15, 39, 50, "male", "L2RaidBoss", 40, 155046.064475, 747.8, 53.854634, 2.1, 60, 57, 73, 76, 70, 80, 2389767, 281312, 458.48043, 600.71532, 56.52768, 293.06, 253, 1, 333, 160, 0, 0, 40, 190, 0, 1), 
(25485, 25485, "Tillion's Inferior", 0, "Raid Fighter", 0, "LineageMonster.skeleton_bi", 11, 31, 49, "male", "L2Monster", 40, 23692.175044, 720, 51.719311, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 1725.13344, 293.49453, 830.84157, 286.36, 253, 4, 333, 131, 0, 0, 60, 190, 0, 1), 
(25486, 25486, "Tillion's Bat", 0, "Raid Fighter", 0, "LineageMonster.vampire_bat", 10, 33.5, 49, "male", "L2Monster", 40, 23692.175044, 720, 51.719311, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 1725.13344, 293.49453, 830.84157, 286.36, 253, 4, 333, 0, 0, 0, 60, 190, 0, 1), 
(25487, 25487, "Water Spirit Lian", 0, "Raid Boss", 0, "LineageMonster.pixy_bi", 10, 54, 40, "female", "L2RaidBoss", 40, 91937.38614, 478.8, 34.038778, 1.8, 60, 57, 73, 76, 70, 80, 2030965, 181264, 236.34363, 469.65105, 18.66292, 229.12, 253, 4, 333, 0, 0, 0, 80, 190, 0, 1), 
(25488, 25488, "Spirit of Gildor", 0, "Raid Fighter", 0, "LineageMonster.pixy", 5, 25, 39, "female", "L2Monster", 40, 9312.608644, 463.32, 32.411747, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 586.57028, 228.70128, 123.0125, 223.14, 253, 4, 333, 0, 0, 0, 80, 190, 0, 1), 
(25489, 25489, "Guardian of Gildor", 0, "Raid Fighter", 0, "LineageMonster.pixy", 5, 25, 39, "female", "L2Monster", 40, 13899.415887, 463.32, 32.411747, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 879.87742, 228.70128, 276.79024, 223.14, 253, 4, 333, 0, 0, 0, 80, 190, 0, 1), 
(25490, 25490, "Gwindorr", 0, "Raid Boss", 0, "LineageMonster.serpent_slave", 17, 46, 40, "male", "L2RaidBoss", 40, 91937.38614, 478.8, 34.038778, 1.8, 60, 57, 73, 76, 70, 80, 2030965, 181264, 236.34363, 469.65105, 18.66292, 229.12, 253, 4, 333, 129, 0, 0, 70, 190, 0, 1), 
(25491, 25491, "Guard of Gwindorr", 0, "Raid Fighter", 0, "LineageMonster.virud_lizardman_scout", 10, 22, 39, "male", "L2Monster", 1100, 9312.608644, 463.32, 32.411747, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 439.93871, 228.70128, 69.19756, 223.14, 253, 8, 333, 2507, 0, 0, 43, 190, 0, 1), 
(25492, 25492, "Follower of Gwindorr", 0, "Raid Fighter", 0, "LineageMonster.virud_lizardman", 10, 23, 39, "male", "L2Monster", 40, 6949.707943, 463.32, 32.411747, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 439.93871, 228.70128, 69.19756, 223.14, 253, 4, 333, 2, 0, 0, 43, 190, 0, 1), 
(25493, 25493, "Eva's Spirit Niniel", 0, "Raid Boss", 0, "LineageMonster.cutie_cat", 8, 15, 55, "female", "L2RaidBoss", 40, 189660.12936, 889.8, 64.171341, 2.4, 60, 57, 73, 76, 70, 80, 2477107, 327038, 610.43901, 670.9086, 93.51865, 327.3, 253, 4, 333, 0, 0, 0, 48, 190, 0, 1), 
(25494, 25494, "Spirit of Niniel", 0, "Raid Fighter", 0, "LineageMonster.pixy", 5, 25, 54, "female", "L2Monster", 40, 29260.940425, 861, 62.194389, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 2312.08069, 328.34384, 1393.84679, 320.36, 253, 8, 333, 0, 0, 0, 80, 190, 0, 1), 
(25495, 25495, "Spirit of Niniel", 0, "Raid Fighter", 0, "LineageMonster.pixy", 5, 25, 54, "female", "L2Monster", 40, 14630.470212, 861, 62.194389, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 1156.04035, 328.34384, 348.4617, 320.36, 253, 1, 333, 0, 0, 0, 80, 190, 0, 1), 
(25496, 25496, "Fafurion's Envoy Pingolpin", 0, "Raid Boss", 0, "LineageMonster.riba", 25, 72, 52, "female", "L2RaidBoss", 40, 169041.653947, 804, 58.088796, 2.4, 60, 57, 73, 76, 70, 80, 2313340, 287521, 516.1512, 628.50318, 73.27274, 306.6, 253, 8, 333, 0, 0, 0, 60, 190, 0, 1), 
(25497, 25497, "Fafurion's Envoy", 0, "Raid Fighter", 0, "LineageMonster.marsh_stakato_soldier", 10, 25, 51, "male", "L2Monster", 40, 25927.407135, 775.8, 55.981899, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 1947.10625, 307.27791, 1087.26799, 299.8, 253, 4, 333, 76, 0, 0, 30, 190, 0, 1), 
(25498, 25498, "Fafurion's Henchman Istary", 0, "Raid Boss", 0, "LineageMonster.farhite_50_bi", 24, 48, 45, "male", "L2RaidBoss", 40, 121183.101254, 610.8, 43.342559, 2.1, 60, 57, 73, 76, 70, 80, 2085510, 229987, 333.67447, 533.36238, 35.73201, 260.2, 253, 1, 333, 5131, 0, 0, 15, 190, 0, 1), 
(25499, 25499, "Alligator of Istary", 0, "Raid Fighter", 0, "LineageMonster.crocodile", 28, 11.5, 44, "male", "L2Monster", 40, 18378.20662, 584, 41.347042, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 1248.24851, 260.15328, 522.12359, 253.82, 253, 4, 333, 0, 0, 0, 70, 190, 0, 1), 
(25500, 25500, "Alligator of Istary", 0, "Raid Fighter", 0, "LineageMonster.crocodile", 28, 11.5, 44, "male", "L2Monster", 40, 9189.10331, 584, 41.347042, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 624.12426, 260.15328, 130.5309, 253.82, 253, 4, 333, 0, 0, 0, 70, 190, 0, 1), 
(25501, 25501, "Boss Akata", 0, "Raid Boss", 0, "LineageNPC.e_collector_teacher_Mdwarf_mon_130p", 11, 23.6, 30, "male", "L2RaidBoss", 40, 53690.033689, 329.4, 21.714039, 1.5, 60, 57, 73, 76, 70, 80, 2308288, 111484, 111.21878, 355.39281, 7.21488, 173.38, 253, 4, 333, 8528, 0, 0, 36, 190, 0, 1), 
(25502, 25502, "Akata's Thug", 0, "Raid Fighter", 0, "LineageNPC.e_traderB_Fdwarf_mon_120p", 8, 22, 30, "female", "L2Monster", 1100, 5755.571611, 329.4, 21.714039, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 222.43755, 177.69641, 28.85951, 173.38, 253, 8, 333, 8527, 0, 0, 49, 190, 0, 1), 
(25503, 25503, "Akata's Lackey", 0, "Raid Fighter", 0, "LineageNPC.e_collector_teacher_Fdwarf_mon_120p", 9, 21.4, 30, "female", "L2Monster", 40, 4295.202695, 329.4, 21.714039, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 222.43755, 177.69641, 28.85951, 173.38, 253, 4, 333, 8529, 0, 0, 45, 190, 0, 1), 
(25504, 25504, "Nellis' Vengeful Spirit", 0, "Raid Boss", 0, "LineageNPC.a_mageguild_teacher_Mhuman_mon_120p", 10, 28.1, 39, "male", "L2RaidBoss", 40, 86871.349292, 463.32, 32.411747, 1.8, 60, 57, 73, 76, 70, 80, 1988451, 173127, 219.96935, 457.40256, 17.29939, 223.14, 253, 4, 333, 8532, 0, 0, 50, 190, 0, 1), 
(25505, 25505, "Nellis' Follower", 0, "Raid Fighter", 0, "LineageMonster.dwarf_ghost", 9, 16.5, 38, "male", "L2Monster", 40, 13134.248391, 447.96, 30.872687, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 818.21687, 222.66431, 258.36304, 217.24, 253, 4, 333, 0, 0, 0, 80, 190, 0, 1), 
(25506, 25506, "Rayito the Looter", 0, "Raid Boss", 0, "LineageMonster.ol_mahum_champion_05te_120p", 16, 33.2, 37, "male", "L2RaidBoss", 40, 77592.657061, 432.72, 29.423287, 1.8, 60, 57, 73, 76, 70, 80, 1932589, 153693, 190.06221, 433.43274, 15.06832, 211.44, 253, 1, 333, 67, 633, 0, 50, 190, 0, 1), 
(25507, 25507, "Rayito's Henchman", 0, "Raid Fighter", 0, "LineageMonster.ol_mahum_05te_110p", 14.5, 28, 36, "male", "L2Monster", 40, 11740.947836, 417.6, 28.064045, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 705.82255, 210.85917, 224.63892, 205.74, 253, 1, 333, 123, 19, 0, 50, 190, 0, 1), 
(25508, 25508, "Rayito's Henchman", 0, "Raid Fighter", 0, "LineageMonster2.northern_goblin_110p", 6, 16.6, 36, "male", "L2Monster", 40, 7866.43505, 417.6, 28.064045, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 470.5366, 210.85917, 99.83515, 205.74, 253, 1, 333, 66, 102, 0, 30, 190, 0, 1), 
(25509, 25509, "Dark Shaman Varangka", 0, "Raid Boss", 0, "LineageMonster.batur_orc_shaman_a_01te_120p", 13, 20.8, 53, "male", "L2RaidBoss", 40, 175997.603312, 832.4, 60.163394, 2.4, 60, 57, 73, 76, 70, 80, 2368104, 300304, 546.57712, 642.54978, 80.62227, 313.46, 253, 4, 333, 316, 0, 0, 50, 190, 0, 1), 
(25510, 25510, "Varangka's Descendant", 0, "Raid Fighter", 0, "LineageMonster.batur_orc_overlord_01te_110p", 13, 26.9, 52, "male", "L2Monster", 40, 27046.664632, 804, 58.088796, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 2064.60481, 314.25159, 1172.36381, 306.6, 253, 4, 333, 74, 0, 0, 80, 190, 0, 1), 
(25511, 25511, "Varangka's Page", 0, "Raid Fighter", 0, "LineageMonster.batur_orc_shaman_a_01te_110p", 12, 18.8, 52, "male", "L2Monster", 40, 13523.332316, 804, 58.088796, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 1032.3024, 314.25159, 293.09095, 306.6, 253, 4, 333, 179, 0, 0, 50, 190, 0, 1), 
(25512, 25512, "Gigantic Chaos Golem", 0, "Raid Boss", 0, "LineageMonster3.chaos_golem", 31, 51.8, 52, "male", "L2RaidBoss", 40, 338083.307895, 804, 145.221991, 2.4, 60, 57, 73, 76, 70, 80, 2313340, 287521, 1032.3024, 628.50318, 293.09095, 306.6, 253, 4, 333, 0, 0, 0, 18, 190, 0, 1), 
(25514, 25514, "Queen Shyeed", 0, "Raid Boss", 0, "LineageMonster3.cannibal_stakato_leader_tran_120p", 45, 50.8, 80, "male", "L2RaidBoss", 40, 300327.053711, 1674.8, 92.338763, 3, 60, 57, 73, 76, 70, 80, 3775961, 557272, 1445.33275, 1024.125, 280.52214, 499.6, 253, 4, 333, 0, 0, 0, 45, 190, 0, 1), 
(25515, 25515, "Spiked Stakato", 0, "Raid Fighter", 0, "LineageMonster.spike_stakato_110p", 13, 21, 79, "male", "L2Monster", 40, 31866.802014, 1641, 91.493086, 3, 40, 43, 30, 21, 20, 20, 0, 0, 3798.33441, 505.60512, 1965.98254, 493.3, 253, 4, 333, 123, 0, 0, 23, 190, 0, 1), 
(25516, 25516, "Spiked Stakato", 0, "Raid Fighter", 0, "LineageMonster.spike_stakato_worker_110p", 13, 22.2, 79, "male", "L2Monster", 40, 47562.391065, 1641, 91.493086, 3, 40, 43, 30, 21, 20, 20, 0, 0, 5697.64406, 505.60512, 4423.65426, 493.3, 253, 4, 333, 0, 0, 0, 23, 190, 0, 1), 
(25523, 25523, "Plague Golem", 0, "Raid Boss", 0, "LineageMonster3.Steel_Trapper", 35, 46.38, 73, "male", "L2RaidBoss", 40, 776489.863368, 1442.4, 302.659981, 3, 60, 57, 73, 76, 70, 80, 5168419, 839126, 4680.0994, 930.08877, 3338.16499, 453.74, 253, 4, 333, 0, 0, 0, 60, 160, 0, 1), 
(25524, 25524, "Flamestone Giant", 0, "Raid Boss", 0, "LineageMonster2.lava_golem", 22, 45, 76, "male", "L2RaidBoss", 40, 401886.766609, 1540.8, 124.302529, 3, 60, 57, 73, 76, 70, 80, 5267108, 1171763, 2501.79548, 971.35365, 888.04886, 473.86, 253, 1, 333, 0, 0, 0, 13, 190, 0, 1), 
(25525, 25525, "Flame Spirit", 0, "Raid Fighter", 0, "LineageMonster.mana_vampire", 11, 20, 75, "male", "L2Monster", 40, 63589.96023, 1507.8, 123.21629, 3, 40, 43, 30, 21, 20, 20, 0, 0, 4902.44696, 478.86935, 3475.50411, 467.22, 253, 4, 333, 0, 0, 0, 90, 190, 0, 1), 
(25526, 25526, "Charged Spirit", 0, "Raid Fighter", 0, "LineageMonster.magical_weaver", 11, 20, 75, "male", "L2Monster", 40, 31794.980115, 1507.8, 123.21629, 3, 40, 43, 30, 21, 20, 20, 0, 0, 4902.44696, 478.86935, 3475.50411, 467.22, 253, 1, 333, 0, 0, 0, 90, 190, 0, 1), 
(25527, 25527, "Uruka", 0, "Raid Boss", 0, "LineageMonster3.Crokian_Elder", 30, 42.51, 80, "male", "L2RaidBoss", 40, 675862.824884, 203.52, 259.751563, 3.18, 60, 57, 73, 76, 70, 80, 3775961, 557272, 3068.49967, 1162.67224, 1381.13521, 567.1848, 253, 1, 333, 0, 0, 0, 60, 190, 0, 1), 
(25528, 25528, "Tiberias", 0, "Prime Inspector", 0, "LineageMonster4.K_Examiner", 10, 24.62, 22, "male", "L2RaidBoss", 40, 31106.789088, 218.52, 16.371994, 1.5, 40, 43, 30, 21, 20, 20, 225568, 18408, 87.89639, 185.31388, 38.96473, 135.60464, 253, 4, 333, 0, 0, 0, 28, 150, 0, 1), 
(25529, 25529, "Garden Guard", 0, "Vice Inspector", 0, "LineageMonster4.Mostro_Fighter", 15.5, 22.5, 22, "male", "L2Npc", 40, 2488.543127, 218.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 51.75278, 92.65694, 35.34044, 67.80232, 253, 4, 333, 0, 0, 0, 36, 120, 0, 1), 
(25530, 25530, "Garden Guard", 0, "Vice Inspector", 0, "LineageMonster4.Mostro_Fighter", 15.5, 22.5, 22, "male", "L2Npc", 40, 1244.271564, 218.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 51.75278, 92.65694, 35.34044, 67.80232, 253, 4, 333, 0, 0, 0, 36, 120, 0, 1), 
(25531, 25531, "Darnel", 0, "Torture Maiden", 0, "LineageMonster4.rah", 20, 40.6, 81, "female", "L2RaidBoss", 40, 1354779.944736, 1708.8, 155.191511, 3, 40, 43, 30, 21, 20, 80, 1713495, 1026728, 5212.7119, 622.10029, 3559.60647, 334.1053, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), 
(25532, 25532, "Kechi", 0, "Fire", 0, "LineageMonster4.Keyache", 12, 29, 82, "male", "L2RaidBoss", 40, 338150.746542, 1743, 192.545054, 3, 40, 43, 30, 21, 20, 80, 2586436, 1438503, 4522.43391, 629.59459, 3088.23609, 338.13, 253, 4, 333, 0, 0, 0, 26, 180, 0, 1), 
(25533, 25533, "Kechi's Henchman", 0, "", 0, "LineageMonster3.Death_Blader_Raid", 15, 32.5, 82, "male", "L2Monster", 40, 18801.064774, 1743, 192.697894, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2138.26232, 629.59459, 1460.15597, 614.28, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(25534, 25534, "Tears", 0, "Ice", 0, "LineageMonster4.tears", 20, 27.5, 83, "female", "L2RaidBoss", 40, 1347510.706572, 1777.4, 152.563942, 3, 40, 43, 30, 21, 20, 80, 2010425, 1208631, 5327.46513, 636.95059, 3637.96805, 342.081, 253, 4, 333, 9638, 9638, 0, 60, 180, 0, 1), 
(25535, 25535, "Tears", 0, "Ice", 0, "LineageMonster4.tears", 20, 27.5, 83, "female", "L2Monster", 40, 1347510.706572, 1777.4, 152.563942, 3, 40, 43, 30, 21, 20, 80, 0, 0, 213.09861, 636.95059, 145.51872, 342.081, 253, 4, 333, 9638, 9638, 0, 60, 180, 0, 1), 
(25536, 25536, "Hannibal", 0, "Raid Boss", 0, "LineageMonster4.rah", 20, 40.6, 81, "female", "L2RaidBoss", 40, 431893.621607, 1777.4, 132.78187, 3, 60, 57, 73, 76, 70, 80, 5614732, 1265702, 2784.89734, 1074.07355, 1033.42208, 523.97271, 253, 4, 333, 0, 0, 0, 60, 100, 0, 1), 
(25537, 25537, "Enmity", 0, "Raid Fighter", 0, "LineageMonster4.eyeless", 36, 43.5, 81, "male", "L2Monster", 40, 34551.489729, 1777.4, 132.78187, 3, 40, 43, 30, 21, 20, 20, 0, 0, 5569.79468, 537.03677, 4133.68833, 523.97271, 253, 4, 333, 0, 0, 0, 60, 100, 0, 1), 
(25538, 25538, "Vengeance", 0, "Raid Fighter", 0, "LineageMonster4.eyeless", 36, 43.5, 81, "male", "L2Monster", 40, 69102.979457, 1777.4, 132.78187, 3, 40, 43, 30, 21, 20, 20, 0, 0, 5569.79468, 537.03677, 4133.68833, 523.97271, 253, 4, 333, 0, 0, 0, 60, 100, 0, 1), 
(25539, 25539, "Typhoon", 0, "Raid Boss", 0, "LineageMonster3.Death_Blader_Raid_sand", 15, 32.5, 81, "male", "L2RaidBoss", 40, 872425.115647, 1812, 335.274223, 3, 60, 57, 73, 76, 70, 80, 5678637, 1283185, 5658.19897, 1092.5476, 4232.88708, 532.98247, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), 
(25540, 25540, "Demon Prince", 0, "Raid Boss", 0, "LineageMonster4.rahuu", 33, 49, 83, "male", "L2RaidBoss", 40, 2230489.488773, 1846.8, 187.223482, 3, 40, 43, 30, 21, 20, 80, 3100452, 410692, 5211.07476, 731.98996, 3599.86629, 353.81079, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), 
(25541, 25541, "Fiend", 0, "Raid Fighter", 0, "LineageMonster3.self_blaster", 9, 25.8, 83, "male", "L2Monster", 40, 55817.801267, 1846.8, 187.410041, 3, 40, 43, 30, 21, 20, 20, 0, 0, 9440.59974, 731.98996, 6521.6675, 353.81079, 253, 4, 333, 0, 0, 0, 200, 240, 0, 1), 
(25542, 25542, "Ranku", 0, "Raid Boss", 0, "LineageMonster4.LaneCoo", 13, 29, 83, "male", "L2RaidBoss", 40, 2230489.488773, 1846.8, 187.223482, 3, 40, 43, 30, 21, 20, 80, 3100452, 410692, 3571.0363, 731.98996, 2466.91014, 353.81079, 253, 4, 333, 0, 0, 0, 26, 180, 0, 1), 
(25543, 25543, "Eidolon", 0, "Raid Fighter", 0, "LineageMonster4.eyeless_080p", 34, 35, 83, "male", "L2Monster", 40, 55817.801267, 1846.8, 187.410041, 3, 40, 43, 30, 21, 20, 20, 0, 0, 9440.59974, 731.98996, 6521.6675, 353.81079, 253, 4, 333, 0, 0, 0, 60, 210, 0, 1), 
(25544, 25544, "Tully", 0, "Steel Citadel", 0, "LineageMonster4.Tollese", 19, 32.5, 83, "male", "L2RaidBoss", 40, 1697736.137237, 1881.8, 171.837731, 3, 40, 43, 30, 21, 20, 80, 2522625, 1749150, 5285.98483, 743.99459, 3672.60127, 359.61279, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), 
(25545, 25545, "Tully's Banshee", 0, "Raid Fighter", 0, "LineageMonster4.giga_whirligig", 33, 47.5, 83, "male", "L2Monster", 40, 4334645.456776, 1881.8, 185.531973, 3, 40, 43, 30, 21, 20, 20, 0, 0, 5285.98483, 743.99459, 3672.60127, 653.30756, 253, 4, 333, 0, 0, 0, 250, 250, 0, 1), 
(25546, 25546, "Rhianna the Traitor", 0, "Forsaken Prisoner", 0, "LineageMonster.banshee_50_bi", 13.5, 38, 75, "female", "L2RaidBoss", 40, 198851.792985, 1507.8, 85.635452, 3, 60, 57, 73, 76, 70, 80, 2329614, 373311, 5343.97939, 957.73869, 876.21289, 467.22, 253, 4, 333, 3939, 0, 0, 80, 170, 0, 1), 
(25547, 25547, "Rhianna's Escort", 0, "", 0, "LineageMonster.binding", 12, 21, 74, "male", "L2Monster", 40, 26321.9636, 4425, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2321.44794, 314.65987, 528.41601, 230.25444, 253, 4, 333, 0, 0, 0, 10, 170, 0, 1), 
(25548, 25548, "Rhianna's Healer", 0, "", 0, "LineageMonster.liviona", 15, 28, 74, "male", "L2Monster", 40, 26321.9636, 4425, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2321.44794, 314.65987, 528.41601, 230.25444, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), 
(25549, 25549, "Tesla the Deceiver", 0, "Forsaken Prisoner", 0, "LineageMonster.virud_lizardman_shaman", 10, 29, 75, "male", "L2RaidBoss", 40, 198851.792985, 1507.8, 85.635452, 3, 60, 57, 73, 76, 70, 80, 2329614, 373311, 5343.97939, 957.73869, 876.21289, 467.22, 253, 4, 333, 7, 0, 0, 43, 170, 0, 1), 
(25550, 25550, "Tesla's Apprentice", 0, "", 0, "LineageMonster.zenta_lizardman_warrior", 13, 35, 74, "male", "L2Monster", 40, 26321.9636, 4425, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2321.44794, 314.65987, 528.41601, 230.25444, 253, 4, 333, 291, 0, 0, 40, 170, 0, 1), 
(25551, 25551, "Tesla's Herald", 0, "", 0, "LineageMonster.virud_lizardman_warrior", 12, 30, 74, "male", "L2Monster", 40, 26321.9636, 4425, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2321.44794, 314.65987, 528.41601, 230.25444, 253, 4, 333, 16, 0, 0, 52, 170, 0, 1), 
(25552, 25552, "Soul Hunter Chakundel", 0, "Forsaken Prisoner", 0, "LineageMonster3.Death_Blader_Raid", 15, 32.5, 76, "male", "L2RaidBoss", 40, 402092.518544, 1540.8, 172.748302, 3, 60, 57, 73, 76, 70, 80, 2383519, 369370, 5484.05623, 971.35365, 896.94605, 473.86, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(25553, 25553, "Durango the Crusher", 0, "Forsaken Prisoner", 0, "LineageMonster3.Steel_Trapper", 35, 46.38, 77, "male", "L2RaidBoss", 40, 406426.733925, 1574, 174.258964, 3, 60, 57, 73, 76, 70, 80, 2441393, 374864, 6058.73911, 984.81219, 925.85379, 480.42, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(25554, 25554, "Brutus the Obstinate", 0, "Forsaken Prisoner", 0, "LineageMonster.kaim_vanul", 24, 40, 78, "male", "L2RaidBoss", 40, 205362.145099, 1607.4, 87.9041, 3, 60, 57, 73, 76, 70, 80, 2504378, 380180, 7149.40064, 998.10183, 941.25731, 486.92, 253, 4, 333, 0, 0, 0, 37, 170, 0, 1), 
(25555, 25555, "Brutus' Right Hand", 0, "", 0, "LineageMonster.death_blader", 15, 45, 77, "male", "L2Monster", 40, 28567.687256, 4722, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2569.32168, 328.27073, 584.83789, 240.21427, 253, 4, 333, 1472, 0, 0, 100, 170, 0, 1), 
(25556, 25556, "Brutus' Left Hand", 0, "", 0, "LineageMonster.death_knight", 12, 31, 77, "male", "L2Monster", 40, 28567.687256, 4722, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2569.32168, 328.27073, 584.83789, 240.21427, 253, 4, 333, 142, 0, 0, 27, 170, 0, 1), 
(25557, 25557, "Ranger Karankawa", 0, "Forsaken Prisoner", 0, "LineageMonster3.Jungle_Bleeze", 60, 47, 79, "female", "L2RaidBoss", 40, 207500.502975, 1641, 88.699884, 3, 60, 57, 73, 76, 70, 80, 2571289, 385228, 7315.33208, 1011.21024, 960.30752, 493.3, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(25558, 25558, "Karankawa's Root", 0, "", 0, "LineageMonster.mandragora_a", 15, 26, 78, "female", "L2Monster", 40, 29743.56864, 4822.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2671.50258, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), 
(25559, 25559, "Karankawa's Blossom", 0, "", 0, "LineageMonster.mandragora_b", 12, 25.5, 78, "female", "L2Monster", 40, 29743.56864, 4822.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2671.50258, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), 
(25560, 25560, "Sargon the Mad", 0, "Forsaken Prisoner", 0, "LineageMonster.heltor_silenos_50_bi", 19, 43.5, 79, "male", "L2RaidBoss", 40, 207500.502975, 1641, 88.699884, 3, 60, 57, 73, 76, 70, 80, 2571289, 385228, 7315.33208, 1011.21024, 960.30752, 493.3, 253, 4, 333, 135, 0, 0, 34, 170, 0, 1), 
(25561, 25561, "Sargon Attendant", 0, "", 0, "LineageMonster.heltor_silenos_shaman", 13, 32, 78, "male", "L2Monster", 40, 29743.56864, 4822.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2671.50258, 332.70061, 608.09666, 243.45587, 253, 4, 333, 200, 0, 0, 29, 170, 0, 1), 
(25562, 25562, "Sargon's Squire", 0, "", 0, "LineageMonster.heltor_silenos_warrior", 13, 31, 78, "male", "L2Monster", 40, 29743.56864, 4822.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2671.50258, 332.70061, 608.09666, 243.45587, 253, 4, 333, 228, 0, 0, 36, 170, 0, 1), 
(25563, 25563, "Beautiful Atrielle", 0, "Forsaken Prisoner", 0, "LineageMonster.succubus_100_bi", 20, 75, 81, "female", "L2RaidBoss", 40, 211731.614773, 1708.8, 90.413177, 3, 60, 57, 73, 76, 70, 80, 2730279, 394141, 7561.96024, 1036.83381, 984.65036, 505.8, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(25564, 25564, "Atrielle's Follower", 0, "", 0, "LineageMonster.bloody_queen", 14, 40, 80, "female", "L2Monster", 40, 32901.130688, 5024.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2911.61265, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), 
(25565, 25565, "Atrielle's Minion", 0, "", 0, "LineageMonster.silhouette", 8, 23, 80, "female", "L2Monster", 40, 32901.130688, 5024.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2911.61265, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), 
(25566, 25566, "Nagen the Tomboy", 0, "Forsaken Prisoner", 0, "LineageMonster.pixy_bi", 10, 54, 82, "female", "L2RaidBoss", 40, 213848.930921, 1743, 91.317308, 3, 60, 57, 73, 76, 70, 80, 2819565, 398177, 7648.5874, 1049.32431, 1012.26341, 511.9, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), 
(25567, 25567, "Nagen's Cohort", 0, "", 0, "LineageMonster.dryad", 9, 20, 81, "female", "L2Monster", 40, 34617.725322, 5126.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 3036.96805, 345.61127, 691.28516, 252.90333, 253, 4, 333, 0, 0, 0, 40, 170, 0, 1), 
(25568, 25568, "Nagen's Friend", 0, "", 0, "LineageMonster.dryad", 9, 20, 81, "female", "L2Monster", 40, 34617.725322, 5126.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 3036.96805, 345.61127, 691.28516, 252.90333, 253, 4, 333, 0, 0, 0, 40, 170, 0, 1), 
(25569, 25569, "Jax the Destroyer", 0, "Forsaken Prisoner", 0, "LineageMonster2.ketra_orc_chieftain_20_bi", 17, 46.2, 82, "male", "L2RaidBoss", 40, 213848.930921, 1743, 91.317308, 3, 60, 57, 73, 76, 70, 80, 2819565, 398177, 7648.5874, 1049.32431, 1012.26341, 511.9, 253, 4, 333, 6719, 0, 0, 24, 170, 0, 1), 
(25570, 25570, "Jax's Vanguard", 0, "", 0, "LineageMonster.ketra_orc_archer", 12, 27, 81, "male", "L2Monster", 1100, 34617.725322, 5126.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 3036.96805, 345.61127, 691.28516, 252.90333, 253, 8, 333, 279, 0, 0, 45, 170, 0, 1), 
(25571, 25571, "Jax's Raider", 0, "", 0, "LineageMonster.ketra_orc", 12, 29, 81, "male", "L2Monster", 40, 34617.725322, 5126.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 3036.96805, 345.61127, 691.28516, 252.90333, 253, 4, 333, 68, 0, 0, 45, 170, 0, 1), 
(25572, 25572, "Hager the Outlaw", 0, "Forsaken Inmate", 0, "LineageMonster.oel_mahum_witch_doctor_50_bi", 22.5, 54, 72, "male", "L2RaidBoss", 40, 192008.832471, 1410, 83.455908, 3, 60, 57, 73, 76, 70, 80, 2192267, 353878, 4529.55926, 916.07841, 815.68988, 446.9, 253, 4, 333, 201, 0, 0, 70, 170, 0, 1), 
(25573, 25573, "Hager's Henchman", 0, "", 0, "LineageMonster.oel_mahum_witch_doctor", 15, 34, 71, "male", "L2Monster", 40, 24927.27, 4133.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2130.6555, 300.65359, 484.98717, 220.00525, 253, 4, 333, 9, 0, 0, 70, 170, 0, 1), 
(25574, 25574, "Hager's Bodyguard", 0, "", 0, "LineageMonster.oel_mahum_warrior", 20, 38, 71, "male", "L2Monster", 40, 24927.27, 4133.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2130.6555, 300.65359, 484.98717, 220.00525, 253, 4, 333, 79, 0, 0, 70, 170, 0, 1), 
(25575, 25575, "All-Seeing Rango", 0, "Forsaken Inmate", 0, "LineageMonster3.Kernon_Raid", 42, 45, 73, "male", "L2RaidBoss", 40, 194342.366232, 1442.4, 84.185615, 3, 60, 57, 73, 76, 70, 80, 2234730, 360602, 4658.99941, 930.08877, 838.41114, 453.74, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(25576, 25576, "Rango's Iris", 0, "", 0, "LineageMonster.monster_eye", 21, 43, 72, "male", "L2Monster", 40, 25401.5331, 4230, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2194.57518, 305.35947, 499.53679, 223.44881, 253, 4, 333, 0, 0, 0, 90, 170, 0, 1), 
(25577, 25577, "Rango's Lens", 0, "", 0, "LineageMonster.field_stalker", 15, 30, 72, "male", "L2Monster", 40, 25401.5331, 4230, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2194.57518, 305.35947, 499.53679, 223.44881, 253, 4, 333, 0, 0, 0, 70, 170, 0, 1), 
(25578, 25578, "Jakard", 0, "Forsaken Inmate", 0, "LineageMonster.hunter_gargoyle_50_bi", 37, 98, 73, "male", "L2RaidBoss", 40, 388684.732465, 1442.4, 168.37123, 3, 60, 57, 73, 76, 70, 80, 2234730, 360602, 4658.99941, 930.08877, 838.41114, 453.74, 253, 4, 333, 0, 0, 0, 100, 170, 0, 1), 
(25579, 25579, "Helsing", 0, "Forsaken Inmate", 0, "LineageMonster3.lidia_von_helmann_120p", 14, 31, 74, "female", "L2RaidBoss", 40, 196619.812149, 1475, 84.909917, 3, 60, 57, 73, 76, 70, 80, 2280801, 367102, 5200.7438, 943.97961, 857.53707, 460.5, 253, 4, 333, 0, 0, 0, 20, 170, 0, 1), 
(25580, 25580, "Helsing's Guard", 0, "", 0, "LineageMonster.death_knight", 12, 31, 73, "male", "L2Monster", 40, 25866.6898, 4327.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2258.21784, 310.02959, 514.02335, 226.8662, 253, 4, 333, 142, 0, 0, 27, 170, 0, 1), 
(25581, 25581, "Helsing's Assassin", 0, "", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 73, "male", "L2Monster", 40, 25866.6898, 4327.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2258.21784, 310.02959, 514.02335, 226.8662, 253, 4, 333, 229, 0, 0, 80, 170, 0, 1), 
(25582, 25582, "Gillien", 0, "Forsaken Inmate", 0, "LineageMonster2.vampire_warrior", 9, 31.5, 75, "male", "L2RaidBoss", 40, 198851.792985, 1507.8, 85.635452, 3, 60, 57, 73, 76, 70, 80, 2329614, 373311, 5343.97939, 957.73869, 876.21289, 467.22, 253, 4, 333, 6723, 0, 0, 43, 170, 0, 1), 
(25583, 25583, "Gillien's Daughter", 0, "", 0, "LineageMonster2.vampire_wizard", 5.5, 28, 74, "female", "L2Monster", 40, 26321.9636, 4425, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2321.44794, 314.65987, 528.41601, 230.25444, 253, 4, 333, 99, 0, 0, 46, 170, 0, 1), 
(25584, 25584, "Gillien's Attendant", 0, "", 0, "LineageMonster2.black_magician", 8, 30, 74, "male", "L2Monster", 40, 26321.9636, 4425, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2321.44794, 314.65987, 528.41601, 230.25444, 253, 4, 333, 178, 0, 0, 19, 170, 0, 1), 
(25585, 25585, "Medici", 0, "Forsaken Inmate", 0, "LineageMonster.medusa_100_bi", 20, 53, 76, "female", "L2RaidBoss", 40, 201046.259272, 1540.8, 86.374151, 3, 60, 57, 73, 76, 70, 80, 2383519, 369370, 5484.05623, 971.35365, 896.94605, 473.86, 253, 4, 333, 0, 0, 0, 50, 170, 0, 1), 
(25586, 25586, "Medici's Sister", 0, "", 0, "LineageMonster2.lilim_wizard", 9, 34, 75, "female", "L2Monster", 40, 26766.5854, 4523.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2384.12703, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 170, 0, 1), 
(25587, 25587, "Medici's Brother", 0, "", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 75, "male", "L2Monster", 40, 26766.5854, 4523.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2384.12703, 319.24623, 542.68324, 233.61053, 253, 4, 333, 229, 0, 0, 80, 170, 0, 1), 
(25588, 25588, "Immortal Muus", 0, "Forsaken Inmate", 0, "LineageMonster.headless_knight_50_bi", 30, 46.5, 77, "male", "L2RaidBoss", 40, 406426.733925, 1574, 174.258964, 3, 60, 57, 73, 76, 70, 80, 2441393, 374864, 6058.73911, 984.81219, 925.85379, 480.42, 253, 4, 333, 2500, 0, 0, 70, 170, 0, 1), 
(25589, 25589, "Brand the Exile", 0, "Forsaken Inmate", 0, "LineageMonster.heltor_silenos_shaman_50_bi", 19.5, 51, 78, "male", "L2RaidBoss", 40, 205362.145099, 1607.4, 87.9041, 3, 60, 57, 73, 76, 70, 80, 2504378, 380180, 7149.40064, 998.10183, 941.25731, 486.92, 253, 4, 333, 5131, 0, 0, 29, 170, 0, 1), 
(25590, 25590, "Brand's Chamberlain", 0, "", 0, "LineageMonster.heltor_silenos_warrior", 13, 31, 77, "male", "L2Monster", 40, 28567.687256, 4722, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2569.32168, 328.27073, 584.83789, 240.21427, 253, 4, 333, 162, 0, 0, 36, 170, 0, 1), 
(25591, 25591, "Brand's Servant", 0, "", 0, "LineageMonster.heltor_silenos_shaman", 13, 32, 77, "male", "L2Monster", 40, 28567.687256, 4722, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2569.32168, 328.27073, 584.83789, 240.21427, 253, 4, 333, 200, 0, 0, 29, 170, 0, 1), 
(25592, 25592, "Commander Koenig", 0, "Forsaken Inmate", 0, "LineageMonster2.ketra_warbeast", 20, 33.5, 79, "male", "L2RaidBoss", 40, 415001.00595, 1641, 177.399768, 3, 60, 57, 73, 76, 70, 80, 2571289, 385228, 7315.33208, 1011.21024, 960.30752, 493.3, 253, 4, 333, 0, 0, 0, 26, 170, 0, 1), 
(25593, 25593, "Gerg the Hunter", 0, "Forsaken Inmate", 0, "LineageMonster3.Elder_Troll", 46, 71.5, 80, "male", "L2RaidBoss", 40, 209635.262152, 1674.8, 89.517997, 3, 60, 57, 73, 76, 70, 80, 2643173, 390090, 7476.50801, 1024.125, 974.82622, 499.6, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(25594, 25594, "Gerg's Follower", 0, "", 0, "LineageMonster.virud_lizardman_scout", 10, 22, 79, "male", "L2Monster", 1100, 31278.245933, 4923, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2789.79244, 337.07008, 635.0222, 246.65326, 253, 8, 333, 2507, 0, 0, 43, 170, 0, 1), 
(25595, 25595, "Gerg's Henchman", 0, "", 0, "LineageMonster.batur_orc", 9, 21.5, 79, "male", "L2Monster", 40, 31278.245933, 4923, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2789.79244, 337.07008, 635.0222, 246.65326, 253, 4, 333, 74, 0, 0, 80, 170, 0, 1), 
(25596, 25596, "Ocular Servitor", 0, "", 0, "LineageMonster2.parasitic_eye_20_sm", 20, 50.5, 82, "male", "L2Monster", 40, 4656.720016, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1317.4781, 380.15949, 925.97281, 278.18421, 253, 4, 333, 0, 0, 0, 30, 160, 0, 1), 
(25597, 25597, "Heurel", 0, "", 0, "LineageMonster2.erinyes", 21, 50, 82, "male", "L2Monster", 40, 4656.720016, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1317.4781, 380.15949, 925.97281, 278.18421, 253, 4, 333, 0, 0, 0, 31, 1, 0, 1), 
(25598, 25598, "Gegei", 0, "", 0, "LineageMonster3.Elder_Troll", 46, 71.5, 82, "male", "L2Monster", 40, 4656.720016, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1317.4781, 380.15949, 925.97281, 278.18421, 253, 1, 333, 0, 0, 0, 60, 1, 0, 1), 
(25599, 25599, "Iglas", 0, "", 0, "LineageMonster2.magmagoil_lad_20_sm", 12, 60, 82, "male", "L2Monster", 40, 4656.720016, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1317.4781, 380.15949, 925.97281, 278.18421, 253, 1, 333, 0, 0, 0, 1, 1, 0, 1), 
(25600, 25600, "Temenir", 0, "Darion's Challenger", 0, "LineageMonster4.behamah", 25, 37.5, 82, "male", "L2Monster", 80, 254046.904194, 1917, 55.059369, 3, 40, 43, 30, 21, 20, 20, 1404180, 488611, 5869.75912, 1520.63794, 4125.48586, 834.55263, 253, 4, 333, 10277, 0, 0, 68, 180, 0, 1), 
(25601, 25601, "Draksius", 0, "Darion's Challenger", 0, "LineageMonster2.ahrimanes_20_sm", 13, 47.2, 82, "male", "L2Monster", 80, 270971.339441, 1917, 44.04554, 3, 40, 43, 30, 21, 20, 20, 1463241, 575349, 5282.78321, 1900.79743, 3712.93728, 1390.92105, 253, 4, 333, 6722, 0, 0, 35, 185, 0, 1), 
(25602, 25602, "Kiretcenah", 0, "Darion's Challenger", 0, "LineageMonster.rakul", 30, 39, 82, "male", "L2Monster", 40, 254046.904194, 1917, 55.059369, 3, 40, 43, 30, 21, 20, 20, 1384493, 459564, 5869.75912, 760.31897, 4125.48586, 1112.73684, 253, 4, 333, 9442, 0, 0, 60, 150, 0, 1), 
(25603, 25603, "Darion", 0, "", 0, "LineageMonster4.darion", 50, 81.22, 84, "male", "L2RaidBoss", 80, 970000, 1917, 100, 3, 60, 57, 73, 76, 70, 80, 4712138, 598881, 3152.92775, 1127.29373, 1289.68198, 549.93387, 253, 4, 333, 0, 10548, 0, 44, 220, 0, 1), 
(25604, 25604, "Mutated Elpy", 0, "Naia's Creature", 0, "LineageMonster.elpy", 5, 4.5, 50, "male", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 305.54906, 200.23844, 208.6504, 146.5258, 253, 4, 333, 0, 0, 0, 50, 80, 0, 1), 
(25605, 25605, "Naia Spore", 0, "", 0, "LineageMonster4.guard_naia_b1t", 17, 9, 82, "male", "L2Monster", 40, 18605.933756, 1846.8, 187.410041, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2202.47572, 589.01648, 1825.40228, 646.52505, 253, 4, 333, 0, 0, 0, 40, 80, 0, 1), 
(25606, 25606, "Naia Spore", 0, "", 0, "LineageMonster4.guard_naia_b2t", 12, 27, 82, "female", "L2Monster", 40, 18605.933756, 1846.8, 187.410041, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2202.47572, 589.01648, 1825.40228, 646.52505, 253, 4, 333, 0, 0, 0, 40, 80, 0, 1), 
(25607, 25607, "Naia Spore", 0, "", 0, "LineageMonster4.guard_naia_b3t", 11, 35, 82, "female", "L2Monster", 40, 18605.933756, 1846.8, 187.410041, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2202.47572, 589.01648, 1825.40228, 646.52505, 253, 1, 333, 0, 0, 0, 40, 80, 0, 1), 
(25608, 25608, "Naia Spore", 0, "", 0, "LineageMonster4.guard_naia_b4t", 20, 31, 82, "male", "L2Monster", 40, 18605.933756, 1846.8, 187.410041, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2202.47572, 589.01648, 1825.40228, 646.52505, 253, 1, 333, 0, 0, 0, 23, 80, 0, 1), 
(25609, 25609, "Epidos", 0, "Naia Shambler", 0, "LineageMonster4.guard_naia_c", 60, 99.5, 82, "male", "L2RaidBoss", 40, 986096.671976, 1917, 287.940361, 3, 60, 57, 73, 76, 70, 80, 13455636, 2851570, 5799.7974, 1140.47846, 4805.40043, 834.54877, 253, 4, 333, 0, 0, 0, 100, 100, 0, 1), 
(25610, 25610, "Epidos", 0, "Naia Shambler", 0, "LineageMonster4.guard_naia_c", 60, 99.5, 82, "male", "L2RaidBoss", 40, 986096.671976, 1917, 287.940361, 3, 60, 57, 73, 76, 70, 80, 13455636, 2851570, 5799.7974, 1140.47846, 4805.40043, 834.54877, 253, 4, 333, 0, 0, 0, 100, 100, 0, 1), 
(25611, 25611, "Epidos", 0, "Naia Shambler", 0, "LineageMonster4.guard_naia_c", 60, 99.5, 82, "male", "L2RaidBoss", 40, 986096.671976, 1917, 287.940361, 3, 60, 57, 73, 76, 70, 80, 13455636, 2851570, 5799.7974, 1140.47846, 4805.40043, 834.54877, 253, 4, 333, 0, 0, 0, 100, 100, 0, 1), 
(25612, 25612, "Epidos", 0, "Naia Shambler", 0, "LineageMonster4.guard_naia_c", 60, 99.5, 82, "male", "L2RaidBoss", 40, 986096.671976, 1917, 287.940361, 3, 60, 57, 73, 76, 70, 80, 13455636, 2851570, 5799.7974, 1140.47846, 4805.40043, 834.54877, 253, 4, 333, 0, 0, 0, 100, 100, 0, 1), 
(25613, 25613, "Naia Spore", 0, "", 0, "LineageMonster4.guard_naia_a", 8.5, 25, 83, "male", "L2Monster", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1202.69669, 365.99498, 830.83577, 267.81924, 253, 4, 333, 0, 0, 0, 40, 80, 0, 1), 
(25614, 25614, "Floating Ghost", 0, "", 0, "LineageMonster4.roaming_Msoul", 6, 26, 82, "male", "L2Monster", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1209.73001, 368.1353, 840.58156, 269.38544, 253, 4, 333, 0, 0, 0, 50, 50, 0, 1), 
(25615, 25615, "Floating Ghost", 0, "", 0, "LineageMonster4.roaming_Fsoul", 8, 25.5, 82, "female", "L2Monster", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1209.73001, 368.1353, 840.58156, 269.38544, 253, 4, 333, 0, 0, 0, 50, 50, 0, 1), 
(25616, 25616, "Lost Warden", 0, "", 0, "LineageMonster.oel_mahum_witch_doctor", 15, 34, 29, "male", "L2RaidBoss", 40, 42937.455937, 315.12, 24.14766, 1.5, 60, 57, 73, 76, 70, 80, 821000, 36456, 216.99966, 345.01794, 148.18263, 168.32, 253, 1, 333, 201, 0, 0, 70, 130, 0, 1), 
(25617, 25617, "Lost Warden", 0, "", 0, "LineageMonster.zenta_lizardman_matriarch", 20, 40, 39, "male", "L2RaidBoss", 40, 68563.427801, 463.32, 35.31069, 1.8, 60, 57, 73, 76, 70, 80, 695958, 60594, 457.58962, 457.40256, 312.47438, 223.14, 253, 8, 333, 221, 0, 0, 53, 140, 0, 1), 
(25618, 25618, "Lost Warden", 0, "", 0, "LineageMonster.gargoyle_bi", 16, 65, 49, "male", "L2RaidBoss", 40, 109735.575864, 720, 52.816637, 2.1, 60, 57, 73, 76, 70, 80, 814824, 99743, 897.18175, 586.98906, 612.65881, 286.36, 253, 4, 333, 0, 0, 0, 140, 140, 0, 1), 
(25619, 25619, "Lost Warden", 0, "", 0, "LineageMonster.death_knight_120p", 22, 35.3, 59, "male", "L2RaidBoss", 40, 154029.954706, 1007, 70.19916, 2.4, 60, 57, 73, 76, 70, 80, 939496, 133511, 1574.55775, 728.44779, 1075.21883, 355.36, 253, 4, 333, 75, 0, 0, 33, 110, 0, 1), 
(25620, 25620, "Lost Warden", 0, "", 0, "LineageMonster2.eligor", 21, 35, 69, "male", "L2RaidBoss", 40, 186877.922094, 1314, 81.163578, 2.7, 60, 57, 73, 76, 70, 80, 1039378, 166225, 2385.12111, 873.45189, 1628.72854, 426.1, 253, 1, 333, 0, 0, 0, 35, 170, 0, 1), 
(25621, 25621, "Lost Warden", 0, "", 0, "LineageMonster3.apostle_grail", 13, 47, 78, "male", "L2RaidBoss", 80, 207939.679772, 1607.4, 87.908551, 3, 60, 57, 73, 76, 70, 80, 1252189, 190090, 2987.18479, 998.10183, 2039.86001, 486.92, 253, 4, 333, 8221, 0, 0, 30, 200, 0, 1), 
(25622, 25622, "Lost Warden", 0, "", 0, "LineageMonster.death_lord", 21, 40, 81, "male", "L2RaidBoss", 40, 214389.061424, 1708.8, 90.417739, 3, 60, 57, 73, 76, 70, 80, 1365139, 197071, 3111.31464, 1036.83381, 2124.62458, 505.8, 253, 4, 333, 78, 0, 0, 40, 160, 0, 1), 
(25623, 25623, "Valdstone", 0, "Master Rider", 0, "LineageMonster4.master_rider", 123, 90, 80, "male", "L2FlyRaidBoss", 40, 309907.557189, 1674.8, 33.247594, 3, 60, 57, 73, 76, 70, 80, 3539613, 991696, 594.2432, 921.7125, 115.33564, 449.64, 253, 4, 333, 0, 0, 0, 60, 300, 0, 1), 
(25624, 25624, "Rok", 0, "King of Birds", 0, "LineageMonster4.loc", 197, 130.5, 80, "female", "L2FlyRaidBoss", 40, 319298.06608, 1777.4, 34.25503, 3, 60, 57, 73, 76, 70, 80, 3658390, 1026322, 623.11769, 972.38611, 125.47423, 474.36582, 253, 4, 333, 0, 0, 0, 60, 300, 0, 1), 
(25625, 25625, "Enira", 0, "Banshee Queen", 0, "LineageMonster4.banshee_queen", 11, 33.5, 80, "female", "L2FlyRaidBoss", 40, 325715.957208, 1846.8, 34.943556, 3, 60, 57, 73, 76, 70, 80, 3745533, 1082907, 643.03355, 1005.72821, 132.11642, 490.63058, 253, 4, 333, 0, 0, 0, 60, 300, 0, 1), 
(25626, 25626, "Dius", 0, "Deadman of Destruction", 0, "LineageMonster4.mutant_drake_wing", 112, 60, 80, "male", "L2FlyRaidBoss", 40, 325715.957208, 1846.8, 34.943556, 3, 40, 43, 30, 21, 20, 20, 3745533, 1082907, 643.03355, 1005.72821, 132.11642, 490.63058, 253, 4, 333, 0, 0, 0, 60, 300, 0, 1), 
(25627, 25627, "Mutant Bird", 0, "Subordinate of King", 0, "LineageMonster4.mutant_hawk", 100, 85, 75, "male", "L2Monster", 40, 57629.963205, 1507.8, 7.788673, 3, 40, 43, 30, 21, 20, 20, 0, 0, 428.97877, 430.98241, 102.53447, 420.498, 253, 4, 333, 0, 0, 0, 60, 300, 0, 1), 
(25628, 25628, "Dra Hawk", 0, "Subordinate of King", 0, "LineageMonster4.drahawk", 110, 35, 76, "female", "L2Monster", 40, 58591.547194, 1540.8, 7.901152, 3, 40, 43, 30, 21, 20, 20, 0, 0, 439.90277, 437.10914, 105.29263, 426.474, 253, 4, 333, 0, 0, 0, 60, 300, 0, 1), 
(25629, 25629, "Floating Skull", 0, "Enira's Evil Spirit", 0, "LineageMonster4.floating_skeleton", 28, 39, 78, "male", "L2FlyMonster", 40, 60370.975082, 1607.4, 8.113642, 3, 40, 43, 30, 21, 20, 20, 0, 0, 459.1994, 449.14582, 111.02336, 438.228, 253, 4, 333, 0, 0, 0, 45, 300, 0, 1), 
(25630, 25630, "Floating Zombie", 0, "Enira's Evil Spirit", 0, "LineageMonster4.floating_zombie", 70, 50, 77, "female", "L2FlyMonster", 40, 59504.155644, 1574, 8.009359, 3, 40, 43, 30, 21, 20, 20, 0, 0, 449.96347, 443.16549, 108.97199, 432.378, 253, 4, 333, 0, 0, 0, 60, 300, 0, 1), 
(25631, 25631, "Drake Wing", 0, "Underling of Destruction", 0, "LineageMonster4.m_drake_wing_knave", 153, 63, 77, "male", "L2Monster", 40, 59504.155644, 1574, 8.009359, 3, 40, 43, 30, 21, 20, 20, 0, 0, 449.96347, 443.16549, 108.97199, 432.378, 253, 4, 333, 0, 0, 0, 60, 300, 0, 1), 
(25632, 25632, "Drak", 0, "Underling of Destruction", 0, "LineageMonster4.drac", 100, 40, 78, "female", "L2Monster", 40, 60370.975082, 1607.4, 8.113642, 3, 40, 43, 30, 21, 20, 20, 0, 0, 459.1994, 449.14582, 111.02336, 438.228, 253, 4, 333, 0, 0, 0, 60, 300, 0, 1), 
(25633, 25633, "Elite Rider", 0, "Valdstone's Elites", 0, "LineageMonster4.master_rider", 123, 90, 76, "male", "L2FlyMonster", 40, 58591.547194, 1540.8, 7.901152, 3, 40, 43, 30, 21, 20, 20, 0, 0, 439.90277, 437.10914, 105.29263, 426.474, 253, 4, 333, 0, 0, 0, 60, 300, 0, 1), 
(25634, 25634, "Cohemenes", 0, "Soul Collector", 0, "LineageMonster4.lich_A_132p", 31.68, 60.72, 81, "male", "L2Monster", 40, 436294.588865, 1812, 186.305573, 3, 60, 57, 73, 76, 70, 80, 3004658, 406483, 1816.91541, 1092.5476, 1073.23051, 532.98247, 253, 4, 333, 0, 0, 0, 46, 200, 0, 1), 
(25635, 25635, "Argekunte", 0, "Vacuous Soul", 0, "LineageMonster4.Death_slayer_120p", 24, 40.8, 81, "male", "L2Monster", 40, 436294.588865, 1812, 186.305573, 3, 60, 57, 73, 76, 70, 80, 3004658, 406483, 1816.91541, 1092.5476, 1073.23051, 532.98247, 253, 4, 333, 13985, 13986, 0, 80, 200, 0, 1), 
(25636, 25636, "Ravenous Soul Devourer", 0, "", 0, "LineageMonster4.soul_wagon_130p", 70, 44.2, 81, "male", "L2Monster", 40, 440657.534754, 1846.8, 188.168628, 3, 60, 57, 73, 76, 70, 80, 3100452, 410692, 1845.69199, 1110.90241, 1103.56024, 541.93835, 253, 4, 333, 0, 0, 0, 110, 200, 0, 1), 
(25637, 25637, "Karpencharr", 0, "Prophet of Lies", 0, "LineageMonster4.lich_A_132p", 31.68, 60.72, 81, "male", "L2Monster", 40, 440657.534754, 1846.8, 188.168628, 3, 60, 57, 73, 76, 70, 80, 3100452, 410692, 1845.69199, 1110.90241, 1103.56024, 541.93835, 253, 4, 333, 0, 0, 0, 46, 200, 0, 1), 
(25638, 25638, "Romerohiv", 0, "Betrayer of Oblivion", 0, "LineageMonster4.lich_b_132p", 31.68, 60.72, 81, "male", "L2Monster", 40, 440657.534754, 1846.8, 188.168628, 3, 60, 57, 73, 76, 70, 80, 3100452, 410692, 1845.69199, 1110.90241, 1103.56024, 541.93835, 253, 4, 333, 0, 0, 0, 46, 200, 0, 1), 
(25639, 25639, "Hitchkarshiek", 0, "Wise Retainer of Suffering", 0, "LineageMonster4.Death_slayer_120p", 24, 40.8, 81, "male", "L2Monster", 40, 440657.534754, 1846.8, 188.168628, 3, 60, 57, 73, 76, 70, 80, 3100452, 410692, 1845.69199, 1110.90241, 1103.56024, 541.93835, 253, 4, 333, 13985, 13986, 0, 80, 200, 0, 1), 
(25640, 25640, "Freedkyilla", 0, "Hand of Night", 0, "LineageMonster4.Death_slayer_120p", 24, 40.8, 81, "male", "L2Monster", 40, 440657.534754, 1846.8, 188.168628, 3, 60, 57, 73, 76, 70, 80, 3100452, 410692, 1845.69199, 1110.90241, 1103.56024, 541.93835, 253, 4, 333, 13984, 0, 0, 80, 200, 0, 1), 
(25641, 25641, "Yehan Cravenizad", 0, "Bloodsucker", 0, "LineageMonster4.death_knight_n_156p", 34.32, 62.4, 81, "male", "L2Monster", 80, 440657.534754, 1846.8, 188.168628, 3, 60, 57, 73, 76, 70, 80, 3100452, 410692, 1845.69199, 1110.90241, 1103.56024, 541.93835, 253, 4, 333, 13982, 0, 0, 73, 180, 0, 1), 
(25642, 25642, "Yehan Jaxsibhan", 0, "Dark Guardian", 0, "LineageMonster4.death_knight_n_156p", 34.32, 62.4, 81, "male", "L2Monster", 80, 440657.534754, 1846.8, 188.168628, 3, 60, 57, 73, 76, 70, 80, 3100452, 410692, 1845.69199, 1110.90241, 1103.56024, 541.93835, 253, 4, 333, 13983, 0, 0, 73, 180, 0, 1), 
(25643, 25643, "Awakened Ancient Sentry", 0, "Raid Boss", 0, "LineageMonster4.death_scout_110p", 18, 27.5, 81, "female", "L2RaidBoss", 40, 440657.534754, 1846.8, 188.168628, 3, 60, 57, 73, 76, 70, 80, 3100452, 410692, 1845.69199, 1110.90241, 1103.56024, 541.93835, 253, 4, 333, 0, 0, 0, 45, 160, 0, 1), 
(25644, 25644, "Awakened Ancient Severer", 0, "Raid Boss", 0, "LineageMonster4.bonecreeper_120p", 51.6, 57, 81, "male", "L2RaidBoss", 40, 440657.534754, 1846.8, 188.168628, 3, 60, 57, 73, 76, 70, 80, 3100452, 410692, 1845.69199, 1110.90241, 1103.56024, 541.93835, 253, 4, 333, 0, 0, 0, 60, 200, 0, 1), 
(25645, 25645, "Awakened Ancient Soul Extractor", 0, "Raid Boss", 0, "LineageMonster4.soul_harvester_120p", 27.6, 37.2, 81, "male", "L2RaidBoss", 40, 440657.534754, 1846.8, 188.168628, 3, 60, 57, 73, 76, 70, 80, 3100452, 410692, 1845.69199, 1110.90241, 1103.56024, 541.93835, 253, 4, 333, 0, 0, 0, 46, 200, 0, 1), 
(25646, 25646, "Awakened Ancient Soul Devourer", 0, "Raid Boss", 0, "LineageMonster4.soul_wagon_130p", 70, 44.2, 81, "male", "L2RaidBoss", 40, 440657.534754, 1846.8, 188.168628, 3, 60, 57, 73, 76, 70, 80, 3100452, 410692, 1845.69199, 1110.90241, 1103.56024, 541.93835, 253, 4, 333, 0, 0, 0, 110, 200, 0, 1), 
(25647, 25647, "Awakened Ancient Fighter", 0, "Raid Boss", 0, "LineageMonster4.death_knight_n_156p", 34.32, 62.4, 81, "male", "L2RaidBoss", 80, 440657.534754, 1846.8, 188.168628, 3, 60, 57, 73, 76, 70, 80, 3100452, 410692, 1845.69199, 1110.90241, 1103.56024, 541.93835, 253, 4, 333, 13982, 0, 0, 73, 180, 0, 1), 
(25648, 25648, "Awakened Ancient Fighter", 0, "Raid Boss", 0, "LineageMonster4.death_knight_n_156p", 34.32, 62.4, 81, "male", "L2RaidBoss", 80, 440657.534754, 1846.8, 188.168628, 3, 60, 57, 73, 76, 70, 80, 3100452, 410692, 1845.69199, 1110.90241, 1103.56024, 541.93835, 253, 4, 333, 13983, 0, 0, 73, 180, 0, 1), 
(25649, 25649, "Awakened Ancient Executor", 0, "Raid Boss", 0, "LineageMonster4.Death_slayer_120p", 24, 40.8, 81, "male", "L2RaidBoss", 40, 440657.534754, 1846.8, 188.168628, 3, 60, 57, 73, 76, 70, 80, 3100452, 410692, 1845.69199, 1110.90241, 1103.56024, 541.93835, 253, 4, 333, 13985, 13986, 0, 80, 200, 0, 1), 
(25650, 25650, "Awakened Ancient Executor", 0, "Raid Boss", 0, "LineageMonster4.Death_slayer_120p", 24, 40.8, 81, "male", "L2RaidBoss", 40, 440657.534754, 1846.8, 188.168628, 3, 60, 57, 73, 76, 70, 80, 3100452, 410692, 1845.69199, 1110.90241, 1103.56024, 541.93835, 253, 4, 333, 13984, 0, 0, 80, 200, 0, 1), 
(25651, 25651, "Awakened Ancient Prophet", 0, "Raid Boss", 0, "LineageMonster4.lich_A_132p", 31.68, 60.72, 81, "male", "L2RaidBoss", 40, 440657.534754, 1846.8, 188.168628, 3, 60, 57, 73, 76, 70, 80, 3100452, 410692, 1845.69199, 1110.90241, 1103.56024, 541.93835, 253, 4, 333, 0, 0, 0, 46, 200, 0, 1), 
(25652, 25652, "Awakened Ancient Prophet", 0, "Raid Boss", 0, "LineageMonster4.lich_b_132p", 31.68, 60.72, 81, "male", "L2RaidBoss", 40, 440657.534754, 1846.8, 188.168628, 3, 60, 57, 73, 76, 70, 80, 3100452, 410692, 1845.69199, 1110.90241, 1103.56024, 541.93835, 253, 4, 333, 0, 0, 0, 46, 200, 0, 1), 
(25653, 25653, "Kanadis Herald", 0, "Invading Forces", 0, "LineageMonster4.pailaka_invader", 30, 33, 81, "male", "L2RaidBoss", 80, 423463.229547, 1708.8, 180.826353, 3, 60, 57, 73, 76, 70, 80, 2730279, 394141, 1732.89962, 1036.83381, 984.65036, 505.8, 253, 4, 333, 0, 0, 0, 60, 200, 0, 1), 
(25654, 25654, "Kanadis Herald", 0, "Invading Forces", 0, "LineageMonster4.pailaka_invader", 30, 33, 83, "male", "L2RaidBoss", 40, 431974.840461, 1777.4, 184.460963, 3, 60, 57, 73, 76, 70, 80, 2911026, 402310, 1767.7309, 1061.58432, 1023.84623, 517.88, 253, 4, 333, 0, 0, 0, 60, 200, 0, 1), 
(25655, 25655, "Kanadis Herald", 0, "Invading Forces", 0, "LineageMonster4.pailaka_invader", 30, 33, 85, "male", "L2RaidBoss", 40, 440657.534754, 1846.8, 188.168628, 3, 60, 57, 73, 76, 70, 80, 3100452, 410692, 1803.26229, 1085.36442, 1053.40504, 529.48, 253, 4, 333, 0, 0, 0, 60, 200, 0, 1), 
(25656, 25656, "Kanadis Fanatic", 0, "", 0, "LineageMonster3.solina_brother", 9, 23.4, 79, "male", "L2Monster", 80, 8710.724385, 1641, 115.221222, 3, 40, 43, 30, 21, 20, 20, 0, 0, 4918.27324, 1348.28, 3539.30916, 493.3, 253, 4, 333, 152, 0, 0, 61, 220, 0, 1), 
(25657, 25657, "Kanadis Fanatic", 0, "", 0, "LineageMonster3.solina_brother", 9, 23.4, 81, "male", "L2Monster", 40, 8760.506415, 1708.8, 114.516424, 3, 40, 43, 30, 21, 20, 20, 0, 0, 5132.03993, 1382.44, 3693.19635, 505.8, 253, 1, 333, 8212, 0, 0, 61, 220, 0, 1), 
(25658, 25658, "Kanadis Fanatic", 0, "", 0, "LineageMonster3.solina_brother", 9, 23.4, 83, "male", "L2Monster", 40, 8789.78771, 1777.4, 113.563149, 3, 40, 43, 30, 21, 20, 20, 0, 0, 5437.18604, 1415.44, 3988.34952, 517.88, 253, 4, 333, 0, 0, 0, 61, 220, 0, 1), 
(25659, 25659, "Kanadis Guide", 0, "Invading Forces", 0, "LineageMonster4.pailaka_invader", 30, 33, 77, "male", "L2RaidBoss", 80, 406426.733925, 1574, 174.258964, 3, 60, 57, 73, 76, 70, 80, 2588731, 332450, 1632.09847, 984.81219, 925.85379, 480.42, 253, 4, 333, 0, 0, 0, 60, 200, 0, 1), 
(25660, 25660, "Kanadis Guide", 0, "Invading Forces", 0, "LineageMonster4.pailaka_invader", 30, 33, 80, "male", "L2RaidBoss", 40, 419270.524304, 1674.8, 179.035993, 3, 60, 57, 73, 76, 70, 80, 2706503, 353878, 1715.7422, 1024.125, 974.82622, 499.6, 253, 4, 333, 0, 0, 0, 60, 200, 0, 1), 
(25661, 25661, "Kanadis Guide", 0, "Invading Forces", 0, "LineageMonster4.pailaka_invader", 30, 33, 83, "male", "L2RaidBoss", 40, 431974.840461, 1777.4, 184.460963, 3, 60, 57, 73, 76, 70, 80, 2853104, 373311, 1767.7309, 1061.58432, 1023.84623, 517.88, 253, 4, 333, 0, 0, 0, 60, 200, 0, 1), 
(25662, 25662, "Kanadis Follower", 0, "", 0, "LineageMonster3.solina_brother", 9, 23.4, 75, "male", "L2Monster", 80, 8551.933905, 1507.8, 115.879863, 3, 40, 43, 30, 21, 20, 20, 0, 0, 4397.83627, 1277, 3117.76918, 467.22, 253, 4, 333, 152, 0, 0, 61, 220, 0, 1), 
(25663, 25663, "Kanadis Follower", 0, "", 0, "LineageMonster3.solina_brother", 9, 23.4, 78, "male", "L2Monster", 40, 8678.43869, 1607.4, 115.481553, 3, 40, 43, 30, 21, 20, 20, 0, 0, 4791.0733, 1330.8, 3435.68424, 486.92, 253, 1, 333, 8212, 0, 0, 61, 220, 0, 1), 
(25664, 25664, "Kanadis Follower", 0, "", 0, "LineageMonster3.solina_brother", 9, 23.4, 81, "male", "L2Monster", 40, 8760.506415, 1708.8, 114.516424, 3, 40, 43, 30, 21, 20, 20, 0, 0, 5132.03993, 1382.44, 3693.19635, 505.8, 253, 4, 333, 0, 0, 0, 61, 220, 0, 1), 
(25665, 25665, "Yehan Klodekus", 0, "Soul Destroyer", 0, "LineageMonster4.death_knight_n_raid", 34.32, 62.4, 81, "male", "L2RaidBoss", 80, 148936.332536, 1743, 53.219019, 3, 60, 57, 73, 76, 70, 80, 5044000, 1152586, 2153.20693, 703.66454, 1624.01433, 514.91118, 253, 4, 333, 13982, 0, 0, 73, 180, 0, 1), 
(25666, 25666, "Yehan Klanikus", 0, "Guide of Darkness", 0, "LineageMonster4.death_knight_n_raid", 34.32, 62.4, 81, "male", "L2RaidBoss", 80, 148936.332536, 1743, 53.219019, 3, 60, 57, 73, 76, 70, 80, 5044000, 1152586, 2153.20693, 703.66454, 1624.01433, 514.91118, 253, 4, 333, 13983, 0, 0, 73, 180, 0, 1), 
(25667, 25667, "Cannibalistic Stakato Chief", 0, "Shadow of Violence", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 34, 40, 82, "male", "L2RaidBoss", 40, 436294.588865, 1812, 18.630557, 3, 60, 57, 73, 76, 70, 80, 4292368, 580689, 3043.21984, 1086.15843, 1220.95193, 529.86561, 253, 4, 333, 0, 0, 0, 40, 200, 0, 1), 
(25668, 25668, "Cannibalistic Stakato Chief", 0, "Shadow of Violence", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 34, 40, 82, "male", "L2RaidBoss", 40, 436294.588865, 1812, 18.630557, 3, 60, 57, 73, 76, 70, 80, 4292368, 580689, 3043.21984, 1086.15843, 1220.95193, 529.86561, 253, 4, 333, 0, 0, 0, 40, 200, 0, 1), 
(25669, 25669, "Cannibalistic Stakato Chief", 0, "Shadow of Violence", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 34, 40, 82, "male", "L2RaidBoss", 40, 373966.790456, 1812, 18.630557, 3, 60, 57, 73, 76, 70, 80, 4292368, 580689, 3043.21984, 1086.15843, 1220.95193, 529.86561, 253, 4, 333, 0, 0, 0, 40, 200, 0, 1), 
(25670, 25670, "Cannibalistic Stakato Chief", 0, "Shadow of Violence", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 34, 40, 82, "male", "L2RaidBoss", 40, 373966.790456, 1812, 18.630557, 3, 60, 57, 73, 76, 70, 80, 4292368, 580689, 3043.21984, 1086.15843, 1220.95193, 529.86561, 253, 4, 333, 0, 0, 0, 40, 200, 0, 1), 
(25671, 25671, "Queen Shyeed", 0, "Raid Boss", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 45, 50.8, 84, "male", "L2RaidBoss", 40, 312521.536403, 1812, 96.088087, 3, 60, 57, 73, 76, 70, 80, 4292368, 580689, 1504.01905, 1073.60169, 298.22125, 523.74, 253, 4, 333, 0, 0, 0, 45, 190, 0, 1), 
(25672, 25672, "Spiked Stakato", 0, "Raid Fighter", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 13, 21, 84, "male", "L2Monster", 40, 33502.308702, 1812, 96.088087, 3, 40, 43, 30, 21, 20, 20, 0, 0, 4010.6172, 536.80085, 2120.59167, 523.74, 253, 4, 333, 123, 0, 0, 23, 190, 0, 1), 
(25673, 25673, "Spiked Stakato", 0, "Raid Fighter", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 13, 22.2, 84, "male", "L2Monster", 40, 50003.445824, 1812, 96.088087, 3, 40, 43, 30, 21, 20, 20, 0, 0, 6016.07621, 536.80085, 4771.54001, 523.74, 253, 4, 333, 0, 0, 0, 23, 190, 0, 1), 
(25674, 25674, "Gwindorr", 0, "Raid Boss", 0, "LineageMonster.serpent_slave", 17, 46, 83, "male", "L2RaidBoss", 40, 309427.263765, 1777.4, 95.13672, 3, 60, 57, 73, 76, 70, 80, 4158609, 574729, 2978.25555, 1061.58432, 294.62845, 517.88, 253, 4, 333, 129, 0, 0, 70, 190, 0, 1), 
(25675, 25675, "Guard of Gwindorr", 0, "Raid Fighter", 0, "LineageMonster.virud_lizardman_scout", 10, 22, 82, "male", "L2Monster", 1100, 32842.180867, 1743, 94.194772, 3, 40, 43, 30, 21, 20, 20, 0, 0, 3931.5922, 524.66216, 2071.34264, 511.9, 253, 8, 333, 2507, 0, 0, 43, 190, 0, 1), 
(25676, 25676, "Follower of Gwindorr", 0, "Raid Fighter", 0, "LineageMonster.virud_lizardman", 10, 23, 82, "male", "L2Monster", 40, 49018.180398, 1743, 94.194772, 3, 40, 43, 30, 21, 20, 20, 0, 0, 5897.53574, 524.66216, 4660.72484, 511.9, 253, 4, 333, 2, 0, 0, 43, 190, 0, 1), 
(25677, 25677, "Water Spirit Lian", 0, "Raid Boss", 0, "LineageMonster.pixy_bi", 10, 54, 84, "female", "L2RaidBoss", 40, 312521.536403, 1812, 96.088087, 3, 60, 57, 73, 76, 70, 80, 4292368, 580689, 3008.0381, 1073.60169, 1192.885, 523.74, 253, 4, 333, 0, 0, 0, 80, 190, 0, 1), 
(25678, 25678, "Sprite of Gildor", 0, "Raid Fighter", 0, "LineageMonster.pixy", 5, 25, 83, "female", "L2Monster", 40, 33170.602676, 1777.4, 95.13672, 3, 40, 43, 30, 21, 20, 20, 0, 0, 3970.90812, 530.79216, 2095.04396, 517.88, 253, 4, 333, 0, 0, 0, 80, 190, 0, 1), 
(25679, 25679, "Guardian of Gildor", 0, "Raid Fighter", 0, "LineageMonster.pixy", 5, 25, 83, "female", "L2Monster", 40, 49508.362202, 1777.4, 95.13672, 3, 40, 43, 30, 21, 20, 20, 0, 0, 5956.5111, 530.79216, 4714.05515, 517.88, 253, 4, 333, 0, 0, 0, 80, 190, 0, 1), 
(25680, 25680, "Giant Marpanak", 0, "Raid Boss", 0, "LineageMonster.lesser_giant_100_bi", 50, 91, 82, "male", "L2RaidBoss", 40, 855234.894272, 1743, 328.667996, 3, 60, 57, 73, 76, 70, 80, 5553283, 1249267, 5450.52438, 1049.32431, 3992.43354, 511.9, 253, 4, 333, 3937, 0, 0, 15, 180, 0, 1), 
(25681, 25681, "Gorgolos", 0, "Raid Boss", 0, "LineageMonster.hunter_gargoyle", 25, 65, 82, "male", "L2RaidBoss", 40, 306363.62749, 1743, 94.194772, 3, 60, 57, 73, 76, 70, 80, 4027950, 568824, 2948.76787, 524.66216, 2071.34264, 511.9, 253, 4, 333, 0, 0, 0, 100, 100, 0, 1), 
(25682, 25682, "Cursed Life", 0, "Raid Fighter", 0, "LineageMonster.gargoyle_bi", 16, 65, 82, "male", "L2Monster", 40, 32842.180867, 1743, 94.194772, 3, 40, 43, 30, 21, 20, 20, 0, 0, 3931.5922, 524.66216, 4660.72484, 511.9, 253, 4, 333, 0, 0, 0, 140, 140, 0, 1), 
(25683, 25683, "Cursed Soul", 0, "Raid Fighter", 0, "LineageMonster.gargoyle_bi", 16, 65, 82, "male", "L2Monster", 40, 49018.180398, 1743, 94.194772, 3, 40, 43, 30, 21, 20, 20, 0, 0, 5897.53574, 524.66216, 4660.72484, 511.9, 253, 4, 333, 0, 0, 0, 140, 140, 0, 1), 
(25684, 25684, "Last Titan Utenus", 0, "Raid Boss", 0, "LineageMonster.lesser_giant_mage_50_bi", 50, 66, 83, "male", "L2RaidBoss", 40, 309427.263765, 1777.4, 95.13672, 3, 60, 57, 73, 76, 70, 80, 4158609, 574729, 2978.25555, 1061.58432, 1178.51379, 517.88, 253, 1, 333, 3938, 0, 0, 15, 190, 0, 1), 
(25685, 25685, "Utenus's Wizard", 0, "Raid Fighter", 0, "LineageMonster.lesser_giant_100_bi", 50, 91, 82, "male", "L2Monster", 40, 32842.180867, 1743, 94.194772, 3, 40, 43, 30, 21, 20, 20, 0, 0, 3931.5922, 524.66216, 2071.34264, 511.9, 253, 4, 333, 0, 0, 0, 15, 190, 0, 1), 
(25686, 25686, "Utenus's Guard", 0, "Raid Fighter", 0, "LineageMonster.leogul", 15, 35, 82, "male", "L2Monster", 40, 49018.180398, 1743, 94.194772, 3, 40, 43, 30, 21, 20, 20, 0, 0, 5897.53574, 524.66216, 4660.72484, 511.9, 253, 4, 333, 0, 0, 0, 80, 190, 0, 1), 
(25687, 25687, "Hekaton Prime", 0, "Raid Boss", 0, "LineageMonster.susceptor", 20, 35, 83, "male", "L2RaidBoss", 40, 431893.621607, 1777.4, 132.78187, 3, 60, 57, 73, 76, 70, 80, 5614732, 1265702, 2752.51481, 1061.58432, 4038.11496, 517.88, 253, 1, 333, 0, 0, 0, 27, 170, 0, 1), 
(25688, 25688, "Hekaton Cottus", 0, "Raid Fighter", 0, "LineageMonster.gamlin", 11, 32, 83, "male", "L2Monster", 40, 46298.996236, 1777.4, 132.78187, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7339.85599, 530.79216, 7178.55696, 517.88, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), 
(25689, 25689, "Hekaton Chires", 0, "Raid Fighter", 0, "LineageMonster.lesser_giant_50_bi", 31.5, 69, 83, "male", "L2Monster", 40, 69102.979457, 1777.4, 132.78187, 3, 40, 43, 30, 21, 20, 20, 0, 0, 11010.05924, 530.79216, 16152.45982, 517.88, 253, 4, 333, 3937, 0, 0, 15, 180, 0, 1), 
(25690, 25690, "Aenkinel", 0, "Invader of Dream", 0, "LineageMonster5.leader_anakazel_low", 30, 31.5, 81, "male", "L2RaidBoss", 40, 436294.588865, 18120, 186.305573, 30, 60, 57, 73, 76, 70, 80, 3327991, 394141, 1785.40821, 1073.60169, 1036.33137, 523.74, 253, 4, 333, 0, 0, 0, 25, 150, 0, 1), 
(25691, 25691, "Aenkinel", 0, "Invader of Dream", 0, "LineageMonster5.leader_anakazel_low", 30, 31.5, 81, "male", "L2RaidBoss", 40, 436294.588865, 18120, 186.305573, 30, 60, 57, 73, 76, 70, 80, 3327991, 394141, 1785.40821, 1073.60169, 1036.33137, 523.74, 253, 4, 333, 0, 0, 0, 25, 150, 0, 1), 
(25692, 25692, "Aenkinel", 0, "Invader of Dream", 0, "LineageMonster5.leader_anakazel_low", 30, 31.5, 81, "male", "L2RaidBoss", 40, 436294.588865, 18120, 186.305573, 30, 60, 57, 73, 76, 70, 80, 3327991, 394141, 1785.40821, 1073.60169, 1036.33137, 523.74, 253, 4, 333, 0, 0, 0, 25, 150, 0, 1), 
(25693, 25693, "Aenkinel", 0, "Invader of Dream", 0, "LineageMonster5.leader_anakazel_low", 30, 31.5, 81, "male", "L2RaidBoss", 40, 436294.588865, 18120, 186.305573, 30, 60, 57, 73, 76, 70, 80, 3327991, 394141, 1785.40821, 1073.60169, 1036.33137, 523.74, 253, 4, 333, 0, 0, 0, 25, 150, 0, 1), 
(25694, 25694, "Aenkinel", 0, "Invader of Dream", 0, "LineageMonster5.leader_anakazel_mid", 14, 28, 82, "male", "L2RaidBoss", 40, 436294.588865, 18120, 186.305573, 30, 60, 57, 73, 76, 70, 80, 37775745, 1117041, 1785.40821, 1073.60169, 1036.33137, 523.74, 253, 4, 333, 0, 0, 0, 60, 160, 0, 1), 
(25695, 25695, "Aenkinel", 0, "Invader of Dream", 0, "LineageMonster5.leader_anakazel_high", 21, 40, 84, "male", "L2RaidBoss", 40, 449514.751203, 19170, 191.950818, 30, 60, 57, 73, 76, 70, 80, 42720366, 1206690, 1839.50786, 1108.0785, 1082.554, 540.56, 253, 4, 333, 0, 0, 0, 50, 140, 0, 1), 
(25696, 25696, "Taklacan", 0, "Bistakon", 0, "LineageMonster5.tarcrakahn_e", 40, 57, 85, "male", "L2RaidBoss", 40, 763865.139276, 18468, 242.62242, 300, 60, 57, 73, 76, 70, 80, 3078749, 399008, 11355.95863, 17479.90252, 1212.53791, 8527.32835, 253, 4, 333, 0, 0, 0, 40, 120, 0, 1), 
(25697, 25697, "Torumba", 0, "Reptilikon", 0, "LineageMonster5.torum_ba_e", 40, 64, 85, "male", "L2RaidBoss", 40, 6312935.035341, 18468, 242.62242, 300, 60, 57, 73, 76, 70, 80, 0, 0, 3038.11849, 1085.36442, 1212.53791, 529.48, 253, 4, 333, 0, 0, 0, 23, 120, 0, 1), 
(25698, 25698, "Dopagen", 0, "Kokracon", 0, "LineageMonster5.dorpagen_e", 45, 75, 85, "male", "L2RaidBoss", 40, 631293.503534, 18468, 242.62242, 300, 60, 57, 73, 76, 70, 80, 3233771, 403115, 11355.95863, 17479.90252, 1212.53791, 8527.32835, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(25699, 25699, "Glakias", 0, "Archery Knight Captain", 0, "LineageMonster5.ice_heavy_knight", 28, 67.5, 85, "male", "L2RaidBoss", 40, 780461.719331, 18468, 139.120531, 500, 60, 57, 73, 76, 70, 80, 0, 0, 8184.13934, 1876.12993, 2579.00134, 640.6708, 253, 4, 333, 0, 0, 0, 40, 120, 0, 1), 
(25700, 25700, "Glakias", 0, "Archery Knight Captain", 0, "LineageMonster5.ice_heavy_knight", 28, 67.5, 85, "male", "L2RaidBoss", 40, 15015056.357086, 92340, 1947.687433, 500, 60, 57, 73, 76, 70, 80, 0, 0, 21748.05311, 2063.74292, 3775.91586, 1089.14036, 253, 4, 333, 0, 0, 0, 40, 120, 0, 1), 
(25701, 25701, "Anays", 0, "Master of Splendor", 0, "LineageMonster3.solina_priest_160p", 24, 55, 84, "male", "L2RaidBoss", 40, 937564.609209, 21812, 240.220218, 500, 60, 57, 73, 76, 70, 80, 6653170, 900069, 11094.68934, 1428.96385, 1192.885, 576.114, 253, 4, 333, 8214, 0, 0, 60, 120, 0, 1), 
(25702, 25702, "Guard of the Grail", 0, "", 0, "LineageMonster.will_o_wisp", 13, 22, 84, "male", "L2Monster", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 1, 333, 0, 0, 0, 25, 140, 0, 1), 
(25703, 25703, "Gigantic Golem", 0, "Chaos", 0, "LineageMonster3.chaos_golem", 31, 51.8, 76, "male", "L2RaidBoss", 40, 402092.518544, 15408, 172.748302, 300, 60, 57, 73, 76, 70, 80, 3429147, 530149, 9037.41875, 971.35365, 896.94605, 473.86, 253, 1, 333, 0, 0, 0, 18, 190, 0, 1), 
(25704, 25704, "Gigantic Golem Subordinate", 0, "Chaos", 0, "LineageMonster3.golem_guardian", 18, 41.5, 75, "male", "L2Monster", 40, 4604.887488, 1507.8, 62.396849, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2372.40161, 1277, 907.28194, 467.22, 253, 4, 333, 0, 0, 0, 53, 200, 0, 1), 
(25705, 25705, "Gigantic Boom Golem", 0, "Chaos", 0, "LineageMonster.big_boom_e", 6, 13, 74, "male", "L2Monster", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 773.81598, 314.65987, 528.41601, 230.25444, 253, 4, 333, 0, 0, 0, 48, 160, 0, 1), 
(25706, 25706, "Lost Watcher", 0, "", 0, "LineageMonster4.ravager_silen", 27, 48.5, 83, "male", "L2Monster", 40, 56202.842001, 1777.4, 190.897046, 3, 40, 43, 30, 21, 20, 20, 0, 0, 9288.76621, 566.1783, 6343.0232, 621.45708, 253, 4, 333, 0, 0, 0, 92, 200, 0, 1), 
(25707, 25707, "Lost Watcher", 0, "", 0, "LineageMonster4.ravager_silen", 27, 48.5, 83, "male", "L2Monster", 40, 56202.842001, 1777.4, 190.897046, 3, 40, 43, 30, 21, 20, 20, 0, 0, 9288.76621, 566.1783, 6343.0232, 621.45708, 253, 4, 333, 0, 0, 0, 92, 200, 0, 1), 
(25708, 25708, "Lost Beholder", 0, "", 0, "LineageMonster4.Death_slayer_080p", 16, 27.2, 83, "male", "L2Monster", 40, 112316.374696, 1777.4, 190.745373, 3, 40, 43, 30, 21, 20, 20, 0, 0, 9063.04944, 566.1783, 6188.88791, 621.45708, 253, 4, 333, 0, 0, 0, 64, 200, 0, 1), 
(25709, 25709, "Lost Warden", 0, "", 0, "LineageMonster4.bonecreeper_120p", 51.6, 57, 83, "male", "L2RaidBoss", 40, 618854.527531, 1777.4, 237.8418, 20, 60, 57, 73, 76, 70, 80, 1455513, 201155, 10874.37207, 1061.58432, 2209.19928, 517.88, 253, 4, 333, 0, 0, 0, 60, 200, 0, 1), 
(25710, 25710, "Lost Captain", 0, "", 0, "LineageMonster4.death_knight_n_156p", 34.32, 62.4, 83, "male", "L2RaidBoss", 40, 280911.661939, 17774, 36.891889, 400, 60, 57, 73, 76, 70, 80, 16653943, 2116126, 10229.13367, 3184.75296, 1682.35469, 1553.64, 253, 4, 333, 0, 0, 0, 73, 180, 0, 1), 
(25711, 25711, "Lost Guard", 0, "", 0, "LineageMonster4.corpseshambler", 34, 34, 83, "male", "L2Monster", 40, 16110.47417, 1777.4, 17.776383, 3, 40, 43, 30, 21, 20, 20, 0, 0, 3582.73438, 530.79216, 2446.54314, 258.93704, 253, 4, 333, 0, 0, 0, 50, 200, 0, 1), 
(25712, 25712, "Lost Assistant Guard", 0, "", 0, "LineageMonster4.disciple_silen", 19, 44, 83, "male", "L2Monster", 40, 16110.47417, 1777.4, 17.776383, 20, 40, 43, 30, 21, 20, 20, 0, 0, 2388.48958, 530.79216, 1631.02876, 258.93704, 253, 4, 333, 0, 0, 0, 73, 170, 0, 1), 
(25713, 25713, "Darnels", 0, "Square", 0, "LineageMonster4.rah", 20, 40.6, 84, "female", "L2RaidBoss", 40, 1395831.131841, 18120, 159.893969, 30, 60, 57, 73, 76, 70, 80, 1789794, 1050642, 5370.66229, 644.16101, 3746.43835, 345.95324, 253, 4, 333, 0, 0, 0, 60, 180, 0, 1), 
(25714, 25714, "Kietch", 0, "Flames", 0, "LineageMonster4.Keyache", 12, 29, 84, "male", "L2RaidBoss", 40, 344947.576548, 18120, 196.41521, 30, 60, 57, 73, 76, 70, 80, 2662111, 1460807, 4613.33483, 644.16101, 3161.66317, 345.95304, 253, 4, 333, 0, 0, 0, 26, 180, 0, 1), 
(25715, 25715, "Kietch's Subordinate", 0, "", 0, "LineageMonster3.Death_Blader_Raid", 15, 32.5, 84, "male", "L2Monster", 40, 19178.966176, 1812, 196.571121, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2181.2414, 644.16101, 1494.87319, 628.49211, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(25716, 25716, "Tears", 0, "Ice", 0, "LineageMonster4.tears", 20, 27.5, 84, "female", "L2RaidBoss", 40, 1360985.813638, 18120, 154.089581, 30, 60, 57, 73, 76, 70, 80, 2039317, 1217980, 5380.73978, 644.16101, 3682.33073, 345.95343, 253, 4, 333, 9638, 9638, 0, 60, 180, 0, 1), 
(25717, 25717, "Tears", 0, "Ice", 0, "LineageMonster4.tears", 20, 27.5, 84, "female", "L2Monster", 40, 1360985.813638, 18120, 154.089581, 30, 40, 43, 30, 21, 20, 20, 0, 0, 215.22959, 644.16101, 147.29323, 345.95343, 253, 4, 333, 9638, 9638, 0, 60, 180, 0, 1), 
(25718, 25718, "Emerald Horn", 0, "Raid Boss", 0, "LineageMonster4.drac_raid", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25719, 25719, "Dust Rider", 0, "Raid Boss", 0, "LineageMonster4.Mutant_drake_raid", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25720, 25720, "Bleeding Fly", 0, "Raid Boss", 0, "LineageMonster4.m_drake_wing_knave_raid", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25721, 25721, "Blackdagger Wing", 0, "Raid Boss", 0, "LineageMonster4.mutant_drake_wing_raid", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25722, 25722, "Shadow Summoner", 0, "Raid Boss", 0, "LineageMonster4.dragon_shadow_raid", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25723, 25723, "Spike Slasher", 0, "Raid Boss", 0, "LineageMonster3.antaras_ex_b_tr_raid", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25724, 25724, "Muscle Bomber", 0, "Raid Boss", 0, "LineageMonster4.dragon_berserker_raid", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25725, 25725, "Drake Lord", 0, "Raid Boss", 0, "LineageMonster6.transform_clodecus", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25726, 25726, "Behemoth Leader", 0, "Raid Boss", 0, "LineageMonster3.antaras_ex_a_raid", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25727, 25727, "Dragon Beast", 0, "Raid Boss", 0, "LineageMonster.kaim_vanul_50_bi_a", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25728, 25728, "Death Knight", 0, "", 0, "LineageMonster.death_knight", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25729, 25729, "Death Knight", 0, "", 0, "LineageMonster.death_knight", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25730, 25730, "Demon's Banquet", 0, "", 0, "LineageMonster.skeleton", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25731, 25731, "Demon's Banquet", 0, "", 0, "LineageMonster.skeleton", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25732, 25732, "Dragon Beast", 0, "Raid Boss", 0, "LineageMonster.kaim_vanul_50_bi_a", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25733, 25733, "Gem Dragon", 0, "", 0, "LineageMonster3.antaras_ex_b_tr", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25734, 25734, "Parasitic Leech", 0, "", 0, "LineageMonster.giant_leech_60p", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25735, 25735, "Greyclaw Kutus", 0, "Lord of Destruction", 0, "LineageMonster.ol_mahum_champion_50_bi", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25736, 25736, "Kutus' Guard", 0, "Follower of Destruction", 0, "LineageMonster.ol_mahum", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25737, 25737, "Kutus' Pawn", 0, "Follower of Destruction", 0, "LineageMonster.ol_mahum", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25738, 25738, "Lead Tracker Sharuk", 0, "Lord of Destruction", 0, "LineageMonster.virud_lizardman_warrior", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25739, 25739, "Sharuk's Minion", 0, "Follower of Destruction", 0, "LineageMonster.virud_lizardman", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25740, 25740, "Sharuk's Marksman", 0, "Follower of Destruction", 0, "LineageMonster.virud_lizardman_scout", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25741, 25741, "Sukar Wererat Chief", 0, "Lord of Destruction", 0, "LineageMonster.wererat", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25742, 25742, "Sukar Wererat Guard", 0, "Follower of Destruction", 0, "LineageMonster.wererat_sm", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25743, 25743, "Sukar Wererat Priest", 0, "Follower of Destruction", 0, "LineageMonster.wererat_sm", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25744, 25744, "Ikuntai", 0, "Lord of Destruction", 0, "LineageMonster.skeleton_knight_50_bi", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25745, 25745, "Ikuntai's Servitor", 0, "Follower of Destruction", 0, "LineageMonster.silhouette", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25746, 25746, "Ikuntai's Pawn", 0, "Follower of Destruction", 0, "LineageMonster.skeleton_pikeman", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25747, 25747, "Zombie Lord Crowl", 0, "Lord of Destruction", 0, "LineageMonster3.Zombie_Raid", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25748, 25748, "Evil Spirit Archer", 0, "Follower of Destruction", 0, "LineageMonster.skeleton_archer", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25749, 25749, "Evil Spirit Warrior", 0, "Follower of Destruction", 0, "LineageMonster.skeleton", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25750, 25750, "Zombie Lord Ferkel", 0, "Lord of Destruction", 0, "LineageMonster.zombie_bi", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25751, 25751, "Ferkel's Warrior", 0, "Follower of Destruction", 0, "LineageMonster.zombie", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25752, 25752, "Ferkel's Priest", 0, "Follower of Destruction", 0, "LineageMonster.zombie", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25753, 25753, "Guillotine Warden", 0, "Lord of Destruction", 0, "LineageMonster.skeleton_pikeman_100_bi", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25754, 25754, "Fire Lord Shadar", 0, "Lord of Destruction", 0, "LineageMonster.dre_vanul_100_bi", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25755, 25755, "Sword of Shadar", 0, "Follower of Destruction", 0, "LineageMonster.imp", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25756, 25756, "Whip of Shadar", 0, "Follower of Destruction", 0, "LineageMonster.succubus", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25757, 25757, "Soul Collector Acheron", 0, "Lord of Destruction", 0, "LineageMonster.vale_master_50_bi", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25758, 25758, "Soul Slasher", 0, "Follower of Destruction", 0, "LineageMonster.dark_horror", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25759, 25759, "Soul Strainer", 0, "Follower of Destruction", 0, "LineageMonster.hungry_spirit", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25760, 25760, "Lord Ishka", 0, "Lord of Destruction", 0, "LineageMonster.death_blader_bi", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25761, 25761, "Ishka's Elite Officer", 0, "Follower of Destruction", 0, "LineageMonster.skeleton_royal_guard", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25762, 25762, "Ishka's Elite Soldier", 0, "Follower of Destruction", 0, "LineageMonster.skeleton_knight_20_bi", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25763, 25763, "Demon Kuri", 0, "Lord of Destruction", 0, "LineageMonster.karik_100_bi", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25764, 25764, "Kuri's Wife", 0, "Follower of Destruction", 0, "LineageMonster.bloody_queen", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25765, 25765, "Devil Blader of Chaos", 0, "Follower of Destruction", 0, "LineageMonster.death_blader", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25766, 25766, "Ancient Drake", 0, "Lord of Destruction", 0, "LineageMonster.drake_50_bi", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25767, 25767, "Carnage Lord Gato", 0, "Lord of Destruction", 0, "LineageMonster.oel_mahum_50_bi", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25768, 25768, "Gato's Marksman", 0, "Follower of Destruction", 0, "LineageMonster.ol_mahum_archer", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25769, 25769, "Gato's Champion", 0, "Follower of Destruction", 0, "LineageMonster.ol_mahum_champion", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25770, 25770, "Ketra Commander Atis", 0, "Lord of Destruction", 0, "LineageMonster.ketra_orc_overload", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25771, 25771, "Ketra Marksman", 0, "Follower of Destruction", 0, "LineageMonster.ketra_orc_archer", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25772, 25772, "Ketra Raider", 0, "Follower of Destruction", 0, "LineageMonster.ketra_orc_warrior", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25773, 25773, "Beacon of Blue Sky", 0, "Lord of Destruction", 0, "LineageMonster.lienrik", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25774, 25774, "Beacon's Shooter", 0, "Follower of Destruction", 0, "LineageMonster.skeleton_archer", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25775, 25775, "Beacon's Warrior", 0, "Follower of Destruction", 0, "LineageMonster.skeleton_knight", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25776, 25776, "Earth Protector Panathen", 0, "Lord of Destruction", 0, "LineageMonster.farhite", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25777, 25777, "Panathen's Knight", 0, "Follower of Destruction", 0, "LineageMonster.nos", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25778, 25778, "Panathen's Protectors", 0, "Follower of Destruction", 0, "LineageMonster.dailaon", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25779, 25779, "Betrayer of Urutu Freki", 0, "Lord of Destruction", 0, "LineageMonster.werewolf_bi", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25780, 25780, "Freki's Vampire Bat", 0, "Follower of Destruction", 0, "LineageMonster.vampire_bat", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25781, 25781, "Freki's Wild Bear", 0, "Follower of Destruction", 0, "LineageMonster.grizzly", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25782, 25782, "Nellis' Vengeful Spirit", 0, "Lord of Destruction", 0, "LineageNPC.a_mageguild_teacher_Mhuman_mon_120p", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25783, 25783, "Nellis' Follower", 0, "Follower of Destruction", 0, "LineageMonster.dwarf_ghost", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25784, 25784, "Rayito the Looter", 0, "Lord of Destruction", 0, "LineageMonster.ol_mahum_champion_05te_120p", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25785, 25785, "Rayito's Henchman", 0, "Follower of Destruction", 0, "LineageMonster.ol_mahum_05te_110p", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25786, 25786, "Rayito's Henchman", 0, "Follower of Destruction", 0, "LineageMonster2.northern_goblin_110p", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25787, 25787, "Ketra's Hero Hekaton", 0, "Lord of Destruction", 0, "LineageMonster2.ketra_orc_chieftain_20_bi", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25788, 25788, "Scout of Hekaton", 0, "Follower of Destruction", 0, "LineageMonster.ketra_orc_archer", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25789, 25789, "Servant of Hekaton", 0, "Follower of Destruction", 0, "LineageMonster.ketra_orc", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25790, 25790, "Varka's Hero Shadith", 0, "Lord of Destruction", 0, "LineageMonster2.barka_silenos_shaman_20_bi", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25791, 25791, "Shadith's Royal Guard Captain", 0, "Follower of Destruction", 0, "LineageMonster2.barka_silenos_warrior", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25792, 25792, "Shadith's Sentinel", 0, "Follower of Destruction", 0, "LineageMonster2.barka_silenos_hunter", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25793, 25793, "Doom Blade Tanatos", 0, "Lord of Destruction", 0, "LineageMonster3.Death_Blader_Raid", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25794, 25794, "Kernon", 0, "Lord of Destruction", 0, "LineageMonster.kaim_vanul", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25795, 25795, "Taliadon", 0, "Follower of Destruction", 0, "LineageMonster.death_blader", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25796, 25796, "Vemsk", 0, "Follower of Destruction", 0, "LineageMonster.death_knight", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25797, 25797, "Meanas Anor", 0, "Lord of Destruction", 0, "LineageMonster.wyrm_50_bi", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25798, 25798, "Wyvern of Marsh", 0, "Follower of Destruction", 0, "LineageMonster.wyrm", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25799, 25799, "Succubus of Marsh", 0, "Follower of Destruction", 0, "LineageMonster.succubus", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25800, 25800, "Mammon Collector Talos", 0, "Lord of Destruction", 0, "LineageMonster2.ashuras", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(25801, 25801, "Talos' Cohort", 0, "Follower of Destruction", 0, "LineageMonster.dre_vanul", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(27001, 27001, "Orc Sniper", 0, "", 0, "LineageMonster.orc_archer", 14, 25, 10, "male", "L2Monster", 1100, 163.28607, 108.4, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 19.33758, 61.82527, 13.20506, 45.24105, 253, 8, 333, 14, 0, 0, 45, 110, 0, 1), 
(27002, 27002, "Orc Fighter", 0, "", 0, "LineageMonster.orc_fighter", 12, 22, 12, "male", "L2Monster", 40, 199.62322, 124.48, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 22.99606, 66.32989, 15.70333, 48.53733, 253, 4, 333, 1, 0, 0, 45, 110, 0, 1), 
(27003, 27003, "Spirit Of Mirrors", 0, "Quest Monster", 0, "LineageMonster.poison_toad", 20, 10, 9, "male", "L2Monster", 40, 143.17564, 100.48, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 17.70841, 59.66387, 12.09255, 43.65943, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(27004, 27004, "Spirit Of Mirrors", 0, "Quest Monster", 0, "LineageMonster.orc_fighter", 12, 22, 10, "male", "L2Monster", 40, 163.28607, 108.4, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 19.33758, 61.82527, 13.20506, 45.24105, 253, 4, 333, 0, 0, 0, 45, 110, 0, 1), 
(27005, 27005, "Spirit Of Mirrors", 0, "Quest Monster", 0, "LineageMonster.werewolf", 10, 26, 11, "male", "L2Monster", 40, 185.38552, 116.4, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 21.0973, 64.04702, 14.40672, 46.86683, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(27006, 27006, "Bhato Bloodspear", 0, "", 0, "LineageMonster.orc_fighter", 12, 22, 11, "male", "L2Monster", 40, 185.38552, 116.4, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 21.0973, 64.04702, 14.40672, 46.86683, 253, 4, 333, 0, 0, 0, 45, 110, 0, 1), 
(27007, 27007, "Tanuki Skullcrusher", 0, "", 0, "LineageMonster.orc_fighter", 12, 22, 11, "male", "L2Monster", 40, 185.38552, 116.4, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 21.0973, 64.04702, 14.40672, 46.86683, 253, 4, 333, 0, 0, 0, 45, 110, 0, 1), 
(27008, 27008, "Kraacul Blackskull", 0, "", 0, "LineageMonster.orc_fighter", 12, 22, 11, "male", "L2Monster", 40, 185.38552, 116.4, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 21.0973, 64.04702, 14.40672, 46.86683, 253, 4, 333, 0, 0, 0, 45, 110, 0, 1), 
(27009, 27009, "Taarq Blackskull", 0, "", 0, "LineageMonster.orc_archer", 14, 25, 11, "male", "L2Monster", 40, 185.38552, 116.4, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 21.0973, 64.04702, 14.40672, 46.86683, 253, 4, 333, 0, 0, 0, 45, 110, 0, 1), 
(27016, 27016, "Nerkas", 0, "Quest Monster", 0, "LineageMonster.dre_vanul", 14, 36, 22, "male", "L2Monster", 40, 387.02878, 218.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 51.75278, 92.65694, 35.34044, 67.80232, 253, 4, 333, 0, 0, 0, 80, 80, 0, 1), 
(27017, 27017, "Plague Zombie", 0, "Quest Monster", 0, "LineageMonster.zombie", 13, 21, 14, "male", "L2Monster", 40, 230.38548, 140.88, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 27.24646, 71.08179, 18.6058, 52.01457, 253, 4, 333, 0, 0, 0, 15, 15, 0, 1), 
(27018, 27018, "Orc Warrior", 0, "", 0, "LineageMonster.orc_fighter", 12, 22, 10, "male", "L2Monster", 40, 163.28607, 108.4, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 19.33758, 61.82527, 13.20506, 45.24105, 253, 4, 333, 0, 0, 0, 45, 110, 0, 1), 
(27019, 27019, "Orc Warrior Leader", 0, "", 0, "LineageMonster.orc_fighter", 12, 22, 11, "male", "L2Monster", 40, 185.38552, 116.4, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 21.0973, 64.04702, 14.40672, 46.86683, 253, 4, 333, 0, 0, 0, 45, 110, 0, 1), 
(27020, 27020, "Varool Foulclaw", 0, "Quest Monster", 0, "LineageMonster.wererat", 14, 25, 20, "male", "L2Monster", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(27021, 27021, "Kirunak", 0, "Quest Monster", 0, "LineageMonster.dre_vanul", 14, 36, 22, "male", "L2Monster", 40, 387.02878, 218.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 51.75278, 92.65694, 35.34044, 67.80232, 253, 4, 333, 0, 0, 0, 80, 80, 0, 1), 
(27022, 27022, "Merkenis", 0, "Quest Monster", 0, "LineageMonster.succubus", 10, 36, 22, "female", "L2Monster", 40, 387.02878, 218.52, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 51.75278, 92.65694, 35.34044, 67.80232, 253, 4, 333, 0, 0, 0, 60, 100, 0, 1), 
(27024, 27024, "Undead Priest", 0, "Quest Monster", 0, "LineageMonster.zombie", 13, 21, 17, "male", "L2Monster", 40, 282.57403, 166.08, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 34.8979, 78.68469, 23.83074, 57.57804, 253, 4, 333, 0, 0, 0, 15, 15, 0, 1), 
(27029, 27029, "Phantom Salamander", 0, "Quest Monster", 0, "LineageMonster.salamander", 16, 6.8, 17, "male", "L2Monster", 40, 282.57403, 166.08, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 34.8979, 78.68469, 23.83074, 57.57804, 253, 4, 333, 0, 0, 0, 64, 96, 0, 1), 
(27030, 27030, "Water Seer", 0, "Quest Monster", 0, "LineageMonster.monster_eye", 21, 43, 17, "male", "L2Monster", 40, 282.57403, 166.08, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 34.8979, 78.68469, 23.83074, 57.57804, 253, 4, 333, 0, 0, 0, 90, 90, 0, 1), 
(27031, 27031, "Ol Mahum Sentry", 0, "Quest Monster", 0, "LineageMonster.ol_mahum", 13.5, 25, 17, "male", "L2Monster", 40, 282.57403, 166.08, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 34.8979, 78.68469, 23.83074, 57.57804, 253, 4, 333, 2, 0, 0, 50, 110, 0, 1), 
(27032, 27032, "Lizardman Warrior", 0, "Quest Monster", 0, "LineageMonster.virud_lizardman_warrior", 12, 30, 13, "male", "L2Monster", 80, 214.61578, 132.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 25.04271, 68.67458, 17.10092, 50.25308, 253, 4, 333, 16, 0, 0, 52, 130, 0, 1), 
(27033, 27033, "Lizardman Scout", 0, "Quest Monster", 0, "LineageMonster.virud_lizardman", 10, 23, 12, "male", "L2Monster", 40, 199.62322, 124.48, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 22.99606, 66.32989, 15.70333, 48.53733, 253, 4, 333, 1, 0, 0, 43, 130, 0, 1), 
(27034, 27034, "Lizardman", 0, "Quest Monster", 0, "LineageMonster.virud_lizardman", 10, 23, 11, "male", "L2Monster", 80, 185.38552, 116.4, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 21.0973, 64.04702, 14.40672, 46.86683, 253, 4, 333, 291, 0, 0, 43, 130, 0, 1), 
(27035, 27035, "Tamil", 0, "Quest Monster", 0, "LineageMonster.bugbear", 17, 35, 19, "male", "L2Monster", 40, 321.63954, 183.28, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 40.96915, 84.07638, 27.97662, 61.52345, 253, 1, 333, 4, 0, 0, 55, 130, 0, 1), 
(27036, 27036, "Calpico", 0, "Quest Monster", 0, "LineageMonster.orc_fighter", 12, 22, 13, "male", "L2Monster", 40, 214.61578, 132.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 25.04271, 68.67458, 17.10092, 50.25308, 253, 4, 333, 2, 0, 0, 45, 110, 0, 1), 
(27037, 27037, "Calpico's Goons", 0, "Quest Monster", 0, "LineageMonster.orc", 10, 21, 10, "male", "L2Monster", 40, 163.28607, 108.4, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 19.33758, 61.82527, 13.20506, 45.24105, 253, 4, 333, 1, 0, 0, 45, 110, 0, 1), 
(27038, 27038, "Cat's Eye Bandit", 0, "Quest Monster", 0, "LineageMonster.ol_mahum", 13.5, 25, 15, "male", "L2Monster", 40, 246.95422, 149.2, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 29.61691, 73.55216, 20.22451, 53.82228, 253, 8, 333, 218, 0, 0, 50, 110, 0, 1), 
(27041, 27041, "Baranka's Messenger", 0, "Quest Monster", 0, "LineageMonster.orc_fighter", 12, 22, 12, "male", "L2Monster", 40, 199.62322, 124.48, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 22.99606, 66.32989, 15.70333, 48.53733, 253, 4, 333, 2, 0, 0, 45, 110, 0, 1), 
(27042, 27042, "Orc Escort", 0, "Quest Monster", 0, "LineageMonster.orc_fighter", 12, 22, 12, "male", "L2Monster", 40, 199.62322, 124.48, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 22.99606, 66.32989, 15.70333, 48.53733, 253, 4, 333, 2, 0, 0, 45, 110, 0, 1), 
(27043, 27043, "Varangka's Tracker", 0, "Quest Monster", 0, "LineageMonster.vampire_bat", 10, 33.5, 11, "male", "L2Monster", 40, 185.38552, 116.4, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 21.0973, 64.04702, 14.40672, 46.86683, 253, 4, 333, 0, 0, 0, 60, 80, 0, 1), 
(27044, 27044, "Kasha Bear Totem Spirit", 0, "Quest Monster", 0, "LineageMonster.grizzly", 21, 40, 17, "male", "L2Monster", 40, 282.57403, 166.08, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 34.8979, 78.68469, 23.83074, 57.57804, 253, 4, 333, 0, 0, 0, 40, 110, 0, 1), 
(27045, 27045, "Kuruka Ratman Leader", 0, "Quest Monster", 0, "LineageMonster.wererat", 14, 25, 18, "male", "L2Monster", 40, 301.66622, 174.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 37.82932, 81.34791, 25.83252, 59.52687, 253, 4, 333, 1, 0, 0, 80, 120, 0, 1), 
(27046, 27046, "Sumi", 0, "Orc Betrayer", 0, "LineageMonster.batur_orc", 9, 21.5, 20, "male", "L2Monster", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 2, 0, 0, 80, 130, 0, 1), 
(27047, 27047, "Wanuk", 0, "Orc Betrayer", 0, "LineageMonster.batur_orc", 9, 21.5, 20, "male", "L2Monster", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 2, 0, 0, 80, 130, 0, 1), 
(27048, 27048, "Chewba", 0, "Orc Betrayer", 0, "LineageMonster.batur_orc", 9, 21.5, 20, "male", "L2Monster", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 2, 0, 0, 80, 130, 0, 1), 
(27049, 27049, "Heitafu", 0, "Orc Betrayer", 0, "LineageMonster.batur_orc", 9, 21.5, 20, "male", "L2Monster", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 2, 0, 0, 80, 130, 0, 1), 
(27050, 27050, "Picubo", 0, "Orc Betrayer", 0, "LineageMonster.batur_orc", 9, 21.5, 20, "male", "L2Monster", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 2, 0, 0, 80, 130, 0, 1), 
(27051, 27051, "Bumbum", 0, "Orc Betrayer", 0, "LineageMonster.batur_orc", 9, 21.5, 20, "male", "L2Monster", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 2, 0, 0, 80, 130, 0, 1), 
(27052, 27052, "Minsku", 0, "Orc Betrayer", 0, "LineageMonster.batur_orc", 9, 21.5, 20, "male", "L2Monster", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 2, 0, 0, 80, 130, 0, 1), 
(27053, 27053, "Chuchu", 0, "Orc Betrayer", 0, "LineageMonster.batur_orc", 9, 21.5, 20, "male", "L2Monster", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 2, 0, 0, 80, 130, 0, 1), 
(27054, 27054, "Umbar Orc", 0, "Quest Monster", 0, "LineageMonster.batur_orc", 9, 21.5, 20, "male", "L2Monster", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 2, 0, 0, 80, 130, 0, 1), 
(27055, 27055, "Zakan", 0, "Orc Betrayer", 0, "LineageMonster.batur_orc", 9, 21.5, 20, "male", "L2Monster", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 2, 0, 0, 80, 130, 0, 1), 
(27056, 27056, "Durka Spirit", 0, "Quest Monster", 0, "LineageMonster.magical_weaver", 11, 20, 18, "male", "L2Monster", 40, 301.66622, 174.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 37.82932, 81.34791, 25.83252, 59.52687, 253, 4, 333, 0, 0, 0, 90, 90, 0, 1), 
(27058, 27058, "Honey Bear", 0, "Quest Monster", 0, "LineageMonster.grizzly", 21, 40, 17, "male", "L2Monster", 40, 282.57403, 166.08, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 34.8979, 78.68469, 23.83074, 57.57804, 253, 4, 333, 0, 0, 0, 40, 110, 0, 1), 
(27059, 27059, "Uoph", 0, "Kaboo Chief", 0, "LineageMonster.orc_fighter", 12, 22, 11, "male", "L2Monster", 40, 185.38552, 116.4, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 21.0973, 64.04702, 14.40672, 46.86683, 253, 4, 333, 2, 0, 0, 45, 110, 0, 1), 
(27060, 27060, "Kracha", 0, "Kaboo Chief", 0, "LineageMonster.orc_archer", 14, 25, 11, "male", "L2Monster", 1100, 185.38552, 116.4, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 21.0973, 64.04702, 14.40672, 46.86683, 253, 8, 333, 275, 0, 0, 45, 110, 0, 1), 
(27061, 27061, "Batoh", 0, "Kaboo Chief", 0, "LineageMonster.orc_fighter", 12, 22, 11, "male", "L2Monster", 40, 185.38552, 116.4, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 21.0973, 64.04702, 14.40672, 46.86683, 253, 1, 333, 86, 0, 0, 45, 110, 0, 1), 
(27062, 27062, "Tanukia", 0, "Kaboo Chief", 0, "LineageMonster.orc_fighter", 12, 22, 8, "male", "L2Monster", 40, 124.92828, 92.64, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 16.20165, 57.56203, 11.06363, 42.1214, 253, 4, 333, 2, 0, 0, 45, 110, 0, 1), 
(27063, 27063, "Tanukia's Warhound", 0, "Quest Monster", 0, "LineageMonster.wolf", 13, 9, 4, "male", "L2Monster", 40, 68.20985, 62.08, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 11.24892, 49.73343, 7.68155, 36.39277, 253, 4, 333, 0, 0, 0, 24, 110, 0, 1), 
(27064, 27064, "Turel", 0, "Kaboo Chief", 0, "LineageMonster.orc_fighter", 12, 22, 11, "male", "L2Monster", 40, 185.38552, 116.4, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 21.0973, 64.04702, 14.40672, 46.86683, 253, 4, 333, 2, 0, 0, 45, 110, 0, 1), 
(27065, 27065, "Roko", 0, "Kaboo Chief", 0, "LineageMonster.orc_archer", 14, 25, 8, "male", "L2Monster", 1100, 124.92828, 92.64, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 16.20165, 57.56203, 11.06363, 42.1214, 253, 8, 333, 275, 0, 0, 45, 110, 0, 1), 
(27066, 27066, "Roko's Warhound", 0, "Quest Monster", 0, "LineageMonster.wolf", 13, 9, 4, "male", "L2Monster", 40, 68.20985, 62.08, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 11.24892, 49.73343, 7.68155, 36.39277, 253, 4, 333, 0, 0, 0, 24, 110, 0, 1), 
(27067, 27067, "Kamut", 0, "Kaboo Chief", 0, "LineageMonster.orc_fighter", 12, 22, 11, "male", "L2Monster", 40, 185.38552, 116.4, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 21.0973, 64.04702, 14.40672, 46.86683, 253, 1, 333, 86, 0, 0, 45, 110, 0, 1), 
(27068, 27068, "Murtika", 0, "Kaboo Chief", 0, "LineageMonster.orc_archer", 14, 25, 8, "male", "L2Monster", 1100, 124.92828, 92.64, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 16.20165, 57.56203, 11.06363, 42.1214, 253, 8, 333, 275, 0, 0, 45, 110, 0, 1), 
(27069, 27069, "Murtika's Warhound", 0, "Quest Monster", 0, "LineageMonster.wolf", 13, 9, 4, "male", "L2Monster", 40, 68.20985, 62.08, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 11.24892, 49.73343, 7.68155, 36.39277, 253, 4, 333, 0, 0, 0, 24, 110, 0, 1), 
(27070, 27070, "Tumran Orc Brigand", 0, "Quest Monster", 0, "LineageMonster.orc_fighter", 12, 22, 11, "male", "L2Monster", 40, 185.38552, 116.4, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 21.0973, 64.04702, 14.40672, 46.86683, 253, 4, 333, 2, 0, 0, 45, 110, 0, 1), 
(27077, 27077, "Unicorn Of Eva", 0, "Quest Monster", 0, "LineageMonster.unicorn", 14, 30, 30, "male", "L2Monster", 40, 604.08419, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 92.64226, 118.46427, 63.26266, 86.68702, 253, 4, 333, 0, 0, 0, 46, 150, 0, 1), 
(27078, 27078, "Trimden Lord", 0, "Quest Monster", 0, "LineageMonster.poison_spider", 27, 25.5, 39, "male", "L2Monster", 40, 925.85879, 463.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 166.06476, 152.46752, 113.4007, 111.56912, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(27079, 27079, "Black Willow Lurker", 0, "Quest Monster", 0, "LineageMonster.hanged_man_ripper", 35, 80, 39, "male", "L2Monster", 40, 925.85879, 463.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 166.06476, 152.46752, 113.4007, 111.56912, 253, 4, 333, 0, 0, 0, 55, 55, 0, 1), 
(27080, 27080, "Pashika Son Of Voltar", 0, "Quest Monster", 0, "LineageMonster.batur_orc_warrior", 10, 20, 37, "male", "L2Monster", 40, 847.31754, 432.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 146.82587, 144.47758, 100.26304, 105.72243, 253, 4, 333, 2, 0, 0, 80, 120, 0, 1), 
(27081, 27081, "Vultus Son Of Voltar", 0, "Quest Monster", 0, "LineageMonster.batur_orc_warrior", 10, 20, 37, "male", "L2Monster", 40, 847.31754, 432.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 146.82587, 144.47758, 100.26304, 105.72243, 253, 4, 333, 2, 0, 0, 80, 120, 0, 1), 
(27082, 27082, "Enku Orc Overlord", 0, "Quest Monster", 0, "LineageMonster.batur_orc_warrior", 10, 20, 33, "male", "L2Monster", 40, 702.20463, 372.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 113.49065, 129.23095, 77.49941, 94.5656, 253, 4, 333, 2, 0, 0, 80, 120, 0, 1), 
(27083, 27083, "Makum Bugbear Thug", 0, "Quest Monster", 0, "LineageMonster.bugbear", 17, 35, 37, "male", "L2Monster", 40, 847.31754, 432.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 146.82587, 144.47758, 100.26304, 105.72243, 253, 4, 333, 2, 0, 0, 55, 130, 0, 1), 
(27086, 27086, "Revenant of Tantos Chief", 0, "Quest Monster", 0, "LineageMonster.batur_orc_overlord", 12, 24, 39, "male", "L2Monster", 40, 925.85879, 463.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 166.06476, 152.46752, 113.4007, 111.56912, 253, 4, 333, 66, 0, 0, 80, 140, 0, 1), 
(27088, 27088, "Harpy Matriarch", 0, "Quest Monster", 0, "LineageMonster.harpy", 10, 42, 34, "female", "L2Monster", 40, 736.96177, 387.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 121.20802, 132.9486, 82.76936, 97.28601, 253, 4, 333, 0, 0, 0, 60, 100, 0, 1), 
(27089, 27089, "Road Collector", 0, "Quest Monster", 0, "LineageMonster.wererat", 14, 25, 36, "male", "L2Monster", 40, 809.52639, 417.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 137.86467, 140.57278, 94.1437, 102.86506, 253, 4, 333, 12, 0, 0, 80, 120, 0, 1), 
(27090, 27090, "Serpent Demon Kadesh", 0, "Quest Monster", 0, "LineageMonster.serpent_slave", 17, 46, 41, "male", "L2Monster", 40, 1008.23781, 504.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 187.11878, 160.69002, 127.77787, 117.58598, 253, 4, 333, 73, 0, 0, 70, 110, 0, 1), 
(27092, 27092, "Neer Bodyguard", 0, "Quest Monster", 0, "LineageMonster.neer_crawler", 14, 22, 33, "male", "L2Monster", 40, 702.20463, 372.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 113.49065, 129.23095, 77.49941, 94.5656, 253, 4, 333, 0, 0, 0, 50, 90, 0, 1), 
(27093, 27093, "Delu Chief Kalkis", 0, "Quest Monster", 0, "LineageMonster.virud_lizardman_matriarch", 13, 37, 37, "male", "L2Monster", 40, 847.31754, 432.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 146.82587, 144.47758, 100.26304, 105.72243, 253, 4, 333, 12, 0, 0, 56, 130, 0, 1), 
(27094, 27094, "Delu Lizardman Assassin", 0, "Quest Monster", 0, "LineageMonster.virud_lizardman", 10, 23, 36, "male", "L2Monster", 40, 809.52639, 417.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 137.86467, 140.57278, 94.1437, 102.86506, 253, 4, 333, 2, 0, 0, 43, 130, 0, 1), 
(27095, 27095, "Singing Flower Phantasm", 0, "Quest Monster", 0, "LineageMonster.mandragora_b", 12, 25.5, 44, "female", "L2Monster", 40, 1138.62924, 584, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 222.23112, 173.43552, 151.75505, 126.91259, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(27096, 27096, "Singing Flower Nightmare", 0, "Quest Monster", 0, "LineageMonster.mandragora_b", 12, 25.5, 44, "female", "L2Monster", 40, 1138.62924, 584, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 222.23112, 173.43552, 151.75505, 126.91259, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(27097, 27097, "Singing Flower Darkling", 0, "Quest Monster", 0, "LineageMonster.mandragora_b", 12, 25.5, 44, "female", "L2Monster", 40, 1138.62924, 584, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 222.23112, 173.43552, 151.75505, 126.91259, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(27098, 27098, "Ghost Fire", 0, "Quest Monster", 0, "LineageMonster.will_o_wisp", 13, 22, 42, "male", "L2Monster", 40, 1050.81652, 531, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 198.34591, 164.88513, 135.44454, 120.65578, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(27099, 27099, "Nameless Revenant", 0, "Quest Monster", 0, "LineageMonster.zombie", 13, 21, 38, "male", "L2Monster", 40, 886.09975, 447.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 156.22273, 148.44287, 106.67987, 108.62405, 253, 4, 333, 0, 0, 0, 15, 15, 0, 1), 
(27100, 27100, "Skeletal Mercenary", 0, "Quest Monster", 0, "LineageMonster.skeleton_knight", 10, 25, 39, "male", "L2Monster", 40, 925.85879, 463.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 166.06476, 152.46752, 113.4007, 111.56912, 253, 4, 333, 69, 0, 0, 40, 160, 0, 1), 
(27101, 27101, "Drevanul Prince Zeruel", 0, "Quest Monster", 0, "LineageMonster.dre_vanul", 14, 36, 42, "male", "L2Monster", 40, 1050.81652, 531, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 198.34591, 164.88513, 135.44454, 120.65578, 253, 4, 333, 0, 0, 0, 80, 80, 0, 1), 
(27102, 27102, "Pako The Cat", 0, "Quest Monster", 0, "LineageMonster.cat_the_cat", 9, 16, 38, "male", "L2Monster", 40, 886.09975, 447.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 156.22273, 148.44287, 106.67987, 108.62405, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(27103, 27103, "Unicorn Racer", 0, "Quest Monster", 0, "LineageMonster.unicorn_boxer", 11, 18, 38, "male", "L2Monster", 40, 886.09975, 447.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 156.22273, 148.44287, 106.67987, 108.62405, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(27104, 27104, "Shadow Turen", 0, "Quest Monster", 0, "LineageMonster.shadow", 10, 30, 39, "male", "L2Monster", 40, 925.85879, 463.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 166.06476, 152.46752, 113.4007, 111.56912, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(27105, 27105, "Mimi The Cat", 0, "Quest Monster", 0, "LineageMonster.cutie_cat", 8, 15, 39, "female", "L2Monster", 40, 925.85879, 463.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 166.06476, 152.46752, 113.4007, 111.56912, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(27106, 27106, "Unicorn Phantasm", 0, "Quest Monster", 0, "LineageMonster.unicorn_mirage", 13, 17, 40, "male", "L2Monster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 176.36077, 156.55035, 120.43155, 114.55675, 253, 4, 333, 0, 0, 0, 27, 140, 0, 1), 
(27107, 27107, "Silhouette Tilfo", 0, "Quest Monster", 0, "LineageMonster.silhouette", 8, 23, 40, "female", "L2Monster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 176.36077, 156.55035, 120.43155, 114.55675, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(27108, 27108, "Stenoa Gorgon Queen", 0, "Quest Monster", 0, "LineageMonster.cave_maiden", 25, 65, 37, "female", "L2Monster", 40, 847.31754, 432.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 146.82587, 144.47758, 100.26304, 105.72243, 253, 4, 333, 127, 0, 0, 70, 120, 0, 1), 
(27109, 27109, "Handmaiden Of Stenoa", 0, "Quest Monster", 0, "LineageMonster.medusa", 10, 25, 33, "female", "L2Monster", 40, 702.20463, 372.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 113.49065, 129.23095, 77.49941, 94.5656, 253, 4, 333, 0, 0, 0, 50, 110, 0, 1), 
(27110, 27110, "Shyslassys", 0, "Quest Monster", 0, "LineageMonster.medusa", 10, 25, 36, "female", "L2Monster", 40, 809.52639, 417.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 137.86467, 140.57278, 94.1437, 102.86506, 253, 4, 333, 0, 0, 0, 50, 110, 0, 1), 
(27111, 27111, "Cave Basilisk", 0, "Quest Monster", 0, "LineageMonster.lesser_basilisk", 34, 25, 30, "male", "L2Monster", 40, 604.08419, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 92.64226, 118.46427, 63.26266, 86.68702, 253, 4, 333, 0, 0, 0, 35, 54, 0, 1), 
(27112, 27112, "Gorr", 0, "Quest Monster", 0, "LineageMonster.medusa", 10, 25, 36, "female", "L2Monster", 40, 809.52639, 417.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 137.86467, 140.57278, 94.1437, 102.86506, 253, 4, 333, 0, 0, 0, 50, 110, 0, 1), 
(27113, 27113, "Baraham", 0, "Quest Monster", 0, "LineageMonster.medusa", 10, 25, 36, "female", "L2Monster", 40, 809.52639, 417.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 137.86467, 140.57278, 94.1437, 102.86506, 253, 4, 333, 0, 0, 0, 50, 110, 0, 1), 
(27114, 27114, "Succubus Queen", 0, "Quest Monster", 0, "LineageMonster.succubus", 10, 36, 34, "female", "L2Monster", 40, 736.96177, 387.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 121.20802, 132.9486, 82.76936, 97.28601, 253, 4, 333, 0, 0, 0, 60, 100, 0, 1), 
(27115, 27115, "Claw Of Succubus", 0, "Quest Monster", 0, "LineageMonster.succubus", 10, 36, 28, "female", "L2Monster", 40, 543.79576, 300.96, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 80.54056, 111.61368, 54.99876, 81.67405, 253, 4, 333, 0, 0, 0, 60, 100, 0, 1), 
(27116, 27116, "Lava Salamander", 0, "Quest Monster", 0, "LineageMonster.salamander", 16, 6.8, 35, "male", "L2Monster", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 129.32896, 136.72948, 88.31491, 100.0527, 253, 4, 333, 0, 0, 0, 64, 96, 0, 1), 
(27117, 27117, "Nahir", 0, "Quest Monster", 0, "LineageMonster.dre_vanul", 14, 36, 35, "male", "L2Monster", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 129.32896, 136.72948, 88.31491, 100.0527, 253, 4, 333, 0, 0, 0, 80, 80, 0, 1), 
(27118, 27118, "Black Willow", 0, "Quest Monster", 0, "LineageMonster.hanged_man_ripper", 35, 80, 30, "male", "L2Monster", 40, 604.08419, 329.4, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 92.64226, 118.46427, 63.26266, 86.68702, 253, 4, 333, 0, 0, 0, 55, 55, 0, 1), 
(27119, 27119, "Spirit of Sir Herod", 0, "Quest Monster", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 35, "male", "L2Monster", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 129.32896, 136.72948, 88.31491, 100.0527, 253, 4, 333, 69, 0, 0, 80, 120, 0, 1), 
(27120, 27120, "Luell Of Zephyr Winds", 0, "Quest Monster", 0, "LineageMonster.sylph", 11, 35, 37, "female", "L2Monster", 40, 847.31754, 432.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 146.82587, 144.47758, 100.26304, 105.72243, 253, 4, 333, 0, 0, 0, 60, 60, 0, 1), 
(27121, 27121, "Actea Of Verdant Wilds", 0, "Quest Monster", 0, "LineageMonster.dryad", 9, 20, 37, "female", "L2Monster", 40, 847.31754, 432.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 146.82587, 144.47758, 100.26304, 105.72243, 253, 4, 333, 0, 0, 0, 40, 110, 0, 1), 
(27122, 27122, "Leto Lizardman Agent", 0, "Quest Monster", 0, "LineageMonster.zenta_lizardman", 11, 32, 35, "male", "L2Monster", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 129.32896, 136.72948, 88.31491, 100.0527, 253, 4, 333, 1, 0, 0, 37, 140, 0, 1), 
(27123, 27123, "Leto Lizardman Leader", 0, "Quest Monster", 0, "LineageMonster.zenta_lizardman_warrior", 13, 35, 38, "male", "L2Monster", 40, 886.09975, 447.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 156.22273, 148.44287, 106.67987, 108.62405, 253, 4, 333, 66, 0, 0, 40, 140, 0, 1), 
(27124, 27124, "Leto Lizardman Assassin", 0, "Quest Monster", 0, "LineageMonster.zenta_lizardman", 11, 32, 37, "male", "L2Monster", 40, 847.31754, 432.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 146.82587, 144.47758, 100.26304, 105.72243, 253, 4, 333, 217, 0, 0, 37, 140, 0, 1), 
(27125, 27125, "Leto Lizardman Sniper", 0, "Quest Monster", 0, "LineageMonster.zenta_lizardman_scout", 11, 30, 36, "male", "L2Monster", 1100, 809.52639, 417.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 137.86467, 140.57278, 94.1437, 102.86506, 253, 8, 333, 14, 0, 0, 37, 150, 0, 1), 
(27126, 27126, "Leto Lizardman Wizard", 0, "Quest Monster", 0, "LineageMonster.zenta_lizardman_shaman", 13, 35, 39, "male", "L2Monster", 40, 925.85879, 463.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 166.06476, 152.46752, 113.4007, 111.56912, 253, 4, 333, 7, 0, 0, 43, 130, 0, 1), 
(27127, 27127, "Leto Lizardman Lord", 0, "Quest Monster", 0, "LineageMonster.zenta_lizardman_matriarch", 20, 40, 40, "male", "L2Monster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 176.36077, 156.55035, 120.43155, 114.55675, 253, 4, 333, 69, 0, 0, 53, 140, 0, 1), 
(27128, 27128, "Aruraune", 0, "Quest Monster", 0, "LineageMonster.mandragora_b", 12, 25.5, 40, "female", "L2Monster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 176.36077, 156.55035, 120.43155, 114.55675, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(27129, 27129, "Ol Mahum Inspector", 0, "Quest Monster", 0, "LineageMonster.ol_mahum", 13.5, 25, 38, "male", "L2Monster", 40, 886.09975, 447.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 156.22273, 148.44287, 106.67987, 108.62405, 253, 4, 333, 2, 0, 0, 50, 110, 0, 1), 
(27130, 27130, "Ol Mahum Betrayer", 0, "Quest Monster", 0, "LineageMonster.ol_mahum", 13.5, 25, 36, "male", "L2Monster", 40, 809.52639, 417.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 137.86467, 140.57278, 94.1437, 102.86506, 253, 4, 333, 12, 0, 0, 50, 110, 0, 1), 
(27131, 27131, "Crimson Werewolf", 0, "Quest Monster", 0, "LineageMonster.werewolf", 10, 26, 36, "male", "L2Monster", 40, 809.52639, 417.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 137.86467, 140.57278, 94.1437, 102.86506, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(27132, 27132, "Krudel Lizardman", 0, "Quest Monster", 0, "LineageMonster.virud_lizardman", 10, 23, 36, "male", "L2Monster", 80, 809.52639, 417.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 137.86467, 140.57278, 94.1437, 102.86506, 253, 4, 333, 291, 0, 0, 43, 130, 0, 1), 
(27133, 27133, "Evil Eye Lord", 0, "Quest Monster", 0, "LineageMonster.monster_eye", 21, 43, 37, "male", "L2Monster", 40, 847.31754, 432.72, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 146.82587, 144.47758, 100.26304, 105.72243, 253, 4, 333, 0, 0, 0, 90, 90, 0, 1), 
(27134, 27134, "Tatoma", 0, "Quest Monster", 0, "LineageMonster.king_bugbear", 15, 40, 32, "male", "L2Monster", 40, 668.47132, 358.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 106.16525, 125.57727, 72.49711, 91.89199, 253, 4, 333, 88, 0, 0, 55, 130, 0, 1), 
(27135, 27135, "Grima", 0, "Quest Monster", 0, "LineageMonster.devastator", 35, 35, 50, "male", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 305.54906, 200.23844, 208.6504, 146.5258, 253, 4, 333, 0, 0, 0, 25, 170, 0, 1), 
(27136, 27136, "Succubus Of Seduction", 0, "Quest Monster", 0, "LineageMonster.succubus", 10, 36, 40, "female", "L2Monster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 176.36077, 156.55035, 120.43155, 114.55675, 253, 4, 333, 0, 0, 0, 60, 100, 0, 1), 
(27137, 27137, "Demon King", 0, "Quest Monster", 0, "LineageMonster.dre_vanul", 14, 36, 50, "male", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 305.54906, 200.23844, 208.6504, 146.5258, 253, 4, 333, 0, 0, 0, 80, 80, 0, 1), 
(27138, 27138, "Great Demon King", 0, "Quest Monster", 0, "LineageMonster.death_knight", 12, 31, 60, "male", "L2Monster", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 481.34551, 247.65008, 328.69659, 181.21958, 253, 4, 333, 127, 0, 0, 27, 110, 0, 1), 
(27139, 27139, "Secret Keeper Tree", 0, "Quest Monster", 0, "LineageMonster.ti_mi_tran", 23, 90, 47, "male", "L2Monster", 40, 1276.53628, 665, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 261.69549, 186.63569, 178.7041, 136.5719, 253, 4, 333, 0, 0, 0, 12, 12, 0, 1), 
(27140, 27140, "Breka Overlord Haka", 0, "Quest Monster", 0, "LineageMonster.batur_orc_overlord", 12, 24, 36, "male", "L2Monster", 40, 809.52639, 417.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 137.86467, 140.57278, 94.1437, 102.86506, 253, 4, 333, 66, 0, 0, 80, 140, 0, 1), 
(27141, 27141, "Breka Overlord Jaka", 0, "Quest Monster", 0, "LineageMonster.batur_orc_overlord", 12, 24, 36, "male", "L2Monster", 40, 809.52639, 417.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 137.86467, 140.57278, 94.1437, 102.86506, 253, 4, 333, 66, 0, 0, 80, 140, 0, 1), 
(27142, 27142, "Breka Overlord Marka", 0, "Quest Monster", 0, "LineageMonster.batur_orc_overlord", 12, 24, 36, "male", "L2Monster", 40, 809.52639, 417.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 137.86467, 140.57278, 94.1437, 102.86506, 253, 4, 333, 66, 0, 0, 80, 140, 0, 1), 
(27143, 27143, "Windsus Aleph", 0, "Quest Monster", 0, "LineageMonster.giant_wild_hog", 35, 27, 42, "male", "L2Monster", 40, 1050.81652, 531, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 198.34591, 164.88513, 135.44454, 120.65578, 253, 4, 333, 0, 0, 0, 35, 120, 0, 1), 
(27144, 27144, "Tarlk Raider Athu", 0, "Quest Monster", 0, "LineageMonster.king_bugbear", 15, 40, 48, "male", "L2Monster", 40, 1324.01623, 692.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 275.82705, 191.12803, 188.35412, 139.8592, 253, 4, 333, 88, 0, 0, 55, 130, 0, 1), 
(27145, 27145, "Tarlk Raider Lanka", 0, "Quest Monster", 0, "LineageMonster.king_bugbear", 15, 40, 48, "male", "L2Monster", 40, 1324.01623, 692.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 275.82705, 191.12803, 188.35412, 139.8592, 253, 4, 333, 88, 0, 0, 55, 130, 0, 1), 
(27146, 27146, "Tarlk Raider Triska", 0, "Quest Monster", 0, "LineageMonster.king_bugbear", 15, 40, 48, "male", "L2Monster", 40, 1324.01623, 692.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 275.82705, 191.12803, 188.35412, 139.8592, 253, 4, 333, 88, 0, 0, 55, 130, 0, 1), 
(27147, 27147, "Tarlk Raider Motura", 0, "Quest Monster", 0, "LineageMonster.king_bugbear", 15, 40, 48, "male", "L2Monster", 40, 1324.01623, 692.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 275.82705, 191.12803, 188.35412, 139.8592, 253, 4, 333, 88, 0, 0, 55, 130, 0, 1), 
(27148, 27148, "Tarlk Raider Kalath", 0, "Quest Monster", 0, "LineageMonster.king_bugbear", 15, 40, 48, "male", "L2Monster", 40, 1324.01623, 692.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 275.82705, 191.12803, 188.35412, 139.8592, 253, 4, 333, 88, 0, 0, 55, 130, 0, 1), 
(27149, 27149, "Gremlin Filcher", 0, "Quest Monster", 0, "LineageMonster.gremlin", 10, 15, 12, "male", "L2Monster", 40, 199.62322, 124.48, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 22.99606, 66.32989, 15.70333, 48.53733, 253, 4, 333, 0, 0, 0, 20, 50, 0, 1), 
(27150, 27150, "Black Legion Stormtrooper", 0, "Quest Monster", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 43, "male", "L2Monster", 40, 1094.28943, 557.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 210.04832, 169.13417, 143.43577, 123.76505, 253, 4, 333, 217, 0, 0, 80, 120, 0, 1), 
(27151, 27151, "Delu Lizardman Headhunter", 0, "Quest Monster", 0, "LineageMonster.virud_lizardman_scout", 10, 22, 28, "male", "L2Monster", 1100, 543.79576, 300.96, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 80.54056, 111.61368, 54.99876, 81.67405, 253, 8, 333, 2507, 0, 0, 43, 130, 0, 1), 
(27152, 27152, "Marsh Stakato Marquess", 0, "Quest Monster", 0, "LineageMonster.marsh_stakato_queen", 15, 37, 35, "female", "L2Monster", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 129.32896, 136.72948, 88.31491, 100.0527, 253, 4, 333, 0, 0, 0, 130, 130, 0, 1), 
(27153, 27153, "Alexandro Sanches", 0, "Dark Lord", 0, "LineageMonster.imp", 10, 24, 3, "male", "L2Monster", 40, 57.54874, 54.64, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 10.24492, 47.91652, 6.99595, 35.06323, 253, 4, 333, 0, 0, 0, 60, 80, 0, 1), 
(27154, 27154, "Bonaparterius", 0, "Abyss King", 0, "LineageMonster.goblin", 10, 16.5, 3, "male", "L2Monster", 40, 57.54874, 54.64, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 10.24492, 47.91652, 6.99595, 35.06323, 253, 4, 333, 4, 0, 0, 40, 110, 0, 1), 
(27155, 27155, "Ramsebalius", 0, "Evil Overlord", 0, "LineageMonster.orc", 10, 21, 3, "male", "L2Monster", 40, 57.54874, 54.64, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 10.24492, 47.91652, 6.99595, 35.06323, 253, 4, 333, 2, 0, 0, 45, 110, 0, 1), 
(27156, 27156, "Leto Shaman Ketz", 0, "Quest Monster", 0, "LineageMonster.zenta_lizardman_shaman", 13, 35, 40, "male", "L2Monster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 176.36077, 156.55035, 120.43155, 114.55675, 253, 4, 333, 159, 0, 0, 43, 130, 0, 1), 
(27157, 27157, "Leto Chief Narak", 0, "Quest Monster", 0, "LineageMonster.zenta_lizardman_matriarch", 20, 40, 41, "male", "L2Monster", 40, 1008.23781, 504.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 187.11878, 160.69002, 127.77787, 117.58598, 253, 4, 333, 221, 0, 0, 53, 140, 0, 1), 
(27158, 27158, "Timak Raider Kaikee", 0, "Quest Monster", 0, "LineageMonster.batur_orc", 9, 21.5, 43, "male", "L2Monster", 40, 1094.28943, 557.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 210.04832, 169.13417, 143.43577, 123.76505, 253, 4, 333, 66, 0, 0, 80, 130, 0, 1), 
(27159, 27159, "Timak Overlord Okun", 0, "Quest Monster", 0, "LineageMonster.batur_orc_overlord", 12, 24, 46, "male", "L2Monster", 40, 1229.78678, 637.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 248.0526, 182.18816, 169.38777, 133.31739, 253, 4, 333, 127, 0, 0, 80, 140, 0, 1), 
(27160, 27160, "Gok Magok", 0, "Grandis Chief", 0, "LineageMonster.twin_headed_giant", 17, 39, 43, "male", "L2Monster", 40, 1094.28943, 557.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 210.04832, 169.13417, 143.43577, 123.76505, 253, 4, 333, 0, 0, 0, 45, 100, 0, 1), 
(27161, 27161, "Taik Overlord Kakran", 0, "Quest Monster", 0, "LineageMonster.ketra_orc_warrior", 12, 24, 45, "male", "L2Monster", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 234.89829, 177.78746, 160.40508, 130.09715, 253, 4, 333, 69, 0, 0, 36, 170, 0, 1), 
(27162, 27162, "Hatar Chieftain Kubel", 0, "Quest Monster", 0, "LineageMonster.medusa", 10, 25, 52, "female", "L2Monster", 40, 1520.38155, 804, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 337.18867, 209.50106, 230.25615, 153.30378, 253, 4, 333, 0, 0, 0, 50, 110, 0, 1), 
(27163, 27163, "Vanor Elder Kerunos", 0, "Quest Monster", 0, "LineageMonster.heltor_silenos_chieftain", 13, 31.5, 51, "male", "L2Monster", 40, 1470.41596, 775.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 321.13207, 204.85194, 219.29157, 149.90176, 253, 4, 333, 179, 0, 0, 27, 160, 0, 1), 
(27164, 27164, "Karul Chief Orooto", 0, "Quest Monster", 0, "LineageMonster.bugbear", 17, 35, 43, "male", "L2Monster", 40, 1094.28943, 557.4, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 210.04832, 169.13417, 143.43577, 123.76505, 253, 4, 333, 88, 0, 0, 55, 130, 0, 1), 
(27165, 27165, "Abyssal Jewel 1", 0, "Quest Monster", 0, "LineageMonster.mirror", 26, 52, 60, "male", "L2Monster", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 481.34551, 247.65008, 328.69659, 181.21958, 253, 4, 333, 0, 0, 0, 80, 165, 0, 1), 
(27166, 27166, "Abyssal Jewel 2", 0, "Quest Monster", 0, "LineageMonster.mirror", 26, 52, 60, "male", "L2Monster", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 481.34551, 247.65008, 328.69659, 181.21958, 253, 4, 333, 0, 0, 0, 80, 165, 0, 1), 
(27167, 27167, "Abyssal Jewel 3", 0, "Quest Monster", 0, "LineageMonster.mirror", 26, 52, 60, "male", "L2Monster", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 481.34551, 247.65008, 328.69659, 181.21958, 253, 4, 333, 0, 0, 0, 80, 165, 0, 1), 
(27168, 27168, "Jewel Guardian Mara", 0, "Quest Monster", 0, "LineageMonster.succubus", 10, 36, 53, "female", "L2Monster", 40, 1570.8463, 832.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 353.71092, 214.18326, 241.5387, 156.73001, 253, 4, 333, 0, 0, 0, 60, 100, 0, 1), 
(27169, 27169, "Jewel Guardian Musfel", 0, "Quest Monster", 0, "LineageMonster.dre_vanul", 14, 36, 53, "male", "L2Monster", 40, 1570.8463, 832.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 353.71092, 214.18326, 241.5387, 156.73001, 253, 4, 333, 0, 0, 0, 80, 80, 0, 1), 
(27170, 27170, "Jewel Guardian Pyton", 0, "Quest Monster", 0, "LineageMonster.serpent_slave", 17, 46, 58, "male", "L2Monster", 40, 1828.68266, 977.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 442.8992, 237.99429, 302.44274, 174.1539, 253, 4, 333, 223, 0, 0, 70, 110, 0, 1), 
(27171, 27171, "Sacrifice Of The Sacrificed", 0, "Quest Monster", 0, "LineageMonster.magical_weaver", 11, 20, 20, "male", "L2Monster", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 0, 0, 0, 90, 90, 0, 1), 
(27172, 27172, "Harit Lizardman Zealot", 0, "Quest Monster", 0, "LineageMonster.zenta_lizardman_warrior", 13, 35, 55, "male", "L2Monster", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 16, 0, 0, 40, 140, 0, 1), 
(27173, 27173, "Box Of Athrea 1", 0, "Quest Monster", 0, "LineageNPC.coffer_a", 12, 9.5, 50, "etc", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 305.54906, 200.23844, 208.6504, 146.5258, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(27174, 27174, "Box Of Athrea 2", 0, "Quest Monster", 0, "LineageNPC.coffer_a", 12, 9.5, 50, "etc", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 305.54906, 200.23844, 208.6504, 146.5258, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(27175, 27175, "Box Of Athrea 3", 0, "Quest Monster", 0, "LineageNPC.coffer_a", 12, 9.5, 50, "etc", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 305.54906, 200.23844, 208.6504, 146.5258, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(27176, 27176, "Box Of Athrea 4", 0, "Quest Monster", 0, "LineageNPC.coffer_a", 12, 9.5, 50, "etc", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 305.54906, 200.23844, 208.6504, 146.5258, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(27177, 27177, "Box Of Athrea 5", 0, "Quest Monster", 0, "LineageNPC.coffer_a", 12, 9.5, 50, "etc", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 305.54906, 200.23844, 208.6504, 146.5258, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(27178, 27178, "Blitz Wyrm", 0, "Quest Monster", 0, "LineageMonster.wyrm", 29, 72, 60, "male", "L2Monster", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 481.34551, 247.65008, 328.69659, 181.21958, 253, 4, 333, 0, 0, 0, 70, 70, 0, 1), 
(27179, 27179, "Grave Keymaster", 0, "Quest Monster", 0, "LineageMonster.gargoyle", 16, 50, 65, "male", "L2Monster", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 582.81759, 271.89033, 397.98887, 198.95754, 253, 4, 333, 0, 0, 0, 140, 140, 0, 1), 
(27180, 27180, "Imperial Slave", 0, "Quest Monster", 0, "LineageMonster.binding", 12, 21, 56, "male", "L2Monster", 40, 1724.6831, 918.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 405.96455, 228.40135, 277.22116, 167.1342, 253, 4, 333, 0, 0, 0, 10, 140, 0, 1), 
(27181, 27181, "Imperial Gravekeeper", 0, "Quest Monster", 0, "LineageMonster.death_blader", 15, 45, 60, "male", "L2Monster", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 481.34551, 247.65008, 328.69659, 181.21958, 253, 4, 333, 1472, 0, 0, 100, 170, 0, 1), 
(27182, 27182, "Ark Guardian Elberoth", 0, "Quest Monster", 0, "LineageMonster.archangel", 15, 80, 60, "male", "L2Monster", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 481.34551, 247.65008, 328.69659, 181.21958, 253, 1, 333, 6370, 0, 0, 50, 200, 0, 1), 
(27183, 27183, "Ark Guardian Shadowfang", 0, "Quest Monster", 0, "LineageMonster.kel_mahum_archer", 13, 27, 60, "male", "L2Monster", 1100, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 481.34551, 247.65008, 328.69659, 181.21958, 253, 8, 333, 288, 0, 0, 50, 160, 0, 1), 
(27184, 27184, "Angel Killer", 0, "Quest Monster", 0, "LineageMonster.death_lord", 21, 40, 60, "male", "L2Monster", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 481.34551, 247.65008, 328.69659, 181.21958, 253, 4, 333, 130, 0, 0, 40, 200, 0, 1), 
(27185, 27185, "Fairy Tree of Wind", 0, "Quest Monster", 0, "LineageNPC.human_tree", 35, 90, 55, "etc", "L2Monster", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 1, 333, 0, 0, 0, 50, 1, 0, 1), 
(27186, 27186, "Fairy Tree of Star", 0, "Quest Monster", 0, "LineageNPC.human_tree", 35, 90, 55, "etc", "L2Monster", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(27187, 27187, "Fairy Tree of Twilight", 0, "Quest Monster", 0, "LineageNPC.human_tree", 35, 90, 55, "etc", "L2Monster", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(27188, 27188, "Fairy Tree of Abyss", 0, "Quest Monster", 0, "LineageNPC.human_tree", 35, 90, 55, "etc", "L2Monster", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(27189, 27189, "Soul of Tree Guardian", 0, "Quest Monster", 0, "LineageMonster.elf_ghost", 7, 21, 50, "male", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 305.54906, 200.23844, 208.6504, 146.5258, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(27190, 27190, "Ol Mahum Support Troop", 0, "Quest Monster", 0, "LineageMonster.ol_mahum_champion", 14, 27, 26, "male", "L2Monster", 40, 487.5704, 273, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 69.75926, 105.02818, 47.63653, 76.85506, 253, 4, 333, 69, 0, 0, 50, 150, 0, 1), 
(27191, 27191, "Malcom", 0, "Quest Monster", 0, "LineageMonster.grizzly", 21, 40, 25, "male", "L2Monster", 40, 460.96247, 259.2, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 64.83203, 101.83533, 44.27187, 74.51868, 253, 4, 333, 0, 0, 0, 40, 159, 0, 1), 
(27192, 27192, "Succubus Handmaiden", 0, "Quest Monster", 0, "LineageMonster.succubus", 10, 36, 18, "female", "L2Monster", 40, 301.66622, 174.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 37.82932, 81.34791, 25.83252, 59.52687, 253, 4, 333, 0, 0, 0, 60, 134, 0, 1), 
(27193, 27193, "Goblin Servant", 0, "Quest Monster", 0, "LineageMonster.goblin", 10, 16.5, 12, "male", "L2Monster", 40, 199.62322, 124.48, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 22.99606, 66.32989, 15.70333, 48.53733, 253, 4, 333, 0, 0, 0, 40, 120, 0, 1), 
(27194, 27194, "Julie the Ripper", 0, "Quest Monster", 0, "LineageMonster.doll_blader", 6, 12, 40, "male", "L2Monster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 176.36077, 156.55035, 120.43155, 114.55675, 253, 8, 333, 5129, 5129, 0, 22, 174, 0, 1), 
(27195, 27195, "Male Ant", 0, "Quest Monster", 0, "LineageMonster.noble_ant", 20, 48, 32, "male", "L2Monster", 40, 668.47132, 358.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 106.16525, 125.57727, 72.49711, 91.89199, 253, 4, 333, 0, 0, 0, 80, 150, 0, 1), 
(27196, 27196, "Bluebacked Alligator", 0, "Quest Monster", 0, "LineageMonster.crocodile", 28, 11.5, 40, "male", "L2Monster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 176.36077, 156.55035, 120.43155, 114.55675, 253, 4, 333, 0, 0, 0, 70, 110, 0, 1), 
(27197, 27197, "Bejewelled Alligator", 0, "Quest Monster", 0, "LineageMonster.crocodile", 28, 11.5, 40, "male", "L2Monster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 176.36077, 156.55035, 120.43155, 114.55675, 253, 4, 333, 0, 0, 0, 70, 110, 0, 1), 
(27199, 27199, "Crimson Werewolf", 0, "Quest Monster", 0, "LineageMonster.werewolf", 10, 26, 36, "male", "L2Monster", 40, 809.52639, 417.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 137.86467, 140.57278, 94.1437, 102.86506, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(27200, 27200, "Krudel Lizardman", 0, "Quest Monster", 0, "LineageMonster.virud_lizardman", 10, 23, 36, "male", "L2Monster", 80, 809.52639, 417.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 137.86467, 140.57278, 94.1437, 102.86506, 253, 4, 333, 291, 0, 0, 43, 130, 0, 1), 
(27201, 27201, "", 0, "", 0, "LineageMonster.bugbear", 17, 35, 10, "male", "L2Monster", 80, 163.28607, 108.4, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 19.33758, 61.82527, 13.20506, 45.24105, 253, 4, 333, 291, 0, 0, 55, 180, 0, 1), 
(27202, 27202, "", 0, "", 0, "LineageMonster.bugbear", 17, 35, 10, "male", "L2Monster", 80, 163.28607, 108.4, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 19.33758, 61.82527, 13.20506, 45.24105, 253, 4, 333, 291, 0, 0, 55, 180, 0, 1), 
(27203, 27203, "", 0, "", 0, "LineageMonster.bugbear", 17, 35, 10, "male", "L2Monster", 80, 163.28607, 108.4, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 19.33758, 61.82527, 13.20506, 45.24105, 253, 4, 333, 291, 0, 0, 55, 180, 0, 1), 
(27204, 27204, "", 0, "", 0, "LineageMonster.bugbear", 17, 35, 10, "male", "L2Monster", 80, 163.28607, 108.4, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 19.33758, 61.82527, 13.20506, 45.24105, 253, 4, 333, 291, 0, 0, 55, 180, 0, 1), 
(27205, 27205, "", 0, "", 0, "LineageMonster.bugbear", 17, 35, 10, "male", "L2Monster", 80, 163.28607, 108.4, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 19.33758, 61.82527, 13.20506, 45.24105, 253, 4, 333, 291, 0, 0, 55, 180, 0, 1), 
(27206, 27206, "", 0, "", 0, "LineageMonster.bugbear", 17, 35, 10, "male", "L2Monster", 80, 163.28607, 108.4, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 19.33758, 61.82527, 13.20506, 45.24105, 253, 4, 333, 291, 0, 0, 55, 180, 0, 1), 
(27207, 27207, "", 0, "", 0, "LineageMonster.bugbear", 17, 35, 10, "male", "L2Monster", 80, 163.28607, 108.4, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 19.33758, 61.82527, 13.20506, 45.24105, 253, 4, 333, 291, 0, 0, 55, 180, 0, 1), 
(27208, 27208, "", 0, "", 0, "LineageMonster.bugbear", 17, 35, 10, "male", "L2Monster", 80, 163.28607, 108.4, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 19.33758, 61.82527, 13.20506, 45.24105, 253, 4, 333, 291, 0, 0, 55, 180, 0, 1), 
(27209, 27209, "", 0, "", 0, "LineageMonster.bugbear", 17, 35, 10, "male", "L2Monster", 80, 163.28607, 108.4, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 19.33758, 61.82527, 13.20506, 45.24105, 253, 4, 333, 291, 0, 0, 55, 180, 0, 1), 
(27210, 27210, "", 0, "", 0, "LineageMonster.bugbear", 17, 35, 10, "male", "L2Monster", 80, 163.28607, 108.4, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 19.33758, 61.82527, 13.20506, 45.24105, 253, 4, 333, 291, 0, 0, 55, 180, 0, 1), 
(27211, 27211, "", 0, "", 0, "LineageMonster.bugbear", 17, 35, 10, "male", "L2Monster", 80, 163.28607, 108.4, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 19.33758, 61.82527, 13.20506, 45.24105, 253, 4, 333, 291, 0, 0, 55, 180, 0, 1), 
(27212, 27212, "", 0, "", 0, "LineageMonster.bugbear", 17, 35, 10, "male", "L2Monster", 80, 163.28607, 108.4, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 19.33758, 61.82527, 13.20506, 45.24105, 253, 4, 333, 291, 0, 0, 55, 180, 0, 1), 
(27213, 27213, "", 0, "", 0, "LineageMonster.bugbear", 17, 35, 10, "male", "L2Monster", 80, 163.28607, 108.4, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 19.33758, 61.82527, 13.20506, 45.24105, 253, 4, 333, 291, 0, 0, 55, 180, 0, 1), 
(27214, 27214, "Guardian of Forbidden Knowledge", 0, "Quest Monster", 0, "LineageMonster2.apostle_warrior", 8, 30, 76, "female", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 80, 0, 0, 50, 180, 0, 1), 
(27215, 27215, "Guardian of Forbidden Knowledge", 0, "Quest Monster", 0, "LineageMonster2.apostle_warrior", 8, 30, 76, "female", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 80, 0, 0, 50, 180, 0, 1), 
(27216, 27216, "Guardian of Forbidden Knowledge", 0, "Quest Monster", 0, "LineageMonster2.apostle_warrior", 8, 30, 76, "female", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 80, 0, 0, 50, 180, 0, 1), 
(27217, 27217, "Soul of Well", 0, "Quest Monster", 0, "LineageMonster.dark_horror", 20, 35, 63, "male", "L2Monster", 40, 2089.92274, 1127.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 541.44774, 262.19426, 369.73862, 191.86238, 253, 4, 333, 0, 0, 0, 100, 180, 0, 1), 
(27218, 27218, "Triol's Pawn", 0, "Quest Monster", 0, "LineageMonster.dre_vanul", 14, 36, 65, "male", "L2Monster", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 582.81759, 271.89033, 397.98887, 198.95754, 253, 4, 333, 0, 0, 0, 80, 180, 0, 1), 
(27219, 27219, "Archon of Halisha", 0, "Quest Monster", 0, "LineageMonster2.ahrimanes", 14, 57.75, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 6722, 0, 0, 35, 180, 0, 1), 
(27220, 27220, "Archon of Halisha", 0, "Quest Monster", 0, "LineageMonster2.ahrimanes", 14, 57.75, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 6722, 0, 0, 35, 180, 0, 1), 
(27221, 27221, "Archon of Halisha", 0, "Quest Monster", 0, "LineageMonster2.ahrimanes", 14, 57.75, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 6722, 0, 0, 35, 180, 0, 1), 
(27222, 27222, "Archon of Halisha", 0, "Quest Monster", 0, "LineageMonster2.ahrimanes", 14, 57.75, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 6722, 0, 0, 35, 180, 0, 1), 
(27223, 27223, "Archon of Halisha", 0, "Quest Monster", 0, "LineageMonster2.ahrimanes", 14, 57.75, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 6722, 0, 0, 35, 180, 0, 1), 
(27224, 27224, "Archon of Halisha", 0, "Quest Monster", 0, "LineageMonster2.ahrimanes", 14, 57.75, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 6722, 0, 0, 35, 180, 0, 1), 
(27225, 27225, "Archon of Halisha", 0, "Quest Monster", 0, "LineageMonster2.ahrimanes", 14, 57.75, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 6722, 0, 0, 35, 180, 0, 1), 
(27226, 27226, "Archon of Halisha", 0, "Quest Monster", 0, "LineageMonster2.ahrimanes", 14, 57.75, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 6722, 0, 0, 35, 180, 0, 1), 
(27227, 27227, "Archon of Halisha", 0, "Quest Monster", 0, "LineageMonster2.ahrimanes", 14, 57.75, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 6722, 0, 0, 35, 180, 0, 1), 
(27228, 27228, "Archon of Halisha", 0, "Quest Monster", 0, "LineageMonster2.ahrimanes", 14, 57.75, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 6722, 0, 0, 35, 180, 0, 1), 
(27229, 27229, "Archon of Halisha", 0, "Quest Monster", 0, "LineageMonster2.ahrimanes", 14, 57.75, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 6722, 0, 0, 35, 180, 0, 1), 
(27230, 27230, "Archon of Halisha", 0, "Quest Monster", 0, "LineageMonster2.ahrimanes", 14, 57.75, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 6722, 0, 0, 35, 180, 0, 1), 
(27231, 27231, "Archon of Halisha", 0, "Quest Monster", 0, "LineageMonster2.ahrimanes", 14, 57.75, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 6722, 0, 0, 35, 180, 0, 1), 
(27232, 27232, "Archon of Halisha", 0, "Quest Monster", 0, "LineageMonster2.ahrimanes", 14, 57.75, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 6722, 0, 0, 35, 180, 0, 1), 
(27233, 27233, "Archon of Halisha", 0, "Quest Monster", 0, "LineageMonster2.ahrimanes", 14, 57.75, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 6722, 0, 0, 35, 180, 0, 1), 
(27234, 27234, "Archon of Halisha", 0, "Quest Monster", 0, "LineageMonster2.ahrimanes", 14, 57.75, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 6722, 0, 0, 35, 180, 0, 1), 
(27235, 27235, "Archon of Halisha", 0, "Quest Monster", 0, "LineageMonster2.ahrimanes", 14, 57.75, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 6722, 0, 0, 35, 180, 0, 1), 
(27236, 27236, "Archon of Halisha", 0, "Quest Monster", 0, "LineageMonster2.ahrimanes", 14, 57.75, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 6722, 0, 0, 35, 180, 0, 1), 
(27237, 27237, "Archon of Halisha", 0, "Quest Monster", 0, "LineageMonster2.ahrimanes", 14, 57.75, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 6722, 0, 0, 35, 180, 0, 1), 
(27238, 27238, "Archon of Halisha", 0, "Quest Monster", 0, "LineageMonster2.ahrimanes", 14, 57.75, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 6722, 0, 0, 35, 180, 0, 1), 
(27239, 27239, "Archon of Halisha", 0, "Quest Monster", 0, "LineageMonster2.ahrimanes", 14, 57.75, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 6722, 0, 0, 35, 180, 0, 1), 
(27240, 27240, "Archon of Halisha", 0, "Quest Monster", 0, "LineageMonster2.ahrimanes", 14, 57.75, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 6722, 0, 0, 35, 180, 0, 1), 
(27241, 27241, "Archon of Halisha", 0, "Quest Monster", 0, "LineageMonster2.ahrimanes", 14, 57.75, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 6722, 0, 0, 35, 180, 0, 1), 
(27242, 27242, "Archon of Halisha", 0, "Quest Monster", 0, "LineageMonster2.ahrimanes", 14, 57.75, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 6722, 0, 0, 35, 180, 0, 1), 
(27243, 27243, "Archon of Halisha", 0, "Quest Monster", 0, "LineageMonster2.ahrimanes", 14, 57.75, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 6722, 0, 0, 35, 180, 0, 1), 
(27244, 27244, "Archon of Halisha", 0, "Quest Monster", 0, "LineageMonster2.ahrimanes", 14, 57.75, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 6722, 0, 0, 35, 180, 0, 1), 
(27245, 27245, "Archon of Halisha", 0, "Quest Monster", 0, "LineageMonster2.ahrimanes", 14, 57.75, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 6722, 0, 0, 35, 180, 0, 1), 
(27246, 27246, "Archon of Halisha", 0, "Quest Monster", 0, "LineageMonster2.ahrimanes", 14, 57.75, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 6722, 0, 0, 35, 180, 0, 1), 
(27247, 27247, "Archon of Halisha", 0, "Quest Monster", 0, "LineageMonster2.ahrimanes", 14, 57.75, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 6722, 0, 0, 35, 180, 0, 1), 
(27248, 27248, "Archon of Halisha", 0, "Quest Monster", 0, "LineageMonster2.ahrimanes", 14, 57.75, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 6722, 0, 0, 35, 180, 0, 1), 
(27249, 27249, "Archon of Halisha", 0, "Quest Monster", 0, "LineageMonster2.ahrimanes", 14, 57.75, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 6722, 0, 0, 35, 180, 0, 1), 
(27250, 27250, "Fallen Angel Allector", 0, "Quest Monster", 0, "LineageMonster.karik", 25, 90, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 0, 0, 0, 37, 180, 0, 1), 
(27251, 27251, "Fallen Angel Allector", 0, "Quest Monster", 0, "LineageMonster.karik", 25, 90, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 0, 0, 0, 37, 180, 0, 1), 
(27252, 27252, "Fallen Angel Allector", 0, "Quest Monster", 0, "LineageMonster.karik", 25, 90, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 0, 0, 0, 37, 180, 0, 1), 
(27253, 27253, "Hell Fire", 0, "Quest Monster", 0, "LineageMonster.will_o_wisp", 13, 22, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 1, 333, 0, 0, 0, 80, 170, 0, 1), 
(27254, 27254, "Unknown Stopper", 0, "Quest Monster", 0, "LineageMonster.fiend_archer", 17, 55, 78, "male", "L2Monster", 1100, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 0, 0, 938.20801, 354.81835, 656.66638, 259.64067, 253, 8, 333, 0, 0, 0, 70, 180, 0, 1), 
(27255, 27255, "Unknown Stopper", 0, "Quest Monster", 0, "LineageMonster.fiend_archer", 17, 55, 78, "male", "L2Monster", 1100, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 0, 0, 938.20801, 354.81835, 656.66638, 259.64067, 253, 8, 333, 0, 0, 0, 70, 180, 0, 1), 
(27256, 27256, "Unknown Stopper", 0, "Quest Monster", 0, "LineageMonster.fiend_archer", 17, 55, 78, "male", "L2Monster", 1100, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 0, 0, 938.20801, 354.81835, 656.66638, 259.64067, 253, 8, 333, 0, 0, 0, 70, 180, 0, 1), 
(27257, 27257, "Archangel Iconoclasis", 0, "Quest Monster", 0, "LineageMonster2.apostle_mage", 11, 38.5, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 1, 333, 161, 0, 0, 50, 180, 0, 1), 
(27258, 27258, "Archangel Iconoclasis", 0, "Quest Monster", 0, "LineageMonster2.apostle_mage", 11, 38.5, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 1, 333, 161, 0, 0, 50, 180, 0, 1), 
(27259, 27259, "Archangel Iconoclasis", 0, "Quest Monster", 0, "LineageMonster2.apostle_mage", 11, 38.5, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 1, 333, 161, 0, 0, 50, 180, 0, 1), 
(27260, 27260, "Archangel Iconoclasis", 0, "Quest Monster", 0, "LineageMonster2.apostle_mage", 11, 38.5, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 1, 333, 161, 0, 0, 50, 180, 0, 1), 
(27261, 27261, "Bead of Sacred Flame", 0, "Quest Monster", 0, "LineageMonster.will_o_wisp", 13, 22, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 1, 333, 0, 0, 0, 80, 180, 0, 1), 
(27262, 27262, "Death Lord Hallate", 0, "Quest Monster", 0, "LineageMonster.death_lord", 21, 40, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 0, 0, 938.20801, 354.81835, 656.66638, 259.64067, 253, 4, 333, 78, 0, 0, 40, 180, 0, 1), 
(27263, 27263, "Death Lord Hallate", 0, "Quest Monster", 0, "LineageMonster.death_lord", 21, 40, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 0, 0, 938.20801, 354.81835, 656.66638, 259.64067, 253, 4, 333, 78, 0, 0, 40, 180, 0, 1), 
(27264, 27264, "Death Lord Hallate", 0, "Quest Monster", 0, "LineageMonster.death_lord", 21, 40, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 0, 0, 938.20801, 354.81835, 656.66638, 259.64067, 253, 4, 333, 78, 0, 0, 40, 180, 0, 1), 
(27265, 27265, "Lich King Icarus", 0, "Quest Monster", 0, "LineageMonster.vale_master", 12, 40, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 0, 0, 938.20801, 354.81835, 656.66638, 259.64067, 253, 4, 333, 205, 0, 0, 70, 180, 0, 1), 
(27266, 27266, "Fallen Angel Haures", 0, "Quest Monster", 0, "LineageMonster.doll_master", 20, 42, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 1, 333, 0, 0, 0, 80, 180, 0, 1), 
(27267, 27267, "Fallen Angel Haures", 0, "Quest Monster", 0, "LineageMonster.doll_master", 20, 42, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 1, 333, 0, 0, 0, 80, 180, 0, 1), 
(27268, 27268, "Guard of Haures", 0, "Quest Monster", 0, "LineageMonster.neer_crawler", 14, 22, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 8, 333, 0, 0, 0, 50, 180, 0, 1), 
(27269, 27269, "Fallen Angel Naverius", 0, "Quest Monster", 0, "LineageMonster.banshee", 9, 23, 76, "female", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 1, 333, 3939, 0, 0, 80, 180, 0, 1), 
(27270, 27270, "Fallen Angel Naverius", 0, "Quest Monster", 0, "LineageMonster.banshee", 9, 23, 76, "female", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 1, 333, 3939, 0, 0, 80, 180, 0, 1), 
(27271, 27271, "Chimera Golem", 0, "Quest Monster", 0, "LineageMonster2.lava_golem", 22, 45, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 0, 0, 0, 13, 180, 0, 1), 
(27272, 27272, "Hallate's Dancer Lillian", 0, "Quest Monster", 0, "LineageMonster.banshee", 9, 23, 76, "female", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 1, 333, 3939, 0, 0, 80, 180, 0, 1), 
(27273, 27273, "Assassin Pezel", 0, "Quest Monster", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 0, 0, 938.20801, 354.81835, 656.66638, 259.64067, 253, 8, 333, 242, 0, 0, 80, 180, 0, 1), 
(27274, 27274, "Fallen Angel Tanakia", 0, "Quest Monster", 0, "LineageMonster2.halisha_d", 23, 60, 78, "female", "L2Monster", 1100, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 0, 0, 938.20801, 354.81835, 656.66638, 259.64067, 253, 8, 333, 286, 0, 0, 43, 180, 0, 1), 
(27275, 27275, "Fallen Angel Tanakia", 0, "Quest Monster", 0, "LineageMonster2.halisha_d", 23, 60, 78, "female", "L2Monster", 1100, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 0, 0, 938.20801, 354.81835, 656.66638, 259.64067, 253, 8, 333, 286, 0, 0, 43, 180, 0, 1), 
(27276, 27276, "Fallen Angel Tanakia", 0, "Quest Monster", 0, "LineageMonster2.halisha_d", 23, 60, 78, "female", "L2Monster", 1100, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 0, 0, 938.20801, 354.81835, 656.66638, 259.64067, 253, 8, 333, 286, 0, 0, 43, 180, 0, 1), 
(27277, 27277, "Fallen Angel Tanakia", 0, "Quest Monster", 0, "LineageMonster2.halisha_d", 23, 60, 78, "female", "L2Monster", 1100, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 0, 0, 938.20801, 354.81835, 656.66638, 259.64067, 253, 8, 333, 286, 0, 0, 43, 180, 0, 1), 
(27278, 27278, "Shadow of Beleth", 0, "Quest Monster", 0, "LineageMonster.vale_master", 12, 40, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 0, 0, 938.20801, 354.81835, 656.66638, 259.64067, 253, 1, 333, 205, 0, 0, 70, 180, 0, 1), 
(27279, 27279, "Cursed Kesadein", 0, "Quest Monster", 0, "LineageMonster.doll_master", 20, 42, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 0, 0, 938.20801, 354.81835, 656.66638, 259.64067, 253, 8, 333, 0, 0, 0, 80, 180, 0, 1), 
(27280, 27280, "Fallen Angel Narcissus", 0, "Quest Monster", 0, "LineageMonster.karik", 25, 90, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 0, 0, 938.20801, 354.81835, 656.66638, 259.64067, 253, 4, 333, 0, 0, 0, 37, 180, 0, 1), 
(27281, 27281, "Fallen Angel Metellus", 0, "Quest Monster", 0, "LineageMonster.karik", 25, 90, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 0, 0, 938.20801, 354.81835, 656.66638, 259.64067, 253, 4, 333, 0, 0, 0, 37, 180, 0, 1), 
(27282, 27282, "Dark Angel Othiel", 0, "Quest Monster", 0, "LineageMonster.archangel", 15, 80, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 0, 0, 938.20801, 354.81835, 656.66638, 259.64067, 253, 4, 333, 97, 0, 0, 50, 180, 0, 1), 
(27283, 27283, "Grandpapa Askalius", 0, "Quest Monster", 0, "LineageMonster.susceptor_prime", 45, 72, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 0, 0, 938.20801, 354.81835, 656.66638, 259.64067, 253, 1, 333, 0, 0, 0, 78, 180, 0, 1), 
(27284, 27284, "Flame Evil Spirit Azira", 0, "Quest Monster", 0, "LineageMonster2.ifrit", 10, 42, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 0, 0, 938.20801, 354.81835, 656.66638, 259.64067, 253, 4, 333, 0, 0, 0, 38, 180, 0, 1), 
(27285, 27285, "Lizard's Totem Sharuhi", 0, "Quest Monster", 0, "LineageMonster.serpent_slave", 17, 46, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 0, 0, 938.20801, 354.81835, 656.66638, 259.64067, 253, 4, 333, 72, 0, 0, 70, 180, 0, 1), 
(27286, 27286, "Fallen Knight Adhil", 0, "Quest Monster", 0, "LineageNPC.a_guard_MHuman", 8, 24, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 79, 107, 0, 50, 180, 0, 1), 
(27287, 27287, "Bound Elf Panacea", 0, "Quest Monster", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 145, 0, 0, 50, 180, 0, 1), 
(27288, 27288, "Sword Player Biel", 0, "Quest Monster", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 74, 74, 0, 50, 180, 0, 1), 
(27289, 27289, "Ancient Sword Master Iron", 0, "Quest Monster", 0, "LineageMonster2.lilim_knight_10_bi", 13, 55, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 5800, 5799, 0, 56, 180, 0, 1), 
(27290, 27290, "White Wing Commander", 0, "Quest Monster", 0, "LineageMonster.archangel", 15, 80, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 97, 0, 0, 50, 180, 0, 1), 
(27291, 27291, "White Wing Fighter", 0, "Quest Monster", 0, "LineageMonster2.apostle_warrior", 8, 30, 76, "female", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 80, 0, 0, 50, 180, 0, 1), 
(27292, 27292, "Fallen Noble Orc Muhark", 0, "Quest Monster", 0, "LineageMonster.ketra_orc_warrior", 12, 24, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 7834, 0, 0, 36, 180, 0, 1), 
(27293, 27293, "Khavatari Uruz", 0, "Quest Monster", 0, "LineageMonster.ketra_orc_warrior", 12, 24, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 0, 0, 0, 36, 180, 0, 1), 
(27294, 27294, "Overlord Atrus", 0, "Quest Monster", 0, "LineageMonster2.ketra_orc_chieftain", 11, 38.5, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 1, 333, 6719, 0, 0, 24, 180, 0, 1), 
(27295, 27295, "Sharuhi Mouth Mudaha", 0, "Quest Monster", 0, "LineageMonster2.ketra_orc_chieftain", 11, 38.5, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 1, 333, 6719, 0, 0, 24, 180, 0, 1), 
(27296, 27296, "Monument Watcher Ezekiel", 0, "Quest Monster", 0, "LineageMonster.archangel", 15, 80, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 97, 0, 0, 50, 180, 0, 1), 
(27297, 27297, "Monument Watcher Ezekiel", 0, "Quest Monster", 0, "LineageMonster.archangel", 15, 80, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 97, 0, 0, 50, 180, 0, 1), 
(27298, 27298, "Monument Watcher Ezekiel", 0, "Quest Monster", 0, "LineageMonster.archangel", 15, 80, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 97, 0, 0, 50, 180, 0, 1), 
(27299, 27299, "Monument Watcher Ezekiel", 0, "Quest Monster", 0, "LineageMonster.archangel", 15, 80, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 97, 0, 0, 50, 180, 0, 1), 
(27300, 27300, "Monument Watcher Ezekiel", 0, "Quest Monster", 0, "LineageMonster.archangel", 15, 80, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 97, 0, 0, 50, 180, 0, 1), 
(27301, 27301, "Monument Watcher Ezekiel", 0, "Quest Monster", 0, "LineageMonster.archangel", 15, 80, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 97, 0, 0, 50, 180, 0, 1), 
(27302, 27302, "Monument Defender Azrael", 0, "Quest Monster", 0, "LineageMonster.archangel", 15, 80, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 0, 0, 938.20801, 354.81835, 656.66638, 259.64067, 253, 4, 333, 97, 0, 0, 50, 180, 0, 1), 
(27303, 27303, "Monument Defender Azrael", 0, "Quest Monster", 0, "LineageMonster.archangel", 15, 80, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 0, 0, 938.20801, 354.81835, 656.66638, 259.64067, 253, 4, 333, 97, 0, 0, 50, 180, 0, 1), 
(27304, 27304, "Monument Defender Azrael", 0, "Quest Monster", 0, "LineageMonster.archangel", 15, 80, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 0, 0, 938.20801, 354.81835, 656.66638, 259.64067, 253, 4, 333, 97, 0, 0, 50, 180, 0, 1), 
(27305, 27305, "Monument Defender Azrael", 0, "Quest Monster", 0, "LineageMonster.archangel", 15, 80, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 0, 0, 938.20801, 354.81835, 656.66638, 259.64067, 253, 4, 333, 97, 0, 0, 50, 180, 0, 1), 
(27306, 27306, "Monument Defender Azrael", 0, "Quest Monster", 0, "LineageMonster.archangel", 15, 80, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 0, 0, 938.20801, 354.81835, 656.66638, 259.64067, 253, 4, 333, 97, 0, 0, 50, 180, 0, 1), 
(27307, 27307, "Monument Defender Azrael", 0, "Quest Monster", 0, "LineageMonster.archangel", 15, 80, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 0, 0, 938.20801, 354.81835, 656.66638, 259.64067, 253, 4, 333, 97, 0, 0, 50, 180, 0, 1), 
(27308, 27308, "Assassin Frost", 0, "Quest Monster", 0, "LineageMonster2.vampire_soldier", 8, 23.5, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 0, 0, 938.20801, 354.81835, 656.66638, 259.64067, 253, 8, 333, 229, 0, 0, 60, 180, 0, 1), 
(27309, 27309, "Minervia Van Hacken", 0, "Quest Monster", 0, "LineageMonster2.vampire_witch", 6, 21.5, 78, "female", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 0, 0, 938.20801, 354.81835, 656.66638, 259.64067, 253, 8, 333, 229, 0, 0, 64, 180, 0, 1), 
(27310, 27310, "Kitanis Van Hacken", 0, "Quest Monster", 0, "LineageMonster2.vampire_lord", 7.5, 25.8, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 0, 0, 938.20801, 354.81835, 656.66638, 259.64067, 253, 4, 333, 0, 0, 0, 15, 180, 0, 1), 
(27311, 27311, "Judgment Hound Dog Kelvas", 0, "Quest Monster", 0, "LineageMonster2.eligor", 21, 35, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 0, 0, 938.20801, 354.81835, 656.66638, 259.64067, 253, 4, 333, 0, 0, 0, 35, 180, 0, 1), 
(27312, 27312, "Mysterious Servitor", 0, "Quest Monster", 0, "LineageMonster.shadeless", 7, 28, 78, "male", "L2Monster", 40, 2975.236919, 1742.976, 8.721, 3.0804, 40, 43, 30, 21, 20, 20, 0, 0, 938.20801, 354.81835, 656.66638, 259.64067, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(27313, 27313, "Vision Guardian Shakiel", 0, "Quest Monster", 0, "LineageMonster2.apostle_mage", 11, 38.5, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 1, 333, 161, 0, 0, 50, 180, 0, 1), 
(27314, 27314, "Vision Guardian Shakiel", 0, "Quest Monster", 0, "LineageMonster2.apostle_mage", 11, 38.5, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 1, 333, 161, 0, 0, 50, 180, 0, 1), 
(27315, 27315, "Vision Guardian Shakiel", 0, "Quest Monster", 0, "LineageMonster2.apostle_mage", 11, 38.5, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 1, 333, 161, 0, 0, 50, 180, 0, 1), 
(27316, 27316, "Fallen Chieftain Vegus", 0, "Quest Monster", 0, "LineageMonster.ketra_orc_warrior", 12, 24, 55, "male", "L2Monster", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 1, 333, 161, 0, 0, 36, 180, 0, 1), 
(27317, 27317, "Restrainer of Glory", 0, "Quest Monster", 0, "LineageMonster.kel_mahum_champion", 13, 32, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 1, 333, 161, 0, 0, 50, 180, 0, 1), 
(27318, 27318, "Wendy's Guardian", 0, "Quest Monster", 0, "LineageMonster3.golem_guardian_090p", 16, 37.2, 46, "male", "L2Monster", 40, 1229.78678, 637.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 248.0526, 182.18816, 169.38777, 133.31739, 253, 4, 333, 0, 0, 0, 50, 130, 0, 1), 
(27319, 27319, "Black Leopard", 0, "Quest Monster", 0, "LineageMonster.onyx_beast", 14, 14.5, 18, "male", "L2Monster", 40, 301.66622, 174.64, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 37.82932, 81.34791, 25.83252, 59.52687, 253, 4, 333, 0, 0, 0, 30, 130, 1, 1), 
(27320, 27320, "Timora Orc", 0, "Quest Monster", 0, "LineageMonster.batur_orc", 9, 21.5, 20, "male", "L2Monster", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 2, 0, 0, 80, 130, 0, 1), 
(27321, 27321, "Bruin Lizardman", 0, "Quest Monster", 0, "LineageMonster.virud_lizardman", 10, 23, 20, "male", "L2Monster", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 44.32863, 86.87049, 30.2707, 63.56806, 253, 1, 333, 291, 0, 0, 43, 130, 0, 1), 
(27322, 27322, "Picot Araneid", 0, "Quest Monster", 0, "LineageMonster.giant_spider_50_bi", 39, 38, 27, "male", "L2Monster", 40, 515.17856, 286.92, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 74.99121, 108.28767, 51.20928, 79.24022, 253, 1, 333, 0, 0, 0, 72, 130, 0, 1), 
(27323, 27323, "Divine Emissary", 0, "Quest Monster", 0, "LineageMonster.angel", 13.5, 36.5, 40, "male", "L2Monster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 176.36077, 156.55035, 120.43155, 114.55675, 253, 4, 333, 148, 0, 0, 30, 170, 0, 1), 
(27324, 27324, "Vision Guard Eranus", 0, "Quest Monster", 0, "LineageMonster2.apostle_warrior", 8, 30, 76, "female", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 6717, 0, 0, 50, 180, 0, 1), 
(27325, 27325, "Archon of Halisha", 0, "Quest Monster", 0, "LineageMonster2.ahrimanes", 14, 57.75, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 6722, 0, 0, 35, 180, 0, 1), 
(27326, 27326, "Archangel Kanriel", 0, "Quest Monster", 0, "LineageMonster.archangel_050p", 13, 37.5, 81, "male", "L2Monster", 80, 2916.89894, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 913.54847, 345.61127, 623.83518, 252.90333, 253, 4, 333, 97, 0, 0, 50, 120, 0, 1); 

INSERT INTO `npc` VALUES
(27327, 27327, "Zakorel's Executor", 0, "Quest Monster", 0, "LineageMonster2.apostle_mage", 11, 38.5, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 6718, 0, 0, 50, 180, 0, 1), 
(27328, 27328, "Zakorel", 0, "Quest Monster", 0, "LineageMonster3.apostle_grail", 13, 47, 81, "male", "L2Monster", 40, 2916.89894, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 913.54847, 345.61127, 623.83518, 252.90333, 253, 4, 333, 6717, 0, 0, 30, 180, 0, 1), 
(27329, 27329, "Archon of Halisha", 0, "Quest Monster", 0, "LineageMonster2.ahrimanes", 14, 57.75, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 6722, 0, 0, 35, 180, 0, 1), 
(27332, 27332, "Guardian Angel", 0, "Quest Monster", 0, "LineageMonster.angel", 13.5, 36.5, 35, "male", "L2Monster", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 129.32896, 136.72948, 88.31491, 100.0527, 253, 4, 333, 196, 0, 0, 30, 170, 0, 1), 
(27333, 27333, "Crimson Duchess", 0, "Quest Monster", 0, "LineageMonster3.lidia_von_helmann", 10, 25.4, 76, "female", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 0, 0, 0, 20, 190, 0, 1), 
(27334, 27334, "Archon of Halisha", 0, "Quest Monster", 0, "LineageMonster2.ahrimanes", 14, 57.75, 76, "male", "L2Monster", 40, 2719.97952, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 815.37145, 323.78455, 556.793, 236.93149, 253, 4, 333, 6722, 0, 0, 35, 180, 0, 1), 
(27335, 27335, "Dark Angel Othiel", 0, "Quest Monster", 0, "LineageMonster.archangel", 15, 80, 81, "male", "L2Monster", 40, 2916.89894, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 913.54847, 345.61127, 623.83518, 252.90333, 253, 4, 333, 97, 0, 0, 50, 180, 0, 1), 
(27336, 27336, "Crimson Lady", 0, "Quest Monster", 0, "LineageMonster.succubus", 10, 36, 40, "female", "L2Monster", 40, 966.57792, 478.8, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 176.36077, 156.55035, 120.43155, 114.55675, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(27337, 27337, "Ol Mahum Officer Tak", 0, "Quest Monster", 0, "LineageMonster.ol_mahum_champion", 14, 27, 20, "male", "L2Monster", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 69, 0, 0, 50, 110, 0, 1), 
(27338, 27338, "Fallen Angel", 0, "Quest Monster", 0, "LineageMonster2.apostle_warrior", 8, 30, 38, "female", "L2Monster", 40, 886.09975, 447.96, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 156.22273, 148.44287, 106.67987, 108.62405, 253, 4, 333, 6717, 0, 0, 50, 180, 0, 1), 
(27339, 27339, "Cruma Marshlands Traitor", 0, "Quest Monster", 0, "LineageMonster2.vampire_witch", 6, 21.5, 35, "female", "L2Monster", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 129.32896, 136.72948, 88.31491, 100.0527, 253, 1, 333, 946, 0, 0, 64, 180, 0, 1), 
(27340, 27340, "Pursuer", 0, "", 0, "LineageMonster.ol_mahum", 13.5, 25, 39, "male", "L2Monster", 40, 925.85879, 463.32, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 166.06476, 152.46752, 113.4007, 111.56912, 253, 4, 333, 219, 0, 0, 50, 110, 0, 1), 
(27341, 27341, "Shilen's Evil Thoughts", 0, "", 0, "LineageNPC.training_doll_150p", 13, 40, 51, "etc", "L2Monster", 40, 1470.41596, 775.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 321.13207, 204.85194, 219.29157, 149.90176, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(27342, 27342, "Shilen's Evil Thoughts", 0, "", 0, "LineageNPC.training_doll_150p", 13, 40, 61, "etc", "L2Monster", 40, 1985.55926, 1066.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 501.08068, 252.49346, 342.17315, 184.76376, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(27343, 27343, "Shilen's Evil Thoughts", 0, "", 0, "LineageMonster5.vicious_mind_of_silen", 14, 27.5, 79, "male", "L2Monster", 40, 3127.824593, 1641, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 929.93081, 337.07008, 635.0222, 246.65326, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(27344, 27344, "Shilen's Evil Thoughts", 0, "", 0, "LineageNPC.training_doll_150p", 13, 40, 51, "etc", "L2Monster", 40, 1470.41596, 775.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 321.13207, 204.85194, 219.29157, 149.90176, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(27345, 27345, "Shilen's Evil Thoughts", 0, "", 0, "LineageNPC.training_doll_150p", 13, 40, 61, "etc", "L2Monster", 40, 1985.55926, 1066.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 501.08068, 252.49346, 342.17315, 184.76376, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(27346, 27346, "Shilen's Evil Thoughts", 0, "", 0, "LineageMonster5.leader_mind_of_silen", 20, 40, 79, "male", "L2Monster", 40, 3127.824593, 1641, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 929.93081, 337.07008, 635.0222, 246.65326, 253, 4, 333, 0, 0, 0, 45, 180, 0, 1), 
(27347, 27347, "Guards of the Dawn Oracle", 0, "", 0, "LineageNPC.a_fighterguild_master_Mhuman", 8, 23.5, 85, "male", "L2Monster", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(27348, 27348, "Guards of the Dawn Oracle", 0, "", 0, "LineageNPC.a_fighterguild_master_Mhuman", 8, 23.5, 85, "male", "L2Monster", 80, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 16, 0, 0, 50, 100, 0, 1), 
(27349, 27349, "Guards of the Dawn Oracle", 0, "", 0, "LineageNPC.a_mageguild_master_MHuman", 8, 24, 85, "male", "L2Monster", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(27350, 27350, "Guards of the Dawn Oracle", 0, "", 0, "LineageNPC.a_mageguild_master_MHuman", 8, 24, 85, "male", "L2Monster", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 1, 333, 5, 0, 0, 50, 100, 0, 1), 
(27351, 27351, "Guards of the Dawn", 0, "", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 85, "female", "L2Monster", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 1, 333, 6, 0, 0, 50, 100, 0, 1), 
(27352, 27352, "Guards of the Dawn Oracle", 0, "", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 85, "female", "L2Monster", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 1, 333, 6, 0, 0, 50, 100, 0, 1), 
(27353, 27353, "Lilim Butcher", 0, "", 0, "LineageMonster2.lilim_assassin_10_sm", 11, 36, 51, "male", "L2Monster", 40, 1470.41596, 775.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 321.13207, 204.85194, 219.29157, 149.90176, 253, 4, 333, 232, 232, 0, 36, 190, 0, 1), 
(27354, 27354, "Lilim Magus", 0, "", 0, "LineageMonster2.lilim_wizard_10_sm", 8, 30.6, 51, "female", "L2Monster", 40, 1470.41596, 775.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 321.13207, 204.85194, 219.29157, 149.90176, 253, 4, 333, 0, 0, 0, 50, 140, 0, 1), 
(27355, 27355, "Lilim Slave Knight", 0, "", 0, "LineageMonster2.lilim_knight_10_sm", 11, 45, 51, "male", "L2Monster", 40, 1470.41596, 775.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 321.13207, 204.85194, 219.29157, 149.90176, 253, 4, 333, 5800, 5799, 0, 56, 180, 0, 1), 
(27356, 27356, "Lilim Stabber", 0, "", 0, "LineageMonster2.lilim_assassin_10_sm", 11, 36, 51, "male", "L2Monster", 40, 1470.41596, 775.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 321.13207, 204.85194, 219.29157, 149.90176, 253, 4, 333, 229, 229, 0, 36, 190, 0, 1), 
(27357, 27357, "Lilim Seer", 0, "", 0, "LineageMonster2.lilim_wizard_10_sm", 8, 30.6, 51, "female", "L2Monster", 40, 1470.41596, 775.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 321.13207, 204.85194, 219.29157, 149.90176, 253, 4, 333, 0, 0, 0, 50, 140, 0, 1), 
(27358, 27358, "Lilim Knight", 0, "", 0, "LineageMonster2.lilim_knight_10_sm", 11, 45, 51, "male", "L2Monster", 40, 1470.41596, 775.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 321.13207, 204.85194, 219.29157, 149.90176, 253, 4, 333, 5800, 5799, 0, 56, 180, 0, 1), 
(27359, 27359, "Lilim Assassin", 0, "", 0, "LineageMonster2.lilim_assassin_10_bi", 13, 44, 51, "male", "L2Monster", 40, 1470.41596, 775.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 321.13207, 204.85194, 219.29157, 149.90176, 253, 4, 333, 234, 234, 0, 36, 190, 0, 1), 
(27360, 27360, "Lilim Great Magus", 0, "", 0, "LineageMonster2.lilim_wizard_10_bi", 10, 37.5, 51, "female", "L2Monster", 40, 1470.41596, 775.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 321.13207, 204.85194, 219.29157, 149.90176, 253, 4, 333, 0, 0, 0, 50, 140, 0, 1), 
(27361, 27361, "Lilim Guard Knight", 0, "", 0, "LineageMonster2.lilim_knight_10_bi", 13, 55, 51, "male", "L2Monster", 40, 1470.41596, 775.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 321.13207, 204.85194, 219.29157, 149.90176, 253, 4, 333, 5800, 5799, 0, 56, 180, 0, 1), 
(27362, 27362, "Lilim Butcher", 0, "", 0, "LineageMonster2.lilim_assassin_10_sm", 11, 36, 61, "male", "L2Monster", 40, 1985.55926, 1066.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 501.08068, 252.49346, 342.17315, 184.76376, 253, 4, 333, 232, 232, 0, 36, 190, 0, 1), 
(27363, 27363, "Lilim Magus", 0, "", 0, "LineageMonster2.lilim_wizard_10_sm", 8, 30.6, 61, "female", "L2Monster", 40, 1985.55926, 1066.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 501.08068, 252.49346, 342.17315, 184.76376, 253, 4, 333, 0, 0, 0, 50, 140, 0, 1), 
(27364, 27364, "Lilim Slave Knight", 0, "", 0, "LineageMonster2.lilim_knight_10_sm", 11, 45, 61, "male", "L2Monster", 40, 1985.55926, 1066.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 501.08068, 252.49346, 342.17315, 184.76376, 253, 4, 333, 5800, 5799, 0, 56, 180, 0, 1), 
(27365, 27365, "Lilim Stabber", 0, "", 0, "LineageMonster2.lilim_assassin_10_sm", 11, 36, 61, "male", "L2Monster", 40, 1985.55926, 1066.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 501.08068, 252.49346, 342.17315, 184.76376, 253, 4, 333, 229, 229, 0, 36, 190, 0, 1), 
(27366, 27366, "Lilim Seer", 0, "", 0, "LineageMonster2.lilim_wizard_10_sm", 8, 30.6, 61, "female", "L2Monster", 40, 1985.55926, 1066.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 501.08068, 252.49346, 342.17315, 184.76376, 253, 4, 333, 0, 0, 0, 50, 140, 0, 1), 
(27367, 27367, "Lilim Knight", 0, "", 0, "LineageMonster2.lilim_knight_10_sm", 11, 45, 61, "male", "L2Monster", 40, 1985.55926, 1066.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 501.08068, 252.49346, 342.17315, 184.76376, 253, 4, 333, 5800, 5799, 0, 56, 180, 0, 1), 
(27368, 27368, "Lilim Assassin", 0, "", 0, "LineageMonster2.lilim_assassin_10_bi", 13, 44, 61, "male", "L2Monster", 40, 1985.55926, 1066.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 501.08068, 252.49346, 342.17315, 184.76376, 253, 4, 333, 234, 234, 0, 36, 190, 0, 1), 
(27369, 27369, "Lilim Great Magus", 0, "", 0, "LineageMonster2.lilim_wizard_10_bi", 10, 37.5, 61, "female", "L2Monster", 40, 1985.55926, 1066.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 501.08068, 252.49346, 342.17315, 184.76376, 253, 4, 333, 0, 0, 0, 50, 140, 0, 1), 
(27370, 27370, "Lilim Guard Knight", 0, "", 0, "LineageMonster2.lilim_knight_10_bi", 13, 55, 61, "male", "L2Monster", 40, 1985.55926, 1066.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 501.08068, 252.49346, 342.17315, 184.76376, 253, 4, 333, 5800, 5799, 0, 56, 180, 0, 1), 
(27371, 27371, "Lilim Butcher", 0, "", 0, "LineageMonster2.lilim_assassin_10_sm", 11, 36, 79, "male", "L2Monster", 40, 3127.824593, 1641, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 929.93081, 337.07008, 635.0222, 246.65326, 253, 4, 333, 232, 232, 0, 36, 190, 0, 1), 
(27372, 27372, "Lilim Magus", 0, "", 0, "LineageMonster2.lilim_wizard_10_sm", 8, 30.6, 79, "female", "L2Monster", 40, 3127.824593, 1641, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 929.93081, 337.07008, 635.0222, 246.65326, 253, 4, 333, 0, 0, 0, 50, 140, 0, 1), 
(27373, 27373, "Lilim Slave Knight", 0, "", 0, "LineageMonster2.lilim_knight_10_sm", 11, 45, 79, "male", "L2Monster", 40, 3127.824593, 1641, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 929.93081, 337.07008, 635.0222, 246.65326, 253, 4, 333, 5800, 5799, 0, 56, 180, 0, 1), 
(27374, 27374, "Shilen's Evil Thoughts", 0, "", 0, "LineageMonster5.leader_mind_of_silen", 20, 40, 79, "male", "L2Monster", 40, 3127.824593, 1641, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 929.93081, 337.07008, 635.0222, 246.65326, 253, 4, 333, 0, 0, 0, 45, 180, 0, 1), 
(27375, 27375, "Shilen's Evil Thoughts", 0, "", 0, "LineageMonster5.vicious_mind_of_silen", 14, 27.5, 79, "male", "L2Monster", 40, 3127.824593, 1641, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 929.93081, 337.07008, 635.0222, 246.65326, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(27376, 27376, "Lilim Knight", 0, "", 0, "LineageMonster2.lilim_knight_10_sm", 11, 45, 79, "male", "L2Monster", 40, 3127.824593, 1641, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 929.93081, 337.07008, 635.0222, 246.65326, 253, 4, 333, 5800, 5799, 0, 56, 180, 0, 1), 
(27377, 27377, "Lilim Assassin", 0, "", 0, "LineageMonster2.lilim_assassin_10_bi", 13, 44, 79, "male", "L2Monster", 40, 3127.824593, 1641, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 929.93081, 337.07008, 635.0222, 246.65326, 253, 4, 333, 234, 234, 0, 36, 190, 0, 1), 
(27378, 27378, "Lilim Great Magus", 0, "", 0, "LineageMonster2.lilim_wizard_10_bi", 10, 37.5, 79, "female", "L2Monster", 40, 3127.824593, 1641, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 929.93081, 337.07008, 635.0222, 246.65326, 253, 4, 333, 0, 0, 0, 50, 140, 0, 1), 
(27379, 27379, "Lilim Guard Knight", 0, "", 0, "LineageMonster2.lilim_knight_10_bi", 13, 55, 79, "male", "L2Monster", 40, 3127.824593, 1641, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 929.93081, 337.07008, 635.0222, 246.65326, 253, 4, 333, 5800, 5799, 0, 56, 180, 0, 1), 
(27380, 27380, "Reckless Sprite of Water", 0, "Quest Monster", 0, "LineageMonster.undine", 12, 27, 76, "female", "L2Monster", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 0, 0, 0, 60, 60, 0, 1), 
(27381, 27381, "Reckless Sprite of Air", 0, "Quest Monster", 0, "LineageMonster.sylph", 11, 35, 76, "female", "L2Monster", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 0, 0, 0, 60, 60, 0, 1), 
(27382, 27382, "Power of Seal Isolation", 0, "", 0, "LineageNPC.training_doll_150p", 13, 40, 51, "etc", "L2Monster", 40, 1470.41596, 775.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 321.13207, 204.85194, 219.29157, 149.90176, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(27383, 27383, "Power of Seal Isolation", 0, "", 0, "LineageNPC.training_doll_150p", 13, 40, 61, "etc", "L2Monster", 40, 1985.55926, 1066.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 501.08068, 252.49346, 342.17315, 184.76376, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(27384, 27384, "Seal Device", 0, "Emperor Shunaiman's", 0, "LineageNPCEV.ssq_sealing_emperor", 21, 24, 79, "female", "L2Monster", 40, 3127.824593, 1641, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 929.93081, 337.07008, 635.0222, 246.65326, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(27385, 27385, "Lilith", 0, "Holy Mother of Abyss", 0, "LineageMonster2.lilith", 42.5, 55, 85, "female", "L2Monster", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 45, 200, 0, 1), 
(27386, 27386, "Lilith's Steward", 0, "", 0, "LineageMonster2.lilim_wizard", 9, 34, 85, "female", "L2Monster", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 50, 190, 0, 1), 
(27387, 27387, "Lilith's Elite", 0, "", 0, "LineageMonster2.lilim_knight", 12, 50, 85, "male", "L2Monster", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 56, 220, 0, 1), 
(27388, 27388, "Anakim", 0, "Flames of Sacred Fire", 0, "LineageMonster2.anakim", 15.5, 29, 85, "female", "L2Monster", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 45, 200, 0, 1), 
(27389, 27389, "Anakim's Guardian", 0, "", 0, "LineageMonster2.nephilim_priest", 23, 40.5, 85, "male", "L2Monster", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 50, 190, 0, 1), 
(27390, 27390, "Anakim's Guard", 0, "", 0, "LineageMonster2.nephilim_lord", 12, 43, 85, "male", "L2Monster", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 65, 220, 0, 1), 
(27391, 27391, "Anakim's Executor", 0, "", 0, "LineageMonster2.nephilim_slayer", 12, 36, 85, "male", "L2Monster", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 65, 190, 0, 1), 
(27392, 27392, "Bloody Axe Aide", 0, "", 0, "LineageMonster.ol_mahum_champion", 14, 27, 65, "male", "L2Monster", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 582.81759, 271.89033, 397.98887, 198.95754, 253, 4, 333, 69, 19, 0, 50, 110, 0, 1), 
(27393, 27393, "Headless Knight", 0, "", 0, "LineageMonster.headless_knight", 21, 31, 65, "male", "L2Monster", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 582.81759, 271.89033, 397.98887, 198.95754, 253, 4, 333, 135, 0, 0, 70, 110, 0, 1), 
(27394, 27394, "Shilen's Evil Thoughts", 0, "", 0, "LineageNPC.training_doll_150p", 13, 40, 51, "etc", "L2Monster", 40, 1470.41596, 775.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 321.13207, 204.85194, 219.29157, 149.90176, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(27395, 27395, "Shilen's Evil Thoughts", 0, "", 0, "LineageNPC.training_doll_150p", 13, 40, 61, "etc", "L2Monster", 40, 1985.55926, 1066.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 501.08068, 252.49346, 342.17315, 184.76376, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(27396, 27396, "Shilen's Evil Thoughts", 0, "", 0, "LineageMonster5.vicious_mind_of_silen", 14, 27.5, 79, "male", "L2Monster", 40, 3127.824593, 1641, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 929.93081, 337.07008, 635.0222, 246.65326, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(27397, 27397, "Shilen's Evil Thoughts", 0, "", 0, "LineageNPC.training_doll_150p", 13, 40, 51, "etc", "L2Monster", 40, 1470.41596, 775.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 321.13207, 204.85194, 219.29157, 149.90176, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(27398, 27398, "Shilen's Evil Thoughts", 0, "", 0, "LineageNPC.training_doll_150p", 13, 40, 61, "etc", "L2Monster", 40, 1985.55926, 1066.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 501.08068, 252.49346, 342.17315, 184.76376, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(27399, 27399, "Shilen's Evil Thoughts", 0, "", 0, "LineageMonster5.vicious_mind_of_silen", 14, 27.5, 79, "male", "L2Monster", 40, 3127.824593, 1641, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 929.93081, 337.07008, 635.0222, 246.65326, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(27400, 27400, "Shilen's Evil Thoughts", 0, "", 0, "LineageNPC.training_doll_150p", 13, 40, 51, "etc", "L2Monster", 40, 1470.41596, 775.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 321.13207, 204.85194, 219.29157, 149.90176, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(27401, 27401, "Shilen's Evil Thoughts", 0, "", 0, "LineageNPC.training_doll_150p", 13, 40, 61, "etc", "L2Monster", 40, 1985.55926, 1066.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 501.08068, 252.49346, 342.17315, 184.76376, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(27402, 27402, "Shilen's Evil Thoughts", 0, "", 0, "LineageMonster5.vicious_mind_of_silen", 14, 27.5, 79, "male", "L2Monster", 40, 3127.824593, 1641, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 929.93081, 337.07008, 635.0222, 246.65326, 253, 4, 333, 0, 0, 0, 30, 180, 0, 1), 
(27403, 27403, "Trainee of Rest", 0, "", 0, "LineageMonster3.monk_warrior", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(27404, 27404, "Supplicant of Rest", 0, "", 0, "LineageMonster5.messenger_covenant_a", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(27405, 27405, "Monastic Pilgrim", 0, "", 0, "LineageMonster.angel_080p", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(27406, 27406, "Monastic Crusader", 0, "", 0, "LineageMonster.archangel_050p", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(27407, 27407, "Solina Lay Brother", 0, "", 0, "LineageMonster3.solina_brother", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(27408, 27408, "Savior Solina", 0, "", 0, "LineageMonster3.solina_father", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(27409, 27409, "Solina Knight Captain", 0, "", 0, "LineageMonster5.solina_knight", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(27410, 27410, "Solina Knights", 0, "", 0, "LineageMonster3.monk_warrior", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(27411, 27411, "Divinity Manager", 0, "", 0, "LineageMonster2.apostle_mage", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(27412, 27412, "Divinity Supervisor", 0, "", 0, "LineageMonster3.apostle_grail", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(27413, 27413, "Divinity Fighter", 0, "", 0, "LineageMonster5.guardian_covenant_a", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(27414, 27414, "Divinity Magus", 0, "", 0, "LineageMonster5.messenger_covenant_a", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(27415, 27415, "Guide Solina", 0, "", 0, "LineageMonster3.solina_brother", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(27416, 27416, "Relic Manager Golem", 0, "", 0, "LineageMonster3.golem_guardian_a", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(27417, 27417, "Mutant Archer", 0, "", 0, "LineageMonster.skeleton_archer", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(27418, 27418, "Mutant Warrior", 0, "", 0, "LineageMonster.skeleton_knight", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(27419, 27419, "Divinity Watcher", 0, "", 0, "LineageMonster5.guardian_covenant", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(27420, 27420, "Instructor Solina", 0, "", 0, "LineageMonster5.solina_knight", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(27421, 27421, "Creature of the Dusk", 0, "", 0, "LineageMonster.skeleton_royal_guard", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(27422, 27422, "Creature of the Dusk", 0, "", 0, "LineageMonster.banshee", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(27423, 27423, "Creature of the Dusk", 0, "", 0, "LineageMonster.skeleton_knight", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(27424, 27424, "Creature of the Dusk", 0, "", 0, "LineageMonster.skeleton_pikeman", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(29001, 29001, "Queen Ant", 0, "", 0, "LineageMonster.queen_ant", 45, 53, 40, "female", "L2GrandBoss", 40, 96596, 300.8, 208, 2.1, 60, 57, 73, 76, 70, 80, 2179536, 140740, 105, 1252, 8, 229, 253, 4, 333, 0, 0, 0, 80, 230, 0, 1), 
(29002, 29002, "Queen Ant Larva", 0, "", 0, "LineageMonster.ant_larva", 12, 8, 38, "male", "L2Monster", 40, 591.9, 315.1, 3.5, 1.5, 40, 43, 30, 21, 20, 20, 0, 1, 89.21, 118.72, 59.01, 84.16, 253, 4, 333, 0, 0, 0, 40, 60, 0, 1), 
(29003, 29003, "Nurse Ant", 0, "", 0, "LineageMonster.ant", 26, 15, 35, "male", "L2Monster", 40, 4000, 402.6, 108, 1.8, 40, 43, 30, 21, 20, 20, 0, 1, 637, 547, 395, 200, 253, 4, 333, 0, 0, 0, 40, 130, 0, 1), 
(29004, 29004, "Guard Ant", 0, "", 0, "LineageMonster.ant", 26, 15, 37, "male", "L2Monster", 40, 4343, 432.7, 115, 1.8, 40, 43, 30, 21, 20, 20, 0, 1, 178, 578, 27, 211, 253, 4, 333, 0, 0, 0, 40, 230, 0, 1), 
(29005, 29005, "Royal Guard Ant", 0, "", 0, "LineageMonster.ant", 26, 15, 39, "male", "L2Monster", 40, 7051, 463.3, 122, 1.8, 40, 43, 30, 21, 20, 20, 0, 1, 1190, 610, 1074, 223, 253, 4, 333, 0, 0, 0, 40, 230, 0, 1), 
(29006, 29006, "Core", 0, "", 0, "LineageNPC.core", 140, 75, 50, "male", "L2GrandBoss", 40, 261551.926, 1708.8, 441.65, 20, 60, 57, 73, 76, 70, 80, 2041407, 153786, 722.31, 1602, 1398.68, 293, 253, 4, 333, 0, 0, 0, 50, 110, 0, 1), 
(29007, 29007, "Death Knight", 0, "", 0, "LineageMonster.death_knight", 12, 31, 50, "male", "L2Monster", 40, 13817, 747.8, 166, 2.1, 40, 43, 30, 21, 20, 20, 0, 1, 410, 801, 69, 293, 253, 4, 333, 75, 0, 0, 27, 110, 0, 1), 
(29008, 29008, "Doom Wraith", 0, "", 0, "LineageMonster.death_blader", 15, 45, 55, "male", "L2Monster", 40, 16012, 889.8, 185, 2.4, 40, 43, 30, 21, 20, 20, 0, 1, 470, 895, 715, 327, 253, 4, 333, 1472, 0, 0, 100, 230, 0, 1), 
(29009, 29009, "Dicor", 0, "", 0, "LineageMonster.mandragora_b", 12, 25.5, 47, "female", "L2Monster", 40, 12544, 665, 154, 2.1, 40, 43, 30, 21, 20, 20, 0, 1, 354, 747, 60, 273, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(29010, 29010, "Validus", 0, "", 0, "LineageMonster.grave", 15, 29, 46, "male", "L2Monster", 40, 12130, 637.8, 150, 2.1, 40, 43, 30, 21, 20, 20, 0, 1, 337, 729, 58, 267, 253, 4, 333, 0, 0, 0, 70, 110, 0, 1), 
(29011, 29011, "Susceptor", 0, "", 0, "LineageMonster.susceptor", 20, 35, 49, "male", "L2Monster", 40, 13389, 720, 162, 2.1, 40, 43, 30, 21, 20, 20, 0, 1, 391, 783, 66, 286, 253, 4, 333, 0, 0, 0, 27, 150, 0, 1), 
(29012, 29012, "Perum", 0, "", 0, "LineageMonster.iron_golem", 18, 34, 48, "male", "L2Monster", 40, 12964, 692.4, 158, 2.1, 40, 43, 30, 21, 20, 20, 0, 1, 372, 765, 63, 280, 253, 4, 333, 0, 0, 0, 20, 20, 0, 1), 
(29013, 29013, "Premo", 0, "", 0, "LineageMonster.troll", 21, 35, 45, "male", "L2Monster", 40, 11721, 610.8, 146, 2.1, 40, 43, 30, 21, 20, 20, 0, 1, 320, 711, 55, 260, 253, 4, 333, 0, 0, 0, 55, 110, 0, 1), 
(29014, 29014, "Orfen", 0, "", 0, "LineageMonster.orfen", 35, 143, 50, "female", "L2GrandBoss", 40, 261551.926, 1708.8, 441.65, 20, 60, 57, 73, 76, 70, 80, 2041407, 153786, 722.31, 1602, 1398.68, 293, 253, 4, 333, 0, 0, 0, 60, 230, 0, 1), 
(29015, 29015, "Raikel", 0, "", 0, "LineageMonster.raikel", 37, 64, 48, "male", "L2Monster", 40, 6482, 692.4, 158, 2.1, 40, 43, 30, 21, 20, 20, 0, 1, 298, 765, 40, 280, 253, 4, 333, 0, 0, 0, 60, 230, 0, 1), 
(29016, 29016, "Raikel Leos", 0, "", 0, "LineageMonster.raikel", 37, 64, 49, "male", "L2Monster", 40, 6694, 720, 162, 2.1, 40, 43, 30, 21, 20, 20, 0, 1, 1058, 783, 1563, 286, 253, 4, 333, 0, 0, 0, 60, 230, 0, 1), 
(29017, 29017, "Riba", 0, "", 0, "LineageMonster.riba", 25, 72, 48, "female", "L2Monster", 40, 6482, 692.4, 158, 2.1, 40, 43, 30, 21, 20, 20, 0, 1, 298, 765, 40, 280, 253, 4, 333, 0, 0, 0, 60, 230, 0, 1), 
(29018, 29018, "Riba Iren", 0, "", 0, "LineageMonster.riba", 25, 72, 49, "female", "L2Monster", 40, 13389, 720, 162, 2.1, 40, 43, 30, 21, 20, 20, 0, 1, 1058, 783, 1563, 286, 253, 4, 333, 0, 0, 0, 60, 230, 0, 1), 
(29019, 29019, "Antharas", 0, "", 0, "LineageMonster.antaras", 300, 300, 79, "male", "L2GrandBoss", 40, 7500000, 18000, 1100, 99, 60, 57, 73, 76, 70, 80, 262720918, 29116376, 4900, 3840, 2550, 825, 253, 4, 333, 0, 0, 0, 50, 186, 0, 1), 
(29020, 29020, "Baium", 0, "", 0, "LineageMonster.baium", 65, 174, 75, "male", "L2GrandBoss", 40, 1709400, 18000, 750, 99, 60, 57, 73, 76, 70, 80, 10253400, 1081544, 3374.18, 3300, 2200, 2200, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(29021, 29021, "Archangel", 0, "", 0, "LineageMonster.archangel", 15, 80, 74, "male", "L2Monster", 80, 186915, 1475, 158, 3, 40, 43, 30, 21, 20, 20, 6571, 343, 1395, 5108, 371, 1686, 253, 4, 333, 93, 0, 0, 50, 170, 0, 1), 
(29022, 29022, "Zaken", 0, "", 0, "LineageMonster.zaken_night", 16, 32, 60, "male", "L2GrandBoss", 40, 360722, 180000, 346.8, 100, 60, 57, 73, 76, 70, 80, 4879746, 423589, 3616, 1981, 1520, 966.39, 253, 4, 333, 0, 0, 0, 42, 190, 0, 1), 
(29023, 29023, "Doll Blader", 0, "", 0, "LineageMonster.doll_blader", 6, 12, 58, "male", "L2Monster", 40, 1828, 832.4, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 442, 261, 302, 191, 253, 4, 333, 5129, 0, 0, 22, 150, 0, 1), 
(29024, 29024, "Vale master", 0, "", 0, "LineageMonster.vale_master", 12, 40, 59, "male", "L2Monster", 40, 1880, 861, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 461, 267, 315, 195, 253, 4, 333, 0, 0, 0, 70, 155, 0, 1), 
(29025, 29025, "Baium", 0, "", 0, "LineageNPC.baium_npc", 65, 82, 75, "male", "L2Npc", 40, 1709400, 18000, 718, 99, 60, 57, 73, 76, 70, 80, 0, 0, 1874.18, 3300, 1596.95, 2200, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(29026, 29026, "Pirate Zombie Captain", 0, "", 0, "LineageMonster.pirates_zombie_captain", 17, 28, 60, "male", "L2Monster", 40, 1933, 804, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 420, 272, 328, 199, 253, 8, 333, 232, 0, 0, 14, 140, 0, 1), 
(29027, 29027, "Pirate Zombie", 0, "", 0, "LineageMonster.pirates_zombie", 10, 23, 57, "male", "L2Monster", 40, 1776, 584, 6.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 371, 256, 289, 187, 253, 8, 333, 225, 0, 0, 11, 140, 0, 1), 
(29028, 29028, "Valakas", 0, "Fire Dragon", 0, "LineageMonster2.valakas", 190, 335, 85, "male", "L2GrandBoss", 40, 93742616.041853, 2025740.402194, 1836, 1000, 60, 57, 73, 76, 70, 80, 296105299, 29014318, 16100.98719, 4369.85702, 6669.68793, 1186.46237, 253, 1, 333, 0, 0, 0, 120, 300, 0, 1), 
(29029, 29029, "Lavasaurus Pustbon", 0, "", 0, "LineageMonster2.magmagoil_lad", 15, 75, 85, "male", "L2Monster", 1100, 4129.702134, 1980.303045, 67.006994, 3.96, 40, 43, 30, 21, 20, 20, 0, 0, 2670.36038, 388.15047, 812.45494, 284.03167, 253, 8, 333, 0, 0, 0, 1, 1, 0, 1), 
(29030, 29030, "Fenril Hound Kerinne", 0, "Family of Valakas", 0, "LineageMonster2.bandersnatch_20_bi", 21, 30, 84, "male", "L2RaidBoss", 40, 104586.37, 1657.536, 170.72, 9.7, 60, 57, 73, 76, 70, 80, 2407887, 1226568, 2512.3, 2681.953, 586.96652, 490.626, 253, 4, 333, 0, 0, 0, 30, 200, 0, 1), 
(29031, 29031, "Kerinne's Ifrit", 0, "", 0, "LineageMonster2.ifrit", 10, 42, 84, "male", "L2Monster", 40, 20648.928, 1607.808, 33.792, 3.84, 40, 43, 30, 21, 20, 20, 0, 0, 4864.32, 1310.88, 3386.88, 479.616, 253, 4, 333, 0, 0, 0, 38, 170, 0, 1), 
(29032, 29032, "Kerinne's Golem", 0, "", 0, "LineageMonster2.lava_golem", 22, 45, 84, "male", "L2Monster", 40, 2854.420948, 1607.808, 48, 3.84, 40, 43, 30, 21, 20, 20, 0, 0, 4864.32, 1310.88, 3386.88, 479.616, 253, 4, 333, 0, 0, 0, 13, 60, 0, 1), 
(29033, 29033, "Fenril Hound Freki", 0, "Family of Valakas", 0, "LineageMonster2.bandersnatch_20_bi", 21, 30, 84, "male", "L2RaidBoss", 40, 105872.34, 1708.14, 171.99, 9.8, 60, 57, 73, 76, 70, 80, 2434088, 1257012, 2593.57, 2742.236, 611.11393, 501.662, 253, 4, 333, 0, 0, 0, 30, 200, 0, 1), 
(29034, 29034, "Freki's Ifrit", 0, "", 0, "LineageMonster2.ifrit", 10, 42, 84, "male", "L2Monster", 40, 20917.08, 1657.536, 34.92, 3.88, 40, 43, 30, 21, 20, 20, 0, 0, 6682.718, 1340.9765, 6293.52579, 490.626, 253, 4, 333, 0, 0, 0, 38, 170, 0, 1), 
(29035, 29035, "Freki's Golem", 0, "", 0, "LineageMonster2.lava_golem", 22, 45, 84, "male", "L2Monster", 40, 20917.08, 1657.536, 34.92, 3.88, 40, 43, 30, 21, 20, 20, 0, 0, 5024.6, 1340.9765, 3539.6658, 490.626, 253, 4, 333, 0, 0, 0, 13, 60, 0, 1), 
(29036, 29036, "Fenril Hound Uruz", 0, "Family of Valakas", 0, "LineageMonster2.bandersnatch_20_bi", 21, 30, 84, "male", "L2RaidBoss", 40, 214199.37, 1759.626, 345.51, 9.9, 60, 57, 73, 76, 70, 80, 2466262, 1289662, 5351.94, 2802.591, 635.49861, 512.721, 253, 4, 333, 0, 0, 0, 30, 200, 0, 1), 
(29037, 29037, "Fenril Hound Kinaz", 0, "Family of Valakas", 0, "LineageMonster2.bandersnatch_20_bi", 21, 30, 84, "male", "L2RaidBoss", 40, 108266.5, 1812, 174, 10, 60, 57, 73, 76, 70, 80, 2504880, 1322688, 2759.5, 2863, 660.07304, 523.7, 253, 4, 333, 0, 0, 0, 30, 200, 0, 1), 
(29038, 29038, "Kinaz's Ifrit", 0, "", 0, "LineageMonster2.ifrit", 10, 42, 84, "male", "L2Monster", 40, 20917.08, 1657.536, 34.92, 3.88, 40, 43, 30, 21, 20, 20, 0, 0, 6682.718, 1340.9765, 6293.52579, 490.626, 253, 4, 333, 0, 0, 0, 38, 170, 0, 1), 
(29039, 29039, "Kinaz's Ifrit", 0, "", 0, "LineageMonster2.ifrit", 10, 42, 84, "male", "L2Monster", 40, 20917.08, 1657.536, 34.92, 3.88, 40, 43, 30, 21, 20, 20, 0, 0, 5024.6, 1340.9765, 3539.6658, 490.626, 253, 4, 333, 0, 0, 0, 38, 170, 0, 1), 
(29040, 29040, "Wings of Flame Ixion", 0, "Gatekeeper of Valakas", 0, "LineageMonster2.inferno_drake_20_bi", 29, 42, 84, "male", "L2RaidBoss", 40, 218741.76, 1865.268, 349.46, 10.1, 60, 57, 73, 76, 70, 80, 2535975, 1356048, 5688.32, 2923.243, 684.7873, 534.795, 253, 4, 333, 0, 0, 0, 57, 200, 0, 1), 
(29041, 29041, "Inferno Golem", 0, "", 0, "LineageMonster2.lava_golem", 22, 45, 84, "male", "L2Monster", 40, 20917.08, 1657.536, 34.92, 3.88, 40, 43, 30, 21, 20, 20, 0, 0, 10049.2, 1340.9765, 14158.6632, 490.626, 253, 4, 333, 0, 0, 0, 13, 60, 0, 1), 
(29042, 29042, "Inferno Golem", 0, "", 0, "LineageMonster2.lava_golem", 22, 45, 84, "male", "L2Monster", 40, 20917.08, 1657.536, 34.92, 3.88, 40, 43, 30, 21, 20, 20, 0, 0, 5024.6, 1340.9765, 3539.6658, 490.626, 253, 4, 333, 0, 0, 0, 13, 60, 0, 1), 
(29043, 29043, "Howling Ifrit", 0, "", 0, "LineageMonster2.ifrit", 10, 42, 84, "male", "L2Monster", 40, 20917.08, 1657.536, 34.92, 3.88, 40, 43, 30, 21, 20, 20, 0, 0, 5024.6, 1340.9765, 3539.6658, 490.626, 253, 4, 333, 0, 0, 0, 38, 170, 0, 1), 
(29044, 29044, "Howling Ifrit", 0, "", 0, "LineageMonster2.ifrit", 10, 42, 84, "male", "L2Monster", 40, 20917.08, 1657.536, 34.92, 3.88, 40, 43, 30, 21, 20, 20, 0, 0, 6682.718, 1340.9765, 6293.52579, 490.626, 253, 4, 333, 0, 0, 0, 38, 170, 0, 1), 
(29045, 29045, "Frintezza", 0, "", 0, "LineageMonster3.frintessa", 45, 42.7, 85, "male", "L2GrandBoss", 40, 428076.22993, 23423.903458, 2484.3, 3.15, 60, 57, 73, 76, 43, 80, 0, 0, 2641.63343, 4218.55484, 971.85659, 3093.60785, 253, 4, 333, 0, 0, 0, 30, 31, 0, 1), 
(29046, 29046, "Scarlet van Halisha", 0, "", 0, "LineageMonster3.follower_of_frintessa", 45, 90.7, 85, "male", "L2GrandBoss", 40, 2254518.097557, 11026.988297, 248.43, 109, 60, 57, 73, 76, 43, 80, 0, 0, 3135.9053, 1342.97453, 1442.51644, 2089.0715, 253, 4, 333, 8204, 0, 0, 240, 111, 0, 1), 
(29047, 29047, "Scarlet van Halisha", 0, "", 0, "LineageMonster3.follower_of_frintessa_tran", 92, 112.8, 85, "male", "L2GrandBoss", 40, 3842432.676332, 23156.675424, 248.43, 109, 60, 57, 73, 76, 43, 80, 130849003, 10028450, 8890.29153, 1566.80362, 8989.07258, 2193.52507, 253, 4, 333, 8222, 0, 0, 250, 155, 0, 1), 
(29048, 29048, "Evil Spirit", 0, "", 0, "LineageMonster3.Evilate", 40, 100, 85, "female", "L2Monster", 40, 82844.512664, 2177.289866, 1.03, 1.03, 40, 43, 30, 21, 20, 20, 0, 0, 1637.2108, 1637.38609, 1151.54283, 1091.59073, 253, 4, 333, 0, 0, 0, 10, 1, 0, 1), 
(29049, 29049, "Evil Spirit", 0, "", 0, "LineageMonster3.Evilate", 40, 100, 85, "female", "L2Monster", 40, 82844.512664, 2177.289866, 1.03, 1.03, 40, 43, 30, 21, 20, 20, 0, 0, 1637.2108, 1637.38609, 1151.54283, 1091.59073, 253, 4, 333, 0, 0, 0, 10, 1, 0, 1), 
(29050, 29050, "Breath of Halisha", 0, "", 0, "LineageMonster3.portrait_spirit", 23, 40, 85, "male", "L2Monster", 40, 12996.441242, 20560.269581, 1.01, 3.03, 40, 43, 30, 21, 20, 20, 0, 0, 1556.78629, 642.23687, 1073.71406, 428.15792, 253, 4, 333, 0, 0, 0, 30, 200, 0, 1), 
(29051, 29051, "Breath of Halisha", 0, "", 0, "LineageMonster3.portrait_spirit_winged", 23, 40, 85, "male", "L2Monster", 40, 12996.441242, 20560.269581, 1.01, 3.03, 40, 43, 30, 21, 20, 20, 0, 0, 1556.78629, 642.23687, 1073.71406, 428.15792, 253, 4, 333, 0, 0, 0, 30, 200, 0, 1), 
(29052, 29052, "", 0, "", 0, "LineageMonster3.Organ_Dummy", 1, 35, 85, "female", "L2Monster", 40, 3960.034064, 2056.828841, 8.585, 3.03, 40, 43, 30, 21, 20, 20, 0, 0, 1216.23929, 3864.96881, 838.83911, 2826.63526, 253, 4, 333, 0, 0, 0, 10, 1, 0, 1), 
(29053, 29053, "", 0, "", 0, "LineageMonster3.Follower_Dummy", 1, 58, 85, "female", "L2Monster", 40, 5448.837225, 2036.464199, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1456.32495, 383.42192, 994.48116, 280.57152, 253, 4, 333, 0, 0, 0, 10, 1, 0, 1), 
(29054, 29054, "Benom", 0, "Triol's Leader", 0, "LineageMonster3.benom", 20, 56, 75, "male", "L2RaidBoss", 40, 568382.4, 4071.06, 357, 8.1, 60, 57, 73, 76, 70, 80, 2499951, 1757872, 4510, 2554, 3279, 467.22, 253, 4, 333, 8203, 8203, 0, 79, 220, 0, 1), 
(29055, 29055, "Teleportation Cubic", 0, "", 0, "LineageNPC.teleport_npc", 40, 80, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(29056, 29056, "Ice Fairy Sirra", 0, "Raid Boss", 0, "LineageMonster3.ice_fairy", 16, 35.6, 60, "female", "L2RaidBoss", 40, 79149.92, 1036.8, 147.557641, 2.4, 60, 57, 73, 76, 70, 80, 1610848, 371722, 1277.93618, 1981.2, 434.60179, 362.44, 253, 4, 333, 0, 0, 0, 30, 190, 0, 1), 
(29057, 29057, "Sirra's Page", 0, "Raid Fighter", 0, "LineageMonster.sylph_110p", 12, 39.7, 59, "female", "L2Monster", 40, 7721.463, 1007, 57.96894, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 1181.243, 971.28, 386.9314, 355.36, 253, 1, 333, 0, 0, 0, 60, 190, 0, 1), 
(29058, 29058, "Sirra's Beholder", 0, "Raid Fighter", 0, "LineageMonster.field_stalker_20_bi", 18, 36, 59, "male", "L2Monster", 40, 3860.731, 1007, 57.96894, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 1181.241, 971.28, 386.9314, 355.36, 253, 4, 333, 0, 0, 0, 70, 190, 0, 1), 
(29059, 29059, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 80, "male", "L2Monster", 40, 3199.044944, 1939.14, 8.925, 3.15, 40, 43, 30, 21, 20, 20, 0, 0, 1032.2003, 379.87755, 740.10194, 277.9779, 253, 4, 333, 0, 0, 0, 1, 160, 0, 1), 
(29060, 29060, "Captain of the Ice Queen's Royal Guard", 0, "Raid Boss", 0, "LineageMonster.gargoyle_02te_120p", 19, 61, 59, "male", "L2RaidBoss", 40, 66183.96803, 1007, 124.219159, 2.4, 60, 57, 73, 76, 70, 80, 1749007, 397080, 1063.76651, 1942.56, 313.79637, 355.36, 253, 4, 333, 0, 0, 0, 140, 190, 0, 1), 
(29061, 29061, "Teleportation Cubic", 0, "", 0, "LineageNPC.teleport_npc_frin", 40, 80, 70, "etc", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(29062, 29062, "Andreas Van Halter", 0, "Seer of Pagan", 0, "LineageMonster3.heretic_priest_110p", 9, 21.3, 80, "male", "L2RaidBoss", 40, 115708.195, 2051.19, 364.87, 3.21, 60, 57, 73, 76, 70, 80, 2915973, 2380617, 3134.565, 3161.7216, 1241.64405, 578.3992, 253, 4, 333, 8208, 0, 0, 30, 210, 0, 1), 
(29063, 29063, "Andreas' Acolyte", 0, "Raid Fighter", 0, "LineageMonster3.heretic_privates", 7.7, 28.4, 80, "male", "L2Monster", 40, 15283.32804, 1994.708, 145.856, 3.18, 40, 43, 30, 21, 20, 20, 0, 0, 8120.81031, 1550.2288, 8457.09203, 567.1848, 253, 1, 333, 8205, 0, 0, 60, 200, 0, 1), 
(29064, 29064, "Andreas' Acolyte", 0, "Raid Fighter", 0, "LineageMonster3.heretic_privates_a", 7.7, 28.4, 80, "male", "L2Monster", 40, 22740.48, 1939.14, 145.32, 3.15, 40, 43, 30, 21, 20, 20, 0, 0, 5913.6, 1519.518, 4557.735, 555.954, 253, 4, 333, 8207, 8207, 0, 58, 200, 0, 1), 
(29065, 29065, "Sailren", 0, "Sealed Evil Power", 0, "LineageMonster3.sailren", 100, 82.1, 80, "male", "L2RaidBoss", 40, 689061.278162, 2051.19, 264.82407, 3.21, 60, 57, 73, 76, 70, 80, 4569145, 592766, 3316.12759, 1185.644, 1426.64875, 578.3992, 253, 1, 333, 0, 0, 0, 41, 185, 0, 1), 
(29066, 29066, "Antharas", 0, "", 0, "LineageMonster.antaras", 300, 300, 79, "male", "L2GrandBoss", 40, 6100000, 1800000, 1100, 1000, 60, 57, 73, 76, 70, 80, 262720918, 29116376, 4900, 3456, 2550, 862.5, 253, 4, 333, 0, 0, 0, 50, 186, 0, 1), 
(29067, 29067, "Antharas", 0, "", 0, "LineageMonster.antaras", 300, 300, 79, "male", "L2GrandBoss", 40, 6800000, 1800000, 1100, 1000, 60, 57, 73, 76, 70, 80, 354676030, 39307416, 4900, 3456, 2550, 862.5, 253, 4, 333, 0, 0, 0, 50, 186, 0, 1), 
(29068, 29068, "Antharas", 0, "Earth Dragon", 0, "LineageMonster.antaras", 300, 300, 85, "male", "L2GrandBoss", 40, 85998875.663273, 1800000, 1830, 1000, 60, 57, 73, 76, 70, 80, 538538585, 52769503, 13352.75508, 4748.07779, 4596.82031, 1184.95863, 253, 4, 333, 0, 0, 0, 50, 186, 0, 1), 
(29069, 29069, "Behemoth Dragon", 0, "", 0, "LineageMonster3.antaras_ex_a", 63, 54, 85, "male", "L2Monster", 40, 401551.69672, 1809, 76.71, 3, 60, 57, 73, 76, 70, 80, 0, 0, 3584.56902, 1071.29474, 1386.66, 522.62686, 253, 4, 333, 0, 0, 0, 180, 180, 0, 1), 
(29070, 29070, "Dragon Bomber", 0, "", 0, "LineageMonster3.antaras_ex_b_80p", 37, 28, 85, "male", "L2Monster", 40, 1353.6766, 1809, 8.5, 3, 60, 57, 73, 76, 70, 80, 0, 0, 1094.11758, 357.09825, 4902.24, 261.309, 253, 4, 333, 0, 0, 0, 200, 250, 0, 1), 
(29071, 29071, "Dragon Bomber", 0, "", 0, "LineageMonster3.antaras_ex_b_80p", 37, 28, 78, "male", "L2Monster", 40, 1000, 1607.4, 8.5, 3, 60, 57, 73, 76, 70, 80, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 200, 245, 0, 1), 
(29072, 29072, "Dragon Bomber", 0, "", 0, "LineageMonster3.antaras_ex_b_80p", 37, 28, 78, "male", "L2Monster", 40, 1000, 1607.4, 8.5, 3, 60, 57, 73, 76, 70, 80, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 200, 255, 0, 1), 
(29073, 29073, "Dragon Bomber", 0, "", 0, "LineageMonster3.antaras_ex_b_80p", 37, 28, 78, "male", "L2Monster", 40, 1000, 1607.4, 8.5, 3, 60, 57, 73, 76, 70, 80, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 200, 247, 0, 1), 
(29074, 29074, "Dragon Bomber", 0, "", 0, "LineageMonster3.antaras_ex_b_80p", 37, 28, 78, "male", "L2Monster", 40, 1000, 1607.4, 8.5, 3, 60, 57, 73, 76, 70, 80, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 200, 252, 0, 1), 
(29075, 29075, "Dragon Bomber", 0, "", 0, "LineageMonster3.antaras_ex_b_80p", 37, 28, 78, "male", "L2Monster", 40, 1000, 1607.4, 8.5, 3, 60, 57, 73, 76, 70, 80, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 200, 243, 0, 1), 
(29076, 29076, "Dragon Bomber", 0, "", 0, "LineageMonster3.antaras_ex_b", 42, 34.5, 85, "male", "L2Monster", 40, 1353.6766, 1809, 8.5, 3, 60, 57, 73, 76, 70, 80, 0, 0, 1094.11758, 357.09825, 4902.24, 261.309, 253, 4, 333, 0, 0, 0, 200, 250, 0, 1), 
(29077, 29077, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 78, "male", "L2Monster", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 20, 0, 1), 
(29078, 29078, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 78, "male", "L2Monster", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 20, 0, 1), 
(29079, 29079, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 78, "male", "L2Monster", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 20, 0, 1), 
(29080, 29080, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 78, "male", "L2Monster", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 20, 0, 1), 
(29081, 29081, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 78, "male", "L2Monster", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 20, 0, 1), 
(29082, 29082, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 78, "male", "L2Monster", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 20, 0, 1), 
(29083, 29083, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 78, "male", "L2Monster", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 20, 0, 1), 
(29084, 29084, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 78, "male", "L2Monster", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 20, 0, 1), 
(29085, 29085, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 78, "male", "L2Monster", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 20, 0, 1), 
(29086, 29086, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 78, "male", "L2Monster", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 20, 0, 1), 
(29087, 29087, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 78, "male", "L2Monster", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 20, 0, 1), 
(29088, 29088, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 78, "male", "L2Monster", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 20, 0, 1), 
(29089, 29089, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 78, "male", "L2Monster", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 20, 0, 1), 
(29090, 29090, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 78, "male", "L2Monster", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 20, 0, 1), 
(29091, 29091, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 78, "male", "L2Monster", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 20, 0, 1), 
(29092, 29092, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 78, "male", "L2Monster", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 20, 0, 1), 
(29093, 29093, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 78, "male", "L2Monster", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 20, 0, 1), 
(29094, 29094, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 78, "male", "L2Monster", 40, 2802.89989, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 855.81387, 332.70061, 584.40994, 243.45587, 253, 4, 333, 0, 0, 0, 1, 20, 0, 1), 
(29095, 29095, "Gordon", 0, "Knight of Destruction", 0, "LineageMonster3.Cruel_Rider", 43, 46.6, 80, "male", "L2RaidBoss", 40, 961780.701912, 2051.19, 369.613703, 3.21, 60, 57, 73, 76, 70, 80, 5885017, 1455305, 6129.55481, 1185.644, 4888.35448, 578.3992, 253, 4, 333, 0, 0, 0, 60, 190, 0, 1), 
(29096, 29096, "Anais", 0, "Lord of Splendor", 0, "LineageMonster3.solina_priest_120p", 16, 41.8, 80, "male", "L2RaidBoss", 40, 480890.350956, 2051.19, 147.845481, 3.21, 60, 57, 73, 76, 70, 80, 8827525, 2036475, 3064.77741, 1185.644, 1222.08862, 578.3992, 253, 4, 333, 8214, 0, 0, 60, 160, 0, 1), 
(29097, 29097, "Splendor Disciple", 0, "Raid Fighter", 0, "LineageMonster3.apostle_grail", 13, 47, 80, "male", "L2Monster", 40, 37734.340484, 1994.708, 145.013611, 3.18, 40, 43, 30, 21, 20, 20, 0, 0, 6012.14777, 581.33612, 4732.40644, 567.1848, 253, 4, 333, 8221, 0, 0, 30, 190, 0, 1), 
(29098, 29098, "Splendor Worshiper", 0, "Raid Fighter", 0, "LineageMonster3.apostle_grail_a", 13, 47, 80, "male", "L2Monster", 40, 50564.016249, 1994.708, 145.013611, 3.18, 40, 43, 30, 21, 20, 20, 0, 0, 6012.14777, 581.33612, 4732.40644, 567.1848, 253, 1, 333, 0, 0, 0, 30, 190, 0, 1), 
(29099, 29099, "Baylor", 0, "Warden", 0, "LineageMonster4.Barler", 54, 77.5, 83, "male", "L2GrandBoss", 40, 1078413.494624, 100000, 100.862738, 1000, 60, 57, 73, 76, 70, 80, 3190205, 2191683, 2098.52696, 1415.44576, 1433.02187, 1035.7618, 253, 4, 333, 0, 0, 0, 34, 180, 0, 1), 
(29100, 29100, "Crystal Prison Guard", 0, "", 0, "LineageMonster4.eyeless", 36, 43.5, 83, "male", "L2Monster", 40, 18734.280667, 1777.4, 190.897046, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1771.53858, 566.1783, 1209.73119, 414.30472, 253, 4, 333, 0, 0, 0, 60, 210, 0, 1), 
(29101, 29101, "Crystalline Golem", 0, "", 0, "LineageMonster4.Crystal_Golem", 34, 47, 83, "male", "L2Monster", 40, 112316.374696, 1777.4, 190.745373, 3, 40, 43, 30, 21, 20, 20, 0, 0, 949.52401, 353.86144, 648.40181, 258.94045, 253, 4, 333, 0, 0, 0, 54, 170, 0, 1), 
(29102, 29102, "Crystalline Golem", 0, "", 0, "LineageMonster4.Crystal_Golem", 34, 47, 83, "male", "L2Monster", 40, 2985.1835, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 949.52401, 353.86144, 648.40181, 258.94045, 253, 4, 333, 0, 0, 0, 54, 170, 0, 1), 
(29103, 29103, "Baylor", 0, "Warden", 0, "LineageMonster4.Barler", 54, 77.5, 83, "male", "L2Monster", 40, 2985.1835, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 949.52401, 353.86144, 648.40181, 258.94045, 253, 4, 333, 0, 0, 0, 34, 180, 0, 1), 
(29104, 29104, "Crystal Prison Guard", 0, "", 0, "LineageMonster4.eyeless", 36, 43.5, 83, "male", "L2Monster", 40, 2985.1835, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 949.52401, 353.86144, 648.40181, 258.94045, 253, 4, 333, 0, 0, 0, 60, 210, 0, 1), 
(29105, 29105, "Crystalline Golem", 0, "", 0, "LineageMonster4.Crystal_Golem", 34, 47, 83, "male", "L2Monster", 40, 2985.1835, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 949.52401, 353.86144, 648.40181, 258.94045, 253, 4, 333, 0, 0, 0, 54, 170, 0, 1), 
(29106, 29106, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 83, "male", "L2Npc", 40, 2985.1835, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 949.52401, 353.86144, 648.40181, 258.94045, 253, 4, 333, 0, 0, 0, 1, 100, 0, 1), 
(29107, 29107, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 83, "male", "L2Npc", 40, 1, 1, 1, 1, 40, 43, 30, 21, 20, 20, 0, 0, 1, 1, 1, 1, 253, 4, 333, 0, 0, 0, 1, 100, 0, 1), 
(29108, 29108, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 83, "male", "L2Npc", 40, 1, 1, 1, 1, 40, 43, 30, 21, 20, 20, 0, 0, 1, 1, 1, 1, 253, 4, 333, 0, 0, 0, 1, 100, 0, 1), 
(29109, 29109, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 83, "male", "L2Npc", 40, 1, 1, 1, 1, 40, 43, 30, 21, 20, 20, 0, 0, 1, 1, 1, 1, 253, 4, 333, 0, 0, 0, 1, 100, 0, 1), 
(29110, 29110, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 83, "male", "L2Npc", 40, 1, 1, 1, 1, 40, 43, 30, 21, 20, 20, 0, 0, 1, 1, 1, 1, 253, 4, 333, 0, 0, 0, 1, 100, 0, 1), 
(29111, 29111, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 83, "male", "L2Npc", 40, 1, 1, 1, 1, 40, 43, 30, 21, 20, 20, 0, 0, 1, 1, 1, 1, 253, 4, 333, 0, 0, 0, 1, 100, 0, 1), 
(29112, 29112, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 83, "male", "L2Npc", 40, 1, 1, 1, 1, 40, 43, 30, 21, 20, 20, 0, 0, 1, 1, 1, 1, 253, 4, 333, 0, 0, 0, 1, 100, 0, 1), 
(29113, 29113, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 83, "male", "L2Npc", 40, 1, 1, 1, 1, 40, 43, 30, 21, 20, 20, 0, 0, 1, 1, 1, 1, 253, 4, 333, 0, 0, 0, 1, 100, 0, 1), 
(29114, 29114, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 83, "male", "L2Npc", 40, 1, 1, 1, 1, 40, 43, 30, 21, 20, 20, 0, 0, 1, 1, 1, 1, 253, 4, 333, 0, 0, 0, 1, 100, 0, 1), 
(29115, 29115, "Crystal Prison Guard", 0, "", 0, "LineageMonster4.eyeless_080p", 34, 35, 83, "male", "L2Monster", 40, 2985.1835, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 949.52401, 353.86144, 648.40181, 258.94045, 253, 4, 333, 0, 0, 0, 60, 210, 0, 1), 
(29116, 29116, "Baylor's Treasure Chest", 0, "", 0, "LineageMonster.mimic_even", 8.5, 8.5, 83, "male", "L2Monster", 40, 2985.1835, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 949.52401, 353.86144, 648.40181, 258.94045, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(29117, 29117, "Baylor's Treasure Chest", 0, "", 0, "LineageMonster.mimic_even", 8.5, 8.5, 83, "male", "L2Monster", 40, 2985.1835, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 949.52401, 353.86144, 648.40181, 258.94045, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(29118, 29118, "Beleth", 0, "", 0, "LineageMonster4.bereth_key", 15, 30, 83, "male", "L2GrandBoss", 40, 2603600, 1000000, 200, 1000, 40, 43, 30, 21, 20, 20, 16447437, 1362651, 4000, 590, 2300, 650, 253, 4, 333, 0, 0, 0, 60, 160, 0, 1), 
(29119, 29119, "Beleth", 0, "", 0, "LineageMonster4.bereth", 15, 30, 83, "male", "L2Monster", 40, 994600, 1000000, 200, 1000, 40, 43, 30, 21, 20, 20, 0, 0, 4000, 590, 2300, 650, 253, 4, 333, 0, 0, 0, 60, 160, 0, 1), 
(29120, 29120, "Beleth Camera 1", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(29121, 29121, "Beleth Camera 2", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(29122, 29122, "Beleth Camera 3", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(29123, 29123, "Beleth Camera 4", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(29124, 29124, "Beleth Camera 5", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(29125, 29125, "Beleth Camera 6", 0, "", 0, "LineageNPC2.bereth_entry", 8.5, 25, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 60, 150, 0, 1), 
(29126, 29126, "Beleth Presentation Incarnation 1", 0, "", 0, "LineageMonster4.bereth", 15, 30, 80, "male", "L2Npc", 80, 2880.37628, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 894.75854, 341.375, 611.00409, 249.80341, 253, 4, 333, 0, 0, 0, 60, 160, 0, 1), 
(29127, 29127, "Beleth Presentation Incarnation 2", 0, "", 0, "LineageMonster4.bereth", 15, 30, 80, "male", "L2Npc", 80, 2880.37628, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 894.75854, 341.375, 611.00409, 249.80341, 253, 4, 333, 0, 0, 0, 60, 160, 0, 1), 
(29128, 29128, "Beleth Presentation Elf", 0, "", 0, "LineageNPC2.bereth_fake", 7, 22.2, 80, "male", "L2Npc", 40, 2880.37628, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 894.75854, 341.375, 611.00409, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(29129, 29129, "Lost Captain", 0, "", 0, "LineageMonster.oel_mahum_champion_05te_120p", 48, 73.5, 29, "male", "L2RaidBoss", 40, 51627.923603, 315.12, 9.658559, 1.5, 60, 57, 73, 76, 70, 80, 5013133, 233765, 499.6902, 1035.05382, 113.74121, 504.96, 253, 4, 333, 0, 0, 0, 84, 120, 0, 1), 
(29130, 29130, "Lost Guard", 0, "", 0, "LineageMonster.oel_mahum_warrior", 20, 38, 29, "male", "L2Monster", 40, 3243.991149, 315.12, 4.829279, 1.5, 40, 43, 30, 21, 20, 20, 0, 0, 249.8451, 172.50897, 170.61181, 84.16, 253, 4, 333, 72, 0, 0, 70, 160, 0, 1), 
(29131, 29131, "Lost Assistant Guard", 0, "", 0, "LineageMonster.oel_mahum_witch_doctor", 15, 34, 29, "male", "L2Monster", 40, 3243.991149, 315.12, 4.829279, 7.5, 40, 43, 30, 21, 20, 20, 0, 0, 166.5634, 172.50897, 113.74121, 84.16, 253, 4, 333, 201, 0, 0, 70, 130, 0, 1), 
(29132, 29132, "Lost Captain", 0, "", 0, "LineageMonster3.Zenta_Lizardman_Raid_120p", 40, 45.5, 39, "female", "L2RaidBoss", 40, 84512.175068, 463.32, 14.123486, 1.8, 60, 57, 73, 76, 70, 80, 4952216, 390467, 1067.15458, 1372.20768, 242.90941, 669.42, 253, 4, 333, 0, 0, 0, 48, 170, 0, 1), 
(29133, 29133, "Lost Guard", 0, "", 0, "LineageMonster.zenta_lizardman_warrior", 13, 35, 39, "male", "L2Monster", 80, 5180.057487, 463.32, 7.061743, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 533.57729, 228.70128, 364.36411, 111.57, 253, 4, 333, 16, 0, 0, 40, 140, 0, 1), 
(29134, 29134, "Lost Assistant Guard", 0, "", 0, "LineageMonster.zenta_lizardman_shaman", 13, 35, 39, "male", "L2Monster", 40, 5180.057487, 463.32, 7.061743, 9, 40, 43, 30, 21, 20, 20, 0, 0, 355.71819, 228.70128, 242.90941, 111.57, 253, 4, 333, 7, 0, 0, 43, 120, 0, 1), 
(29135, 29135, "Lost Captain", 0, "", 0, "LineageMonster3.Steel_Trapper_120p", 45, 56, 49, "male", "L2RaidBoss", 40, 138394.422441, 720, 21.125446, 2.1, 60, 57, 73, 76, 70, 80, 6038762, 629275, 2091.75485, 1760.96718, 476.13246, 859.08, 253, 4, 333, 0, 0, 0, 60, 160, 0, 1), 
(29136, 29136, "Lost Guard", 0, "", 0, "LineageMonster3.golem_cannon_catapult_a", 23.5, 34.7, 49, "male", "L2Monster", 40, 8290.657251, 720, 10.562723, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 1045.87742, 293.49453, 714.19868, 143.18, 253, 4, 333, 0, 0, 0, 130, 160, 0, 1), 
(29137, 29137, "Lost Assistant Guard", 0, "", 0, "LineageMonster3.golem_repair", 23, 32.8, 49, "male", "L2Monster", 40, 8290.657251, 720, 10.562723, 10.5, 40, 43, 30, 21, 20, 20, 0, 0, 697.25162, 293.49453, 476.13246, 143.18, 253, 4, 333, 0, 0, 0, 72, 190, 0, 1), 
(29138, 29138, "Lost Captain", 0, "", 0, "LineageMonster.headless_knight_170p", 35, 54.5, 59, "male", "L2RaidBoss", 40, 196694.915642, 1007, 28.07804, 2.4, 60, 57, 73, 76, 70, 80, 7188264, 860647, 3637.52664, 2185.34337, 827.98638, 1066.08, 253, 4, 333, 135, 0, 0, 70, 150, 0, 1), 
(29139, 29139, "Lost Guard", 0, "", 0, "LineageMonster.dark_horror_bi", 20, 42, 59, "male", "L2Monster", 40, 11637.145375, 1007, 14.03902, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 1818.76332, 364.2239, 1241.97958, 177.68, 253, 4, 333, 0, 0, 0, 100, 100, 0, 1), 
(29140, 29140, "Lost Assistant Guard", 0, "", 0, "LineageMonster.dark_horror_bi", 20, 42, 59, "male", "L2Monster", 40, 11637.145375, 1007, 14.03902, 12, 40, 43, 30, 21, 20, 20, 0, 0, 1212.50888, 364.2239, 827.98638, 177.68, 253, 4, 333, 0, 0, 0, 100, 100, 0, 1), 
(29141, 29141, "Lost Captain", 0, "", 0, "LineageMonster2.ketra_warbeast_130p", 40, 45, 69, "male", "L2RaidBoss", 40, 239746.726642, 1314, 32.463536, 2.7, 60, 57, 73, 76, 70, 80, 8315797, 1112310, 5466.50387, 2620.35567, 1244.30451, 1278.3, 253, 4, 333, 0, 0, 0, 38, 150, 0, 1), 
(29142, 29142, "Lost Guard", 0, "", 0, "LineageMonster4.eyeless", 36, 43.5, 69, "male", "L2Monster", 40, 14118.840659, 1314, 16.231768, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 2733.25193, 436.72595, 1866.45677, 213.05, 253, 4, 333, 0, 0, 0, 60, 210, 0, 1), 
(29143, 29143, "Lost Assistant Guard", 0, "", 0, "LineageMonster4.eyeless", 36, 43.5, 69, "male", "L2Monster", 40, 14118.840659, 1314, 16.231768, 13.5, 40, 43, 30, 21, 20, 20, 0, 0, 1822.16796, 436.72595, 1244.30451, 213.05, 253, 4, 333, 0, 0, 0, 60, 210, 0, 1), 
(29144, 29144, "Lost Captain", 0, "", 0, "LineageMonster.archangel", 15, 80, 78, "male", "L2RaidBoss", 80, 267072.719256, 1607.4, 35.161357, 3, 60, 57, 73, 76, 70, 80, 12606595, 1625206, 6825.89686, 2994.30549, 1553.73426, 1460.76, 253, 4, 333, 97, 0, 0, 50, 170, 0, 1), 
(29145, 29145, "Lost Guard", 0, "", 0, "LineageMonster3.apostle_grail", 13, 47, 78, "male", "L2Monster", 40, 15710.076268, 1607.4, 17.580679, 3, 40, 43, 30, 21, 20, 20, 0, 0, 3412.94843, 499.05092, 2330.60138, 243.46, 253, 4, 333, 8221, 0, 0, 30, 220, 0, 1), 
(29146, 29146, "Lost Assistant Guard", 0, "", 0, "LineageMonster2.apostle_mage", 11, 38.5, 78, "male", "L2Monster", 40, 15710.076268, 1607.4, 17.580679, 15, 40, 43, 30, 21, 20, 20, 0, 0, 2275.29895, 499.05092, 1553.73426, 243.46, 253, 4, 333, 6718, 0, 0, 50, 165, 0, 1), 
(29147, 29147, "Lost Captain", 0, "", 0, "LineageMonster3.Drake_Raid", 44, 51.5, 81, "male", "L2RaidBoss", 40, 275376.592431, 1708.8, 36.164973, 3, 60, 57, 73, 76, 70, 80, 12961356, 1669147, 7108.00718, 3110.50143, 1617.94916, 1517.4, 253, 4, 333, 0, 0, 0, 60, 170, 0, 1), 
(29148, 29148, "Lost Guard", 0, "", 0, "LineageMonster3.antaras_ex_b", 42, 34.5, 81, "male", "L2Monster", 40, 16197.334, 1708.8, 18.082486, 3, 40, 43, 30, 21, 20, 20, 0, 0, 3554.00359, 518.41691, 2426.92374, 252.9, 253, 4, 333, 0, 0, 0, 200, 200, 0, 1), 
(29149, 29149, "Lost Assistant Guard", 0, "", 0, "LineageMonster3.antaras_ex_b", 42, 34.5, 81, "male", "L2Monster", 40, 16197.334, 1708.8, 18.082486, 15, 40, 43, 30, 21, 20, 20, 0, 0, 2369.33573, 518.41691, 1617.94916, 252.9, 253, 4, 333, 0, 0, 0, 200, 200, 0, 1), 
(29150, 29150, "Ekimus", 0, "Lord of Immortality", 0, "LineageMonster4.echmus", 25, 70, 82, "male", "L2GrandBoss", 40, 1178416.991421, 184680, 1754.50098, 1000, 60, 57, 73, 76, 70, 80, 0, 0, 2054.09667, 12734.94253, 1506.05547, 8471.70752, 253, 4, 333, 0, 0, 0, 60, 200, 0, 1), 
(29151, 29151, "Feral Hound of the Netherworld", 0, "", 0, "LineageMonster4.voidhound_080p", 64, 48.4, 82, "male", "L2Monster", 40, 4234.063127, 184680, 8.5, 1000, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 60, 200, 0, 1), 
(29152, 29152, "Feral Hound of the Netherworld", 0, "", 0, "LineageMonster4.voidhound_080p", 64, 48.4, 82, "male", "L2Monster", 40, 4234.063127, 184680, 8.5, 1000, 40, 43, 30, 21, 20, 20, 0, 0, 2083.46395, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 60, 200, 0, 1), 
(29153, 29153, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 73, "male", "L2Npc", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(29154, 29154, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 73, "male", "L2Npc", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(29155, 29155, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 73, "male", "L2Npc", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(29156, 29156, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 73, "male", "L2Npc", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(29157, 29157, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 73, "male", "L2Npc", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(29158, 29158, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 73, "male", "L2Npc", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(29159, 29159, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 73, "male", "L2Npc", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(29160, 29160, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 73, "male", "L2Npc", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(29161, 29161, "Pre-Awakened Ekimus", 0, "", 0, "LineageMonster4.echmus_born", 25, 70, 73, "male", "L2Npc", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 0, 0, 0, 60, 200, 0, 1), 
(29162, 29162, "Soldiers of Bravery", 0, "Tiat's Bodyguards", 0, "LineageMonster4.dragon_rider", 36, 51, 82, "male", "L2Monster", 80, 334640.100173, 184680, 187.260794, 1000, 40, 43, 30, 21, 20, 20, 0, 0, 7904.12814, 578.86102, 5397.49488, 635.37806, 253, 4, 333, 0, 0, 0, 60, 200, 0, 1), 
(29163, 29163, "Tiat", 0, "Witch of the Dragon of Darkness", 0, "LineageMonster4.tiat", 55, 104, 82, "female", "L2GrandBoss", 40, 5523846.14459, 184680, 548.283698, 1000, 60, 57, 73, 76, 70, 80, 0, 0, 3093.77457, 530.62261, 2112.64698, 352.98781, 253, 4, 333, 0, 0, 0, 80, 200, 0, 1), 
(29164, 29164, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 73, "male", "L2Npc", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(29165, 29165, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 73, "male", "L2Npc", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(29166, 29166, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 73, "male", "L2Npc", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(29167, 29167, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 73, "male", "L2Npc", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(29168, 29168, "", 0, "", 0, "LineageMonster4.tiat", 55, 104, 73, "female", "L2Npc", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 0, 0, 0, 80, 200, 0, 1), 
(29169, 29169, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 73, "male", "L2Monster", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(29170, 29170, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 73, "male", "L2Npc", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(29171, 29171, "", 0, "", 0, "LineageNpcEV.tiat_release_effect", 0.01, 160, 73, "female", "L2Npc", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(29172, 29172, "", 0, "", 0, "LineageNpcEV.tiat_change_effect", 0.01, 160, 73, "female", "L2Npc", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(29173, 29173, "Tiat Priest", 0, "", 0, "LineageNPC2.tiat_oracle", 8, 25, 73, "female", "L2Npc", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 0, 0, 0, 50, 50, 0, 1), 
(29174, 29174, "Tiat Priest", 0, "", 0, "LineageNPC2.tiat_oracle", 8, 25, 73, "female", "L2Npc", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 0, 0, 0, 50, 50, 0, 1), 
(29175, 29175, "Tiat", 0, "Witch of the Dragon of Darkness", 0, "LineageMonster4.tiat", 55, 104, 82, "female", "L2GrandBoss", 40, 5523846.14459, 184680, 548.283698, 1000, 60, 57, 73, 76, 70, 80, 11480335, 4460470, 3093.77457, 530.62261, 2112.64698, 352.98781, 253, 4, 333, 0, 0, 0, 80, 200, 0, 1), 
(29176, 29176, "Zaken", 0, "", 0, "LineageMonster.zaken", 16, 32, 60, "male", "L2GrandBoss", 40, 90456.5, 30000, 337, 200, 60, 57, 73, 76, 70, 80, 4154684, 587467, 1211.5, 247.65008, 328.69659, 181.21958, 253, 4, 333, 0, 0, 0, 42, 190, 0, 1), 
(29177, 29177, "Freya", 0, "Ice Queen", 0, "LineageMonster5.freya_throne", 50, 98.5, 85, "female", "L2GrandBoss", 40, 1989104.858609, 184680, 556.482124, 300, 60, 57, 73, 76, 70, 80, 0, 0, 8184.13934, 1085.36442, 2579.00134, 529.48, 253, 4, 333, 0, 0, 0, 45, 150, 0, 1), 
(29178, 29178, "Freya", 0, "Ice Queen", 0, "LineageMonster5.freya_throne", 50, 98.5, 85, "female", "L2GrandBoss", 40, 1989104.858609, 184680, 556.482124, 300, 60, 57, 73, 76, 70, 80, 0, 0, 8184.13934, 1085.36442, 2579.00134, 529.48, 253, 4, 333, 0, 0, 0, 45, 150, 0, 1), 
(29179, 29179, "Freya", 0, "Ice Queen", 0, "LineageMonster5.freya_stand", 22, 55, 85, "female", "L2GrandBoss", 40, 2662001.195295, 184680, 612.130336, 300, 60, 57, 73, 76, 70, 80, 51569937, 6164678, 9002.55327, 1193.90086, 3120.59162, 582.428, 253, 4, 333, 0, 0, 0, 54, 180, 0, 1), 
(29180, 29180, "Freya", 0, "Ice Queen", 0, "LineageMonster5.freya_stand", 22, 55, 85, "female", "L2GrandBoss", 40, 47212840.576821, 184680, 18363.910082, 1000, 60, 57, 73, 76, 70, 80, 108799553, 12524212, 21208.84518, 1589.08205, 5528.31841, 1193.8, 253, 4, 333, 0, 0, 0, 54, 180, 0, 1), 
(29181, 29181, "Zaken", 0, "", 0, "LineageMonster.zaken", 16, 32, 83, "male", "L2GrandBoss", 40, 3155900.346728, 177740, 818.275841, 300, 60, 57, 73, 76, 70, 80, 15282889, 2051807, 8022.87946, 1061.58432, 2559.96936, 517.88, 253, 4, 333, 0, 0, 0, 42, 190, 0, 1), 
(29182, 29182, "Doll Blader", 0, "", 0, "LineageMonster.doll_blader", 6, 12, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 5129, 0, 0, 22, 150, 0, 1), 
(29183, 29183, "Veil Master", 0, "", 0, "LineageMonster.vale_master", 12, 40, 82, "male", "L2Monster", 40, 3643.389767, 1743, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1055.28566, 349.77477, 720.6233, 255.95, 253, 4, 333, 0, 0, 0, 70, 155, 0, 1), 
(29184, 29184, "Pirate Zombie Captain", 0, "", 0, "LineageMonster4.cursed_pirate", 24, 37, 83, "male", "L2Monster", 40, 3835.590606, 1777.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1099.42362, 353.86144, 750.76381, 258.94045, 253, 4, 333, 0, 0, 0, 25.5, 140, 0, 1), 
(29185, 29185, "Pirate Zombie", 0, "", 0, "LineageMonster.pirates_zombie", 10, 23, 81, "male", "L2Monster", 40, 3461.772532, 1708.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1012.32268, 345.61127, 691.28516, 252.90333, 253, 4, 333, 225, 0, 0, 11, 140, 0, 1), 
(29186, 29186, "Balor", 0, "Chief Guard", 0, "LineageMonster4.Barler", 54, 77.5, 85, "male", "L2GrandBoss", 40, 985293.229521, 1955.34, 378.67367, 300, 60, 57, 73, 76, 70, 80, 9930637, 1322209, 3825.01372, 1654.78449, 1860.88877, 1181.91313, 253, 4, 333, 0, 0, 0, 34, 180, 0, 1), 
(29187, 29187, "Crystal Prison Guard", 0, "", 0, "LineageMonster4.eyeless", 36, 43.5, 85, "male", "L2Monster", 40, 18815.573117, 1955.34, 187.367998, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1834.58348, 602.7947, 1252.78269, 441.099, 253, 4, 333, 0, 0, 0, 60, 210, 0, 1), 
(29188, 29188, "Crystal Golem", 0, "", 0, "LineageMonster4.Crystal_Golem", 34, 47, 85, "male", "L2Monster", 40, 114631.265523, 1846.8, 187.367998, 3, 40, 43, 30, 21, 20, 20, 0, 0, 983.0479, 361.78814, 671.29428, 264.74086, 253, 4, 333, 0, 0, 0, 54, 170, 0, 1), 
(29189, 29189, "Crystal Golem", 0, "", 0, "LineageMonster4.Crystal_Golem", 34, 47, 85, "male", "L2Monster", 40, 3046.70947, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 983.0479, 361.78814, 671.29428, 264.74086, 253, 4, 333, 0, 0, 0, 54, 170, 0, 1), 
(29190, 29190, "Tarask Dragon", 0, "", 0, "LineageMonster3.antaras_ex_a", 63, 54, 85, "male", "L2Monster", 40, 401551.69672, 1809, 76.71, 3, 60, 57, 73, 76, 70, 80, 0, 0, 3584.56902, 1071.29474, 1386.66, 522.62686, 253, 4, 333, 0, 0, 0, 180, 180, 0, 1), 
(30001, 30001, "Lector", 0, "Weapon Merchant", 0, "LineageNPC.a_traderA_MHuman", 10, 24, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30002, 30002, "Jackson", 0, "Armor Merchant", 0, "LineageNPC.a_traderB_MHuman", 8, 25, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30003, 30003, "Silvia", 0, "Accessory Merchant", 0, "LineageNPC.a_traderA_FHuman", 7, 23, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30004, 30004, "Katerina", 0, "Grocer", 0, "LineageNPC.a_traderB_FHuman", 8, 24.5, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30005, 30005, "Wilford", 0, "Warehouse Keeper", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 70, "male", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30006, 30006, "Roxxy", 0, "Gatekeeper", 0, "LineageNPC.a_teleporter_FHuman", 8, 25, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30008, 30008, "Roien", 0, "Grand Master", 0, "LineageNPC.a_fighterguild_master_Mhuman", 8, 23.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30009, 30009, "Newbie Helper", 0, "", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30010, 30010, "Auron", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30014, 30014, "Celma", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_FHuman", 9.5, 22.4, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30017, 30017, "Gallint", 0, "Grand Magister", 0, "LineageNPC.a_mageguild_master_MHuman", 8, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30019, 30019, "Newbie Helper", 0, "", 0, "LineageNPC.a_mageguild_teacher_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30022, 30022, "Zigaunt", 0, "Priest", 0, "LineageNPC.a_sanctuary_teacher_MHuman", 8, 23, 70, "male", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30026, 30026, "Bitz", 0, "Grand Master", 0, "LineageNPC.a_fighterguild_master_Mhuman", 8, 23.5, 70, "male", "L2VillageMasterFighter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30027, 30027, "Gwinter", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30028, 30028, "Pintage", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30029, 30029, "Minia", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_FHuman", 9.5, 22.4, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30030, 30030, "Vivyan", 0, "Priestess", 0, "LineageNPC.a_sanctuary_teacher_FHuman", 8, 22.5, 70, "female", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30031, 30031, "Biotin", 0, "High Priest", 0, "LineageNPC.a_sanctuary_master_MHuman", 8, 24, 70, "male", "L2VillageMasterPriest", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30032, 30032, "Yohanes", 0, "Priest", 0, "LineageNPC.a_sanctuary_teacher_MHuman", 8, 23, 70, "male", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30033, 30033, "Baulro", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_MHuman", 8, 23, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30034, 30034, "Iris", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_FHuman", 8, 23.5, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30035, 30035, "Harrys", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_MHuman", 8, 23, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30036, 30036, "Petron", 0, "Priest", 0, "LineageNPC.a_sanctuary_teacher_MHuman", 8, 23, 70, "male", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30037, 30037, "Levian", 0, "High Priestess", 0, "LineageNPC.a_sanctuary_teacher_FHuman", 8, 22.5, 70, "female", "L2VillageMasterPriest", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30039, 30039, "Gilbert", 0, "Captain", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 129, 102, 0, 50, 160, 0, 1), 
(30040, 30040, "Leon", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 275, 0, 0, 50, 160, 0, 1), 
(30041, 30041, "Arnold", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 275, 0, 0, 50, 160, 0, 1), 
(30042, 30042, "Abellos", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 2, 20, 0, 50, 160, 0, 1), 
(30043, 30043, "Johnstone", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 2, 20, 0, 50, 160, 0, 1), 
(30044, 30044, "Chiperan", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 275, 0, 0, 50, 160, 0, 1), 
(30045, 30045, "Kenyos", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 275, 0, 0, 50, 160, 0, 1), 
(30046, 30046, "Hanks", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 2, 20, 0, 50, 160, 0, 1), 
(30047, 30047, "Firon", 0, "Wharf Manager", 0, "LineageNPC.a_wharfinger_MHuman", 8, 23, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30048, 30048, "Darin", 0, "", 0, "LineageNPC.a_common_peopleB_MHuman", 8, 22, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30049, 30049, "Bonnie", 0, "", 0, "LineageNPC.a_common_peopleB_FHuman", 8, 20.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30050, 30050, "Elias", 0, "", 0, "LineageNPC.a_common_peopleA_MHuman", 8, 21.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30051, 30051, "Cristel", 0, "", 0, "LineageNPC.a_common_peopleA_FHuman", 8, 21.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30054, 30054, "Rant", 0, "Warehouse Keeper", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 70, "male", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30055, 30055, "Rolfe", 0, "Warehouse Keeper", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 70, "male", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30057, 30057, "Aldo", 0, "Warehouse Keeper", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 70, "male", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30058, 30058, "Holvas", 0, "Warehouse Keeper", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 70, "male", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30059, 30059, "Trisha", 0, "Gatekeeper", 0, "LineageNPC.a_teleporter_FHuman", 8, 25, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30060, 30060, "Sabrin", 0, "Weapon Merchant", 0, "LineageNPC.a_traderA_MHuman", 10, 24, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30061, 30061, "Casey", 0, "Armor Merchant", 0, "LineageNPC.a_traderB_MHuman", 8, 25, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30062, 30062, "Sonia", 0, "Accessory Merchant", 0, "LineageNPC.a_traderA_FHuman", 7, 23, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30063, 30063, "Lara", 0, "Grocer", 0, "LineageNPC.a_traderB_FHuman", 8, 24.5, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30064, 30064, "Terry", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30065, 30065, "Arnelle", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_FHuman", 9.5, 22.4, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30066, 30066, "Pabris", 0, "Grand Master", 0, "LineageNPC.a_fighterguild_master_Mhuman", 8, 23.5, 70, "male", "L2VillageMasterFighter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30067, 30067, "Glyvka", 0, "Priestess", 0, "LineageNPC.a_sanctuary_teacher_FHuman", 8, 22.5, 70, "female", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30068, 30068, "Shegfield", 0, "Priest", 0, "LineageNPC.a_mageguild_teacher_MElf", 7, 22.2, 70, "male", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30069, 30069, "Rollant", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_MHuman", 8, 23, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30070, 30070, "Sylvain", 0, "High Priest", 0, "LineageNPC.a_sanctuary_master_MHuman", 8, 24, 70, "male", "L2VillageMasterPriest", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30071, 30071, "Lucas", 0, "Captain", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 129, 102, 0, 50, 160, 0, 1), 
(30072, 30072, "Metty", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 275, 0, 0, 50, 160, 0, 1), 
(30073, 30073, "Jacob", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 275, 0, 0, 50, 160, 0, 1), 
(30074, 30074, "Harlan", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 2, 20, 0, 50, 160, 0, 1), 
(30075, 30075, "Xaber", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 275, 0, 0, 50, 160, 0, 1), 
(30076, 30076, "Liam", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 2, 20, 0, 50, 160, 0, 1), 
(30078, 30078, "Pano", 0, "Grocer", 0, "LineageNPC.a_common_peopleA_MHuman", 8, 21.5, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30079, 30079, "Barder", 0, "Warehouse Keeper", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 70, "male", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30080, 30080, "Clarissa", 0, "Gatekeeper", 0, "LineageNPC.a_teleporter_FHuman", 8, 25, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30081, 30081, "Helvetia", 0, "Grocer", 0, "LineageNPC.a_traderB_FHuman", 8, 24.5, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30082, 30082, "Denkus", 0, "Accessory Merchant", 0, "LineageNPC.a_traderB_MHuman", 8, 25, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30083, 30083, "Pochi", 0, "Warehouse Keeper", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 70, "male", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30084, 30084, "Graham", 0, "Warrior-use Weapon Merchant", 0, "LineageNPC.a_traderA_MHuman", 10, 24, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30085, 30085, "Stanford", 0, "Wizard-use Weapon Merchant", 0, "LineageNPC.a_traderA_MHuman", 10, 24, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30086, 30086, "Taurin", 0, "Warehouse Keeper", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 70, "male", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30087, 30087, "Peta", 0, "Wizard-use Armor Merchant", 0, "LineageNPC.a_traderA_FHuman", 7, 23, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30088, 30088, "Radia", 0, "Warrior-use Armor Merchant", 0, "LineageNPC.a_traderB_FHuman", 8, 24.5, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30090, 30090, "Sandra", 0, "Accessory Merchant", 0, "LineageNPC.a_traderB_FHuman", 8, 24.5, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30091, 30091, "Ellie", 0, "Accessory Merchant", 0, "LineageNPC.a_traderA_FHuman", 7, 23, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30092, 30092, "Collob", 0, "Warehouse Keeper", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 70, "male", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30093, 30093, "Groot", 0, "Dye Merchant", 0, "LineageNPC.a_traderA_MHuman", 10, 24, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30094, 30094, "Gentler", 0, "Wizard-use Equipment Merchant", 0, "LineageNPC.a_traderB_MHuman", 8, 25, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30095, 30095, "Randolf", 0, "Warehouse Keeper", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 70, "male", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30097, 30097, "Galladucci", 0, "Weapon Merchant", 0, "LineageNPC.a_traderA_MDwarf", 8, 17, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30098, 30098, "Alexandria", 0, "Armor Merchant", 0, "LineageNPC.a_traderB_FHuman", 8, 24.5, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30103, 30103, "Valkon", 0, "Warehouse Keeper", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 70, "male", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30104, 30104, "Parman", 0, "Warehouse Keeper", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 70, "male", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30105, 30105, "Genwitter", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30106, 30106, "Dufner", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30107, 30107, "Goldian", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_MElf", 7, 22.5, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30108, 30108, "Macken", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30109, 30109, "Hannavalt", 0, "Grand Master", 0, "LineageNPC.a_fighterguild_master_Mhuman", 8, 23.5, 70, "male", "L2VillageMasterFighter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30110, 30110, "Iker", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_MHuman", 8, 23, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30111, 30111, "Dieter", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_MHuman", 8, 23, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30112, 30112, "Maurius", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_MElf", 7, 22.2, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30113, 30113, "Juris", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_FElf", 7, 21.2, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30114, 30114, "Roa", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_FHuman", 8, 23.5, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30115, 30115, "Jurek", 0, "Grand Magister", 0, "LineageNPC.a_mageguild_master_MHuman", 8, 24, 70, "male", "L2VillageMasterMystic", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30116, 30116, "Dustin", 0, "Priest", 0, "LineageNPC.a_sanctuary_teacher_MHuman", 8, 23, 70, "male", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30117, 30117, "Primos", 0, "Priest", 0, "LineageNPC.a_sanctuary_teacher_MHuman", 8, 23, 70, "male", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30118, 30118, "Pupina", 0, "Priestess", 0, "LineageNPC.a_sanctuary_teacher_FHuman", 8, 22.5, 70, "female", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30119, 30119, "Isabellin", 0, "Priestess", 0, "LineageNPC.a_mageguild_teacher_FElf", 7, 22.2, 70, "female", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30120, 30120, "Maximilian", 0, "High Priest", 0, "LineageNPC.a_sanctuary_master_MHuman", 8, 24, 70, "male", "L2VillageMasterPriest", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30121, 30121, "Jeronin", 0, "Captain", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 129, 102, 0, 50, 160, 0, 1), 
(30122, 30122, "Bane", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 275, 0, 0, 50, 160, 0, 1), 
(30123, 30123, "Vesa", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 275, 0, 0, 50, 160, 0, 1), 
(30124, 30124, "Zerome", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 2, 20, 0, 50, 160, 0, 1), 
(30125, 30125, "Belton", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 2, 20, 0, 50, 160, 0, 1), 
(30126, 30126, "Rath", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 2, 20, 0, 50, 160, 0, 1), 
(30128, 30128, "Atanas", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 2, 20, 0, 50, 160, 0, 1), 
(30129, 30129, "Mitraell", 0, "Hierarch", 0, "LineageNPC.a_patriarch_MDarkElf", 6, 23.8, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30130, 30130, "Undrias", 0, "Abyssal Celebrant", 0, "LineageNPC.a_clergyman_MDarkElf", 8, 22.3, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30131, 30131, "Newbie Helper", 0, "", 0, "LineageNPC.a_clergyman_FDarkElf", 8, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30132, 30132, "Cecktinon", 0, "Abyssal Celebrant", 0, "LineageNPC.a_clergyman_MDarkElf", 8, 22.3, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30133, 30133, "Kartia", 0, "Abyssal Celebrant", 0, "LineageNPC.a_clergyman_FDarkElf", 8, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30134, 30134, "Jasmine", 0, "Gatekeeper", 0, "LineageNPC.a_teleporter_FDarkElf", 8, 25, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30135, 30135, "Iria", 0, "Weapon Merchant", 0, "LineageNPC.a_trader_Fdarkelf", 8, 24.5, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30136, 30136, "Payne", 0, "Armor Merchant", 0, "LineageNPC.a_trader_MDarkElf", 8, 22.5, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30137, 30137, "Vollodos", 0, "Grocer", 0, "LineageNPC.a_trader_MDarkElf", 8, 22.5, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30138, 30138, "Minaless", 0, "Accessory Merchant", 0, "LineageNPC.a_trader_Fdarkelf", 8, 24.5, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30139, 30139, "Dorankus", 0, "Warehouse Keeper", 0, "LineageNPC.a_trader_MDarkElf", 8, 22.5, 70, "male", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30140, 30140, "Erviante", 0, "Warehouse Keeper", 0, "LineageNPC.a_trader_MDarkElf", 8, 22.5, 70, "male", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30141, 30141, "Talloth", 0, "Tetrarch", 0, "LineageNPC.a_patriarch_MDarkElf", 6, 23.8, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30143, 30143, "Trudy", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_FDarkElf", 8, 23, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30144, 30144, "Harne", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_FDarkElf", 8, 23, 70, "female", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30145, 30145, "Vlasty", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_MDarkElf", 8, 22, 70, "male", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30146, 30146, "Mirabel", 0, "Gatekeeper", 0, "LineageNPC.a_teleporter_FElf", 8.5, 23.5, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30147, 30147, "Unoren", 0, "Weapon Merchant", 0, "LineageNPC.a_trader_MElf", 6, 24.5, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30148, 30148, "Ariel", 0, "Armor Merchant", 0, "LineageNPC.a_trader_FElf", 8, 24, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30149, 30149, "Creamees", 0, "Accessory Merchant", 0, "LineageNPC.a_trader_MElf", 6, 24.5, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30150, 30150, "Herbiel", 0, "Grocer", 0, "LineageNPC.a_trader_MElf", 6, 24.5, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30151, 30151, "Chad", 0, "Warehouse Keeper", 0, "LineageNPC.a_trader_MElf", 6, 24.5, 70, "male", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30152, 30152, "Julia", 0, "Warehouse Keeper", 0, "LineageNPC.a_common_people_FElf", 7, 25.5, 70, "female", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30153, 30153, "Markius", 0, "Warehouse Keeper", 0, "LineageNPC.a_common_people_MElf", 6, 21, 70, "male", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30154, 30154, "Asterios", 0, "Hierarch", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 70, "male", "L2VillageMasterPriest", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30155, 30155, "Ellenia", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_FElf", 8, 22.5, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30156, 30156, "Cobendell", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_MElf", 7, 22.5, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30157, 30157, "Greenis", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_FElf", 7, 21.2, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30158, 30158, "Esrandell", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_MElf", 7, 22.2, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30162, 30162, "Karin", 0, "Gatekeeper", 0, "LineageNPC.a_teleporter_FHuman", 8, 25, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30163, 30163, "Rex", 0, "Trader", 0, "LineageNPC.a_traderB_MHuman", 8, 25, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30164, 30164, "Ian", 0, "Trader", 0, "LineageNPC.a_traderB_MHuman", 8, 25, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30165, 30165, "Ralford", 0, "Trader", 0, "LineageNPC.a_trader_FElf", 8, 24, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30166, 30166, "Wesley", 0, "Magic Trader", 0, "LineageNPC.a_traderA_MHuman", 10, 24, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30169, 30169, "Marty", 0, "Warehouse Keeper", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 70, "male", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30170, 30170, "Radic", 0, "Warehouse Keeper", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 70, "male", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30171, 30171, "Gaius", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_MHuman", 8, 23, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30174, 30174, "Arkenias", 0, "Grand Magister", 0, "LineageNPC.a_mageguild_teacher_FElf", 7, 21.2, 70, "female", "L2VillageMasterMystic", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30175, 30175, "Fairen", 0, "Grand Magister", 0, "LineageNPC.a_mageguild_teacher_FDarkElf", 8, 23, 70, "female", "L2VillageMasterMystic", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30176, 30176, "Valleria", 0, "Grand Magister", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 70, "female", "L2VillageMasterMystic", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30177, 30177, "Valentina", 0, "Gatekeeper", 0, "LineageNPC.a_teleporter_FHuman", 8, 25, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30178, 30178, "Zenkin", 0, "Armor Merchant", 0, "LineageNPC.a_traderA_MHuman", 10, 24, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30179, 30179, "Raudia", 0, "Weapon Merchant", 0, "LineageNPC.a_traderB_FHuman", 8, 24.5, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30180, 30180, "Sara", 0, "Grocer", 0, "LineageNPC.a_traderA_FHuman", 7, 23, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30181, 30181, "Galibredo", 0, "Accessory Merchant", 0, "LineageNPC.a_traderA_MHuman", 10, 24, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30182, 30182, "Cliff", 0, "Warehouse Keeper", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 70, "male", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30183, 30183, "Hagger", 0, "Warehouse Keeper", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 70, "male", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30184, 30184, "Rigol", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30185, 30185, "Taniac Blackbird", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30186, 30186, "Bhan", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_MElf", 7, 22.5, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30187, 30187, "Klaus Blackbird", 0, "Grand Master", 0, "LineageNPC.a_fighterguild_master_Mhuman", 8, 23.5, 70, "male", "L2VillageMasterFighter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30188, 30188, "Vadin", 0, "Priest", 0, "LineageNPC.a_sanctuary_teacher_MHuman", 8, 23, 70, "male", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30189, 30189, "Rovia", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_FElf", 7, 21.2, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30190, 30190, "Phanovia", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_FHuman", 8, 23.5, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30191, 30191, "Hollint", 0, "High Priest", 0, "LineageNPC.a_sanctuary_master_MHuman", 8, 24, 70, "male", "L2VillageMasterPriest", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30192, 30192, "Darya", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_FDarkElf", 8, 23, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30194, 30194, "Gideon", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_MDarkElf", 8, 22, 70, "male", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30195, 30195, "Brecson", 0, "Grand Master", 0, "LineageNPC.a_guild_master_MDarkElf", 8, 23, 70, "male", "L2VillageMasterDElf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30196, 30196, "Mouen", 0, "Captain", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 129, 102, 0, 50, 160, 0, 1), 
(30197, 30197, "Hector", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 275, 0, 0, 50, 160, 0, 1), 
(30198, 30198, "Jerin", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 2, 20, 0, 50, 160, 0, 1), 
(30199, 30199, "Yates", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 275, 0, 0, 50, 160, 0, 1), 
(30200, 30200, "Stan", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 275, 0, 0, 50, 160, 0, 1), 
(30201, 30201, "Pinaps", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 275, 0, 0, 50, 160, 0, 1), 
(30207, 30207, "Arodin", 0, "Weapon Merchant", 0, "LineageNPC.a_traderA_MHuman", 10, 24, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30208, 30208, "Damion", 0, "Armor Merchant", 0, "LineageNPC.a_traderB_MHuman", 8, 25, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30209, 30209, "Colleen", 0, "Dye Merchant", 0, "LineageNPC.a_traderB_FHuman", 8, 24.5, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30210, 30210, "Norman", 0, "Warehouse Keeper", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 70, "male", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30216, 30216, "Wheeler", 0, "Sentinel", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 130, 0, 0, 50, 160, 0, 1), 
(30217, 30217, "Berros", 0, "Sentinel", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 276, 0, 0, 50, 160, 0, 1), 
(30218, 30218, "Kendell", 0, "Sentinel", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 276, 0, 0, 50, 160, 0, 1), 
(30219, 30219, "Veltress", 0, "Sentinel", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 130, 0, 0, 50, 160, 0, 1), 
(30220, 30220, "Starden", 0, "Sentinel", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 276, 0, 0, 50, 160, 0, 1), 
(30221, 30221, "Rayen", 0, "Sentinel", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 130, 0, 0, 50, 160, 0, 1), 
(30222, 30222, "Alshupes", 0, "", 0, "LineageNPC.a_common_people_MElf", 6, 21, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30223, 30223, "Arujien", 0, "", 0, "LineageNPC.a_common_people_MElf", 6, 21, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30224, 30224, "Rayla", 0, "Sentry Knight", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 80, "female", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 79, 0, 0, 50, 160, 0, 1), 
(30230, 30230, "Edroc", 0, "Trader", 0, "LineageNPC.a_traderB_MHuman", 8, 25, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30231, 30231, "Garette", 0, "Trader", 0, "LineageNPC.a_traderB_MHuman", 8, 25, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30232, 30232, "Sorint", 0, "Warehouse Keeper", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 70, "male", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30233, 30233, "Esmeralda", 0, "Gatekeeper", 0, "LineageNPC.a_teleporter_FHuman", 8, 25, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30253, 30253, "Simplon", 0, "Armor Merchant", 0, "LineageNPC.a_traderA_MHuman", 10, 24, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30254, 30254, "Harmony", 0, "Grocer", 0, "LineageNPC.a_traderA_FHuman", 7, 23, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30255, 30255, "Haprock", 0, "Warehouse Keeper", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 70, "male", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30256, 30256, "Bella", 0, "Gatekeeper", 0, "LineageNPC.a_teleporter_FHuman", 8, 25, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30283, 30283, "Altran", 0, "Blacksmith", 0, "LineageNPC.a_smith_MDwarf", 7, 16.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 89, 0, 0, 50, 120, 0, 1), 
(30284, 30284, "Alberius", 0, "Sentinel Knight", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 150, 0, 0, 50, 160, 0, 1), 
(30285, 30285, "Gartrandell", 0, "Sentinel", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 130, 0, 0, 50, 160, 0, 1), 
(30288, 30288, "Rains", 0, "Grand Master", 0, "LineageNPC.a_fighterguild_master_Mhuman", 8, 23.5, 70, "male", "L2VillageMasterFighter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30289, 30289, "Raymond", 0, "High Priest", 0, "LineageNPC.a_sanctuary_master_MHuman", 8, 24, 70, "male", "L2VillageMasterPriest", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30290, 30290, "Xenos", 0, "Grand Master", 0, "LineageNPC.a_guild_master_MDarkElf", 8, 23, 70, "male", "L2VillageMasterDElf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30291, 30291, "Alex", 0, "Captain", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 68, 0, 0, 50, 120, 0, 1), 
(30293, 30293, "Manuel", 0, "Priest", 0, "LineageNPC.a_mageguild_teacher_MElf", 7, 22.2, 70, "male", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30294, 30294, "Varan", 0, "Accessory Merchant", 0, "LineageNPC.a_traderB_MHuman", 8, 25, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30297, 30297, "Tobias", 0, "Grand Master", 0, "LineageNPC.a_guild_master_MDarkElf", 8, 23, 70, "male", "L2VillageMasterDElf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30298, 30298, "Pinter", 0, "Blacksmith", 0, "LineageNPC.a_smith_MDwarf", 7, 16.5, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 89, 0, 0, 50, 120, 0, 1), 
(30300, 30300, "Pushkin", 0, "Blacksmith", 0, "LineageNPC.a_smith_MDwarf", 7, 16.5, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 89, 0, 0, 50, 120, 0, 1), 
(30301, 30301, "Hally", 0, "Trader", 0, "LineageNPC.a_traderA_FHuman", 7, 23, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30305, 30305, "Vellior", 0, "Tetrarch", 0, "LineageNPC.a_patriarch_MDarkElf", 6, 23.8, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30307, 30307, "Karrod", 0, "Blacksmith", 0, "LineageNPC.a_common_people_MDarkElf", 7, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30311, 30311, "Sir Collin Windawood", 0, "", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30312, 30312, "Rockswell", 0, "Lighthouse Keeper", 0, "LineageNPC.a_common_peopleA_MHuman", 8, 21.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30313, 30313, "Asha", 0, "Trader", 0, "LineageNPC.a_traderA_FHuman", 7, 23, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30314, 30314, "Nestle", 0, "Accessory Merchant", 0, "LineageNPC.a_traderB_MHuman", 8, 25, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30315, 30315, "Poesia", 0, "Grocer", 0, "LineageNPC.a_traderA_FHuman", 7, 23, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30316, 30316, "Raut", 0, "Warehouse Keeper", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 70, "male", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30317, 30317, "Kluto", 0, "Blacksmith", 0, "LineageNPC.a_smith_MDwarf", 7, 16.5, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 89, 0, 0, 50, 120, 0, 1), 
(30320, 30320, "Richlin", 0, "Gatekeeper", 0, "LineageNPC.a_teleporter_FHuman", 8, 25, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30321, 30321, "Sydnia", 0, "Weapon Merchant", 0, "LineageNPC.a_traderA_FHuman", 7, 23, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30322, 30322, "Ballin", 0, "Warehouse Keeper", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 70, "male", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30325, 30325, "Audiberti", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30326, 30326, "Leona", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_FHuman", 9.5, 22.4, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30327, 30327, "Sorius", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_MElf", 7, 22.5, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30328, 30328, "Reisa", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_FElf", 8, 22.5, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30329, 30329, "Virgil", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_MDarkElf", 8, 23, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30330, 30330, "Sidra", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_FDarkElf", 8, 23, 70, "female", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30331, 30331, "Toma", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 275, 0, 0, 50, 160, 0, 1), 
(30332, 30332, "Bathis", 0, "Captain", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 129, 102, 0, 50, 160, 0, 1), 
(30333, 30333, "Praga", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 2, 20, 0, 50, 160, 0, 1), 
(30334, 30334, "Babenco", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 275, 0, 0, 50, 160, 0, 1), 
(30335, 30335, "Brynn", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 275, 0, 0, 50, 160, 0, 1), 
(30336, 30336, "Curtis", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 275, 0, 0, 50, 160, 0, 1), 
(30337, 30337, "Moretti", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 2, 20, 0, 50, 160, 0, 1), 
(30338, 30338, "Melville", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 275, 0, 0, 50, 160, 0, 1), 
(30342, 30342, "Varsak", 0, "", 0, "LineageNPC.a_common_peopleB_MHuman", 8, 22, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30344, 30344, "Rohmer", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_MHuman", 8, 23, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30345, 30345, "Ramoniell", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_FElf", 7, 21.2, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30346, 30346, "Kayleen", 0, "Sentry", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 80, "female", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 277, 0, 0, 50, 160, 0, 1), 
(30347, 30347, "Marion", 0, "Sentry", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 80, "female", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 132, 0, 0, 50, 160, 0, 1), 
(30348, 30348, "Nelsya", 0, "Sentry", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 80, "female", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 132, 0, 0, 50, 160, 0, 1), 
(30349, 30349, "Jenna", 0, "Sentry", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 80, "female", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 277, 0, 0, 50, 160, 0, 1), 
(30350, 30350, "Carlon", 0, "Warehouse Keeper", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 70, "male", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30351, 30351, "Astaron", 0, "", 0, "LineageNPC.a_common_people_MDarkElf", 7, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30352, 30352, "Karina", 0, "", 0, "LineageNPC.a_common_people_FDarkElf", 8, 21.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30353, 30353, "Jughead", 0, "", 0, "LineageNPC.a_common_people_MDarkElf", 7, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30354, 30354, "Jewel", 0, "", 0, "LineageNPC.a_common_people_FDarkElf", 8, 21.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30355, 30355, "Roselyn", 0, "Sentry", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 80, "female", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 277, 0, 0, 50, 160, 0, 1), 
(30356, 30356, "Altima", 0, "Sentry", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 80, "female", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 277, 0, 0, 50, 160, 0, 1), 
(30357, 30357, "Kristin", 0, "Sentry", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 80, "female", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 132, 0, 0, 50, 160, 0, 1), 
(30358, 30358, "Thifiell", 0, "Tetrarch", 0, "LineageNPC.a_patriarch_MDarkElf", 6, 23.8, 70, "male", "L2VillageMasterDElf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30359, 30359, "Kaitar", 0, "Tetrarch", 0, "LineageNPC.a_patriarch_MDarkElf", 6, 23.8, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30360, 30360, "Harant", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_MDarkElf", 8, 23, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30361, 30361, "Rizraell", 0, "", 0, "LineageNPC.a_common_people_FElf", 7, 25.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30362, 30362, "Andellia", 0, "", 0, "LineageNPC.a_common_people_FElf", 7, 25.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30363, 30363, "Aios", 0, "Blacksmith", 0, "LineageNPC.a_common_people_MElf", 6, 21, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30368, 30368, "Lilith", 0, "", 0, "LineageNPC.a_common_people_FElf", 7, 25.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30369, 30369, "Baenedes", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_MElf", 7, 22.5, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30370, 30370, "Nerupa", 0, "", 0, "LineageMonster.aracne", 15, 26, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 64, 120, 0, 1), 
(30371, 30371, "Thalia", 0, "", 0, "LineageNPC.a_common_people_FElf", 7, 25.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30373, 30373, "Ramos", 0, "Grand Master", 0, "LineageNPC.a_fighterguild_master_Mhuman", 8, 23.5, 70, "male", "L2VillageMasterFighter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30374, 30374, "Rhodiell", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_FElf", 8, 22.5, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30375, 30375, "Adonius", 0, "Priest", 0, "LineageNPC.a_mageguild_teacher_MElf", 7, 22.2, 70, "male", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30376, 30376, "Nell", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_FElf", 7, 21.2, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30377, 30377, "Talbot", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_MDarkElf", 8, 22, 70, "male", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30378, 30378, "Estella", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_FDarkElf", 8, 23, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30379, 30379, "Bezique", 0, "Captain", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 280, 0, 0, 50, 160, 0, 1), 
(30380, 30380, "Plink", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 275, 0, 0, 50, 160, 0, 1), 
(30381, 30381, "Alvah", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 275, 0, 0, 50, 160, 0, 1), 
(30382, 30382, "Leikan", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 2, 20, 0, 50, 160, 0, 1), 
(30383, 30383, "Scott", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 275, 0, 0, 50, 160, 0, 1), 
(30384, 30384, "Linus", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 2, 20, 0, 50, 160, 0, 1), 
(30385, 30385, "Weisz", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 275, 0, 0, 50, 160, 0, 1), 
(30386, 30386, "Luis", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 2, 20, 0, 50, 160, 0, 1), 
(30387, 30387, "Clancy", 0, "Wharf Manager", 0, "LineageNPC.a_wharfinger_MHuman", 8, 23, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30391, 30391, "Parina", 0, "", 0, "LineageNPC.a_common_peopleB_FHuman", 8, 20.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30400, 30400, "Newbie Helper", 0, "", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30401, 30401, "Newbie Helper", 0, "", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30402, 30402, "Newbie Helper", 0, "", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30403, 30403, "Newbie Helper", 0, "", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30404, 30404, "Newbie Helper", 0, "", 0, "LineageNPC.a_clergyman_MDarkElf", 8, 22.3, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30405, 30405, "Marius", 0, "", 0, "LineageNPC.a_common_people_MElf", 6, 21, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30406, 30406, "Matheo", 0, "", 0, "LineageNPC.a_common_peopleA_MHuman", 8, 21.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30407, 30407, "Mesella", 0, "", 0, "LineageNPC.a_common_peopleA_FHuman", 8, 21.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30408, 30408, "Lionel", 0, "", 0, "LineageNPC.a_common_peopleA_MHuman", 8, 21.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30409, 30409, "Earth Snake", 0, "", 0, "LineageMonster.lesser_basilisk", 34, 25, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 35, 100, 0, 1), 
(30410, 30410, "Wasteland Lizardman", 0, "", 0, "LineageMonster.virud_lizardman", 10, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 43, 110, 0, 1), 
(30411, 30411, "Flame Salamander", 0, "", 0, "LineageMonster.salamander", 16, 6.8, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 64, 96, 0, 1), 
(30412, 30412, "Wind Sylph", 0, "", 0, "LineageMonster.sylph", 11, 35, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 60, 60, 0, 1), 
(30413, 30413, "Water Undine", 0, "", 0, "LineageMonster.undine", 12, 27, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 60, 60, 0, 1), 
(30414, 30414, "Rosella", 0, "", 0, "LineageNPC.a_common_people_FElf", 7, 25.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30415, 30415, "Charkeren", 0, "", 0, "LineageNPC.a_common_people_MDarkElf", 7, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30416, 30416, "Triskel", 0, "", 0, "LineageNPC.a_common_people_MDarkElf", 7, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30417, 30417, "Sir Klaus Vasper", 0, "", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30418, 30418, "Annika", 0, "", 0, "LineageNPC.a_common_people_FDarkElf", 8, 21.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30419, 30419, "Arkenia", 0, "Witch", 0, "LineageNPC.a_clergyman_FDarkElf", 8, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30420, 30420, "Tyra", 0, "", 0, "LineageNPC.a_trader_Fdarkelf", 8, 24.5, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30421, 30421, "Varika", 0, "Witch", 0, "LineageNPC.a_clergyman_FDarkElf", 8, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30422, 30422, "Kalinta", 0, "Abyssal Celebrant", 0, "LineageNPC.a_clergyman_FDarkElf", 8, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30423, 30423, "Northwind", 0, "", 0, "LineageNPC.a_common_people_MElf", 6, 21, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30424, 30424, "Allana", 0, "", 0, "LineageNPC.a_sanctuary_teacher_FHuman", 8, 22.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30425, 30425, "Neti", 0, "", 0, "LineageNPC.a_common_peopleA_FHuman", 8, 21.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30426, 30426, "Prias", 0, "", 0, "LineageNPC.a_wharfinger_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30427, 30427, "Siff", 0, "Gatekeeper", 0, "LineageNPC.a_teleporter_FHuman", 8, 25, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30428, 30428, "Perrin", 0, "", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30429, 30429, "Tiramisa", 0, "Gatekeeper", 0, "LineageNPC.a_teleporter_FHuman", 8, 25, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30430, 30430, "Trionell", 0, "Sentinel", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 130, 0, 0, 50, 160, 0, 1), 
(30431, 30431, "Eriel", 0, "Sentinel", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 130, 0, 0, 50, 160, 0, 1), 
(30432, 30432, "Irene", 0, "Sentry", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 80, "female", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 132, 0, 0, 50, 160, 0, 1), 
(30433, 30433, "Kathaway", 0, "Sentry", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 80, "female", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 132, 0, 0, 50, 160, 0, 1), 
(30434, 30434, "Samed", 0, "", 0, "LineageNPC.a_wharfinger_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30435, 30435, "Leopold", 0, "", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30436, 30436, "Sarien", 0, "Trader", 0, "LineageNPC.a_traderA_MHuman", 10, 24, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30437, 30437, "Rolento", 0, "Trader", 0, "LineageNPC.e_traderB_MDwarf", 8, 17.5, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30452, 30452, "Kurt", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 2, 20, 0, 50, 160, 0, 1), 
(30458, 30458, "Poitan", 0, "Blacksmith", 0, "LineageNPC.a_smith_MDwarf", 7, 16.5, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 89, 0, 0, 50, 120, 0, 1), 
(30459, 30459, "Wandius", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_MElf", 7, 22.5, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30460, 30460, "Cardien", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_FElf", 8, 22.5, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30461, 30461, "Mirien", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_FElf", 7, 21.2, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30462, 30462, "Tronix", 0, "Grand Master", 0, "LineageNPC.a_guild_master_MDarkElf", 8, 23, 70, "male", "L2VillageMasterDElf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30463, 30463, "Ixia", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_FDarkElf", 8, 23, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30464, 30464, "Clayton", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_MDarkElf", 8, 22, 70, "male", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30465, 30465, "Herven", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 275, 0, 0, 50, 160, 0, 1), 
(30466, 30466, "Bright", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 2, 20, 0, 50, 160, 0, 1), 
(30469, 30469, "Jonas", 0, "", 0, "LineageNPC.a_common_peopleB_MHuman", 8, 22, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30471, 30471, "Rupio", 0, "Blacksmith", 0, "LineageNPC.a_smith_MDwarf", 7, 16.5, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 89, 0, 0, 50, 120, 0, 1), 
(30472, 30472, "Rosheria", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_FElf", 8, 22.5, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30473, 30473, "Bandellos", 0, "Priest", 0, "LineageNPC.a_mageguild_teacher_MElf", 7, 22.2, 70, "male", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30474, 30474, "Angus", 0, "Grand Master", 0, "LineageNPC.a_guild_master_MDarkElf", 8, 23, 70, "male", "L2VillageMasterDElf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30475, 30475, "Stapin", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_MDarkElf", 8, 23, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30476, 30476, "Kaira", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_FDarkElf", 8, 23, 70, "female", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30477, 30477, "Sir Ortho Lancer", 0, "", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30478, 30478, "Reikin", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 275, 0, 0, 50, 160, 0, 1), 
(30483, 30483, "Mozella", 0, "Gatekeeper", 0, "LineageNPC.a_teleporter_FHuman", 8, 25, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30484, 30484, "Ponti", 0, "Gatekeeper", 0, "LineageNPC.a_teleporter_FHuman", 8, 25, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30485, 30485, "Capella", 0, "Gatekeeper", 0, "LineageNPC.a_teleporter_FHuman", 8, 25, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30486, 30486, "Hanna", 0, "Gatekeeper", 0, "LineageNPC.a_teleporter_FHuman", 8, 25, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30487, 30487, "Penelope", 0, "Gatekeeper", 0, "LineageNPC.a_teleporter_FHuman", 8, 25, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30497, 30497, "Edmond", 0, "", 0, "LineageNPC.a_common_peopleB_MHuman", 8, 22, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30498, 30498, "Moke", 0, "Warehouse Chief", 0, "LineageNPC.e_warehouse_master_MDwarf", 8, 17.5, 70, "male", "L2VillageMasterDwarf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30499, 30499, "Tapoy", 0, "Head Blacksmith", 0, "LineageNPC.e_smith_master_MDwarf", 8, 16.5, 70, "male", "L2VillageMasterDwarf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30500, 30500, "Osborn", 0, "High Prefect", 0, "LineageNPC.e_patriarch_MOrc", 8, 26, 70, "male", "L2VillageMasterOrc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30501, 30501, "Kasman", 0, "Prefect", 0, "LineageNPC.e_fighterguild_teacher_MOrc", 8, 28.5, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30502, 30502, "Umos", 0, "Seer", 0, "LineageNPC.e_clergyman_MOrc", 8, 29, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30503, 30503, "Rikadio", 0, "Warehouse Chief", 0, "LineageNPC.e_warehouse_master_MDwarf", 8, 17.5, 70, "male", "L2VillageMasterDwarf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30504, 30504, "Mendio", 0, "Head Blacksmith", 0, "LineageNPC.e_smith_master_MDwarf", 8, 16.5, 70, "male", "L2VillageMasterDwarf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30505, 30505, "Drikus", 0, "High Prefect", 0, "LineageNPC.e_patriarch_MOrc", 8, 26, 70, "male", "L2VillageMasterOrc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30506, 30506, "Buka", 0, "Prefect", 0, "LineageNPC.e_fighterguild_teacher_MOrc", 8, 28.5, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30507, 30507, "Racoy", 0, "Seer", 0, "LineageNPC.e_clergyman_MOrc", 8, 29, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30508, 30508, "Castor", 0, "High Prefect", 0, "LineageNPC.e_patriarch_MOrc", 8, 26, 70, "male", "L2VillageMasterOrc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30509, 30509, "Dowki", 0, "Prefect", 0, "LineageNPC.e_fighterguild_teacher_MOrc", 8, 28.5, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30510, 30510, "Somak", 0, "Seer", 0, "LineageNPC.e_clergyman_MOrc", 8, 29, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30511, 30511, "Gesto", 0, "Warehouse Chief", 0, "LineageNPC.e_warehouse_master_MDwarf", 8, 17.5, 70, "male", "L2VillageMasterDwarf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30512, 30512, "Kusto", 0, "Head Blacksmith", 0, "LineageNPC.e_smith_master_MDwarf", 8, 16.5, 70, "male", "L2VillageMasterDwarf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30513, 30513, "Penatus", 0, "High Prefect", 0, "LineageNPC.e_patriarch_MOrc", 8, 26, 70, "male", "L2VillageMasterOrc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30514, 30514, "Vokian", 0, "Prefect", 0, "LineageNPC.e_fighterguild_teacher_MOrc", 8, 28.5, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30515, 30515, "Manakia", 0, "Seer", 0, "LineageNPC.e_clergyman_MOrc", 8, 29, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30516, 30516, "Reep", 0, "Weapon Merchant", 0, "LineageNPC.a_traderA_MDwarf", 8, 17, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30517, 30517, "Shari", 0, "Armor Merchant", 0, "LineageNPC.e_traderA_FDwarf", 7, 18.5, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30518, 30518, "Garita", 0, "Accessory Merchant", 0, "LineageNPC.e_traderB_MDwarf", 8, 17.5, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30519, 30519, "Mion", 0, "Grocer", 0, "LineageNPC.e_traderB_FDwarf", 7, 18, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30520, 30520, "Reed", 0, "Warehouse Chief", 0, "LineageNPC.e_warehouse_master_MDwarf", 8, 17.5, 70, "male", "L2VillageMasterDwarf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30521, 30521, "Murdoc", 0, "Warehouse Keeper", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 70, "male", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30522, 30522, "Airy", 0, "Warehouse Keeper", 0, "LineageNPC.e_warehouse_keeper_FDwarf", 7, 18, 70, "female", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30523, 30523, "Gouph", 0, "Collector", 0, "LineageNPC.e_collector_teacher_MDwarf", 8, 17.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30524, 30524, "Pippi", 0, "Collector", 0, "LineageNPC.e_collector_teacher_FDwarf", 8, 17.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30525, 30525, "Bronk", 0, "Head Blacksmith", 0, "LineageNPC.e_smith_master_MDwarf", 8, 16.5, 70, "male", "L2VillageMasterDwarf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30526, 30526, "Brunon", 0, "Blacksmith", 0, "LineageNPC.a_smith_MDwarf", 7, 16.5, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 89, 0, 0, 50, 120, 0, 1), 
(30527, 30527, "Silvera", 0, "Blacksmith", 0, "LineageNPC.e_smith_Fdwarf", 8, 17.5, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30528, 30528, "Laferon", 0, "Foreman", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30529, 30529, "Maron", 0, "Miner", 0, "LineageNPC.e_mine_teacher_MDwarf", 8, 18, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30530, 30530, "Newbie Helper", 0, "", 0, "LineageNPC.e_mine_teacher_FDwarf", 8, 18.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30531, 30531, "Lockirin", 0, "Iron Gate's", 0, "LineageNPC.e_warehouse_master_MDwarf", 8, 17.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30532, 30532, "Spiron", 0, "Golden Wheel's", 0, "LineageNPC.e_traderA_master_MDwarf", 8, 18, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30533, 30533, "Balanki", 0, "Silver Scale's", 0, "LineageNPC.e_traderB_master_MDwarf", 8, 17, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30534, 30534, "Keef", 0, "Bronze Key's", 0, "LineageNPC.e_collector_master_MDwarf", 8, 18.4, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30535, 30535, "Filaur", 0, "Gray Pillar Member", 0, "LineageNPC.e_mine_master_MDwarf", 8, 19.7, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30536, 30536, "Arin", 0, "Black Anvil's", 0, "LineageNPC.e_smith_master_MDwarf", 8, 16.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30537, 30537, "Daichir", 0, "Priest of the Earth", 0, "LineageNPC.e_celebrant_MDwarf", 8, 19.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30538, 30538, "Zimenf", 0, "Priest of the Earth", 0, "LineageNPC.e_clergyman_MDwarf", 8, 17.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30539, 30539, "Chichirin", 0, "Priestess of the Earth", 0, "LineageNPC.e_warehouse_keeper_FDwarf", 7, 18, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30540, 30540, "Wirphy", 0, "Gatekeeper", 0, "LineageNPC.e_teleporter_FDwarf", 8, 21.3, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30541, 30541, "Paion", 0, "Protector", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 282, 0, 0, 50, 160, 0, 1), 
(30542, 30542, "Runant", 0, "Defender", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 273, 0, 0, 50, 160, 0, 1), 
(30543, 30543, "Ethan", 0, "Defender", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 296, 0, 0, 50, 120, 0, 1), 
(30544, 30544, "Cromwell", 0, "Defender", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 296, 0, 0, 50, 120, 0, 1), 
(30545, 30545, "Proton", 0, "Defender", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 296, 0, 0, 50, 120, 0, 1), 
(30546, 30546, "Dinkey", 0, "Defender", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 273, 0, 0, 50, 160, 0, 1), 
(30547, 30547, "Tardyon", 0, "Defender", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 273, 0, 0, 50, 160, 0, 1), 
(30548, 30548, "Nathan", 0, "Defender", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 296, 0, 0, 50, 120, 0, 1), 
(30549, 30549, "Ghouliff Droopstone", 0, "", 0, "LineageNPC.e_common_people_MDwarf", 8, 17, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30550, 30550, "Gauri Twinklerock", 0, "", 0, "LineageNPC.e_warehouse_keeper_FDwarf", 7, 18, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30551, 30551, "Tink Wandergold", 0, "", 0, "LineageNPC.e_common_people_MDwarf", 8, 17, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30552, 30552, "Kiril Sparkystone", 0, "", 0, "LineageNPC.e_warehouse_keeper_FDwarf", 7, 18, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30553, 30553, "Maryse Redbonnet", 0, "", 0, "LineageNPC.e_warehouse_keeper_FDwarf", 7, 18, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30554, 30554, "Bolter", 0, "Miner", 0, "LineageNPC.e_mine_teacher_MDwarf", 8, 18, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30555, 30555, "Torocco", 0, "Carrier", 0, "LineageNPC.a_traderA_MDwarf", 8, 17, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30556, 30556, "Toma", 0, "Master", 0, "LineageNPC.e_collector_master_MDwarf", 8, 18.4, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30557, 30557, "Torai", 0, "", 0, "LineageNPC.e_common_people_MDwarf", 8, 17, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30558, 30558, "Jakal", 0, "Weapon Merchant", 0, "LineageNPC.e_trader_MOrc", 8, 23.5, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30559, 30559, "Kunai", 0, "Armor Merchant", 0, "LineageNPC.e_trader_FOrc", 8, 24, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30560, 30560, "Uska", 0, "Accessory Merchant", 0, "LineageNPC.e_trader_MOrc", 8, 23.5, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30561, 30561, "Papuma", 0, "Grocer", 0, "LineageNPC.e_trader_MOrc", 8, 23.5, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30562, 30562, "Grookin", 0, "Warehouse Keeper", 0, "LineageNPC.e_trader_MOrc", 8, 23.5, 70, "male", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30563, 30563, "Imantu", 0, "Warehouse Keeper", 0, "LineageNPC.e_trader_MOrc", 8, 23.5, 70, "male", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30564, 30564, "Sumari", 0, "Blacksmith", 0, "LineageNPC.e_trader_MOrc", 8, 23.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30565, 30565, "Kakai", 0, "Flame Lord", 0, "LineageNPC.e_patriarch_MOrc", 8, 26, 70, "male", "L2VillageMasterOrc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30566, 30566, "Varkees", 0, "Atuba Chief", 0, "LineageNPC.e_fighterguild_teacher_MOrc", 8, 28.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 81, 0, 0, 50, 120, 0, 1), 
(30567, 30567, "Tantus", 0, "Neruga Chief", 0, "LineageNPC.e_fighterguild_teacher_MOrc", 8, 28.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 175, 0, 0, 50, 120, 0, 1), 
(30568, 30568, "Hatos", 0, "Urutu Chief", 0, "LineageNPC.e_fighterguild_teacher_MOrc", 8, 28.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 202, 0, 0, 50, 120, 0, 1), 
(30569, 30569, "Brukurse", 0, "Prefect", 0, "LineageNPC.e_fighterguild_teacher_MOrc", 8, 28.5, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30570, 30570, "Karukia", 0, "Prefect", 0, "LineageNPC.e_trader_FOrc", 8, 24, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30571, 30571, "Tanapi", 0, "Seer", 0, "LineageNPC.e_clergyman_MOrc", 8, 29, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30572, 30572, "Livina", 0, "Seer", 0, "LineageNPC.e_clergyman_FOrc", 7, 28, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30573, 30573, "Vulkus", 0, "Flame Guardian", 0, "LineageNPC.e_clergyman_MOrc", 8, 29, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30575, 30575, "Newbie Helper", 0, "", 0, "LineageNPC.e_clergyman_FOrc", 7, 28, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30576, 30576, "Tamil", 0, "Gatekeeper", 0, "LineageNPC.e_teleporter_FOrc", 8, 32, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30577, 30577, "Rukain", 0, "Praetorian", 0, "LineageNPC.e_guard_MOrc", 8, 27, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 279, 0, 0, 50, 160, 0, 1), 
(30578, 30578, "Nakusin", 0, "Centurion", 0, "LineageNPC.e_guard_MOrc", 8, 27, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 275, 0, 0, 50, 160, 0, 1), 
(30579, 30579, "Tamai", 0, "Centurion", 0, "LineageNPC.e_guard_MOrc", 8, 27, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 275, 0, 0, 50, 160, 0, 1), 
(30580, 30580, "Parugon", 0, "Centurion", 0, "LineageNPC.e_guard_MOrc", 8, 27, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 91, 0, 0, 50, 120, 0, 1), 
(30581, 30581, "Orinak", 0, "Centurion", 0, "LineageNPC.e_guard_MOrc", 8, 27, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 275, 0, 0, 50, 160, 0, 1), 
(30582, 30582, "Tiku", 0, "Centurion", 0, "LineageNPC.e_guard_MOrc", 8, 27, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 91, 0, 0, 50, 120, 0, 1), 
(30583, 30583, "Petukai", 0, "Centurion", 0, "LineageNPC.e_guard_MOrc", 8, 27, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 91, 0, 0, 50, 120, 0, 1), 
(30584, 30584, "Vapook", 0, "Centurion", 0, "LineageNPC.e_guard_MOrc", 8, 27, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 91, 0, 0, 50, 120, 0, 1), 
(30585, 30585, "Tataru Zu Hestui", 0, "", 0, "LineageNPC.e_common_people_MOrc", 8, 26, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30586, 30586, "Anai Zu Neruga", 0, "", 0, "LineageNPC.e_trader_FOrc", 8, 24, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30587, 30587, "Gantaki Zu Urutu", 0, "", 0, "LineageNPC.e_common_people_MOrc", 8, 26, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30588, 30588, "Takia Zu Duda-Mara", 0, "", 0, "LineageNPC.e_trader_FOrc", 8, 24, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30589, 30589, "Kazkin Zu Gandi", 0, "", 0, "LineageNPC.e_common_people_MOrc", 8, 26, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30590, 30590, "Rosheek", 0, "Khavatari", 0, "LineageNPC.e_fighterguild_teacher_MOrc", 8, 28.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30591, 30591, "Toruku", 0, "Khavatari", 0, "LineageNPC.e_fighterguild_teacher_MOrc", 8, 28.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30592, 30592, "Hestui Totem Spirit", 0, "", 0, "LineageMonster.grizzly", 21, 40, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 110, 0, 1), 
(30593, 30593, "Duda-Mara Totem Spirit", 0, "", 0, "LineageMonster.giant_spider", 26, 25.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 72, 130, 0, 1), 
(30594, 30594, "Ranspo", 0, "Warehouse Chief", 0, "LineageNPC.e_warehouse_master_MDwarf", 8, 17.5, 70, "male", "L2VillageMasterDwarf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30595, 30595, "Opix", 0, "Head Blacksmith", 0, "LineageNPC.e_smith_master_MDwarf", 8, 16.5, 70, "male", "L2VillageMasterDwarf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30596, 30596, "Harkel", 0, "Partisan Doorman", 0, "LineageMonster.ol_mahum", 13.5, 25, 70, "male", "L2CastleDoormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 110, 0, 1), 
(30597, 30597, "Piotur", 0, "", 0, "LineageNPC.a_common_peopleB_MHuman", 8, 22, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30598, 30598, "Newbie Guide", 0, "", 0, "LineageNPC.a_sanctuary_teacher_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30599, 30599, "Newbie Guide", 0, "", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30600, 30600, "Newbie Guide", 0, "", 0, "LineageNPC.a_guild_master_MDarkElf", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30601, 30601, "Newbie Guide", 0, "", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30602, 30602, "Newbie Guide", 0, "", 0, "LineageNPC.e_guard_MOrc", 8, 27, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30608, 30608, "Maria", 0, "", 0, "LineageNPC.a_common_peopleB_FHuman", 8, 20.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30609, 30609, "Creta", 0, "Astrologer", 0, "LineageNPC.a_mageguild_teacher_FHuman", 8, 23.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30610, 30610, "Cronos", 0, "Elder", 0, "LineageNPC.a_mageguild_master_MHuman", 8, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30611, 30611, "Triff", 0, "Drunkard", 0, "LineageNPC.e_common_people_MDwarf", 8, 17, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30612, 30612, "Casian", 0, "Elder", 0, "LineageNPC.a_mageguild_master_MHuman", 8, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30613, 30613, "Alders Spirit", 0, "", 0, "LineageMonster.human_ghost", 8, 22, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(30614, 30614, "Metheus", 0, "Brother", 0, "LineageNPC.a_sanctuary_teacher_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30615, 30615, "Voltar", 0, "Breka Chief", 0, "LineageMonster.batur_orc_overlord", 12, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 173, 0, 0, 80, 120, 0, 1), 
(30616, 30616, "Kepra", 0, "Enku Chief", 0, "LineageMonster.orc_champion", 10, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 162, 0, 0, 45, 120, 0, 1), 
(30617, 30617, "Burai", 0, "Turek Chief", 0, "LineageMonster.orc_shaman", 9, 22, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 172, 0, 0, 45, 120, 0, 1), 
(30618, 30618, "Harak", 0, "Leunt Chief", 0, "LineageMonster.orc_fighter", 12, 22, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 172, 0, 0, 45, 120, 0, 1), 
(30619, 30619, "Driko", 0, "Vuku Chief", 0, "LineageMonster.batur_orc_shaman", 11, 16, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 183, 0, 0, 50, 120, 0, 1), 
(30620, 30620, "Emily", 0, "", 0, "LineageNPC.a_common_peopleA_FHuman", 8, 21.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30621, 30621, "Nikola", 0, "Maestro", 0, "LineageNPC.e_smith_master_MDwarf", 8, 16.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30622, 30622, "Box Of Titan", 0, "", 0, "LineageNPC.coffer_b", 12, 9, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30623, 30623, "Kaien", 0, "Duelist", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 135, 0, 0, 50, 120, 0, 1), 
(30624, 30624, "Ascalon", 0, "Veteran", 0, "LineageNPC.a_wharfinger_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(30625, 30625, "Mason", 0, "", 0, "LineageNPC.a_wharfinger_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30626, 30626, "Hamil", 0, "Sagittarius", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30627, 30627, "Tree", 0, "", 0, "LineageNPC.human_tree", 35, 90, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30628, 30628, "Strong Wooden Chest", 0, "", 0, "LineageNPC.box", 18, 14, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30629, 30629, "Rukal", 0, "Bard", 0, "LineageNPC.a_common_people_MElf", 6, 21, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 4202, 0, 0, 50, 120, 0, 1), 
(30630, 30630, "Orim", 0, "Shadow", 0, "LineageNPC.a_hardins_pupil_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30631, 30631, "Roderik", 0, "Warden", 0, "LineageNPC.a_guard_MHuman", 8, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 2, 20, 0, 50, 120, 0, 1), 
(30632, 30632, "Endrigo", 0, "Warden", 0, "LineageNPC.a_guard_MHuman", 8, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 2, 20, 0, 50, 120, 0, 1), 
(30633, 30633, "Evert", 0, "Fisher", 0, "LineageNPC.a_common_peopleA_MHuman", 8, 21.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30634, 30634, "Galatea", 0, "High Summoner", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30635, 30635, "Almors", 0, "Summoner", 0, "LineageNPC.a_mageguild_teacher_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30636, 30636, "Camoniell", 0, "Summoner", 0, "LineageNPC.a_mageguild_teacher_FElf", 7, 21.2, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30637, 30637, "Belthus", 0, "Summoner", 0, "LineageNPC.a_mageguild_teacher_MDarkElf", 8, 22, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30638, 30638, "Basilla", 0, "Summoner", 0, "LineageNPC.a_mageguild_teacher_FHuman", 8, 23.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30639, 30639, "Celestiel", 0, "Summoner", 0, "LineageNPC.a_mageguild_teacher_MElf", 7, 22.2, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30640, 30640, "Brynthea", 0, "Summoner", 0, "LineageNPC.a_mageguild_teacher_FDarkElf", 8, 23, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30641, 30641, "Takuna", 0, "Duda-Mara Chief", 0, "LineageNPC.e_fighterguild_teacher_MOrc", 8, 28.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 202, 0, 0, 50, 120, 0, 1), 
(30642, 30642, "Chianta", 0, "Gandi Chief", 0, "LineageNPC.e_fighterguild_teacher_MOrc", 8, 28.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 175, 0, 0, 50, 120, 0, 1), 
(30643, 30643, "First Orc", 0, "", 0, "LineageNPC.e_patriarch_MOrc", 8, 26, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30644, 30644, "Kash", 0, "", 0, "LineageNPC.a_common_peopleA_MHuman", 8, 21.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30645, 30645, "Martien", 0, "", 0, "LineageNPC.a_common_peopleB_MHuman", 8, 22, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30646, 30646, "Raldo", 0, "Champion", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30647, 30647, "Chest Of Shyslassys", 0, "", 0, "LineageNPC.coffer_c", 12, 9, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30648, 30648, "Santiago", 0, "Hermit", 0, "LineageNPC.a_traderA_MHuman", 10, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30649, 30649, "Ancestor Martankus", 0, "", 0, "LineageNPC.orc_head", 110, 103, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30650, 30650, "Gerald", 0, "Priest of the Earth", 0, "LineageNPC.e_clergyman_MDwarf", 8, 17.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30651, 30651, "Dorf", 0, "Wanderer", 0, "LineageNPC.e_common_people_MDwarf", 8, 17, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30652, 30652, "Uruha", 0, "", 0, "LineageNPC.a_common_people_FDarkElf", 8, 21.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30653, 30653, "Sir Aron Tanford", 0, "", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30654, 30654, "Sir Kiel Nighthawk", 0, "", 0, "LineageNPC.a_fighterguild_teacher_MDarkElf", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 74, 0, 0, 50, 120, 0, 1), 
(30655, 30655, "Isael Silvershadow", 0, "", 0, "LineageNPC.a_fighterguild_teacher_FHuman", 9.5, 22.4, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30656, 30656, "Spirit Of Sir Talianus", 0, "", 0, "LineageMonster.human_ghost", 8, 22, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(30657, 30657, "Seresin", 0, "Cardinal", 0, "LineageNPC.a_sanctuary_teacher_FHuman", 8, 22.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30658, 30658, "Gupu", 0, "Father", 0, "LineageNPC.a_traderA_MDwarf", 8, 17, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30659, 30659, "Orphan Girl", 0, "", 0, "LineageNPC.e_traderA_FDwarf", 7, 18.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30660, 30660, "Windy Shaoring", 0, "", 0, "LineageNPC.e_collector_teacher_FDwarf", 8, 17.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30661, 30661, "Mysterious Dark Elf", 0, "", 0, "LineageNPC.a_casino_FDarkElf", 8, 23, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30662, 30662, "Piper Longbow", 0, "", 0, "LineageNPC.a_fighterguild_teacher_FElf", 8, 22.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30663, 30663, "Slein Shining Blade", 0, "", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 69, 0, 0, 50, 120, 0, 1), 
(30664, 30664, "Cain Flying Knife", 0, "", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 217, 0, 0, 50, 120, 0, 1), 
(30665, 30665, "Kristina", 0, "Saint", 0, "LineageNPC.a_sanctuary_teacher_FHuman", 8, 22.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30666, 30666, "Sla", 0, "Preacher", 0, "LineageNPC.a_mageguild_teacher_FHuman", 8, 23.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30667, 30667, "Ramus", 0, "", 0, "LineageNPC.a_mageguild_teacher_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30668, 30668, "Katari", 0, "", 0, "LineageNPC.a_common_people_FDarkElf", 8, 21.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30669, 30669, "Kakan", 0, "", 0, "LineageNPC.e_trader_FOrc", 8, 24, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30670, 30670, "Nyakuri", 0, "", 0, "LineageNPC.e_warehouse_keeper_FDwarf", 7, 18, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30671, 30671, "Croto", 0, "Chief", 0, "LineageNPC.e_guard_MOrc", 8, 27, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30672, 30672, "Dubabah", 0, "Jailer", 0, "LineageNPC.e_guard_MOrc", 8, 27, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30673, 30673, "Lorain", 0, "Researcher", 0, "LineageNPC.e_collector_teacher_FDwarf", 8, 17.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30674, 30674, "Daurin Hammercrush", 0, "", 0, "LineageNPC.e_common_people_MDwarf", 8, 17, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30675, 30675, "Corpse Of Kamur", 0, "", 0, "LineageNPC.e_trader_Morc_death", 22, 23.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30676, 30676, "Croop", 0, "Warehouse Chief", 0, "LineageNPC.e_warehouse_master_MDwarf", 8, 17.5, 70, "male", "L2VillageMasterDwarf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30677, 30677, "Flutter", 0, "Head Blacksmith", 0, "LineageNPC.e_smith_master_MDwarf", 8, 16.5, 70, "male", "L2VillageMasterDwarf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30678, 30678, "Helton", 0, "Blacksmith", 0, "LineageNPC.a_smith_MDwarf", 7, 16.5, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 89, 0, 0, 50, 120, 0, 1), 
(30679, 30679, "Roameria", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_FElf", 8, 22.5, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30680, 30680, "Egnos", 0, "Priest", 0, "LineageNPC.a_mageguild_teacher_MElf", 7, 22.2, 70, "male", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30681, 30681, "Karia", 0, "High Prefect", 0, "LineageNPC.e_trader_FOrc", 8, 24, 70, "female", "L2VillageMasterOrc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30682, 30682, "Pekiron", 0, "Seer", 0, "LineageNPC.e_clergyman_MOrc", 8, 29, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30683, 30683, "Daunt", 0, "Prefect", 0, "LineageNPC.e_fighterguild_teacher_MOrc", 8, 28.5, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30684, 30684, "Viktor", 0, "Trader", 0, "LineageNPC.a_traderB_MHuman", 8, 25, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30685, 30685, "Baxt", 0, "Warehouse Chief", 0, "LineageNPC.e_warehouse_master_MDwarf", 8, 17.5, 70, "male", "L2VillageMasterDwarf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30686, 30686, "Silva", 0, "Warehouse Keeper", 0, "LineageNPC.e_warehouse_keeper_FDwarf", 7, 18, 70, "female", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30687, 30687, "Vergara", 0, "Head Blacksmith", 0, "LineageNPC.e_smith_master_MDwarf", 8, 16.5, 70, "male", "L2VillageMasterDwarf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30688, 30688, "Duning", 0, "Blacksmith", 0, "LineageNPC.a_smith_MDwarf", 7, 16.5, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 89, 0, 0, 50, 120, 0, 1), 
(30689, 30689, "Siria", 0, "Grand Master", 0, "LineageNPC.a_fighterguild_master_FHuman", 8, 21.5, 70, "female", "L2VillageMasterFighter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30690, 30690, "Luther", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30691, 30691, "Aren Athebaldt", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30692, 30692, "Stedmiel", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_MElf", 7, 22.5, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30693, 30693, "Queenien", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_FElf", 8, 22.5, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30694, 30694, "Scraide", 0, "Grand Magister", 0, "LineageNPC.a_mageguild_master_MHuman", 8, 24, 70, "male", "L2VillageMasterMystic", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30695, 30695, "Moses", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_MHuman", 8, 23, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30696, 30696, "Page", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_FHuman", 8, 23.5, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30697, 30697, "Videlrien", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_FElf", 7, 21.2, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30698, 30698, "Evelyn", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_FElf", 7, 21.2, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30699, 30699, "Medown", 0, "Grand Master", 0, "LineageNPC.a_guild_master_MDarkElf", 8, 23, 70, "male", "L2VillageMasterDElf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30700, 30700, "Prestan", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_FDarkElf", 8, 23, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30701, 30701, "Errickin", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_MDarkElf", 8, 22, 70, "male", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30702, 30702, "Bernard", 0, "Guild President", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30703, 30703, "Colin", 0, "Guild President", 0, "LineageNPC.a_wharfinger_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30704, 30704, "Garvarentz", 0, "High Prefect", 0, "LineageNPC.e_patriarch_MOrc", 8, 26, 70, "male", "L2VillageMasterOrc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30705, 30705, "Chakiris", 0, "Prefect", 0, "LineageNPC.e_fighterguild_teacher_MOrc", 8, 28.5, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30706, 30706, "Lazenby", 0, "Seer", 0, "LineageNPC.e_clergyman_MOrc", 8, 29, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30707, 30707, "Raigen", 0, "Captain", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 129, 102, 0, 50, 120, 0, 1), 
(30708, 30708, "Nasign", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 2, 20, 0, 50, 120, 0, 1), 
(30709, 30709, "Norton", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 275, 0, 0, 50, 160, 0, 1), 
(30710, 30710, "Weston", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 2, 20, 0, 50, 120, 0, 1), 
(30711, 30711, "Byron", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 2, 20, 0, 50, 120, 0, 1), 
(30712, 30712, "Makhis", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 2, 20, 0, 50, 120, 0, 1), 
(30713, 30713, "Gardner", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 275, 0, 0, 50, 160, 0, 1), 
(30714, 30714, "Paros", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 2, 20, 0, 50, 120, 0, 1), 
(30715, 30715, "Marina", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_FHuman", 8, 23.5, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30716, 30716, "Cecile", 0, "Gatekeeper", 0, "LineageNPC.a_teleporter_FHuman", 8, 25, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30717, 30717, "Gauen", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_MElf", 7, 22.2, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30718, 30718, "Joan", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_FElf", 7, 21.2, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30719, 30719, "Mariell", 0, "Gatekeeper", 0, "LineageNPC.a_teleporter_FElf", 8.5, 23.5, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30720, 30720, "Kaiena", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_FDarkElf", 8, 23, 70, "female", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30721, 30721, "Ladd", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_MDarkElf", 8, 22, 70, "male", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30722, 30722, "Merian", 0, "Gatekeeper", 0, "LineageNPC.a_teleporter_FDarkElf", 8, 25, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30723, 30723, "Roy", 0, "Captain", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 129, 102, 0, 50, 120, 0, 1), 
(30724, 30724, "Tavillian", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 2, 20, 0, 50, 120, 0, 1), 
(30725, 30725, "Yening", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 2, 20, 0, 50, 120, 0, 1), 
(30726, 30726, "Tebose", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 2, 20, 0, 50, 120, 0, 1), 
(30727, 30727, "Verona", 0, "Gatekeeper", 0, "LineageNPC.a_teleporter_FHuman", 8, 25, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30728, 30728, "Leirynn", 0, "Militiaman", 0, "LineageNPC.a_fighterguild_teacher_FHuman", 9.5, 22.4, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 93, 0, 0, 50, 120, 0, 1), 
(30729, 30729, "Borys", 0, "Drunkard", 0, "LineageNPC.a_wharfinger_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30730, 30730, "Jax", 0, "Bodyguard", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 232, 0, 0, 50, 120, 0, 1), 
(30731, 30731, "Martin", 0, "Pet Manager", 0, "LineageNPC.a_traderB_MHuman", 8, 25, 70, "male", "L2PetManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30732, 30732, "Ol Mahum Pilgrim", 0, "", 0, "LineageMonster.ol_mahum", 13.5, 25, 36, "male", "L2Npc", 40, 809.52639, 417.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 137.86467, 140.57278, 94.1437, 102.86506, 253, 4, 333, 1, 0, 0, 50, 110, 0, 1), 
(30733, 30733, "Guard", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 275, 0, 0, 50, 160, 0, 1), 
(30734, 30734, "Supply Box On Wharf", 0, "", 0, "LineageNPC.box", 18, 14, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30735, 30735, "Sophya", 0, "Mercenary Captain", 0, "LineageNPC.a_fighterguild_master_FHuman", 8, 21.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30736, 30736, "Redfoot", 0, "Mercenary", 0, "LineageNPC.a_common_peopleA_MHuman", 8, 21.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30737, 30737, "Morgan", 0, "Guildsman", 0, "LineageNPC.a_traderA_MHuman", 10, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30738, 30738, "Matild", 0, "Alchemist", 0, "LineageNPC.e_traderA_FDwarf", 7, 18.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30739, 30739, "Keltir", 0, "Royal Servant", 0, "LineageMonster.fox", 9.5, 10, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 23, 110, 0, 1), 
(30740, 30740, "Toad", 0, "Royal Servant", 0, "LineageMonster.poison_toad", 20, 10, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(30741, 30741, "Rabbit", 0, "Royal Servant", 0, "LineageMonster.rabbit", 5, 4.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 80, 0, 1), 
(30742, 30742, "Rupina", 0, "Fairy of Love", 0, "LineageMonster.pixy", 5, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(30743, 30743, "Wisdom Chest", 0, "", 0, "LineageNPC.coffer_c", 12, 9, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30744, 30744, "Grey", 0, "Guild Member", 0, "LineageNPC.a_traderA_MHuman", 10, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30745, 30745, "Tor", 0, "Guild Member", 0, "LineageNPC.a_common_peopleA_MHuman", 8, 21.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30746, 30746, "Cybellin", 0, "", 0, "LineageNPC.a_teleporter_FDarkElf", 8, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30747, 30747, "Mimyu", 0, "Fairy", 0, "LineageMonster.pixy", 5, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(30748, 30748, "Exarion", 0, "Drake", 0, "LineageMonster.drake", 30, 100, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 70, 70, 0, 1), 
(30749, 30749, "Zwov", 0, "Drake", 0, "LineageMonster.drake", 30, 100, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 70, 70, 0, 1), 
(30750, 30750, "Kalibran", 0, "Drake", 0, "LineageMonster.drake", 30, 100, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 70, 70, 0, 1), 
(30751, 30751, "Suzet", 0, "Wyrm", 0, "LineageMonster.wyrm", 29, 72, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 70, 70, 0, 1), 
(30752, 30752, "Shamhai", 0, "Wyrm", 0, "LineageMonster.wyrm", 29, 72, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 70, 70, 0, 1), 
(30753, 30753, "Gabrielle", 0, "", 0, "LineageNPC.a_fighterguild_teacher_FHuman", 9.5, 22.4, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30754, 30754, "Gilmore", 0, "Antharas Watchman", 0, "LineageMonster.skeleton_knight", 10, 25, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 150, 0, 0, 40, 160, 0, 1), 
(30755, 30755, "Theodric", 0, "Antharas Watchman", 0, "LineageMonster.skeleton_knight", 10, 25, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 127, 0, 0, 40, 160, 0, 1), 
(30756, 30756, "Sir Kristof Rodemai", 0, "", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30757, 30757, "Statue Of Offering", 0, "", 0, "LineageNPC.castle_kent_statue_jewel", 25, 98, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(30758, 30758, "Athrea", 0, "Witch", 0, "LineageNPC.a_hardins_pupil_FHuman", 8, 23, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30759, 30759, "Kalis", 0, "Witch", 0, "LineageNPC.a_hardins_pupil_FHuman", 8, 23, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30760, 30760, "Sir Gustav Athebaldt", 0, "", 0, "LineageNPC2.gustaf_athebalt", 14, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30761, 30761, "Corpse Of Fritz", 0, "", 0, "LineageNPC.e_guard_MDwarf_death", 13, 19, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30762, 30762, "Corpse Of Lutz", 0, "", 0, "LineageNPC.e_guard_MDwarf_death", 13, 19, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30763, 30763, "Corpse Of Kurtz", 0, "", 0, "LineageNPC.e_guard_MDwarf_death", 13, 19, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30764, 30764, "Balthazar", 0, "", 0, "LineageNPC.e_common_people_MDwarf", 8, 17, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30765, 30765, "Imperial Coffer", 0, "", 0, "LineageNPC.coffer_d", 12, 9.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30766, 30766, "Cleo", 0, "Witch", 0, "LineageNPC.a_hardins_pupil_FHuman", 8, 23, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30767, 30767, "Auctioneer", 0, "", 0, "LineageNPC.a_maidB_FHuman", 8, 22, 70, "female", "L2Auctioneer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30768, 30768, "Auctioneer", 0, "", 0, "LineageNPC.a_trader_FElf", 8, 24, 70, "female", "L2Auctioneer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30769, 30769, "Auctioneer", 0, "", 0, "LineageNPC.a_common_people_FDarkElf", 8, 21.5, 70, "female", "L2Auctioneer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30770, 30770, "Auctioneer", 0, "", 0, "LineageNPC.e_traderA_FDwarf", 7, 18.5, 70, "female", "L2Auctioneer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30771, 30771, "Auctioneer", 0, "", 0, "LineageNPC.e_trader_FOrc", 8, 24, 70, "female", "L2Auctioneer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30772, 30772, "Wilson", 0, "Clan Hall Gatekeeper", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallDoormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30773, 30773, "Todd", 0, "Clan Hall Gatekeeper", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallDoormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30827, 30827, "Lundy", 0, "Pet Manager", 0, "LineageNPC.a_traderB_MHuman", 8, 25, 70, "male", "L2PetManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30828, 30828, "Waters", 0, "Pet Manager", 0, "LineageNPC.a_traderB_MHuman", 8, 25, 70, "male", "L2PetManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30829, 30829, "Cooper", 0, "Pet Manager", 0, "LineageNPC.a_traderB_MHuman", 8, 25, 70, "male", "L2PetManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30830, 30830, "Joey", 0, "Pet Manager", 0, "LineageNPC.a_traderB_MHuman", 8, 25, 70, "male", "L2PetManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30831, 30831, "Nelson", 0, "Pet Manager", 0, "LineageNPC.a_traderB_MHuman", 8, 25, 70, "male", "L2PetManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30832, 30832, "Hardin", 0, "", 0, "LineageNPC.a_hardin_MHuman", 8, 22.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30833, 30833, "Kaspar", 0, "Magister", 0, "LineageNPC.a_hardins_pupil_MHuman", 8, 23, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30834, 30834, "Cema", 0, "Magic Trader", 0, "LineageNPC.a_hardins_pupil_FHuman", 8, 23, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30835, 30835, "Icarus", 0, "Lich King", 0, "LineageMonster.vale_master", 12, 40, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 212, 0, 0, 70, 15, 0, 1), 
(30836, 30836, "Minerva", 0, "Gatekeeper", 0, "LineageNPC.a_teleporter_FDarkElf", 8, 25, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30837, 30837, "Woodrow", 0, "Weapon Merchant", 0, "LineageNPC.a_traderA_MHuman", 10, 24, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30838, 30838, "Woodley", 0, "Armor Merchant", 0, "LineageNPC.a_traderA_MHuman", 10, 24, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30839, 30839, "Holly", 0, "Grocer", 0, "LineageNPC.a_traderA_FHuman", 7, 23, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30840, 30840, "Lorenzo", 0, "Trader", 0, "LineageNPC.a_common_peopleB_MHuman", 8, 22, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30841, 30841, "Carson", 0, "Accessory Merchant", 0, "LineageNPC.a_traderB_MHuman", 8, 25, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30842, 30842, "Alexis", 0, "Accessory Merchant", 0, "LineageNPC.a_trader_FElf", 8, 24, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30843, 30843, "Romp", 0, "Warehouse Keeper", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 70, "male", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30844, 30844, "Walderal", 0, "Warehouse Keeper", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 70, "male", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30845, 30845, "Klump", 0, "Warehouse Chief", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 70, "male", "L2VillageMasterDwarf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30846, 30846, "Wilbert", 0, "Blacksmith", 0, "LineageNPC.a_smith_MDwarf", 7, 16.5, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 89, 0, 0, 50, 120, 0, 1), 
(30847, 30847, "Ferris", 0, "Head Blacksmith", 0, "LineageNPC.e_smith_master_MDwarf", 8, 16.5, 70, "male", "L2VillageMasterDwarf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30848, 30848, "Elisa", 0, "Gatekeeper", 0, "LineageNPC.a_teleporter_FHuman", 8, 25, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30849, 30849, "Sedrick", 0, "Grand Master", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 70, "male", "L2VillageMasterFighter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30850, 30850, "Aiken", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30851, 30851, "Kendra", 0, "Master", 0, "LineageNPC.a_fighterguild_master_FHuman", 8, 21.5, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30852, 30852, "Sinden", 0, "Master", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30853, 30853, "Raien", 0, "Master", 0, "LineageNPC.a_common_people_FElf", 7, 25.5, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30854, 30854, "Drikiyan", 0, "Grand Magister", 0, "LineageNPC.a_mageguild_master_MHuman", 8, 24, 70, "male", "L2VillageMasterMystic", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30855, 30855, "Desmond", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_MHuman", 8, 23, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30856, 30856, "Winonin", 0, "Magister", 0, "LineageNPC.a_common_people_FElf", 7, 25.5, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30857, 30857, "Orven", 0, "High Priest", 0, "LineageNPC.a_sanctuary_master_MHuman", 8, 24, 70, "male", "L2VillageMasterPriest", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30858, 30858, "Ross", 0, "Priest", 0, "LineageNPC.a_sanctuary_teacher_MHuman", 8, 23, 70, "male", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30859, 30859, "Vivyan", 0, "Priestess", 0, "LineageNPC.a_sanctuary_teacher_FHuman", 8, 22.5, 70, "female", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30860, 30860, "Flownia", 0, "Priestess", 0, "LineageNPC.a_trader_FElf", 8, 24, 70, "female", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30861, 30861, "Leonard", 0, "Priest", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 70, "male", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30862, 30862, "Oltran", 0, "Grand Master", 0, "LineageNPC.a_guild_master_MDarkElf", 8, 23, 70, "male", "L2VillageMasterDElf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30863, 30863, "Ghest", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_MDarkElf", 8, 23, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30864, 30864, "Hanellin", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_FDarkElf", 8, 23, 70, "female", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30865, 30865, "Ladanza", 0, "High Prefect", 0, "LineageNPC.e_patriarch_MOrc", 8, 26, 70, "male", "L2VillageMasterOrc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30866, 30866, "Marestella", 0, "Prefect", 0, "LineageNPC.e_trader_FOrc", 8, 24, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30867, 30867, "Reva", 0, "Seer", 0, "LineageNPC.e_trader_MOrc", 8, 23.5, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30868, 30868, "Sir Eric Rodemai", 0, "", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 128, 632, 0, 50, 120, 0, 1), 
(30869, 30869, "Lemper", 0, "Pet Manager", 0, "LineageNPC.a_traderB_MHuman", 8, 25, 70, "male", "L2PetManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30870, 30870, "Kurtiz", 0, "Captain", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 129, 102, 0, 50, 160, 0, 1), 
(30871, 30871, "Bret", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 275, 0, 0, 50, 160, 0, 1), 
(30872, 30872, "Conroy", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 2, 102, 0, 50, 160, 0, 1), 
(30873, 30873, "Coleman", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 275, 0, 0, 50, 160, 0, 1), 
(30874, 30874, "Aldis", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 2, 102, 0, 50, 160, 0, 1), 
(30875, 30875, "Carlton", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 275, 0, 0, 50, 160, 0, 1), 
(30876, 30876, "Eastan", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 2, 102, 0, 50, 160, 0, 1), 
(30877, 30877, "Grayson", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 275, 0, 0, 50, 160, 0, 1), 
(30878, 30878, "Angelina", 0, "Gatekeeper", 0, "LineageNPC.a_teleporter_FHuman", 8, 25, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30879, 30879, "Felton", 0, "Wharf Manager", 0, "LineageNPC.a_wharfinger_MHuman", 8, 23, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30880, 30880, "Viktor Van Dake", 0, "Border Outpost Captain", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 2, 0, 0, 50, 160, 0, 1), 
(30881, 30881, "Sanders", 0, "Border Outpost Aide", 0, "LineageNPC.a_common_peopleB_MHuman", 8, 22, 70, "male", "L2Guard", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30882, 30882, "Frontier Guard", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 2, 0, 0, 50, 160, 0, 1), 
(30883, 30883, "Frontier Guard", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 14, 0, 0, 50, 160, 0, 1), 
(30884, 30884, "Frontier Guard", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 2, 0, 0, 50, 160, 0, 1), 
(30885, 30885, "Frontier Guard", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 14, 0, 0, 50, 160, 0, 1), 
(30886, 30886, "Frontier Guard", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 2, 0, 0, 50, 160, 0, 1), 
(30887, 30887, "Frontier Guard", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 14, 0, 0, 50, 160, 0, 1), 
(30888, 30888, "Frontier Guard", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 2, 0, 0, 50, 160, 0, 1), 
(30889, 30889, "Frontier Guard", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 14, 0, 0, 50, 160, 0, 1), 
(30890, 30890, "Espen", 0, "Armor Merchant", 0, "LineageNPC.a_trader_MElf", 6, 24.5, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30891, 30891, "Verona", 0, "Weapon Merchant", 0, "LineageNPC.a_traderB_FHuman", 8, 24.5, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30892, 30892, "Enverun", 0, "Accessory Merchant", 0, "LineageNPC.a_traderA_MHuman", 10, 24, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30893, 30893, "Payel", 0, "Grocer", 0, "LineageNPC.a_trader_FElf", 8, 24, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30894, 30894, "Natools", 0, "Warehouse Chief", 0, "LineageNPC.e_warehouse_master_MDwarf", 8, 17.5, 70, "male", "L2VillageMasterDwarf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30895, 30895, "Kluck", 0, "Warehouse Keeper", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 70, "male", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30896, 30896, "Mia", 0, "Warehouse Keeper", 0, "LineageNPC.e_warehouse_keeper_FDwarf", 7, 18, 70, "female", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30897, 30897, "Roman", 0, "Head Blacksmith", 0, "LineageNPC.e_smith_master_MDwarf", 8, 16.5, 70, "male", "L2VillageMasterDwarf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30898, 30898, "Morning", 0, "Blacksmith", 0, "LineageNPC.e_smith_Fdwarf", 8, 17.5, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30899, 30899, "Flauen", 0, "Gatekeeper", 0, "LineageNPC.a_teleporter_FElf", 8.5, 23.5, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30900, 30900, "Marcus", 0, "Grand Master", 0, "LineageNPC.a_fighterguild_master_FHuman", 8, 21.5, 70, "female", "L2VillageMasterFighter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30901, 30901, "Arti", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30902, 30902, "Karuna", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30903, 30903, "Traus", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_MElf", 7, 22.5, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30904, 30904, "Naiel", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_FElf", 8, 22.5, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30905, 30905, "Squillari", 0, "High Priest", 0, "LineageNPC.a_sanctuary_master_MHuman", 8, 24, 70, "male", "L2VillageMasterPriest", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30906, 30906, "Ranton", 0, "Priest", 0, "LineageNPC.a_sanctuary_teacher_MHuman", 8, 23, 70, "male", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30907, 30907, "Minevia", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_FHuman", 8, 23.5, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30908, 30908, "Tanios", 0, "Priest", 0, "LineageNPC.a_mageguild_teacher_MElf", 7, 22.2, 70, "male", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30909, 30909, "Anabel", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_FElf", 7, 21.2, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30910, 30910, "Xairakin", 0, "Grand Master", 0, "LineageNPC.a_guild_master_MDarkElf", 8, 23, 70, "male", "L2VillageMasterDElf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30911, 30911, "Brikus", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_MDarkElf", 8, 23, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30912, 30912, "Xenovia", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_FDarkElf", 8, 23, 70, "female", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30913, 30913, "Tushku", 0, "High Prefect", 0, "LineageNPC.e_patriarch_MOrc", 8, 26, 70, "male", "L2VillageMasterOrc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30914, 30914, "Sorbo", 0, "Prefect", 0, "LineageNPC.e_trader_FOrc", 8, 24, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30915, 30915, "Takina", 0, "Seer", 0, "LineageNPC.e_mageguild_teacher_FOrc", 8, 28, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30916, 30916, "Gosta", 0, "Captain", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 129, 102, 0, 50, 160, 0, 1), 
(30917, 30917, "Dupuis", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 275, 0, 0, 50, 160, 0, 1), 
(30918, 30918, "Kent", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 2, 102, 0, 50, 160, 0, 1), 
(30919, 30919, "Rodic", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 275, 0, 0, 50, 160, 0, 1), 
(30920, 30920, "Kraisen", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 2, 102, 0, 50, 160, 0, 1), 
(30921, 30921, "Timos", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 275, 0, 0, 50, 160, 0, 1), 
(30922, 30922, "Cage", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 2, 102, 0, 50, 160, 0, 1), 
(30923, 30923, "Dunst", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 275, 0, 0, 50, 160, 0, 1), 
(30924, 30924, "Nedy", 0, "Wharf Manager", 0, "LineageNPC.a_wharfinger_MHuman", 8, 23, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30925, 30925, "Morelyn", 0, "High Priestess", 0, "LineageNPC.a_mageguild_teacher_FElf", 7, 22.2, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30926, 30926, "Restina", 0, "Priestess", 0, "LineageNPC.a_mageguild_teacher_FElf", 7, 22.2, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30927, 30927, "Alicia", 0, "Priestess", 0, "LineageNPC.a_sanctuary_teacher_FHuman", 8, 22.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30928, 30928, "Fenster", 0, "Mercenary", 0, "LineageNPC.e_collector_teacher_MDwarf", 8, 17.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30929, 30929, "Patrin", 0, "Antique Dealer", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30930, 30930, "Rogent", 0, "Antique Appraiser", 0, "LineageNPC.e_mine_master_MDwarf", 8, 19.7, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30931, 30931, "Bentley", 0, "", 0, "LineageNPC.a_traderA_MDwarf", 8, 17, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30932, 30932, "Benica", 0, "", 0, "LineageNPC.e_collector_teacher_FDwarf", 8, 17.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30933, 30933, "Braki", 0, "", 0, "LineageNPC.e_collector_teacher_MDwarf", 8, 17.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30934, 30934, "Marsha", 0, "Collector", 0, "LineageNPC.e_collector_teacher_FDwarf", 8, 17.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30935, 30935, "Trumpin", 0, "Collector", 0, "LineageNPC.e_collector_teacher_MDwarf", 8, 17.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30936, 30936, "Malcom1", 0, "Frog Prince", 0, "LineageMonster.poison_toad", 20, 10, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30937, 30937, "Malcom2", 0, "Wild Boar Prince", 0, "LineageMonster.giant_wild_hog", 35, 27, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 35, 120, 0, 1), 
(30938, 30938, "Malcom3", 0, "Orc Prince", 0, "LineageMonster.ketra_orc", 12, 29, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 45, 120, 0, 1), 
(30939, 30939, "Malcom4", 0, "Prince of Darkness", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(30940, 30940, "Malcom5", 0, "Gremlin Prince", 0, "LineageMonster.gremlin", 10, 15, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 20, 120, 0, 1), 
(30941, 30941, "Malcom6", 0, "Prince of Wild Beast", 0, "LineageMonster.saber_toothed_tiger", 34, 28, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(30942, 30942, "Malcom7", 0, "Monster Eye Prince", 0, "LineageMonster.monster_eye", 21, 43, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 90, 120, 0, 1), 
(30943, 30943, "Malcom8", 0, "Rabbit Prince", 0, "LineageMonster.rabbit", 5, 4.5, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30944, 30944, "Malcom9", 0, "Human Prince", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30945, 30945, "Malcom10", 0, "Prince", 0, "LineageNPC.e_collector_master_MDwarf", 8, 18.4, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30946, 30946, "Lucianne Tanford", 0, "", 0, "LineageNPC.a_fighterguild_master_FHuman", 8, 21.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30947, 30947, "Rerikya", 0, "", 0, "LineageNPC.e_trader_FOrc", 8, 24, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30948, 30948, "Meridien", 0, "", 0, "LineageNPC.a_common_people_FElf", 7, 25.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30949, 30949, "Keplon", 0, "Researcher", 0, "LineageNPC.e_mine_master_MDwarf", 8, 19.7, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30950, 30950, "Euclie", 0, "Researcher", 0, "LineageNPC.e_mine_teacher_FDwarf", 8, 18.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30951, 30951, "Pithgon", 0, "Researcher", 0, "LineageNPC.e_mine_master_MDwarf", 8, 19.7, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30952, 30952, "Dimensional Vortex 1", 0, "", 0, "LineageNPC.broadcasting_tower", 7, 35, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30953, 30953, "Dimensional Vortex 2", 0, "", 0, "LineageNPC.broadcasting_tower", 7, 35, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30954, 30954, "Dimensional Vortex 3", 0, "", 0, "LineageNPC.broadcasting_tower", 7, 35, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30955, 30955, "Gillian's Revenant", 0, "", 0, "LineageMonster.zombie", 13, 21, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 15, 120, 0, 1), 
(30956, 30956, "Nanarin", 0, "Musician", 0, "LineageNPC.a_fighterguild_teacher_FDarkElf", 8, 23, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 325, 0, 0, 50, 120, 0, 1), 
(30957, 30957, "Swan", 0, "Bard", 0, "LineageNPC.a_common_peopleB_MHuman", 8, 22, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 4202, 0, 0, 50, 120, 0, 1), 
(30958, 30958, "Galion", 0, "", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30959, 30959, "Barbado", 0, "Musician", 0, "LineageNPC.e_collector_teacher_MDwarf", 8, 17.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 5133, 0, 0, 50, 120, 0, 1), 
(30960, 30960, "Beer Chest", 0, "", 0, "LineageNPC.box", 18, 14, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30961, 30961, "Cloth Chest", 0, "", 0, "LineageNPC.coffer_d", 12, 9.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30962, 30962, "Statue of Water", 0, "", 0, "LineageNPC.coffer_d", 12, 9.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30963, 30963, "Statue of Fire", 0, "", 0, "LineageNPC.coffer_d", 12, 9.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30964, 30964, "Statue of Wind", 0, "", 0, "LineageNPC.coffer_d", 12, 9.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30965, 30965, "Statue of Earth", 0, "", 0, "LineageNPC.coffer_d", 12, 9.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30966, 30966, "Statue of Darkness", 0, "", 0, "LineageNPC.coffer_d", 12, 9.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30967, 30967, "Statue of Light", 0, "", 0, "LineageNPC.coffer_d", 12, 9.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30968, 30968, "Jennifer", 0, "Lady Orc", 0, "LineageNPC.e_trader_FOrc", 8, 24, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30969, 30969, "Iason Heine", 0, "", 0, "LineageNPC2.iason_haine", 13.5, 20.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30970, 30970, "Dorothy", 0, "Locksmith", 0, "LineageNPC.a_fighterguild_teacher_FHuman", 9.5, 22.4, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30971, 30971, "Orpheus", 0, "Mad Doctor", 0, "LineageNPC.e_mine_teacher_MDwarf", 8, 18, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30972, 30972, "Orpheus Resurrecter", 0, "", 0, "LineageMonster.susceptor", 20, 35, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 27, 120, 0, 1), 
(30973, 30973, "Medium Jar", 0, "", 0, "LineageNPC.pot", 10, 15, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30974, 30974, "Oliver", 0, "Resurrected Adventurer", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30975, 30975, "Clarine", 0, "Resurrected Adventurer", 0, "LineageNPC.e_collector_teacher_FDwarf", 8, 17.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30976, 30976, "Resurrected Town Maiden", 0, "", 0, "LineageNPC.a_common_peopleB_FHuman", 8, 20.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30977, 30977, "Holy Ark of Secrecy 1", 0, "", 0, "LineageNPC.coffer_a", 12, 9.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30978, 30978, "Holy Ark of Secrecy 2", 0, "", 0, "LineageNPC.coffer_b", 12, 9, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30979, 30979, "Holy Ark of Secrecy 3", 0, "", 0, "LineageNPC.coffer_c", 12, 9, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30980, 30980, "Ark Guardian's Corpse", 0, "", 0, "LineageNPC.angel_death", 25, 36.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30981, 30981, "Black Judge", 0, "", 0, "LineageNPC.a_clergyman_FDarkElf", 8, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30982, 30982, "Sleeping Ant Larva1", 0, "", 0, "LineageMonster.ant_larva", 12, 8, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 120, 0, 1), 
(30983, 30983, "Sleeping Ant Larva2", 0, "", 0, "LineageMonster.ant_larva", 12, 8, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 120, 0, 1), 
(30984, 30984, "Sleeping Ant Larva3", 0, "", 0, "LineageMonster.ant_larva", 12, 8, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 120, 0, 1), 
(30985, 30985, "Sleeping Ant Larva4", 0, "", 0, "LineageMonster.ant_larva", 12, 8, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 120, 0, 1), 
(30986, 30986, "Sleeping Ant Larva5", 0, "", 0, "LineageMonster.ant_larva", 12, 8, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 120, 0, 1), 
(30987, 30987, "Sleeping Ant Larva6", 0, "", 0, "LineageMonster.ant_larva", 12, 8, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 120, 0, 1), 
(30988, 30988, "Verce", 0, "Leathersmith", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30989, 30989, "Chest of Bifrons", 0, "", 0, "LineageNPC.coffer_c", 12, 9, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30990, 30990, "Lottery Ticket Seller", 0, "", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30991, 30991, "Lottery Ticket Seller", 0, "", 0, "LineageNPC.a_trader_MElf", 6, 24.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30992, 30992, "Lottery Ticket Seller", 0, "", 0, "LineageNPC.a_trader_MDarkElf", 8, 22.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30993, 30993, "Lottery Ticket Seller", 0, "", 0, "LineageNPC.a_traderA_MDwarf", 8, 17, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30994, 30994, "Lottery Ticket Seller", 0, "", 0, "LineageNPC.e_trader_MOrc", 8, 23.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(30995, 30995, "Race Manager", 0, "", 0, "LineageNPC.e_teleporter_FDwarf", 8, 21.3, 70, "female", "L2RaceManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31001, 31001, "Claudia Athebaldt", 0, "", 0, "LineageNPC2.madam_claudia", 10, 22, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31002, 31002, "Reorin", 0, "Maestro", 0, "LineageNPC.e_smith_master_MDwarf", 8, 16.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31003, 31003, "Here I Come", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31004, 31004, "Half Moon Love", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 70, "female", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 48, 120, 0, 1), 
(31005, 31005, "Everlasting", 0, "", 0, "LineageMonster.mechanic_golem", 5, 19, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(31006, 31006, "Dark Side of the Moon", 0, "", 0, "LineageMonster.silhouette", 8, 23, 70, "female", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31007, 31007, "Wind Rider", 0, "", 0, "LineageMonster.unicorn_boxer", 11, 18, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 27, 120, 0, 1), 
(31008, 31008, "Shooting Star", 0, "", 0, "LineageMonster.unicorn_mirage", 13, 17, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 27, 120, 0, 1), 
(31009, 31009, "Cyclone Thunder", 0, "", 0, "LineageMonster.dark_fencer", 7, 13, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 25, 120, 0, 1), 
(31010, 31010, "Hungry Baby", 0, "", 0, "LineageMonster.hatchling", 9, 10, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31011, 31011, "Salty Dog", 0, "", 0, "LineageMonster.pet_wolf", 13, 11.5, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 24, 120, 0, 1), 
(31012, 31012, "Raging Revolution", 0, "", 0, "LineageMonster.silver_cat", 7, 15, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 48, 120, 0, 1), 
(31013, 31013, "Valentine Blue", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 48, 120, 0, 1), 
(31014, 31014, "Light My Fire", 0, "", 0, "LineageMonster.big_boom", 6, 13, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 48, 120, 0, 1), 
(31015, 31015, "Red Bullet", 0, "", 0, "LineageMonster.fox", 9.5, 10, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 23, 120, 0, 1), 
(31016, 31016, "Shining Silver", 0, "", 0, "LineageMonster.rabbit", 5, 4.5, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31017, 31017, "Over the top", 0, "", 0, "LineageMonster.ant_larva", 12, 8, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 120, 0, 1), 
(31018, 31018, "Royal Straight", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31019, 31019, "All Seven", 0, "", 0, "LineageMonster.wererat", 14, 25, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31020, 31020, "Nasty Green", 0, "", 0, "LineageMonster.dryad", 9, 20, 70, "female", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 120, 0, 1), 
(31021, 31021, "Shortcut", 0, "", 0, "LineageMonster.goblin", 10, 16.5, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 120, 0, 1), 
(31022, 31022, "Typhoon Tiger", 0, "", 0, "LineageMonster.giant_bee", 8, 24.5, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 90, 120, 0, 1), 
(31023, 31023, "Red Hot", 0, "", 0, "LineageMonster.salamander", 16, 6.8, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 64, 120, 0, 1), 
(31024, 31024, "Galaxy Express", 0, "", 0, "LineageMonster.onyx_beast", 14, 14.5, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(31025, 31025, "Best Condition", 0, "", 0, "LineageMonster.manadragora", 14, 17.8, 70, "female", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31026, 31026, "Albatross", 0, "", 0, "LineageMonster.orc", 10, 21, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 45, 120, 0, 1), 
(31027, 31027, "Coffer of the Dead", 0, "", 0, "LineageNPC.coffer_b", 12, 9, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31028, 31028, "Chest of Kernon", 0, "", 0, "LineageNPC.coffer_c", 12, 9, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31029, 31029, "Chest of Golkonda", 0, "", 0, "LineageNPC.coffer_c", 12, 9, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31030, 31030, "Chest of Hallate", 0, "", 0, "LineageNPC.coffer_c", 12, 9, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31031, 31031, "Broadcasting Tower", 0, "", 0, "LineageNPC.broadcasting_tower", 7, 35, 70, "etc", "L2Observation", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31032, 31032, "Guard", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 275, 0, 0, 50, 160, 0, 1), 
(31033, 31033, "Sentinel", 0, "", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 276, 0, 0, 50, 160, 0, 1), 
(31034, 31034, "Sentry", 0, "", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 80, "female", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 277, 0, 0, 50, 160, 0, 1), 
(31035, 31035, "Defender", 0, "", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 275, 0, 0, 50, 160, 0, 1), 
(31036, 31036, "Centurion", 0, "", 0, "LineageNPC.e_guard_MOrc", 8, 27, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 273, 0, 0, 50, 160, 0, 1), 
(31042, 31042, "Kantabilon", 0, "Melody Maestro", 0, "LineageNPC.e_common_people_MDwarf", 8, 17, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31043, 31043, "Octavia", 0, "Melody Maestro", 0, "LineageNPC.e_traderA_FDwarf", 7, 18.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31044, 31044, "Galman", 0, "Valley Trader", 0, "LineageNPC.e_smith_master_MDwarf", 8, 16.5, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31045, 31045, "Kitzka", 0, "Valley Trader", 0, "LineageNPC.e_collector_teacher_FDwarf", 8, 17.5, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31046, 31046, "Marsden", 0, "Symbol Maker", 0, "LineageNPC.a_traderC_Mhuman", 8, 23, 70, "male", "L2SymbolMaker", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31047, 31047, "Kell", 0, "Symbol Maker", 0, "LineageNPC.a_traderC_Mhuman", 8, 23, 70, "male", "L2SymbolMaker", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31048, 31048, "McDermott", 0, "Symbol Maker", 0, "LineageNPC.a_traderC_Mhuman", 8, 23, 70, "male", "L2SymbolMaker", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31049, 31049, "Pepper", 0, "Symbol Maker", 0, "LineageNPC.a_traderC_Mhuman", 8, 23, 70, "male", "L2SymbolMaker", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31050, 31050, "Thora", 0, "Symbol Maker", 0, "LineageNPC.a_traderC_Mhuman", 8, 23, 70, "male", "L2SymbolMaker", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31051, 31051, "Keach", 0, "Symbol Maker", 0, "LineageNPC.a_traderC_Mhuman", 8, 23, 70, "male", "L2SymbolMaker", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31052, 31052, "Heid", 0, "Symbol Maker", 0, "LineageNPC.a_traderC_Mhuman", 8, 23, 70, "male", "L2SymbolMaker", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31053, 31053, "Kidder", 0, "Symbol Maker", 0, "LineageNPC.a_mageguild_teacher_FHuman", 8, 23.5, 70, "female", "L2SymbolMaker", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31067, 31067, "Rood", 0, "Pet Manager", 0, "LineageNPC.a_traderB_MHuman", 8, 25, 70, "male", "L2PetManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31074, 31074, "Corpse of Hutaku", 0, "", 0, "LineageNPC.e_trader_Morc_death", 22, 23.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31075, 31075, "Sales Cat of Ivory Tower", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31076, 31076, "Newbie Guide", 0, "", 0, "LineageNPC.a_common_peopleB_FHuman", 8, 20.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31077, 31077, "Newbie Guide", 0, "", 0, "LineageNPC.a_common_peopleB_FHuman", 8, 20.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31078, 31078, "Priest of Dawn", 0, "", 0, "LineageNPC.priest_of_dawn", 8, 30.5, 70, "male", "L2DawnPriest", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 5802, 0, 50, 120, 0, 1), 
(31079, 31079, "Priest of Dawn", 0, "", 0, "LineageNPC.priest_of_dawn", 8, 30.5, 70, "male", "L2DawnPriest", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 5802, 0, 50, 120, 0, 1), 
(31080, 31080, "Priest of Dawn", 0, "", 0, "LineageNPC.priest_of_dawn", 8, 30.5, 70, "male", "L2DawnPriest", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 5802, 0, 50, 120, 0, 1), 
(31081, 31081, "Priest of Dawn", 0, "", 0, "LineageNPC.priest_of_dawn", 8, 30.5, 70, "male", "L2DawnPriest", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 5802, 0, 50, 120, 0, 1), 
(31082, 31082, "Priest of Dawn", 0, "", 0, "LineageNPC.priest_of_dawn", 8, 30.5, 70, "male", "L2DawnPriest", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 5802, 0, 50, 120, 0, 1), 
(31083, 31083, "Priest of Dawn", 0, "", 0, "LineageNPC.priest_of_dawn", 8, 30.5, 70, "male", "L2DawnPriest", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 5802, 0, 50, 120, 0, 1), 
(31084, 31084, "Priest of Dawn", 0, "", 0, "LineageNPC.priest_of_dawn", 8, 30.5, 70, "male", "L2DawnPriest", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 5802, 0, 50, 120, 0, 1), 
(31085, 31085, "Dusk Priestess", 0, "", 0, "LineageNPC.priest_of_dusk", 8, 22, 70, "female", "L2DuskPriest", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 5801, 0, 0, 50, 120, 0, 1), 
(31086, 31086, "Dusk Priestess", 0, "", 0, "LineageNPC.priest_of_dusk", 8, 22, 70, "female", "L2DuskPriest", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 5801, 0, 0, 50, 120, 0, 1), 
(31087, 31087, "Dusk Priestess", 0, "", 0, "LineageNPC.priest_of_dusk", 8, 22, 70, "female", "L2DuskPriest", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 5801, 0, 0, 50, 120, 0, 1), 
(31088, 31088, "Dusk Priestess", 0, "", 0, "LineageNPC.priest_of_dusk", 8, 22, 70, "female", "L2DuskPriest", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 5801, 0, 0, 50, 120, 0, 1), 
(31089, 31089, "Dusk Priestess", 0, "", 0, "LineageNPC.priest_of_dusk", 8, 22, 70, "female", "L2DuskPriest", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 5801, 0, 0, 50, 120, 0, 1), 
(31090, 31090, "Dusk Priestess", 0, "", 0, "LineageNPC.priest_of_dusk", 8, 22, 70, "female", "L2DuskPriest", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 5801, 0, 0, 50, 120, 0, 1), 
(31091, 31091, "Dusk Priestess", 0, "", 0, "LineageNPC.priest_of_dusk", 8, 22, 70, "female", "L2DuskPriest", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 5801, 0, 0, 50, 120, 0, 1), 
(31092, 31092, "Black Marketeer of Mammon", 0, "", 0, "LineageNPC.black_market_trader_MDwarf", 8, 18, 70, "male", "L2SignsPriest", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31093, 31093, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(31094, 31094, "Orator of Revelations", 0, "", 0, "LineageMonster.liviona", 15, 28, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31095, 31095, "Gatekeeper Ziggurat", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 70, "etc", "L2DungeonGatekeeper", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31096, 31096, "Gatekeeper Ziggurat", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 70, "etc", "L2DungeonGatekeeper", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31097, 31097, "Gatekeeper Ziggurat", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 70, "etc", "L2DungeonGatekeeper", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31098, 31098, "Gatekeeper Ziggurat", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 70, "etc", "L2DungeonGatekeeper", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31099, 31099, "Gatekeeper Ziggurat", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 70, "etc", "L2DungeonGatekeeper", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31100, 31100, "Gatekeeper Ziggurat", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 70, "etc", "L2DungeonGatekeeper", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31101, 31101, "Gatekeeper Ziggurat", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 70, "etc", "L2DungeonGatekeeper", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31102, 31102, "Gatekeeper Ziggurat", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 70, "etc", "L2DungeonGatekeeper", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31103, 31103, "Gatekeeper Ziggurat", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 70, "etc", "L2DungeonGatekeeper", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31104, 31104, "Gatekeeper Ziggurat", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 70, "etc", "L2DungeonGatekeeper", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31105, 31105, "Gatekeeper Ziggurat", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 70, "etc", "L2DungeonGatekeeper", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31106, 31106, "Gatekeeper Ziggurat", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 70, "etc", "L2DungeonGatekeeper", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31107, 31107, "Gatekeeper Ziggurat", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 70, "etc", "L2DungeonGatekeeper", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31108, 31108, "Gatekeeper Ziggurat", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 70, "etc", "L2DungeonGatekeeper", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31109, 31109, "Gatekeeper Ziggurat", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 70, "etc", "L2DungeonGatekeeper", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31110, 31110, "Gatekeeper Ziggurat", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 70, "etc", "L2DungeonGatekeeper", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31111, 31111, "Gatekeeper Spirit", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 70, "etc", "L2DungeonGatekeeper", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31112, 31112, "Gatekeeper Spirit", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 70, "etc", "L2DungeonGatekeeper", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31113, 31113, "Merchant of Mammon", 0, "", 0, "LineageNPC.black_market_trader_MDwarf_set", 22, 18, 70, "male", "L2SignsPriest", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31114, 31114, "Gatekeeper Ziggurat", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 70, "etc", "L2DungeonGatekeeper", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31115, 31115, "Gatekeeper Ziggurat", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 70, "etc", "L2DungeonGatekeeper", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31116, 31116, "Gatekeeper Ziggurat", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 70, "etc", "L2DungeonGatekeeper", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31117, 31117, "Gatekeeper Ziggurat", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 70, "etc", "L2DungeonGatekeeper", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31118, 31118, "Gatekeeper Ziggurat", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 70, "etc", "L2DungeonGatekeeper", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31119, 31119, "Gatekeeper Ziggurat", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 70, "etc", "L2DungeonGatekeeper", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31120, 31120, "Gatekeeper Ziggurat", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 70, "etc", "L2DungeonGatekeeper", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31121, 31121, "Gatekeeper Ziggurat", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 70, "etc", "L2DungeonGatekeeper", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31122, 31122, "Gatekeeper Ziggurat", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 70, "etc", "L2DungeonGatekeeper", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31123, 31123, "Gatekeeper Ziggurat", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 70, "etc", "L2DungeonGatekeeper", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31124, 31124, "Gatekeeper Ziggurat", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 70, "etc", "L2DungeonGatekeeper", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31125, 31125, "Gatekeeper Ziggurat", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 70, "etc", "L2DungeonGatekeeper", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31126, 31126, "Blacksmith of Mammon", 0, "", 0, "LineageNPC.e_smith_master_MDwarf", 8, 16.5, 70, "male", "L2SignsPriest", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31127, 31127, "Festival Guide", 0, "Level 31 and Below", 0, "LineageNPC.priest_of_dawn", 8, 30.5, 70, "male", "L2FestivalGuide", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 5802, 0, 50, 120, 0, 1), 
(31128, 31128, "Festival Guide", 0, "Level 42 and Below", 0, "LineageNPC.priest_of_dawn", 8, 30.5, 70, "male", "L2FestivalGuide", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 5802, 0, 50, 120, 0, 1), 
(31129, 31129, "Festival Guide", 0, "Level 53 and Below", 0, "LineageNPC.priest_of_dawn", 8, 30.5, 70, "male", "L2FestivalGuide", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 5802, 0, 50, 120, 0, 1), 
(31130, 31130, "Festival Guide", 0, "Level 64 and Below", 0, "LineageNPC.priest_of_dawn", 8, 30.5, 70, "male", "L2FestivalGuide", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 5802, 0, 50, 120, 0, 1), 
(31131, 31131, "Festival Guide", 0, "No Level Limit", 0, "LineageNPC.priest_of_dawn", 8, 30.5, 70, "male", "L2FestivalGuide", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 5802, 0, 50, 120, 0, 1), 
(31132, 31132, "Festival Witch", 0, "", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 70, "female", "L2FestivalGuide", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31133, 31133, "Festival Witch", 0, "", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 70, "female", "L2FestivalGuide", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31134, 31134, "Festival Witch", 0, "", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 70, "female", "L2FestivalGuide", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31135, 31135, "Festival Witch", 0, "", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 70, "female", "L2FestivalGuide", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31136, 31136, "Festival Witch", 0, "", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 70, "female", "L2FestivalGuide", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31137, 31137, "Festival Guide", 0, "Level 31 and Below", 0, "LineageNPC.priest_of_dusk", 8, 22, 70, "female", "L2FestivalGuide", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 5801, 0, 0, 50, 120, 0, 1), 
(31138, 31138, "Festival Guide", 0, "Level 42 and Below", 0, "LineageNPC.priest_of_dusk", 8, 22, 70, "female", "L2FestivalGuide", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 5801, 0, 0, 50, 120, 0, 1), 
(31139, 31139, "Festival Guide", 0, "Level 53 and Below", 0, "LineageNPC.priest_of_dusk", 8, 22, 70, "female", "L2FestivalGuide", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 5801, 0, 0, 50, 120, 0, 1), 
(31140, 31140, "Festival Guide", 0, "Level 64 and Below", 0, "LineageNPC.priest_of_dusk", 8, 22, 70, "female", "L2FestivalGuide", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 5801, 0, 0, 50, 120, 0, 1), 
(31141, 31141, "Festival Guide", 0, "No Level Limit", 0, "LineageNPC.priest_of_dusk", 8, 22, 70, "female", "L2FestivalGuide", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 5801, 0, 0, 50, 120, 0, 1), 
(31142, 31142, "Festival Witch", 0, "", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 70, "female", "L2FestivalGuide", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31143, 31143, "Festival Witch", 0, "", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 70, "female", "L2FestivalGuide", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31144, 31144, "Festival Witch", 0, "", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 70, "female", "L2FestivalGuide", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31145, 31145, "Festival Witch", 0, "", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 70, "female", "L2FestivalGuide", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31146, 31146, "Festival Witch", 0, "", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 70, "female", "L2FestivalGuide", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31147, 31147, "Sobling", 0, "Head Researcher", 0, "LineageNPC.e_mine_master_MDwarf", 8, 19.7, 70, "male", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31148, 31148, "Pirate's Chest", 0, "", 0, "LineageNPC.coffer_c", 12, 9, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31149, 31149, "Alchemist's Mixing Urn", 0, "", 0, "LineageNPC.pot", 10, 15, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31168, 31168, "Priest of Dawn", 0, "", 0, "LineageNPC.priest_of_dawn", 8, 30.5, 70, "male", "L2DawnPriest", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 5802, 0, 50, 120, 0, 1), 
(31169, 31169, "Dusk Priestess", 0, "", 0, "LineageNPC.priest_of_dusk", 8, 22, 70, "female", "L2DuskPriest", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 5801, 0, 0, 50, 120, 0, 1), 
(31170, 31170, "Crest of Dawn", 0, "", 0, "LineageDeco.flag_ssq", 0.01, 0.01, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31171, 31171, "Crest of Dusk", 0, "", 0, "LineageDeco.flag_ssq", 0.01, 0.01, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31172, 31172, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(31173, 31173, "Orator of Revelations", 0, "", 0, "LineageMonster.liviona", 15, 28, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31174, 31174, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(31175, 31175, "Orator of Revelations", 0, "", 0, "LineageMonster.liviona", 15, 28, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31176, 31176, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(31177, 31177, "Orator of Revelations", 0, "", 0, "LineageMonster.liviona", 15, 28, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31178, 31178, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(31179, 31179, "Orator of Revelations", 0, "", 0, "LineageMonster.liviona", 15, 28, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31180, 31180, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(31181, 31181, "Orator of Revelations", 0, "", 0, "LineageMonster.liviona", 15, 28, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31182, 31182, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(31183, 31183, "Orator of Revelations", 0, "", 0, "LineageMonster.liviona", 15, 28, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31184, 31184, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(31185, 31185, "Orator of Revelations", 0, "", 0, "LineageMonster.liviona", 15, 28, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31186, 31186, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(31187, 31187, "Orator of Revelations", 0, "", 0, "LineageMonster.liviona", 15, 28, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31188, 31188, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(31189, 31189, "Orator of Revelations", 0, "", 0, "LineageMonster.liviona", 15, 28, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31190, 31190, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(31191, 31191, "Orator of Revelations", 0, "", 0, "LineageMonster.liviona", 15, 28, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31192, 31192, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(31193, 31193, "Orator of Revelations", 0, "", 0, "LineageMonster.liviona", 15, 28, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31194, 31194, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(31195, 31195, "Orator of Revelations", 0, "", 0, "LineageMonster.liviona", 15, 28, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31196, 31196, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(31197, 31197, "Orator of Revelations", 0, "", 0, "LineageMonster.liviona", 15, 28, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31198, 31198, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(31199, 31199, "Orator of Revelations", 0, "", 0, "LineageMonster.liviona", 15, 28, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31200, 31200, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(31201, 31201, "Orator of Revelations", 0, "", 0, "LineageMonster.liviona", 15, 28, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31202, 31202, "Maximus", 0, "", 0, "LineageMonster.pet_wolf", 13, 11.5, 70, "male", "L2TownPet", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 24, 120, 0, 1), 
(31203, 31203, "Moon Dancer", 0, "", 0, "LineageMonster.pet_wolf", 13, 11.5, 70, "male", "L2TownPet", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 24, 120, 0, 1), 
(31204, 31204, "Georgio", 0, "", 0, "LineageMonster.pet_wolf", 13, 11.5, 70, "male", "L2TownPet", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 24, 120, 0, 1), 
(31205, 31205, "Katz", 0, "", 0, "LineageMonster.hatchling", 9, 10, 70, "male", "L2TownPet", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31206, 31206, "Ten Ten", 0, "", 0, "LineageMonster.hatchling", 9, 10, 70, "male", "L2TownPet", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31207, 31207, "Sardinia", 0, "", 0, "LineageMonster.hatchling", 9, 10, 70, "male", "L2TownPet", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31208, 31208, "La Grange", 0, "", 0, "LineageMonster.hatchling", 9, 10, 70, "male", "L2TownPet", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31209, 31209, "Misty Rain", 0, "", 0, "LineageMonster.pet_wolf", 13, 11.5, 70, "male", "L2TownPet", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 24, 120, 0, 1), 
(31210, 31210, "Race Track Gatekeeper", 0, "", 0, "LineageNPC.e_teleporter_FDwarf", 8, 21.3, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31211, 31211, "Race Track Guide", 0, "", 0, "LineageNPC.e_traderA_FDwarf", 7, 18.5, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31212, 31212, "Event Gatekeeper", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 48, 120, 0, 1), 
(31213, 31213, "Event Gatekeeper", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 48, 120, 0, 1), 
(31214, 31214, "Event Gatekeeper", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 48, 120, 0, 1), 
(31215, 31215, "Event Gatekeeper", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 48, 120, 0, 1), 
(31216, 31216, "Event Gatekeeper", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 48, 120, 0, 1), 
(31217, 31217, "Event Gatekeeper", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 48, 120, 0, 1), 
(31218, 31218, "Event Gatekeeper", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 48, 120, 0, 1), 
(31219, 31219, "Event Gatekeeper", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 48, 120, 0, 1), 
(31220, 31220, "Event Gatekeeper", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 48, 120, 0, 1), 
(31221, 31221, "Event Gatekeeper", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 48, 120, 0, 1), 
(31222, 31222, "Event Gatekeeper", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 48, 120, 0, 1), 
(31223, 31223, "Event Gatekeeper", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 48, 120, 0, 1), 
(31224, 31224, "Event Gatekeeper", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 48, 120, 0, 1), 
(31225, 31225, "Arena Manager", 0, "", 0, "LineageNPC.e_teleporter_FDwarf", 8, 21.3, 70, "female", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31226, 31226, "Arena Director", 0, "", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31227, 31227, "Buzz the Cat", 0, "Event Manager", 0, "LineageMonster.cat_the_cat", 9, 16, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31228, 31228, "Roy the Cat", 0, "Event Manager", 0, "LineageMonster.cat_the_cat", 9, 16, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31229, 31229, "Winnie the Cat", 0, "Event Manager", 0, "LineageMonster.cutie_cat", 8, 15, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 48, 120, 0, 1), 
(31230, 31230, "Louie the Cat", 0, "Event Manager", 0, "LineageMonster.silver_cat", 7, 15, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 48, 120, 0, 1), 
(31231, 31231, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(31232, 31232, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(31233, 31233, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(31234, 31234, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(31235, 31235, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(31236, 31236, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(31237, 31237, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(31238, 31238, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(31239, 31239, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(31240, 31240, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(31241, 31241, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(31242, 31242, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(31243, 31243, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(31244, 31244, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(31245, 31245, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(31246, 31246, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(31247, 31247, "Orator of Revelations", 0, "", 0, "LineageMonster.liviona", 15, 28, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31248, 31248, "Orator of Revelations", 0, "", 0, "LineageMonster.liviona", 15, 28, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31249, 31249, "Orator of Revelations", 0, "", 0, "LineageMonster.liviona", 15, 28, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31250, 31250, "Orator of Revelations", 0, "", 0, "LineageMonster.liviona", 15, 28, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31251, 31251, "Orator of Revelations", 0, "", 0, "LineageMonster.liviona", 15, 28, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31252, 31252, "Orator of Revelations", 0, "", 0, "LineageMonster.liviona", 15, 28, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31253, 31253, "Orator of Revelations", 0, "", 0, "LineageMonster.liviona", 15, 28, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31254, 31254, "Orator of Revelations", 0, "", 0, "LineageMonster.liviona", 15, 28, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31255, 31255, "Buzz the Cat", 0, "Event Manager", 0, "LineageMonster.cat_the_cat", 9, 16, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31256, 31256, "Leon", 0, "Weapon Merchant", 0, "LineageNPC.a_traderC_Mhuman", 8, 23, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31257, 31257, "Veronica", 0, "Weapon Merchant", 0, "LineageNPC.a_traderD_Fhuman", 8, 25.3, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31258, 31258, "Helmut", 0, "Armor Merchant", 0, "LineageNPC.a_common_peopleC_Mhuman", 10, 24, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31259, 31259, "Janne", 0, "Armor Merchant", 0, "LineageNPC.a_common_peopleC_Fhuman", 8, 22.5, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31260, 31260, "Judith", 0, "Accessory Merchant", 0, "LineageNPC.a_traderD_Fhuman", 8, 25.3, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31261, 31261, "Renee", 0, "Accessory Merchant", 0, "LineageNPC.e_warehouse_keeper_FDwarf", 7, 18, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31262, 31262, "Rupert", 0, "Trader", 0, "LineageNPC.a_traderD_Mhuman", 8, 21.5, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31263, 31263, "Liesel", 0, "Grocer", 0, "LineageNPC.a_common_peopleC_Fhuman", 8, 22.5, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31264, 31264, "Olsun", 0, "Symbol Maker", 0, "LineageNPC.a_traderC_Mhuman", 8, 23, 70, "male", "L2SymbolMaker", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31265, 31265, "Annette", 0, "Pet Manager", 0, "LineageNPC.a_fighterguild_teacher_FHuman", 9.5, 22.4, 70, "female", "L2PetManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31266, 31266, "Kaiser", 0, "", 0, "LineageMonster2.youth_tiger", 16, 17.2, 70, "male", "L2TownPet", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(31267, 31267, "Lietta", 0, "Warehouse Keeper", 0, "LineageNPC.e_warehouse_keeper_FDwarf", 7, 18, 70, "female", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31268, 31268, "Hakon", 0, "Warehouse Keeper", 0, "LineageNPC.e_warehouse_master_MDwarf", 8, 17.5, 70, "male", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31269, 31269, "Mona", 0, "Warehouse Chief", 0, "LineageNPC.e_traderB_FDwarf", 7, 18, 70, "female", "L2VillageMasterDwarf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31270, 31270, "Stefano", 0, "Warehouse Keeper", 0, "LineageNPC.e_collector_teacher_MDwarf", 8, 17.5, 70, "male", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31271, 31271, "Hilda", 0, "Blacksmith", 0, "LineageNPC.e_smith_Fdwarf", 8, 17.5, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 87, 0, 0, 50, 120, 0, 1), 
(31272, 31272, "Noel", 0, "Head Blacksmith", 0, "LineageNPC.e_smith_master_MDwarf", 8, 16.5, 70, "male", "L2VillageMasterDwarf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31273, 31273, "Borodin", 0, "Blueprint Seller", 0, "LineageNPC.e_mine_teacher_MDwarf", 8, 18, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31274, 31274, "Fundin", 0, "Mineral Trader", 0, "LineageNPC.a_smith_MDwarf", 7, 16.5, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 89, 0, 0, 50, 120, 0, 1), 
(31275, 31275, "Tatiana", 0, "Gatekeeper", 0, "LineageNPC.e_teleporter_Fhuman", 8, 25, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31276, 31276, "Bernhard", 0, "Grand Master", 0, "LineageNPC.a_fighterguild_master_Mhuman", 8, 23.5, 70, "male", "L2VillageMasterFighter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 76, 0, 0, 50, 120, 0, 1), 
(31277, 31277, "Felix", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 125, 20, 0, 50, 120, 0, 1), 
(31278, 31278, "Bronwyn", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_MElf", 7, 22.5, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 130, 0, 0, 50, 120, 0, 1), 
(31279, 31279, "Gregory", 0, "High Priest", 0, "LineageNPC.a_temple_master_Mhuman", 8, 22.5, 70, "male", "L2VillageMasterPriest", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 193, 0, 0, 50, 120, 0, 1), 
(31280, 31280, "Bastian", 0, "Priest", 0, "LineageNPC.a_temple_teacher_Mhuman", 8, 23, 70, "male", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31281, 31281, "Cerenas", 0, "Priest", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 70, "male", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31282, 31282, "Justin", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_MHuman", 8, 23, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31283, 31283, "Alminas", 0, "Magister", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31284, 31284, "Elena", 0, "Spellbook Seller", 0, "LineageNPC.a_traderD_Fhuman", 8, 25.3, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31285, 31285, "Samael", 0, "Grand Master", 0, "LineageNPC.a_patriarch_MDarkElf", 6, 23.8, 70, "male", "L2VillageMasterDElf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31286, 31286, "Drakon", 0, "Master", 0, "LineageNPC.a_guild_master_MDarkElf", 8, 23, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 143, 0, 0, 50, 120, 0, 1), 
(31287, 31287, "Kamilen", 0, "Magister", 0, "LineageNPC.a_casino_FDarkElf", 8, 23, 70, "female", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 204, 0, 0, 50, 120, 0, 1), 
(31288, 31288, "Aklan", 0, "High Prefect", 0, "LineageNPC.e_patriarch_MOrc", 8, 26, 70, "male", "L2VillageMasterOrc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31289, 31289, "Lakan", 0, "Prefect", 0, "LineageNPC.e_fighterguild_teacher_MOrc", 8, 28.5, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 161, 0, 0, 50, 120, 0, 1), 
(31290, 31290, "Skahi", 0, "Seer", 0, "LineageNPC.e_clergyman_MOrc", 8, 29, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 202, 0, 0, 50, 120, 0, 1), 
(31291, 31291, "Terava", 0, "Amulet Seller", 0, "LineageNPC.e_clergyman_FOrc", 7, 28, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31292, 31292, "Andrei", 0, "Captain", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 133, 632, 0, 50, 120, 0, 1), 
(31293, 31293, "Gunter", 0, "Guard", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 126, 628, 0, 50, 120, 0, 1), 
(31294, 31294, "Sven", 0, "Guard", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 94, 0, 0, 50, 120, 0, 1), 
(31295, 31295, "Henrik", 0, "Guard", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 126, 628, 0, 50, 120, 0, 1), 
(31296, 31296, "Cadmon", 0, "Guard", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 94, 0, 0, 50, 120, 0, 1), 
(31297, 31297, "Bayard", 0, "Guard", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 126, 628, 0, 50, 120, 0, 1), 
(31298, 31298, "Ulrich", 0, "Guard", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 94, 0, 0, 50, 120, 0, 1), 
(31299, 31299, "Eugen", 0, "Guard", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 126, 628, 0, 50, 120, 0, 1), 
(31300, 31300, "Drumond", 0, "Weapon Merchant", 0, "LineageNPC.e_traderB_master_MDwarf", 8, 17, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31301, 31301, "Nils", 0, "Weapon Merchant", 0, "LineageNPC.a_traderD_Mhuman", 8, 21.5, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31302, 31302, "Vladimir", 0, "Armor Merchant", 0, "LineageNPC.a_common_peopleC_Mhuman", 10, 24, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31303, 31303, "Alisha", 0, "Armor Merchant", 0, "LineageNPC.a_traderD_Fhuman", 8, 25.3, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31304, 31304, "Astrid", 0, "Accessory Merchant", 0, "LineageNPC.a_traderC_Fhuman", 8, 22.5, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31305, 31305, "Candice", 0, "Accessory Merchant", 0, "LineageNPC.e_traderA_FDwarf", 7, 18.5, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31306, 31306, "Natasha", 0, "Trader", 0, "LineageNPC.a_traderB_FHuman", 8, 24.5, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31307, 31307, "Weber", 0, "Grocer", 0, "LineageNPC.a_traderD_Mhuman", 8, 21.5, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31308, 31308, "Achim", 0, "Symbol Maker", 0, "LineageNPC.a_traderC_Mhuman", 8, 23, 70, "male", "L2SymbolMaker", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31309, 31309, "Woods", 0, "Pet Manager", 0, "LineageNPC.a_traderD_Mhuman", 8, 21.5, 70, "male", "L2PetManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31310, 31310, "Rafael", 0, "", 0, "LineageMonster.strider", 23, 31, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31311, 31311, "Hugin", 0, "Warehouse Keeper", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 70, "male", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31312, 31312, "Durin", 0, "Warehouse Keeper", 0, "LineageNPC.a_traderA_MDwarf", 8, 17, 70, "male", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31313, 31313, "Lunin", 0, "Warehouse Keeper", 0, "LineageNPC.e_traderB_MDwarf", 8, 17.5, 70, "male", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31314, 31314, "Donal", 0, "Warehouse Chief", 0, "LineageNPC.e_warehouse_master_MDwarf", 8, 17.5, 70, "male", "L2VillageMasterDwarf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31315, 31315, "Daisy", 0, "Warehouse Keeper", 0, "LineageNPC.e_warehouse_keeper_FDwarf", 7, 18, 70, "female", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31316, 31316, "Vincenz", 0, "Blacksmith", 0, "LineageNPC.a_smith_MDwarf", 7, 16.5, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 89, 0, 0, 50, 120, 0, 1), 
(31317, 31317, "Lombert", 0, "Head Blacksmith", 0, "LineageNPC.e_smith_master_MDwarf", 8, 16.5, 70, "male", "L2VillageMasterDwarf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31318, 31318, "Greta", 0, "Blueprint Seller", 0, "LineageNPC.e_mine_teacher_FDwarf", 8, 18.5, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31319, 31319, "Hans", 0, "Mineral Trader", 0, "LineageNPC.e_traderB_master_MDwarf", 8, 17, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31320, 31320, "Ilyana", 0, "Gatekeeper", 0, "LineageNPC.e_teleporter_Fhuman", 8, 25, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31321, 31321, "Siegmund", 0, "Grand Master", 0, "LineageNPC.a_fighterguild_master_Mhuman", 8, 23.5, 70, "male", "L2VillageMasterFighter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 76, 0, 0, 50, 120, 0, 1), 
(31322, 31322, "Erian", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 125, 20, 0, 50, 120, 0, 1), 
(31323, 31323, "Beryl", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_FElf", 8, 22.5, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 130, 0, 0, 50, 120, 0, 1), 
(31324, 31324, "Andromeda", 0, "Grand Master", 0, "LineageNPC.a_casino_FDarkElf", 8, 23, 70, "female", "L2VillageMasterDElf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 316, 0, 0, 50, 120, 0, 1), 
(31325, 31325, "Themis", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_FDarkElf", 8, 23, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 227, 627, 0, 50, 120, 0, 1), 
(31326, 31326, "Lambac", 0, "High Prefect", 0, "LineageNPC.e_patriarch_MOrc", 8, 26, 70, "male", "L2VillageMasterOrc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31327, 31327, "Tazki", 0, "Prefect", 0, "LineageNPC.e_fighterguild_teacher_MOrc", 8, 28.5, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 161, 0, 0, 50, 120, 0, 1), 
(31328, 31328, "Innocentin", 0, "High Priest", 0, "LineageNPC.a_temple_master_Mhuman", 8, 22.5, 70, "male", "L2VillageMasterPriest", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 193, 0, 0, 50, 120, 0, 1), 
(31329, 31329, "Eliyah", 0, "Priest", 0, "LineageNPC.a_temple_teacher_Mhuman", 8, 23, 70, "male", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31330, 31330, "Wagner", 0, "Priest", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 70, "male", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31331, 31331, "Valdis", 0, "Grand Magister", 0, "LineageNPC.a_mageguild_master_MHuman", 8, 24, 70, "male", "L2VillageMasterMystic", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31332, 31332, "Amelia", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_FHuman", 8, 23.5, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31333, 31333, "Rumiel", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_FElf", 7, 21.2, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31334, 31334, "Tifaren", 0, "Grand Magister", 0, "LineageNPC.a_teleporter_FDarkElf", 8, 25, 70, "female", "L2VillageMasterDElf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31335, 31335, "Kayan", 0, "Magister", 0, "LineageNPC.a_clergyman_MDarkElf", 8, 22.3, 70, "male", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 317, 0, 0, 50, 120, 0, 1), 
(31336, 31336, "Rahorakti", 0, "Grand Seer", 0, "LineageNPC.e_clergyman_MOrc", 8, 29, 70, "male", "L2VillageMasterOrc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 202, 0, 0, 50, 120, 0, 1), 
(31337, 31337, "Mekara", 0, "Seer", 0, "LineageNPC.e_mageguild_teacher_FOrc", 8, 28, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31338, 31338, "Anton", 0, "Spellbook Seller", 0, "LineageNPC.a_traderD_Mhuman", 8, 21.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31339, 31339, "Hakran", 0, "Amulet Seller", 0, "LineageNPC.e_mageguild_teacher_MOrc", 8, 29, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31340, 31340, "Mathias", 0, "Captain", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 133, 632, 0, 50, 120, 0, 1), 
(31341, 31341, "Richtor", 0, "Guard", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 126, 628, 0, 50, 120, 0, 1), 
(31342, 31342, "Dimitri", 0, "Guard", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 94, 0, 0, 50, 120, 0, 1), 
(31343, 31343, "Bellard", 0, "Guard", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 126, 628, 0, 50, 120, 0, 1), 
(31344, 31344, "Schmidt", 0, "Guard", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 94, 0, 0, 50, 120, 0, 1), 
(31345, 31345, "Ian", 0, "Guard", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 126, 628, 0, 50, 120, 0, 1), 
(31346, 31346, "Sirius", 0, "Guard", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 94, 0, 0, 50, 120, 0, 1), 
(31347, 31347, "Burke", 0, "Guard", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 126, 628, 0, 50, 120, 0, 1), 
(31348, 31348, "Agripel", 0, "High Priest", 0, "LineageNPC.a_temple_master_Mhuman", 8, 22.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31349, 31349, "Benedict", 0, "Priest", 0, "LineageNPC.a_temple_master_Mhuman", 8, 22.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31350, 31350, "Dominic", 0, "Priest", 0, "LineageNPC.a_temple_master_Mhuman", 8, 22.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31351, 31351, "Volker", 0, "Wharf Manager", 0, "LineageNPC.a_traderC_Mhuman", 8, 23, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31356, 31356, "Remy", 0, "Porter", 0, "LineageNPC.a_traderB_MHuman", 8, 25, 70, "male", "L2NpcWalker", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31357, 31357, "Leandro", 0, "Secretary", 0, "LineageNPC.a_common_peopleB_MHuman", 8, 22, 70, "male", "L2NpcWalker", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31358, 31358, "Kasiel", 0, "Bard", 0, "LineageNPC.a_trader_MElf", 6, 24.5, 70, "male", "L2NpcWalker", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 4202, 0, 0, 50, 120, 0, 1), 
(31359, 31359, "Jaradine", 0, "Mother Tree Guardian", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 70, "male", "L2NpcWalker", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 189, 0, 0, 50, 120, 0, 1), 
(31360, 31360, "Alhena", 0, "Tetrarch Agent", 0, "LineageNPC.a_casino_FDarkElf", 8, 23, 70, "female", "L2NpcWalker", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 315, 0, 0, 50, 120, 0, 1), 
(31361, 31361, "Kreed", 0, "Tetrarch Executioner", 0, "LineageNPC.a_trader_MDarkElf", 8, 22.5, 70, "male", "L2NpcWalker", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 151, 0, 0, 50, 120, 0, 1), 
(31362, 31362, "Tate", 0, "Carrier", 0, "LineageNPC.a_traderA_MDwarf", 8, 17, 70, "male", "L2NpcWalker", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31363, 31363, "Rogin", 0, "Deliveryman", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 70, "male", "L2NpcWalker", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31364, 31364, "Rokar", 0, "Guardian of Flame", 0, "LineageNPC.e_guard_MOrc", 8, 27, 70, "male", "L2NpcWalker", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 203, 0, 0, 50, 120, 0, 1), 
(31365, 31365, "Yakand", 0, "Guardian of Flame", 0, "LineageNPC.e_guard_MOrc", 8, 27, 70, "male", "L2NpcWalker", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 203, 0, 0, 50, 120, 0, 1), 
(31366, 31366, "Feed Seller", 0, "", 0, "LineageNPC.a_traderD_Mhuman", 8, 21.5, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31367, 31367, "Voice of Glory", 0, "", 0, "LineageMonster.kel_mahum_witch_doctor", 13, 25, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 193, 0, 0, 50, 120, 0, 1), 
(31368, 31368, "Mikellan", 0, "Monk of Silence", 0, "LineageNPC.a_temple_teacher_Mhuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31369, 31369, "Mennon", 0, "Monk of Silence", 0, "LineageNPC.a_temple_teacher_Mhuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31370, 31370, "Kadun Zu Ketra", 0, "Hierarch", 0, "LineageMonster2.ketra_orc_chieftain", 11, 38.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 6719, 0, 0, 24, 120, 0, 1), 
(31371, 31371, "Wahkan", 0, "Ketra's Messenger", 0, "LineageMonster.ketra_orc", 12, 29, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 175, 0, 0, 45, 120, 0, 1), 
(31372, 31372, "Asefa", 0, "Soul Guide", 0, "LineageMonster.ketra_orc_shaman", 10, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 205, 0, 0, 10, 120, 0, 1), 
(31373, 31373, "Atan", 0, "Grocer", 0, "LineageMonster.ketra_orc_warrior", 12, 24, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 36, 120, 0, 1), 
(31374, 31374, "Jaff", 0, "Warehouse Keeper", 0, "LineageMonster.ketra_orc_warrior", 12, 24, 70, "male", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 36, 120, 0, 1), 
(31375, 31375, "Jumara", 0, "Trader", 0, "LineageMonster.ketra_orc_warrior", 12, 24, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 36, 120, 0, 1), 
(31376, 31376, "Kurfa", 0, "Gatekeeper", 0, "LineageMonster.ketra_orc_shaman", 10, 23, 70, "male", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 205, 0, 0, 10, 120, 0, 1), 
(31377, 31377, "Ashas Varka Durai", 0, "Hierarch", 0, "LineageMonster2.barka_silenos_chieftain", 18, 42.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 145, 0, 0, 25, 120, 0, 1), 
(31378, 31378, "Naran Ashanuk", 0, "Varka's Messenger", 0, "LineageMonster2.barka_silenos_warrior", 16, 41, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 173, 0, 0, 34, 120, 0, 1), 
(31379, 31379, "Udan Mardui", 0, "Soul Guide", 0, "LineageMonster2.barka_silenos_shaman", 14, 39.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 6716, 0, 0, 36, 120, 0, 1), 
(31380, 31380, "Diyabu", 0, "Grocer", 0, "LineageMonster2.barka_silenos_hunter", 16, 38, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 44, 120, 0, 1), 
(31381, 31381, "Hagos", 0, "Warehouse Keeper", 0, "LineageMonster2.barka_silenos_warrior", 16, 41, 70, "male", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 34, 120, 0, 1), 
(31382, 31382, "Shikon", 0, "Trader", 0, "LineageMonster2.barka_silenos_hunter", 16, 38, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 44, 120, 0, 1), 
(31383, 31383, "Teranu Mardui", 0, "Gatekeeper", 0, "LineageMonster2.barka_silenos_shaman", 14, 39.5, 70, "male", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 6716, 0, 0, 36, 120, 0, 1), 
(31384, 31384, "Gatekeeper of Fire Dragon", 0, "", 0, "LineageMonster.skeleton_knight", 10, 25, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 84, 0, 0, 40, 120, 0, 1), 
(31385, 31385, "Heart of Volcano", 0, "", 0, "LineageNPC.heart_of_warding", 17, 120, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31386, 31386, "Violet", 0, "Grocer", 0, "LineageNPC.a_traderD_Fhuman", 8, 25.3, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31387, 31387, "Kurstin", 0, "", 0, "LineageNPC.a_traderB_FHuman", 8, 24.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31388, 31388, "Mina", 0, "", 0, "LineageNPC.a_traderB_FHuman", 8, 24.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31389, 31389, "Dorian", 0, "", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 297, 0, 0, 50, 120, 0, 1), 
(31390, 31390, "Dummy - Boy A", 0, "Ch4 Test", 0, "LineageNPC.a_traderA_MHuman", 10, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31391, 31391, "Dummy  - Boy B", 0, "Ch4 Test", 0, "LineageNPC.a_traderA_MHuman", 10, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31392, 31392, "Dummy  - Boy C", 0, "Ch4 Test", 0, "LineageNPC.a_traderA_MHuman", 10, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31393, 31393, "Dummy - Boy D", 0, "Ch4 Test", 0, "LineageNPC.a_traderA_MHuman", 10, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31394, 31394, "Dummy - Boy E", 0, "Ch4 Test", 0, "LineageNPC.a_traderA_MHuman", 10, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31395, 31395, "Dummy - Lady F", 0, "Ch4 Test", 0, "LineageNPC.a_teleporter_FHuman", 8, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31396, 31396, "Dummy - Lady G", 0, "Ch4 Test", 0, "LineageNPC.a_teleporter_FHuman", 8, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31397, 31397, "Dummy - Lady H", 0, "Ch4 Test", 0, "LineageNPC.a_teleporter_FHuman", 8, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31398, 31398, "Dummy - Lady I", 0, "Ch4 Test", 0, "LineageNPC.a_teleporter_FHuman", 8, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31399, 31399, "Dummy - Lady J", 0, "Ch4 Test", 0, "LineageNPC.a_teleporter_FHuman", 8, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31400, 31400, "Dummy - Sword Guard", 0, "Ch4 Test", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(31401, 31401, "Dummy - Bow Guard", 0, "Ch4 Test", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 14, 0, 0, 50, 120, 0, 1), 
(31404, 31404, "Monster Race Guide", 0, "Town of Gludio", 0, "LineageNPC.e_teleporter_FDwarf", 8, 21.3, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31405, 31405, "Monster Race Guide", 0, "Town of Dion", 0, "LineageNPC.e_teleporter_FDwarf", 8, 21.3, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31406, 31406, "Monster Race Guide", 0, "Town of Giran", 0, "LineageNPC.e_teleporter_FDwarf", 8, 21.3, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31407, 31407, "Monster Race Guide", 0, "Heine", 0, "LineageNPC.e_teleporter_FDwarf", 8, 21.3, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31408, 31408, "Monster Race Guide", 0, "Town of Oren", 0, "LineageNPC.e_teleporter_FDwarf", 8, 21.3, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31409, 31409, "Monster Race Guide", 0, "Hunters Village", 0, "LineageNPC.e_teleporter_FDwarf", 8, 21.3, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31410, 31410, "Monster Race Guide", 0, "Town of Aden", 0, "LineageNPC.e_teleporter_FDwarf", 8, 21.3, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31411, 31411, "Monster Race Guide", 0, "Town of Goddard", 0, "LineageNPC.e_teleporter_FDwarf", 8, 21.3, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31412, 31412, "Monster Race Guide", 0, "Rune Township", 0, "LineageNPC.e_teleporter_FDwarf", 8, 21.3, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31413, 31413, "Antonio", 0, "Spellbook Seller", 0, "LineageNPC.a_common_peopleB_MHuman", 8, 22, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31414, 31414, "Lynn", 0, "Spellbook Seller", 0, "LineageNPC.a_common_people_FElf", 7, 25.5, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31415, 31415, "Triya", 0, "Spellbook Seller", 0, "LineageNPC.a_mageguild_teacher_MDarkElf", 8, 22, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31416, 31416, "Aren", 0, "Spellbook Seller", 0, "LineageNPC.a_common_peopleB_MHuman", 8, 22, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31417, 31417, "Berynel", 0, "Spellbook Seller", 0, "LineageNPC.a_common_people_MElf", 6, 21, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31418, 31418, "Rouke", 0, "Spellbook Seller", 0, "LineageNPC.a_traderB_MHuman", 8, 25, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31419, 31419, "Lorel", 0, "Spellbook Seller", 0, "LineageNPC.a_common_people_MElf", 6, 21, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31420, 31420, "Tomanel", 0, "Spellbook Seller", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31421, 31421, "Ratriya", 0, "Spellbook Seller", 0, "LineageNPC.a_common_people_FElf", 7, 25.5, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31422, 31422, "Migel", 0, "Spellbook Seller", 0, "LineageNPC.a_common_peopleB_MHuman", 8, 22, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31423, 31423, "Romas", 0, "Spellbook Seller", 0, "LineageNPC.a_traderB_MHuman", 8, 25, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31424, 31424, "Shantra", 0, "Amulet Seller", 0, "LineageNPC.e_clergyman_FOrc", 7, 28, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31425, 31425, "Koram", 0, "Amulet Seller", 0, "LineageNPC.e_mageguild_teacher_MOrc", 8, 29, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31426, 31426, "Jaka", 0, "Amulet Seller", 0, "LineageNPC.e_mageguild_teacher_MOrc", 8, 29, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31427, 31427, "Urgal", 0, "Amulet Seller", 0, "LineageNPC.e_mageguild_teacher_MOrc", 8, 29, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31428, 31428, "Shafa", 0, "Amulet Seller", 0, "LineageNPC.e_clergyman_FOrc", 7, 28, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31429, 31429, "Shitara", 0, "Amulet Seller", 0, "LineageNPC.e_clergyman_FOrc", 7, 28, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31430, 31430, "Donai", 0, "Amulet Seller", 0, "LineageNPC.e_mageguild_teacher_MOrc", 8, 29, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31431, 31431, "Karai", 0, "Amulet Seller", 0, "LineageNPC.e_mageguild_teacher_MOrc", 8, 29, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31432, 31432, "Reeya", 0, "Blueprint Seller", 0, "LineageNPC.e_mine_teacher_FDwarf", 8, 18.5, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31433, 31433, "Ronaldo", 0, "Blueprint Seller", 0, "LineageNPC.e_mine_master_MDwarf", 8, 19.7, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31434, 31434, "Shaling", 0, "Blueprint Seller", 0, "LineageNPC.e_mine_teacher_FDwarf", 8, 18.5, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31435, 31435, "Daeger", 0, "Blueprint Seller", 0, "LineageNPC.e_traderA_master_MDwarf", 8, 18, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31436, 31436, "Dani", 0, "Blueprint Seller", 0, "LineageNPC.e_mine_teacher_FDwarf", 8, 18.5, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31437, 31437, "Luka", 0, "Blueprint Seller", 0, "LineageNPC.e_mine_master_MDwarf", 8, 19.7, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31438, 31438, "Lara", 0, "Blueprint Seller", 0, "LineageNPC.e_mine_teacher_FDwarf", 8, 18.5, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31439, 31439, "Rogen", 0, "Mineral Trader", 0, "LineageNPC.e_collector_teacher_MDwarf", 8, 17.5, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31440, 31440, "Lanna", 0, "Mineral Trader", 0, "LineageNPC.e_collector_teacher_FDwarf", 8, 17.5, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31441, 31441, "Gordo", 0, "Mineral Trader", 0, "LineageNPC.e_traderB_master_MDwarf", 8, 17, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31442, 31442, "Kiki", 0, "Mineral Trader", 0, "LineageNPC.e_traderB_FDwarf", 7, 18, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31443, 31443, "Raban", 0, "Mineral Trader", 0, "LineageNPC.e_collector_teacher_MDwarf", 8, 17.5, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31444, 31444, "Cona", 0, "Mineral Trader", 0, "LineageNPC.e_warehouse_keeper_FDwarf", 7, 18, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31445, 31445, "Shutner", 0, "Mineral Trader", 0, "LineageNPC.e_traderB_MDwarf", 8, 17.5, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31452, 31452, "Ghost of Wigoth", 0, "", 0, "LineageNPC.a_temple_master_Mhuman", 8, 22.5, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31453, 31453, "Nameless Spirit", 0, "", 0, "LineageNPC.a_king_MHuman", 8, 21, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31454, 31454, "Ghost of Wigoth", 0, "", 0, "LineageNPC.a_temple_master_Mhuman", 8, 22.5, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31455, 31455, "Key Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31456, 31456, "Key Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31457, 31457, "Key Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31458, 31458, "Key Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31459, 31459, "Key Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31460, 31460, "Key Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31461, 31461, "Key Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31462, 31462, "Key Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31463, 31463, "Key Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31464, 31464, "Key Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31465, 31465, "Key Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31466, 31466, "Key Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31467, 31467, "Key Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31468, 31468, "Mysterious Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31469, 31469, "Mysterious Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31470, 31470, "Mysterious Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31471, 31471, "Mysterious Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31472, 31472, "Mysterious Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31473, 31473, "Mysterious Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31474, 31474, "Mysterious Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31475, 31475, "Mysterious Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31476, 31476, "Mysterious Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31477, 31477, "Mysterious Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31478, 31478, "Mysterious Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31479, 31479, "Mysterious Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31480, 31480, "Mysterious Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31481, 31481, "Mysterious Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31482, 31482, "Mysterious Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31483, 31483, "Mysterious Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31484, 31484, "Mysterious Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31485, 31485, "Mysterious Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31486, 31486, "Mysterious Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31487, 31487, "Mysterious Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31488, 31488, "Rift Post Recruit", 0, "", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 94, 0, 0, 50, 120, 0, 1), 
(31489, 31489, "Rift Post Private", 0, "", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 304, 0, 0, 50, 120, 0, 1), 
(31490, 31490, "Rift Post Officer", 0, "", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 79, 111, 0, 50, 120, 0, 1), 
(31491, 31491, "Rift Post Captain", 0, "", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 76, 660, 0, 50, 120, 0, 1), 
(31492, 31492, "Rift Post Commander", 0, "", 0, "LineageNPC.a_lord_MHuman", 7, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 80, 655, 0, 50, 120, 0, 1), 
(31493, 31493, "Rift Post Hero", 0, "", 0, "LineageNPC.a_fighterguild_master_Mhuman", 8, 23.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 135, 0, 0, 50, 120, 0, 1), 
(31494, 31494, "Dimensional Gate Keeper", 0, "", 0, "LineageNPC.rift_keeper", 38, 120.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31495, 31495, "Dimensional Gate Keeper", 0, "", 0, "LineageNPC.rift_keeper", 38, 120.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31496, 31496, "Dimensional Gate Keeper", 0, "", 0, "LineageNPC.rift_keeper", 38, 120.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31497, 31497, "Dimensional Gate Keeper", 0, "", 0, "LineageNPC.rift_keeper", 38, 120.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31498, 31498, "Dimensional Gate Keeper", 0, "", 0, "LineageNPC.rift_keeper", 38, 120.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31499, 31499, "Dimensional Gate Keeper", 0, "", 0, "LineageNPC.rift_keeper", 38, 120.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31500, 31500, "Dimensional Gate Keeper", 0, "", 0, "LineageNPC.rift_keeper", 38, 120.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31501, 31501, "Dimensional Gate Keeper", 0, "", 0, "LineageNPC.rift_keeper", 38, 120.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31502, 31502, "Dimensional Gate Keeper", 0, "", 0, "LineageNPC.rift_keeper", 38, 120.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31503, 31503, "Dimensional Gate Keeper", 0, "", 0, "LineageNPC.rift_keeper", 38, 120.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31504, 31504, "Dimensional Gate Keeper", 0, "", 0, "LineageNPC.rift_keeper", 38, 120.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31505, 31505, "Dimensional Gate Keeper", 0, "", 0, "LineageNPC.rift_keeper", 38, 120.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31506, 31506, "Dimensional Gate Keeper", 0, "", 0, "LineageNPC.rift_keeper", 38, 120.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31507, 31507, "Dimensional Gate Keeper", 0, "", 0, "LineageNPC.rift_keeper", 38, 120.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31508, 31508, "Altar of Saints", 0, "", 0, "LineageNPC.holy_altar", 14, 45.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31509, 31509, "Altar of Saints", 0, "", 0, "LineageNPC.holy_altar", 14, 45.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31510, 31510, "Altar of Saints", 0, "", 0, "LineageNPC.holy_altar", 14, 45.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31511, 31511, "Altar of Saints", 0, "", 0, "LineageNPC.holy_altar", 14, 45.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31512, 31512, "Evil Altar", 0, "", 0, "LineageNPC.evil_altar", 11, 45, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31513, 31513, "Evil Altar", 0, "", 0, "LineageNPC.evil_altar", 11, 45, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31514, 31514, "Evil Altar", 0, "", 0, "LineageNPC.evil_altar", 11, 45, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31515, 31515, "Evil Altar", 0, "", 0, "LineageNPC.evil_altar", 11, 45, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31516, 31516, "Evil Altar", 0, "", 0, "LineageNPC.evil_altar", 11, 45, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31517, 31517, "Hierarch", 0, "", 0, "LineageNPC.a_hardin_MHuman", 8, 22.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31518, 31518, "Mysterious Necromancer", 0, "", 0, "LineageNPC.a_hardins_pupil_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31519, 31519, "Enfeux", 0, "", 0, "LineageNPC.saints_coffin", 20, 60, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31520, 31520, "Leikar", 0, "Maid", 0, "LineageNPC.a_maidA_FHuman", 8, 20.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31521, 31521, "Jeremy", 0, "Chef", 0, "LineageNPC.a_common_peopleB_MHuman", 8, 22, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31522, 31522, "Mysterious Wizard", 0, "", 0, "LineageNPC.a_hardin_MHuman", 8, 22.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31523, 31523, "Tombstone", 0, "", 0, "LineageNPC.old_tomb_stone", 20, 30, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31524, 31524, "Ghost of von Hellmann", 0, "", 0, "LineageNPC.a_temple_master_Mhuman", 8, 22.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31525, 31525, "Ghost of von Hellmann's Page", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(31526, 31526, "Broken Bookshelf", 0, "", 0, "LineageNPC.old_bookshelf", 15, 33.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31527, 31527, "Well", 0, "", 0, "LineageNPC.umul", 33, 37, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31528, 31528, "Ghost of Priest", 0, "", 0, "LineageMonster.elf_ghost", 7, 21, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31529, 31529, "Ghost of Adventurer", 0, "", 0, "LineageMonster.human_ghost", 8, 22, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31530, 31530, "Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31531, 31531, "Tombstone", 0, "", 0, "LineageNPC.old_tomb_stone", 20, 30, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31532, 31532, "Maid of Lidia", 0, "", 0, "LineageMonster2.vampire_witch", 6, 21.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 64, 120, 0, 1), 
(31533, 31533, "Broken Bookshelf", 0, "", 0, "LineageNPC.old_bookshelf", 15, 33.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31534, 31534, "Broken Bookshelf", 0, "", 0, "LineageNPC.old_bookshelf", 15, 33.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31535, 31535, "Broken Bookshelf", 0, "", 0, "LineageNPC.old_bookshelf", 15, 33.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31536, 31536, "Coffin", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31537, 31537, "Tunatun", 0, "Beast Herder", 0, "LineageNPC.a_common_peopleC_Mhuman", 10, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31538, 31538, "Ghost of Adventurer", 0, "", 0, "LineageNPC.a_traderA_MHuman", 10, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31539, 31539, "Vulcan", 0, "Blacksmith of Flame", 0, "LineageNPC.a_smith_MDwarf", 7, 16.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 89, 0, 0, 50, 120, 0, 1), 
(31540, 31540, "Klein", 0, "Watcher of Valakas", 0, "LineageMonster.skeleton_royal_guard", 11, 28.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31541, 31541, "Daimon's Altar", 0, "", 0, "LineageNPC.gianteye_altar", 40, 45, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31542, 31542, "Yeti's Table", 0, "", 0, "LineageNPC.yetis_dinner_table", 23, 16, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31543, 31543, "Pulin", 0, "", 0, "LineageNPC.e_bath_MDwarf", 6, 16.3, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31544, 31544, "Naff", 0, "", 0, "LineageNPC.e_bath_MDwarf", 6, 16.3, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31545, 31545, "Crocus", 0, "", 0, "LineageNPC.e_bath_MDwarf", 6, 16.3, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31546, 31546, "Kuber", 0, "", 0, "LineageNPC.e_bath_MDwarf", 6, 16.3, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31547, 31547, "Beolin", 0, "", 0, "LineageNPC.e_bath_MDwarf", 6, 16.3, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31548, 31548, "Mysterious Ancient Tablet", 0, "", 0, "LineageNPC.old_tablet", 32, 46.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31549, 31549, "Mysterious Ancient Tablet", 0, "", 0, "LineageNPC.old_tablet", 32, 46.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31550, 31550, "Mysterious Ancient Tablet", 0, "", 0, "LineageNPC.old_tablet", 32, 46.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31551, 31551, "Mysterious Ancient Tablet", 0, "", 0, "LineageNPC.old_tablet", 32, 46.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31552, 31552, "Mysterious Ancient Tablet", 0, "", 0, "LineageNPC.old_tablet", 32, 46.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31553, 31553, "Pierce", 0, "Mercenary Captain", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 135, 0, 0, 50, 120, 0, 1), 
(31554, 31554, "Kahman", 0, "Mercenary", 0, "LineageNPC.e_fighterguild_teacher_MOrc", 8, 28.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 161, 0, 0, 50, 120, 0, 1), 
(31555, 31555, "Abercrombie", 0, "Mercenary Supplier", 0, "LineageNPC.e_collector_teacher_MDwarf", 8, 17.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31556, 31556, "Selina", 0, "Mercenary Medic", 0, "LineageNPC.a_traderC_Fhuman", 8, 22.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 189, 659, 0, 50, 120, 0, 1), 
(31557, 31557, "Mercenary Sentry", 0, "", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 298, 0, 0, 50, 120, 0, 1), 
(31558, 31558, "Ketra's Holy Altar", 0, "", 0, "LineageNPC.orcish_totem", 25, 47.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31559, 31559, "Box of Asefa", 0, "", 0, "LineageNPC.coffer_d", 12, 9.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31560, 31560, "Varka's Holy Altar", 0, "", 0, "LineageNPC.silenos_totem", 28, 55, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31561, 31561, "Udan Mardui's Box", 0, "", 0, "LineageNPC.coffer_b", 12, 9, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31562, 31562, "Klufe", 0, "Fishing Guild Member", 0, "LineageNPC.a_fisherA_Mhuman", 8, 23, 70, "male", "L2Fisherman", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 7560, 0, 0, 50, 120, 0, 1), 
(31563, 31563, "Perelin", 0, "Fishing Guild Member", 0, "LineageNPC.a_fisherA_Mhuman", 8, 23, 70, "male", "L2Fisherman", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 7560, 0, 0, 50, 120, 0, 1), 
(31564, 31564, "Mishini", 0, "Fishing Guild Member", 0, "LineageNPC.a_fisherA_Mhuman", 8, 23, 70, "male", "L2Fisherman", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 7560, 0, 0, 50, 120, 0, 1), 
(31565, 31565, "Ogord", 0, "Fishing Guild Member", 0, "LineageNPC.a_fisherA_Mhuman", 8, 23, 70, "male", "L2Fisherman", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 7560, 0, 0, 50, 120, 0, 1), 
(31566, 31566, "Ropfi", 0, "Fishing Guild Member", 0, "LineageNPC.a_fisherA_Mhuman", 8, 23, 70, "male", "L2Fisherman", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 7560, 0, 0, 50, 120, 0, 1), 
(31567, 31567, "Bleaker", 0, "Fishing Guild Member", 0, "LineageNPC.a_fisherA_Mhuman", 8, 23, 70, "male", "L2Fisherman", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 7560, 0, 0, 50, 120, 0, 1), 
(31568, 31568, "Pamfus", 0, "Fishing Guild Member", 0, "LineageNPC.a_fisherA_Mhuman", 8, 23, 70, "male", "L2Fisherman", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 7560, 0, 0, 50, 120, 0, 1), 
(31569, 31569, "Cyano", 0, "Fishing Guild Member", 0, "LineageNPC.a_fisherA_Mhuman", 8, 23, 70, "male", "L2Fisherman", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 7560, 0, 0, 50, 120, 0, 1), 
(31570, 31570, "Lanosco", 0, "Fishing Guild Member", 0, "LineageNPC.a_fisherA_Mhuman", 8, 23, 70, "male", "L2Fisherman", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 7560, 0, 0, 50, 120, 0, 1), 
(31571, 31571, "Hufs", 0, "Fishing Guild Member", 0, "LineageNPC.a_fisherA_Mhuman", 8, 23, 70, "male", "L2Fisherman", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 7560, 0, 0, 50, 120, 0, 1), 
(31572, 31572, "O'Fulle", 0, "Fishing Guild Member", 0, "LineageNPC.a_fisherA_Mhuman", 8, 23, 70, "male", "L2Fisherman", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 7560, 0, 0, 50, 120, 0, 1), 
(31573, 31573, "Monakan", 0, "Fishing Guild Member", 0, "LineageNPC.a_fisherA_Mhuman", 8, 23, 70, "male", "L2Fisherman", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 7560, 0, 0, 50, 120, 0, 1), 
(31574, 31574, "Willie", 0, "Fishing Guild Member", 0, "LineageNPC.a_fisherA_Mhuman", 8, 23, 70, "male", "L2Fisherman", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 7560, 0, 0, 50, 120, 0, 1), 
(31575, 31575, "Litulon", 0, "Fishing Guild Member", 0, "LineageNPC.a_fisherA_Mhuman", 8, 23, 70, "male", "L2Fisherman", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 7560, 0, 0, 50, 120, 0, 1), 
(31576, 31576, "Berix", 0, "Fishing Guild Member", 0, "LineageNPC.a_fisherA_Mhuman", 8, 23, 70, "male", "L2Fisherman", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 7560, 0, 0, 50, 120, 0, 1), 
(31577, 31577, "Linnaeus", 0, "Fishing Guild Member", 0, "LineageNPC.a_fisherA_Mhuman", 8, 23, 70, "male", "L2Fisherman", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 7560, 0, 0, 50, 120, 0, 1), 
(31578, 31578, "Hilgendorf", 0, "Fishing Guild Member", 0, "LineageNPC.a_fisherA_Mhuman", 8, 23, 70, "male", "L2Fisherman", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 7560, 0, 0, 50, 120, 0, 1), 
(31579, 31579, "Klaus", 0, "Fishing Guild Member", 0, "LineageNPC.a_fisherA_Mhuman", 8, 23, 70, "male", "L2Fisherman", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 7560, 0, 0, 50, 120, 0, 1), 
(31580, 31580, "Galadrid", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_MDarkElf", 8, 23, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 132, 110, 0, 50, 120, 0, 1), 
(31581, 31581, "Anastia", 0, "Magister", 0, "LineageNPC.a_clergyman_FDarkElf", 8, 25, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 202, 0, 0, 50, 120, 0, 1), 
(31582, 31582, "Mordred", 0, "Dark Knight", 0, "LineageMonster2.vampire_soldier", 8, 23.5, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 84, 634, 0, 60, 120, 0, 1), 
(31583, 31583, "Feynn", 0, "Blacksmith", 0, "LineageNPC.a_smith_MDwarf", 7, 16.5, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 168, 0, 0, 50, 120, 0, 1), 
(31584, 31584, "Valentine", 0, "Brewer", 0, "LineageNPC.e_traderB_MDwarf", 8, 17.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31585, 31585, "Sparky the Cat", 0, "Keats Servitor", 0, "LineageMonster.cat_the_cat", 9, 16, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31586, 31586, "Sparky the Cat", 0, "Keats Servitor", 0, "LineageMonster.cat_the_cat", 9, 16, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31587, 31587, "Gedrik", 0, "Gemcutter", 0, "LineageNPC.e_traderB_master_MDwarf", 8, 17, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31588, 31588, "Agnes", 0, "Saint of Light", 0, "LineageNPC.a_teleporter_FElf", 8.5, 23.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31589, 31589, "Duda-Mara Totem Spirit", 0, "", 0, "LineageMonster.giant_spider", 26, 25.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 72, 120, 0, 1), 
(31590, 31590, "Truth Scholar Devianne", 0, "", 0, "LineageNPC.a_teleporter_FHuman", 8, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 192, 0, 0, 50, 120, 0, 1), 
(31591, 31591, "Sunset Guide Luna", 0, "", 0, "LineageNPC.a_sanctuary_teacher_FHuman", 8, 22.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 189, 633, 0, 50, 120, 0, 1), 
(31592, 31592, "Telson", 0, "Chief Golem Crafter", 0, "LineageNPC.e_mine_master_MDwarf", 8, 19.7, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31593, 31593, "Dorothy", 0, "Golem of Telson", 0, "LineageMonster.mechanic_golem", 5, 19, 70, "male", "L2TownPet", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(31594, 31594, "Mond", 0, "Chief Inspector", 0, "LineageNPC.e_celebrant_MDwarf", 8, 19.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31595, 31595, "Leona Blackbird", 0, "", 0, "LineageNPC.a_fighterguild_teacher_FHuman", 9.5, 22.4, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 79, 110, 0, 50, 120, 0, 1), 
(31596, 31596, "Tobald", 0, "Master", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 187, 0, 0, 50, 120, 0, 1), 
(31597, 31597, "Tobald", 0, "Master", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 187, 0, 0, 50, 120, 0, 1), 
(31598, 31598, "Medina Blackheart", 0, "", 0, "LineageNPC.a_trader_Fdarkelf", 8, 24.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 206, 0, 0, 50, 120, 0, 1), 
(31599, 31599, "Disgraced Knight Waldstein", 0, "", 0, "LineageNPC.a_fighterguild_master_Mhuman", 8, 23.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 81, 0, 0, 50, 120, 0, 1), 
(31600, 31600, "Pamela Aprodia", 0, "", 0, "LineageNPC.a_casino_FDarkElf", 8, 23, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 151, 0, 0, 50, 120, 0, 1), 
(31601, 31601, "Pamela Aprodia", 0, "", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 151, 0, 0, 50, 120, 0, 1), 
(31602, 31602, "Sharona Artemia", 0, "Bodyguard", 0, "LineageNPC.a_clergyman_FDarkElf", 8, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 232, 0, 0, 50, 120, 0, 1), 
(31603, 31603, "Black Cat", 0, "Hunter Guild Member", 0, "LineageNPC.a_common_people_FDarkElf", 8, 21.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 227, 0, 0, 50, 120, 0, 1), 
(31604, 31604, "Grimst", 0, "Information Broker", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31605, 31605, "Kinsley", 0, "Head Summoner", 0, "LineageNPC.a_mageguild_master_MHuman", 8, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 212, 0, 0, 50, 120, 0, 1), 
(31606, 31606, "Alice de Catrina", 0, "Kinsley's Servitor", 0, "LineageMonster2.queen_of_cat", 8, 15, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 26, 120, 0, 1), 
(31607, 31607, "Sake Dun Zu Hestui", 0, "", 0, "LineageNPC.e_guard_MOrc", 8, 27, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 298, 0, 0, 50, 120, 0, 1), 
(31608, 31608, "Belinda", 0, "Summoner", 0, "LineageNPC.a_mageguild_teacher_FElf", 7, 21.2, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31609, 31609, "Aurora the Unicorn", 0, "Belinda Servitor", 0, "LineageMonster.unicorn_boxer", 11, 18, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 27, 120, 0, 1), 
(31610, 31610, "Shiken Gloomdrake", 0, "", 0, "LineageNPC.a_common_people_MDarkElf", 7, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 80, 633, 0, 50, 120, 0, 1), 
(31611, 31611, "Scryde Heartseeker", 0, "", 0, "LineageNPC.a_common_people_MDarkElf", 7, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 81, 0, 0, 50, 120, 0, 1), 
(31612, 31612, "Eternity Wanderer Staris", 0, "", 0, "LineageNPC.a_trader_MElf", 6, 24.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 150, 0, 0, 50, 120, 0, 1), 
(31613, 31613, "Noctisse", 0, "Summoner", 0, "LineageNPC.a_clergyman_FDarkElf", 8, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 204, 0, 0, 50, 120, 0, 1), 
(31614, 31614, "Radyss", 0, "Head Summoner", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31615, 31615, "Hermit", 0, "", 0, "LineageNPC.a_common_peopleC_Mhuman", 10, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31616, 31616, "Hermit", 0, "", 0, "LineageNPC.a_fisherA_Mhuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 8, 0, 0, 50, 120, 0, 1), 
(31617, 31617, "Aria Firstmatter", 0, "", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 236, 0, 0, 50, 120, 0, 1), 
(31618, 31618, "Moon Voice Irene", 0, "", 0, "LineageNPC.a_common_people_FElf", 7, 25.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 130, 109, 0, 50, 120, 0, 1), 
(31619, 31619, "Erica Ken Weber", 0, "", 0, "LineageNPC.a_fighterguild_teacher_FHuman", 9.5, 22.4, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 236, 0, 0, 50, 120, 0, 1), 
(31620, 31620, "Verdure Elder Elikia", 0, "", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 189, 0, 0, 50, 120, 0, 1), 
(31621, 31621, "Abyss Saint Elcardia", 0, "", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 206, 0, 0, 50, 120, 0, 1), 
(31622, 31622, "Keats", 0, "Cursed Summoner", 0, "LineageMonster.poison_toad", 20, 10, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31623, 31623, "Bavarin", 0, "Information Broker", 0, "LineageNPC.e_bath_MDwarf", 6, 16.3, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31624, 31624, "Donath", 0, "Master Chef", 0, "LineageNPC.a_common_peopleB_MHuman", 8, 22, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31625, 31625, "Yeti", 0, "Donath Kitchen Help", 0, "LineageNPC.yeti_cute", 5, 10.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 5129, 0, 0, 50, 120, 0, 1), 
(31626, 31626, "Duncan", 0, "Chef", 0, "LineageNPC.a_smith_MDwarf", 7, 16.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 5129, 0, 0, 50, 120, 0, 1), 
(31627, 31627, "Mist", 0, "Information Broker", 0, "LineageNPC.e_bath_MDwarf", 6, 16.3, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31628, 31628, "Lilly", 0, "Mist's Granddaughter", 0, "LineageNPC.e_traderA_FDwarf", 7, 18.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31629, 31629, "Kaleidos the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 48, 120, 0, 1), 
(31630, 31630, "Kaleidos the Unicorn", 0, "", 0, "LineageMonster.blue_eye", 11, 16, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 48, 120, 0, 1), 
(31631, 31631, "Eric Ramsheart", 0, "", 0, "LineageNPC.a_fighterguild_master_Mhuman", 8, 23.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 79, 0, 0, 50, 120, 0, 1), 
(31632, 31632, "Mysterious Servitor", 0, "", 0, "LineageMonster.shadeless", 7, 28, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 48, 120, 0, 1), 
(31633, 31633, "Winter Hunter Kadyth", 0, "", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 285, 0, 0, 50, 120, 0, 1), 
(31634, 31634, "Winter Hunter Kadyth", 0, "", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 285, 0, 0, 50, 120, 0, 1), 
(31635, 31635, "Winter Hunter Kadyth", 0, "", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 285, 0, 0, 50, 120, 0, 1), 
(31636, 31636, "Flame Successor Akkan", 0, "", 0, "LineageNPC.e_guard_MOrc", 8, 27, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 305, 0, 0, 50, 120, 0, 1), 
(31637, 31637, "Khavatari Kashu", 0, "", 0, "LineageNPC.e_guard_MOrc", 8, 27, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 267, 0, 0, 50, 120, 0, 1), 
(31638, 31638, "Starling Knight Kastien", 0, "", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 142, 0, 0, 50, 120, 0, 1), 
(31639, 31639, "Kain Van Halter", 0, "", 0, "LineageNPC.a_traderA_MHuman", 10, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 2626, 0, 0, 50, 120, 0, 1), 
(31640, 31640, "Pilgrim of Darkness", 0, "", 0, "LineageNPC.a_hardins_pupil_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 318, 0, 0, 50, 120, 0, 1), 
(31641, 31641, "Pilgrim of Darkness", 0, "", 0, "LineageNPC.a_hardins_pupil_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 318, 0, 0, 50, 120, 0, 1), 
(31642, 31642, "Tarkai Zu Duda-Mara", 0, "", 0, "LineageNPC.e_guard_MOrc", 8, 27, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 210, 0, 0, 50, 120, 0, 1), 
(31643, 31643, "Silver Feyshar", 0, "", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 148, 0, 0, 50, 120, 0, 1), 
(31644, 31644, "Dawn Witness Franz", 0, "Witness of Dawn", 0, "LineageNPC.a_sanctuary_master_MHuman", 8, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 205, 0, 0, 50, 120, 0, 1), 
(31645, 31645, "Hindemith Truevoice", 0, "", 0, "LineageNPC.a_traderD_Mhuman", 8, 21.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 195, 0, 0, 50, 120, 0, 1), 
(31646, 31646, "Tablet of Vision", 0, "", 0, "LineageNPC.codex_stone", 7, 24, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31647, 31647, "Tablet of Vision", 0, "", 0, "LineageNPC.codex_stone", 7, 24, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31648, 31648, "Tablet of Vision", 0, "", 0, "LineageNPC.codex_stone", 7, 24, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31649, 31649, "Tablet of Vision", 0, "", 0, "LineageNPC.codex_stone", 7, 24, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31650, 31650, "Tablet of Vision", 0, "", 0, "LineageNPC.codex_stone", 7, 24, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31651, 31651, "Tablet of Vision", 0, "", 0, "LineageNPC.codex_stone", 7, 24, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31652, 31652, "Tablet of Vision", 0, "", 0, "LineageNPC.codex_stone", 7, 24, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31653, 31653, "Tablet of Vision", 0, "", 0, "LineageNPC.codex_stone", 7, 24, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31654, 31654, "Tablet of Vision", 0, "", 0, "LineageNPC.codex_stone", 7, 24, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31655, 31655, "Tablet of Vision", 0, "", 0, "LineageNPC.codex_stone", 7, 24, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31656, 31656, "Tablet of Vision", 0, "", 0, "LineageNPC.codex_stone", 7, 24, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31657, 31657, "Tablet of Vision", 0, "", 0, "LineageNPC.codex_stone", 7, 24, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31658, 31658, "Tablet of Vision", 0, "", 0, "LineageNPC.codex_stone", 7, 24, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31659, 31659, "Tablet of Vision", 0, "", 0, "LineageNPC.codex_stone", 7, 24, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31660, 31660, "Tablet of Vision", 0, "", 0, "LineageNPC.codex_stone", 7, 24, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31661, 31661, "Forgotten Monument", 0, "", 0, "LineageNPC.old_tablet", 32, 46.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31662, 31662, "Forgotten Monument", 0, "", 0, "LineageNPC.old_tablet", 32, 46.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31663, 31663, "Forgotten Monument", 0, "", 0, "LineageNPC.old_tablet", 32, 46.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31664, 31664, "Forgotten Monument", 0, "", 0, "LineageNPC.old_tablet", 32, 46.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31665, 31665, "Corpse of Dwarf", 0, "", 0, "LineageNPC.e_guard_MDwarf_death", 13, 19, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31666, 31666, "Lumen", 0, "Spellbook Seller", 0, "LineageNPC.a_traderD_Mhuman", 8, 21.5, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31667, 31667, "Raik", 0, "Amulet Seller", 0, "LineageNPC.e_trader_MOrc", 8, 23.5, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31668, 31668, "Tangen", 0, "Blueprint Seller", 0, "LineageNPC.e_smith_master_MDwarf", 8, 16.5, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31669, 31669, "Onyx", 0, "Mineral Trader", 0, "LineageNPC.e_mine_teacher_MDwarf", 8, 18, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31670, 31670, "Burns", 0, "Spellbook Seller", 0, "LineageNPC.a_traderD_Mhuman", 8, 21.5, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31671, 31671, "Patrol", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 275, 0, 0, 50, 120, 0, 1), 
(31672, 31672, "Patrol", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 94, 0, 0, 50, 120, 0, 1), 
(31673, 31673, "Patrol", 0, "", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 275, 0, 0, 50, 120, 0, 1), 
(31674, 31674, "Patrol", 0, "", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 94, 0, 0, 50, 120, 0, 1), 
(31675, 31675, "Viktor Van Deik", 0, "Border Outpost Captain", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 70, "male", "L2Guard", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 128, 632, 0, 50, 120, 0, 1), 
(31676, 31676, "Gregory Athebaldt", 0, "Border Outpost Captain", 0, "LineageNPC.a_fighterguild_master_Mhuman", 8, 23.5, 70, "male", "L2Doormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 70, 0, 0, 50, 120, 0, 1), 
(31677, 31677, "Border Patrol", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 94, 0, 0, 50, 120, 0, 1), 
(31678, 31678, "Border Patrol", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 94, 0, 0, 50, 120, 0, 1), 
(31679, 31679, "Eustace Van Essen", 0, "Frontier Guard Captain", 0, "LineageNPC.a_fighterguild_master_Mhuman", 8, 23.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 70, 0, 0, 50, 120, 0, 1), 
(31680, 31680, "Fleming Van Issen", 0, "Frontier Guard Captain", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 70, "male", "L2Doormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 128, 632, 0, 50, 120, 0, 1), 
(31681, 31681, "Frontier Guard", 0, "", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 94, 0, 0, 50, 120, 0, 1), 
(31682, 31682, "Frontier Guard", 0, "", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 94, 0, 0, 50, 120, 0, 1), 
(31683, 31683, "Eye of Argos", 0, "", 0, "LineageNPC.argos_eye", 205, 305, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31684, 31684, "Eye of Udan Mardui", 0, "", 0, "LineageMonster.mana_vampire", 11, 20, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 90, 120, 0, 1), 
(31685, 31685, "Asefa's Eye", 0, "", 0, "LineageMonster.magical_weaver", 11, 20, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 90, 120, 0, 1), 
(31686, 31686, "Gatekeeper of Fire Dragon", 0, "", 0, "LineageMonster.skeleton_knight", 10, 25, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 84, 0, 0, 40, 120, 0, 1), 
(31687, 31687, "Gatekeeper of Fire Dragon", 0, "", 0, "LineageMonster.skeleton_knight", 10, 25, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 84, 0, 0, 40, 120, 0, 1), 
(31688, 31688, "Grand Olympiad Manager", 0, "", 0, "LineageNPC.a_fighterguild_master_Mhuman", 8, 23.5, 70, "male", "L2OlympiadManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 70, 0, 0, 50, 120, 0, 1), 
(31689, 31689, "Olympiad Finisher", 0, "", 0, "LineageNPC.a_fighterguild_master_Mhuman", 8, 23.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 70, 0, 0, 50, 120, 0, 1), 
(31690, 31690, "Monument of Heroes", 0, "", 0, "LineageNPC.heroes_obelisk_human", 24, 69, 70, "etc", "L2OlympiadManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31691, 31691, "Training Dummy", 0, "", 0, "LineageNPC.training_doll", 9, 22, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31692, 31692, "Priest of Dawn", 0, "", 0, "LineageNPC.priest_of_dawn", 8, 30.5, 70, "male", "L2DawnPriest", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 5802, 0, 50, 120, 0, 1), 
(31693, 31693, "Priest of Dusk", 0, "", 0, "LineageNPC.priest_of_dusk", 8, 22, 70, "female", "L2DuskPriest", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 5801, 0, 0, 50, 120, 0, 1), 
(31694, 31694, "Priest of Dawn", 0, "", 0, "LineageNPC.priest_of_dawn", 8, 30.5, 70, "male", "L2DawnPriest", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 5802, 0, 50, 120, 0, 1), 
(31695, 31695, "Priest of Dusk", 0, "", 0, "LineageNPC.priest_of_dusk", 8, 22, 70, "female", "L2DuskPriest", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 5801, 0, 0, 50, 120, 0, 1), 
(31696, 31696, "Platis", 0, "Fishing Guild Member", 0, "LineageNPC.a_fisherA_Mhuman", 8, 23, 70, "male", "L2Fisherman", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 7560, 0, 0, 50, 120, 0, 1), 
(31697, 31697, "Eindarkner", 0, "Fishing Guild Member", 0, "LineageNPC.a_fisherA_Mhuman", 8, 23, 70, "male", "L2Fisherman", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 7560, 0, 0, 50, 120, 0, 1), 
(31698, 31698, "Arisha", 0, "Gatekeeper", 0, "LineageNPC.e_teleporter_Fhuman", 8, 25, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31699, 31699, "Stanislava", 0, "Gatekeeper", 0, "LineageNPC.e_teleporter_Fhuman", 8, 25, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31700, 31700, "Saint's Follower", 0, "", 0, "LineageNPC.e_warehouse_keeper_FDwarf", 7, 18, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31701, 31701, "Saint's Follower", 0, "", 0, "LineageNPC.a_common_people_MElf", 6, 21, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31702, 31702, "Saint's Follower", 0, "", 0, "LineageNPC.e_common_people_MDwarf", 8, 17, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31703, 31703, "Saint's Follower", 0, "", 0, "LineageNPC.a_common_peopleC_Fhuman", 8, 22.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31704, 31704, "Saint's Follower", 0, "", 0, "LineageNPC.a_common_peopleA_FHuman", 8, 21.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31705, 31705, "Daimon the White-Eyed", 0, "", 0, "LineageMonster2.hundred_eye", 21, 55, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(31706, 31706, "Miki the Cat", 0, "", 0, "LineageMonster.cat_the_cat", 9, 16, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31707, 31707, "Ketra Van Grunt", 0, "", 0, "LineageMonster2.ketra_orc_chieftain", 11, 38.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 6719, 0, 0, 24, 120, 0, 1), 
(31708, 31708, "Ketra Van Shaman", 0, "", 0, "LineageMonster.ketra_orc_shaman", 10, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 92, 0, 0, 10, 120, 0, 1), 
(31709, 31709, "Ketra Van Captain", 0, "", 0, "LineageMonster2.ketra_orc_warlord", 12, 30, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 80, 0, 0, 27, 120, 0, 1), 
(31710, 31710, "Ketra Van Commander", 0, "", 0, "LineageMonster2.barka_silenos_chieftain", 18, 42.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 2500, 0, 0, 25, 120, 0, 1), 
(31711, 31711, "Ketra Van Shaman", 0, "", 0, "LineageMonster2.barka_silenos_shaman", 14, 39.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 6716, 0, 0, 36, 120, 0, 1), 
(31712, 31712, "Varka Raider", 0, "", 0, "LineageMonster2.barka_silenos_warrior", 16, 41, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 142, 0, 0, 34, 120, 0, 1), 
(31713, 31713, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(31714, 31714, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(31715, 31715, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(31716, 31716, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(31717, 31717, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(31718, 31718, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(31719, 31719, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(31720, 31720, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(31721, 31721, "Orator of Revelations", 0, "", 0, "LineageMonster.liviona", 15, 28, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31722, 31722, "Orator of Revelations", 0, "", 0, "LineageMonster.liviona", 15, 28, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31723, 31723, "Orator of Revelations", 0, "", 0, "LineageMonster.liviona", 15, 28, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31724, 31724, "Orator of Revelations", 0, "", 0, "LineageMonster.liviona", 15, 28, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31725, 31725, "Orator of Revelations", 0, "", 0, "LineageMonster.liviona", 15, 28, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31726, 31726, "Orator of Revelations", 0, "", 0, "LineageMonster.liviona", 15, 28, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31727, 31727, "Orator of Revelations", 0, "", 0, "LineageMonster.liviona", 15, 28, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31728, 31728, "Orator of Revelations", 0, "", 0, "LineageMonster.liviona", 15, 28, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31729, 31729, "Adventurer Guildsman", 0, "", 0, "LineageNPC.a_common_peopleA_MHuman", 8, 21.5, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 156, 20, 0, 50, 120, 0, 1), 
(31730, 31730, "Adventurer Guildsman", 0, "", 0, "LineageNPC.a_common_people_MElf", 6, 21, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 130, 0, 0, 50, 120, 0, 1), 
(31731, 31731, "Adventurer Guildsman", 0, "", 0, "LineageNPC.a_fighterguild_teacher_FDarkElf", 8, 23, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 224, 0, 0, 50, 120, 0, 1), 
(31732, 31732, "Adventurer Guildsman", 0, "", 0, "LineageNPC.e_common_people_MOrc", 8, 26, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31733, 31733, "Adventurer Guildsman", 0, "", 0, "LineageNPC.e_collector_teacher_FDwarf", 8, 17.5, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31734, 31734, "Adventurer Guildsman", 0, "", 0, "LineageNPC.a_fighterguild_teacher_FHuman", 9.5, 22.4, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 129, 102, 0, 50, 120, 0, 1), 
(31735, 31735, "Adventurer Guildsman", 0, "", 0, "LineageNPC.a_fighterguild_teacher_FElf", 8, 22.5, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 231, 0, 0, 50, 120, 0, 1), 
(31736, 31736, "Adventurer Guildsman", 0, "", 0, "LineageNPC.a_trader_MDarkElf", 8, 22.5, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 151, 0, 0, 50, 120, 0, 1), 
(31737, 31737, "Adventurer Guildsman", 0, "", 0, "LineageNPC.e_trader_FOrc", 8, 24, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 99, 0, 0, 50, 120, 0, 1), 
(31738, 31738, "Adventurer Guildsman", 0, "", 0, "LineageNPC.e_common_people_MDwarf", 8, 17, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 99, 0, 0, 50, 120, 0, 1), 
(31739, 31739, "Talien", 0, "", 0, "LineageNPC.a_common_peopleB_MHuman", 8, 22, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 4202, 0, 0, 50, 120, 0, 1), 
(31740, 31740, "Caradine", 0, "", 0, "LineageNPC.a_mageguild_teacher_FElf", 7, 21.2, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 285, 0, 0, 50, 120, 0, 1), 
(31741, 31741, "Ossian", 0, "", 0, "LineageNPC.a_common_peopleC_Mhuman", 10, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 129, 102, 0, 50, 120, 0, 1), 
(31742, 31742, "Virgil", 0, "", 0, "LineageNPC.e_common_people_MDwarf", 8, 17, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31743, 31743, "Kassandra", 0, "", 0, "LineageNPC.e_warehouse_keeper_FDwarf", 7, 18, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31744, 31744, "Ogmar", 0, "", 0, "LineageNPC.e_common_people_MOrc", 8, 26, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31745, 31745, "Lady of the Lake", 0, "", 0, "LineageNPC.a_teleporter_FElf", 8.5, 23.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31746, 31746, "Fallen Unicorn", 0, "", 0, "LineageMonster.death_unicorn", 14, 30, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 46, 120, 0, 1), 
(31747, 31747, "Pure White Unicorn", 0, "", 0, "LineageMonster.unicorn", 14, 30, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 46, 120, 0, 1), 
(31748, 31748, "Cornerstone of Restraining", 0, "", 0, "LineageNPC.grave_keeper", 8, 21, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31750, 31750, "Mysterious Woman", 0, "", 0, "LineageNPC.a_teleporter_FElf", 8.5, 23.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31751, 31751, "Mysterious Dark Knight", 0, "", 0, "LineageMonster.death_lord", 21, 40, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 78, 0, 0, 40, 120, 0, 1), 
(31752, 31752, "Corpse of Angel", 0, "", 0, "LineageNPC.angel_death", 25, 36.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31755, 31755, "Halaster", 0, "Grand Magister", 0, "LineageNPC.a_mageguild_master_MHuman", 8, 24, 70, "male", "L2VillageMasterMystic", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31756, 31756, "Mr. Cat", 0, "Test Server Helper", 0, "LineageMonster.cat_the_cat", 9, 16, 70, "male", "L2ClassMaster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31757, 31757, "Miss Queen", 0, "Test Server Helper", 0, "LineageMonster2.queen_of_cat", 8, 15, 70, "female", "L2ClassMaster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 26, 120, 0, 1), 
(31758, 31758, "Rafi", 0, "", 0, "LineageMonster.hatchling", 9, 10, 70, "male", "L2TownPet", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31759, 31759, "Teleportation Cubic", 0, "", 0, "LineageNPC.teleport_npc", 40, 80, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31760, 31760, "Miss Queen", 0, "Adventurers' Guide", 0, "LineageMonster2.queen_of_cat", 8, 15, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 26, 120, 0, 1), 
(31761, 31761, "Miss Queen", 0, "Adventurers' Guide", 0, "LineageMonster2.queen_of_cat", 8, 15, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 26, 120, 0, 1), 
(31762, 31762, "Miss Queen", 0, "Adventurers' Guide", 0, "LineageMonster2.queen_of_cat", 8, 15, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 26, 120, 0, 1), 
(31763, 31763, "Miss Queen", 0, "Adventurers' Guide", 0, "LineageMonster2.queen_of_cat", 8, 15, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 26, 120, 0, 1), 
(31764, 31764, "Miss Queen", 0, "Adventurers' Guide", 0, "LineageMonster2.queen_of_cat", 8, 15, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 26, 120, 0, 1), 
(31765, 31765, "Miss Queen", 0, "Adventurers' Guide", 0, "LineageMonster2.queen_of_cat", 8, 15, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 26, 120, 0, 1), 
(31766, 31766, "Miss Queen", 0, "Adventurers' Guide", 0, "LineageMonster2.queen_of_cat", 8, 15, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 26, 120, 0, 1), 
(31767, 31767, "Event Gatekeeper", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 48, 120, 0, 1), 
(31768, 31768, "Event Gatekeeper", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 48, 120, 0, 1), 
(31769, 31769, "Monument of Heroes", 0, "", 0, "LineageNPC.heroes_obelisk_elf", 24, 77.5, 70, "etc", "L2OlympiadManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31770, 31770, "Monument of Heroes", 0, "", 0, "LineageNPC.heroes_obelisk_darkelf", 25, 77, 70, "etc", "L2OlympiadManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31771, 31771, "Monument of Heroes", 0, "", 0, "LineageNPC.heroes_obelisk_orc", 24, 72.5, 70, "etc", "L2OlympiadManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31772, 31772, "Monument of Heroes", 0, "", 0, "LineageNPC.heroes_obelisk_dwarf", 23, 80, 70, "etc", "L2OlympiadManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31773, 31773, "Sonin", 0, "Warehouse Keeper", 0, "LineageNPC.e_warehouse_keeper_FDwarf", 7, 18, 70, "female", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31774, 31774, "Beryl the Cat", 0, "Event Manager", 0, "LineageMonster2.queen_of_cat", 8, 15, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 26, 120, 0, 1), 
(31775, 31775, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_fighterguild_teacher_FHuman", 9.5, 22.4, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 129, 102, 0, 50, 120, 0, 1), 
(31776, 31776, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_common_peopleA_MHuman", 8, 21.5, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 156, 20, 0, 50, 120, 0, 1), 
(31777, 31777, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_fighterguild_teacher_FDarkElf", 8, 23, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 224, 0, 0, 50, 120, 0, 1), 
(31778, 31778, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_trader_MDarkElf", 8, 22.5, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 151, 0, 0, 50, 120, 0, 1), 
(31779, 31779, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_trader_MDarkElf", 8, 22.5, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 151, 0, 0, 50, 120, 0, 1), 
(31780, 31780, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_common_people_MElf", 6, 21, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 130, 0, 0, 50, 120, 0, 1), 
(31781, 31781, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_fighterguild_teacher_FElf", 8, 22.5, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 231, 0, 0, 50, 120, 0, 1), 
(31782, 31782, "Adventure Guildsman", 0, "", 0, "LineageNPC.e_collector_teacher_FDwarf", 8, 17.5, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31783, 31783, "Adventure Guildsman", 0, "", 0, "LineageNPC.e_common_people_MDwarf", 8, 17, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 99, 0, 0, 50, 120, 0, 1), 
(31784, 31784, "Adventure Guildsman", 0, "", 0, "LineageNPC.e_common_people_MOrc", 8, 26, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31785, 31785, "Adventure Guildsman", 0, "", 0, "LineageNPC.e_trader_FOrc", 8, 24, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 99, 0, 0, 50, 120, 0, 1), 
(31786, 31786, "Adventure Guildsman", 0, "", 0, "LineageNPC.e_trader_FOrc", 8, 24, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 99, 0, 0, 50, 120, 0, 1), 
(31787, 31787, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_fighterguild_teacher_FHuman", 9.5, 22.4, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 129, 102, 0, 50, 120, 0, 1), 
(31788, 31788, "Adventure Guildsman", 0, "", 0, "LineageNPC.e_common_people_MOrc", 8, 26, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31789, 31789, "Adventure Guildsman", 0, "", 0, "LineageNPC.e_common_people_MDwarf", 8, 17, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 99, 0, 0, 50, 120, 0, 1), 
(31790, 31790, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_fighterguild_teacher_FElf", 8, 22.5, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 231, 0, 0, 50, 120, 0, 1), 
(31791, 31791, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_trader_MDarkElf", 8, 22.5, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 151, 0, 0, 50, 120, 0, 1), 
(31792, 31792, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_common_people_MElf", 6, 21, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 130, 0, 0, 50, 120, 0, 1), 
(31793, 31793, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_fighterguild_teacher_FDarkElf", 8, 23, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 224, 0, 0, 50, 120, 0, 1), 
(31794, 31794, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_fighterguild_teacher_FElf", 8, 22.5, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 231, 0, 0, 50, 120, 0, 1), 
(31795, 31795, "Adventure Guildsman", 0, "", 0, "LineageNPC.e_common_people_MOrc", 8, 26, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31796, 31796, "Adventure Guildsman", 0, "", 0, "LineageNPC.e_collector_teacher_FDwarf", 8, 17.5, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31797, 31797, "Adventure Guildsman", 0, "", 0, "LineageNPC.e_common_people_MDwarf", 8, 17, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 99, 0, 0, 50, 120, 0, 1), 
(31798, 31798, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_fighterguild_teacher_FHuman", 9.5, 22.4, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 129, 102, 0, 50, 120, 0, 1), 
(31799, 31799, "Adventure Guildsman", 0, "", 0, "LineageNPC.e_common_people_MOrc", 8, 26, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31800, 31800, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_common_peopleA_MHuman", 8, 21.5, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 156, 20, 0, 50, 120, 0, 1), 
(31801, 31801, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_common_peopleA_MHuman", 8, 21.5, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 156, 20, 0, 50, 120, 0, 1), 
(31802, 31802, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_fighterguild_teacher_FHuman", 9.5, 22.4, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 129, 102, 0, 50, 120, 0, 1), 
(31803, 31803, "Adventure Guildsman", 0, "", 0, "LineageNPC.e_common_people_MOrc", 8, 26, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31804, 31804, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_fighterguild_teacher_FDarkElf", 8, 23, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 224, 0, 0, 50, 120, 0, 1), 
(31805, 31805, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_fighterguild_teacher_FElf", 8, 22.5, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 231, 0, 0, 50, 120, 0, 1), 
(31806, 31806, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_common_people_MElf", 6, 21, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 130, 0, 0, 50, 120, 0, 1), 
(31807, 31807, "Adventure Guildsman", 0, "", 0, "LineageNPC.e_common_people_MDwarf", 8, 17, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 99, 0, 0, 50, 120, 0, 1), 
(31808, 31808, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_fighterguild_teacher_FHuman", 9.5, 22.4, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 129, 102, 0, 50, 120, 0, 1), 
(31809, 31809, "Adventure Guildsman", 0, "", 0, "LineageNPC.e_common_people_MOrc", 8, 26, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31810, 31810, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_fighterguild_teacher_FDarkElf", 8, 23, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 224, 0, 0, 50, 120, 0, 1), 
(31811, 31811, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_common_people_MElf", 6, 21, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 130, 0, 0, 50, 120, 0, 1), 
(31812, 31812, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_fighterguild_teacher_FDarkElf", 8, 23, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 224, 0, 0, 50, 120, 0, 1), 
(31813, 31813, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_fighterguild_teacher_FElf", 8, 22.5, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 231, 0, 0, 50, 120, 0, 1), 
(31814, 31814, "Adventure Guildsman", 0, "", 0, "LineageNPC.e_collector_teacher_FDwarf", 8, 17.5, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31815, 31815, "Adventure Guildsman", 0, "", 0, "LineageNPC.e_common_people_MOrc", 8, 26, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31816, 31816, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_fighterguild_teacher_FDarkElf", 8, 23, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 224, 0, 0, 50, 120, 0, 1), 
(31817, 31817, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_common_people_MElf", 6, 21, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 130, 0, 0, 50, 120, 0, 1), 
(31818, 31818, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_fighterguild_teacher_FHuman", 9.5, 22.4, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 129, 102, 0, 50, 120, 0, 1), 
(31819, 31819, "Adventure Guildsman", 0, "", 0, "LineageNPC.e_collector_teacher_FDwarf", 8, 17.5, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31820, 31820, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_fighterguild_teacher_FElf", 8, 22.5, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 231, 0, 0, 50, 120, 0, 1), 
(31821, 31821, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_fighterguild_teacher_FDarkElf", 8, 23, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 224, 0, 0, 50, 120, 0, 1), 
(31822, 31822, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_fighterguild_teacher_FHuman", 9.5, 22.4, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 129, 102, 0, 50, 120, 0, 1), 
(31823, 31823, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_common_people_MElf", 6, 21, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 130, 0, 0, 50, 120, 0, 1), 
(31824, 31824, "Adventure Guildsman", 0, "", 0, "LineageNPC.e_collector_teacher_FDwarf", 8, 17.5, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31825, 31825, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_fighterguild_teacher_FDarkElf", 8, 23, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 224, 0, 0, 50, 120, 0, 1), 
(31826, 31826, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_fighterguild_teacher_FElf", 8, 22.5, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 231, 0, 0, 50, 120, 0, 1), 
(31827, 31827, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_fighterguild_teacher_FElf", 8, 22.5, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 231, 0, 0, 50, 120, 0, 1), 
(31828, 31828, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_common_people_MElf", 6, 21, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 130, 0, 0, 50, 120, 0, 1), 
(31829, 31829, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_trader_MDarkElf", 8, 22.5, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 151, 0, 0, 50, 120, 0, 1), 
(31830, 31830, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_fighterguild_teacher_FDarkElf", 8, 23, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 224, 0, 0, 50, 120, 0, 1), 
(31831, 31831, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_fighterguild_teacher_FHuman", 9.5, 22.4, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 129, 102, 0, 50, 120, 0, 1), 
(31832, 31832, "Adventure Guildsman", 0, "", 0, "LineageNPC.e_common_people_MOrc", 8, 26, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31833, 31833, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_fighterguild_teacher_FElf", 8, 22.5, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 231, 0, 0, 50, 120, 0, 1), 
(31834, 31834, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_common_peopleA_MHuman", 8, 21.5, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 156, 20, 0, 50, 120, 0, 1), 
(31835, 31835, "Adventure Guildsman", 0, "", 0, "LineageNPC.e_collector_teacher_FDwarf", 8, 17.5, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31836, 31836, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_common_people_MElf", 6, 21, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 130, 0, 0, 50, 120, 0, 1), 
(31837, 31837, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_fighterguild_teacher_FDarkElf", 8, 23, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 224, 0, 0, 50, 120, 0, 1), 
(31838, 31838, "Adventure Guildsman", 0, "", 0, "LineageNPC.e_common_people_MDwarf", 8, 17, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 99, 0, 0, 50, 120, 0, 1), 
(31839, 31839, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_common_people_MElf", 6, 21, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 130, 0, 0, 50, 120, 0, 1), 
(31840, 31840, "Adventure Guildsman", 0, "", 0, "LineageNPC.e_common_people_MOrc", 8, 26, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31841, 31841, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_fighterguild_teacher_FHuman", 9.5, 22.4, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 129, 102, 0, 50, 120, 0, 1), 
(31842, 31842, "Teleportation Cubic", 0, "", 0, "LineageNPC.teleport_npc", 40, 80, 70, "etc", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 1, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31843, 31843, "Teleportation Cubic", 0, "", 0, "LineageNPC.teleport_npc", 40, 80, 70, "etc", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 490, 1, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31844, 31844, "Aracna", 0, "", 0, "LineageMonster.aracne", 15, 26, 50, "female", "L2Monster", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3000, 226, 305.54906, 200.23844, 208.6504, 146.5258, 253, 4, 333, 0, 0, 0, 64, 120, 0, 1), 
(31845, 31845, "Bloody Pixy", 0, "", 0, "LineageMonster.pixy", 5, 25, 80, "female", "L2FriendlyMob", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 7680, 226, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31846, 31846, "Satyros", 0, "", 0, "LineageMonster.pan", 14, 35, 80, "male", "L2Monster", 80, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 7680, 226, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 291, 0, 0, 45, 110, 0, 1), 
(31847, 31847, "Pan", 0, "", 0, "LineageMonster.pan", 14, 35, 80, "male", "L2Monster", 80, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 7680, 226, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 291, 0, 0, 45, 110, 0, 1), 
(31848, 31848, "Pixy", 0, "", 0, "LineageMonster.pixy", 5, 25, 80, "female", "L2FriendlyMob", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 7680, 226, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31849, 31849, "Red Arachne", 0, "", 0, "LineageMonster.aracne", 15, 26, 80, "female", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 7680, 226, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 64, 120, 0, 1), 
(31850, 31850, "Blight Treant", 0, "", 0, "LineageMonster.ti_mi_riran", 23, 90, 80, "male", "L2FriendlyMob", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 7680, 226, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 12, 12, 0, 1), 
(31851, 31851, "Treant", 0, "", 0, "LineageMonster.ti_mi_tran", 23, 90, 80, "male", "L2FriendlyMob", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 7680, 226, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 12, 12, 0, 1), 
(31852, 31852, "Pixy Murika", 0, "", 0, "LineageMonster.pixy", 5, 25, 50, "female", "L2Npc", 40, 1421.00103, 747.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 3000, 226, 305.54906, 200.23844, 208.6504, 146.5258, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31853, 31853, "Treant Bremec", 0, "", 0, "LineageMonster.ti_mi_tran", 23, 90, 80, "male", "L2FriendlyMob", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 7680, 226, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 12, 12, 0, 1), 
(31854, 31854, "Event Manager", 0, "", 0, "LineageNPC.a_maidA_FHuman", 8, 20.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 490, 10, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31855, 31855, "Event Manager", 0, "", 0, "LineageNPC.a_trader_FElf", 8, 24, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 490, 10, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31856, 31856, "Event Manager", 0, "", 0, "LineageNPC.a_clergyman_FDarkElf", 8, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 490, 10, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31857, 31857, "Event Manager", 0, "", 0, "LineageNPC.e_traderA_FDwarf", 7, 18.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 490, 10, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31858, 31858, "Event Manager", 0, "", 0, "LineageNPC.e_trader_FOrc", 8, 24, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 490, 10, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31859, 31859, "Teleportation Cubic", 0, "", 0, "LineageNPC.teleport_npc", 40, 80, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 490, 1, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31860, 31860, "Buzz the Cat", 0, "Event Manager", 0, "LineageMonster.cat_the_cat", 9, 16, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 490, 10, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(31861, 31861, "Gatekeeper", 0, "", 0, "LineageNPC.a_teleporter_FHuman", 8, 25, 56, "female", "L2Teleporter", 40, 1724.6831, 918.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 314, 10, 405.96455, 228.40135, 277.22116, 167.1342, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31862, 31862, "Angelic Vortex", 0, "", 0, "LineageNPC.broadcasting_tower", 7, 35, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 490, 10, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31863, 31863, "Santa Trainee", 0, "", 0, "LineageNPC.e_smith_master_MDwarf", 8, 16.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 490, 10, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31864, 31864, "Santa Trainee", 0, "", 0, "LineageNPC.e_smith_master_MDwarf", 8, 16.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 490, 10, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31865, 31865, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 35, "etc", "L2Npc", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 129.32896, 136.72948, 88.31491, 100.0527, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31866, 31866, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 35, "etc", "L2Npc", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 129.32896, 136.72948, 88.31491, 100.0527, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31867, 31867, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 35, "etc", "L2Npc", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 129.32896, 136.72948, 88.31491, 100.0527, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31868, 31868, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 35, "etc", "L2Npc", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 129.32896, 136.72948, 88.31491, 100.0527, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31869, 31869, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 35, "etc", "L2Npc", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 129.32896, 136.72948, 88.31491, 100.0527, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31870, 31870, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 35, "etc", "L2Npc", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 129.32896, 136.72948, 88.31491, 100.0527, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31871, 31871, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 35, "etc", "L2Npc", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 129.32896, 136.72948, 88.31491, 100.0527, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31872, 31872, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 35, "etc", "L2Npc", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 129.32896, 136.72948, 88.31491, 100.0527, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31873, 31873, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 35, "etc", "L2Npc", 40, 772.73802, 402.6, 4.5, 1.8, 40, 43, 30, 21, 20, 20, 0, 0, 129.32896, 136.72948, 88.31491, 100.0527, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31874, 31874, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 45, "etc", "L2Npc", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 234.89829, 177.78746, 160.40508, 130.09715, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31875, 31875, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 45, "etc", "L2Npc", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 234.89829, 177.78746, 160.40508, 130.09715, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31876, 31876, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 45, "etc", "L2Npc", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 234.89829, 177.78746, 160.40508, 130.09715, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31877, 31877, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 45, "etc", "L2Npc", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 234.89829, 177.78746, 160.40508, 130.09715, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31878, 31878, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 45, "etc", "L2Npc", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 234.89829, 177.78746, 160.40508, 130.09715, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31879, 31879, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 45, "etc", "L2Npc", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 234.89829, 177.78746, 160.40508, 130.09715, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31880, 31880, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 45, "etc", "L2Npc", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 234.89829, 177.78746, 160.40508, 130.09715, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31881, 31881, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 45, "etc", "L2Npc", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 234.89829, 177.78746, 160.40508, 130.09715, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31882, 31882, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 45, "etc", "L2Npc", 40, 1183.80594, 610.8, 5.5, 2.1, 40, 43, 30, 21, 20, 20, 0, 0, 234.89829, 177.78746, 160.40508, 130.09715, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31883, 31883, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 55, "etc", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31884, 31884, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 55, "etc", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31885, 31885, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 55, "etc", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31886, 31886, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 55, "etc", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31887, 31887, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 55, "etc", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31888, 31888, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 55, "etc", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31889, 31889, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 55, "etc", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31890, 31890, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 55, "etc", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31891, 31891, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 55, "etc", "L2Npc", 40, 1673.05473, 889.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 388.11142, 223.6362, 265.02979, 163.64727, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31892, 31892, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 65, "etc", "L2Npc", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 582.81759, 271.89033, 397.98887, 198.95754, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31893, 31893, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 65, "etc", "L2Npc", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 582.81759, 271.89033, 397.98887, 198.95754, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31894, 31894, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 65, "etc", "L2Npc", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 582.81759, 271.89033, 397.98887, 198.95754, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31895, 31895, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 65, "etc", "L2Npc", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 582.81759, 271.89033, 397.98887, 198.95754, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31896, 31896, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 65, "etc", "L2Npc", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 582.81759, 271.89033, 397.98887, 198.95754, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31897, 31897, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 65, "etc", "L2Npc", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 582.81759, 271.89033, 397.98887, 198.95754, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31898, 31898, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 65, "etc", "L2Npc", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 582.81759, 271.89033, 397.98887, 198.95754, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31899, 31899, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 65, "etc", "L2Npc", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 582.81759, 271.89033, 397.98887, 198.95754, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31900, 31900, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 65, "etc", "L2Npc", 40, 2193.43142, 1188.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 582.81759, 271.89033, 397.98887, 198.95754, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31901, 31901, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31902, 31902, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31903, 31903, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31904, 31904, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31905, 31905, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31906, 31906, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31907, 31907, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31908, 31908, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31909, 31909, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31910, 31910, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 85, "etc", "L2Npc", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31911, 31911, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 85, "etc", "L2Npc", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31912, 31912, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 85, "etc", "L2Npc", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31913, 31913, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 85, "etc", "L2Npc", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31914, 31914, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 85, "etc", "L2Npc", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31915, 31915, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 85, "etc", "L2Npc", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31916, 31916, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 85, "etc", "L2Npc", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31917, 31917, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 85, "etc", "L2Npc", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31918, 31918, "Guardian of Border", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 85, "etc", "L2Npc", 40, 4234.063127, 1846.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1188.87259, 361.78814, 811.84586, 264.74086, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31919, 31919, "Ghost Chamberlain of Elmoreden", 0, "", 0, "LineageNPC.a_tombkeeperA", 8, 23, 70, "female", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31920, 31920, "Ghost Chamberlain of Elmoreden", 0, "", 0, "LineageNPC.a_tombkeeperA", 8, 23, 70, "female", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31921, 31921, "Conquerors' Sepulcher Manager", 0, "", 0, "LineageNPC.grave_keeper", 8, 21, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31922, 31922, "Emperors' Sepulcher Manager", 0, "", 0, "LineageNPC.grave_keeper", 8, 21, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31923, 31923, "Great Sages' Sepulcher Manager", 0, "", 0, "LineageNPC.grave_keeper", 8, 21, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31924, 31924, "Judges' Sepulcher Manager", 0, "", 0, "LineageNPC.grave_keeper", 8, 21, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31925, 31925, "Baron's Hall Gatekeeper", 0, "", 0, "LineageNPC.rift_keeper_25_sm", 9.5, 29, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31926, 31926, "Viscount's Hall Gatekeeper", 0, "", 0, "LineageNPC.rift_keeper_25_sm", 9.5, 29, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31927, 31927, "Count's Hall Gatekeeper", 0, "", 0, "LineageNPC.rift_keeper_25_sm", 9.5, 29, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31928, 31928, "Marquis' Hall Gatekeeper", 0, "", 0, "LineageNPC.rift_keeper_25_sm", 9.5, 29, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31929, 31929, "Duke's Hall Gatekeeper", 0, "", 0, "LineageNPC.rift_keeper_25_sm", 9.5, 29, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31930, 31930, "Baron's Hall Gatekeeper", 0, "", 0, "LineageNPC.rift_keeper_25_sm", 9.5, 29, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31931, 31931, "Viscount's Hall Gatekeeper", 0, "", 0, "LineageNPC.rift_keeper_25_sm", 9.5, 29, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31932, 31932, "Count's Hall Gatekeeper", 0, "", 0, "LineageNPC.rift_keeper_25_sm", 9.5, 29, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31933, 31933, "Marquis' Hall Gatekeeper", 0, "", 0, "LineageNPC.rift_keeper_25_sm", 9.5, 29, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31934, 31934, "Duke's Hall Gatekeeper", 0, "", 0, "LineageNPC.rift_keeper_25_sm", 9.5, 29, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31935, 31935, "Baron's Hall Gatekeeper", 0, "", 0, "LineageNPC.rift_keeper_25_sm", 9.5, 29, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31936, 31936, "Viscount's Hall Gatekeeper", 0, "", 0, "LineageNPC.rift_keeper_25_sm", 9.5, 29, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31937, 31937, "Count's Hall Gatekeeper", 0, "", 0, "LineageNPC.rift_keeper_25_sm", 9.5, 29, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31938, 31938, "Marquis' Hall Gatekeeper", 0, "", 0, "LineageNPC.rift_keeper_25_sm", 9.5, 29, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31939, 31939, "Duke's Hall Gatekeeper", 0, "", 0, "LineageNPC.rift_keeper_25_sm", 9.5, 29, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31940, 31940, "Baron's Hall Gatekeeper", 0, "", 0, "LineageNPC.rift_keeper_25_sm", 9.5, 29, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31941, 31941, "Viscount's Hall Gatekeeper", 0, "", 0, "LineageNPC.rift_keeper_25_sm", 9.5, 29, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31942, 31942, "Count's Hall Gatekeeper", 0, "", 0, "LineageNPC.rift_keeper_25_sm", 9.5, 29, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31943, 31943, "Marquis' Hall Gatekeeper", 0, "", 0, "LineageNPC.rift_keeper_25_sm", 9.5, 29, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31944, 31944, "Duke's Hall Gatekeeper", 0, "", 0, "LineageNPC.rift_keeper_25_sm", 9.5, 29, 70, "male", "L2SepulcherNpc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(31945, 31945, "Auzendorff", 0, "Weapon Merchant", 0, "LineageNPC.e_traderB_MDwarf", 8, 17.5, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31946, 31946, "Hombre", 0, "Weapon Merchant", 0, "LineageNPC.a_traderD_Mhuman", 8, 21.5, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31947, 31947, "Owaki", 0, "Armor Merchant", 0, "LineageNPC.e_trader_MOrc", 8, 23.5, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31948, 31948, "Adrian", 0, "Armor Merchant", 0, "LineageNPC.a_traderC_Mhuman", 8, 23, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31949, 31949, "Rouge", 0, "Accessory Merchant", 0, "LineageNPC.a_traderC_Fhuman", 8, 22.5, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31950, 31950, "Mailland", 0, "Accessory Merchant", 0, "LineageNPC.e_traderB_FDwarf", 7, 18, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31951, 31951, "Jose", 0, "Trader", 0, "LineageNPC.a_traderD_Fhuman", 8, 25.3, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31952, 31952, "Pele", 0, "Grocer", 0, "LineageNPC.a_common_peopleC_Fhuman", 8, 22.5, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31953, 31953, "Rankar", 0, "Symbol Maker", 0, "LineageNPC.a_mageguild_teacher_MHuman", 8, 23, 70, "male", "L2SymbolMaker", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31954, 31954, "Saroyan", 0, "Pet Manager", 0, "LineageNPC.a_traderD_Mhuman", 8, 21.5, 70, "male", "L2PetManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31955, 31955, "Ruby", 0, "", 0, "LineageMonster2.baby_tiger", 11, 15.7, 70, "male", "L2TownPet", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 28, 120, 0, 1), 
(31956, 31956, "Rydel", 0, "Warehouse Keeper", 0, "LineageNPC.e_warehouse_keeper_FDwarf", 7, 18, 70, "female", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31957, 31957, "Cherbal", 0, "Warehouse Keeper", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 70, "male", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31958, 31958, "Yasheni", 0, "Warehouse Chief", 0, "LineageNPC.e_warehouse_keeper_FDwarf", 7, 18, 70, "female", "L2VillageMasterDwarf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31959, 31959, "Axel", 0, "Warehouse Keeper", 0, "LineageNPC.e_warehouse_master_MDwarf", 8, 17.5, 70, "male", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31960, 31960, "Buryun", 0, "Blacksmith", 0, "LineageNPC.e_smith_Fdwarf", 8, 17.5, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 87, 0, 0, 50, 120, 0, 1), 
(31961, 31961, "Newyear", 0, "Head Blacksmith", 0, "LineageNPC.e_smith_master_MDwarf", 8, 16.5, 70, "male", "L2VillageMasterDwarf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 89, 0, 0, 50, 120, 0, 1), 
(31962, 31962, "Altair", 0, "Blueprint Seller", 0, "LineageNPC.a_traderA_MDwarf", 8, 17, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31963, 31963, "Hitchi", 0, "Mineral Trader", 0, "LineageNPC.e_traderB_master_MDwarf", 8, 17, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31964, 31964, "Bilia", 0, "Gatekeeper", 0, "LineageNPC.e_teleporter_Fhuman", 8, 25, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31965, 31965, "Hector", 0, "Grand Master", 0, "LineageNPC.a_fighterguild_master_Mhuman", 8, 23.5, 70, "male", "L2VillageMasterFighter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 76, 0, 0, 50, 120, 0, 1), 
(31966, 31966, "Karamon", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 125, 20, 0, 50, 120, 0, 1), 
(31967, 31967, "Euline", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_FElf", 8, 22.5, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 130, 0, 0, 50, 120, 0, 1), 
(31968, 31968, "Baryl", 0, "High Priest", 0, "LineageNPC.a_temple_master_Mhuman", 8, 22.5, 70, "male", "L2VillageMasterPriest", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 193, 0, 0, 50, 120, 0, 1), 
(31969, 31969, "Evelyn", 0, "Priest", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 70, "female", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31970, 31970, "Sinis", 0, "Priest", 0, "LineageNPC.a_mageguild_teacher_MElf", 7, 22.2, 70, "male", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31971, 31971, "Otillo", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_MHuman", 8, 23, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31972, 31972, "Atraxia", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_FElf", 7, 21.2, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31973, 31973, "Raheel", 0, "Spellbook Seller", 0, "LineageNPC.a_sanctuary_teacher_MHuman", 8, 23, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31974, 31974, "Drizzit", 0, "Grand Master", 0, "LineageNPC.a_guild_master_MDarkElf", 8, 23, 70, "male", "L2VillageMasterDElf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 143, 0, 0, 50, 120, 0, 1), 
(31975, 31975, "Aerina", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_MDarkElf", 8, 23, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 143, 0, 0, 50, 120, 0, 1), 
(31976, 31976, "Talia", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_FDarkElf", 8, 23, 70, "female", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 204, 0, 0, 50, 120, 0, 1), 
(31977, 31977, "Shaka", 0, "High Prefect", 0, "LineageNPC.e_patriarch_MOrc", 8, 26, 70, "male", "L2VillageMasterOrc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31978, 31978, "Tazeer", 0, "Prefect", 0, "LineageNPC.e_fighterguild_teacher_MOrc", 8, 28.5, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 161, 0, 0, 50, 120, 0, 1), 
(31979, 31979, "Moira", 0, "Seer", 0, "LineageNPC.e_clergyman_FOrc", 7, 28, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 202, 0, 0, 50, 120, 0, 1), 
(31980, 31980, "Rumba", 0, "Amulet Seller", 0, "LineageNPC.e_clergyman_FOrc", 7, 28, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31981, 31981, "Vishotsky", 0, "Captain", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 133, 632, 0, 50, 120, 0, 1), 
(31982, 31982, "Glen", 0, "Guard", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 126, 628, 0, 50, 120, 0, 1), 
(31983, 31983, "Friggar", 0, "Guard", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 94, 0, 0, 50, 120, 0, 1), 
(31984, 31984, "Sherring", 0, "Guard", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 126, 628, 0, 50, 120, 0, 1), 
(31985, 31985, "Kosmos", 0, "Guard", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 94, 0, 0, 50, 120, 0, 1), 
(31986, 31986, "Erstack", 0, "Guard", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 126, 628, 0, 50, 120, 0, 1), 
(31987, 31987, "Gotter", 0, "Guard", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 94, 0, 0, 50, 120, 0, 1), 
(31988, 31988, "Singa", 0, "Guard", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 80, "male", "L2Guard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 126, 628, 0, 50, 120, 0, 1), 
(31989, 31989, "Batidae", 0, "Fishing Guild Member", 0, "LineageNPC.a_fisherA_Mhuman", 8, 23, 70, "male", "L2Fisherman", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 7560, 0, 0, 50, 120, 0, 1), 
(31990, 31990, "Siger", 0, "Blacksmith", 0, "LineageNPC.a_smith_MDwarf", 7, 16.5, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31991, 31991, "Adventure Guildsman", 0, "", 0, "LineageNPC.e_collector_teacher_FDwarf", 8, 17.5, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31992, 31992, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_fighterguild_teacher_FHuman", 9.5, 22.4, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 129, 102, 0, 50, 120, 0, 1), 
(31993, 31993, "Adventure Guildsman", 0, "", 0, "LineageNPC.e_common_people_MDwarf", 8, 17, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 99, 0, 0, 50, 120, 0, 1), 
(31994, 31994, "Adventure Guildsman", 0, "", 0, "LineageNPC.e_common_people_MOrc", 8, 26, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31995, 31995, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_common_peopleA_MHuman", 8, 21.5, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 156, 20, 0, 50, 120, 0, 1), 
(31996, 31996, "Javier", 0, "Grand Magister", 0, "LineageNPC.a_mageguild_master_MHuman", 8, 24, 70, "male", "L2VillageMasterMystic", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(31997, 31997, "Priest of Dawn", 0, "", 0, "LineageNPC.priest_of_dawn", 8, 30.5, 70, "male", "L2DawnPriest", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 5802, 0, 50, 120, 0, 1), 
(31998, 31998, "Dusk Priestess", 0, "", 0, "LineageNPC.priest_of_dusk", 8, 22, 70, "female", "L2DuskPriest", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 5801, 0, 0, 50, 120, 0, 1), 
(31999, 31999, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(32000, 32000, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(32001, 32001, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1), 
(32002, 32002, "Preacher of Doom", 0, "", 0, "LineageMonster.dark_horror", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 100, 120, 0, 1); 

INSERT INTO `npc` VALUES
(32003, 32003, "Orator of Revelations", 0, "", 0, "LineageMonster.liviona", 15, 28, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(32004, 32004, "Orator of Revelations", 0, "", 0, "LineageMonster.liviona", 15, 28, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(32005, 32005, "Orator of Revelations", 0, "", 0, "LineageMonster.liviona", 15, 28, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(32006, 32006, "Orator of Revelations", 0, "", 0, "LineageMonster.liviona", 15, 28, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(32007, 32007, "Galba", 0, "Fishing Guild Member", 0, "LineageNPC.a_fisherA_Mhuman", 8, 23, 70, "male", "L2Fisherman", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 7560, 0, 0, 50, 120, 0, 1), 
(32008, 32008, "Greymore", 0, "Priest", 0, "LineageNPC.a_temple_master_Mhuman", 8, 22.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32009, 32009, "Devorin", 0, "Nurse", 0, "LineageNPC.e_common_people_FDwarf", 7, 17.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32010, 32010, "Flauron", 0, "Priest", 0, "LineageNPC.a_temple_master_Mhuman", 8, 22.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32011, 32011, "Imperial Tomb Guide", 0, "", 0, "LineageNPC.a_tombkeeperA", 8, 23, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32012, 32012, "Tantan", 0, "Retired Adventurer", 0, "LineageNPC2.a_old_people_Mhuman", 9, 17.3, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 6, 32, 0, 1), 
(32013, 32013, "Suki", 0, "Wild Maiden", 0, "LineageNPC.a_common_peopleB_FHuman", 8, 20.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32014, 32014, "Ivan", 0, "Runaway Youth", 0, "LineageNPC.a_traderD_Mhuman", 8, 21.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32015, 32015, "Scout's Corpse", 0, "", 0, "LineageNPC.e_guard_MDwarf_death", 13, 19, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32016, 32016, "Torrant", 0, "Beacon Tower Manager", 0, "LineageNPC.e_guard_MOrc", 8, 27, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 95, 0, 0, 50, 120, 0, 1), 
(32017, 32017, "Karuda", 0, "", 0, "LineageNPC.e_guard_MOrc", 8, 27, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 93, 0, 0, 50, 120, 0, 1), 
(32018, 32018, "Misa", 0, "", 0, "LineageNPC.a_maidB_FHuman", 8, 22, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32019, 32019, "Suspicious Man", 0, "", 0, "LineageNPC.a_sanctuary_teacher_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32020, 32020, "Rafforty", 0, "", 0, "LineageNPC.a_common_peopleC_Mhuman", 10, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32021, 32021, "Ice Sculpture", 0, "", 0, "LineageNpcEV.ice_sculpture_c", 16, 20.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32022, 32022, "Kier", 0, "", 0, "LineageNpcEV.ice_sculpture_b", 12, 24, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32023, 32023, "Ice Shelf", 0, "", 0, "LineageNpcEV.ice_shelf", 35, 14.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32024, 32024, "Mulia", 0, "Clan Trader", 0, "LineageNPC.e_smith_master_MDwarf", 8, 16.5, 70, "male", "L2ClanTrader", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32025, 32025, "Ilia", 0, "Clan Trader", 0, "LineageNPC.e_smith_Fdwarf", 8, 17.5, 70, "female", "L2ClanTrader", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32026, 32026, "Hestui Guard", 0, "", 0, "LineageNPC.e_fighterguild_teacher_MOrc", 8, 28.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32027, 32027, "Holy Brazier", 0, "", 0, "LineageNpcEV.grail_brazier_b", 30, 31, 78, "etc", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32028, 32028, "Holy Grail", 0, "", 0, "LineageNpcEV.holy_grail", 6.2, 7, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32029, 32029, "Freya's Steward", 0, "", 0, "LineageNPC.a_common_people_MElf", 6, 21, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32030, 32030, "Garden Sculpture", 0, "", 0, "LineageNpcEV.ice_sculpture_c", 16, 20.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32031, 32031, "Ice Fairy Sculpture", 0, "", 0, "LineageNpcEV.ice_sculpture_b", 12, 24, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32032, 32032, "Strange Machine", 0, "", 0, "LineageNpcEV.strange_mechanical_instrument", 16, 15.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32033, 32033, "Doctor Chaos", 0, "", 0, "LineageNPC2.doctor_chaos", 9, 15.6, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(32034, 32034, "Temple Gatekeeper", 0, "", 0, "LineageNpcEV.heretical_sanctuary_gatekeeper_a", 80, 181.5, 70, "etc", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32035, 32035, "Temple Gatekeeper", 0, "", 0, "LineageNpcEV.heretical_sanctuary_openner_a", 28, 70, 70, "etc", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32036, 32036, "Temple Gatekeeper", 0, "", 0, "LineageNpcEV.heretical_sanctuary_gatekeeper_b", 80, 203.5, 70, "etc", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32037, 32037, "Temple Gatekeeper", 0, "", 0, "LineageNpcEV.heretical_sanctuary_openner_b", 28, 70, 70, "etc", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32038, 32038, "Ritual Offering", 0, "", 0, "LineageNPC.a_traderA_Mhuman_deco", 10, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32039, 32039, "Triol's Mirror", 0, "", 0, "LineageNpcEV.heretical_devil_mirror", 28, 70, 70, "etc", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32040, 32040, "Triol's Mirror", 0, "", 0, "LineageNpcEV.heretical_devil_mirror", 28, 70, 70, "etc", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32041, 32041, "Yumi", 0, "Collector", 0, "LineageNPC.e_collector_teacher_FDwarf", 8, 17.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32042, 32042, "Weathermaster", 0, "", 0, "LineageNpcEV.pavel_weather_controller", 14.5, 18.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32043, 32043, "Weathermaster", 0, "", 0, "LineageNpcEV.pavel_weather_controller", 14.5, 18.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32044, 32044, "Weathermaster", 0, "", 0, "LineageMonster3.Evilate_weather", 16, 18.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 10, 1, 0, 1), 
(32045, 32045, "Doctor Chaos' Secret Bookshelf", 0, "", 0, "LineageMonster3.Evilate_doc_chaos", 25, 33.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 10, 1, 0, 1), 
(32046, 32046, "Suspicious-Looking Pile of Stones", 0, "", 0, "LineageMonster.susceptor_env", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 27, 1, 0, 1), 
(32047, 32047, "Wendy", 0, "", 0, "LineageNPC.e_teleporter_FDwarf", 8, 21.3, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32048, 32048, "Event Gatekeeper", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 48, 120, 0, 1), 
(32049, 32049, "Rooney", 0, "Blacksmith of Wind", 0, "LineageNPC.a_smith_MDwarf", 7, 16.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32050, 32050, "Parts Box", 0, "", 0, "LineageNPC.box", 18, 14, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32051, 32051, "Altar Gatekeeper", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32052, 32052, "Obi", 0, "Railroad Worker", 0, "LineageNPC.e_mine_teacher_MDwarf", 8, 18, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32053, 32053, "Abey", 0, "Railroad Worker", 0, "LineageNPC.e_mine_teacher_FDwarf", 8, 18.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32054, 32054, "Ghost of a Railroad Engineer", 0, "", 0, "LineageMonster.dwarf_ghost", 9, 16.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(32055, 32055, "Ghost of an Ancient Railroad Engineer", 0, "", 0, "LineageMonster.dwarf_ghost", 9, 16.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(32056, 32056, "Aren", 0, "Khavatari", 0, "LineageNPC.e_mageguild_teacher_FOrc", 8, 28, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32057, 32057, "Totem Spirit of Gandi", 0, "", 0, "LineageMonster.onyx_beast", 14, 14.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(32058, 32058, "Triol's Revelation", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32059, 32059, "Triol's Revelation", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32060, 32060, "Triol's Revelation", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32061, 32061, "Triol's Revelation", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32062, 32062, "Triol's Revelation", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32063, 32063, "Triol's Revelation", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32064, 32064, "Triol's Revelation", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32065, 32065, "Triol's Revelation", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32066, 32066, "Triol's Revelation", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32067, 32067, "Triol's Revelation", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32068, 32068, "Triol's Revelation", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32069, 32069, "Gutenhagen", 0, "Collector", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32070, 32070, "Adolph", 0, "", 0, "LineageNPC2.a_child_people_Mhuman", 5, 12.3, 70, "male", "L2NpcWalker", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 26, 45, 0, 1), 
(32071, 32071, "Linda", 0, "", 0, "LineageNPC2.a_child_people_Fhuman", 5, 12.3, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 24, 50, 0, 1), 
(32072, 32072, "Edwin", 0, "", 0, "LineageNPC2.a_old_people_Mhuman", 9, 17.3, 70, "male", "L2NpcWalker", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 6, 32, 0, 1), 
(32073, 32073, "Old Female Drifter", 0, "", 0, "LineageNPC2.a_old_people_Fhuman", 9, 17.3, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 9, 34, 0, 1), 
(32074, 32074, "Gludio Territory Manager", 0, "Guild President", 0, "LineageNPC.a_mageguild_teacher_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32075, 32075, "Sandy the Cat", 0, "Tournament Helper", 0, "LineageMonster2.queen_of_cat", 8, 15, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 26, 120, 0, 1), 
(32076, 32076, "Box", 0, "", 0, "LineageNPC.box", 18, 14, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32077, 32077, "Ice Sculpture", 0, "", 0, "LineageNpcEV.ice_sculpture_c", 16, 20.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32078, 32078, "Ice Sculpture", 0, "", 0, "LineageNpcEV.ice_sculpture_c", 16, 20.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32079, 32079, "Ice Sculpture", 0, "", 0, "LineageNpcEV.ice_sculpture_c", 16, 20.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32082, 32082, "Dion Territory Manager", 0, "Adventure Guildsman", 0, "LineageNPC.a_mageguild_teacher_MHuman", 8, 23, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32083, 32083, "Giran Territory Manager", 0, "Adventure Guildsman", 0, "LineageNPC.a_mageguild_teacher_MHuman", 8, 23, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32084, 32084, "Oren Territory Manager", 0, "Adventure Guildsman", 0, "LineageNPC.a_mageguild_teacher_MHuman", 8, 23, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32085, 32085, "Aden Territory Manager", 0, "Adventure Guildsman", 0, "LineageNPC.a_mageguild_teacher_MHuman", 8, 23, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32086, 32086, "Innadril Territory Manager", 0, "Adventure Guildsman", 0, "LineageNPC.a_mageguild_teacher_MHuman", 8, 23, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32087, 32087, "Schuttgart Territory Manager", 0, "Adventure Guildsman", 0, "LineageNPC.a_mageguild_teacher_MHuman", 8, 23, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32088, 32088, "Goddard Territory Manager", 0, "Adventure Guildsman", 0, "LineageNPC.a_mageguild_teacher_MHuman", 8, 23, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32089, 32089, "Rune Territory Manager", 0, "Adventure Guildsman", 0, "LineageNPC.a_mageguild_teacher_MHuman", 8, 23, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32090, 32090, "Dead Leopard's Carcass", 0, "", 0, "LineageMonster.onyx_beast_ns", 14, 14.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(32091, 32091, "Omega's Cat", 0, "Event Manager", 0, "LineageMonster.cutie_cat", 8, 15, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 48, 120, 0, 1), 
(32092, 32092, "Alder", 0, "Warehouse Chief", 0, "LineageNPC.e_warehouse_master_MDwarf", 8, 17.5, 70, "male", "L2VillageMasterDwarf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32093, 32093, "Bolin", 0, "Head Blacksmith", 0, "LineageNPC.e_common_people_MDwarf", 8, 17, 70, "male", "L2VillageMasterDwarf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 89, 0, 0, 50, 120, 0, 1), 
(32094, 32094, "Schule", 0, "Grand Master", 0, "LineageNPC.a_fighterguild_master_FHuman", 8, 21.5, 70, "female", "L2VillageMasterFighter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 76, 0, 0, 50, 120, 0, 1), 
(32095, 32095, "Marie", 0, "High Priest", 0, "LineageNPC.a_sanctuary_teacher_FHuman", 8, 22.5, 70, "female", "L2VillageMasterPriest", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 193, 0, 0, 50, 120, 0, 1), 
(32096, 32096, "Helminter", 0, "Grand Master", 0, "LineageNPC.a_fighterguild_teacher_FDarkElf", 8, 23, 70, "female", "L2VillageMasterDElf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 143, 0, 0, 50, 120, 0, 1), 
(32097, 32097, "Finker", 0, "High Prefect", 0, "LineageNPC.e_trader_FOrc", 8, 24, 70, "female", "L2VillageMasterOrc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32098, 32098, "Celes", 0, "Grand Magister", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 70, "female", "L2VillageMasterMystic", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32099, 32099, "Tony the Cat", 0, "Event Manager", 0, "LineageMonster.cutie_cat", 8, 15, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 48, 120, 0, 1), 
(32100, 32100, "Tony the Cat", 0, "Event Manager", 0, "LineageMonster.cutie_cat", 8, 15, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 48, 120, 0, 1), 
(32101, 32101, "Tony the Cat", 0, "Event Manager", 0, "LineageMonster.cutie_cat", 8, 15, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 48, 120, 0, 1), 
(32102, 32102, "Tony the Cat", 0, "Event Manager", 0, "LineageMonster.cutie_cat", 8, 15, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 48, 120, 0, 1), 
(32103, 32103, "Telling the Cat", 0, "Event Manager", 0, "LineageMonster.cutie_cat", 8, 15, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 48, 120, 0, 1), 
(32104, 32104, "Vervato", 0, "", 0, "LineageMonster3.Crokian_Sorcerer", 25, 33, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 60, 100, 0, 1), 
(32105, 32105, "Dinn", 0, "", 0, "LineageNPC.a_traderC_Mhuman", 8, 23, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32106, 32106, "Singsing", 0, "", 0, "LineageNPC.a_wharfinger_MHuman", 8, 23, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32107, 32107, "Teleportation Cubic", 0, "", 0, "LineageNPC.teleport_npc", 40, 80, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32108, 32108, "", 0, "", 0, "LineageNPC2.rhamphorhynchus_npc", 1, 30, 70, "male", "L2FlyTerrainObject", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 60, 160, 0, 1), 
(32109, 32109, "Shilen's Stone Statue", 0, "", 0, "LineageNpcEV.primeval_raid_teleporter", 24, 72.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32110, 32110, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 20, 0, 1), 
(32111, 32111, "Orahochin", 0, "", 0, "LineageMonster3.Crokian_Sorcerer", 25, 33, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 8217, 0, 0, 60, 100, 0, 1), 
(32112, 32112, "Gariachin", 0, "", 0, "LineageMonster3.Crokian_Sorcerer", 25, 33, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 60, 100, 0, 1), 
(32113, 32113, "Marquez", 0, "", 0, "LineageNPC.a_wharfinger_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32114, 32114, "Mushika", 0, "", 0, "LineageMonster3.Crokian_Elder", 30, 42.51, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 60, 100, 0, 1), 
(32115, 32115, "Asamah", 0, "", 0, "LineageMonster3.Crokian_Vice_Elder", 45, 41.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 60, 100, 0, 1), 
(32116, 32116, "Kirikachin", 0, "", 0, "LineageMonster3.Crokian_Vice_Elder", 45, 41.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 60, 100, 0, 1), 
(32117, 32117, "Karakawei", 0, "", 0, "LineageMonster3.Crokian_Sorcerer", 25, 33, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 60, 100, 0, 1), 
(32118, 32118, "Mantarasa Egg", 0, "", 0, "LineageNpcEV.dinosaur_nest", 53, 11.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32119, 32119, "Ulu Kaimu", 0, "", 0, "LineageMonster3.Evilate_doc_chaos", 25, 33.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 10, 100, 0, 1), 
(32120, 32120, "Balu Kaimu", 0, "", 0, "LineageMonster3.Evilate_doc_chaos", 25, 33.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 10, 100, 0, 1), 
(32121, 32121, "Chuta Kaimu", 0, "", 0, "LineageMonster3.Evilate_doc_chaos", 25, 33.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 10, 100, 0, 1), 
(32122, 32122, "Warrior's Grave", 0, "", 0, "LineageMonster3.Evilate_weather", 16, 18.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 10, 100, 0, 1), 
(32123, 32123, "Valakas", 0, "", 0, "LineageMonster3.valakas_f", 190, 335, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 120, 290, 0, 1), 
(32124, 32124, "Great Soul", 0, "", 0, "LineageNPC2.Soul_Collector_Npc", 14, 25, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32125, 32125, "Great Soul", 0, "", 0, "LineageNPC2.Soul_Collector_Npc", 14, 25, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32126, 32126, "Priest Guard", 0, "", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 70, "male", "L2Npc", 1100, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 8, 333, 7824, 0, 0, 50, 140, 0, 1), 
(32127, 32127, "Priest Guard", 0, "", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 70, "male", "L2Npc", 1100, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 8, 333, 7824, 0, 0, 50, 140, 0, 1), 
(32128, 32128, "Guardian Wizard of the Cloth", 0, "", 0, "LineageNPC.a_traderB_FHuman", 8, 24.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 4900, 0, 0, 50, 140, 0, 1), 
(32129, 32129, "", 0, "", 0, "LineageNPC2.valakas_f_dummy", 5, 10, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32130, 32130, "Strategist Lucien", 0, "Event Manager", 0, "LineageMonster3.king_of_cat", 6, 16.01, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 160, 120, 0, 1), 
(32131, 32131, "Magic Laboratory Worker", 0, "Event Manager", 0, "LineageNPC.e_smith_Fdwarf", 8, 17.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 313, 0, 0, 50, 120, 0, 1), 
(32132, 32132, "Alchemist's Servitor", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32133, 32133, "Perwan", 0, "Vice Hierarch", 0, "LineageNPC2.K_M1_elder", 17, 25, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 20, 120, 0, 1), 
(32134, 32134, "Newbie Helper", 0, "", 0, "LineageNPC2.K_F1_elder", 13, 22.25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 10, 120, 0, 1), 
(32135, 32135, "Newbie Guide", 0, "", 0, "LineageNPC2.K_M1_elder", 17, 25, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 20, 120, 0, 1), 
(32136, 32136, "Basil", 0, "Marksman", 0, "LineageNPC2.K_M1_guard", 13, 25, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 9645, 0, 0, 39, 120, 0, 1), 
(32137, 32137, "Sucrete", 0, "Marksman", 0, "LineageNPC2.K_M1_guard", 13, 25, 80, "male", "L2Guard", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 9645, 0, 0, 39, 120, 0, 1), 
(32138, 32138, "Kekropus", 0, "Hierarch", 0, "LineageNPC2.K_kekrops", 18, 28, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 20, 120, 0, 1), 
(32139, 32139, "Casca", 0, "Vice Hierarch", 0, "LineageNPC2.K_M1_elder", 17, 25, 70, "male", "L2VillageMasterKamael", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 20, 120, 0, 1), 
(32140, 32140, "Zenya", 0, "Vice Hierarch", 0, "LineageNPC2.K_F1_elder", 13, 22.25, 70, "female", "L2VillageMasterKamael", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 10, 120, 0, 1), 
(32141, 32141, "Nerga", 0, "Master", 0, "LineageNPC2.K_M1_master", 15, 25, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9646, 0, 0, 30, 120, 0, 1), 
(32142, 32142, "Tenor", 0, "Master", 0, "LineageNPC2.K_M1_master", 15, 25, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9646, 0, 0, 30, 120, 0, 1), 
(32143, 32143, "Belkis", 0, "Master", 0, "LineageNPC2.K_F1_master", 12, 23, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9644, 0, 0, 24, 120, 0, 1), 
(32144, 32144, "Xonia", 0, "Master", 0, "LineageNPC2.K_F1_master", 12, 23, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9644, 0, 0, 24, 120, 0, 1), 
(32145, 32145, "Maynard", 0, "Grand Master", 0, "LineageNPC2.K_F1_grand", 11, 22.25, 70, "female", "L2VillageMasterKamael", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9646, 0, 0, 28, 120, 0, 1), 
(32146, 32146, "Valpor", 0, "Grand Master", 0, "LineageNPC2.K_M1_grand", 13, 25, 70, "male", "L2VillageMasterKamael", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9645, 0, 0, 28, 120, 0, 1), 
(32147, 32147, "Rivian", 0, "Grand Master", 0, "LineageNPC.a_mageguild_teacher_FElf", 7, 21.2, 70, "female", "L2VillageMasterMystic", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32148, 32148, "Cindet", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_MElf", 7, 22.5, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32149, 32149, "Ennear", 0, "Magister", 0, "LineageNPC.a_fighterguild_teacher_FElf", 8, 22.5, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32150, 32150, "Took", 0, "High Prefect", 0, "LineageNPC.e_patriarch_MOrc", 8, 26, 70, "male", "L2VillageMasterOrc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32151, 32151, "Herz", 0, "Prefect", 0, "LineageNPC.e_fighterguild_teacher_MOrc", 8, 28.5, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32152, 32152, "Henri", 0, "Seer", 0, "LineageNPC.e_clergyman_FOrc", 7, 28, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32153, 32153, "Prana", 0, "High Priest", 0, "LineageNPC.a_temple_master_Mhuman", 8, 22.5, 70, "male", "L2VillageMasterPriest", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32154, 32154, "Aldenia", 0, "Grand Master", 0, "LineageNPC.a_fighterguild_master_FHuman", 8, 21.5, 70, "female", "L2VillageMasterFighter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32155, 32155, "Nabot", 0, "Priest", 0, "LineageNPC.a_temple_teacher_Mhuman", 8, 23, 70, "male", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32156, 32156, "Talbot", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32157, 32157, "Moka", 0, "Head Blacksmith", 0, "LineageNPC.e_smith_master_MDwarf", 8, 16.5, 70, "male", "L2VillageMasterDwarf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32158, 32158, "Fisler", 0, "Warehouse Chief", 0, "LineageNPC.e_collector_master_MDwarf", 8, 18.4, 70, "male", "L2VillageMasterDwarf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32159, 32159, "Kincaid", 0, "Blacksmith", 0, "LineageNPC.a_smith_MDwarf", 7, 16.5, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32160, 32160, "Devon", 0, "Grand Magister", 0, "LineageNPC.a_mageguild_teacher_MDarkElf", 8, 22, 70, "male", "L2VillageMasterDElf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32161, 32161, "Black", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_MDarkElf", 8, 23, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32162, 32162, "Martika", 0, "Magister", 0, "LineageNPC.a_clergyman_FDarkElf", 8, 25, 70, "female", "L2TrainerHealers", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32163, 32163, "Ragara", 0, "Gatekeeper", 0, "LineageNPC2.K_F1_teleporter", 13, 23.5, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(32164, 32164, "Erinu", 0, "Weapon Merchant", 0, "LineageNPC2.K_M1_normal", 13, 25, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 28, 120, 0, 1), 
(32165, 32165, "Zakone", 0, "Armor Merchant", 0, "LineageNPC2.K_M1_normal", 13, 25, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 28, 120, 0, 1), 
(32166, 32166, "Trevor", 0, "Accessory Merchant", 0, "LineageNPC2.K_M1_normal", 13, 25, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 28, 120, 0, 1), 
(32167, 32167, "Nika", 0, "Grocer", 0, "LineageNPC2.K_F1_normal", 11, 22.5, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 20, 120, 0, 1), 
(32168, 32168, "Zenith", 0, "Trader", 0, "LineageNPC2.K_F1_normal", 11, 22.5, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 20, 120, 0, 1), 
(32169, 32169, "Mila", 0, "Trader", 0, "LineageNPC2.K_F1_normal", 11, 22.5, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 20, 120, 0, 1), 
(32170, 32170, "Benis", 0, "Warehouse Keeper", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 70, "male", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32171, 32171, "Hoffa", 0, "Warehouse Chief", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 70, "male", "L2VillageMasterDwarf", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32172, 32172, "Saylem", 0, "Warehouse Keeper", 0, "LineageNPC.e_warehouse_keeper_FDwarf", 7, 18, 70, "female", "L2Warehouse", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32173, 32173, "Marcela", 0, "Zerstorer", 0, "LineageNPC2.K_F1_guard_Master", 13, 22.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9646, 0, 0, 48, 120, 0, 1), 
(32174, 32174, "Maddy", 0, "Marksman", 0, "LineageNPC2.K_F1_guard", 13, 22.5, 70, "female", "L2Guard", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9644, 0, 0, 60, 120, 0, 1), 
(32175, 32175, "Bixon", 0, "Marksman", 0, "LineageNPC2.K_M1_guard", 13, 25, 70, "male", "L2Guard", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9645, 0, 0, 39, 120, 0, 1), 
(32176, 32176, "Ambra", 0, "Marksman", 0, "LineageNPC2.K_F1_guard", 13, 22.5, 70, "female", "L2Guard", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9644, 0, 0, 60, 120, 0, 1), 
(32177, 32177, "Syzar", 0, "Marksman", 0, "LineageNPC2.K_M1_guard", 13, 25, 70, "male", "L2Guard", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9645, 0, 0, 39, 120, 0, 1), 
(32178, 32178, "Carver", 0, "Marksman", 0, "LineageNPC2.K_F1_guard", 13, 22.5, 70, "female", "L2Guard", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9644, 0, 0, 60, 120, 0, 1), 
(32179, 32179, "Putin", 0, "Marksman", 0, "LineageNPC2.K_M1_guard", 13, 25, 70, "male", "L2Guard", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9645, 0, 0, 39, 120, 0, 1), 
(32180, 32180, "Kato", 0, "Marksman", 0, "LineageNPC2.K_M1_guard", 13, 25, 70, "male", "L2Guard", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9645, 0, 0, 39, 120, 0, 1), 
(32181, 32181, "Mellon", 0, "Gatekeeper", 0, "LineageNPC2.K_F1_teleporter", 13, 23.5, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(32182, 32182, "Coplan", 0, "Master", 0, "LineageNPC2.K_M1_master", 15, 25, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9646, 0, 0, 30, 120, 0, 1), 
(32183, 32183, "Yunha", 0, "Master", 0, "LineageNPC2.K_F1_master", 12, 23, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9644, 0, 0, 24, 120, 0, 1), 
(32184, 32184, "Yinir", 0, "Gatekeeper", 0, "LineageNPC2.K_F1_teleporter", 13, 23.5, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(32185, 32185, "Peregrine", 0, "Marksman", 0, "LineageNPC2.K_M1_guard", 13, 25, 70, "male", "L2Guard", 1100, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 8, 333, 9645, 0, 0, 39, 120, 0, 1), 
(32186, 32186, "Yung", 0, "Gatekeeper", 0, "LineageNPC2.K_F1_teleporter", 13, 23.5, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(32187, 32187, "Nadir", 0, "Vice Hierarch", 0, "LineageNPC2.K_F1_elder", 13, 22.25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 10, 120, 0, 1), 
(32188, 32188, "Morelin", 0, "Marksman", 0, "LineageNPC2.K_F1_guard", 13, 22.5, 70, "female", "L2Guard", 1100, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 8, 333, 9644, 0, 0, 60, 120, 0, 1), 
(32189, 32189, "Largo", 0, "Gatekeeper", 0, "LineageNPC2.K_F1_teleporter", 13, 23.5, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(32190, 32190, "Mao", 0, "Vice Hierarch", 0, "LineageNPC2.K_M1_elder", 17, 25, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 20, 120, 0, 1), 
(32191, 32191, "Hanarin", 0, "Grand Master", 0, "LineageNPC2.K_F1_grand", 11, 22.25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9644, 0, 0, 28, 120, 0, 1), 
(32192, 32192, "Falken", 0, "Marksman", 0, "LineageNPC2.K_M1_guard", 13, 25, 70, "male", "L2Guard", 1100, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 8, 333, 9645, 0, 0, 39, 120, 0, 1), 
(32193, 32193, "Yeniche", 0, "Grand Master", 0, "LineageNPC2.K_F1_grand", 11, 22.25, 70, "female", "L2VillageMasterKamael", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9646, 0, 0, 28, 120, 0, 1), 
(32194, 32194, "Shubain", 0, "Master", 0, "LineageNPC2.K_M1_master", 15, 25, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9646, 0, 0, 30, 120, 0, 1), 
(32195, 32195, "Sione", 0, "Master", 0, "LineageNPC2.K_F1_master", 12, 23, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9644, 0, 0, 24, 120, 0, 1), 
(32196, 32196, "Gershwin", 0, "Grand Master", 0, "LineageNPC2.K_M1_grand", 13, 25, 70, "male", "L2VillageMasterKamael", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9646, 0, 0, 28, 120, 0, 1), 
(32197, 32197, "Gwain", 0, "Master", 0, "LineageNPC2.K_M1_master", 15, 25, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9646, 0, 0, 30, 120, 0, 1), 
(32198, 32198, "Gobie", 0, "Master", 0, "LineageNPC2.K_F1_master", 12, 23, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9644, 0, 0, 24, 120, 0, 1), 
(32199, 32199, "Holst", 0, "Grand Master", 0, "LineageNPC2.K_M1_grand", 13, 25, 70, "male", "L2VillageMasterKamael", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9645, 0, 0, 28, 120, 0, 1), 
(32200, 32200, "Entien", 0, "Master", 0, "LineageNPC2.K_M1_master", 15, 25, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9646, 0, 0, 30, 120, 0, 1), 
(32201, 32201, "Rindy", 0, "Master", 0, "LineageNPC2.K_F1_master", 12, 23, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9644, 0, 0, 24, 120, 0, 1), 
(32202, 32202, "Khadava", 0, "Grand Master", 0, "LineageNPC2.K_F1_grand", 11, 22.25, 70, "female", "L2VillageMasterKamael", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9644, 0, 0, 28, 120, 0, 1), 
(32203, 32203, "Ramen", 0, "Master", 0, "LineageNPC2.K_M1_master", 15, 25, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9646, 0, 0, 30, 120, 0, 1), 
(32204, 32204, "Fiske", 0, "Master", 0, "LineageNPC2.K_F1_master", 12, 23, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9644, 0, 0, 24, 120, 0, 1), 
(32205, 32205, "Aetonic", 0, "Grand Master", 0, "LineageNPC2.K_M1_grand", 13, 25, 70, "male", "L2VillageMasterKamael", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9646, 0, 0, 28, 120, 0, 1), 
(32206, 32206, "Pieche", 0, "Grand Master", 0, "LineageNPC2.K_F1_grand", 11, 22.25, 70, "female", "L2VillageMasterKamael", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9646, 0, 0, 28, 120, 0, 1), 
(32207, 32207, "Orkurus", 0, "Master", 0, "LineageNPC2.K_M1_master", 15, 25, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9646, 0, 0, 30, 120, 0, 1), 
(32208, 32208, "Rasha", 0, "Master", 0, "LineageNPC2.K_F1_master", 12, 23, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9644, 0, 0, 24, 120, 0, 1), 
(32209, 32209, "Ferdinand", 0, "Grand Master", 0, "LineageNPC2.K_M1_grand", 13, 25, 70, "male", "L2VillageMasterKamael", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9645, 0, 0, 28, 120, 0, 1), 
(32210, 32210, "Eddy", 0, "Grand Master", 0, "LineageNPC2.K_F1_grand", 11, 22.25, 70, "female", "L2VillageMasterKamael", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9644, 0, 0, 28, 120, 0, 1), 
(32211, 32211, "Jueno", 0, "Master", 0, "LineageNPC2.K_M1_master", 15, 25, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9646, 0, 0, 30, 120, 0, 1), 
(32212, 32212, "Rishtar", 0, "Master", 0, "LineageNPC2.K_F1_master", 12, 23, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9644, 0, 0, 24, 120, 0, 1), 
(32213, 32213, "Vitus", 0, "Grand Master", 0, "LineageNPC2.K_M1_grand", 13, 25, 70, "male", "L2VillageMasterKamael", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9646, 0, 0, 28, 120, 0, 1), 
(32214, 32214, "Meldina", 0, "Grand Master", 0, "LineageNPC2.K_F1_grand", 11, 22.25, 70, "female", "L2VillageMasterKamael", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9646, 0, 0, 28, 120, 0, 1), 
(32215, 32215, "Tenain", 0, "Master", 0, "LineageNPC2.K_M1_master", 15, 25, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9646, 0, 0, 30, 120, 0, 1), 
(32216, 32216, "Noir", 0, "Master", 0, "LineageNPC2.K_F1_master", 12, 23, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9644, 0, 0, 24, 120, 0, 1), 
(32217, 32217, "Barta", 0, "Grand Master", 0, "LineageNPC2.K_M1_grand", 13, 25, 70, "male", "L2VillageMasterKamael", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9645, 0, 0, 28, 120, 0, 1), 
(32218, 32218, "Miya", 0, "Grand Master", 0, "LineageNPC2.K_F1_grand", 11, 22.25, 70, "female", "L2VillageMasterKamael", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9644, 0, 0, 28, 120, 0, 1), 
(32219, 32219, "Fabnor", 0, "Master", 0, "LineageNPC2.K_M1_master", 15, 25, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9646, 0, 0, 30, 120, 0, 1), 
(32220, 32220, "Selsia", 0, "Master", 0, "LineageNPC2.K_F1_master", 12, 23, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9644, 0, 0, 24, 120, 0, 1), 
(32221, 32221, "Brome", 0, "Grand Master", 0, "LineageNPC2.K_M1_grand", 13, 25, 70, "male", "L2VillageMasterKamael", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9646, 0, 0, 28, 120, 0, 1), 
(32222, 32222, "Liane", 0, "Grand Master", 0, "LineageNPC2.K_F1_grand", 11, 22.25, 70, "female", "L2VillageMasterKamael", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9646, 0, 0, 28, 120, 0, 1), 
(32223, 32223, "Duroga", 0, "Master", 0, "LineageNPC2.K_M1_master", 15, 25, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9646, 0, 0, 30, 120, 0, 1), 
(32224, 32224, "Auren", 0, "Master", 0, "LineageNPC2.K_F1_master", 12, 23, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9644, 0, 0, 24, 120, 0, 1), 
(32225, 32225, "Taine", 0, "Grand Master", 0, "LineageNPC2.K_M1_grand", 13, 25, 70, "male", "L2VillageMasterKamael", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9645, 0, 0, 28, 120, 0, 1), 
(32226, 32226, "Raula", 0, "Grand Master", 0, "LineageNPC2.K_F1_grand", 11, 22.25, 70, "female", "L2VillageMasterKamael", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9644, 0, 0, 28, 120, 0, 1), 
(32227, 32227, "Digler", 0, "Master", 0, "LineageNPC2.K_M1_master", 15, 25, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9646, 0, 0, 30, 120, 0, 1), 
(32228, 32228, "Medea", 0, "Master", 0, "LineageNPC2.K_F1_master", 12, 23, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9644, 0, 0, 24, 120, 0, 1), 
(32229, 32229, "Hagel", 0, "Grand Master", 0, "LineageNPC2.K_M1_grand", 13, 25, 70, "male", "L2VillageMasterKamael", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9646, 0, 0, 28, 120, 0, 1), 
(32230, 32230, "Ceci", 0, "Grand Master", 0, "LineageNPC2.K_F1_grand", 11, 22.25, 70, "female", "L2VillageMasterKamael", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9646, 0, 0, 28, 120, 0, 1), 
(32231, 32231, "Luben", 0, "Master", 0, "LineageNPC2.K_M1_master", 15, 25, 70, "male", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9646, 0, 0, 30, 120, 0, 1), 
(32232, 32232, "Minuet", 0, "Master", 0, "LineageNPC2.K_F1_master", 12, 23, 70, "female", "L2Trainer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9644, 0, 0, 24, 120, 0, 1), 
(32233, 32233, "Zoldart", 0, "Grand Master", 0, "LineageNPC2.K_M1_grand", 13, 25, 70, "male", "L2VillageMasterKamael", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9645, 0, 0, 28, 120, 0, 1), 
(32234, 32234, "Nizer", 0, "Grand Master", 0, "LineageNPC2.K_F1_grand", 11, 22.25, 70, "female", "L2VillageMasterKamael", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9644, 0, 0, 28, 120, 0, 1), 
(32235, 32235, "Katenar", 0, "", 0, "LineageNPC2.k_hero_rapire", 10, 24.62, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9646, 0, 0, 28, 120, 0, 1), 
(32236, 32236, "Harkilgamed", 0, "", 0, "LineageNPC2.k_hero_bigsword", 11, 25, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9645, 0, 0, 42, 120, 0, 1), 
(32237, 32237, "Rodenpicula", 0, "", 0, "LineageNPC2.k_hero_bowgun", 9, 23, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9644, 0, 0, 47, 120, 0, 1), 
(32238, 32238, "Rock", 0, "", 0, "LineageNpcEV.stone_q0236_p", 60, 25, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(32239, 32239, "Mother Nornil", 0, "", 0, "LineageNpcEV.mother_nornil", 50, 253, 70, "male", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(32240, 32240, "Katenar", 0, "", 0, "LineageNPC2.k_hero_rapire", 10, 24.62, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9646, 0, 0, 28, 120, 0, 1), 
(32241, 32241, "Berka", 0, "", 0, "LineageNPC2.K_M1_master", 15, 25, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9646, 0, 0, 30, 120, 0, 1), 
(32242, 32242, "Katenar", 0, "", 0, "LineageNPC2.k_hero_rapire", 10, 24.62, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9646, 0, 0, 28, 120, 0, 1), 
(32243, 32243, "Cargo Box", 0, "", 0, "LineageNPC.box", 18, 14, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32244, 32244, "Suspicious Man", 0, "", 0, "LineageNPC2.K_M1_normal", 13, 25, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 28, 120, 0, 1), 
(32245, 32245, "Matras", 0, "", 0, "LineageNPC.e_mine_teacher_MDwarf", 8, 18, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32246, 32246, "Rua", 0, "", 0, "LineageNPC2.a_child_people_Fhuman", 5, 12.3, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 24, 120, 0, 1), 
(32247, 32247, "Serian", 0, "", 0, "LineageNPC.a_common_peopleA_FHuman", 8, 21.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32248, 32248, "First Reaction", 0, "", 0, "LineageNPC.a_common_peopleB_MHuman", 8, 22, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32249, 32249, "Chief Jarron", 0, "", 0, "LineageNPC.a_wharfinger_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32250, 32250, "Ario", 0, "", 0, "LineageNPC.a_common_peopleA_MHuman", 8, 21.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32251, 32251, "Saria", 0, "", 0, "LineageNPC.a_common_peopleA_FHuman", 8, 21.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32252, 32252, "Caravaner Gort", 0, "", 0, "LineageNPC2.K_M1_normal", 13, 25, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 28, 120, 0, 1), 
(32253, 32253, "Harkilgamed", 0, "", 0, "LineageNPC2.k_hero_bigsword", 11, 25, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9645, 0, 0, 42, 120, 0, 1), 
(32254, 32254, "Harkilgamed", 0, "", 0, "LineageNPC2.k_hero_bigsword", 11, 25, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9645, 0, 0, 42, 120, 0, 1), 
(32255, 32255, "Icon of the Past", 0, "", 0, "LineageNpcEV.godness_of_the_past", 54, 245, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(32256, 32256, "Icon of the Present", 0, "", 0, "LineageNpcEV.godness_of_the_being", 54, 245, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(32257, 32257, "Icon of the Future", 0, "", 0, "LineageNpcEV.godness_of_the_come", 54, 245, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(32258, 32258, "Menacing Machine", 0, "", 0, "LineageNpcEV.mother_nornil", 50, 253, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(32259, 32259, "Vault Door Controller", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32260, 32260, "Gatemaster of the Past", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32261, 32261, "Gatemaster of the Present", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32262, 32262, "Gatemaster of the Future", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32263, 32263, "Rodenpicula", 0, "", 0, "LineageNPC2.k_hero_bowgun", 9, 23, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9644, 0, 0, 47, 120, 0, 1), 
(32264, 32264, "Kanis", 0, "", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32271, 32271, "Parme", 0, "", 0, "LineageNPC.a_teleporter_FElf", 65, 23, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32272, 32272, "Akyaka", 0, "", 0, "LineageNPC.a_traderA_MDwarf", 8, 17, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32273, 32273, "Oracle Guide", 0, "", 0, "LineageNpcEV.teleport_device", 16, 42, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(32274, 32274, "Oracle Guide", 0, "", 0, "LineageNpcEV.teleport_device", 16, 42, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(32275, 32275, "Oracle Guide", 0, "", 0, "LineageNpcEV.teleport_device", 16, 42, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(32276, 32276, "Oracle Guide", 0, "", 0, "LineageNpcEV.teleport_device", 16, 42, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(32277, 32277, "Oracle Guide", 0, "", 0, "LineageNpcEV.teleport_device", 16, 42, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(32278, 32278, "Oracle Guide", 0, "", 0, "LineageNpcEV.teleport_device", 16, 42, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(32279, 32279, "Oracle Guide", 0, "", 0, "LineageNpcEV.teleport_device", 16, 42, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(32280, 32280, "Oracle Guide", 0, "", 0, "LineageNpcEV.teleport_device", 16, 42, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(32281, 32281, "Oracle Guide", 0, "", 0, "LineageNpcEV.teleport_device", 16, 42, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(32282, 32282, "Yiyen", 0, "Archaeologist", 0, "LineageNPC.e_teleporter_FDwarf", 8, 21.3, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32284, 32284, "Eva's Protector", 0, "", 0, "LineageNpcEV.teleport_device", 16, 42, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 0, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(32285, 32285, "Eva's Protector", 0, "", 0, "LineageNpcEV.teleport_device", 16, 42, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 0, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(32286, 32286, "Eva's Protector", 0, "", 0, "LineageNpcEV.teleport_device", 16, 42, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 0, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(32287, 32287, "Eva's Protector", 0, "", 0, "LineageNpcEV.teleport_device", 16, 42, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 0, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(32288, 32288, "Symbol of Faith", 0, "", 0, "LineageNpcEV.dark_clouds_crystal", 23, 37, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(32289, 32289, "Symbol of Adversity", 0, "", 0, "LineageNpcEV.dark_clouds_crystal", 23, 37, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(32290, 32290, "Symbol of Adventure", 0, "", 0, "LineageNpcEV.dark_clouds_crystal", 23, 37, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(32291, 32291, "Symbol of Truth", 0, "", 0, "LineageNpcEV.truth_lie_crystal", 23, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(32292, 32292, "Galate", 0, "", 0, "LineageNPC.a_mageguild_teacher_FHuman", 8, 23.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32293, 32293, "Jirrone", 0, "", 0, "LineageNPC.a_common_peopleC_Mhuman", 10, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32294, 32294, "Budenka", 0, "Harbor Caravaner", 0, "LineageMonster4.Caravan", 33, 58.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 56, 120, 0, 1), 
(32296, 32296, "Seruzia", 0, "Spirit of the Old Seer", 0, "LineageMonster.human_ghost", 8, 22, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(32297, 32297, "Falk", 0, "", 0, "LineageMonster4.Caravan", 33, 58.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 56, 120, 0, 1), 
(32298, 32298, "Hude", 0, "Caravan Merchant", 0, "LineageMonster4.Caravan", 33, 58.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 56, 120, 0, 1), 
(32299, 32299, "Quarry Slave", 0, "", 0, "LineageMonster4.Caravan_Slave", 35, 47.5, 70, "male", "L2QuestGuard", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 46, 120, 0, 1), 
(32300, 32300, "Bernarde", 0, "", 0, "LineageNPC.a_common_peopleC_Mhuman", 10, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32301, 32301, "Kendal", 0, "Wandering Ghost", 0, "LineageMonster.human_ghost", 8, 22, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(32302, 32302, "Jerian", 0, "", 0, "LineageNPC.a_mageguild_teacher_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32303, 32303, "Machine", 0, "", 0, "LineageNpcEV.warp_gate_a", 16, 31, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(32304, 32304, "Oasis", 0, "", 0, "LineageNPC.training_doll_150p", 13, 40, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32305, 32305, "Ranku's Scapegoat", 0, "", 0, "LineageMonster4.Caravan_Slave_a", 35, 47.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 46, 120, 0, 1), 
(32306, 32306, "Native's Corpse", 0, "", 0, "LineageMonster.zombie_corpse", 13, 21, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 15, 120, 0, 1), 
(32307, 32307, "Dolmen", 0, "", 0, "LineageNpcEV.huge_dolmen", 220, 450, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(32308, 32308, "Ming", 0, "Love Cat", 0, "LineageMonster.cutie_cat", 8, 15, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 48, 120, 0, 1), 
(32312, 32312, "Rat Hole", 0, "", 0, "LineageNPC.training_doll_150p", 13, 40, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32313, 32313, "Deltuva", 0, "", 0, "LineageNPC.a_common_peopleC_Mhuman", 10, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32314, 32314, "Warpgate", 0, "", 0, "LineageNpcEV.warp_gate_a", 16, 31, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(32315, 32315, "Warpgate", 0, "", 0, "LineageNpcEV.warp_gate_a", 16, 31, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(32316, 32316, "Warpgate", 0, "", 0, "LineageNpcEV.warp_gate_b", 16, 31, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(32317, 32317, "Warpgate", 0, "", 0, "LineageNpcEV.warp_gate_c", 16, 31, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(32318, 32318, "Warpgate", 0, "", 0, "LineageNpcEV.warp_gate_d", 16, 31, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(32319, 32319, "Warpgate", 0, "", 0, "LineageNpcEV.warp_gate_e", 16, 31, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(32320, 32320, "Item Broker", 0, "Adventure Guildsman", 0, "LineageNPC.a_traderC_Mhuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32321, 32321, "Item Broker", 0, "Adventure Guildsman", 0, "LineageNPC.a_traderC_Mhuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32322, 32322, "Item Broker", 0, "Adventure Guildsman", 0, "LineageNPC.a_traderC_Mhuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32323, 32323, "Avant-Garde", 0, "Transformation Wizard", 0, "LineageNPC.a_traderB_FHuman", 8, 24.5, 70, "female", "L2TransformManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32324, 32324, "Black Stone Monolith", 0, "", 0, "LineageNpcEV.dark_clouds_stonehenge", 19, 24.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(32325, 32325, "Yin", 0, "Attribute Master", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32326, 32326, "Yang", 0, "Attribute Master", 0, "LineageNPC.a_mageguild_master_MHuman", 8, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32327, 32327, "Adventurers' Guide", 0, "", 0, "LineageNPC.a_sanctuary_teacher_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32328, 32328, "Crystalline Golem", 0, "", 0, "LineageMonster4.Crystal_Golem", 34, 47, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 54, 30, 0, 1), 
(32330, 32330, "Garden Guard", 0, "", 1, "LineageNPC2.K_F1_guard", 13, 22.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9644, 0, 0, 60, 120, 0, 1), 
(32331, 32331, "Arcane Nucleus", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(32332, 32332, "Katenar", 0, "", 0, "LineageNPC2.k_hero_rapire", 10, 24.62, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9646, 0, 0, 28, 120, 0, 1), 
(32333, 32333, "Katenar", 0, "", 0, "LineageNPC2.k_hero_rapire", 10, 24.62, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9646, 0, 0, 28, 120, 0, 1), 
(32334, 32334, "Harkilgamed", 0, "", 0, "LineageNPC2.k_hero_bigsword", 11, 25, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 9645, 0, 0, 42, 120, 0, 1), 
(32335, 32335, "Marksman", 0, "", 0, "LineageNPC2.K_F1_guard", 13, 22.5, 70, "female", "L2Guard", 1100, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 8, 333, 9644, 0, 0, 60, 120, 0, 1), 
(32336, 32336, "Marksman", 0, "", 0, "LineageNPC2.K_F1_guard", 13, 22.5, 70, "female", "L2Guard", 1100, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 8, 333, 9644, 0, 0, 60, 120, 0, 1), 
(32337, 32337, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_common_people_MElf", 6, 21, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 130, 0, 0, 50, 120, 0, 1), 
(32338, 32338, "Adventure Guildsman", 0, "", 0, "LineageNPC.e_collector_teacher_FDwarf", 8, 17.5, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32339, 32339, "Adventure Guildsman", 0, "", 0, "LineageNPC.a_fighterguild_teacher_FHuman", 9.5, 22.4, 70, "female", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 129, 102, 0, 50, 120, 0, 1), 
(32340, 32340, "Adventure Guildsman", 0, "", 0, "LineageNPC.e_common_people_MOrc", 8, 26, 70, "male", "L2Adventurer", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32342, 32342, "Eva's Gift Box", 0, "", 0, "LineageMonster.mimic_even", 8.5, 8.5, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(32343, 32343, "Moonlight Tombstone", 0, "", 0, "LineageNPC.evil_altar", 11, 45, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32344, 32344, "Spooky Tombstone", 0, "", 0, "LineageNPC.evil_altar", 11, 45, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32345, 32345, "Buron", 0, "Tailor", 0, "LineageNPC.a_common_peopleC_Mhuman", 10, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32346, 32346, "Kanaf", 0, "", 0, "LineageNPC.a_common_peopleC_Mhuman", 10, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32347, 32347, "Shadai", 0, "Legendary Blacksmith", 0, "LineageNPC.e_smith_master_MDwarf", 8, 16.5, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32348, 32348, "Burang", 0, "Fishing Guild Member", 0, "LineageNPC.a_fisherA_Mhuman", 8, 23, 70, "male", "L2Fisherman", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 7560, 0, 0, 50, 1, 0, 1), 
(32349, 32349, "Rignos", 0, "", 0, "LineageMonster3.zombie_gateguard", 17, 30.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 173, 0, 0, 33, 1, 0, 1), 
(32350, 32350, "Sandstorm", 0, "", 0, "LineageNpc2.sandTourbillon_a", 0.01, 35, 84, "etc", "L2Npc", 40, 4039.042705, 1812, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1144.7313, 357.86723, 781.70308, 261.87171, 253, 1, 333, 0, 0, 0, 50, 220, 0, 1), 
(32351, 32351, "Enceinte Insurgent", 0, "", 0, "LineageNPC.a_common_peopleC_Mhuman", 10, 24, 70, "male", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 291, 0, 0, 50, 160, 0, 1), 
(32352, 32352, "Desert Heatmaster", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32353, 32353, "Event Gatekeeper", 0, "", 0, "LineageMonster.cutie_cat", 8, 15, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 48, 120, 0, 1), 
(32354, 32354, "Kief", 0, "", 0, "LineageNPC.a_common_peopleC_Mhuman", 10, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32355, 32355, "Solomon", 0, "", 0, "LineageNPC.a_common_peopleC_Mhuman", 10, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32356, 32356, "Jude", 0, "", 0, "LineageMonster4.Caravan", 33, 58.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 56, 1, 0, 1), 
(32357, 32357, "Native Slave", 0, "", 0, "LineageNPC.a_common_peopleC_Mhuman", 10, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32358, 32358, "Native Prisoner", 0, "", 0, "LineageNPC.a_common_peopleC_Mhuman", 10, 24, 70, "male", "L2QuestGuard", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32359, 32359, "Lahm", 0, "Blacksmith of Power", 0, "LineageNPC.e_smith_master_MDwarf", 8, 16.5, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32361, 32361, "Caravan Supporter", 0, "", 0, "LineageNPC.box", 18, 14, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32362, 32362, "Hellbound Native", 0, "", 0, "LineageNPC.a_common_peopleC_Mhuman", 10, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 1, 0, 0, 50, 100, 0, 1), 
(32363, 32363, "Hellbound Insurgent", 0, "", 0, "LineageNPC.a_common_peopleC_Mhuman", 10, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 129, 102, 0, 50, 100, 0, 1), 
(32364, 32364, "Hellbound Traitor", 0, "", 0, "LineageNPC.a_common_peopleC_Mhuman", 10, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32365, 32365, "Snow", 0, "Event Manager", 0, "LineageNPC2.TP_game_staff", 5, 12.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 75, 120, 0, 1), 
(32366, 32366, "Destroyed Device", 0, "", 0, "LineageMonster.susceptor_env", 20, 35, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 27, 1, 0, 1), 
(32367, 32367, "Alarm", 0, "", 0, "LineageNpcEV.pavel_weather_controller", 14.5, 18.5, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32368, 32368, "Weathered Rock", 0, "", 0, "LineageNpcEV.stone_q0236_p", 60, 25, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32369, 32369, "Fallen Angel", 0, "", 0, "LineageMonster2.apostle_warrior", 8, 30, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 6717, 0, 0, 50, 180, 0, 1), 
(32370, 32370, "Old Dwarven Ghost", 0, "", 0, "LineageNPC.e_collector_teacher_Mdwarf_mon", 8, 17.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 8528, 0, 0, 36, 140, 0, 1), 
(32371, 32371, "Ingenious Contraption", 0, "", 0, "LineageNpcEV.elobrate_machine", 13, 20, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32372, 32372, "Mysterious Agent", 0, "", 0, "LineageMonster.kel_mahum_witch_doctor", 13, 25, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 202, 0, 0, 50, 100, 0, 1), 
(32373, 32373, "Dorian", 0, "", 0, "LineageNPC.a_mageguild_teacher_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32374, 32374, "Teleportation Cubic", 0, "", 0, "LineageNPC.teleport_cube", 30, 65, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32375, 32375, "Teleportation Cubic", 0, "", 0, "LineageNPC.teleport_cube", 30, 65, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32376, 32376, "Teleportation Cubic", 0, "", 0, "LineageNPC.teleport_cube", 30, 65, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32377, 32377, "Kuram", 0, "Coordinator", 0, "LineageNPC2.TP_battlezone_staff", 7.8, 17.29, 70, "male", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 60, 60, 0, 1), 
(32378, 32378, "Fantasy Isle Paddies", 0, "Gatekeeper", 0, "LineageNPC.e_teleporter_FDwarf", 8, 21.3, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32379, 32379, "", 0, "", 0, "LineageNPC2.TP_flag", 0.01, 12.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32380, 32380, "", 0, "", 0, "LineageNPC2.TP_trumpet", 0.01, 12.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32381, 32381, "", 0, "", 0, "LineageNPC2.TP_clown_tall", 0.01, 26.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32382, 32382, "", 0, "", 0, "LineageNPC2.TP_wedding_maid", 0.01, 9.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32383, 32383, "", 0, "", 0, "LineageNPC2.TP_juggler", 0.01, 10.25, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32384, 32384, "", 0, "", 0, "LineageNPC2.TP_unicycler", 0.01, 10.25, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32385, 32385, "", 0, "", 0, "LineageNPC2.TP_acrobat_ball", 0.01, 20, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32386, 32386, "", 0, "", 0, "LineageNPC.pr_a_guard_FDarkelf", 0.01, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32387, 32387, "", 0, "", 0, "LineageNPC.pr_a_casino_FDarkElf", 0.01, 23, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32388, 32388, "", 0, "", 0, "LineageNPC.pr_a_trader_Fdarkelf", 0.01, 24.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32389, 32389, "", 0, "", 0, "LineageNPC.pr_a_teleporter_FDarkElf", 0.01, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32390, 32390, "", 0, "", 0, "LineageNPC.pr_a_common_people_FDarkElf", 0.01, 21.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32391, 32391, "", 0, "", 0, "LineageNPC.pr_e_guard_MDwarf", 0.01, 19, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32392, 32392, "", 0, "", 0, "LineageNPC.pr_a_warehouse_keeper_MDwarf", 0.01, 17, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32393, 32393, "", 0, "", 0, "LineageNPC.pr_e_traderA_FDwarf", 0.01, 18.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32394, 32394, "", 0, "", 0, "LineageNPC.pr_e_warehouse_keeper_FDwarf", 0.01, 18, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32395, 32395, "", 0, "", 0, "LineageNPC.pr_e_teleporter_FDwarf", 0.01, 21.3, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32396, 32396, "", 0, "", 0, "LineageNPC.pr_a_guard_MElf", 0.01, 23.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32397, 32397, "", 0, "", 0, "LineageNPC.pr_a_patriarch_MElf", 0.01, 22.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32398, 32398, "", 0, "", 0, "LineageNPC.pr_a_trader_FElf", 0.01, 24, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32399, 32399, "", 0, "", 0, "LineageNPC.pr_a_teleporter_FElf", 0.01, 23.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32400, 32400, "", 0, "", 0, "LineageNPC.pr_a_common_people_FElf", 0.01, 25.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32401, 32401, "", 0, "", 0, "LineageNPC.pr_e_guard_MOrc", 0.01, 27, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32402, 32402, "", 0, "", 0, "LineageNPC.pr_e_smith_MOrc", 0.01, 23.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32403, 32403, "", 0, "", 0, "LineageNPC.pr_e_patriarch_MOrc", 0.01, 26, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32404, 32404, "", 0, "", 0, "LineageNPC.pr_e_teleporter_FOrc", 0.01, 32, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32405, 32405, "", 0, "", 0, "LineageNPC.pr_a_mageguild_master_MHuman", 0.01, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32406, 32406, "", 0, "", 0, "LineageNPC.pr_a_mageguild_master_FHuman", 0.01, 23, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32407, 32407, "", 0, "", 0, "LineageNPC.pr_a_fighterguild_master_FHuman", 0.01, 21.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32408, 32408, "", 0, "", 0, "LineageNPC.pr_a_teleporter_FHuman", 0.01, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32409, 32409, "", 0, "", 0, "LineageMonster.pr_cutie_cat", 0.01, 15, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32410, 32410, "", 0, "", 0, "LineageMonster2.pr_baby_buffalo", 0.01, 15, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32411, 32411, "", 0, "", 0, "LineageMonster2.pr_baby_tiger", 0.01, 15.7, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32412, 32412, "", 0, "", 0, "LineageMonster2.pr_baby_ostrich", 0.01, 15, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32413, 32413, "", 0, "", 0, "LineageMonster.pr_yeti", 0.01, 27.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32414, 32414, "", 0, "", 0, "LineageNPC.pr_yeti_cute", 0.01, 10.8, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32415, 32415, "", 0, "", 0, "LineageNPC.pr_yeti_cute_r", 0.01, 10.8, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32416, 32416, "", 0, "", 0, "LineageMonster3.pr_unicorn_magnus", 0.01, 17, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32417, 32417, "", 0, "", 0, "LineageMonster.pr_blue_eye", 0.01, 16, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32418, 32418, "", 0, "", 0, "LineageMonster.pr_unicorn_mirage", 0.01, 17, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32419, 32419, "", 0, "", 0, "LineageMonster.pr_unicorn_boxer", 0.01, 18, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32420, 32420, "", 0, "", 0, "LineageMonster2.pr_angelic_unicorn", 0.01, 25.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32421, 32421, "", 0, "", 0, "LineageMonster.pr_silver_cat", 0.01, 15, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32422, 32422, "", 0, "", 0, "LineageMonster.pr_cat_the_cat", 0.01, 16, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32423, 32423, "", 0, "", 0, "LineageMonster2.pr_queen_of_cat", 0.01, 15, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32424, 32424, "Show Staff", 0, "", 0, "LineageNPC.sw_e_mine_teacher_FDwarf", 0.01, 18.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32425, 32425, "Show Staff", 0, "", 0, "LineageNPC.sw_e_smith_Fdwarf", 0.01, 17.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32426, 32426, "Show Staff", 0, "", 0, "LineageNPC.sw_e_traderB_FDwarf", 0.01, 18, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32427, 32427, "Show Staff", 0, "", 0, "LineageNPC.sw_e_collector_teacher_FDwarf", 0.01, 17.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32428, 32428, "Show Staff", 0, "", 0, "LineageNPC.pr_e_warehouse_keeper_FDwarf", 0.01, 18, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32429, 32429, "", 0, "", 0, "LineageMonster.sw_batur_orc_shaman", 0.01, 16, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 30, 0, 1), 
(32430, 32430, "", 0, "", 0, "LineageNPC.pr_e_teleporter_FDwarf", 0.01, 21.3, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32431, 32431, "Leyla Mira", 0, "Elf Singer", 0, "LineageNPC.pr_a_teleporter_FElf", 0.01, 23, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32432, 32432, "", 0, "", 0, "LineageNPC.pr_a_teleporter_FElf", 0.01, 23.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32433, 32433, "MC", 0, "", 0, "LineageNPC.pr_a_casino_MHuman", 0.01, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32437, 32437, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32438, 32438, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32439, 32439, "Backflip Expert", 0, "", 0, "LineageMonster.sw_ant_larva", 0.01, 8, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32440, 32440, "Backflip Originator", 0, "", 0, "LineageMonster.pr_harpy", 0.01, 42, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32441, 32441, "Backflip Superman", 0, "", 0, "LineageMonster2.pr_knight_of_shadow", 0.01, 35.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32442, 32442, "", 0, "", 0, "LineageNPC2.TP_juggler", 0.01, 10.25, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32443, 32443, "", 0, "", 0, "LineageNPC2.TP_unicycler", 0.01, 10.25, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32444, 32444, "", 0, "", 0, "LineageNPC2.TP_acrobat_ball", 0.01, 20, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32445, 32445, "", 0, "", 0, "LineageNPC2.TP_clown_tall", 0.01, 26.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32446, 32446, "", 0, "", 0, "LineageNPC2.TP_trumpet", 0.01, 12.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32447, 32447, "", 0, "", 0, "LineageMonster.pr_medusa", 0.01, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32448, 32448, "", 0, "", 0, "LineageMonster2.pr_vampire_witch", 0.01, 21.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32449, 32449, "", 0, "", 0, "LineageMonster2.pr_vampire_wizard", 0.01, 28, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32450, 32450, "", 0, "", 0, "LineageMonster3.pr_lidia_von_helmann", 0.01, 25.4, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32451, 32451, "", 0, "", 0, "LineageMonster.pr_cave_maiden", 0.01, 65, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32452, 32452, "", 0, "", 0, "LineageMonster3.pr_Succubus_Raid", 0.01, 30.7, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32453, 32453, "", 0, "", 0, "LineageMonster3.pr_Bloody_Queen_Raid", 0.01, 34, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32454, 32454, "", 0, "", 0, "LineageMonster4.pr_rah", 0.01, 40.6, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32455, 32455, "", 0, "", 0, "LineageMonster4.pr_tears", 0.01, 27.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32456, 32456, "", 0, "", 0, "LineageMonster.pr_succubus", 0.01, 36, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32457, 32457, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32458, 32458, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32464, 32464, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32465, 32465, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32466, 32466, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32467, 32467, "Teleportation Cubic", 0, "", 0, "LineageNPC.teleport_cube", 30, 65, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32468, 32468, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32469, 32469, "Eindburgh", 0, "Vice Hierarch", 0, "LineageNPC2.K_M1_elder", 17, 25, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 20, 160, 0, 1), 
(32470, 32470, "Stone Coffin", 0, "", 0, "LineageNpcEV.stone_coffin", 109, 11.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32471, 32471, "", 0, "", 0, "LineageNPC2.pr_K_F1_teleporter", 0.01, 23.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32472, 32472, "", 0, "", 0, "LineageNPC2.pr_K_F1_master", 0.01, 23, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32473, 32473, "", 0, "", 0, "LineageNPC2.pr_K_F1_guard_Master", 0.01, 22.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32474, 32474, "", 0, "", 0, "LineageNPC2.pr_k_hero_bowgun", 0.01, 23, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 40, 40, 0, 1), 
(32475, 32475, "Subclass Certification Helper", 0, "", 0, "LineageMonster3.king_of_cat", 6, 16.01, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 160, 160, 0, 1), 
(32476, 32476, "Employee of Magic Research Institute", 0, "Event manager", 0, "LineageNPC.e_smith_Fdwarf", 8, 17.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 313, 0, 0, 50, 120, 0, 1), 
(32477, 32477, "Volunteer", 0, "Gatekeeper Welfare Foundation", 0, "LineageNPC.a_teleporter_FHuman", 8, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32478, 32478, "Dimensional Merchant", 0, "", 0, "LineageNPC2.premium_master", 10, 23.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 60, 0, 1), 
(32479, 32479, "Adios", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 70, "male", "L2Guard", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 129, 102, 0, 50, 160, 0, 1), 
(32480, 32480, "Ronde", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 70, "male", "L2Guard", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 129, 102, 0, 50, 160, 0, 1), 
(32481, 32481, "Saige", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 70, "male", "L2Guard", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 129, 102, 0, 50, 160, 0, 1), 
(32482, 32482, "Emdrere", 0, "Guard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 70, "male", "L2Guard", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 129, 102, 0, 50, 160, 0, 1), 
(32483, 32483, "", 0, "", 0, "LineageNpcEV.kamaloka_obelisk", 16, 46, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32484, 32484, "Pathfinder Worker", 0, "", 0, "LineageNPC.a_mageguild_teacher_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32485, 32485, "Pathfinder Worker", 0, "", 0, "LineageNPC.a_mageguild_teacher_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32486, 32486, "Inventor Maru", 0, "", 0, "LineageNPC.e_collector_teacher_FDwarf", 8, 17.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32487, 32487, "Mark", 0, "", 0, "LineageNPC.a_fighterguild_teacher_MDarkElf_dead", 10, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32488, 32488, "Mark", 0, "", 0, "LineageNPC.a_fighterguild_teacher_MDarkElf", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32490, 32490, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32491, 32491, "Underground Coliseum Helper", 0, "", 0, "LineageNPC2.TP_battlezone_staff", 7.8, 17.29, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 60, 1, 0, 1), 
(32492, 32492, "Crystal Water Bottle", 0, "", 0, "LineageNPCEV.crystal_pint", 13, 14, 36, "female", "L2Chest", 40, 1, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32493, 32493, "Burning Brazier", 0, "", 0, "LineageNPCEV.blazing_brazier", 15, 11.5, 36, "female", "L2Chest", 40, 1, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32494, 32494, "Skull", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 61, "male", "L2Npc", 40, 1, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32495, 32495, "Treasure Box", 0, "", 0, "LineageNPC.coffer_d", 12, 9.5, 61, "etc", "L2Chest", 40, 1, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32496, 32496, "Escape Device", 0, "", 0, "LineageNPCEV.dark_obelisk", 15, 51.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32497, 32497, "Inspector Adler", 0, "", 0, "LineageNPC.a_mageguild_teacher_MElf", 7, 22.2, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32498, 32498, "Devil's Isle Survivor", 0, "", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32499, 32499, "Ketra Orc Shaman", 0, "", 0, "LineageMonster.ketra_orc_shaman_20_bi", 12, 27.6, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 10, 1, 0, 1), 
(32500, 32500, "Inspector Sinai", 0, "", 0, "LineageNPC.a_mageguild_teacher_FElf", 7, 22.2, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32501, 32501, "Devil's Isle Supporter", 0, "", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32502, 32502, "Ketra Orc Supporter", 0, "", 0, "LineageMonster.ketra_orc_shaman", 10, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 10, 1, 0, 1), 
(32503, 32503, "Entrance Manager", 0, "Kratei's Cube", 0, "LineageNPC.e_smith_master_MDwarf", 8, 16.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32504, 32504, "Match Manager", 0, "Kratei's Cube", 0, "LineageNPC.a_traderA_MDwarf", 8, 17, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32505, 32505, "Match Manager", 0, "Kratei's Cube", 0, "LineageNPC.a_traderA_MDwarf", 8, 17, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32506, 32506, "Match Manager", 0, "Kratei's Cube", 0, "LineageNPC.a_traderA_MDwarf", 8, 17, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32507, 32507, "Temple Inspector", 0, "", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32508, 32508, "Dwarf Adventurer", 0, "", 0, "LineageNPC.e_mine_teacher_MDwarf", 8, 18, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32509, 32509, "Ketra Orc Intelligence Officer", 0, "", 0, "LineageMonster.ketra_orc", 12, 29, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 45, 1, 0, 1), 
(32510, 32510, "Inspector Adler", 0, "", 0, "LineageNPC.a_mageguild_teacher_MElf", 7, 22.2, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32511, 32511, "Dwarf Adventurer", 0, "", 0, "LineageNPC.e_mine_teacher_MDwarf", 8, 18, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32512, 32512, "Ketra Orc Supporter", 0, "", 0, "LineageMonster2.ketra_orc_warlord", 12, 30, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 27, 1, 0, 1), 
(32513, 32513, "Kun", 0, "Entrance Manager", 0, "LineageNPC2.TP_battlezone_staff", 7.8, 17.29, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 60, 1, 0, 1), 
(32514, 32514, "Tarion", 0, "Entrance Manager", 0, "LineageNPC2.TP_battlezone_staff", 7.8, 17.29, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 60, 1, 0, 1), 
(32515, 32515, "Leo", 0, "Entrance Manager", 0, "LineageNPC2.TP_battlezone_staff", 7.8, 17.29, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 60, 1, 0, 1), 
(32516, 32516, "Candice", 0, "Entrance Manager", 0, "LineageNPC2.TP_battlezone_staff", 7.8, 17.29, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 60, 1, 0, 1), 
(32517, 32517, "Airship Controller", 0, "", 0, "LineageNpcEV.riding_control_unit", 19, 28, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32518, 32518, "Vortex Gate", 0, "Aerial Cleft", 0, "LineageNpcEV.war_gate", 300, 130, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32519, 32519, "Vortex Gate", 0, "Aerial Cleft", 0, "LineageNpcEV.war_gate", 300, 130, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32520, 32520, "Emery Converter", 0, "Aerial Cleft", 0, "LineageNPC.teleport_npc_sm", 7, 15, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32521, 32521, "Entrance Manager", 0, "Handy's Block Checker - Arena 1", 0, "LineageNPC.e_teleporter_FDwarf", 8, 21.3, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32522, 32522, "Entrance Manager", 0, "Handy's Block Checker - Arena 2", 0, "LineageNPC.e_teleporter_FDwarf", 8, 21.3, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32523, 32523, "Entrance Manager", 0, "Handy's Block Checker - Arena 3", 0, "LineageNPC.e_teleporter_FDwarf", 8, 21.3, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32524, 32524, "Entrance Manager", 0, "Handy's Block Checker - Arena 4", 0, "LineageNPC.e_teleporter_FDwarf", 8, 21.3, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32525, 32525, "Tiat", 0, "Witch of the Dragon of Darkness", 0, "LineageNPC2.tiat_oracle", 8, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 50, 0, 1), 
(32526, 32526, "Allenos", 0, "Sergeant", 0, "LineageNPC2.gracia_soldier", 11, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 13524, 13525, 0, 50, 160, 0, 1), 
(32527, 32527, "Edric", 0, "Officer", 0, "LineageNPC2.gracia_remnants_a", 9.5, 22.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 160, 0, 1), 
(32528, 32528, "Medibal's Corpse", 0, "", 0, "LineageNPC.a_mageguild_teacher_Mhuman_dead", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32529, 32529, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32530, 32530, "Tepios", 0, "Officer", 0, "LineageNPC2.gracia_soldier", 11, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 13524, 13525, 0, 50, 160, 0, 1), 
(32531, 32531, "Destroyed Tumor", 0, "", 0, "LineageNpcEV.tumor_immortality_a", 0.01, 55, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32532, 32532, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32533, 32533, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32534, 32534, "Jaedin", 0, "Guide of Infinity", 0, "LineageMonster4.disciple_silen", 19, 44, 70, "male", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 73, 170, 0, 1), 
(32535, 32535, "Destroyed Tumor", 0, "", 0, "LineageNpcEV.tumor_immortality_a", 42, 55, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32536, 32536, "Destroyed Tumor", 0, "", 0, "LineageNpcEV.tumor_immortality_a", 42, 55, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32537, 32537, "Mouth of Ekimus", 0, "", 0, "LineageNpcEV.mouth_immotality_a", 80, 14, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32538, 32538, "Closed Mouth of Ekimus", 0, "", 0, "LineageNpcEV.mouth_immotality", 80, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32539, 32539, "Gatekeeper of Abyss", 0, "", 0, "LineageNpcEV.vigil_immortality", 70, 119, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32540, 32540, "Gatekeeper of Abyss", 0, "", 0, "LineageNpcEV.vigil_immortality_dis", 70, 119, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32541, 32541, "Unstable Seed of Generation", 0, "", 0, "LineageNpcEV.life_seed", 57.75, 65.63, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32542, 32542, "Stabilized Seed of Generation", 0, "", 0, "LineageNpcEV.life_seed", 57.75, 65.63, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32543, 32543, "Energy of Generation", 0, "", 0, "LineageNPC.training_doll_150p", 13, 40, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32544, 32544, "Seed of Generation", 0, "Artificial", 0, "LineageNpcEV.artificial_life_seed", 57.75, 65.63, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32545, 32545, "Kurkle", 0, "Gracia Special Product Middleman", 0, "LineageNPC.training_doll_150p", 13, 40, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32546, 32546, "Asyatei", 0, "Soul Trader", 0, "LineageMonster4.death_scout_088p", 14.4, 22, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 45, 160, 0, 1), 
(32547, 32547, "Center Tumor", 0, "", 0, "LineageNpcEV.tumor_immortality_a_120p", 50.4, 65, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32548, 32548, "Keucereus", 0, "Admiral", 0, "LineageNPC2.xers", 12.5, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 160, 0, 1), 
(32549, 32549, "Dilios", 0, "General", 0, "LineageNPC2.dilios", 10, 21.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 160, 0, 1), 
(32550, 32550, "Kirklan", 0, "Special Product Broker", 0, "LineageNPC.a_traderA_MHuman", 10, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32551, 32551, "Noiless", 0, "Soldier", 0, "LineageNPC2.gracia_soldier", 11, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 13524, 13525, 0, 50, 160, 0, 1), 
(32552, 32552, "Tomaris", 0, "Soldier", 0, "LineageNPC2.gracia_soldier", 11, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 13524, 13525, 0, 50, 160, 0, 1), 
(32553, 32553, "Jisans", 0, "Soldier", 0, "LineageNPC2.gracia_soldier", 11, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 13524, 13525, 0, 50, 160, 0, 1), 
(32554, 32554, "Moira", 0, "Soldier", 0, "LineageNPC.a_fighterguild_master_FHuman", 8, 21.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 13524, 0, 0, 50, 100, 0, 1), 
(32555, 32555, "Tenius", 0, "Soldier", 0, "LineageNPC2.gracia_remnants_a", 9.5, 22.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 160, 0, 1), 
(32556, 32556, "El", 0, "Soldier", 0, "LineageNPC2.gracia_remnants_b", 9.5, 22.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 160, 0, 1), 
(32557, 32557, "Lekon", 0, "Engineer", 0, "LineageNPC.a_smith_MDwarf", 7, 16.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32558, 32558, "Barrier Orb", 0, "", 0, "LineageNpcEV.dark_clouds_crystal", 23, 37, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32559, 32559, "Artius", 0, "War Mage", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32560, 32560, "Orbyu", 0, "Soldier", 0, "LineageNPC2.gracia_soldier", 11, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 13524, 13525, 0, 50, 160, 0, 1), 
(32561, 32561, "Kunota", 0, "Soldier", 0, "LineageNPC2.gracia_soldier", 11, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 13524, 13525, 0, 50, 160, 0, 1), 
(32562, 32562, "Siest", 0, "Soldier", 0, "LineageNPC2.gracia_soldier", 11, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 13524, 13525, 0, 50, 160, 0, 1), 
(32563, 32563, "Plenos", 0, "Soldier", 0, "LineageNPC2.gracia_soldier", 11, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 13524, 13525, 0, 50, 160, 0, 1), 
(32564, 32564, "Papiku", 0, "Magister", 0, "LineageNPC.a_mageguild_teacher_FElf", 7, 21.2, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32565, 32565, "Felix", 0, "Master", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32566, 32566, "Ginby", 0, "Soldier", 0, "LineageNPC2.gracia_soldier", 11, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 13524, 13525, 0, 50, 160, 0, 1), 
(32567, 32567, "Lelrikia", 0, "Priest of Shilen", 0, "LineageNPC2.disciple_silen_b", 15.75, 25.73, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 160, 0, 1), 
(32568, 32568, "Unidentified Body", 0, "", 0, "LineageNPC.ssq_guard_MDwarf_death", 13, 19, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32569, 32569, "Cain", 0, "Priest", 0, "LineageNPC.a_sanctuary_teacher_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32570, 32570, "Eric", 0, "Herb Collector", 0, "LineageNPC.a_common_peopleA_MHuman", 8, 21.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32571, 32571, "Colin", 0, "Secret Agent", 0, "LineageNPC2.secret_agent_colin", 10, 22.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 50, 0, 1), 
(32572, 32572, "Frog", 0, "Great King", 0, "LineageMonster.poison_toad_100_bi", 40, 20, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32573, 32573, "Tess", 0, "Grandma", 0, "LineageNPC2.a_old_people_Fhuman", 9, 17.3, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 9, 34, 0, 1), 
(32574, 32574, "Kuta", 0, "Native", 0, "LineageNPC.a_common_peopleC_Mhuman", 10, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32575, 32575, "Light of Dawn", 0, "Teleporter", 0, "LineageNPC.teleport_npc_sm", 7, 15, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32576, 32576, "John", 0, "Captain of the Dawn", 0, "LineageMonster3.Kight_of_Dawn", 12, 24.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 36.48, 160, 0, 1), 
(32577, 32577, "Password Entry Device", 0, "", 0, "LineageNpcEV.ssq_identification", 35, 50, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32578, 32578, "Identity Confirm Device", 0, "", 0, "LineageNpcEV.ssq_code_input", 35, 50, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32579, 32579, "Darkness of Dawn", 0, "Teleporter", 0, "LineageNPC.teleport_npc_sm", 7, 15, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32580, 32580, "", 0, "", 0, "LineageNPC.camera_target_dummy", 11, 25, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 20, 0, 1), 
(32581, 32581, "", 0, "", 0, "LineageNPC.camera_target_dummy", 18, 50, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32582, 32582, "Jaina", 0, "Priest", 0, "LineageNPC.a_sanctuary_teacher_FHuman", 8, 22.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32583, 32583, "", 0, "", 0, "LineageNPC.camera_target_dummy", 11, 25, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 20, 0, 1), 
(32584, 32584, "Merchant of Mammon", 0, "", 0, "LineageNPC.black_market_trader_MDwarf_set", 22, 18, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32585, 32585, "Promise of Mammon", 0, "Teleporter", 0, "LineageNPC.teleport_npc_sm", 7, 15, 70, "etc", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32586, 32586, "Shunaiman", 0, "Emperor of Elmoreden", 0, "LineageNPC2.emperor_shuneimman", 15, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 50, 0, 1), 
(32587, 32587, "Leon", 0, "Emperor's Guard", 0, "LineageNPC2.guard_elmoaden", 15, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 50, 0, 1), 
(32588, 32588, "Emperor's Seal Device", 0, "", 0, "LineageNpcEV.orb_of_kaizer", 37, 49, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32589, 32589, "Emperor's Seal Device", 0, "", 0, "LineageNpcEV.orb_of_kaizer", 37, 49, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32590, 32590, "Emperor's Seal Device", 0, "", 0, "LineageNpcEV.orb_of_kaizer", 37, 49, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32591, 32591, "Emperor's Seal Device", 0, "", 0, "LineageNpcEV.orb_of_kaizer", 37, 49, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32592, 32592, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32593, 32593, "Wood", 0, "Priest", 0, "LineageNPC.a_mageguild_teacher_MHuman", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32594, 32594, "Leopard", 0, "Password Decoder", 0, "LineageNPC.a_guild_master_MDarkElf", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32595, 32595, "Lawrence", 0, "Great Teacher", 0, "LineageNPC.a_patriarch_MDarkElf", 6, 23.8, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32596, 32596, "Sophia", 0, "Library of Sages Director", 0, "LineageNPC.a_mageguild_teacher_FElf", 7, 21.2, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32597, 32597, "Franz", 0, "Witness of Dawn", 0, "LineageNPC2.leader_of_dawn_franz_abel", 12, 23.75, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 160, 0, 1), 
(32598, 32598, "Court Magician", 0, "Elmore-Aden's", 0, "LineageNPC.a_temple_master_Corpse", 8, 22.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 50, 0, 1), 
(32599, 32599, "Master Yogi", 0, "Mountain Ascetic", 0, "LineageNPC2.event_comic_masteryogy", 9, 16.7, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 160, 0, 1), 
(32600, 32600, "Alegria", 0, "Birthday Celebration Helper", 0, "LineageNPC2.event_birth_alegria", 5, 21, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 160, 0, 1), 
(32601, 32601, "Instant Moving Device", 0, "", 0, "LineageNpcEV.crystal_of_secret_door", 57, 74, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32602, 32602, "Temporary Teleporter", 0, "", 0, "LineageNpcEV.teleport_device", 16, 42, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32603, 32603, "Tepios", 0, "Officer", 0, "LineageNPC2.gracia_soldier", 11, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 13524, 13525, 0, 50, 160, 0, 1), 
(32604, 32604, "Airship Controller", 0, "", 0, "LineageNpcEV.riding_control_unit", 19, 28, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32605, 32605, "Airship Controller", 0, "", 0, "LineageNpcEV.riding_control_unit", 19, 28, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32606, 32606, "Airship Controller", 0, "", 0, "LineageNpcEV.riding_control_unit", 19, 28, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32607, 32607, "Airship Controller", 0, "", 0, "LineageNpcEV.riding_control_unit", 19, 28, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32608, 32608, "Airship Controller", 0, "", 0, "LineageNpcEV.riding_control_unit", 19, 28, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32609, 32609, "Airship Controller", 0, "", 0, "LineageNpcEV.riding_control_unit", 19, 28, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32610, 32610, "Olf Kanore", 0, "Weaver", 0, "LineageNPC.a_mageguild_teacher_MElf", 7, 22.2, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32611, 32611, "Tolonis", 0, "Officer", 0, "LineageNPC2.gracia_remnants_a", 9.5, 22.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 160, 0, 1), 
(32612, 32612, "Olf Adams", 0, "Weaver", 0, "LineageNPC.a_mageguild_teacher_MElf", 7, 22.2, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32613, 32613, "Handy", 0, "Game Manager", 0, "LineageNPC2.block_mother_staff", 12, 31, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 120, 120, 0, 1), 
(32614, 32614, "Lamcedas", 0, "Gatekeeper", 0, "LineageNPC.a_teleporter_FHuman", 8, 25, 70, "female", "L2Teleporter", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32615, 32615, "Ishuma", 0, "Maestro", 0, "LineageNPC.e_smith_master_MDwarf", 8, 16.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32616, 32616, "Mine", 0, "Fortune Teller", 0, "LineageNPC.a_casino_FDarkElf", 8, 23, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32617, 32617, "Jaina", 0, "Priest", 0, "LineageNPC.a_sanctuary_teacher_FHuman", 8, 22.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32618, 32618, "Thyimi", 0, "Trader", 0, "LineageNPC.e_warehouse_keeper_FDwarf", 7, 18, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32619, 32619, "", 0, "", 0, "LineageNPC2.gracia_soldier", 11, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 13524, 0, 0, 50, 160, 0, 1), 
(32620, 32620, "", 0, "", 0, "LineageNPC2.gracia_soldier", 11, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 13524, 13525, 0, 50, 160, 0, 1), 
(32621, 32621, "", 0, "", 0, "LineageNPC2.gracia_soldier", 11, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 13524, 13525, 0, 50, 160, 0, 1), 
(32622, 32622, "Anatole", 0, "Soldier", 0, "LineageNPC2.gracia_soldier", 11, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 160, 0, 1), 
(32623, 32623, "Morenki", 0, "Soldier", 0, "LineageNPC.a_fighterguild_teacher_MDarkElf", 8, 23, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32624, 32624, "Anbram", 0, "Soldier", 0, "LineageNPC2.gracia_soldier", 11, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 160, 0, 1), 
(32625, 32625, "Anciel", 0, "Soldier", 0, "LineageNPC.a_fighterguild_teacher_MElf", 7, 22.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32626, 32626, "Royal Guard", 0, "Soldier", 0, "LineageNPC2.gracia_soldier", 11, 25, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 13524, 13525, 0, 50, 160, 0, 1), 
(32627, 32627, "Nottingale", 0, "Wizard", 0, "LineageNPC.a_teleporter_FElf", 8.5, 23.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32628, 32628, "Wharf Patrol", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 94, 0, 0, 50, 120, 0, 1), 
(32629, 32629, "Wharf Patrol", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 94, 0, 0, 50, 120, 0, 1), 
(32630, 32630, "Gracia Server Helper", 0, "", 0, "LineageNPC2.message_event_master", 10, 20, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 160, 0, 1), 
(32631, 32631, "Gracia Server Proof Exchanger", 0, "", 0, "LineageNPC2.message_event_master", 10, 20, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 160, 0, 1), 
(32632, 32632, "Gracia Survivor", 0, "", 0, "LineageNPC2.gracia_remnants_a", 9.5, 22.5, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 160, 0, 1), 
(32633, 32633, "Cat of Christmas", 0, "Sharing happiness", 0, "LineageMonster.cutie_cat", 8, 15, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(32634, 32634, "Cat of Christmas", 0, "Sharing happiness", 0, "LineageMonster.cutie_cat", 8, 15, 70, "female", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 48, 140, 0, 1), 
(32635, 32635, "Master Dugi", 0, "Energy Recovery Event", 0, "LineageNPC2.event_comic_masteryogy", 9, 16.7, 75, "female", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 160, 0, 1), 
(32636, 32636, "Employee of Magic Research Institute", 0, "Event manager", 0, "LineageNPC.e_smith_Fdwarf", 8, 17.5, 75, "female", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 313, 0, 0, 50, 120, 0, 1), 
(32637, 32637, "Workshop Teleporter", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 50, 0, 1), 
(32638, 32638, "Roni the cat", 0, "PC Cafe Event", 0, "LineageMonster.cutie_cat", 8, 15, 75, "female", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 48, 120, 0, 1), 
(32639, 32639, "Pierre Baguette", 0, "April Fool's Day Event", 0, "LineageNPC.e_common_people_MDwarf", 8, 17, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32640, 32640, "Kintaijin", 0, "Bounty Hunter", 0, "LineageNPC.e_trader_MOrc", 8, 23.5, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32641, 32641, "Dr. Helvetica", 0, "", 0, "LineageNPC.a_smith_MDwarf", 7, 16.5, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 89, 0, 0, 50, 120, 0, 1), 
(32642, 32642, "Broken Golem Control Device", 0, "", 0, "LineageNpcEV.strange_mechanical_instrument", 16, 15.5, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32643, 32643, "Athenia", 0, "Priestess", 0, "LineageNPC.a_trader_FElf", 8, 24, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32644, 32644, "Piazza", 0, "Expert Summoner", 0, "LineageNPC.a_fighterguild_teacher_FElf", 8, 22.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32645, 32645, "Chandra", 0, "Transport Post", 0, "LineageNPC.e_mine_teacher_FDwarf", 8, 18.5, 80, "female", "L2Teleporter", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32646, 32646, "Katensa", 0, "Workman", 0, "LineageNPC.e_common_people_MDwarf", 8, 17, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32647, 32647, "Atra", 0, "Apprentice", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 135, 0, 0, 50, 120, 0, 1), 
(32648, 32648, "News Informer", 0, "", 0, "LineageNPC2.TP_game_staff", 5, 12.5, 80, "male", "L2Teleporter", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 75, 120, 0, 1), 
(32649, 32649, "Dwyph", 0, "Dwarf Adventurer", 0, "LineageNPC.e_mine_teacher_MDwarf", 8, 18, 80, "male", "L2Teleporter", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32650, 32650, "Kanemika", 0, "Grave Robber Leader", 0, "LineageMonster.wererat", 14, 25, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(32651, 32651, "Grave Robber Warrior", 0, "Quest Monster", 0, "LineageMonster.wererat", 14, 25, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(32652, 32652, "Teleport Crystal", 0, "", 0, "LineageNPC.teleport_cube_50p", 30, 32.5, 80, "etc", "L2Teleporter", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32653, 32653, "Krun", 0, "", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 80, "male", "L2Teleporter", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32654, 32654, "Tarun", 0, "", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 80, "male", "L2Teleporter", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32655, 32655, "Chairen", 0, "", 0, "LineageNPC.e_mageguild_teacher_FOrc", 8, 28, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32656, 32656, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 20, 0, 1), 
(32657, 32657, "Disciple's Gatekeeper", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32658, 32658, "Guardian of Eastern Seal", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32659, 32659, "Guardian of Western Seal", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32660, 32660, "Guardian of Southern Seal", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32661, 32661, "Guardian of Northern Seal", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32662, 32662, "Guardian of Great Seal", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32663, 32663, "Guardian of Tower of Seal", 0, "", 0, "LineageNPC.teleport_npc_sm", 7, 15, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32664, 32664, "Delusion Manager", 0, "", 0, "LineageNpcEV.shelter_of_dream_menager", 25, 47.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32665, 32665, "Delusion Manager", 0, "", 0, "LineageNpcEV.shelter_of_dream_menager", 25, 47.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32666, 32666, "Delusion Manager", 0, "", 0, "LineageNpcEV.shelter_of_dream_menager", 25, 47.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32667, 32667, "Delusion Manager", 0, "", 0, "LineageNpcEV.shelter_of_dream_menager", 25, 47.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32668, 32668, "Delusion Manager", 0, "", 0, "LineageNpcEV.shelter_of_dream_menager", 25, 47.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32669, 32669, "Delusion Manager", 0, "", 0, "LineageNpcEV.shelter_of_dream_menager", 25, 47.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32670, 32670, "Delusion Manager", 0, "", 0, "LineageNpcEV.shelter_of_dream_menager", 25, 47.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32671, 32671, "Delusion Manager", 0, "", 0, "LineageNpcEV.shelter_of_dream_menager", 25, 47.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32672, 32672, "Delusion Manager", 0, "", 0, "LineageNpcEV.shelter_of_dream_menager", 25, 47.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32673, 32673, "Delusion Manager", 0, "", 0, "LineageNpcEV.shelter_of_dream_menager", 25, 47.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32674, 32674, "Delusion Manager", 0, "", 0, "LineageNpcEV.shelter_of_dream_menager", 25, 47.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32675, 32675, "Delusion Manager", 0, "", 0, "LineageNpcEV.shelter_of_dream_menager", 25, 47.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32676, 32676, "Delusion Manager", 0, "", 0, "LineageNpcEV.shelter_of_dream_menager", 25, 47.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32677, 32677, "Delusion Manager", 0, "", 0, "LineageNpcEV.shelter_of_dream_menager", 25, 47.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32678, 32678, "Delusion Manager", 0, "", 0, "LineageNpcEV.shelter_of_dream_menager", 25, 47.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32679, 32679, "Delusion Manager", 0, "", 0, "LineageNpcEV.shelter_of_dream_menager", 25, 47.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32680, 32680, "Delusion Manager", 0, "", 0, "LineageNpcEV.shelter_of_dream_menager", 25, 47.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32681, 32681, "Delusion Manager", 0, "", 0, "LineageNpcEV.shelter_of_dream_menager", 25, 47.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32682, 32682, "Delusion Manager", 0, "", 0, "LineageNpcEV.shelter_of_dream_menager", 25, 47.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32683, 32683, "Delusion Manager", 0, "", 0, "LineageNpcEV.shelter_of_dream_menager", 25, 47.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32684, 32684, "Delusion Manager", 0, "", 0, "LineageNpcEV.shelter_of_dream_menager", 25, 47.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32685, 32685, "Delusion Manager", 0, "", 0, "LineageNpcEV.shelter_of_dream_menager", 25, 47.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32686, 32686, "Delusion Manager", 0, "", 0, "LineageNpcEV.shelter_of_dream_menager", 25, 47.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32687, 32687, "Delusion Manager", 0, "", 0, "LineageNpcEV.shelter_of_dream_menager", 25, 47.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32688, 32688, "Delusion Manager", 0, "", 0, "LineageNpcEV.shelter_of_dream_menager", 25, 47.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32689, 32689, "Delusion Manager", 0, "", 0, "LineageNpcEV.shelter_of_dream_menager", 25, 47.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32690, 32690, "Delusion Manager", 0, "", 0, "LineageNpcEV.shelter_of_dream_menager", 25, 47.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32691, 32691, "Delusion Manager", 0, "", 0, "LineageNpcEV.shelter_of_dream_menager", 25, 47.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32692, 32692, "Delusion Manager", 0, "", 0, "LineageNpcEV.shelter_of_dream_menager", 25, 47.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32693, 32693, "Delusion Manager", 0, "", 0, "LineageNpcEV.shelter_of_dream_menager", 25, 47.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32694, 32694, "Delusion Manager", 0, "", 0, "LineageNpcEV.shelter_of_dream_menager", 25, 47.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32695, 32695, "Delusion Manager", 0, "", 0, "LineageNpcEV.shelter_of_dream_menager", 25, 47.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32696, 32696, "Delusion Manager", 0, "", 0, "LineageNpcEV.shelter_of_dream_menager", 25, 47.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32697, 32697, "Delusion Manager", 0, "", 0, "LineageNpcEV.shelter_of_dream_menager", 25, 47.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32698, 32698, "Delusion Manager", 0, "", 0, "LineageNpcEV.shelter_of_dream_menager", 25, 47.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32699, 32699, "Delusion Manager", 0, "", 0, "LineageNpcEV.shelter_of_dream_menager", 25, 47.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32700, 32700, "Delusion Manager", 0, "", 0, "LineageNpcEV.shelter_of_dream_menager", 25, 47.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32701, 32701, "Delusion Manager", 0, "", 0, "LineageNpcEV.shelter_of_dream_menager", 25, 47.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32702, 32702, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32703, 32703, "", 0, "", 0, "LineageNPC.clear_npc", 0.1, 0.1, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32704, 32704, "Somulitan", 0, "Soul Fragment Annex", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32705, 32705, "Zaken's Candle", 0, "", 0, "LineageNpcEV.oak_candle", 8, 13.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32706, 32706, "Lucien's Altar", 0, "", 0, "LineageNpcEV.altar_of_lucien", 90, 38.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32707, 32707, "Lucien's Altar", 0, "", 0, "LineageNpcEV.altar_of_lucien", 90, 38.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32708, 32708, "Lucien's Altar", 0, "", 0, "LineageNpcEV.altar_of_lucien", 90, 38.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32709, 32709, "Lucien's Altar", 0, "", 0, "LineageNpcEV.altar_of_lucien", 90, 38.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32710, 32710, "Lucien's Altar", 0, "", 0, "LineageNpcEV.altar_of_lucien", 90, 38.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32711, 32711, "Droph", 0, "Dwarf Adventurer", 0, "LineageNPC.e_mine_teacher_MDwarf", 8, 18, 80, "male", "L2Teleporter", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32712, 32712, "Somulitan", 0, "Zaken Researcher", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 80, "male", "L2Teleporter", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32713, 32713, "Pathfinder Worker", 0, "", 0, "LineageNPC.a_mageguild_teacher_MHuman", 8, 23, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(32714, 32714, "Asher", 0, "Gatekeeper", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 80, "male", "L2Teleporter", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32715, 32715, "Lilith", 0, "Holy Mother of Abyss", 0, "LineageMonster2.lilith", 42.5, 55, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 45, 200, 0, 1), 
(32716, 32716, "Lilith's Steward", 0, "", 0, "LineageMonster2.lilim_wizard", 9, 34, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 190, 0, 1), 
(32717, 32717, "Lilith's Elite", 0, "", 0, "LineageMonster2.lilim_knight", 12, 50, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 5800, 5799, 0, 56, 220, 0, 1), 
(32718, 32718, "Anakim", 0, "Flames of Sacred Fire", 0, "LineageMonster2.anakim", 15.5, 29, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 45, 200, 0, 1), 
(32719, 32719, "Anakim's Guardian", 0, "", 0, "LineageMonster2.nephilim_priest", 23, 40.5, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 190, 0, 1), 
(32720, 32720, "Anakim's Guard", 0, "", 0, "LineageMonster2.nephilim_lord", 12, 43, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 65, 220, 0, 1), 
(32721, 32721, "Anakim's Executor", 0, "", 0, "LineageMonster2.nephilim_slayer", 12, 36, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 65, 190, 0, 1), 
(32722, 32722, "Battle League Helper", 0, "", 0, "LineageNPC2.TP_game_staff", 5, 12.5, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 75, 120, 0, 1), 
(32723, 32723, "", 0, "", 0, "LineageNPC.camera_target_dummy_a", 0.1, 0.1, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32724, 32724, "", 0, "", 0, "LineageNPC.camera_target_dummy_a", 0.1, 0.1, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32725, 32725, "Priest of Resurrection", 0, "", 0, "LineageNPC2.eva", 13, 26.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 50, 0, 1), 
(32726, 32726, "Dr. Ice", 0, "Event manager", 0, "LineageNPC.e_teleporter_FDwarf", 8, 21.3, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32727, 32727, "Puss the Cat", 0, "Event manager", 0, "LineageMonster.cat_the_cat", 9, 16, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(32728, 32728, "Heavenly Bridge Keeper", 0, "Event manager", 0, "LineageNPC.a_traderA_MDwarf", 8, 17, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32729, 32729, "", 0, "", 0, "LineageNpcEV.Kerthang_sign_A", 0.1, 152, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32730, 32730, "", 0, "", 0, "LineageNpcEV.Kerthang_sign_B", 0.1, 365, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32731, 32731, "Hardin", 0, "", 0, "LineageNPC.a_hardin_MHuman", 8, 22.5, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32732, 32732, "Sixth Anniversary Party Manager", 0, "Event manager", 0, "LineageNPC2.event_birth_alegria", 5, 21, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 160, 0, 1), 
(32733, 32733, "Kbaldir", 0, "Commander", 0, "LineageNpc2.gracia_ocommander_1hs", 15, 27.5, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 57, 180, 0, 1), 
(32734, 32734, "Klemis", 0, "Officer", 0, "LineageNpc2.gracia_meofficer_1hs", 9, 23.5, 80, "male", "L2Teleporter", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 180, 0, 1), 
(32735, 32735, "Nemo", 0, "", 0, "LineageNPC.a_hardins_pupil_MHuman", 8, 23, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 13465, 0, 0, 50, 100, 0, 1), 
(32736, 32736, "Ermian", 0, "General", 0, "LineageNPC2.dilios", 10, 21.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 160, 0, 1), 
(32737, 32737, "Seyo", 0, "", 0, "LineageNPC.a_traderB_MHuman", 8, 25, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32738, 32738, "Injured Soldier", 0, "", 0, "LineageMonster5.glacia_tired_soldier", 7, 22, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 40, 120, 0, 1), 
(32739, 32739, "Bomona", 0, "", 0, "LineageNPC.a_hardins_pupil_FHuman", 8, 23, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(32740, 32740, "Batracos", 0, "Gatekeeper", 0, "LineageMonster5.tantaar_lizardman_sorcerer", 29, 44, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 75, 150, 0, 1), 
(32741, 32741, "Ankumi", 0, "Researcher", 0, "LineageNPC.e_collector_teacher_FDwarf", 8, 17.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32742, 32742, "Laki", 0, "Investigator", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 28, 160, 0, 1), 
(32743, 32743, "Sally", 0, "Investigator", 0, "LineageNPC.e_trader_FOrc", 8, 24, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32744, 32744, "Johnny", 0, "Chief Investigator", 0, "LineageNPC.a_hardins_pupil_MHuman", 8, 23, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32745, 32745, "Teleport Device", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32746, 32746, "Teleport Device", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32747, 32747, "Teleport Device", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32748, 32748, "Teleport Device", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32749, 32749, "Teleport Device", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32750, 32750, "Teleport Device", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32751, 32751, "Teleport Device", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32752, 32752, "Teleport Device", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32753, 32753, "Floor Teleport Device", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32754, 32754, "Floor Teleport Device", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32755, 32755, "Floor Teleport Device", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32756, 32756, "Floor Teleport Device", 0, "", 0, "LineageNpcEV.trioll_altar", 9, 33.5, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32757, 32757, "Greymore", 0, "Priest", 0, "LineageNPC.a_temple_master_Mhuman", 8, 22.5, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32758, 32758, "Sumiel", 0, "Treasure Seeker", 0, "LineageMonster5.solina_old_brother_cleaner", 15, 30, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 40, 120, 0, 1), 
(32759, 32759, "Gumiel", 0, "Treasure Seeker", 0, "LineageMonster5.solina_old_brother_cleaner", 15, 30, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 40, 120, 0, 1), 
(32760, 32760, "Jinia", 0, "", 0, "LineageMonster5.guildmaster_jinia", 11, 23.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 40, 120, 0, 1), 
(32761, 32761, "Kegor", 0, "", 0, "LineageMonster5.swordmaster_kegor", 15, 27.5, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 40, 120, 0, 1), 
(32762, 32762, "Sirra", 0, "", 0, "LineageMonster5.human_sirr", 10, 22, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 40, 120, 0, 1), 
(32763, 32763, "Sirra", 0, "Ice Fairy", 0, "LineageMonster3.ice_fairy", 16, 35.6, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 30, 250, 0, 1), 
(32764, 32764, "", 0, "", 0, "LineageNPC.camera_target_dummy_a", 0.1, 0.1, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(32765, 32765, "Box of Doubt", 0, "", 0, "LineageNPC.box", 18, 14, 80, "etc", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32766, 32766, "Ilvenis", 0, "Soldier", 0, "LineageNPC2.gracia_soldier", 11, 25, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 13524, 13525, 0, 50, 160, 0, 1), 
(32767, 32767, "McLaren", 0, "Soldier", 0, "LineageNpc2.gracia_feofficer_bowgun", 8, 23, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 34, 180, 0, 1), 
(32768, 32768, "Kelleyia", 0, "", 0, "LineageNPC.a_common_peopleC_Fhuman", 8, 22.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32769, 32769, "Corpse of Gracia Soldier", 0, "", 0, "LineageNpc2.gracia_fsoldier_corpse", 15, 23, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32770, 32770, "Corpse of Gracia Soldier", 0, "", 0, "LineageNpc2.gracia_feofficer_corpse", 15, 23, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32771, 32771, "Corpse of Gracia Soldier", 0, "", 0, "LineageNpc2.gracia_meofficer_corpse", 15, 23.5, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32772, 32772, "Corpse of Gracia Soldier", 0, "", 0, "LineageNpc2.gracia_ocommander_corpse", 25, 27.5, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32773, 32773, "Jakan", 0, "Officer", 0, "LineageNpc2.gracia_ocommander_pole", 15, 27.5, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 43, 180, 0, 1), 
(32774, 32774, "Elmina", 0, "Soldier", 0, "LineageNpc2.gracia_fsoldier_1hs", 8, 23, 80, "female", "L2Teleporter", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 48, 180, 0, 1), 
(32775, 32775, "Gracia Soldier", 0, "", 0, "LineageNPC2.gracia_remnants_a", 9.5, 22.5, 80, "female", "L2TerrainObject", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 160, 0, 1), 
(32776, 32776, "Gracia Soldier", 0, "", 0, "LineageNPC2.gracia_remnants_b", 9.5, 22.5, 80, "female", "L2TerrainObject", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 160, 0, 1), 
(32777, 32777, "Battalion Leader", 0, "Jinia Guild", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 80, 641, 0, 30, 160, 0, 1), 
(32778, 32778, "Legionnaire", 0, "Jinia Guild", 0, "LineageNPC2.officer_of_insurgents_orc", 14.5, 30, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 9813, 9813, 0, 40, 120, 0, 1), 
(32779, 32779, "Airship Controller", 0, "", 0, "LineageNpcEV.riding_control_unit_c", 19, 28, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32780, 32780, "Aquilani", 0, "", 0, "LineageNPC.a_temple_teacher_Mhuman", 8, 23, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32781, 32781, "Jinia", 0, "", 0, "LineageMonster5.guildmaster_jinia", 11, 23.5, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 40, 120, 0, 1), 
(32782, 32782, "Lionel", 0, "Transmitter", 0, "LineageNpcEV.riding_control_unit", 19, 28, 80, "female", "L2Teleporter", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(32783, 32783, "Priest of Blessing", 0, "", 0, "LineageNPC.a_temple_master_Mhuman", 8, 22.5, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32784, 32784, "Elcadia", 0, "Abyssal Saintess", 0, "LineageNpc2.elcardia", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32785, 32785, "Elcadia", 0, "Abyssal Saintess", 0, "LineageNpc2.elcardia", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32786, 32786, "Elcadia", 0, "Abyssal Saintess", 0, "LineageNpc2.elcardia", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32787, 32787, "Elcadia", 0, "Abyssal Saintess", 0, "LineageNpc2.elcardia", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32788, 32788, "Elcadia", 0, "Abyssal Saintess", 0, "LineageNpc2.elcardia", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32789, 32789, "Elcadia", 0, "Abyssal Saintess", 0, "LineageNpc2.elcardia", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32790, 32790, "Elcadia", 0, "Abyssal Saintess", 0, "LineageNpc2.elcardia", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32791, 32791, "Elcadia", 0, "Abyssal Saintess", 0, "LineageNpc2.elcardia", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32792, 32792, "Eris's Evil Thoughts", 0, "Director", 0, "LineageNpc2.elyss_the_silent", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32793, 32793, "Solina's Evil Thoughts", 0, "Saintess of Elmore-Aden", 0, "LineageNpc2.solina_the_saint", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32794, 32794, "Solina", 0, "Saintess of Elmore-Aden", 0, "LineageNpc2.solina_the_saint", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32795, 32795, "Eris", 0, "Solina's Disciple", 0, "LineageNpc2.elyss_the_silent", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32796, 32796, "Anais", 0, "Solina's Disciple", 0, "LineageNpc2.officiating_minister", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32797, 32797, "Jude van Etina", 0, "Solina's Disciple", 0, "LineageNpc2.udit_van_etina", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32798, 32798, "Elcadia", 0, "Abyssal Saintess", 0, "LineageNpc2.elcardia", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32799, 32799, "Hardin", 0, "Grand Wizard", 0, "LineageNPC.a_hardin_MHuman", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32800, 32800, "Frikios", 0, "Guide of Revelation", 0, "LineageNpc2.frikios", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32801, 32801, "Solina Bodyguard", 0, "Solina's Guard", 0, "LineageNpc2.nephilim_knight", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32802, 32802, "Solina Bodyguard", 0, "Solina's Guard", 0, "LineageNpc2.nephilim_knight_off", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32803, 32803, "Relic Guardian", 0, "", 0, "LineageNpc2.nephilim_knight", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32804, 32804, "Relic Watcher", 0, "", 0, "LineageNpc2.nephilim_knight_off", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32805, 32805, "Relic Watcher", 0, "", 0, "LineageNpc2.nephilim_knight_off", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32806, 32806, "Relic Watcher", 0, "", 0, "LineageNpc2.nephilim_knight_off", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32807, 32807, "Relic Watcher", 0, "", 0, "LineageNpc2.nephilim_knight_off", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32808, 32808, "Etis van Etina", 0, "Head of the Embryo", 0, "LineageMonster6.etis_van_etina", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32809, 32809, "Pile of Books", 0, "", 0, "LineageNPC.camera_target_dummy", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32810, 32810, "Pile of Books", 0, "", 0, "LineageNPC.camera_target_dummy", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32811, 32811, "Pile of Books", 0, "", 0, "LineageNPC.camera_target_dummy", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32812, 32812, "Pile of Books", 0, "", 0, "LineageNPC.camera_target_dummy", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32813, 32813, "Pile of Books", 0, "", 0, "LineageNPC.camera_target_dummy", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32814, 32814, "Pile of Books", 0, "", 0, "LineageNPC.camera_target_dummy", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32815, 32815, "Odd Globe", 0, "", 0, "LineageNPC.camera_target_dummy", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32816, 32816, "Teleport Control Device", 0, "", 0, "LineageNPC.camera_target_dummy", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32817, 32817, "Teleport Control Device", 0, "", 0, "LineageNPC.camera_target_dummy", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32818, 32818, "Teleport Control Device", 0, "", 0, "LineageNPC.camera_target_dummy", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32819, 32819, "Teleport Control Device", 0, "", 0, "LineageNPC.camera_target_dummy", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32820, 32820, "Teleport Control Device", 0, "", 0, "LineageNPC.camera_target_dummy", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32821, 32821, "Reading Desk", 0, "", 0, "LineageNPC.camera_target_dummy", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32822, 32822, "Reading Desk", 0, "", 0, "LineageNPC.camera_target_dummy", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32823, 32823, "Reading Desk", 0, "", 0, "LineageNPC.camera_target_dummy", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32824, 32824, "Reading Desk", 0, "", 0, "LineageNPC.camera_target_dummy", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32825, 32825, "Reading Desk", 0, "", 0, "LineageNPC.camera_target_dummy", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32826, 32826, "Reading Desk", 0, "", 0, "LineageNPC.camera_target_dummy", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32827, 32827, "Reading Desk", 0, "", 0, "LineageNPC.camera_target_dummy", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32828, 32828, "Reading Desk", 0, "", 0, "LineageNPC.camera_target_dummy", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32829, 32829, "Reading Desk", 0, "", 0, "LineageNPC.camera_target_dummy", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32830, 32830, "Reading Desk", 0, "", 0, "LineageNPC.camera_target_dummy", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32831, 32831, "Reading Desk", 0, "", 0, "LineageNPC.camera_target_dummy", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32832, 32832, "Reading Desk", 0, "", 0, "LineageNPC.camera_target_dummy", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32833, 32833, "Reading Desk", 0, "", 0, "LineageNPC.camera_target_dummy", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32834, 32834, "Reading Desk", 0, "", 0, "LineageNPC.camera_target_dummy", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32835, 32835, "Reading Desk", 0, "", 0, "LineageNPC.camera_target_dummy", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32836, 32836, "Reading Desk", 0, "", 0, "LineageNPC.camera_target_dummy", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32837, 32837, "Teleport Control Device", 0, "", 0, "LineageNPC.camera_target_dummy", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32838, 32838, "Powerful Device", 0, "", 0, "LineageNpcEV.ssq2_stick_main", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32839, 32839, "Powerful Device", 0, "", 0, "LineageNpcEV.ssq2_stick_main", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32840, 32840, "Powerful Device", 0, "", 0, "LineageNpcEV.ssq2_stick_main", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32841, 32841, "Powerful Device", 0, "", 0, "LineageNpcEV.ssq2_stick_main", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32842, 32842, "Teleport Control Device", 0, "", 0, "LineageNPC.camera_target_dummy", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32843, 32843, "Tomb of the Saintess", 0, "", 0, "LineageNPC.camera_target_dummy", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32844, 32844, "Teleport Control Device", 0, "", 0, "LineageNPC.camera_target_dummy", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32845, 32845, "Treasure Chest", 0, "", 0, "LineageMonster5.bounded_mimic", 25, 35, 80, "male", "L2Monster", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32846, 32846, "Treasure Chest", 0, "", 0, "LineageMonster5.bounded_mimic", 25, 35, 80, "male", "L2Monster", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32847, 32847, "Treasure Chest", 0, "", 0, "LineageMonster5.bounded_mimic", 25, 35, 80, "male", "L2Monster", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32848, 32848, "Treasure Chest", 0, "", 0, "LineageMonster5.bounded_mimic", 25, 35, 80, "male", "L2Monster", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32849, 32849, "Treasure Chest", 0, "", 0, "LineageMonster5.bounded_mimic", 25, 35, 80, "male", "L2Monster", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32850, 32850, "Treasure Chest", 0, "", 0, "LineageMonster5.bounded_mimic", 25, 35, 80, "male", "L2Monster", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32851, 32851, "Treasure Chest", 0, "", 0, "LineageMonster5.bounded_mimic", 25, 35, 80, "male", "L2Monster", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32852, 32852, "Treasure Chest", 0, "", 0, "LineageMonster5.bounded_mimic", 25, 35, 80, "male", "L2Monster", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32853, 32853, "Altar of Hallows", 0, "", 0, "LineageMonster5.bounded_mimic", 25, 35, 80, "male", "L2Monster", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32854, 32854, "Altar of Hallows", 0, "", 0, "LineageMonster5.bounded_mimic", 25, 35, 80, "male", "L2Monster", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32855, 32855, "Altar of Hallows", 0, "", 0, "LineageMonster5.bounded_mimic", 25, 35, 80, "male", "L2Monster", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32856, 32856, "Altar of Hallows", 0, "", 0, "LineageMonster5.bounded_mimic", 25, 35, 80, "male", "L2Monster", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32857, 32857, "Altar of Hallows", 0, "", 0, "LineageNpcEV.staff_altar", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32858, 32858, "Altar of Hallows", 0, "", 0, "LineageNpcEV.sword_altar", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32859, 32859, "Altar of Hallows", 0, "", 0, "LineageNpcEV.book_altar", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32860, 32860, "Altar of Hallows", 0, "", 0, "LineageNpcEV.shield_altar", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32861, 32861, "Sophia", 0, "Library Director of Saints", 0, "LineageNPC.a_mageguild_teacher_FElf", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32862, 32862, "Gruff-looking Man", 0, "", 0, "LineageNPC.a_mageguild_teacher_MDarkElf", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32863, 32863, "Sophia", 0, "Library Director of Saints", 0, "LineageNPC.a_mageguild_teacher_FElf", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32864, 32864, "Separated Soul", 0, "", 0, "LineageNPC.a_temple_master_Mhuman", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32865, 32865, "Separated Soul", 0, "", 0, "LineageNPC.a_temple_master_Mhuman", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32866, 32866, "Separated Soul", 0, "", 0, "LineageNPC.a_temple_master_Mhuman", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32867, 32867, "Separated Soul", 0, "", 0, "LineageNPC.a_temple_master_Mhuman", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32868, 32868, "Separated Soul", 0, "", 0, "LineageNPC.a_temple_master_Mhuman", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32869, 32869, "Separated Soul", 0, "", 0, "LineageNPC.a_temple_master_Mhuman", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32870, 32870, "Separated Soul", 0, "", 0, "LineageNPC.a_temple_master_Mhuman", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32871, 32871, "Dragon Vortex", 0, "", 0, "LineageNPC.collision_dummy_dragon", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32872, 32872, "Tightly Shut Door", 0, "", 0, "LineageNPC.camera_target_dummy", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32873, 32873, "Cracked Wall", 0, "", 0, "LineageNPC.camera_target_dummy", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32874, 32874, "Lyann", 0, "Recipe Merchant", 0, "LineageNPC.e_traderA_FDwarf", 7, 18.5, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32875, 32875, "Tahoo", 0, "Recipe Merchant", 0, "LineageNPC.a_traderA_MDwarf", 8, 17, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32876, 32876, "Desian", 0, "Recipe Merchant", 0, "LineageNPC.e_traderB_FDwarf", 7, 18, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32877, 32877, "Plani", 0, "Recipe Merchant", 0, "LineageNPC.e_collector_teacher_FDwarf", 8, 17.5, 70, "female", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32878, 32878, "Sparky", 0, "Recipe Merchant", 0, "LineageNPC.e_collector_teacher_MDwarf", 8, 17.5, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32879, 32879, "Drawin", 0, "Recipe Merchant", 0, "LineageNPC.a_traderA_MDwarf", 8, 17, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32880, 32880, "Dolphren", 0, "Recipe Merchant", 0, "LineageNPC.e_traderB_MDwarf", 8, 17.5, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32881, 32881, "Denver", 0, "Recipe Merchant", 0, "LineageNPC.e_collector_master_MDwarf", 8, 18.4, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32882, 32882, "Prouse", 0, "Recipe Merchant", 0, "LineageNPC.e_traderA_master_MDwarf", 8, 18, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32883, 32883, "Hedinger", 0, "Recipe Merchant", 0, "LineageNPC.e_traderB_master_MDwarf", 8, 17, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32884, 32884, "Drake Lord", 0, "", 0, "LineageMonster6.corpse_transform_clodecus", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32885, 32885, "Behemoth Leader", 0, "", 0, "LineageMonster3.corpse_antaras_ex_a", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32886, 32886, "Dragon Beast", 0, "", 0, "LineageMonster.corpse_kaim_vanul_50_bi", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32887, 32887, "Metar", 0, "Recipe Merchant", 0, "LineageNPC.e_traderB_master_MDwarf", 8, 17, 70, "male", "L2Merchant", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(32888, 32888, "Jude van Etina's Evil Thoughts", 0, "Solina's Disciple", 0, "LineageNpc2.udit_van_etina", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32889, 32889, "Jude van Etina's Evil Thoughts", 0, "Solina's Disciple", 0, "LineageNpc2.udit_van_etina", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32890, 32890, "Ruiman", 0, "Warehouse Keeper of the Valley", 0, "LineageNPC.e_warehouse_master_MDwarf", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(32891, 32891, "Separated Soul", 0, "", 0, "LineageNPC.a_temple_master_Mhuman", 25, 35, 80, "male", "L2Npc", 40, 2444, 2444, 0, 0, 10, 10, 10, 10, 10, 10, 0, 0, 500, 500, 500, 500, 278, 1, 333, 0, 0, 0, 60, 160, 0, 1), 
(35010, 35010, "Mercenary", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 67, "male", "L2Defender", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 449, 1, 624.93199, 281.55251, 426.74754, 206.02791, 253, 4, 333, 128, 628, 0, 50, 195, 0, 1), 
(35011, 35011, "Mercenary", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 67, "male", "L2Defender", 80, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 449, 1, 624.93199, 281.55251, 426.74754, 206.02791, 253, 4, 333, 93, 0, 0, 50, 195, 0, 1), 
(35012, 35012, "Mercenary", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 67, "male", "L2Defender", 1100, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 449, 1, 624.93199, 281.55251, 426.74754, 206.02791, 253, 8, 333, 280, 0, 0, 50, 195, 0, 1), 
(35013, 35013, "Mercenary", 0, "", 0, "LineageNPC.a_mageguild_teacher_FHuman", 8, 23.5, 67, "female", "L2Defender", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 449, 1, 624.93199, 281.55251, 426.74754, 206.02791, 253, 1, 333, 316, 0, 0, 50, 195, 0, 1), 
(35014, 35014, "Mercenary", 0, "", 0, "LineageNPC.a_mageguild_teacher_MHuman", 8, 23, 67, "male", "L2Defender", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 449, 1, 624.93199, 281.55251, 426.74754, 206.02791, 253, 1, 333, 179, 0, 0, 50, 195, 0, 1), 
(35015, 35015, "Mercenary", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 67, "male", "L2Defender", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 449, 1, 624.93199, 281.55251, 426.74754, 206.02791, 253, 4, 333, 128, 628, 0, 50, 195, 0, 1), 
(35016, 35016, "Mercenary", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 67, "male", "L2Defender", 80, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 449, 1, 624.93199, 281.55251, 426.74754, 206.02791, 253, 4, 333, 93, 0, 0, 50, 195, 0, 1), 
(35017, 35017, "Mercenary", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 67, "male", "L2Defender", 1100, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 449, 1, 624.93199, 281.55251, 426.74754, 206.02791, 253, 8, 333, 280, 0, 0, 50, 195, 0, 1), 
(35018, 35018, "Mercenary", 0, "", 0, "LineageNPC.a_mageguild_teacher_FHuman", 8, 23.5, 67, "female", "L2Defender", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 449, 1, 624.93199, 281.55251, 426.74754, 206.02791, 253, 1, 333, 316, 0, 0, 50, 195, 0, 1), 
(35019, 35019, "Mercenary", 0, "", 0, "LineageNPC.a_mageguild_teacher_MHuman", 8, 23, 67, "male", "L2Defender", 40, 2295.48154, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 449, 1, 624.93199, 281.55251, 426.74754, 206.02791, 253, 1, 333, 179, 0, 0, 50, 195, 0, 1), 
(35020, 35020, "Mercenary of Dawn", 0, "", 0, "LineageNPC.a_fighterguild_master_Mhuman", 8, 23.5, 80, "male", "L2Defender", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 640, 1, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 150, 0, 0, 50, 195, 0, 1), 
(35021, 35021, "Mercenary of Dawn", 0, "", 0, "LineageNPC.a_fighterguild_master_Mhuman", 8, 23.5, 80, "male", "L2Defender", 80, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 640, 1, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 97, 0, 0, 50, 195, 0, 1), 
(35022, 35022, "Mercenary of Dawn", 0, "", 0, "LineageNPC.a_fighterguild_master_Mhuman", 8, 23.5, 80, "male", "L2Defender", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 640, 1, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 288, 0, 0, 50, 195, 0, 1), 
(35023, 35023, "Mercenary of Dawn", 0, "", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 80, "female", "L2Defender", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 640, 1, 970.53755, 341.375, 662.75133, 249.80341, 253, 1, 333, 325, 0, 0, 50, 195, 0, 1), 
(35024, 35024, "Mercenary of Dawn", 0, "", 0, "LineageNPC.a_mageguild_master_MHuman", 8, 24, 80, "male", "L2Defender", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 640, 1, 970.53755, 341.375, 662.75133, 249.80341, 253, 1, 333, 196, 0, 0, 50, 195, 0, 1), 
(35025, 35025, "Mercenary of Dawn", 0, "", 0, "LineageNPC.a_fighterguild_master_Mhuman", 8, 23.5, 80, "male", "L2Defender", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 640, 1, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 150, 0, 0, 50, 195, 0, 1), 
(35026, 35026, "Mercenary of Dawn", 0, "", 0, "LineageNPC.a_fighterguild_master_Mhuman", 8, 23.5, 80, "male", "L2Defender", 80, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 640, 1, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 97, 0, 0, 50, 195, 0, 1), 
(35027, 35027, "Mercenary of Dawn", 0, "", 0, "LineageNPC.a_fighterguild_master_Mhuman", 8, 23.5, 80, "male", "L2Defender", 1100, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 640, 1, 970.53755, 341.375, 662.75133, 249.80341, 253, 8, 333, 288, 0, 0, 50, 195, 0, 1), 
(35028, 35028, "Mercenary of Dawn", 0, "", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 80, "female", "L2Defender", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 640, 1, 970.53755, 341.375, 662.75133, 249.80341, 253, 1, 333, 325, 0, 0, 50, 195, 0, 1), 
(35029, 35029, "Mercenary of Dawn", 0, "", 0, "LineageNPC.a_mageguild_master_MHuman", 8, 24, 80, "male", "L2Defender", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 640, 1, 970.53755, 341.375, 662.75133, 249.80341, 253, 1, 333, 196, 0, 0, 50, 195, 0, 1), 
(35030, 35030, "Elite Mercenary Guild Member", 0, "", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 578, 1, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 132, 0, 0, 50, 195, 0, 1), 
(35031, 35031, "Elite Mercenary Guild Member", 0, "", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 80, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 578, 1, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 301, 0, 0, 50, 195, 0, 1), 
(35032, 35032, "Elite Mercenary Guild Member", 0, "", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 578, 1, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 280, 0, 0, 50, 195, 0, 1), 
(35033, 35033, "Elite Mercenary Guild Member", 0, "", 0, "LineageNPC.a_sanctuary_teacher_FHuman", 8, 22.5, 76, "female", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 578, 1, 824.42207, 323.78455, 562.9734, 236.93149, 253, 1, 333, 316, 0, 0, 50, 195, 0, 1), 
(35034, 35034, "Elite Mercenary Guild Member", 0, "", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 578, 1, 824.42207, 323.78455, 562.9734, 236.93149, 253, 1, 333, 325, 0, 0, 50, 195, 0, 1), 
(35035, 35035, "Elite Mercenary Guild Member", 0, "", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 578, 1, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 132, 0, 0, 50, 195, 0, 1), 
(35036, 35036, "Elite Mercenary Guild Member", 0, "", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 80, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 578, 1, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 301, 0, 0, 50, 195, 0, 1), 
(35037, 35037, "Elite Mercenary Guild Member", 0, "", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 578, 1, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 280, 0, 0, 50, 195, 0, 1), 
(35038, 35038, "Elite Mercenary Guild Member", 0, "", 0, "LineageNPC.a_sanctuary_teacher_FHuman", 8, 22.5, 76, "female", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 578, 1, 824.42207, 323.78455, 562.9734, 236.93149, 253, 1, 333, 316, 0, 0, 50, 195, 0, 1), 
(35039, 35039, "Elite Mercenary Guild Member", 0, "", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 578, 1, 824.42207, 323.78455, 562.9734, 236.93149, 253, 1, 333, 325, 0, 0, 50, 195, 0, 1), 
(35040, 35040, "Greater Recruit", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 72, "male", "L2Defender", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 518, 1, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 66, 20, 0, 50, 195, 0, 1), 
(35041, 35041, "Greater Recruit", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 72, "male", "L2Defender", 80, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 518, 1, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 16, 0, 0, 50, 195, 0, 1), 
(35042, 35042, "Greater Recruit", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 72, "male", "L2Defender", 1100, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 518, 1, 731.52506, 305.35947, 499.53679, 223.44881, 253, 8, 333, 274, 0, 0, 50, 195, 0, 1), 
(35043, 35043, "Greater Recruit", 0, "", 0, "LineageNPC.a_mageguild_teacher_FHuman", 8, 23.5, 72, "female", "L2Defender", 40, 2540.15331, 1410, 8.5, 3, 22, 27, 21, 41, 20, 20, 518, 1, 731.52506, 305.35947, 499.53679, 223.44881, 253, 1, 333, 7, 0, 0, 50, 195, 0, 1), 
(35044, 35044, "Greater Recruit", 0, "", 0, "LineageNPC.a_mageguild_teacher_MHuman", 8, 23, 72, "male", "L2Defender", 40, 2540.15331, 1410, 8.5, 3, 22, 27, 21, 41, 20, 20, 518, 1, 731.52506, 305.35947, 499.53679, 223.44881, 253, 1, 333, 154, 0, 0, 50, 195, 0, 1), 
(35045, 35045, "Greater Recruit", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 72, "male", "L2Defender", 40, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 518, 1, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 66, 20, 0, 50, 195, 0, 1), 
(35046, 35046, "Greater Recruit", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 72, "male", "L2Defender", 80, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 518, 1, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 16, 0, 0, 50, 195, 0, 1), 
(35047, 35047, "Greater Recruit", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 72, "male", "L2Defender", 1100, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 518, 1, 731.52506, 305.35947, 499.53679, 223.44881, 253, 8, 333, 274, 0, 0, 50, 195, 0, 1), 
(35048, 35048, "Greater Recruit", 0, "", 0, "LineageNPC.a_mageguild_teacher_FHuman", 8, 23.5, 72, "female", "L2Defender", 40, 2540.15331, 1410, 8.5, 3, 22, 27, 21, 41, 20, 20, 518, 1, 731.52506, 305.35947, 499.53679, 223.44881, 253, 1, 333, 7, 0, 0, 50, 195, 0, 1), 
(35049, 35049, "Greater Recruit", 0, "", 0, "LineageNPC.a_mageguild_teacher_MHuman", 8, 23, 72, "male", "L2Defender", 40, 2540.15331, 1410, 8.5, 3, 22, 27, 21, 41, 20, 20, 518, 1, 731.52506, 305.35947, 499.53679, 223.44881, 253, 1, 333, 154, 0, 0, 50, 195, 0, 1), 
(35050, 35050, "Recruit", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 64, "male", "L2Defender", 40, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 410, 1, 562.02275, 267.04468, 383.78868, 195.41171, 253, 4, 333, 66, 0, 0, 50, 195, 0, 1), 
(35051, 35051, "Recruit", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 64, "male", "L2Defender", 80, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 410, 1, 562.02275, 267.04468, 383.78868, 195.41171, 253, 4, 333, 16, 0, 0, 50, 195, 0, 1), 
(35052, 35052, "Recruit", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 64, "male", "L2Defender", 1100, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 410, 1, 562.02275, 267.04468, 383.78868, 195.41171, 253, 8, 333, 14, 0, 0, 50, 195, 0, 1), 
(35053, 35053, "Recruit", 0, "", 0, "LineageNPC.a_traderB_FHuman", 8, 24.5, 64, "female", "L2Defender", 40, 2141.82127, 1158, 7.5, 2.7, 22, 27, 21, 41, 20, 20, 410, 1, 562.02275, 267.04468, 383.78868, 195.41171, 253, 1, 333, 6, 0, 0, 50, 195, 0, 1), 
(35054, 35054, "Recruit", 0, "", 0, "LineageNPC.a_sanctuary_teacher_MHuman", 8, 23, 64, "male", "L2Defender", 40, 2141.82127, 1158, 7.5, 2.7, 22, 27, 21, 41, 20, 20, 410, 1, 562.02275, 267.04468, 383.78868, 195.41171, 253, 1, 333, 99, 0, 0, 50, 195, 0, 1), 
(35055, 35055, "Recruit", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 64, "male", "L2Defender", 40, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 410, 1, 562.02275, 267.04468, 383.78868, 195.41171, 253, 4, 333, 66, 0, 0, 50, 195, 0, 1), 
(35056, 35056, "Recruit", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 64, "male", "L2Defender", 80, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 410, 1, 562.02275, 267.04468, 383.78868, 195.41171, 253, 4, 333, 16, 0, 0, 50, 195, 0, 1), 
(35057, 35057, "Recruit", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 64, "male", "L2Defender", 1100, 2141.82127, 1158, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 410, 1, 562.02275, 267.04468, 383.78868, 195.41171, 253, 8, 333, 14, 0, 0, 50, 195, 0, 1), 
(35058, 35058, "Recruit", 0, "", 0, "LineageNPC.a_traderB_FHuman", 8, 24.5, 64, "female", "L2Defender", 40, 2141.82127, 1158, 7.5, 2.7, 22, 27, 21, 41, 20, 20, 410, 1, 562.02275, 267.04468, 383.78868, 195.41171, 253, 1, 333, 6, 0, 0, 50, 195, 0, 1), 
(35059, 35059, "Recruit", 0, "", 0, "LineageNPC.a_sanctuary_teacher_MHuman", 8, 23, 64, "male", "L2Defender", 40, 2141.82127, 1158, 7.5, 2.7, 22, 27, 21, 41, 20, 20, 410, 1, 562.02275, 267.04468, 383.78868, 195.41171, 253, 1, 333, 99, 0, 0, 50, 195, 0, 1), 
(35060, 35060, "Nephilim Mercenary", 0, "", 0, "LineageMonster3.Kight_of_Dawn", 12, 24.5, 85, "male", "L2Npc", 40, 596964.367482, 1662.649295, 981, 3, 40, 43, 30, 21, 20, 20, 723, 1, 2920.46742, 361.78814, 5982.90187, 264.74086, 253, 4, 333, 2500, 6377, 0, 36.48, 195, 0, 1), 
(35061, 35061, "Nephilim Mercenary", 0, "", 0, "LineageMonster3.Elite_Mage", 6.5, 21.96, 82, "female", "L2Npc", 40, 585703.507798, 1561.39136, 989, 3, 22, 27, 21, 41, 20, 20, 672, 1, 2704.10327, 349.77477, 5539.65578, 255.95, 253, 1, 333, 8687, 0, 0, 33, 195, 0, 1), 
(35062, 35062, "Headquarters", 0, "", 0, "LineageDeco.flag_a", 10, 80, 1, "etc", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35063, 35063, "Gludio Holy Artifact", 0, "", 0, "LineageNPC.castle_kent_statue_jewel", 25, 98, 20, "etc", "L2Artefact", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35064, 35064, "Baron Lewin Waldner", 0, "", 0, "LineageNPC.a_lord_MHuman", 7, 23, 83, "male", "L2Defender", 40, 38355.906059, 5332.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 689, 1, 3298.27085, 353.86144, 750.76381, 258.94045, 253, 4, 333, 79, 0, 0, 50, 120, 0, 1), 
(35065, 35065, "Cronenberg", 0, "Sir", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 81, "male", "L2Defender", 40, 34617.725322, 5126.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 656, 1, 3036.96805, 345.61127, 691.28516, 252.90333, 253, 4, 333, 142, 0, 0, 50, 120, 0, 1), 
(35066, 35066, "Royal Knight", 0, "Gludio", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 79, "male", "L2Defender", 40, 3127.824593, 1641, 8.5, 3, 40, 43, 30, 21, 20, 20, 624, 1, 929.93081, 337.07008, 635.0222, 246.65326, 253, 4, 333, 76, 2497, 0, 50, 120, 0, 1), 
(35067, 35067, "Court Sorcerer", 0, "Gludio", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 77, "male", "L2Defender", 40, 2856.768726, 1574, 8.5, 3, 22, 27, 21, 41, 20, 20, 593, 1, 856.44056, 328.27073, 584.83789, 240.21427, 253, 1, 333, 325, 0, 0, 50, 120, 0, 1), 
(35068, 35068, "Court Sorcerer", 0, "Gludio", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 77, "female", "L2Defender", 40, 2856.768726, 1574, 8.5, 3, 22, 27, 21, 41, 20, 20, 593, 1, 856.44056, 328.27073, 584.83789, 240.21427, 253, 1, 333, 193, 0, 0, 50, 120, 0, 1), 
(35069, 35069, "Court Guard", 0, "Gludio", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 77, "male", "L2Defender", 80, 2856.768726, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 593, 1, 856.44056, 328.27073, 584.83789, 240.21427, 253, 4, 333, 94, 0, 0, 50, 120, 0, 1), 
(35070, 35070, "Guard", 0, "Gludio", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35071, 35071, "Guard", 0, "Gludio", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 2499, 0, 0, 50, 120, 0, 1), 
(35072, 35072, "Guard", 0, "Gludio", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 276, 0, 0, 50, 120, 0, 1), 
(35073, 35073, "Guard", 0, "Gludio", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 75, "female", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35074, 35074, "Guard", 0, "Gludio", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 75, "female", "L2Defender", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(35075, 35075, "Guard", 0, "Gludio", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 75, "female", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 14, 0, 0, 50, 120, 0, 1), 
(35076, 35076, "Guard", 0, "Gludio", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35077, 35077, "Guard", 0, "Gludio", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2Defender", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(35078, 35078, "Guard", 0, "Gludio", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 14, 0, 0, 50, 120, 0, 1), 
(35079, 35079, "Royal Knight", 0, "Gludio", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 79, "male", "L2Defender", 40, 3127.824593, 1641, 8.5, 3, 40, 43, 30, 21, 20, 20, 624, 1, 929.93081, 337.07008, 635.0222, 246.65326, 253, 4, 333, 76, 2497, 0, 50, 120, 0, 1), 
(35080, 35080, "Court Sorcerer", 0, "Gludio", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 77, "male", "L2Defender", 40, 2856.768726, 1574, 8.5, 3, 22, 27, 21, 41, 20, 20, 593, 1, 856.44056, 328.27073, 584.83789, 240.21427, 253, 1, 333, 325, 0, 0, 50, 120, 0, 1), 
(35081, 35081, "Court Sorcerer", 0, "Gludio", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 77, "female", "L2Defender", 40, 2856.768726, 1574, 8.5, 3, 22, 27, 21, 41, 20, 20, 593, 1, 856.44056, 328.27073, 584.83789, 240.21427, 253, 1, 333, 193, 0, 0, 50, 120, 0, 1), 
(35082, 35082, "Court Guard", 0, "Gludio", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 77, "male", "L2Defender", 80, 2856.768726, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 593, 1, 856.44056, 328.27073, 584.83789, 240.21427, 253, 4, 333, 94, 0, 0, 50, 120, 0, 1), 
(35083, 35083, "Guard", 0, "Gludio", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 93, 0, 0, 50, 120, 0, 1), 
(35084, 35084, "Guard", 0, "Gludio", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 2499, 0, 0, 50, 120, 0, 1), 
(35085, 35085, "Guard", 0, "Gludio", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 276, 0, 0, 50, 120, 0, 1), 
(35086, 35086, "Guard", 0, "Gludio", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 75, "female", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35087, 35087, "Guard", 0, "Gludio", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 75, "female", "L2Defender", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(35088, 35088, "Guard", 0, "Gludio", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 75, "female", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 14, 0, 0, 50, 120, 0, 1), 
(35089, 35089, "Guard", 0, "Gludio", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35090, 35090, "Guard", 0, "Gludio", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2Defender", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(35091, 35091, "Guard", 0, "Gludio", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 14, 0, 0, 50, 120, 0, 1), 
(35092, 35092, "Gatekeeper", 0, "Gludio", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35093, 35093, "Gatekeeper", 0, "Gludio", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35094, 35094, "Gatekeeper", 0, "Gludio", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35095, 35095, "Mass Gatekeeper", 0, "Gludio", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2CastleTeleporter", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35096, 35096, "Outer Doorman", 0, "Gludio", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35097, 35097, "Inner Doorman", 0, "Gludio", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35098, 35098, "Blacksmith", 0, "Gludio", 0, "LineageNPC.a_smith_MDwarf", 7, 16.5, 75, "male", "L2CastleBlacksmith", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 89, 0, 0, 50, 120, 0, 1), 
(35099, 35099, "Warehouse Keeper", 0, "Gludio", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 75, "male", "L2CastleWarehouse", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35100, 35100, "Sayres", 0, "Chamberlain", 0, "LineageNPC.a_chamberlain_MHuman", 9.5, 22.5, 75, "male", "L2CastleChamberlain", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35101, 35101, "Grad", 0, "Wyvern Manager", 0, "LineageNPC.a_traderB_MHuman", 8, 25, 75, "male", "L2CastleWyvernManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35102, 35102, "Greenspan", 0, "Mercenary Manager", 0, "LineageNPC.a_common_peopleA_MHuman", 8, 21.5, 75, "male", "L2MercManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35103, 35103, "Manor Manager", 0, "Gludio", 0, "LineageNPC.a_chamberlain_MHuman", 9.5, 22.5, 75, "male", "L2ManorManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35104, 35104, "Tyron", 0, "Sir", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2SiegeNpc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 74, 0, 0, 50, 160, 0, 1), 
(35105, 35105, "Dion Holy Artifact", 0, "", 0, "LineageNPC.castle_kent_statue_jewel", 25, 98, 20, "etc", "L2Artefact", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 40, 10, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35106, 35106, "Duke Byron Ashton", 0, "", 0, "LineageNPC.a_lord_MHuman", 7, 23, 83, "male", "L2Defender", 40, 38355.906059, 5332.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 689, 1, 3298.27085, 353.86144, 750.76381, 258.94045, 253, 4, 333, 79, 0, 0, 50, 120, 0, 1), 
(35107, 35107, "Ivano", 0, "Sir", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 81, "male", "L2Defender", 40, 34617.725322, 5126.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 656, 1, 3036.96805, 345.61127, 691.28516, 252.90333, 253, 4, 333, 142, 0, 0, 50, 120, 0, 1), 
(35108, 35108, "Royal Knight", 0, "Dion", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 79, "male", "L2Defender", 40, 3127.824593, 1641, 8.5, 3, 40, 43, 30, 21, 20, 20, 624, 1, 929.93081, 337.07008, 635.0222, 246.65326, 253, 4, 333, 76, 2497, 0, 50, 120, 0, 1), 
(35109, 35109, "Court Sorcerer", 0, "Dion", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 77, "male", "L2Defender", 40, 2856.768726, 1574, 8.5, 3, 22, 27, 21, 41, 20, 20, 593, 1, 856.44056, 328.27073, 584.83789, 240.21427, 253, 1, 333, 325, 0, 0, 50, 120, 0, 1), 
(35110, 35110, "Court Sorcerer", 0, "Dion", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 77, "female", "L2Defender", 40, 2856.768726, 1574, 8.5, 3, 22, 27, 21, 41, 20, 20, 593, 1, 856.44056, 328.27073, 584.83789, 240.21427, 253, 1, 333, 193, 0, 0, 50, 120, 0, 1), 
(35111, 35111, "Court Guard", 0, "Dion", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 77, "male", "L2Defender", 80, 2856.768726, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 593, 1, 856.44056, 328.27073, 584.83789, 240.21427, 253, 4, 333, 94, 0, 0, 50, 120, 0, 1), 
(35112, 35112, "Guard", 0, "Dion", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35113, 35113, "Guard", 0, "Dion", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 2499, 0, 0, 50, 120, 0, 1), 
(35114, 35114, "Guard", 0, "Dion", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 276, 0, 0, 50, 120, 0, 1), 
(35115, 35115, "Guard", 0, "Dion", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 75, "female", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35116, 35116, "Guard", 0, "Dion", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 75, "female", "L2Defender", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(35117, 35117, "Guard", 0, "Dion", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 75, "female", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 14, 0, 0, 50, 120, 0, 1), 
(35118, 35118, "Guard", 0, "Dion", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35119, 35119, "Guard", 0, "Dion", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2Defender", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(35120, 35120, "Guard", 0, "Dion", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 14, 0, 0, 50, 120, 0, 1), 
(35121, 35121, "Royal Knight", 0, "Dion", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 79, "male", "L2Defender", 40, 3127.824593, 1641, 8.5, 3, 40, 43, 30, 21, 20, 20, 624, 1, 929.93081, 337.07008, 635.0222, 246.65326, 253, 4, 333, 76, 2497, 0, 50, 120, 0, 1), 
(35122, 35122, "Court Sorcerer", 0, "Dion", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 77, "male", "L2Defender", 40, 2856.768726, 1574, 8.5, 3, 22, 27, 21, 41, 20, 20, 593, 1, 856.44056, 328.27073, 584.83789, 240.21427, 253, 1, 333, 325, 0, 0, 50, 120, 0, 1), 
(35123, 35123, "Court Sorcerer", 0, "Dion", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 77, "female", "L2Defender", 40, 2856.768726, 1574, 8.5, 3, 22, 27, 21, 41, 20, 20, 593, 1, 856.44056, 328.27073, 584.83789, 240.21427, 253, 1, 333, 193, 0, 0, 50, 120, 0, 1), 
(35124, 35124, "Court Guard", 0, "Dion", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 77, "male", "L2Defender", 80, 2856.768726, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 593, 1, 856.44056, 328.27073, 584.83789, 240.21427, 253, 4, 333, 94, 0, 0, 50, 120, 0, 1), 
(35125, 35125, "Court Guard", 0, "Dion", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 93, 0, 0, 50, 120, 0, 1), 
(35126, 35126, "Court Guard", 0, "Dion", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 2499, 0, 0, 50, 120, 0, 1), 
(35127, 35127, "Court Guard", 0, "Dion", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 276, 0, 0, 50, 120, 0, 1), 
(35128, 35128, "Court Guard", 0, "Dion", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 75, "female", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35129, 35129, "Court Guard", 0, "Dion", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 75, "female", "L2Defender", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(35130, 35130, "Court Guard", 0, "Dion", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 75, "female", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 14, 0, 0, 50, 120, 0, 1), 
(35131, 35131, "Court Guard", 0, "Dion", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35132, 35132, "Court Guard", 0, "Dion", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2Defender", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(35133, 35133, "Court Guard", 0, "Dion", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 14, 0, 0, 50, 120, 0, 1), 
(35134, 35134, "Gatekeeper", 0, "Dion", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35135, 35135, "Gatekeeper", 0, "Dion", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35136, 35136, "Gatekeeper", 0, "Dion", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35137, 35137, "Mass Gatekeeper", 0, "Dion", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2CastleTeleporter", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35138, 35138, "Outer Doorman", 0, "Dion", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35139, 35139, "Inner Doorman", 0, "Dion", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35140, 35140, "Blacksmith", 0, "Dion", 0, "LineageNPC.a_smith_MDwarf", 7, 16.5, 75, "male", "L2CastleBlacksmith", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 89, 0, 0, 50, 120, 0, 1), 
(35141, 35141, "Warehouse Keeper", 0, "Dion", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 75, "male", "L2CastleWarehouse", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35142, 35142, "Crosby", 0, "Chamberlain", 0, "LineageNPC.a_chamberlain_MHuman", 9.5, 22.5, 75, "male", "L2CastleChamberlain", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35143, 35143, "Hodler", 0, "Wyvern Manager", 0, "LineageNPC.a_traderB_MHuman", 8, 25, 75, "male", "L2CastleWyvernManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35144, 35144, "Mercenary Manager Sanford", 0, "Mercenary Manager", 0, "LineageNPC.a_common_peopleA_MHuman", 8, 21.5, 75, "male", "L2MercManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35145, 35145, "Manor Manager", 0, "Dion", 0, "LineageNPC.a_chamberlain_MHuman", 9.5, 22.5, 75, "male", "L2ManorManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35146, 35146, "Gibbson", 0, "Herald", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2SiegeNpc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 74, 0, 0, 50, 160, 0, 1), 
(35147, 35147, "Giran Holy Artifact", 0, "", 0, "LineageNPC.castle_kent_statue_jewel", 25, 98, 20, "etc", "L2Artefact", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 40, 10, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35148, 35148, "Baron Carmon Esthus", 0, "", 0, "LineageNPC.a_lord_MHuman", 7, 23, 83, "male", "L2Defender", 40, 38355.906059, 5332.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 689, 1, 3298.27085, 353.86144, 750.76381, 258.94045, 253, 4, 333, 79, 0, 0, 50, 120, 0, 1), 
(35149, 35149, "Ulric", 0, "Sir", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 81, "male", "L2Defender", 40, 34617.725322, 5126.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 656, 1, 3036.96805, 345.61127, 691.28516, 252.90333, 253, 4, 333, 142, 0, 0, 50, 120, 0, 1), 
(35150, 35150, "Royal Knight", 0, "Giran", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 79, "male", "L2Defender", 40, 3127.824593, 1641, 8.5, 3, 40, 43, 30, 21, 20, 20, 624, 1, 929.93081, 337.07008, 635.0222, 246.65326, 253, 4, 333, 76, 2497, 0, 50, 120, 0, 1), 
(35151, 35151, "Court Sorcerer", 0, "Giran", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 77, "male", "L2Defender", 40, 2856.768726, 1574, 8.5, 3, 22, 27, 21, 41, 20, 20, 593, 1, 856.44056, 328.27073, 584.83789, 240.21427, 253, 1, 333, 325, 0, 0, 50, 120, 0, 1), 
(35152, 35152, "Court Sorcerer", 0, "Giran", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 77, "female", "L2Defender", 40, 2856.768726, 1574, 8.5, 3, 22, 27, 21, 41, 20, 20, 593, 1, 856.44056, 328.27073, 584.83789, 240.21427, 253, 1, 333, 193, 0, 0, 50, 120, 0, 1), 
(35153, 35153, "Court Guard", 0, "Giran", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 77, "male", "L2Defender", 80, 2856.768726, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 593, 1, 856.44056, 328.27073, 584.83789, 240.21427, 253, 4, 333, 94, 0, 0, 50, 120, 0, 1), 
(35154, 35154, "Guard", 0, "Giran", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35155, 35155, "Guard", 0, "Giran", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 2499, 0, 0, 50, 120, 0, 1), 
(35156, 35156, "Guard", 0, "Giran", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 276, 0, 0, 50, 120, 0, 1), 
(35157, 35157, "Guard", 0, "Giran", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 75, "female", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35158, 35158, "Guard", 0, "Giran", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 75, "female", "L2Defender", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(35159, 35159, "Guard", 0, "Giran", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 75, "female", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 14, 0, 0, 50, 120, 0, 1), 
(35160, 35160, "Guard", 0, "Giran", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35161, 35161, "Guard", 0, "Giran", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2Defender", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(35162, 35162, "Guard", 0, "Giran", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 14, 0, 0, 50, 120, 0, 1), 
(35163, 35163, "Royal Knight", 0, "Giran", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 79, "male", "L2Defender", 40, 3127.824593, 1641, 8.5, 3, 40, 43, 30, 21, 20, 20, 624, 1, 929.93081, 337.07008, 635.0222, 246.65326, 253, 4, 333, 76, 2497, 0, 50, 120, 0, 1), 
(35164, 35164, "Court Sorcerer", 0, "Giran", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 77, "male", "L2Defender", 40, 2856.768726, 1574, 8.5, 3, 22, 27, 21, 41, 20, 20, 593, 1, 856.44056, 328.27073, 584.83789, 240.21427, 253, 1, 333, 325, 0, 0, 50, 120, 0, 1), 
(35165, 35165, "Court Sorcerer", 0, "Giran", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 77, "female", "L2Defender", 40, 2856.768726, 1574, 8.5, 3, 22, 27, 21, 41, 20, 20, 593, 1, 856.44056, 328.27073, 584.83789, 240.21427, 253, 1, 333, 193, 0, 0, 50, 120, 0, 1), 
(35166, 35166, "Court Guard", 0, "Giran", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 77, "male", "L2Defender", 80, 2856.768726, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 593, 1, 856.44056, 328.27073, 584.83789, 240.21427, 253, 4, 333, 94, 0, 0, 50, 120, 0, 1), 
(35167, 35167, "Guard", 0, "Giran", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 93, 0, 0, 50, 120, 0, 1), 
(35168, 35168, "Guard", 0, "Giran", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 2499, 0, 0, 50, 120, 0, 1), 
(35169, 35169, "Guard", 0, "Giran", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 276, 0, 0, 50, 120, 0, 1), 
(35170, 35170, "Guard", 0, "Giran", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 75, "female", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35171, 35171, "Guard", 0, "Giran", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 75, "female", "L2Defender", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(35172, 35172, "Guard", 0, "Giran", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 75, "female", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 14, 0, 0, 50, 120, 0, 1), 
(35173, 35173, "Guard", 0, "Giran", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35174, 35174, "Guard", 0, "Giran", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2Defender", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(35175, 35175, "Guard", 0, "Giran", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 14, 0, 0, 50, 120, 0, 1), 
(35176, 35176, "Gatekeeper", 0, "Giran", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35177, 35177, "Gatekeeper", 0, "Giran", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35178, 35178, "Gatekeeper", 0, "Giran", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35179, 35179, "Mass Gatekeeper", 0, "Giran", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2CastleTeleporter", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35180, 35180, "Outer Doorman", 0, "Giran", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35181, 35181, "Inner Doorman", 0, "Giran", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35182, 35182, "Blacksmith", 0, "Giran", 0, "LineageNPC.a_smith_MDwarf", 7, 16.5, 75, "male", "L2CastleBlacksmith", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 89, 0, 0, 50, 120, 0, 1), 
(35183, 35183, "Warehouse Keeper", 0, "Giran", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 75, "male", "L2CastleWarehouse", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35184, 35184, "Saul", 0, "Chamberlain", 0, "LineageNPC.a_chamberlain_MHuman", 9.5, 22.5, 75, "male", "L2CastleChamberlain", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35185, 35185, "Bryce", 0, "Wyvern Manager", 0, "LineageNPC.a_traderB_MHuman", 8, 25, 75, "male", "L2CastleWyvernManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35186, 35186, "Arvid", 0, "Mercenary Manager", 0, "LineageNPC.a_common_peopleA_MHuman", 8, 21.5, 75, "male", "L2MercManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35187, 35187, "Manor Manager", 0, "Giran", 0, "LineageNPC.a_chamberlain_MHuman", 9.5, 22.5, 75, "male", "L2ManorManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35188, 35188, "Holmes", 0, "Sir", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2SiegeNpc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 74, 0, 0, 50, 160, 0, 1), 
(35189, 35189, "Oren Holy Artifact", 0, "", 0, "LineageNPC.castle_kent_statue_jewel", 25, 98, 20, "etc", "L2Artefact", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 40, 10, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35190, 35190, "Balthus Van Dyke", 0, "Duke", 0, "LineageNPC.a_lord_MHuman", 7, 23, 83, "male", "L2Defender", 40, 38355.906059, 5332.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 689, 1, 3298.27085, 353.86144, 750.76381, 258.94045, 253, 4, 333, 79, 0, 0, 50, 120, 0, 1), 
(35191, 35191, "Quant", 0, "Sir", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 81, "male", "L2Defender", 40, 34617.725322, 5126.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 656, 1, 3036.96805, 345.61127, 691.28516, 252.90333, 253, 4, 333, 142, 0, 0, 50, 120, 0, 1), 
(35192, 35192, "Royal Knight", 0, "Oren", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 79, "male", "L2Defender", 40, 3127.824593, 1641, 8.5, 3, 40, 43, 30, 21, 20, 20, 624, 1, 929.93081, 337.07008, 635.0222, 246.65326, 253, 4, 333, 76, 2497, 0, 50, 120, 0, 1), 
(35193, 35193, "Court Sorcerer", 0, "Oren", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 77, "male", "L2Defender", 40, 2856.768726, 1574, 8.5, 3, 22, 27, 21, 41, 20, 20, 593, 1, 856.44056, 328.27073, 584.83789, 240.21427, 253, 1, 333, 325, 0, 0, 50, 120, 0, 1), 
(35194, 35194, "Court Sorcerer", 0, "Oren", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 77, "female", "L2Defender", 40, 2856.768726, 1574, 8.5, 3, 22, 27, 21, 41, 20, 20, 593, 1, 856.44056, 328.27073, 584.83789, 240.21427, 253, 1, 333, 193, 0, 0, 50, 120, 0, 1), 
(35195, 35195, "Court Guard", 0, "Oren", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 77, "male", "L2Defender", 80, 2856.768726, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 593, 1, 856.44056, 328.27073, 584.83789, 240.21427, 253, 4, 333, 94, 0, 0, 50, 120, 0, 1), 
(35196, 35196, "Guard", 0, "Oren", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35197, 35197, "Guard", 0, "Oren", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 2499, 0, 0, 50, 120, 0, 1), 
(35198, 35198, "Guard", 0, "Oren", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 276, 0, 0, 50, 120, 0, 1), 
(35199, 35199, "Guard", 0, "Oren", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 75, "female", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35200, 35200, "Guard", 0, "Oren", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 75, "female", "L2Defender", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(35201, 35201, "Guard", 0, "Oren", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 75, "female", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 14, 0, 0, 50, 120, 0, 1), 
(35202, 35202, "Guard", 0, "Oren", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35203, 35203, "Guard", 0, "Oren", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2Defender", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(35204, 35204, "Guard", 0, "Oren", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 14, 0, 0, 50, 120, 0, 1), 
(35205, 35205, "Royal Knight", 0, "Oren", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 79, "male", "L2Defender", 40, 3127.824593, 1641, 8.5, 3, 40, 43, 30, 21, 20, 20, 624, 1, 929.93081, 337.07008, 635.0222, 246.65326, 253, 4, 333, 76, 2497, 0, 50, 120, 0, 1), 
(35206, 35206, "Court Sorcerer", 0, "Oren", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 77, "male", "L2Defender", 40, 2856.768726, 1574, 8.5, 3, 22, 27, 21, 41, 20, 20, 593, 1, 856.44056, 328.27073, 584.83789, 240.21427, 253, 1, 333, 325, 0, 0, 50, 120, 0, 1), 
(35207, 35207, "Court Sorcerer", 0, "Oren", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 77, "female", "L2Defender", 40, 2856.768726, 1574, 8.5, 3, 22, 27, 21, 41, 20, 20, 593, 1, 856.44056, 328.27073, 584.83789, 240.21427, 253, 1, 333, 193, 0, 0, 50, 120, 0, 1), 
(35208, 35208, "Court Guard", 0, "Oren", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 77, "male", "L2Defender", 80, 2856.768726, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 593, 1, 856.44056, 328.27073, 584.83789, 240.21427, 253, 4, 333, 94, 0, 0, 50, 120, 0, 1), 
(35209, 35209, "Guard", 0, "Oren", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 93, 0, 0, 50, 120, 0, 1), 
(35210, 35210, "Guard", 0, "Oren", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 2499, 0, 0, 50, 120, 0, 1), 
(35211, 35211, "Guard", 0, "Oren", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 276, 0, 0, 50, 120, 0, 1), 
(35212, 35212, "Guard", 0, "Oren", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 75, "female", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35213, 35213, "Guard", 0, "Oren", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 75, "female", "L2Defender", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(35214, 35214, "Guard", 0, "Oren", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 75, "female", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 14, 0, 0, 50, 120, 0, 1), 
(35215, 35215, "Guard", 0, "Oren", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35216, 35216, "Guard", 0, "Oren", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2Defender", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(35217, 35217, "Guard", 0, "Oren", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 14, 0, 0, 50, 120, 0, 1), 
(35218, 35218, "Gatekeeper", 0, "Oren", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35219, 35219, "Gatekeeper", 0, "Oren", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35220, 35220, "Gatekeeper", 0, "Oren", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35221, 35221, "Mass Gatekeeper", 0, "Oren", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2CastleTeleporter", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35222, 35222, "Outer Doorman", 0, "Oren", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35223, 35223, "Inner Doorman", 0, "Oren", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35224, 35224, "Blacksmith", 0, "Oren", 0, "LineageNPC.a_smith_MDwarf", 7, 16.5, 75, "male", "L2CastleBlacksmith", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 89, 0, 0, 50, 120, 0, 1), 
(35225, 35225, "Warehouse Keeper", 0, "Oren", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 75, "male", "L2CastleWarehouse", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35226, 35226, "Brasseur", 0, "Chamberlain", 0, "LineageNPC.a_chamberlain_MHuman", 9.5, 22.5, 75, "male", "L2CastleChamberlain", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35227, 35227, "Finrod", 0, "Wyvern Manager", 0, "LineageNPC.a_trader_MElf", 6, 24.5, 75, "male", "L2CastleWyvernManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35228, 35228, "Morrison", 0, "Mercenary Manager", 0, "LineageNPC.a_common_peopleA_MHuman", 8, 21.5, 75, "male", "L2MercManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35229, 35229, "Manor Manager", 0, "Oren", 0, "LineageNPC.a_chamberlain_MHuman", 9.5, 22.5, 75, "male", "L2ManorManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35230, 35230, "Manor Manager", 0, "Oren", 0, "LineageNPC.a_trader_MElf", 6, 24.5, 75, "male", "L2ManorManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35231, 35231, "Manor Manager", 0, "Oren", 0, "LineageNPC.a_common_people_MDarkElf", 7, 23, 75, "male", "L2ManorManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35232, 35232, "Sherwood", 0, "Messenger", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2SiegeNpc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 74, 0, 0, 50, 160, 0, 1), 
(35233, 35233, "Aden Holy Artifact", 0, "", 0, "LineageNPC.castle_kent_statue_jewel", 25, 98, 20, "etc", "L2Artefact", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 40, 10, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35234, 35234, "Amadeo Cadmus", 0, "King", 0, "LineageNPC.a_lord_MHuman", 7, 23, 85, "male", "L2Defender", 40, 42340.631269, 5540.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 723, 1, 3566.61778, 361.78814, 811.84586, 264.74086, 253, 4, 333, 80, 0, 0, 50, 120, 0, 1), 
(35235, 35235, "Royal Knight", 0, "Aden", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 81, "male", "L2Defender", 40, 34617.725322, 5126.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 656, 1, 3036.96805, 345.61127, 691.28516, 252.90333, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(35236, 35236, "Court Sorcerer", 0, "Aden", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 79, "male", "L2Defender", 40, 31278.245933, 4923, 8.5, 3, 22, 27, 21, 41, 20, 20, 624, 1, 2789.79244, 337.07008, 635.0222, 246.65326, 253, 1, 333, 7, 0, 0, 50, 120, 0, 1), 
(35237, 35237, "Court Sorcerer", 0, "Aden", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 79, "male", "L2Defender", 40, 31278.245933, 4923, 8.5, 3, 22, 27, 21, 41, 20, 20, 624, 1, 2789.79244, 337.07008, 635.0222, 246.65326, 253, 1, 333, 92, 0, 0, 50, 120, 0, 1), 
(35238, 35238, "Court Guard", 0, "Aden", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 79, "male", "L2Defender", 80, 31278.245933, 4923, 8.5, 3, 40, 43, 30, 21, 20, 20, 624, 1, 2789.79244, 337.07008, 635.0222, 246.65326, 253, 4, 333, 1376, 0, 0, 50, 120, 0, 1), 
(35239, 35239, "Guard", 0, "Aden", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 78, "male", "L2Defender", 80, 29743.56864, 4822.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 608, 1, 2671.50258, 332.70061, 608.09666, 243.45587, 253, 4, 333, 300, 0, 0, 50, 120, 0, 1), 
(35240, 35240, "Guard", 0, "Aden", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 78, "male", "L2Defender", 40, 29743.56864, 4822.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 608, 1, 2671.50258, 332.70061, 608.09666, 243.45587, 253, 4, 333, 132, 0, 0, 50, 120, 0, 1), 
(35241, 35241, "Guard", 0, "Aden", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 78, "male", "L2Defender", 1100, 29743.56864, 4822.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 608, 1, 2671.50258, 332.70061, 608.09666, 243.45587, 253, 8, 333, 14, 0, 0, 50, 120, 0, 1), 
(35242, 35242, "Guard", 0, "Aden", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 78, "female", "L2Defender", 80, 29743.56864, 4822.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 608, 1, 2671.50258, 332.70061, 608.09666, 243.45587, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35243, 35243, "Guard", 0, "Aden", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 78, "female", "L2Defender", 40, 29743.56864, 4822.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 608, 1, 2671.50258, 332.70061, 608.09666, 243.45587, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(35244, 35244, "Guard", 0, "Aden", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 78, "female", "L2Defender", 1100, 29743.56864, 4822.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 608, 1, 2671.50258, 332.70061, 608.09666, 243.45587, 253, 8, 333, 14, 0, 0, 50, 120, 0, 1), 
(35245, 35245, "Guard", 0, "Aden", 0, "LineageNPC.a_guard_MHuman", 8, 24, 78, "male", "L2Defender", 80, 29743.56864, 4822.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 608, 1, 2671.50258, 332.70061, 608.09666, 243.45587, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35246, 35246, "Guard", 0, "Aden", 0, "LineageNPC.a_guard_MHuman", 8, 24, 78, "male", "L2Defender", 40, 29743.56864, 4822.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 608, 1, 2671.50258, 332.70061, 608.09666, 243.45587, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(35247, 35247, "Guard", 0, "Aden", 0, "LineageNPC.a_guard_MHuman", 8, 24, 78, "male", "L2Defender", 1100, 29743.56864, 4822.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 608, 1, 2671.50258, 332.70061, 608.09666, 243.45587, 253, 8, 333, 14, 0, 0, 50, 120, 0, 1), 
(35248, 35248, "Royal Knight", 0, "Aden", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 81, "male", "L2Defender", 40, 34617.725322, 5126.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 656, 1, 3036.96805, 345.61127, 691.28516, 252.90333, 253, 4, 333, 142, 633, 0, 50, 120, 0, 1), 
(35249, 35249, "Court Sorcerer", 0, "Aden", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 79, "male", "L2Defender", 40, 31278.245933, 4923, 8.5, 3, 22, 27, 21, 41, 20, 20, 624, 1, 2789.79244, 337.07008, 635.0222, 246.65326, 253, 1, 333, 326, 0, 0, 50, 120, 0, 1), 
(35250, 35250, "Court Sorcerer", 0, "Aden", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 79, "female", "L2Defender", 40, 31278.245933, 4923, 8.5, 3, 22, 27, 21, 41, 20, 20, 624, 1, 2789.79244, 337.07008, 635.0222, 246.65326, 253, 1, 333, 325, 0, 0, 50, 120, 0, 1), 
(35251, 35251, "Court Guard", 0, "Aden", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 79, "male", "L2Defender", 80, 31278.245933, 4923, 8.5, 3, 40, 43, 30, 21, 20, 20, 624, 1, 2789.79244, 337.07008, 635.0222, 246.65326, 253, 4, 333, 300, 0, 0, 50, 120, 0, 1), 
(35252, 35252, "Guard", 0, "Aden", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 78, "male", "L2Defender", 80, 29743.56864, 4822.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 608, 1, 2671.50258, 332.70061, 608.09666, 243.45587, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35253, 35253, "Guard", 0, "Aden", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 78, "male", "L2Defender", 40, 29743.56864, 4822.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 608, 1, 2671.50258, 332.70061, 608.09666, 243.45587, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(35254, 35254, "Guard", 0, "Aden", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 78, "male", "L2Defender", 1100, 29743.56864, 4822.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 608, 1, 2671.50258, 332.70061, 608.09666, 243.45587, 253, 8, 333, 285, 0, 0, 50, 120, 0, 1), 
(35255, 35255, "Guard", 0, "Aden", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 78, "female", "L2Defender", 80, 29743.56864, 4822.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 608, 1, 2671.50258, 332.70061, 608.09666, 243.45587, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35256, 35256, "Guard", 0, "Aden", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 78, "female", "L2Defender", 40, 29743.56864, 4822.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 608, 1, 2671.50258, 332.70061, 608.09666, 243.45587, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(35257, 35257, "Guard", 0, "Aden", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 78, "female", "L2Defender", 1100, 29743.56864, 4822.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 608, 1, 2671.50258, 332.70061, 608.09666, 243.45587, 253, 8, 333, 14, 0, 0, 50, 120, 0, 1), 
(35258, 35258, "Guard", 0, "Aden", 0, "LineageNPC.a_guard_MHuman", 8, 24, 78, "male", "L2Defender", 80, 29743.56864, 4822.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 608, 1, 2671.50258, 332.70061, 608.09666, 243.45587, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35259, 35259, "Guard", 0, "Aden", 0, "LineageNPC.a_guard_MHuman", 8, 24, 78, "male", "L2Defender", 40, 29743.56864, 4822.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 608, 1, 2671.50258, 332.70061, 608.09666, 243.45587, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(35260, 35260, "Guard", 0, "Aden", 0, "LineageNPC.a_guard_MHuman", 8, 24, 78, "male", "L2Defender", 1100, 29743.56864, 4822.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 608, 1, 2671.50258, 332.70061, 608.09666, 243.45587, 253, 8, 333, 14, 0, 0, 50, 120, 0, 1), 
(35261, 35261, "Gatekeeper", 0, "Aden", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35262, 35262, "Gatekeeper", 0, "Aden", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35263, 35263, "Gatekeeper", 0, "Aden", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35264, 35264, "Gatekeeper", 0, "Aden", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35265, 35265, "Gatekeeper", 0, "Aden", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35266, 35266, "Mass Gatekeeper", 0, "Aden", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2CastleTeleporter", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35267, 35267, "Outer Doorman", 0, "Aden", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35268, 35268, "Inner Doorman", 0, "Aden", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35269, 35269, "Hall Doorman", 0, "Aden", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35270, 35270, "Inner Doorman", 0, "Aden", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35271, 35271, "Gatekeeper", 0, "Aden", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35272, 35272, "Blacksmith", 0, "Aden", 0, "LineageNPC.a_smith_MDwarf", 7, 16.5, 75, "male", "L2CastleBlacksmith", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 89, 0, 0, 50, 120, 0, 1), 
(35273, 35273, "Warehouse Keeper", 0, "Aden", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 75, "male", "L2CastleWarehouse", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35274, 35274, "Logan", 0, "Chamberlain", 0, "LineageNPC.a_chamberlain_MHuman", 9.5, 22.5, 75, "male", "L2CastleChamberlain", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35275, 35275, "Kruger", 0, "Wyvern Manager", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 75, "male", "L2CastleWyvernManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35276, 35276, "Eldon", 0, "Mercenary Manager", 0, "LineageNPC.a_common_peopleA_MHuman", 8, 21.5, 75, "male", "L2MercManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35277, 35277, "Manor Manager", 0, "Aden", 0, "LineageNPC.a_chamberlain_MHuman", 9.5, 22.5, 75, "male", "L2ManorManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35278, 35278, "Messenger Ruford", 0, "Messenger", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2SiegeNpc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 135, 0, 0, 50, 160, 0, 1), 
(35279, 35279, "Innadril Holy Artifact", 0, "", 0, "LineageNPC.castle_kent_statue_jewel", 25, 98, 20, "etc", "L2Artefact", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 40, 10, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35280, 35280, "Baron Lionel Hunter", 0, "", 0, "LineageNPC.a_lord_MHuman", 7, 23, 83, "male", "L2Defender", 40, 38355.906059, 5332.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 689, 1, 3298.27085, 353.86144, 750.76381, 258.94045, 253, 4, 333, 79, 0, 0, 50, 120, 0, 1), 
(35281, 35281, "Schaht", 0, "Sir", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 81, "male", "L2Defender", 40, 34617.725322, 5126.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 656, 1, 3036.96805, 345.61127, 691.28516, 252.90333, 253, 4, 333, 142, 0, 0, 50, 120, 0, 1), 
(35282, 35282, "Royal Knight", 0, "Innadril", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 79, "male", "L2Defender", 40, 3127.824593, 1641, 8.5, 3, 40, 43, 30, 21, 20, 20, 624, 1, 929.93081, 337.07008, 635.0222, 246.65326, 253, 4, 333, 76, 2497, 0, 50, 120, 0, 1), 
(35283, 35283, "Court Sorcerer", 0, "Innadril", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 77, "male", "L2Defender", 40, 2856.768726, 1574, 8.5, 3, 22, 27, 21, 41, 20, 20, 593, 1, 856.44056, 328.27073, 584.83789, 240.21427, 253, 1, 333, 325, 0, 0, 50, 120, 0, 1), 
(35284, 35284, "Court Sorcerer", 0, "Innadril", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 77, "female", "L2Defender", 40, 2856.768726, 1574, 8.5, 3, 22, 27, 21, 41, 20, 20, 593, 1, 856.44056, 328.27073, 584.83789, 240.21427, 253, 1, 333, 193, 0, 0, 50, 120, 0, 1), 
(35285, 35285, "Court Guard", 0, "Innadril", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 77, "male", "L2Defender", 80, 2856.768726, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 593, 1, 856.44056, 328.27073, 584.83789, 240.21427, 253, 4, 333, 94, 0, 0, 50, 120, 0, 1), 
(35286, 35286, "Guard", 0, "Innadril", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35287, 35287, "Guard", 0, "Innadril", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 2499, 0, 0, 50, 120, 0, 1), 
(35288, 35288, "Guard", 0, "Innadril", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 276, 0, 0, 50, 120, 0, 1), 
(35289, 35289, "Guard", 0, "Innadril", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 75, "female", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35290, 35290, "Guard", 0, "Innadril", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 75, "female", "L2Defender", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(35291, 35291, "Guard", 0, "Innadril", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 75, "female", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 14, 0, 0, 50, 120, 0, 1), 
(35292, 35292, "Guard", 0, "Innadril", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35293, 35293, "Guard", 0, "Innadril", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2Defender", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(35294, 35294, "Guard", 0, "Innadril", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 14, 0, 0, 50, 120, 0, 1), 
(35295, 35295, "Royal Knight", 0, "Innadril", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 79, "male", "L2Defender", 40, 3127.824593, 1641, 8.5, 3, 40, 43, 30, 21, 20, 20, 624, 1, 929.93081, 337.07008, 635.0222, 246.65326, 253, 4, 333, 76, 2497, 0, 50, 120, 0, 1), 
(35296, 35296, "Court Sorcerer", 0, "Innadril", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 77, "male", "L2Defender", 40, 2856.768726, 1574, 8.5, 3, 22, 27, 21, 41, 20, 20, 593, 1, 856.44056, 328.27073, 584.83789, 240.21427, 253, 1, 333, 325, 0, 0, 50, 120, 0, 1), 
(35297, 35297, "Court Sorcerer", 0, "Innadril", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 77, "female", "L2Defender", 40, 2856.768726, 1574, 8.5, 3, 22, 27, 21, 41, 20, 20, 593, 1, 856.44056, 328.27073, 584.83789, 240.21427, 253, 1, 333, 193, 0, 0, 50, 120, 0, 1), 
(35298, 35298, "Court Guard", 0, "Innadril", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 77, "male", "L2Defender", 80, 2856.768726, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 593, 1, 856.44056, 328.27073, 584.83789, 240.21427, 253, 4, 333, 94, 0, 0, 50, 120, 0, 1), 
(35299, 35299, "Guard", 0, "Innadril", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 93, 0, 0, 50, 120, 0, 1), 
(35300, 35300, "Guard", 0, "Innadril", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 2499, 0, 0, 50, 120, 0, 1), 
(35301, 35301, "Guard", 0, "Innadril", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 276, 0, 0, 50, 120, 0, 1), 
(35302, 35302, "Guard", 0, "Innadril", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 75, "female", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35303, 35303, "Guard", 0, "Innadril", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 75, "female", "L2Defender", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(35304, 35304, "Guard", 0, "Innadril", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 75, "female", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 14, 0, 0, 50, 120, 0, 1), 
(35305, 35305, "Guard", 0, "Innadril", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35306, 35306, "Guard", 0, "Innadril", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2Defender", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(35307, 35307, "Guard", 0, "Innadril", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 14, 0, 0, 50, 120, 0, 1), 
(35308, 35308, "Gatekeeper", 0, "Innadril", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35309, 35309, "Gatekeeper", 0, "Innadril", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35310, 35310, "Gatekeeper", 0, "Innadril", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35311, 35311, "Mass Gatekeeper", 0, "Innadril", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2CastleTeleporter", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35312, 35312, "Outer Doorman", 0, "Innadril", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35313, 35313, "Inner Doorman", 0, "Innadril", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35314, 35314, "Blacksmith", 0, "Innadril", 0, "LineageNPC.a_smith_MDwarf", 7, 16.5, 75, "male", "L2CastleBlacksmith", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 89, 0, 0, 50, 120, 0, 1), 
(35315, 35315, "Warehouse Keeper", 0, "Innadril", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 75, "male", "L2CastleWarehouse", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35316, 35316, "Neurath", 0, "Chamberlain", 0, "LineageNPC.a_chamberlain_MHuman", 9.5, 22.5, 75, "male", "L2CastleChamberlain", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35317, 35317, "Tate", 0, "Wyvern Manager", 0, "LineageNPC.a_traderB_MHuman", 8, 25, 75, "male", "L2CastleWyvernManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35318, 35318, "Solinus", 0, "Mercenary Manager", 0, "LineageNPC.a_common_peopleA_MHuman", 8, 21.5, 75, "male", "L2MercManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35319, 35319, "Manor Manager", 0, "Innadril", 0, "LineageNPC.a_chamberlain_MHuman", 9.5, 22.5, 75, "male", "L2ManorManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35320, 35320, "Raybell", 0, "Sir", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2SiegeNpc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 74, 0, 0, 50, 160, 0, 1), 
(35322, 35322, "Altar of Fire", 0, "", 0, "LineageNPC.godad_holything", 34, 65, 20, "etc", "L2Artefact", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35323, 35323, "Altar of Water", 0, "", 0, "LineageNPC.godad_holything", 34, 65, 20, "etc", "L2Artefact", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35324, 35324, "Heinz", 0, "Royal Guard Captain", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 81, "male", "L2Defender", 40, 34617.725322, 5126.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 656, 1, 3036.96805, 345.61127, 691.28516, 252.90333, 253, 4, 333, 142, 0, 0, 50, 120, 0, 1), 
(35325, 35325, "Duke Mora Ken Abygail", 0, "", 0, "LineageNPC.a_lord_MHuman", 7, 23, 83, "male", "L2Defender", 40, 38355.906059, 5332.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 689, 1, 3298.27085, 353.86144, 750.76381, 258.94045, 253, 4, 333, 79, 0, 0, 50, 120, 0, 1), 
(35326, 35326, "Royal Knight", 0, "Goddard", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 79, "male", "L2Defender", 40, 3127.824593, 1641, 8.5, 3, 40, 43, 30, 21, 20, 20, 624, 1, 929.93081, 337.07008, 635.0222, 246.65326, 253, 4, 333, 76, 2497, 0, 50, 120, 0, 1), 
(35327, 35327, "Court Sorcerer", 0, "Goddard", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 77, "male", "L2Defender", 40, 2856.768726, 1574, 8.5, 3, 22, 27, 21, 41, 20, 20, 593, 1, 856.44056, 328.27073, 584.83789, 240.21427, 253, 1, 333, 325, 0, 0, 50, 120, 0, 1), 
(35328, 35328, "Court Sorcerer", 0, "Goddard", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 77, "female", "L2Defender", 40, 2856.768726, 1574, 8.5, 3, 22, 27, 21, 41, 20, 20, 593, 1, 856.44056, 328.27073, 584.83789, 240.21427, 253, 1, 333, 193, 0, 0, 50, 120, 0, 1), 
(35329, 35329, "Guard", 0, "Goddard", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 77, "male", "L2Defender", 80, 2856.768726, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 593, 1, 856.44056, 328.27073, 584.83789, 240.21427, 253, 4, 333, 1376, 0, 0, 50, 120, 0, 1), 
(35330, 35330, "Bodyguard", 0, "Goddard", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 93, 0, 0, 50, 120, 0, 1), 
(35331, 35331, "Bodyguard", 0, "Goddard", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 75, "male", "L2Defender", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(35332, 35332, "Bodyguard", 0, "Goddard", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 14, 0, 0, 50, 120, 0, 1), 
(35333, 35333, "Bodyguard", 0, "Goddard", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 75, "female", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35334, 35334, "Bodyguard", 0, "Goddard", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 75, "female", "L2Defender", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(35335, 35335, "Bodyguard", 0, "Goddard", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 75, "female", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 14, 0, 0, 50, 120, 0, 1), 
(35336, 35336, "Bodyguard", 0, "Goddard", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35337, 35337, "Bodyguard", 0, "Goddard", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2Defender", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(35338, 35338, "Bodyguard", 0, "Goddard", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 280, 0, 0, 50, 120, 0, 1), 
(35339, 35339, "Royal Knight", 0, "Goddard", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 79, "male", "L2Defender", 40, 3127.824593, 1641, 8.5, 3, 40, 43, 30, 21, 20, 20, 624, 1, 929.93081, 337.07008, 635.0222, 246.65326, 253, 4, 333, 76, 2497, 0, 50, 120, 0, 1), 
(35340, 35340, "Court Sorcerer", 0, "Goddard", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 77, "male", "L2Defender", 40, 2856.768726, 1574, 8.5, 3, 22, 27, 21, 41, 20, 20, 593, 1, 856.44056, 328.27073, 584.83789, 240.21427, 253, 1, 333, 325, 0, 0, 50, 120, 0, 1), 
(35341, 35341, "Court Sorcerer", 0, "Goddard", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 77, "female", "L2Defender", 40, 2856.768726, 1574, 8.5, 3, 22, 27, 21, 41, 20, 20, 593, 1, 856.44056, 328.27073, 584.83789, 240.21427, 253, 1, 333, 193, 0, 0, 50, 120, 0, 1), 
(35342, 35342, "Guard", 0, "Goddard", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 77, "male", "L2Defender", 80, 2856.768726, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 593, 1, 856.44056, 328.27073, 584.83789, 240.21427, 253, 4, 333, 1376, 0, 0, 50, 120, 0, 1), 
(35343, 35343, "Bodyguard", 0, "Goddard", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 93, 0, 0, 50, 120, 0, 1), 
(35344, 35344, "Bodyguard", 0, "Goddard", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 75, "male", "L2Defender", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(35345, 35345, "Bodyguard", 0, "Goddard", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 14, 0, 0, 50, 120, 0, 1), 
(35346, 35346, "Bodyguard", 0, "Goddard", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 75, "female", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35347, 35347, "Bodyguard", 0, "Goddard", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 75, "female", "L2Defender", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(35348, 35348, "Bodyguard", 0, "Goddard", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 75, "female", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 14, 0, 0, 50, 120, 0, 1), 
(35349, 35349, "Bodyguard", 0, "Goddard", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35350, 35350, "Bodyguard", 0, "Goddard", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Defender", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 76, 0, 0, 50, 120, 0, 1), 
(35351, 35351, "Bodyguard", 0, "Goddard", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 1, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 280, 0, 0, 50, 120, 0, 1), 
(35352, 35352, "Gatekeeper", 0, "Goddard", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35353, 35353, "Gatekeeper", 0, "Goddard", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35354, 35354, "Gatekeeper", 0, "Goddard", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35355, 35355, "Mass Gatekeeper", 0, "Goddard", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2CastleTeleporter", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35356, 35356, "Outer Doorman", 0, "Goddard", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35357, 35357, "Inner Doorman", 0, "Goddard", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35358, 35358, "Inner Doorman", 0, "Goddard", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35359, 35359, "Gatekeeper", 0, "Goddard", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35360, 35360, "Gatekeeper", 0, "Goddard", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35361, 35361, "Blacksmith", 0, "Goddard", 0, "LineageNPC.a_smith_MDwarf", 7, 16.5, 75, "male", "L2CastleBlacksmith", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 89, 0, 0, 50, 120, 0, 1), 
(35362, 35362, "Warehouse Keeper", 0, "Goddard", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 75, "male", "L2CastleWarehouse", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35363, 35363, "Alfred", 0, "Chamberlain", 0, "LineageNPC.a_chamberlain_MHuman", 9.5, 22.5, 75, "male", "L2CastleChamberlain", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35364, 35364, "Hadley", 0, "Wyvern Manager", 0, "LineageNPC.a_common_peopleC_Mhuman", 10, 24, 75, "male", "L2WyvernManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35365, 35365, "Rowell", 0, "Manager of Mercenary", 0, "LineageNPC.a_common_peopleC_Mhuman", 10, 24, 75, "male", "L2MercManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35366, 35366, "Manor Manager", 0, "Goddard", 0, "LineageNPC.a_chamberlain_MHuman", 9.5, 22.5, 75, "male", "L2ManorManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35367, 35367, "Daven", 0, "Messenger", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2SiegeNpc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 74, 0, 0, 50, 160, 0, 1), 
(35368, 35368, "Bloody Lord Nurka", 0, "", 0, "LineageMonster.oel_mahum", 20, 37, 73, "male", "L2Monster", 40, 1150000, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 2665, 1, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 72, 0, 0, 70, 110, 0, 1), 
(35369, 35369, "Partisan Healer", 0, "", 0, "LineageMonster.batur_orc_shaman", 11, 16, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 2450, 1, 688.86373, 295.91597, 470.40463, 216.53847, 253, 1, 333, 7, 0, 0, 50, 120, 0, 1), 
(35370, 35370, "Partisan Court Guard", 0, "", 0, "LineageMonster.ol_mahum_champion", 14, 27, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 2450, 1, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 69, 0, 0, 50, 110, 0, 1), 
(35371, 35371, "Partisan Court Guard", 0, "", 0, "LineageMonster.ol_mahum_archer", 14, 25, 70, "male", "L2Monster", 1100, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 2450, 1, 688.86373, 295.91597, 470.40463, 216.53847, 253, 8, 333, 14, 0, 0, 50, 110, 0, 1), 
(35372, 35372, "Partisan Soldier", 0, "", 0, "LineageMonster.ol_mahum", 13.5, 25, 68, "male", "L2Monster", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 2312, 1, 646.17968, 286.3615, 441.25696, 209.54692, 253, 4, 333, 2, 0, 0, 50, 110, 0, 1), 
(35373, 35373, "Partisan Sorcerer", 0, "", 0, "LineageMonster.batur_orc_shaman", 11, 16, 68, "male", "L2Monster", 40, 2345.76698, 1282.4, 7.5, 2.7, 22, 27, 21, 41, 20, 20, 2312, 1, 646.17968, 286.3615, 441.25696, 209.54692, 253, 1, 333, 7, 0, 0, 50, 120, 0, 1), 
(35374, 35374, "Partisan Archer", 0, "", 0, "LineageMonster.ol_mahum_archer", 14, 25, 68, "male", "L2Monster", 1100, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 2312, 1, 646.17968, 286.3615, 441.25696, 209.54692, 253, 8, 333, 14, 0, 0, 50, 110, 0, 1), 
(35375, 35375, "Bloody Lord Nurka", 0, "", 0, "LineageMonster.oel_mahum", 20, 37, 73, "male", "L2Monster", 40, 1150000, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 2665, 1, 752.73928, 310.02959, 514.02335, 226.8662, 253, 4, 333, 72, 0, 0, 70, 110, 0, 1), 
(35376, 35376, "Partisan Healer", 0, "", 0, "LineageMonster.batur_orc_shaman", 11, 16, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 22, 27, 21, 41, 20, 20, 2450, 1, 688.86373, 295.91597, 470.40463, 216.53847, 253, 1, 333, 7, 0, 0, 50, 120, 0, 1), 
(35377, 35377, "Partisan Court Guard", 0, "", 0, "LineageMonster.ol_mahum_champion", 14, 27, 70, "male", "L2Monster", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 2450, 1, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 69, 0, 0, 50, 110, 0, 1), 
(35378, 35378, "Partisan Court Guard", 0, "", 0, "LineageMonster.ol_mahum_archer", 14, 25, 70, "male", "L2Monster", 1100, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 2450, 1, 688.86373, 295.91597, 470.40463, 216.53847, 253, 8, 333, 14, 0, 0, 50, 110, 0, 1), 
(35379, 35379, "Partisan Soldier", 0, "", 0, "LineageMonster.ol_mahum", 13.5, 25, 68, "male", "L2Monster", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 2312, 1, 646.17968, 286.3615, 441.25696, 209.54692, 253, 4, 333, 2, 0, 0, 50, 110, 0, 1), 
(35380, 35380, "Partisan Sorcerer", 0, "", 0, "LineageMonster.batur_orc_shaman", 11, 16, 68, "male", "L2Monster", 40, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 2312, 1, 646.17968, 286.3615, 441.25696, 209.54692, 253, 1, 333, 7, 0, 0, 50, 120, 0, 1), 
(35381, 35381, "Partisan Archer", 0, "", 0, "LineageMonster.ol_mahum_archer", 14, 25, 68, "male", "L2Monster", 1100, 2345.76698, 1282.4, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 2312, 1, 646.17968, 286.3615, 441.25696, 209.54692, 253, 8, 333, 14, 0, 0, 50, 110, 0, 1), 
(35382, 35382, "Brakel", 0, "Partisan Herald", 0, "LineageMonster.ol_mahum_champion", 14, 27, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35383, 35383, "Tamutak", 0, "Ol Mahum Steward", 0, "LineageMonster.ol_mahum_champion", 14, 27, 70, "male", "L2ClanHallManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35384, 35384, "Black", 0, "Clan Hall Manager", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35385, 35385, "Renny", 0, "Clan Hall Gatekeeper", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallDoormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35386, 35386, "Boyer", 0, "Clan Hall Manager", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35387, 35387, "Baback", 0, "Clan Hall Gatekeeper", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallDoormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35388, 35388, "Tim", 0, "Clan Hall Manager", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35389, 35389, "Loring", 0, "Clan Hall Gatekeeper", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallDoormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35390, 35390, "Dillon", 0, "Clan Hall Manager", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35391, 35391, "Latif", 0, "Clan Hall Gatekeeper", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallDoormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35392, 35392, "Bremmer", 0, "Clan Hall Manager", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35393, 35393, "Faolan", 0, "Clan Hall Gatekeeper", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallDoormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35394, 35394, "Kalis", 0, "Clan Hall Manager", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35395, 35395, "Kogan", 0, "Clan Hall Gatekeeper", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallDoormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35396, 35396, "Winker", 0, "Clan Hall Manager", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35397, 35397, "Merton", 0, "Clan Hall Gatekeeper", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallDoormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35398, 35398, "Ruben", 0, "Clan Hall Manager", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35399, 35399, "Luce", 0, "Clan Hall Gatekeeper", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallDoormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35400, 35400, "Horner", 0, "Clan Hall Manager", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35401, 35401, "Amiel", 0, "Clan Hall Gatekeeper", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallDoormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35402, 35402, "Borna", 0, "Clan Hall Gatekeeper", 0, "LineageNpc2.agit_maid_a", 9, 22.25, 70, "female", "L2ClanHallDoormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35403, 35403, "Ron", 0, "Clan Hall Manager", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35404, 35404, "Jamal", 0, "Clan Hall Gatekeeper", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallDoormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35405, 35405, "Flynn", 0, "Clan Hall Manager", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35406, 35406, "Jabilo", 0, "Clan Hall Gatekeeper", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallDoormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35407, 35407, "Seth", 0, "Clan Hall Manager", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35408, 35408, "Dietrich", 0, "", 0, "LineageMonster.headless_knight", 21, 31, 76, "male", "L2Monster", 40, 2758.059233, 1540.8, 8.5, 3, 60, 57, 73, 76, 70, 80, 578, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 0, 0, 0, 70, 180, 0, 1), 
(35409, 35409, "Mikhail", 0, "", 0, "LineageMonster.headless_knight", 21, 31, 76, "male", "L2Monster", 40, 2758.059233, 1540.8, 8.5, 3, 60, 57, 73, 76, 70, 80, 578, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 0, 0, 0, 70, 180, 0, 1), 
(35410, 35410, "Gustav", 0, "", 0, "LineageMonster.headless_knight", 21, 31, 78, "male", "L2Monster", 40, 4137000, 1607.4, 8.5, 3, 60, 57, 73, 76, 70, 80, 608, 0, 1334.07646, 332.70061, 151.24704, 243.45587, 253, 4, 333, 0, 0, 0, 70, 180, 0, 1), 
(35411, 35411, "Doom Servant", 0, "", 0, "LineageMonster.hungry_spirit", 30, 40, 73, "male", "L2Defender", 40, 2586.66898, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 533, 0, 752.73928, 310.02959, 514.02335, 226.8662, 253, 1, 333, 0, 0, 0, 15, 120, 0, 1), 
(35412, 35412, "Doom Guard", 0, "", 0, "LineageMonster.hungry_spirit", 30, 40, 74, "male", "L2Defender", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 548, 0, 773.81598, 314.65987, 528.41601, 230.25444, 253, 1, 333, 0, 0, 0, 15, 120, 0, 1), 
(35413, 35413, "Doom Archer", 0, "", 0, "LineageMonster.skeleton_archer", 11, 27, 75, "male", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 286, 0, 0, 40, 140, 0, 1), 
(35414, 35414, "Doom Trooper", 0, "", 0, "LineageMonster.skeleton_pikeman", 10, 28, 76, "male", "L2Defender", 80, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 578, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 301, 0, 0, 50, 155, 0, 1), 
(35415, 35415, "Doom Warrior", 0, "", 0, "LineageMonster.skeleton_knight", 10, 25, 77, "male", "L2Defender", 40, 2856.768726, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 593, 0, 856.44056, 328.27073, 584.83789, 240.21427, 253, 8, 333, 71, 0, 0, 40, 160, 0, 1), 
(35416, 35416, "Doom Knight", 0, "", 0, "LineageMonster.death_blader", 15, 45, 78, "male", "L2Defender", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 608, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 1472, 0, 0, 100, 170, 0, 1), 
(35417, 35417, "Doorman of Hell", 0, "", 0, "LineageMonster.dwarf_ghost", 9, 16.5, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(35418, 35418, "Doorman of Hell", 0, "", 0, "LineageMonster.dwarf_ghost", 9, 16.5, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(35419, 35419, "Hephaeston", 0, "Wyvern Manager", 0, "LineageMonster.human_ghost", 8, 22, 75, "male", "L2WyvernManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(35420, 35420, "Loken", 0, "Messenger", 0, "LineageMonster.human_ghost", 8, 22, 75, "male", "L2SiegeNpc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 74, 0, 0, 80, 1, 0, 1), 
(35421, 35421, "Biggerstaff", 0, "Steward", 0, "LineageMonster.elf_ghost", 7, 21, 75, "male", "L2ClanHallManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(35422, 35422, "Flag of Winner", 0, "", 0, "LineageDeco.azit_a", 100, 72, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35423, 35423, "Red Flag", 0, "", 0, "LineageDeco.azit_b", 75, 55, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35424, 35424, "Yellow Flag", 0, "", 0, "LineageDeco.azit_b", 75, 55, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35425, 35425, "Green Flag", 0, "", 0, "LineageDeco.azit_b", 75, 55, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35426, 35426, "Blue Flag", 0, "", 0, "LineageDeco.azit_b", 75, 55, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35427, 35427, "Purple Flag", 0, "", 0, "LineageDeco.azit_b", 75, 55, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35428, 35428, "Oel Mahum Berserker", 0, "", 0, "LineageMonster.oel_mahum_warrior", 20, 38, 73, "male", "L2Defender", 40, 70386.644903, 2143.566667, 8.5, 3, 40, 43, 30, 21, 20, 20, 6395, 247, 293.99876, 1240.61871, 625.52928, 226.8662, 253, 4, 333, 0, 0, 0, 70, 140, 0, 1), 
(35429, 35429, "Oel Mahum Scout", 0, "", 0, "LineageMonster.oel_mahum_warrior", 20, 38, 73, "male", "L2Defender", 40, 31673.990206, 2143.566667, 8.5, 3, 40, 43, 30, 21, 20, 20, 6395, 247, 293.99876, 1240.61871, 625.52928, 226.8662, 253, 4, 333, 0, 0, 0, 70, 140, 0, 1), 
(35430, 35430, "Oel Mahum Leader", 0, "", 0, "LineageMonster.oel_mahum_witch_doctor", 15, 34, 73, "male", "L2Defender", 40, 35193.322451, 2143.566667, 8.5, 3, 40, 43, 30, 21, 20, 20, 6395, 247, 293.99876, 1240.61871, 625.52928, 226.8662, 253, 4, 333, 0, 0, 0, 70, 140, 0, 1), 
(35431, 35431, "Oel Mahum Cleric", 0, "", 0, "LineageMonster.oel_mahum_witch_doctor", 15, 34, 73, "male", "L2Defender", 40, 35193.322451, 2143.566667, 8.5, 3, 40, 43, 30, 21, 20, 20, 6395, 247, 293.99876, 1240.61871, 625.52928, 226.8662, 253, 4, 333, 0, 0, 0, 70, 140, 0, 1), 
(35432, 35432, "Oel Mahum Thief", 0, "", 0, "LineageMonster.oel_mahum_40_sm", 12, 19, 73, "male", "L2Defender", 40, 28154.657961, 2143.566667, 8.5, 3, 40, 43, 30, 21, 20, 20, 6395, 247, 293.99876, 1240.61871, 625.52928, 226.8662, 253, 4, 333, 0, 0, 0, 70, 140, 0, 1), 
(35433, 35433, "Inner Doorman", 0, "", 0, "LineageMonster.oel_mahum", 20, 37, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 70, 120, 0, 1), 
(35434, 35434, "Inner Doorman", 0, "", 0, "LineageMonster.oel_mahum", 20, 37, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 70, 120, 0, 1), 
(35435, 35435, "Outer Doorman", 0, "", 0, "LineageMonster.oel_mahum", 20, 37, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 70, 120, 0, 1), 
(35436, 35436, "Outer Doorman", 0, "", 0, "LineageMonster.oel_mahum", 20, 37, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 70, 120, 0, 1), 
(35437, 35437, "Messenger", 0, "", 0, "LineageMonster.oel_mahum", 20, 37, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 70, 120, 0, 1), 
(35438, 35438, "Chamberlain", 0, "", 0, "LineageMonster.oel_mahum", 20, 37, 75, "male", "L2ClanHallManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 563, 10, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 70, 120, 0, 1), 
(35439, 35439, "Carey", 0, "Clan Hall Manager", 0, "LineageNPC.a_maidB_FHuman", 8, 22, 70, "female", "L2ClanHallManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35440, 35440, "Daniel", 0, "Clan Hall Gatekeeper", 0, "LineageNPC.a_common_peopleB_MHuman", 8, 22, 70, "male", "L2ClanHallDoormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35441, 35441, "Dianne", 0, "Clan Hall Manager", 0, "LineageNPC.a_maidA_FHuman", 8, 20.5, 70, "female", "L2ClanHallManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35442, 35442, "Jacques", 0, "Clan Hall Gatekeeper", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallDoormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35443, 35443, "Crissy", 0, "Clan Hall Manager", 0, "LineageNPC.a_common_peopleB_FHuman", 8, 20.5, 70, "female", "L2ClanHallManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35444, 35444, "Joff", 0, "Clan Hall Gatekeeper", 0, "LineageNPC.a_common_peopleB_MHuman", 8, 22, 70, "male", "L2ClanHallDoormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35445, 35445, "Albert", 0, "Clan Hall Manager", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35446, 35446, "Niels", 0, "Clan Hall Gatekeeper", 0, "LineageNPC.a_common_peopleB_MHuman", 8, 22, 70, "male", "L2ClanHallDoormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35447, 35447, "Korgen", 0, "Clan Hall Manager", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35448, 35448, "Rudy", 0, "Clan Hall Gatekeeper", 0, "LineageNPC.a_common_peopleB_MHuman", 8, 22, 70, "male", "L2ClanHallDoormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35449, 35449, "DiMaggio", 0, "Clan Hall Manager", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35450, 35450, "Gellar", 0, "Clan Hall Gatekeeper", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallDoormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35451, 35451, "Emma", 0, "Clan Hall Manager", 0, "LineageNPC.a_common_peopleB_FHuman", 8, 20.5, 70, "female", "L2ClanHallManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35452, 35452, "Theobolt", 0, "Clan Hall Gatekeeper", 0, "LineageNPC.a_common_peopleB_MHuman", 8, 22, 70, "male", "L2ClanHallDoormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35453, 35453, "Adrienne", 0, "Clan Hall Manager", 0, "LineageNPC.a_maidA_FHuman", 8, 20.5, 70, "female", "L2ClanHallManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35454, 35454, "Rosconne", 0, "Clan Hall Gatekeeper", 0, "LineageNPC.a_common_peopleB_MHuman", 8, 22, 70, "male", "L2ClanHallDoormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35455, 35455, "Bianca", 0, "Clan Hall Manager", 0, "LineageNPC.a_maidB_FHuman", 8, 22, 70, "female", "L2ClanHallManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35456, 35456, "Stewart", 0, "Clan Hall Gatekeeper", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallDoormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35457, 35457, "Gladys", 0, "Clan Hall Manager", 0, "LineageNPC.a_maidA_FHuman", 8, 20.5, 70, "female", "L2ClanHallManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35458, 35458, "Theron", 0, "Clan Hall Gatekeeper", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallDoormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35459, 35459, "Regina", 0, "Clan Hall Manager", 0, "LineageNPC.a_maidB_FHuman", 8, 22, 70, "female", "L2ClanHallManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35460, 35460, "Trey", 0, "Clan Hall Gatekeeper", 0, "LineageNPC.a_common_peopleB_MHuman", 8, 22, 70, "male", "L2ClanHallDoormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35461, 35461, "Aida", 0, "Clan Hall Manager", 0, "LineageNpc2.agit_maid_c", 6.5, 17.7, 70, "female", "L2ClanHallManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35462, 35462, "Kalmer", 0, "Clan Hall Gatekeeper", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallDoormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35463, 35463, "Helga", 0, "Clan Hall Manager", 0, "LineageNPC.a_common_peopleB_FHuman", 8, 20.5, 70, "female", "L2ClanHallManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35464, 35464, "Volfrem", 0, "Clan Hall Gatekeeper", 0, "LineageNPC.a_common_peopleB_MHuman", 8, 22, 70, "male", "L2ClanHallDoormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35465, 35465, "Millicent", 0, "Clan Hall Manager", 0, "LineageNPC.a_common_peopleB_FHuman", 8, 20.5, 70, "female", "L2ClanHallManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35466, 35466, "Gerard", 0, "Clan Hall Gatekeeper", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallDoormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35467, 35467, "Branhillde", 0, "Clan Hall Manager", 0, "LineageNPC.a_traderC_Fhuman", 8, 22.5, 70, "female", "L2ClanHallManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35468, 35468, "Lambert", 0, "Clan Hall Gatekeeper", 0, "LineageNPC.a_common_peopleB_MHuman", 8, 22, 70, "male", "L2ClanHallDoormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35469, 35469, "Gods' Altar", 0, "", 0, "LineageNpcEV.rune_holything", 46, 72.5, 20, "etc", "L2Artefact", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35470, 35470, "Astair van Halter", 0, "King", 0, "LineageNPC.a_lord_MHuman", 7, 23, 85, "male", "L2Defender", 40, 42340.631269, 5540.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 3566.61778, 361.78814, 811.84586, 264.74086, 253, 4, 333, 80, 0, 0, 50, 120, 0, 1), 
(35471, 35471, "Royal Knight", 0, "Rune", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 81, "male", "L2Defender", 40, 34617.725322, 5126.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 3036.96805, 345.61127, 691.28516, 252.90333, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(35472, 35472, "Court Sorcerer", 0, "Rune", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 79, "male", "L2Defender", 40, 31278.245933, 4923, 8.5, 3, 22, 27, 21, 41, 20, 20, 0, 0, 2789.79244, 337.07008, 635.0222, 246.65326, 253, 1, 333, 7, 0, 0, 50, 120, 0, 1), 
(35473, 35473, "Court Sorcerer", 0, "Rune", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 79, "female", "L2Defender", 40, 31278.245933, 4923, 8.5, 3, 22, 27, 21, 41, 20, 20, 0, 0, 2789.79244, 337.07008, 635.0222, 246.65326, 253, 1, 333, 92, 0, 0, 50, 120, 0, 1), 
(35474, 35474, "Court Guard", 0, "Rune", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 79, "male", "L2Defender", 80, 31278.245933, 4923, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2789.79244, 337.07008, 635.0222, 246.65326, 253, 4, 333, 1376, 0, 0, 50, 120, 0, 1), 
(35475, 35475, "Guard", 0, "Rune", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 78, "male", "L2Defender", 80, 29743.56864, 4822.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2671.50258, 332.70061, 608.09666, 243.45587, 253, 4, 333, 300, 0, 0, 50, 120, 0, 1), 
(35476, 35476, "Guard", 0, "Rune", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 78, "male", "L2Defender", 40, 29743.56864, 4822.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2671.50258, 332.70061, 608.09666, 243.45587, 253, 4, 333, 132, 0, 0, 50, 120, 0, 1), 
(35477, 35477, "Guard", 0, "Rune", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 78, "male", "L2Defender", 1100, 29743.56864, 4822.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2671.50258, 332.70061, 608.09666, 243.45587, 253, 8, 333, 14, 0, 0, 50, 120, 0, 1), 
(35478, 35478, "Guard", 0, "Rune", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 78, "female", "L2Defender", 80, 29743.56864, 4822.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2671.50258, 332.70061, 608.09666, 243.45587, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35479, 35479, "Guard", 0, "Rune", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 78, "female", "L2Defender", 40, 29743.56864, 4822.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2671.50258, 332.70061, 608.09666, 243.45587, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(35480, 35480, "Guard", 0, "Rune", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 78, "female", "L2Defender", 1100, 29743.56864, 4822.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2671.50258, 332.70061, 608.09666, 243.45587, 253, 8, 333, 14, 0, 0, 50, 120, 0, 1), 
(35481, 35481, "Guard", 0, "Rune", 0, "LineageNPC.e_guard_MOrc", 8, 27, 78, "male", "L2Defender", 80, 29743.56864, 4822.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2671.50258, 332.70061, 608.09666, 243.45587, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35482, 35482, "Guard", 0, "Rune", 0, "LineageNPC.e_guard_MOrc", 8, 27, 78, "male", "L2Defender", 40, 29743.56864, 4822.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2671.50258, 332.70061, 608.09666, 243.45587, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(35483, 35483, "Guard", 0, "Rune", 0, "LineageNPC.a_guard_MHuman", 8, 24, 78, "male", "L2Defender", 1100, 29743.56864, 4822.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2671.50258, 332.70061, 608.09666, 243.45587, 253, 8, 333, 14, 0, 0, 50, 120, 0, 1), 
(35484, 35484, "Royal Knight", 0, "Rune", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 81, "male", "L2Defender", 40, 34617.725322, 5126.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 3036.96805, 345.61127, 691.28516, 252.90333, 253, 4, 333, 142, 633, 0, 50, 120, 0, 1), 
(35485, 35485, "Court Sorcerer", 0, "Rune", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 79, "male", "L2Defender", 40, 31278.245933, 4923, 8.5, 3, 22, 27, 21, 41, 20, 20, 0, 0, 2789.79244, 337.07008, 635.0222, 246.65326, 253, 1, 333, 326, 0, 0, 50, 120, 0, 1), 
(35486, 35486, "Court Sorcerer", 0, "Rune", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 79, "female", "L2Defender", 40, 31278.245933, 4923, 8.5, 3, 22, 27, 21, 41, 20, 20, 0, 0, 2789.79244, 337.07008, 635.0222, 246.65326, 253, 1, 333, 325, 0, 0, 50, 120, 0, 1), 
(35487, 35487, "Court Guard", 0, "Rune", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 79, "male", "L2Defender", 80, 31278.245933, 4923, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2789.79244, 337.07008, 635.0222, 246.65326, 253, 4, 333, 300, 0, 0, 50, 120, 0, 1), 
(35488, 35488, "Guard", 0, "Rune", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 78, "male", "L2Defender", 80, 29743.56864, 4822.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2671.50258, 332.70061, 608.09666, 243.45587, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35489, 35489, "Guard", 0, "Rune", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 78, "male", "L2Defender", 40, 29743.56864, 4822.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2671.50258, 332.70061, 608.09666, 243.45587, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(35490, 35490, "Guard", 0, "Rune", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 78, "male", "L2Defender", 1100, 29743.56864, 4822.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2671.50258, 332.70061, 608.09666, 243.45587, 253, 8, 333, 285, 0, 0, 50, 120, 0, 1), 
(35491, 35491, "Guard", 0, "Rune", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 78, "female", "L2Defender", 80, 29743.56864, 4822.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2671.50258, 332.70061, 608.09666, 243.45587, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35492, 35492, "Guard", 0, "Rune", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 78, "female", "L2Defender", 40, 29743.56864, 4822.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2671.50258, 332.70061, 608.09666, 243.45587, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(35493, 35493, "Guard", 0, "Rune", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 78, "female", "L2Defender", 1100, 29743.56864, 4822.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2671.50258, 332.70061, 608.09666, 243.45587, 253, 8, 333, 14, 0, 0, 50, 120, 0, 1), 
(35494, 35494, "Guard", 0, "Rune", 0, "LineageNPC.e_guard_MOrc", 8, 27, 78, "male", "L2Defender", 80, 29743.56864, 4822.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2671.50258, 332.70061, 608.09666, 243.45587, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35495, 35495, "Guard", 0, "Rune", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 78, "male", "L2Defender", 40, 29743.56864, 4822.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2671.50258, 332.70061, 608.09666, 243.45587, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(35496, 35496, "Guard", 0, "Rune", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 78, "male", "L2Defender", 1100, 29743.56864, 4822.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 2671.50258, 332.70061, 608.09666, 243.45587, 253, 8, 333, 14, 0, 0, 50, 120, 0, 1), 
(35497, 35497, "Gatekeeper", 0, "Rune", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35498, 35498, "Gatekeeper", 0, "Rune", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35499, 35499, "Gatekeeper", 0, "Rune", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35500, 35500, "Gatekeeper", 0, "Rune", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35501, 35501, "Gatekeeper", 0, "Rune", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35502, 35502, "Group Gatekeeper", 0, "Rune", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2CastleTeleporter", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35503, 35503, "Outer Doorman", 0, "Rune", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35504, 35504, "Inner Doorman", 0, "Rune", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35505, 35505, "Inner Doorman", 0, "Rune", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35506, 35506, "Dungeon Gatekeeper", 0, "Rune", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35507, 35507, "Blacksmith", 0, "Rune", 0, "LineageNPC.a_smith_MDwarf", 7, 16.5, 75, "male", "L2CastleBlacksmith", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 89, 0, 0, 50, 120, 0, 1), 
(35508, 35508, "Warehouse Keeper", 0, "Rune", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 75, "male", "L2CastleWarehouse", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35509, 35509, "Frederick", 0, "Chamberlain", 0, "LineageNPC.a_chamberlain_MHuman", 9.5, 22.5, 75, "male", "L2CastleChamberlain", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35510, 35510, "Titus", 0, "Wyvern Manager", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 75, "male", "L2CastleWyvernManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35511, 35511, "Gompus", 0, "Mercenary Manager", 0, "LineageNPC.a_common_peopleC_Mhuman", 10, 24, 75, "male", "L2MercManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35512, 35512, "Manor Manager", 0, "Rune", 0, "LineageNPC.a_chamberlain_MHuman", 9.5, 22.5, 75, "male", "L2ManorManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35513, 35513, "Sherman", 0, "Messenger", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2SiegeNpc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 135, 0, 0, 50, 160, 0, 1), 
(35514, 35514, "Altar of Wind", 0, "", 0, "LineageNPC.godad_holything", 34, 65, 20, "etc", "L2Artefact", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35515, 35515, "Altar of Earth", 0, "", 0, "LineageNPC.godad_holything", 34, 65, 20, "etc", "L2Artefact", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35516, 35516, "Verus", 0, "Royal Guard Captain", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 81, "male", "L2Defender", 40, 34617.725322, 5126.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 3036.96805, 345.61127, 691.28516, 252.90333, 253, 4, 333, 142, 0, 0, 50, 120, 0, 1), 
(35517, 35517, "Swain Ken Orwen", 0, "Count", 0, "LineageNPC.a_lord_MHuman", 7, 23, 83, "male", "L2Defender", 40, 38355.906059, 5332.2, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 3298.27085, 353.86144, 750.76381, 258.94045, 253, 4, 333, 79, 0, 0, 50, 120, 0, 1), 
(35518, 35518, "Royal Knight", 0, "Schuttgart", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 79, "male", "L2Defender", 40, 3127.824593, 1641, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 929.93081, 337.07008, 635.0222, 246.65326, 253, 4, 333, 76, 2497, 0, 50, 120, 0, 1), 
(35519, 35519, "Court Sorcerer", 0, "Schuttgart", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 77, "male", "L2Defender", 40, 2856.768726, 1574, 8.5, 3, 22, 27, 21, 41, 20, 20, 0, 0, 856.44056, 328.27073, 584.83789, 240.21427, 253, 1, 333, 325, 0, 0, 50, 120, 0, 1), 
(35520, 35520, "Court Sorcerer", 0, "Schuttgart", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 77, "female", "L2Defender", 40, 2856.768726, 1574, 8.5, 3, 22, 27, 21, 41, 20, 20, 0, 0, 856.44056, 328.27073, 584.83789, 240.21427, 253, 1, 333, 193, 0, 0, 50, 120, 0, 1), 
(35521, 35521, "Court Guard", 0, "Schuttgart", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 77, "male", "L2Defender", 80, 2856.768726, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 856.44056, 328.27073, 584.83789, 240.21427, 253, 4, 333, 1376, 0, 0, 50, 120, 0, 1), 
(35522, 35522, "Guard", 0, "Schuttgart", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 93, 0, 0, 50, 120, 0, 1), 
(35523, 35523, "Guard", 0, "Schuttgart", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 75, "male", "L2Defender", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(35524, 35524, "Guard", 0, "Schuttgart", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 14, 0, 0, 50, 120, 0, 1), 
(35525, 35525, "Guard", 0, "Schuttgart", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 75, "female", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35526, 35526, "Guard", 0, "Schuttgart", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 75, "female", "L2Defender", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(35527, 35527, "Guard", 0, "Schuttgart", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 75, "female", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 14, 0, 0, 50, 120, 0, 1), 
(35528, 35528, "Guard", 0, "Schuttgart", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35529, 35529, "Guard", 0, "Schuttgart", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2Defender", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(35530, 35530, "Guard", 0, "Schuttgart", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 280, 0, 0, 50, 120, 0, 1), 
(35531, 35531, "Royal Knight", 0, "Schuttgart", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 79, "male", "L2Defender", 40, 3127.824593, 1641, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 929.93081, 337.07008, 635.0222, 246.65326, 253, 4, 333, 76, 2497, 0, 50, 120, 0, 1), 
(35532, 35532, "Court Sorcerer", 0, "Schuttgart", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 77, "male", "L2Defender", 40, 2856.768726, 1574, 8.5, 3, 22, 27, 21, 41, 20, 20, 0, 0, 856.44056, 328.27073, 584.83789, 240.21427, 253, 1, 333, 325, 0, 0, 50, 120, 0, 1), 
(35533, 35533, "Court Sorcerer", 0, "Schuttgart", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 77, "female", "L2Defender", 40, 2856.768726, 1574, 8.5, 3, 22, 27, 21, 41, 20, 20, 0, 0, 856.44056, 328.27073, 584.83789, 240.21427, 253, 1, 333, 193, 0, 0, 50, 120, 0, 1), 
(35534, 35534, "Court Guard", 0, "Schuttgart", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 77, "male", "L2Defender", 80, 2856.768726, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 856.44056, 328.27073, 584.83789, 240.21427, 253, 4, 333, 1376, 0, 0, 50, 120, 0, 1), 
(35535, 35535, "Guard", 0, "Schuttgart", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 93, 0, 0, 50, 120, 0, 1), 
(35536, 35536, "Guard", 0, "Schuttgart", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 75, "male", "L2Defender", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(35537, 35537, "Guard", 0, "Schuttgart", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 14, 0, 0, 50, 120, 0, 1), 
(35538, 35538, "Guard", 0, "Schuttgart", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 75, "female", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35539, 35539, "Guard", 0, "Schuttgart", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 75, "female", "L2Defender", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 2, 0, 0, 50, 120, 0, 1), 
(35540, 35540, "Guard", 0, "Schuttgart", 0, "LineageNPC.a_guard_FDarkelf", 7, 25, 75, "female", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 14, 0, 0, 50, 120, 0, 1), 
(35541, 35541, "Guard", 0, "Schuttgart", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 16, 0, 0, 50, 120, 0, 1), 
(35542, 35542, "Guard", 0, "Schuttgart", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Defender", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 76, 0, 0, 50, 120, 0, 1), 
(35543, 35543, "Guard", 0, "Schuttgart", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 280, 0, 0, 50, 120, 0, 1), 
(35544, 35544, "Gatekeeper", 0, "Schuttgart", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35545, 35545, "Gatekeeper", 0, "Schuttgart", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35546, 35546, "Gatekeeper", 0, "Schuttgart", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35547, 35547, "Group Gatekeeper", 0, "Schuttgart", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2CastleTeleporter", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35548, 35548, "Outer Doorman", 0, "Schuttgart", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35549, 35549, "Inner Doorman", 0, "Schuttgart", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35550, 35550, "Inner Doorman", 0, "Schuttgart", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35551, 35551, "Doorman", 0, "Schuttgart", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35552, 35552, "Doorman", 0, "Schuttgart", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35553, 35553, "Blacksmith", 0, "Schuttgart", 0, "LineageNPC.a_smith_MDwarf", 7, 16.5, 75, "male", "L2CastleBlacksmith", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 89, 0, 0, 50, 120, 0, 1), 
(35554, 35554, "Warehouse Keeper", 0, "Schuttgart", 0, "LineageNPC.a_warehouse_keeper_MDwarf", 8, 17, 75, "male", "L2CastleWarehouse", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35555, 35555, "August", 0, "Chamberlain", 0, "LineageNPC.a_chamberlain_MHuman", 9.5, 22.5, 75, "male", "L2CastleChamberlain", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35556, 35556, "Gallic", 0, "Wyvern Manager", 0, "LineageNPC.a_common_peopleC_Mhuman", 10, 24, 75, "male", "L2CastleWyvernManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35557, 35557, "Kendrew", 0, "Mercenary Manager", 0, "LineageNPC.a_common_peopleC_Mhuman", 10, 24, 75, "male", "L2MercManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35558, 35558, "Manor Manager", 0, "Schuttgart", 0, "LineageNPC.a_chamberlain_MHuman", 9.5, 22.5, 75, "male", "L2ManorManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35559, 35559, "Daguerre", 0, "Messenger", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2SiegeNpc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 74, 0, 0, 50, 160, 0, 1), 
(35560, 35560, "Mass Gatekeeper", 0, "", 0, "LineageMonster.oel_mahum", 20, 37, 56, "male", "L2Teleporter", 40, 1724.6831, 918.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 405.96455, 228.40135, 277.22116, 167.1342, 253, 4, 333, 0, 0, 0, 70, 120, 0, 1), 
(35561, 35561, "Mass Gatekeeper", 0, "", 0, "LineageMonster.oel_mahum", 20, 37, 56, "male", "L2Teleporter", 40, 1724.6831, 918.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 405.96455, 228.40135, 277.22116, 167.1342, 253, 4, 333, 0, 0, 0, 70, 120, 0, 1), 
(35562, 35562, "Mass Gatekeeper", 0, "", 0, "LineageMonster.oel_mahum", 20, 37, 56, "male", "L2Teleporter", 40, 1724.6831, 918.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 405.96455, 228.40135, 277.22116, 167.1342, 253, 4, 333, 0, 0, 0, 70, 120, 0, 1), 
(35563, 35563, "Mass Gatekeeper", 0, "", 0, "LineageMonster.oel_mahum", 20, 37, 56, "male", "L2Teleporter", 40, 1724.6831, 918.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 405.96455, 228.40135, 277.22116, 167.1342, 253, 4, 333, 0, 0, 0, 70, 120, 0, 1), 
(35564, 35564, "Mass Gatekeeper", 0, "", 0, "LineageMonster.oel_mahum", 20, 37, 56, "male", "L2Teleporter", 40, 1724.6831, 918.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 405.96455, 228.40135, 277.22116, 167.1342, 253, 4, 333, 0, 0, 0, 70, 120, 0, 1), 
(35565, 35565, "Mass Gatekeeper", 0, "", 0, "LineageMonster.oel_mahum", 20, 37, 56, "male", "L2Teleporter", 40, 1724.6831, 918.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 405.96455, 228.40135, 277.22116, 167.1342, 253, 4, 333, 0, 0, 0, 70, 120, 0, 1), 
(35566, 35566, "Ronald", 0, "Clan Hall Manager", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35567, 35567, "Emil", 0, "Clan Hall Gatekeeper", 0, "LineageNPC.a_common_peopleB_MHuman", 8, 22, 70, "male", "L2ClanHallDoormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35568, 35568, "Wayne", 0, "Clan Hall Manager", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35569, 35569, "Daniel", 0, "Clan Hall Gatekeeper", 0, "LineageNPC.a_common_peopleB_MHuman", 8, 22, 70, "male", "L2ClanHallDoormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35570, 35570, "Patty", 0, "Clan Hall Manager", 0, "LineageNpc2.agit_maid_a", 9, 22.25, 70, "female", "L2ClanHallManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35571, 35571, "Dale", 0, "Clan Hall Gatekeeper", 0, "LineageNPC.a_common_peopleB_MHuman", 8, 22, 70, "male", "L2ClanHallDoormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35572, 35572, "Jimmy", 0, "Clan Hall Manager", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35573, 35573, "Shawn", 0, "Clan Hall Gatekeeper", 0, "LineageNPC.a_common_peopleB_MHuman", 8, 22, 70, "male", "L2ClanHallDoormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35574, 35574, "Michael", 0, "Clan Hall Manager", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35575, 35575, "Ryan", 0, "Clan Hall Gatekeeper", 0, "LineageNPC.a_common_peopleB_MHuman", 8, 22, 70, "male", "L2ClanHallDoormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35576, 35576, "Jack", 0, "Clan Hall Manager", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35577, 35577, "Harry", 0, "Clan Hall Gatekeeper", 0, "LineageNPC.a_common_peopleB_MHuman", 8, 22, 70, "male", "L2ClanHallDoormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35578, 35578, "Karuto", 0, "Clan Hall Manager", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35579, 35579, "Egon", 0, "Clan Hall Gatekeeper", 0, "LineageNPC.a_common_peopleB_MHuman", 8, 22, 70, "male", "L2ClanHallDoormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35580, 35580, "Carol", 0, "Clan Hall Manager", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35581, 35581, "Osho", 0, "Clan Hall Gatekeeper", 0, "LineageNPC.a_common_peopleB_MHuman", 8, 22, 70, "male", "L2ClanHallDoormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35582, 35582, "Stanley", 0, "Clan Hall Manager", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35583, 35583, "Walter", 0, "Clan Hall Gatekeeper", 0, "LineageNPC.a_common_peopleB_MHuman", 8, 22, 70, "male", "L2ClanHallDoormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35584, 35584, "Billy", 0, "Clan Hall Manager", 0, "LineageNPC.a_casino_MHuman", 8, 23, 70, "male", "L2ClanHallManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35585, 35585, "Alice", 0, "Clan Hall Gatekeeper", 0, "LineageNpc2.agit_maid_a", 9, 22.25, 70, "female", "L2ClanHallDoormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35586, 35586, "Serena", 0, "Clan Hall Manager", 0, "LineageNPC.a_maidA_FHuman", 8, 20.5, 70, "female", "L2ClanHallManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35587, 35587, "Neria", 0, "Clan Hall Gatekeeper", 0, "LineageNpc2.agit_maid_c", 6.5, 17.7, 70, "female", "L2ClanHallDoormen", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35588, 35588, "Hot Springs Gourd", 0, "", 0, "LineageNPC.drop_gourd_50_bi", 34, 40, 56, "etc", "L2Npc", 40, 623000, 918.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 405.96455, 990000, 277.22116, 990000, 253, 1, 333, 0, 0, 0, 50, 100, 0, 1), 
(35589, 35589, "Hot Springs Gourd", 0, "", 0, "LineageNPC.drop_gourd_50_bi", 34, 40, 56, "etc", "L2Npc", 40, 623000, 918.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 405.96455, 990000, 277.22116, 990000, 253, 1, 333, 0, 0, 0, 50, 100, 0, 1), 
(35590, 35590, "Hot Springs Gourd", 0, "", 0, "LineageNPC.drop_gourd_50_bi", 34, 40, 56, "etc", "L2Npc", 40, 623000, 918.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 405.96455, 990000, 277.22116, 990000, 253, 1, 333, 0, 0, 0, 50, 100, 0, 1), 
(35591, 35591, "Hot Springs Gourd", 0, "", 0, "LineageNPC.drop_gourd_50_bi", 34, 40, 56, "etc", "L2Npc", 40, 623000, 918.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 405.96455, 990000, 277.22116, 990000, 253, 1, 333, 0, 0, 0, 50, 100, 0, 1), 
(35592, 35592, "Enraged Yeti", 0, "", 0, "LineageMonster.yeti", 15, 27.5, 56, "male", "L2Npc", 40, 1724.6831, 918.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 405.96455, 228.40135, 277.22116, 167.1342, 253, 4, 333, 0, 0, 0, 80, 170, 0, 1), 
(35593, 35593, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 52, "male", "L2Npc", 40, 1520.38155, 804, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 337.18867, 209.50106, 230.25615, 153.30378, 253, 4, 333, 0, 0, 0, 80, 156, 0, 1), 
(35594, 35594, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 52, "male", "L2Npc", 40, 1520.38155, 804, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 337.18867, 209.50106, 230.25615, 153.30378, 253, 4, 333, 0, 0, 0, 80, 156, 0, 1), 
(35595, 35595, "Treasure Chest", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 52, "male", "L2Npc", 40, 1520.38155, 804, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 337.18867, 209.50106, 230.25615, 153.30378, 253, 4, 333, 0, 0, 0, 80, 156, 0, 1), 
(35596, 35596, "Hot Springs Yeti", 0, "Maitre 'D", 0, "LineageNPC.yeti_cute", 5, 10.5, 56, "male", "L2Npc", 40, 1724.6831, 918.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 10000, 228.40135, 277.22116, 167.1342, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35597, 35597, "Hot Springs Yeti", 0, "Maitre 'D", 0, "LineageNPC.yeti_cute", 5, 10.5, 56, "male", "L2Npc", 40, 1724.6831, 918.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 10000, 228.40135, 277.22116, 167.1342, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35598, 35598, "Hot Springs Yeti", 0, "Maitre 'D", 0, "LineageNPC.yeti_cute", 5, 10.5, 56, "male", "L2Npc", 40, 1724.6831, 918.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 10000, 228.40135, 277.22116, 167.1342, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35599, 35599, "Hot Springs Yeti", 0, "Maitre 'D", 0, "LineageNPC.yeti_cute", 5, 10.5, 56, "male", "L2Npc", 40, 1724.6831, 918.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 10000, 228.40135, 277.22116, 167.1342, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35600, 35600, "Manager", 0, "", 0, "LineageNPC.yeti_cute", 5, 10.5, 56, "male", "L2Npc", 40, 1724.6831, 918.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 405.96455, 228.40135, 277.22116, 167.1342, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35601, 35601, "Doorman", 0, "", 0, "LineageNPC.yeti_cute", 5, 10.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35602, 35602, "Doorman", 0, "", 0, "LineageNPC.yeti_cute", 5, 10.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35603, 35603, "Coordinator", 0, "", 0, "LineageMonster.yeti", 15, 27.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(35604, 35604, "Messenger", 0, "", 0, "LineageNPC.yeti_cute", 5, 10.5, 56, "male", "L2Npc", 40, 1724.6831, 918.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 405.96455, 228.40135, 277.22116, 167.1342, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35605, 35605, "Angout", 0, "Steward", 0, "LineageMonster.yeti", 15, 27.5, 56, "male", "L2Npc", 40, 1724.6831, 918.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 405.96455, 228.40135, 277.22116, 167.1342, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(35606, 35606, "Victor's Flag", 0, "", 0, "LineageNpcEV.azit_contest_pile_winner", 63.5, 97.5, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35607, 35607, "Red Flag", 0, "", 0, "LineageNpcEV.azit_contest_pile_a", 51.8, 108.25, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35608, 35608, "Yellow Flag", 0, "", 0, "LineageNpcEV.azit_contest_pile_b", 51.8, 108.25, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35609, 35609, "Green Flag", 0, "", 0, "LineageNpcEV.azit_contest_pile_c", 51.8, 108.25, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35610, 35610, "Blue Flag", 0, "", 0, "LineageNpcEV.azit_contest_pile_d", 51.8, 108.25, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35611, 35611, "Purple Flag", 0, "", 0, "LineageNpcEV.azit_contest_pile_e", 51.8, 108.25, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35612, 35612, "Group Gatekeeper", 0, "", 0, "LineageMonster.kel_mahum", 13, 26, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35613, 35613, "Group Gatekeeper", 0, "", 0, "LineageMonster.kel_mahum", 13, 26, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35614, 35614, "Group Gatekeeper", 0, "", 0, "LineageMonster.kel_mahum", 13, 26, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35615, 35615, "Group Gatekeeper", 0, "", 0, "LineageMonster.kel_mahum", 13, 26, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35616, 35616, "Group Gatekeeper", 0, "", 0, "LineageMonster.kel_mahum", 13, 26, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35617, 35617, "Group Gatekeeper", 0, "", 0, "LineageMonster.kel_mahum", 13, 26, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35618, 35618, "Frenzied Cougar", 0, "", 0, "LineageMonster.saber_toothed_tiger", 34, 28, 73, "male", "L2Defender", 40, 70386.644903, 2143.566667, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 293.99876, 1240.61871, 625.52928, 226.8662, 253, 4, 333, 0, 0, 0, 60, 140, 0, 1), 
(35619, 35619, "Frenzied Buffalo", 0, "", 0, "LineageMonster2.buffalo", 22, 31, 73, "male", "L2Defender", 40, 31673.990206, 2143.566667, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 293.99876, 1240.61871, 625.52928, 226.8662, 253, 4, 333, 0, 0, 0, 80, 140, 0, 1), 
(35620, 35620, "Frenzied Kookaburra", 0, "", 0, "LineageMonster2.rough_ostrich", 10, 33, 73, "male", "L2Defender", 40, 35193.322451, 2143.566667, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 293.99876, 2481.23743, 625.52928, 226.8662, 253, 4, 333, 0, 0, 0, 23, 140, 0, 1), 
(35621, 35621, "Frenzied Buffalo Baby", 0, "", 0, "LineageMonster2.baby_buffalo", 8, 15, 73, "male", "L2Defender", 40, 35193.322451, 2143.566667, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 293.99876, 620.30936, 625.52928, 226.8662, 253, 4, 333, 0, 0, 0, 30, 140, 0, 1), 
(35622, 35622, "Frenzied Baby Cougar", 0, "", 0, "LineageMonster2.baby_tiger", 8, 15.7, 73, "male", "L2Defender", 40, 28154.657961, 2143.566667, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 235.19901, 992.49497, 625.52928, 226.8662, 253, 4, 333, 0, 0, 0, 28, 140, 0, 1), 
(35623, 35623, "Inner Doorman", 0, "", 0, "LineageMonster.kel_mahum_champion", 13, 32, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35624, 35624, "Inner Doorman", 0, "", 0, "LineageMonster.kel_mahum_champion", 13, 32, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35625, 35625, "Outer Doorman", 0, "", 0, "LineageMonster.kel_mahum_champion", 13, 32, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35626, 35626, "Outer Doorman", 0, "", 0, "LineageMonster.kel_mahum_champion", 13, 32, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35627, 35627, "Messenger", 0, "", 0, "LineageMonster.kel_mahum_champion", 13, 32, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35628, 35628, "Quigby", 0, "Farm Manager", 0, "LineageMonster.kel_mahum_champion", 13, 32, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35629, 35629, "Lidia von Hellmann", 0, "", 0, "LineageMonster3.lidia_von_helmann", 10, 25.4, 78, "female", "L2Monster", 40, 903214.015294, 1607.4, 37.3, 3, 60, 57, 73, 76, 70, 80, 0, 0, 1575.77421, 998.10183, 556.49512, 486.91174, 253, 4, 333, 8209, 0, 0, 20, 180, 0, 1), 
(35630, 35630, "Alfred von Hellmann", 0, "", 0, "LineageMonster3.Vampire_Troop_Leader", 19, 35, 77, "male", "L2Defender", 80, 110191.515554, 1574, 22.5, 3, 60, 57, 73, 76, 70, 80, 0, 0, 1440.03527, 984.81219, 124.1006, 480.42854, 253, 4, 333, 8679, 0, 0, 60, 180, 0, 1), 
(35631, 35631, "Giselle von Hellmann", 0, "", 0, "LineageMonster2.vampire_wizard", 5.5, 28, 77, "female", "L2Defender", 40, 110191.515554, 1574, 22.5, 3, 60, 57, 73, 76, 70, 80, 0, 0, 1440.03527, 984.81219, 124.1006, 480.42854, 253, 4, 333, 99, 0, 0, 46, 180, 0, 1), 
(35632, 35632, "Vampire Adept", 0, "", 0, "LineageMonster2.vampire_witch", 6, 21.5, 73, "female", "L2Defender", 40, 7144.075962, 1442.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1722.9305, 310.02959, 136.90452, 226.8662, 253, 8, 333, 946, 0, 0, 64, 120, 0, 1), 
(35633, 35633, "Vampire Soldier", 0, "", 0, "LineageMonster2.vampire_soldier", 8, 23.5, 74, "male", "L2Defender", 40, 7896.58908, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1709.62599, 314.65987, 528.41601, 230.25444, 253, 8, 333, 234, 0, 0, 60, 120, 0, 1), 
(35634, 35634, "Vampire Caster", 0, "", 0, "LineageMonster2.vampire_witch", 6, 21.5, 75, "female", "L2Defender", 1100, 8029.97562, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 3526.34866, 319.24623, 542.68324, 233.61053, 253, 8, 333, 946, 0, 0, 64, 140, 0, 1), 
(35635, 35635, "Vampire Magister", 0, "", 0, "LineageMonster2.vampire_wizard", 5.5, 28, 76, "female", "L2Defender", 40, 8274.1777, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1922.69132, 323.78455, 562.9734, 236.93149, 253, 4, 333, 99, 0, 0, 46, 155, 0, 1), 
(35636, 35636, "Vampire Warlord", 0, "", 0, "LineageMonster2.vampire_warrior", 9, 31.5, 77, "male", "L2Defender", 80, 8570.306177, 1574, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1712.88112, 328.27073, 584.83789, 240.21427, 253, 4, 333, 6723, 0, 0, 43, 160, 0, 1), 
(35637, 35637, "Vampire Leader", 0, "", 0, "LineageMonster2.vampire_lord", 7.5, 25.8, 78, "male", "L2Defender", 40, 8923.070592, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 1556.42254, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 15, 170, 0, 1), 
(35638, 35638, "Valens", 0, "Wyvern Manager", 0, "LineageMonster2.vampire_soldier", 8, 23.5, 75, "male", "L2WyvernManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(35639, 35639, "Jacquard", 0, "Messenger", 0, "LineageMonster2.vampire_soldier", 8, 23.5, 75, "male", "L2SiegeNpc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(35640, 35640, "Bandello", 0, "Steward", 0, "LineageMonster2.vampire_soldier", 8, 23.5, 75, "male", "L2ClanHallManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(35641, 35641, "Fortress Guard", 0, "", 0, "LineageMonster2.vampire_soldier", 8, 23.5, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 60, 1, 0, 1), 
(35642, 35642, "Fortress Guard", 0, "", 0, "LineageMonster2.vampire_soldier", 8, 23.5, 75, "male", "L2CastleDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 60, 1, 0, 1), 
(35643, 35643, "Gate", 0, "", 0, "LineageNpcEV.farm_hedge", 184, 24, 56, "etc", "L2Npc", 40, 1724.6831, 918.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 405.96455, 228.40135, 277.22116, 167.1342, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35644, 35644, "Manor Manager", 0, "Schuttgart", 0, "LineageNPC.a_traderA_MDwarf", 8, 17, 70, "male", "L2ManorManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35645, 35645, "Manor Manager", 0, "Schuttgart", 0, "LineageNPC.e_trader_MOrc", 8, 23.5, 70, "male", "L2ManorManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35646, 35646, "Vampire Caster", 0, "", 0, "LineageMonster2.vampire_witch", 6, 21.5, 70, "female", "L2Npc", 1100, 6886, 1251, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 2773, 281.55251, 426.74754, 206.02791, 253, 8, 333, 946, 0, 0, 64, 140, 0, 1), 
(35647, 35647, "Vampire Leader", 0, "", 0, "LineageMonster2.vampire_lord", 7.5, 25.8, 73, "male", "L2Npc", 40, 7333, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 1204, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 15, 170, 0, 1), 
(35648, 35648, "Court Magician", 0, "Gludio", 0, "LineageMonster3.Elite_Mage", 6.5, 21.96, 70, "female", "L2CastleMagician", 40, 2444.46819, 1345.8, 7.5, 2.7, 22, 27, 21, 41, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 8687, 0, 0, 33, 120, 0, 1), 
(35649, 35649, "Court Magician", 0, "Dion", 0, "LineageMonster3.Elite_Mage", 6.5, 21.96, 70, "female", "L2CastleMagician", 40, 2444.46819, 1345.8, 7.5, 2.7, 22, 27, 21, 41, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 8687, 0, 0, 33, 120, 0, 1), 
(35650, 35650, "Court Magician", 0, "Giran", 0, "LineageMonster3.Elite_Mage", 6.5, 21.96, 70, "female", "L2CastleMagician", 40, 2444.46819, 1345.8, 7.5, 2.7, 22, 27, 21, 41, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 8687, 0, 0, 33, 120, 0, 1), 
(35651, 35651, "Court Magician", 0, "Oren", 0, "LineageMonster3.Elite_Mage", 6.5, 21.96, 70, "female", "L2CastleMagician", 40, 2444.46819, 1345.8, 7.5, 2.7, 22, 27, 21, 41, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 8687, 0, 0, 33, 120, 0, 1), 
(35652, 35652, "Court Magician", 0, "Aden", 0, "LineageMonster3.Elite_Mage", 6.5, 21.96, 70, "female", "L2CastleMagician", 40, 2444.46819, 1345.8, 7.5, 2.7, 22, 27, 21, 41, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 8687, 0, 0, 33, 120, 0, 1), 
(35653, 35653, "Court Magician", 0, "Innadril", 0, "LineageMonster3.Elite_Mage", 6.5, 21.96, 70, "female", "L2CastleMagician", 40, 2444.46819, 1345.8, 7.5, 2.7, 22, 27, 21, 41, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 8687, 0, 0, 33, 120, 0, 1), 
(35654, 35654, "Court Magician", 0, "Goddard", 0, "LineageMonster3.Elite_Mage", 6.5, 21.96, 70, "female", "L2CastleMagician", 40, 2444.46819, 1345.8, 7.5, 2.7, 22, 27, 21, 41, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 8687, 0, 0, 33, 120, 0, 1), 
(35655, 35655, "Court Magician", 0, "Rune", 0, "LineageMonster3.Elite_Mage", 6.5, 21.96, 70, "female", "L2CastleMagician", 40, 2444.46819, 1345.8, 7.5, 2.7, 22, 27, 21, 41, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 8687, 0, 0, 33, 120, 0, 1), 
(35656, 35656, "Court Magician", 0, "Schuttgart", 0, "LineageMonster3.Elite_Mage", 6.5, 21.96, 70, "female", "L2CastleMagician", 40, 2444.46819, 1345.8, 7.5, 2.7, 22, 27, 21, 41, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 8687, 0, 0, 33, 120, 0, 1), 
(35657, 35657, "Flagpole", 0, "", 0, "LineageNpcEV.rune_holything", 46, 72.5, 20, "etc", "L2Npc", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 40, 0, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35658, 35658, "Foreman", 0, "Shanty Fortress", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 75, "male", "L2FortManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35659, 35659, "Suspicious Merchant", 0, "Shanty Fortress", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2FortSiegeNpc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(35660, 35660, "Guard Captain", 0, "Shanty Fortress", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 75, "female", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 80, 641, 0, 30, 120, 0, 1), 
(35661, 35661, "Archer Captain", 0, "Shanty Fortress", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 75, "male", "L2Npc", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 0, 0, 0, 30, 120, 0, 1), 
(35662, 35662, "Support Unit Captain", 0, "Shanty Fortress", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 75, "female", "L2FortSupportCaptain", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 28, 120, 0, 1), 
(35663, 35663, "Engineering Manager", 0, "Shanty Fortress", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35664, 35664, "Logistics Officer", 0, "Shanty Fortress", 0, "LineageNPC.e_collector_teacher_MDwarf", 8, 17.5, 75, "male", "L2FortLogistics", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35665, 35665, "Supply Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(35666, 35666, "Detention Camp Warden", 0, "Shanty Fortress", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35667, 35667, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35668, 35668, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35669, 35669, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35670, 35670, "Rebel Commander", 0, "Shanty Fortress", 0, "LineageNPC2.chief_of_insurgents", 10, 26.99, 80, "male", "L2Defender", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 3200, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 2500, 6377, 0, 29.8, 120, 0, 1), 
(35671, 35671, "Decorated Rebel Soldier", 0, "Shanty Fortress", 0, "LineageMonster.shadow_50_bi", 15, 45, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(35672, 35672, "Rebel Private", 0, "Shanty Fortress", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 97, 0, 0, 50, 120, 0, 1), 
(35673, 35673, "Court Guard", 0, "Shanty Fortress", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 72, "male", "L2Defender", 80, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2592, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 98, 0, 0, 50, 120, 0, 1), 
(35674, 35674, "Guard", 0, "Shanty Fortress", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 72, "male", "L2Defender", 1100, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2592, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 8, 333, 287, 0, 0, 50, 120, 0, 1), 
(35675, 35675, "Power Control Unit", 0, "Control Room", 0, "LineageNpcEV.machine_construction_a", 54, 59.5, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(35676, 35676, "Dwarven Gunnery Sergeant", 0, "", 0, "LineageNPC2.battery_of_insurgents", 13, 17.5, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 0, 0, 0, 60, 120, 0, 1), 
(35677, 35677, "Guard Captain", 0, "Guard", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 78, "female", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 80, 641, 0, 60, 120, 0, 1), 
(35678, 35678, "Guard", 0, "Guard", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 75, 0, 0, 50, 120, 0, 1), 
(35679, 35679, "Guard", 0, "Guard", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 75, 0, 0, 50, 120, 0, 1), 
(35680, 35680, "Support Unit Captain", 0, "Support Unit", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 78, "female", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(35681, 35681, "Wizard", 0, "Support Unit", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 325, 0, 0, 50, 120, 0, 1), 
(35682, 35682, "Healer", 0, "Support Unit", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 76, "female", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 92, 0, 0, 50, 120, 0, 1), 
(35683, 35683, "Archer Captain", 0, "Archer", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 78, "male", "L2FortCommander", 1100, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 8, 333, 10212, 0, 0, 60, 120, 0, 1), 
(35684, 35684, "Archer", 0, "Archer", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 287, 0, 0, 50, 120, 0, 1), 
(35685, 35685, "Ballista", 0, "Shanty Fortress", 0, "LineageNpcEV.ballista", 112, 59, 80, "male", "L2FortBallista", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(35686, 35686, "Mercenary Captain", 0, "", 0, "LineageMonster3.Kight_of_Dawn", 12, 24.5, 80, "male", "L2Npc", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 2500, 6377, 0, 36.48, 100, 0, 1), 
(35687, 35687, "Mercenary Private", 0, "", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2Npc", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 96, 0, 0, 50, 120, 0, 1), 
(35688, 35688, "Flagpole", 0, "", 0, "LineageNpcEV.rune_holything", 46, 72.5, 20, "etc", "L2Npc", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35689, 35689, "Foreman", 0, "Southern Fortress", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 75, "male", "L2FortManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35690, 35690, "Suspicious Merchant", 0, "Southern Fortress", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2FortSiegeNpc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(35691, 35691, "Guard Captain", 0, "Southern Fortress", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 75, "female", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 80, 641, 0, 30, 120, 0, 1), 
(35692, 35692, "Archer Captain", 0, "Southern Fortress", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 75, "male", "L2Npc", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 0, 0, 0, 30, 120, 0, 1), 
(35693, 35693, "General", 0, "Southern Fortress", 0, "LineageNPC2.officer_of_insurgents_orc", 14.5, 30, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 9813, 9813, 0, 60, 120, 0, 1), 
(35694, 35694, "Support Unit Captain", 0, "Southern Fortress", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 75, "female", "L2FortSupportCaptain", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 28, 120, 0, 1), 
(35695, 35695, "Engineering Manager", 0, "Southern Fortress", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35696, 35696, "Logistics Officer", 0, "Southern Fortress", 0, "LineageNPC.e_collector_teacher_MDwarf", 8, 17.5, 75, "male", "L2FortLogistics", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35697, 35697, "Supply Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(35698, 35698, "Detention Camp Warden", 0, "Southern Fortress", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35699, 35699, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35700, 35700, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35701, 35701, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35702, 35702, "Rebel Commander", 0, "Southern Fortress", 0, "LineageNPC2.chief_of_insurgents", 10, 26.99, 80, "male", "L2Defender", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 3200, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 2500, 6377, 0, 29.8, 120, 0, 1), 
(35703, 35703, "Decorated Rebel Soldier", 0, "Southern Fortress", 0, "LineageMonster.shadow_50_bi", 15, 45, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(35704, 35704, "Rebel Private", 0, "Southern Fortress", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 97, 0, 0, 50, 120, 0, 1), 
(35705, 35705, "Court Guard", 0, "Southern Fortress", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 72, "male", "L2Defender", 80, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2592, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 98, 0, 0, 50, 120, 0, 1), 
(35706, 35706, "Guard", 0, "Southern Fortress", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 72, "male", "L2Defender", 1100, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2592, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 8, 333, 287, 0, 0, 50, 120, 0, 1), 
(35707, 35707, "Main Machine", 0, "Control Room", 0, "LineageNpcEV.machine_guard_a", 46, 35, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(35708, 35708, "Backup Power Unit", 0, "Control Room", 0, "LineageNpcEV.strange_mechanical_instrument", 16, 15.5, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35709, 35709, "Control Unit", 0, "Control Room", 0, "LineageNpcEV.door_lock", 39, 42.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(35710, 35710, "Power Control Unit", 0, "Control Room", 0, "LineageNpcEV.machine_construction_a", 54, 59.5, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(35711, 35711, "Dwarven Gunnery Sergeant", 0, "", 0, "LineageNPC2.battery_of_insurgents", 13, 17.5, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 0, 0, 0, 60, 120, 0, 1), 
(35712, 35712, "Scout Golem", 0, "Control Room", 0, "LineageMonster.mechanic_golem", 5, 19, 74, "male", "L2Defender", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 2738, 0, 773.81598, 314.65987, 528.41601, 230.25444, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(35713, 35713, "Guard Captain", 0, "Guard", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 78, "female", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 80, 641, 0, 60, 120, 0, 1), 
(35714, 35714, "Guard", 0, "Guard", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 75, 0, 0, 50, 120, 0, 1), 
(35715, 35715, "Guard", 0, "Guard", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 75, 0, 0, 50, 120, 0, 1), 
(35716, 35716, "Support Unit Captain", 0, "Support Unit", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 78, "female", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(35717, 35717, "Wizard", 0, "Support Unit", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 325, 0, 0, 50, 120, 0, 1), 
(35718, 35718, "Healer", 0, "Support Unit", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 76, "female", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 92, 0, 0, 50, 120, 0, 1), 
(35719, 35719, "Archer Captain", 0, "Archer", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 78, "male", "L2FortCommander", 1100, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 8, 333, 10212, 0, 0, 60, 120, 0, 1), 
(35720, 35720, "Archer", 0, "Archer", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 287, 0, 0, 50, 120, 0, 1), 
(35721, 35721, "General", 0, "Officer's Barracks", 0, "LineageNPC2.officer_of_insurgents_orc", 14.5, 30, 78, "male", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 9813, 9813, 0, 60, 120, 0, 1), 
(35722, 35722, "Minister", 0, "Officer's Barracks", 0, "LineageNPC.e_guard_MOrc", 8, 27, 78, "male", "L2Defender", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 7895, 0, 0, 50, 120, 0, 1), 
(35723, 35723, "Ballista", 0, "Southern Fortress", 0, "LineageNpcEV.ballista", 112, 59, 80, "male", "L2FortBallista", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(35724, 35724, "Mercenary Captain", 0, "", 0, "LineageMonster3.Kight_of_Dawn", 12, 24.5, 80, "male", "L2Npc", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 2500, 6377, 0, 36.48, 100, 0, 1), 
(35725, 35725, "Mercenary Private", 0, "", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2Npc", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 96, 0, 0, 50, 120, 0, 1), 
(35726, 35726, "Flagpole", 0, "", 0, "LineageNpcEV.rune_holything", 46, 72.5, 20, "etc", "L2Npc", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35727, 35727, "Foreman", 0, "Hive Fortress", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 75, "male", "L2FortManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35728, 35728, "Suspicious Merchant", 0, "Hive Fortress", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2FortSiegeNpc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(35729, 35729, "Guard Captain", 0, "Hive Fortress", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 75, "female", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 80, 641, 0, 30, 120, 0, 1), 
(35730, 35730, "Archer Captain", 0, "Hive Fortress", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 75, "male", "L2Npc", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 0, 0, 0, 30, 120, 0, 1), 
(35731, 35731, "Support Unit Captain", 0, "Hive Fortress", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 75, "female", "L2FortSupportCaptain", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 28, 120, 0, 1), 
(35732, 35732, "Engineering Manager", 0, "Hive Fortress", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35733, 35733, "Logistics Officer", 0, "Hive Fortress", 0, "LineageNPC.e_collector_teacher_MDwarf", 8, 17.5, 75, "male", "L2FortLogistics", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35734, 35734, "Supply Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(35735, 35735, "Detention Camp Warden", 0, "Hive Fortress", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35736, 35736, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35737, 35737, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35738, 35738, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35739, 35739, "Rebel Commander", 0, "Hive Fortress", 0, "LineageNPC2.chief_of_insurgents", 10, 26.99, 80, "male", "L2Defender", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 3200, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 2500, 6377, 0, 29.8, 120, 0, 1), 
(35740, 35740, "Decorated Rebel Soldier", 0, "Hive Fortress", 0, "LineageMonster.shadow_50_bi", 15, 45, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(35741, 35741, "Rebel Private", 0, "Hive Fortress", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 97, 0, 0, 50, 120, 0, 1), 
(35742, 35742, "Court Guard", 0, "Hive Fortress", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 72, "male", "L2Defender", 80, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2592, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 98, 0, 0, 50, 120, 0, 1), 
(35743, 35743, "Guard", 0, "Hive Fortress", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 72, "male", "L2Defender", 1100, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2592, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 8, 333, 287, 0, 0, 50, 120, 0, 1), 
(35744, 35744, "Power Control Unit", 0, "Control Room", 0, "LineageNpcEV.machine_construction_a", 54, 59.5, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(35745, 35745, "Dwarven Gunnery Sergeant", 0, "", 0, "LineageNPC2.battery_of_insurgents", 13, 17.5, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 0, 0, 0, 60, 120, 0, 1), 
(35746, 35746, "Guard Captain", 0, "Guard", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 78, "female", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 80, 641, 0, 60, 120, 0, 1), 
(35747, 35747, "Guard", 0, "Guard", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 75, 0, 0, 50, 120, 0, 1), 
(35748, 35748, "Guard", 0, "Guard", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 75, 0, 0, 50, 120, 0, 1), 
(35749, 35749, "Support Unit Captain", 0, "Support Unit", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 78, "female", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(35750, 35750, "Wizard", 0, "Support Unit", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 325, 0, 0, 50, 120, 0, 1), 
(35751, 35751, "Healer", 0, "Support Unit", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 76, "female", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 92, 0, 0, 50, 120, 0, 1), 
(35752, 35752, "Archer Captain", 0, "Archer", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 78, "male", "L2FortCommander", 1100, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 8, 333, 10212, 0, 0, 60, 120, 0, 1), 
(35753, 35753, "Archer", 0, "Archer", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 287, 0, 0, 50, 120, 0, 1), 
(35754, 35754, "Ballista", 0, "Hive Fortress", 0, "LineageNpcEV.ballista", 112, 59, 80, "male", "L2FortBallista", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(35755, 35755, "Mercenary Captain", 0, "", 0, "LineageMonster3.Kight_of_Dawn", 12, 24.5, 80, "male", "L2Npc", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 2500, 6377, 0, 36.48, 100, 0, 1), 
(35756, 35756, "Mercenary Private", 0, "", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2Npc", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 96, 0, 0, 50, 120, 0, 1), 
(35757, 35757, "Flagpole", 0, "", 0, "LineageNpcEV.rune_holything", 46, 72.5, 20, "etc", "L2Npc", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35758, 35758, "Foreman", 0, "Valley Fortress", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 75, "male", "L2FortManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35759, 35759, "Suspicious Merchant", 0, "Valley Fortress", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2FortSiegeNpc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(35760, 35760, "Guard Captain", 0, "Valley Fortress", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 75, "female", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 80, 641, 0, 30, 120, 0, 1), 
(35761, 35761, "Archer Captain", 0, "Valley Fortress", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 75, "male", "L2Npc", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 0, 0, 0, 30, 120, 0, 1), 
(35762, 35762, "General", 0, "Valley Fortress", 0, "LineageNPC2.officer_of_insurgents_orc", 14.5, 30, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 9813, 9813, 0, 60, 120, 0, 1), 
(35763, 35763, "Support Unit Captain", 0, "Valley Fortress", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 75, "female", "L2FortSupportCaptain", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 28, 120, 0, 1), 
(35764, 35764, "Engineering Manager", 0, "Valley Fortress", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35765, 35765, "Logistics Officer", 0, "Valley Fortress", 0, "LineageNPC.e_collector_teacher_MDwarf", 8, 17.5, 75, "male", "L2FortLogistics", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35766, 35766, "Supply Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(35767, 35767, "Detention Camp Warden", 0, "Valley Fortress", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35768, 35768, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35769, 35769, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35770, 35770, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35771, 35771, "Rebel Commander", 0, "Valley Fortress", 0, "LineageNPC2.chief_of_insurgents", 10, 26.99, 80, "male", "L2Defender", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 3200, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 2500, 6377, 0, 29.8, 120, 0, 1), 
(35772, 35772, "Decorated Rebel Soldier", 0, "Valley Fortress", 0, "LineageMonster.shadow_50_bi", 15, 45, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(35773, 35773, "Rebel Private", 0, "Valley Fortress", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 97, 0, 0, 50, 120, 0, 1), 
(35774, 35774, "Court Guard", 0, "Valley Fortress", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 72, "male", "L2Defender", 80, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2592, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 98, 0, 0, 50, 120, 0, 1), 
(35775, 35775, "Guard", 0, "Valley Fortress", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 72, "male", "L2Defender", 1100, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2592, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 8, 333, 287, 0, 0, 50, 120, 0, 1), 
(35776, 35776, "Main Machine", 0, "Control Room", 0, "LineageNpcEV.machine_guard_a", 46, 35, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(35777, 35777, "Backup Power Unit", 0, "Control Room", 0, "LineageNpcEV.strange_mechanical_instrument", 16, 15.5, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35778, 35778, "Control Unit", 0, "Control Room", 0, "LineageNpcEV.door_lock", 39, 42.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(35779, 35779, "Power Control Unit", 0, "Control Room", 0, "LineageNpcEV.machine_construction_a", 54, 59.5, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(35780, 35780, "Dwarven Gunnery Sergeant", 0, "", 0, "LineageNPC2.battery_of_insurgents", 13, 17.5, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 0, 0, 0, 60, 120, 0, 1), 
(35781, 35781, "Scout Golem", 0, "Control Room", 0, "LineageMonster.mechanic_golem", 5, 19, 74, "male", "L2Defender", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 2738, 0, 773.81598, 314.65987, 528.41601, 230.25444, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(35782, 35782, "Guard Captain", 0, "Guard", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 78, "female", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 80, 641, 0, 60, 120, 0, 1), 
(35783, 35783, "Guard", 0, "Guard", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 75, 0, 0, 50, 120, 0, 1), 
(35784, 35784, "Guard", 0, "Guard", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 75, 0, 0, 50, 120, 0, 1), 
(35785, 35785, "Support Unit Captain", 0, "Support Unit", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 78, "female", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(35786, 35786, "Wizard", 0, "Support Unit", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 325, 0, 0, 50, 120, 0, 1), 
(35787, 35787, "Healer", 0, "Support Unit", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 76, "female", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 92, 0, 0, 50, 120, 0, 1), 
(35788, 35788, "Archer Captain", 0, "Archer", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 78, "male", "L2FortCommander", 1100, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 8, 333, 10212, 0, 0, 60, 120, 0, 1), 
(35789, 35789, "Archer", 0, "Archer", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 287, 0, 0, 50, 120, 0, 1), 
(35790, 35790, "General", 0, "Officer's Barracks", 0, "LineageNPC2.officer_of_insurgents_orc", 14.5, 30, 78, "male", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 9813, 9813, 0, 60, 120, 0, 1), 
(35791, 35791, "Minister", 0, "Officer's Barracks", 0, "LineageNPC.e_guard_MOrc", 8, 27, 78, "male", "L2Defender", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 7895, 0, 0, 50, 120, 0, 1), 
(35792, 35792, "Ballista", 0, "Valley Fortress", 0, "LineageNpcEV.ballista", 112, 59, 80, "male", "L2FortBallista", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(35793, 35793, "Mercenary Captain", 0, "", 0, "LineageMonster3.Kight_of_Dawn", 12, 24.5, 80, "male", "L2Npc", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 2500, 6377, 0, 36.48, 100, 0, 1), 
(35794, 35794, "Mercenary Private", 0, "", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2Npc", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 96, 0, 0, 50, 120, 0, 1), 
(35795, 35795, "Flagpole", 0, "", 0, "LineageNpcEV.rune_holything", 46, 72.5, 20, "etc", "L2Npc", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35796, 35796, "Foreman", 0, "Ivory Fortress", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 75, "male", "L2FortManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35797, 35797, "Suspicious Merchant", 0, "Ivory Fortress", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2FortSiegeNpc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(35798, 35798, "Guard Captain", 0, "Ivory Fortress", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 75, "female", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 80, 641, 0, 30, 120, 0, 1), 
(35799, 35799, "Archer Captain", 0, "Ivory Fortress", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 75, "male", "L2Npc", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 0, 0, 0, 30, 120, 0, 1), 
(35800, 35800, "Support Unit Captain", 0, "Ivory Fortress", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 75, "female", "L2FortSupportCaptain", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 28, 120, 0, 1), 
(35801, 35801, "Engineering Manager", 0, "Ivory Fortress", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35802, 35802, "Logistics Officer", 0, "Ivory Fortress", 0, "LineageNPC.e_collector_teacher_MDwarf", 8, 17.5, 75, "male", "L2FortLogistics", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35803, 35803, "Supply Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(35804, 35804, "Detention Camp Warden", 0, "Ivory Fortress", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35805, 35805, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35806, 35806, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35807, 35807, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35808, 35808, "Rebel Commander", 0, "Ivory Fortress", 0, "LineageNPC2.chief_of_insurgents", 10, 26.99, 80, "male", "L2Defender", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 3200, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 2500, 6377, 0, 29.8, 120, 0, 1), 
(35809, 35809, "Decorated Rebel Soldier", 0, "Ivory Fortress", 0, "LineageMonster.shadow_50_bi", 15, 45, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(35810, 35810, "Rebel Private", 0, "Ivory Fortress", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 97, 0, 0, 50, 120, 0, 1), 
(35811, 35811, "Court Guard", 0, "Ivory Fortress", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 72, "male", "L2Defender", 80, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2592, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 98, 0, 0, 50, 120, 0, 1), 
(35812, 35812, "Guard", 0, "Ivory Fortress", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 72, "male", "L2Defender", 1100, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2592, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 8, 333, 287, 0, 0, 50, 120, 0, 1), 
(35813, 35813, "Power Control Unit", 0, "Control Room", 0, "LineageNpcEV.machine_construction_a", 54, 59.5, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(35814, 35814, "Dwarven Gunnery Sergeant", 0, "", 0, "LineageNPC2.battery_of_insurgents", 13, 17.5, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 0, 0, 0, 60, 120, 0, 1), 
(35815, 35815, "Guard Captain", 0, "Guard", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 78, "female", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 80, 641, 0, 60, 120, 0, 1), 
(35816, 35816, "Guard", 0, "Guard", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 75, 0, 0, 50, 120, 0, 1), 
(35817, 35817, "Guard", 0, "Guard", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 75, 0, 0, 50, 120, 0, 1), 
(35818, 35818, "Support Unit Captain", 0, "Support Unit", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 78, "female", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(35819, 35819, "Wizard", 0, "Support Unit", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 325, 0, 0, 50, 120, 0, 1), 
(35820, 35820, "Healer", 0, "Support Unit", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 76, "female", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 92, 0, 0, 50, 120, 0, 1), 
(35821, 35821, "Archer Captain", 0, "Archer", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 78, "male", "L2FortCommander", 1100, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 8, 333, 10212, 0, 0, 60, 120, 0, 1), 
(35822, 35822, "Archer", 0, "Archer", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 287, 0, 0, 50, 120, 0, 1), 
(35823, 35823, "Ballista", 0, "Ivory Fortress", 0, "LineageNpcEV.ballista", 112, 59, 80, "male", "L2FortBallista", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(35824, 35824, "Mercenary Captain", 0, "", 0, "LineageMonster3.Kight_of_Dawn", 12, 24.5, 80, "male", "L2Npc", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 2500, 6377, 0, 36.48, 100, 0, 1), 
(35825, 35825, "Mercenary Private", 0, "", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2Npc", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 96, 0, 0, 50, 120, 0, 1), 
(35826, 35826, "Flagpole", 0, "", 0, "LineageNpcEV.rune_holything", 46, 72.5, 20, "etc", "L2Npc", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35827, 35827, "Foreman", 0, "Narsell Fortress", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 75, "male", "L2FortManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35828, 35828, "Suspicious Merchant", 0, "Narsell Fortress", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2FortSiegeNpc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(35829, 35829, "Guard Captain", 0, "Narsell Fortress", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 75, "female", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 80, 641, 0, 30, 120, 0, 1), 
(35830, 35830, "Archer Captain", 0, "Narsell Fortress", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 75, "male", "L2Npc", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 0, 0, 0, 30, 120, 0, 1), 
(35831, 35831, "Support Unit Captain", 0, "Narsell Fortress", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 75, "female", "L2FortSupportCaptain", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 28, 120, 0, 1), 
(35832, 35832, "Engineering Manager", 0, "Narsell Fortress", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35833, 35833, "Logistics Officer", 0, "Narsell Fortress", 0, "LineageNPC.e_collector_teacher_MDwarf", 8, 17.5, 75, "male", "L2FortLogistics", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35834, 35834, "Supply Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(35835, 35835, "Detention Camp Warden", 0, "Narsell Fortress", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35836, 35836, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35837, 35837, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35838, 35838, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35839, 35839, "Rebel Commander", 0, "Narsell Fortress", 0, "LineageNPC2.chief_of_insurgents", 10, 26.99, 80, "male", "L2Defender", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 3200, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 2500, 6377, 0, 29.8, 120, 0, 1), 
(35840, 35840, "Decorated Rebel Soldier", 0, "Narsell Fortress", 0, "LineageMonster.shadow_50_bi", 15, 45, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(35841, 35841, "Rebel Private", 0, "Narsell Fortress", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 97, 0, 0, 50, 120, 0, 1), 
(35842, 35842, "Court Guard", 0, "Narsell Fortress", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 72, "male", "L2Defender", 80, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2592, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 98, 0, 0, 50, 120, 0, 1), 
(35843, 35843, "Guard", 0, "Narsell Fortress", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 72, "male", "L2Defender", 1100, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2592, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 8, 333, 287, 0, 0, 50, 120, 0, 1), 
(35844, 35844, "Power Control Unit", 0, "Control Room", 0, "LineageNpcEV.machine_construction_a", 54, 59.5, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(35845, 35845, "Dwarven Gunnery Sergeant", 0, "", 0, "LineageNPC2.battery_of_insurgents", 13, 17.5, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 0, 0, 0, 60, 120, 0, 1), 
(35846, 35846, "Guard Captain", 0, "Guard", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 78, "female", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 80, 641, 0, 60, 120, 0, 1), 
(35847, 35847, "Guard", 0, "Guard", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 75, 0, 0, 50, 120, 0, 1), 
(35848, 35848, "Guard", 0, "Guard", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 75, 0, 0, 50, 120, 0, 1), 
(35849, 35849, "Support Unit Captain", 0, "Support Unit", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 78, "female", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(35850, 35850, "Wizard", 0, "Support Unit", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 325, 0, 0, 50, 120, 0, 1), 
(35851, 35851, "Healer", 0, "Support Unit", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 76, "female", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 92, 0, 0, 50, 120, 0, 1), 
(35852, 35852, "Archer Captain", 0, "Archer", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 78, "male", "L2FortCommander", 1100, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 8, 333, 10212, 0, 0, 60, 120, 0, 1), 
(35853, 35853, "Archer", 0, "Archer", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 287, 0, 0, 50, 120, 0, 1), 
(35854, 35854, "Ballista", 0, "Narsell Fortress", 0, "LineageNpcEV.ballista", 112, 59, 80, "male", "L2FortBallista", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(35855, 35855, "Mercenary Captain", 0, "", 0, "LineageMonster3.Kight_of_Dawn", 12, 24.5, 80, "male", "L2Npc", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 2500, 6377, 0, 36.48, 100, 0, 1), 
(35856, 35856, "Mercenary Private", 0, "", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2Npc", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 96, 0, 0, 50, 120, 0, 1), 
(35857, 35857, "Flagpole", 0, "", 0, "LineageNpcEV.rune_holything", 46, 72.5, 20, "etc", "L2Npc", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35858, 35858, "Foreman", 0, "Bayou Fortress", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 75, "male", "L2FortManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35859, 35859, "Suspicious Merchant", 0, "Bayou Fortress", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2FortSiegeNpc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(35860, 35860, "Guard Captain", 0, "Bayou Fortress", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 75, "female", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 80, 641, 0, 30, 120, 0, 1), 
(35861, 35861, "Archer Captain", 0, "Bayou Fortress", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 75, "male", "L2Npc", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 0, 0, 0, 30, 120, 0, 1), 
(35862, 35862, "General", 0, "Bayou Fortress", 0, "LineageNPC2.officer_of_insurgents_orc", 14.5, 30, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 9813, 9813, 0, 60, 120, 0, 1), 
(35863, 35863, "Support Unit Captain", 0, "Bayou Fortress", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 75, "female", "L2FortSupportCaptain", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 28, 120, 0, 1), 
(35864, 35864, "Engineering Manager", 0, "Bayou Fortress", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35865, 35865, "Logistics Officer", 0, "Bayou Fortress", 0, "LineageNPC.e_collector_teacher_MDwarf", 8, 17.5, 75, "male", "L2FortLogistics", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35866, 35866, "Supply Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(35867, 35867, "Detention Camp Warden", 0, "Bayou Fortress", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35868, 35868, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35869, 35869, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35870, 35870, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35871, 35871, "Rebel Commander", 0, "Bayou Fortress", 0, "LineageNPC2.chief_of_insurgents", 10, 26.99, 80, "male", "L2Defender", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 3200, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 2500, 6377, 0, 29.8, 120, 0, 1), 
(35872, 35872, "Decorated Rebel Soldier", 0, "Bayou Fortress", 0, "LineageMonster.shadow_50_bi", 15, 45, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(35873, 35873, "Rebel Private", 0, "Bayou Fortress", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 97, 0, 0, 50, 120, 0, 1), 
(35874, 35874, "Court Guard", 0, "Bayou Fortress", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 72, "male", "L2Defender", 80, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2592, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 98, 0, 0, 50, 120, 0, 1), 
(35875, 35875, "Guard", 0, "Bayou Fortress", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 72, "male", "L2Defender", 1100, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2592, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 8, 333, 287, 0, 0, 50, 120, 0, 1), 
(35876, 35876, "Main Machine", 0, "Control Room", 0, "LineageNpcEV.machine_guard_a", 46, 35, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(35877, 35877, "Backup Power Unit", 0, "Control Room", 0, "LineageNpcEV.strange_mechanical_instrument", 16, 15.5, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35878, 35878, "Control Unit", 0, "Control Room", 0, "LineageNpcEV.door_lock", 39, 42.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(35879, 35879, "Power Control Unit", 0, "Control Room", 0, "LineageNpcEV.machine_construction_a", 54, 59.5, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(35880, 35880, "Dwarven Gunnery Sergeant", 0, "", 0, "LineageNPC2.battery_of_insurgents", 13, 17.5, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 0, 0, 0, 60, 120, 0, 1), 
(35881, 35881, "Scout Golem", 0, "Control Room", 0, "LineageMonster.mechanic_golem", 5, 19, 74, "male", "L2Defender", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 2738, 0, 773.81598, 314.65987, 528.41601, 230.25444, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(35882, 35882, "Guard Captain", 0, "Guard", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 78, "female", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 80, 641, 0, 60, 120, 0, 1), 
(35883, 35883, "Guard", 0, "Guard", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 75, 0, 0, 50, 120, 0, 1), 
(35884, 35884, "Guard", 0, "Guard", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 75, 0, 0, 50, 120, 0, 1), 
(35885, 35885, "Support Unit Captain", 0, "Support Unit", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 78, "female", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(35886, 35886, "Wizard", 0, "Support Unit", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 325, 0, 0, 50, 120, 0, 1), 
(35887, 35887, "Healer", 0, "Support Unit", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 76, "female", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 92, 0, 0, 50, 120, 0, 1), 
(35888, 35888, "Archer Captain", 0, "Archer", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 78, "male", "L2FortCommander", 1100, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 8, 333, 10212, 0, 0, 60, 120, 0, 1), 
(35889, 35889, "Archer", 0, "Archer", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 287, 0, 0, 50, 120, 0, 1), 
(35890, 35890, "General", 0, "Officer's Barracks", 0, "LineageNPC2.officer_of_insurgents_orc", 14.5, 30, 78, "male", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 9813, 9813, 0, 60, 120, 0, 1), 
(35891, 35891, "Minister", 0, "Officer's Barracks", 0, "LineageNPC.e_guard_MOrc", 8, 27, 78, "male", "L2Defender", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 7895, 0, 0, 50, 120, 0, 1), 
(35892, 35892, "Ballista", 0, "Bayou Fortress", 0, "LineageNpcEV.ballista", 112, 59, 80, "male", "L2FortBallista", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(35893, 35893, "Mercenary Captain", 0, "", 0, "LineageMonster3.Kight_of_Dawn", 12, 24.5, 80, "male", "L2Npc", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 2500, 6377, 0, 36.48, 100, 0, 1), 
(35894, 35894, "Mercenary Private", 0, "", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2Npc", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 96, 0, 0, 50, 120, 0, 1), 
(35895, 35895, "Flagpole", 0, "", 0, "LineageNpcEV.rune_holything", 46, 72.5, 20, "etc", "L2Npc", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35896, 35896, "Foreman", 0, "White Sands Fortress", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 75, "male", "L2FortManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35897, 35897, "Suspicious Merchant", 0, "White Sands Fortress", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2FortSiegeNpc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(35898, 35898, "Guard Captain", 0, "White Sands Fortress", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 75, "female", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 80, 641, 0, 30, 120, 0, 1), 
(35899, 35899, "Archer Captain", 0, "White Sands Fortress", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 75, "male", "L2Npc", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 0, 0, 0, 30, 120, 0, 1), 
(35900, 35900, "Support Unit Captain", 0, "White Sands Fortress", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 75, "female", "L2FortSupportCaptain", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 28, 120, 0, 1), 
(35901, 35901, "Engineering Manager", 0, "White Sands Fortress", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35902, 35902, "Logistics Officer", 0, "White Sands Fortress", 0, "LineageNPC.e_collector_teacher_MDwarf", 8, 17.5, 75, "male", "L2FortLogistics", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35903, 35903, "Supply Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(35904, 35904, "Detention Camp Warden", 0, "White Sands Fortress", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35905, 35905, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35906, 35906, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35907, 35907, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35908, 35908, "Rebel Commander", 0, "White Sands Fortress", 0, "LineageNPC2.chief_of_insurgents", 10, 26.99, 80, "male", "L2Defender", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 3200, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 2500, 6377, 0, 29.8, 120, 0, 1), 
(35909, 35909, "Decorated Rebel Soldier", 0, "White Sands Fortress", 0, "LineageMonster.shadow_50_bi", 15, 45, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(35910, 35910, "Rebel Private", 0, "White Sands Fortress", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 97, 0, 0, 50, 120, 0, 1), 
(35911, 35911, "Court Guard", 0, "White Sands Fortress", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 72, "male", "L2Defender", 80, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2592, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 98, 0, 0, 50, 120, 0, 1), 
(35912, 35912, "Guard", 0, "White Sands Fortress", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 72, "male", "L2Defender", 1100, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2592, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 8, 333, 287, 0, 0, 50, 120, 0, 1), 
(35913, 35913, "Power Control Unit", 0, "Control Room", 0, "LineageNpcEV.machine_construction_a", 54, 59.5, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(35914, 35914, "Dwarven Gunnery Sergeant", 0, "", 0, "LineageNPC2.battery_of_insurgents", 13, 17.5, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 0, 0, 0, 60, 120, 0, 1), 
(35915, 35915, "Guard Captain", 0, "Guard", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 78, "female", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 80, 641, 0, 60, 120, 0, 1), 
(35916, 35916, "Guard", 0, "Guard", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 75, 0, 0, 50, 120, 0, 1), 
(35917, 35917, "Guard", 0, "Guard", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 75, 0, 0, 50, 120, 0, 1), 
(35918, 35918, "Support Unit Captain", 0, "Support Unit", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 78, "female", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(35919, 35919, "Wizard", 0, "Support Unit", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 325, 0, 0, 50, 120, 0, 1), 
(35920, 35920, "Healer", 0, "Support Unit", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 76, "female", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 92, 0, 0, 50, 120, 0, 1), 
(35921, 35921, "Archer Captain", 0, "Archer", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 78, "male", "L2FortCommander", 1100, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 8, 333, 10212, 0, 0, 60, 120, 0, 1), 
(35922, 35922, "Archer", 0, "Archer", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 287, 0, 0, 50, 120, 0, 1), 
(35923, 35923, "Ballista", 0, "White Sands Fortress", 0, "LineageNpcEV.ballista", 112, 59, 80, "male", "L2FortBallista", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(35924, 35924, "Mercenary Captain", 0, "", 0, "LineageMonster3.Kight_of_Dawn", 12, 24.5, 80, "male", "L2Npc", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 2500, 6377, 0, 36.48, 100, 0, 1), 
(35925, 35925, "Mercenary Private", 0, "", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2Npc", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 96, 0, 0, 50, 120, 0, 1), 
(35926, 35926, "Flagpole", 0, "", 0, "LineageNpcEV.rune_holything", 46, 72.5, 20, "etc", "L2Npc", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35927, 35927, "Foreman", 0, "Borderland Fortress", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 75, "male", "L2FortManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35928, 35928, "Suspicious Merchant", 0, "Borderland Fortress", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2FortSiegeNpc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(35929, 35929, "Guard Captain", 0, "Borderland Fortress", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 75, "female", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 80, 641, 0, 30, 120, 0, 1), 
(35930, 35930, "Archer Captain", 0, "Borderland Fortress", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 75, "male", "L2Npc", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 0, 0, 0, 30, 120, 0, 1), 
(35931, 35931, "General", 0, "Borderland Fortress", 0, "LineageNPC2.officer_of_insurgents_orc", 14.5, 30, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 9813, 9813, 0, 60, 120, 0, 1), 
(35932, 35932, "Support Unit Captain", 0, "Borderland Fortress", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 75, "female", "L2FortSupportCaptain", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 28, 120, 0, 1), 
(35933, 35933, "Engineering Manager", 0, "Borderland Fortress", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35934, 35934, "Logistics Officer", 0, "Borderland Fortress", 0, "LineageNPC.e_collector_teacher_MDwarf", 8, 17.5, 75, "male", "L2FortLogistics", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35935, 35935, "Supply Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(35936, 35936, "Detention Camp Warden", 0, "Borderland Fortress", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35937, 35937, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35938, 35938, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35939, 35939, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35940, 35940, "Rebel Commander", 0, "Borderland Fortress", 0, "LineageNPC2.chief_of_insurgents", 10, 26.99, 80, "male", "L2Defender", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 3200, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 2500, 6377, 0, 29.8, 120, 0, 1), 
(35941, 35941, "Decorated Rebel Soldier", 0, "Borderland Fortress", 0, "LineageMonster.shadow_50_bi", 15, 45, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(35942, 35942, "Rebel Private", 0, "Borderland Fortress", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 97, 0, 0, 50, 120, 0, 1), 
(35943, 35943, "Court Guard", 0, "Borderland Fortress", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 72, "male", "L2Defender", 80, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2592, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 98, 0, 0, 50, 120, 0, 1), 
(35944, 35944, "Guard", 0, "Borderland Fortress", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 72, "male", "L2Defender", 1100, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2592, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 8, 333, 287, 0, 0, 50, 120, 0, 1), 
(35945, 35945, "Main Machine", 0, "Control Room", 0, "LineageNpcEV.machine_guard_a", 46, 35, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(35946, 35946, "Backup Power Unit", 0, "Control Room", 0, "LineageNpcEV.strange_mechanical_instrument", 16, 15.5, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35947, 35947, "Control Unit", 0, "Control Room", 0, "LineageNpcEV.door_lock", 39, 42.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(35948, 35948, "Power Control Unit", 0, "Control Room", 0, "LineageNpcEV.machine_construction_a", 54, 59.5, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(35949, 35949, "Dwarven Gunnery Sergeant", 0, "", 0, "LineageNPC2.battery_of_insurgents", 13, 17.5, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 0, 0, 0, 60, 120, 0, 1), 
(35950, 35950, "Scout Golem", 0, "Control Room", 0, "LineageMonster.mechanic_golem", 5, 19, 74, "male", "L2Defender", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 2738, 0, 773.81598, 314.65987, 528.41601, 230.25444, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(35951, 35951, "Guard Captain", 0, "Guard", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 78, "female", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 80, 641, 0, 60, 120, 0, 1), 
(35952, 35952, "Guard", 0, "Guard", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 75, 0, 0, 50, 120, 0, 1), 
(35953, 35953, "Guard", 0, "Guard", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 75, 0, 0, 50, 120, 0, 1), 
(35954, 35954, "Support Unit Captain", 0, "Support Unit", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 78, "female", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(35955, 35955, "Wizard", 0, "Support Unit", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 325, 0, 0, 50, 120, 0, 1), 
(35956, 35956, "Healer", 0, "Support Unit", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 76, "female", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 92, 0, 0, 50, 120, 0, 1), 
(35957, 35957, "Archer Captain", 0, "Archer", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 78, "male", "L2FortCommander", 1100, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 8, 333, 10212, 0, 0, 60, 120, 0, 1), 
(35958, 35958, "Archer", 0, "Archer", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 287, 0, 0, 50, 120, 0, 1), 
(35959, 35959, "General", 0, "Officer's Barracks", 0, "LineageNPC2.officer_of_insurgents_orc", 14.5, 30, 78, "male", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 9813, 9813, 0, 60, 120, 0, 1), 
(35960, 35960, "Minister", 0, "Officer's Barracks", 0, "LineageNPC.e_guard_MOrc", 8, 27, 78, "male", "L2Defender", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 7895, 0, 0, 50, 120, 0, 1), 
(35961, 35961, "Ballista", 0, "Borderland Fortress", 0, "LineageNpcEV.ballista", 112, 59, 80, "male", "L2FortBallista", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(35962, 35962, "Mercenary Captain", 0, "", 0, "LineageMonster3.Kight_of_Dawn", 12, 24.5, 80, "male", "L2Npc", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 2500, 6377, 0, 36.48, 100, 0, 1), 
(35963, 35963, "Mercenary Private", 0, "", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2Npc", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 96, 0, 0, 50, 120, 0, 1), 
(35964, 35964, "Flagpole", 0, "", 0, "LineageNpcEV.rune_holything", 46, 72.5, 20, "etc", "L2Npc", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(35965, 35965, "Foreman", 0, "Swamp Fortress", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 75, "male", "L2FortManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35966, 35966, "Suspicious Merchant", 0, "Swamp Fortress", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2FortSiegeNpc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(35967, 35967, "Guard Captain", 0, "Swamp Fortress", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 75, "female", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 80, 641, 0, 30, 120, 0, 1), 
(35968, 35968, "Archer Captain", 0, "Swamp Fortress", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 75, "male", "L2Npc", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 0, 0, 0, 30, 120, 0, 1), 
(35969, 35969, "General", 0, "Swamp Fortress", 0, "LineageNPC2.officer_of_insurgents_orc", 14.5, 30, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 9813, 9813, 0, 60, 120, 0, 1), 
(35970, 35970, "Support Unit Captain", 0, "Swamp Fortress", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 75, "female", "L2FortSupportCaptain", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 28, 120, 0, 1), 
(35971, 35971, "Engineering Manager", 0, "Swamp Fortress", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35972, 35972, "Logistics Officer", 0, "Swamp Fortress", 0, "LineageNPC.e_collector_teacher_MDwarf", 8, 17.5, 75, "male", "L2FortLogistics", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35973, 35973, "Supply Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(35974, 35974, "Detention Camp Warden", 0, "Swamp Fortress", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35975, 35975, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35976, 35976, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35977, 35977, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35978, 35978, "Rebel Commander", 0, "Swamp Fortress", 0, "LineageNPC2.chief_of_insurgents", 10, 26.99, 80, "male", "L2Defender", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 3200, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 2500, 6377, 0, 29.8, 120, 0, 1), 
(35979, 35979, "Decorated Rebel Soldier", 0, "Swamp Fortress", 0, "LineageMonster.shadow_50_bi", 15, 45, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(35980, 35980, "Rebel Private", 0, "Swamp Fortress", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 97, 0, 0, 50, 120, 0, 1), 
(35981, 35981, "Court Guard", 0, "Swamp Fortress", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 72, "male", "L2Defender", 80, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2592, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 98, 0, 0, 50, 120, 0, 1), 
(35982, 35982, "Guard", 0, "Swamp Fortress", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 72, "male", "L2Defender", 1100, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2592, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 8, 333, 287, 0, 0, 50, 120, 0, 1), 
(35983, 35983, "Main Machine", 0, "Control Room", 0, "LineageNpcEV.machine_guard_a", 46, 35, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(35984, 35984, "Backup Power Unit", 0, "Control Room", 0, "LineageNpcEV.strange_mechanical_instrument", 16, 15.5, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(35985, 35985, "Control Unit", 0, "Control Room", 0, "LineageNpcEV.door_lock", 39, 42.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(35986, 35986, "Power Control Unit", 0, "Control Room", 0, "LineageNpcEV.machine_construction_a", 54, 59.5, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(35987, 35987, "Dwarven Gunnery Sergeant", 0, "", 0, "LineageNPC2.battery_of_insurgents", 13, 17.5, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 0, 0, 0, 60, 120, 0, 1), 
(35988, 35988, "Scout Golem", 0, "Control Room", 0, "LineageMonster.mechanic_golem", 5, 19, 74, "male", "L2Defender", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 2738, 0, 773.81598, 314.65987, 528.41601, 230.25444, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(35989, 35989, "Guard Captain", 0, "Guard", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 78, "female", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 80, 641, 0, 60, 120, 0, 1), 
(35990, 35990, "Guard", 0, "Guard", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 75, 0, 0, 50, 120, 0, 1), 
(35991, 35991, "Guard", 0, "Guard", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 75, 0, 0, 50, 120, 0, 1), 
(35992, 35992, "Support Unit Captain", 0, "Support Unit", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 78, "female", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(35993, 35993, "Wizard", 0, "Support Unit", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 325, 0, 0, 50, 120, 0, 1), 
(35994, 35994, "Healer", 0, "Support Unit", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 76, "female", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 92, 0, 0, 50, 120, 0, 1), 
(35995, 35995, "Archer Captain", 0, "Archer", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 78, "male", "L2FortCommander", 1100, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 8, 333, 10212, 0, 0, 60, 120, 0, 1), 
(35996, 35996, "Archer", 0, "Archer", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 287, 0, 0, 50, 120, 0, 1), 
(35997, 35997, "General", 0, "Officer's Barracks", 0, "LineageNPC2.officer_of_insurgents_orc", 14.5, 30, 78, "male", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 9813, 9813, 0, 60, 120, 0, 1), 
(35998, 35998, "Minister", 0, "Officer's Barracks", 0, "LineageNPC.e_guard_MOrc", 8, 27, 78, "male", "L2Defender", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 7895, 0, 0, 50, 120, 0, 1), 
(35999, 35999, "Ballista", 0, "Swamp Fortress", 0, "LineageNpcEV.ballista", 112, 59, 80, "male", "L2FortBallista", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(36000, 36000, "Mercenary Captain", 0, "", 0, "LineageMonster3.Kight_of_Dawn", 12, 24.5, 80, "male", "L2Npc", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 2500, 6377, 0, 36.48, 100, 0, 1), 
(36001, 36001, "Mercenary Private", 0, "", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2Npc", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 96, 0, 0, 50, 120, 0, 1), 
(36002, 36002, "Flagpole", 0, "", 0, "LineageNpcEV.rune_holything", 46, 72.5, 20, "etc", "L2Npc", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(36003, 36003, "Foreman", 0, "Archaic Fortress", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 75, "male", "L2FortManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36004, 36004, "Suspicious Merchant", 0, "Archaic Fortress", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2FortSiegeNpc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(36005, 36005, "Guard Captain", 0, "Archaic Fortress", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 75, "female", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 80, 641, 0, 30, 120, 0, 1), 
(36006, 36006, "Archer Captain", 0, "Archaic Fortress", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 75, "male", "L2Npc", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 0, 0, 0, 30, 120, 0, 1), 
(36007, 36007, "Support Unit Captain", 0, "Archaic Fortress", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 75, "female", "L2FortSupportCaptain", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 28, 120, 0, 1), 
(36008, 36008, "Engineering Manager", 0, "Archaic Fortress", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36009, 36009, "Logistics Officer", 0, "Archaic Fortress", 0, "LineageNPC.e_collector_teacher_MDwarf", 8, 17.5, 75, "male", "L2FortLogistics", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36010, 36010, "Supply Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(36011, 36011, "Detention Camp Warden", 0, "Archaic Fortress", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36012, 36012, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36013, 36013, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36014, 36014, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36015, 36015, "Rebel Commander", 0, "Archaic Fortress", 0, "LineageNPC2.chief_of_insurgents", 10, 26.99, 80, "male", "L2Defender", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 3200, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 2500, 6377, 0, 29.8, 120, 0, 1), 
(36016, 36016, "Decorated Rebel Soldier", 0, "Archaic Fortress", 0, "LineageMonster.shadow_50_bi", 15, 45, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(36017, 36017, "Rebel Private", 0, "Archaic Fortress", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 97, 0, 0, 50, 120, 0, 1), 
(36018, 36018, "Court Guard", 0, "Archaic Fortress", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 72, "male", "L2Defender", 80, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2592, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 98, 0, 0, 50, 120, 0, 1), 
(36019, 36019, "Guard", 0, "Archaic Fortress", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 72, "male", "L2Defender", 1100, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2592, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 8, 333, 287, 0, 0, 50, 120, 0, 1), 
(36020, 36020, "Power Control Unit", 0, "Control Room", 0, "LineageNpcEV.machine_construction_a", 54, 59.5, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(36021, 36021, "Dwarven Gunnery Sergeant", 0, "", 0, "LineageNPC2.battery_of_insurgents", 13, 17.5, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 0, 0, 0, 60, 120, 0, 1), 
(36022, 36022, "Guard Captain", 0, "Guard", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 78, "female", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 80, 641, 0, 60, 120, 0, 1), 
(36023, 36023, "Guard", 0, "Guard", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 75, 0, 0, 50, 120, 0, 1), 
(36024, 36024, "Guard", 0, "Guard", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 75, 0, 0, 50, 120, 0, 1), 
(36025, 36025, "Support Unit Captain", 0, "Support Unit", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 78, "female", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(36026, 36026, "Wizard", 0, "Support Unit", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 325, 0, 0, 50, 120, 0, 1), 
(36027, 36027, "Healer", 0, "Support Unit", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 76, "female", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 92, 0, 0, 50, 120, 0, 1), 
(36028, 36028, "Archer Captain", 0, "Archer", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 78, "male", "L2FortCommander", 1100, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 8, 333, 10212, 0, 0, 60, 120, 0, 1), 
(36029, 36029, "Archer", 0, "Archer", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 287, 0, 0, 50, 120, 0, 1), 
(36030, 36030, "Ballista", 0, "Archaic Fortress", 0, "LineageNpcEV.ballista", 112, 59, 80, "male", "L2FortBallista", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(36031, 36031, "Mercenary Captain", 0, "", 0, "LineageMonster3.Kight_of_Dawn", 12, 24.5, 80, "male", "L2Npc", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 2500, 6377, 0, 36.48, 100, 0, 1), 
(36032, 36032, "Mercenary Private", 0, "", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2Npc", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 96, 0, 0, 50, 120, 0, 1), 
(36033, 36033, "Flagpole", 0, "", 0, "LineageNpcEV.rune_holything", 46, 72.5, 20, "etc", "L2Npc", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(36034, 36034, "Foreman", 0, "Floran Fortress", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 75, "male", "L2FortManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36035, 36035, "Suspicious Merchant", 0, "Floran Fortress", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2FortSiegeNpc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(36036, 36036, "Guard Captain", 0, "Floran Fortress", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 75, "female", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 80, 641, 0, 30, 120, 0, 1), 
(36037, 36037, "Archer Captain", 0, "Floran Fortress", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 75, "male", "L2Npc", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 0, 0, 0, 30, 120, 0, 1), 
(36038, 36038, "General", 0, "Floran Fortress", 0, "LineageNPC2.officer_of_insurgents_orc", 14.5, 30, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 9813, 9813, 0, 60, 120, 0, 1), 
(36039, 36039, "Support Unit Captain", 0, "Floran Fortress", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 75, "female", "L2FortSupportCaptain", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 28, 120, 0, 1), 
(36040, 36040, "Engineering Manager", 0, "Floran Fortress", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36041, 36041, "Logistics Officer", 0, "Floran Fortress", 0, "LineageNPC.e_collector_teacher_MDwarf", 8, 17.5, 75, "male", "L2FortLogistics", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36042, 36042, "Supply Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(36043, 36043, "Detention Camp Warden", 0, "Floran Fortress", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36044, 36044, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36045, 36045, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36046, 36046, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36047, 36047, "Rebel Commander", 0, "Floran Fortress", 0, "LineageNPC2.chief_of_insurgents", 10, 26.99, 80, "male", "L2Defender", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 3200, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 2500, 6377, 0, 29.8, 120, 0, 1), 
(36048, 36048, "Decorated Rebel Soldier", 0, "Floran Fortress", 0, "LineageMonster.shadow_50_bi", 15, 45, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(36049, 36049, "Rebel Private", 0, "Floran Fortress", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 97, 0, 0, 50, 120, 0, 1), 
(36050, 36050, "Court Guard", 0, "Floran Fortress", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 72, "male", "L2Defender", 80, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2592, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 98, 0, 0, 50, 120, 0, 1), 
(36051, 36051, "Guard", 0, "Floran Fortress", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 72, "male", "L2Defender", 1100, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2592, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 8, 333, 287, 0, 0, 50, 120, 0, 1), 
(36052, 36052, "Main Machine", 0, "Control Room", 0, "LineageNpcEV.machine_guard_a", 46, 35, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(36053, 36053, "Backup Power Unit", 0, "Control Room", 0, "LineageNpcEV.strange_mechanical_instrument", 16, 15.5, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36054, 36054, "Control Unit", 0, "Control Room", 0, "LineageNpcEV.door_lock", 39, 42.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(36055, 36055, "Power Control Unit", 0, "Control Room", 0, "LineageNpcEV.machine_construction_a", 54, 59.5, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(36056, 36056, "Dwarven Gunnery Sergeant", 0, "", 0, "LineageNPC2.battery_of_insurgents", 13, 17.5, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 0, 0, 0, 60, 120, 0, 1), 
(36057, 36057, "Scout Golem", 0, "Control Room", 0, "LineageMonster.mechanic_golem", 5, 19, 74, "male", "L2Defender", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 2738, 0, 773.81598, 314.65987, 528.41601, 230.25444, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(36058, 36058, "Guard Captain", 0, "Guard", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 78, "female", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 80, 641, 0, 60, 120, 0, 1), 
(36059, 36059, "Guard", 0, "Guard", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 75, 0, 0, 50, 120, 0, 1), 
(36060, 36060, "Guard", 0, "Guard", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 75, 0, 0, 50, 120, 0, 1), 
(36061, 36061, "Support Unit Captain", 0, "Support Unit", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 78, "female", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(36062, 36062, "Wizard", 0, "Support Unit", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 325, 0, 0, 50, 120, 0, 1), 
(36063, 36063, "Healer", 0, "Support Unit", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 76, "female", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 92, 0, 0, 50, 120, 0, 1), 
(36064, 36064, "Archer Captain", 0, "Archer", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 78, "male", "L2FortCommander", 1100, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 8, 333, 10212, 0, 0, 60, 120, 0, 1), 
(36065, 36065, "Archer", 0, "Archer", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 287, 0, 0, 50, 120, 0, 1), 
(36066, 36066, "General", 0, "Officer's Barracks", 0, "LineageNPC2.officer_of_insurgents_orc", 14.5, 30, 78, "male", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 9813, 9813, 0, 60, 120, 0, 1), 
(36067, 36067, "Minister", 0, "Officer's Barracks", 0, "LineageNPC.e_guard_MOrc", 8, 27, 78, "male", "L2Defender", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 7895, 0, 0, 50, 120, 0, 1), 
(36068, 36068, "Ballista", 0, "Floran Fortress", 0, "LineageNpcEV.ballista", 112, 59, 80, "male", "L2FortBallista", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(36069, 36069, "Mercenary Captain", 0, "", 0, "LineageMonster3.Kight_of_Dawn", 12, 24.5, 80, "male", "L2Npc", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 2500, 6377, 0, 36.48, 100, 0, 1), 
(36070, 36070, "Mercenary Private", 0, "", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2Npc", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 96, 0, 0, 50, 120, 0, 1), 
(36071, 36071, "Flagpole", 0, "", 0, "LineageNpcEV.rune_holything", 46, 72.5, 20, "etc", "L2Npc", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(36072, 36072, "Foreman", 0, "Cloud Mountain", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 75, "male", "L2FortManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36073, 36073, "Suspicious Merchant", 0, "Cloud Mountain", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2FortSiegeNpc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(36074, 36074, "Guard Captain", 0, "Cloud Mountain", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 75, "female", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 80, 641, 0, 30, 120, 0, 1), 
(36075, 36075, "Archer Captain", 0, "Cloud Mountain", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 75, "male", "L2Npc", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 0, 0, 0, 30, 120, 0, 1), 
(36076, 36076, "General", 0, "Cloud Mountain", 0, "LineageNPC2.officer_of_insurgents_orc", 14.5, 30, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 9813, 9813, 0, 60, 120, 0, 1), 
(36077, 36077, "Support Unit Captain", 0, "Cloud Mountain", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 75, "female", "L2FortSupportCaptain", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 28, 120, 0, 1), 
(36078, 36078, "Engineering Manager", 0, "Cloud Mountain", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36079, 36079, "Logistics Officer", 0, "Cloud Mountain", 0, "LineageNPC.e_collector_teacher_MDwarf", 8, 17.5, 75, "male", "L2FortLogistics", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36080, 36080, "Supply Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(36081, 36081, "Detention Camp Warden", 0, "Cloud Mountain", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36082, 36082, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36083, 36083, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36084, 36084, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36085, 36085, "Rebel Commander", 0, "Cloud Mountain", 0, "LineageNPC2.chief_of_insurgents", 10, 26.99, 80, "male", "L2Defender", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 3200, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 2500, 6377, 0, 29.8, 120, 0, 1), 
(36086, 36086, "Decorated Rebel Soldier", 0, "Cloud Mountain", 0, "LineageMonster.shadow_50_bi", 15, 45, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(36087, 36087, "Rebel Private", 0, "Cloud Mountain", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 97, 0, 0, 50, 120, 0, 1), 
(36088, 36088, "Court Guard", 0, "Cloud Mountain", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 72, "male", "L2Defender", 80, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2592, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 98, 0, 0, 50, 120, 0, 1), 
(36089, 36089, "Guard", 0, "Cloud Mountain", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 72, "male", "L2Defender", 1100, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2592, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 8, 333, 287, 0, 0, 50, 120, 0, 1), 
(36090, 36090, "Main Machine", 0, "Control Room", 0, "LineageNpcEV.machine_guard_a", 46, 35, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(36091, 36091, "Backup Power Unit", 0, "Control Room", 0, "LineageNpcEV.strange_mechanical_instrument", 16, 15.5, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36092, 36092, "Control Unit", 0, "Control Room", 0, "LineageNpcEV.door_lock", 39, 42.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(36093, 36093, "Power Control Unit", 0, "Control Room", 0, "LineageNpcEV.machine_construction_a", 54, 59.5, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(36094, 36094, "Dwarven Gunnery Sergeant", 0, "", 0, "LineageNPC2.battery_of_insurgents", 13, 17.5, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 0, 0, 0, 60, 120, 0, 1), 
(36095, 36095, "Scout Golem", 0, "Control Room", 0, "LineageMonster.mechanic_golem", 5, 19, 74, "male", "L2Defender", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 2738, 0, 773.81598, 314.65987, 528.41601, 230.25444, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(36096, 36096, "Guard Captain", 0, "Guard", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 78, "female", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 80, 641, 0, 60, 120, 0, 1), 
(36097, 36097, "Guard", 0, "Guard", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 75, 0, 0, 50, 120, 0, 1), 
(36098, 36098, "Guard", 0, "Guard", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 75, 0, 0, 50, 120, 0, 1), 
(36099, 36099, "Support Unit Captain", 0, "Support Unit", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 78, "female", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(36100, 36100, "Wizard", 0, "Support Unit", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 325, 0, 0, 50, 120, 0, 1), 
(36101, 36101, "Healer", 0, "Support Unit", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 76, "female", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 92, 0, 0, 50, 120, 0, 1), 
(36102, 36102, "Archer Captain", 0, "Archer", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 78, "male", "L2FortCommander", 1100, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 8, 333, 10212, 0, 0, 60, 120, 0, 1), 
(36103, 36103, "Archer", 0, "Archer", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 287, 0, 0, 50, 120, 0, 1), 
(36104, 36104, "General", 0, "Officer's Barracks", 0, "LineageNPC2.officer_of_insurgents_orc", 14.5, 30, 78, "male", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 9813, 9813, 0, 60, 120, 0, 1), 
(36105, 36105, "Minister", 0, "Officer's Barracks", 0, "LineageNPC.e_guard_MOrc", 8, 27, 78, "male", "L2Defender", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 7895, 0, 0, 50, 120, 0, 1), 
(36106, 36106, "Ballista", 0, "Cloud Mountain", 0, "LineageNpcEV.ballista", 112, 59, 80, "male", "L2FortBallista", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(36107, 36107, "Mercenary Captain", 0, "", 0, "LineageMonster3.Kight_of_Dawn", 12, 24.5, 80, "male", "L2Npc", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 2500, 6377, 0, 36.48, 100, 0, 1), 
(36108, 36108, "Mercenary Private", 0, "", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2Npc", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 96, 0, 0, 50, 120, 0, 1), 
(36109, 36109, "Flagpole", 0, "", 0, "LineageNpcEV.rune_holything", 46, 72.5, 20, "etc", "L2Npc", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(36110, 36110, "Foreman", 0, "Tanor Fortress", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 75, "male", "L2FortManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36111, 36111, "Suspicious Merchant", 0, "Tanor Fortress", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2FortSiegeNpc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(36112, 36112, "Guard Captain", 0, "Tanor Fortress", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 75, "female", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 80, 641, 0, 30, 120, 0, 1), 
(36113, 36113, "Archer Captain", 0, "Tanor Fortress", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 75, "male", "L2Npc", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 0, 0, 0, 30, 120, 0, 1), 
(36114, 36114, "Support Unit Captain", 0, "Tanor Fortress", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 75, "female", "L2FortSupportCaptain", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 28, 120, 0, 1), 
(36115, 36115, "Engineering Manager", 0, "Tanor Fortress", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36116, 36116, "Logistics Officer", 0, "Tanor Fortress", 0, "LineageNPC.e_collector_teacher_MDwarf", 8, 17.5, 75, "male", "L2FortLogistics", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36117, 36117, "Supply Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(36118, 36118, "Detention Camp Warden", 0, "Tanor Fortress", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36119, 36119, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36120, 36120, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36121, 36121, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36122, 36122, "Rebel Commander", 0, "Tanor Fortress", 0, "LineageNPC2.chief_of_insurgents", 10, 26.99, 80, "male", "L2Defender", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 3200, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 2500, 6377, 0, 29.8, 120, 0, 1), 
(36123, 36123, "Decorated Rebel Soldier", 0, "Tanor Fortress", 0, "LineageMonster.shadow_50_bi", 15, 45, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(36124, 36124, "Rebel Private", 0, "Tanor Fortress", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 97, 0, 0, 50, 120, 0, 1), 
(36125, 36125, "Court Guard", 0, "Tanor Fortress", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 72, "male", "L2Defender", 80, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2592, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 98, 0, 0, 50, 120, 0, 1), 
(36126, 36126, "Guard", 0, "Tanor Fortress", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 72, "male", "L2Defender", 1100, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2592, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 8, 333, 287, 0, 0, 50, 120, 0, 1), 
(36127, 36127, "Power Control Unit", 0, "Control Room", 0, "LineageNpcEV.machine_construction_a", 54, 59.5, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(36128, 36128, "Dwarven Gunnery Sergeant", 0, "", 0, "LineageNPC2.battery_of_insurgents", 13, 17.5, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 0, 0, 0, 60, 120, 0, 1), 
(36129, 36129, "Guard Captain", 0, "Guard", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 78, "female", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 80, 641, 0, 60, 120, 0, 1), 
(36130, 36130, "Guard", 0, "Guard", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 75, 0, 0, 50, 120, 0, 1), 
(36131, 36131, "Guard", 0, "Guard", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 75, 0, 0, 50, 120, 0, 1), 
(36132, 36132, "Support Unit Captain", 0, "Support Unit", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 78, "female", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(36133, 36133, "Wizard", 0, "Support Unit", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 325, 0, 0, 50, 120, 0, 1), 
(36134, 36134, "Healer", 0, "Support Unit", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 76, "female", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 92, 0, 0, 50, 120, 0, 1), 
(36135, 36135, "Archer Captain", 0, "Archer", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 78, "male", "L2FortCommander", 1100, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 8, 333, 10212, 0, 0, 60, 120, 0, 1), 
(36136, 36136, "Archer", 0, "Archer", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 287, 0, 0, 50, 120, 0, 1), 
(36137, 36137, "Ballista", 0, "Tanor Fortress", 0, "LineageNpcEV.ballista", 112, 59, 80, "male", "L2FortBallista", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(36138, 36138, "Mercenary Captain", 0, "", 0, "LineageMonster3.Kight_of_Dawn", 12, 24.5, 80, "male", "L2Npc", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 2500, 6377, 0, 36.48, 100, 0, 1), 
(36139, 36139, "Mercenary Private", 0, "", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2Npc", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 96, 0, 0, 50, 120, 0, 1), 
(36140, 36140, "Flagpole", 0, "", 0, "LineageNpcEV.rune_holything", 46, 72.5, 20, "etc", "L2Npc", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(36141, 36141, "Foreman", 0, "Dragonspine Fortress", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 75, "male", "L2FortManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36142, 36142, "Suspicious Merchant", 0, "Dragonspine Fortress", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2FortSiegeNpc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(36143, 36143, "Guard Captain", 0, "Dragonspine Fortress", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 75, "female", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 80, 641, 0, 30, 120, 0, 1), 
(36144, 36144, "Archer Captain", 0, "Dragonspine Fortress", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 75, "male", "L2Npc", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 0, 0, 0, 30, 120, 0, 1), 
(36145, 36145, "Support Unit Captain", 0, "Dragonspine Fortress", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 75, "female", "L2FortSupportCaptain", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 28, 120, 0, 1), 
(36146, 36146, "Engineering Manager", 0, "Dragonspine Fortress", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36147, 36147, "Logistics Officer", 0, "Dragonspine Fortress", 0, "LineageNPC.e_collector_teacher_MDwarf", 8, 17.5, 75, "male", "L2FortLogistics", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36148, 36148, "Supply Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1); 

INSERT INTO `npc` VALUES
(36149, 36149, "Detention Camp Warden", 0, "Dragonspine Fortress", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36150, 36150, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36151, 36151, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36152, 36152, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36153, 36153, "Rebel Commander", 0, "Dragonspine Fortress", 0, "LineageNPC2.chief_of_insurgents", 10, 26.99, 80, "male", "L2Defender", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 3200, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 2500, 6377, 0, 29.8, 120, 0, 1), 
(36154, 36154, "Decorated Rebel Soldier", 0, "Dragonspine Fortress", 0, "LineageMonster.shadow_50_bi", 15, 45, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(36155, 36155, "Rebel Private", 0, "Dragonspine Fortress", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 97, 0, 0, 50, 120, 0, 1), 
(36156, 36156, "Court Guard", 0, "Dragonspine Fortress", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 72, "male", "L2Defender", 80, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2592, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 98, 0, 0, 50, 120, 0, 1), 
(36157, 36157, "Guard", 0, "Dragonspine Fortress", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 72, "male", "L2Defender", 1100, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2592, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 8, 333, 287, 0, 0, 50, 120, 0, 1), 
(36158, 36158, "Power Control Unit", 0, "Control Room", 0, "LineageNpcEV.machine_construction_a", 54, 59.5, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(36159, 36159, "Dwarven Gunnery Sergeant", 0, "", 0, "LineageNPC2.battery_of_insurgents", 13, 17.5, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 0, 0, 0, 60, 120, 0, 1), 
(36160, 36160, "Guard Captain", 0, "Guard", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 78, "female", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 80, 641, 0, 60, 120, 0, 1), 
(36161, 36161, "Guard", 0, "Guard", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 75, 0, 0, 50, 120, 0, 1), 
(36162, 36162, "Guard", 0, "Guard", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 75, 0, 0, 50, 120, 0, 1), 
(36163, 36163, "Support Unit Captain", 0, "Support Unit", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 78, "female", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(36164, 36164, "Wizard", 0, "Support Unit", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 325, 0, 0, 50, 120, 0, 1), 
(36165, 36165, "Healer", 0, "Support Unit", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 76, "female", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 92, 0, 0, 50, 120, 0, 1), 
(36166, 36166, "Archer Captain", 0, "Archer", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 78, "male", "L2FortCommander", 1100, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 8, 333, 10212, 0, 0, 60, 120, 0, 1), 
(36167, 36167, "Archer", 0, "Archer", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 287, 0, 0, 50, 120, 0, 1), 
(36168, 36168, "Ballista", 0, "Dragonspine Fortress", 0, "LineageNpcEV.ballista", 112, 59, 80, "male", "L2FortBallista", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(36169, 36169, "Mercenary Captain", 0, "", 0, "LineageMonster3.Kight_of_Dawn", 12, 24.5, 80, "male", "L2Npc", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 2500, 6377, 0, 36.48, 100, 0, 1), 
(36170, 36170, "Mercenary Private", 0, "", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2Npc", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 96, 0, 0, 50, 120, 0, 1), 
(36171, 36171, "Flagpole", 0, "", 0, "LineageNpcEV.rune_holything", 46, 72.5, 20, "etc", "L2Npc", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(36172, 36172, "Foreman", 0, "Antharas' Fortress", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 75, "male", "L2FortManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36173, 36173, "Suspicious Merchant", 0, "Antharas' Fortress", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2FortSiegeNpc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(36174, 36174, "Guard Captain", 0, "Antharas' Fortress", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 75, "female", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 80, 641, 0, 30, 120, 0, 1), 
(36175, 36175, "Archer Captain", 0, "Antharas' Fortress", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 75, "male", "L2Npc", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 0, 0, 0, 30, 120, 0, 1), 
(36176, 36176, "General", 0, "Antharas' Fortress", 0, "LineageNPC2.officer_of_insurgents_orc", 14.5, 30, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 9813, 9813, 0, 60, 120, 0, 1), 
(36177, 36177, "Support Unit Captain", 0, "Antharas' Fortress", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 75, "female", "L2FortSupportCaptain", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 28, 120, 0, 1), 
(36178, 36178, "Engineering Manager", 0, "Antharas' Fortress", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36179, 36179, "Logistics Officer", 0, "Antharas' Fortress", 0, "LineageNPC.e_collector_teacher_MDwarf", 8, 17.5, 75, "male", "L2FortLogistics", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36180, 36180, "Supply Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(36181, 36181, "Detention Camp Warden", 0, "Antharas' Fortress", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36182, 36182, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36183, 36183, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36184, 36184, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36185, 36185, "Rebel Commander", 0, "Antharas' Fortress", 0, "LineageNPC2.chief_of_insurgents", 10, 26.99, 80, "male", "L2Defender", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 3200, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 2500, 6377, 0, 29.8, 120, 0, 1), 
(36186, 36186, "Decorated Rebel Soldier", 0, "Antharas' Fortress", 0, "LineageMonster.shadow_50_bi", 15, 45, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(36187, 36187, "Rebel Private", 0, "Antharas' Fortress", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 97, 0, 0, 50, 120, 0, 1), 
(36188, 36188, "Court Guard", 0, "Antharas' Fortress", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 72, "male", "L2Defender", 80, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2592, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 98, 0, 0, 50, 120, 0, 1), 
(36189, 36189, "Guard", 0, "Antharas' Fortress", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 72, "male", "L2Defender", 1100, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2592, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 8, 333, 287, 0, 0, 50, 120, 0, 1), 
(36190, 36190, "Main Machine", 0, "Control Room", 0, "LineageNpcEV.machine_guard_a", 46, 35, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(36191, 36191, "Backup Power Unit", 0, "Control Room", 0, "LineageNpcEV.strange_mechanical_instrument", 16, 15.5, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36192, 36192, "Control Unit", 0, "Control Room", 0, "LineageNpcEV.door_lock", 39, 42.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(36193, 36193, "Power Control Unit", 0, "Control Room", 0, "LineageNpcEV.machine_construction_a", 54, 59.5, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(36194, 36194, "Dwarven Gunnery Sergeant", 0, "", 0, "LineageNPC2.battery_of_insurgents", 13, 17.5, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 0, 0, 0, 60, 120, 0, 1), 
(36195, 36195, "Scout Golem", 0, "Control Room", 0, "LineageMonster.mechanic_golem", 5, 19, 74, "male", "L2Defender", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 2738, 0, 773.81598, 314.65987, 528.41601, 230.25444, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(36196, 36196, "Guard Captain", 0, "Guard", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 78, "female", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 80, 641, 0, 60, 120, 0, 1), 
(36197, 36197, "Guard", 0, "Guard", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 75, 0, 0, 50, 120, 0, 1), 
(36198, 36198, "Guard", 0, "Guard", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 75, 0, 0, 50, 120, 0, 1), 
(36199, 36199, "Support Unit Captain", 0, "Support Unit", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 78, "female", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(36200, 36200, "Wizard", 0, "Support Unit", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 325, 0, 0, 50, 120, 0, 1), 
(36201, 36201, "Healer", 0, "Support Unit", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 76, "female", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 92, 0, 0, 50, 120, 0, 1), 
(36202, 36202, "Archer Captain", 0, "Archer", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 78, "male", "L2FortCommander", 1100, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 8, 333, 10212, 0, 0, 60, 120, 0, 1), 
(36203, 36203, "Archer", 0, "Archer", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 287, 0, 0, 50, 120, 0, 1), 
(36204, 36204, "General", 0, "Officer's Barracks", 0, "LineageNPC2.officer_of_insurgents_orc", 14.5, 30, 78, "male", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 9813, 9813, 0, 60, 120, 0, 1), 
(36205, 36205, "Minister", 0, "Officer's Barracks", 0, "LineageNPC.e_guard_MOrc", 8, 27, 78, "male", "L2Defender", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 7895, 0, 0, 50, 120, 0, 1), 
(36206, 36206, "Ballista", 0, "Antharas' Fortress", 0, "LineageNpcEV.ballista", 112, 59, 80, "male", "L2FortBallista", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(36207, 36207, "Mercenary Captain", 0, "", 0, "LineageMonster3.Kight_of_Dawn", 12, 24.5, 80, "male", "L2Npc", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 2500, 6377, 0, 36.48, 100, 0, 1), 
(36208, 36208, "Mercenary Private", 0, "", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2Npc", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 96, 0, 0, 50, 120, 0, 1), 
(36209, 36209, "Flagpole", 0, "", 0, "LineageNpcEV.rune_holything", 46, 72.5, 20, "etc", "L2Npc", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(36210, 36210, "Foreman", 0, "Western Fortress", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 75, "male", "L2FortManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36211, 36211, "Suspicious Merchant", 0, "Western Fortress", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2FortSiegeNpc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(36212, 36212, "Guard Captain", 0, "Western Fortress", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 75, "female", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 80, 641, 0, 30, 120, 0, 1), 
(36213, 36213, "Archer Captain", 0, "Western Fortress", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 75, "male", "L2Npc", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 0, 0, 0, 30, 120, 0, 1), 
(36214, 36214, "General", 0, "Western Fortress", 0, "LineageNPC2.officer_of_insurgents_orc", 14.5, 30, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 9813, 9813, 0, 60, 120, 0, 1), 
(36215, 36215, "Support Unit Captain", 0, "Western Fortress", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 75, "female", "L2FortSupportCaptain", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 28, 120, 0, 1), 
(36216, 36216, "Engineering Manager", 0, "Western Fortress", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36217, 36217, "Logistics Officer", 0, "Western Fortress", 0, "LineageNPC.e_collector_teacher_MDwarf", 8, 17.5, 75, "male", "L2FortLogistics", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36218, 36218, "Supply Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(36219, 36219, "Detention Camp Warden", 0, "Western Fortress", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36220, 36220, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36221, 36221, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36222, 36222, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36223, 36223, "Rebel Commander", 0, "Western Fortress", 0, "LineageNPC2.chief_of_insurgents", 10, 26.99, 80, "male", "L2Defender", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 3200, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 2500, 6377, 0, 29.8, 120, 0, 1), 
(36224, 36224, "Decorated Rebel Soldier", 0, "Western Fortress", 0, "LineageMonster.shadow_50_bi", 15, 45, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(36225, 36225, "Rebel Private", 0, "Western Fortress", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 97, 0, 0, 50, 120, 0, 1), 
(36226, 36226, "Court Guard", 0, "Western Fortress", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 72, "male", "L2Defender", 80, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2592, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 98, 0, 0, 50, 120, 0, 1), 
(36227, 36227, "Guard", 0, "Western Fortress", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 72, "male", "L2Defender", 1100, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2592, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 8, 333, 287, 0, 0, 50, 120, 0, 1), 
(36228, 36228, "Main Machine", 0, "Control Room", 0, "LineageNpcEV.machine_guard_a", 46, 35, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(36229, 36229, "Backup Power Unit", 0, "Control Room", 0, "LineageNpcEV.strange_mechanical_instrument", 16, 15.5, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36230, 36230, "Control Unit", 0, "Control Room", 0, "LineageNpcEV.door_lock", 39, 42.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(36231, 36231, "Power Control Unit", 0, "Control Room", 0, "LineageNpcEV.machine_construction_a", 54, 59.5, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(36232, 36232, "Dwarven Gunnery Sergeant", 0, "", 0, "LineageNPC2.battery_of_insurgents", 13, 17.5, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 0, 0, 0, 60, 120, 0, 1), 
(36233, 36233, "Scout Golem", 0, "Control Room", 0, "LineageMonster.mechanic_golem", 5, 19, 74, "male", "L2Defender", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 2738, 0, 773.81598, 314.65987, 528.41601, 230.25444, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(36234, 36234, "Guard Captain", 0, "Guard", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 78, "female", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 80, 641, 0, 60, 120, 0, 1), 
(36235, 36235, "Guard", 0, "Guard", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 75, 0, 0, 50, 120, 0, 1), 
(36236, 36236, "Guard", 0, "Guard", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 75, 0, 0, 50, 120, 0, 1), 
(36237, 36237, "Support Unit Captain", 0, "Support Unit", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 78, "female", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(36238, 36238, "Wizard", 0, "Support Unit", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 325, 0, 0, 50, 120, 0, 1), 
(36239, 36239, "Healer", 0, "Support Unit", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 76, "female", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 92, 0, 0, 50, 120, 0, 1), 
(36240, 36240, "Archer Captain", 0, "Archer", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 78, "male", "L2FortCommander", 1100, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 8, 333, 10212, 0, 0, 60, 120, 0, 1), 
(36241, 36241, "Archer", 0, "Archer", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 287, 0, 0, 50, 120, 0, 1), 
(36242, 36242, "General", 0, "Officer's Barracks", 0, "LineageNPC2.officer_of_insurgents_orc", 14.5, 30, 78, "male", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 9813, 9813, 0, 60, 120, 0, 1), 
(36243, 36243, "Minister", 0, "Officer's Barracks", 0, "LineageNPC.e_guard_MOrc", 8, 27, 78, "male", "L2Defender", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 7895, 0, 0, 50, 120, 0, 1), 
(36244, 36244, "Ballista", 0, "Western Fortress", 0, "LineageNpcEV.ballista", 112, 59, 80, "male", "L2FortBallista", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(36245, 36245, "Mercenary Captain", 0, "", 0, "LineageMonster3.Kight_of_Dawn", 12, 24.5, 80, "male", "L2Npc", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 2500, 6377, 0, 36.48, 100, 0, 1), 
(36246, 36246, "Mercenary Private", 0, "", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2Npc", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 96, 0, 0, 50, 120, 0, 1), 
(36247, 36247, "Flagpole", 0, "", 0, "LineageNpcEV.rune_holything", 46, 72.5, 20, "etc", "L2Npc", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(36248, 36248, "Foreman", 0, "Hunter's Fortress", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 75, "male", "L2FortManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36249, 36249, "Suspicious Merchant", 0, "Hunter's Fortress", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2FortSiegeNpc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(36250, 36250, "Guard Captain", 0, "Hunter's Fortress", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 75, "female", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 80, 641, 0, 30, 120, 0, 1), 
(36251, 36251, "Archer Captain", 0, "Hunter's Fortress", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 75, "male", "L2Npc", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 0, 0, 0, 30, 120, 0, 1), 
(36252, 36252, "General", 0, "Hunter's Fortress", 0, "LineageNPC2.officer_of_insurgents_orc", 14.5, 30, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 9813, 9813, 0, 60, 120, 0, 1), 
(36253, 36253, "Support Unit Captain", 0, "Hunter's Fortress", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 75, "female", "L2FortSupportCaptain", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 28, 120, 0, 1), 
(36254, 36254, "Engineering Manager", 0, "Hunter's Fortress", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36255, 36255, "Logistics Officer", 0, "Hunter's Fortress", 0, "LineageNPC.e_collector_teacher_MDwarf", 8, 17.5, 75, "male", "L2FortLogistics", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36256, 36256, "Supply Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(36257, 36257, "Detention Camp Warden", 0, "Hunter's Fortress", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36258, 36258, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36259, 36259, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36260, 36260, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36261, 36261, "Rebel Commander", 0, "Hunter's Fortress", 0, "LineageNPC2.chief_of_insurgents", 10, 26.99, 80, "male", "L2Defender", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 3200, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 2500, 6377, 0, 29.8, 120, 0, 1), 
(36262, 36262, "Decorated Rebel Soldier", 0, "Hunter's Fortress", 0, "LineageMonster.shadow_50_bi", 15, 45, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(36263, 36263, "Rebel Private", 0, "Hunter's Fortress", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 97, 0, 0, 50, 120, 0, 1), 
(36264, 36264, "Court Guard", 0, "Hunter's Fortress", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 72, "male", "L2Defender", 80, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2592, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 98, 0, 0, 50, 120, 0, 1), 
(36265, 36265, "Guard", 0, "Hunter's Fortress", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 72, "male", "L2Defender", 1100, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2592, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 8, 333, 287, 0, 0, 50, 120, 0, 1), 
(36266, 36266, "Main Machine", 0, "Control Room", 0, "LineageNpcEV.machine_guard_a", 46, 35, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(36267, 36267, "Backup Power Unit", 0, "Control Room", 0, "LineageNpcEV.strange_mechanical_instrument", 16, 15.5, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36268, 36268, "Control Unit", 0, "Control Room", 0, "LineageNpcEV.door_lock", 39, 42.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(36269, 36269, "Power Control Unit", 0, "Control Room", 0, "LineageNpcEV.machine_construction_a", 54, 59.5, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(36270, 36270, "Dwarven Gunnery Sergeant", 0, "", 0, "LineageNPC2.battery_of_insurgents", 13, 17.5, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 0, 0, 0, 60, 120, 0, 1), 
(36271, 36271, "Scout Golem", 0, "Control Room", 0, "LineageMonster.mechanic_golem", 5, 19, 74, "male", "L2Defender", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 2738, 0, 773.81598, 314.65987, 528.41601, 230.25444, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(36272, 36272, "Guard Captain", 0, "Guard", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 78, "female", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 80, 641, 0, 60, 120, 0, 1), 
(36273, 36273, "Guard", 0, "Guard", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 75, 0, 0, 50, 120, 0, 1), 
(36274, 36274, "Guard", 0, "Guard", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 75, 0, 0, 50, 120, 0, 1), 
(36275, 36275, "Support Unit Captain", 0, "Support Unit", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 78, "female", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(36276, 36276, "Wizard", 0, "Support Unit", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 325, 0, 0, 50, 120, 0, 1), 
(36277, 36277, "Healer", 0, "Support Unit", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 76, "female", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 92, 0, 0, 50, 120, 0, 1), 
(36278, 36278, "Archer Captain", 0, "Archer", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 78, "male", "L2FortCommander", 1100, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 8, 333, 10212, 0, 0, 60, 120, 0, 1), 
(36279, 36279, "Archer", 0, "Archer", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 287, 0, 0, 50, 120, 0, 1), 
(36280, 36280, "General", 0, "Officer's Barracks", 0, "LineageNPC2.officer_of_insurgents_orc", 14.5, 30, 78, "male", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 9813, 9813, 0, 60, 120, 0, 1), 
(36281, 36281, "Minister", 0, "Officer's Barracks", 0, "LineageNPC.e_guard_MOrc", 8, 27, 78, "male", "L2Defender", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 7895, 0, 0, 50, 120, 0, 1), 
(36282, 36282, "Ballista", 0, "Hunter's Fortress", 0, "LineageNpcEV.ballista", 112, 59, 80, "male", "L2FortBallista", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(36283, 36283, "Mercenary Captain", 0, "", 0, "LineageMonster3.Kight_of_Dawn", 12, 24.5, 80, "male", "L2Npc", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 2500, 6377, 0, 36.48, 100, 0, 1), 
(36284, 36284, "Mercenary Private", 0, "", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2Npc", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 96, 0, 0, 50, 120, 0, 1), 
(36285, 36285, "Flagpole", 0, "", 0, "LineageNpcEV.rune_holything", 46, 72.5, 20, "etc", "L2Npc", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(36286, 36286, "Foreman", 0, "Aaru Fortress", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 75, "male", "L2FortManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36287, 36287, "Suspicious Merchant", 0, "Aaru Fortress", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2FortSiegeNpc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(36288, 36288, "Guard Captain", 0, "Aaru Fortress", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 75, "female", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 80, 641, 0, 30, 120, 0, 1), 
(36289, 36289, "Archer Captain", 0, "Aaru Fortress", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 75, "male", "L2Npc", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 0, 0, 0, 30, 120, 0, 1), 
(36290, 36290, "Support Unit Captain", 0, "Aaru Fortress", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 75, "female", "L2FortSupportCaptain", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 28, 120, 0, 1), 
(36291, 36291, "Engineering Manager", 0, "Aaru Fortress", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36292, 36292, "Logistics Officer", 0, "Aaru Fortress", 0, "LineageNPC.e_collector_teacher_MDwarf", 8, 17.5, 75, "male", "L2FortLogistics", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36293, 36293, "Supply Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(36294, 36294, "Detention Camp Warden", 0, "Aaru Fortress", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36295, 36295, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36296, 36296, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36297, 36297, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36298, 36298, "Rebel Commander", 0, "Aaru Fortress", 0, "LineageNPC2.chief_of_insurgents", 10, 26.99, 80, "male", "L2Defender", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 3200, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 2500, 6377, 0, 29.8, 120, 0, 1), 
(36299, 36299, "Decorated Rebel Soldier", 0, "Aaru Fortress", 0, "LineageMonster.shadow_50_bi", 15, 45, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(36300, 36300, "Rebel Private", 0, "Aaru Fortress", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 97, 0, 0, 50, 120, 0, 1), 
(36301, 36301, "Court Guard", 0, "Aaru Fortress", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 72, "male", "L2Defender", 80, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2592, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 98, 0, 0, 50, 120, 0, 1), 
(36302, 36302, "Guard", 0, "Aaru Fortress", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 72, "male", "L2Defender", 1100, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2592, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 8, 333, 287, 0, 0, 50, 120, 0, 1), 
(36303, 36303, "Power Control Unit", 0, "Control Room", 0, "LineageNpcEV.machine_construction_a", 54, 59.5, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(36304, 36304, "Dwarven Gunnery Sergeant", 0, "", 0, "LineageNPC2.battery_of_insurgents", 13, 17.5, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 0, 0, 0, 60, 120, 0, 1), 
(36305, 36305, "Guard Captain", 0, "Guard", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 78, "female", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 80, 641, 0, 60, 120, 0, 1), 
(36306, 36306, "Guard", 0, "Guard", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 75, 0, 0, 50, 120, 0, 1), 
(36307, 36307, "Guard", 0, "Guard", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 75, 0, 0, 50, 120, 0, 1), 
(36308, 36308, "Support Unit Captain", 0, "Support Unit", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 78, "female", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(36309, 36309, "Wizard", 0, "Support Unit", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 325, 0, 0, 50, 120, 0, 1), 
(36310, 36310, "Healer", 0, "Support Unit", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 76, "female", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 92, 0, 0, 50, 120, 0, 1), 
(36311, 36311, "Archer Captain", 0, "Archer", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 78, "male", "L2FortCommander", 1100, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 8, 333, 10212, 0, 0, 60, 120, 0, 1), 
(36312, 36312, "Archer", 0, "Archer", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 287, 0, 0, 50, 120, 0, 1), 
(36313, 36313, "Ballista", 0, "Aaru Fortress", 0, "LineageNpcEV.ballista", 112, 59, 80, "male", "L2FortBallista", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(36314, 36314, "Mercenary Captain", 0, "", 0, "LineageMonster3.Kight_of_Dawn", 12, 24.5, 80, "male", "L2Npc", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 2500, 6377, 0, 36.48, 100, 0, 1), 
(36315, 36315, "Mercenary Private", 0, "", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2Npc", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 96, 0, 0, 50, 120, 0, 1), 
(36316, 36316, "Flagpole", 0, "", 0, "LineageNpcEV.rune_holything", 46, 72.5, 20, "etc", "L2Npc", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(36317, 36317, "Foreman", 0, "Demon Fortress", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 75, "male", "L2FortManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36318, 36318, "Suspicious Merchant", 0, "Demon Fortress", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2FortSiegeNpc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(36319, 36319, "Guard Captain", 0, "Demon Fortress", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 75, "female", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 80, 641, 0, 30, 120, 0, 1), 
(36320, 36320, "Archer Captain", 0, "Demon Fortress", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 75, "male", "L2Npc", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 0, 0, 0, 30, 120, 0, 1), 
(36321, 36321, "General", 0, "Demon Fortress", 0, "LineageNPC2.officer_of_insurgents_orc", 14.5, 30, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 9813, 9813, 0, 60, 120, 0, 1), 
(36322, 36322, "Support Unit Captain", 0, "Demon Fortress", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 75, "female", "L2FortSupportCaptain", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 28, 120, 0, 1), 
(36323, 36323, "Engineering Manager", 0, "Demon Fortress", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36324, 36324, "Logistics Officer", 0, "Demon Fortress", 0, "LineageNPC.e_collector_teacher_MDwarf", 8, 17.5, 75, "male", "L2FortLogistics", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36325, 36325, "Supply Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(36326, 36326, "Detention Camp Warden", 0, "Demon Fortress", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36327, 36327, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36328, 36328, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36329, 36329, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36330, 36330, "Rebel Commander", 0, "Demon Fortress", 0, "LineageNPC2.chief_of_insurgents", 10, 26.99, 80, "male", "L2Defender", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 3200, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 2500, 6377, 0, 29.8, 120, 0, 1), 
(36331, 36331, "Decorated Rebel Soldier", 0, "Demon Fortress", 0, "LineageMonster.shadow_50_bi", 15, 45, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(36332, 36332, "Rebel Private", 0, "Demon Fortress", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 97, 0, 0, 50, 120, 0, 1), 
(36333, 36333, "Court Guard", 0, "Demon Fortress", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 72, "male", "L2Defender", 80, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2592, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 98, 0, 0, 50, 120, 0, 1), 
(36334, 36334, "Guard", 0, "Demon Fortress", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 72, "male", "L2Defender", 1100, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2592, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 8, 333, 287, 0, 0, 50, 120, 0, 1), 
(36335, 36335, "Main Machine", 0, "Control Room", 0, "LineageNpcEV.machine_guard_a", 46, 35, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(36336, 36336, "Backup Power Unit", 0, "Control Room", 0, "LineageNpcEV.strange_mechanical_instrument", 16, 15.5, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36337, 36337, "Control Unit", 0, "Control Room", 0, "LineageNpcEV.door_lock", 39, 42.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(36338, 36338, "Power Control Unit", 0, "Control Room", 0, "LineageNpcEV.machine_construction_a", 54, 59.5, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(36339, 36339, "Dwarven Gunnery Sergeant", 0, "", 0, "LineageNPC2.battery_of_insurgents", 13, 17.5, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 0, 0, 0, 60, 120, 0, 1), 
(36340, 36340, "Scout Golem", 0, "Control Room", 0, "LineageMonster.mechanic_golem", 5, 19, 74, "male", "L2Defender", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 2738, 0, 773.81598, 314.65987, 528.41601, 230.25444, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(36341, 36341, "Guard Captain", 0, "Guard", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 78, "female", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 80, 641, 0, 60, 120, 0, 1), 
(36342, 36342, "Guard", 0, "Guard", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 75, 0, 0, 50, 120, 0, 1), 
(36343, 36343, "Guard", 0, "Guard", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 75, 0, 0, 50, 120, 0, 1), 
(36344, 36344, "Support Unit Captain", 0, "Support Unit", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 78, "female", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(36345, 36345, "Wizard", 0, "Support Unit", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 325, 0, 0, 50, 120, 0, 1), 
(36346, 36346, "Healer", 0, "Support Unit", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 76, "female", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 92, 0, 0, 50, 120, 0, 1), 
(36347, 36347, "Archer Captain", 0, "Archer", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 78, "male", "L2FortCommander", 1100, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 8, 333, 10212, 0, 0, 60, 120, 0, 1), 
(36348, 36348, "Archer", 0, "Archer", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 287, 0, 0, 50, 120, 0, 1), 
(36349, 36349, "General", 0, "Officer's Barracks", 0, "LineageNPC2.officer_of_insurgents_orc", 14.5, 30, 78, "male", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 9813, 9813, 0, 60, 120, 0, 1), 
(36350, 36350, "Minister", 0, "Officer's Barracks", 0, "LineageNPC.e_guard_MOrc", 8, 27, 78, "male", "L2Defender", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 7895, 0, 0, 50, 120, 0, 1), 
(36351, 36351, "Ballista", 0, "Demon Fortress", 0, "LineageNpcEV.ballista", 112, 59, 80, "male", "L2FortBallista", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(36352, 36352, "Mercenary Captain", 0, "", 0, "LineageMonster3.Kight_of_Dawn", 12, 24.5, 80, "male", "L2Npc", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 2500, 6377, 0, 36.48, 100, 0, 1), 
(36353, 36353, "Mercenary Private", 0, "", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2Npc", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 96, 0, 0, 50, 120, 0, 1), 
(36354, 36354, "Flagpole", 0, "", 0, "LineageNpcEV.rune_holything", 46, 72.5, 20, "etc", "L2Npc", 40, 342.5127, 192, 2.5, 1.2, 40, 43, 30, 21, 20, 20, 0, 0, 44.32863, 86.87049, 30.2707, 63.56806, 253, 4, 333, 0, 0, 0, 50, 1, 0, 1), 
(36355, 36355, "Foreman", 0, "Monastic Fortress", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 75, "male", "L2FortManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36356, 36356, "Suspicious Merchant", 0, "Monastic Fortress", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2FortSiegeNpc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 100, 0, 1), 
(36357, 36357, "Guard Captain", 0, "Monastic Fortress", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 75, "female", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 80, 641, 0, 30, 120, 0, 1), 
(36358, 36358, "Archer Captain", 0, "Monastic Fortress", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 75, "male", "L2Npc", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 0, 0, 0, 30, 120, 0, 1), 
(36359, 36359, "General", 0, "Monastic Fortress", 0, "LineageNPC2.officer_of_insurgents_orc", 14.5, 30, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 9813, 9813, 0, 60, 120, 0, 1), 
(36360, 36360, "Support Unit Captain", 0, "Monastic Fortress", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 75, "female", "L2FortSupportCaptain", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 28, 120, 0, 1), 
(36361, 36361, "Engineering Manager", 0, "Monastic Fortress", 0, "LineageNPC.e_guard_MDwarf", 8, 19, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36362, 36362, "Logistics Officer", 0, "Monastic Fortress", 0, "LineageNPC.e_collector_teacher_MDwarf", 8, 17.5, 75, "male", "L2FortLogistics", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36363, 36363, "Supply Box", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(36364, 36364, "Detention Camp Warden", 0, "Monastic Fortress", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36365, 36365, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36366, 36366, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36367, 36367, "Doorman", 0, "", 0, "LineageNPC.a_guard_MHuman", 8, 24, 75, "male", "L2FortDoormen", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36368, 36368, "Rebel Commander", 0, "Monastic Fortress", 0, "LineageNPC2.chief_of_insurgents", 10, 26.99, 80, "male", "L2Defender", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 3200, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 2500, 6377, 0, 29.8, 120, 0, 1), 
(36369, 36369, "Decorated Rebel Soldier", 0, "Monastic Fortress", 0, "LineageMonster.shadow_50_bi", 15, 45, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 0, 0, 0, 80, 120, 0, 1), 
(36370, 36370, "Rebel Private", 0, "Monastic Fortress", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Defender", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 97, 0, 0, 50, 120, 0, 1), 
(36371, 36371, "Court Guard", 0, "Monastic Fortress", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 72, "male", "L2Defender", 80, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2592, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 4, 333, 98, 0, 0, 50, 120, 0, 1), 
(36372, 36372, "Guard", 0, "Monastic Fortress", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 72, "male", "L2Defender", 1100, 2540.15331, 1410, 8.5, 3, 40, 43, 30, 21, 20, 20, 2592, 0, 731.52506, 305.35947, 499.53679, 223.44881, 253, 8, 333, 287, 0, 0, 50, 120, 0, 1), 
(36373, 36373, "Main Machine", 0, "Control Room", 0, "LineageNpcEV.machine_guard_a", 46, 35, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(36374, 36374, "Backup Power Unit", 0, "Control Room", 0, "LineageNpcEV.strange_mechanical_instrument", 16, 15.5, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36375, 36375, "Control Unit", 0, "Control Room", 0, "LineageNpcEV.door_lock", 39, 42.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2813, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(36376, 36376, "Power Control Unit", 0, "Control Room", 0, "LineageNpcEV.machine_construction_a", 54, 59.5, 75, "etc", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(36377, 36377, "Dwarven Gunnery Sergeant", 0, "", 0, "LineageNPC2.battery_of_insurgents", 13, 17.5, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 0, 0, 0, 60, 120, 0, 1), 
(36378, 36378, "Scout Golem", 0, "Control Room", 0, "LineageMonster.mechanic_golem", 5, 19, 74, "male", "L2Defender", 40, 2632.19636, 1475, 8.5, 3, 40, 43, 30, 21, 20, 20, 2738, 0, 773.81598, 314.65987, 528.41601, 230.25444, 253, 4, 333, 0, 0, 0, 30, 120, 0, 1), 
(36379, 36379, "Guard Captain", 0, "Guard", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 78, "female", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 80, 641, 0, 60, 120, 0, 1), 
(36380, 36380, "Guard", 0, "Guard", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 75, 0, 0, 50, 120, 0, 1), 
(36381, 36381, "Guard", 0, "Guard", 0, "LineageNPC.a_royal_guardB_MHuman", 7, 24, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 75, 0, 0, 50, 120, 0, 1), 
(36382, 36382, "Support Unit Captain", 0, "Support Unit", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 78, "female", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 0, 0, 0, 60, 120, 0, 1), 
(36383, 36383, "Wizard", 0, "Support Unit", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 76, "male", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 325, 0, 0, 50, 120, 0, 1), 
(36384, 36384, "Healer", 0, "Support Unit", 0, "LineageNPC.a_mageguild_master_FHuman", 8, 23, 76, "female", "L2Defender", 40, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 4, 333, 92, 0, 0, 50, 120, 0, 1), 
(36385, 36385, "Archer Captain", 0, "Archer", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 78, "male", "L2FortCommander", 1100, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 8, 333, 10212, 0, 0, 60, 120, 0, 1), 
(36386, 36386, "Archer", 0, "Archer", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 76, "male", "L2Defender", 1100, 2758.059233, 1540.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 2888, 0, 824.42207, 323.78455, 562.9734, 236.93149, 253, 8, 333, 287, 0, 0, 50, 120, 0, 1), 
(36387, 36387, "General", 0, "Officer's Barracks", 0, "LineageNPC2.officer_of_insurgents_orc", 14.5, 30, 78, "male", "L2FortCommander", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 9813, 9813, 0, 60, 120, 0, 1), 
(36388, 36388, "Minister", 0, "Officer's Barracks", 0, "LineageNPC.e_guard_MOrc", 8, 27, 78, "male", "L2Defender", 40, 681761.551881, 1607.4, 397.49728, 3, 40, 43, 30, 21, 20, 20, 3042, 0, 7149.40064, 532.32098, 4882.11391, 584.29409, 253, 4, 333, 7895, 0, 0, 50, 120, 0, 1), 
(36389, 36389, "Ballista", 0, "Monastic Fortress", 0, "LineageNpcEV.ballista", 112, 59, 80, "male", "L2FortBallista", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(36390, 36390, "Mercenary Captain", 0, "", 0, "LineageMonster3.Kight_of_Dawn", 12, 24.5, 80, "male", "L2Npc", 40, 679374.315372, 1674.8, 391.417777, 3, 40, 43, 30, 21, 20, 20, 0, 0, 7476.50801, 546.2, 5105.48575, 599.52818, 253, 4, 333, 2500, 6377, 0, 36.48, 100, 0, 1), 
(36391, 36391, "Mercenary Private", 0, "", 0, "LineageNPC.e_guard_MOrc", 8, 27, 75, "male", "L2Npc", 80, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 96, 0, 0, 50, 120, 0, 1), 
(36392, 36392, "Improvised Explosive", 0, "", 0, "LineageMonster.orc", 10, 21, 60, "male", "L2Npc", 40, 1933.24044, 1036.8, 6.5, 2.4, 40, 43, 30, 21, 20, 20, 0, 0, 481.34551, 247.65008, 328.69659, 181.21958, 253, 4, 333, 0, 0, 0, 45, 1, 0, 1), 
(36393, 36393, "Special Envoy", 0, "Gludio", 0, "LineageNPC.a_teleporter_FHuman", 8, 25, 75, "female", "L2FortEnvoy", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36394, 36394, "Special Envoy", 0, "Gludio", 0, "LineageNPC.a_teleporter_FHuman", 8, 25, 75, "female", "L2FortEnvoy", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36395, 36395, "Special Envoy", 0, "Dion", 0, "LineageNPC.a_maidB_FHuman", 8, 22, 75, "female", "L2FortEnvoy", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36396, 36396, "Special Envoy", 0, "Giran", 0, "LineageNPC.a_sanctuary_teacher_FHuman", 8, 22.5, 75, "female", "L2FortEnvoy", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36397, 36397, "Special Envoy", 0, "Oren", 0, "LineageNPC.a_clergyman_FDarkElf", 8, 25, 75, "female", "L2FortEnvoy", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36398, 36398, "Special Envoy", 0, "Aden", 0, "LineageNPC.a_maidB_FHuman", 8, 22, 75, "female", "L2FortEnvoy", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36399, 36399, "Special Envoy", 0, "Aden", 0, "LineageNPC.a_maidB_FHuman", 8, 22, 75, "female", "L2FortEnvoy", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36400, 36400, "Special Envoy", 0, "Innadril", 0, "LineageNPC.a_teleporter_FElf", 8.5, 23.5, 75, "female", "L2FortEnvoy", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36401, 36401, "Special Envoy", 0, "Goddard", 0, "LineageNPC.e_teleporter_Fhuman", 8, 25, 75, "female", "L2FortEnvoy", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36402, 36402, "Olympiad Host", 0, "", 0, "LineageNPC.a_fighterguild_master_Mhuman", 8, 23.5, 70, "male", "L2OlympiadManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 70, 0, 0, 50, 120, 0, 1), 
(36403, 36403, "Warden", 0, "Gludio", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36404, 36404, "Warden", 0, "Dion", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36405, 36405, "Warden", 0, "Giran", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36406, 36406, "Warden", 0, "Oren", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36407, 36407, "Warden", 0, "Aden", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36408, 36408, "Warden", 0, "Innadril", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36409, 36409, "Warden", 0, "Goddard", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36410, 36410, "Warden", 0, "Rune", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36411, 36411, "Warden", 0, "Schuttgart", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 75, "male", "L2Npc", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36412, 36412, "Fortress Trap", 0, "", 0, "LineageMonster3.Organ_Dummy", 1, 35, 78, "female", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 10, 1, 0, 1), 
(36413, 36413, "Fortress Trap", 0, "", 0, "LineageMonster3.Organ_Dummy", 1, 35, 78, "female", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 10, 1, 0, 1), 
(36414, 36414, "Fortress Trap", 0, "", 0, "LineageMonster3.Organ_Dummy", 1, 35, 78, "female", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 10, 1, 0, 1), 
(36415, 36415, "Fortress Trap", 0, "", 0, "LineageMonster3.Organ_Dummy", 1, 35, 78, "female", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 10, 1, 0, 1), 
(36416, 36416, "Fortress Trap", 0, "", 0, "LineageMonster3.Organ_Dummy", 1, 35, 78, "female", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 10, 1, 0, 1), 
(36417, 36417, "Fortress Trap", 0, "", 0, "LineageMonster3.Organ_Dummy", 1, 35, 78, "female", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 10, 1, 0, 1), 
(36418, 36418, "Fortress Trap", 0, "", 0, "LineageMonster3.Organ_Dummy", 1, 35, 78, "female", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 10, 1, 0, 1), 
(36419, 36419, "Fortress Trap", 0, "", 0, "LineageMonster3.Organ_Dummy", 1, 35, 78, "female", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 10, 1, 0, 1), 
(36420, 36420, "Fortress Trap", 0, "", 0, "LineageMonster3.Organ_Dummy", 1, 35, 78, "female", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 10, 1, 0, 1), 
(36421, 36421, "Fortress Trap", 0, "", 0, "LineageMonster3.Organ_Dummy", 1, 35, 78, "female", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 10, 1, 0, 1), 
(36422, 36422, "Fortress Trap", 0, "", 0, "LineageMonster3.Organ_Dummy", 1, 35, 78, "female", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 10, 1, 0, 1), 
(36423, 36423, "Fortress Trap", 0, "", 0, "LineageMonster3.Organ_Dummy", 1, 35, 78, "female", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 10, 1, 0, 1), 
(36424, 36424, "Fortress Trap", 0, "", 0, "LineageMonster3.Organ_Dummy", 1, 35, 78, "female", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 10, 1, 0, 1), 
(36425, 36425, "Fortress Trap", 0, "", 0, "LineageMonster3.Organ_Dummy", 1, 35, 78, "female", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 10, 1, 0, 1), 
(36426, 36426, "Fortress Trap", 0, "", 0, "LineageMonster3.Organ_Dummy", 1, 35, 78, "female", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 10, 1, 0, 1), 
(36427, 36427, "Fortress Trap", 0, "", 0, "LineageMonster3.Organ_Dummy", 1, 35, 78, "female", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 10, 1, 0, 1), 
(36428, 36428, "Fortress Trap", 0, "", 0, "LineageMonster3.Organ_Dummy", 1, 35, 78, "female", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 10, 1, 0, 1), 
(36429, 36429, "Fortress Trap", 0, "", 0, "LineageMonster3.Organ_Dummy", 1, 35, 78, "female", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 10, 1, 0, 1), 
(36430, 36430, "Fortress Trap", 0, "", 0, "LineageMonster3.Organ_Dummy", 1, 35, 78, "female", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 10, 1, 0, 1), 
(36431, 36431, "Fortress Trap", 0, "", 0, "LineageMonster3.Organ_Dummy", 1, 35, 78, "female", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 10, 1, 0, 1), 
(36432, 36432, "Fortress Trap", 0, "", 0, "LineageMonster3.Organ_Dummy", 1, 35, 78, "female", "L2Npc", 40, 2974.356864, 1607.4, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 890.50086, 332.70061, 608.09666, 243.45587, 253, 4, 333, 0, 0, 0, 10, 1, 0, 1), 
(36433, 36433, "Special Envoy", 0, "Rune", 0, "LineageNPC.a_maidB_FHuman", 8, 22, 75, "female", "L2FortEnvoy", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36434, 36434, "Special Envoy", 0, "Schuttgart", 0, "LineageNPC.e_traderA_FDwarf", 7, 18.5, 75, "female", "L2FortEnvoy", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36435, 36435, "Special Envoy", 0, "Gludio", 0, "LineageNPC.a_teleporter_FHuman", 8, 25, 75, "female", "L2FortEnvoy", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36436, 36436, "Special Envoy", 0, "Dion", 0, "LineageNPC.a_maidB_FHuman", 8, 22, 75, "female", "L2FortEnvoy", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36437, 36437, "Special Envoy", 0, "Gludio", 0, "LineageNPC.a_teleporter_FHuman", 8, 25, 75, "female", "L2FortEnvoy", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36438, 36438, "Special Envoy", 0, "Oren", 0, "LineageNPC.a_clergyman_FDarkElf", 8, 25, 75, "female", "L2FortEnvoy", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36439, 36439, "Special Envoy", 0, "Dion", 0, "LineageNPC.a_maidB_FHuman", 8, 22, 75, "female", "L2FortEnvoy", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36440, 36440, "Special Envoy", 0, "Giran", 0, "LineageNPC.a_sanctuary_teacher_FHuman", 8, 22.5, 75, "female", "L2FortEnvoy", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36441, 36441, "Special Envoy", 0, "Dion", 0, "LineageNPC.a_maidB_FHuman", 8, 22, 75, "female", "L2FortEnvoy", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36442, 36442, "Special Envoy", 0, "Oren", 0, "LineageNPC.a_clergyman_FDarkElf", 8, 25, 75, "female", "L2FortEnvoy", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36443, 36443, "Special Envoy", 0, "Oren", 0, "LineageNPC.a_clergyman_FDarkElf", 8, 25, 75, "female", "L2FortEnvoy", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36444, 36444, "Special Envoy", 0, "Giran", 0, "LineageNPC.a_sanctuary_teacher_FHuman", 8, 22.5, 75, "female", "L2FortEnvoy", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36445, 36445, "Special Envoy", 0, "Aden", 0, "LineageNPC.a_maidB_FHuman", 8, 22, 75, "female", "L2FortEnvoy", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36446, 36446, "Special Envoy", 0, "Oren", 0, "LineageNPC.a_clergyman_FDarkElf", 8, 25, 75, "female", "L2FortEnvoy", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36447, 36447, "Special Envoy", 0, "Goddard", 0, "LineageNPC.e_teleporter_Fhuman", 8, 25, 75, "female", "L2FortEnvoy", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36448, 36448, "Special Envoy", 0, "Aden", 0, "LineageNPC.a_maidB_FHuman", 8, 22, 75, "female", "L2FortEnvoy", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36449, 36449, "Special Envoy", 0, "Giran", 0, "LineageNPC.a_sanctuary_teacher_FHuman", 8, 22.5, 75, "female", "L2FortEnvoy", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36450, 36450, "Special Envoy", 0, "Innadril", 0, "LineageNPC.a_teleporter_FElf", 8.5, 23.5, 75, "female", "L2FortEnvoy", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36451, 36451, "Special Envoy", 0, "Giran", 0, "LineageNPC.a_sanctuary_teacher_FHuman", 8, 22.5, 75, "female", "L2FortEnvoy", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36452, 36452, "Special Envoy", 0, "Rune", 0, "LineageNPC.a_maidB_FHuman", 8, 22, 75, "female", "L2FortEnvoy", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36453, 36453, "Special Envoy", 0, "Goddard", 0, "LineageNPC.e_teleporter_Fhuman", 8, 25, 75, "female", "L2FortEnvoy", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36454, 36454, "Special Envoy", 0, "Rune", 0, "LineageNPC.a_maidB_FHuman", 8, 22, 75, "female", "L2FortEnvoy", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36455, 36455, "Special Envoy", 0, "Schuttgart", 0, "LineageNPC.e_traderA_FDwarf", 7, 18.5, 75, "female", "L2FortEnvoy", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36456, 36456, "Manor Manager", 0, "Aden", 0, "LineageNPC2.K_M1_normal", 13, 25, 75, "male", "L2ManorManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 28, 120, 0, 1), 
(36457, 36457, "Wyvern Manager", 0, "Shanty Fortress", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 75, "male", "L2FortWyvernManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36458, 36458, "Wyvern Manager", 0, "Southern Fortress", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 75, "male", "L2FortWyvernManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36459, 36459, "Wyvern Manager", 0, "Hive Fortress", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 75, "male", "L2FortWyvernManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36460, 36460, "Wyvern Manager", 0, "Valley Fortress", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 75, "male", "L2FortWyvernManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36461, 36461, "Wyvern Manager", 0, "Ivory Fortress", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 75, "male", "L2FortWyvernManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36462, 36462, "Wyvern Manager", 0, "Narsell Fortress", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 75, "male", "L2FortWyvernManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36463, 36463, "Wyvern Manager", 0, "Bayou Fortress", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 75, "male", "L2FortWyvernManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36464, 36464, "Wyvern Manager", 0, "White Sands Fortress", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 75, "male", "L2FortWyvernManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36465, 36465, "Wyvern Manager", 0, "Borderland Fortress", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 75, "male", "L2FortWyvernManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36466, 36466, "Wyvern Manager", 0, "Swamp Fortress", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 75, "male", "L2FortWyvernManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36467, 36467, "Wyvern Manager", 0, "Archaic Fortress", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 75, "male", "L2FortWyvernManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36468, 36468, "Wyvern Manager", 0, "Floran Fortress", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 75, "male", "L2FortWyvernManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36469, 36469, "Wyvern Manager", 0, "Cloud Mountain", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 75, "male", "L2FortWyvernManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36470, 36470, "Wyvern Manager", 0, "Tanor Fortress", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 75, "male", "L2FortWyvernManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36471, 36471, "Wyvern Manager", 0, "Dragonspine Fortress", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 75, "male", "L2FortWyvernManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36472, 36472, "Wyvern Manager", 0, "Antharas' Fortress", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 75, "male", "L2FortWyvernManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36473, 36473, "Wyvern Manager", 0, "Western Fortress", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 75, "male", "L2FortWyvernManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36474, 36474, "Wyvern Manager", 0, "Hunter's Fortress", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 75, "male", "L2FortWyvernManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36475, 36475, "Wyvern Manager", 0, "Aaru Fortress", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 75, "male", "L2FortWyvernManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36476, 36476, "Wyvern Manager", 0, "Demon Fortress", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 75, "male", "L2FortWyvernManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36477, 36477, "Wyvern Manager", 0, "Monastic Fortress", 0, "LineageNPC.a_fighterguild_teacher_MHuman", 8, 23, 75, "male", "L2FortWyvernManager", 40, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36478, 36478, "Mickey", 0, "Pet Trader", 0, "LineageNPC.e_collector_teacher_FDwarf", 8, 17.5, 70, "female", "L2PetManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36479, 36479, "Rapidus", 0, "Reputation Manager", 0, "LineageNPC.a_fighterguild_master_Mhuman", 8, 23.5, 70, "male", "L2FameManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36480, 36480, "Scipio", 0, "Reputation Manager", 0, "LineageNPC.a_fighterguild_master_Mhuman", 8, 23.5, 70, "male", "L2FameManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36481, 36481, "Mercenary Captain", 0, "Gludio", 0, "LineageMonster3.Kight_of_Dawn", 12, 24.5, 70, "male", "L2MercenaryManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 2500, 6377, 0, 36.48, 160, 0, 1), 
(36482, 36482, "Mercenary Captain", 0, "Dion", 0, "LineageMonster3.Kight_of_Dawn", 12, 24.5, 70, "male", "L2MercenaryManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 2500, 6377, 0, 36.48, 160, 0, 1), 
(36483, 36483, "Mercenary Captain", 0, "Giran", 0, "LineageMonster3.Kight_of_Dawn", 12, 24.5, 70, "male", "L2MercenaryManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 2500, 6377, 0, 36.48, 160, 0, 1), 
(36484, 36484, "Mercenary Captain", 0, "Oren", 0, "LineageMonster3.Kight_of_Dawn", 12, 24.5, 70, "male", "L2MercenaryManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 2500, 6377, 0, 36.48, 160, 0, 1), 
(36485, 36485, "Mercenary Captain", 0, "Aden", 0, "LineageMonster3.Kight_of_Dawn", 12, 24.5, 70, "male", "L2MercenaryManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 2500, 6377, 0, 36.48, 160, 0, 1), 
(36486, 36486, "Mercenary Captain", 0, "Innadril", 0, "LineageMonster3.Kight_of_Dawn", 12, 24.5, 70, "male", "L2MercenaryManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 2500, 6377, 0, 36.48, 160, 0, 1), 
(36487, 36487, "Mercenary Captain", 0, "Goddard", 0, "LineageMonster3.Kight_of_Dawn", 12, 24.5, 70, "male", "L2MercenaryManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 2500, 6377, 0, 36.48, 160, 0, 1), 
(36488, 36488, "Mercenary Captain", 0, "Rune", 0, "LineageMonster3.Kight_of_Dawn", 12, 24.5, 70, "male", "L2MercenaryManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 2500, 6377, 0, 36.48, 160, 0, 1), 
(36489, 36489, "Mercenary Captain", 0, "Schuttgart", 0, "LineageMonster3.Kight_of_Dawn", 12, 24.5, 70, "male", "L2MercenaryManager", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 2500, 6377, 0, 36.48, 160, 0, 1), 
(36490, 36490, "Territory Manager", 0, "Gludio", 0, "LineageNPC2.feudal_custodian", 10, 22.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36491, 36491, "Territory Manager", 0, "Dion", 0, "LineageNPC2.feudal_custodian", 10, 22.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36492, 36492, "Territory Manager", 0, "Giran", 0, "LineageNPC2.feudal_custodian", 10, 22.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36493, 36493, "Territory Manager", 0, "Oren", 0, "LineageNPC2.feudal_custodian", 10, 22.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36494, 36494, "Territory Manager", 0, "Aden", 0, "LineageNPC2.feudal_custodian", 10, 22.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36495, 36495, "Territory Manager", 0, "Innadril", 0, "LineageNPC2.feudal_custodian", 10, 22.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36496, 36496, "Territory Manager", 0, "Goddard", 0, "LineageNPC2.feudal_custodian", 10, 22.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36497, 36497, "Territory Manager", 0, "Rune", 0, "LineageNPC2.feudal_custodian", 10, 22.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36498, 36498, "Territory Manager", 0, "Schuttgart", 0, "LineageNPC2.feudal_custodian", 10, 22.5, 70, "male", "L2Npc", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 0, 0, 0, 50, 120, 0, 1), 
(36499, 36499, "Territory Catapult", 0, "Gludio", 0, "LineageNpcEV.ballista", 112, 59, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(36500, 36500, "Territory Catapult", 0, "Dion", 0, "LineageNpcEV.ballista", 112, 59, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(36501, 36501, "Territory Catapult", 0, "Giran", 0, "LineageNpcEV.ballista", 112, 59, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(36502, 36502, "Territory Catapult", 0, "Oren", 0, "LineageNpcEV.ballista", 112, 59, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(36503, 36503, "Territory Catapult", 0, "Aden", 0, "LineageNpcEV.ballista", 112, 59, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(36504, 36504, "Territory Catapult", 0, "Innadril", 0, "LineageNpcEV.ballista", 112, 59, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(36505, 36505, "Territory Catapult", 0, "Goddard", 0, "LineageNpcEV.ballista", 112, 59, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(36506, 36506, "Territory Catapult", 0, "Rune", 0, "LineageNpcEV.ballista", 112, 59, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(36507, 36507, "Territory Catapult", 0, "Schuttgart", 0, "LineageNpcEV.ballista", 112, 59, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(36508, 36508, "Military Association Leader", 0, "Gludio", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 80, "male", "L2Defender", 40, 463876, 1674.8, 981, 3, 40, 43, 30, 21, 20, 20, 64129, 77672, 2911.61265, 341.375, 1988.25399, 249.80341, 253, 4, 333, 76, 2497, 0, 50, 120, 0, 1), 
(36509, 36509, "Territory Border Guard", 0, "Gludio", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 70, "male", "L2Defender", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 8678, 0, 0, 50, 120, 0, 1), 
(36510, 36510, "Religious Association Leader", 0, "Gludio", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 80, "male", "L2Defender", 40, 463876, 1674.8, 981, 3, 22, 27, 21, 41, 20, 20, 64129, 77672, 2911.61265, 341.375, 1988.25399, 249.80341, 253, 4, 333, 8687, 0, 0, 50, 120, 0, 1), 
(36511, 36511, "Territory Guard", 0, "Gludio", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 80, "male", "L2Defender", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 9442, 0, 0, 50, 120, 0, 1), 
(36512, 36512, "Territory Border Guard", 0, "Gludio", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 8684, 0, 0, 50, 120, 0, 1), 
(36513, 36513, "Economic Association Leader", 0, "Gludio", 0, "LineageNPC.a_traderB_MHuman", 8, 25, 80, "male", "L2Defender", 40, 463876, 1674.8, 981, 3, 40, 43, 30, 21, 20, 20, 64129, 77672, 2911.61265, 341.375, 1988.25399, 249.80341, 253, 4, 333, 6365, 0, 0, 50, 120, 0, 1), 
(36514, 36514, "Military Association Leader", 0, "Dion", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 80, "male", "L2Defender", 40, 463876, 1674.8, 981, 3, 40, 43, 30, 21, 20, 20, 64129, 77672, 2911.61265, 341.375, 1988.25399, 249.80341, 253, 4, 333, 76, 2497, 0, 50, 120, 0, 1), 
(36515, 36515, "Territory Border Guard", 0, "Dion", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 70, "male", "L2Defender", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 8678, 0, 0, 50, 120, 0, 1), 
(36516, 36516, "Religious Association Leader", 0, "Dion", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 80, "male", "L2Defender", 40, 463876, 1674.8, 981, 3, 22, 27, 21, 41, 20, 20, 64129, 77672, 2911.61265, 341.375, 1988.25399, 249.80341, 253, 4, 333, 8687, 0, 0, 50, 120, 0, 1), 
(36517, 36517, "Territory Guard", 0, "Dion", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 80, "male", "L2Defender", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 9442, 0, 0, 50, 120, 0, 1), 
(36518, 36518, "Territory Border Guard", 0, "Dion", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 8684, 0, 0, 50, 120, 0, 1), 
(36519, 36519, "Economic Association Leader", 0, "Dion", 0, "LineageNPC.a_traderB_MHuman", 8, 25, 80, "male", "L2Defender", 40, 463876, 1674.8, 981, 3, 40, 43, 30, 21, 20, 20, 64129, 77672, 2911.61265, 341.375, 1988.25399, 249.80341, 253, 4, 333, 6365, 0, 0, 50, 120, 0, 1), 
(36520, 36520, "Military Association Leader", 0, "Giran", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 80, "male", "L2Defender", 40, 463876, 1674.8, 981, 3, 40, 43, 30, 21, 20, 20, 64129, 77672, 2911.61265, 341.375, 1988.25399, 249.80341, 253, 4, 333, 76, 2497, 0, 50, 120, 0, 1), 
(36521, 36521, "Territory Border Guard", 0, "Giran", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 70, "male", "L2Defender", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 8678, 0, 0, 50, 120, 0, 1), 
(36522, 36522, "Religious Association Leader", 0, "Giran", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 80, "male", "L2Defender", 40, 463876, 1674.8, 981, 3, 22, 27, 21, 41, 20, 20, 64129, 77672, 2911.61265, 341.375, 1988.25399, 249.80341, 253, 4, 333, 8687, 0, 0, 50, 120, 0, 1), 
(36523, 36523, "Territory Guard", 0, "Giran", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 80, "male", "L2Defender", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 9442, 0, 0, 50, 120, 0, 1), 
(36524, 36524, "Territory Border Guard", 0, "Giran", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 8684, 0, 0, 50, 120, 0, 1), 
(36525, 36525, "Economic Association Leader", 0, "Giran", 0, "LineageNPC.a_traderB_MHuman", 8, 25, 80, "male", "L2Defender", 40, 463876, 1674.8, 981, 3, 40, 43, 30, 21, 20, 20, 64129, 77672, 2911.61265, 341.375, 1988.25399, 249.80341, 253, 4, 333, 6365, 0, 0, 50, 120, 0, 1), 
(36526, 36526, "Military Association Leader", 0, "Oren", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 80, "male", "L2Defender", 40, 463876, 1674.8, 981, 3, 40, 43, 30, 21, 20, 20, 64129, 77672, 2911.61265, 341.375, 1988.25399, 249.80341, 253, 4, 333, 76, 2497, 0, 50, 120, 0, 1), 
(36527, 36527, "Territory Border Guard", 0, "Oren", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 70, "male", "L2Defender", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 8678, 0, 0, 50, 120, 0, 1), 
(36528, 36528, "Religious Association Leader", 0, "Oren", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 80, "male", "L2Defender", 40, 463876, 1674.8, 981, 3, 22, 27, 21, 41, 20, 20, 64129, 77672, 2911.61265, 341.375, 1988.25399, 249.80341, 253, 4, 333, 8687, 0, 0, 50, 120, 0, 1), 
(36529, 36529, "Territory Guard", 0, "Oren", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 80, "male", "L2Defender", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 9442, 0, 0, 50, 120, 0, 1), 
(36530, 36530, "Territory Border Guard", 0, "Oren", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 8684, 0, 0, 50, 120, 0, 1), 
(36531, 36531, "Economic Association Leader", 0, "Oren", 0, "LineageNPC.a_traderB_MHuman", 8, 25, 80, "male", "L2Defender", 40, 463876, 1674.8, 981, 3, 40, 43, 30, 21, 20, 20, 64129, 77672, 2911.61265, 341.375, 1988.25399, 249.80341, 253, 4, 333, 6365, 0, 0, 50, 120, 0, 1), 
(36532, 36532, "Military Association Leader", 0, "Aden", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 80, "male", "L2Defender", 40, 463876, 1674.8, 981, 3, 40, 43, 30, 21, 20, 20, 64129, 77672, 2911.61265, 341.375, 1988.25399, 249.80341, 253, 4, 333, 76, 2497, 0, 50, 120, 0, 1), 
(36533, 36533, "Territory Border Guard", 0, "Aden", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 70, "male", "L2Defender", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 8678, 0, 0, 50, 120, 0, 1), 
(36534, 36534, "Religious Association Leader", 0, "Aden", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 80, "male", "L2Defender", 40, 463876, 1674.8, 981, 3, 22, 27, 21, 41, 20, 20, 64129, 77672, 2911.61265, 341.375, 1988.25399, 249.80341, 253, 4, 333, 8687, 0, 0, 50, 120, 0, 1), 
(36535, 36535, "Territory Guard", 0, "Aden", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 80, "male", "L2Defender", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 9442, 0, 0, 50, 120, 0, 1), 
(36536, 36536, "Territory Border Guard", 0, "Aden", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 8684, 0, 0, 50, 120, 0, 1), 
(36537, 36537, "Economic Association Leader", 0, "Aden", 0, "LineageNPC.a_traderB_MHuman", 8, 25, 80, "male", "L2Defender", 40, 463876, 1674.8, 981, 3, 40, 43, 30, 21, 20, 20, 64129, 77672, 2911.61265, 341.375, 1988.25399, 249.80341, 253, 4, 333, 6365, 0, 0, 50, 120, 0, 1), 
(36538, 36538, "Military Association Leader", 0, "Innadril", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 80, "male", "L2Defender", 40, 463876, 1674.8, 981, 3, 40, 43, 30, 21, 20, 20, 64129, 77672, 2911.61265, 341.375, 1988.25399, 249.80341, 253, 4, 333, 76, 2497, 0, 50, 120, 0, 1), 
(36539, 36539, "Territory Border Guard", 0, "Innadril", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 70, "male", "L2Defender", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 8678, 0, 0, 50, 120, 0, 1), 
(36540, 36540, "Religious Association Leader", 0, "Innadril", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 80, "male", "L2Defender", 40, 463876, 1674.8, 981, 3, 22, 27, 21, 41, 20, 20, 64129, 77672, 2911.61265, 341.375, 1988.25399, 249.80341, 253, 4, 333, 8687, 0, 0, 50, 120, 0, 1), 
(36541, 36541, "Territory Guard", 0, "Innadril", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 80, "male", "L2Defender", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 9442, 0, 0, 50, 120, 0, 1), 
(36542, 36542, "Territory Border Guard", 0, "Innadril", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 8684, 0, 0, 50, 120, 0, 1), 
(36543, 36543, "Economic Association Leader", 0, "Innadril", 0, "LineageNPC.a_traderB_MHuman", 8, 25, 80, "male", "L2Defender", 40, 463876, 1674.8, 981, 3, 40, 43, 30, 21, 20, 20, 64129, 77672, 2911.61265, 341.375, 1988.25399, 249.80341, 253, 4, 333, 6365, 0, 0, 50, 120, 0, 1), 
(36544, 36544, "Military Association Leader", 0, "Goddard", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 80, "male", "L2Defender", 40, 463876, 1674.8, 981, 3, 40, 43, 30, 21, 20, 20, 64129, 77672, 2911.61265, 341.375, 1988.25399, 249.80341, 253, 4, 333, 76, 2497, 0, 50, 120, 0, 1), 
(36545, 36545, "Territory Border Guard", 0, "Goddard", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 70, "male", "L2Defender", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 8678, 0, 0, 50, 120, 0, 1), 
(36546, 36546, "Religious Association Leader", 0, "Goddard", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 80, "male", "L2Defender", 40, 463876, 1674.8, 981, 3, 22, 27, 21, 41, 20, 20, 64129, 77672, 2911.61265, 341.375, 1988.25399, 249.80341, 253, 4, 333, 8687, 0, 0, 50, 120, 0, 1), 
(36547, 36547, "Territory Guard", 0, "Goddard", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 80, "male", "L2Defender", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 9442, 0, 0, 50, 120, 0, 1), 
(36548, 36548, "Territory Border Guard", 0, "Goddard", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 8684, 0, 0, 50, 120, 0, 1), 
(36549, 36549, "Economic Association Leader", 0, "Goddard", 0, "LineageNPC.a_traderB_MHuman", 8, 25, 80, "male", "L2Defender", 40, 463876, 1674.8, 981, 3, 40, 43, 30, 21, 20, 20, 64129, 77672, 2911.61265, 341.375, 1988.25399, 249.80341, 253, 4, 333, 6365, 0, 0, 50, 120, 0, 1), 
(36550, 36550, "Military Association Leader", 0, "Rune", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 80, "male", "L2Defender", 40, 463876, 1674.8, 981, 3, 40, 43, 30, 21, 20, 20, 64129, 77672, 2911.61265, 341.375, 1988.25399, 249.80341, 253, 4, 333, 76, 2497, 0, 50, 120, 0, 1), 
(36551, 36551, "Territory Border Guard", 0, "Rune", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 70, "male", "L2Defender", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 8678, 0, 0, 50, 120, 0, 1), 
(36552, 36552, "Religious Association Leader", 0, "Rune", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 80, "male", "L2Defender", 40, 463876, 1674.8, 981, 3, 22, 27, 21, 41, 20, 20, 64129, 77672, 2911.61265, 341.375, 1988.25399, 249.80341, 253, 4, 333, 8687, 0, 0, 50, 120, 0, 1), 
(36553, 36553, "Territory Guard", 0, "Rune", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 80, "male", "L2Defender", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 9442, 0, 0, 50, 120, 0, 1), 
(36554, 36554, "Territory Border Guard", 0, "Rune", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 8684, 0, 0, 50, 120, 0, 1), 
(36555, 36555, "Economic Association Leader", 0, "Rune", 0, "LineageNPC.a_traderB_MHuman", 8, 25, 80, "male", "L2Defender", 40, 463876, 1674.8, 981, 3, 40, 43, 30, 21, 20, 20, 64129, 77672, 2911.61265, 341.375, 1988.25399, 249.80341, 253, 4, 333, 6365, 0, 0, 50, 120, 0, 1), 
(36556, 36556, "Military Association Leader", 0, "Schuttgart", 0, "LineageNPC.a_royal_guardA_MHuman", 7, 24, 80, "male", "L2Defender", 40, 463876, 1674.8, 981, 3, 40, 43, 30, 21, 20, 20, 64129, 77672, 2911.61265, 341.375, 1988.25399, 249.80341, 253, 4, 333, 76, 2497, 0, 50, 120, 0, 1), 
(36557, 36557, "Territory Border Guard", 0, "Schuttgart", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 70, "male", "L2Defender", 40, 2444.46819, 1345.8, 7.5, 2.7, 40, 43, 30, 21, 20, 20, 0, 0, 688.86373, 295.91597, 470.40463, 216.53847, 253, 4, 333, 8678, 0, 0, 50, 120, 0, 1), 
(36558, 36558, "Religious Association Leader", 0, "Schuttgart", 0, "LineageNPC.a_patriarch_MElf", 8, 22.5, 80, "male", "L2Defender", 40, 463876, 1674.8, 981, 3, 22, 27, 21, 41, 20, 20, 64129, 77672, 2911.61265, 341.375, 1988.25399, 249.80341, 253, 4, 333, 8687, 0, 0, 50, 120, 0, 1), 
(36559, 36559, "Territory Guard", 0, "Schuttgart", 0, "LineageNPC.e_elmore_guard_Mhuman", 8, 23.5, 80, "male", "L2Defender", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 9442, 0, 0, 50, 120, 0, 1), 
(36560, 36560, "Territory Border Guard", 0, "Schuttgart", 0, "LineageNPC.a_guard_MElf", 8, 23.5, 75, "male", "L2Defender", 1100, 2676.65854, 1507.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 794.70901, 319.24623, 542.68324, 233.61053, 253, 8, 333, 8684, 0, 0, 50, 120, 0, 1), 
(36561, 36561, "Economic Association Leader", 0, "Schuttgart", 0, "LineageNPC.a_traderB_MHuman", 8, 25, 80, "male", "L2Defender", 40, 463876, 1674.8, 981, 3, 40, 43, 30, 21, 20, 20, 64129, 77672, 2911.61265, 341.375, 1988.25399, 249.80341, 253, 4, 333, 6365, 0, 0, 50, 120, 0, 1), 
(36562, 36562, "Seduced Knight", 0, "Investigator", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 83, "female", "L2Npc", 40, 58333.054747, 1777.4, 8.5, 3, 40, 43, 30, 21, 26, 20, 0, 0, 1099.42362, 530.79216, 750.76381, 258.94045, 336, 4, 333, 80, 641, 0, 30, 120, 0, 1), 
(36563, 36563, "Seduced Ranger", 0, "Investigator", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 83, "male", "L2Npc", 1100, 58333.054747, 1777.4, 8.5, 3, 40, 43, 30, 21, 26, 20, 0, 0, 1099.42362, 530.79216, 750.76381, 258.94045, 336, 8, 333, 10212, 0, 0, 30, 120, 0, 1), 
(36564, 36564, "Seduced Mage", 0, "Investigator", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 83, "female", "L2Npc", 40, 58333.054747, 1777.4, 8.5, 3, 40, 43, 30, 21, 26, 20, 0, 0, 1099.42362, 530.79216, 750.76381, 258.94045, 336, 1, 333, 0, 0, 0, 28, 120, 0, 1), 
(36565, 36565, "Seduced Warrior", 0, "Investigator", 0, "LineageNPC2.officer_of_insurgents_orc", 14.5, 30, 83, "male", "L2Npc", 40, 58333.054747, 1777.4, 8.5, 3, 40, 43, 30, 21, 26, 20, 0, 0, 1099.42362, 530.79216, 750.76381, 258.94045, 336, 4, 333, 9813, 9813, 0, 40, 120, 0, 1), 
(36566, 36566, "Seduced Knight", 0, "Investigator", 0, "LineageNPC2.garrison_of_insurgents", 10, 23.75, 77, "female", "L2Npc", 40, 43728.007992, 1404.887386, 7.5, 2.7, 40, 43, 30, 21, 26, 20, 0, 0, 742.37341, 379.30061, 506.94481, 222.65961, 336, 4, 333, 80, 641, 0, 30, 120, 0, 1), 
(36567, 36567, "Seduced Ranger", 0, "Investigator", 0, "LineageNPC2.archer_of_insurgents", 10, 23.5, 77, "male", "L2Npc", 1100, 43728.007992, 1404.887386, 7.5, 2.7, 40, 43, 30, 21, 26, 20, 0, 0, 742.37341, 379.30061, 506.94481, 222.65961, 336, 8, 333, 10212, 0, 0, 30, 120, 0, 1), 
(36568, 36568, "Seduced Mage", 0, "Investigator", 0, "LineageNPC2.mage_of_insurgents", 9, 23.5, 77, "female", "L2Npc", 40, 43728.007992, 1404.887386, 7.5, 2.7, 40, 43, 30, 21, 26, 20, 0, 0, 742.37341, 379.30061, 506.94481, 222.65961, 336, 1, 333, 0, 0, 0, 28, 120, 0, 1), 
(36569, 36569, "Seduced Warrior", 0, "Investigator", 0, "LineageNPC2.officer_of_insurgents_orc", 14.5, 30, 77, "male", "L2Npc", 40, 43728.007992, 1404.887386, 7.5, 2.7, 40, 43, 30, 21, 26, 20, 0, 0, 742.37341, 379.30061, 506.94481, 222.65961, 336, 4, 333, 9813, 9813, 0, 40, 120, 0, 1), 
(36570, 36570, "Emery Compressor", 0, "Aerial Cleft", 0, "LineageNpcEV.source_facility", 62, 140, 80, "female", "L2Teleporter", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(36571, 36571, "Vortex", 0, "Aerial Cleft", 0, "LineageNpcEV.war_gate", 300, 130, 80, "female", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(36572, 36572, "Gludio Ward", 0, "", 0, "LineageNpcEV.native_thing_of_territory", 10, 35, 80, "female", "L2TerritoryWard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(36573, 36573, "Dion Ward", 0, "", 0, "LineageNpcEV.native_thing_of_territory", 10, 35, 80, "female", "L2TerritoryWard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(36574, 36574, "Giran Ward", 0, "", 0, "LineageNpcEV.native_thing_of_territory", 10, 35, 80, "female", "L2TerritoryWard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(36575, 36575, "Oren Ward", 0, "", 0, "LineageNpcEV.native_thing_of_territory", 10, 35, 80, "female", "L2TerritoryWard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(36576, 36576, "Aden Ward", 0, "", 0, "LineageNpcEV.native_thing_of_territory", 10, 35, 80, "female", "L2TerritoryWard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(36577, 36577, "Innadril Ward", 0, "", 0, "LineageNpcEV.native_thing_of_territory", 10, 35, 80, "female", "L2TerritoryWard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(36578, 36578, "Goddard Ward", 0, "", 0, "LineageNpcEV.native_thing_of_territory", 10, 35, 80, "female", "L2TerritoryWard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(36579, 36579, "Rune Ward", 0, "", 0, "LineageNpcEV.native_thing_of_territory", 10, 35, 80, "female", "L2TerritoryWard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(36580, 36580, "Schuttgart Ward", 0, "", 0, "LineageNpcEV.native_thing_of_territory", 10, 35, 80, "female", "L2TerritoryWard", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(36581, 36581, "Territory Catapult", 0, "Gludio", 0, "LineageNpcEV.damaged_ballista", 125, 43, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(36582, 36582, "Territory Catapult", 0, "Dion", 0, "LineageNpcEV.damaged_ballista", 125, 43, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(36583, 36583, "Territory Catapult", 0, "Giran", 0, "LineageNpcEV.damaged_ballista", 125, 43, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(36584, 36584, "Territory Catapult", 0, "Oren", 0, "LineageNpcEV.damaged_ballista", 125, 43, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(36585, 36585, "Territory Catapult", 0, "Aden", 0, "LineageNpcEV.damaged_ballista", 125, 43, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(36586, 36586, "Territory Catapult", 0, "Innadril", 0, "LineageNpcEV.damaged_ballista", 125, 43, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(36587, 36587, "Territory Catapult", 0, "Goddard", 0, "LineageNpcEV.damaged_ballista", 125, 43, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(36588, 36588, "Territory Catapult", 0, "Rune", 0, "LineageNpcEV.damaged_ballista", 125, 43, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(36589, 36589, "Territory Catapult", 0, "Schuttgart", 0, "LineageNpcEV.damaged_ballista", 125, 43, 80, "male", "L2Npc", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 1, 1, 0, 1), 
(36590, 36590, "Outpost", 0, "", 0, "LineageNpcEV.Advance_quarters", 110, 70, 1, "female", "L2Npc", 40, 39.74519, 40, 2, 0.9, 40, 43, 30, 21, 20, 20, 0, 0, 8.47458, 44.44444, 5.78704, 32.52252, 253, 4, 333, 0, 0, 0, 1, 120, 0, 1), 
(36591, 36591, "Supplies Safe", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(36592, 36592, "Supplies Safe", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(36593, 36593, "Supplies Safe", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(36594, 36594, "Supplies Safe", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(36595, 36595, "Supplies Safe", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(36596, 36596, "Supplies Safe", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(36597, 36597, "Supplies Safe", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(36598, 36598, "Supplies Safe", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1), 
(36599, 36599, "Supplies Safe", 0, "", 0, "LineageMonster.mimic", 8.5, 8.5, 80, "male", "L2Monster", 40, 3290.113069, 1674.8, 8.5, 3, 40, 43, 30, 21, 20, 20, 0, 0, 970.53755, 341.375, 662.75133, 249.80341, 253, 4, 333, 0, 0, 0, 80, 1, 0, 1);